import groovy.xml.MarkupBuilder

import java.text.Collator
import java.text.MessageFormat

import org.apache.commons.io.IOUtils
import org.apache.commons.logging.Log
import org.apache.commons.logging.LogFactory
import org.codehaus.groovy.control.MultipleCompilationErrorsException

import com.sas.fsd.shared.util.StringUtil
import com.sas.oprisk.framework.server.persistence.PersistenceSession
import com.sas.oprisk.framework.server.persistence.PersistenceStrategy
import com.sas.oprisk.framework.server.services.AppContentService
import com.sas.oprisk.monitor.web.admin.SiteMaintenanceUtils
import com.sas.oprisk.server.ApplicationProperties
import com.sas.oprisk.server.User
import com.sas.oprisk.server.behavior.GlobalPermission
import com.sas.oprisk.server.behavior.SecurityUtils
import com.sas.oprisk.server.services.ServiceLocator
import com.sas.svcs.dav.client.ContentDTO
import com.sas.ui.cpb3.function.FunctionRegistry
import com.sas.ui.cpb3.context.Context
import com.sas.ui.cpb3.context.IContext
import com.sas.ui.cpb3.CPBServiceRegistry
import com.sas.ui.cpb3.ICPBService
import com.sas.oprisk.framework.server.services.FrameworkServiceLocator
import com.sas.oprisk.framework.server.content.ContentRegistryProperties
import com.sas.oprisk.framework.server.content.PerspectiveUtil
import com.sas.oprisk.framework.server.config.FrameworkSystemProperties



  

PersistenceSession ps=ServiceLocator.getPersistenceSession();
final User currentUser = SecurityUtils.getUser(ps);
String devMode = System.getProperty("sas.development.mode");
if (!("true".equals(devMode) ||
currentUser.hasGlobalPermission(GlobalPermission.superuser, ps)))
{
   request.getRequestDispatcher("/insufficientPermissions.jsp").forward(request, response);
   return;
}

Log log = LogFactory.getLog("com.sas.oprisk.server");
PersistenceStrategy strategy =ps.getStrategy()
AppContentService appContentService= ServiceLocator.getAppContentService();
String CUST_FUNCTION_FOLDER_PATH = appContentService.getContentScriptsPath() + "/customfunctions/html5Ui/";
IContext contextJSON
def showCreate= "none"
def showExisting= "flex"
def showTest="none"
int numBackUps=5
String msg=""

def getParam= {
  return  !StringUtil.isEmpty(request.getParameter(it)) ? request.getParameter(it) : ""
}


def inferDataTypes= {
   def param=  !StringUtil.isEmpty(it) ? it : ""
   try{
      BigDecimal bd=new BigDecimal(param);
      if(bd.scale()>0)
      {
         return new Double(param);
      }
      return new Long(param);
   }catch(NumberFormatException e){
      //not a number
      if("TRUE".equalsIgnoreCase(param) || "FALSE".equalsIgnoreCase(param)){
         return new Boolean(param);
      }else{
         return param
      }
   }
}

def getArgCount= {
   String s=getParam("argCount")
   try{
      argCount=Integer.parseInt(s)
   }catch(Exception e)
   {
      argCount=0
   }
   
}
def appendMsg = {
   if (it!=null)
   {
      msg += "<font color='red'>" + it + "</font> <br>"
   }
}

int argCount=getArgCount()
def args=[]
def selScope = getParam("selScope")
if (StringUtil.isEmpty(selScope) && !FrameworkSystemProperties.isSymphonyMode(ServiceLocator.getContentId())) 
   selScope = ServiceLocator.getContentId();
else if (StringUtil.isEmpty(selScope))
   selScope = PerspectiveUtil.format(ServiceLocator.getContentId(),ServiceLocator.getPerspectiveId())
def selFunc = getParam("selFunc")
def cmd = getParam("cmd")
def scriptTxt=getParam("scriptTxt")
def newFnName=getParam("newFnName")
def contextTxt=getParam("contextTxt")
def formActionPath = request.getContextPath() + "/groovyEditor.groovy?rgfContentId=" + StringUtil.escapeHTML(ServiceLocator.getContentId())
if (FrameworkSystemProperties.isSymphonyMode(ServiceLocator.getContentId()) && !StringUtil.isEmpty(ServiceLocator.getPerspectiveId()))
{
   formActionPath += "&" + PerspectiveUtil.PARAM + "=" + StringUtil.escapeHTML(ServiceLocator.getPerspectiveId())
}

def populateArgs={
   argCount.times{
      if (!StringUtil.isEmpty(getParam("args${it}"))) {
          args.add(inferDataTypes(getParam("args${it}")))
      }
      else{
         args.add("")
      }
   }
   if (getParam("args")!=null){
      def cols =getParam("args").tokenize(",")
      cols.each{
         args << inferDataTypes(it)
      }
   }
   try{
      contextTxt=getParam("contextTxt")
      if (StringUtil.isEmpty(contextTxt))
      {
         contextJSON= new Context(new org.json.JSONObject("{}"))
      }else{
         contextJSON= new Context(new org.json.JSONObject(contextTxt))
      }
   }catch (Exception e)
   {
      log.error(e)
      appendMsg(e.getCause())
   }
    
}
populateArgs()
def resultTxt=""




def getArgs={
   if (it <= args.size-1){
      return args.get(it)
   }else{
      return ""
   }
}




ResourceBundle bundle= ApplicationProperties.getBundle(ServiceLocator.getLocale());
GroovyClassLoader gcl = new GroovyClassLoader()

def getSavePath={
   if (selScope == null || selScope.equals(ServiceLocator.getContentId())) {
      return CUST_FUNCTION_FOLDER_PATH;
   } 
   else {
      String[] components = PerspectiveUtil.parse(selScope);
      return FrameworkServiceLocator.getContentService().getBaseWebdavPath() + "/" + components[1] + "/Scripts/customfunctions/html5Ui/";
   }
}

def getBackupPath={
   return getSavePath() + "backup";
}

def localize={key,vals ->
   String message = bundle.getString(key)
   if(vals!=null){
      message = MessageFormat.format(message, vals)
   }
   return message
}
String unsavedChanges=localize("groovyEditor.unsavedChanges.txt" , null)
def testCompile = {scriptNm ->
  
   GroovyCodeSource codeSource = new GroovyCodeSource(scriptTxt, selFunc, GroovyShell.DEFAULT_CODE_BASE)
   try{
      def scriptClass =gcl.parseClass(codeSource)
      inst = scriptClass.newInstance()
      argCount=inst.getArgumentCount()
      if (cmd.equals("test"))
      {
            inst.setContext(contextJSON)
            try{
               resultTxt=  inst.evaluate(args.toArray())
            }catch(Exception e)
            {
               log.error(e)
               resultTxt=e.toString()
               resultTxt+=e.getMessage()
            }
      }else if (cmd.equals("loadFunc")) {
         args.clear()
         contextTxt=""
      }
      
   }
   catch(MultipleCompilationErrorsException e)
   {
      try{
         List errors =e.getErrorCollector().getErrors()
         if (errors!=null){
            errors.each{
               appendMsg(it.getCause().getMessage())
            }
         }
      }catch(Exception x){
         log.error(x)
         appendMsg(x.getCause())
      }
      return false
   }
   catch (Throwable  e){
      log.error(e)
      appendMsg(e)
      return false
   }
   return true
}

def displaySaveMsg=  {msg= localize("groovyEditor.save.success.fmt.txt", [selFunc] as Object[]) }

def  getGroovyFunContents={
   log.debug("Getting groovy function for " + selFunc + " in scope " + selScope);
   def inputStream = null;
   if (selScope == null || selScope.equals(ServiceLocator.getContentId())) {
      inputStream = appContentService.getCpb3GroovyFunction(FrameworkServiceLocator.getContentId(),selFunc)
   }
   else {
      String[] components = PerspectiveUtil.parse(selScope);
      inputStream = appContentService.getCpb3GroovyFunction(FrameworkServiceLocator.getContentId(),components[1],selFunc)
   }
   if (inputStream != null) {
      StringWriter writer = new StringWriter();
      IOUtils.copy(inputStream, writer, 'UTF-8');
      return writer.toString();
   }
   else {
      return null;
   }
   
}

def readFunctionList= {
   Closure filter = { it.toLowerCase().endsWith(".groovy") };
   Closure adjustNames = {it.replace("customfunctions/html5Ui/","")};
   def list = null;
   if (selScope == null || selScope.equals(ServiceLocator.getContentId())) {
      def temp = appContentService.getCpb3GroovyFunctionFileNames(ServiceLocator.getContentId(), null).findAll(filter)
      list = temp.collect(adjustNames);
   }
   else {
      String[] components = PerspectiveUtil.parse(selScope);
      def temp = appContentService.getCpb3GroovyFunctionFileNames(ServiceLocator.getContentId(), components[1]).findAll(filter)
      list = temp.collect(adjustNames);
   }

   Collections.sort(list, Collator.getInstance(ServiceLocator.getLocale()))
   return list  
}


def allFunctionsList= {

   Closure filter = { it.toLowerCase().endsWith(".groovy") };
   Closure adjustNames = {it.replace("customfunctions/html5Ui/","")};
   
   Set<String> distincFns=new HashSet<String>();
   List funList =[];
   if (selScope == null || selScope.equals(ServiceLocator.getContentId())) {
      def temp = appContentService.getCpb3GroovyFunctionFileNames(ServiceLocator.getContentId(), null).findAll(filter)
      funList.addAll(temp.collect(adjustNames)); 
   }
   else {
      String[] components = PerspectiveUtil.parse(selScope);
      def temp = appContentService.getCpb3GroovyFunctionFileNames(ServiceLocator.getContentId(), components[1]).findAll(filter)
      funList.addAll(temp.collect(adjustNames));   
   }
   
   log.debug("List of functions: " + funList);
   
   funList.each { fn ->
     indexofDot= fn.lastIndexOf(".")
     if ((indexofDot)> -1)
     {
        
        distincFns.add(fn.substring(0,indexofDot).toUpperCase())
     }
   }
   return distincFns
}



def keepNBackUps ={
   Closure filter = { it.startsWith(selFunc.substring(0,selFunc.indexOf("."))) };
   Closure adjustNames = {it.replace("customfunctions/html5Ui/backup/","")};
   def list = null;
   if (selScope == null || selScope.equals(ServiceLocator.getContentId())) {
      def temp = appContentService.getCpb3BackupGroovyFunctionFileNames(ServiceLocator.getContentId(), null);
      list = temp.collect(adjustNames).findAll(filter);
   }
   else {
      String[] components = PerspectiveUtil.parse(selScope);
      def temp = appContentService.getCpb3BackupGroovyFunctionFileNames(ServiceLocator.getContentId(), components[1]);
      list = temp.collect(adjustNames).findAll(filter);
   }
   if (list!=null){
      // retain last 5 backups
      while  (list.size() > numBackUps)
      {
         ContentDTO contentDto = new ContentDTO();
         contentDto.setPath(getBackupPath());
         log.warn("Removing earliest back up file " + "/"+list.get(0))
         contentDto.setFileName(list.get(0));
         appContentService.delete(contentDto);
         list.remove(0)
      }
   }
   
}

def doBackUp={
   String oldContents=getGroovyFunContents();
   //Do not save back up if nothing changed
   if (oldContents.equals(scriptTxt)){
      log.warn("Not taking back up. No changes..")
      msg= localize("groovyEditor.nochange.txt" , null)
      return;
   }
   String backupFileNm = selFunc.substring(0,selFunc.indexOf(".")) + "_" + new Date().getTime() + ".groovy";
   appContentService.saveUnversionedFile(oldContents, getBackupPath(), backupFileNm)
   displaySaveMsg()
   keepNBackUps()
}

def saveGroovy= {
   def success=testCompile()
   if (success)
   {
     try{
          log.debug("Doing backup");
          doBackUp()
          log.debug("Backup done, saving");
          appContentService.saveUnversionedFile(scriptTxt, getSavePath(), selFunc)
          log.debug("Save complete");
     }catch(Exception e){
        log.error("Failed to save groovy updates", e)
        appendMsg(localize('groovyEditor.cannotFindFunction.fmt.txt',[selFunc] as Object[]))
     }
     
   }else{
      showTest="none"
   }
  
}

def saveNewGroovy= {
   appContentService.saveUnversionedFile(scriptTxt, getSavePath(), selFunc)
   displaySaveMsg()
}



def initNewFunc ={
   
   scriptTxt="""
package customfunctions.html5Ui;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.sas.ui.cpb3.expr.AFunction;
import com.sas.ui.cpb3.EvaluationException;

/*
        This is a sample custom function file, implemented in Groovy using Java syntax.
        
        The Custom Function has to extend Function, and implement the 2 abstract functions
        evaluate and getArgumentCount. The getArgumentCount is used for the CPB parser to
        parse the Expression in CPB, and pass correct number of arguments as args in evaluate
        method.
        
        To use this custom function, add this declaration to CPB:
        
     Sample Usage:
        
     <ui-definition id="policy-ui-def" type="CustomObject1">
     <!--
     ================================================================
      UI Definition
     ================================================================
     -->
        <title>...</title>
        
        <function name="C_${newFnName}" qualified-class-name="customfunctions.html5Ui.${newFnName}" />
        <screen id="...">
           <initialize>
              <set name="TEMP.foo" value="C_${newFnName}(param1, param2..)" />
              
         
        
     */

public class ${newFnName} extends AFunction
{
   private static Log log = LogFactory.getLog(${newFnName}.class);

   @Override
   public Object evaluate(Object[] args) throws EvaluationException
   {
      if (args[0] != null){
         log.info("Echoing in log: " + args[0]);
      }
      return args[0];
   }

   @Override
   public int getArgumentCount()
   {
      return 1;
   }

}
"""
}

def doCmd = {
   
      def result
      switch (cmd) {
         case 'loadFunc':
         try{
               scriptTxt = getGroovyFunContents()
               showExisting="flex"
               showCreate="none"
               showTest = "flex"
               testCompile()
            }catch(Exception e){
               scriptTxt=""
               log.error(e)
               appendMsg(localize('com.sas.oprisk.framework.server.OpRiskException.message.txt',null))
            }
            
            break;
        case 'refresh':
           scriptTxt = ""
           showExisting="flex"
           showCreate="none"
           showTest = "none"
           break
        case 'test':
           showExisting="flex"
           showCreate="none"
           showTest = "flex"
           testCompile()
           break
        case 'save':
           if (!StringUtil.isEmpty(selFunc)){
              showTest = "flex"
              saveGroovy()
           }
           break
        case 'createNew':
           //initNewFunc()
           showCreate="flex"
           showExisting="none"
           showTest = "none"
           newFnName=""
           scriptTxt=""
           break;
        case 'showNew':
           selFunc=newFnName
           if (!StringUtil.validGroovyFuncName(newFnName))
           {
              showCreate="flex"
              showExisting="none"
              showTest = "none"
              appendMsg(localize("groovyEditor.invalid.fileName.txt",null));
           }else{
              
              newFnName =  newFnName.substring(0,newFnName.indexOf("."));
              ICPBService service=CPBServiceRegistry.getService(ServiceLocator.getContentService().getActiveContentId());
              if (allFunctionsList().contains(newFnName.toUpperCase())){
                 showCreate="flex"
                 showExisting="none"
                 showTest = "none"
                 appendMsg( localize("groovyEditor.function.alreadyExists",null))
                 newFnName=selFunc;
              }else{
                 initNewFunc()
                 saveNewGroovy()
                 showCreate="none"
                 //set selecteDFin
                 showExisting="flex"
                 showTest = "flex"
              }
           }
           break
       case 'flush':
          showCreate="none"
          showTest = "flex"
          SiteMaintenanceUtils.invalidateCaches();
          msg= localize("admin.flushCaches.complete.txt",null)
          break
//         default:
//            showTest = "none"
//            showExisting="flex"
//            showCreate="none"
//            scriptTxt=""
//            break
          
      }
   }
   

doCmd()

def builder = new MarkupBuilder(out)
//if (StringUtil.isEmpty(scriptTxt)){
//
//   initNewFunc();
//}


builder{
      script ('',type:"text/javascript", src: ( request.getContextPath() + "/resources/sap/ui/thirdparty/jquery.js"))
      script ('',type:"text/javascript", src: ( request.getContextPath() + "/resources/ckeditor/samples/toolbarconfigurator/lib/codemirror/codemirror.js"))
      script ('',type:"text/javascript", src: ( request.getContextPath() + "/resources/ckeditor/samples/toolbarconfigurator/lib/codemirror/javascript.js"))
      script ('',type:"text/javascript", src: ( request.getContextPath() + "/admin/groovyEditor/groovy.js"))
      link rel: "stylesheet", href: (request.getContextPath() +"/resources/ckeditor/samples/toolbarconfigurator/lib/codemirror/codemirror.css"),  type: 'text/css'
      link rel: "stylesheet", href: (request.getContextPath() + "/admin/groovyEditor/groovyEditor.css"),  type: 'text/css'
      script ('',type:"text/javascript", src: ( request.getContextPath() + "/admin/groovyEditor/groovyEditor.js"))
      title("Groovy Custom Function editor")
      def showMsg=StringUtil.isEmpty(msg)? "none":"flex"
      div(id:"main",style:"display:flex"){
         div("",id:"msg",style:"padding:10px;color:green;background-color:powderblue;display:${showMsg}" ){println msg}
         form id:"gForm",method: "POST", style:"display:flex", action: formActionPath, {
            input type:"hidden", name:"selScope", id:"selScope", value:selScope;
            input type:"hidden", name:"selFunc", id:"selFunc", value:selFunc;
            input type:"hidden", name:"cmd", id:"cmd", value:cmd;
            input type:"hidden", name:"unsavedChanges", id:"unsavedChanges", value:unsavedChanges;
            //Create new function
            div(id:"newFunc",style:"display:${showCreate}"){
               label(localize('groovyEditor.new.function.name.txt',null))
               input type:"text", name:"newFnName", id:"newFnName", value: newFnName, size:50
               input type:"button", id:"createBtn", name: "createBtn" ,onClick:"javascript:groovyEditor.showNew()", value:localize('application.button.create.txt',null)
               input type:"button", id:"cancelNew", name: "cancelNew" ,onClick:"javascript:groovyEditor.cancelNew()", value:localize('application.button.cancel.txt',null)
            }
            
            //Editing  existing functions
            div(id:"cmDiv",style:"display:${showExisting};"){
            
               if (FrameworkSystemProperties.isSymphonyMode(ServiceLocator.getContentId())) {
                  div(id:"cmPerspectiveDiv"){
                     label(localize("groovyEditor.select.scope.txt",null))
                     select id:"scopeOptions", onchange:"javascript:groovyEditor.switchScope()", {
                        option value:ServiceLocator.getContentId(), ServiceLocator.getContentId();
                        for (perspectiveName in ContentRegistryProperties.getAllPerspectiveIds(ServiceLocator.getContentId())) {
                           def formatted = PerspectiveUtil.format(ServiceLocator.getContentId(),perspectiveName)
                           if (formatted.equals(selScope)) option value:formatted, selected:true, formatted
                           else option value:formatted, formatted 
                        }
                     }
                  }
               }
               div(id:"cmHeaderDiv"){
                  label(localize("groovyEditor.select.function.txt",null))
                  select id:"groovyFuncNames", onchange:"javascript:groovyEditor.switchFunc()", {
                     option " ";
                     option value:"createNew", localize("groovyEditor.createNewFunction.txt",null)
                     for (fnName in readFunctionList()) {
                        if (fnName.equals(selFunc)) option value:fnName, selected:true, fnName
                        else option value:fnName, fnName
                     }
                  }
                  input type:"button", id:"saveBtn", name: "saveBtn" ,onClick:"javascript:groovyEditor.save()", value:localize('application.button.save.txt',null)
                  input type:"button", id:"flushBtn", name: "flushBtn" ,onClick:"javascript:groovyEditor.flush()", value:localize('admin.flushCaches.txt',null)
               }
               textarea id:"scriptTxt" , name:"scriptTxt" , rows:140, cols :100, style:"display:${showExisting}",   scriptTxt
            }
            div(id:"testDiv",style:"display:${showTest};"){
                div(id:"testHeaderDiv"){
                   label(selFunc)
                   input type:"button", id:"testBtn", name: "testBtn" ,onClick:"javascript:groovyEditor.testFunc()", value:localize('application.button.test.txt',null)
                }
                if (argCount!=null)
                {
                   argCount.times{ x ->
                      div(id:"testArg"+x){
                         label(":" + x)
                         input type:"text", name:"args${x}", id:"args${x}", value:"${getArgs(x)}", size:50
                      }
                   }
                }
                label(localize("groovyEditor.context.txt",null))
                textarea id:"contextTxt" , name:"contextTxt" , rows:5, cols :25,    contextTxt
                if (argCount==0){
                   input type:"text", name:"args", id:"args", value:"", size:50
                }
                
                //br()
                //br()
                input type:"hidden", name:"argCount", id:"argCount", value:argCount;
                label(localize("groovyEditor.results.txt",null))
                //br()
                textarea id:"resultTxt" , name:"resultTxt" , rows:12, cols :55, readOnly:true,   resultTxt
            }
         }
      }
}


msg=""
argCount=0