/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
/**
 * Describes the public facade of the {@link sap.m.SelectionDetails} control.
 * @name sap.m.SelectionDetailsFacade
 * @class The public facade of the {@link sap.m.SelectionDetails} control
 * @extends sap.ui.base.Interface
 * @since 1.48.0
 * @ui5-metamodel This control/element also will be described in the UI5 (legacy) designtime metamodel
 * @alias sap.m.SelectionDetailsFacade
 * @public
 * @author SAP SE
 * @version 800001.6.0.20241202143000_f0htmcm80p
 * @borrows sap.ui.core.Element#addCustomData as addCustomData
 * @borrows sap.ui.core.Element#getCustomData as getCustomData
 * @borrows sap.ui.core.Element#indexOfCustomData as indexOfCustomData
 * @borrows sap.ui.core.Element#insertCustomData as insertCustomData
 * @borrows sap.ui.core.Element#removeCustomData as removeCustomData
 * @borrows sap.ui.core.Element#removeAllCustomData as removeAllCustomData
 * @borrows sap.ui.core.Element#destroyCustomData as destroyCustomData
 * @borrows sap.ui.core.Element#data as data
 * @borrows sap.ui.core.Element#addEventDelegate as addEventDelegate
 * @borrows sap.ui.core.Element#removeEventDelegate as removeEventDelegate
 * @borrows sap.m.SelectionDetails#attachBeforeOpen as attachBeforeOpen
 * @borrows sap.m.SelectionDetails#detachBeforeOpen as detachBeforeOpen
 * @borrows sap.m.SelectionDetails#attachBeforeClose as attachBeforeClose
 * @borrows sap.m.SelectionDetails#detachBeforeClose as detachBeforeClose
 * @borrows sap.m.SelectionDetails#attachNavigate as attachNavigate
 * @borrows sap.m.SelectionDetails#detachNavigate as detachNavigate
 * @borrows sap.m.SelectionDetails#attachActionPress as attachActionPress
 * @borrows sap.m.SelectionDetails#detachActionPress as detachActionPress
 * @borrows sap.m.SelectionDetails#addAction as addAction
 * @borrows sap.m.SelectionDetails#removeAction as removeAction
 * @borrows sap.m.SelectionDetails#removeAllActions as removeAllActions
 * @borrows sap.m.SelectionDetails#addActionGroup as addActionGroup
 * @borrows sap.m.SelectionDetails#removeActionGroup as removeActionGroup
 * @borrows sap.m.SelectionDetails#removeAllActionGroups as removeAllActionGroups
 */
/**
 * Describes the public facade of the {@link sap.m.SelectionDetailsItem} element.
 * @name sap.m.SelectionDetailsItemFacade
 * @class The public facade of the {@link sap.m.SelectionDetailsItem} element
 * @extends sap.ui.base.Interface
 * @since 1.48.0
 * @ui5-metamodel This control/element also will be described in the UI5 (legacy) designtime metamodel
 * @alias sap.m.SelectionDetailsItemFacade
 * @public
 * @author SAP SE
 * @version 800001.6.0.20241202143000_f0htmcm80p
 * @borrows sap.ui.core.Element#addCustomData as addCustomData
 * @borrows sap.ui.core.Element#getCustomData as getCustomData
 * @borrows sap.ui.core.Element#indexOfCustomData as indexOfCustomData
 * @borrows sap.ui.core.Element#insertCustomData as insertCustomData
 * @borrows sap.ui.core.Element#removeCustomData as removeCustomData
 * @borrows sap.ui.core.Element#removeAllCustomData as removeAllCustomData
 * @borrows sap.ui.core.Element#destroyCustomData as destroyCustomData
 * @borrows sap.ui.core.Element#data as data
 * @borrows sap.ui.core.Element#addEventDelegate as addEventDelegate
 * @borrows sap.ui.core.Element#removeEventDelegate as removeEventDelegate
 * @borrows sap.m.SelectionDetailsItem#setEnableNav as setEnableNav
 * @borrows sap.m.SelectionDetailsItem#getEnableNav as getEnableNav
 * @borrows sap.m.SelectionDetailsItem#addAction as addAction
 * @borrows sap.m.SelectionDetailsItem#removeAction as removeAction
 */