/*
 * Copyright 2014, 2016 SAS Institute Inc.
 * All Rights Reserved.
 *
 */

jQuery.sap.declare("sas.hc.m.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.m
 * @public
 */

// library dependencies
jQuery.sap.require("sap.m.library");
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sas.hc.tnt.library");
jQuery.sap.require("sas.hc.ui.unified.library");
jQuery.sap.require("sas.hc.ui.core.library");
jQuery.sap.require("sas.ltjs.sasicu.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
    name : "sas.hc.m",
    dependencies : ["sap.m","sap.ui.core","sas.hc.tnt","sas.hc.ui.unified","sas.hc.ui.core","sas.ltjs.sasicu"],
    types : [
        "sas.hc.m.InputLabelPosition",
        "sas.hc.m.MessageDialogAction",
        "sas.hc.m.MessageDialogType",
        "sas.hc.m.MessageSummaryLayoutModeType",
        "sas.hc.m.MessageSummaryFilterButtonType",
        "sas.hc.m.TabState",
        "sas.hc.m.InfoFormat"
    ],
    interfaces : [
    ],
    controls : [
        "sas.hc.m.a11yHelper",
        "sas.hc.m.AbstractNumericFormatter",
        "sas.hc.m.ActionListItem",
        "sas.hc.m.ActionSelect",
        "sas.hc.m.ActionSheet",
        "sas.hc.m.App",
        "sas.hc.m.ARIALiveConstants",
        "sas.hc.m.ARIARoleConstants",
        "sas.hc.m.BannerHeading",
        "sas.hc.m.Bar",
        "sas.hc.m.BaseValidationAdapter",
        "sas.hc.m.BusyDialog",
        "sas.hc.m.BusyIndicator",
        "sas.hc.m.Button",
        "sas.hc.m.Carousel",
        "sas.hc.m.CheckBox-A11Y",
        "sas.hc.m.CheckBox",
        "sas.hc.m.ColorPickerResponsivePopover",
        "sas.hc.m.Column",
        "sas.hc.m.ColumnListItem",
        "sas.hc.m.ComboBox",
        "sas.hc.m.ComboBoxBase",
        "sas.hc.m.ComboBoxTextField",
        "sas.hc.m.CompositeInput",
        "sas.hc.m.CompositeInputPropertyItem",
        "sas.hc.m.CustomListItem",
        "sas.hc.m.CustomTile",
        "sas.hc.m.CustomTileStyled",
        "sas.hc.m.DatePicker",
        "sas.hc.m.DateRangeSelection",
        "sas.hc.m.DateTimeComposite",
        "sas.hc.m.DateTimeCompositeUtil",
        "sas.hc.m.DateTimeInput",
        "sas.hc.m.DateTimePicker",
        "sas.hc.m.DefaultNumericFormatter",
        "sas.hc.m.Dialog",
        "sas.hc.m.DisplayListItem",
        "sas.hc.m.ExpandableTextArea",
        "sas.hc.m.FacetFilter",
        "sas.hc.m.FacetFilterItem",
        "sas.hc.m.FacetFilterList",
        "sas.hc.m.FeedInput",
        "sas.hc.m.FeedListItem",
        "sas.hc.m.FlexBox",
        "sas.hc.m.FlexItemData",
        "sas.hc.m.FormattedText",
        "sas.hc.m.GroupHeaderListItem",
        "sas.hc.m.GroupToken",
        "sas.hc.m.GrowingEnablement",
        "sas.hc.m.GrowingList",
        "sas.hc.m.HBox",
        "sas.hc.m.Header",
        "sas.hc.m.Heading",
        "sas.hc.m.HelpPopup",
        "sas.hc.m.IconTabBar",
        "sas.hc.m.IconTabFilter",
        "sas.hc.m.IconTabHeader",
        "sas.hc.m.IconTabSeparator",
        "sas.hc.m.IconTabTextValidationAdapter",
        "sas.hc.m.Image",
        "sas.hc.m.Input",
        "sas.hc.m.InputBase",
        "sas.hc.m.InputListItem",
        "sas.hc.m.InputValidationAdapter",
        "sas.hc.m.Label",
        "sas.hc.m.Link",
        "sas.hc.m.List",
        "sas.hc.m.ListBase",
        "sas.hc.m.ListDesktopBehaviorEnablement",
        "sas.hc.m.ListItemBase",
        "sas.hc.m.ListItemDesktopBehaviorEnablement",
        "sas.hc.m.ListScrollEnablement",
        "sas.hc.m.MaxLengthValidationAdapter",
        "sas.hc.m.Menu",
        "sas.hc.m.MenuButton",
        "sas.hc.m.MenuItem",
        "sas.hc.m.MessageBox",
        "sas.hc.m.MessageDialog",
        "sas.hc.m.MessagePage",
        "sas.hc.m.MessagePopover",
        "sas.hc.m.MessagePopoverItem",
        "sas.hc.m.MessageStrip",
        "sas.hc.m.MessageSummary",
        "sas.hc.m.MessageToast",
        "sas.hc.m.MessageView",
        "sas.hc.m.MonthPicker",
        "sas.hc.m.MonthPickerDialog",
        "sas.hc.m.MultiComboBox",
        "sas.hc.m.MultiInput",
        "sas.hc.m.NavContainer",
        "sas.hc.m.NavListItem",
        "sas.hc.m.NumericStepper",
        "sas.hc.m.ObjectAttribute",
        "sas.hc.m.ObjectHeader",
        "sas.hc.m.ObjectIdentifier",
        "sas.hc.m.ObjectListItem",
        "sas.hc.m.ObjectMarker",
        "sas.hc.m.ObjectNumber",
        "sas.hc.m.ObjectStatus",
        "sas.hc.m.OverflowButton",
        "sas.hc.m.OverflowList",
        "sas.hc.m.OverflowListItem",
        "sas.hc.m.OverflowToolbar",
        "sas.hc.m.OverflowToolbarAssociativePopover",
        "sas.hc.m.OverflowToolbarAssociativePopoverControls",
        "sas.hc.m.OverflowToolbarButton",
        "sas.hc.m.OverflowToolbarLayoutData",
        "sas.hc.m.P13nColumnsItem",
        "sas.hc.m.P13nColumnsPanel",
        "sas.hc.m.P13nConditionPanel",
        "sas.hc.m.P13nDialog",
        "sas.hc.m.P13nDimMeasureItem",
        "sas.hc.m.P13nDimMeasurePanel",
        "sas.hc.m.P13nFilterItem",
        "sas.hc.m.P13nFilterPanel",
        "sas.hc.m.P13nGroupItem",
        "sas.hc.m.P13nGroupPanel",
        "sas.hc.m.P13nItem",
        "sas.hc.m.P13nPanel",
        "sas.hc.m.P13nSortItem",
        "sas.hc.m.P13nSortPanel",
        "sas.hc.m.Page",
        "sas.hc.m.PageAccessibleLandmarkInfo",
        "sas.hc.m.PagingButton",
        "sas.hc.m.Panel",
        "sas.hc.m.PDFViewer",
        "sas.hc.m.PlanningCalendar",
        "sas.hc.m.Popover",
        "sas.hc.m.PopoverPatches",
        "sas.hc.m.ProgressIndicator",
        "sas.hc.m.PullToRefresh",
        "sas.hc.m.QuarterPicker",
        "sas.hc.m.QuarterPickerDialog",
        "sas.hc.m.RadioButton",
        "sas.hc.m.RadioButtonGroup",
        "sas.hc.m.RangeValidationAdapter",
        "sas.hc.m.RatingIndicator",
        "sas.hc.m.ResponsivePopover",
        "sas.hc.m.ResponsiveToolbar",
        "sas.hc.m.ScrollContainer",
        "sas.hc.m.SearchButton",
        "sas.hc.m.SearchField",
        "sas.hc.m.SegmentedButton",
        "sas.hc.m.SegmentedButtonItem",
        "sas.hc.m.Select",
        "sas.hc.m.SelectDialog",
        "sas.hc.m.SelectList",
        "sas.hc.m.Shell",
        "sas.hc.m.Slider",
        "sas.hc.m.SplitApp",
        "sas.hc.m.SplitContainer",
        "sas.hc.m.StandardListItem",
        "sas.hc.m.StandardTile",
        "sas.hc.m.StandardTreeItem",
        "sas.hc.m.SuggestionItem",
        "sas.hc.m.Switch",
        "sas.hc.m.TabbableInterface",
        "sas.hc.m.Table",
        "sas.hc.m.TableSelectDialog",
        "sas.hc.m.TabStripSelectList",
        "sas.hc.m.Text",
        "sas.hc.m.TextArea",
        "sas.hc.m.Tile",
        "sas.hc.m.TileContainer",
        "sas.hc.m.TimePicker",
        "sas.hc.m.TimePickerComboBox",
        "sas.hc.m.TimePickerComboBoxes",
        "sas.hc.m.TimePickerSlider",
        "sas.hc.m.TimePickerSliders",
        "sas.hc.m.Title",
        "sas.hc.m.TitleCheckBox",
        "sas.hc.m.ToggleButton",
        "sas.hc.m.Token",
        "sas.hc.m.Tokenizer",
        "sas.hc.m.Toolbar",
        "sas.hc.m.ToolbarLayoutData",
        "sas.hc.m.ToolbarSeparator",
        "sas.hc.m.ToolbarSpacer",
        "sas.hc.m.ToolHeaderOverflowButton",
        "sas.hc.m.Tree",
        "sas.hc.m.TreeItemBase",
        "sas.hc.m.UploadCollection",
        "sas.hc.m.UploadCollectionItem",
        "sas.hc.m.UploadCollectionParameter",
        "sas.hc.m.UploadCollectionToolbarPlaceholder",
        "sas.hc.m.Validator",
        "sas.hc.m.VBox",
        "sas.hc.m.ViewSettingsCustomItem",
        "sas.hc.m.ViewSettingsDialog",
        "sas.hc.m.ViewSettingsFilterItem",
        "sas.hc.m.ViewSettingsItem",
        "sas.hc.m.WeekPicker",
        "sas.hc.m.WeekPickerDialog",
        "sas.hc.m.ZeroState",
        "sas.hc.m.colorpicker.ColorPicker",
        "sas.hc.m.colorpicker.layout.BasicCustomContent",
        "sas.hc.m.colorpicker.layout.ColorPickerContainer",
        "sas.hc.m.colorpicker.model.ColorChangeObject",
        "sas.hc.m.delegate.ValueStateMessage",
        "sas.hc.m.facetSearch.FacetSearch",
        "sas.hc.m.facetSearch.FacetSearchListItem",
        "sas.hc.m.facetSearch.FacetSearchListView",
        "sas.hc.m.facetSearch.FacetSearchModel",
        "sas.hc.m.fontChooser.CustomSelectList",
        "sas.hc.m.fontChooser.CustomStyleItem",
        "sas.hc.m.fontChooser.FontChooser",
        "sas.hc.m.fontChooser.FontChooserVO",
        "sas.hc.m.fontChooser.FontFamilySelect",
        "sas.hc.m.objectInspector.FormatUtil",
        "sas.hc.m.objectInspector.ObjectInspector",
        "sas.hc.m.objectInspector.ObjectInspectorBase",
        "sas.hc.m.slider.BaseSlider",
        "sas.hc.m.slider.DateTimeStepEnum",
        "sas.hc.m.slider.HorizontalSlider",
        "sas.hc.m.slider.InputTypeEnum",
        "sas.hc.m.slider.VerticalSlider",
        "sas.hc.m.slider.a11y.A11ySlider",
        "sas.hc.m.slider.operatorMenu.OperatorEnum",
        "sas.hc.m.tags.TagInput",
        "sas.hc.m.tags.TagDialog",
        "sas.hc.m.tags.TagInfoProvider",
        "sas.hc.m.tokenInput.TokenInput",
        "sas.hc.m.util.DateUtil"
    ],
    elements : [
    ],
    version : "800001.10.0.20241202143000_f0htmcm80p"});

/////////////////////////////////////////////////////
// START: Monkey patch Custom styles.
/////////////////////////////////////////////////////

// sap.m.Label
(function(){
    jQuery.sap.require('sap.m.LabelRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Label.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMLabel:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.LabelRenderer.getCustomCSSRules=function(oControl){
        var a={},cssSelector = "#"+oControl.getId()+".sapMLabel";
        a[cssSelector]=oControl.getCustomStyles().getStyles();
        return a;
    };
}());

// sap.m.ListBase
(function(){
    jQuery.sap.require('sap.m.ListBase');
    var fnOldApplySettings = sap.m.ListBase.prototype._applySettingsToItem;
    /**
     * Apply ListBase settings to given list item
     * @param {object} oItem TODO-jsdoc
     * @param {boolean} bOnlyProperties TODO-jsdoc
     */
    sap.m.ListBase.prototype._applySettingsToItem=function(oItem, bOnlyProperties) {
        fnOldApplySettings.apply(this, arguments);
        // apply custom styles if applicable.
        // filter only color style property
        // apply only if this item is not within a List since List applies the styles for its items
        if (!oItem.getParent() instanceof sap.m.List) {

            var colorStyleVal = this.getCustomStyles() && this.getCustomStyles().getPropertyValue('color', this.getCustomStyles().getStyles()),
                selectedColorStyleVal = this.getCustomStyles() && this.getCustomStyles().getPropertyValue('color', this.getCustomStyles().getSelectedStateStyles()),
                styleObj = undefined;
            if (colorStyleVal || selectedColorStyleVal) {
                styleObj = new sas.hc.ui.core.Styles();
                styleObj.setStyles(colorStyleVal ? {color: colorStyleVal} : undefined);
                styleObj.setSelectedStateStyles(selectedColorStyleVal ? {color: selectedColorStyleVal} : undefined);
            }
            oItem.setCustomStyles(styleObj);
        }
    };

    /**
     * Pass on custom styles set on this control to child controls if any.
     */
    sap.m.ListBase.prototype.doSetCustomStyles=function(){
        // render child controls
        var aItems = this.getItems(),
            bRenderItems = this.shouldRenderItems(),
            colorVal = this.getCustomStyles() && this.getCustomStyles().getPropertyValue('color',this.getCustomStyles().getStyles()),
            selectedColorVal = this.getCustomStyles() && this.getCustomStyles().getPropertyValue('color',this.getCustomStyles().getSelectedStateStyles()),
            styleObj=undefined;
        if(colorVal || selectedColorVal){
            styleObj = new sas.hc.ui.core.Styles();
            styleObj.setStyles(colorVal ? {color:colorVal}:undefined);
            styleObj.setSelectedStateStyles(selectedColorVal ? {color:selectedColorVal} : undefined);
        }
        // filter only color style property
        bRenderItems && aItems.forEach(function(oItem) {
            // apply only if this item is not within a List since List applies the styles for its items
            if (!oItem.getParent() instanceof sap.m.List)
                oItem.setCustomStyles(styleObj);
        });
    };

    jQuery.sap.require('sap.m.ListRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}.
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id> .sapMLIB:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.ListRenderer.getCustomCSSRules=function(oControl){
        var a={},
            id="#"+oControl.getId(),
            cssSelector = id+" .sapMLIB:not(.sapMLIBSelected):not(:hover)",
            sss,
            oCustS = oControl.getCustomStyles() ? oControl.getCustomStyles().getStyles() : null;

        if(oCustS){
            // this is for the list
            a[cssSelector]=oCustS;
            // no border around icon ever
            a[id+" .sapMSLIImgIcon.sapUiIcon"] = { 'border': 'none'};
            a[id+" .sasMLIBIconAction.sapUiIcon"] = { 'border': 'none'};


            // check for selectedState styles.
            sss = oControl.getCustomStyles().getSelectedStateStyles();
            if (sss) {
                a[id+' .sapMLIB.sapMLIBSelected,'+id+' .sapMLIB:hover,'+id+' .sapMLIB.sapMLIBSelected:hover'] = sss;
            }

            // now the list items
            id="#"+oControl.getId()+" .sapMLIB.sapMSLI:not(.sapMLIBSelected):not(:hover)",
            cssSelector = id+" .sapMSLITitle,"+id+" .sapMSLIDescription,"+id+" .sapMSLITitleOnly,"+id+" .sapMLIBCounter,"
                +id+" .sapMSLIImgIcon.sapUiIcon," +id+" .sasMLIBIconAction.sapUiIcon," +id+" .sapMSLIInfo";
            a[cssSelector]=oCustS;

            // apply selected state styles if any to the list items
            if(sss){
                var sStateLIBId="#"+oControl.getId()+" .sapMLIBSelected.sapMSLI", // selected item
                    sStateLIBHover="#"+oControl.getId()+" .sapMSLI.sapMLIB:hover",// hover over non-selected item
                    selectedStateSelector=sStateLIBHover+" .sapMSLITitle,"+sStateLIBHover+" .sapMSLIDescription,"
                        +sStateLIBHover+" .sapMSLITitleOnly,"+sStateLIBHover+" .sapMLIBCounter,"
                        +sStateLIBHover+" .sapMSLIImgIcon.sapUiIcon,"
                        +sStateLIBHover+" .sasMLIBIconAction.sapUiIcon,"
                        +sStateLIBHover+" .sapMSLIInfo,"
                        +sStateLIBId+" .sapMSLITitle,"+sStateLIBId+" .sapMSLIDescription,"
                        +sStateLIBId+" .sapMSLITitleOnly,"+sStateLIBId+" .sapMLIBCounter,"
                        +sStateLIBId+" .sapMSLIImgIcon.sapUiIcon,"
                        +sStateLIBId+" .sasMLIBIconAction.sapUiIcon,"
                        +sStateLIBId+" .sapMSLIInfo";
                a[selectedStateSelector] = sss;
            }

            // if there is a font size then the elements have to be sized appropriately

            var fontSize = oControl.getCustomStyles().getPropertyValue('font-size', oCustS);
            if (fontSize) {
                var sNewSize, iFontSize = parseFloat(fontSize), sUnits = /[a-z]*$/ig.exec(fontSize);
                if (iFontSize>0) { // sanity check in case fontSize was garbage
                    sNewSize = (1.5*iFontSize)+""; // convert to string
                    sNewSize += sUnits ? sUnits[0] : "";
                    id = /* '.sapMSltPopup '+ */ "#"+oControl.getId()+' .sapMLIB.sapMSLI:not(.sapMLIBSelected):not(:hover)';
                    a[ id+' .sapMLIBContent' /*.sapMSLIImgIcon.sapUiIcon'*/] = {/*'height':sNewSize, 'width':sNewSize, */'line-height':sNewSize};
                    a[ id+' .sapMSLIImgIcon.sapUiIcon'] = {'height':sNewSize, 'width':sNewSize, 'line-height':sNewSize};
                    a[ id+' .sasMLIBIconAction.sapUiIcon'] = {'height':sNewSize, 'width':sNewSize, 'line-height':sNewSize};
                    a[id+' .sapMSLIImg.sapMImg '] = {'height':sNewSize, 'width':sNewSize};


                    sNewSize = (1.5*iFontSize + 11)+"";
                    sNewSize += sUnits ? sUnits[0] : "";
                    a["#"+ oControl.getId() + " .sapMLIB:not(.sapMLIBSelected):not(:hover)"] = jQuery.extend({'height': sNewSize}, a["#"+ oControl.getId() + " .sapMLIB:not(.sapMLIBSelected):not(:hover)"] ||{});

                    // this is to line up items in the drop down list
                    sNewSize = (iFontSize/2)+""; // left margin of text in list box is half the font size
                    sNewSize += sUnits ? sUnits[0] : "";
                    a[id +" .sapMSLIImg.sapMImg+.sapMSLIDiv.sapMSLITitleDiv>.sapMSLITitleOnly"] = jQuery.extend(a[id+" .sapMSLIImg.sapMImg+.sapMSLIDiv.sapMSLITitleDiv>.sapMSLITitleOnly"] || {},
                        {'margin-left':sNewSize});
                }
            }

            // if there is a font size for the selected then the elements have to be sized appropriately when selected
            fontSize = oControl.getCustomStyles().getPropertyValue('font-size', sss);
            if (fontSize) {
                iFontSize = parseFloat(fontSize), sUnits = /[a-z]*$/ig.exec(fontSize);
                if (iFontSize>0) { // sanity check in case fontSize was garbage
                    sNewSize = (1.5*iFontSize)+""; // convert to string
                    sNewSize += sUnits ? sUnits[0] : "";
                    sStateLIBId="#"+oControl.getId()+" .sapMLIBSelected.sapMSLI", // selected item
                    sStateLIBHover="#"+oControl.getId()+" .sapMLIB.sapMSLI:hover",// hover over item

                    //id = /* '.sapMSltPopup '+ */ "#"+oControl.getId()+' .sapMLIB.sapMSLI:not(.sapMLIBSelected):not(:hover)';
                    a[ sStateLIBId+' .sapMLIBContent, '+ sStateLIBHover+' .sapMLIBContent'  /*.sapMSLIImgIcon.sapUiIcon'*/] = {/*'height':sNewSize, 'width':sNewSize, */'line-height':sNewSize};
                    a[ sStateLIBId+' .sapMSLIImgIcon.sapUiIcon, '+sStateLIBHover+' .sapMSLIImgIcon.sapUiIcon'] = {'height':sNewSize, 'width':sNewSize, 'line-height':sNewSize};
                    a[ sStateLIBId+' .sasMLIBIconAction.sapUiIcon, '+sStateLIBHover+' .sasMLIBIconAction.sapUiIcon'] = {'height':sNewSize, 'width':sNewSize, 'line-height':sNewSize};
                    a[sStateLIBId+' .sapMSLIImg.sapMImg, '+sStateLIBHover+' .sapMSLIImg.sapMImg'] = {'height':sNewSize, 'width':sNewSize};
                    id = "#"+ oControl.getId();

                    sNewSize = (1.5*iFontSize + 11)+"";
                    sNewSize += sUnits ? sUnits[0] : "";
                    a[id+' .sapMLIB.sapMLIBSelected,'+id+' .sapMLIB:hover,'+id+' .sapMLIB.sapMLIBSelected:hover'] = jQuery.extend({'height': sNewSize}, a[id+' .sapMLIB.sapMLIBSelected,'+id+' .sapMLIB:hover,'+id+' .sapMLIB.sapMLIBSelected:hover'] ||{});;
                }
            }
        }
        return a;
    };

    jQuery.sap.require('sap.m.StandardListItemRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id> .sapMLIB:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.StandardListItemRenderer.getCustomCSSRules=function(oControl){
        var a={};
        // If this list item is inside a List control there is nothing to do since List applies the custom styles
        // for its items
        if (!oControl.getParent() instanceof sap.m.List) {
            var id = "#" + oControl.getId() + ":not(.sapMLIBSelected):not(:hover)",
                cssSelector = id + " .sapMSLITitle," + id + " .sapMSLIDescription," + id + " .sapMSLITitleOnly," + id + " .sapMLIBCounter";
            a[cssSelector] = oControl.getCustomStyles().getStyles();

            // selected state styles if any.
            if (oControl.getCustomStyles().getSelectedStateStyles()) {
                var sStateLIBId = "#" + oControl.getId() + ".sapMLIBSelected", // selected item
                    sStateLIBHover = "#" + oControl.getId() + ".sapMLIB:hover",// hover over non-selected item
                    selectedStateSelector = sStateLIBHover + " .sapMSLITitle," + sStateLIBHover + " .sapMSLIDescription,"
                        + sStateLIBHover + " .sapMSLITitleOnly," + sStateLIBHover + " .sapMLIBCounter,"
                        + sStateLIBId + " .sapMSLITitle," + sStateLIBId + " .sapMSLIDescription,"
                        + sStateLIBId + " .sapMSLITitleOnly," + sStateLIBId + " .sapMLIBCounter";
                a[selectedStateSelector] = oControl.getCustomStyles().getSelectedStateStyles();
            }
        }

        return a;
    };

}());

// sap.m.Popover
(function(){
    jQuery.sap.require('sap.m.Popover');

    /**
     * Pass on custom styles set on this control to child controls if any.
     */
    sap.m.Popover.prototype.doSetCustomStyles=function(){
        var header = this._getAnyHeader(),
            subHeader = this.getSubHeader();
        //footer = this.getFooter();
        header && header.setCustomStyles(this.getCustomStyles());
        // set it to sub header if any.
        subHeader && subHeader.setCustomStyles(this.getCustomStyles());
        // dont do it for footer. For some reason Flex didn't do it.
        // set it to footer if any.
        //footer && footer.setCustomStyles(this.getCustomStyles());
    };

    jQuery.sap.require('sap.m.PopoverRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMPopover:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.PopoverRenderer.getCustomCSSRules=function(oControl){
        var a={},
            id="#"+oControl.getId(),
            cssSelector = id+".sapMPopover",
            cs=oControl.getCustomStyles(),
            bgColor=cs ? cs.getPropertyValue('background',cs.getStyles()) || cs.getPropertyValue('background-color',cs.getStyles()) : undefined;
        a[cssSelector]=cs.getStyles();
        // check if background[-color] exists.
        if(bgColor){
            a[id+" .sapMPopoverArrUp:after"]={ 'border-bottom-color':bgColor};
            a[id+" .sapMPopoverArrDown:after"]={ 'border-top-color':bgColor};
            a[id+" .sapMPopoverArrLeft:after"]={ 'border-right-color':bgColor};
            a[id+" .sapMPopoverArrRight:after"]={ 'border-left-color':bgColor};
            //For HTMLCOMMONS-5082, add this for popover list background color
            a[id+" div.sapMPopoverCont"] = {"background-color": bgColor};
        }
        return a;
    };

    jQuery.sap.require("sap.m.PopoverRenderer");

    var fnOldRender = sap.m.PopoverRenderer.render;

    // SDK Copy Start - ramars - S1173711- 1.28 - PopoverRenderer-dbg.js 22:46
    sap.m.PopoverRenderer.render = function(rm, oControl) {

        // We do some null checking here and if everything looks good we
        // go ahead and call the original function. Otherwise we spit out
        // an error message to the console and do nothing

        // Note that we are checking that the control exists and has definitions
        // for the various functions that are going to be called in the either the
        // main renderer or the generateRootClasses subroutine. This is a fix for
        // cases where we attempt to render popovers that have somehow become
        // corrupted just before or perhaps during the rendering process.

        if (oControl
            && oControl.getTooltip_AsString
            && oControl.getSubHeader
            && oControl.getFooter
            && oControl.getVerticalScrolling
            && oControl.getHorizontalScrolling
            && oControl.getShowHeader
            && oControl._getAnyHeader
            && oControl._hasSingleNavContent
            && oControl._hasSinglePageContent
            && oControl.getPlacement) {
            fnOldRender.call(this, rm, oControl);
        } else {
            sas.log.error("Attempting to render corrupt instance of Popover: " + oControl);
        }
    };
    // SDK Copy End
}());

//sap.m.Bar && Toolbar
(function(){
    jQuery.sap.require('sap.m.Bar');

    /**
     * Pass on custom styles set on this control to child controls if any.
     */
    sap.m.Bar.prototype.doSetCustomStyles=function(){
        var that=this;
        function passOnCustomStyles(){
            var contentLeft = that.getContentLeft(),
                contentMiddle = that.getContentMiddle(),
                contentRight = that.getContentRight();

            // set it to right content if any.
            contentLeft && contentLeft.forEach(function(oItem){
                oItem.setCustomStyles(that.getCustomStyles());
            });
            // set it to middle content if any.
            contentMiddle && contentMiddle.forEach(function(oItem){
                oItem.setCustomStyles(that.getCustomStyles());
            });
            // set it to right content if any.
            contentRight && contentRight.forEach(function(oItem){
                oItem.setCustomStyles(that.getCustomStyles());
            });
        }
        passOnCustomStyles();
        // add a delegate in case content is not generated yet.
        var oDelegate = {
            onBeforeRendering:function(){
                passOnCustomStyles();
            },
            onAfterRendering:function(){
                that.removeEventDelegate(this);
            }
        };
        this.addEventDelegate(oDelegate);

    };

    jQuery.sap.require('sap.m.BarRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMBarContainer:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.BarRenderer.getCustomCSSRules=function(oControl){
        var a={},id="#"+oControl.getId(),cssSelector = id+".sapMBar,"+id+" .sapMBarContainer";
        a[cssSelector]=oControl.getCustomStyles().getStyles();
        return a;
    };

    jQuery.sap.require('sap.m.ToolbarRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMTB:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.ToolbarRenderer.getCustomCSSRules=function(oControl){
        var a={},id="#"+oControl.getId(),cssSelector = id+".sapMTB";
        a[cssSelector]=oControl.getCustomStyles().getStyles();
        return a;
    };

}());

// sap.m.ComboBox & MultiCombBox
(function(){
    jQuery.sap.require('sap.m.ComboBox');

    /**
     * Pass on custom styles set on this control to child controls if any.
     */
    sap.m.ComboBox.prototype.doSetCustomStyles=function(){
        var picker = this.getPicker();
        var list = this.getList();
        var styles = this.getCustomStyles();
        list.setCustomStyles(styles);
        picker.setCustomStyles(styles);
    };

    jQuery.sap.require('sap.m.ComboBoxRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMComboBox:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.ComboBoxRenderer.getCustomCSSRules=function(oControl){
        var a={},
            id="#"+oControl.getId(),
            cssSelector = id + ".sapMInputBase",
            cs=oControl.getCustomStyles() ? oControl.getCustomStyles().getStyles() : null;
        if(cs){
            a[cssSelector]=cs;
            var backgroundColor = oControl.getCustomStyles().getPropertyValue('background',cs) || oControl.getCustomStyles().getPropertyValue('background-color',cs);
            var fontSize = oControl.getCustomStyles().getPropertyValue('font-size', cs);
            var height = oControl.getCustomStyles().getPropertyValue('height', cs);
            var iFontSize = parseFloat(fontSize);
            var iHeight = parseFloat(height);
            var fontSizeUnits = /[a-z]*$/ig.exec(fontSize);
            fontSizeUnits = fontSizeUnits ? fontSizeUnits[0] : "";
            cssSelector = id + ">input" + ".sapMInputBaseInner";
            a[cssSelector] = jQuery.extend({}, cs);
            if (iFontSize > 0) {
                if(!(iHeight > 0)){
                    height = (iFontSize + ((fontSizeUnits === "rem")? 2 : 16)) + fontSizeUnits;
                    a[id + ".sapMInputBase"] = jQuery.extend({'height': height}, a[cssSelector] || {});
                    iHeight = parseFloat(height);
                }
                cssSelector = id + ">input" + ".sapMInputBaseInner";
                var heightUnits = /[a-z]*$/ig.exec(height);
                heightUnits = heightUnits ? heightUnits[0] : "";
                a[cssSelector] = jQuery.extend(a[cssSelector], {"height": (iHeight - ((heightUnits === "rem") ? 0.325 : 6)) + heightUnits});
                cssSelector = id + ">button" + ".sapMComboBoxBaseArrow";
                iHeight = (iHeight - ((heightUnits === "rem") ? 0.5 : 8));
                var iWidth = iHeight*1.33;
                a[cssSelector] = {"width": iWidth + heightUnits, "height": iHeight + heightUnits, "line-height" : iHeight + heightUnits};
                cssSelector = id + ">input" + ".sapMComboBoxBaseInputInner:not(.sapMComboBoxBaseInputInnerReadonly)";
                var iPadding = (iWidth + ((heightUnits === "rem") ? 0.5 : 8));
                a[cssSelector] = {"padding-right" : iPadding + heightUnits};
            }
            if(backgroundColor){
                a[id + ">input" + ".sapMInputBaseInner"] = jQuery.extend({'background-color': backgroundColor, 'border-color': backgroundColor}, a[id + ">input" + ".sapMInputBaseInner"] || {});
                a[id + ">button" + ".sapMComboBoxBaseArrow"] = jQuery.extend({'background-color': backgroundColor}, a[id + ">button" + ".sapMComboBoxBaseArrow"] || {});
            }
            var color = oControl.getCustomStyles().getPropertyValue('color',cs);
            if(color){
                a[id + ">input" + ".sapMInputBaseInner"] = jQuery.extend({'color': color}, a[id + ">input" + ".sapMInputBaseInner"] || {});
            }

        }
        return a;
    };
}());

(function(){
    jQuery.sap.require('sap.m.MultiComboBox');

    /**
     * Pass on custom styles set on this control to child controls if any.
     */
    sap.m.MultiComboBox.prototype.doSetCustomStyles=function(){
        var customStyles = this.getCustomStyles();
        if(customStyles){
            var list = this.getList();
            var picker = this.getPicker();
            var styles = customStyles.getStyles();
            var selectedStateStyles = customStyles.getSelectedStateStyles();
            styles = jQuery.extend({}, styles);
            selectedStateStyles = jQuery.extend({}, selectedStateStyles);
            delete styles.width;
            delete selectedStateStyles.width;
            var listStyles = new sas.hc.ui.core.Styles().setStyles(styles).setSelectedStateStyles(selectedStateStyles);
            picker.setCustomStyles(customStyles);
            list.setCustomStyles(listStyles);
        }
    };

    jQuery.sap.require('sap.m.MultiComboBoxRenderer');
    /**
     * Determine CSS rules that should be sufficient to apply custom styles on this instance of Control.
     * Custom styles can be accessed using Control.getCustomStyles().
     * @see {sas.hc.ui.core.Styles}
     *
     * @param {sap.ui.core.Control} oControl an object representation of the control that should be rendered
     * @returns {object} An Object with CSS selector as key and CSS style JSON object as value. E.g.
     * <code>
     * {
     *   #<control-id>.sapMMultiComboBox:{
     *          "background-color":"rgba(255,1,255,0.5)",
     *          ...
     *       }
     * }
     * </code>
     */
    sap.m.MultiComboBoxRenderer.getCustomCSSRules=function(oControl){
        var a={},
            id="#"+oControl.getId(),
            cssSelector = id + ".sapMInputBase";
        var cs=oControl.getCustomStyles() ? oControl.getCustomStyles().getStyles() : null;
        if(cs){
            a[cssSelector]=cs;
            var backgroundColor = oControl.getCustomStyles().getPropertyValue('background',cs) || oControl.getCustomStyles().getPropertyValue('background-color',cs);
            var fontSize = oControl.getCustomStyles().getPropertyValue('font-size', cs);
            var height = oControl.getCustomStyles().getPropertyValue('height', cs);
            var iFontSize = parseFloat(fontSize);
            var iHeight = parseFloat(height);
            var fontSizeUnits = /[a-z]*$/ig.exec(fontSize);
            fontSizeUnits = fontSizeUnits ? fontSizeUnits[0] : "";
            a[id + " span"] = jQuery.extend({}, cs);
            if (iFontSize > 0) {

                if(!(iHeight > 0)){
                    height = (iFontSize + ((fontSizeUnits === "rem")? 2 : 16)) + fontSizeUnits;
                    a[cssSelector] = jQuery.extend({'height': height}, a[cssSelector] || {});
                    iHeight = parseFloat(height);
                }
                var heightUnits = /[a-z]*$/ig.exec(height);
                heightUnits = heightUnits ? heightUnits[0] : "";
                height = (iHeight - ((heightUnits === "rem") ? 0.325 : 6)) + heightUnits;
                a[id + " div" + ".sapMMultiComboBoxBorder"] = {"height": height, "font-size": fontSize};
                a[id + " div" + ".sapMTokenizer"] = {"height": height, "font-size": fontSize};
                a[id + " div" + ".sapMTokenizerScrollContainer"] = {"height": height, "font-size": fontSize};
                a[id + " div" + ".sapMToken"] = {"height": height, "font-size": iFontSize *0.89 + fontSizeUnits};
                a[id + " span"] = jQuery.extend(a[id + " span"], {"font-size": iFontSize *0.89 + fontSizeUnits});
                a[id + " span.sapMTokenIcon.sapUiIcon"] = {"padding-right": iFontSize/6 + fontSizeUnits};
                a[id + " div" + ".sapMMultiComboBoxInputContainer > input"] = {"height": (iHeight - ((heightUnits === "rem") ? 0.325 : 6)) + heightUnits, "font-size": fontSize};
                iHeight = (iHeight - ((heightUnits === "rem") ? 0.5 : 8));
                var iWidth = iHeight*1.33;
                a[id + " button" + ".sapMComboBoxBaseArrow"] = {"width": iWidth + heightUnits, "height": iHeight + heightUnits, "line-height" : iHeight + heightUnits};
            }
            if(backgroundColor){
                a[id + " input" + ".sapMInputBaseInner:not(.sapMInputBaseReadonlyInner):not(.sapMInputBaseStateInner):not(.sapMInputBaseDisabledInner):active"] = {"background-color" :backgroundColor};
                a[id + " div" + ".sapMMultiComboBoxInputContainer > input"] = jQuery.extend({'background-color': backgroundColor}, a[id + " div" + ".sapMMultiComboBoxInputContainer > input"] || {});
                a[id + ".sapMMultiComboBox > .sapMMultiComboBoxBorder"] = jQuery.extend({"background-color" : backgroundColor, 'border-color': backgroundColor}, a[id + ".sapMMultiComboBox > .sapMMultiComboBoxBorder"] || {});;
                a[id + ">.sap-desktop .sapMMultiComboBoxFocused:not(.sapMInputBaseReadonly):not(.sapMInputBaseError):not(.sapMInputBaseWarning):not(.sapMInputBaseSuccess) .sapMMultiComboBoxBorder"] = {"border-color" : backgroundColor};
                a[id + " button" + ".sapMComboBoxBaseArrow"] = jQuery.extend({'background-color': backgroundColor}, a[id + " button" + ".sapMComboBoxBaseArrow"] || {});
                delete a[id + " span"]['background'];
                delete a[id + " span"]['background-color'];
            }
        }
        return a;
    };
}());


/////////////////////////////////////////////////////
// END: Monkey patch for Custom styles.
/////////////////////////////////////////////////////

/*
 * TODO factor this into the SDK once the build tools are ready for SDK forks
 * Fix to support icon button styles.
 */
(function() {
    jQuery.sap.require("sap.m.ButtonRenderer");

    var fOldRenderFunction = sap.m.ButtonRenderer.render;

    /**
     * Renders the HTML for the given control, using the provided
     * {@link sap.ui.core.RenderManager}.
     *
     * @param {sap.ui.core.RenderManager}
     *            oRenderManager the RenderManager that can be used for writing to
     *            the Render-Output-Buffer
     * @param {sap.ui.core.Control}
     *            oControl an object representation of the control that should be
     *            rendered
     */
    sap.m.ButtonRenderer.render = function(oRenderManager, oControl) {
        // fix assumes the first time oRm.writeClasses() is called will be on the outer "button" element
        var text = oControl.getText();
        if (typeof text === 'undefined' || text === null || text.length === 0)
            oRenderManager.addClass("sasIconBtn");
        // delegate to the original render function
        fOldRenderFunction.call(this, oRenderManager, oControl);
    };
})();

/**
 * A subset of input label position types that fit to a simple API returning one string.
 *
 * @enum {string}
 * @public
 * @ui5-metamodel This enumeration also will be described in the UI5 (legacy) designtime metamodel
 */
sas.hc.m.InputLabelPosition = {

    /**
     * default (Left)
     * @public
     */
    Left : "Left",

    /**
     * An input control for specifying label position to be top.
     * @public
     */
    Top : "Top"

};


//storage for holding the enum for display Mode
sas.hc.m.ColorPickerDisplayModes = {};

//The displayMode object; Picked string values and not objects as I am unsure in XML mode.
Object.defineProperties(sas.hc.m.ColorPickerDisplayModes, {
    /**
     * This mode referred as <code>sas.hc.m.ColorPicker.BASIC</code>
     * always displays the BASIC Color Picker Tab of the Color Picker Container When opened.
     * @public
     */
    'BASIC' : {value: 'basic', enumerable: true},

    /**
     * This mode referred as <code>sas.hc.m.ColorPicker.CUSTOM</code>
     * always displays the CUSTOM Color Picker Tab of the Color Picker Container When opened.
     * @public
     */
    'CUSTOM' : {value: 'custom', enumerable: true}
});

//prevent new properties from being added.
Object.freeze && Object.freeze(sas.hc.m.ColorPickerDisplayModes);

/**
 * Enum for specifying various actions supported by MessageDialog
 * @enum {string}
 * @public
 */
sas.hc.m.MessageDialogAction = {
    Ok: "OK",
    Cancel: "CANCEL",
    Yes: "YES",
    No: "NO",
    Abort: "ABORT",
    Retry: "RETRY",
    Ignore: "IGNORE",
    Close: "CLOSE",
    Delete: "DELETE",
    Save: "SAVE",
    DontSave: "DONT_SAVE",
    Discard: "DISCARD",
    Apply: "APPLY",
    Reset: "RESET",
    CloseTab: "CLOSE_TAB"
};


/**
 * Enum for the available MessageDialog types
 * @enum {string}
 * @public
 */
sas.hc.m.MessageDialogType = {
    Information: "Information",
    Warning: "Warning",
    Error: "Error"
};
/**
 * Enum for specifying the different layout modes that MessageSummary supports
 *
 * * List Mode is best used for a flat list of messages that are relatively brief.
 * * NavigationList is best used when the message text or message detail can be lengthy.
 * * WindowShade is best used when the messages may be relevant to more than one item.
 *
 *
 * @enum {string}
 * @public
 */
sas.hc.m.MessageSummaryLayoutModeType = {
    List: "List",
    NavigationList: "NavigationList",
    WindowShade: "WindowShade"
};

/**
 * Enum for specifying the different message types that MessageSummary supports
 * @enum {string}
 * @public
 */
sas.hc.m.MessageSummaryFilterButtonType = {
    Information: "Information",
    Warning: "Warning",
    Error: "Error",
    Success: "Success"
};

/**
 * Different states for the Tab (sas.hc.m.IconTabFilter) in IconTabBar
 *
 * @enum {string}
 * @public
 */
sas.hc.m.TabState = {
    /**
     * State is readonly.
     * @public
     */
    ReadOnly: "ReadOnly",

    /**
     * State is not valid.
     * @public
     */
    Alert: "Alert",

    /**
     * State is valid.
     * @public
     */
    Ready: "Ready",

    /**
     * State indicates unsaved changes in the tab's content area.
     * @public
     */
    Dirty: "Dirty",

    /**
     * State is processing.
     * @public
     */
    Processing: "Processing",

    /**
     * State is not specified.
     * @public
     */
    None: "None"
};

/**
 * Enum for specifying different layout types for Dialog
 *
 * @enum {string}
 * @public
 */
sas.hc.m.DialogLayout = {
    /**
     * Layout is a fixed size. The height and width are determined by the size property regardless of the content. If size is set to Auto this layout is ignored.
     * @public
     */
    Fixed: "Fixed",

    /**
     * Layout is a responsive size. The height of the dialog is determined by the content. The size property determines min/max widths of the dialog. Auto sets the default min/max widths.
     * @public
     */
    Responsive: "Responsive"
};

/**
 * Enum for specifying different sizes for Dialog
 *
 * @enum {string}
 * @public
 */
sas.hc.m.DialogSize = {
    /**
     * Dialog is of size Auto. The "layout" property is ignored.
     * @public
     */
    Auto: "Auto",

    /**
     * Dialog is of size Large. If "layout" is set to FIXED this creates a 48x60rem dialog. If "layout" is set to Responsive; the dialog has a min/max width of 20rem - 48rem, and a max-height of 75% upto 60rem total. These values are subject to change by the UX specification.
     * @public
     */
    Large: "Large",

    /**
     * Dialog is of size Medium. If "layout" is set to FIXED this creates a 60x72rem dialog. If "layout" is set to Responsive; the dialog has a min/max width of 30rem - 72rem, and a max-height of 75% upto 60rem total. These values are subject to change by the UX specification.
     * @public
     */
    Medium: "Medium",

    /**
     * Dialog is of size small. If "layout" is set to FIXED this creates a 24x40rem dialog. If "layout" is set to Responsive; the dialog has a min/max width of 10rem - 24rem, and a max-height of 50% upto 40rem total. These values are subject to change by the UX specification.
     * @public
     */
    Small: "Small"
};

/**
 * Different text format options for the information text, which is the
 * {@link sas.hc.m.StandardListItem#setInfo info} property of StandardListItem.
 *
 * @see sas.hc.m.StandardListItem#setInfo
 * @enum {string}
 * @public
 * @since 8.0
 */
sas.hc.m.InfoFormat = {
    /**
     * Info text is separated from title/description, which is preferable for numeric values.
     * @public
     */
    Separated: "Separated",

    /**
     * Info text is concatenated with title/description, which is sometimes preferable for text strings.
     * @public
     */
    Concatenated: "Concatenated"
};


/**
 * Pre-defined sizes for Tiles based on {@link sas.hc.m.TileBsae sas.hc.m.TileBase}.<br />
 * The `Auto` option will allow the natural FlexBox sizing to occur.<br />
 * Use `Custom` when the size doesn't match one of the other pre-defined sizes.
 * @enum {string}
 * @public
 * @since 8.0
 */
sas.hc.m.TileSize = {
    Small: "Small",
    Medium: "Medium",
    Large: "Large",
    Auto: "Auto",
    Custom: "Custom"
};

/**
 * Height/Width values used when implementing `sas.hc.m.TileSize`.
 * @enum {string}
 * @private
 * @since 8.0
 */
sas.hc.m._TileSizeConfig = {
    Small: {
        width: "8rem",
        height: "9.5rem",
    },
    Medium: {
        width: "11rem",
        height: "11.2rem",
    },
    Large: {
        width: "18.75rem",
        height: "15.6rem",
    }
};

/**
 * The type of accent border to apply.
 * Used by TileBase's `accentBorderType` property
 * @enum {string}
 * @public
 * @since 8.0
 */
sas.hc.m.AccentBorderType = {
    Off: "Off",
    Grey: "Grey",
    GraphPaletteColor1: "GraphPaletteColor1",
    GraphPaletteColor2: "GraphPaletteColor2",
    GraphPaletteColor3: "GraphPaletteColor3",
    GraphPaletteColor4: "GraphPaletteColor4",
    GraphPaletteColor5: "GraphPaletteColor5",
    GraphPaletteColor6: "GraphPaletteColor6",
    GraphPaletteColor7: "GraphPaletteColor7",
    GraphPaletteColor8: "GraphPaletteColor8"
};
