/*
 * Copyright 2014, 2016 SAS Institute Inc.
 * All Rights Reserved.
 *
 */

jQuery.sap.declare("sas.hc.ui.core.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.ui.core
 * @public
 */

// library dependencies
jQuery.sap.require("sap.ui.core.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
    name : "sas.hc.ui.core",
    dependencies : ["sap.ui.core"],
    types : [
    ],
    interfaces : [
        "sas.hc.ui.core.IScrollContainer"
    ],
    controls : [
        "sas.hc.contributor.responsive.ResponsiveContributor",
        "sas.hc.contributor.responsive.ResponsiveReporter",
        "sas.hc.ui.core.AnimationUtil",
        "sas.hc.ui.core.BootTask",
        "sas.hc.ui.core.ClearFocusRingTask",
        "sas.hc.ui.core.ComponentContainer",
        "sas.hc.ui.core.Configuration",
        "sas.hc.ui.core.ContextMenuHandler",
        "sas.hc.ui.core.ContextMenuTask",
        "sas.hc.ui.core.Control",
        "sas.hc.ui.core.Core",
        "sas.hc.ui.core.CSRFTask",
        "sas.hc.ui.core.CustomData",
        "sas.hc.ui.core.DataState",
        "sas.hc.ui.core.Earcon",
        "sas.hc.ui.core.Element",
        "sas.hc.ui.core.extraConfig",
        "sas.hc.ui.core.globalErrorHandler",
        "sas.hc.ui.core.GlobalSettings",
        "sas.hc.ui.core.HorizontalScrollDelegate",
        "sas.hc.ui.core.HTML",
        "sas.hc.ui.core.Icon",
        "sas.hc.ui.core.IconPool",
        "sas.hc.ui.core.InvisibleText",
        "sas.hc.ui.core.Item",
        "sas.hc.ui.core.LayoutData",
        "sas.hc.ui.core.LeftNavDataProvider",
        "sas.hc.ui.core.LeftNavPetDataProvider",
        "sas.hc.ui.core.ListItem",
        "sas.hc.ui.core.LocalBusyIndicator",
        "sas.hc.ui.core.Message",
        "sas.hc.ui.core.MonkeyPatchApplySettingsTask",
        "sas.hc.ui.core.Narrator",
        "sas.hc.ui.core.RegistryTask",
        "sas.hc.ui.core.ScrollBar",
        "sas.hc.ui.core.ScrollDelegate",
        "sas.hc.ui.core.SeparatorItem",
        "sas.hc.ui.core.splashA11Y",
        "sas.hc.ui.core.Styles",
        "sas.hc.ui.core.SVGCache",
        "sas.hc.ui.core.TimeoutHandlerTask",
        "sas.hc.ui.core.Title",
        "sas.hc.ui.core.TooltipBase",
        "sas.hc.ui.core.TouchDetectionTask",
        "sas.hc.ui.core.UIComponent",
        "sas.hc.ui.core.util",
        "sas.hc.ui.core.UtilTask",
        "sas.hc.ui.core.VariantLayoutData",
        "sas.hc.ui.core.VersionInfoTask",
        "sas.hc.ui.core.VerticalScrollDelegate",
        "sas.hc.ui.core.waitFor",
        "sas.hc.ui.core.actionManager.ActionChallenge",
        "sas.hc.ui.core.actionManager.ActionExtensionInfo",
        "sas.hc.ui.core.actionManager.ActionExtensionSupport",
        "sas.hc.ui.core.actionManager.ActionManager",
        "sas.hc.ui.core.actionManager.actions.BaseAction",
        "sas.hc.ui.core.actionManager.actions.BaseUndoableAction",
        "sas.hc.ui.core.actionManager.actions.BaseUndoableTransactionalAction",
        "sas.hc.ui.core.actionManager.actions.GenericTransactionalAction",
        "sas.hc.ui.core.actionManager.actions.TransactionalActionWithPrimary",
        "sas.hc.ui.core.actionManager.events.ActionExecutionPendingEvent",
        "sas.hc.ui.core.actionManager.events.ActionStateChangeEvent",
        "sas.hc.ui.core.applicationSwitcher.Application",
        "sas.hc.ui.core.applicationSwitcher.ApplicationSwitcher",
        "sas.hc.ui.core.applicationSwitcher.ApplicationSwitcherBootTask",
        "sas.hc.ui.core.applicationSwitcher.ApplicationSwitcherDiagnosticsPanel",
        "sas.hc.ui.core.applicationSwitcher.ApplicationSwitcherModel",
        "sas.hc.ui.core.applicationSwitcher.ApplicationSwitcherPetrichorModel",
        "sas.hc.ui.core.cache.CacheManagerTask",
        "sas.hc.ui.core.cache.UserPreferencesCache",
        "sas.hc.ui.core.delegate.Draggable",
        "sas.hc.ui.core.delegate.Droppable",
        "sas.hc.ui.core.delegate.TableClickHandlerDelegate",
        "sas.hc.ui.core.delegate.ToolbarItemNavigation",
        "sas.hc.ui.core.mvc.HTMLView",
        "sas.hc.ui.core.mvc.JSAppView",
        "sas.hc.ui.core.mvc.JSONView",
        "sas.hc.ui.core.mvc.JSView",
        "sas.hc.ui.core.mvc.TemplateView",
        "sas.hc.ui.core.mvc.View",
        "sas.hc.ui.core.mvc.XMLView",
        "sas.hc.ui.core.search.OpenSearchProvider",
        "sas.hc.ui.core.search.SearchProvider",
        "sas.hc.ui.core.settings.GlobalSettingsHelper",
        "sas.hc.ui.core.theme.ApplicationTheme",
        "sas.hc.ui.core.theme.ApplicationThemeProvider",
        "sas.hc.ui.core.theme.CustomApplicationThemeProvider",
        "sas.hc.ui.core.theme.EmbeddedApplicationTheme",
        "sas.hc.ui.core.theme.EmbeddedApplicationThemeProvider",
        "sas.hc.ui.core.theme.IconInitialization",
        "sas.hc.ui.core.theme.ThemeBootTask",
        "sas.hc.ui.core.theme.ThemeDescriptor",
        "sas.hc.ui.core.theme.ThemeUtil",
        "sas.hc.ui.core.theme.service.ThemeService",
        "sas.hc.ui.core.theme.service.ThemeServiceProxy",
        "sas.hc.ui.core.theme.service.petrichor.PetrichorApplicationTheme",
        "sas.hc.ui.core.theme.service.petrichor.PetrichorThemeService",
        "sas.hc.ui.core.theme.service.wip.WIPApplicationTheme",
        "sas.hc.ui.core.theme.service.wip.WIPThemeService",
        "sas.hc.ui.core.tmpl.DOMAttribute",
        "sas.hc.ui.core.tmpl.DOMElement",
        "sas.hc.ui.core.tmpl.Template",
        "sas.hc.ui.core.tmpl.TemplateControl",
        "sas.hc.ui.core.util.CalendarUtil",
        "sas.hc.ui.core.util.ComponentServiceClassResolver",
        "sas.hc.ui.core.util.DomToCanvasUtil",
        "sas.hc.ui.core.util.jqXHRRetryHandler",
        "sas.hc.ui.core.util.LongPressUtil",
        "sas.hc.ui.core.util.ltjsLoaderUtil",
        "sas.hc.ui.core.util.LTJSUtil",
        "sas.hc.ui.core.util.ObjectProxy",
        "sas.hc.ui.core.util.PetKeepAliveService",
        "sas.hc.ui.core.util.PetSignoutService",
        "sas.hc.ui.core.util.PetUserInfoService",
        "sas.hc.ui.core.util.ProfilingUtil",
        "sas.hc.ui.core.util.SASCollatorUtil",
        "sas.hc.ui.core.util.ServicesUtil",
        "sas.hc.ui.core.util.SignoutService",
        "sas.hc.ui.core.util.StringUtil",
        "sas.hc.ui.core.util.Timer",
        "sas.hc.ui.core.util.Url",
        "sas.hc.ui.core.util.UserInfo",
        "sas.hc.ui.core.util.WIPKeepAliveService",
        "sas.hc.ui.core.util.WIPUserInfoService",
        "sas.hc.ui.model.JSONModel",
        "sas.hc.ui.model.PageableContext",
        "sas.hc.ui.model.PageableJSONListBinding",
        "sas.hc.ui.model.PageableJSONModel",
        "sas.hc.ui.model.PageableJSONTreeBinding",
        "sas.hc.ui.model.PageableJSONTreeBindingAdapter",
        "sas.hc.ui.model.PageableJSONTreeModel",
        "sas.hc.ui.model.SimpleModelCache",
        "sas.hc.ui.services.RestService",
        "sas.hc.ui.services.ServiceRegistry",
        "sas.hc.ui.services.notifications.AbstractNotificationsService",
        "sas.hc.ui.services.notifications.NotificationsService",
        "sas.hc.ui.services.notifications.PetrichorNotificationsAdapterService",
        "sas.hc.ui.services.petrichor.appRegistry.AppRegistryService",
        "sas.hc.ui.services.petrichor.avatar.AvatarService",
        "sas.hc.ui.services.petrichor.comments.CommentService",
        "sas.hc.ui.services.petrichor.files.FileService",
        "sas.hc.ui.services.petrichor.fonts.FontService",
        "sas.hc.ui.services.petrichor.notifications.NotificationsService",
        "sas.hc.ui.services.petrichor.preferences.PreferencesService",
        "sas.hc.ui.services.petrichor.theme.ThemeService",
        "sas.hc.ui.core.ServerSideEventBus"

    ],
    elements : [
        "sas.hc.ui.core.ScrollDelegate",
        "sas.hc.ui.core.HorizontalScrollDelegate",
        "sas.hc.ui.core.VerticalScrollDelegate"
    ],
    version : "800001.10.0.20241202143000_f0htmcm80p"});



/**
 *
 * Represents an interface for controls which require Horizontal / Vertical Scrolling such as sas.hc.m.Tokenizer.
 * The classes which implement this interface are:
 * - sas.hc.m.Tokenizer
 *
 * Note: This interface can be used by IconTabbar & Breadcrumb at a later date.
 *
 * @name sas.hc.ui.core.IScrollContainer
 * @interface
 * @public
 * @ui5-metamodel This interface also will be described in the UI5 (legacy) designtime metamodel
 *
 * Methods: (+) indicates public, (-) indicates private)
 * (+) onAfterScrollComplete
 * (+) getScrollState
 */

//-----------------------------------------------------------------------------
//Begin of Library Initialization coding, copied from shared.js
//-----------------------------------------------------------------------------

(function() {

    var lazy = sap.ui.lazyRequire;

    function each(sPackage,aClasses,sShortcutPkg) {
        for(var i=0; i<aClasses.length; i++) {
            if ( sShortcutPkg ) {
                lazy(sShortcutPkg, aClasses[i].toLowerCase(), sPackage + aClasses[i]);
            } else {
                lazy(sPackage + aClasses[i], "new extend getMetadata");
            }
        }
    }

    // lazy imports
    each("sas.hc.ui.core.mvc.", ["JSAppView"], "sas.hc.ui");

    // Initialize icons
    if(!sas.applicationSwitcher || !sas.applicationSwitcher._isMainApplication()){
        jQuery.sap.require("sas.hc.ui.core.theme.IconInitialization");
        sas.hc.ui.core.theme.IconInitialization.initThemeDescriptorIcons();
        // add UserInfo require to fetch user information async'ly
        jQuery.sap.require("sas.hc.ui.core.util.UserInfo");
    }
}());

// Backward-compatible name mapping
sas.hc.ui.core.delegate.ItemDefaultAction = sas.hc.ui.core.delegate.TableClickHandlerDelegate;


/////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////SETTINGS CONSTANTS////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 * The name of the sas.eventBus Channel on which an event of the type change would be dispatched.
 * @public
 */
sas.hc.ui.core.SETTINGS_CHANNEL ="settingsChannel";

/**
 * This event will be fired against the settingsChannel of sas.eventBus after settings are persisted.
 * @public
 */
sas.hc.ui.core.SETTINGS_CHANGE = "settingsChange";


jQuery.sap.require("sap.ui.base.DataType");


/**
 * A color representation in hex format.
 *
 * @typedef {string} sas.hc.ui.core.Color
 *
 * @static
 * @public
 *
 */
sas.hc.ui.core.Color = sap.ui.base.DataType.createType("sas.hc.ui.core.Color", {
    isValid: function (value) {
        var hexPattern = new RegExp("^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$");
        return hexPattern.test(value);
    }
},
sap.ui.base.DataType.getType("string")
);


jQuery.sap.require('sas.hc.ui.core.GlobalSettings');

/////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////END SETTINGS CONSTANTS//////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

/********************************************************
 ********** COMMENT MANAGER RELATED CHANGES ************
 ********************************************************/

/**
 * This is a method to get Comment service containg element-id in the url.
 * This method is added since comment rest service uri with element-id is not registered in the registry till 9.4M2.
 * Uri with element-id is registered in 9.4M3 with name as ContentElementCommentSummaryService so
 * when we move to 9.4M3 this method will be redundant and should be removed.
 *
 * @returns {*}
 */

if(jQuery.sap.getObject("sas.registry.wip")){

    sas.registry.wip.getContentElementCommentSummaryService = function() {

        var cs, sUrl;

        cs = jQuery.extend(true, {}, sas.registry.wip.getCommentService());
        cs.name = "ContentElementCommentSummaryService REST";
        cs.serviceInterface = "ContentElementCommentSummaryService REST";
        sUrl = cs.url;
        cs.url = sUrl.substring(0, sUrl.lastIndexOf("/")) + "/{element-id}" + sUrl.substring(sUrl.lastIndexOf("/"));

        return cs;
    };
}

/********************************************************
 ******* END OF COMMENT MANAGER RELATED CHANGES *********
 ********************************************************/
sas.hc.ui.core.CustomExternalFocusStyles = {
    'sasCustomExternalFocusStyles': [
        {'selector':'*:focus, html.sap-desktop .sapMBtn:focus > .sapMFocusable, .sasSlider .sliderPseudoFocus .sasThumb, .sasSlider .sasHighlightColor.sliderPseudoFocus , html.sap-desktop .sapMSwtCont:focus > .sapMSwt,html.sap-desktop .sapUiCalItem:focus > .sapUiCalItemText, .sapUiTriCb:focus .sapUiTriCbInner, html.sap-desktop .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg, .sapUiBtnS.sapUiBtnIconOnly.sapUiBtnStd:focus > span.sapUiBtnIco', 'styles':{'outline-color':'@FOCUSCOLOR !important;' ,'outline-width':'@FOCUSTHICKNESS !important' }},
        {'selector':'.sapMSF.sapMFocus .sapMSFF, .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):not(.sasUiMnuItmDisabledFocusEnabled):focus, html.sap-desktop .sapMSegBBtn.sapMSegBBtnFocusable:focus,.sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus', 'styles':{'outline':'@FOCUSTHICKNESS dotted @FOCUSCOLOR !important;' }},
        {'selector':'.sapMSlt.sasMSltFocused:after,.sapMFocus .sasMInputOuterDiv:before,.sapMTextArea.sapMFocus:after, .sapMSelectListItemBase.sapMSelectListItemBaseSelected::before, html[data-sap-ui-browser*="ie"].sap-desktop .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus:before, html[data-sap-ui-browser*="ed"].sap-desktop .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus:before, html[data-sap-ui-browser*="ie"] .sapUiAcd .sapUiAcdSectionHdr:focus::after, .sapMComboBox.sapMFocus:after, html[data-sap-ui-browser*="ed"] .sapUiAcd .sapUiAcdSectionHdr:focus::after, .sapMComboBox.sapMFocus:after, .sapMDP.sapMFocus:after, html[data-sap-ui-browser^="ie"].sap-desktop .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg:before, html[data-sap-ui-browser^="ed"].sap-desktop .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg:before,html[data-sap-ui-browser^="ie"] .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):not(.sasUiMnuItmDisabledFocusEnabled):focus::after,html[data-sap-ui-browser^="ed"] .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):not(.sasUiMnuItmDisabledFocusEnabled):focus::after,html[data-sap-ui-browser^="ie"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus::after,html[data-sap-ui-browser^="ed"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus::after, html[data-sap-ui-browser^="ie"].sap-desktop .sapMFocus > .sapMSFF:before,html[data-sap-ui-browser^="ed"].sap-desktop .sapMFocus > .sapMSFF:before', 'styles':{'border':'@FOCUSTHICKNESS dotted @FOCUSCOLOR !important;' }},
        {'selector':':focus::before, :focus::after, .sasSlider .sasSliderArrowThumbs .sliderPseudoFocus:before, html[data-sap-ui-browser*="ie"] .sapMBtn:focus .sapMBtnFocusDiv, html[data-sap-ui-browser*="ed"] .sapMBtn:focus .sapMBtnFocusDiv,html[data-sap-ui-browser^="ie"].sap-desktop .sapUiCalItem:not(.sapUiCalItemDsbl):focus > .sapUiCalItemText::after, html[data-sap-ui-browser^="ed"].sap-desktop .sapUiCalItem:not(.sapUiCalItemDsbl):focus > .sapUiCalItemText::after,html[data-sap-ui-browser^="ie"].sap-desktop .sapMToken:focus .sapMTokenText::before, html[data-sap-ui-browser^="ie"].sap-desktop .sapMToken.sasMGroupToken:focus .sasMGroupTokenButton::before, html[data-sap-ui-browser^="ed"].sap-desktop .sapMToken:focus .sapMTokenText::before, html[data-sap-ui-browser^="ed"].sap-desktop .sapMToken.sasMGroupToken:focus .sasMGroupTokenButton::before, html[data-sap-ui-browser^="ie"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus::after, html[data-sap-ui-browser^="ed"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus::after,html[data-sap-ui-browser^="ie"] .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):not(.sasUiMnuItmDisabledFocusEnabled):focus::after, html[data-sap-ui-browser^="ed"] .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):not(.sasUiMnuItmDisabledFocusEnabled):focus::after, .sapMSB:focus .sapMSBInner:after', 'styles':{'border-color':'@FOCUSCOLOR !important;', 'border-width':'@FOCUSTHICKNESS !important' }},
        {'selector':'html[data-sap-ui-browser*="ie"].sap-desktop .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus, html[data-sap-ui-browser*="ed"].sap-desktop .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus, html[data-sap-ui-browser*="ie"] .sapUiLoSplitter > .sapUiLoSplitterBar:focus, html[data-sap-ui-browser*="ed"] .sapUiLoSplitter > .sapUiLoSplitterBar:focus, html[data-sap-ui-browser^="ie"] .sapUiMnu :not(.sapUiMnuItmDsbl).sapUiMnuItm:focus, html[data-sap-ui-browser^="ed"] .sapUiMnu :not(.sapUiMnuItmDsbl).sapUiMnuItm:focus, html[data-sap-ui-browser^="ie"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus, html[data-sap-ui-browser^="ed"] .sapUiMnuItm.sapUiMnuItmDsbl.sasUiMnuItmDisabledFocus,html[data-sap-ui-browser^="ie"].sap-desktop .sapMFocus > .sapMSFF, html[data-sap-ui-browser^="ed"].sap-desktop .sapMFocus > .sapMSFF', 'styles':{'outline':'none !important;'  }},
        {'selector':'html[data-sap-ui-browser*="ie"] .sapUiTableCnt .sapUiTableRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ed"] .sapUiTableCnt .sapUiTableRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ie"] .sapUiTableColHdrCnt .sapUiTableSelAllEnabled.sapUiTableColRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ed"] .sapUiTableColHdrCnt .sapUiTableSelAllEnabled.sapUiTableColRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ie"] .sapUiTableCnt .sapUiTableRowHdr .sapMRb:focus::before, html[data-sap-ui-browser*="ed"] .sapUiTableCnt .sapUiTableRowHdr .sapMRb:focus::before, html[data-sap-ui-browser*="ie"] .sapUiTable .sapMRbB:focus::after, html[data-sap-ui-browser*="ed"] .sapUiTable .sapMRbB:focus::after, html[data-sap-ui-browser*="ie"] .sapUiTable .sapUiTableCol:focus, html[data-sap-ui-browser*="ed"] .sapUiTable .sapUiTableCol:focus, html[data-sap-ui-browser*="ie"] .sapUiTableTr > td:focus, html[data-sap-ui-browser*="ed"] .sapUiTableTr > td:focus', 'styles':{'box-shadow':'inset 0 0 0 @FOCUSTHICKNESS @FOCUSCOLOR !important'}}
    ]
};

/******
 * Currently, the following styles are a direct copy of the above custom external focus styles with the addition of adding the .clearFocusRing selector.
 * .clearFocusRing is set on the body in javascript. Any additions made to CustomExternalFocusStyles must also be added to ClearFocusRingStyles.
 */
sas.hc.ui.core.ClearFocusRingStyles = {
    'sasClearFocusRingStyles': [
        {'selector':'.clearFocusRing *:focus, html.sap-desktop .clearFocusRing .sapMBtn:focus > .sapMFocusable,.clearFocusRing .sasSlider .sliderPseudoFocus .sasThumb, .clearFocusRing .sasSlider .sasHighlightColor.sliderPseudoFocus , html.sap-desktop .clearFocusRing .sapMSwtCont:focus > .sapMSwt,html.sap-desktop .clearFocusRing .sapUiCalItem:focus > .sapUiCalItemText, .clearFocusRing .sapUiTriCb:focus .sapUiTriCbInner, html.sap-desktop .clearFocusRing .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg, .clearFocusRing .sapUiBtnS.sapUiBtnIconOnly.sapUiBtnStd:focus > span.sapUiBtnIco', 'styles':{'outline':'none !important;'}},
        {'selector':'.clearFocusRing .sapUiMnu .sapUiMnuItm:not(.sapUiMnuItmDsbl):focus, html.sap-desktop .clearFocusRing .sapMSegBBtn.sapMSegBBtnFocusable:focus', 'styles':{'outline':'none !important;'}},
        {'selector':'.clearFocusRing .sapMSelectListItemBase.sapMSelectListItemBaseSelected::before, html[data-sap-ui-browser*="ie"].sap-desktop .clearFocusRing .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus:before, html[data-sap-ui-browser*="ed"].sap-desktop .clearFocusRing .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus:before,html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiAcd .sapUiAcdSectionHdr:focus::after, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiAcd .sapUiAcdSectionHdr:focus::after,html[data-sap-ui-browser^="ie"] .clearFocusRing .sapUiTriCb:focus .sapUiTriCbInner::after, html[data-sap-ui-browser^="ed"] .clearFocusRing .sapUiTriCb:focus .sapUiTriCbInner::after', 'styles':{'border':'none !important;' }},
        {'selector':'.clearFocusRing :focus::before, .clearFocusRing :focus::after, .clearFocusRing .sasSlider .sasSliderArrowThumbs .sliderPseudoFocus:before, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapMBtn:focus .sapMBtnFocusDiv, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapMBtn:focus .sapMBtnFocusDiv,html[data-sap-ui-browser^="ie"].sap-desktop .clearFocusRing .sapUiCalItem:not(.sapUiCalItemDsbl):focus > .sapUiCalItemText::after, html[data-sap-ui-browser^="ed"].sap-desktop .clearFocusRing .sapUiCalItem:not(.sapUiCalItemDsbl):focus > .sapUiCalItemText::after,html[data-sap-ui-browser^="ie"].sap-desktop .clearFocusRing .sapMToken:focus .sapMTokenText::before, html[data-sap-ui-browser^="ie"].sap-desktop .clearFocusRing .sapMToken.sasMGroupToken:focus .sasMGroupTokenButton::before, html[data-sap-ui-browser^="ed"].sap-desktop .clearFocusRing .sapMToken:focus .sapMTokenText::before, html[data-sap-ui-browser^="ed"].sap-desktop .clearFocusRing .sapMToken.sasMGroupToken:focus .sasMGroupTokenButton::before, .clearFocusRing .sapMComboBox.sapMInputBaseReadonly.sapMFocus:after, html[data-sap-ui-browser^="ie"].sap-desktop .clearFocusRing .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg:before, html[data-sap-ui-browser^="ed"].sap-desktop .clearFocusRing .sapMCb:not(.sapMCbBgDis):not(.sapMCbHasLabel):focus > .sapMCbBg:before, .clearFocusRing .sapMSB:focus .sapMSBInner:after', 'styles':{'border':'none !important;' }},
        {'selector':'html[data-sap-ui-browser*="ie"].sap-desktop .clearFocusRing .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus, html[data-sap-ui-browser*="ed"].sap-desktop .clearFocusRing .sasCustomFocusIndicatorStyles .sapMSegBBtn.sapMSegBBtnFocusable:focus, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiLoSplitter > .sapUiLoSplitterBar:focus, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiLoSplitter > .sapUiLoSplitterBar:focus', 'styles':{'outline':'none !important;'  }},
        {'selector':'html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTableCnt .sapUiTableRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTableCnt .sapUiTableRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTableColHdrCnt .sapUiTableSelAllEnabled.sapUiTableColRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTableColHdrCnt .sapUiTableSelAllEnabled.sapUiTableColRowHdr :not(.sapMCbBgDis):not(.sapMCbHasLabel).sapMCb:focus::before, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTableCnt .sapUiTableRowHdr .sapMRb:focus::before, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTableCnt .sapUiTableRowHdr .sapMRb:focus::before, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTable .sapMRbB:focus::after, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTable .sapMRbB:focus::after, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTable .sapUiTableCol:focus, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTable .sapUiTableCol:focus, html[data-sap-ui-browser*="ie"] .clearFocusRing .sapUiTableTr > td:focus, html[data-sap-ui-browser*="ed"] .clearFocusRing .sapUiTableTr > td:focus', 'styles':{'box-shadow':'none !important;'}},
        {'selector':'.sasCustomFocusIndicatorStyles.clearFocusRing .sapMFocus.sapMInputBaseReadonly .sasMInputOuterDiv:before,.sasCustomFocusIndicatorStyles.clearFocusRing .sapMFocus.sapMInputBaseDisabled .sasMInputOuterDiv:before,.sasCustomFocusIndicatorStyles.clearFocusRing .sapMFocus.sapMTextArea.sapMInputBaseReadonly:after,.sasCustomFocusIndicatorStyles.clearFocusRing .sapMFocus.sapMTextArea.sapMInputBaseDisabled:after', 'styles':{'border':'none !important'}}
    ]
};

(function(){
    // initialized ActionManager
    jQuery.sap.require("sas.hc.ui.core.actionManager.ActionManager");
    // create system level actionManager to handle undo/redo stack
    var actionManager=undefined;
    Object.defineProperty(sas,'actionManager',{
        get:function(){
            if(actionManager === undefined){
                actionManager = new sas.hc.ui.core.actionManager.ActionManager();
            }
            return actionManager;
        },
        enumerable:true,
    });
}());
