/*
 * Copyright 2014, 2016 SAS Institute Inc.
 * All Rights Reserved.
 *
 */

jQuery.sap.declare("sas.hc.ui.services.comment.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.ui.services.comment
 * @public
 */

// library dependencies
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sas.hc.ui.commons.library");
jQuery.sap.require("sas.hc.m.library");
//jQuery.sap.require("sas.hc.nls.library");
jQuery.sap.require("sas.ltjs.commons.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
    name : "sas.hc.ui.services.comment",
    dependencies : ["sap.ui.core","sas.hc.ui.commons","sas.hc.m","sas.ltjs.commons"],
    types : [
    ],
    interfaces : [
    ],
    controls : [
        "sas.hc.ui.services.comment.CommentManager",
        "sas.hc.ui.services.comment.components.CommentEntryForm",
        "sas.hc.ui.services.comment.components.CommentListItem",
        "sas.hc.ui.services.comment.controller.CommentManagerController",
        "sas.hc.ui.services.comment.model.Attachment",
        "sas.hc.ui.services.comment.model.Comment",
        "sas.hc.ui.services.comment.model.CommentDataModel",
        "sas.hc.ui.services.comment.model.CommentNode",
        "sas.hc.ui.services.comment.model.TrackComment",
        "sas.hc.ui.services.comment.petrichor.CommentManager",
        "sas.hc.ui.services.comment.petrichor.components.CommentEntryForm",
        "sas.hc.ui.services.comment.petrichor.components.CommentListItem",
        "sas.hc.ui.services.comment.petrichor.components.CommentReplyForm",
        "sas.hc.ui.services.comment.petrichor.controller.CommentManagerController",
        "sas.hc.ui.services.comment.petrichor.model.Attachment",
        "sas.hc.ui.services.comment.petrichor.model.Comment",
        "sas.hc.ui.services.comment.petrichor.model.CommentsInfo",
        "sas.hc.ui.services.comment.petrichor.model.TrackComment",
        "sas.hc.ui.services.comment.petrichor.pagination.CommentsPaginator",
        "sas.hc.ui.services.comment.petrichor.proxy.AbstractServiceProxy",
        "sas.hc.ui.services.comment.petrichor.proxy.CommentPetrichorServiceProxy",
        "sas.hc.ui.services.comment.petrichor.util.AttachmentReader",
        "sas.hc.ui.services.comment.petrichor.util.CommentManagerUtil",
        "sas.hc.ui.services.comment.proxy.AbstractServicesProxy",
        "sas.hc.ui.services.comment.proxy.ServicesProxy",
        "sas.hc.ui.services.comment.util.CommentManagerUtil"
    ],
    elements : [
    ],
    version : "800001.10.0.20241202143000_f0htmcm80p"});
