/*
 * Copyright 2014, 2016 SAS Institute Inc.
 * All Rights Reserved.
 *
 */

jQuery.sap.declare("sas.hc.ui.services.navigation.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.ui.services.navigation
 * @public
 */

// library dependencies
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sas.hc.ui.commons.library");
jQuery.sap.require("sas.hc.m.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
    name : "sas.hc.ui.services.navigation",
    dependencies : ["sap.ui.core","sas.hc.ui.commons","sas.hc.m","sas.ltjs.sasicu"],
    types : [
    ],
    interfaces : [
    ],
    controls : [
        "sas.hc.ui.services.navigation.ContentDataDescriptor",
        "sas.hc.ui.services.navigation.ContentNavigationModel",
        "sas.hc.ui.services.navigation.ContentSelectionPane-A11y",
        "sas.hc.ui.services.navigation.ContentSelectionPane",
        "sas.hc.ui.services.navigation.ContentSelector",
        "sas.hc.ui.services.navigation.ContentTypeDescriptor",
        "sas.hc.ui.services.navigation.classes.ContentColumnView",
        "sas.hc.ui.services.navigation.classes.ContentSelectorD",
        "sas.hc.ui.services.navigation.classes.ContentSelectorM",
        "sas.hc.ui.services.navigation.classes.NavigatorToolBar",
        "sas.hc.ui.services.navigation.config.ContentItemIdentity",
        "sas.hc.ui.services.navigation.config.FilteredItemsConfig",
        "sas.hc.ui.services.navigation.config.FilterItem",
        "sas.hc.ui.services.navigation.config.ModelConfig",
        "sas.hc.ui.services.navigation.config.ServiceConfig",
        "sas.hc.ui.services.navigation.controls.NavigationListItem",
        "sas.hc.ui.services.navigation.descriptors.ContentPermissionsDescriptor",
        "sas.hc.ui.services.navigation.descriptors.ContentPETDataDescriptor",
        "sas.hc.ui.services.navigation.descriptors.ContentPETPermissionsDescriptor",
        "sas.hc.ui.services.navigation.descriptors.ContentPETTypeDescriptor",
        "sas.hc.ui.services.navigation.descriptors.ContentPETValidationResultDescriptor",
        "sas.hc.ui.services.navigation.descriptors.ContentValidationResultDescriptor",
        "sas.hc.ui.services.navigation.descriptors.OperationsResultDescriptor",
        "sas.hc.ui.services.navigation.descriptors.PETOperationsResultDescriptor",
        "sas.hc.ui.services.navigation.models.ContentNavigationPETModel",
        "sas.hc.ui.services.navigation.types.DataIntegrationObjectTypeConstants",
        "sas.hc.ui.services.navigation.types.ObjectTypeConstants",
        
        "sas.hc.ui.services.navigation.util.CNUtil",
        "sas.hc.ui.services.navigation.util.FilterUtil",
        "sas.hc.ui.services.navigation.util.ItemMenuHelper",
        "sas.hc.ui.services.navigation.util.ItemUtil",
        "sas.hc.ui.services.navigation.util.ListUtil",
        "sas.hc.ui.services.navigation.util.PetServicesUtil",
        "sas.hc.ui.services.navigation.util.SASFoldersSvcUtil",
        "sas.hc.ui.services.navigation.util.ServiceConfigUtil",
        "sas.hc.ui.services.navigation.util.SortUtil"
        
    ],
    elements : [
    ],
    version : "800001.10.0.20241202143000_f0htmcm80p"});
