jQuery.sap.declare("sas.risk.common.widgets.CheckBoxGroup");

jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.hc.m.CheckBox");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.common.widgets.CheckBoxGroup",{
	metadata:{
      properties:{
      	checkedValues: {type:"string[]",defaultValue:null}
      },
      aggregations:{
			items : {type : "sas.hc.m.CheckBox", multiple : true, singularName : "item"}
      },
      events : {
			"change" : {}
		}
   },
   constructor:function(){
   	sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
   },
   renderer : sas.risk.common.layout.flexlayout.FlexLayoutRenderer
});
sas.risk.common.widgets.CheckBoxGroup.prototype.setCheckedValues = function(valuesArray){
	this.setProperty("checkedValues",valuesArray);
	if(valuesArray===undefined || valuesArray===null){
		return;
	}
	var i;
	var j; 
	var checkBoxes=this.getItems();
	_.each(checkBoxes, function(cb){cb.setSelected(false);});
	for(i=0;i<valuesArray.length;i++){
		var val=valuesArray[i];
		for(j=0;j<checkBoxes.length;j++){
			var checkBox=checkBoxes[j];
			if(checkBox.getName() === val){
				checkBox.setSelected(true);
				break;
			}
		}
	}
};
/*TODO:not sure if naming this fn getCheckedValues will disturb the checkbox field*/
sas.risk.common.widgets.CheckBoxGroup.prototype.calcCheckedValues = function(){
	var values=[];
	var checkBoxes=this.getItems();
	_.each(checkBoxes, function(cb){
		if(cb.getSelected(false)){
			values.push(cb.getName());
		}
	});
	return values;
};

