jQuery.sap.declare("sas.risk.common.widgets.LabelPlus");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.risk.common.widgets.HelpPopup");
jQuery.sap.require("sas.risk.common.utils.CompositeUtil");

sas.hc.m.Label.extend("sas.risk.common.widgets.LabelPlus", {
	metadata : {
		properties:{
			errored:{type:"boolean",defaultValue:false},
			help:{type:"string"}
		},
		aggregations : {
	   	helpPopup:{type: "sap.ui.core.Control", multiple: false}
		}
	},
	constructor: function(){
		sas.risk.common.utils.CompositeUtil.addComposite(this,"help",this.getHelpPopup,"content");
		sas.hc.m.Label.apply(this,arguments);
	},
	renderer : "sas.risk.common.widgets.LabelPlusRenderer"
});
sas.risk.common.widgets.LabelPlus.prototype.getHelpPopup=function(){
	var helpPopup=this.getAggregation("helpPopup");
	if(!helpPopup){
		helpPopup=new sas.risk.common.widgets.HelpPopup();
		this.setAggregation("helpPopup",helpPopup);
	}
	helpPopup.getEnabled = function(){return true;};
	return helpPopup;
};
sas.risk.common.utils.CompositeUtil.mixinPropertySupport(sas.risk.common.widgets.LabelPlus);