jQuery.sap.declare("sas.risk.common.widgets.expreditor.ExprEditor");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.hc.ui.core.HTML");
jQuery.sap.require('sas.hc.ui.layout.Splitter');
jQuery.sap.require('sas.hc.ui.layout.SplitterLayoutData');
jQuery.sap.require("sas.hc.ui.commons.Tree");
jQuery.sap.require("sas.hc.ui.commons.TreeNode");
jQuery.sap.require("sas.hc.ui.model.JSONModel");
jQuery.sap.require("sas.hc.m.IconTabBar");
jQuery.sap.require("sas.hc.m.IconTabFilter");
jQuery.sap.require("sas.hc.m.Title");
jQuery.sap.require("sas.hc.m.List");
jQuery.sap.require("sas.hc.m.StandardListItem");
jQuery.sap.require("sap.ui.core.CustomData");
jQuery.sap.require("sas.risk.common.widgets.expreditor.ExprEditorHelper");
jQuery.sap.require("sas.risk.common.widgets.expreditor.ExprEditorDebug");
jQuery.sap.require("sas.risk.common.widgets.expreditor.ExpressionParser");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
jQuery.sap.require("sas.risk.common.widgets.MessageDetailsBox");
jQuery.sap.require("sas.hc.m.BusyDialog");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.common.widgets.expreditor.ExprEditor",{
    metadata:{
        properties:{
            value:{type:"any"},
            meta:{type:"any"}
        },
        events:{
            change:{}
        }
    },
    constructor:function(){
        sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);

        this.rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
        this.addStyleClass("ExprEditor");
        this.setWidth("100%");
        this.setHeight("400px");
        this.setAlignItems(sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Stretch);
        var helper=sas.risk.common.widgets.expreditor.ExprEditorHelper.createExprHelper(this);
        this.main=this.createExprMain();
        this.splitter=new sas.hc.ui.layout.Splitter({
            contentAreas: [helper, this.main],
            width: "100%"
        });
        this.addItem(new sas.risk.common.layout.flexlayout.FlexLayout({
            flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
            items:[this.splitter],
            width:"100%"
        }));
        jQuery.sap.require("sas/risk/common/widgets/expreditor/codemirror/lib/codemirror");
        jQuery.sap.require("sas/risk/common/widgets/expreditor/codemirror/mode/datadef/datadef");
        jQuery.sap.require("sas/risk/common/widgets/expreditor/codemirror/addon/edit/matchbrackets");
        jQuery.sap.require("sas/risk/common/widgets/expreditor/codemirror/addon/selection/active-line");
        jQuery.sap.require("sas/risk/common/widgets/expreditor/codemirror/addon/hint/show-hint");
        var $head=$("head");
        if(!$head.find("link#risk_common_codemirror").length){
            $("head").append("<link type='text/css' rel='stylesheet' id='risk_common_codemirror' href='resources/sas/risk/common/widgets/expreditor/codemirror/lib/codemirror.css'>");
            $("head").append("<link type='text/css' rel='stylesheet' href='resources/sas/risk/common/widgets/expreditor/codemirror/theme/datadef.css'>");
            $("head").append("<link type='text/css' rel='stylesheet' href='resources/sas/risk/common/widgets/expreditor/codemirror/addon/hint/show-hint.css'>");
            $("head").append("<link type='text/css' rel='stylesheet' href='resources/sas/risk/common/widgets/expreditor/ExprEditor.css'>");
        }
        this.timeout=500;
    },
    renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
});
sas.risk.common.widgets.expreditor.ExprEditor.prototype.setMeta=function(meta){
    var prevMeta=this.getProperty("meta")||{};
    var values=this._formatValuesMeta(prevMeta,meta);
    var newMeta={
        //value:prevMeta.value||meta.value||"",
        messages:prevMeta.messages||meta.messages||[],
        variables:meta.variables||prevMeta.variables||{items:[],categories:[]},
        operators:meta.operators||prevMeta.operators||{items:[],categories:[]},
        validValues:values,
        conversionURL:meta.conversionURL || "/SASRiskGovernanceFramework/groovy/rmc/Json2Sql.groovy?contentType=json" // default
    };
    this.setProperty("meta",newMeta);
    var data={search:"",messages:newMeta.messages};
    var model=new sas.hc.ui.model.JSONModel(data);
    this.setModel(model,this.getModelId());

    this.punctuators={};
    var that=this;
    newMeta["operators"].items.forEach(function(tokenType,idx){
        if(tokenType.keyToken){
            that.punctuators[tokenType.keyToken]=tokenType;
        }else{
            if (tokenType.label&&tokenType.label.length===1){
                that.punctuators[tokenType.label]=tokenType;
            }else {
                that.punctuators[tokenType.id] = tokenType;
            }
        }
    });
    //this.punctuators[","]={id:"_comma", keyToken:","};

    this.dataItems={};
    newMeta["variables"].items.forEach(function(tokenType,idx){
        if(tokenType.id){
            that.dataItems[tokenType.id]=tokenType;
        }
    });
};
sas.risk.common.widgets.expreditor.ExprEditor.LABELS={
    "variables":"expreditor.dataitems.txt",
    "operators":"expreditor.operators.txt",
    "filter":"expreditor.filter.txt",
    "messages":"expreditor.messages.fmt",
    "nohelp":"expreditor.help.txt"
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.getLabel=function(key,args){
    var val=this.rb.getText(sas.risk.common.widgets.expreditor.ExprEditor.LABELS[key]);
    if ("nohelp"===key){
        val="<i>"+val+"</i>";
    }
    if(args&&args.length){
        return jQuery.sap.formatMessage(val,args);
    }
    return val;
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.getStatusIcon=function(forStatus){
    if (forStatus===undefined){
        return sas.icons.HC.ERRORSTATUS;
    }
    return (forStatus!==2?sas.icons.HC.ERRORSTATUS:sas.icons.HC.WARNINGSTATUS);
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.getModelId=function(){
    return "expr-"+this.getId();
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.createExprMain=function(){
    var splitterLayoutData=new sas.hc.ui.layout.SplitterLayoutData({
        size: "auto",
        minSize: 150
    });
    this.editor=this.createExprEditor();
    this.debug=sas.risk.common.widgets.expreditor.ExprEditorDebug.createExprDebug(this);
    var splitter=new sas.hc.ui.layout.Splitter({
        contentAreas: [this.editor, this.debug],
        width: "100%",
        orientation: sap.ui.core.Orientation.Vertical,
        layoutData:splitterLayoutData
    });
    return splitter;
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.createExprEditor=function(){
    var splitterLayoutData=new sas.hc.ui.layout.SplitterLayoutData({
        size: "auto",
        minSize: 150
    });
    var html=new sas.hc.ui.core.HTML({content:"<div></div>",layoutData:splitterLayoutData});
    return html;
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.onAfterRendering=function(){
    $(this.editor.getDomRef()).css("height","100%").css("display","flex");
    if (this.getMeta() === undefined) return;	// do not initialize code mirror yet
    if(!this.cm){
        this.cm=CodeMirror(this.editor.getDomRef(),{
            lineNumbers: true,
            styleActiveLine: true,
            matchBrackets: true,
            mode: {name: "datadef", meta:this.getMeta()},
            theme: "datadef",
            viewportMargin: Infinity,
            extraKeys: {"Ctrl-Space": "autocomplete"},
            hintOptions: {hint: $.proxy(this.onHint,this)}
        });
        this.cm.on("change",$.proxy(this.onEditorLiveChange,this));
        this.cm.on("blur",$.proxy(this.onEditorChange,this));

        this.cm.setValue(this.getValue()?this.getValue():"");
    }
	// https://rndjira.sas.com/browse/RGFRMWRK-416..
	this.cm.refresh();  // RGFRMWRK-327.. refresh to let code mirror align itself correctly
    this._toggleFocus();
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.onHint=function(cm, option){
    var cursor = cm.getCursor(), line = cm.getLine(cursor.line);
    var start = cursor.ch, end = cursor.ch;
    var meta=this.getMeta();

    if (Object.keys(meta["validValues"]).length>0){
        var idx=end-1,
            stop=false,
            wordValues,
            word;
        var origEnd=cursor.ch;
        var word=this._next(start,end,line);
        if (word!==undefined&&word!==null){
      	  wordValues=meta["validValues"][word.toLowerCase()];   // we need to be case ignorant
        }
        if (wordValues!==undefined){
      	  wordValues.sort();
            return {
                list: wordValues,
                from: CodeMirror.Pos(cursor.line, start),
                to: CodeMirror.Pos(cursor.line, cursor.ch)
            };
        }
    }
    start = cursor.ch, end = cursor.ch;
    while (start && this._isRecognizedChar(line.charAt(start - 1))) --start;
    while (end < line.length && this._isRecognizedChar(line.charAt(end))) ++end;
    word = line.slice(start, end).toUpperCase();

    var matches=[];
    _.each(["variables","operators"],function(type){
        _.each(meta[type].items,function(item){
            if(item.id.toUpperCase().startsWith(word)){
                // Srini: because we have an "_" we will try to display the relevant information..
                //	use either the keyToken or remove the '_'
                var displayTerm;
                if(item.keyToken){
                    displayTerm=item.keyToken;
                }else{
                    if (item.label&&item.label.length===1){
                        displayTerm = item.label;
                    }else {
                        if ("_parens"!==item.id){   // Srini.. ignore this not even sure why this required
                            displayTerm=item.id.startsWith("_")? item.id.substr(1):item.id;
                        }
                    }
                }
                if (displayTerm!==undefined){   // Srini..because of the if for _parens, we need to do this here :(
                    matches.push(displayTerm);
                }
            }
        });
    });
    matches.sort();
    return {
        list: matches,
        from: CodeMirror.Pos(cursor.line, start),
        to: CodeMirror.Pos(cursor.line, end)
    };
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.onEditorChange=function(event){
    var text=event.doc.getValue();
	// https://rndjira.sas.com/browse/RGFRMWRK-416..
    this.setValue(text);    // this is very important.. cannot comment this ever
    //console.error("TODO: Add grammar info to call to parser here",event,this);

    var meta=this.getMeta();
    var metaItems = {variables: meta["variables"].items, operators: meta["operators"].items};
    var language="SAS"; // Srini.. adding the option for language

    var parser = new sas.risk.common.widgets.expreditor.ExpressionParser();
    var json = parser.parse(text, metaItems,language);  // parse needs at least the operators
    var messages=this.getModel(this.getModelId()).getProperty("/messages");
    // provide the validation errors
    var validationErrors={hasErrors:messages.length>0, messages:messages};
    json=_.isString(json)?JSON.parse(json):json;

    var messages=this.getModel(this.getModelId()).getProperty("/messages");
    //var data={filterJson:json, metaJson:meta}; //filterJson:view.parsedExpression||{}, metaJson:modelData.meta
    var self=this;
    // call groovy to get the SQL WHERE CLAUSE
    /*$.ajax({
        contentType: 'application/json',
        data: JSON.stringify(data),
        dataType: 'json',
        processData: false,
        type: 'POST',
        url: meta.conversionURL || "/SASRiskGovernanceFramework/groovy/rmc/Json2Sql.groovy?contentType=json" // default
    })
        .fail(function(xhr,status,error){
            console.error("Result: " + status + " " + error + " " + xhr.status + " " + xhr.statusText);
            var errorJSON={
                message:self.rb.getText("expreditor.conversionURL.fail.message.txt"),
                remediation: self.rb.getText("expreditor.conversionURL.fail.txt"),
                details:[
                    jQuery.sap.formatMessage(self.rb.getText("expreditor.conversionURL.fail.status.fmt"), xhr.status),
                    jQuery.sap.formatMessage(self.rb.getText("expreditor.conversionURL.fail.status.fmt"), xhr.statusText),
                ]
            };
            validationErrors.translationError=errorJSON;
        })
        .always(function(result){
            // these are the items to be saved
            self.fireChange({
                rawExpression:text,
                parsedExpression:json,
                validationErrors:validationErrors,
                convertedExpression:result.convertedExpression
            });
            return true;
        });*/
    self.fireChange({
        rawExpression:text,
        parsedExpression:json,
        validationErrors:validationErrors/*,
        convertedExpression:result.convertedExpression*/
    });
    // event.refresh();    // RGFRMWRK-327.. refresh to let code mirror align itself correctly
    return true;
};
sas.risk.common.widgets.expreditor.ExprEditor.prototype.onEditorLiveChange=function(event){
    var text=event.doc.getValue();
    this.timeout= 0;    // after initial timeout of 500 reset this so that typing tardiness is little bearable
    //console.error("EDITR LIVE CHANGE",event,this);
	// https://rndjira.sas.com/browse/RGFRMWRK-416.... no need for this here.. we will do it onEditorChange
    // this.setValue(text);    // this is very important.. cannot comment this ever

    var meta=this.getMeta();
    var metaItems = {variables: meta["variables"].items, operators: meta["operators"].items, categories: meta["variables"].categories};
    var parser = new sas.risk.common.widgets.expreditor.ExpressionParser();
    var json = parser.parseAndValidate(text, metaItems);  // validation needs at least the variables
    var that=this;
    if (parser.errors.length> 0) {
        var messages=[];
        _.each(parser.errors,function(error){
            var message="", token={type:"", name:""};
            switch(Object.prototype.toString.call(error.tokenName)){
                case "[object String]":
                    token={type:"variable", name:error.tokenName};
                    // ignore formatting parse errors
                    message=(error.errorStatus!==0)?jQuery.sap.formatMessage(that.rb.getText(error.message), token.name):error.message;
                    break;
                case "[object Array]":
                    var all=error.tokenName.slice();
                    token={type:"function", name:all.shift(), arguments:all};
                    // ignore formatting parse errors
                    message=(error.errorStatus!==0)?jQuery.sap.formatMessage(that.rb.getText(error.message), error.tokenName):error.message;
                    break;
                default:
                    message=that.rb.getText(error.message);
                    break;
            }
            messages.push({label:message,line:error.line,column:error.column,token:token,status:error.errorStatus});
        });
        this.getModel(this.getModelId()).setProperty("/messages", messages);
    }
    else {
        this.getModel(this.getModelId()).setProperty("/messages",[]);
    }
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._next=function(start,end,text){
    var inQuote=false;
    var index=start;
    var word=null;
    while(index>=0){
        var c=text.charAt(index--);
        var op=this.punctuators[c];
        if(op!==undefined){
            switch(c){
                case "=":
                case ">":
                case "<":
                case "*":
                    if(index>=0){
                        var cc=text[index]+c;
                        if(cc===">=" || cc==="<>" || cc==="<=" || cc==="**"){
                            index--;
                        }
                    }
                    word=this._getTheWord(index+1,text);
                    return word;

                case "(":
                    // read till we either encounter an IN
                    word=this._readTillInAndReturnTheVariableName(text,index+1);
                    return word;

                default:
                    // a space or something that cannot be recognized
                    if (!this._isRecognizedChar(c)) {
                        return null;
                    }
                    break;
            }
        } else if (this._isRecognizedChar(c)) {
            var inQuote=(c==='"'||c==="'")?c:false;
            var isComma=false;
            while(index>0){
                var c2=text[index];
                inQuote=(inQuote && c2!==c);
                if(!inQuote && !this._isRecognizedChar(c2)){
                    if (c2===" "){
                        // if we are at space... eat all spaces till a character is found
                        index=this._eatSpace(text,index+1);
                        if (text[index]===","||text[index-1]===","){ // if text at that index =","
                            isComma=true;
                        }
                    }else{
                        if (c2===","){
                            isComma=true;
                        }
                    }
                    break;
                }
                index--;
            }
            if (isComma){
                --index;
            }else{
                if (text[index]===" "){
                    index=this._eatSpace(text,index);
                    index-=1;   // reduce by 1 because we are at a space and eat space ignores that
                }
                word=this._readTillInAndReturnTheVariableName(text,index);
                return word;
            }
        } else {
            //ignore all other characters (whitespace, etc)
        }
    }
    return null;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._isRecognizedChar=function(str){
    var RECOGNIZED_CHAR_REGEX=/[\w.$'"%&;|)]/i;	// % and ; are valid characters because they represent a SAS Macro

    return str&&(str.length === 1 &&  RECOGNIZED_CHAR_REGEX.test(str));
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._eatSpace=function(str,index){
    var idx=index;
    if (/\s+$/.test(str.charAt(idx-1))) --idx;
    return idx;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._getOperator=function(c){
    var meta=this.getMeta();
    var op = meta["operators"].items.find(function (item) {
        return item.id.toUpperCase() === c.toUpperCase();
    });

    return op;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._readTillInAndReturnTheVariableName=function(text,index){
    // read till we either encounter an IN
    index=this._eatSpace(text,index);
    if (index>0){
        var str="";
        while(index>-1&&this._isRecognizedChar(text[--index])) {
            str=text[index]+str;
        }
    }
    if ("in"===str){
        //index-=2;
        //index=this._eatSpace(text,index);
        var word=this._getTheWord(index,text);
        return word;
    }
    return null;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._getVariable=function(word){
    var meta=this.getMeta();
    var di=meta["variables"].items.find(function(item){
        return item.id.toUpperCase() === word.toUpperCase();
    });

    return di;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._getTheWord=function(idx,text){
    idx=this._eatSpace(text,idx);
    var initialIndex=idx;
    while (idx && /\w/.test(text.charAt(idx - 1))) --idx;

    return text.slice(idx, initialIndex).trim();
};


sas.risk.common.widgets.expreditor.ExprEditor.prototype._formatValuesMeta=function(prevMeta,meta){
    var values=prevMeta.values||meta.values;
    var mapOfValidValues=[],/*{"columnName":"","validValues":[]}*/
        validVars=[],
        allVars=[];

    var variables=(prevMeta!==undefined&&prevMeta.variables!==undefined)?prevMeta.variables.items:meta.variables.items;
    var categories=(prevMeta!==undefined&&prevMeta.variables)?prevMeta.variables.categories:meta.variables.categories;
    variables.forEach(function(item){
        validVars.push(item.id);
    });
    _.each(variables,function(eachVar){
        allVars.push(eachVar.id);
    });
    _.each(values,function(row){
        var variable;
        for (var key in row){
            var caseIgnoredKey=key.toLowerCase();
            var userDefinedValue=row[key];
            variable=_.find(variables, function(eachVar){
                return eachVar.id.toUpperCase()===key.toUpperCase();
            });

            if (variable!==undefined) {
                var category=categories.find(function(category){
                    return category.members.indexOf(key)>=0;
                });
                var found = Object.keys(mapOfValidValues).find(function (mapKey) {
                    return mapKey.toUpperCase() === key.toUpperCase();
                });
                if (found===undefined) {
                    mapOfValidValues[caseIgnoredKey]=[];
                    allVars.forEach(function(member){
                        mapOfValidValues[caseIgnoredKey].push(member);
                    });
                }
                
                // Check if the variable type has been specified
                if(variable.type === undefined) {
                    if(category === undefined)
                        // Set default variable type as Character
                        variable.type = "Character";
                    else
                        // Use the category label as a proxy for the variable type
                        variable.type = category.label;
                }

                var newValue = "";
                switch(variable.type) {
                    case "Numeric":
                    case "Num":
                        newValue="" + userDefinedValue + "";
                        break;
                    /* Special processing for Date/Time/Datetime values */
                    case "Date":
                        newValue=" input(\"" + userDefinedValue + "\", anydtdte10.)";
                        break;
                    case "Time":
                        newValue=" \"" + userDefinedValue + "\"t";
                        break;
                    case "Datetime":
                        newValue="" + userDefinedValue.replace(/(\d{4}-\d{2}-\d{2}) (\d{2}):(\d{2}):(\d{2}(\.\d*)?)/, " dhms(input(\"$1\", anydtdte10.), $2, $3, $4)") + "";
                        break;                         
                    default:
                        newValue="\"" + userDefinedValue + "\"";
                        break;
                }
                var existingValues=mapOfValidValues[caseIgnoredKey];
                if (existingValues.indexOf(newValue)<0) {
                    mapOfValidValues[caseIgnoredKey].unshift/*.push*/(newValue);
                }
            }
        }
    });
    return mapOfValidValues;
};

sas.risk.common.widgets.expreditor.ExprEditor.prototype._toggleFocus = function(timeout) {
    // RGFRMWRK-407 JIRA
    var that = this;
    timeout = this.timeout;
    if (this.timeout > 0) {
        setTimeout(function() {
            // toggle focus around so that the tree does not start re-adjusting
            if (that.editor.getParent() !== undefined) {
                that.cm.focus();
                that.editor.getParent().getContentAreas()[1].getItems()[1].focus();
                // set the selection on the tree
                if (that.tree !== undefined && (that.selectedNode !== undefined && that.selectedNode !== null)) {
                    // that.tree.setSelection(that.selectedNode);
                    // that.selectedNode.focus();
                    // that.selectedNode.scrollIntoView();
                }
                that.cm.focus();
            }
        }, timeout);
    } else {
        // focus has been placed on the selected node.. therefore, we can move focus to the cm
        this.cm.focus();
    }
};

sas.risk.common.utils.CompositeUtil.mixinPropertySupport(sas.risk.common.widgets.expreditor.ExprEditor);