jQuery.sap.declare("sas.risk.common.widgets.expreditor.ExprEditorDebug");

sas.risk.common.widgets.expreditor.ExprEditorDebug={
	createExprDebug:function(ee){
		var modelId=ee.getModelId();
		var title=new sas.hc.m.Title({
			level: 'H3',
			text: {
				path:modelId+">/messages",
				formatter:function(messages){
					return ee.getLabel("messages",[messages.length]);
				}
			}
		}).addStyleClass("ExprEditor-messages-title");
		var list=new sas.hc.m.List({
			items:{
				path:modelId+">/messages",
				template:new sas.hc.m.StandardListItem({
					icon:{
						path:modelId+">status",
						formatter: function(status){
							return ee.getStatusIcon(status);
						}
					},
					title:"{"+modelId+">label}",
					type: sap.m.ListType.Active
				})
			},
			mode: sap.m.ListMode.None,
			itemPress:$.proxy(sas.risk.common.widgets.expreditor.ExprEditorDebug.onMessageSelect,ee),
			layoutData:splitterLayoutData
		});
		var splitterLayoutData=new sas.hc.ui.layout.SplitterLayoutData({
	        size: "50px",
	        collapsible:true
	    });
		var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
			items:[title,list],
			layoutData:splitterLayoutData
		});
		return layout;
	},
	onMessageSelect:function(event){
		var listItem=event.getParameter("listItem");
		var message=listItem.getBindingContext(this.getModelId()).getObject();
		//this.cm.setOption("mode",{name:"datadef",hello:{world:123}});
		if (message&&(message.line&&message.column)){
			var lineStart=message.line-1;
            var columnStart=message.column-1;
            var name=message.token&&message.token.type!=="function"?message.token.name:"";
			var columnEnd=(name.length?name.length+columnStart:columnStart+1);
			this.cm.setSelection(CodeMirror.Pos(lineStart,columnStart),CodeMirror.Pos(lineStart,columnEnd));
		}
		console.error("LIST ITEM",listItem,message);
	}
};
