jQuery.sap.declare("sas.risk.common.widgets.querybldr.handler.BooleanFilterHandler");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.hc.m.RadioButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.BooleanFilter");

sas.risk.common.widgets.querybldr.handler.BooleanFilterHandler=function(columnOptions,cellOptions,changeCallback){
	this.columnOptions=columnOptions;
	this.cellOptions=cellOptions;
	this.changeCallback=changeCallback;
	var choices=cellOptions.choices||[];
	for(var i=0;i<choices.length;i++){
		if(choices[i].value===true){
			this.yes=choices[i].label;
		}
		if(choices[i].value===false){
			this.no=choices[i].label;
		}
	}
};
sas.risk.common.widgets.querybldr.handler.BooleanFilterHandler.prototype={
	getOperators:function(){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		var value=filter.getValue();
		if(value===undefined||value===null){
			value=true;
		}
		value=!!value;
		filter.setValue(value);
		filter.setValueLabel(rb.getText("table.dialog.advsearch.boolean."+(value?"yes":"no")+".txt"));
		var that=this;
		var selected=function(e){
			if(this.getSelected()){
				filter.setValue(this.isYes);
				filter.setValueLabel(rb.getText("table.dialog.advsearch.boolean."+(this.isYes?"yes":"no")+".txt"));
			}
			that.changeCallback();
		};
      var yes=new sas.hc.m.RadioButton({
      	text:rb.getText("table.dialog.advsearch.boolean.yes.txt"),
      	select:selected,
      	selected:!!filter.getValue()
      });
      yes.isYes=true;
      var no=new sas.hc.m.RadioButton({
      	text:rb.getText("table.dialog.advsearch.boolean.no.txt"),
      	select:selected,
      	selected:!filter.getValue()
      });
      no.isYes=false;
      yes.setGroupName(yes.getId()+"-group");
      no.setGroupName(yes.getId()+"-group");
		return new sas.risk.common.layout.flexlayout.FlexLayout({items:[yes,no]}).addStyleClass("riskTabAdvBool");
	},
	updateFilterValueLabel:function(filter){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		var def=$.Deferred().resolve();
		var value=filter.getValue();
		if(value===undefined||value===null){
			value=true;
		}
		value=!!value;
		var yesTxt=this.yes||rb.getText("table.dialog.advsearch.boolean.yes.txt");
		var noTxt=this.no||rb.getText("table.dialog.advsearch.boolean.no.txt");
		filter.setValueLabel(value?yesTxt:noTxt);
		return def;
	},
	createFilter:function(){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		var columnId=this.columnOptions.id;
		var columnLabel=this.columnOptions.label;
		var trueLabel=this.yes||rb.getText("table.dialog.advsearch.boolean.yes.txt");
		return new sas.risk.common.widgets.spreadsheet.filter.BooleanFilter(columnId,"eq",true,columnLabel,trueLabel);
	}
};