jQuery.sap.declare("sas.risk.common.widgets.querybldr.handler.ChoicesFilterHandler");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.risk.slimtable.widget.Item");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.StringFilter");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.NumberFilter");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.BooleanFilter");

sas.risk.common.widgets.querybldr.handler.ChoicesFilterHandler=function(columnOptions,cellOptions,changeCallback,quoteIt){
	this.columnOptions=columnOptions;
	this.cellOptions=cellOptions;
	this.quoteIt=quoteIt;
	this.changeCallback=changeCallback;
};
sas.risk.common.widgets.querybldr.handler.ChoicesFilterHandler.prototype={
	getOperators:function(){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		var that=this;
		var select=new sas.hc.m.Select({
			change:function(e){
				var item=e.getParameter("selectedItem");
				filter.setValue(item.getKey());
				filter.setValueLabel(item.getText());
				that.changeCallback();
			}
		});
		var choices=this.cellOptions.choices;
		var i,choice;
		for(i=0;i<choices.length;i++){
			choice=choices[i];
			select.addItem(new sas.risk.slimtable.widget.Item({
				key:choice.value,
				text:choice.label
			}));
		}
		if(filter.getValue()){
			select.setSelectedKey(filter.getValue());
		}else{
			var selectedItem=select.getItemAt(0);
			filter.setValue(selectedItem.getKey());
			filter.setValueLabel(selectedItem.getText());
		}
		return select;
	},
	updateFilterValueLabel:function(filter){
		var def=$.Deferred().resolve();
		var value=filter.getValue();
		if(value){
			var choices=this.colMeta.getColChoices();
			var i,choice;
			for(i=0;i<choices.length;i++){
				choice=choices[i];
				if(choice.value===value){
					filter.setValueLabel(choice.label);
					break;
				}
			}			
		}
		return def;
	},
	createFilter:function(){
		var columnId=this.columnOptions.id;
		var columnLabel=this.columnOptions.label;
		var choices=this.cellOptions.choices;
		var value=choices[0].value;
		var label=choices[0].label;
		if(_.isBoolean(value)){
			return new sas.risk.common.widgets.spreadsheet.filter.BooleanFilter(columnId,"eq",value,columnLabel,label);
		}
		if(this.quoteIt){
			return new sas.risk.common.widgets.spreadsheet.filter.StringFilter(columnId,"contains",value,columnLabel,label);
		}
		return new sas.risk.common.widgets.spreadsheet.filter.NumberFilter(columnId,"eq",value,columnLabel,label);
	}
};