jQuery.sap.declare("sas.risk.common.widgets.querybldr.handler.DefaultFilterHandler");

sas.risk.common.widgets.querybldr.handler.DefaultFilterHandler=function(columnOptions,changeCallback){
	this.columnOptions=columnOptions;
	this.changeCallback=changeCallback;
};
sas.risk.common.widgets.querybldr.handler.DefaultFilterHandler.prototype={
	getOperators:function(){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		var value=filter.getValue()!==null?filter.getValue():"";
		var that=this;
		return new sas.hc.m.Input({
			placeholder:rb.getText("table.dialog.advsearch.value.placeholder.txt"),
			value:value,
			change:function(e){
				filter.setValue(e.getParameter("value"));
				filter.setValueLabel(e.getParameter("value"));
				that.changeCallback();
			}
		}).addStyleClass("riskTabAdvString");
	},
	updateFilterValueLabel:function(filter){
		filter.setValueLabel(filter.getValue());
		return $.Deferred().resolve();
	},
	createFilter:function(){
		var columnId=this.columnOptions.id;
		var columnLabel=this.columnOptions.label;
		return new sas.risk.common.widgets.spreadsheet.filter.StringFilter(columnId,"eq","",columnLabel,"");
	}
};