jQuery.sap.declare("sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.StringFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.DefaultFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.BooleanFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.DateFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.TimestampFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.NumberFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.ChoicesFilterHandler");

sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory=function(){
	this.registry={};
};
sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory.prototype={
	getHandler:function(qBldr,columnId){
		var meta=qBldr.getMeta();
		var changeCallback=$.proxy(qBldr.updateValue,qBldr);
		var columnOptions=meta.getColumnOptions(columnId);
		var cellOptions=meta.getCellOptions(columnId);
		var type=cellOptions["cellType"]||"string";
		switch(type){
			case "string":
				return new sas.risk.common.widgets.querybldr.handler.StringFilterHandler(columnOptions,changeCallback);
			case "dropdown":
				return new sas.risk.common.widgets.querybldr.handler.ChoicesFilterHandler(columnOptions,cellOptions,changeCallback,true);
			case "percent":
			case "number":
				return new sas.risk.common.widgets.querybldr.handler.NumberFilterHandler(columnOptions,changeCallback);
			case "date":
				return new sas.risk.common.widgets.querybldr.handler.DateFilterHandler(columnOptions,changeCallback);
			case "timestamp":
				return new sas.risk.common.widgets.querybldr.handler.TimestampFilterHandler(columnOptions,changeCallback);
			case "boolean":
				return new sas.risk.common.widgets.querybldr.handler.BooleanFilterHandler(columnOptions,cellOptions,changeCallback);
			default:
				if(this.registry[type]){
					jQuery.sap.require(widgetClassName);
					var klass=sap.ui.require(widgetClassName.replace(/\./g, "/"));
					return new klass(filter,meta);
				}else{
					console.warn("No Filter Handler available for type:"+type+", will use the default filter handler.");// eslint-disable-line no-console
					return new sas.risk.common.widgets.querybldr.handler.DefaultFilterHandler(columnOptions,changeCallback);
				}
		}
	},
	register:function(key,klassName){
		this.registry[key]=klassName;
	}
};
//SINGLETON
sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory._instance=new sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory();
sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory.getInstance=function(){
	return sas.risk.common.widgets.querybldr.handler.FilterHandlerFactory._instance;
};