jQuery.sap.declare("sas.risk.common.widgets.querybldr.handler.NumberFilterHandler");
jQuery.sap.require("sas.risk.common.widgets.querybldr.handler.format.RiskNumber");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.NumberFilter");

sas.risk.common.widgets.querybldr.handler.NumberFilterHandler=function(columnOptions,changeCallback){
	this.columnOptions=columnOptions;
	this.changeCallback=changeCallback;
};
sas.risk.common.widgets.querybldr.handler.NumberFilterHandler.prototype={
	getOperators:function(){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"},
			{label:rb.getText("table.dialog.advsearch.operator.gt.txt"),key:"gt"},
			{label:rb.getText("table.dialog.advsearch.operator.lt.txt"),key:"lt"},
			{label:rb.getText("table.dialog.advsearch.operator.ge.txt"),key:"ge"},
			{label:rb.getText("table.dialog.advsearch.operator.le.txt"),key:"le"}
		];
	},
	getInput:function(filter){
		var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
		var input=filter.getValue()!==null?filter.getValue():null;
		var numFormatter=new sas.risk.common.widgets.querybldr.handler.format.RiskNumber();
		var output=numFormatter.formatValue(input, "string");
		var that=this;
		return new sas.hc.m.Input({
			placeholder:rb.getText("table.dialog.advsearch.numericvalue.placeholder.txt"),
			type:sap.m.InputType.Number,
			value:output,
			change:function(e){
				var parsedVal=numFormatter.parseValue(e.getParameter("value"), "string"); //it will validate the number and won't reach the next line in case of error helping not set wrong value for filter
				filter.setValue(parsedVal);
				filter.setValueLabel(numFormatter.formatValue(parsedVal?parsedVal.toString():"","string"));
				that.changeCallback();
			}
		}).addStyleClass("riskTabAdvString");
	},
	updateFilterValueLabel:function(filter){
		filter.setValueLabel(filter.getValue());
		return $.Deferred().resolve();
	},
	createFilter:function(){
		var columnId=this.columnOptions.id;
		var columnLabel=this.columnOptions.label;
		return new sas.risk.common.widgets.spreadsheet.filter.NumberFilter(columnId,"eq",0,columnLabel,"0");
	}
};