jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.Spreadsheet");
jQuery.sap.require("sas.hc.m.IconTabBar");
jQuery.sap.require("sas.hc.ui.table.WideTable");
jQuery.sap.require("sas.hc.ui.table.WideTableRenderer");
jQuery.sap.require("sas.hc.ui.table.WideTreeTable");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.FetchCriteria");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetFormulaContext");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetMeta");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetState");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.View");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.api.SpreadsheetPreferencesAPI");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.api.SpreadsheetViewsAPI");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.model.SpreadsheetLocalService");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONModel");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.model.SpreadsheetRestService");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.BroadSearch");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.ColumnOrder");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Busy");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.CreateNewButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.EditButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Filters");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.RefreshButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.SaveButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Search");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Sort");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.ZeroState");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Totals");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.UndoButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.Views");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetZeroStateFactory");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetTable");

sap.ui.core.Control.extend("sas.risk.common.widgets.spreadsheet.Spreadsheet",{
	metadata:{
		properties:{
			meta:{type:"any"},
			fetchCriteria:{type:"any"},
			preferencesAPI:{type:"any",defaultValue:sas.risk.common.widgets.spreadsheet.api.SpreadsheetPreferencesAPI},
			viewsAPI:{type:"any",defaultValue:sas.risk.common.widgets.spreadsheet.api.SpreadsheetViewsAPI},
			viewsKey:{type:"any"},
			preferencesKey:{type:"any",defaultValue:{}},
			dataBindId:{type:"any"},
			dataKey:{type:"any",defaultValue:{}},
			arrayNames:{type:"any"},
			dataUrl:{type:"any"},
			dataHeader:{type:"any"},
			formulaContext:{type:"any"},
			values:{type:"any",defaultValue:{start:0,count:0,items:[]}},
			patch:{type:"any"}
		},
		aggregations:{
			_tabs:{type:"sas.hc.m.IconTabBar",multiple:false}
		},
		events:{
			rowSelectionChange:{},
			metaChange:{},
			change:{},
			select:{},
			preFetchData:{},
			postFetchData:{},
			preMetaChange:{},
			postMetaChange:{},
			mashup:{}
		}
	},
	constructor:function(){
		this.models={};
		this.state=new sas.risk.common.widgets.spreadsheet.SpreadsheetState(this);
		sap.ui.core.Control.apply(this,arguments);
		if(!this.getMeta()){
			var emptyMeta=new sas.risk.common.widgets.spreadsheet.SpreadsheetMeta({table:{options:{}},columns:[]});
			emptyMeta.attachChange($.proxy(this._onMetaChange,this));
			this.setProperty("meta",[{id:"abc",meta:emptyMeta}]);
		}
		this.singleSelectHandler=$.proxy(this.handleSingleSelect,this);
		this.preMetaChangeHandler=$.proxy(this.handlePreMetaChange,this);
		this.rowTrackerHandler=$.proxy(this.rowTrackerHandler,this);
		new sas.risk.common.widgets.spreadsheet.toolbar.ColumnOrder(this);//adding column order support (before first preMetaChange event)
		new sas.risk.common.widgets.spreadsheet.toolbar.Busy(this);
	},
	renderer:function(rm,control){
		if(control.tabs.getItems()===1){
			rm.renderControl(control.tabs.getItems()[0]);
		}else{
			rm.renderControl(control.tabs);
		}
	}
});
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.applySettings=function(){
	sap.ui.core.Control.prototype.applySettings.apply(this,arguments);
	var formulaContext=this.getFormulaContext();
	if(!formulaContext){
		formulaContext=new sas.risk.common.widgets.spreadsheet.SpreadsheetFormulaContext(function(){
			console.error("Trying to execute an external formula but a formula context has not been registered.",arguments);// eslint-disable-line no-console
			return $.Deferred().resolve(true);
		});
	}
	this.state.setFormulaContext(formulaContext);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setPreferencesKey=function(value){
	var preferencesKey=value||{};
	if(_.isString(value)){
		preferencesKey={abc:value};
	}
	this.setProperty("preferencesKey",preferencesKey);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setViewsKey=function(value){
	var viewsKey=value||{};
	if(_.isString(value)){
		viewsKey={abc:value};
	}
	this.setProperty("viewsKey",viewsKey);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setDataUrl=function(value){
	var dataUrl=value;
	if(_.isString(value)){
		dataUrl={abc:value};
	}
	this.setProperty("dataUrl",dataUrl);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setDataKey=function(value){
	var dataKey=value;
	if(_.isString(value)){
		dataKey={abc:value};
	}
	this.setProperty("dataKey",dataKey);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setArrayNames=function(value){
	var arrayNames=value;
	if(_.isString(value)){
		arrayNames={abc:[value]};
	}else if(_.isArray(value)){
		arrayNames={abc:value};
	}
	this.setProperty("arrayNames",arrayNames);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.initFilterModel=function(total) {
	this.filterModel=new sas.hc.ui.model.JSONModel({
		filterSelected: [],
		filterTotal: total,
		filterPanelOpen: true
	});
	return this.filterModel;
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getFilterModel=function() {
	return this.filterModel;
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSelectedSheetId=function(){
	return this.getSelectedSheetTable().data("sheetId");
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSelectedSheetTable=function(){
	return this.getSheetTable(this.getSelectedSheet().getText());
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSheetIds=function(){
	return _.map(this.tabs.getItems(),function(tab){
		return tab.getText();
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSheetTables=function(){
	return _.map(this.tabs.getItems(),function(tab){
		return tab.getContent()[0];
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSheetTable=function(sheetId){
	var sheet=_.find(this.tabs.getItems(),function(tab){
		return tab.getText()===sheetId;
	});
	return sheet.getContent()[0];
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getState=function(){
	return this.state;
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSelectedSheetKey=function(){
	return this.tabs.getSelectedKey();
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSelectedSheetIndex=function(){
	return this.tabs.getItems().indexOf(this.getSelectedSheet());
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getSelectedSheet=function(){
	return this.tabs.getSelectedItem();
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.handlePreMetaChange=function(event){
	var that=this;
	event.getParameter("defs")[0].done(function(){
		that._metaChange();
		that.initialized=true;
		that.firePostMetaChange({meta:event.getParameter("meta")});
		that._fetch();
		that.firePostFetchData({fetchCriteria:that.getFetchCriteria()});
		that.setBusy(false);
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.onBeforeRendering=function(){
	if(!this.initialized){
		this.detachPreMetaChange(this.preMetaChangeHandler);
		this.attachPreMetaChange(this.preMetaChangeHandler);
		this.firePreMetaChange({defs:[$.Deferred().resolve()],meta:this.getMeta()});
	}
};
//META
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._onMetaChange=function(event){
	this.fireMetaChange(event.getParameters());
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setMeta=function(meta){
	this.setProperty("meta",meta);
	var that=this;
	if(meta&&meta.length){
		_.each(meta,function(m){
			m.meta.attachChange($.proxy(that._onMetaChange,that));
		});
	}
	if(this.initialized){
		this.setBusy(true);
		this.state.clearCells();//different meta, so any cached goodies are just noise.. clear'm
		this.firePreMetaChange({defs:[$.Deferred().resolve()],meta:meta});
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._metaChange=function(){
	var prevFetchCriteria=this.getFetchCriteria();
	var fetchCriteriaMap=(!this.initialized&&prevFetchCriteria)?prevFetchCriteria:{};
	this.setProperty("fetchCriteria",fetchCriteriaMap,true);
	this._createTabs();
	this.syncValues();
	if(!this.initialized){
		new sas.risk.common.widgets.spreadsheet.toolbar.Sort(this);//adding sort support (after table created)
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._createTabs=function(){
	var that=this;
	this.tabs=this.tabs||new sas.hc.m.IconTabBar({
		showOverflowPopOver: true,
		enableDynamicStyle: true,
		select:function(e){
			that.fireSelect(e);
		},
		tabChanging:function(e) {
			setTimeout(function(){
				var table=that.getSelectedSheetTable();
				var sheetId=table.data("sheetId");
				that.fetchData(sheetId);
			}, 0);
		}
	}).addStyleClass("riskSpreadsheetTab");
	this.tabs.removeStyleClass("riskSpreadsheetTabHidden");
	this.tabs.removeAllItems();
	_.each(this.getMeta(),function(metaInfo){
		var tab = new sas.hc.m.IconTabFilter({
          design: "Horizontal",
          text: metaInfo.id
      });
		tab.addContent(that._createSheet(metaInfo));
		that.tabs.addItem(tab);
	});
	if(this.tabs.getItems().length===1){
		this.tabs.addStyleClass("riskSpreadsheetTabHidden");
	}
	this.tabs.setSelectedItem(this.tabs.getItems()[0]);
	this.set_tabs(this.tabs);
	this.refreshFormulaMode();
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._createSheet=function(metaInfo){
	var sheetId=metaInfo.id;
	var meta=metaInfo.meta;
	var dataBindIdMap=this.getDataBindId()||{};
	var dataBindId=dataBindIdMap[sheetId]||"items";
	var that=this;
	var metaTableOptions=meta.getTableOptions();
	var tableOptions=$.extend({
		rowHeight:32,
		rows:{
			path:sheetId+">/"+dataBindId,
			parameters:{
				numberOfExpandedLevels:metaTableOptions.numberOfExpandedLevels||0
			}
		},
		rowSelectionChange:function(e){
			that.fireRowSelectionChange(e.getParameters());
		},
		state:this.state
	},metaTableOptions);
	if(!this.getEnabled()){
		tableOptions["selectionMode"]="None";
	}
	var sheet=(tableOptions.isTree)?new sas.risk.common.widgets.spreadsheet.SpreadsheetTreeTable(tableOptions).addStyleClass("riskSpreadsheet")
											 :new sas.risk.common.widgets.spreadsheet.SpreadsheetTable(tableOptions).addStyleClass("riskSpreadsheet");
	sheet.data("sheetId",sheetId);
	if(tableOptions.selectionMode==="Single"){
		sheet.attachRowSelectionChange(this.singleSelectHandler);
	}else{
		sheet.detachRowSelectionChange(this.singleSelectHandler);
	}
	if(tableOptions.rowHover===false){
		sheet.addStyleClass("riskSpreadsheetNoSelect");
	}
	var fetchCriteriaMap=this.getFetchCriteria();
	var fetchCriteria=fetchCriteriaMap[sheetId]||new sas.risk.common.widgets.spreadsheet.FetchCriteria();
	fetchCriteriaMap[sheetId]=fetchCriteria;
	this._refreshColumns(sheet,metaInfo,fetchCriteria);
	this.mixinRowTracker(sheet,metaInfo);
	this.mixinRowHierarchy(sheet);
	this.createModel(metaInfo,sheet,fetchCriteria);
	this.handleZeroState(sheet,tableOptions);
	return sheet;
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.handleZeroState=function(sheet,tableOptions){
	if(tableOptions.noData){
		var noData=sas.risk.common.widgets.spreadsheet.SpreadsheetZeroStateFactory.getInstance().create(tableOptions.noData,sheet);
		sheet.setNoData(noData);
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.mixinRowHierarchy=function(sheet){
	var that=this;
	if(!sheet.onAfterRendering._MIXED_ROW_HIERARCHY_){
		var orig=sheet.onAfterRendering;
		sheet.onAfterRendering=function(){
			orig.apply(this,arguments);
			window.setTimeout($.proxy(that.fixRowHierarchy,that,this),0);
			var selectedCell = this._getSelectedCell;
			window.setTimeout(function(){
				$("#sap-ui-static .riskSpreadsheetCellPopup").remove();
			}, 0);
		};
		sheet.onAfterRendering._MIXED_ROW_HIERARCHY_=true;
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.fixRowHierarchy=function(sheet){
	var $table=sheet.$();
	_.each(sheet._mFnResultsCache._getColumnRangeToRender.lastResult._other,function(val,key){
		key=key.substring(key.indexOf("|")+1);
		$th=$table.find(".sapUiTableColHdr:nth-child("+(val[2]+1)+") th[data-sap-ui-colid="+key+"]");
		if(val[0]){
			$th.css("width",val[0]);
			$th.attr("colspan",val[1]);
		}else{
			$th.css("display","none");
		}
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.createModel=function(metaInfo,sheet,fetchCriteria){
	var meta=metaInfo.meta;
	var sheetId=metaInfo.id;
	var isTree=meta.getTableOptions().isTree;
	var tableModel=sheet.getModel(sheetId);
	var klass=isTree?sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel:sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONModel;
	if(tableModel){
		var isTreeModel=tableModel instanceof sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel;
		klass=(isTree && !isTreeModel)?sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel:
			      ((!isTree && isTreeModel)?sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONModel:null);
		var bindId=tableModel.getBindId();
		var service=tableModel.getService();
		var dataKey=tableModel.dataKey;
		var arrayNames=tableModel.arrayNames;
		var delta=tableModel.delta;
		var undo=tableModel.undo;
	}else{
		var dataUrlMap=this.getDataUrl()||{};
		var dataUrl=dataUrlMap[sheetId];
		service=(dataUrl)?
				new sas.risk.common.widgets.spreadsheet.model.SpreadsheetRestService({url:dataUrl}):
				new sas.risk.common.widgets.spreadsheet.model.SpreadsheetLocalService();
		var arrayNamesMap=this.getArrayNames()||{};
		var dataBindIdMap=this.getDataBindId()||{};
		bindId=dataBindIdMap[sheetId]||"items";
		dataKey=this.getDataKey()[sheetId]||"key";
		arrayNames=arrayNamesMap[sheetId];
	}
	if(klass){
		tableModel&&tableModel.destroy();
		tableModel=new klass({
			bindId:bindId,
			service:service,
			dataKey:dataKey,
			arrayNames:arrayNames,
			delta:delta,
			undo:undo,
			patch:this.getPatch()||{}
		});
		var that=this;
		tableModel.attachChange(function(e){
			that.fireChange(e.getParameters());
		});
		if(meta && meta.tableOptions && meta.getTableOptions()["pageSize"]) {
			tableModel.setPageSize(meta.getTableOptions()["pageSize"]);
		}
		tableModel.setServiceData({fetchCriteria:fetchCriteria});
	}
	var header=this.getDataHeader();
	if(header&&header[sheetId]&&tableModel.setHeader){
		tableModel.setHeader(header[sheetId]);
	}
	this.models[sheetId]=tableModel;
	this.setModel(tableModel,sheetId);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setValues=function(value){
	if(!value){//value passed by model is falsy, use a reasonable default instead
		value={start:0,count:0,items:[]};
		this.getBindingInfo("values").skipModelUpdate=false;//apply the new default value back on the model
	}
	this.setProperty("values",value);
	if(_.size(this.models)){
		this.syncValues();
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.getMetaInfo=function(sheetId){
	return _.find(this.getMeta(),function(metaInfo){
		return metaInfo.id===sheetId;
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.syncValues=function(){
	var value=this.getProperty("values");
	if(_.isString(value)){
		value=JSON.parse(value);
	}
	value=$.isArray(value)?value:[value];
	var meta=this.getMeta();
	var that=this;
	if(meta){
		var models=this.models;
		var metaInfoIds=_.pluck(meta,"id");
		_.each(value,function(val,index){
			var sheetId=metaInfoIds[index];
			var model=models[sheetId];
			if(model){
				model.clearData();
				var rowBinding=that.getSheetTable(sheetId).getBinding("rows");
				if(rowBinding.resetData)//tree binding adapter needs to be manually cleaned up or else it caches previous values
				   rowBinding.resetData();
				var service=model.getService();
				//reactive the service model
				model.setServiceData(model.getServiceData());
				if(service instanceof sas.risk.common.widgets.spreadsheet.model.SpreadsheetLocalService){
					service.setData(val);
				}
			}
		});
		var tab=this.tabs.getSelectedItem();
		var table=tab.getContent()[0];
		table.rerender();
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._refreshColumns=function(sheet,metaInfo,fetchCriteria){
	var meta=metaInfo.meta;
	var sheetId=metaInfo.id;
	sheet.destroyColumns();
	var columnFactory=sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory.getInstance();
	var columnIds=meta.getColumnIds();
	this.state.clearColumnAliases(sheetId);
	var dataKey=this.getDataKey()[sheetId]||"key";
	var that=this;
	_.each(columnIds,function(columnId){
		var options=meta.getColumnOptions(columnId);
		var opts=$.extend({
			name:columnId,
			template:new sas.risk.common.widgets.spreadsheet.SpreadsheetCell({cellId:"{"+sheetId+">"+dataKey+"}",sheet:sheet}),
			sheetId:sheetId,
			_state:that.state
		},options);
		delete opts.id;
		if(opts.visible){
			that.state.addColumnAlias(sheetId,columnId);
		}
		var column=columnFactory.create(opts);
		sheet.addColumn(column);
		if(column.getVisible() && fetchCriteria.columnIds.indexOf(columnId)===-1){
			fetchCriteria.columnIds.push(columnId);
		}
	});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.rowTrackerHandler=function(e){
	var table=e.getSource();
	var sheetId=table.data("sheetId");
	var dataKey=this.getDataKey()[sheetId]||"key";
	this.state.clearRowAliases(sheetId);
	var rows=table.getRows();
	for(var i=0;i<rows.length;i++){
		var ctxt=table.getContextByIndex(i);
		if(ctxt){
			var obj=ctxt.getObject();
			if(obj){
				var key=ctxt.getObject()[dataKey];
				this.state.addRowAlias(sheetId,key,i+1);
				this.state.addRowPath(sheetId,key,ctxt.getPath());
			}
		}
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.mixinRowTracker=function(sheet,metaInfo){
	sheet.detachEvent("_rowsUpdated",this.rowTrackerHandler);
	sheet.attachEvent("_rowsUpdated",this.rowTrackerHandler);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.refreshFormulaMode=function(){
	if(this.state.isInFormulaMode()){
		_.each(this.getSheetTables(),function(table){
			table.addStyleClass("riskSpreadsheetFormulaMode");
		});
	}else{
		_.each(this.getSheetTables(),function(table){
			table.removeStyleClass("riskSpreadsheetFormulaMode");
		});
	}
};
/*  Set errors from array.  Structure:
	[{sheetId: "someId",errors :[{row: 1,col: A,errorText: "some error message", errorText: "error"},{row: 2,col: B,errorText: "some error message", errorText: "warning"}]}]
*/
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setCellErrors = function(errorData) {
	var that = this;

	//loop through each sheet
	_.each(errorData, function(errorSheet, index) {
		if(errorSheet.sheetId && that.getSheetTable(errorSheet.sheetId)) {
			_.each(errorSheet.errors, function(error, index) {
				var row = that.getSheetTable(errorSheet.sheetId).getRows()[error.row-1];
				if(row) {
					_.each(row.getCells(), function(cell, index) {
						if(cell.cellControl && cell.cellControl.cellInfo && cell.cellControl.cellInfo.aliasRef === (error.col + error.row)) {
							cell.cellControl.setErrorText(error.errorText);
							cell.cellControl.setErrorState(error.errorState);
							cell.cellControl.invalidateParent();
						}
					});
				}

			});
		}
	});
};
//SINGLE SELECT EVENT
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.handleSingleSelect=function(){
	var table=this.getSelectedSheetTable();
	var sheetId=table.data("sheetId");
	var indices=table.getSelectedIndices();
	if(indices.length===1){
		var rowData=table.getContextByIndex(indices[0]).getObject();
		var dataKey=this.getDataKey()[sheetId]||"key";
		this.fireMashup({
			event_name:"object_selected",
			key:rowData[dataKey]
		});
	}
};
//FETCH
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.setFetchCriteria=function(value){
	var fetchCriteria=value;
	if(value instanceof sas.risk.common.widgets.spreadsheet.FetchCriteria){
		fetchCriteria={abc:value};
	}
	this.setProperty("fetchCriteria",fetchCriteria);
	if(this.initialized){
		this._fetch();
		this.firePostFetchData({fetchCriteria:fetchCriteria});
	}
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype._fetch=function(){
	var tab=this.tabs.getSelectedItem();
	var sheetId=tab.getText();
	var table=tab.getContent()[0];
	var model=table.getModel(sheetId);
	model.clearData();
	var rowBinding=table.getBinding("rows");
	delete rowBinding._oRootNode;//tree binding adapter needs to be manually cleaned up or else it caches previous values

	var metaInfo=_.find(this.getMeta(),function(mi){return mi.id===sheetId;});
	var fetchCriteriaMap=this.getFetchCriteria();
	var fetchCriteria=fetchCriteriaMap[sheetId]||new sas.risk.common.widgets.spreadsheet.FetchCriteria();
	model.setServiceData({fetchCriteria:fetchCriteria,meta:metaInfo.meta,activate:true});
};
sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype.fetchData=function(sheetId){
	var fetchCriteriaMap=this.getFetchCriteria();
	var fetchCriteria=fetchCriteriaMap[sheetId];
	fetchCriteria.clear();
	this.firePreFetchData({fetchCriteria:fetchCriteriaMap});
	//save and clear zero state
	var oldNoData = this.getSelectedSheetTable().getNoData() ? 
		this.getSelectedSheetTable().getNoData() : null;
	var tableOptions = this.getMetaInfo(sheetId).meta.tableOptions;
	tableOptions.noData = " ";
	this.handleZeroState(this.getSelectedSheetTable(), tableOptions);
	this._fetch();
	//reapply old zero state
	tableOptions.noData = oldNoData;
	this.handleZeroState(this.getSelectedSheetTable(), tableOptions);
	this.firePostFetchData({fetchCriteria:fetchCriteriaMap});
};
//we need the reason to be set so that the aria call happens when updating rows for a tree table. without it, it skips the call and doesnt refresh our numbering of the rows
sap.ui.model.ClientTreeBinding.prototype.checkUpdate=function(){
	this.applyFilter();
	this._mLengthsCache={};
	this._fireChange({reason:"change"});
};
//updates for column hierarchy
sas.hc.ui.table.TableRenderer.renderColStartOrig=sas.hc.ui.table.TableRenderer.renderColStart;
sas.hc.ui.table.TableRenderer.renderColStart=function(rm, oTable, oColumn, iIndex, sHeaderId, oLabel){
	if(oTable instanceof sas.hc.ui.table.WideTable || oTable instanceof sas.hc.ui.table.WideTreeTable){
		var range=this.getColumnRenderRange(oTable);
		sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.calcColumnWidthSpan(oTable,oColumn,iIndex,oLabel,range);
	}
	sas.hc.ui.table.TableRenderer.renderColStartOrig.apply(this,arguments);
};
sas.risk.common.widgets.spreadsheet.Spreadsheet._origInitColumnResizing=sas.hc.ui.table.TablePointerExtension._ColumnResizeHelper.initColumnResizing;
sas.hc.ui.table.TablePointerExtension._ColumnResizeHelper.initColumnResizing=function(oTable, oEvent){
	var $table=oTable.$();
	var levels=$table.find(".sapUiTableColHdrCnt>div:first-child()>.sapUiTableColHdr").length;
	sas.risk.common.widgets.spreadsheet.Spreadsheet._origInitColumnResizing.apply(this,arguments);
	if(levels>1){
		var oColumn = oTable._getVisibleColumns()[oTable._iLastHoveredColumnIndex];
		var $column=$table.find("#"+oColumn.getId()+"_"+(levels-1));
	   oTable._iColumnResizeOriginalWidth = $column.width();		
	}
};
jQuery.sap.require("sap.ui.core.EnabledPropagator");
sap.ui.core.EnabledPropagator.call(sas.risk.common.widgets.spreadsheet.Spreadsheet.prototype);
