jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetCellInfo");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetCellFactory");

sap.ui.core.Control.extend("sas.risk.common.widgets.spreadsheet.SpreadsheetCell",{
	metadata:{
		properties:{
			cellId:{type:"string"},
			sheet:{type:"any"}
		}
	},
	renderer:function(rm,control){
		if(!control.getVisible()){return;}
		rm.write("<DIV");
		rm.writeControlData(control);
		rm.addStyle("height","31px");
		rm.addStyle("width","100%");
		rm.addStyle("display","flex");
		rm.addStyle("flex-grow","2");
		rm.writeStyles();
		rm.writeClasses();
		rm.write(">"); // DIV element
		//create cell info
		var colId=control.data()["sap-ui-colid"];
		var cellId=control.getCellId();
		if(cellId){
			var table=control.getSheet();
			var column=_.find(table.getColumns(),function(column){return column.getId()===colId;});
			var columnId=column.getName();		
			var spreadsheet=table.getParent();
			if(!spreadsheet.getState){//tab vs no tab
				spreadsheet=spreadsheet.getParent().getParent().getParent();
			}
			var sheetId=table.data("sheetId");
			var cellKey=sas.risk.common.widgets.spreadsheet.SpreadsheetCellInfo.createKey(sheetId,columnId,cellId);
			var cellInfo=spreadsheet.getState().getCell(cellKey,true);
			//create/refresh spreadsheet cell
			var meta=spreadsheet.getMetaInfo(sheetId).meta;
			var cellOptions=meta.getCellOptions(columnId,cellId);
			var cellType=cellOptions.cellType||"string";
			if(control.cellControl&&control.cellControl.getCellType()!==cellType){
				sas.risk.common.widgets.spreadsheet.SpreadsheetCellFactory.getInstance().release(control.cellControl);
				control.cellControl=null;
			}
			if(!control.cellControl){
				control.cellControl=sas.risk.common.widgets.spreadsheet.SpreadsheetCellFactory.getInstance().request(cellType);
			}
			//load and render it
			control.cellControl.loadCell(cellInfo);
			rm.renderControl(control.cellControl);
		}
		rm.write("</DIV>");
	}
});