jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleByColumn");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetCellInfo");

sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleByColumn=function(colFormat,valFormat){
	this.colFormat=colFormat;
	this.valFormat=valFormat;
};
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleByColumn.prototype={
	style:function(rm,cell){
		var cellId=cell.cellInfo.getSCellId();
		var myColumnId=cell.cellInfo.getSColumnId();
		var myValue=cell.cellInfo.getValue();
		var targetColumnId=this.format(this.colFormat,myColumnId,myValue);
		var dataRow=_.find(cell.cellInfo.getSModel().getDataArray(),function(row){return row.key==cellId;});// eslint-disable-line eqeqeq
		if(!_.isUndefined(dataRow[targetColumnId])){
			var targetValue=dataRow[targetColumnId];
			rm.addClass(this.format(this.valFormat,targetColumnId,targetValue,myColumnId,myValue));
		}
	},
   format:function(format) {
   	var args = Array.prototype.slice.call(arguments, 1);
   	return format.replace(/{(\d+)}/g, function(match, number) { 
   		return typeof args[number] != 'undefined' ? args[number] : match;
   	});
   }
};
