jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory");

sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory=function(){
	this.registry={};
	this.cache={};
};
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory.prototype={
	register:function(type,klassName){
		this.registry[type]=klassName;
	},
	request:function(type){
		var typeCache=this.cache[type];
		if(typeCache){
			return typeCache;
		}else{
			var split=type.split("|");
			var simpleType=split[0];
			var klassName=this.registry[simpleType];
			if(!klassName){
				console.error("No CellStyle item named "+simpleType+" has been registered. Ignoring it.");// eslint-disable-line no-console
				return null;
			}
			jQuery.sap.require(klassName);
			var klass=sap.ui.require(klassName.replace(/\./g, "/"));
			sas.risk.common.widgets.spreadsheet.SpreadsheetCellFactory.counter++;
			typeCache=new (klass.bind.apply(klass,split));
			this.cache[type]=typeCache;
			return typeCache;
		}
	}
};
//STATICS
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory.counter=0;
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory._instance=new sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory();
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory.getInstance=function(){
	return sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory._instance;
};
sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleFactory.getInstance().register("column_style","sas.risk.common.widgets.spreadsheet.SpreadsheetCellStyleByColumn");
