jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetColumn");
jQuery.sap.require("sas.hc.ui.table.Column");

sas.hc.ui.table.Column.extend("sas.risk.common.widgets.spreadsheet.SpreadsheetColumn",{
	metadata:{
		properties:{
			defaultVisible:{type:"boolean", defaultValue: true},
			quickSearch:{type:"boolean"},
			filterable:{type:"boolean"},
			filterPanelOpen:{type:"boolean"},
			queryable:{type:"boolean"},
			defaultOrder:{type:"int"},
			choices:{type:"string[]"},
			useAllFilter:{type:"boolean"},
			useNoneFilter:{type:"boolean"},
			sheetId:{typs:"string"},
			_state:{type:"any"},
			dataDefault: {type: "any"} //allows user to set default data on addrowbutton
		}
	},
	constructor:function(){
		this.formulaAlias=new sap.ui.core.HTML({content:"<div class='riskSpreadsheetColNumber'></div>"});
		sas.hc.ui.table.Column.apply(this,arguments);
	}
});
sas.risk.common.widgets.spreadsheet.SpreadsheetColumn.prototype.applySettings=function(settings){
	settings.label=this._createLabel(settings);
	sas.hc.ui.table.Column.prototype.applySettings.apply(this,arguments);
};
sas.risk.common.widgets.spreadsheet.SpreadsheetColumn.prototype.getMultiLabels=function(){
	var label=this.getLabel();
	var multiLabels=sas.hc.ui.table.Column.prototype.getMultiLabels.apply(this,arguments);
	if(multiLabels.length){
		var origLabel=multiLabels.pop();
		if(!label.getText()){
			label.setText(origLabel.getText());
		}
		multiLabels.push(label);
	}
	return multiLabels;
};
sas.risk.common.widgets.spreadsheet.SpreadsheetColumn.prototype._createMenu=function(){
   return new sas.risk.common.widgets.spreadsheet.SpreadsheetColumnMenu(this.getId() + "-menu");
};
sas.risk.common.widgets.spreadsheet.SpreadsheetColumn.prototype._createLabel=function(settings){
	var label=settings.label;
	var actualLabel=new sas.hc.m.Label({text:label});
	var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
		items:[
			actualLabel,
			this.formulaAlias
		]
	});
	layout.setText=function(lbl){
		actualLabel.setText(lbl);
	};
	layout.getText=function(){return actualLabel.getText();};
	this.formulaAlias._COLUMN_=this;
	var sheetId=settings.sheetId;
	layout.onBeforeRendering=function(){
		var formulaAlias=this.getItems()[1];
		var column=formulaAlias._COLUMN_;
		var state=column.get_state();
		var alias=state.getColumnAlias(sheetId,column.getName());
		formulaAlias.setContent("<div class='riskSpreadsheetColNumber'>"+alias+"</div>");
	};
	return layout;
};
jQuery.sap.require("sas.hc.ui.table.ColumnMenu");
jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetColumnMenu");
sas.hc.ui.table.ColumnMenu.extend("sas.risk.common.widgets.spreadsheet.SpreadsheetColumnMenu",{
	renderer:"sas.hc.ui.table.ColumnMenuRenderer"
});
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnMenu.prototype._addMultiSortMenuItem=function(){};
