jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetColumn");

sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory=function(){
	this.registry={};
};
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory.prototype={
	register:function(type,klassName){
		this.registry[type]=klassName;
	},
	create:function(options){
		var type=options.columnType||"default";
		var klassName=this.registry[type];
		if(!klassName){
			console.error("Spreadsheet column of type "+type+" is not registered.");// eslint-disable-line no-console
			klassName=this.registry["default"];
		}
		jQuery.sap.require(klassName);
		var klass=sap.ui.require(klassName.replace(/\./g, "/"));
		var clone=$.extend({},options);
		delete clone.columnType;
		return new klass(clone);
	}
};
//STATICS
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory._instance=new sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory();
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory.getInstance=function(){
	return sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory._instance;
};
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory.getInstance().register("default","sas.risk.common.widgets.spreadsheet.SpreadsheetColumn");
sas.risk.common.widgets.spreadsheet.SpreadsheetColumnFactory.getInstance().register("number","sas.risk.common.widgets.spreadsheet.SpreadsheetNumberColumn");