jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetFormulaContext");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.Functions");

sas.risk.common.widgets.spreadsheet.SpreadsheetFormulaContext=function(externalFnCallback){
	this.externalFnCallback=externalFnCallback||function(funcName){
		return $.Deferred().reject("#NAME?");//The formula contains an unrecognized formula name
	};
	this.formulaNames=[];
	this.state=null;
};
sas.risk.common.widgets.spreadsheet.SpreadsheetFormulaContext.prototype={
	setState:function(state){
		this.state=state;
	},
	clearExpectedFormulas:function(){
		this.formulaNames=[];
	},
	addExpectedFormulas:function(formulaNames){
		this.formulaNames=this.formulaNames.concat(formulaNames);
	},
	get:function(key){
		var def=$.Deferred();
		if(this.formulaNames.indexOf(key)!==-1){//looking for a formula
			if(sas.risk.common.widgets.spreadsheet.formula.Functions[key]){
				def.resolve(sas.risk.common.widgets.spreadsheet.formula.Functions[key]);
			}else{
				def.resolve($.proxy(this.externalFnCallback,this,key));
			}
		}else{//looking for a variable
			var cachedValue=this.state.getCachedValue(key);
			if(cachedValue){
				def.resolve(cachedValue.value);
			}else{
				var cellInfo=this.state.getCell(key);
				var value=cellInfo.getValue();
				var cellOptions=cellInfo.getSOptions();
				if(cellOptions.cellType==="formula"){
					return cellInfo.evaluateExpression();
				}else{
					def.resolve(value);
				}				
			}
		}
		return def;
	}
};