jQuery.sap.require("sas.hc.ui.table.WideTable");
jQuery.sap.require("sas.hc.ui.table.WideTreeTable");
jQuery.sap.require("sas.hc.ui.table.TableKeyboardExtension");
jQuery.sap.require("sas.hc.ui.table.ItemNavigation");
jQuery.sap.require("sas.hc.ui.table.TableUtils");

sas.risk.common.widgets.spreadsheet.SpreadsheetTableMixin={
	onAfterRendering:function(){
		this.isTree?sas.hc.ui.table.WideTreeTable.prototype.onAfterRendering.apply(this,arguments):sas.hc.ui.table.WideTable.prototype.onAfterRendering.apply(this,arguments);
		var itemNav=this._getItemNavigation();
		itemNav.detachEvent(sas.hc.ui.table.ItemNavigation.Events.AfterFocus,this.proxyOnAfterFocus);
		itemNav.attachEvent(sas.hc.ui.table.ItemNavigation.Events.AfterFocus,this.proxyOnAfterFocus);
		itemNav.detachEvent(sas.hc.ui.table.ItemNavigation.Events.FocusAgain,this.proxyOnFocusAgain);
		itemNav.attachEvent(sas.hc.ui.table.ItemNavigation.Events.FocusAgain,this.proxyOnFocusAgain);
	},
	onFocusAgain:function(event){
		return this.onAfterFocus(event);
	},
	_attachEvents:function(){
		this.isTree?sas.hc.ui.table.WideTreeTable.prototype._attachEvents.apply(this,arguments):
			sas.hc.ui.table.WideTable.prototype._attachEvents.apply(this,arguments);
		var $vsb = jQuery(this.getDomRef("vsb"));
      	var $hsb = jQuery(this.getDomRef("hsb"));
      	// For preventing the ItemNavigation to re-apply focus to old position (table cell)
      	// when clicking on ScrollBar
      	$hsb.bind("mousedown.sapUiTableHScroll", $.proxy(this._blurDanglingCell,this));
      	$vsb.bind("mousedown.sapUiTableVScroll", $.proxy(this._blurDanglingCell,this));
      	if (sap.ui.Device.browser.firefox) {
	      	this._getScrollTargets().bind("MozMousePixelScroll.sapUiTableMouseWheel", this._blurDanglingCell.bind(this));
      	} else {
	      	this._getScrollTargets().bind("wheel.sapUiTableMouseWheel", this._blurDanglingCell.bind(this));
      	}
	},
	_blurDanglingCell:function(){
		var cell=this._getSelectedCell();
		if(cell){
			cell.blurCell();
		}
	},
	_getSelectedCell:function(){
		//return null if no cell is selected due to a rerender
		if(!this.getFocusDomRef()){return null;}
		var rowIdx=sas.hc.ui.table.TableUtils.getRowIndexOfFocusedCell(this);
		if(rowIdx<0){return;}
		var colIdx=sas.hc.ui.table.TableUtils.getColumnIndexOfFocusedCell(this);
		if(colIdx<0){return;}
		var domRef=this._getItemNavigation().getFocusedDomRef();
		var $cell=$(domRef).find(".riskSpreadsheetCell");
		if($cell.length){
			return sap.ui.getCore().byId($cell[0].id);
		}
		return null;
	},
	onAfterFocus:function(event){
		setTimeout($.proxy(this._focus,this),0,event);
	},
	_focus:function(event){
		var cell=this._getSelectedCell();
		if(cell){
			cell.cellInfo.getSState().onCellClick(cell);
		}else{
			var sheetId=this.data("sheetId");
			this.getState().blurPreviousCell(sheetId);
		}
	}
};

jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetTable");
sas.hc.ui.table.WideTable.extend("sas.risk.common.widgets.spreadsheet.SpreadsheetTable",{
	metadata:{
		properties:{
			state:{type:"any"}
		}
	},
	constructor:function(){
		sas.hc.ui.table.WideTable.apply(this,arguments);
		this.proxyOnAfterFocus=$.proxy(this.onAfterFocus,this);
		this.proxyOnFocusAgain=$.proxy(this.onFocusAgain,this);
	},
	renderer: "sas.hc.ui.table.WideTableRenderer"
});

//REMOVE THIS WHEN WE MOVE to 9.0
//FIXES INFINITE LOOP BUG WHEN HIEHGT RESIZE
sas.risk.common.widgets.spreadsheet.SpreadsheetTable.prototype._adjustRows = function() {
	var bChanged = false;	//default to no change
	
	if (this.hasOwnProperty("_iAdjustRowsCount") === false) {
		//1st time in a new adjustment, so create a loop count property
		this._iAdjustRowsCount = 0;
	}

	//we are in an adjustment, do loop detection
	this._iAdjustRowsCount++;
	if (this._iAdjustRowsCount < 4) {	//give it a few tries to do the right thing
		bChanged = sas.hc.ui.table.Table.prototype._adjustRows.apply(this, arguments);
	}
	
	//if no changes occurred, then delete the counter
	if (!bChanged) {
		delete this._iAdjustRowsCount;
	}
	
	return bChanged;
};
// END OF FUNCTION TO REMOVE
$.extend(sas.risk.common.widgets.spreadsheet.SpreadsheetTable.prototype,sas.risk.common.widgets.spreadsheet.SpreadsheetTableMixin);
jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetTreeTable");
sas.hc.ui.table.WideTreeTable.extend("sas.risk.common.widgets.spreadsheet.SpreadsheetTreeTable",{
	metadata:{
		properties:{
			state:{type:"any"}
		}
	},
	constructor:function(){
		sas.hc.ui.table.WideTreeTable.apply(this,arguments);
		this.isTree=true;
		this.proxyOnAfterFocus=$.proxy(this.onAfterFocus,this);
		this.proxyOnFocusAgain=$.proxy(this.onFocusAgain,this);
	},
	renderer: "sas.hc.ui.table.WideTreeTableRenderer"
});
sas.risk.common.widgets.spreadsheet.SpreadsheetTable.prototype.invalidate = function(oOrigin) {
	if (oOrigin !== this.getSelectAllControl()) {   //S1241581: the select-all control can invalidate all it wants, but it won't bother me
		if (!this._ignoreInvalidateOfChildControls && !(oOrigin instanceof sas.hc.ui.table.WideRow) && !(oOrigin instanceof sas.risk.common.widgets.spreadsheet.SpreadsheetColumn)) {
			this._bInvalid = true;
			var vReturn = sap.ui.core.Control.prototype.invalidate.call(this);
		}

		return vReturn;
	}
}; 
$.extend(sas.risk.common.widgets.spreadsheet.SpreadsheetTreeTable.prototype,sas.risk.common.widgets.spreadsheet.SpreadsheetTableMixin);
