jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory");

sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory=function(){
	this.registry={};
};
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.prototype={
	register:function(type,klassName){
		this.registry[type]=klassName;
	},
	create:function(type,args){
		var klassName=this.registry[type]||this.registry[type.split("|")[0]];
		if(!klassName){
			
			console.error("No Spreadsheet Toolbar item named "+type+" has been registered. Ignoring it.");// eslint-disable-line no-console
			return null;
		}
		jQuery.sap.require(klassName);
		var klass=sap.ui.require(klassName.replace(/\./g, "/"));
		args=args||{};
		args.spreadsheetToolbarType=type;
		return new klass(args);
	}
};
//STATICS
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory._instance=new sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory();
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance=function(){
	return sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory._instance;
};

sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("broadsearch","sas.risk.common.widgets.spreadsheet.toolbar.BroadSearch");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("search","sas.risk.common.widgets.spreadsheet.toolbar.Search");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("filters","sas.risk.common.widgets.spreadsheet.toolbar.Filters");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("createnew","sas.risk.common.widgets.spreadsheet.toolbar.CreateNewButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("edit","sas.risk.common.widgets.spreadsheet.toolbar.EditButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("save","sas.risk.common.widgets.spreadsheet.toolbar.SaveButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("undo","sas.risk.common.widgets.spreadsheet.toolbar.UndoButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("addrow","sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("refresh","sas.risk.common.widgets.spreadsheet.toolbar.RefreshButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("delete","sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("spacer","sas.risk.common.widgets.spreadsheet.toolbar.Spacer");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("removeitem","sas.risk.common.widgets.spreadsheet.toolbar.RemoveItemButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("totals","sas.risk.common.widgets.spreadsheet.toolbar.Totals");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("zerostate","sas.risk.common.widgets.spreadsheet.toolbar.ZeroState");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("export", "sas.risk.common.widgets.spreadsheet.toolbar.ExportButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("import", "sas.risk.common.widgets.spreadsheet.toolbar.ImportButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("moveup", "sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("movedown", "sas.risk.common.widgets.spreadsheet.toolbar.MoveTopButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("movetop", "sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton");
sas.risk.common.widgets.spreadsheet.SpreadsheetToolbarFactory.getInstance().register("movebottom", "sas.risk.common.widgets.spreadsheet.toolbar.MoveBottomButton");