jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
jQuery.sap.require("sas.hc.m.DefaultNumericFormatter");
jQuery.sap.require("sas.hc.m.InputValidationAdapter");
sas.risk.common.widgets.spreadsheet.SpreadsheetUtil={
	_rb:null,
	_baseRb: sap.ui.getCore().getLibraryResourceBundle("sas.risk.common"),
	_wrapperRb:{
		getText : function(key, args){
			var val=null;
			var bundle = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._rb;
			if(bundle){
				val=bundle.getText(key,args);
			}
			if(val){return val;}
			if(!val){
				val=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._baseRb.getText(key,args);
			}
			if(!val){
				console.error("Risk Common Resource bundle missing : Key = " + key);// eslint-disable-line no-console
				return key;
			}
			return (args&&args.length)?jQuery.sap.formatMessage(val,args):val;
		},
		hasText : function(key){
			var val=null;
			var bundle = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._rb;
			if(bundle){
				val=bundle.getText(key);
			}
			if(val){return true;}
			if(!val){
				val=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._baseRb.getText(key,args);
			}
			return !!val;
		}
	},
	_numericFormatter:new sas.hc.m.DefaultNumericFormatter(),
	_numericValidator:new sas.hc.m.InputValidationAdapter(),
	formatNumber:function(number){
		if(_.isNull(number)||_.isUndefined(number)){return "";}
		var ff=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._numericFormatter;
		var vv=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._numericValidator;
		var result=ff.format(number,sap.ui.getCore().getConfiguration().getFormatLocale(),vv.getDecimalAndGroupingSeparator());
		return result.formattedNumber;
	},
	setBundle:function(rb){
		sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._rb=rb;
	},
	getBundle:function(){
		return sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._wrapperRb;
	},
	_locale:null,
	getLocale:function(){
		return sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._locale;
	},
	setLocale:function(locale){
		sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._locale=locale;
	},
	round:function(value,decimals){
		return Number(Math.round(value+'e'+decimals)+'e-'+decimals);
	},
	getCaretPosition : function(elemId) {
		var elem = document.getElementById(elemId);
		var iCaretPos = 0;
		if (document.selection) {// IE Support
			elem.focus();
			var oSel = document.selection.createRange();
			oSel.moveStart('character', -elem.value.length);
			iCaretPos = oSel.text.length;
		}
		else if (elem.selectionStart || elem.selectionStart === '0') {
			iCaretPos = elem.selectionStart;
		}
		return iCaretPos;
	},
	setCaretPosition:function(elemId,caretPos){
		_.delay(function(){
			sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._setCaretPosition(elemId, caretPos);
		},0);		
	},
	_setCaretPosition:function(elemId,caretPos){
		var el = (elemId instanceof Element)?elemId:document.getElementById(elemId);
		el.value = el.value;
		// ^ this is used to not only get "focus", but
		// to make sure we don't have it everything -selected-
		// (it causes an issue in chrome, and having it doesn't hurt any other browser)
		caretPos = (caretPos === undefined) ? el.value.length : caretPos;
		if (el !== null) {
			if (el.createTextRange) {
				var range = el.createTextRange();
				range.move('character', caretPos);
				range.select();
				return true;
			}else{
				// (el.selectionStart === 0 added for Firefox bug)
				if (el.selectionStart || el.selectionStart === 0) {
					el.focus();
					el.setSelectionRange(caretPos, caretPos);
					return true;
				} else  { // fail city, fortunately this never happens (as far as I've tested) :)
					el.focus();
					return false;
				}
			}
		}
	},
	_mergeLabels:function(table,text,multiLabelIndex,currentIndex,firstIndex,lastIndex){//returns [width,span,multiLabelIndex]
		if(currentIndex>firstIndex){//if previous column has same text, assume current column will be merged
			var prevMultiLabels=table.getColumns()[currentIndex-1].getMultiLabels();
			if(prevMultiLabels.length){
				var ml=prevMultiLabels[multiLabelIndex];
				var prevText=ml? ml.getText() : null;
				if(text===prevText){
					return [0,0,multiLabelIndex];
				}
			}
		}
		//look at next columns for merging potential, at the very least it will stand on its own
		var width=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._getWidth(table.getColumns()[currentIndex].getWidth());
		var span=1;
		for(var i=currentIndex+1;i<lastIndex;i++){
			var nextText;
			if(table.getColumns()[i].getMultiLabels()[multiLabelIndex]) {
				nextText=table.getColumns()[i].getMultiLabels()[multiLabelIndex].getText();
			}
			if(nextText===text){//prev column has same text, merge it
				width+=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._getWidth(table.getColumns()[i].getWidth());
				span++;
			}else{//reached a previous column with different text. stop merging.
				break;
			}
		}
		return [width,span,multiLabelIndex];
	},
	//_REGEX_WIDTH:/^(\d+)(?:px)?$/,
	_REGEX_WIDTH:/^([\d\.]+)(?:px)?$/,
	//Fix for defect RGFRMWRK-182
	_getWidth:function(str){
		var match=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._REGEX_WIDTH.exec(str);
		return parseInt(match[1]);
	},
	calcColumnWidthSpan:function(table,column,index,label,range){//creates a cache of calculated column hierarchy info
		if(range.width===0 || range.start+1>=range.end){return ;}//fake out call
		var cache=table._mFnResultsCache._getColumnRangeToRender.lastResult._other||{};//store in cache cuz we get called _many_ times
		table._mFnResultsCache._getColumnRangeToRender.lastResult._other=cache;//initialize cache
		var multiLabels=column.getMultiLabels();
		var multiIndex=multiLabels.indexOf(label);
		if(cache[multiIndex+"|"+column.getId()]){return ;}//cache hit
		if(multiIndex<(multiLabels.length-1)&&multiIndex!==-1){//is in multiLabel mode and is not leaf label
			label.setTextAlign("Center");
			var fixedCount=table.getFixedColumnCount();
			if(range.start<fixedCount){//fixed columns scrolling
				results=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._mergeLabels(table,label.getText(),multiIndex,index,range.start,range.end);
			}else{//all fixed columns fit
				if(index<fixedCount){//fixed column
					results=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._mergeLabels(table,label.getText(),multiIndex,index,0,fixedCount);
				}else{//scrolling columns
					if(index>=range.start && index<range.end){//scrolling column in range
						results=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil._mergeLabels(table,label.getText(),multiIndex,index,range.start,range.end);
					}else{//scrolling column out of range
						results=[0,0,multiIndex];
					}
				}
			}
			cache[multiIndex+"|"+column.getId()]=results;
		}
	},
	objectMetaToFileMeta: function(meta) {
		var fileMeta = {'id': meta.id, 'meta': {'id' : meta.id}};
		fileMeta.meta.table = {'options': meta.meta.tableOptions };
		fileMeta.meta.table.columnOptions = meta.meta.baseColumnOptions;
		fileMeta.meta.table.cellOptions = meta.meta.baseCellOptions;
		if (meta.meta.cellOptions && JSON.stringify(meta.meta.cellOptions) !== JSON.stringify({})) {
			fileMeta.meta.cells = meta.meta.cellOptions;
		}
		fileMeta.meta.columns = [];

		_.each(meta.meta.getColumnIds(), function(value, index) {
			fileMeta.meta.columns[index] = {"options" : 
				meta.meta.columnOptions[value]
			};

			//convert multilabel to label
			var multilabels = [];
			if(fileMeta.meta.columns[index].options.multiLabels){
				_.each(fileMeta.meta.columns[index].options.multiLabels, function(multi, multiIndex) {
					multilabels.push(multi.getText());
				});
				delete fileMeta.meta.columns[index].options["multiLabels"];
				fileMeta.meta.columns[index].options.label = multilabels;
			}

			if(meta.meta.columnCellOptions[value]) {
				fileMeta.meta.columns[index].cellOptions = meta.meta.columnCellOptions[value];
			}
		});

		return fileMeta;
	},
	delPropValue:function(target,path){
	   //Given a target object, it removes the property found a the given path relative to the object
	   //eg: target={a:{b:{c:123}}} path="/a/b/c" --> target={a:{b:{}}}
      var split=path.split("/");
      split=_.filter(split,function(propName){return !!propName;});//ignore empty propNames that split may introduce
      var lastPropName=split.pop();
      var propTarget=_.reduce(split,function(currentTarget,propName){
         if(_.isUndefined(currentTarget[propName])){
            return {};
         }
         return currentTarget[propName];
      },target);
      delete propTarget[lastPropName];
	},
	addPropValue:function(target,path,value){
	   //Given a target object, it sets the given value at the given path relative to the object
	   //creating any intermediate parent as needed
	   //eg: target={}; path="/a/b/c" value="123" --> target={a:{b:{c:123}}}
	   var split=path.split("/");
	   split=_.filter(split,function(propName){return !!propName;});//ignore empty propNames that split may introduce
	   var lastPropName=split.pop();
	   var propTarget=_.reduce(split,function(currentTarget,propName){
         if(_.isUndefined(currentTarget[propName])){
            currentTarget[propName]={};
         }
         return currentTarget[propName];
	   },target);
	   propTarget[lastPropName]=value;
	},
	importRestServiceDataPatch:function(data,spreadsheet){
   	var value=data.data;
   	if(_.isString(value)){
   		value=JSON.parse(value);
   	}
   	value=$.isArray(value)?value:[value];
   	var meta=spreadsheet.getMeta();
   	if(meta){
   		var models=spreadsheet.models;
   		var metaInfoIds=_.pluck(meta,"id");
   		_.each(value,function(val,index){
   			var sheetId=metaInfoIds[index];
   			var model=models[sheetId];
   			if(model){
   				var service=model.getService();
   				if(service instanceof sas.risk.common.widgets.spreadsheet.model.SpreadsheetRestService){
   					var rowKeys=model.getRowKeys();
   					
   					var originalData = spreadsheet.getValues();
   					if (originalData) {
   						var itemKeys=[];
   						var items = originalData.items;
   						for(var key in items) {
   							var row=items[key];
   							var rKey=row.key;
   							if (rowKeys.indexOf(rKey) !== -1) {
      							itemKeys.push(row.key);
   							} else {
   								if (typeof rKey=='number' && rowKeys.indexOf(rKey.toString()) !== -1) {
   									itemKeys.push(rKey.toString());
   								} else {
   									itemKeys=[];
   									break;
   								}
   							}
   					   }
   						if (itemKeys.length > 0 && itemKeys.length !== rowKeys.length) {
   							rowKeys=itemKeys;
   						}
   					}
   					
   					var importKeys=[];
   					var newRows=[];
                  var meta1=spreadsheet.getMeta()[index].meta;
                  var dataKey=spreadsheet.getDataKey()[sheetId]||"key";
                  for(var i=0; i<val.items.length; i++){
                     var row = val.items[i];
                     var cellId = row[dataKey];
                     importKeys.push(cellId);
                     if (rowKeys.indexOf(cellId) !== -1) {
                        var columnsInRow = Object.entries(row);
                     	_.each(columnsInRow,function(column){
                     		var columnId = column[0];
                     		var newValue = column[1];
                           var cellOptions = meta1.getCellOptions(columnId, cellId);
									if (cellOptions) {
										var currValue = model.getValue(cellId, columnId, cellOptions);
										if (newValue) {
											if (currValue !== newValue) {
												model.setValue(cellId, columnId, newValue, cellOptions, true);
											}
										} else if (currValue) {
											model.setValue(cellId, columnId, newValue, cellOptions, true);
										}
									}
                     	});
                     } else {
                     	newRows.push(row);
                     }
                  }
                  
                  // check the rows deleted from the import if any
                  var patch = model.getPatch();
               	_.each(rowKeys,function(rowKey){
                  	if (importKeys.indexOf(rowKey) === -1) {
               	      var opsInPatch =[];
               	      opsInPatch.push({op:"remove"});
               	      patch[rowKey]= opsInPatch;
                  	}
               	});
               	
                  // check the new rows added from the import if any
               	_.each(newRows,function(newRow){
               		//service.addDraftRow(newRow);
            	      var rowPatch=[];
            	      patch[newRow[dataKey]]=rowPatch;
            	      _.each(newRow,function(value,key){
            	      	rowPatch.push({op:"add",path:key,value:value});
            	      });
               	});
   					
   				}
   			}
   		});
   	}
	}
	
};