jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.api.SpreadsheetViewsAPI");

sas.risk.common.widgets.spreadsheet.api.SpreadsheetViewsAPI={
	saveView:function(key,view){
		var def=$.Deferred();
		var valueStr=localStorage.getItem(key);
		var value=null;
		if(valueStr){
			value=JSON.parse(valueStr);
			value[view.getViewName()]=view.toJson();
			if(view.getViewIsDefault()) {
				var defaultViewName=view.getViewName();
				_.each(value,function(viewJson,viewName){
					viewJson.isDefault=(defaultViewName===viewName);
				});
			}
			def.resolve(sas.risk.common.widgets.spreadsheet.View.loadViews(_.values(value)));

		}else{
			value={};
			value[view.getViewName()]=view.toJson();
		}
		localStorage.setItem(key,JSON.stringify(value));
		return def.resolve([]);
	},
	getViews:function(key){
		var def=$.Deferred();
		var valueStr=localStorage.getItem(key);
		if(valueStr){
			var json=JSON.parse(valueStr);
			def.resolve(sas.risk.common.widgets.spreadsheet.View.loadViews(_.values(json)));
		}
		return def.resolve([]);
	},
	deleteView:function(key,view){
		var def=$.Deferred();
		var valueStr=localStorage.getItem(key);
		if(valueStr){
			var value=JSON.parse(valueStr);
			delete value[view.getViewName()];
			localStorage.setItem(key,JSON.stringify(value));
		}
		return def.resolve();	
	},
	setAsDefaultView:function(key,view){
		var def=$.Deferred();
		var valueStr=localStorage.getItem(key);
		if(valueStr){
			var value=JSON.parse(valueStr);
			var defaultViewName=view.getViewName();
			_.each(value,function(viewJson,viewName){
				viewJson.isDefault=(defaultViewName===viewName);
			});
			localStorage.setItem(key,JSON.stringify(value));
		}
		return def.resolve();	
	}
};