jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.ADialogCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ACell");
jQuery.sap.require("sas.risk.common.utils.DialogManager");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");

sas.risk.common.widgets.spreadsheet.control.ACell.extend("sas.risk.common.widgets.spreadsheet.control.ADialogCell",{
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createEditControl=function(){
	var value=this.cellInfo.getValue();
	var valueStr=this.formatValueAsString(value);
	this.editInput = new sas.hc.m.Text({
       text: valueStr
   }).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Center
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	layout.addItem(this.editInput);
	var that=this;
	layout.addItem(new sas.risk.common.widgets.Button({
      icon: sas.icons.HC.CONFIGURATION,
      press:function(){
      	that.createDialog();
      }
   }));
	layout.addStyleClass("riskSpreadsheetDialogCell");
	layout.getValue=function(){
		return this.innerValue;
	};
	layout.setValue=function(value){
		this.innerValue=value;
	};
	layout.setValue(value);
   return layout;
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.focusOnEditControl=function(){};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.formatNumber=function(num){
	return sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.formatNumber(num);
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createViewControl=function(){
	return new sas.hc.m.Text({}).addStyleClass("riskSpreadsheetADialogCellView");
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.refreshViewControl=function(){
	var value=this.cellInfo.getValue();
	this.viewControl.setText(this.formatValueAsString(value));
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.formatValueAsString=function(value){
	return value;
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.getDialogName=function(){
	return "";//OVERRIDE
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createDialogViewData=function(){
	var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	this.editControl.setValue(this.cellInfo.getValue());
	return {
		title:rb.getText("spreadsheet.cell.dialog.param.title.txt"),
		value:this.editControl.getValue(),
		callback:this.dialogCallback
	};
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createDialog=function(){
	this.preventBlur=true;
	return sas.risk.common.utils.DialogManager.open(this.getDialogName(),this.createDialogViewData(),this.dialogCallback,this);
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.dialogCallback=function(e){
	if(e.getParameter&&e.getParameter("isOk")){
		this.editControl.setValue(e.getParameter("value"));
		this.editInput.setText(this.formatValueAsString(this.editControl.getValue()));
		this.storeNewValue();
		this.refreshViewControl();
	}
	this.preventBlur=false;
	this.editing=false;
	e.resolve&&e.resolve();
};
sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createPopup=function(){
	var popup=sas.risk.common.widgets.spreadsheet.control.ACell.prototype.createPopup.apply(this,arguments);
	var that=this;
	var orig=popup.onFocusEvent;
	popup.onFocusEvent=function(oBrowserEvent){
		var oEvent = jQuery.event.fix(oBrowserEvent);
		var type = (oEvent.type === "focus" || oEvent.type === "activate") ? "focus" : "blur";
		if(type==="blur"){
			if(that.preventBlur){return;}
		}
		orig.apply(this,arguments);
	};
	return popup;
};