jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.CheckboxCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ADialogCell");

sas.risk.common.widgets.spreadsheet.control.ADialogCell.extend("sas.risk.common.widgets.spreadsheet.control.CheckboxCell",{
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.common.widgets.spreadsheet.control.CheckboxCell.prototype.getDialogName=function(){
	return "sas.risk.common.widgets.spreadsheet.control.CheckboxDialog";
};
sas.risk.common.widgets.spreadsheet.control.CheckboxCell.prototype.formatValueAsString=function(value){
	var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	if(value && value.length){
		if(value.length<5){
			var choices=this.cellInfo.getSOptions().choices;
			var vals=_.filter(choices,function(c){
				return value.indexOf(c.value)!==-1;
			});
			return _.pluck(vals,"label").join(",");
		}else{
			return rb.getText("spreadsheet.cell.cbox.many.txt",[value.length]);
		}
	}else{
		return "";
	}
};
sas.risk.common.widgets.spreadsheet.control.CheckboxCell.prototype.createDialogViewData=function(){
	var viewData=sas.risk.common.widgets.spreadsheet.control.ADialogCell.prototype.createDialogViewData.apply(this,arguments);
	var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	viewData.title=rb.getText("spreadsheet.cell.cbox.title.txt");
	viewData.cpbForm=this.cellInfo.spreadsheet.getParent().getParent().getCpbForm();
	viewData.choices=this.cellInfo.getSOptions().choices;
	return viewData;
};