jQuery.sap.require("sas.risk.common.layout.gridlayout.GridLayout");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sap.ui.model.json.JSONModel");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetMeta");
jQuery.sap.require("sas.ui.cpb3.components.SpreadsheetComponent");
jQuery.sap.require("sas.risk.common.widgets.CheckBoxGroup");

sap.ui.jsview("sas.risk.common.widgets.spreadsheet.control.CheckboxDialog", {
	getControllerName : function() {
		return "sas.risk.common.widgets.spreadsheet.control.CheckboxDialog";
	},
	createContent : function(controller) {
		var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	   var that=this;
	   var viewData=this.getViewData();
	   this.createButtons(controller);
	   this.group=new sas.risk.common.widgets.CheckBoxGroup({
	   	checkedValues:"{choose>/values}",
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
			flexWrap:sas.risk.common.layout.flexlayout.FlexLayoutWrap.Wrap,
			items:{
				path:"choose>/choices",
				template:new sas.hc.m.CheckBox({
					name:"{choose>value}",
					text:"{choose>label}"
				})
			}
	   });
	   return this.group;
	},
	createButtons : function(controller) {
		var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	   this.okButton=new sas.risk.common.widgets.Button({
			text:rb.getText("spreadsheet.cell.dialog.button.ok.txt"),
			press:$.proxy(controller.actionOk,controller)
		});
	   this.okButton.addStyleClass("sasPrimaryButton");
		this.cancelButton=new sas.risk.common.widgets.Button({
			text:rb.getText("spreadsheet.cell.dialog.button.cancel.txt"),
			press:$.proxy(controller.actionCancel,controller)
		});
	},
	getDialogSettings : function() {
		return {
         contentWidth:"50%",
         beginButton: this.okButton,
         endButton: this.cancelButton,
         initialFocus: this.group
		};
	}
});
sap.ui.controller("sas.risk.common.widgets.spreadsheet.control.CheckboxDialog", {
	onInit:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		var model=this.createModel();
		view.setModel(model,"choose");
		view.group.setCheckedValues(model.getData().values);
	},
	actionOk:function(){
		var view=this.getView();
		view.getDialog().close();
		var checkedValues=view.group.calcCheckedValues();
		var value=[];
		_.each(view.group.getItems(),function(item){
			if(checkedValues.indexOf(item.getName())!==-1){
				value.push(item.getName());
			}
		});
		view.fireClosing({
			isOk:true,
			value:value
		});
	},
	actionCancel:function(){
		var view=this.getView();
		view.getDialog().close();
		view.fireClosing({
			isOk:false
		});
	},
	createModel: function(meta){
		var view=this.getView();
		var viewData=view.getViewData();
		var data={choices:[]};
		if(viewData.choices && viewData.choices.length){
			data.choices=$.extend(true,{},viewData.choices);
		}
		if(viewData.value && viewData.value.length){
			data.values=viewData.value;
		}
		return new sap.ui.model.json.JSONModel(data);
	}
});