jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.DateCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ACell");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.ui.cpb3.model.format.CpbDateFormat");
jQuery.sap.require("sas.hc.m.DatePicker");

sas.risk.common.widgets.spreadsheet.control.ACell.extend("sas.risk.common.widgets.spreadsheet.control.DateCell",{
	constructor:function(){
		sas.risk.common.widgets.spreadsheet.control.ACell.apply(this,arguments);
		var locale=sas.ui.cpb3.CpbUtil.getLocale();
		this.restFormat = sas.ui.cpb3.model.format.CpbDateFormat.getInstance({pattern: "yyyy-MM-ddz"}, locale);
		this.mediumFormat= sas.ui.cpb3.model.format.CpbDateFormat.getInstance({style: "medium"}, locale);
	},
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.createEditControl=function(){
	this.picker=new sas.hc.m.DatePicker({
		width: 'auto',
		valueFormat: "medium",
		displayFormat: "medium",
		readOnly: true,
		showWeekNumbers: true,
		showTodayButton: true,
		value:this.getMediumValue()
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	var that=this;
	this.picker.attachChange(function(e){
		if(e.getParameter("valid")){
			that.storeNewValue();
			that.refreshViewControl();
		}
	});
	return this.picker;
};
//API
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.createViewControl=function(){
	return new sas.hc.m.Text({}).addStyleClass("riskSpreadsheetDateCellView");
};
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.refreshViewControl=function(){
	this.viewControl.setText(this.getMediumValue());
};
//VALUE MANAGEMENT
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.getNewValue=function(){
	return this.getRestValue();
};
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.getRestValue=function(){
	var date=this.mediumFormat.parse(this.picker.getValue());
	return this.restFormat.format(date,true);
};
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.getMediumValue=function(){
	var restDateStr=this.cellInfo.getValue();
	var date=this.restFormat.parse(restDateStr);
	return this.mediumFormat.format(date);
};
//NAVIGATION
sas.risk.common.widgets.spreadsheet.control.DateCell.prototype.handleKeydown=function(event){
	switch(event.keyCode){
		case jQuery.sap.KeyCodes.ENTER:
			event.stopImmediatePropagation();
			event.preventDefault();
			return;
		case jQuery.sap.KeyCodes.SPACE:
			if(!(this.picker._oPopup&&this.picker._oPopup.isOpen())){
				this.picker.toggleOpen();
				return;//let the select widget handle it
			}
		default:
			sas.risk.common.widgets.spreadsheet.control.ACell.prototype.handleKeydown.apply(this,arguments);
	}
};