jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.DateCellClear");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.DateCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ACell");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.ui.cpb3.model.format.CpbDateFormat");
jQuery.sap.require("sas.hc.m.DatePicker");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");

//TODO: add l10n string for the button.  This is a temporary fix and should be removed in HC9+ when we can do it through the component itself

sas.risk.common.widgets.spreadsheet.control.DateCell.extend("sas.risk.common.widgets.spreadsheet.control.DateCellClear", {
    constructor: function () {
        sas.risk.common.widgets.spreadsheet.control.ACell.apply(this, arguments);
        var locale = sas.ui.cpb3.CpbUtil.getLocale();
        this.restFormat = sas.ui.cpb3.model.format.CpbDateFormat.getInstance({
            pattern: "yyyy-MM-ddz"
        }, locale);
        this.mediumFormat = sas.ui.cpb3.model.format.CpbDateFormat.getInstance({
            style: "medium"
        }, locale);
    },
    renderer: "sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});

sas.risk.common.widgets.spreadsheet.control.DateCellClear.prototype.createEditControl = function () {
    this.picker = new sas.hc.m.DatePicker({
        valueFormat: "medium",
        displayFormat: "medium",
        readOnly: true,
        showWeekNumbers: true,
        showTodayButton: true,
        value: this.getMediumValue()
    });
    var that = this;
    this.picker.attachChange(function (e) {
        if (e.getParameter("valid")) {
            that.storeNewValue();
            that.refreshViewControl();
        }
    });
    this.clearButton = new sas.hc.m.Button({
        icon: sas.icons.HC.CLEARFILTER,
        press: function () {
            if (that.picker) {
                that.picker.setValue("");
            } else {
                console.error("DatePicker Object cannot be found.");
            }
        }
    });

    this.layout = new sas.risk.common.layout.flexlayout.FlexLayout({
        width: "100%",
        items: [this.picker, this.clearButton],
        flexDirection: sas.risk.common.layout.flexlayout.FlexLayoutDirection.Row
    });

    return this.layout;
};