jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.DateTimeCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.DateCell");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.ui.cpb3.model.format.CpbDateFormat");
jQuery.sap.require("sas.hc.m.DateTimePicker");

sas.risk.common.widgets.spreadsheet.control.DateCell.extend("sas.risk.common.widgets.spreadsheet.control.DateTimeCell",{
	constructor:function(){
		sas.risk.common.widgets.spreadsheet.control.DateCell.apply(this,arguments);
		var locale=sas.ui.cpb3.CpbUtil.getLocale();
		this.restFormat = sas.ui.cpb3.model.format.CpbDateFormat.getDateTimeInstance({pattern: "yyyy-MM-ddTHH:mm:ss.SSSz"}, locale);
		this.mediumFormat= sas.ui.cpb3.model.format.CpbDateFormat.getDateTimeInstance({style: "medium"}, locale);
	},
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.common.widgets.spreadsheet.control.DateTimeCell.prototype.createEditControl=function(){
	this.picker=new sas.hc.m.DateTimePicker({
		width: 'auto',
		valueFormat: "medium",
		displayFormat: "medium",
		readOnly: true,
		showWeekNumbers: true,
		showTodayButton: true,
		value:this.getMediumValue()
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	var that=this;
	this.picker.attachChange(function(e){
		if(e.getParameter("valid")){
			that.storeNewValue();
		}
	});
	return this.picker;
};