jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.DropdownCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ACell");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");

sas.risk.common.widgets.spreadsheet.control.ACell.extend("sas.risk.common.widgets.spreadsheet.control.DropdownCell",{
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.common.widgets.spreadsheet.control.DropdownCell.prototype.createEditControl=function(){
	var value=this.cellInfo.getValue();
	var that=this;
	this.select=new sas.hc.m.Select({
		change:function(){
			that.storeNewValue();
			that.refreshViewControl();
		}
	}).addStyleClass("riskSpreadsheetSelectCell");
	this.select.setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	this.select.addItem(new sas.hc.ui.core.Item({
		key:"",
		text:rb.getText("select.none.selected.txt")
	}));
	_.each(this.cellInfo.getSOptions().choices,function(choice){
		that.select.addItem(new sas.hc.ui.core.Item({
			key:choice.value,
			text:choice.label
		}));
	});
	this.select.setSelectedKey(value);
	return this.select;
};
//API
sas.risk.common.widgets.spreadsheet.control.DropdownCell.prototype.createViewControl=function(){
	return new sas.hc.m.Text({}).addStyleClass("riskSpreadsheetDropdownCellView");
};
sas.risk.common.widgets.spreadsheet.control.DropdownCell.prototype.refreshViewControl=function(){
	var value=this.cellInfo.getValue();
	var match=_.find(this.cellInfo.getSOptions().choices,function(choice){return choice.value===value;});
	var label=match?match.label:"";
	this.viewControl.setText(label);
};
//VALUE MANAGEMENT
sas.risk.common.widgets.spreadsheet.control.DropdownCell.prototype.getNewValue=function(){
	var value=this.editControl.getSelectedKey();
	return value;
};
//NAVIGATION
sas.risk.common.widgets.spreadsheet.control.DropdownCell.prototype.handleKeydown=function(event){
	switch(event.keyCode){
		case jQuery.sap.KeyCodes.ARROW_UP:
		case jQuery.sap.KeyCodes.ARROW_DOWN:
			if(this.select.isOpen()){
				return;//let the select widget handle it
			}
			event.preventDefault();
			event.stopImmediatePropagation();
		default:
			sas.risk.common.widgets.spreadsheet.control.ACell.prototype.handleKeydown.apply(this,arguments);
	}
};