jQuery.sap.require("sas.risk.common.layout.gridlayout.GridLayout");
jQuery.sap.require("sap.ui.model.json.JSONModel");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
jQuery.sap.require("sas.hc.ui.commons.dualselector.DualSelector");

sap.ui.jsview("sas.risk.common.widgets.spreadsheet.control.DualSelectorDialog", {
	getControllerName : function() {
		return "sas.risk.common.widgets.spreadsheet.control.DualSelectorDialog";
	},
	createContent : function(controller) {
		var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	   var that=this;
	   var viewData=this.getViewData();
	   this.createButtons(controller);
 		this.compAvailableModel=new sap.ui.model.json.JSONModel();
	   this.dual=new sas.hc.ui.commons.dualselector.DualSelector({
	   	responsive:false,
	   	contextPath:"/values",
	   	labelField:"label",
	   	dualSelectorCreationComplete:function(){
	   		that.syncWidget();
	   	}
	   });
	   this.dual.setModel(this.compAvailableModel);
	   return this.dual;
	},
	syncWidget:function(){
		var choicesModel=this.getModel("choose");
		var values=choicesModel.getProperty("/choices");
		var value=choicesModel.getProperty("/values");
		var available=_.filter(values,function(valueLabel){
			return !value||value.indexOf(valueLabel.value)===-1;
		});
		var selected=_.filter(values,function(valueLabel){
			return value&&value.indexOf(valueLabel.value)!==-1;
		});
		selected=_.sortBy(selected,function(valueLabel){
			return value.indexOf(valueLabel.value);
		});
		this.compAvailableModel.setProperty("/values",available);
		this.dual.getTargetList().getModel().setProperty("/itemList",selected);
	},
	createButtons : function(controller) {
		var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	   this.okButton=new sas.risk.common.widgets.Button({
			text:rb.getText("spreadsheet.cell.dialog.button.ok.txt"),
			press:$.proxy(controller.actionOk,controller)
		});
	   this.okButton.addStyleClass("sasPrimaryButton");
		this.cancelButton=new sas.risk.common.widgets.Button({
			text:rb.getText("spreadsheet.cell.dialog.button.cancel.txt"),
			press:$.proxy(controller.actionCancel,controller)
		});
	},
	getDialogSettings : function() {
		return {
         contentWidth:"50%",
         beginButton: this.okButton,
         endButton: this.cancelButton,
         initialFocus: this.dual
		};
	}
});
sap.ui.controller("sas.risk.common.widgets.spreadsheet.control.DualSelectorDialog", {
	onInit:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		var model=this.createModel();
		view.setModel(model,"choose");
	},
	actionOk:function(){
		var view=this.getView();
		view.getDialog().close();
		var selectedValues=view.dual.getTargetList().getModel().getProperty("/itemList");
		view.fireClosing({
			isOk:true,
			value:_.pluck(selectedValues,"value")
		});
	},
	actionCancel:function(){
		var view=this.getView();
		view.getDialog().close();
		view.fireClosing({
			isOk:false
		});
	},
	createModel: function(meta){
		var view=this.getView();
		var viewData=view.getViewData();
		var data={choices:[]};
		if(viewData.choices && viewData.choices.length){
			data.choices=$.extend(true,{},viewData.choices);
		}
		if(viewData.value && viewData.value.length){
			data.values=viewData.value;
		}
		return new sap.ui.model.json.JSONModel(data);
	}
});