jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.validator.RangeCellValidator");
jQuery.sap.require("sas.hc.m.RangeValidationAdapter");

//This validator doesn't perform any validatation and always shows an error when one is shown.

sas.hc.m.RangeValidationAdapter.extend("sas.risk.common.widgets.spreadsheet.control.validator.RangeCellValidator",{
	metadata:{
		properties:{
			validatorOptions:{type: "any"},
			errorState: {type: "any"},
            errorText:{type:"string"},//localized error message
			cell: {type: "any"}
		}
	},
	constructor: function() {
		sas.hc.m.RangeValidationAdapter.apply(this, arguments);

		if(this.getValidatorOptions()) {
			//if no errorText is passed in the constructor check for it in validatorOptions and set
			if(!this.getErrorText() && this.getValidatorOptions().errorText){
				this.setErrorText(this.getValidatorOptions().errorText);
            }

            if(!this.getMinValue() && this.getValidatorOptions().minValue){
				this.setMinValue(this.getValidatorOptions().minValue);
            }
            if(!this.getMaxValue() && this.getValidatorOptions().maxValue){
				this.setMaxValue(this.getValidatorOptions().maxValue);
            }

			//takes errorType string and converts to sap valuestate object
			var errorType = this.getErrorState() || (this.getValidatorOptions().forceState && this.getValidatorOptions().errorState) || "";
			errorType = errorType.toUpperCase();
			switch(errorType){
				case "INFO" || "INFORMATION":
					this.setErrorState(sap.ui.core.ValueState.Information);
					break;
				case "NONE":
					this.setErrorState(sap.ui.core.ValueState.None);
					break;
				case "SUCCESS":
					this.setErrorState(sap.ui.core.ValueState.Success);
					break;
				case "WARNING":
					this.setErrorState(sap.ui.core.ValueState.Warning);
					break;
				default:
					this.setErrorState(sap.ui.core.ValueState.Error);
			}	
		}

	}
});


sas.risk.common.widgets.spreadsheet.control.validator.RangeCellValidator.prototype.numericLiveValidation = function(sValue, allowIntegersOnly, enableGroupingSeparator){
	var result = sas.hc.m.InputValidationAdapter.prototype.numericLiveValidation.apply(this, arguments);
	return this.processValidationResult(sValue, result);
};
sas.risk.common.widgets.spreadsheet.control.validator.RangeCellValidator.prototype.numericValidation = function(sValue, allowIntegersOnly, enableGroupingSeparator){
	var result = sas.hc.m.InputValidationAdapter.prototype.numericLiveValidation.apply(this, arguments);
	var validation = this.processValidationResult(sValue, result);

	if(this.getCell() && validation){
		if(this.getErrorText()) {
			this.getCell().setErrorText(this.getErrorText());
		}
		this.getCell().setErrorState(validation.valueType);
		this.getCell().invalidateParent();
	}
	return validation;
};