jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory");

sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory=function(){
	this.registry={};
	this.cache={};
};
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.prototype={
	register:function(type,klassName){
		this.registry[type]=klassName;
	},
	request:function(type, options, cell){
		var typeCache=this.cache[type];
		if(typeCache && typeCache.length){
			return typeCache.pop();
		}else{
			var klassName=this.registry[type];
			if(!klassName){
				return null;
			}
			jQuery.sap.require(klassName);
			var klass=sap.ui.require(klassName.replace(/\./g, "/"));
			sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.counter++;
			return new klass({validatorOptions: options, cell: cell});
		}
	}
};
//STATICS
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.counter=0;
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory._instance=new sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory();
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.getInstance=function(){
	return sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory._instance;
};

sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.getInstance().register("regex","sas.risk.common.widgets.spreadsheet.control.validator.RegexCellValidator");
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.getInstance().register("error","sas.risk.common.widgets.spreadsheet.control.validator.ErrorMessageValidator");
sas.risk.common.widgets.spreadsheet.control.validator.SpreadsheetValidatorFactory.getInstance().register("range","sas.risk.common.widgets.spreadsheet.control.validator.RangeCellValidator");