jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.filter.AFilter");

sas.risk.common.widgets.spreadsheet.filter.AFilter=function(name,operator,value,nameLabel,valueLabel){
	this.name=name;
	this.operator=operator;
	this.value=value;
	this.nameLabel=nameLabel;
	this.valueLabel=valueLabel;
};
sas.risk.common.widgets.spreadsheet.filter.AFilter.prototype={
	getName:function(){
		return this.name;
	},
	getOperator:function(){
		return this.operator;
	},
	setOperator:function(operator){
		this.operator=operator;
	},
	getValue:function(){
		return this.value;
	},
	setNameLabel:function(nameLabel){
		this.nameLabel=nameLabel;
	},
	getNameLabel:function(){
		return this.nameLabel;
	},
	setValue:function(value){
		this.value=value;
	},
	setValueLabel:function(valueLabel){
		this.valueLabel=valueLabel;
	},
	getValueLabel:function(){
		return this.valueLabel;
	},
	equals:function(other){
		return !!other&&(this.toString()===other.toString());
	},
	clone:function(){
		var klass=this.getType();
		var filter=new klass(this.name,this.operator,this.value,this.nameLabel,this.valueLabel);
		if(filter.isAdvancedFilter){filter.isAdvancedFilter=true;}
		return filter;
	},
	evaluate:function(valuesCallbackFn){
		var val=valuesCallbackFn(this.name); //work with the actual value
		if(val===undefined || val===null){return false;}//no value --> no match
		var match=val.toString().toUpperCase().trim() === this.value.toString().toUpperCase().trim();
		return match;
	},
	toJson:function(){
		return {
			name:this.name,
			operator:this.operator,
			value:this.formatValue(),
			type:this.getTypeName()
		};
	},
	toString:function(){
      return this.operator+"("+this.name+","+this.formatValue()+")";
	},
	toArray:function(){
		return [this];
	},
	findByName:function(name){
		return name===this.name?[this]:undefined;
	},
	formatValue:function(){
		return this.value;
	},
	getTypeName:function(){},
	getType:function(){}
};
sas.risk.common.widgets.spreadsheet.filter.AFilter.hydrate=function(json){
	if(!json){return null;}
	var type=sas.risk.common.widgets.spreadsheet.filter.AFilter.getFilterType(json.type)||json.type;
	jQuery.sap.require(type);
	var klass=sap.ui.require(type.replace(/\./g, "/"));
	return klass.hydrate(json);
};
//SINGLETON
sas.risk.common.widgets.spreadsheet.filter.AFilter._registry={
		string:"sas.risk.common.widgets.spreadsheet.filter.StringFilter",
		number:"sas.risk.common.widgets.spreadsheet.filter.NumberFilter",
		boolean:"sas.risk.common.widgets.spreadsheet.filter.BooleanFilter",
		and:"sas.risk.common.widgets.spreadsheet.filter.AndFilter",
		or:"sas.risk.common.widgets.spreadsheet.filter.OrFilter",
		date:"sas.risk.common.widgets.spreadsheet.filter.DateFilter",
		timestamp:"sas.risk.common.widgets.spreadsheet.filter.TimestampFilter",
		value:"sas.risk.common.widgets.spreadsheet.filter.ValueFilter"
};
sas.risk.common.widgets.spreadsheet.filter.AFilter.registerFilterType=function(alias,klassName){
	sas.risk.common.widgets.spreadsheet.filter.AFilter._registry[alias]=klassName;
};
sas.risk.common.widgets.spreadsheet.filter.AFilter.getFilterType=function(alias){
	return sas.risk.common.widgets.spreadsheet.filter.AFilter._registry[alias];
};