jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter");

sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter=function(filters,name){
	this.filters=filters||[];
	this.name=name;
};
sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.prototype={
	toString:function(){
		if(!this.filters.length)
			return "";
		if(this.filters.length===1)
			return this.filters[0].toString();
		return this.name+"("+this.filters.join(",")+")";
	},
	equals:function(other){
		if(other instanceof sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter && this.name===other.name){
			return this.filters.length===other.filters.length && _.every(this.filters,function(f){
				return !!_.find(other.filters,function(of){
					return of.equals(f);
				});
			});
		}
		return false;
	},
	clone:function(){
		var cFilters=[];
		for(var i=0;i<this.filters.length;i++){
			cFilters.push(this.filters[i].clone());
		}
		return this._createNew(cFilters);
	},
	_createNew:function(filters){},//ABSTRACT
	addFilter:function(filter){
		if(filter){
			this.filters.push(filter);
		}
	},
	getChildren:function(){
		return this.filters;
	},
	hasChildren:function(){
		return this.getChildren().length > 0;
	},
	findByName:function(name){
		return _.reduce(this.filters,function(results,filter){
			var result=filter.findByName(name);
			if(result){
				return results.concat(result);
			}
			return results;
		},[]);
	},
	evaluate:function(rowData,columnMeta){},//ABSTRACT
	toArray:function(){
		return _.reduce(this.filters,function(results,filter){
			var result=filter.toArray();
			if(result){
				return results.concat(result);
			}
			return results;
		},[]);
	},
	toJson:function(){//OVERRIDE
		var json={
			children:[],
		};
		for(var i=0;i<this.filters.length;i++){
			json.children.push(this.filters[i].toJson());
		}
		return json;
	}
};