jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.filter.AndFilter");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter");

sas.risk.common.widgets.spreadsheet.filter.AndFilter=function(filters){
	sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.call(this,filters,"and");
	this.type="sas.risk.common.widgets.spreadsheet.filter.AndFilter";
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype=Object.create(sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.prototype);

sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype._createNew=function(filters){
	return new sas.risk.common.widgets.spreadsheet.filter.AndFilter(filters);
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype.evaluate=function(valuesCallbackFn){
	var i, children=this.getChildren(), match=true;
	for(i=0; i<children.length; i++){
		var filter=children[i];
		match=match && filter.evaluate(valuesCallbackFn);
		if(!match){
			return false;
		}
	}
	return match;
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype.getTypeName=function(){
	return "and";
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype.getType=function(){
	return sas.risk.common.widgets.spreadsheet.filter.AndFilter;
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.prototype.toJson=function(){
	var json=sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.prototype.toJson.apply(this,arguments);
	json.type=this.getTypeName();
	return json;
};
sas.risk.common.widgets.spreadsheet.filter.AndFilter.hydrate=function(j){
	var and=new sas.risk.common.widgets.spreadsheet.filter.AndFilter();
	var arrayOfChildren=j.children||j.filters||[];
	for(var i=0;i<arrayOfChildren.length;i++){
		and.addFilter(sas.risk.common.widgets.spreadsheet.filter.AFilter.hydrate(arrayOfChildren[i]));
	}
	return and;
};