jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.filter.OrFilter");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter");

sas.risk.common.widgets.spreadsheet.filter.OrFilter=function(filters){
	sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.call(this,filters,"or");
	this.type="sas.risk.common.widgets.spreadsheet.filter.OrFilter";
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype=Object.create(sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.prototype);

sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype._createNew=function(filters){
	return new sas.risk.common.widgets.spreadsheet.filter.OrFilter(filters);
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype.evaluate=function(valuesCallbackFn){
	var i, children=this.getChildren(), match=false;
	for(i=0; i<children.length; i++){
		var filter=children[i];
		match=match || filter.evaluate(valuesCallbackFn);
		if(match){
			return true;
		}
	}
	return match;
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype.getTypeName=function(){
	return "or";
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype.getType=function(){
	return sas.risk.common.widgets.spreadsheet.filter.OrFilter;
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.prototype.toJson=function(){
	var json=sas.risk.common.widgets.spreadsheet.filter.AJunctionFilter.prototype.toJson.apply(this,arguments);
	json.type=this.getTypeName();
	return json;
};
sas.risk.common.widgets.spreadsheet.filter.OrFilter.hydrate=function(j){
	var or=new sas.risk.common.widgets.spreadsheet.filter.OrFilter();
	var arrayOfChildren=j.children||j.filters||[];
	for(var i=0;i<arrayOfChildren.length;i++){
		or.addFilter(sas.risk.common.widgets.spreadsheet.filter.AFilter.hydrate(arrayOfChildren[i]));
	}
	return or;
};