jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.filter.StringFilter");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.AFilter");

sas.risk.common.widgets.spreadsheet.filter.StringFilter=function(name,operator,value,nameLabel,valueLabel){
	sas.risk.common.widgets.spreadsheet.filter.AFilter.apply(this,arguments);
	this.caseSensitive=false;
	this.type="sas.risk.common.widgets.spreadsheet.filter.StringFilter";
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype=Object.create(sas.risk.common.widgets.spreadsheet.filter.AFilter.prototype);

sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.toString=function(){
   if(this.operator==="contains"){
   	return this.operator+"("+(this.caseSensitive?"":"$primary,")+this.name+","+this.formatValue()+")";
   }else if(this.operator==="notContains"){
   	return "not"+"(contains"+"("+(this.caseSensitive?"":"$primary,")+this.name+","+this.formatValue()+")"+")";
   }
   else{
   	return sas.risk.common.widgets.spreadsheet.filter.AFilter.prototype.toString.apply(this,arguments);
   }
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.evaluate=function(valuesCallbackFn){
	if(this.operator==="contains"){
		var val=valuesCallbackFn(this.name);//this may need tweaking if there is a diff between display value and actual value
		if(val===undefined || val===null){return false;}//no value --> no match
		return val.toString().toUpperCase().trim().indexOf(this.value.toString().toUpperCase().trim())>-1;
	}else if(this.operator==="notContains"){
		var val=valuesCallbackFn(this.name);//this may need tweaking if there is a diff between display value and actual value
		if(val===undefined || val===null){return false;}//no value --> no match
		return val.toString().toUpperCase().trim().indexOf(this.value.toString().toUpperCase().trim())===-1;
	}else{
		return sas.risk.common.widgets.spreadsheet.filter.AFilter.prototype.evaluate.apply(this,arguments);
	}
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.setCaseSensitive=function(caseSensitive){
	this.caseSensitive=caseSensitive;
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.getTypeName=function(){
	return "string";
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.getType=function(){
	return sas.risk.common.widgets.spreadsheet.filter.StringFilter;
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.prototype.formatValue=function(){
	var val = "" + this.value;
	val = val.replace(/'/g,"''");
	return "'"+val+"'";
};
sas.risk.common.widgets.spreadsheet.filter.StringFilter.hydrate=function(j){
	return new sas.risk.common.widgets.spreadsheet.filter.StringFilter(j.name,j.operator,j.value&&j.value.replace(/^[']+(.*)[']+$/,"$1"));
};