jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.formula.Lexer");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.Token");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.TokenType");

sas.risk.common.widgets.spreadsheet.formula.Lexer=function(text){
		this.index=0;
		this.text=text||"";
		if(!_.isString(this.text)&&this.text.toString){
			this.text=this.text.toString();
		}
		this.textLength=this.text.length;
};
sas.risk.common.widgets.spreadsheet.formula.Lexer.prototype={
		init:function(){
			this.punctuators={};
			var that=this;
			$.each(sas.risk.common.widgets.spreadsheet.formula.TokenType.values(),function(idx,tokenType){
				if(tokenType.punctuator){
					that.punctuators[tokenType.punctuator]=tokenType;
				}
			});
			this.RECOGNIZED_CHAR_REGEX=/[\w.$'"!:%@|]/i;
		},
		next:function(){
			var inQuote=false;
			while(this.index<this.textLength){
				var c=this.text[this.index++];
				var tokenType=this.punctuators[c];
				if(tokenType){
					switch(tokenType){
						case sas.risk.common.widgets.spreadsheet.formula.TokenType.LESS_THAN:
						case sas.risk.common.widgets.spreadsheet.formula.TokenType.GREATER_THAN:
							if(this.index<this.textLength){
								var cc=c+this.text[this.index];
								if(this.punctuators[cc]){
									this.index++;
									return new sas.risk.common.widgets.spreadsheet.formula.Token(this.punctuators[cc],cc);
								}
							}
					}
					return new sas.risk.common.widgets.spreadsheet.formula.Token(this.punctuators[c],c);
				} else if (this._isRecognizedChar(c)) {
					var start=this.index-1;
					// fixes S1270023
					//	if the string contains ONLY spaces continue to read further
					if (/^\s+$/.test(c)){
						continue;
					}
					inQuote=(c==='"'||c==="'");
					while(this.index<this.text.length){
						var c2=this.text[this.index];
						inQuote=((inQuote && c2!==c) || (!inQuote && (c2==='"'||c2==="'")));
						if(!inQuote && !this._isRecognizedChar(c2)){
							break;
						}
						this.index++;
					}
					while(this.text[this.index-1]==='!' || this.text[this.index-1]==='%'){
						this.index--;//NAME cannot end in ! or %,backtrack 1.
					}
					var name=this.text.substring(start,this.index);
					return new sas.risk.common.widgets.spreadsheet.formula.Token(sas.risk.common.widgets.spreadsheet.formula.TokenType.NAME,name);
				} else {
					//ignore all other characters (whitespace, etc)
				}
			}
			return new sas.risk.common.widgets.spreadsheet.formula.Token(sas.risk.common.widgets.spreadsheet.formula.TokenType.EOF,'');
		},
		_isRecognizedChar:function(str){
			// fixes for S1272410
			if (/^\s+$/.test(str)){
				return true;
			}
			return str.length === 1 &&  this.RECOGNIZED_CHAR_REGEX.test(str);
		}
};
sas.risk.common.widgets.spreadsheet.formula.Lexer.prototype.init();