jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.formula.eval.ComparisonEval");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.TokenType");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil");

sas.risk.common.widgets.spreadsheet.formula.eval.ComparisonEval={
	eval:function(expr,fnContext){
		var def=$.Deferred();
		var leftValueDef=sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil.eval(expr.left,fnContext);
		var rightValueDef=sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil.eval(expr.right,fnContext);
		$.when(leftValueDef,rightValueDef).done(function(leftValue,rightValue){
			if (_.isNumber(leftValue)&&_.isNumber(rightValue)){
				leftValue=sas.risk.common.widgets.spreadsheet.formula.Math.precisionRound(leftValue);
				rightValue=sas.risk.common.widgets.spreadsheet.formula.Math.precisionRound(rightValue);
			}
			switch(expr.comparator){
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.EQUAL.name:
					def.resolve(leftValue===rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.NOT_EQUAL.name:
					def.resolve(leftValue!==rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.GREATER_THAN.name:
					def.resolve(leftValue>rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.GREATER_THAN_EQUAL.name:
					def.resolve(leftValue>=rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.LESS_THAN.name:
					def.resolve(leftValue<rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.LESS_THAN_EQUAL.name:
					def.resolve(leftValue<=rightValue);
					break;
			}
		}).fail(function(error){
			def.reject(error);
		});
		return def;
	}
};