jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.formula.eval.OperatorEval");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.formula.TokenType");

sas.risk.common.widgets.spreadsheet.formula.eval.OperatorEval={
	eval:function(expr,fnContext){
		var def=$.Deferred();
		var leftValueDef=sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil.eval(expr.left,fnContext);
		var rightValueDef=sas.risk.common.widgets.spreadsheet.formula.ExpressionUtil.eval(expr.right,fnContext);
		$.when(leftValueDef,rightValueDef).done(function(leftValue,rightValue){
			if(leftValue===null){
				leftValue=0;
			}
			if(rightValue===null){
				rightValue=0;
			}
			if((!_.isNumber(leftValue) || !_.isNumber(rightValue)) && expr.operator!==sas.risk.common.widgets.spreadsheet.formula.TokenType.PLUS.name){
				def.reject("#VALUE!");
			}/*else{
				leftValue=Number(leftValue);
			 	rightValue=Number(rightValue);
		   }*/
			switch(expr.operator){
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.PLUS.name:
					def.resolve(leftValue+rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.MINUS.name:
					def.resolve(leftValue-rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.ASTERISK.name:
					def.resolve(leftValue*rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.SLASH.name:
					def.resolve(leftValue/rightValue);
					break;
				case sas.risk.common.widgets.spreadsheet.formula.TokenType.CARET.name:
					def.resolve(Math.pow(leftValue,rightValue));
					break;
			}
		}).fail(function(error){
			def.reject(error);
		});
		return def;
	}
};