jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONMixin");
jQuery.sap.require("sas.hc.ui.model.PageableJSONTreeModel");

sas.hc.ui.model.PageableJSONTreeModel.extend("sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel",{
	constructor:function(settings){
		sas.hc.ui.model.PageableJSONTreeModel.apply(this,arguments);
		this._initialize(settings);
	}
});
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONMixin.mixin(sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel);
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel.prototype._requestFromService=function(iStart, iLimit, oHeaders, fnSuccess, fnFail, oBinding){
	var wrappedSuccess=$.proxy(this.wrappedSuccess,this,fnSuccess);
	return sas.hc.ui.model.PageableJSONTreeModel.prototype._requestFromService.call(this,iStart, iLimit, oHeaders, wrappedSuccess, fnFail, oBinding);
};
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel.prototype.loadNodesForPath=function(sDataKey, iStartIndex, iLength, oBinding){
	this.serviceData=this.serviceData||{};
	this.serviceData.parentKeys=this._getParentKeys(sDataKey);
	this.serviceData.arrayNames=this.arrayNames;
	var nodes=sas.hc.ui.model.PageableJSONTreeModel.prototype.loadNodesForPath.apply(this,arguments);
	return nodes;
};
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel.prototype._getParentKeys=function(key){
	var parents=[];
	var prefix="/"+this.getBindId()+"/";
	if(key.indexOf(prefix)===0){
		var chunks=key.substring(prefix.length).split("/");
		while(chunks.length){
			var mTreeData=this._mTreeData[prefix+chunks.join("/")];
			if(mTreeData){//null if entry has no children but binding blindly looking to expand to a level
				parents.unshift(mTreeData.childrenUrl);
			}
			chunks.pop();
		}
	}
	return parents;
};
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel.prototype._getChildrenUrlFromKey=function(key){
	return this._mTreeData[key]?key:null;
};
sas.risk.common.widgets.spreadsheet.model.SpreadsheetPageableJSONTreeModel.prototype.wrappedSuccess=function(fnSuccess, json, textStatus, jqXHR){
	var data=json[this._sItemsProperty];
	this._fillUpDataCache(data);
	return fnSuccess(json, textStatus, jqXHR);
};