jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction");

sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction",{
   constructor:function(settings){
      sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.apply(this,arguments);
      this.setEnabled(false);
   },
   renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.setSpreadsheet=function(spreadsheet){
   sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.prototype.setSpreadsheet.apply(this,arguments);
   spreadsheet.attachPostFetchData($.proxy(this.onPostFetchData,this));
};
sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.onPostFetchData=function(){
   var spreadsheet=this.getSpreadsheet();
   var table=spreadsheet.getSelectedSheetTable();
   table.setSelectedIndex();
   this.setEnabled(false);
};
sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.onSelectionChange=function(){
   var table=this.getSpreadsheet().getSelectedSheetTable();
   var indices=table.getSelectedIndices();
   var count=indices.length;
   this.setEnabled(count>=1);
};
sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.onPress=function(){
   var spreadsheet=this.getSpreadsheet();
   var sheetId=spreadsheet.getSelectedSheetId();
   var table=spreadsheet.getSelectedSheetTable();
   var model=table.getModel(sheetId);
   var dataKey=model.getDataKey();
   var items=model.getData().items;
   var size=items.length;
   var indices=$.extend([],table.getSelectedIndices());
   indices=this.processIndices(indices,size);
   var items2=model.service.data.items;
   var size2=items2.length;
   var indices2=_.map(indices,function(index){
      var found=_.find(items2,function(item){return item[dataKey]===items[index][dataKey];});
      return _.indexOf(items2,found);
   });
   var that=this;
   _.each(indices,function(index,i){//takes care of the visual
      var newIndex=that.calculateNewIndex(index,size,i);
      if(newIndex!==index){
         items.splice(newIndex,0,items.splice(index,1)[0]);
         table.addSelectionInterval(newIndex,newIndex);
         table.removeSelectionInterval(index,index);
      }
   });
   _.each(indices2,function(index,i){//takes care of the data
      var newIndex=that.calculateNewIndex(index,size2,i);
      if(newIndex!==index){
         items2.splice(newIndex,0,items2.splice(index,1)[0]);
      }
   });
   model.checkUpdate();
   model.fireChange({action:'reorder'});
};