jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction");
jQuery.sap.require("sas.risk.common.utils.DialogManager");

sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton",{
	constructor:function(settings){
		sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.apply(this,arguments);
		this.setEnabled(true);
		this.setIcon(sas.icons.HC.ADDITEM);
		settings.toolbar2.addItem(this);
		this.viewData=settings.viewData;
	},
	renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton.prototype.onPress=function(){
	sas.risk.common.utils.DialogManager.open(
			this.getDialogName(),
			this.viewData,
			this.onCloseDialog,
			this);
};
sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton.prototype.getDialogName=function(){
	return "sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialog";
};
sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton.prototype.onCloseDialog=function(e){
	var rows=e.getParameter("rows");
	this.mungeRows(rows);
};
sas.risk.common.widgets.spreadsheet.toolbar.AddItemButton.prototype.mungeRows=function(rows){
	//munge rows here
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var table=spreadsheet.getSelectedSheetTable();
	var model=table.getModel(sheetId);
	var persistToModel=this.viewData.persistToModel;
	var data=model.service.data.items;
	var dataKey=spreadsheet.getDataKey()[sheetId]||"key";
	var splicedSome=false;
	_.each(rows,function(newRow){
		if(persistToModel){
			var found=_.find(data,function(r){
				return r[dataKey]===newRow[dataKey];
			});
			if(!found){
				data.splice(data.length,0,newRow);
				splicedSome=true;
			}
		}else{
			model.service.addDraftRow(newRow);
		}
	});
	if(persistToModel){
		model.service.count=data.length;
		if(splicedSome){
			model.fireChange({action:'add_draft'});
		}
	}
	table.setBusyIndicatorDelay(0);
	table.setBusy(true);
	spreadsheet.fetchData(sheetId);
};