jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogController");

sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogController=function(){};
sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogController.prototype={
	onInit:function(){
		var view=this.getView();
		this.loadMeta().done(function(meta){
			view.spreadsheet.setMeta(meta);
			view.spreadsheet.setVisible(true);
			view.getDialog().setBusy(false);
		});
	},
	loadMeta:function(){
		var view=this.getView();
		var def=$.Deferred();
		if(view.metaUrl instanceof sas.risk.common.widgets.spreadsheet.Spreadsheet){
			setTimeout(function(){
				//take meta from parent spreadsheet and clone it
				var metaJson=view.metaUrl.getMeta()[0].meta.toJson();
				var cloneMeta=sas.ui.cpb3.components.SpreadsheetComponent._parseMeta(metaJson);
				def.resolve(cloneMeta);	
			},0);
		}else{
			$.getJSON(view.metaUrl).done(function(metas){
				var meta=sas.ui.cpb3.components.SpreadsheetComponent._parseMeta(metas);
				meta[0].meta.getTableOptions()["selectionMode"]="MultiToggle";
				def.resolve(meta);
			});
		}
		return def;
	},
	actionOk:function(){
		var view=this.getView();
		var payload={rows:[]};
		var table=view.spreadsheet.getSelectedSheetTable();
		_.each(table.getSelectedIndices(),function(index){
			payload.rows.push(table.getContextByIndex(index).getObject());
		});
		view.fireClosing(payload);
		view.getDialog().close();
	},
	actionCancel:function(){
		this.getView().getDialog().close();
	}
};