jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogView");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.Spreadsheet");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");

sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogView=function(controllerName){
	this.controllerName=controllerName||"sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialog";
};
sas.risk.common.widgets.spreadsheet.toolbar.AddItemDialogView.prototype={
	getControllerName : function() {
		return this.controllerName;
	},
	createContent : function(controller) {
		var viewData=this.getViewData();
		this.metaUrl=viewData.metaUrl;
		this.createButtons(controller);
		this.spreadsheet=this.createSpreadsheet();
      this.layout=this.createLayout(this.createPieces(this.spreadsheet));
      return this.layout;
	},
	createButtons : function(controller) {
	   var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	   this.okButton=new sas.risk.common.widgets.Button({
			text:rb.getText("comment.add.dialog.ok.txt"),
			enabled:false,
			press:$.proxy(controller.actionOk,controller)
		});
	   this.okButton.addStyleClass("sasPrimaryButton");
		this.cancelButton=new sas.risk.common.widgets.Button({
			text:rb.getText("comment.add.dialog.cancel.txt"),
			press:$.proxy(controller.actionCancel,controller)
		});
	},
	getDialogSettings : function() {
		var dialog=this.getDialog();
		dialog.setBusyIndicatorDelay(0);
		dialog.setBusy(true);
		return {
			beginButton : this.okButton,
			endButton : this.cancelButton,
			contentWidth:"80%"
		};
	},
	createLayout:function(pieces){
		if(pieces.menu.getItems().length){
			pieces.toolbar2.addItem(new sas.hc.m.MenuButton({
				icon:sas.icons.HC.OVERFLOW,
				menu:pieces.menu
			}));
		}
		var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
			alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Stretch,
			items:[pieces.toolbar1,pieces.toolbar2,pieces.spreadsheet,pieces.footer]
		}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
			alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.Stretch
		}));
		return layout;
	},
	createSpreadsheet:function(){
		var that=this;
		var settings=$.extend({
			visible:false,
			rowSelectionChange:function(e){
				var spreadsheet=e.getSource();
				var indices=spreadsheet.getSelectedSheetTable().getSelectedIndices();
				that.okButton.setEnabled(!!indices.length);
			}
		},this.getViewData().spreadsheet);
		return new sas.risk.common.widgets.spreadsheet.Spreadsheet(settings);
	},
	createPieces:function(spreadsheet){
		var toolbar1=new sas.risk.common.layout.flexlayout.FlexLayout({}).addStyleClass("riskSpreadsheetToolbar");
		var toolbar2=new sas.risk.common.layout.flexlayout.FlexLayout({}).addStyleClass("riskSpreadsheetToolbar");
		jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.BroadSearch");
		toolbar2.addItem(new sas.risk.common.widgets.spreadsheet.toolbar.BroadSearch({spreadsheet:spreadsheet}));
		var footer=new sas.risk.common.layout.flexlayout.FlexLayout({}).addStyleClass("riskSpreadsheetToolbar");
		var menu=new sas.hc.m.Menu();
		return {spreadsheet:spreadsheet,toolbar1:toolbar1,toolbar2:toolbar2,footer:footer,menu:menu};
	}
};
