jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction");

sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton",{
	constructor:function(){
		sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.apply(this,arguments);
		this.setEnabled(true);
		this.setIcon(sas.icons.HC.ADDROW);
	},
	renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.prototype.onPress=function(){
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var table=spreadsheet.getSelectedSheetTable();
	var model=table.getModel(sheetId);
	var newRow={};
	newRow[model.dataKey]=sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.generateID();
	var columns = table.getColumns();
	_.each(columns, function(column){
		newRow[column.getName()]= column.getDataDefault() ? column.getDataDefault() : "";
	});
	model.service.addDraftRow(newRow);
	
	table.setFirstVisibleRow(0);
	table.setBusyIndicatorDelay(0);
	table.setBusy(true);
	spreadsheet.fetchData(sheetId);
};
sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.ALPHABET = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.ID_LENGTH = 8;
sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.generateID = function() {
  var rtn = '_draft_';
  for (var i = 0; i < sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.ID_LENGTH; i++) {
    rtn += sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.ALPHABET.charAt(Math.floor(Math.random() * sas.risk.common.widgets.spreadsheet.toolbar.AddRowButton.ALPHABET.length));
  }
  return rtn;
};