jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.Busy");

sas.risk.common.widgets.spreadsheet.toolbar.Busy=function(spreadsheet){
	this.spreadsheet=spreadsheet;
	this.spreadsheet.attachPreFetchData($.proxy(this.onPreFetchData,this));
	this.spreadsheet.attachPostMetaChange($.proxy(this.onPostMetaChange,this));
	this.onDataLoadedFn=$.proxy(this.onDataLoaded,this);
	this.onPreFetchData=$.proxy(this.onPreFetchData, this);
};
sas.risk.common.widgets.spreadsheet.toolbar.Busy.prototype={
	onPostMetaChange:function(event){
		this.spreadsheet.getSelectedSheetTable().setBusy(true);
		var that=this;
		_.each(this.spreadsheet.getSheetTables(),function(table){
			var sheetId=table.data("sheetId");
			var service=table.getModel(sheetId).getService();
			service.detachLoaded(that.onDataLoadedFn);
			service.attachLoaded(that.onDataLoadedFn);
			service.detachLoading(that.onPreFetchData);
			service.attachLoading(that.onPreFetchData);
		});
	},
	onDataLoaded:function(event){
		this.spreadsheet.getSelectedSheetTable().setBusy(false);
	},
	onPreFetchData:function(event){
		this.spreadsheet.getSelectedSheetTable().setBusyIndicatorDelay(1000);
		this.spreadsheet.getSelectedSheetTable().setBusy(true);
	}
};