jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction");

sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton",{
	constructor:function(){
		sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.apply(this,arguments);
		this.setEnabled(false);
		this.setIcon(sas.icons.HC.DELETE);
	},
	renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.onSelectionChange=function(){
	var table=this.getSpreadsheet().getSelectedSheetTable();
	var indices=table.getSelectedIndices();
	var count=indices.length;
	this.setEnabled(count>=1);
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.onPress=function(){
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var dataKey=spreadsheet.getDataKey()[sheetId]||"key";
	var table=spreadsheet.getSelectedSheetTable();
	var indices=table.getSelectedIndices();
	var keys=_.map(indices,function(index){
		var rowData=table.getContextByIndex(index).getObject();
		return rowData[dataKey];
	});
	this.removeRows(keys,table,sheetId);
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.removeRows=function(keys,table,sheetId){
	var model=table.getModel(sheetId);
	model.service.removeRows(keys,this.getDeleteOptions())
		.done($.proxy(this.deleteCallbackSuccess,this))
		.fail($.proxy(this.deleteCallbackFailure,this));
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.getDeleteOptions=function(){
	return {
		getDeleteHeaders: $.proxy(this.getDeleteHeaders,this),
		getDeleteMethod: $.proxy(this.getDeleteMethod,this),
		getDeleteUrl: $.proxy(this.getDeleteUrl,this)
	};
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.deleteCallbackSuccess=function(){
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var table=spreadsheet.getSelectedSheetTable();
	table.setSelectedIndex();
	this.setEnabled(false);

	table.setFirstVisibleRow(0);
	table.setBusyIndicatorDelay(0);
	table.setBusy(true);
	spreadsheet.fetchData(sheetId);
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.deleteCallbackFailure=function(){
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.getDeleteHeaders=function(){
	return {
		Accept: "application/json; charset=UTF-8",
		"Content-Type": "application/json; charset=UTF-8"
	};	
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.getDeleteMethod=function(){
	return "DELETE";
};
sas.risk.common.widgets.spreadsheet.toolbar.DeleteButton.prototype.getDeleteUrl=function(){
	return this.getSpreadsheet().getDataUrl();
};