jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction");

sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton",{
   constructor:function(settings){
      sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.apply(this,arguments);
      this.setIcon(sas.icons.HC.ARROWSMALLDOWN);
   },
   renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton.prototype.onSelectionChange=function(){
   var table=this.getSpreadsheet().getSelectedSheetTable();
   var sheetId=this.getSpreadsheet().getSelectedSheetId();
   var model=table.getModel(sheetId);
   if(model.getData().items.length===model.service.allRows().length){//no filtering
      sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.onSelectionChange.apply(this,arguments);
   }else{
      this.setEnabled(false);
   }
};
sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton.prototype.processIndices = function(indices,size){
   indices.sort(function(a,b){return b-a;});//ordering when a-b is 1,2,3 and b-a is 3,2,1
   return _.filter(indices,function(num,i){//skip rows already at the bottom
      return num!==(size-1-i);
   });
};
sas.risk.common.widgets.spreadsheet.toolbar.MoveDownButton.prototype.calculateNewIndex=function(oldIndex,size){
   return Math.min(size-1,oldIndex+1);
};