jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction");

sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton",{
   constructor:function(settings){
      sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.apply(this,arguments);
      this.setIcon(sas.icons.HC.ARROWSMALLUP);
   },
   renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton.prototype.onSelectionChange=function(){
   var table=this.getSpreadsheet().getSelectedSheetTable();
   var sheetId=this.getSpreadsheet().getSelectedSheetId();
   var model=table.getModel(sheetId);
   if(model.getData().items.length===model.service.allRows().length){//no filtering
      sas.risk.common.widgets.spreadsheet.toolbar.AMoveItemAction.prototype.onSelectionChange.apply(this,arguments);
   }else{
      this.setEnabled(false);
   }
};
sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton.prototype.processIndices = function(indices){
   indices.sort(function(a,b){return a-b;});//ordering when a-b is 1,2,3 and b-a is 3,2,1
   return _.filter(indices,function(num,i){//skip rows already at the top
      return num!==i;
   });
};
sas.risk.common.widgets.spreadsheet.toolbar.MoveUpButton.prototype.calculateNewIndex=function(oldIndex){
   return Math.max(0,oldIndex-1);
};