jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.SaveButton");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction");

sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.extend("sas.risk.common.widgets.spreadsheet.toolbar.SaveButton",{
	constructor:function(){
		sas.risk.common.widgets.spreadsheet.toolbar.AButtonAction.apply(this,arguments);
		this.setEnabled(true);
		this.setIcon(sas.icons.HC.SAVE);
		this.successFn=$.proxy(this.saveCallbackSuccess,this);
		this.failureFn=$.proxy(this.saveCallbackFailure,this);
	},
	renderer:"sas.hc.m.ButtonRenderer"
});
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.onPress=function(){
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var table=spreadsheet.getSelectedSheetTable();
	var model=table.getModel(sheetId);
	var patch=model.getPatch();
	if(patch.length){
		var payload=this.processPatch(patch);
		$.ajax({
			headers: this.getSaveHeaders(),
			method: this.getSaveMethod(),
			url: this.getSaveUrl(),
			dataType:"json",
	      data:JSON.stringify(payload)
		}).done(this.successFn).fail(this.failureFn);
	}
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.processPatch=function(patch){
	return patch;
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.saveCallbackSuccess=function(){
	var spreadsheet=this.getSpreadsheet();
	var sheetId=spreadsheet.getSelectedSheetId();
	var table=spreadsheet.getSelectedSheetTable();
	var model=table.getModel(sheetId);
	model.service.clearDrafts();
	
	table.setFirstVisibleRow(0);
	table.setBusyIndicatorDelay(0);
	table.setBusy(true);
	spreadsheet.fetchData(sheetId);
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.saveCallbackFailure=function(){
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.getSaveHeaders=function(){
	return {
		Accept: "application/json; charset=UTF-8",
		"Content-Type": "application/json; charset=UTF-8"
	};	
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.getSaveMethod=function(){
	return "PUT";
};
sas.risk.common.widgets.spreadsheet.toolbar.SaveButton.prototype.getSaveUrl=function(){
	return this.getSpreadsheet().getDataUrl();
};