jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.Totals");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.hc.m.SearchField");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.hc.ui.core.Item");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.filter.StringFilter");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutRenderer");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.common.widgets.spreadsheet.toolbar.Totals",{
	metadata:{
		properties:{
			spreadsheet:{type:"any"},
			toolbar1:{type:"any"},
			toolbar2:{type:"any"},
			footer:{type:"any"},
			menu:{type:"any"},
			spreadsheetToolbarType:{type:"any"}
		}
	},
	constructor:function(){
		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
		this.addStyleClass("riskSpreadsheetTotals");
		this.setAlignItems(sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Center);
		this.onDataLoadedFn=$.proxy(this.onDataLoaded,this);
		this.totalsCache={};
	},
	renderer:sas.risk.common.layout.flexlayout.FlexLayoutRenderer
});
sas.risk.common.widgets.spreadsheet.toolbar.Totals.prototype.setSpreadsheet=function(spreadsheet){
	this.setProperty("spreadsheet",spreadsheet);
	spreadsheet.attachPreFetchData($.proxy(this.onPreFetchData,this));
	spreadsheet.attachPostMetaChange($.proxy(this.onPostMetaChange,this));
	spreadsheet.attachSelect($.proxy(this.onSelect,this));
};
sas.risk.common.widgets.spreadsheet.toolbar.Totals.prototype.onPostMetaChange=function(event){
	if(!this.text){
		this.text=new sas.hc.m.Text();
		this.addItem(this.text);
	}
	var that=this;
	_.each(this.getSpreadsheet().getSheetTables(),function(table){
		var sheetId=table.data("sheetId");
		var service=table.getModel(sheetId).getService();
		service.detachLoaded(that.onDataLoadedFn);
		service.attachLoaded(that.onDataLoadedFn);
	});
	var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	this.text.setText(rb.getText("table.footer.totals.loading.txt"));
};
sas.risk.common.widgets.spreadsheet.toolbar.Totals.prototype.onDataLoaded=function(event){
	var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	var count=event.getParameter("count");
	var sheetId=this.getSpreadsheet().getSelectedSheetTable().data("sheetId");
	this.totalsCache[sheetId]=count;
	this.text.setText(rb.getText("table.footer.totals.loaded.fmt.txt",[count]));
};
sas.risk.common.widgets.spreadsheet.toolbar.Totals.prototype.onPreFetchData=function(event){
	var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	this.text.setText(rb.getText("table.footer.totals.loading.txt"));
};
sas.risk.common.widgets.spreadsheet.toolbar.Totals.prototype.onSelect=function(event){
	if(this.text){
		var sheetId=this.getSpreadsheet().getSelectedSheetTable().data("sheetId");
		var count=this.totalsCache[sheetId];
		if(count!==undefined){
			var rb = sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
			this.text.setText(rb.getText("table.footer.totals.loaded.fmt.txt",[count]));
		}else{
			this.text.setText("");
		}
	}
};