jQuery.sap.declare("sas.risk.common.widgets.spreadsheet.toolbar.ZeroState");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");

sas.risk.common.widgets.spreadsheet.toolbar.ZeroState=function(pieces){
	this.spreadsheet=pieces.spreadsheet;
	this.spreadsheet.attachPostFetchData($.proxy(this.onPostFetchData,this));
	this.spreadsheet.attachSelect($.proxy(this.onSelect,this));
};
sas.risk.common.widgets.spreadsheet.toolbar.ZeroState.prototype={
	onSelect:function(event){
		this.processZeroState();
	},
	onPostFetchData:function(event){
		this.processZeroState();
	},
	processZeroState:function(){
		var sheetId=this.spreadsheet.getSelectedSheetId();
		var fetchCriteria=this.spreadsheet.getFetchCriteria()[sheetId];
		var table=this.spreadsheet.getSelectedSheetTable();
		this.refreshZeroState(fetchCriteria,table);
	},
	refreshZeroState:function(fetchCriteria,table){
		var rowBinding=table.getBinding("rows");
		var rowCount=rowBinding?rowBinding.getLength():0;
		if(fetchCriteria.getFilter()){//A FILTER IS SET
			if(!rowCount){
				table.setNoData(this.getNoResultsNoData());
			}
		}else{//NO FILTER
			if(!rowCount){
				table.setNoData(this.getNoFilterNoData());
			}
		}
		return rowCount;
	},
	getNoResultsNoData:function(){
		return sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle().getText("spreadsheet.zerostate.noitems.txt");
	},
	getNoFilterNoData:function(){
		return sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle().getText("spreadsheet.zerostate.noitems.txt");
	}
};