jQuery.sap.declare("sas.risk.common.widgets.windowshade.WindowShadePlus");
jQuery.sap.require("sas.hc.ui.commons.windowshade.WindowShade");
jQuery.sap.require("sas.hc.ui.commons.windowshade.WindowShadeRenderer");

sas.hc.ui.commons.windowshade.WindowShade.extend("sas.risk.common.widgets.windowshade.WindowShadePlus",{
	renderer: sas.hc.ui.commons.windowshade.WindowShadeRenderer
});
/**
 * Activation of the section - Opens or closes a section.
 * This function is called onClick by the mouse, or via ENTER/SPACE keys
 * @param {jQuery.Event} oEvent Browser event
 * @private
 */
sas.risk.common.widgets.windowshade.WindowShadePlus.prototype._checkIfSection = function(oEvent){
    //Click on the windowshade itself are not considered
    var sectionControl, iconParent;


    //Click on the windowshade itself are not considered
    if(oEvent.srcControl.getId() === this.getId() || 
   	 (oEvent.type!=="sapspace" && oEvent.srcControl instanceof sas.risk.common.widgets.windowshade.WindowShadePlusSection)){
        return false;
    }

    //Move up in the DOM to get the section (click occurs on the arrow which is an inner html element)
    var target = jQuery(oEvent.target);

    //Disable the possibility to click on the content to open/close a section
    if(target.hasClass("sasUiWndSectionCont")){
        return false;
    }

    //Clicked on label (part of WindowShadeSection)
    if(oEvent.srcControl instanceof sas.risk.common.widgets.LabelPlus){
   	 sectionControl = oEvent.srcControl.getParent();
    }
    else{
   	 sectionControl = jQuery(oEvent.target).control(0);
    }
    if (sectionControl instanceof sap.ui.core.Icon) {
        // Move up a level from the icon and try again
        iconParent = jQuery(oEvent.target).parent();
        sectionControl = jQuery(iconParent).control(0);
    }

    if (!(sectionControl && sectionControl instanceof sas.hc.ui.commons.windowshade.WindowShadeSection)) {
        return false;
    }

    return sectionControl;
};
