jQuery.sap.declare("sas.risk.common.widgets.windowshade.WindowShadePlusSection2");
jQuery.sap.require("sas.hc.ui.commons.windowshade.WindowShadeSection");
jQuery.sap.require("sas.risk.common.utils.CompositeUtil");
jQuery.sap.require("sas.risk.common.widgets.LabelPlus");

sas.hc.ui.commons.windowshade.WindowShadeSection.extend("sas.risk.common.widgets.windowshade.WindowShadePlusSection2", {
	metadata : {
		properties:{
			text : {type : "string", group : "Misc", defaultValue : null},
			required : {type : "boolean", group : "Misc", defaultValue : false},
			errored:{type:"boolean",defaultValue:false},
			help:{type:"string"}
		},
		aggregations : {
	    	label : {type : "sas.risk.common.widgets.LabelPlus", multiple : false},
		},
		events:{
			click:{enableEventBubbling:true}
		}
	},
	constructor: function(){
		this.label=new sas.risk.common.widgets.LabelPlus().addStyleClass("riskWindowShadeSectionLabel");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"title",this.label,"text");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"errored",this.label,"errored");
		sas.hc.ui.commons.windowshade.WindowShadeSection.apply(this,arguments);
		this.addStyleClass("riskWindowShadeSection");
	},
	renderer:"sas.hc.ui.commons.windowshade.WindowShadeSectionRenderer"
});
sas.risk.common.widgets.windowshade.WindowShadePlusSection2.prototype.init=function(){
	sas.hc.ui.commons.windowshade.WindowShadeSection.prototype.init.apply(this,arguments);
	this.setLabel(this.label);
	this.setAllowTitleEditing(true);
	this.inplaceEdit=this.label;
};
sas.risk.common.widgets.windowshade.WindowShadePlusSection2.prototype.onBeforeRendering=function(){
	var helpPopup=this.getHelpButton();
	var help=this.getHelp();
	if(!helpPopup && help){
		var helpPopup=new sas.risk.common.widgets.HelpPopup({
			content:help
		});
		helpPopup.getEnabled = function(){return true;};
		this.setHelpButton(helpPopup);
	}else if(helpPopup && !help){
		this.destroyHelpButton();
	}
};
/*click through on label to collapse/expand*/
sas.risk.common.widgets.windowshade.WindowShadePlusSection2.prototype.onclick=function(event){
	if(event.target===this.label.getDomRef().children[0]){
		event.target=this.getDomRef();
		this.getParent()._handlePress(event);
	}
};
sas.risk.common.utils.CompositeUtil.mixinPropertySupport(sas.risk.common.widgets.windowshade.WindowShadePlusSection2);
sas.risk.common.utils.CompositeUtil.mixinEventSupport(sas.risk.common.widgets.windowshade.WindowShadePlusSection2);