jQuery.sap.declare("sas.risk.rgf.api.DelegationAPI");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.ui.cpb3.CPBService");

sas.risk.rgf.api.DelegationAPI={
	addDelegation:function(delegateId,startDate,endDate){
		var def = $.Deferred();
		$.ajax({
			type : "POST",
			url : sas.risk.rgf.util.RGFUtil.getRestUrl()+"/delegations",
			contentType : "application/json; charset=UTF-8",
			data : JSON.stringify({delegateId:delegateId,startDate:startDate,endDate:endDate})
		}).done(function(data, textStatus, jqXHR) {
			def.resolve(data);
		}).fail(function(e) {
			sas.risk.rgf.util.RGFUtil.handleFail(e);
			def.reject();
		});
		return def;
	},
	updateDelegation:function(delegationId,delegateId,startDate,endDate){
		var def = $.Deferred();
		$.ajax({
			type : "PUT",
			url : sas.risk.rgf.util.RGFUtil.getRestUrl()+"/delegations" + "/" + delegationId,
			contentType : "application/json; charset=UTF-8",
			data : JSON.stringify({delegateId:delegateId,startDate:startDate,endDate:endDate})
		}).done(function(data, textStatus, jqXHR) {
			def.resolve(data);
		}).fail(function(e) {
			sas.risk.rgf.util.RGFUtil.handleFail(e);
			def.reject();
		});
		return def;
	},
	deleteDelegation:function(delegationId){
		var def = $.Deferred();
		$.ajax({
			type : "DELETE",
			url : sas.risk.rgf.util.RGFUtil.getRestUrl()+"/delegations/" + delegationId
		}).done(function(data, textStatus, jqXHR) {
			def.resolve(data);
		}).fail(function(e) {
			sas.risk.rgf.util.RGFUtil.handleFail(e);
			def.reject();
		});
		return def;
	},
	isDelegationUnique:function(delegationId,delegate,startDate,endDate,serviceId){
		var def = $.Deferred();
		var cpbService=sas.ui.cpb3.CPBService.getInstance(serviceId);
		var expression="isDelegationUnique(delegationId,delegate,startDate,endDate)";
		var data={SCREENID:"ManageDelegations",DELEGATIONID:delegationId,DELEGATE:delegate,STARTDATE:startDate,ENDDATE:endDate};
		cpbService.getCpbAPI().evalExpression(expression,data).done(function(response){
			def.resolve(response.result);
		}).fail(function(e){
			sas.risk.rgf.util.RGFUtil.handleFail(e);
			def.reject();
		});
		return def;
	},
	isDelegationValid:function(delegationId,delegate,startDate,endDate,serviceId,maxTime){
		var def = $.Deferred();
		var cpbService=sas.ui.cpb3.CPBService.getInstance(serviceId);
		var expression="isDelegationValid(delegationId,delegate,startDate,endDate,maxTime)";
		var data={SCREENID:"ManageDelegations",DELEGATIONID:delegationId,DELEGATE:delegate,STARTDATE:startDate,ENDDATE:endDate,MAXTIME:maxTime};
		cpbService.getCpbAPI().evalExpression(expression,data).done(function(response){
			def.resolve(response.result);
		}).fail(function(e){
			sas.risk.rgf.util.RGFUtil.handleFail(e);
			def.reject();
		});
		return def;
	}
};