jQuery.sap.declare("sas.risk.rgf.biz.Dimension");
jQuery.sap.require("sas.risk.rgf.biz.DimensionDefinition");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.slimtable.meta.filter.StringFilter");

sas.risk.rgf.biz.Dimension=function(name,label,alias,rootLabel,isRequired,allowsMultiple,leafOnly,visibleByDefault,primary){
	this.name=name.toLowerCase();
	this.label=label;
	this.alias=alias;
	this.rootLabel=rootLabel;
	this.isRequired = isRequired || primary;
   this.allowsMultiple = allowsMultiple;
   this.leafOnly = leafOnly;
   this.visibleByDefault = visibleByDefault;
   this.primary = primary;
   var def=sas.risk.rgf.biz.DimensionDefinition[name];
   if(def){
   	def.alias=this.alias;
   }
};
sas.risk.rgf.biz.Dimension.prototype={
	getDimName:function(){
		return this.name;
	},
	getDimLabel:function(){
		return this.label;
	},
	getDimRootLabel:function(){
		return this.rootLabel;
	},
	getIsRequired:function(){
		return this.isRequired;
	},
	getLeafOnly:function(){
		return this.leafOnly;
	},
	getAllowsMultiple:function(){
		return this.allowsMultiple;
	},
	equals:function(other){
		return other instanceof sas.risk.rgf.biz.Dimension &&
				 this.name.toLowerCase() === other.name.toLowerCase();
	},
	search:function(searchText,query,securityKey,filter,loadAllAvailable,showInactive){
		var def=$.Deferred();
		var origFilter=query.getQueryFilter("SIMPLE");
		if(origFilter){origFilter=origFilter.clone();}
		if(searchText){
			query.addQueryFilter(new sas.risk.slimtable.meta.filter.StringFilter('localization.name',"contains",searchText),"SIMPLE");
		}
		var that=this;
		sas.risk.rgf.api.DimensionalLocationAPI.searchNodes(this.name,query,securityKey,filter,loadAllAvailable,showInactive).done(function(items,count,start){
			var i,item,node;
			var nodes=[];
			for(i=0;i<items.length;i++){
				item=items[i];
				node=sas.risk.rgf.biz.DimNode.createFromJson(that.name,item);
				sas.risk.rgf.biz.DimNodeRegistry.addToCache(node,securityKey);
				nodes.push(node);
			}
			query.setQueryFilter(origFilter,"SIMPLE");
			def.resolve(nodes,count,start);
   	});
   	return def;
	}
};
//STATICS
sas.risk.rgf.biz.Dimension.getRestURL=function(dimName){
	var dimDef=sas.risk.rgf.biz.DimensionDefinition[dimName.toLowerCase()];
	return sas.risk.rgf.util.RGFUtil.getRestUrl()+"/"+dimDef.url;
};
sas.risk.rgf.biz.Dimension.getOfficialName=function(dimName){
	var dimDef=sas.risk.rgf.biz.DimensionDefinition[dimName.toLowerCase()];
	return dimDef.name;
};
