jQuery.sap.declare("sas.risk.rgf.biz.View");
jQuery.sap.require("sas.risk.rgf.meta.QueryMeta");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.rgf.meta.filter.FilterMetaFactory");

sas.risk.rgf.biz.View=function(key,name,description,columns,
                               sortColumn,sortDirection,sortColumn2,sortDirection2,sortColumn3,sortDirection3,
                               filterSimple,filterAdvanced,dimensionPoints,isDefault,version,sortedColumns){
      
   this.key=key;
   this.name=name;
   this.description=description;
   this.columns=columns;
   this.sortColumn=sortColumn;
   this.sortDirection=sortDirection;
   this.sortColumn2=sortColumn2;
   this.sortDirection2=sortDirection2;
   this.sortColumn3=sortColumn3;
   this.sortDirection3=sortDirection3;
   this.filterSimple=filterSimple;
   this.filterAdvanced=filterAdvanced;
   this.dimensionPoints=dimensionPoints;
   this.isDefault=isDefault;
   this.version=version;
/*    this.sortedColumns = [];

   var self = this;
   var moreSortedColumns = _.filter(columns, function(column) {
      if (column.name === self.sortColumn) { 
         column.sortOrder = 0; 
         column.sortDirection = self.sortDirection; 
         return true;
      } else if (column.name === self.sortColumn2) {
         column.sortOrder = 1; 
         column.sortDirection = self.sortDirection2; 
         return true;
      } else if (column.name === self.sortColumn3){ 
         column.sortOrder = 2; 
         column.sortDirection = self.sortDirection3; 
         return true;
      } else 
         return false;
   });

   _.each(moreSortedColumns, function(c) {
         self.sortedColumns.push(c);
   }); */

   this.queryMeta=sas.risk.rgf.biz.View.createQueryMeta(sortColumn,sortDirection,filterSimple,filterAdvanced,dimensionPoints,columns,sortColumn2,sortDirection2,sortColumn3,sortDirection3);
};
sas.risk.rgf.biz.View.prototype={
	clone:function(){
		var cloneView=new sas.risk.rgf.biz.View(this.getKey(),
				this.getName(),
				this.getDescription(),
				this.getColumns() ? this.getColumns().slice(0) : this.getColumns(),
				this.getSortColumn(),
            this.getSortDirection(),
            this.getSortColumn2(),
            this.getSortDirection2(),
            this.getSortColumn3(),
				this.getSortDirection3(),
				this.getFilterSimple(),
				this.getFilterAdvanced(),
				this.getDimensionPoints() ? this.getDimensionPoints().slice(0) : this.getDimensionPoints(),
				this.getIsDefault(),
            this.getVersion(),
            this.getQueryMeta().getSortedColumns()
            );
		cloneView.setQueryMeta(this.getQueryMeta().clone());
		return cloneView;
	},
   getQueryMeta:function(){
      return this.queryMeta;
   },
   setQueryMeta:function(queryMeta){
   	this.queryMeta=queryMeta;
   },
   getKey:function(){
       return this.key;
   },
   setKey:function(k){
   	this.key=k;
   },
   getName:function(){
      return this.name;
   },
   getDescription:function(){
   	return this.description;
   },
   getColumns:function(){
      return this.columns;
   },
   getSortColumn:function(){
      return this.sortColumn;
   },
   getSortDirection:function(){
      return this.sortDirection;
   },
   getSortColumn2:function(){
      return this.sortColumn2;
   },
   getSortDirection2:function(){
      return this.sortDirection2;
   },
   getSortColumn3:function(){
      return this.sortColumn3;
   },
   getSortDirection3:function(){
      return this.sortDirection3;
   },
   getFilterSimple:function(){
   	return this.filterSimple;
   },
   getFilterAdvanced:function(){
   	return this.filterAdvanced;
   },
   getIsDefault:function(){
      return this.isDefault;
   },
   setIsDefault:function(val){
      this.isDefault=val; 
    },   
   getVersion:function(){
      return this.version;
   },
   getDimensionPoints:function(){
      return this.dimensionPoints;
   },
   getLocation:function(){
   	var qMetaLocPoints=this.getQueryMeta().getLocationPoints();
   	if(!qMetaLocPoints) return null;
   	var loc=qMetaLocPoints.split(",");
   	return loc.length+"|"+loc.join("|")+"|";
   },
   hasField:function(name){
      return this.getcolumnNames().findIndex(function(colName){return colName===name;});
   },
   getColumnNames:function(){
   	var i,colNames=[];
		for(i=0;i<this.columns.length;i++){
			colNames.push(this.columns[i].getColName());
		}
		return colNames;
   },
   setColumns:function(cols){
   	this.columns=cols;
   	this.getQueryMeta().setOrderedColumns(cols);
   },
   equal:function(v){
      return v instanceof sas.risk.rgf.biz.View && v.key===this.key && v.name.toUpperCase()===this.name.toUpperCase();
   },
   toString:function(){
   	var jsonFilterSimple=this.filterSimple?JSON.stringify(this.filterSimple.toJson()):null;
   	var jsonFilterAdvanced=this.filterAdvanced?JSON.stringify(this.filterAdvanced.toJson()):null;
      return JSON.stringify({
         key:this.key,
         name:this.name,
         description:this.description,
         fields: this.getColumnNames(),
         sortColumn: this.sortColumn,
         sortDirection: this.sortDirection,
         sortColumn2: this.sortColumn2,
         sortDirection2: this.sortDirection2,
         sortColumn3: this.sortColumn3,
         sortDirection3: this.sortDirection3,
         default:this.isDefault,
         simpleFilter: jsonFilterSimple,
         advancedFilter: jsonFilterAdvanced,
         dimensionalPoints: this.dimensionPoints
         
     });
   }
}

//STATICS
sas.risk.rgf.biz.View.loadViews=function(viewsJson,tableMeta){
	var def=$.Deferred();
   var views=[];
   var defs=[];
   _.each(viewsJson, function(view){
   	defs.push($.when(sas.risk.rgf.meta.filter.FilterMetaFactory.createFilterFromJson(JSON.parse(view.simpleFilter||null),tableMeta),
   			 sas.risk.rgf.meta.filter.FilterMetaFactory.createFilterFromJson(JSON.parse(view.advancedFilter||null),tableMeta))
		.done(function(filterSimple,filterAdvanced){
         views.push(new sas.risk.rgf.biz.View(view.key,view.name,view.description,tableMeta.getOrderedColumnsByNames(view.fields),
                    view.sortColumn,view.sortDirection,view.sortColumn2,view.sortDirection2,view.sortColumn3,view.sortDirection3,
                    filterSimple,filterAdvanced,
                    view.dimensionalPoints,view.isDefault,view.version,tableMeta.getSortedColumns())
                   );   		
   	}));
   });
   $.when.apply($,defs).done(function(){
      var rb=sas.risk.rgf.util.RGFUtil.getBundle();
      views.unshift(sas.risk.rgf.biz.View.generateBaseView(tableMeta));
      views.push(new sas.risk.rgf.biz.View(-2,rb.getText("table.view.custom.txt")));
      def.resolve(views);
   });
   return def;
};
sas.risk.rgf.biz.View.createQueryMeta=function(sortColumn,sortDirection,filterSimple,filterAdvanced,dimensionPoints,columns,sortColumn2,sortDirection2,sortColumn3,sortDirection3){
   var queryMeta=new sas.risk.rgf.meta.QueryMeta();
   //LOCATION
   if(dimensionPoints){
   	queryMeta.setLocationPoints(dimensionPoints);
   }
   //SORT
   //if the sort column is still a visible column, then add the sort information


   var sortColExists=_.find(columns,function(col){return col.getColName()===sortColumn});
   if(sortColExists && sortColumn && sortDirection){
      queryMeta.setSort(sortColumn,sortDirection,sortColExists);
   }
   var sortCol2Exists=_.find(columns,function(col){return col.getColName()===sortColumn2});
   if(sortCol2Exists && sortColumn2 && sortDirection2){
      queryMeta.setSort2(sortColumn2,sortDirection2,sortCol2Exists);
   }
   var sortCol3Exists=_.find(columns,function(col){return col.getColName()===sortColumn3});
   if(sortCol3Exists && sortColumn3 && sortDirection3){
      queryMeta.setSort3(sortColumn3,sortDirection3,sortCol3Exists);
   }
   //FILTERS
   queryMeta.setQueryFilter(filterSimple,"SIMPLE");
   queryMeta.setQueryFilter(filterAdvanced,"ADVANCED");
   //FIELDS
   queryMeta.setOrderedColumns(columns);

/* 
   //If additional sorted columns
   //@@DD removing this for now
   if (sortedColumns !== undefined && sortedColumns.length) {
      queryMeta.setSortedColumns(sortedColumns);
      
      if (sortedColumns[0]) {
         queryMeta.setSort(sortedColumns[0].getColName(),sortedColumns[0].getSortDirection(),sortedColumns[0]);
       }
       if (sortedColumns[1]) {
         queryMeta.setSort2(sortedColumns[1].getColName(),sortedColumns[1].getSortDirection(),sortedColumns[1]);
       }
   
       if (sortedColumns[2]) {
         queryMeta.setSort3(sortedColumns[2].getColName(),sortedColumns[2].getSortDirection(),sortedColumns[2]);
       }
   
   } 
 */
   return queryMeta;
};
sas.risk.rgf.biz.View.matchView=function(views,query){
	var i;
	for(i=0;i<views.length;i++){
		var view=views[i];
		console.warn("****** VIEW *******",view.name);
		var matchQueryMeta=view.getQueryMeta() && view.getQueryMeta().equal(query,true);
		if(matchQueryMeta){
			return view;
		}
	}
	return null;
};
sas.risk.rgf.biz.View.findDefaultView=function(views){
	return _.find(views,function(view){return view.isDefault;});
};
sas.risk.rgf.biz.View.findViewIndex=function(views,key){
	return views.indexOf(_.find(views,function(view){return view.getKey()===key;}));
};
sas.risk.rgf.biz.View.generateBaseView=function(tableMeta){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var sortColumnName=tableMeta.getDefaultSortedColumn() ? tableMeta.getDefaultSortedColumn().getColName() : null;
   var sortDirection=tableMeta.getDefaultSortedColumn() ? tableMeta.getDefaultSortedColumn().getSortDirection() : null;
   var baseView=new sas.risk.rgf.biz.View(-1,rb.getText("table.view.non.txt"),null,
   		tableMeta.getVisibleColumns(),sortColumnName,sortDirection);
   return baseView;
};