jQuery.sap.declare("sas.risk.rgf.bizcomp.RGFObjectBizComp");
jQuery.sap.require("sas.ui.cpb3.bizcomp.ObjectBizComp");
jQuery.sap.require("sas.risk.rgf.nav.RGFToolbarActionsObject");

sas.ui.cpb3.bizcomp.ObjectBizComp.extend("sas.risk.rgf.bizcomp.RGFObjectBizComp",{});
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.init=function(template){
	sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.init.apply(this,arguments);
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.loadBizCompModel=function(e){
	var args=e.getParameters().arguments;
	this.isLbo=args.variance==="lbo";
	sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.loadBizCompModel.apply(this,arguments);
	sas.ui.cpb3.CpbUtil.attachStorageEvent('add_lbo',$.proxy(this.onStorageAddLboEvent, this));
	sas.ui.cpb3.CpbUtil.attachStorageEvent('del_lbo',$.proxy(this.onStorageDelLboEvent, this));
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.calculateKey=function(args){
	if(this.isLbo && this.isDraft){
		return null;
	}
	return sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.calculateKey.apply(this,arguments);
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.createOverrides=function(){
	if(this.isLbo && this.isDraft){
		var overrides = {"PREVIOUSLINKEDBUSINESSOBJECTS":JSON.parse(sessionStorage.getItem("previous_Linked_BusinessObjects")),
				"PREVIOUSBUSINESSOBJECT":JSON.parse(sessionStorage.getItem("previous_BusinessObject"))};
		if (sessionStorage.getItem("previous_Location")) { //do not allow null in UI context
			overrides["PREVIOUSLOCATION"] = JSON.parse(sessionStorage.getItem("previous_Location"));
		}
		return overrides;		
	}
	return sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.createOverrides.apply(this,arguments);
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.getToolbar=function(template){
	return new sas.risk.rgf.nav.RGFToolbarActionsObject({cpbForm:this.getCpbForm(),template:template,bizComp:this});
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.onStorageAddLboEvent=function(e){
	var payload=e.getParameter("payload");
	var link=sas.risk.rgf.biz.Link.fromJson(payload);
	this.cpbForm.fireEvent('addToLbo',{
		link:link
	});
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.onStorageDelLboEvent=function(e){
	var payload=e.getParameter("payload");
	var link=sas.risk.rgf.biz.Link.fromJson(payload);
	this.cpbForm.fireEvent('delFromLbo',{
		link:link
	});
};
sas.risk.rgf.bizcomp.RGFObjectBizComp.prototype.unloadBizCompModel=function(){
	sas.ui.cpb3.CpbUtil.detachStorageEvent('add_lbo',$.proxy(this.onStorageAddLboEvent, this));
	sas.ui.cpb3.CpbUtil.detachStorageEvent('del_lbo',$.proxy(this.onStorageDelLboEvent, this));
	sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.unloadBizCompModel.apply(this,arguments);
};