jQuery.sap.declare("sas.risk.rgf.components.AttachmentsComponent");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.hc.m.List");
jQuery.sap.require("sap.m.ScrollContainer");
jQuery.sap.require("sas.hc.m.StandardListItem");
jQuery.sap.require("sap.ui.model.json.JSONModel");
jQuery.sap.require("sas.hc.m.CustomListItem");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.ui.commons.Label");
jQuery.sap.require("sas.hc.ui.commons.TextField");
jQuery.sap.require("sas.hc.ui.commons.form.SimpleForm");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.risk.rgf.util.DialogManager");
jQuery.sap.require("sas.risk.rgf.api.AttachmentsAPI");
jQuery.sap.require("sas.risk.slimtable.util.RowActionUtil");
jQuery.sap.require("sas.risk.rgf.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.CustomizationInfoItem");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.risk.slimtable.plugins.TableOptions");
jQuery.sap.require("sas.risk.slimtable.plugins.Search");
jQuery.sap.require("sas.risk.slimtable.plugins.Filter");
jQuery.sap.require("sas.risk.slimtable.plugins.Counter");
jQuery.sap.require("sas.risk.slimtable.plugins.Pager");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.common.widgets.MessageDetailsBox");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.AttachmentsComponent",sas.ui.cpb3.components.AComponentMixin.mixinMeta({
   metadata : {
       properties : {
           "meta" : {type : "any"},
           "visibleRows" : {type:"int"},
           "formattingKey" : {type:"any"}
       },
       events:{
           change:{}
       }
   },
   constructor:function(){
   	this.supportsLayout=true;
   	this.supportsLabel=true;
 		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
	 },
	 renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.AttachmentsComponent);

sas.risk.rgf.components.AttachmentsComponent.prototype.setMeta=function(meta) {
   this.setProperty("meta", meta);
   this.meta = meta;

   var model=this.getModel("cpb_data");
   if (model)
   {
      this.initializeTable(model);
   }
}

sas.risk.rgf.components.AttachmentsComponent.prototype.getTableTopActionsPlugin=function(){
	var that=this;
	
	//-- Add Link --//
   this.addLink = new sas.risk.common.widgets.Button({
   	 icon : sas.icons.HC.ADDITEM,
       tooltip : that.meta.addLink,
       press : $.proxy(this.actionTargetAdd,this)
   }).addStyleClass("RGFAttachmentsActionLink");
	
   //-- Delete Link --//
   this.multiDeleteLink = new sas.risk.common.widgets.Button({
       icon : sas.icons.HC.REMOVEITEM,
       tooltip : that.meta.deleteLink,
       press : $.proxy(this.actionTargetDelete,this),
       enabled : false
   }).addStyleClass("RGFAttachmentsActionLink");
   
   this.tableTopActionsPlugin=new sas.risk.slimtable.plugins.TablePlugin({
     	position: sas.risk.slimtable.TableLayout.TOP_END,
   	items:[this.addLink, this.multiDeleteLink]
   });
   this.tableTopActionsPlugin.handleDisabled=function(){
   	that.multiDeleteLink.setVisible(false);
   	that.addLink.setVisible(false);
   };
   return this.tableTopActionsPlugin;
};
sas.risk.rgf.components.AttachmentsComponent.prototype._createComponent = function() {
   var that = this;
   var rb = sas.risk.rgf.util.RGFUtil.getBundle();
      
   //TABLE
   this.table = new sas.risk.rgf.widget.RGFTable({
   	 formattingKey : this.getFormattingKey(),
       meta : that.meta.tableMeta,
       data : $.proxy(this.fetchData, this),
       clientSide : true,
       visibleRows : this.getVisibleRows(),
       showSelectionControls : true,
       multiSelect : true,
       enabled:this.getCpbEnabled(),
       required:this.getCpbRequired(),
       plugins:[this.getTableTopActionsPlugin(),
                new sas.risk.slimtable.plugins.Search(),
                new sas.risk.slimtable.plugins.Filter(),
                new sas.risk.slimtable.plugins.TableOptions({
              	  menuItems: this.getTableMenuItems()
                }),
                new sas.risk.slimtable.plugins.Counter(),
                new sas.risk.slimtable.plugins.Pager()
       ]
   });
   sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbEnabled",this.table,"enabled");
   
   this.table.attachRowSelect($.proxy(this.actionTableSelectionChanged,this));
   this.table.attachRowClick($.proxy(this.actionTableRowClicked,this));
   
   //ACTION COLUMN
   var actionColumn=sas.risk.slimtable.util.RowActionUtil.createActionColumn($.proxy(this.createActionMenuItems,this), this.table);
   this.table.addActionColumn(actionColumn);
   this._label.addStyleClass("RGFTabTitleLabel");
   return this.table;
};

sas.risk.rgf.components.AttachmentsComponent.prototype.getTableMenuItems=function(){
	var menuItems=[new sas.risk.rgf.widget.menu.ColumnsItem({serviceId:this.getCpbForm().getCpbService().getServiceId()})];
	var customizationInfoMeta=this.meta.tableMeta.customizationInfoMeta;
	if(customizationInfoMeta){
		var custInfoUrl=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/utils/showCustomizationInfo/"+customizationInfoMeta.boType+"/labelOverridePrefix/"+this.getLabelOverridePrefix();
		menuItems.push(new sas.risk.rgf.widget.menu.CustomizationInfoItem({url:custInfoUrl,meta:customizationInfoMeta}));
	}
   return menuItems;
};

sas.risk.rgf.components.AttachmentsComponent.prototype.fetchData = function(query) {
   return sas.risk.rgf.api.AttachmentsAPI.fetchAttachments(this.getModel("cpb_data"),this.meta.groupNumber);
};

sas.risk.rgf.components.AttachmentsComponent.prototype.refreshTableContent = function(e) {
   this.table.doRefresh();
};

sas.risk.rgf.components.AttachmentsComponent.prototype.doCPBRefresh = function(){
   this.table.doRefresh();
};

sas.risk.rgf.components.AttachmentsComponent.prototype.fireChange=function(){
   var bi=this.table.getParent().getBindingInfo("cpbValue")
   if(bi && bi.binding && bi.binding.getModel()){
       bi.binding.getModel().checkUpdate();
   }
   this.fireEvent("change",arguments);
};

//CREATES
sas.risk.rgf.components.AttachmentsComponent.prototype.createActionMenuItems=function(extra){
   var that=this;
   var rb = sas.risk.rgf.util.RGFUtil.getBundle();
   
   var rowData = extra.rowData; 
   var isUpdateEnabled = this.getCpbEnabled();
   
   var enabledActions = [];
   
   if (isUpdateEnabled)
   {
      var updateItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.editAction,
         callback : function(){that.actionRowUpdate(this);}
      });
      enabledActions.push(updateItem);
       
      var deleteItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.deleteAction,
         callback : function(){that.actionRowDelete(this);}
      });
      enabledActions.push(deleteItem);    
   }
   
   return enabledActions;
};

sas.risk.rgf.components.AttachmentsComponent.prototype.actionTableSelectionChanged=function(){
   var enableDelete = false;
   var source=this.table.getSource();
   var indices=source.getSelections();
   if (indices.length && indices.length > 0)
      this.multiDeleteLink.setEnabled(true);    
   else
      this.multiDeleteLink.setEnabled(false);   
};

sas.risk.rgf.components.AttachmentsComponent.prototype.actionTargetDelete=function(){
   var source=this.table.getSource();
   var indices=source.getSelections();
   var srcRows=source.getData();
   var i,row,link,rows=[],links=[];
    
   for(var i=0;i<indices.length;i++){
       row=srcRows[indices[i]];
       rows.push(row);
   }
   this.doDelete(rows, source);      
};

sas.risk.rgf.components.AttachmentsComponent.prototype.actionTargetAdd=function(){
   var source=this.table.getSource();
   var indices=source.getSelections();
   var srcRows=source.getData();
   var that=this;

   //initialize a draft entry       
   var def = sas.risk.rgf.api.AttachmentsAPI.createDraftAttachment(this.getModel("cpb_data"), this.meta.groupNumber).done(function(draftItem) {      
       var rb = sas.risk.rgf.util.RGFUtil.getBundle();
       var viewData={
             create:true,
             meta:that.meta,
             model:that.getModel("cpb_data"),
             sscchoices:that.getModel("cpb_choices").getData("cpb_choices")["SOURCESYSTEMCD"],
             item:draftItem,
             width:800, //TODO improve
             height:400,
             title:that.meta.addTitle
         };
         var closeHandler = function()
         {
            if (!that.meta.immediateSave) {
               that.fireChange();
            }
            that.refreshTableContent();
         };
         sas.risk.rgf.util.DialogManager.open("AttachmentPropertiesDialog",viewData,closeHandler,that);
   }).fail(function(e){
         if (e.status && e.status === 404)
         {
            //The parent object no longer exists
            var errorJson = {"message" : that.meta.missingParentMsg};      
   	      sas.risk.common.widgets.MessageDetailsBox.error(errorJson, sas.config.appName, sas.risk.rgf.util.RGFUtil.getBundle());	
         }
         else
         {
            sas.risk.rgf.util.RGFUtil.handleFail(e);
         }
   });
   //todo - handle failure. if 404, then the parent no longer exists.
};

sas.risk.rgf.components.AttachmentsComponent.prototype.actionRowDelete=function(item){
   var rowData = item.getParent().getPayload().rowData;
   this.doDelete([rowData]);
};

sas.risk.rgf.components.AttachmentsComponent.prototype.doDelete=function(items, source){
   var rb = sas.risk.rgf.util.RGFUtil.getBundle();
   var that = this;
   
   if (items && items.length > 0)
   {
      var callBackFn = function(event) {
      	var action=event.getParameter("origin").getMessageDialogAction();
         if(action==="CANCEL"){return;}
         that.table.setBusyIndicatorDelay(0);
         that.table.setBusy(true);
         var delDef = sas.risk.rgf.api.AttachmentsAPI.deleteAttachments(that.getModel("cpb_data"), that.meta.groupNumber, that.meta.immediateSave, items);
         delDef.done(function(){
            if (!that.meta.immediateSave) {
               that.fireChange();
            }
         }).fail(function(e){
             sas.risk.rgf.util.RGFUtil.handleFail(e)
         }).always(function(e){
            if (source) source.setSelections([]);
            that.table.doRefresh();
            that.table.setBusy(false);
         });
     };
      
     var labelTxt = jQuery.sap.formatMessage(this.meta.deleteConfirmation,[items[0].name]);
     var titleTxt = this.meta.deleteConfirmationTitle;
     
     if (items.length > 1)
     {
        labelTxt = jQuery.sap.formatMessage(this.meta.multiDeleteConfirmation,[items.length]);
        titleTxt = this.meta.multiDeleteConfirmationTitle;      
     }
		sas.hc.m.MessageDialog.warning({
			text:labelTxt,
			title:titleTxt,
			buttonActions:[sas.hc.m.MessageDialogAction.Delete,sas.hc.m.MessageDialogAction.Cancel],
			buttonPress:callBackFn
		});
   }
};

sas.risk.rgf.components.AttachmentsComponent.prototype.actionRowUpdate=function(item){
   var rowData = item.getParent().getPayload().rowData;
   var that=this;

       var rb = sas.risk.rgf.util.RGFUtil.getBundle();
       var viewData={
             create:false,
             meta:that.meta,
             model:that.getModel("cpb_data"),
             sscchoices:that.getModel("cpb_choices").getData("cpb_choices")["SOURCESYSTEMCD"],
             item:rowData,
             width:800, //TODO improve
             height:400,
             title:that.meta.editTitle
         };
         var closeHandler = function()
         {
            that.fireChange();
            that.refreshTableContent();
         };
         sas.risk.rgf.util.DialogManager.open("AttachmentPropertiesDialog",viewData,closeHandler,that);
};


sas.risk.rgf.components.AttachmentsComponent.prototype.actionTableRowClicked=function(e)
{
   //CLICKING ON ROW WILL DOWNLOAD
   var rowData = e.getSource().getSource().getData()[e.getParameter("rowIdx")];
   sas.risk.rgf.api.AttachmentsAPI.followAttachmentLink(rowData);
};

//UTILS
sas.risk.rgf.components.AttachmentsComponent.prototype.findLink=function(item, name)
{
   var result;
   if (item && item.links)
   {
      result = _.find(item.links, function (link) {return link.rel === name});
   }
   return result;
}
//STATICS
sas.risk.rgf.components.AttachmentsComponent.create=function(fieldJson, modelId, cpbForm) {
   var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
   return new sas.risk.rgf.components.AttachmentsComponent($.extend(
       settings,
       {
      	 cpbValue:sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId,'ATTACHMENTS',true),
      	 meta : fieldJson.meta,
          visibleRows : fieldJson.visibleRows,
          formattingKey :sas.risk.rgf.util.RGFUtil.buildFormattingKey(cpbForm,fieldJson.type,fieldJson.cpbName)
       }
   ));
};