jQuery.sap.declare("sas.risk.rgf.components.CommentsComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.hc.m.List");
jQuery.sap.require("sap.m.ScrollContainer");
jQuery.sap.require("sas.hc.m.StandardListItem");
jQuery.sap.require("sap.ui.model.json.JSONModel");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.CustomListItem");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.ui.commons.Label");
jQuery.sap.require("sas.hc.ui.commons.TextField");
jQuery.sap.require("sas.hc.ui.commons.form.SimpleForm");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.hc.m.Heading");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.risk.rgf.util.DialogManager");
jQuery.sap.require("sas.risk.rgf.api.CommentsAPI");
jQuery.sap.require("sas.risk.slimtable.meta.ColumnFormatterRegistry");
jQuery.sap.require("sas.risk.rgf.meta.formatter.CommentsFormatter");
jQuery.sap.require("sas.risk.rgf.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.CustomizationInfoItem");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.CommentsComponent", sas.ui.cpb3.components.AComponentMixin.mixinMeta({
	metadata : {
		properties : {
			"meta" : {type : "any"},
			"visibleRows" : {type:"int"},
			formattingKey:{type:"any"}
		},
		events:{
			"change":{}
		}
	},
	constructor:function(){
 		this.supportsLayout=true;
 		this.supportsLabel=true;
 		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
 	},
 	renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
}));

sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.CommentsComponent);

sas.risk.rgf.components.CommentsComponent.prototype._createComponent = function() {
	this.meta = this.getProperty("meta");
	this.createTable()
	this._label.addStyleClass("RGFTabTitleLabel");
	return this.table;
};
sas.risk.rgf.components.CommentsComponent.prototype.wireOnChange = function(onChangeFn) {
	if(onChangeFn){
		this.attachChange(onChangeFn);
	}
};
sas.risk.rgf.components.CommentsComponent.prototype.fetchData = function(query) {
	return sas.risk.rgf.api.CommentsAPI.fetchComments(this.getModel("cpb_data"),this.meta.groupNumber,this.meta.pointInTime);
};
sas.risk.rgf.components.CommentsComponent.prototype.setCpbValue = function(value) {
	this.table&&this.table.doRefresh();
	this.setProperty("cpbValue",value);
};
sas.risk.rgf.components.CommentsComponent.prototype.getTableTopActionsPlugin=function(){
	var that=this;
	var cpbModelManager=this.getCpbForm().getCpbModelManager();
	//-- Add Comment Link --//
   this.createLink = new sas.risk.common.widgets.Button({
   	icon : sas.icons.HC.COMMENT,
		tooltip : that.meta.addLinkLabel,
		press : function(evt) {
			
			var viewData={
				create:true,
				meta:that.meta,
				title:that.meta.addCommentDialogTitle,
				immediateSave:that.meta.immediateSave || cpbModelManager.getScreenReadonly()
			};
			sas.risk.rgf.util.DialogManager.open("AddCommentDialog",viewData,that.actionSaveLink,that);
		}
	});
   this.createLink.getEnabled=function(val){//createLink should be always enabled irrespective of whether table is readonly or not
   	var modelId=that.getBindingInfo("cpbValue").parts[0].model;
   	var model=that.getModel(modelId);
   	var isPreview=false;
   	if(model) {
   		isPreview=model.getProperty("/IS_SCREEN_PREVIEW");
   	}
   	return !isPreview && that.getCpbEnabled(); //not activate add comment link if it is in screen editor preview scenario, otherwise add comment should be always active (unless specifically told not to be)
   };
   this.tableTopActionsPlugin=new sas.risk.slimtable.plugins.TablePlugin({
     	position: sas.risk.slimtable.TableLayout.TOP_END,
   	items:[this.createLink]
   });
   this.tableTopActionsPlugin.handleDisabled=function(){
   	//Nothing to do here since only action we have here (this.createLink) should always be active irrespective of table is readonly or not
   };
   return this.tableTopActionsPlugin;
};
sas.risk.rgf.components.CommentsComponent.prototype.createTable = function() {
	var that = this;
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	this.table = new sas.risk.rgf.widget.RGFTable({
		formattingKey : this.getFormattingKey(),
		meta : that.meta.tableMeta,
		data : $.proxy(this.fetchData, this),
		clientSide : true,
		visibleRows : this.getVisibleRows(),
      plugins:[this.getTableTopActionsPlugin(),
               new sas.risk.slimtable.plugins.Search(),
               new sas.risk.slimtable.plugins.Filter(),
               new sas.risk.slimtable.plugins.TableOptions({
              	  menuItems: this.getTableMenuItems()
                }),
               new sas.risk.slimtable.plugins.Counter()
      ]
	});
	
	sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbEnabled",this.table,"enabled");
	
	//Handle the actions in case of readonly
   this.table.attachEvent("riskTabledisabled",function(event){
   	var disabled=event.getParameter("disabled");
   	if(disabled){
   		
   	}
   });
};


sas.risk.rgf.components.CommentsComponent.prototype.getTableMenuItems=function(){
	var menuItems=[new sas.risk.rgf.widget.menu.ColumnsItem({serviceId:this.getCpbForm().getCpbService().getServiceId()})];
	var customizationInfoMeta=this.meta.tableMeta.customizationInfoMeta;
	if(customizationInfoMeta){
		var custInfoUrl=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/utils/showCustomizationInfo/boTypeNm/"+customizationInfoMeta.boType+"/labelOverridePrefix/"+this.getLabelOverridePrefix();
		menuItems.push(new sas.risk.rgf.widget.menu.CustomizationInfoItem({url:custInfoUrl,meta:customizationInfoMeta}));
	}
   return menuItems;
};

//CUSTOM CELL FORMATTING COMMENTS TEXT and ICON
sas.risk.rgf.components.CommentsComponent.formatter={
	"JAVA.LANG.STRING_commentText":new sas.risk.rgf.meta.formatter.CommentsFormatter("JAVA.LANG.STRING_commentText")
};
sas.risk.rgf.components.CommentsComponent.prototype.actionCreateCommentCell = function(parent,input,viewCommentFunc) {
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var div=document.createElement("DIV");
	div.className="CommentsCell";
//	var parentHeight=$(parent.parentElement).height();
	$(div).css("height",28);//Set the div height to the parent one so that it stays in one cell
	var commentTxt=document.createElement("SPAN");
	var temp=document.createElement("div");
	temp.innerHTML=jQuery.sap._sanitizeHTML(input);
	//	commentTxt.innerHTML=temp.textContent;
	//commentTxt.innerHTML=jQuery.sap._sanitizeHTML(input);
	commentTxt.innerHTML=DOMPurify.sanitize(temp.innerHTML, {KEEP_CONTENT: false}); 
	//Only display the first element
	var elementToDisplay=$(commentTxt).children().length===0 ? commentTxt : $(commentTxt).children()[0]; //When it is a simple string comment, $(commentTxt).children() will be empty
	var foundElemWithTxt=$(commentTxt).children().length===0 ? true : false;
	//handle the case when user has empty lines at the beginning
	while(!foundElemWithTxt){
		var child=$(commentTxt).children()[0];
		if(child && child.textContent.trim().length === 0){
			$(child).remove();
		}else{
			foundElemWithTxt=true;
			elementToDisplay=child;
		}
	}
	//remove the margin and padding of the element to be shown so that it shows up in the one line comment cell
	$(elementToDisplay).css("margin-top","0px");
	$(elementToDisplay).css("padding-top","0px");
	$(elementToDisplay).css("margin-bottom","0px");
	$(elementToDisplay).css("padding-bottom","0px");
	//Handle removing font-size css from the displaying element (with text) and all it's children.
	var removeFontSize=function(elem){
		$(elem).children().each(function(indx, child){
		     removeFontSize(child);
		});
		$(elem).css('font-size','');
	};
	removeFontSize(elementToDisplay);
	//If the element to display includes anchor tags, then update the target attribute of all those anchor tags to _blank 
	var updateTarget=function(elem){
		$(elem).children().each(function(indx, child){
			updateTarget(child);
		});
		if($(elem).is("a")){
			$(elem).attr('target','_blank');
		}
	};
	updateTarget(elementToDisplay);
	//If the element to display includes table then keep only the 1st row to display
	if($(elementToDisplay).is("table")){
		var caption=$(elementToDisplay).find("caption");
		var thead=$(elementToDisplay).find("thead");
		if(caption.length>0 && thead.length>0){
			thead.remove();
		}else if(thead.length>0){
			var i, trs=$(thead).children();
			for(i=1;i<trs.length;i++){
				$(trs[i]).remove();
			}
		}
		var tbody=$(elementToDisplay).find("tbody");
		if((caption.length>0 || thead.length>0) && tbody.length>0){
			tbody.remove();
		}else if(tbody.length>0){
			var i, trs=$(tbody).children();
			for(i=1;i<trs.length;i++){
				$(trs[i]).remove();
			}
		}
		$(elementToDisplay).css('width','100%');
		var tableDiv=document.createElement("div");
		tableDiv.appendChild(elementToDisplay);
		$(tableDiv).css("width",'100%');
		elementToDisplay=tableDiv;
	}
	$(elementToDisplay).css("overflow","hidden");
	if (elementToDisplay)
		elementToDisplay.className="CommentsTxt";
	var viewCommentIcon=document.createElement("SPAN");
	viewCommentIcon.title=rb.getText("comment.viewCommentIcon.tooltip.txt");
	viewCommentIcon.className="CommentsIcon";
	viewCommentIcon.onmousedown=viewCommentFunc;
	viewCommentIcon.dataset.sapUiIconContent="";
	div.appendChild(viewCommentIcon);
	if (elementToDisplay)
		div.appendChild(elementToDisplay);
	parent.appendChild(div);
};
sas.risk.rgf.components.CommentsComponent.prototype.actionSaveLink = function(e) {
	var that=this;
	var dialog=e.getParameter("dialog");
	var commentText=e.getParameter("commentText");
	var that=this;
	var cpbModelManager=this.getCpbForm().getCpbModelManager();
	var commentAuthor=cpbModelManager.getUIContextValue("CURRENTUSER")["handle"].split("|")[1];
	var commentLinks=[];
	var authorLink=$.extend({},cpbModelManager.getUIContextValue("CURRENTUSER").links[0]);
	authorLink.rel="author";
	commentLinks.push(authorLink);
	var comment=
	{
			"commentText": commentText,
			"author"	: commentAuthor,
			"links":commentLinks,
			"groupNo": this.meta.groupNumber
	};
	var immediate=that.meta.immediateSave || cpbModelManager.getScreenReadonly();
	var def = this.getCpbForm().getCpbService().getCpbAPI().getCurrentServerTime();
	def.done(function(json){
		comment.commentDttm=json.currentTime;
		sas.risk.rgf.api.CommentsAPI.createComment(cpbModelManager.getUIContextModel(), comment, immediate)
		.done(function(){
			that.table.doRefresh();
			that.fireChange();
			dialog.close();
		}).fail(function(e){
         if (e.status && e.status === 404)
         {
           //The parent object no longer exists
           var errorJson = {"message" : that.meta.missingParentMsg};      
           sas.risk.common.widgets.MessageDetailsBox.error(errorJson, sas.config.appName, sas.risk.rgf.util.RGFUtil.getBundle());	
         }
         else
         {
            sas.risk.rgf.util.RGFUtil.handleFail(e);
         }
		})
	});
};
//STATICS
sas.risk.rgf.components.CommentsComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	return new sas.risk.rgf.components.CommentsComponent($.extend(
		settings,
		{
			cpbValue : modelId ? "{" + modelId + ">/COMMENTS}" : "{/COMMENTS}",
			meta : fieldJson.meta,
			formattingKey :sas.risk.rgf.util.RGFUtil.buildFormattingKey(cpbForm,fieldJson.type,fieldJson.cpbName),
			visibleRows : fieldJson.visibleRows
		}
	));
};
sas.risk.slimtable.meta.ColumnFormatterRegistry.registerFactory(sas.risk.rgf.components.CommentsComponent.formatter,"Comments");