jQuery.sap.declare("sas.risk.rgf.components.DimensionalLocationComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutRenderer");
jQuery.sap.require("sas.risk.rgf.widget.dimloc.DimensionalLocation");
jQuery.sap.require("sas.risk.rgf.biz.Favorite");
jQuery.sap.require("sas.risk.rgf.biz.Feature");
jQuery.sap.require("sas.risk.rgf.biz.Dimension");
jQuery.sap.require("sas.risk.rgf.biz.DimNode");
jQuery.sap.require("sas.risk.rgf.biz.DimNodeRegistry");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.DimensionalLocationComponent", sas.ui.cpb3.components.AComponentMixin.mixinMeta({
	metadata:{
		properties:{
			meta:{type:"any"}
		}
	},
	constructor:function(){
		this.supportsLayout=true;
		var settings=this._parseMeta(arguments[0].meta);
		this.widget = new sas.risk.rgf.widget.dimloc.DimensionalLocation(settings);
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbLabel",this.widget,"title");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbRequired",this.widget,"required");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbErrored",this.widget,"errored");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbHelp",this.widget,"help");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbValue",this.widget,"handle");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbEnabled",this.widget,"enabled");
		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
		this.addStyleClass("cpbSuperWide");
	},
	renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.DimensionalLocationComponent);

sas.risk.rgf.components.DimensionalLocationComponent.prototype.setCPBValue=function(value){
	this.setCpbValue(value);
};
sas.risk.rgf.components.DimensionalLocationComponent.prototype.setCPBRequired=function(value){
	this.widget.setRequired(value);
//	this.widget.section.setRequired(value);
};
sas.risk.rgf.components.DimensionalLocationComponent.prototype._createComponent = function() {
	this.getCpbForm().attachEvent('reload',$.proxy(this.onReloadFavs,this));
	this.widget.attachFavChange(function(e){
		var fav=e.getParameter("newValue");
		sas.ui.cpb3.CpbUtil.fireStorageEvent('reload',{type:"ora_favs",key:fav.getKey()},true);
	});
	return this.widget;
};
sas.risk.rgf.components.DimensionalLocationComponent.prototype.onReloadFavs=function(event){
	var type=event.getParameter("type");
	if(type==="ora_favs" || type==="*"){
		this.widget.reloadFavorites();
	}
};
sas.risk.rgf.components.DimensionalLocationComponent.prototype._parseMeta=function(meta){
   var isForFiltering=meta.isForFiltering;
   var excludedDimensions=(meta.excludedDimensions&&meta.excludedDimensions.split(","))||[];
   var feature=sas.risk.rgf.biz.Feature.parseFromJson(meta.feature,isForFiltering?null:meta.secureActionVal);
   feature.setExcludedDimensions(excludedDimensions);
   var favorites=sas.risk.rgf.biz.Favorite.parseAll(meta.favorites);
   return {
   	isEverywhereAllowed:meta.isEverywhereAllowed,
      isForFiltering:isForFiltering,
	   isPoint:meta.isPoint,
	   singlePoint:!!meta.singlePoint,
	   isRootVisible:meta.isRootVisible,
	   secureActionVal:meta.secureActionVal,
	   secureObjectClassName:meta.secureObjectClassName,
	   showMappedStandardBusinessLine:meta.showMappedStandardBusinessLine,
	   showMappedStandardRiskType:meta.showMappedStandardRiskType,
	   validatePermissions:meta.validatePermissions,
	   feature:feature,
	   favorites:favorites,
	   hideInactive: meta.hideInactive,
	   showInactiveCheckbox: meta.showInactiveCheckbox
   };
};
//STATICS
sas.risk.rgf.components.DimensionalLocationComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	return new sas.risk.rgf.components.DimensionalLocationComponent($.extend(
		settings,
		{
			cpbValue:sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId,fieldJson.cpbName),
			meta : fieldJson.meta
		}
	));
};