jQuery.sap.declare("sas.risk.rgf.components.HyperLinkComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sap.m.Link");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sap.m.LinkRenderer");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.HyperLinkComponent", sas.ui.cpb3.components.AComponentMixin.mixinMeta({
	metadata : {
		properties : {
			"linkHref" : {type : "sap.ui.core.URI"},
			"linkImage" : {type : "string"},
			"linkText" : {type : "string"},
			"linkTarget" : {type : "string"},
			"linkImage" : {type : "string"}
		}
	},
	constructor : function() {
		this.supportsLayout=true;
		this.supportsLabel=true;
	  	this.supportsAlign=true;
 		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
	},
	renderer : "sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.HyperLinkComponent);


sas.risk.rgf.components.HyperLinkComponent.prototype.init=function(){
	var that=this;
	this.link = new sas.hc.m.Link({
	});
	this.oImage = new sap.m.Image({});
};

sas.risk.rgf.components.HyperLinkComponent.prototype.onBeforeRendering=function(){
	this.link.setText(this.getLinkText());
	this.link.setHref(this.getLinkHref());
	this.link.setTarget(this.getLinkTarget());
	this.oImage.setSrc(this.getLinkImage());
};

sas.risk.rgf.components.HyperLinkComponent.prototype._createComponent = function() {
	var items=[];
	if (this.getLinkImage()){
		items=[this.oImage,this.link];
	}else{
		items=[this.link];
	}
	var comp=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%",
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Row,
		items:items	
	}).addStyleClass("RGFHyperLink");
   return comp;
};
//STATICS
sas.risk.rgf.components.HyperLinkComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	// Create a binding to the CPB field if the linkHref parameter looks like "FIELD:Temp.someUrlField"
	if(/^FIELD:.*$/i.test(fieldJson.linkHref))
	   settings.linkHref = sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId, fieldJson.linkHref.split(":")[1]);
	else
	   settings.linkHref = fieldJson.linkHref;
	
	return new sas.risk.rgf.components.HyperLinkComponent($.extend(
		settings,
		{
			meta : fieldJson.meta,
			linkTarget : fieldJson.linkTarget,
			linkText : fieldJson.linkText,
			linkImage : fieldJson.linkImage
		}
	));
};