jQuery.sap.declare("sas.risk.rgf.components.IFrameComponent");

jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-core');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-widget');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-mouse');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-draggable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-droppable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-sortable');

jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-resizable');
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.IFrameComponent",sas.ui.cpb3.components.AComponentMixin.mixinMeta({
	metadata:{
		properties:{
			"cpbSrc" : {type : "sap.ui.core.URI"},
			"cpbWidth" : {type : "sap.ui.core.CSSSize"},
			"cpbHeight" : {type : "sap.ui.core.CSSSize"},
			"allowResize": {type : "boolean", defaultValue: true}
		}
	},
   constructor:function(){
   	this.supportsLayout=true;
  	 	this.supportsLabel=true;
  	 	this.supportsAlign=true;
  	 	sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
   }
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.IFrameComponent);

sas.risk.rgf.components.IFrameComponent.prototype._createComponent = function() {
	var url=this.getCpbSrc();
	var width=this.getCpbWidth();
	var height=this.getCpbHeight();
	var allowResize=this.getAllowResize();
	
	//TODO: css resize is not supported in IE. jQuery ui resize was buggy with sticky drag.
	var iframeTag="<iframe class='RGFIFrame RGFResizable' width='"+width+"' height='"+height+"' src='"+url+"' ></iframe>";
	if(!allowResize){
		iframeTag="<iframe class='RGFIFrame' width='"+width+"' height='"+height+"' src='"+url+"' ></iframe>";
	}

	var ifComp=new sap.ui.core.HTML({
		content:iframeTag
   });
	
	this.setWidth("100%");
	this.setFlexDirection(sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column);
	
	return ifComp;
};
//STATICS
sas.risk.rgf.components.IFrameComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getFieldBasicSettings(fieldJson,modelId,cpbForm);
	return new sas.risk.rgf.components.IFrameComponent($.extend(
		settings,
		{
			searchKey : fieldJson.searchKey,
			cpbSrc : fieldJson.url,
			cpbWidth : fieldJson.cpbWidth,
			cpbHeight : fieldJson.cpbHeight,
			allowResize : fieldJson.allowResize
		}
	));
};