jQuery.sap.declare("sas.risk.rgf.components.RGFAdvancedTableComponent");
jQuery.sap.require("sas.ui.cpb3.components.AdvancedTableComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutRenderer");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.risk.slimtable.widget.menu.SeparatorItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.ExcelItem");
jQuery.sap.require("sas.risk.rgf.util.NavigationUtil");
jQuery.sap.require("sas.risk.slimtable.plugins.TableOptions");
jQuery.sap.require("sas.risk.slimtable.plugins.Counter");
jQuery.sap.require("sas.risk.slimtable.plugins.Pager");
jQuery.sap.require("sas.risk.rgf.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.slimtable.widget.menu.AdvSearchItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.CustomizationInfoItem");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");

sas.ui.cpb3.components.AdvancedTableComponent.extend("sas.risk.rgf.components.RGFAdvancedTableComponent", {
    metadata:{
        properties:{
            "showExportToExcel":{type:"boolean",defaultValue:false},
            "showExportForDataLoad":{type:"boolean",defaultValue:false},
            "showExportAttachments":{type:"boolean",defaultValue:false}
        }
    },
 	 renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
});

sas.risk.rgf.components.RGFAdvancedTableComponent.prototype.getTableMenuItems=function(){
	var menuItems=[];
	var customizationInfoMeta=this.getMeta().customizationInfoMeta;
	if(customizationInfoMeta){
		var custInfoUrl=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/utils/showCustomizationInfo/queryTableType/"+this.getQueryTableType();
		menuItems.push(new sas.risk.rgf.widget.menu.CustomizationInfoItem({url:custInfoUrl,meta:customizationInfoMeta}));
	}
   return menuItems;
};
sas.risk.rgf.components.RGFAdvancedTableComponent.prototype.getAdvTableComponent=function(queryTableType, visibleRowsProp){
	this._label.addStyleClass("RGFTabTitleLabel");
	return new sas.risk.rgf.widget.RGFTable({
		formattingKey:this.getFormattingKey(),
      meta: this.getMeta(),
      data: $.proxy(this._fetchData,this),
      exportURL: this.getExportUrl(),
      visibleRows: visibleRowsProp,
      showSelectionControls:false,
      plugins:[this.getTableTopActionsPlugin(),
               new sas.risk.slimtable.plugins.TableOptions({
             	  menuItems: this.getTableMenuItems()
               }),
               new sas.risk.slimtable.plugins.Counter(),
               new sas.risk.slimtable.plugins.Pager(),
               new sas.risk.slimtable.plugins.Search(),
               new sas.risk.slimtable.plugins.Filter()
      ]
   });
};

sas.risk.rgf.components.RGFAdvancedTableComponent.prototype.doRowClick=function(oEvent){
   var type = this.getQueryTableType();
   var rowData=this.comp.getSource().getData()[oEvent.getParameter("rowIdx")];
   sas.ui.cpb3.nav.NavUtil.getInstance().navTo(
		this.getCpbForm(),
		{
			event_name:"object_selected",
			type:type,
			key:rowData.key,
			variance:"lbo"
		}
	);
};

sas.risk.rgf.components.RGFAdvancedTableComponent.prototype.getExportUrl=function(){
   var dataUrl = this.getDataUrl();
	var exportUrl = sas.risk.rgf.util.RGFUtil.getRestUrl()+"/"+this.getQueryTableType()+"/export";
   if (dataUrl && dataUrl.indexOf("?") > 0)
   {
      var i = dataUrl.indexOf("?");
      exportUrl = dataUrl.substring(0,i) + "/export" + dataUrl.substring(i,dataUrl.length);
   }
	if (this.getMeta().custFileOverride) 
	{
		exportUrl += exportUrl.indexOf("?") > 0 ? "&" : "?"; 
		exportUrl += "fileName="+this.getMeta().custFileOverride;
	}
   return exportUrl;
};
//STATICS
sas.risk.rgf.components.RGFAdvancedTableComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.risk.rgf.components.RGFAdvancedTableComponent._createSettings(fieldJson,modelId,cpbForm);
	return sas.ui.cpb3.components.AdvancedTableComponent._createComponent(settings,sas.risk.rgf.components.RGFAdvancedTableComponent);
};
sas.risk.rgf.components.RGFAdvancedTableComponent._createSettings=function(fieldJson, modelId, cpbForm) {
	fieldJson.dataUrl=sas.risk.rgf.util.RGFUtil.aimRestUrl(fieldJson.dataUrl);
	fieldJson.metaUrl=sas.risk.rgf.util.RGFUtil.aimRestUrl(fieldJson.metaUrl);
	var settings=sas.ui.cpb3.components.AdvancedTableComponent._createSettings(fieldJson,modelId,cpbForm);
	$.extend(settings,{
		showExportToExcel: fieldJson.showExportToExcel,
		showExportForDataLoad: fieldJson.showExportForDataLoad,
		showExportAttachments: fieldJson.showExportAttachments
	});
	settings.formattingKey=sas.risk.rgf.util.RGFUtil.buildFormattingKey(cpbForm,fieldJson.type,fieldJson.cpbName);
	return settings;
};
