jQuery.sap.declare("sas.risk.rgf.components.WorkflowDiagramComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.WorkflowDiagramComponent",sas.ui.cpb3.components.AComponentMixin.mixinMeta({
    metadata:{
        properties:{
            "searchKey":{type:"string"},
				"tpHandlePath":{type:"string"},
				"wfTemplatePath":{type:"string"}
        }
    },
    constructor:function(){
   	 this.supportsLayout=true;
   	 this.supportsLabel=true;
   	 this.supportsAlign=true;
   	 sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
    }
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.WorkflowDiagramComponent);

sas.risk.rgf.components.WorkflowDiagramComponent.prototype._createComponent = function() {
	var that=this;
	var formatURL=function(handle,template){
		var searchKey=that.getSearchKey();
		var params = "";
		params=params+"&tstamp=" + Date.now();
		params=params+"&timeoutEnabled=false";
		//params=params+"&logging=debug&timeoutPingWindowInterval=30&mouseWheelHandlerEnabled=true";
	   params=params+"&handle="+handle;
	   params=params+"&searchBy=DataObject";
	   params=params+"&searchKey="+searchKey;
	   params=params+"&rgfContentId="+that.getCpbForm().getCpbService().getServiceId();
	   if (_.isString(template)){
		   params=params+"&templateName="+template;
	   }
	   
	   var url=encodeURI("Director?_directive=WorkflowAdmin"+params);
		var wfContent="<iframe class='RGFIFrame' width='100%' height='640px' src='"+url+"' ></iframe>";
		return wfContent;
	}
	
	var wfDiagram=new sas.ui.cpb3.widget.HTML({
		content:{parts:[this.getTpHandlePath(), this.getWfTemplatePath()], formatter: formatURL}
   });
	var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		width:"100%",
   	items:[wfDiagram]
   });
   return layout;
};
//STATICS
sas.risk.rgf.components.WorkflowDiagramComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	return new sas.risk.rgf.components.WorkflowDiagramComponent($.extend(
		settings,
		{
			searchKey : fieldJson.searchKey,
			tpHandlePath : sas.ui.cpb3.WidgetBindingUtil.getDataPath(modelId,"TPHANDLE"),
			wfTemplatePath : sas.ui.cpb3.WidgetBindingUtil.getDataPath(modelId,"WORKFLOW.TEMPLATE")
		}
	));
};