jQuery.sap.declare("sas.risk.rgf.components.WorkflowUIComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.ui.mashup.util.PerspectiveUtil");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.components.WorkflowUIComponent",sas.ui.cpb3.components.AComponentMixin.mixinMeta({
    metadata:{
        properties:{
            "tpHandle":			{type:"string"},
            "url":				{type:"string"},
            "cpbHeight":		{type:"string", defaultValue: "640px"},
            "cpbWidth":			{type:"string", defaultValue: "100%"},
				"tpHandlePath":	{type:"string"},
				"allowResize": 	{type:"boolean", defaultValue: false},
				"wfTemplatePath":	{type:"string"}
        }
    },
    constructor:function(){
   	 this.supportsLayout=true;
   	 this.supportsLabel=true;
   	 this.supportsAlign=true;
   	 sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
    }
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.rgf.components.WorkflowUIComponent);

sas.risk.rgf.components.WorkflowUIComponent.prototype._createComponent = function() {
	var that=this;
	var formatURL=function(handle,template){
		var tpHandle = that.getTpHandle();
	   var firstUrl = (that.getUrl()===undefined) ? "tiles/workflow/WorkflowUI.jsp" : that.getUrl();
	   var serviceId = that.getCpbForm().getCpbService().getServiceId();
	   
	   var contentId = serviceId;
	   var perspectiveId = null;
	   var perspectiveIdPartStr = "";
   	var split = sas.ui.mashup.util.PerspectiveUtil.parse(serviceId);
   	if (split !== undefined && split.length == 2) {
   		contentId = split[0];
   		perspectiveId = split[1];
   		perspectiveIdPartStr = "&amp;uiPerspectiveId=" + perspectiveId;
   	}
   	
	   var url = encodeURI(firstUrl + "?tpHandle=" + tpHandle + "&amp;cpb0Ui=false&amp;cpb3Ui=true&amp;rgfContentId=" + contentId + perspectiveIdPartStr);
	   var iframeTag = that.getAllowResize() ? "<iframe class='RGFIFrame RGFResizable' width='" : "<iframe class='RGFIFrame' width='";
		var wfContent = iframeTag + that.getCpbWidth() + "' height='" + that.getCpbHeight() + "' src='" + url + "' ></iframe>";
		return wfContent;
	}
	
	var wfUI=new sas.ui.cpb3.widget.HTML({
		content:{parts:[this.getTpHandlePath(), this.getWfTemplatePath()], formatter: formatURL}
   });
	
	var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		width:"100%",
   	items:[wfUI]
   });
   return layout;
};
//STATICS
sas.risk.rgf.components.WorkflowUIComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	return new sas.risk.rgf.components.WorkflowUIComponent($.extend(
		settings,
		{
			tpHandle : fieldJson.tpHandle,
			url : fieldJson.url,
			cpbWidth : fieldJson.cpbWidth,
			cpbHeight : fieldJson.cpbHeight,
			allowResize : fieldJson.allowResize,			
			tpHandlePath : sas.ui.cpb3.WidgetBindingUtil.getDataPath(modelId,"TPHANDLE"),
			wfTemplatePath : sas.ui.cpb3.WidgetBindingUtil.getDataPath(modelId,"WORKFLOW.TEMPLATE")
		}
	));
};