/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
*/

jQuery.sap.declare("sas.risk.rgf.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.risk.rgf
 * @public
*/
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sas.hc.ui.core.library");
jQuery.sap.require("sap.ui.layout.library");
jQuery.sap.require("sap.ui.unified.library")
jQuery.sap.require("sap.ui.commons.library");
jQuery.sap.require("sap.ui.ux3.library");
jQuery.sap.require("sas.hc.ui.layout.library");
jQuery.sap.require("sap.m.library");
jQuery.sap.require("sas.hc.m.library");
jQuery.sap.require("sas.hc.ui.commons.library");
jQuery.sap.require("sas.hc.ui.commons.codeEditor.library");
jQuery.sap.require("sas.vaviewer.library");
jQuery.sap.require("sas.risk.common.library");
jQuery.sap.require("sas.risk.slimtable.library");
jQuery.sap.require("sas.ui.cpb3.library");


// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
  name : "sas.risk.rgf",
  dependencies : [
      "sap.ui.core",
      "sas.hc.ui.core",
      "sap.ui.layout",
      "sap.ui.unified",
      "sap.ui.commons",
      "sap.ui.ux3",
      "sas.hc.ui.layout",
      "sap.m",
      "sas.hc.m",
      "sas.hc.ui.commons",
      "sas.hc.ui.commons.codeEditor",
      "sas.vaviewer",
      "sas.risk.common",
      "sas.risk.slimtable",
      "sas.ui.cpb3"
  ],
  version : "704001.32.0.20241213091100_f0rgf74p"
});

sas.risk.rgf.library={
	initialize:function(){
		$.ajaxSetup({jsonp:false});
	   jQuery.sap.require("sas.risk.rgf.util.RGFFixes");//patch it all up
	   jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
	   jQuery.sap.require("sas.risk.rgf.api.UtilsAPI");
      //Register Factories
      jQuery.sap.require("sas.risk.rgf.meta.ColumnFormatterFactory");
      jQuery.sap.require("sas.risk.rgf.nav.RGFActionProcessor");
      //Guard losing changes on window close
      jQuery(window).bind("beforeunload", function(e){
         if(sas.risk.rgf.util.RGFUtil.hasUnsavedChanges()){
            var rb = sas.risk.rgf.util.RGFUtil.getBundle();
            var message=rb.getText("form.unsaved.warning.txt");
            e.returnValue=message;
            return message;            
         }
      });
      //get ready in case of a timeout
      sas.risk.rgf.util.RGFUtil.handleTimeout();
      
	   var router=sap.ui.core.routing.Router.getRouter("router");
	   var callback=function(e){
	   	router.detachRouteMatched(callback);
	      //Hooking into logout link -- needs first route to be processed to determine if it is a child tab
	      var menuButton=sas.risk.rgf.util.RGFUtil.getLogoutLink();
	      if(sas.risk.rgf.util.RGFUtil.isMainTab()){//catch logout link event
	         menuButton.getMenu().detachItemSelected(sas.risk.rgf.util.RGFUtil.closeAllChildTabs);
	         menuButton.getMenu().attachItemSelected(sas.risk.rgf.util.RGFUtil.closeAllChildTabs);
	      }else{//hide logout link and global search when we are in a new tab
	         menuButton.setVisible(false);
	         var globalSearch=sas.risk.rgf.util.RGFUtil.getGlobalSearchField();
	         if(globalSearch){
	         	globalSearch.setVisible(false);//getting reverted later by unknonwn call
	         	globalSearch.setVisible=function(){};
	         }
	         sas.risk.rgf.util.RGFUtil.registerChildTab();
	      }
         //Hooking into HTML Commons: Global Search
      	sas.risk.rgf.util.RGFUtil.takeoverGlobalSearchField();
      	
      	//Notification polling interval
      	var notificationPollingInterval = sas.risk.rgf.api.CommonAPI.getNotificationPollingInterval();
         sas.log.debug("notificationPollingInterval=" + notificationPollingInterval);
      	if (notificationPollingInterval === -1) {
      		sas.risk.rgf.util.RGFUtil.getBanner().setShowNotifications(false);
      	} else if (notificationPollingInterval > 0) {
      		sas.risk.rgf.util.RGFUtil.getBanner().notificationsControl.notificationList.setPollingInterval(notificationPollingInterval);
      	}
	   };
	   router.attachRouteMatched(callback);

	   //Create content library
      jQuery.sap.require("sas.ui.mashup.api.AppAPI");
      sas.ui.mashup.api.AppAPI.getAppInfo().done(function(appInfo){
      	_.each(appInfo.getDependencies(),function(dep){
      		if(dep.name.startsWith("sas.risk.rgf.")){
      	      var contentId=dep.name.substring("sas.risk.rgf.".length);
      			jQuery.sap.declare("sas.risk.rgf."+contentId+".library");
      	      sas.risk.rgf[contentId].library={
      	   		initialize:function(){
      	   			return sas.risk.rgf.library.initializeContent();
      	   		}
      	      };
      		}
      	});
      });
      console.error("Initialized sas.risk.rgf Library");
      return $.Deferred().resolve();
	},
	initializeContent:function(){
	   //Register a CPB instance using the app Id we are running
	   jQuery.sap.require("sas.risk.rgf.data.RGFModelManagerObject");
	   jQuery.sap.require("sas.risk.rgf.api.RGFCpbObjectAPI");
	   jQuery.sap.require("sas.risk.rgf.api.RGFCpbQueryAPI");
	   jQuery.sap.require("sas.risk.rgf.api.RGFUIContextAPI");
	   jQuery.sap.require("sas.ui.cpb3.CPBService");
	   jQuery.sap.require("sas.ui.mashup.util.PerspectiveUtil");
	   var serviceId=sas.ui.mashup.util.PerspectiveUtil.getAppKey();
	   var cpbService=sas.ui.cpb3.CPBService.register(serviceId,{
	   	modelManagerObjectClass:sas.risk.rgf.data.RGFModelManagerObject,
	   	objectAPIClass:sas.risk.rgf.api.RGFCpbObjectAPI,
	   	queryAPI:new sas.risk.rgf.api.RGFCpbQueryAPI(),
	   	uiContextAPI:new sas.risk.rgf.api.RGFUIContextAPI(),
	   });
	   sas.risk.rgf.util.RGFUtil.setRestUrl("rest/"+serviceId);//TODO: RGFUtil no sharing between content ids
	   jQuery.sap.require("sas.ui.cpb3.layout.LayoutFactory");
	   jQuery.sap.require("sas.ui.cpb3.field.FieldFactory");
	   jQuery.sap.require("sas.ui.cpb3.components.CpbComponentFactory");
	   jQuery.sap.require("sas.risk.rgf.components.ComponentFactory");
	   cpbService.getWidgetRegistry().registerFactory(sas.ui.cpb3.layout.LayoutFactory);      
	   cpbService.getWidgetRegistry().registerFactory(sas.ui.cpb3.field.FieldFactory);
	   cpbService.getWidgetRegistry().registerFactory(sas.ui.cpb3.components.CpbComponentFactory);
	   cpbService.getWidgetRegistry().registerFactory(sas.risk.rgf.components.ComponentFactory);
		//Load User Preferences
	   return $.when(//TODO: RGFUtil needs to be more content id specific to allow two diff content comps to be on same page 
	   		sas.ui.mashup.api.AppAPI.getAppInfo(),
	   		sas.risk.rgf.api.CommonAPI.loadUserDetails(),
	   		sas.risk.rgf.api.CommonAPI.loadCPB3Resources(),
	         sas.risk.rgf.api.CommonAPI.loadTaskTypes(),
	         sas.risk.rgf.api.UtilsAPI.getVisibleRowCounts(),
	         sas.risk.rgf.api.UtilsAPI.loadRestMediaTypes(),
	         sas.risk.rgf.api.CommonAPI.loadDataLoaders(),
	         sas.risk.rgf.api.CommonAPI.loadDefaultMultiEval(),
	         sas.risk.rgf.api.CommonAPI.loadGZIPCompressionThreshold(),
	         sas.risk.rgf.api.CommonAPI.loadMultiEvalPayloadDebugging(),
	         sas.risk.rgf.api.CommonAPI.loadConfigdataOptions()
	   ).done(function(appInfo){
	   	//register all the biz comps
	   	jQuery.sap.require("sas.ui.cpb3.bizcomp.ObjectBizComp");
	   	jQuery.sap.require("sas.risk.rgf.bizcomp.RGFQueryBizComp");
	   	jQuery.sap.require("sas.risk.rgf.bizcomp.RGFObjectBizComp");
	   	jQuery.sap.require("sas.ui.cpb3.bizcomp.ScreenEditorBizComp");
	   	jQuery.sap.require("sas.ui.cpb3.bizcomp.ExternalViewerBizComp");
	   	jQuery.sap.require("sas.risk.rgf.bizcomp.ScreenDefEditorBizComp");
	      var menu=appInfo.getMenu();
	   	var libName="sas.risk.rgf."+appInfo.getAppId();
	   	var library={};
	   	var mediaTypes=sas.risk.rgf.api.UtilsAPI.getRestMediaTypes();
	   	var typeMap=_.reduce(mediaTypes,function(memo,type){
	   		memo[type.screenId]=type.restUri;
	   		return memo;
	   	},{});
	   	_.each(appInfo.getPages(),function(page){
	   		_.each(page.getComponentInfos(),function(comp){
	   			if(comp.libName===libName){
	   				if(comp.name.charAt(1)!=="_"){return;}//skip pages not prefixed with X_...
	   				var shortName=comp.name.substring(2);
	   				switch(comp.name.charAt(0)){
	   					case "O":
	   						library[comp.name]=new sas.risk.rgf.bizcomp.RGFObjectBizComp({serviceId:serviceId,libName:libName,name:shortName,screenId:shortName,objectType:typeMap[shortName]});
	   						sas.ui.cpb3.bizcomp.ScreenEditorBizComp.registerUrl(page.getPageId(),shortName);
   						break;
	   					case "Q":
	   						library[comp.name]=new sas.risk.rgf.bizcomp.RGFQueryBizComp({serviceId:serviceId,libName:libName,name:shortName,screenId:shortName});
	   						sas.ui.cpb3.bizcomp.ScreenEditorBizComp.registerUrl(page.getPageId(),shortName);
   						break;
	   					case "S":
	   						library[comp.name]=new sas.ui.cpb3.bizcomp.ScreenEditorBizComp({serviceId:serviceId,libName:libName,name:shortName,screenId:shortName});
   						break;
	   					case "E":
	   						library[comp.name]=new sas.ui.cpb3.bizcomp.ExternalViewerBizComp({libName:libName,name:shortName});
	   				      //Register Menu URLs for External Viewers
	   						var menuItem=menu.findMenuItem(shortName);
	   						if(menuItem){
	   							sas.ui.cpb3.bizcomp.ExternalViewerBizComp.registerUrl(shortName,menuItem.getContext()["target_url"]);
	   						}
   						break;
	   					case "D":
	   						library[comp.name]=new sas.risk.rgf.bizcomp.ScreenDefEditorBizComp({serviceId:serviceId,libName:libName,name:shortName,screenId:shortName});
   						break;
	   				}
	   			}
	   		});
	   	});
	   	sas.ui.mashup.LibRegistry.registerLib(libName,library);
		   var router=sap.ui.core.routing.Router.getRouter("router");
		   var callback=function(e){
		   	router.detachRouteMatched(callback);
		      var userDetails=sas.risk.rgf.api.CommonAPI.getUserDetails();
		      var banner=sas.risk.rgf.util.RGFUtil.getBanner();
		      //Hooking into HTML Commons: Impersonation
		      if(userDetails.getImpersonatedName()){
		         banner.setUserName(userDetails.getImpersonatedName()+ " ("+userDetails.getName()+")");
		      }
		   };
		   router.attachRouteMatched(callback);
	      cpbService.setBundle(sas.risk.rgf.util.RGFUtil.getBundle());//this one requires loadCPB3Resources to complete
	      jQuery.sap.require("sas.risk.common.widgets.spreadsheet.SpreadsheetUtil");
	      sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.setBundle(sas.risk.rgf.util.RGFUtil.getBundle());
	      jQuery.sap.require("sas.risk.slimtable.util.SlimTableUtil");
	      sas.risk.slimtable.util.SlimTableUtil.setBundle(sas.risk.rgf.util.RGFUtil.getBundle());
	      sas.ui.cpb3.CpbUtil.setLocale(sas.risk.rgf.util.RGFUtil.getLocale());//this one requires loadUserDetails to complete
	      sas.risk.slimtable.util.SlimTableUtil.setLocale(sas.risk.rgf.util.RGFUtil.getLocale());
	      sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.setLocale(sas.risk.rgf.util.RGFUtil.getLocale());
	      console.error("Initialized "+libName+" Library");
	   });
	}
};
