jQuery.sap.declare("sas.risk.rgf.meta.QueryMeta");
jQuery.sap.require("sas.risk.slimtable.meta.QueryMeta");
jQuery.sap.require("sas.risk.rgf.meta.filter.IsUnderFilter");

sas.risk.rgf.meta.QueryMeta=function(){
	sas.risk.slimtable.meta.QueryMeta.apply(this,arguments);
	this.orderedColumns=[]; //specific to RGF
	this.setToStringHook(this.rgfToStringHook);
};
//RGF version of QueryMeta extends the generic one from slimtable since it needs to handle additional query for example location
sas.risk.rgf.meta.QueryMeta.prototype=Object.create(sas.risk.slimtable.meta.QueryMeta.prototype);

sas.risk.rgf.meta.QueryMeta.prototype.clone=function(){
	var cloneFilters=_.mapObject(this.filters,function(filter){return filter?filter.clone():filter;});
	var qMeta=new sas.risk.rgf.meta.QueryMeta(cloneFilters,this.sortName,this.sortDirection,this.limit,this.start);
	qMeta.setLocation(this.getLocation());
	qMeta.setOrderedColumns(this.getOrderedColumns() ? this.getOrderedColumns().slice(0) : []);
	return qMeta;
},
sas.risk.rgf.meta.QueryMeta.prototype.rgfToStringHook=function(filters){
	if(this.locationPoints){
		filters["SIMPLE"]=this._mergeFilter(filters["SIMPLE"],new sas.risk.rgf.meta.filter.IsUnderFilter(this.locationPoints),true);
	}
	return filters;
};
sas.risk.rgf.meta.QueryMeta.prototype.getLocation=function(){
	if(!this.locationPoints){return null;}
	return this.locationPoints.length+"|"+this.locationPoints.join("|")+"|"; /*I18nOK:LINE*/
};
sas.risk.rgf.meta.QueryMeta.prototype.setLocation=function(location){
	if(location){
		var splits=location.split("|");
		splits.shift();
		splits.pop();
		if(splits.length){
			this.locationPoints=splits;
		}
	}
	else{
		this.locationPoints=null;
	}
};
sas.risk.rgf.meta.QueryMeta.prototype.getLocationPoints=function(){
   return this.locationPoints ? this.locationPoints.join(",") : null;
};
sas.risk.rgf.meta.QueryMeta.prototype.setLocationPoints=function(points){
	this.locationPoints=points;
};
sas.risk.rgf.meta.QueryMeta.prototype.matchLocationPoints=function(locPoints){
   if(!this.locationPoints && !locPoints) return true; 
   if((this.locationPoints && !locPoints) || (!this.locationPoints && locPoints)) return false;
    if(this.locationPoints.length !== locPoints.length) return false;
    return this.locationPoints.sort().join() === locPoints.sort().join();
};
sas.risk.rgf.meta.QueryMeta.prototype.equal=function(qMeta,ignorePaging){
	var isEqual=sas.risk.slimtable.meta.QueryMeta.prototype.equal.apply(this,arguments);
	console.warn("MATCHLOC",this.locationPoints,this.matchLocationPoints(qMeta.locationPoints),qMeta.locationPoints);
	return isEqual && this.matchLocationPoints(qMeta.locationPoints); 
};
sas.risk.rgf.meta.QueryMeta.prototype.delta=function(qMeta){
	var deltas=sas.risk.slimtable.meta.QueryMeta.prototype.delta.apply(this,arguments);
	if(!this.matchLocationPoints(qMeta.locationPoints)){deltas.push("LOCATION");}
	return deltas;
};