jQuery.sap.declare("sas.risk.rgf.meta.filter.FilterMetaFactory");
jQuery.sap.require("sas.risk.rgf.meta.filter.IsUnderFilter");
jQuery.sap.require("sas.risk.rgf.util.search.RGFFilterHandlerFactory");
jQuery.sap.require("sas.risk.slimtable.meta.filter.StringFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.BooleanFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.DateFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.TimestampFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.NumberFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.ValueFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.AndFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.OrFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.ObjectLinkFilter");

sas.risk.rgf.meta.filter.FilterMetaFactory={
		createFilterFromJson:function(json,tableMeta){
			var def=$.Deferred();
			if(json){
				var filter=sas.risk.rgf.meta.filter.FilterMetaFactory._hydrateFilter(json);
				sas.risk.rgf.meta.filter.FilterMetaFactory.resolveLabels(filter,tableMeta).done(function(){
					def.resolve(filter);
				});
			}else{
				def.resolve(null);
			}
			return def;
		},
		_hydrateFilter:function(j){
			switch(j.type){
				case "sas.risk.slimtable.meta.filter.StringFilter":
					return new sas.risk.slimtable.meta.filter.StringFilter(j.name,j.operator,j.value&&j.value.replace(/^[']+(.*)[']+$/,"$1"));
				case "sas.risk.slimtable.meta.filter.BooleanFilter":
					return new sas.risk.slimtable.meta.filter.BooleanFilter(j.name,j.operator,j.value);
				case "sas.risk.slimtable.meta.filter.DateFilter":
					return new sas.risk.slimtable.meta.filter.DateFilter(j.name,j.operator,j.value&&new Date(j.value));
				case "sas.risk.slimtable.meta.filter.TimestampFilter":
					return new sas.risk.slimtable.meta.filter.TimestampFilter(j.name,j.operator,j.value&&new Date(j.value));
				case "sas.risk.slimtable.meta.filter.NumberFilter":
					return new sas.risk.slimtable.meta.filter.NumberFilter(j.name,j.operator,j.value);
				case "sas.risk.slimtable.meta.filter.ValueFilter":
					return new sas.risk.slimtable.meta.filter.ValueFilter(j.name,j.operator,j.value);
				case "sas.risk.rgf.meta.filter.IsUnderFilter":
					return new sas.risk.rgf.meta.filter.IsUnderFilter(j.value&&j.value.split(","));
				case "sas.risk.slimtable.meta.filter.AndFilter":
					var and=new sas.risk.slimtable.meta.filter.AndFilter();
					for(var i=0;i<(j.children||[]).length;i++){
						and.addFilter(sas.risk.rgf.meta.filter.FilterMetaFactory._hydrateFilter(j.children[i]));
					}
					return and;
				case "sas.risk.slimtable.meta.filter.OrFilter":
					var or=new sas.risk.slimtable.meta.filter.OrFilter();
					for(var i=0;i<(j.children||[]).length;i++){
						or.addFilter(sas.risk.rgf.meta.filter.FilterMetaFactory._hydrateFilter(j.children[i]));
					}
					return or;
				case "sas.risk.slimtable.meta.filter.ObjectLinkFilter":
					return new sas.risk.slimtable.meta.filter.ObjectLinkFilter(j.name,j.operator,j.value);
			}
		},
		resolveLabels:function(filter,tableMeta){
			var def=$.Deferred();
			var defs=[];
			var array=filter.toArray();
			var i,f,colMeta;
			for(i=0;i<array.length;i++){
				f=array[i];
				colMeta=tableMeta.getColumnByName(f.getName());
				f.setNameLabel(colMeta.getColLabel());
				defs.push(sas.risk.rgf.util.search.RGFFilterHandlerFactory.getInstance().getHandler(colMeta).updateFilterValueLabel(f));
			}
			$.when.apply($,defs).done(function(){def.resolve();});
			return def;
		}
};
