jQuery.sap.declare("sas.risk.rgf.meta.formatter.BulkResultFormatter");
jQuery.sap.require("sas.risk.slimtable.meta.formatter.AFormatter");

sas.risk.rgf.meta.formatter.BulkResultFormatter=function(){
	sas.risk.slimtable.meta.formatter.AFormatter.apply(this,arguments);
};

sas.risk.rgf.meta.formatter.BulkResultFormatter.prototype=Object.create(sas.risk.slimtable.meta.formatter.AFormatter.prototype);

sas.risk.rgf.meta.formatter.BulkResultFormatter.prototype.calcWidthWeight=function(td){
	var length=sas.risk.slimtable.meta.formatter.AFormatter.prototype.calcWidthWeight.apply(this,arguments);
	return length+9;//make room for icon and info button
};
sas.risk.rgf.meta.formatter.BulkResultFormatter.prototype.format=function(columnMeta,rowData,parent,extra){
	sas.risk.slimtable.meta.formatter.AFormatter.prototype.format.apply(this,arguments);
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	var input=columnMeta.extractValue(rowData);
	if(!parent){//return text value for sorting
		return input?(input.success?"Success":"Failure"):"";
	}
	var isUpdate=!!parent.children.length;
	var label=isUpdate?parent.children[0]:document.createElement("LABEL");
	var result="";
	if(input){
		if(input.success){
			result=rb.getText("bulkAction.table.col.result.successful.txt");
			label.className="sapMLabel sapMLabelMaxWidth sasMLabel BulkSuccessMark";
		}else{
			result=rb.getText("bulkAction.table.col.result.failed.txt");
			var detail=document.createElement("SPAN");
			detail.className="BulkErrorDetails";
			var errors={
				message:rb.getText("bulkAction.failed.txt"),
				details:input.messages
			}
			detail.onmousedown=(function(){
				jQuery.sap.require("sas.risk.common.widgets.MessageDetailsBox");
				sas.risk.common.widgets.MessageDetailsBox.error(errors,sas.config.appName, sas.risk.rgf.util.RGFUtil.getBundle())
			});
			label.className="sapMLabel sapMLabelMaxWidth sasMLabel BulkErrorMark";
		}
	}else{
		result="";
		label.className="sapMLabel sapMLabelMaxWidth sasMLabel";
	}
	if(isUpdate){
		label.childNodes[0].nodeValue=result;
		if(label.children.length){
			label.removeChild(label.children[0]);
		}
	}else{
		label.appendChild(document.createTextNode(result));
		parent.appendChild(label);
	}
	if(detail){
		label.appendChild(detail);
	}
};
