jQuery.sap.declare("sas.risk.rgf.meta.formatter.CalendarEntryFormatter");
jQuery.sap.require("sas.risk.slimtable.meta.formatter.AFormatter");

sas.risk.rgf.meta.formatter.CalendarEntryFormatter=function(){
	sas.risk.slimtable.meta.formatter.AFormatter.apply(this,arguments);
};

sas.risk.rgf.meta.formatter.CalendarEntryFormatter.prototype=Object.create(sas.risk.slimtable.meta.formatter.AFormatter.prototype);

sas.risk.rgf.meta.formatter.CalendarEntryFormatter.prototype.format=function(columnMeta,rowData,parent,extra){
	sas.risk.slimtable.meta.formatter.AFormatter.prototype.format.apply(this,arguments);
	var input=columnMeta.extractValue(rowData);
	if(input===null||input===undefined){input="";}
	if(parent.children.length==2){
		var div1=parent.children[0];
		var div2=parent.children[1];
		if(input.planned){
			var percentWidth=100*(input.planned.end-input.planned.start+1)/(input.planned.daysInMonth);
			var percentLeft=100*(input.planned.start-1)/(input.planned.daysInMonth);
			div1.style.width=percentWidth+"%";
			div1.style.left=percentLeft+"%";
			div1.title=input.planned.description;
			div1.style.backgroundColor=input.planned.color;
		}else{
			div1.style.width=0;
			div1.title="";
		}
		if(input.actual){
			var percentWidth=100*(input.actual.end-input.actual.start+1)/(input.actual.daysInMonth);
			var percentLeft=100*(input.actual.start-1)/(input.actual.daysInMonth);
			div2.style.width=percentWidth+"%";
			div2.style.left=percentLeft+"%";
			div2.title=input.actual.description;
			div2.style.backgroundColor=input.actual.color;
		}else{
			div2.style.width=0;
			div2.title="";
		}
	}else{//document.createTextNode(input)
		var div1=document.createElement("div");
		div1.className="RGFCalPlanned";
		div1.appendChild(document.createTextNode(" "));
		var div2=document.createElement("div");
		div2.appendChild(document.createTextNode(" "));
		div2.className="RGFCalActual";
		if(input.planned){
			var percentWidth=100*(input.planned.end-input.planned.start+1)/(input.planned.daysInMonth);
			var percentLeft=100*(input.planned.start-1)/(input.planned.daysInMonth);
			div1.style.width=percentWidth+"%";
			div1.style.left=percentLeft+"%";
			div1.title=input.planned.description;
			div1.style.backgroundColor=input.planned.color;
		}else{
			div1.style.width=0;
			div1.title="";
		}
		if(input.actual){
			var percentWidth=100*(input.actual.end-input.actual.start+1)/(input.actual.daysInMonth);
			var percentLeft=100*(input.actual.start-1)/(input.actual.daysInMonth);
			div2.style.width=percentWidth+"%";
			div2.style.left=percentLeft+"%";
			div2.title=input.actual.description;
			div2.style.backgroundColor=input.actual.color;
		}else{
			div2.style.width=0;
			div2.title="";
		}
		parent.appendChild(div1);
		parent.appendChild(div2);
	}
};
