jQuery.sap.declare("sas.risk.rgf.meta.formatter.CommentsFormatter");
jQuery.sap.require("sas.risk.slimtable.meta.formatter.AFormatter");

sas.risk.rgf.meta.formatter.CommentsFormatter=function(){
	sas.risk.slimtable.meta.formatter.AFormatter.apply(this,arguments);
};

sas.risk.rgf.meta.formatter.CommentsFormatter.prototype=Object.create(sas.risk.slimtable.meta.formatter.AFormatter.prototype);

sas.risk.rgf.meta.formatter.CommentsFormatter.prototype.format=function(columnMeta,rowData,parent,extra){
	sas.risk.slimtable.meta.formatter.AFormatter.prototype.format.apply(this,arguments);
	var tempInput=jQuery.sap._sanitizeHTML(columnMeta.extractValue(rowData));
	var input=DOMPurify.sanitize(tempInput,{KEEP_CONTENT: false});
	if(!parent){//return the text content for search
		var tempElem=document.createElement("SPAN");
		tempElem.innerHTML=input;
		return tempElem.textContent;
	}
	var slimTable=extra.source.getTable();
	var rgfTable=slimTable.getParent();
	var commentsComponent=rgfTable.getParent();
	var total=extra.source.getData().length-1;
	var tableMeta=extra.source.getTableMeta();
	var rowIdx=extra.rowIndex;
	var commentTimeStamp=sas.risk.rgf.util.RGFUtil.toLongTimeStampString(rowData.commentDttm);
	var mouseDownFunc=function(){return function(){
		var author=rowData.author;
		var links=rowData.links;
		if(links){//find link with rel=author
			var i;
         for (i = 0; i < links.length; i++){
            if (links[i].rel === "author" && links[i].title){
               author=links[i].title;
               break;
            }
         }
		}
		var viewData={
				meta:commentsComponent.meta,
 				timestamp:commentTimeStamp,
 				user:author,
 				commentText: rowData.commentText,
 				title:commentsComponent.meta.viewCommentLabel
 		};
		sas.risk.rgf.util.DialogManager.open("ViewCommentDialog",viewData);
	};};
	if(parent.children.length){
		var content=$(parent).find(".CommentsCell")[0];
//		$($(parent).find(".CommentsCell")[0]).find(".CommentsTxt")[0].innerHTML=input;
//		$($(parent).find(".CommentsCell")[0]).find(".CommentsIcon")[0].onmousedown=mouseDownFunc();
		parent.removeChild(content);
		sas.risk.rgf.components.CommentsComponent.prototype.actionCreateCommentCell(parent,input,mouseDownFunc());
	}else{
		sas.risk.rgf.components.CommentsComponent.prototype.actionCreateCommentCell(parent,input,mouseDownFunc());
	}
};

