jQuery.sap.declare("sas.risk.rgf.meta.formatter.TimestampFormatter");
jQuery.sap.require("sas.risk.slimtable.meta.formatter.AFormatter");
jQuery.sap.require("sas.ui.cpb3.model.type.CpbDate");

sas.risk.rgf.meta.formatter.TimestampFormatter=function(){
	sas.risk.slimtable.meta.formatter.AFormatter.apply(this,arguments);
};

sas.risk.rgf.meta.formatter.TimestampFormatter.prototype=Object.create(sas.risk.slimtable.meta.formatter.AFormatter.prototype);

//RGF specific Timestamp formatter
sas.risk.rgf.meta.formatter.TimestampFormatter.prototype.format=function(columnMeta,rowData,parent,extra){
	sas.risk.slimtable.meta.formatter.AFormatter.prototype.format.apply(this,arguments);
	var input=columnMeta.extractValue(rowData);
	// RGFRMWRK-437 Needed for Administration/FinancialData/ExchangeRates screen
	//FIXME https://rndjira.sas.com/browse/RGFRMWRK-437
	//FIXME Thai: date and time under Data Created are not converted for different calendar
	// Use CpbDate to get the Thai solar year handling
	//var dateTime = new sap.ui.model.type.DateTime({source: {pattern: "yyyy-MM-ddTHH:mm:ss.SSSz"}, style: "medium"});
	var dateTime = new sas.ui.cpb3.model.type.CpbDate({source: {pattern: "yyyy-MM-ddTHH:mm:ss.SSSz"}, style: "medium"});
	var output=dateTime.formatValue(input,"string");
	if(!parent){return output;}
	parent.setAttribute("title",output);
	if(parent.childNodes.length){
		var content=parent.childNodes[0];
		content.nodeValue=output;
		parent.appendChild(content);
	}else{
		parent.appendChild(document.createTextNode(output));
	}
};

