jQuery.sap.declare("sas.risk.rgf.nav.ScreenDefEditorToolbarActions");
jQuery.sap.require("sas.ui.cpb3.model.CpbScreenEditorModel");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutRenderer");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.rgf.util.NavigationUtil");
jQuery.sap.require("sas.risk.rgf.api.ScreenDefinitionsAPI");
jQuery.sap.require("sas.hc.m.MessageToast");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");


sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.risk.rgf.nav.ScreenDefEditorToolbarActions",{
	metadata:{
		properties:{
			comp:{type:"any"},
			template:{type:"any"}
		}
	},
	renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
});
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.applySettings=function(){
	sas.risk.common.layout.flexlayout.FlexLayout.prototype.applySettings.apply(this,arguments);
	this.saveButton=this.createSaveButton();
	this.closeButton=this.createCloseButton();
	this.addItem(this.saveButton);
	this.addItem(this.closeButton);
};
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.createCloseButton=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	return new sas.risk.common.widgets.Button({
		text:rb.getText("form.button.close.txt"),
		press: $.proxy(this.actionCloseCheck,this)
	}).addStyleClass("FormCloseButton").setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexShrink:0}));
};
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.createSaveButton=function(){
	var that=this;
	return new sas.risk.common.widgets.Button({
		icon: sas.icons.HC.SAVE,
		press: function(){
			that.actionSave();
		},
		enabled:{
			parts:[sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().bindScreenPath("/isDirty")],
			formatter:function(isDirty){
				return !!isDirty;
			}
		}
	}).addStyleClass("FormSaveButton");
};
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.actionSave=function(){
	sas.ui.mashup.App.getInstance().setBusy(true);
	var comp=this.getComp();
	var screenXML=comp.codeEditor.getText();
	var screenRk=comp.getScreenRk();
	var that=this;
	sas.risk.rgf.api.ScreenDefinitionsAPI.saveScreen(screenRk,screenXML).done(function(json){
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().applyScreenUpdate("isDirty",false);
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().applyScreenUpdate("ETAG",json["ETAG"]);
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().refreshErrorModel(json);
		sas.ui.cpb3.CpbUtil.fireStorageEvent('reload',{type:"screenDefinitions",key:screenRk},true);
	}).fail(function(json){
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().refreshErrorModel(json);
	}).always(function(){
		sas.ui.mashup.App.getInstance().setBusy(false);		
	});
};
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.actionCloseCheck = function(e){
	if(this.saveButton.getEnabled()){
		var rb=sas.risk.rgf.util.RGFUtil.getBundle();
		var answer=confirm(rb.getText("form.unsaved.warning.txt"));
		if(answer){
			this.actionClose();
		}
	}else{
		this.actionClose();
	}
};
sas.risk.rgf.nav.ScreenDefEditorToolbarActions.prototype.actionClose = function(e) {
	var parentType=_.find(sas.risk.rgf.api.UtilsAPI.getRestMediaTypes(),function(type){
		return type.boTypeNm==="screenDefinition"
	});
	sas.ui.cpb3.nav.NavUtil.getInstance().navTo(
		this.getComp(),
		{
			event_name:"close_object"
		}
	);
};