jQuery.sap.declare("sas.risk.rgf.util.LBOLinkDialogUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.slimtable.plugins.Search");
jQuery.sap.require("sas.risk.slimtable.plugins.TableOptions");
jQuery.sap.require("sas.risk.slimtable.plugins.Filter");
jQuery.sap.require("sas.risk.slimtable.plugins.Counter");
jQuery.sap.require("sas.risk.slimtable.plugins.Pager");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.ui.cpb3.CPBService");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");

sas.risk.rgf.util.LBOLinkDialogUtil={
		createContent:function(controller,view,config){
			view.addStyleClass("rgfObjectViewPopup");
			view.tableRestDone=false;
			view.draftLinkInstanceRestDone=false;
			var viewData=view.getViewData();
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			sas.risk.rgf.util.LBOLinkDialogUtil.createButtons(controller,view,config);
			view.cpbForm=new sas.ui.cpb3.CPBForm({
				serviceId: viewData.serviceId,
				screenId: "LinkInstance",
				data: sas.ui.cpb3.model.CpbModelManager.bindData('/'),
				cpbModelManager:sas.ui.cpb3.CPBService.getInstance(viewData.serviceId).createModelManagerObject()
			});
			view.layout=new sas.risk.common.layout.flexlayout.FlexLayout({
				flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
				items:[
				   sas.ui.cpb3.CpbUtil.createMessagesPanel(),
					view.cpbForm
				]
			}).addStyleClass("cpbContentArea cpbContentAreaDialog");
			view.layout.getCpbForm=function(){return view.cpbForm;};//for column picker :/
			if(config.showTable){
				if(viewData.isLocated && viewData.showLocationChooser){
					view.dimLoc=new sas.risk.rgf.widget.dimloc.DimensionalLocation({
						title:rb.getText("lbo.add.dialog.dimloc.title.txt"),
						isEverywhereAllowed:false,
						isForFiltering:true,
						isPoint:false,
						isRootVisible:true,
						feature:viewData.targetFeature,
						favorites:viewData.favorites,
						secureActionVal:"R"
					});
					view.layout.addItem(view.dimLoc);
				}
				var qp=viewData.queryProcessor;
				var fetchData=function(query){
					var baseUrl=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/"+viewData.collectionName;
					var params=null;
					if(qp){
						switch(qp.type){
							case "UserQuery":
								var handle=viewData.location||"1|10000|";//(eveywhere)
								var objectType=viewData.sourceTypeName;
								var action="'"+(qp.action||"")+"'";
								params={filter:"secureUserQueryProcessor("+action+",'"+objectType+"','"+handle+"','"+qp.showSuperUsers+"','"+qp.roles.join("','")+"')"};				
							break;
							case "FilterExpression":
								params={filter:qp.filter};
							break;
						}
					}else{
						params={};
						if(viewData.targetFeature && viewData.targetFeature.getName()==="User"){
							params.activeFlg=true;
						}
					}
					var url=baseUrl+"?"+(params?$.param(params)+"&":"")+query.toString();
					return $.getJSON(url);
				};
				var getTableMenuItems=function(){
					var menuItems=[new sas.risk.slimtable.widget.menu.AdvSearchItem(),new sas.risk.rgf.widget.menu.ColumnsItem({serviceId:viewData.serviceId})];
					var customizationInfoMeta=viewData.tableMeta.customizationInfoMeta;
					if(customizationInfoMeta){
						var custInfoUrl=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/utils/showCustomizationInfo/boTypeNm/"+customizationInfoMeta.boType;
						menuItems.push(new sas.risk.rgf.widget.menu.CustomizationInfoItem({url:custInfoUrl,meta:customizationInfoMeta}));
					}
				   return menuItems;
				};
				view.table=new sas.risk.rgf.widget.RGFTable({
					formattingKey:viewData.formattingKey,
					showSelectionControls:true,
					location:viewData.isLocated?viewData.location:null,
					multiSelect:viewData.multiSelect,
					data: fetchData,
					meta: viewData.tableMeta,
					visibleRows: viewData.tableMeta.dialogVisibleRows,
					plugins:[new sas.risk.slimtable.plugins.Search(),
			               new sas.risk.slimtable.plugins.Filter(),
			               new sas.risk.slimtable.plugins.TableOptions({
			              	  menuItems: getTableMenuItems()
			                }),
			               new sas.risk.slimtable.plugins.Counter(),
			               new sas.risk.slimtable.plugins.Pager()
			      ],
					rowSelect:function(){
						sas.risk.rgf.util.LBOLinkDialogUtil.actionRowSelected(controller);
					},
					preselection:function(source){
						var data=source.getData();
						var selections=source.getSelections();
						var i;
						for(i=0;i<data.length;i++){
							if(viewData.linkIds.indexOf(data[i].key)!==-1 && selections.indexOf(i)===-1){
								selections.push(i);
							}
						}
					},
					disablement:function(source){
						var data=source.getData();
						var disableds=[];
						var i,key;
						if(viewData.multiSelect){
							for(i=0;i<data.length;i++){
								key=data[i].key;
								if(viewData.linkIds.indexOf(key)!==-1 || (viewData.equalTypes && viewData.sourceObjectKey===key)){
									disableds.push(i);
								}
							}
							source.setDisableds(disableds);
						}
					}
				});
				if(viewData.isLocated && viewData.showLocationChooser){
					view.dimLoc.attachChange(function(event){
						view.table.setLocation(event.getParameter("newValue"));
						view.table.doRefresh();
					});
				}
				//When the table preference changes, update the local table meta json's column information accordingly        
		      view.table.attachEvent("tablePreferenceChanged",function(event){
		    	  var colNames=event.getParameter("rawColumnNames");
		    	  sas.risk.slimtable.meta.TableMeta.updateTableMetaJsonUserDisplayColumns(viewData.tableMeta,colNames);
		      });
	         view.table.attachEvent("dataReceived",function(event){
	   			view.tableRestDone=true;
	   			if (view.tableRestDone && view.draftLinkInstanceRestDone) {
	         		view.okButton.setEnabled(true);	         	
	   			}
	         });
				view.layout.addItem(view.table);				
			}
			return view.layout;
		},
		createButtons : function(controller,view,config) {
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			view.okButton = new sas.risk.common.widgets.Button({
				text : rb.getText(config.buttonOkLabel),
				press : $.proxy(controller.actionOk,controller)
			});			
			view.okButton.setEnabled(false);
			view.cancelButton = new sas.risk.common.widgets.Button({
				text : rb.getText(config.buttonCancelLabel),
				press : $.proxy(controller.actionCancel,controller)
			});
		},
		actionRowSelected:function(controller){
			var hasNewSelections=!!controller.doGetNewSelections().length;
			if (!sas.risk.rgf.util.LBOLinkDialogUtil.isChooser(controller)) {
				controller.getView().okButton.setEnabled(hasNewSelections);
			}
		},
		onInit : function(controller){
			var view=controller.getView();
			var cpbModelManager=view.getCpbForm().getCpbModelManager();
			var viewData=view.getViewData();
			var overrides=$.extend({},viewData.linkType,viewData.PREVIOUSBUSINESSOBJECT);
			var link=viewData.link;
			if(link && link.getPageContext()){//opened before, saved and draft-revisit
				overrides=$.extend({},link.getPageContext().cpb_data,overrides);
			}
			if(!link || !link.getKey() || link.lastModifiedDttm == undefined){//new draft 
				view.getCpbForm().getCpbAPI().createObjectContext("LinkInstance","linkInstances",null,overrides).done(function(json) {
					link&&link.setPageContext(json);
					cpbModelManager.refresh(json,view);
					if(viewData.isLocated && viewData.showLocationChooser){
						view.dimLoc.setHandle(viewData.location);
					}
					
					view.draftLinkInstanceRestDone=true;
	   			if (view.tableRestDone && view.draftLinkInstanceRestDone) {
	         		view.okButton.setEnabled(true);	         	
	   			}
				});
			}else{//saved before but not visited  // pass in extra variables to cpb for initialize block
				view.getCpbForm().getCpbAPI().loadObjectContext("LinkInstance","linkInstances",link.getKey(),overrides).done(function(pageContext) {
					link.setPageContext(pageContext);
					cpbModelManager.refresh(pageContext,view);
					
					view.draftLinkInstanceRestDone=true;
	   			if (view.tableRestDone && view.draftLinkInstanceRestDone) {
	         		view.okButton.setEnabled(true);	         	
	   			}
         		
				}).fail(function(){
					view.getDialog().close();
				});
			}
		},
		validateContext:function(controller){
         var view=controller.getView();
         var viewData=view.getViewData();
         var cpbForm=view.getCpbForm();
         cpbForm.updateUIContextWithRequiredFields(view);
         var uiContext=cpbForm.getCpbModelManager().getUIContext(view);
         var key=uiContext.LINKINSTANCERK;
         return view.getCpbForm().getCpbAPI().validateObjectContext("linkInstances",key,uiContext,null);
		},
		isChooser:function(controller){
			return controller.getView().getViewData().formattingKey[3]==="LinkedBusinessObjectChooserComponent";
		}
};