jQuery.sap.declare("sas.risk.rgf.util.RGFFixes");

sas.risk.rgf.util.RGFFixes={};
_.differenceObj=function(obj1,obj2,comparator){
	return _.filter(obj1,function(o1){
		return !_.some(obj2,comparator&&_.partial(comparator,o1)||function(o2){
			return o1.equals(o2);
		})
	});
};
//jQuery.sap.require("sas.hc.ui.core.IconPool");
jQuery.sap.require("sas.hc.ui.core.theme.IconInitialization");
//Based on comment on sas/hc/ui/core/messagebundle.properties related to __0__ tooltips
var iconsWithNoTooltip=[sas.icons.HC.ARROWSMALLDOWNBTN,sas.icons.HC.ARROWSMALLRIGHTBTN];
_.each(iconsWithNoTooltip,function(src){
	var iconInfo=sap.ui.core.IconPool.getIconInfo(src);
	if(iconInfo.customData && iconInfo.customData.getKey()==="sas-commons-iconName"){
		iconInfo.customData.setValue("");//make tooltip empty string instead of __0__
	}
});

jQuery.sap.require('sas.hc.ui.commons.SessionTimeoutDialog');
sas.hc.ui.commons.SessionTimeoutDialog.__ORIG__show=sas.hc.ui.commons.SessionTimeoutDialog.show;
sas.hc.ui.commons.SessionTimeoutDialog.show=function(warningDuration,callback,suppressEvent){
	if(!suppressEvent){//main tab only
		sas.ui.cpb3.CpbUtil.fireStorageEvent("SESSION_WARNING",{duration:warningDuration});//let child tabs know is time to show the warning
	}
	var wrappedCallback=function(result){//main tab only, sniff out the choice made on main tab
		if(result===sas.hc.ui.commons.SessionTimeoutDialog.Action.LOGOFF){
			sas.eventBus.publish(sas.timeoutManager.events.BEFORE_TIME_OUT);//let child tabs know its time to close window
		}else{
			sas.ui.cpb3.CpbUtil.fireStorageEvent("SESSION_WARNING_CLOSEDIAG",{close:true});//let child tabs know to close dialog only
		}
		callback(result);
	};
	sas.hc.ui.commons.SessionTimeoutDialog.__ORIG__show(warningDuration,!suppressEvent?wrappedCallback:callback);
};



//FIXME https://rndjira.sas.com/browse/RGFRMWRK-551
//FIXME CRP:GCM - currency input check is failing for PT locale.
//FIXME RGFRMWRK-666 - fix currency input validation for fr-fr and ru-ru locale
jQuery.sap.require('sap.ui.core.library');
jQuery.sap.require('sap.ui.core.Configuration');
sap.ui.core.Configuration.prototype.__ORIG__getFormatLocale = sap.ui.core.Configuration.prototype.getFormatLocale;
sap.ui.core.Configuration.prototype.getFormatLocale = function () {
	var myFormatLocale = (this.formatLocale || this.language).toString();
	if (myFormatLocale === "pt" || myFormatLocale.toLowerCase() === "pt-pt") myFormatLocale = "pt-br"; //pt-br
	if (myFormatLocale.toLowerCase() === "fr-ch" || myFormatLocale.toLowerCase() === "fr-fr" || myFormatLocale.toLowerCase() === "fr-ca") 
		myFormatLocale = "fr-lu"; //fr-lu works on both windows and Linux
	return myFormatLocale;
};

jQuery.sap.require('sap.ui.core.format.NumberFormat');
sap.ui.core.format.NumberFormat.__ORIG__getFloatInstance = sap.ui.core.format.NumberFormat.getFloatInstance;
sap.ui.core.format.NumberFormat.getFloatInstance = function(oFormatOptions, oLocale) {
	var oFormat = this.createInstance(oFormatOptions, oLocale),
		oLocaleFormatOptions = this.getLocaleFormatOptions(oFormat.oLocaleData, "float");
	if (oLocale === undefined) {
		var myLocale = sap.ui.getCore().getConfiguration().getFormatLocale().toLowerCase();
		if (myLocale === "pt-pt" || myLocale === "pt-br" || myLocale === "fr-lu") {
			oLocaleFormatOptions.groupingSeparator = ".";
		}
	}

	oFormat.oFormatOptions = jQuery.extend(false, {}, this.oDefaultFloatFormat, oLocaleFormatOptions, oFormatOptions);
	return oFormat;
};

//FIXME https://rndjira.sas.com/browse/RGFRMWRK-437
//FIXME Thai: date and time under Data Created are not converted for different calendar
// Today button on the calendar.
jQuery.sap.require('sas.hc.ui.unified.Calendar');
jQuery.sap.require('sas.ui.cpb3.CpbUtil');
sas.hc.ui.unified.Calendar.prototype._handleTodayButton = function(e) {
	var locale=sas.ui.cpb3.CpbUtil.getLocale();
	var todayDate = new Date;
	if (locale.sLocaleId === "th_TH") {
		var todayDateArray = todayDate.toDateString().split(" ");
		var iYear = parseInt(todayDateArray[3]);
		if (iYear > 1900 && iYear < 2200) {
			iYear = iYear + 543;
		}
		todayDateArray[3] = iYear.toString();
		todayDate = new Date(todayDateArray.join(" "));
	}
   this.focusDate(todayDate);
   var t = this._getFocusedDate()
     , a = this.getAggregation("month");
   a.length > 0 && a[0].selectDay(t),
   this.firePressToday({
       date: sap.ui.unified.calendar.CalendarUtils._createLocalDate(t.toLocalJSDate())
   })
};
