jQuery.sap.declare("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
jQuery.sap.require("sas.risk.rgf.util.URLParser");
jQuery.sap.require("sas.hc.m.BusyDialog");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.m.Link");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.ui.commons.TextView");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");


sas.risk.rgf.util.RGFUtil={
	_visibleRows:null,
	_dialogVisibleRows:null,
	_rb:{
		_bundleJSON : null,
		getText : function(key, args){
			var bundle = sas.risk.rgf.util.RGFUtil._rb._bundleJSON;
			if(!bundle){
				console.error("Resource bundle JSON missing : sas.risk.rgf.util.RGFUtil._rb._bundle. Key = " + key); /*I18nOK:EMS*/
				return key;
			}
			var val = bundle[key];
			if(!val){
				console.error(key + " is missing in bundle sas.risk.rgf.util.RGFUtil._rb._bundle"); /*I18nOK:EMS*/
				return "???"+key+"???"; /*I18nOK:LINE*/
			}
			return (args&&args.length)?jQuery.sap.formatMessage(val,args):val;
		},
		hasText : function(key){
			var bundle = sas.risk.rgf.util.RGFUtil._rb._bundleJSON;
			if(!bundle){
				console.error("Resource bundle JSON missing : sas.risk.rgf.util.RGFUtil._rb._bundle. Key = " + key); /*I18nOK:EMS*/
				return key;
			}
			var val = bundle[key];
			return !!val;
		}
	},
	getBundle:function(){
		return sas.risk.rgf.util.RGFUtil._rb; 
	},
	getCaretPosition : function(elemId) {
		var elem = document.getElementById(elemId);
		var iCaretPos = 0;
		if (document.selection) {// IE Support
			elem.focus();
			var oSel = document.selection.createRange();
			oSel.moveStart('character', -elem.value.length);
			iCaretPos = oSel.text.length;
		}
		else if (elem.selectionStart || elem.selectionStart == '0') {
			iCaretPos = elem.selectionStart;
		}
		return iCaretPos;
	},
	setCaretPosition : function(elemId, caretPos) {
		var elem = document.getElementById(elemId);
		caretPos = (caretPos === undefined) ? elem.value.length : caretPos;
		if (elem != null) {
			if (elem.createTextRange) {
				var range = elem.createTextRange();
				range.move('character', caretPos);
				range.select();
			}
			else {
				elem.focus();
				if (elem.selectionStart !== undefined) {
					elem.setSelectionRange(caretPos, caretPos);
				}
			}
		}
	},
	getSelection:function(){
		return window.getSelection().toString();
	},
	empty : function(div){
		delete div._key_;
		while (div.lastChild) {/*clean up the div*/
		    div.removeChild(div.lastChild);
		}
	},
	handleFail:function(e,jqxhr){
		var rb=sas.risk.rgf.util.RGFUtil.getBundle();
		sas.ui.cpb3.CpbUtil.handleFail(e,jqxhr,rb);
	},
   handleCreatorFromUIContext:function(data){
   	var links=data.links || [];
		links.push({rel:"creator",title:data.CREATOR.name});
		data.CREATOR.rk=parseInt(data.CREATOR.handle.split("|")[1]);
		data.links=links;
   },
   convertUserFromRestToUIContextFormat:function(user){
   	var result={};
	    result.collectionName="users";
	    result.handle="ORAUSER|"+user.key+"|";
	    result.name=user.displayNm;
	    return result;
   },
   toLocaleDateTimeString:function(dateObject){
   	jQuery.sap.require("sas.ui.cpb3.model.format.CpbDateFormat");
   	jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
   	var localeId=sas.risk.rgf.api.CommonAPI.getUserDetails().getLocale();
   	var locale=localeId ? new sap.ui.core.Locale(localeId) : null;
   	var inputFormat = sas.ui.cpb3.model.format.CpbDateFormat.getDateTimeInstance({style: "medium"}, locale);
   	return inputFormat.format(dateObject);
   },
   getLocale:function(){
   	jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
   	var localeId=sas.risk.rgf.api.CommonAPI.getUserDetails().getLocale();
		if (localeId.toLowerCase() === "pt-pt") {
			localeId = "pt-br";
		}
   	return localeId ? new sap.ui.core.Locale(localeId) : null;
   },
   toLongTimeStampString:function(dateObject){
   	var dateTime = new sap.ui.model.type.DateTime({source: {pattern: "yyyy-MM-ddTHH:mm:ss.SSSz"}, style: "long"});
		var output=dateTime.formatValue(dateObject,"string");
		return output;
   },
   registerChildTab:function(){
   	sas.ui.cpb3.CpbUtil.attachStorageEvent('close',function(event){
   		$(window).unbind('beforeunload'); //to not show the browser default warning message while leaving a page with changes
   		top.close();
   	});
   },
   closeAllChildTabs:function(e){
   	var menu=sas.ui.mashup.App.getInstance().banner.optionsButton.getMenu();
   	var menuItem=_.find(menu.getItems(),function(item){return item.getId().endsWith("-signoutMenuItem");});
   	if(e.getId()==="itemSelected" && e.getParameter("item").getId()===(menuItem&&menuItem.getId())){
   		sas.ui.cpb3.CpbUtil.fireStorageEvent('close',{type:'close'});
   	}
   },
   _mainTab:null,
   isMainTab:function(){
   	if(sas.risk.rgf.util.RGFUtil._mainTab===null){
	   	var hash=hasher.getHash();
	   	sas.risk.rgf.util.RGFUtil._mainTab=!(hash&&hash.endsWith("/lbo"));
   	}
		return sas.risk.rgf.util.RGFUtil._mainTab;
   },
   queue:function(func){
   	var qName="q_"+(func.name||"queue");
   	var wrapper=function(){
   		var args=arguments;
   		var context=this;
   		console.error("TRYING SETHANLDE"); /*I18nOK:EMS*/
   		context[qName]=context[qName]||[];
   		if(context[qName].length){//already running one, must queue it up
   			context[qName][0]=args;
   		}else{//empty queue, run it now
   			context[qName].push(args);//add it to queue so we know its in the middle of running one
   			func.apply(context,args).done(function(){
   				if(context[qName][0]!==args){//another queued up while this one ran, must run another one
   					wrapper.apply(context,context[qName].pop());
   				}else{//no more to run
   					context[qName].pop();
   				}
   			});
   		}
   	}
   	return wrapper;
   },
   getIconContent:function(iconName){
   	var iconSrc=sas.icons.HC[iconName]||iconName;
   	return sap.ui.core.IconPool.getIconInfo(iconSrc).content.charCodeAt(0).toString(16);
   },
   chain : function(arr)
   {
      var func=function(def){
          if(arr.length){
          arr.shift()().then(function(){
            func(def);
          }).fail(function(e){
            def.reject(e);
          });
        }else{
          def.resolve();
        }
      }
      var deferred=$.Deferred();
      func(deferred);
      return deferred;
   },
   getParentETag : function(model)
   {
   	var data=model.getData();
      return data["BO_ETAG_VALUE"];
   },
   updateParentETag : function(model, jqXHR)
   {
      var newParentEtag = jqXHR.getResponseHeader("ETag");
      var data=model.getData();
      if (newParentEtag)
      {
 	   	data["BO_ETAG_VALUE"] = newParentEtag;
      }
   },
   hasUnsavedChanges:function(){
   	var template=sas.ui.mashup.App.getInstance().getCurrentTemplate();
   	if(template.isInstanceOf(sas.ui.mashup.template.ViewToolbarTemplate)){
	   	var actionsLayout=template.actions;
	   	var actionsLayoutItems=actionsLayout.getItems();
	   	if(actionsLayoutItems.length){
	      	var objectToolbarAction=actionsLayoutItems[0];
	      	if(objectToolbarAction && objectToolbarAction.saveButton && objectToolbarAction.saveButton.getDomRef()){
	      		return objectToolbarAction.saveButton.getEnabled();
	      	}
	   	}
   	}
   	return false;
   },
   getBanner:function(){
   	return sas.ui.mashup.App.getInstance().banner;
   },
   getGlobalSearchField:function(){
   	return sas.ui.mashup.App.getInstance().banner.searchField;
   },
   getLogoutLink:function(){
   	return sas.ui.mashup.App.getInstance().banner.optionsButton;
   },
   takeoverGlobalSearchField:function(){
      var cincoSearchField=sas.risk.rgf.util.RGFUtil.getGlobalSearchField();
      if(cincoSearchField){
         cincoSearchField.detachSearch(cincoSearchField.mEventRegistry.search[0].fFunction);//detach default search handler
         cincoSearchField.attachSearch(function(event){
            var query=event.getParameter("query");
            if(query){
	            var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	            if(sas.risk.rgf.util.RGFUtil.hasUnsavedChanges()){
		            var message=rb.getText("form.unsaved.warning.txt");
		            if(!confirm(message)){return false;}
	            }
	            var viewData={
            		query:query,
            		title:rb.getText("global.search.title.txt")
	            };
	            sas.risk.rgf.util.DialogManager.open("FacetedSearchDialog",viewData,null,null,"RGFSearchLayoutDialog");
            }
         });
      }
   },
   recurseClasses:function(element,tab){
		tab=tab||"";
		console.error(tab+element.tagName+"["+element.id+" ] -> "+($(element).attr("class")||""),element);
		$.each(element.children,function(index,child){
			sas.risk.rgf.util.RGFUtil.recurseClasses(child,tab+"  ");
		});
	},
	parentClasses:function(element){
		console.error(element.tagName+"["+element.id+" ] -> "+($(element).attr("class")||""),element);
		if(element.parentElement){
			sas.risk.rgf.util.RGFUtil.parentClasses(element.parentElement);
		}
	},
	diff:function(a,b){
		var r={};
		sas.risk.rgf.util.RGFUtil._diff(a,b,r);
		sas.risk.rgf.util.RGFUtil._diff(b,a,r);
		return r;
	},
	_diff:function(a,b,r){
		_.each(a,function(v,k){
			// already checked this or equal...
	      if (r.hasOwnProperty(k) || b[k] === v) return;
	      // but what if it returns an empty object? still attach?
	      if(_.isObject(v)&&_.isObject(b[k])){
	      	var innerDiff=sas.risk.rgf.util.RGFUtil.diff(v, b[k])
	      	if(_.size(innerDiff)){
	      		r[k]=innerDiff;
	      	}
	      }else{
	      	r[k] = v;	
	      }
		});
	},
	_prune:function(a){
		if(_.isObject(a)||_.isArray(a)){
			_.each(a,function(v,k){
//				console.error(v,k);
				var pruned=sas.risk.rgf.util.RGFUtil._prune(v);
				if(_.isNull(pruned)){
					delete a[k];
				}else{
					a[k]=pruned;
				}
			});
		}
		if(_.isObject(a)&&!_.keys(a).length){return null;}
		return a;
	},
	invokeExportMip:function(rootFolderName, exportMIPUrl, exportItems){
   	var that=this;
   	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		if (exportItems.length > 0) {
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			var infoTxt=rb.getText("table.exportMip.exporting.count.display.fmt.txt", [exportItems.length]);
			var infoLabel = new sas.hc.ui.commons.TextView({text: infoTxt});
	    	var infoDialog = new sas.hc.m.Dialog({
	    		title:rb.getText("table.exportMip.title.txt"),
	    		content: infoLabel,
	    		showCancelButton: false
	    	}).addStyleClass("RGFMipExportInfoDialog");
	    	infoDialog.open();
         sas.risk.rgf.api.UtilsAPI.exportToMip(exportMIPUrl)
         .done(function(data){
         	infoDialog.close();
         	sas.hc.m.MessageDialog.information({
      			text:rb.getText("table.exportMip.success.fmt.txt",[exportItems.length]),
      			title: rb.getText("table.exportMip.title.txt")
      		});
         }).fail(function(e){
         	infoDialog.close();
         	if(_.has(e,"responseCode")){that.showMipExportErrorDialog(e, rootFolderName);}
         });
		}else{
		 	sas.hc.m.MessageDialog.warning({text:rb.getText("table.exportMip.count.empty.txt"),title:rb.getText("table.exportMip.title.txt"),buttonActions:[sas.hc.m.MessageDialogAction.Ok]});
		}
   },
   showMipExportErrorDialog: function(e, rootFolderName){
   	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
      var that=this;
      var errorResponseCode=e.responseCode;
      var errorLabel = "";
      switch(parseInt(errorResponseCode)){
      	case 1:
      		errorLabel=new sas.hc.m.Label({text: rb.getText("table.exportMip.failure.txt")});
      		break;
      	case 2:
      		errorLabel=new sas.hc.m.Label({text: rb.getText("table.exportMip.failure.missing.workgroup.txt")});
      		break;
      	case 3:
      		errorLabel=new sas.hc.m.Label({text: rb.getText("table.exportMip.failure.duplicate.rootFolder.fmt.txt", [rootFolderName])});
      		break;
      	case 4:
      		errorLabel=new sas.hc.m.Label({text: rb.getText("table.exportMip.exportRootFolder.property.invalid.txt")});
      		break;
      }
      var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
   		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Row,
   		items: [errorLabel]
   	})
      
      var blob=e.blob ? e.blob : null;
      if(blob){
         var fileName=e.fileName;
         var a = document.createElement("a");
         var downloadUrl = URL.createObjectURL(blob);
   	   a.href = downloadUrl;
   	   a.download = fileName;
   	   document.body.appendChild(a);
         var errorLink = new sas.hc.m.Link({
         	text : rb.getText("table.exportMip.failure.downloadLink.txt"),
         	press: function () {
         		if(window.navigator.msSaveBlob){
         			window.navigator.msSaveBlob(blob,fileName);
         		}else{
         			a.click();
         		}
         	}
         }).addStyleClass("RGFMipExportErrorLink");
         layout.addItem(errorLink);
      }
      var errorMsgDialog=new sas.hc.m.Dialog({
      	title:rb.getText("table.exportMip.title.txt"),
      	icon:sas.icons.HC.ERRORSTATUS, 
      	content: layout
      });
      var closeButton = new sas.risk.common.widgets.Button({
         text: rb.getText("table.exportMip.close.txt"),
         press: function () {
         	errorMsgDialog.close();
         }
      });
      errorMsgDialog.setRightButton(closeButton);
      errorMsgDialog.open();
   },
   isScreenEditable:function(routeName){
   	return sas.risk.rgf.api.CommonAPI.getUserDetails().getScreenEditor();
   },
   buildFormattingKey:function(cpbForm,klassName,fieldName){
   	return sas.ui.cpb3.CpbUtil.buildFormattingKey(cpbForm,klassName,fieldName,["RGF"]);
   },
   buildDialogFormattingKey:function(viewId,cpbForm,klassName,fieldName){
   	return sas.ui.cpb3.CpbUtil.buildDialogFormattingKey(viewId,cpbForm,klassName,fieldName,["RGF"]);
   },
   byteLength:function(str) {// returns the byte length of an utf8 string
   	var s = str.length;
   	for (var i=str.length-1; i>=0; i--) {
   		var code = str.charCodeAt(i);
   		if (code > 0x7f && code <= 0x7ff) s++;
   		else if (code > 0x7ff && code <= 0xffff) s+=2;
   		if (code >= 0xDC00 && code <= 0xDFFF) i--; //trail surrogate
   	}
   	return s;
   },
   handleTimeout:function(){
   	if(sas.timeoutManager){//MAIN TAB
   		/*This event means it is time to gracefully close down*/
	   	sas.eventBus.subscribe(sas.timeoutManager.events.BEFORE_TIME_OUT,function(){
				$(window).unbind('beforeunload'); //to not show the browser default warning message while leaving a page with changes
				sas.ui.cpb3.CpbUtil.fireStorageEvent('close',{type:'close'});//close all child tabs
	   	});
	   	/*This event means that a child tab has responded to the session warning*/
   		sas.ui.cpb3.CpbUtil.attachStorageEvent("SESSION_WARNING_RESPONSE",function(event){
   			var userAction=event.getParameter("payload").action;
   			var warningDialog=_.find(sap.m.InstanceManager.getOpenDialogs(),function(dialog){
   				return (dialog.getIcon()===sas.icons.HC.WARNINGSTATUS && dialog.getType()===sap.m.DialogType.Message);
   			});//scrounge around to find that warning dialog
   			if(warningDialog){
   				switch(userAction){
   					case sas.hc.ui.commons.SessionTimeoutDialog.Action.CONTINUE:
   						var continueButton=_.find(warningDialog.getButtons(),function(button){return button.getId()===warningDialog.getLeftButton();});
   						if(continueButton){continueButton.firePress();}
						break;
   					case sas.hc.ui.commons.SessionTimeoutDialog.Action.LOGOFF:
   						sas.eventBus.publish(sas.timeoutManager.events.BEFORE_TIME_OUT);//let child tabs know its time to close
   						var logoffButton=_.find(warningDialog.getButtons(),function(button){return button.getId()===warningDialog.getRightButton();});
   						if(logoffButton){logoffButton.firePress();}
						break;
   				}
   			}
   		});
   	}else{//CHILD TABS
   		/*This event means that child tab needs to show session timeout warning*/
   		sas.ui.cpb3.CpbUtil.attachStorageEvent("SESSION_WARNING",function(event){
	   		var warningDuration=event.getParameter("payload").duration;
	   		sas.hc.ui.commons.SessionTimeoutDialog.show(warningDuration,function(userAction){
   				sas.ui.cpb3.CpbUtil.fireStorageEvent("SESSION_WARNING_RESPONSE",{action:userAction});//let main tab what was chosen
					if(userAction===sas.hc.ui.commons.SessionTimeoutDialog.Action.LOGOFF){
						sas.eventBus.publish(sas.timeoutManager.events.BEFORE_TIME_OUT);//let child tabs know its time to close
					}
	   		},true);
	   	});
   		/*This event means that child tab needs to close warning dialog and proceed as normal*/
   		sas.ui.cpb3.CpbUtil.attachStorageEvent("SESSION_WARNING_CLOSEDIAG",function(event){
   			var warningDialog=_.find(sap.m.InstanceManager.getOpenDialogs(),function(dialog){
   				return (dialog.getIcon()===sas.icons.HC.WARNINGSTATUS && dialog.getType()===sap.m.DialogType.Message);
   			});//scrounge around to find that warning dialog
   			if(warningDialog){
   				warningDialog.close();
   			}
   		});
   	}
   },
   _restUrl: "rest",
   setRestUrl:function(restUrl) {
   	sas.risk.rgf.util.RGFUtil._restUrl=restUrl;
   },
   getRestUrl:function() {
   	return sas.risk.rgf.util.RGFUtil._restUrl;
   },
   aimRestUrl:function(url){
   	if(!url){return url;}
   	var restUrl=sas.risk.rgf.util.RGFUtil.getRestUrl();
   	var split=restUrl.split("-");
   	if(url.startsWith(restUrl)){
   		return url;
   	}else if(url.startsWith(split[0]) && split.length==2){
   	   return restUrl+"/"+url.substring(split[0].length+1);
   	}else if(url.startsWith("rest/")){
   		return restUrl+"/"+url.substring("rest/".length);
   	}else{
   		return restUrl+"/"+url;
   	}
   }
}