jQuery.sap.declare("sas.risk.rgf.util.search.ObjectChooserFilterHandler");
jQuery.sap.require("sas.risk.rgf.widget.ObjectChooser");
jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
jQuery.sap.require("sas.risk.slimtable.meta.filter.ValueFilter");

sas.risk.rgf.util.search.ObjectChooserFilterHandler=function(colMeta,mgr,meta){
	this.colMeta=colMeta;
	this.mgr=mgr;
	this.meta=meta;
};
sas.risk.rgf.util.search.ObjectChooserFilterHandler.prototype={
	setOperator:function(filter,operator){
		filter.setOperator(operator);
	},
	getOperators:function(){
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		if(!filter.getType())
			filter.setType(sas.risk.slimtable.meta.filter.ValueFilter);
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		var chooser=new sas.risk.rgf.widget.ObjectChooser(this.meta);
		if(filter.getValue()){
			chooser.setKey(filter.getValue());
		}
		chooser.attachChange(function(e){
			var value=e.getParameter("newValue");
			filter.setValue(value?value.key:null);
			filter.setValueLabel(value?this.createItemLabel(value):null);
		});
		return chooser;
	},
	updateFilterValueLabel:function(filter){
		var def=$.Deferred().resolve();
		var chooser=new sas.risk.rgf.widget.ObjectChooser(this.meta);
		sas.risk.rgf.api.CommonAPI.loadCollection(this.meta.collectionName,[filter.getValue()]).done(function(items){
			if(items.length===1){
				filter.setValueLabel(chooser.createItemLabel(items[0]));
			}
			def.resolve();
		});
		return def;
	}
};