jQuery.sap.declare("sas.risk.rgf.util.search.RGFFilterHandlerFactory");
jQuery.sap.require("sas.risk.slimtable.util.search.FilterHandlerFactory");
jQuery.sap.require("sas.risk.slimtable.util.SlimTableUtil");
jQuery.sap.require("sas.risk.slimtable.util.search.ChoicesFilterHandler");
jQuery.sap.require("sas.risk.rgf.util.search.ObjectChooserFilterHandler");
jQuery.sap.require("sas.risk.rgf.api.UtilsAPI");

sas.risk.rgf.util.search.RGFFilterHandlerFactory=function(){
	sas.risk.slimtable.util.search.FilterHandlerFactory.apply(this,arguments);
};
sas.risk.rgf.util.search.RGFFilterHandlerFactory.prototype=Object.create(sas.risk.slimtable.util.search.FilterHandlerFactory.prototype);

sas.risk.rgf.util.search.RGFFilterHandlerFactory.prototype.getHandler=function(colMeta,mgr){
	var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
	//try rest media types first
	var type=colMeta.getType()||"";
	var custObjectNumber=type.split("com.sas.oprisk.server.CustomObject");
	if(custObjectNumber.length>1){
	   var target="customObject"+custObjectNumber[1];
	   var mediaType=_.find(sas.risk.rgf.api.UtilsAPI.getRestMediaTypes(),function(mediaType){
	      return mediaType.boTypeNm===target;
      });
      return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
         collectionName:mediaType.objectType,
         placeholderTxt:rb.getText("objectChooser.placeholder.fmt.txt",[mediaType.label]),
         dialogTitleTxt:rb.getText("objectChooser.dialog.fmt.title",[mediaType.label])
     });
	}
	switch(colMeta.getType()){
		case "com.sas.oprisk.server.User":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"users",
	   		 placeholderTxt:rb.getText("objectChooser.users.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.users.dialog.title"),
	   		 icon:sas.icons.HC.USER,
	   		 searchAttr:"displayNm"
			});
		case "com.sas.oprisk.server.RiskInstance":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"risks",
	   		 placeholderTxt:rb.getText("objectChooser.risks.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.risks.dialog.title"),
	   		 searchAttr:"riskNm"
			});
		case "com.sas.oprisk.server.Assessment":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"assessmentExs",
	   		 placeholderTxt:rb.getText("objectChooser.assessments.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.assessments.dialog.title"),
	   		 searchAttr:"nameTxt"
			});
		case "com.sas.oprisk.server.Policy":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"policies",
	   		 placeholderTxt:rb.getText("objectChooser.policies.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.policies.dialog.title"),
	   		 searchAttr:"policyNm"
			});
		case "com.sas.oprisk.server.QuestionnaireTemplate":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"templateExs",
	   		 placeholderTxt:rb.getText("objectChooser.templateExs.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.templateExs.dialog.title"),
	   		 searchAttr:"nameTxt"
			});				
		case "com.sas.oprisk.server.RatingsTemplate":
			return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
	   		 collectionName:"ratingsTemplates",
	   		 placeholderTxt:rb.getText("objectChooser.ratingsTemplates.placeholder.txt"),
	   		 dialogTitleTxt:rb.getText("objectChooser.ratingsTemplates.dialog.title"),
	   		 searchAttr:"ratingsTemplateNm"
			});				
		case "com.sas.oprisk.server.base.ActionPlanStatus":
		case "com.sas.oprisk.server.base.ValidationStateCd":
		case "com.sas.oprisk.server.base.IssueStatus":
		case "com.sas.oprisk.server.base.RiskOwnershipCd":
		case "com.sas.oprisk.server.base.AssessmentStatusCd":
		case "com.sas.oprisk.server.base.AssessmentTypeCd":
		case "com.sas.oprisk.server.base.InitiatorCd":
		case "com.sas.oprisk.server.base.AssessmentStageCd":
		case "com.sas.oprisk.server.base.TemplateStatusCd":
		case "com.sas.oprisk.server.base.AssessmentStatusCd":
		case "com.sas.oprisk.server.Dimension":
		case "com.sas.oprisk.server.base.ScreenDefinitionTypeCd":
			return new sas.risk.slimtable.util.search.ChoicesFilterHandler(colMeta,mgr,true);
		case "com.sas.oprisk.server.AssessmentTrigger":
		case "com.sas.oprisk.server.AssessmentFrequency":
		case "com.sas.oprisk.server.AssessmentPeriod":
			return new sas.risk.slimtable.util.search.ChoicesFilterHandler(colMeta,mgr,false);
		default:
			if(colMeta.getType().search(sas.risk.rgf.util.search.RGFFilterHandlerFactory.CUSTOBJ_RE)!==-1){//handle rest of custom objects
				return new sas.risk.rgf.util.search.ObjectChooserFilterHandler(colMeta,mgr,{
		   		 collectionName:colMeta.getType().replace(sas.risk.rgf.util.search.RGFFilterHandlerFactory.CUSTOBJ_RE,'c$1s')
				});
			}
			//call super if we haven't found it yet
			return sas.risk.slimtable.util.search.FilterHandlerFactory.prototype.getHandler(colMeta,mgr);
	}
};
sas.risk.rgf.util.search.RGFFilterHandlerFactory.CUSTOBJ_RE=/com\.sas\.oprisk\.server\.C(ustomObject\d+)/;
//SINGLETON
sas.risk.rgf.util.search.RGFFilterHandlerFactory._instance=new sas.risk.rgf.util.search.RGFFilterHandlerFactory();
sas.risk.slimtable.util.search.FilterHandlerFactory._instance=sas.risk.rgf.util.search.RGFFilterHandlerFactory._instance;/*override cpb singleton*/
sas.risk.rgf.util.search.RGFFilterHandlerFactory.getInstance=function(){
	return sas.risk.rgf.util.search.RGFFilterHandlerFactory._instance;
};