jQuery.sap.require("sas.risk.rgf.nav.RGFToolbarActionsObject");
jQuery.sap.require("sas.risk.common.widgets.Button");

sap.ui.jsview("sas.risk.rgf.view.dialog.ActivityPickerDialog", {
	getControllerName : function() {
		return "sas.risk.rgf.view.dialog.ActivityPickerDialog";
	},
	createContent : function(controller) {
		var that=this;
		var viewData=this.getViewData();
		//viewData.activities = viewData.activities.sort((a,b) => (a.localizedLabel > b.localizedLabel) ? 1 : -1);
		viewData.activities = viewData.activities.sort((function(a,b){return (a.localizedLabel > b.localizedLabel) ? 1 : -1}));
		var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		this.createButtons(controller);
     
      this.layout=new sas.risk.common.layout.flexlayout.FlexLayout({
      	flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
      	items:[
   			new sap.ui.commons.layout.HorizontalLayout({
   				content:[
   				         	new sas.risk.common.widgets.Button({
   				         			icon: sas.icons.HC.INFORMATION,
   				         	}),
							new sas.hc.m.Label({
							    text: viewData.workFlowActivityPickerNotes 
							})
   				]
   			}).addStyleClass("rgfActivityPickerNotes")
	      ]
      })
      this.oList = new sas.hc.m.List({
          includeItemInSelection : true,
      });
      var oItemTemplate = new sas.hc.m.StandardListItem({
    	  title: "{localizedLabel}",
    	   type : sap.m.ListType.Active,
           role: "link",
      });
      this.oList.attachItemPress($.proxy(controller.itemSelected,controller));
      
      this.oList.setModel(new sap.ui.model.json.JSONModel(viewData.activities));
      this.oList.bindAggregation("items","/",oItemTemplate);
      
      this.layout.addItem(this.oList);
      return this.layout;
	},
	createButtons : function(controller) {
		var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		this.cancelButton = new sas.risk.common.widgets.Button({
			text : rb.getText("dimloc.button.cancel.txt"),
			press:$.proxy(controller.actionCancel,controller)
		});
	},
	getDialogSettings : function() {
		var viewData=this.getViewData();
		return {
			beginButton : this.cancelButton,
			contentWidth:"50%",
			showClose:false,
			escapeHandler:function(def){
				sas.risk.rgf.nav.RGFToolbarActionsObject.actionClose(viewData.cpbForm);
				def.resolve();
			}
		};
	}
});
sap.ui.controller("sas.risk.rgf.view.dialog.ActivityPickerDialog", {
	onInit:function(){
	},
	actionCancel:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		sas.risk.rgf.nav.RGFToolbarActionsObject.actionClose(viewData.cpbForm);
		var dialog=view.getDialog();
		dialog.close();
	},
	itemSelected:function(e){
		var view=this.getView();
		var viewData=view.getViewData();
		var dialog=view.getDialog();
		dialog.setBusyIndicatorDelay(0);
		dialog.setBusy(true);
		var selActivity=view.oList.getSelectedItem().getBindingContext().getObject();
		view.fireClosing({
			activity:selActivity
		});
	}
});