jQuery.sap.require("sap.ui.commons.layout.HorizontalLayout");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.ui.cpb3.widget.RadioButtonGroup");
jQuery.sap.declare("sas.risk.rgf.biz.DimensionDefinition");

sap.ui.jsview("sas.risk.rgf.view.dialog.ExportDimenisonToExcelDialog", {
    getControllerName : function() {
        return "sas.risk.rgf.view.dialog.ExportDimenisonToExcelDialog";
    },
    createContent : function(controller) {
   	 this.viewData=this.getViewData();
   	 this.rgfTable=this.viewData.source;
       var innerLayout=this.createInnerLayout();
       
       var layout = new sas.hc.ui.commons.layout.VerticalLayout({
          content : [ innerLayout]
       });
       $.proxy(this.createButtons(controller),this);
       return layout;
   },
   createButtons : function(controller) {
      var rb = sas.risk.rgf.util.RGFUtil.getBundle();
      this.okButton = new sas.risk.common.widgets.Button({
         text : rb.getText("table.dialog.button.ok.txt"),
         press : $.proxy(controller.actionOk,this,controller)
     });
      this.cancelButton = new sas.risk.common.widgets.Button({
          text : rb.getText("table.dialog.button.cancel.txt"),
          press : $.proxy(controller.actionCancel,this,controller)
      });
   },
   getDialogSettings : function() {
      return {
         contentWidth:"50%",
         beginButton : this.okButton,
         endButton : this.cancelButton
      };
   },
   createInnerLayout : function(){
   	var rb = sas.risk.rgf.util.RGFUtil.getBundle();

      var choice1 = new sas.hc.m.RadioButton().addStyleClass("cpbRadioButton").addCustomData(new sap.ui.core.CustomData({
         key: "val",
         value : "all"
		}));
      choice1.setText(rb.getText("dimension.export.all.txt"));
      choice1.setTooltip(rb.getText("dimension.export.all.txt"));
      
		var choice2 = new sas.hc.m.RadioButton().addStyleClass("cpbRadioButton").addCustomData(new sap.ui.core.CustomData({
         key: "val",
         value : "single"
		}));
      choice2.setText(rb.getText("dimension.export.single.txt"));
      choice2.setTooltip(rb.getText("dimension.export.single.txt"));
      if(!this.viewData.selectedDimNode) {choice2.setEnabled(false);}

      this.innerLayout = new sas.ui.cpb3.widget.RadioButtonGroup({
         selectedIndex: 0,
			buttons : [ choice1, choice2 ]
		}).addStyleClass("cpbBooleanRadioButtonGroup");

   	return this.innerLayout;
   }
});
sap.ui.controller("sas.risk.rgf.view.dialog.ExportDimenisonToExcelDialog", {
   actionOk:function(controller){
      var dialog=controller.getView().getDialog();
      dialog.setBusyIndicatorDelay(0);
      dialog.setBusy(true);
      
      //get url to download
      var exportURL=sas.risk.rgf.util.RGFUtil.getRestUrl();
      if(this.innerLayout.getSelectedButton().getCustomData()[0].getValue() === "all") {
         exportURL += "/utils/exportDimensions";
      } else if (this.innerLayout.getSelectedButton().getCustomData()[0].getValue() === "single" && this.viewData.selectedDimNode){
         exportURL += "/" + sas.risk.rgf.biz.DimensionDefinition[this.viewData.selectedDimNode.getDimensionName()].url +
         "/export?exportForDataLoad=true&amp;includeAllCols=true";
      } else {
         console.error("exportURL is not provided. Can't perform Export to dataload."); /*I18nOK:EMS*/
         return;
      }

      exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("start");
      exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("limit");
      
      var xhr=new XMLHttpRequest();
  	   xhr.open("GET",exportURL,true);
  	   xhr.responseType="blob";
  	   xhr.onload=function(e){
  	   	if(this.status==200){
  	         var contentDispositionHeader = xhr.getResponseHeader("content-disposition");
  	         var fileName = contentDispositionHeader.slice(contentDispositionHeader.indexOf("filename")).replace("filename=\"", "").replace("\"","");
  	   		var blob=this.response;
  	   		if(window.navigator.msSaveBlob){
  	   			window.navigator.msSaveBlob(blob,fileName);
  	   		}else{
  		         var downloadUrl = URL.createObjectURL(blob);
  		         var a = document.createElement("a");
  				   a.href = downloadUrl;
  				   a.download = fileName;
  				   document.body.appendChild(a);
  				   a.click();
              }
  	   	}
  	   };
  	   xhr.onerror=function(e){
         console.log(e);
  	   	alert('Unable to download excel for dataload.'); //I18nOK:EMS
  	   };
  	   xhr.send();
      dialog.close();
   },
   actionCancel:function(controller){
   	var dialog=controller.getView().getDialog();
   	dialog.close();
   }
});