jQuery.sap.require("sas.ui.cpb3.CPBForm");
jQuery.sap.require("sas.risk.rgf.util.LBOLinkDialogUtil");

sap.ui.jsview("sas.risk.rgf.view.dialog.LBOEditLinkDialog", {
	getControllerName : function() {
		return "sas.risk.rgf.view.dialog.LBOEditLinkDialog";
	},
	createContent : function(controller) {
		var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		var config={
			buttonOkLabel:"lbo.edit.dialog.ok.txt",
			buttonCancelLabel:"lbo.edit.dialog.cancel.txt"
		};
		return sas.risk.rgf.util.LBOLinkDialogUtil.createContent(controller,this,config);
	},
	getDialogSettings : function() {
		var viewData=this.getViewData();
		return {
			beginButton : this.okButton,
			endButton : this.cancelButton,
			contentWidth:viewData.width+"px",
			contentHeight:viewData.height+"px"
		};
	},
	getCpbForm:function(){
		return this.cpbForm;
	}
});
sap.ui.controller("sas.risk.rgf.view.dialog.LBOEditLinkDialog", {
	onInit:function(){
		sas.risk.rgf.util.LBOLinkDialogUtil.onInit(this);
		if (this.getView() && this.getView().okButton) {
			this.getView().okButton.setEnabled(true);
		}
	},
	actionOk:function(){
      var that=this;
      sas.risk.rgf.util.LBOLinkDialogUtil.validateContext(this).done(function(json){
   		var view=that.getView();
   		var cpbModelManager=view.getCpbForm().getCpbModelManager();
         if(json.hasErrors){
            cpbModelManager.applyErrors(json,view);
         }else{
            cpbModelManager.updateData(json.cpb_data,view);
      		var dialog=view.getDialog();
      		dialog.setBusy(true);
      		var pageContext=cpbModelManager.getPageContext(view);
      		view.fireClosing({
      			pageContext:pageContext,
      			link:view.getViewData().link
      		});
         }
      });
	},
	actionCancel:function(){
		this.getView().getDialog().close();
	}
});