jQuery.sap.require("sas.risk.rgf.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.slimtable.plugins.Pager");
jQuery.sap.require("sas.risk.slimtable.plugins.Search");
jQuery.sap.require("sas.risk.slimtable.plugins.Filter");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");

sap.ui.jsview("sas.risk.rgf.view.dialog.ObjectChooserDialog", {
	getControllerName : function() {
       return "sas.risk.rgf.view.dialog.ObjectChooserDialog";
   },
   createContent : function(controller) {
      var viewData=this.getViewData();
      var innerLayout=this.createInnerLayout();
      var layout = new sas.hc.ui.commons.layout.VerticalLayout({
         height : "100%",
         width : "100%",
         content : [ innerLayout]
      });
      $.proxy(this.createButtons(controller),this);
      return layout;
   },
   createButtons : function(controller) {
      var rb = sas.risk.rgf.util.RGFUtil.getBundle();
      this.cancelButton = new sas.risk.common.widgets.Button({
      	text: rb.getText("objectChooser.cancelBtn.txt"),
      	press:$.proxy(controller.actionCancel,controller) 
      });
   },
	getDialogSettings : function() {
		return {
			contentWidth:"60%",
			endButton : this.cancelButton
		};
	},
	createInnerLayout : function(){
      var viewData=this.getViewData();
		var viewData=this.getViewData();
		var url=sas.risk.rgf.util.RGFUtil.getRestUrl()+"/"+viewData.collectionName;
		if(viewData.filter){
			url+="?filter="+viewData.filter.toString();
		}
		this.chooserTable=new sas.risk.rgf.widget.RGFTable({
			formattingKey:viewData.formattingKey,
         bindPath: "/items",
         meta: {columns:[]},
         data: url,
         visibleRows:sas.risk.rgf.util.RGFUtil._dialogVisibleRows,
         plugins:[new sas.risk.slimtable.plugins.Search(),
                  new sas.risk.slimtable.plugins.Filter(),
                  new sas.risk.slimtable.plugins.TableOptions({
                 	  menuItems: this.getMenuItems()
                   }),
                  new sas.risk.slimtable.plugins.Counter(),
                  new sas.risk.slimtable.plugins.Pager()
         ]
      })
		this.chooserTable.attachRowClick($.proxy(this.doRowClick,this));
      this.chooserTable.setMeta(viewData.chooserTableMeta);
      this.chooserTable.setVisibleRows(viewData.chooserTableMeta.dialogVisibleRows);
      return this.chooserTable;
	},
	getMenuItems : function(){
		var viewData=this.getViewData();
		return [new sas.risk.rgf.widget.menu.ColumnsItem({serviceId:viewData.serviceId})];
	},
	doRowClick : function(oEvent){
		this.fireClosing({
			item:this.chooserTable.getSource().getData()[oEvent.getParameter("rowIdx")]
		});
		this.getDialog().close();
	}
});
sap.ui.controller("sas.risk.rgf.view.dialog.ObjectChooserDialog", {
	actionCancel : function(){
		this.getView().getDialog().close();
	}
});    