jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.risk.slimtable.plugins.Counter");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.common.widgets.MessageDetailsBox");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");

sap.ui.jsview("sas.risk.rgf.view.dialog.ViewHistoryDialog", {
	getControllerName : function() {
		return "sas.risk.rgf.view.dialog.ViewHistoryDialog";
	},
	createContent : function(controller) {
		var viewData=this.getViewData();
		var that=this;
		var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		this.createButtons(controller);
     
      this.layout=new sas.risk.common.layout.flexlayout.FlexLayout({
      	flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
      	items:[]
      });
      
      this.table=new sas.risk.rgf.widget.RGFTable({
      	formattingKey:viewData.formattingKey,
      	data : $.proxy(this.fetchData, this),
   		meta: viewData.meta.tableMeta,
   		clientSide : true,
   		visibleRows: viewData.meta.tableMeta.dialogVisibleRows,
   		plugins:[new sas.risk.slimtable.plugins.Counter()]
   	});
      
      this.layout.addItem(this.table);
      return this.layout;
	},
	fetchData : function(query) {
		var that = this;
		var viewData = this.getViewData();
		return $.getJSON(sas.risk.rgf.util.RGFUtil.getRestUrl()+"/"+ viewData.objectType + "/" + viewData.objectId + "/changeReasons").fail(function(e) {
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			that.getDialog().close();
         if (e.status && e.status === 404)
         {
           //The parent object no longer exists
           var errorJson = {"message" : rb.getText("message.error.404.txt")};      
           sas.risk.common.widgets.MessageDetailsBox.error(errorJson, sas.config.appName, sas.risk.rgf.util.RGFUtil.getBundle());	
         }
         else
         {
            sas.risk.rgf.util.RGFUtil.handleFail(e);
         }  

		});
	},
	createButtons : function(controller) {
		var rb = sas.risk.rgf.util.RGFUtil.getBundle();
		var that=this;
		
		this.closeButton = new sas.risk.common.widgets.Button({
			text : rb.getText("view.history.close.button.txt"),
			press : $.proxy(controller.actionClose,controller)
		});
	},
	getDialogSettings : function() {
		var viewData=this.getViewData();
		return {
			contentWidth:"50%",
			beginButton : this.closeButton
		};
	}
});
sap.ui.controller("sas.risk.rgf.view.dialog.ViewHistoryDialog", {
	onInit:function(){
     
	},
	onAfterRendering:function(){
		this.getView().getDialog()._reposition();
	},
	actionClose:function(){
		this.getView().getDialog().close();
	}
});