jQuery.sap.declare("sas.risk.rgf.widget.LBOAddLinkDialogController");
jQuery.sap.require("sas.risk.rgf.widget.dimloc.DimensionalLocation");
jQuery.sap.require("sas.risk.slimtable.widget.menu.AdvSearchItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.rgf.widget.menu.CustomizationInfoItem");
jQuery.sap.require("sas.risk.rgf.util.LBOLinkDialogUtil");

sas.risk.rgf.widget.LBOAddLinkDialogController=function(){};
sas.risk.rgf.widget.LBOAddLinkDialogController.prototype={
	onInit:function(){
		sas.risk.rgf.util.LBOLinkDialogUtil.onInit(this);
	},
	actionOk:function(){
	   var that=this;
	   sas.risk.rgf.util.LBOLinkDialogUtil.validateContext(this).done(function(json){
         var view=that.getView();
         var cpbModelManager=view.getCpbForm().getCpbModelManager();
	      if(json.hasErrors){
	         cpbModelManager.applyErrors(json,view);
	      }else{
	         cpbModelManager.updateData(json.cpb_data,view);
	         var viewData=view.getViewData();
	         var dialog=view.getDialog();
	         dialog.setBusy(true);
	         var pageContext=cpbModelManager.getPageContext(view);
	         view.fireClosing({
	            pageContext:pageContext,
	            selections:that.doGetNewSelections(),
	            previousSelections:viewData.multiSelect?[]:viewData.linkIds
	         });
	      }
	   });
	},
	actionCancel:function(){
		this.getView().getDialog().close();
	},
	doGetNewSelections:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		var source=view.table.table.getSource();
		var selected=source.getSelections();
		var data=source.getData();
		var selectedMap=_.map(selected,function(idx){
			return data[idx].key;
		});
		if(!viewData.multiSelect){
			return selectedMap.length?selectedMap:viewData.linkIds||[];
		}
		return _.difference(selectedMap,viewData.linkIds);		
	}
};