jQuery.sap.declare("sas.risk.rgf.widget.LinkedBusinessObjectsMixin");

sas.risk.rgf.widget.LinkedBusinessObjectsMixin={
	meta:{
		metadata:{
			properties:{
				linkType:{type:"any"},
				sourceObjectKey:{type:"int"},
				linkContainer:{type:"any"},
				isLocated:{type:"boolean",defaultValue:false},
				showLocationChooser:{type:"boolean",defaultValue:true},
				isDimension:{type:"boolean",defaultValue:false},
				collectionName:{type:"string"},
				targetFeature:{type:"any"},
				favorites:{type:"any"},
				enforceSide:{type:"boolean",defaultValue:false},
				targetMeta:{type:"any"},
				linkLabel:{type:"string"},
				editDialogWidth:{type:"int",defaultValue:1200},
				editDialogHeight:{type:"int",defaultValue:800},
				queryProcessor:{type:"any"},
				sourceTypeName:{type:"string"},
				locationFieldName:{type:"string"},
				queryProcessorFieldName:{type:"string"},
				equalTypes:{type:"boolean",defaultValue:false},
				multiSelect:{type:"boolean",defaultValue:true},
				sourceSystemCode:{type:"string"},
				linkTypeKey:{type:"int"},
				immediateSave:{type:"boolean",defaultValue:false},
				sideOfLink:{type:"int",defaultValue:0},
				missingLocationMessage:{type:"string"},
				links:{type:"any"}
			}
		}
	},
	proto:{
		actionTargetAdd:function(e,link,overrides){
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			var cpbModelManager=this.getCpbForm().getCpbModelManager();
			var location=null;
			var qp=this.getQueryProcessor();
			if(!qp && this.getQueryProcessorFieldName()){
				qp=cpbModelManager.getUIContext()[this.getQueryProcessorFieldName().toUpperCase()];
			} 
			if(this.getLocationFieldName()){
				location=cpbModelManager.getUIContext()[this.getLocationFieldName().toUpperCase()];
				if(!location){
					alert(this.getMissingLocationMessage());
					return;
				}
			}
			var viewData={
				sourceObjectKey:this.getSourceObjectKey(),
				isLocated:this.getIsLocated(),
				showLocationChooser:this.getShowLocationChooser(),
				isDimension:this.getIsDimension(),
				collectionName:this.getCollectionName(),
				targetFeature:this.getTargetFeature(),
				equalTypes:this.getEqualTypes(),
				favorites:this.getFavorites(),
				tableMeta:this.getTargetMeta(),
				width:this.getEditDialogWidth(),
				height:this.getEditDialogHeight(),
				linkIds:_.map(this.getLinks(),function(link){return link.getTargetKey();}),
				queryProcessor:qp,
				sourceTypeName:this.getSourceTypeName(),
				location:location,
				linkType:this.getLinkType(),
				multiSelect:this.getMultiSelect(),
				link:link
			};
			viewData["PREVIOUSBUSINESSOBJECT"]={};
		   _.each(this.getCpbForm().getCpbModelManager().getUIContext(),function(value,key){
		   	viewData.PREVIOUSBUSINESSOBJECT["PREVIOUSBUSINESSOBJECT."+key]=value;
		   });
			if(overrides){
				$.extend(viewData,overrides);
			}
			if(viewData.isDimension && this.getShowDimensionChooserAsTree()){
				$.extend(viewData,{
					leafOnly:this.getLeafOnly(),
					nonLeafOnly:this.getNonLeafOnly(),
					rootVisible:this.getRootVisible(),
					searchable:this.getSearchable(),
					showDimensionChooserAsTree:this.getShowDimensionChooserAsTree(),
					showFooter:this.getShowFooter(),
					showInactive:this.getShowInactive()
				});
			}
			//formatting key
			var component=this.getCpbName?this:this.getParent();
			var cpbForm=component.getCpbForm();
			var compName=component.getMetadata().getName().split(".").pop();
			viewData.formattingKey=sas.risk.rgf.util.RGFUtil.buildDialogFormattingKey("LBOAddLinkDialog",cpbForm,compName,component.getCpbName());
			viewData.title=viewData.title||rb.getText("lbo.add.dialog.title.txt");
			viewData.serviceId=cpbForm.getServiceId();
			this.actionTargetAddOpenDialog(viewData);
		},
		actionTargetAddOpenDialog:function(viewData){
			sas.risk.rgf.util.DialogManager.open("LBOAddLinkDialog",viewData,this.actionAddLinkSave,this);	
		},
		actionAddLinkSave:function(e){
			var pageContext=e.getParameter("pageContext");
			var data=pageContext.cpb_data;
			sas.risk.rgf.util.RGFUtil.handleCreatorFromUIContext(data);
			var selections=e.getParameter("selections");
			var previousSelections=e.getParameter("previousSelections");
			var dialog=e.getParameter("dialog");
			var currLinks=this.getLinks();
			var unlinks=[];
			_.each(previousSelections,function(prevSel){
				unlinks.push(currLinks[prevSel]);
			});
			this.saveLinks(unlinks,selections,pageContext).done(function(){
				dialog.close();
			}).fail(function(response){
				if(response && response.showErrorMsgOnTop){
					dialog.attachAfterClose(function(e){
						$($("#AppArea")[0]).scrollTop(0);
					});
				}
				dialog.close();
			});
		},
		saveLinks:function(unlinks,otherObjIds,pageContext){
			if (unlinks.length)
			   this.deleteLinks(unlinks);
			var that=this;
			var sourceKey=this.getSourceObjectKey();
			var linkTypeKey=this.getLinkTypeKey();
			var ssc=this.getSourceSystemCode();
			var creatorRk=null,linkInstanceDesc=null,customFields={},links=null;
			if(pageContext){
				var data=pageContext.cpb_data;
				creatorRk=this.doGetCreator(data);
				linkInstanceDesc=this.doGetLinkInstanceDesc(data);
				customFields=this.doGetCustomFields(data);
				links=data.links;
			}
			_.each(otherObjIds,function(selection){
				var bizKey1=that.getSideOfLink()?selection:sourceKey;
				var bizKey2=that.getSideOfLink()?sourceKey:selection;
				var link=new sas.risk.rgf.biz.Link(bizKey1,bizKey2,null,creatorRk,linkInstanceDesc,null,null,
						  linkTypeKey,ssc,$.extend({},customFields),sourceKey,null,links);
				if(pageContext){
					link.setPageContext($.extend(true,{},pageContext));
				}
				sas.risk.rgf.util.LinksUtil.updateLink(link,that);//update link container
			});
			var def=$.Deferred();
			if(this.getImmediateSave()){
				var cpbModelManager=this.getCpbForm().getCpbModelManager();
				var linkContainer=this.getLinkContainer();
				return sas.risk.rgf.api.LinkedBusinessObjectsAPI.immediateUpdateLinks(linkContainer,cpbModelManager).done(function(newObjectLinks){
					//Update the existing link's attributes for example key
					sas.risk.rgf.biz.Link.updateLinks(newObjectLinks, that.getLinks(), sourceKey);
					that.doRefresh();
				});
			}else{
				if (otherObjIds.length > 0 || unlinks.length > 0) this.fireChange();
				this.doRefresh();
				def.resolve();
			}
			return def;
		},
		doGetCustomFields:function(data){
			var customFields={};
			var tm=this.getTableMeta();
			for(key in data){
				var column=tm.getColumnByName(key,true);
				if(column && column.isColCustom()){
					customFields[column.getColName()]=data[key];
				}
			}
			return customFields;
		},
		doGetLinkInstanceDesc:function(data){
			return data.LINKINSTANCEDESC;
		},
		doGetCreator:function(data){
			return data.CREATOR.rk;
		},
		actionRowEdit:function(link){
			var rb = sas.risk.rgf.util.RGFUtil.getBundle();
			var viewData={
				link:link,
				width:this.getEditDialogWidth(),
				height:this.getEditDialogHeight(),
				linkType:this.getLinkType()
			};
			viewData["PREVIOUSBUSINESSOBJECT"]={};
		   _.each(this.getCpbForm().getCpbModelManager().getUIContext(),function(value,key){
		   	viewData.PREVIOUSBUSINESSOBJECT["PREVIOUSBUSINESSOBJECT."+key]=value;
		   });
			//formatting key
			var component=this.getCpbName?this:this.getParent();
			var cpbForm=component.getCpbForm();
			var compName=component.getMetadata().getName().split(".").pop();
			viewData.formattingKey=sas.risk.rgf.util.RGFUtil.buildDialogFormattingKey("LBOEditLinkDialog",cpbForm,compName,component.getCpbName());
			viewData.title=rb.getText("lbo.edit.dialog.title.txt");
			viewData.serviceId=cpbForm.getServiceId();
			sas.risk.rgf.util.DialogManager.open("LBOEditLinkDialog",viewData,this.actionRowEditSave,this);	
		},
		actionRowEditSave:function(e){
			var that=this;
			var pageContext=e.getParameter("pageContext");
			var link=e.getParameter("link");
			link.setPageContext(pageContext);
			var data=pageContext.cpb_data;
			var customFields=this.doGetCustomFields(data);
			link.setDescription(this.doGetLinkInstanceDesc(data));
			link.setValidFrom(this.doGetLinkValidFrom(data));
			link.setCustomFields(customFields);
			sas.risk.rgf.util.LinksUtil.updateLink(link,this);//update link container
			var dialog=e.getParameter("dialog");
			if(this.getImmediateSave()){
				var cpbModelManager=this.getCpbForm().getCpbModelManager();
				var linkContainer=this.getLinkContainer();
				sas.risk.rgf.api.LinkedBusinessObjectsAPI.immediateUpdateLinks(linkContainer,cpbModelManager).done(function(){
					dialog.close();
					that.doRefresh();
				}).fail(function(response){
					if(response && response.showErrorMsgOnTop){
						dialog.attachAfterClose(function(e){
							$($("#AppArea")[0]).scrollTop(0);
						});
					}
					dialog.close();
				});
			}else{
				this.fireChange();
				dialog.close();
				this.doRefresh();
			}
		},
		deleteLinks:function(links){
			var that = this;
			sas.risk.rgf.util.LinksUtil.deleteLinks(links,this,this.getImmediateSave());//update link container
			if(this.getImmediateSave()){
				this.setBusyIndicatorDelay(0);
				this.setBusy(true);
				var cpbModelManager=this.getCpbForm().getCpbModelManager();
				var linkContainer=this.getLinkContainer();
				sas.risk.rgf.api.LinkedBusinessObjectsAPI.immediateUpdateLinks(linkContainer,cpbModelManager).done(function(){
					that.setBusy(false);
					that.doRefresh();
				}).fail(function(response){
					that.setBusy(false);
					if(response && response.showErrorMsgOnTop){
						$($("#AppArea")[0]).scrollTop(0);
					}
				});
			}else{
				this.doRefresh();
			}
		},
		//LINK CONTAINER MGMT
		fireChange:function(){
			var bi=this.getBindingInfo("cpbValue")||this.getParent().getBindingInfo("cpbValue");
			if(bi && bi.binding && bi.binding.getModel()){
				bi.binding.getModel().checkUpdate();
			}
			this.fireEvent("change",arguments);
		},
		deleteAll:function(){
		   var links=this.getLinks();
			if (!links || links.length == 0)
		      return;
		   
		   var i, j, index;
		   for (key in links){
		      var k1 = links[key].key;
		      var linkContainer=this.getLinkContainer();
		      for (j=0; j < linkContainer.length; j++){
		         var link = linkContainer[j];
		         var k2 = link.key;
		         if (k1 == k2){
		            linkContainer.splice(j, 1);
		            break;
		         }
		      }
		   }
		   
			this.setLinks({});
			//this.setLinkContainer([]);
			this.fireChange();
		}
	}
};
sas.risk.rgf.widget.LinkedBusinessObjectsMixin.mixinMeta=function(meta){
	return $.extend(true,{},sas.risk.rgf.widget.LinkedBusinessObjectsMixin.meta,meta);
};
sas.risk.rgf.widget.LinkedBusinessObjectsMixin.mixin=function(klass){
	$.extend(klass.prototype,sas.risk.rgf.widget.LinkedBusinessObjectsMixin.proto);
};