jQuery.sap.declare("sas.risk.rgf.widget.LinkedBusinessObjectsTable");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.hc.m.Link");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.risk.rgf.util.LinksUtil");
jQuery.sap.require("sas.hc.m.MessageBox");
jQuery.sap.require("sas.risk.rgf.biz.Link");
jQuery.sap.require("sas.risk.rgf.api.CommonAPI");
jQuery.sap.require("sas.risk.slimtable.util.RowActionUtil");
jQuery.sap.require("sas.risk.rgf.api.LinkedBusinessObjectsAPI");
jQuery.sap.require("sas.risk.rgf.widget.LinkedBusinessObjectsMixin");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.rgf.util.NavigationUtil");

sas.risk.rgf.widget.RGFTable.extend("sas.risk.rgf.widget.LinkedBusinessObjectsTable",sas.risk.rgf.widget.LinkedBusinessObjectsMixin.mixinMeta({
	metadata:{
		properties:{
			showCreateLink:{type:"boolean",defaultValue:true},
			showAddTargetLink:{type:"boolean",defaultValue:true},
			showRemoveTargetLink:{type:"boolean",defaultValue:true},
			showDeleteTargetLink:{type:"boolean",defaultValue:false},
			showEditLink:{type:"boolean",defaultValue:false},
			showNoLinkTypesMessage:{type:"boolean",defaultValue:false},
			noLinkTypesMessage:{type:"string"},
			bizObjLabel:{type:"string"},
			createLabel:{type:"string"},
			linkLabel:{type:"string"},
			unlinkLabel:{type:"string"},
			deleteLabel:{type:"string"},
			//ORA
			leafOnly:{type:"boolean",defaultValue:false},
			nonLeafOnly:{type:"boolean",defaultValue:false},
			rootVisible:{type:"boolean",defaultValue:true},
			searchable:{type:"boolean",defaultValue:true},
			showDimensionChooserAsTree:{type:"boolean",defaultValue:false},
			showFooter:{type:"boolean",defaultValue:true},
			showInactive:{type:"boolean",defaultValue:false},
			//CPB
			cpbForm:{type:"any"}
		},
      events:{
			change: {}
      }
	},
	renderer:"sas.risk.slimtable.TableRenderer"
}));
sas.risk.rgf.widget.LinkedBusinessObjectsMixin.mixin(sas.risk.rgf.widget.LinkedBusinessObjectsTable);

sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.fetchData=function(){
	return sas.risk.rgf.util.LinksUtil.fetchData(this);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.init=function(){
	sas.risk.rgf.widget.RGFTable.prototype.init.apply(this,arguments);
	this.partialViewPending=false;
	this.partialViewPerms=false;
	this.attachRowSelect($.proxy(this.actionTableSelectionChanged,this));
	this.attachRowClick($.proxy(this.actionTableRowClicked,this));
	this.addPlugin(this.getTableTopActionsPlugin());
	this.addFooterMsgLayout();
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.setMeta=function(){
	sas.risk.rgf.widget.RGFTable.prototype.setMeta.apply(this,arguments);
	//ACTION COLUMN
	var actionColumn=sas.risk.slimtable.util.RowActionUtil.createActionColumn($.proxy(this.createActionMenuItems,this),this);
	this.addActionColumn(actionColumn);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.getTableTopActionsPlugin=function(){
	var that=this;
	this.targetCreateLink=new sas.risk.common.widgets.Button({
		icon:sas.icons.HC.NEWSTARBURST,
      press: $.proxy(this.actionTargetCreate,this)
   });
	this.targetAddLink=new sas.risk.common.widgets.Button({
		icon:sas.icons.HC.ADDITEM,
      press: $.proxy(this.actionTargetAdd,this)
   });
	this.targetUnlinkLink=new sas.risk.common.widgets.Button({
		icon:sas.icons.HC.REMOVEITEM,
		enabled:false,
      press: $.proxy(this.actionTargetUnlink,this)
   });
	this.targetDeleteLink=new sas.risk.common.widgets.Button({
		icon:sas.icons.HC.DELETE,
		enabled:false,
      press: $.proxy(this.actionTargetDelete,this)
   });
	
   this.tableTopActionsPlugin=new sas.risk.slimtable.plugins.TablePlugin({
     	position: sas.risk.slimtable.TableLayout.TOP_END,
   	items:[this.targetCreateLink, this.targetAddLink, this.targetUnlinkLink, this.targetDeleteLink]
   });
   this.tableTopActionsPlugin.handleDisabled=function() {
   	if(that.targetCreateLink) {
   		that.targetCreateLink.setVisible(false);
   	}
   	if(that.targetAddLink) {
   		that.targetAddLink.setVisible(false); 
   	}
   	if(that.rowEditItem) {
   		that.rowEditItem.setVisible(false);
   	}
   	if(that.targetUnlinkLink) {
   		that.targetUnlinkLink.setVisible(false);
   	}
   	if(that.rowUnlinkItem) {
   		that.rowUnlinkItem.setVisible(false);
   	}
   	if(that.targetDeleteLink){
   		that.targetDeleteLink.setVisible(false);
   	}
   	if(that.rowDeleteItem) {
   		that.rowDeleteItem.setVisible(false);
   	}
   };
   return this.tableTopActionsPlugin;
};
//REFRESH
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.refreshAll=function(){
	sas.risk.rgf.widget.RGFTable.prototype.refreshAll.apply(this,arguments);
	if(this.targetCreateLink){this.targetCreateLink.setTooltip(this.getCreateLabel());}
	this.targetAddLink.setTooltip(this.getLinkLabel());
	this.targetUnlinkLink.setTooltip(this.getUnlinkLabel());
	if(this.targetDeleteLink){this.targetDeleteLink.setTooltip(this.getDeleteLabel());}
	if(this.getShowNoLinkTypesMessage()){this.setNoDataText(this.getNoLinkTypesMessage());}
	else{this.setNoDataText(this.getNoLinkTypesMessage());}
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.refreshAdvFooter=function(){
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	sas.risk.rgf.widget.RGFTable.prototype.refreshAdvFooter.apply(this,arguments);
	this.footerMsgLayout.removeAllItems();
	if(this.partialViewPending){
		this.footerMsgLayout.setVisible(true);
		this.footerMsgLayout.addItem( new sas.hc.m.Label({
			text : rb.getText("lbo.hasUnsavedPendingItems.txt")
		}).addStyleClass("cpbMessage"));
	}
	if(this.partialViewPerms){
		this.footerMsgLayout.setVisible(true);
		this.footerMsgLayout.addItem( new sas.hc.m.Label({
			text : rb.getText("lbo.hasInvisibleItems.txt")
		}).addStyleClass("cpbMessage"));
	}
};
//CREATES
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.addFooterMsgLayout=function(){
	this.footerMsgLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		justifyContent:sas.risk.common.layout.flexlayout.FlexLayoutJustifyContent.SpaceBetween
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.Stretch
	}));
	this.footerMsgLayout.setVisible(false);
	this.footerMsgLayout.addStyleClass("RGFTabFooterMsgLayout cpbMessageBar RGFInfoMessageBar");
	this.advFooterLayout.addItem(this.footerMsgLayout);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.createActionMenuItems=function(extra){
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	var that=this;
	
	this.rowEditItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
		text : rb.getText("lbo.action.edit.txt"),
		callback : function() {
			var rowData = this.getParent().getPayload().rowData;
			var link=rowData.__LINK__;
			that.actionRowEdit(link);
		}
	});
	this.rowEditItem.setVisible(this.getShowEditLink());
	
	this.rowUnlinkItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
		text : rb.getText("lbo.action.unlink.txt"),
		callback : function() {
			that.actionRowUnlink(this);
		}
	});
	this.rowUnlinkItem.setVisible(this.targetUnlinkLink.getVisible());
	
	this.rowDeleteItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
		text : rb.getText("lbo.action.delete.txt"),
		callback : function(){that.actionRowDelete(this);}
	});
	this.rowDeleteItem.setVisible(this.targetDeleteLink.getVisible());
	
	return [this.rowEditItem, this.rowUnlinkItem, this.rowDeleteItem];
};
//ACTIONS
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionTableRowClicked=function(e){
   //CLICKING ON ROW FOR NAVIGATE TO EDIT
   var type = this.getCollectionName();
   var data = e.getSource().getSource().getData()[e.getParameter("rowIdx")];
   var key = e.getSource().getSource().getData()[e.getParameter("rowIdx")].key;
	sas.risk.rgf.util.NavigationUtil.navTo(
		this.getCpbForm(),
		{
	      type:type,
	      key:key,
	      showPendingLink:(data.linkInstanceId == null),
	      linkTypeKey:this.getLinkTypeKey(),
	      sourceObjectKey:this.getSourceObjectKey(),
	      sideOfLink:this.getSideOfLink(),
	      sourceTypeName:this.getSourceTypeName(),
	      targetMeta:this.getTargetMeta(),
	      sourceSystemCd:this.getSourceSystemCode(),
			variance:"lbo",
			event_name:"object_selected"
		}
	);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionTargetCreate=function(){
	//CLICKING ON ACTION for "Create Related Model..."
	var type = this.getCollectionName();
	this.hydrateStorageWithSourceObjectInfo();
	sas.risk.rgf.util.NavigationUtil.navTo(
		this.getCpbForm(),
		{
			key:"drafts",
			type:type,
			linkTypeKey:this.getLinkTypeKey(),
			sourceObjectKey:this.getSourceObjectKey(),
			sideOfLink:this.getSideOfLink(),
			sourceTypeName:this.getSourceTypeName(),
			targetMeta:this.getTargetMeta(),
			sourceSystemCd:this.getSourceSystemCode(),
			variance:"lbo",
			event_name:"create_new"
		}
	);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.hydrateStorageWithSourceObjectInfo=function(){
	var cpbModelManager=this.getCpbForm().getCpbModelManager();
	if(typeof(Storage) !== "undefined") {
		sessionStorage.setItem("previous_Linked_BusinessObjects", JSON.stringify(this.getLinkContainer()));
		sessionStorage.setItem("previous_BusinessObject", JSON.stringify(cpbModelManager.getUIContextValue("BUSINESSOBJECT")));
		var location = cpbModelManager.getUIContextValue("LOCATION");
		if (location) {
			sessionStorage.setItem("previous_Location", JSON.stringify(location));			
		}
		else {
			sessionStorage.setItem("previous_Location", "");  //this object does not have a location
		}

   } else {
      console.warn("localStorage / sessionStorage not supported by this browser")
   }	
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionTargetUnlink=function(){
	var that = this;
	var source=this.table.getSource();
	var indices=source.getSelections();
	var rows=source.getData();
	var i,row,links=[];
	for(i=0;i<indices.length;i++){
		row=rows[indices[i]];
		links.push(row.__LINK__);
	}
	var def=this.doUnlink(links,true);
	def.done(function(success){
		if(success) {
			that.clearTableSelections(); //clear table selection unless you hit cancel
		}
	});
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionTargetDelete=function() {
	var that = this;
	that.setBusyIndicatorDelay(0);
	that.setBusy(true);
	
	var source = this.table.getSource();
	var indices = source.getSelections();
	var rows = source.getData();
	var i,row;
	var links=[];
	var objDelLinks=[];
	for(i = 0; i < indices.length; i++) {
		row = rows[indices[i]];
		links.push(row.__LINK__); // linked business object "link"
		
		var jsonLinks = row.links; 
		var deleteObjLink=_.find(jsonLinks,function(jsonLink){return jsonLink.rel.toUpperCase()==="DELETE"});
		objDelLinks.push(deleteObjLink); // json href "link" members
	}
	
	this._doDelete(links, objDelLinks, true); // delete issued viaTableSelection = true
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionRowUnlink=function(item){
	var rowData = item.getParent().getPayload().rowData;
	var link=rowData.__LINK__;
	this.doUnlink([link]);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionRowDelete=function(item) {
	var rowData = item.getParent().getPayload().rowData;
	var link=rowData.__LINK__;
	var jsonLinks = rowData.links; 
	var deleteObjLink=_.find(jsonLinks,function(jsonLink){return jsonLink.rel.toUpperCase()==="DELETE"});
	this._doDelete([link], [deleteObjLink]);
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.actionTableSelectionChanged=function() {
	if(this.targetUnlinkLink) {
		this.targetUnlinkLink.setEnabled(!!this.table.getSource().getSelections().length);
	}	
	if(this.targetDeleteLink) {
		this.targetDeleteLink.setEnabled(!!this.table.getSource().getSelections().length);
	}
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.clearTableSelections=function() {
	this.table.getSource().setSelections([]); 
	this.actionTableSelectionChanged();
}
//DOs
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.doGetLinkValidFrom=function(data){
   return data.BUSINESSOBJECT.validFrom;
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.getTableMeta=function(){
	return this.table.getSource().getTableMeta();
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.doUnlink=function(links, viaSelection, noWarn) {
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	var def=$.Deferred();
	var that = this;
	var callBackFn = function(event) {
		var action=event&&event.getParameter("origin").getMessageDialogAction();
		if(action===sas.hc.m.MessageDialogAction.Cancel){def.resolve(false);return;}
		that.deleteLinks(links);
		if (links.length && !that.getImmediateSave()) that.fireChange();
		def.resolve(true);
	};
	if(noWarn) {
		callBackFn();
	} else {
		var labelKey=(viaSelection)?"lbo.action.confirmation.fmt.txt":"lbo.action.confirmation.txt";
		var labelArgs=[this.getBizObjLabel()];
		var titleKey="lbo.action.confirmation.title.fmt.txt";
		sas.hc.m.MessageDialog.warning({
			text:rb.getText(labelKey,labelArgs),
			title:rb.getText(titleKey,labelArgs),
			buttonActions:[ {key:"UNLINK",text:rb.getText("lbo.action.confirmation.unlink.txt")}, sas.hc.m.MessageDialogAction.Cancel],
			buttonPress:callBackFn
		});
	}
	return def;
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype._doDelete=function(businessObjectLinks, objectDeleteLinks, viaSelection) {
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	var that = this;
	
	var callBackFn = function(event) {
		var action=event.getParameter("origin").getMessageDialogAction();
		if(action===sas.hc.m.MessageDialogAction.Cancel){that.setBusy(false);return;}
		
		var def = that._doBusinessObjectDeletes(objectDeleteLinks);
		def.done(function(success) {
			def = that.doUnlink(businessObjectLinks, viaSelection, true); // noWarn=true; already did the warning in this _doDelete function
			def.done(function(success) {
				if(success) {
					 that.doRefresh();
				    that.clearTableSelections(); //clear table selection unless you hit cancel
				    def.resolve(true);
				} 
			}).fail(function(response) {
				if(response && response.showErrorMsgOnTop) {
					$($("#AppArea")[0]).scrollTop(0);
				}
				def.reject();
			}).always(function(response) {
				that.setBusy(false);
			});
		}).fail(function(response) {
			// _doBusinessObjectDeletes already handled the error - nothing further needed
		});
	};
	
	var labelKey=(viaSelection) ? "lbo.action.confirmation.delete.fmt.txt" : "lbo.action.confirmation.delete.txt";
	var args=[that.getBizObjLabel()];
	var titleKey="lbo.action.confirmation.delete.title.fmt.txt";
	sas.hc.m.MessageDialog.warning({
		text:rb.getText(labelKey, args),
		title:rb.getText(titleKey, args),
		buttonActions:[ {key:"DELETE", text:rb.getText("lbo.action.delete.txt")}, sas.hc.m.MessageDialogAction.Cancel],
		buttonPress:callBackFn
	});
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype._doBusinessObjectDeletes=function(objDeleteLinks) {
	var that = this;
	that.setBusyIndicatorDelay(0);
	that.setBusy(true);
	var def=$.Deferred();
	
	var deferreds = [];
	for(var i = 0; i < objDeleteLinks.length; i++) {
	    var deleteLink = objDeleteLinks[i];
	    deferreds.push(
   		 this.getCpbForm().getQueryAPI().deleteQueryTableEntry(deleteLink.uri, deleteLink.method)
	    );
	};
	// Can't pass a literal array, so use apply.
	$.when.apply($, deferreds).then(function() {
	    that.doRefresh();
	    def.resolve(true); 
	}).fail(function(response) {
		 if(response && response.showErrorMsgOnTop) {
			  $($("#AppArea")[0]).scrollTop(0);
		 }
		 def.reject();
	}).always(function() {
		 that.setBusy(false);
	});
	
	return def;
};

//SETTERS
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.setShowCreateLink=function(value){
	this.setProperty("showCreateLink",value);
	if (!value) {
		this.targetCreateLink.setVisible(false);
	}	
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.setShowAddTargetLink=function(value){
	this.setProperty("showAddTargetLink",value);
	if (!value) {
		if(this.targetAddLink) {
			this.targetAddLink.setVisible(false);
		}
	}	
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.setShowRemoveTargetLink=function(value){
	this.setProperty("showRemoveTargetLink",value);
	if (!value) {
		if(this.targetUnlinkLink) {
			this.targetUnlinkLink.setVisible(false);
		}
	}	
};
sas.risk.rgf.widget.LinkedBusinessObjectsTable.prototype.setShowDeleteTargetLink=function(value){
	this.setProperty("showDeleteTargetLink",value);
	if (!value) {
		if(this.targetDeleteLink) {
			this.targetDeleteLink.setVisible(false);
		}
	}	
};