jQuery.sap.declare("sas.risk.rgf.widget.cell.MultiObjectChooserCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ADialogCell");

sas.risk.common.widgets.spreadsheet.control.ADialogCell.extend("sas.risk.rgf.widget.cell.MultiObjectChooserCell",{
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.rgf.widget.cell.MultiObjectChooserCell.prototype.getDialogName=function(){
	return "sas.ui.cpb3.components.MultiObjectChooserDialog";
};
sas.risk.rgf.widget.cell.MultiObjectChooserCell.prototype.createDialogViewData=function(){
	var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	var splits=this.getCellType().split("_");
	var collection=splits.pop();
	var cpbForm=this.cellInfo.spreadsheet.getParent().getParent().getCpbForm();
	var serviceId=cpbForm.getServiceId();
   var metaUrl="rest/"+serviceId+"/fieldMeta/"+collection;
   var dataUrl="rest/"+serviceId+"/"+collection;

	return {
		title:rb.getText("spreadsheet.cell.dialog.param.title.txt"),
		isSpreadsheet:true,
		metaUrl:metaUrl,
		dataUrl:dataUrl,
		cancelButtonTxt:rb.getText("objectChooser.cancelBtn.txt"),
		collection:collection
	};
};
sas.risk.rgf.widget.cell.MultiObjectChooserCell.prototype.dialogCallback=function(e){
	var rows=e.getParameter("item");
	this.editControl.setValue(rows);
	this.editInput.setText(this.formatValueAsString(rows));
	this.storeNewValue();
	this.refreshViewControl();
	this.preventBlur=false;
	this.editing=false;
	e.resolve&&e.resolve();
};
sas.risk.rgf.widget.cell.MultiObjectChooserCell.prototype.formatValueAsString=function(value){
	if(value&&value.length){
		if(value.length>=5){
			var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
			return rb.getText("spreadsheet.cell.multiobj.many.txt",[value.length]);
		}
		var labels=[];
		_.each(_.pluck(value,"name"),function(v){
			labels.push(v);
		});
		return labels.join(",");
	}
	return value;
};