jQuery.sap.declare("sas.risk.rgf.widget.cell.ObjectChooserCell");
jQuery.sap.require("sas.risk.common.widgets.spreadsheet.control.ADialogCell");

sas.risk.common.widgets.spreadsheet.control.ADialogCell.extend("sas.risk.rgf.widget.cell.ObjectChooserCell",{
	renderer:"sas.risk.common.widgets.spreadsheet.control.ACellRenderer"
});
sas.risk.rgf.widget.cell.ObjectChooserCell.prototype.getDialogName=function(){
	return "sas.ui.cpb3.components.ObjectChooserDialog";
};
sas.risk.rgf.widget.cell.ObjectChooserCell.prototype.createDialogViewData=function(){
	var rb=sas.risk.common.widgets.spreadsheet.SpreadsheetUtil.getBundle();
	var splits=this.getCellType().split("_");
	var collection=splits.pop();
	var cpbForm=this.cellInfo.spreadsheet.getParent().getParent().getCpbForm();
	var serviceId=cpbForm.getServiceId();
   var metaUrl="rest/"+serviceId+"/fieldMeta/"+collection;
   var dataUrl="rest/"+serviceId+"/"+collection;

	return {
		title:rb.getText("spreadsheet.cell.dialog.param.title.txt"),
		isSpreadsheet:true,
		metaUrl:metaUrl,
		dataUrl:dataUrl,
		cancelButtonTxt:rb.getText("objectChooser.cancelBtn.txt"),
		collection:collection
	};
};
sas.risk.rgf.widget.cell.ObjectChooserCell.prototype.dialogCallback=function(e){
	var row=e.getParameter("item");
	this.editControl.setValue({name:row.name,key:row.key,sourceSystemCd:row.sourceSystemCd,objectId:row.objectId});
	this.editInput.setText(this.formatValueAsString(this.editControl.getValue()));
	this.storeNewValue();
	this.refreshViewControl();
	this.preventBlur=false;
};
sas.risk.rgf.widget.cell.ObjectChooserCell.prototype.formatValueAsString=function(value){
	return value&&value.name;
};