jQuery.sap.declare("sas.risk.rgf.widget.dimloc.DimensionalLocation");
jQuery.sap.require("sas.hc.ui.commons.windowshade.WindowShade");
jQuery.sap.require("sas.risk.common.widgets.windowshade.WindowShadePlusSection2");
jQuery.sap.require("sas.risk.rgf.meta.DimLocSelection");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.risk.slimtable.widget.Item");
jQuery.sap.require("sas.risk.common.utils.DialogManager");
jQuery.sap.require("sas.risk.rgf.widget.dimloc.DimensionalLocationUtil");
jQuery.sap.require("sas.risk.rgf.widget.dimloc.DimensionalLocationConstraints");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.gridlayout.GridLayout");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.risk.rgf.biz.SecurityKey");
jQuery.sap.require("sas.risk.rgf.JSONModel");

sas.hc.ui.commons.windowshade.WindowShade.extend("sas.risk.rgf.widget.dimloc.DimensionalLocation",{
	metadata:{
		properties:{
			feature:{type:"any"},
			favorites:{type:"any"},
			isEverywhereAllowed:{type:"boolean"},
			isForFiltering:{type:"boolean"},
			isPoint:{type:"boolean"},
			singlePoint:{type:"boolean",defaultValue:false},
			isRootVisible:{type:"boolean"},
			secureActionVal:{type:"string"},
			secureObjectClassName:{type:"string"},
			showMappedStandardBusinessLine:{type:"boolean"},
			showMappedStandardRiskType:{type:"boolean"},
			validatePermissions:{type:"boolean"},
			hideInactive:{type:"boolean", defaultValue: true},
			showInactiveCheckbox: {type:"boolean", defaultValue: true},
			required:{type:"boolean"},
			handle:{type:"string"},
			enabled:{type:"boolean",defaultValue:true},
			title:{type:"string"},
			collapsed:{type:"boolean",defaultValue:true},
			//linked to section
			required : {type : "boolean", group : "Misc", defaultValue : false},
			errored:{type:"boolean",defaultValue:false},
			help:{type:"string"}
		},
		events:{
			change : {
				parameters : {
					newValue : {type : "string"}
				}
			},
			favChange:{
				parameters : {
					newValue : {type : "any"},
					action : {type : "string"}
				}
			}
		}
	},
	constructor:function(){
		this.dimLocSelection=new sas.risk.rgf.meta.DimLocSelection();
		this.isEverywhere=false;
		this.section = new sas.risk.common.widgets.windowshade.WindowShadePlusSection2();
	   sas.risk.common.utils.CompositeUtil.addComposite(this,"title",this.section);
		sas.risk.common.utils.CompositeUtil.addComposite(this,"required",this.section);
		sas.risk.common.utils.CompositeUtil.addComposite(this,"errored",this.section);
		sas.risk.common.utils.CompositeUtil.addComposite(this,"help",this.section);   
		sas.hc.ui.commons.windowshade.WindowShade.apply(this,arguments);
		this.addSection(this.section);
		this.addStyleClass("RGFDimLoc");
		this.setWidth("100%");
	},
	renderer:"sas.hc.ui.commons.windowshade.WindowShadeRenderer"
});
sas.risk.common.utils.CompositeUtil.mixinPropertySupport(sas.risk.rgf.widget.dimloc.DimensionalLocation);

sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.applySettings=function(){
	sas.hc.ui.commons.windowshade.WindowShade.prototype.applySettings.apply(this,arguments);
	this.dimLocConstraints=new sas.risk.rgf.widget.dimloc.DimensionalLocationConstraints(this);
	this.createAll();
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.setIsPoint=function(value){
	this.setProperty("isPoint",value);
	this.dimLocSelection.setPointBased(value);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.setHandle=function(handle,def){
	def=def||$.Deferred();
   this.queued=this.queued||[];
   if(this.queued.length){//already running one, must queue it up
   		 def=this.queued[0].def;//override the queue but reuse the deferred
          this.queued[0]={handle:handle,def:def};
   }else{//empty queue, run it now
          this.queued.push({handle:handle,def:def});//add it to queue so we know its in the middle of running one
          var that=this;
          this._setHandle(handle).done(function(){
                 if(that.queued[0]&&that.queued[0].handle!==handle){//another queued up while this one ran, must run another one
                    	  var next=that.queued.pop();
                       that.setHandle(next.handle,next.def);
                 }else{//no more to run
                       that.queued.pop();
                 }
                 def.resolve();
          });
   }
   return def;
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype._setHandle=function(handle){
	this.setProperty("handle",handle);
	var def=$.Deferred();
	jQuery.sap.delayedCall(0, this, function() {
		this._setHandleAsync(handle).done(function(){
			def.resolve();
		});
	});
	return def;
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype._setHandleAsync=function(handle){
	this.isEverywhere=handle==="1|10000|";
	var that=this;
	var d1=sas.risk.rgf.biz.DimArea.load(handle,this.getSecurityKey());
	var d2=sas.risk.rgf.biz.Favorite.loadAllNodes(this.getFavorites(),this.getSecurityKey());
	return $.when(d1,d2).done(function(area){
		that.area=area;
		if(!that.getIsPoint()&&!area.isBasic()){//if orachooser is set to basic mode, but the handle is advanced, than auto switch to advanced editor
			that.setIsPoint(true);//TODO:maybe set built flag to false?
			that.built=false;//force a recreate for area to point coercion 
		}
		if(that.getIsPoint()){
			that.dimLocSelection.setAll(area.getNodesByPoint(that.getSecurityKey()));
		}else{
			that.dimLocSelection.set(area.getNodes(that.getSecurityKey()));
		}
		that.createAll();
		that.refreshAll();
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.getSecurityKey=function(){
	return this.securityKey;
};
/****************
 * CREATES
 ****************/
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.createAll=function(){
	if(!this.built){
		this.securityKey=this.getIsForFiltering()?null:new sas.risk.rgf.biz.SecurityKey(this.getFeature(),this.getSecureActionVal());
		this.createHeader();
		this.createBody();
		this.built=true;
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.createHeader=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var that=this;
	//FAV DROPDOWN
	this.favSelect=new sas.hc.m.Select({
		change:function(e){
			var item=e.getParameter("selectedItem");
			var fav=item.getPayload();
			that.dimLocSelection.reset();
			if(fav){
				if(that.getIsPoint()){
					that.dimLocSelection.setAll(fav.getArea().getNodesByPoint(that.getSecurityKey()));
				}else{
					that.dimLocSelection.set(fav.getArea().getNodes(that.getSecurityKey()));
				}
			}
			if(item.getKey()!=="-4"){//-4 is everywhere
				that.isEverywhere=false;
			}else{
				that.actionSelectEverywhere();
			}
			that.refreshBody();
			that.actionApplyDimLocSelection();
		},
		items:{
			path:"private>/items",
			template:new sas.risk.slimtable.widget.Item({
				text:"{private>text}",
				key:"{private>key}",
				payload:"{private>payload}",
				enabled:"{private>enabled}"
			})
		},
		selectedKey:"{private>/selectedKey}"
	}).addStyleClass("RiskSelect");
	this.favSelect.setModel(new sas.risk.rgf.JSONModel(),"private");
	this.favManage=new sas.hc.m.Link({
		text:rb.getText("dimloc.fav.manage.txt"),
		press:$.proxy(this.actionOpenEditor,this)
	});
	this.favLabel=new sas.hc.m.Text({text:""});
	this.favWidget=this.getEnabled()?this.favSelect:this.favLabel;
	this.favWidget.addStyleClass("RGFDimLocFavSelect");
	this.headerExtraLayout=new sas.hc.m.Toolbar({
		content:[
			 this.favWidget,this.favManage
		]
	});
	this.section.setHeaderToolbar(this.headerExtraLayout);	
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.createBody=function(){
	this.section.removeAllContent();
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	if(this.getIsPoint()){
		this.midLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
		}).addStyleClass("RGFDimLocSelViewer ");
		this.section.addStyleClass("RGFDimLocPoints");
	}else{
		this.midLayout=new sas.risk.common.layout.gridlayout.GridLayout({
			width:"100%",
			gridTemplateColumns:"auto 1fr",
			gridColumnGap:"24px",
			gridRowGap:"8px"
		}).addStyleClass("RGFDimLocSelViewer");
	}
	this.section.addContent(this.midLayout);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.reloadFavorites=function(){
	var that=this;
	sas.risk.rgf.biz.Favorite.loadAll(this.getSecurityKey()).done(function(favs){
		that.setFavorites(favs);
		that.refreshAll();
	});
};
/**********************
/* REFRESH METHODS
/**********************/
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshAll=function(){
	if(this.getParent() && this.getParent().getVisible()){
		this.refreshBody();
		this.refreshFavorites();
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshBody=function(){
	if(this.getIsPoint()){
		this.refreshBodyPoints();
	}else{
		this.refreshBodyBasic();
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshBodyBasic=function(){
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshSelectionViewerBasic(this,this.dimLocSelection,this.isEverywhere,this.midLayout);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshBodyPoints=function(){
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshSelectionViewerPoints(this,this.dimLocSelection,this.isEverywhere,this.midLayout);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshFavorites=function(){
	if(!this.getEnabled()){
		if(this.favLabel!==this.favWidget){
			this.favWidget=this.favLabel;
			this.headerExtraLayout.removeAllContent();
			this.headerExtraLayout.addContent(this.favWidget);
		}
		return this.refreshFavoritesReadonly();
	}
	if(this.favSelect!==this.favWidget){
		this.favWidget=this.favSelect;
		this.headerExtraLayout.removeAllContent();
		this.headerExtraLayout.addContent(this.favWidget);
		this.headerExtraLayout.addContent(this.favManage);
	}
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshFavorites(this,this.dimLocSelection,this.isEverywhere,this.favSelect);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.refreshFavoritesReadonly=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var feature=this.getFeature();
	var selNodes=this.dimLocSelection.getAll();
	var securityKey=this.getSecurityKey();
	var isPoint=this.getIsPoint();
	var isForFiltering=this.getIsForFiltering();
	var selectedFav=_.find(this.getFavorites(),function(fav){return fav.matchesNodes(selNodes,securityKey)&&fav.isValidForFeature(feature,!isPoint,isForFiltering,securityKey);});
	if(this.isEverywhere){
		this.favLabel.setText(rb.getText("dimloc.fav.everywhere.txt"));
	}else if(selectedFav){
		this.favLabel.setText(selectedFav.getName());
	}else if(this.dimLocSelection.isEmpty()){
		this.favLabel.setText(rb.getText("dimloc.fav.nonsel.txt"));
	}else{
		this.favLabel.setText(rb.getText("dimloc.fav.custom.txt"));
	}
};
/****************
 * ACTIONS
 ****************/
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.actionApplyDimLocSelection=function(){
	var that=this;
	that.setBusy(true);
	this.dimLocSelection.getPoints().done(function(points){
		var origHandle=that.getHandle();
		var area=new sas.risk.rgf.biz.DimArea(points);
		var handle=points.length?area.getHandle():"";
		if(that.isEverywhere){
			handle="1|10000|";//'everywhere' handle
		}
		if(origHandle!==handle){
			that.setHandle(handle).done(function(){
				that.fireChange({newValue:handle});
				that.setBusy(false);
			});
		}else{
			that.setBusy(false);
		}
	}).fail(function(e){
		console.error("Failed:",e);
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.actionSelectEverywhere=function(){
	this.dimLocSelection.reset();
	this.isEverywhere=true;
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.actionOpenEditor=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var viewData={
		title:rb.getText("dimloc.manage.dialog.txt"),
		dimloc:this
	};
	sas.risk.common.utils.DialogManager.open("sas.risk.rgf.widget.dimloc.DimensionalLocationEditorDialog",viewData,this.actionSaveEditor,this);
};
sas.risk.rgf.widget.dimloc.DimensionalLocation.prototype.actionSaveEditor=function(e){
	var editor=e.getParameter("editor");
	this.dimLocSelection=editor.dimLocSelection;
	this.isEverywhere=editor.isEverywhere;
	this.actionApplyDimLocSelection();
};