jQuery.sap.declare("sas.risk.rgf.widget.dimloc.DimensionalLocationEditor");
jQuery.sap.require("sas.risk.common.widgets.windowshade.WindowShadePlus");
jQuery.sap.require("sas.risk.common.widgets.windowshade.WindowShadePlusSection");
jQuery.sap.require("sas.risk.slimtable.widget.Select");
jQuery.sap.require("sas.hc.ui.commons.layout.VerticalLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.HorizontalLayout");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.risk.slimtable.widget.Item");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.ui.layout.Splitter");
jQuery.sap.require("sas.risk.rgf.widget.Tree");
jQuery.sap.require("sas.risk.rgf.widget.TreeNode");
jQuery.sap.require("sas.risk.rgf.util.RGFUtil");
jQuery.sap.require("sas.hc.m.Link");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.risk.rgf.api.DimensionalLocationAPI");
jQuery.sap.require("sas.risk.rgf.biz.Favorite");
jQuery.sap.require("sas.risk.rgf.biz.DimArea");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.risk.rgf.widget.RGFTable");
jQuery.sap.require("sas.risk.rgf.biz.DimensionDefinition");
jQuery.sap.require("sas.risk.rgf.meta.DimLocSelection");
jQuery.sap.require("sas.risk.rgf.util.DialogManager");
jQuery.sap.require("sas.risk.common.utils.CompositeUtil");
jQuery.sap.require("sas.hc.ui.commons.windowshade.WindowShadeRenderer");
jQuery.sap.require("sas.risk.common.widgets.LabelPlus");
jQuery.sap.require("sas.risk.slimtable.widget.SearchField");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.risk.common.utils.CustomDataUtil");
jQuery.sap.require("sas.risk.common.widgets.CheckBoxGroup");

sas.hc.ui.commons.layout.BorderLayout.extend("sas.risk.rgf.widget.dimloc.DimensionalLocationEditor",{
	metadata:{
		properties:{
			dimloc:{type:"any"}
		},
		events:{
			change : {
				parameters : {
					newValue : {type : "string"}
				}
			},
			favChange:{
				parameters : {
					newValue : {type : "any"},
					action : {type : "string"}
				}
			}
		}
	},
	constructor:function(){
		this.searchMode=false;
		sas.hc.ui.commons.layout.BorderLayout.apply(this,arguments);
		this.setWidth("100%");
		this.setHeight("100%");
		this.addStyleClass("RGFDimLocEditor");
	},
	renderer:"sas.hc.ui.commons.layout.BorderLayoutRenderer"
});
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.applySettings=function(){
	sas.hc.ui.commons.layout.BorderLayout.prototype.applySettings.apply(this,arguments);
   var dimloc=this.getDimloc();
	this.dimLocSelection=dimloc.dimLocSelection.clone();
   this.isEverywhere=dimloc.isEverywhere;
	this.createAll();
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createAll=function(){
	var headerLayout=this.createSearchField();
	headerLayout.addItem(this.createClearAllLink());
	this.setTop(new sas.hc.ui.commons.layout.BorderLayoutArea({
		size:"32px",
		content:[headerLayout]
	}));
	var centerItems = [this.createSplitter(),this.createFilterMappings()];
	this.dimloc = this.getDimloc();
	var that = this;
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	if(this.dimloc && this.dimloc.getShowInactiveCheckbox()) {
		this.showInactiveCheckbox = new sas.hc.m.CheckBox({
   		text: rb.getText("dimension.hideInactive.txt"), //Hide inactive and staged
   		selected: that.dimloc.getHideInactive(), 
   		select:function(e){
   			var selected=e.getParameter("selected");
				that.dimloc.setHideInactive(selected);
				that.tree.collapseAll();
				that.refreshAll();
			}
		}).addStyleClass("RGFDimLocInactiveCheckbox");
		centerItems.push(this.showInactiveCheckbox);
	}
	var centerLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		height:"100%",
		items: centerItems
	});
	this.setCenter(new sas.hc.ui.commons.layout.BorderLayoutArea({content:[centerLayout]}));
	var footerLayout=this.createClassificationSelect();
	footerLayout.addItem(this.createAddRemoveFavLinks());

	this.setBottom(new sas.hc.ui.commons.layout.BorderLayoutArea({
		size:"58px",
		content:[footerLayout]
	}));
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createSearchField=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	this.searchField=new sas.risk.slimtable.widget.SearchField({
		placeholder:rb.getText("dimloc.search.placeholder.txt"),
		search:$.proxy(this.actionSearch,this)
	});
	var that=this;
	this.searchField.attachBrowserEvent("keyup",function(e){
		if(!that.searchMode&&that.searchField.getValue()){//special case where you hit backspace, switches to tree but you are still focused in on search field and type something
			that.searchMode=true;
			that.actionSearchSelectDim();//trigger dim selection for first render
			that.refreshTree();
			that.refreshSearch();
			setTimeout(function(){
				sas.risk.rgf.util.RGFUtil.setCaretPosition(that.searchField.getId()+"-I",that.searchField.getValue().length);
			},0);//the rerendering of its peers is causing the caret position to move back to 0 index
		}
	});
//	this.searchField.attachBrowserEvent("focusin",function(e){//clicking on the search field
//		if(!that.searchMode){
//			that.searchMode=true;
//			that.actionSearchSelectDim();//trigger dim selection for first render
//			that.refreshTree();
//			that.refreshSearch();
//		}
//	});
	var searchFieldLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%"
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexShrink:0,
		flexGrow:0
	})).addStyleClass("RGFDimLocSearchLayout");
	searchFieldLayout.setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:0,
		flexShrink:0,
		alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.Stretch
	}));
	searchFieldLayout.addItem(this.searchField);
	this.searchFieldDoneButton=new sas.risk.common.widgets.Button({
		text:rb.getText("dimloc.search.done.button.txt"),
		press:function(){
			that.searchMode=false;
			that.searchField.setValue("");
			that.refreshTree();
			that.refreshSearch();
		}
	});
	this.searchFieldDoneButton.addStyleClass("sasPrimaryButton");
	searchFieldLayout.addItem(this.searchFieldDoneButton);
	return searchFieldLayout;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createClearAllLink=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var that=this;
	this.clearAllLink=new sas.hc.m.Link({
		text:rb.getText("dimloc.link.clearAll.txt"),
		press:function(){
			that.dimLocSelection.reset();
			that.isEverywhere=false;
			that.actionSearchSelectDim();//trigger dim selection for a good clear of search results
			that.refreshAll();
		}
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.Center
	})).addStyleClass("RGFDimLocClearAllLink");
	return this.clearAllLink;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createSplitter=function(){
	this.splitter=new sas.hc.ui.layout.Splitter().setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:1
	})).addStyleClass("RGFDimLocSplitter");
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	this.pickerLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Stretch,
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:2//IE11 forgets width:100% when toggling between search and tree, must use grow:2
	})).addStyleClass("");
	var tree=this.createTree();
	var searchResults=this.createSearchResults();
	this.pickerLayout.addItem(tree);
	this.pickerLayout.addItem(searchResults);
	this.splitter.addContentArea(this.pickerLayout);
	var selViewer=this.createSelectionViewer();
	this.splitter.addContentArea(selViewer);
	if(this.getDimloc().getIsPoint()){
		this.splitter.addStyleClass("RGFDimLocPoints");
	}
	return this.splitter;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createFilterMappings=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var that=this;
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	this.filterMappings=new sas.hc.m.CheckBox({
		text:rb.getText("dimloc.manage.dialog.filtermappings.txt"),
		selected:(!isForFiltering)&&!dimloc.getSecurityKey().getOverrideMappings(),
		visible:false,
		select:function(e){
			var selected=e.getParameter("selected");
			var dimloc=that.getDimloc();
			dimloc.getSecurityKey().setOverrideMappings(!selected);
			that.tree.collapseAll();
			that.refreshAll();
		}
	});
	return this.filterMappings;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createClassificationSelect=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var selectLabel=new sas.hc.m.Label({text:rb.getText("dimloc.manage.dialog.select.label.txt")}).addStyleClass("RGFDimLocClassSelectLabel");
	var that=this;
	var dimloc=this.getDimloc();
	this.select=new sas.hc.m.Select({
		change:function(e){
			var item=e.getParameter("selectedItem");
			var fav=item.getPayload();
			that.dimLocSelection.reset();
			if(fav){
				if(dimloc.getIsPoint()){
					that.dimLocSelection.setAll(fav.getArea().getNodesByPoint(dimloc.getSecurityKey()));
				}else{
					that.dimLocSelection.set(fav.getArea().getNodes(dimloc.getSecurityKey()));
				}
			}
			if(item.getKey()!=="-4"){//-4 is everywhere
				that.isEverywhere=false;
			}else{
				that.actionSelectEverywhere();
			}
			that.refreshAll();
		},
		items:{
			path:"private>/items",
			template:new sas.risk.slimtable.widget.Item({
				text:"{private>text}",
				key:"{private>key}",
				payload:"{private>payload}",
				enabled:"{private>enabled}"
			})
		},
		selectedKey:"{private>/selectedKey}"
	});
	this.select.setModel(dimloc.favSelect.getModel("private"),"private");
	this.select.addAriaLabelledBy(selectLabel);
	var selectLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		items:[selectLabel,this.select]
	});
	return new sas.risk.common.layout.flexlayout.FlexLayout({
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.FlexEnd,
		items:[selectLayout]
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexShrink:0,
		flexGrow:0
	}));
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createAddRemoveFavLinks=function(){
	var that=this;
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	this.addFaveLink=new sas.hc.m.Link({
		text:rb.getText("dimloc.link.addFav.txt"),
		press:function(){
			that.actionAddToFavorites();
		}
	});
	this.delFaveLink=new sas.hc.m.Link({
		text:rb.getText("dimloc.link.delFav.txt"),
		press:function(){
			var fav=that.select.getSelectedItem().getPayload();
			var answer=confirm(rb.getText("dimloc.link.delFav.confirmation.fmt.txt",[fav.getName()]));
			if(answer){
				that.actionDelFromFavorites();
			}
		}
	});
	this.addFaveLink.addStyleClass("RGFDimLocFavLink");
	this.delFaveLink.addStyleClass("RGFDimLocFavLink");
	return new sas.risk.common.layout.flexlayout.FlexLayout({
		items:[this.addFaveLink],
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.FlexEnd
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createSearchResults=function(){
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var that=this;
	this.searchResults=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%",
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	this.searchResults.addItem(this.createSearchDims());

	//formatting key
	var component=this.getDimloc().getParent();
	var cpbForm=component.getCpbForm?component.getCpbForm():null;
	var compName=cpbForm?component.getMetadata().getName().split(".").pop():"DimensionalLocation";
	var cpbName=component.getCpbName?component.getCpbName():null;
	var formattingKey=sas.risk.rgf.util.RGFUtil.buildFormattingKey(cpbForm,compName,cpbName);
	this.searchTable=new sas.risk.rgf.widget.RGFTable({
		formattingKey:formattingKey,
		showSelectionControls:true,
		multiSelect:true,
		meta: {
			columns:[
				{	
					filterable: false,
					label: rb.getText("dimloc.search.table.col.name.txt"),
					name: "name",
					quickSearch: false,
					sortPreference: 9999,
					sortable: true,
					type: "java.lang.String",
					userDisplayOrder: 0,
					userVisible: true,
					visible: true
				},
				{	
					filterable: false,
					label: rb.getText("dimloc.search.table.col.path.txt"),
					name: "path",
					quickSearch: false,
					sortPreference: 9999,
					sortable: true,
					type: "java.lang.String",
					userDisplayOrder: 1,
					userVisible: true,
					visible: true
				}
			]
		},
		data: $.proxy(this.actionSearchTable,this),
		visibleRows: -1,
		rowSelect:$.proxy(this.actionSearchResultRowSelected,this),
		preselection:$.proxy(this.actionSearchUpdateResultSelections,this),
		disablement:$.proxy(this.actionSearchUpdateResultDisablements,this),
		plugins:[new sas.risk.slimtable.plugins.Counter(),
		         new sas.risk.slimtable.plugins.Pager()
		]
	}).addStyleClass("RGFDimLocSearchTable");
	this.searchResults.addItem(this.searchTable);
	this.searchResults.setVisible(false);
	return this.searchResults;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createSearchDims=function(){
	var dimloc=this.getDimloc();
	var rb=sas.risk.rgf.util.RGFUtil.getBundle();
	var layout=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%",
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Row,
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Baseline
	});
	var label=new sas.hc.m.Label({text:rb.getText("dimloc.search.dims.txt")});
	label.setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:0,
		flexShrink:0
	}));
	label.addStyleClass("RGFDimLocSearchSelectLabel");
	layout.addItem(label);
	this.dimSelect=new sas.risk.slimtable.widget.Select({
		change:$.proxy(this.actionSearchSelectDim,this)
	});
	this.dimSelect.setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:0,
		flexShrink:0,
		alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.FlexStart
	}));
	var feature=dimloc.getFeature();
	var dims=feature.getDimensions();
	var i,dim,item;
	for(i=0;i<dims.length;i++){
		dim=dims[i];
		item=new sas.risk.slimtable.widget.Item({
			text:dim.getDimLabel(),
			key:i,
			payload:dim
		});
		this.dimSelect.addItem(item);
	}
	this.dimSelect.addStyleClass("RGFDimLocSearchSelect");
	layout.addItem(this.dimSelect);
	return layout;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createTree=function(){
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var feature=dimloc.getFeature();
	var isRootVisible=dimloc.getIsRootVisible();
	this.tree=new sas.risk.rgf.widget.Tree({
		showHeader:false,
		selectionMode:sap.ui.commons.TreeSelectionMode.None
	});
	this.tree.addStyleClass("RGFTree");
	var dims=feature.getDimensions();
	var basicMode=!dimloc.getIsPoint();
	var singlePoint=dimloc.getSinglePoint();
	var i,dim,dimNode,node;
	for(i=0;i<dims.length;i++){
		dim=dims[i];
		dimNode=sas.risk.rgf.biz.DimNodeRegistry.getNode(dim.getDimName(),-1,dimloc.getSecurityKey());
		node=this.createTreeNode(dim.getDimRootLabel(),dimNode,
				(isRootVisible&&dimNode.calcSelectable(feature))||isForFiltering,/*selectable*/
				dim.getIsRequired(),/*required*/
				(dim.getAllowsMultiple()&&basicMode&&!singlePoint)||isForFiltering);/*allowsMultiple*/
		if(node.getRequired()){
			node.addStyleClass("RGFTreeNodeRequired");
		}
		if(!dimNode.getLeaf()){
			node.addNode(new sas.risk.rgf.widget.TreeNode({}));
		}
		this.tree.addNode(node);
	}
	this.tree.collapseAll();
	this.tree.setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:2,
		alignSelf:sas.risk.common.layout.flexlayout.FlexLayoutDataAlignSelf.Stretch
	}));
	return this.tree;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createTreeNode=function(text,key,selectable,required,allowsMultiple){
	var that=this;
	return new sas.risk.rgf.widget.TreeNode({
		text:text,
		key:key,
		selectable:selectable&&!that.isEverywhere,//do not show selection when 'everywhere' is selected
		required:required,
		allowsMultiple:allowsMultiple,
		groupName:key.getDimensionName(),
		expand:function(){
			var expandingDimNode=this.getKey();
			that.actionExpandNode(expandingDimNode,this);
		},
		select:function(e){
			var selected=e.getParameter("selected");
			if(selected){
				that.handleSingleSelection.apply(that,[this.getParent().getKey()]);
				that.actionSelectNode(this.getParent().getKey(),this);
			}else{
				that.actionDeselectNode(this.getParent().getKey(),this);
			}
		}
	});	
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.handleSingleSelection=function(dimNode){
	var dimloc=this.getDimloc();
	var dims=dimloc.getFeature().getDimensions();
	var dim=_.find(dims,function(dim){return dim.name===dimNode.getDimensionName();});
	var isBasic=!dimloc.getIsPoint();
	var singlePoint=dimloc.getSinglePoint();
	var isForFiltering=dimloc.getIsForFiltering();
	if((dim.getAllowsMultiple() && isBasic && !singlePoint)||isForFiltering){return;}
	//If it is in single selection mode or in point based mode then make sure only one node is selected in that dimension 
	var selectionDims=this.dimLocSelection.getAll()[this.dimLocSelection.getCurrentIndex()];
	var existingNode=_.find(selectionDims,function(dim){return dim.getDimensionName()===dimNode.getDimensionName();});
	if(existingNode){
		this.actionDeselectNode(existingNode);
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.createSelectionViewer=function(){
	if(this.getDimloc().getIsPoint()){
		this.midLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
		}).addStyleClass("RGFDimLocSelViewer");
	}else{
		this.midLayout=new sas.risk.common.layout.gridlayout.GridLayout({
			width:"100%",
			gridTemplateColumns:"auto 1fr",
			gridColumnGap:"24px",
			gridRowGap:"12px"
		}).addStyleClass("RGFDimLocSelViewer");
	}
	return this.midLayout;
};
/**********************
/* REFRESH METHODS
/**********************/
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshAll=function(){
	var that=this;
	this.getDimloc().dimLocConstraints.refreshConstraints(this.tree,this.searchTable,this.dimLocSelection).done(function(){
		that.refreshTree();
		that.refreshSearch();
		that.refreshFavorites();
		that.refreshSelectionViewer();
		that.refreshFilterMappings();
		that.fireChange({editor:that});
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshFilterMappings=function(){
	var dimloc=this.getDimloc();
	this.filterMappings.setVisible(dimloc.getFeature().getHasConstraints()&&!dimloc.getIsForFiltering());
	this.filterMappings.setEnabled(dimloc.getFeature().getAllowUnconstrained());
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshTree=function(){
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var isRootVisible=dimloc.getIsRootVisible();
	var feature=dimloc.getFeature();
	var that=this;
	var recurse=function(parent){
		var i,node,key,selected,selectable;
		var children=parent.getNodes();
		for(i=0;i<children.length;i++){
			node=children[i];
			key=node.getKey();
			selected=that.dimLocSelection.containsNode(key);
			if(selected){
				node.addStyleClass("RGFTreeNodeSelected");
			}else{
				node.removeStyleClass("RGFTreeNodeSelected");
			}
			if(node.getSelected()!==selected){
				node.setSelected(selected);
			}
			if(key){
				var constraints=dimloc.dimLocConstraints.getConstraints(key.getDimensionName(),key.getDimNodeKey(),that.dimLocSelection);
				selectable=key.isRoot()?!that.isEverywhere&&((key.calcSelectable(feature)&&isRootVisible&&constraints.selectable)||isForFiltering)
						                 :!that.isEverywhere&&((key.calcSelectable(feature)&&constraints.selectable)||isForFiltering);
				sas.risk.common.utils.CustomDataUtil.data(node,"HIDEME",(!constraints.visible).toString(),true);
			}else{
				selectable=!that.isEverywhere;
			}
			node.setSelectable(selectable);
			recurse(node);
		}
	}
	recurse(this.tree);
	if(this.tree.getDomRef()){
		this.tree.scrollTopInfo=this.tree.getDomRef().scrollTop;
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshSearch=function(){
	if(this.searchMode){
		this.pickerLayout.setHeight("100%");//for table auto row size
		this.searchFieldDoneButton.setVisible(true);
		this.tree.setVisible(false);
		this.searchResults.setVisible(true);
		this.actionSearchUpdateResultSelections();
		this.actionSearchUpdateResultDisablements();
	}else{
		this.pickerLayout.setHeight("auto");/*for tree to have a padding on the bottom when scrolling*/
		this.searchFieldDoneButton.setVisible(false);
		this.searchResults.setVisible(false);
		this.tree.setVisible(true);
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshFavorites=function(){
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshFavorites(this.getDimloc(),this.dimLocSelection,this.isEverywhere,this.select,this.addFaveLink,this.delFaveLink,this.favNameLabel);
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshSelectionViewer=function(){
	if(this.getDimloc().getIsPoint()){
		this.refreshSelectionViewerPoints();
	}else{
		this.refreshSelectionViewerBasic();
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshSelectionViewerBasic=function(){
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshSelectionViewerBasic(this.getDimloc(),this.dimLocSelection,this.isEverywhere,this.midLayout,this);
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.refreshSelectionViewerPoints=function(){
	sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.refreshSelectionViewerPoints(this.getDimloc(),this.dimLocSelection,this.isEverywhere,this.midLayout,this);
};
/****************
 * ACTIONS
 ****************/
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionExpandNode=function(dimNode,treeNode){
	var that=this;
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var hideInactive=dimloc.getHideInactive();
	var feature=dimloc.getFeature();
	var allowsMultiple=feature.getDimension(dimNode.getDimensionName()).getAllowsMultiple();
	var securityKey=dimloc.getSecurityKey();
	var basicMode=!dimloc.getIsPoint();
	var singlePoint=dimloc.getSinglePoint();
	dimNode.loadChildren(securityKey, null, !hideInactive).done(function(children){
		treeNode.removeAllNodes();
		var i,childDimNode,childTreeNode;
		if(!children.length){
			dimNode.setLeaf(true);
		}else{
			for(i=0;i<children.length;i++){
				childDimNode=children[i];
				childTreeNode=that.createTreeNode(childDimNode.getLocalizedLabel(),childDimNode,
						childDimNode.calcSelectable(feature)||isForFiltering,/*selectable*/
						false,/*required*/
						(allowsMultiple&&basicMode&&!singlePoint)||isForFiltering);/*allowsMultiple*/
				if(!childDimNode.getLeaf()){
					childTreeNode.addNode(new sas.risk.rgf.widget.TreeNode({}));
					childTreeNode.setExpanded(false);
				}
				if(that.dimLocSelection.containsNode(childDimNode)){
					childTreeNode.setSelected(true);
				}
				treeNode.addNode(childTreeNode);
			}
			treeNode.setExpanded(true);
		}
		that.getDimloc().dimLocConstraints.refreshConstraints(that.tree,that.searchTable,that.dimLocSelection).done(function(){
			that.refreshTree();
		});
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionDelFromFavorites=function(){
	var fav=this.select.getSelectedItem().getPayload();
	var that=this;
	var dimloc=this.getDimloc();
	sas.risk.rgf.api.DimensionalLocationAPI.deleteFavorite(fav.getKey()).done(function(){
		dimloc.setFavorites(_.filter(dimloc.getFavorites(),function(favorite){return fav!==favorite;}));
		that.refreshFavorites();
		dimloc.fireFavChange({newValue:fav,action:"delete"});
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionAddToFavorites=function(){
	this.actionOpenAddFavDialog();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionPointSave=function(){
	this.dimLocSelection.newPoint();
	this.searchMode=false;//same as actionPointEdit
	this.searchField.setValue("");
	this.tree.collapseAll();
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionPointRemove=function(index){
	this.dimLocSelection.removePoint(index);
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionPointEdit=function(index){
	this.dimLocSelection.setCurrentIndex(index);
	this.searchMode=false;//same as actionPointSave
	this.searchField.setValue("");
	this.tree.collapseAll();
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSelectEverywhere=function(){
	this.dimLocSelection.reset();
	this.isEverywhere=true;
	this.actionSearchSelectDim();//trigger dim selection for a good clear of search results
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSelectNode=function(dimNode,treeNode){
	this.dimLocSelection.addNode(dimNode);
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionDeselectNode=function(dimNode,treeNode){
	this.dimLocSelection.removeNode(dimNode);
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearchSelectDim=function(){
	var selectedItem=(this.dimSelect.getSelectedItem()||this.dimSelect.getItems()[0]);
	if(!this.dimSelect.getSelectedItem()){
		this.dimSelect.setSelectedItem(selectedItem);
	}
	var dim=selectedItem.getPayload();
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var isBasic=!dimloc.getIsPoint();
	var singlePoint=dimloc.getSinglePoint();
	this.searchTable.setShowSelectionControls(!this.isEverywhere);
	this.searchTable.setMultiSelect((dim.getAllowsMultiple()&&isBasic&&!singlePoint)||isForFiltering);
	this.searchTable.setVisible(false);
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearchTable=function(query){
	var def=$.Deferred();
	var dimloc=this.getDimloc();
	if(this.dimSelect&&this.searchField&&this.searchField.getValue()){
		var securityKey=dimloc.getSecurityKey();
		var searchText=this.searchField.getValue();
		var dim=this.dimSelect.getSelectedItem().getPayload();
		var hideInactive=dimloc.getHideInactive();
		var loadAllAvailable=null;
		dim.search(searchText,query,securityKey,true,loadAllAvailable,!hideInactive).done(function(nodes,count,start){
			var json={count:count,start:start,items:[]};
			var node,i;
			for(i=0;i<nodes.length;i++){
				node=nodes[i];
				json.items.push({name:node.getName(),path:node.getLocalizedPath(),payload:node});
			}
			def.resolve(json);
		});
	}else{
		def.resolve({items:[],count:0,start:0});
	}
	return def;
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearch=function(e){
	if(e.getParameter("query")){
		this.searchTable.setVisible(true);
		var that=this;
		this.searchTable.doRefresh();
	}else{//empty string search, backspace on last character, clear search button all fall here
		this.searchMode=false;
		this.refreshSearch();
		this.refreshTree();
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearchUpdateResultSelections=function(){
	var that=this;
	var dimName=this.dimSelect.getSelectedItem().getPayload().getDimName();
	var source=this.searchTable.getSource();
	var data=source.getData();
	if(!data){return;}//too soon. model has no data yet.
	var selections=source.getSelections();
	var i,rowDimNode,ctxt,model,path,selected,selectionIndex;
	var delta=false;
	for(i=0;i<data.length;i++){
		selectionIndex=selections.indexOf(i);
		selected=selectionIndex!==-1;
		rowDimNode=data[i].payload;
		if(rowDimNode){
			if(that.dimLocSelection.containsNode(rowDimNode)){
				if(!selected){//match found, if unselected it must be selected
					selections.push(i);
					delta=true;
				}
			}else{//no match found, if selected than it must be deselected
				if(selected){
					selections.splice(selectionIndex,1);
					delta=true;
				}
			}
		}
	}
	if(delta){
		source.getTable().rerender();
	}
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearchUpdateResultDisablements=function(source){
	var source=source||this.searchTable.getSource();
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var feature=dimloc.getFeature();
	var data=source.getData();
	var origDisableds=source.getDisableds();
	var disableds=[];
	var that=this;
	dimloc.dimLocConstraints.refreshConstraints(this.tree,this.searchTable,this.dimLocSelection).done(function(){
		var i,row,dimNode,constraints;
		if(data && !isForFiltering){ //no disablements when filtering
			for(i=0;i<data.length;i++){
				row=data[i];
				dimNode=row.payload;
				constraints=dimloc.dimLocConstraints.getConstraints(dimNode.getDimensionName(),dimNode.getDimNodeKey(),that.dimLocSelection);
				if(!constraints.visible||!constraints.selectable||!dimNode.calcSelectable(feature)){
					disableds.push(i);
				}
			}
		}
		if(origDisableds.length!==disableds.length || !!_.difference(origDisableds,disableds).length){
			source.setDisableds(disableds);
			that.searchTable.rerender();
		}
	});
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSearchResultRowSelected=function(e){
	var source=this.searchTable.getSource();
	var selected=e.getParameter("selected");
	var rowIdx=e.getParameter("rowIdx");
	var selections=source.getSelections();
	var dimNode=source.getData()[rowIdx].payload;
	var dimloc=this.getDimloc();
	var isForFiltering=dimloc.getIsForFiltering();
	var feature=dimloc.getFeature();
	var dim=feature.getDimension(dimNode.getDimensionName());
	var basicMode=!dimloc.getIsPoint();
	var singlePoint=dimloc.getSinglePoint();
	if(selected){
		if(!isForFiltering && (!dim.getAllowsMultiple() || !basicMode || singlePoint)){
			this.dimLocSelection.removeDim(dimNode.getDimensionName());
		}
		if(!this.dimLocSelection.containsNode(dimNode)){
			this.dimLocSelection.addNode(dimNode);
		}
	}else{
		this.dimLocSelection.removeNode(dimNode);
	}
	this.refreshAll();
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionOpenAddFavDialog=function(){
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	var viewData={
		title:rb.getText("dimloc.fav.add.basic.title.txt")	
	};
	sas.risk.rgf.util.DialogManager.open("AddFavoriteDialog",viewData,this.actionSaveAddFavDialog,this);
};
sas.risk.rgf.widget.dimloc.DimensionalLocationEditor.prototype.actionSaveAddFavDialog=function(e){
	var name=e.getParameter("name");
	var dialog=e.getParameter("dialog");
	var that=this;
	var dimloc=this.getDimloc();
	this.dimLocSelection.getPoints().done(function(points) {
		sas.risk.rgf.biz.Favorite.create(name, points).done(function(favorite) {
			dimloc.getFavorites().push(favorite);
			dialog.setBusy(false);
			that.refreshFavorites();
			dimloc.fireFavChange({newValue:favorite,action:"add"});
			dialog.close();
		}).fail(function(){
			dialog.setBusy(false);
		});
	});
};
sas.risk.common.utils.CompositeUtil.mixinPropertySupport(sas.risk.rgf.widget.dimloc.DimensionalLocationEditor);
