jQuery.sap.declare("sas.risk.rgf.widget.dimloc.DimensionalLocationUtil");
jQuery.sap.require("sas.risk.common.layout.gridlayout.GridLayoutData");

sas.risk.rgf.widget.dimloc.DimensionalLocationUtil={
		refreshSelectionViewerPoints:function(dimloc,dimLocSelection,isEverywhere,midLayout,eventHandler){
			var rb=sas.risk.rgf.util.RGFUtil.getBundle();
			midLayout.removeAllItems();
			midLayout.removeStyleClass("RGFDimLocSelViewerZeroState");
			var hasSelections=dimLocSelection.hasSelections();
			var isReadonly=!eventHandler;
			var feature=dimloc.getFeature();
			var baseDimensions=feature.getDimensions();
			var visibleByDefaultDims = feature.getVisibleByDefaultDimensions();
			var processedVisibleByDefault=false;
			var requiredDimensions=_.filter(baseDimensions,function(dim){return dim.getIsRequired();});
			var reqDimNames=_.pluck(requiredDimensions,'name');
			var x,includedDim=false,selectionCount=dimLocSelection.getCount();
			if(hasSelections){ //If there are selections then show them and indicate the required dimensions in each selection
				var count=dimLocSelection.getCount();
				var i,isEditing,saveRemoveLink,editLink,link1Added,link2Added,groups,activeClass;
				for(i=0;i<count;i++){
					groups=dimLocSelection.group(i);
					if(_.size(groups)===0){continue;}//skip empty point, ie: the last one
					var grid=new sas.risk.common.layout.gridlayout.GridLayout({
						width:"100%",
						gridTemplateColumns:"auto 1fr",
						gridColumnGap:"24px",
						gridRowGap:isReadonly?"8px":"12px"
					}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
						flexGrow:0,
						flexShrink:0
					}));
					if(i!==0){//if not first point
						var spacer=new sas.risk.common.layout.flexlayout.FlexLayout({
							width:"100%"
						}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
							flexShrink:0
						})).addStyleClass("RGFDimLocSelViewerPtSpacer");
						midLayout.addItem(spacer);
					}
					midLayout.addItem(grid);
					link1Added=false;
					link2Added=false;
					isEditing=(dimLocSelection.getCurrentIndex()===i);
					activeClass=(isEditing)?"RGFDimLocPtSelected":"RGFDimLocPtNotSelected";
					grid.addStyleClass(activeClass);
					saveRemoveLink=isReadonly?null
						                      :(isEditing?new sas.hc.m.Link({
						                     	 				text:rb.getText("dimloc.link.savept.txt"),
						                     	 				enabled:dimLocSelection.containsAll(reqDimNames,i),
						                     	 				press:$.proxy(eventHandler.actionPointSave,eventHandler)
						                     	 			 }).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
						                  							gridColumnStart:"3",
						                  							gridColumnEnd:"4",
						                  							justifySelf:sas.risk.common.layout.gridlayout.GridLayoutDataJustifySelf.End
						                  					 })).addStyleClass("RGFDimLocLink")
												               :new sas.hc.m.Link({
												               	text:rb.getText("dimloc.link.removept.txt"),
												               	press:$.proxy(eventHandler.actionPointRemove,eventHandler,i)
											               	 }).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
											               		 gridColumnStart:"3",
																		 gridColumnEnd:"4",
																		 justifySelf:sas.risk.common.layout.gridlayout.GridLayoutDataJustifySelf.End
																	 })).addStyleClass("RGFDimLocLink"));
					editLink=(isReadonly||isEditing)?null
															  :new sas.hc.m.Link({
																  text:rb.getText("dimloc.link.editpt.txt"),
																  press:$.proxy(eventHandler.actionPointEdit,eventHandler,i)
																}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
																	gridColumnStart:"3",
																	gridColumnEnd:"4",
																	justifySelf:sas.risk.common.layout.gridlayout.GridLayoutDataJustifySelf.End
																})).addStyleClass("RGFDimLocLink");
					sortedGroups=_.sortBy(groups,function(g,n){return feature.indexOfDimension(n);});
					var groupNames=[], groupNameToGroupMap={};
					_.each(sortedGroups,function(group){
					   var dimName=group[0].getDimensionName();
						groupNames.push(dimName);	
						groupNameToGroupMap[dimName]=group;
					});
					if(groupNames.length===0){ //To avoid adding entry for a selection with empty nodes
						grid.addStyleClass("RGFDimLocSelViewerEmpty")
						continue;
					}
					var reqAndGroupNames=groupNames.concat(reqDimNames);
					reqAndGroupNames=reqAndGroupNames.concat(_.pluck(visibleByDefaultDims,'name'));
					processedVisibleByDefault=true;
					reqAndGroupNames=_.uniq(reqAndGroupNames);
					
					var sortedReqAndGroupNames=_.sortBy(reqAndGroupNames,function(g){return feature.indexOfDimension(g);});
					_.each(sortedReqAndGroupNames,function(rg){
						var dimension=feature.getDimension(rg);
						if(!dimension){return false;}/*excluded dimension*/
						var group=groupNameToGroupMap[dimension.getDimName()];
						//Handle first DimNode in the Dimension Group
						var groupLabel=new sas.risk.common.widgets.LabelPlus({
							text:rb.getText("dimloc.coloned.fmt.txt",dimension.getDimLabel()),
							required:(reqDimNames.indexOf(dimension.getDimName()) > -1) ? true : false
						}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
							gridColumnStart:"1",
							gridColumnEnd:"2"
						}));
						groupLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
						var path=group ? group.shift().getLocalizedPath() : "";
						var pathLabel=new sas.hc.m.Text({text:path}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
							gridColumnStart:"2",
							gridColumnEnd:"3"
						}));
						pathLabel.addStyleClass("RGFDimLocSelViewerSelNodesPathLbl");
						grid.addItem(groupLabel);
						grid.addItem(pathLabel);
						//Add Edit links as Needed
						if(!link1Added){
							grid.addItem(saveRemoveLink);
							link1Added=true;
						}else if(!link2Added){
							grid.addItem(editLink);
							link2Added=true;
						}
						//Handle remaining DimNodes in the Dimension group
						_.each(group,function(node){
							pathLabel=new sas.hc.m.Text({text:node.getLocalizedPath()}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
								gridColumnStart:"2",
								gridColumnEnd:"3"
							}));
							pathLabel.addStyleClass("RGFDimLocSelViewerSelNodesPathLbl");
							grid.addItem(pathLabel);
							if(!link2Added){
								grid.addItem(editLink);
								link2Added=true;
							}
						});
					});
					//Make sure an Edit Link is added if the Dimension Group has 1 or 0 DimNodes
					if(link1Added&&!link2Added&&!(isEditing||isReadonly)){
						grid.addItem(editLink);
					}
				}
			} 	
			//If there is no selection then simply show the required point
			else if(isReadonly){
				var sortedRequiredDims=_.sortBy(requiredDimensions,function(dim){return feature.indexOfDimension(dim.getDimName());});
				_.each(sortedRequiredDims,function(reqDim){
					var dimLabel=new sas.risk.common.widgets.LabelPlus({
						text:rb.getText("dimloc.coloned.fmt.txt",reqDim.getDimLabel()),
						required:true
					});
					dimLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
					midLayout.addItem(dimLabel);
				});
			}
			// Add in the VisibleByDefault items
			if (visibleByDefaultDims.length && !processedVisibleByDefault){
			 	_.each(visibleByDefaultDims,function(visibleDim){
		 			var dimLabel=new sas.risk.common.widgets.LabelPlus({
						text:rb.getText("dimloc.coloned.fmt.txt",visibleDim.getDimLabel()),
						required: false
					});
			 		dimLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
			 		midLayout.addItem(dimLabel);
			 	});
			}
			if(isEverywhere){
				var everywhereLabel=new sas.hc.m.Label({text:rb.getText("dimloc.selView.everywhere.txt")});
				everywhereLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
				if(!isReadonly){
					midLayout.addStyleClass("RGFDimLocSelViewerZeroState");
				}
				midLayout.addItem(everywhereLabel);
			}else if(!midLayout.getItems().length){
				var noneLabel=new sas.hc.m.Text({
					text:rb.getText(!isReadonly?"dimloc.selView.zerostate.txt":"dimloc.selView.none.txt")
				});
				noneLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
				if(!isReadonly){
					midLayout.addStyleClass("RGFDimLocSelViewerZeroState");
				}
				midLayout.addItem(noneLabel);
			}
		},
		refreshSelectionViewerBasic:function(dimloc,dimLocSelection,isEverywhere,midLayout,eventHandler){
			var isReadonly=!eventHandler;
			midLayout.removeStyleClass("RGFDimLocSelViewerZeroState");
			var rb=sas.risk.rgf.util.RGFUtil.getBundle();
			midLayout.removeAllItems();
			var groups=dimLocSelection.group();
			var feature=dimloc.getFeature();
			var sortedGroups=_.sortBy(groups,function(g,n){return feature.indexOfDimension(n);});
			var requiredDims=feature.getRequiredDimensions();
			var visibleByDefaultDims = feature.getVisibleByDefaultDimensions();
			var sortedRequiredDims=_.sortBy(requiredDims,function(dim){return feature.indexOfDimension(dim.getDimName());});
			_.each(sortedRequiredDims,function(reqDim){
				var includedDim=_.find(sortedGroups,function(group){return group[0].getDimensionName()===reqDim.getDimName();});
				if(includedDim){
					sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.addGroupToBodyBasic(midLayout,feature,includedDim,true);
					sortedGroups.splice(sortedGroups.indexOf(includedDim),1);
				}
				else{
					var dimLabel=new sas.risk.common.widgets.LabelPlus({
						text:rb.getText("dimloc.coloned.fmt.txt",reqDim.getDimLabel()),
						required:true
					}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
						gridColumnEnd:"span 2"
					}));
					dimLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
					midLayout.addItem(dimLabel);
				}
			});
			_.each(visibleByDefaultDims, function( visdim) {
				if(!sortedRequiredDims.find(function(name){ return name.name === visdim.name; })) {
					var includedDim=_.find(sortedGroups,function(group){return group[0].getDimensionName()===visdim.getDimName();});
				    if(!includedDim){
				   	 var dimLabel=new sas.risk.common.widgets.LabelPlus({
				   		 text:rb.getText("dimloc.coloned.fmt.txt",visdim.getDimLabel()),
				   		 required:false
				   	 }).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
				   		 gridColumnEnd:"span 2"
				   	 }));
				   	 dimLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
				   	 midLayout.addItem(dimLabel);
				    }
				}
			});
			_.each(sortedGroups,function(group){
				sas.risk.rgf.widget.dimloc.DimensionalLocationUtil.addGroupToBodyBasic(midLayout,feature,group);
			});
			if(isEverywhere){
				var everywhereLabel=new sas.hc.m.Text({
					text:rb.getText("dimloc.selView.everywhere.txt")
				}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
					gridColumnEnd:"span 2"
				}));
				everywhereLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
				if(!isReadonly){
					midLayout.addStyleClass("RGFDimLocSelViewerZeroState");
				}
				midLayout.addItem(everywhereLabel);
			}else if(!midLayout.getItems().length){
				var noneLabel=new sas.hc.m.Text({
					text:rb.getText(!isReadonly?"dimloc.selView.zerostate.txt":"dimloc.selView.none.txt")
				}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
					gridColumnEnd:"span 2"
				}));
				noneLabel.addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
				if(!isReadonly){
					midLayout.addStyleClass("RGFDimLocSelViewerZeroState");
				}
				midLayout.addItem(noneLabel);
			}
		},
		addGroupToBodyBasic:function(midLayout,feature,group,required){
			var rb=sas.risk.rgf.util.RGFUtil.getBundle();
			var groupName=group[0].getDimensionName();
			var dimension=feature.getDimension(groupName);
			if(!dimension){return;}//dimension was not part of feature, dropping it.(must of been a change in dimensionality.xml since obj creation)
			var groupLabel=new sas.risk.common.widgets.LabelPlus({
				text:rb.getText("dimloc.coloned.fmt.txt",dimension.getDimLabel()),
				required:required
			}).addStyleClass("RGFDimLocSelViewerSelNodesGrpLbl");
			var pathLabel=new sas.hc.m.Label({text:group.shift().getLocalizedPath()}).addStyleClass("RGFDimLocSelViewerSelNodesPathLbl");
			midLayout.addItem(groupLabel);
			midLayout.addItem(pathLabel);
			_.each(group,function(node){
				pathLabel=new sas.hc.m.Text({
					text:node.getLocalizedPath()
				}).setLayoutData(new sas.risk.common.layout.gridlayout.GridLayoutData({
					gridColumnStart:2
				})).addStyleClass("RGFDimLocSelViewerSelNodesPathLbl");
				midLayout.addItem(pathLabel);
			});
		},
		refreshFavorites:function(dimloc,dimLocSelection,isEverywhere,select,addFaveLink,delFaveLink,favNameLabel){
			var rb=sas.risk.rgf.util.RGFUtil.getBundle();
			var allowEverywhere=dimloc.getIsEverywhereAllowed();
			var feature=dimloc.getFeature();
			var isPoint=dimLocSelection.pointBased;
			var isForFiltering=dimloc.getIsForFiltering();
			var selNodes=dimLocSelection.getAll();
			if(isPoint){
				selNodes=selNodes.slice();
				selNodes.pop();//don't include the unsaved point
			}
			var favorites=dimloc.getFavorites();
			var securityKey=dimloc.getSecurityKey();
			var selectedFav=_.find(favorites,function(fav){return fav.matchesNodes(selNodes,securityKey)&&fav.isValidForFeature(feature,!isPoint,isForFiltering,securityKey);});
			
			var items=[];
			var data={items:items};
			items.push({
				text:rb.getText("dimloc.fav.nonsel.txt"),
				key:"-2",
				enabled:true
			});
			if(dimloc.getIsEverywhereAllowed()){
				items.push({
					text:rb.getText("dimloc.fav.everywhere.txt"),
					key:"-4",
					enabled:true
				});
			}
			if(!selectedFav){
				if(isEverywhere){
					data.selectedKey="-4";
				}else if(dimLocSelection.isEmpty()){
					data.selectedKey="-2";
				}else{
					items.push({
						text:rb.getText("dimloc.fav.custom.txt"),
						key:"-3",
						enabled:true
					});
					data.selectedKey="-3";
				}
			}
			var i,fav;
			for(i=0;i<favorites.length;i++){
				fav=favorites[i];
				items.push({
					text:fav.getName(),
					key:fav.getKey().toString(),
					payload:fav,
					enabled:fav.isValidForFeature(feature,!isPoint,isForFiltering,securityKey)
				});
				if(selectedFav===fav){
					data.selectedKey=fav.getKey().toString();
				}
			}
			var privateModel=select.getModel("private");
			var oldData=privateModel.getData();
			if(!oldData.items || oldData.items.length!==data.items.length || 
				 _.differenceObj(oldData.items,data.items,function(a,b){
					 return a.key===b.key && a.enabled===b.enabled;
				 }).length){
				privateModel.setData(data);
			}else if(oldData.selectedKey!==data.selectedKey){
				privateModel.setProperty("/selectedKey",data.selectedKey);
			}
			if(addFaveLink){
				addFaveLink.setEnabled(!dimLocSelection.isEmpty());
				var layout=addFaveLink.getParent()||delFaveLink.getParent();
				layout.removeAllItems();
				if(isEverywhere){
					addFaveLink.setEnabled(false);
					layout.addItem(addFaveLink);
				}else	if(selectedFav){
					layout.addItem(delFaveLink);
				}else{
					layout.addItem(addFaveLink);
				}
			}
		}
};