jQuery.sap.declare("sas.risk.rgf.widget.menu.ExcelItem");
jQuery.sap.require("sas.risk.common.widgets.MenuItem");
jQuery.sap.require("sas.risk.rgf.util.DialogManager");

sas.risk.common.widgets.MenuItem.extend("sas.risk.rgf.widget.menu.ExcelItem",{});
sas.risk.rgf.widget.menu.ExcelItem.prototype.applySettings=function(){
	this.setText(sas.risk.rgf.util.RGFUtil.getBundle().getText("table.toolbar.menu.excel.txt"));
   this.setPayload("EXCEL");
   this.setHideOnReadonly(false);
	this.setCallback($.proxy(this.action,this));
	sas.risk.common.widgets.MenuItem.prototype.applySettings.apply(this,arguments);
};
sas.risk.rgf.widget.menu.ExcelItem.prototype.action=function(rgfTable){
	var that=rgfTable;
	var fields;
	var query = that.getQuery();
	if (query){
		var visibleColumns = query.getOrderedColumns();
		for(i = 0; i < visibleColumns.length; i++) {
			var varName = visibleColumns[i].name;
			if (!fields) {
				fields = "fields=" + varName;
			} else {
				fields = fields + "," + varName;
			}
		}
	}
   var exportURL=rgfTable.getExportURL();
   if(!exportURL) {
      console.error("exportURL is not provided. Can't perform Export to excel.");
      return; //TODO: display error dialog that exportURL is not provided
   }
   
   // adding visible fields
   if (fields)
   	exportURL=exportURL+ (exportURL.indexOf("?") > 0 ? "&" : "?") + fields;
   
   exportURL=exportURL+ (exportURL.indexOf("?") > 0 ? "&" : "?") +that.query.toString();
   exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("start");
   exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("limit");
   var xhr=new XMLHttpRequest();
   xhr.open("GET",exportURL,true);
   xhr.responseType="blob";
   xhr.onload=function(e){
   	if(this.status==200){
         var contentDispositionHeader = xhr.getResponseHeader("content-disposition");
         var fileName = contentDispositionHeader.slice(contentDispositionHeader.indexOf("filename")).replace("filename=\"", "").replace("\"","");
   		var blob=this.response;
   		if(window.navigator.msSaveBlob){
   			window.navigator.msSaveBlob(blob,fileName);
   		}else{
	         var downloadUrl = URL.createObjectURL(blob);
	         var a = document.createElement("a");
			   a.href = downloadUrl;
			   a.download = fileName;
			   document.body.appendChild(a);
			   a.click();
   		}
   	}
   };
   xhr.onerror=function(e){
   	console.log(e);
   	alert('Unable to download excel.');
   };
   xhr.send();
};