jQuery.sap.declare("sas.risk.rgf.widget.menu.LBOExcelItem");
jQuery.sap.require("sas.risk.common.widgets.MenuItem");

sas.risk.common.widgets.MenuItem.extend("sas.risk.rgf.widget.menu.LBOExcelItem",{});
sas.risk.rgf.widget.menu.LBOExcelItem.prototype.applySettings=function(){
	this.setText(sas.risk.rgf.util.RGFUtil.getBundle().getText("table.toolbar.menu.excel.txt"));
   this.setPayload("EXCEL");
   this.setHideOnReadonly(false);
	this.setCallback($.proxy(this.action,this));
	sas.risk.common.widgets.MenuItem.prototype.applySettings.apply(this,arguments);
};
sas.risk.rgf.widget.menu.LBOExcelItem.prototype.action=function(rgfTable){
	var component = rgfTable.getParent();
	var fields;
	var visibleColumns = component.tables[0].table.state.source.tableMeta.visibleColumns
	for(i = 0; i < visibleColumns.length; i++) {
		var varName = visibleColumns[i].name;
		if (!fields) {
			fields = "fields=" + varName;
		} else {
			fields = fields + "," + varName;
		}
	}
	
	var filter;
	var data = component.tables[0].table.state.source.data;
	for(i = 0; i < data.length; i++) {
		var key = data[i].key;
		if (i == 0) {
			filter = "filter=in(key," + key;
		} else {
			filter = filter + "," + key;
		} 
	}
	filter = filter ? filter + ")" : "filter=in(key,-1)";
	
	
	var that=rgfTable;
   var exportURL= rgfTable.getExportURL(); //sas.risk.rgf.util.RGFUtil.getRestUrl() + "/" + component.tables[0].getCollectionName() + "/export";
   if(!exportURL) {
      console.error("exportURL is not provided. Can't perform Export to excel.");
      return;
   }
   
   // adding visible fields
   exportURL=exportURL+ (exportURL.indexOf("?") > 0 ? "&" : "?") + fields;
   
   // adding the current data/rows in LBO table
   exportURL=exportURL+ (exportURL.indexOf("?") > 0 ? "&" : "?") + filter;
   
   // adding general query parameters
   exportURL=exportURL+ (exportURL.indexOf("?") > 0 ? "&" : "?") +that.query.toString();
   exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("start");
   exportURL=sas.risk.rgf.util.URLParser.parseURL(exportURL).removeParam("limit");
   
   var xhr=new XMLHttpRequest();
   xhr.open("GET",exportURL,true);
   xhr.responseType="blob";
   xhr.onload=function(e){
   	if(this.status==200){
         var contentDispositionHeader = xhr.getResponseHeader("content-disposition");
         var fileName = contentDispositionHeader.slice(contentDispositionHeader.indexOf("filename")).replace("filename=\"", "").replace("\"","");
   		var blob=this.response;
   		if(window.navigator.msSaveBlob){
   			window.navigator.msSaveBlob(blob,fileName);
   		}else{
	         var downloadUrl = URL.createObjectURL(blob);
	         var a = document.createElement("a");
			   a.href = downloadUrl;
			   a.download = fileName;
			   document.body.appendChild(a);
			   a.click();
   		}
   	}
   };
   xhr.onerror=function(e){
   	console.log(e);
   	alert('Unable to download excel.');
   };
   xhr.send();
};