jQuery.sap.declare("sas.risk.slimtable.meta.ColumnMeta");
jQuery.sap.require("sap.ui.commons.Label");

sas.risk.slimtable.meta.ColumnMeta = function(displayOrder, type, label, name, rawName, preferredWidth, fixed, visible, userVisible, quickSearch, choices, custom, filterable, useAllFilter, sortable, sortDirection, queryable, linkField, sortOrder, nameLocalization, descLocalization){
	this.displayOrder = displayOrder;
	this.type = type;
	this.label = label;
	this.name = name;
	this.rawName = rawName;
	this.preferredWidth = preferredWidth;
	this.fixed = fixed;
	this.defaultVisible = visible;
	this.userVisible=userVisible;
	this.queryable=queryable;
	this.quickSearch = quickSearch;
	this.choices = choices;
	this.custom = custom;
	this.filterable = filterable;
	this.useAllFilter = useAllFilter;
	this.sortable = sortable;
	this.sortDirection = sortDirection;
	this.formatter = null;
	this.action = null;
	this.queryable = queryable;
	this.linkField = linkField;
	this.sortOrder = sortOrder;
	this.nameLocalization = nameLocalization;
	this.descLocalization = descLocalization;
};
sas.risk.slimtable.meta.ColumnMeta.prototype = {
	isColQueryable : function() {
		return this.queryable;
	},
	isColVisible : function() {
		return this.userVisible;
	},
	isColCustom : function() {
		return this.custom;
	},
	isColDefaultVisible:function(){
		return this.defaultVisible;
	},
	isColFilterable : function() {
		return this.filterable;
	},
	useAllFilter : function() {
		return this.useAllFilter;
	},
	isColSearchable : function() {
		return this.quickSearch;
	},
	isColFixed : function() {
		return this.fixed;
	},
	getColName : function() {
		return this.name;
	},
	getColRawName : function() {
		return this.rawName;
	},
	setColName : function(name) {
		this.name=name;
	},
	getColLabel : function() {
		return this.label;
	},
	getDisplayOrder : function() {
		return this.displayOrder;
	},
	isColSortable : function() {
		return this.sortable;
	},
	isColSorted : function() {
		return this.sortDirection!=="None";
	},
	getSortDirection : function() {
		return this.sortDirection;
	},
	setSortOrder : function(sortOrder) {
		this.sortOrder=sortOrder;
	},
	getSortOrder : function() {
		return this.sortOrder;
	},
	getColPreferredWidth : function() {
		return this.preferredWidth;
	},
	setColChoices : function(choices){
		this.choices=choices;
	},
	getColChoices : function() {
		return this.choices;
	},
	setVisible : function(visible) {
		this.userVisible = visible;
	},
	setSortDirection : function(val) {
		this.sortDirection = val;
	},
	getType : function() {
		return this.type;
	},
	setFormatter : function(formatter) {
		this.formatter=formatter;
	},
	getFormatter : function() {
		return this.formatter;
	},
	extractValue : function(rowData) {
		if (this.custom) {
			var customFields=rowData["customFields"];
			return customFields?customFields[this.name]:null;
		}
		else {
			return rowData[this.name];
		}
	},
	extractDisplayValue : function(rowData){
		var formatter=this.getFormatter();
		var displayVal=formatter.format(this,rowData);
		return displayVal;
	},
	getColAction : function(){
		return this.action;
	},
	setColAction : function(action){
		this.action=action;
	},
	isNameLocalization : function() {
		return this.nameLocalization;
	},	
	isDescLocalization : function() {
		return this.descLocalization;
	}	
};
// STATICS
sas.risk.slimtable.meta.ColumnMeta.createColumns = function(columnJson,tableMeta) {
	var columns = [];
	var i, c, sortDirection, sortOrder;
	for (i = 0; i < columnJson.length; i++) {
		c = columnJson[i];
		sortDirection = (c.orderBy === undefined) ? "None" : (c.orderBy ?"descending":"ascending");
		sortOrder = (c.orderBy === undefined) ? -1: 0;
		columns.push(new sas.risk.slimtable.meta.ColumnMeta(c.userDisplayOrder, c.type, c.label, c.name, c.rawName, null, false, c.visible, c.userVisible, c.quickSearch, 
																	 c.choices, c.custom, c.filterable, !!c.useAllFilter, c.sortable, sortDirection, c.queryable, c.linkField, sortOrder, c.nameLocalization, c.descLocalization));
	}
	return columns;
};
