jQuery.sap.declare("sas.risk.slimtable.meta.filter.StringFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.AFilter");

sas.risk.slimtable.meta.filter.StringFilter=function(name,operator,value,nameLabel,valueLabel){
	sas.risk.slimtable.meta.filter.AFilter.apply(this,arguments);
};
sas.risk.slimtable.meta.filter.StringFilter.prototype=Object.create(sas.risk.slimtable.meta.filter.AFilter.prototype);

sas.risk.slimtable.meta.filter.StringFilter.prototype.toString=function(){
   if(this.operator==="contains"){
   	return this.operator+"($primary,"+this.name+","+this.formatValue()+")";
   }else if(this.operator==="notContains"){
   	return  "or" + "(" + "not"+ "(" + "contains"+"($primary,"+this.name+","+this.formatValue()+ ")"+ ")" +","+"isNull"+"(" + this.name +")"+")";
   } else if (this.operator === "eq2") {
	   return "eq" + "(" + this.name + "," + this.formatValue() + ")";
   } else if (this.operator === "ne") {
	   return "or" + "(" + "ne" + "(" + this.name + "," + this.formatValue() + ")"+","+"isNull"+"(" + this.name +")"+")";  
   } else{
   	return sas.risk.slimtable.meta.filter.AFilter.prototype.toString.apply(this,arguments);
   }
};
sas.risk.slimtable.meta.filter.StringFilter.prototype.evaluate=function(rowData,tableMeta){
	if(this.operator==="contains"){
		var columnMeta=tableMeta.getColumnByName(this.name);
		var val=columnMeta.extractDisplayValue(rowData);
		if(val===undefined || val===null){return false;}//no value --> no match
		return val.toString().toUpperCase().trim().indexOf(this.value.toString().toUpperCase().trim())>-1;
	}else if(this.operator==="notContains"){
		var val=valuesCallbackFn(this.name);//this may need tweaking if there is a diff between display value and actual value
		if(val===undefined || val===null){return false;}//no value --> no match
		return val.toString().toUpperCase().trim().indexOf(this.value.toString().toUpperCase().trim())===-1;
	}else{
		return sas.risk.slimtable.meta.filter.AFilter.prototype.evaluate.apply(this,arguments);
	}
};
sas.risk.slimtable.meta.filter.StringFilter.prototype.getTypeName=function(){
	return "sas.risk.slimtable.meta.filter.StringFilter";
};
sas.risk.slimtable.meta.filter.StringFilter.prototype.getType=function(){
	return sas.risk.slimtable.meta.filter.StringFilter;
};
sas.risk.slimtable.meta.filter.StringFilter.prototype.formatValue=function(){
	var val=this.value.replace(/'/g,"''");
	return "'"+val+"'";
};
