jQuery.sap.declare("sas.risk.slimtable.meta.formatter.IconFormatter");
jQuery.sap.require("sas.risk.slimtable.meta.formatter.AFormatter");

sas.risk.slimtable.meta.formatter.IconFormatter=function(){
	sas.risk.slimtable.meta.formatter.AFormatter.apply(this,arguments);
};

sas.risk.slimtable.meta.formatter.IconFormatter.prototype=Object.create(sas.risk.slimtable.meta.formatter.AFormatter.prototype);

sas.risk.slimtable.meta.formatter.IconFormatter.prototype.format=function(columnMeta,rowData,parent,extra){
	sas.risk.slimtable.meta.formatter.AFormatter.prototype.format.apply(this,arguments);
	var input=columnMeta.extractValue(rowData);
	if(!parent){//return the text content for search
		var tempElem=document.createElement("SPAN");
		tempElem.innerHTML=input;
		return tempElem.textContent;
	}
	var slimTable=extra.source.getTable();
	var table=slimTable.getParent();
	var iconClass=this.resolveIconClass(table,input);
	if(parent.children.length){//clean up
		var content=$(parent).find(".riskIconFormatterCell")[0];
		parent.removeChild(content);
	}
	this.createIconSpan(parent,iconClass);
};
sas.risk.slimtable.meta.formatter.IconFormatter.prototype.resolveIconClass=function(table,input){
	return table.getFormattingKey().join("_")+" "+input;
};
sas.risk.slimtable.meta.formatter.IconFormatter.prototype.createIconSpan=function(parent,iconClass){
	var div=document.createElement("DIV");
	div.className="riskIconFormatterCell "+iconClass;
	parent.appendChild(div);
};

