jQuery.sap.declare("sas.risk.slimtable.util.RowActionUtil");
jQuery.sap.require("sas.risk.common.widgets.MenuItem");
jQuery.sap.require("sas.risk.slimtable.util.SlimTableUtil");
jQuery.sap.require("sas.risk.common.widgets.Menu");
jQuery.sap.require("sas.risk.slimtable.meta.ColumnMeta");

sas.risk.slimtable.util.RowActionUtil={
	createActionColumn:function(actionMenuItems,rTable){
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
	   var actionColumn=new sas.risk.slimtable.meta.ColumnMeta(-1,"ACTION",rb.getText("table.col.actions.txt"),"action","action","2%",true,true);
	   actionColumn.setSortDirection("None"); //so that it will not be considered for default sorted column
	   var that=this;
	   actionColumn.setColAction(function(columnMeta,rowData,target){
	   	var menu=that.createActionMenu(actionMenuItems,{columnMeta:columnMeta,rowData:rowData,riskTable:rTable});
	   	var eDock = sap.ui.core.Popup.Dock;
			menu.open(
					false /*First item already highlighted*/,
					target /*Dom reference which gets the focus back when the menu is closed*/,
					eDock.BeginTop, /*"Edge" of the menu (see sap.ui.core.Popup)*/
					eDock.BeginBottom, /*"Edge" of the related opener position (see sap.ui.core.Popup)*/
					target /*Related opener position (see sap.ui.core.Popup)*/
			);
		});
	   actionColumn.hasColActionItems=function(columnMeta,rowData,target){
	   	var payload={columnMeta:columnMeta,rowData:rowData,riskTable:rTable};
	   	var items=actionMenuItems;
	   	if(_.isFunction(items)){items=items(payload);}
	   	return !!items.length;
	   };
	   return actionColumn;
	},
	createActionMenu:function(items,payload){
		if(_.isFunction(items)){items=items(payload);}
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		var menu=new sas.risk.common.widgets.Menu({payload:payload});

		//loops through menu items and checks for submenus
		var i;
		for(i=0;i<items.length;i++){
			var parentTableEnabled=payload.riskTable.getEnabled();			
			//check for submenu
			if(items[i].length > 1) {
				var j;
				var subMenuItem = this.createActionMenuItem({
					"text": rb.getText("queryTable.action.quickLink.subMenu.txt")
				});
				var subMenu=new sas.risk.common.widgets.Menu({payload:payload});
				//loop through submenu agregation and appent to submenu
				for(j=0;j<items[i].length;j++){	
					if(!parentTableEnabled && items[i][j].getHideOnReadonly()) continue;
					subMenu.addItem(items[i][j]);
				}
				subMenuItem.setSubmenu(subMenu);//append submenu to menu item
				menu.addItem(subMenuItem);//add submenuitem to root menu

			//Check for case that submenu only has one item
			} else if(items[i].length === 1) { 
				if(!parentTableEnabled && items[i][0].getHideOnReadonly()) continue;
				menu.addItem(items[i][0]);
			//Normal menu items
			} else { 
				if(!parentTableEnabled && items[i].getHideOnReadonly()) continue;
				menu.addItem(items[i]);
			}
		}
		menu.attachItemSelect(function(e) {
			var item=e.getParameter("item");
			if(item.getCallback()) {
				item.getCallback().call(item,this.getPayload());
			}
		  });
		return menu;
	},
	createActionMenuItem:function(info){
		return new sas.risk.common.widgets.MenuItem({
			text:info.text,
			icon:info.icon,
			hideOnReadonly:info.hideOnReadonly,
			payload:info.payload,
			callback:info.callback
		});
	}
};
