jQuery.sap.declare("sas.risk.slimtable.util.TableUtil");
jQuery.sap.require("sas.risk.slimtable.meta.filter.StringFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.NumberFilter");

sas.risk.slimtable.util.TableUtil={
	createFilterForSelect : function(selectFilter){
		var selectedItem=selectFilter.getSelectedItem();
		var payload=sas.risk.slimtable.util.TableUtil.findCustomData(selectedItem,"payload");
		switch(payload.colMeta.getType()){
			case "java.lang.Boolean":
			case "java.lang.Integer":
			case "java.lang.Long":
			case "java.util.Date":
				return new sas.risk.slimtable.meta.filter.NumberFilter(selectFilter.getName(),"eq",payload.value,payload.colMeta.getColLabel(),selectedItem.getText());
			default:
				return new sas.risk.slimtable.meta.filter.StringFilter(selectFilter.getName(),"eq",payload.value,payload.colMeta.getColLabel(),selectedItem.getText());
		}
	   return filter;
	},
	findCustomData:function(obj,key){
		var customData=_.find(obj.getCustomData(),function(cd){return cd.getKey()===key;});
		return customData?customData.getValue():null;
	},
	timestampArray:function(array){
		if(!array || array.__TIMESTAMP__){return array;}
		array.__TIMESTAMP__=_.now();
		var funcNames=["push","pop","shift","unshift","reverse","sort","splice"];
		_.each(funcNames,function(funcName){
			array[funcName]=function(){
				Array.prototype[funcName].apply(this,arguments);
				this.__TIMESTAMP__=_.now();
			};
		});
		return array;
	}
};