jQuery.sap.declare("sas.risk.slimtable.util.search.ChoicesFilterHandler");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.risk.slimtable.widget.Item");
jQuery.sap.require("sas.risk.slimtable.meta.filter.StringFilter");
jQuery.sap.require("sas.risk.slimtable.meta.filter.NumberFilter");

sas.risk.slimtable.util.search.ChoicesFilterHandler=function(colMeta,mgr,quoteIt){
	this.colMeta=colMeta;
	this.mgr=mgr;
	this.quoteIt=quoteIt;
};
sas.risk.slimtable.util.search.ChoicesFilterHandler.prototype={
	setOperator:function(filter,operator){
		filter.setOperator(operator);
	},
	getOperators:function(){
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		if(this.quoteIt){
			filter.setType(sas.risk.slimtable.meta.filter.StringFilter);
		}else{
			filter.setType(sas.risk.slimtable.meta.filter.NumberFilter);			
		}
		var select=new sas.hc.m.Select({
			change:function(e){
				var item=e.getParameter("selectedItem");
				filter.setValue(item.getKey());
				filter.setValueLabel(item.getText());
			}
		});
		var choices=this.colMeta.getColChoices();
		var i,choice;
		for(i=0;i<choices.length;i++){
			choice=choices[i];
			select.addItem(new sas.risk.slimtable.widget.Item({
				key:choice.value,
				text:choice.label
			}));
		}
		if(filter.getValue()){
			select.setSelectedKey(filter.getValue());
		}else{
			var selectedItem=select.getItemAt(0);
			if(selectedItem !== null) {
				filter.setValue(selectedItem.getKey());
				filter.setValueLabel(selectedItem.getText());
			}
		}
		return select;
	},
	updateFilterValueLabel:function(filter){
		var def=$.Deferred().resolve();
		var value=filter.getValue();
		if(value){
			var choices=this.colMeta.getColChoices();
			var i,choice;
			for(i=0;i<choices.length;i++){
				choice=choices[i];
				if(choice.value===value){
					filter.setValueLabel(choice.label);
					break;
				}
			}			
		}
		return def;
	}
};