jQuery.sap.declare("sas.risk.slimtable.util.search.StringFilterHandler");
jQuery.sap.require("sas.risk.slimtable.meta.filter.StringFilter");

sas.risk.slimtable.util.search.StringFilterHandler=function(colMeta,mgr){
	this.colMeta=colMeta;
	this.mgr=mgr;
};
sas.risk.slimtable.util.search.StringFilterHandler.prototype={
	setOperator:function(filter,operator){
		filter.setOperator(operator);
	},
	getOperators:function(){
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		return [
			{label:rb.getText("table.dialog.advsearch.operator.contains.txt"),key:"contains"},
			{label:rb.getText("table.dialog.advsearch.operator.notContains.txt"),key:"notContains"},
			{label:rb.getText("table.dialog.advsearch.operator.eq.txt"),key:"eq"},
			{label:rb.getText("table.dialog.advsearch.operator.ne.txt"),key:"ne"}
		];
	},
	getInput:function(filter){
		filter.setType(sas.risk.slimtable.meta.filter.StringFilter);
		var rb = sas.risk.slimtable.util.SlimTableUtil.getBundle();
		var value=filter.getValue()!==null?filter.getValue():"";
		return new sas.hc.m.Input({
			placeholder:rb.getText("table.dialog.advsearch.value.placeholder.txt"),
			value:value,
			change:function(e){
				filter.setValue(e.getParameter("value"));
				filter.setValueLabel(e.getParameter("value"));
			}
		}).addStyleClass("riskTabAdvString");
	},
	updateFilterValueLabel:function(filter){
		filter.setValueLabel(filter.getValue());
		return $.Deferred().resolve();
	}
};