jQuery.sap.declare("sas.ui.cpb3.api.CpbQueryAPI");

sas.ui.cpb3.api.CpbQueryAPI=function(){};
sas.ui.cpb3.api.CpbQueryAPI.prototype={
	setCpbService:function(cpbService){
		this.cpbService=cpbService;
	},
	/***********************************************************
	 *            LOAD QUERY TABLE MODELS
	 ***********************************************************/
	loadQueryTableModels:function(screenId,/*optional*/initValues,screenDef,context){
		var def=$.Deferred();
		var appId=this.cpbService.getServiceId();
		var data=$.extend(initValues,{screenId:screenId});
		var values={data:data};
		if(screenDef){
			values.screenDef=screenDef;
		}
		$.ajax({
			type: "POST",
			url:"rest/cpb/"+appId+"/initialize/"+screenId,
			headers: {
            Accept: "application/json; charset=UTF-8",
            "Content-Type": "application/json; charset=UTF-8"
         },
			dataType:"json",
			data:JSON.stringify(values),
			success : $.proxy(this._loadQueryTableModelsSuccess,this,def,context),
			error : $.proxy(this._loadQueryTableModelsError,this,def,context)
		});
		return def;
	},
	_loadQueryTableModelsSuccess:function(def,context,response){
		var json={
			cpb_labels:response.labels,
			cpb_exps:response.expressions,
			cpb_structure:response.structure,
			cpb_observers:response.observers,
			cpb_choices:response.choices,
			cpb_messages:{},
			cpb_data:response.data
		};
		def.resolve(json);
	},
	_loadQueryTableModelsError:function(def,context,jqxhr,textStatus,error){
      def.reject();
	},
	/***********************************************************
	 *            DELETE QUERY TABLE ENTRY
	 ***********************************************************/
	deleteQueryTableEntry:function(URI,method){
		var that=this;
		var def=$.Deferred();
	   $.ajax({
	       type : method,
	       url : "rest"+URI,
	   }).done(function(data, textStatus, jqXHR) {
	       def.resolve(data);
	   }).fail(function(e,jqxhr){
	   	 var rb=that.cpbService.getBundle();
	       sas.ui.cpb3.CpbUtil.handleFail(e,jqxhr,rb);
	       def.reject();
	   });
	   return def;
	}	
};