jQuery.sap.declare("sas.ui.cpb3.bizcomp.ACPBBizComp");
jQuery.sap.require("sas.ui.mashup.biz.ABizComp");

sas.ui.mashup.biz.ABizComp.extend("sas.ui.cpb3.bizcomp.ACPBBizComp",{
	metadata:{
		properties:{
			serviceId:{type:"string"},
			screenId:{type:"string"}
		}
	}
});
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.init=function(template){
	this.eventQueue=[];
	this.stickyOn=true;
	sas.ui.cpb3.CpbUtil.attachStorageEvent('reload',$.proxy(this.onStorageEvent, this));
};
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.createBizCompView=function(template){
	this.cpbModelManager=sas.ui.cpb3.CPBService.getInstance(this.getServiceId()).createModelManagerObject(template);
	var layout = new sas.risk.common.layout.flexlayout.FlexLayout({
		width : "100%",
		flexDirection : sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:2
	})).addStyleClass("cpbContentArea");
	var that=this;
	this.cpbForm = new sas.ui.cpb3.CPBForm({
		serviceId:this.getServiceId(),
		screenId : this.getScreenId(),
		data : sas.ui.cpb3.model.CpbModelManager.bindData('/'),
		cpbModelManager : this.cpbModelManager,
		mashup:function(e){
			that.fireMashup(e.getParameters());
		}
	});
	this.messagesPanel=sas.ui.cpb3.CpbUtil.createMessagesPanel();
	layout.addItem(this.messagesPanel);
	layout.addItem(this.cpbForm);
	return layout;
};
//BEYOND MASHUP
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.getCpbForm=function(){
	return this.cpbForm;
};
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.onStorageEvent=function(event){
	var payload=event.getParameter("payload");
	this.eventQueue.push(payload);
	if(this.getParent()){//only process events if view is the active view
		this.processQueuedEvents();
	}
};
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.processQueuedEvents=function(){
	while(this.eventQueue.length){
		var payload=this.eventQueue.pop();
		this.cpbForm.fireEvent('reload',{
			type : payload.type,
			key : parseInt(payload.key)
		});			
	}
};
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.unloadBizCompModel=function(){
	sas.ui.cpb3.CpbUtil.detachStorageEvent('reload',$.proxy(this.onStorageEvent, this));
	if(this.cpbForm){
		var objectModel=this.cpbForm.getCpbModelManager();
		objectModel.clear();
		this.cpbForm.destroyItems();
		if(this.cpbForm.mEventRegistry.reload){
			this.cpbForm.mEventRegistry.reload.length=0;
		}
		this.cpbForm.built=false;
	}
	if(this.messagesPanel){
		this.messagesPanel.destroyItems();
	}
};
sas.ui.cpb3.bizcomp.ACPBBizComp.prototype.getViewType=function(e){
	return "ContentView";
};
