jQuery.sap.declare("sas.ui.cpb3.bizcomp.ObjectBizComp");
jQuery.sap.require("sas.ui.cpb3.bizcomp.ACPBBizComp");
jQuery.sap.require("sas.ui.cpb3.nav.ToolbarActionsObject");

sas.ui.cpb3.bizcomp.ACPBBizComp.extend("sas.ui.cpb3.bizcomp.ObjectBizComp",{
	metadata:{
		properties:{
			objectType:{type:"string"}
		}
	},
	constructor:function(sId,mSettings,oScope){//play nice so clone works
		if ( typeof sId !== 'string' && sId !== undefined ) {// shift arguments in case sId was missing, but mSettings was given
			oScope = mSettings,mSettings = sId,sId = mSettings && mSettings.id;
		}
		var that=this;
		$.extend(mSettings,{
			eventsPublished:[{name:"closeAppInfoEditor"}],
			contextInfo:[
				{id:"draft",params:[]},
				{id:"edit",params:[{name:"appInfoId"}]}
			]
		});
		sas.ui.cpb3.bizcomp.ACPBBizComp.call(this,sId,mSettings);
	}
});
sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.loadBizCompModel=function(e){
	var args=e.getParameters().arguments;
	this.isDraft=args.key==="drafts";
	this.isCreateLike=this.isDraft?((!!args.variance)&&(args.variance!=="lbo")):false;
	this.key=this.calculateKey(args);
	
	sas.ui.mashup.App.getInstance().setBusy(true);
	var cpbModelManager=this.getCpbForm().getCpbModelManager();
	hasher.changed.add(function onHashChange(newHash,oldHash){//clean up session for this object instance when we navigate elsewhere
		sas.ui.cpb3.CpbUtil.sessionClear(oldHash+"|");
		hasher.changed.remove(onHashChange);
	});
	if (!cpbModelManager.isInitialized(this.cpbForm)) {//first load only
		var screenId=this.getScreenId();
		var objectType=this.getObjectType();
		var overrides=this.createOverrides();
		var cpbAPI=this.getCpbForm().getCpbAPI();
		var apiFunc=this._getAPICall(cpbAPI);
		apiFunc(screenId, objectType, this.key, overrides).done(function(json,context){
			cpbModelManager.refresh(json,context);
			sas.ui.mashup.App.getInstance().setBusy(false);
		});
	}else{
		this.eventQueue.push({type:"*"});
		this.processQueuedEvents();
		sas.ui.mashup.App.getInstance().setBusy(false);
	}
};
sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.calculateKey=function(args){
	return this.isDraft?args.variance:args.key;
};
sas.ui.cpb3.bizcomp.ObjectBizComp.prototype._getAPICall=function(cpbAPI){
	if(this.isDraft){
		return $.proxy(cpbAPI.createObjectContext,cpbAPI);
	}
	return $.proxy(cpbAPI.loadObjectContext,cpbAPI);
};
sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.createOverrides=function(){
	return null;
};
sas.ui.cpb3.bizcomp.ObjectBizComp.prototype.getToolbar=function(template){
	return new sas.ui.cpb3.nav.ToolbarActionsObject({cpbForm:this.getCpbForm(),template:template,bizComp:this});
};