jQuery.sap.declare("sas.ui.cpb3.bizcomp.ScreenEditorBizComp");
jQuery.sap.require("sas.ui.cpb3.bizcomp.ACPBBizComp");
jQuery.sap.require("sas.ui.cpb3.nav.ScreenEditorToolbarActions");

sas.ui.cpb3.bizcomp.ACPBBizComp.extend("sas.ui.cpb3.bizcomp.ScreenEditorBizComp",{
	constructor:function(sId,mSettings,oScope){
		if ( typeof sId !== 'string' && sId !== undefined ) {// shift arguments in case sId was missing, but mSettings was given
			oScope = mSettings,mSettings = sId,sId = mSettings && mSettings.id;
		}
		var that=this;
		var control=new sap.ui.core.Control({
//			closeAppInfoEditor:function(e){
//				that.fireMashup(e);
//			}
		});
		$.extend(mSettings,{
			eventsPublished:[{name:"closeAppInfoEditor"}],
			contextInfo:[
				{id:"draft",params:[]},
				{id:"edit",params:[{name:"appInfoId"}]}
			],
			control:control
		});
		sas.ui.mashup.biz.ABizComp.call(this,sId,mSettings);
	}
});
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createBizCompView=function(template){
	this.template=template;
	this.cpbModelManager=sas.ui.cpb3.CPBService.getInstance(this.getServiceId()).createModelManagerObject(this);
	this.contentLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		items:[],
		width:"100%",
		alignContent:sas.risk.common.layout.flexlayout.FlexLayoutAlignContent.Stretch,
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Stretch
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({
		flexGrow:2
	}));
   return this.contentLayout;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.getToolbar=function(template){
	return new sas.ui.cpb3.nav.ScreenEditorToolbarActions({cpbForm:this.getCpbForm(),template:template,bizcomp:this});
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.loadBizCompModel=function(e){
	sas.ui.mashup.App.getInstance().setBusy(true);
	this.contentLayout.removeAllItems();
	this.contentLayout.addItem(this.createMainLayout());
	var args=e.getParameter("arguments");
	this.objectKey=args.key;
	this.objectVariance=args.variance;
	this.isObject=!!this.objectKey;
	this.type=args.type;
	this.screenId=sas.ui.cpb3.bizcomp.ScreenEditorBizComp.getUrl(this.type);
	var serviceId=this.getServiceId();
	var cpbService=sas.ui.cpb3.CPBService.getInstance(serviceId);
	var that=this;
	cpbService.getScreenEditorAPI().loadScreen(this.getScreenId()).done(function(screenData){
		var cpbScreenEditorModel=sas.ui.cpb3.model.CpbScreenEditorModel.getInstance();
		cpbScreenEditorModel.refreshSourceModel(screenData); //set the screenData in the MainShell context so that Toolbar title and Toolbar actions binding will work
		that.template.title.setText(cpbScreenEditorModel.getScreenData().FILENAME);
		that.refreshCode(); // necessary because we cannot bind the code editor directly to the data
	}).fail(function(e,jqxhr){
		var rb=cpbService.getBundle();
		sas.ui.cpb3.CpbUtil.handleFail(e,jqxhr,rb);
	}).always(function(){
		sas.ui.mashup.App.getInstance().setBusy(false);
	});
};
//HELPERS
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.getScreenId=function(){
	return this.screenId;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createMainLayout=function(){
	var mainLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%",
		items:[this.createErrorLayout(),this.createTabsLayout()],
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
	});
	return mainLayout;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createErrorLayout=function(){
	var rb = sas.risk.rgf.util.RGFUtil.getBundle();
	return sas.ui.cpb3.util.ScreenDefUtil.createErrorLayout(rb);
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createSourceLayout=function(){
	var that=this;
	this.codeEditorLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		items:[this.createCodeEditor("")]
	}).addStyleClass("screenDefCodeEditorLayout");
	var sourceLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		width:"100%",
		items:[this.createToolbar(),this.codeEditorLayout],
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
	}).addStyleClass("screenDefEditorSourceLayout");
	return sourceLayout;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createCodeEditor=function(editorContent){
	var that=this;
	//CODE EDITOR CONTROL
	jQuery.sap.require("sas.hc.ui.commons.codeEditor.Mode");//else it wont find LanguageMode.Xml below
	this.codeEditor=new sas.hc.ui.commons.codeEditor.CodeEditor("_"+window.performance.now()+"codeEditor",{
		content:editorContent,
		langMode: sas.hc.ui.commons.codeEditor.LanguageMode.Xml,
		lineHighlightingVisible: true,
		lineNumberVisible: true,
		syntaxHighlighting: true,
		autoCompleteEnabled: true,
		hintEnabled: true
	}).addStyleClass("CpbCodeEditor");
	this.codeEditor.attachReady(function(evt){
		evt.getSource().resize("100%","100%");
	});
	this.codeEditor.attachTextChanged(function(evt){
		var newContent=that.codeEditor.getText();
		if(!!that.getEditorTxt() && that.getEditorTxt()!==newContent){ //checking getEditorTxt() exists ignores the textChange event fired during initial loading
			sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().applyScreenUpdate("isDirty",true);
			sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().applyScreenUpdate("XML",newContent);
		}
		that.setEditorTxt(newContent);
	});		
	this.codeEditor.activate();
	return this.codeEditor;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createToolbar=function(){
	//CODE EDITOR TOOLBAR
	var that = this;
	var toolbar=new sas.hc.m.Toolbar({
      content: [
          new sas.hc.m.Button({
              icon: sas.icons.HC.UNDO,
              press: function() {
                  that.codeEditor.undo();
              }
          }),
          new sas.hc.m.Button({
              icon: sas.icons.HC.REDO,
              press: function() {
                  that.codeEditor.redo();
              }
          }),
          new sas.hc.m.Button({
              icon: sas.icons.HC.CUT,
              press: function() {
                  that.codeEditor.cut();
              }
          }),
          new sas.hc.m.Button({
              icon: sas.icons.HC.COPY,
              press: function() {
                  that.codeEditor.copy();
              }
          }),
          new sas.hc.m.Button({
              icon: sas.icons.HC.PASTE,
              press: function() {
                  that.codeEditor.paste();
              }
          }),
          new sas.hc.m.Button({
              icon: sas.icons.HC.FIND,
              press: function() {
                  that.codeEditor.showFindReplaceDialog();
              }
          })
      ]
	}).addStyleClass('cpbScreenEditorToolbar');
	return toolbar;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createTabsLayout=function(){
	var that=this;
	var cpbService=sas.ui.cpb3.CPBService.getInstance(this.getServiceId());
	var rb = cpbService.getBundle();
	this.sourceTab=new sas.hc.m.IconTabFilter({
		key:"source",
      text: rb.getText("screen.editor.source.title.txt")
	});
	this.previewTab=new sas.hc.m.IconTabFilter({
		key:"preview",
      text: rb.getText("screen.editor.preview.title.txt")
	});
	this.sourceTab.addContent(this.createSourceLayout());
	this.previewTab.addContent(this.createPreviewLayout());
	this.tabs=new sas.hc.m.IconTabBar({
		items:[this.sourceTab, this.previewTab],
		select:function(evt){
			that.handleTabSelect(evt);
		}
	}).addStyleClass("cpbScreenEditorContent cpbMenuBar");
	return this.tabs;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createPreviewLayout=function(){
	var layout = new sas.risk.common.layout.flexlayout.FlexLayout({
		width : "100%",
		flexDirection : sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column
	}).addStyleClass("cpbScreenEditorPreviewTabContent");
	this.cpbForm = new sas.ui.cpb3.CPBForm({
		serviceId : this.getServiceId(),
		screenId : this.getScreenId(),
		data : sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().bindData('/'),
		cpbModelManager:this.cpbModelManager
	});
	layout.addItem(this.cpbForm);
	return layout;
};
/**
 * This is needed because you cannot bind to the code editor directly.
 */
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.refreshCode=function(){
	var editorContent=sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().getScreenXML();
	sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().refreshErrorModel({});
	this.codeEditor.setText(editorContent);
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.selectSourceTab=function(){
	this.tabs.setSelectedKey("source");
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.selectPreviewTab=function() {
	this.codeEditor.hideFindReplaceDialog(); // In case it's still hanging around from the source tab, we need to hide it
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.zapOnLeave=function(){
	this.codeEditor.hideFindReplaceDialog();
	this.selectSourceTab();
	sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().clear(this);
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.getEditorTxt=function(){
	return this.editorTxt;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.setEditorTxt=function(txt){
	this.editorTxt=txt;
};

sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.handleTabSelect=function(evt){
	var tabKey=evt.getParameters().selectedItem.getKey();
	tabKey==="source" ? this.handleSource() : tabKey==="preview" ? this.handlePreview() : null;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.createScreenConfig=function(){
	
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.handleSource=function(){
	this.refreshCode(); // necessary because we cannot bind the code editor directly to the data
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.handlePreview=function(){
	sas.ui.mashup.App.getInstance().setBusy(true);
	this.selectPreviewTab();
	this.previewTab.getContent()[0].setVisible(false);
	var screenXML=this.codeEditor.getText();
	var screenId=this.getScreenId();
	var that=this;
	var serviceId=this.getServiceId();
	sas.ui.cpb3.CPBService.getInstance(serviceId).getScreenEditorAPI().saveScreen(screenId,screenXML,false).done(function(results){
		that.loadPreview(results.TEMP_ID);
	}).fail(function(json){
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().refreshErrorModel(json);
		that.selectSourceTab();
	}).always(function(){
		sas.ui.mashup.App.getInstance().setBusy(false);
	});
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.loadPreview=function(screenId){
	var that=this;
	this.callLoadPreviewAPI(screenId).done(function(json){
		//make the screen read-only for preview screen, and let consumers know that this is for preview screen
		json.cpb_data.SCREEN_READ_ONLY=true;
		json.cpb_data.IS_SCREEN_PREVIEW=true;
		json.cpb_misc=json.cpb_misc||{};
		json.cpb_misc.rebuild=true;//force a page rebuild to catch new changes
		var screenEditorModel=sas.ui.cpb3.model.CpbScreenEditorModel.getInstance();
		screenEditorModel.refreshPreviewModel(json,that.cpbForm);
		that.previewTab.getContent()[0].setVisible(true);
	}).fail(function(e,jqxhr){
		var serviceId=that.getServiceId();
		var rb=sas.ui.cpb3.CPBService.getInstance(serviceId).getBundle();
      sas.ui.cpb3.CpbUtil.handleFail(e,jqxhr,rb);
   }).always(function(){
   	sas.ui.mashup.App.getInstance().setBusy(false);
   });
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.callLoadPreviewAPIQuery=function(screenId){
	var serviceId=this.getServiceId();
	return sas.ui.cpb3.CPBService.getInstance(serviceId).getQueryAPI().loadQueryTableModels(screenId);
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.callLoadPreviewAPIObject=function(screenId){
	var isDraft=this.objectKey==="drafts";
	var objectId=isDraft?this.objectVariance||"drafts":this.objectKey;
	var libName=this.getLibName();
	var bizComp=sas.ui.mashup.LibRegistry.getBizComp(libName,"O_"+this.getScreenId());
	var cpbAPI=this.getCpbForm().getCpbAPI();
	var apiCall=bizComp._getAPICall(cpbAPI);
	return apiCall(screenId, this.type, objectId, bizComp.createOverrides());
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.prototype.callLoadPreviewAPI=function(screenId){
	if(this.isObject){
		return this.callLoadPreviewAPIObject(screenId);
	}else{
		return this.callLoadPreviewAPIQuery(screenId);
	}
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp._urls={};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.registerUrl=function(key,url){
	sas.ui.cpb3.bizcomp.ScreenEditorBizComp._urls[key]=url;
};
sas.ui.cpb3.bizcomp.ScreenEditorBizComp.getUrl=function(key){
	return sas.ui.cpb3.bizcomp.ScreenEditorBizComp._urls[key]||key;
};