jQuery.sap.declare("sas.ui.cpb3.components.QueryBuilderComponent");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.risk.common.widgets.querybldr.QueryBuilder");

sas.risk.common.layout.flexlayout.FlexLayout.extend("sas.ui.cpb3.components.QueryBuilderComponent", sas.ui.cpb3.components.AComponentMixin.mixinMeta({
	metadata : {
		properties : {
			meta:{type:"any"}
		}
	},
	constructor : function(settings) {
		this.supportsLayout=true;
		this.supportsLabel=true;
		var that=this;
		this.queryBldr=new sas.risk.common.widgets.querybldr.QueryBuilder();
		sas.risk.common.utils.CompositeUtil.addComposite(this, "cpbValue", this.queryBldr, "value");
		sas.risk.common.utils.CompositeUtil.addComposite(this, "meta", this.queryBldr);
		sas.risk.common.layout.flexlayout.FlexLayout.apply(this,arguments);
		this.addStyleClass("cpbSuperWide");
	},
	renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.ui.cpb3.components.QueryBuilderComponent);
sas.ui.cpb3.components.QueryBuilderComponent.prototype.setCPBValue = function(value) {
	this.setCpbValue(value);
};
sas.ui.cpb3.components.QueryBuilderComponent.prototype._createComponent = function() {
	this.addStyleClass("cpbQueryBuilderComponent");
	this.addItem(this.queryBldr);
	return this.queryBldr;
};
//STATICS
sas.ui.cpb3.components.QueryBuilderComponent.create=function(fieldJson, modelId, cpbForm) {
	var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
	settings.meta=sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId, fieldJson.metaField);
	return new sas.ui.cpb3.components.QueryBuilderComponent($.extend(
		settings,
		{
			cpbValue:sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId,fieldJson.cpbName)
		}
	));
};