jQuery.sap.declare("sas.ui.cpb3.dialog.ACPBDialogController");
jQuery.sap.require("sas.ui.cpb3.model.CpbModelManagerObject");

sas.ui.cpb3.dialog.ACPBDialogController=function(){};
sas.ui.cpb3.dialog.ACPBDialogController.prototype={
	onInit:function(){
		return this._onInit();
	},
	_onInit:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		var cpbModelManager=view.cpbForm.getCpbModelManager();
		if(viewData.create){
	      	view.cpbForm.getCpbAPI().createObjectContext(viewData.screenId,viewData.objectType,viewData.objectId,viewData.overrides).done(function(json){
	      		cpbModelManager.refresh(json,view);
	      	});
		}else if(viewData.load){
	      	view.cpbForm.getCpbAPI().loadObjectContext(viewData.screenId,viewData.objectType,viewData.objectId,viewData.overrides).done(function(json){
	      		cpbModelManager.refresh(json,view);
	      	});
		}else{
			view.cpbForm.getQueryAPI().loadQueryTableModels(viewData.screenId,viewData.overrides).done(function(json){
				cpbModelManager.refresh(json,view);
			});
		}
	},
	actionClose:function(){
		return this._actionClose();
	},
	_actionClose:function(){
		var view=this.getView();
		view.getDialog().close();
	},
	actionOk:function(){
		return this._actionOk();
	},
	_actionOk:function(){
	   	var view = this.getView();
	   	var cpbForm=view.cpbForm;
	   	var cpbModelManager=cpbForm.getCpbModelManager();
	   	var uiContext=cpbModelManager.getUIContext(view);
    	cpbForm.updateUIContextWithRequiredFields(view); //Update the UIContext with required fields information needed during validation
	   	var viewData = view.getViewData();
	   	view.getDialog().setBusyIndicatorDelay(0);
	   	view.getDialog().setBusy(true);
      	cpbForm.getCpbAPI().saveObjectContext(viewData.objectType,viewData.create.objectId,uiContext).done(function(json){
    		if(!json.hasErrors){
          		cpbModelManager.refresh(json,view);
        		view.fireClosing({cpbForm:this.cpbForm});
        		view.getDialog().close();
    		}else{
    			cpbModelManager.applyErrors(json,view);
    		}
    	   	view.getDialog().setBusy(false);
      	}).fail(function(e){view.getDialog().setBusy(false);});
	}
};