jQuery.sap.declare("sas.ui.cpb3.dialog.ACPBDialogView");
jQuery.sap.require("sas.risk.common.widgets.Button");
jQuery.sap.require("sas.ui.cpb3.CPBService");

sas.ui.cpb3.dialog.ACPBDialogView=function(controllerName){
	this.controllerName=controllerName||"sas.ui.cpb3.dialog.CPBDialog";
};
sas.ui.cpb3.dialog.ACPBDialogView.prototype={
	getControllerName : function() {
		return this.controllerName;
	},
	createContent : function(controller) {
		var that=this;
		var viewData=this.getViewData();
		$.extend(controller,viewData.actions||{});
		this.layout=new sas.risk.common.layout.flexlayout.FlexLayout({
			flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
			items:[]
		});
		this.cpbForm=new sas.ui.cpb3.CPBForm({
			serviceId : viewData.serviceId,
			screenId: viewData.screenId,
			data: sas.ui.cpb3.model.CpbModelManager.bindData('/'),
			cpbModelManager:sas.ui.cpb3.CPBService.getInstance(viewData.serviceId).createModelManagerObject()
		});
		this.createButtons(controller);
		this.layout.addItem(this.createMessagesPanel());
		this.layout.addItem(this.cpbForm);
		return this.layout;
	},
	createMessagesPanel:function(){
		return sas.ui.cpb3.CpbUtil.createMessagesPanel();
	},
	createButtons : function(controller) {
		var rb = this.cpbForm.getCpbService().getBundle();
		this.okButton = new sas.risk.common.widgets.Button({
			text : rb.getText("ok.button.txt"),
			press : $.proxy(controller.actionOk,controller),
		}).addStyleClass("sasPrimaryButton");
		this.closeButton = new sas.risk.common.widgets.Button({
			text : rb.getText("close.button.txt"),
			press : $.proxy(controller.actionClose,controller),
		});
	},
	getDialogSettings : function() {
		var viewData=this.getViewData();
		var settings=null;
		if(viewData.create||viewData.load){
			settings={beginButton:this.okButton,endButton : this.closeButton};
		}else if(viewData.queryload){
			var rb = this.cpbForm.getCpbService().getBundle();
			this.closeButton.setText(rb.getText("cancel.button.txt"));
			settings={beginButton:this.okButton,endButton : this.closeButton};
		}else{
			settings={beginButton: this.closeButton};
		}
		$.extend(settings,viewData.dialogSettings||{});
		return settings;
	}		
};