jQuery.sap.declare("sas.ui.cpb3.field.StringField");
jQuery.sap.require("sas.ui.cpb3.field.AFieldMixin");
jQuery.sap.require("sas.ui.cpb3.widget.InputField");
jQuery.sap.require("sap.ui.layout.VerticalLayout");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");

sap.ui.layout.VerticalLayout.extend("sas.ui.cpb3.field.StringField",sas.ui.cpb3.field.AFieldMixin.mixinMeta({
	metadata:{
		properties:{
			cpbLength:{type:"int"},
			cpbMaxLength:{type:"int"},
		}
	},
	constructor:function(){
	   this.field = new sas.ui.cpb3.widget.InputField({
	      type: sap.m.InputType.Text
	   });
	   sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbLength",this.field,"size");
	   sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbMaxLength",this.field,"maxLength");
	   sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbValue",this.field,"value");
	   sap.ui.layout.VerticalLayout.apply(this,arguments);
	}
}));
sas.ui.cpb3.field.AFieldMixin.mixin(sas.ui.cpb3.field.StringField);

sas.ui.cpb3.field.StringField.prototype._createField = function() {
    return this.field;
};
sas.ui.cpb3.field.StringField.prototype.setCpbEnabled = function(val) {
	this.setProperty("cpbEnabled",val);
	if(!val && this.field instanceof sas.ui.cpb3.widget.InputField){
		var index=this._layout.indexOfItem(this.field);
		this._layout.removeItem(this.field);
		this.addStyleClass("cpbReadonlyContainer");
		var bindingInfo = this.field.getBindingInfo("value");
		this.field = new sap.ui.commons.TextView().addStyleClass("cpbReadonlyField");
	   sas.risk.common.utils.CompositeUtil.delComposite(this,"cpbValue");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbValue",this.field,"text");
		if(bindingInfo){this.field.bindProperty("text",bindingInfo);}
		this._layout.insertItem(this.field,index);
	}
};
sas.ui.cpb3.field.StringField.prototype.setCPBValue = function(value) {//OVERRIDEN
	this.setCpbValue(value);
};
//STATICS
sas.ui.cpb3.field.StringField.create=function(fieldJson,modelId,cpbForm){
	jQuery.sap.require("sas.ui.cpb3.model.type.CpbString");
	var settings=sas.ui.cpb3.WidgetBindingUtil.getFieldBasicSettings(fieldJson,modelId,cpbForm);
	var lengthSettings=sas.ui.cpb3.WidgetBindingUtil.getLengthSettings(fieldJson,modelId,cpbForm);
	var field=new sas.ui.cpb3.field.StringField($.extend(settings,lengthSettings));
	field.bindProperty("cpbValue",{
		path: sas.ui.cpb3.WidgetBindingUtil.getDataPath(modelId,fieldJson.cpbName),
		type: 'sas.ui.cpb3.model.type.CpbString',
		formatOptions: {field:field}
	});
	return field;
};