jQuery.sap.declare("sas.ui.cpb3.field.TextField");
jQuery.sap.require("sas.ui.cpb3.field.AFieldMixin");
jQuery.sap.require("sas.ui.cpb3.widget.InputField");
jQuery.sap.require("sap.ui.layout.VerticalLayout");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");

sas.hc.m.Text.extend("sas.ui.cpb3.field.TextField",sas.ui.cpb3.field.AFieldMixin.mixinMeta({
	renderer:"sas.hc.m.TextRenderer"
}));
sas.ui.cpb3.field.AFieldMixin.mixin(sas.ui.cpb3.field.TextField);

sas.ui.cpb3.field.TextField.prototype._createField = function() {
    return this;
};
sas.ui.cpb3.field.TextField.prototype.addContent = function(value) {//OVERRIDEN
	//throw away content built by field mixin
};
sas.ui.cpb3.field.TextField.prototype.setCPBValue = function(value) {//OVERRIDEN
	this.setCpbValue(value);
};
sas.ui.cpb3.field.TextField.prototype.setCPBValues = function(values) {//OVERRIDEN
	this.setCpbValues(values);
};
sas.ui.cpb3.field.TextField.prototype.attachChange = function(onChangeFn) {
	this.attachBrowserEvent("click",onChangeFn);
};
sas.ui.cpb3.field.TextField.prototype.onBeforeRendering = function(value) {
	var that=this;
	var label=this.getLabel();
	var styles=this.getCpbValues();
	//clean custom styles
	_.each(this.aCustomStyleClasses,function(style){
		if(style&&!style.toLowerCase().startsWith("cpb")){
			that.removeStyleClass(style);
		}
	});
	if(styles){
		styles=$.isArray(styles)?styles:[styles];
		_.each(styles,function(style){
			that.addStyleClass(style);
		});
	}
	this.setText(this.getCpbValue()||label.getText());
};
//STATICS
sas.ui.cpb3.field.TextField.create=function(fieldJson,modelId,cpbForm){
	var settings=sas.ui.cpb3.WidgetBindingUtil.getFieldBasicSettings(fieldJson,modelId,cpbForm);
	settings.cpbValue=sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId,fieldJson.cpbName);
	settings.cpbValues=sas.ui.cpb3.WidgetBindingUtil.getExpBindingPath(fieldJson.cpbValues);
	settings.cpbAlign="none";
	return new sas.ui.cpb3.field.TextField(settings);
};