jQuery.sap.declare("sas.ui.cpb3.layout.ALayoutMixin");
jQuery.sap.require("sas.ui.cpb3.ABaseControlMixin");
jQuery.sap.require("sap.ui.layout.VerticalLayout");
jQuery.sap.require("sap.ui.layout.VerticalLayoutRenderer");
jQuery.sap.require("sap.ui.commons.TextView");

sas.ui.cpb3.layout.ALayoutMixin={
	meta:{
		constructor:function(){
	   	this.children=[];
	   	this.__META_PARENT_BARRIER__.getClass().apply(this, arguments);
	   },
		renderer:"sap.ui.layout.VerticalLayoutRenderer"
	},
	proto:{
		mixinType:"Layout",
		onBeforeRendering:function(){
			var lastChildIdx=this.children.length-1;
			_.each(this.children,function(c,i){
				if(c.removeStyleClass){
					c.removeStyleClass("cpbLayoutFirst");
					c.removeStyleClass("cpbLayoutLast");
					if(i===0){
						c.addStyleClass("cpbLayoutFirst");
					}
					if(i===lastChildIdx){
						c.addStyleClass("cpbLayoutLast");
					}
				}
			});
			if(!this.getCpbParent()){//recalculate required inheritance only once for each tree
				this.fullRecalcRequired();
			}
		},
		fullRecalcRequired:function(){//calculate leafs and move up from there
			var childIndex,child;
			for(childIndex in this.children){
				child=this.children[childIndex];
				if(child.getType()==="Layout"){
					child.fullRecalcRequired();
				}
			}
			this.calcCpbRequired();
		},
		applySettings:function(){
			var origApplySettings=this.getMetadata().getClass().prototype.applySettings;
			if(sas.ui.cpb3.layout.ALayoutMixin.proto.applySettings!==origApplySettings){
				origApplySettings.apply(this,arguments);
			}else{
				this.getMetadata().getParent().getClass().prototype.applySettings.apply(this, arguments);
			}
			this._layout=this._createLayout();
			this.addStyleClass("cpbLayout");
		},
		getLayout:function(){
			return this._layout;
		},
		setCpbRequired:function(value,inherited){
			if(inherited && this.originalRequired===undefined){
				this.originalRequired=this.getCpbRequired();
			}
			if(!inherited){
				this.originalRequired=value;
			}
			if(value){
				this.setProperty("cpbRequired",true);				
			}else{
				this.setProperty("cpbRequired",this.originalRequired);
			}
			var parent=this.getCpbParent();
			if(parent){
				if(!value){
					parent.calcCpbRequired();
				}else{
					parent.setCpbRequired(true,true);
				}
			}
		},
		calcCpbRequired:function(){
			var origReq=this.originalRequired||false;
			var children=this.children;
			var childIndex;
			var child;
			for(childIndex in children){
				child=children[childIndex];
				if(children[childIndex].getCpbRequired()){
					origReq=true;
					break;
				}
			}
			this.setCpbRequired(origReq,true);
		}
	}
};
sas.ui.cpb3.layout.ALayoutMixin.mixinMeta=function(meta){
	var halfMixedMeta=$.extend(true,{},sas.ui.cpb3.layout.ALayoutMixin.meta,meta);
	return sas.ui.cpb3.ABaseControlMixin.mixinMeta(halfMixedMeta);
};
sas.ui.cpb3.layout.ALayoutMixin.mixin=function(klass){
	var halfMixedKlass=sas.ui.cpb3.ABaseControlMixin.mixin(klass);
	klass.prototype.__META_PARENT_BARRIER__=klass.getMetadata().getParent();
	$.extend(klass.prototype,sas.ui.cpb3.layout.ALayoutMixin.proto);
};
