jQuery.sap.declare("sas.ui.cpb3.layout.TabLayout");
jQuery.sap.require("sas.ui.cpb3.layout.ALayoutMixin");
jQuery.sap.require("sas.ui.cpb3.widget.IconTabFilter");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.risk.common.widgets.LabelPlus");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");

sas.ui.cpb3.widget.IconTabFilter.extend("sas.ui.cpb3.layout.TabLayout", sas.ui.cpb3.layout.ALayoutMixin.mixinMeta({
	metadata:{
		properties:{
			active:{type:"boolean",defaultValue:false},
			required:{type:"boolean",defaultValue:false},
			errored:{type:"boolean",defaultValue:false},
			cpbKey:{type:"string"},
			cpbActive:{type:"boolean"}
		}
	},
	constructor:function(){
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbKey",this,"key");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbActive",this,"active");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbLabel",this,"text");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbRequired",this,"required");
		sas.risk.common.utils.CompositeUtil.addComposite(this, "cpbVisible", this, "visible");
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbErrored",this,"errored");
		sas.ui.cpb3.layout.ALayoutMixin.meta.constructor.apply(this,arguments);
	},
	renderer:null
}));
sas.ui.cpb3.layout.ALayoutMixin.mixin(sas.ui.cpb3.layout.TabLayout);

sas.ui.cpb3.layout.TabLayout.prototype.init=function(){
	var payload=new sas.risk.common.layout.flexlayout.FlexLayout({
		flexDirection:sas.risk.common.layout.flexlayout.FlexLayoutDirection.Column,
		width:"100%"
	}).setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexGrow:2}));
	this.setPayload(payload);
	sas.ui.cpb3.widget.IconTabFilter.prototype.init.apply(this, arguments);
};
sas.ui.cpb3.layout.TabLayout.prototype.applySettings=function(){
	sas.ui.cpb3.widget.IconTabFilter.prototype.applySettings.apply(this,arguments);
	this._layout=this;
};
sas.ui.cpb3.layout.TabLayout.prototype.addItem = function(item) {
	this.children.push(item);
	this.getPayload().addItem(item);
	item.setCpbParent(this);
};
sas.ui.cpb3.layout.TabLayout.prototype.getItems = function(){
	return this.getPayload().getItems();
};
sas.ui.cpb3.layout.TabLayout.prototype.setCPBVisible = function(val) {
	var that = this;
	
	var idx = 0;
	var currentTabSelection = _.find(this.getCpbParent().children, function(child, index) {
		idx=index;return child.getCpbKey() === that.getCpbKey();
	});
	//If the currentTabSelection is the last item in the list,set the nextTabSelection to be the first item in the list
	if (idx === this.getCpbParent().children.length-1) { idx = -1;}

	var nextTabSelection = this.getCpbParent().children[idx+1];
	this.setVisible(val);
	var parent = this.getParent().getParent();
	if (val) {
		parent.setSelectedKey(currentTabSelection.getKey());
		parent.fireSelect({item:currentTabSelection});	
	} 	
};
		 
//STATICS
sas.ui.cpb3.layout.TabLayout.create=function(fieldJson,modelId,cpbForm){
	return new sas.ui.cpb3.layout.TabLayout({
		cpbForm:cpbForm,
		cpbId:fieldJson.widgetId,
		cpbKey:fieldJson.id,
		cpbLabel:{
			path:"cpb_labels>/label"+fieldJson.cpbLabel,
			formatter:sas.ui.cpb3.WidgetBindingUtil.formatterLabelNoSeparator
		},
      cpbRequired:sas.ui.cpb3.WidgetBindingUtil.getExpBindingPath(fieldJson.cpbRequired),
      cpbVisible:sas.ui.cpb3.WidgetBindingUtil.getExpBindingPath(fieldJson.cpbVisible),
      cpbActive:sas.ui.cpb3.WidgetBindingUtil.getExpBindingPath(fieldJson.cpbActive),
      cpbErrored:{
      	path:sas.ui.cpb3.model.CpbModelManagerObject.bindMessagePath("/errored"),
      	formatter:sas.ui.cpb3.WidgetBindingUtil.formatterError
      }
	});
};