jQuery.sap.declare("sas.ui.cpb3.model.CpbModelManagerObject");
jQuery.sap.require("sas.ui.cpb3.model.CpbModelManager");
jQuery.sap.require("sas.ui.cpb3.model.CpbJSONModel");
jQuery.sap.require("sas.ui.cpb3.CPBForm");

sas.ui.cpb3.model.CpbModelManagerObject=function(){
	sas.ui.cpb3.model.CpbModelManager.apply(this,arguments);
};
sas.ui.cpb3.model.CpbModelManagerObject._nameChoices = "cpb_choices";
sas.ui.cpb3.model.CpbModelManagerObject._nameMessages = "cpb_messages";
sas.ui.cpb3.model.CpbModelManagerObject._nameNestedSaves = "cpb_nsaves";
sas.ui.cpb3.model.CpbModelManagerObject._nameNestedDeletes = "cpb_ndeletes";
sas.ui.cpb3.model.CpbModelManagerObject._nameClone = "cpb_clone";
sas.ui.cpb3.model.CpbModelManagerObject._nameMisc = "cpb_misc";

sas.ui.cpb3.model.CpbModelManagerObject.prototype=$.extend({},Object.create(sas.ui.cpb3.model.CpbModelManager.prototype),{
	_nameChoices : sas.ui.cpb3.model.CpbModelManagerObject._nameChoices,
	_nameMessages : sas.ui.cpb3.model.CpbModelManagerObject._nameMessages,
	_nameNestedSaves : sas.ui.cpb3.model.CpbModelManagerObject._nameNestedSaves,
	_nameNestedDeletes : sas.ui.cpb3.model.CpbModelManagerObject._nameNestedDeletes,
	_nameClone : sas.ui.cpb3.model.CpbModelManagerObject._nameClone,
	_nameMisc : sas.ui.cpb3.model.CpbModelManagerObject._nameMisc,
	_json : null,
	_context : null,
	reinstate : function() {
		this.refresh(this._json,this._context);
	},
	refresh : function(json,context) {
		this._json=json;
		this._context=this._resolveContext(context);
		this._setModel(json.cpb_labels,this._nameLabels,this._context);
		this._setModel(json.cpb_exps,this._nameExps,this._context);
		this._setModel(json.cpb_structure,this._nameStructure,this._context);
		this._setModel(json.cpb_observers,this._nameObservers,this._context);
		this._setModel(json.cpb_choices,this._nameChoices,this._context);
		this._setModel(json.cpb_nestedSaves,this._nameNestedSaves,this._context);
		this._setModel(json.cpb_nestedDeletes,this._nameNestedDeletes,this._context);
		this._setModel(json.cpb_messages,this._nameMessages,this._context);
		this._setModel(json.cpb_misc,this._nameMisc,this._context);
		this._setModel(json.cpb_data,this._nameData,this._context);
		this._setModel($.extend(true,{},json.cpb_data),this._nameClone,this._context);
		//PAGE DIRTY CHECK
		var dataModel=this._getModel(this._nameData,this._context);
		if(dataModel){
			var rootModel=null;
			if(this.defaultContext && this.defaultContext.getRootCPBForm){
				var rootCpbForm=this.defaultContext.getRootCPBForm();
				if(rootCpbForm){
					rootModel=rootCpbForm.getCpbModelManager()._getModel(this._nameData,rootCpbForm);
				}
			}
			var cloneModel=this._getModel(this._nameClone,this._context);
			var miscModel=this._getModel(this._nameMisc,this._context);
			dataModel&&dataModel.attachChange(function(){
            var dataModelData=dataModel.getData();
				var onlyDefined=_.omit(dataModelData, _.filter(_.keys(dataModelData), function(key) { return _.isUndefined(dataModelData[key]) }))
				var isDirty=!(_.isEqual(onlyDefined,cloneModel.getData()));
				if (miscModel != undefined) {
	                miscModel.setProperty("/isDirty",isDirty);
				}
				if(isDirty&&rootModel && this!==rootModel){
					rootModel.fireChange();
				}
			});
			dataModel.fireChange();//initial setting
		}
	},
	updateData : function(newData,context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameData);
		model.setData(newData);
	},
	updateMessages : function(newMessages,context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameMessages);
		model.setData(newMessages);
	},
	getPageContext : function(context) {
		context=this._resolveContext(context);
		return {
			cpb_labels:this._getModel(this._nameLabels,context).getData(),
			cpb_exps:this._getModel(this._nameExps,context).getData(),
			cpb_structure:this._getModel(this._nameStructure,context).getData(),
			cpb_observers:this._getModel(this._nameObservers,context).getData(),
			cpb_choices:this._getModel(this._nameChoices,context).getData(),
			cpb_messages:this._getModel(this._nameMessages,context).getData(),
			cpb_data:this._getModel(this._nameData,context).getData(),
			cpb_misc:this._getModel(this._nameMisc,context).getData(),
		};
	},
	setMessageModel:function(json,context){
		context=this._resolveContext(context);
		if(!json){
			context.setModel(new sas.ui.cpb3.model.CpbJSONModel({}),this._nameMessages);
		}else{
			context.setModel(new sas.ui.cpb3.model.CpbJSONModel(json),this._nameMessages);
		}
	},
	applyErrors:function(json,context){
		context=this._resolveContext(context);
		context.getModel(this._nameNestedSaves).setData(json.cpb_nestedSaves);
		context.getModel(this._nameNestedDeletes).setData(json.cpb_nestedDeletes);
		context.getModel(this._nameMessages).setData(json.cpb_messages);
		context.getModel(this._nameData).setData(json.cpb_data);	
		context.getModel(this._nameData).checkUpdate(true);
	},
	getErrored:function(screenId,context){
		context=this._resolveContext(context);
		var messagesModel=context.getModel(this._nameMessages);
		if(messagesModel){
			var errored=messagesModel.getProperty("/errored");
			return _.filter(errored||[],function(err){
				if(screenId){
					return err.toString().indexOf(screenId+".")===0;
				}else{
					return _.isNumber(err);
				}
			});
		}
		return [];
	},
	hasErrors:function(context){
		context=this._resolveContext(context);
		var messagesModel=context.getModel(this._nameMessages);
		if(messagesModel){
			var messages=messagesModel.getProperty("/messages");
			return !!_.find(messages||[],function(msg){return msg.status==="ERROR";});
		}
		return false;
	},
	setRequiredFields:function(requiredControlIds,context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameData);
		var clone=context.getModel(this._nameClone);
		clone.setProperty('/REQUIREDFIELDS',requiredControlIds);
		model.setProperty('/REQUIREDFIELDS',requiredControlIds);
	},
	isDirty:function(context){
		context=this._resolveContext(context);
		var miscModel=context.getModel(this._nameMisc);
		if(miscModel){
         var isDirty=miscModel.getProperty("/isDirty");
         return !!isDirty;
		}
		return false;
	},
	isFlaggedDirty:function(context){/*set by Java side when initialize block dirties page*/
		context=this._resolveContext(context);
		var dataModel=context.getModel(this._nameData);
		if(dataModel){
			var isDirty=dataModel.getProperty("/__DIRTY__");
			return !!isDirty;
		}
		return false;
	},
	getChoices:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameChoices);
		return model && model.getData();
	},
	getNestedSaves:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameNestedSaves);
		var data=model && model.getData();
		return data;
	},
	getNestedDeletes:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameNestedDeletes);
		var data=model && model.getData();
		return data;
	},
	getScreenReadonly:function(context){
		return this.getUIContextValue("SCREEN_READ_ONLY",context);
	},
	getChangeReasonRequired:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameMisc);
		return model && model.getProperty("/changeReasonRequired");
	},
	getChangeReasonMaxLen:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameMisc);
		return model && model.getProperty("/changeReasonMaxLen");
	},
	getNeverBeenSaved:function(context){
		var uiContext=this.getUIContext(context);
		return uiContext.NEVERBEENSAVED;
	},
	getObjectTypeName:function(context){
		var uiContext=this.getUIContext(context);
		return uiContext.BUSINESSOBJECT.displayName;
	},
	getObjectNameBindParts:function(){
		return [sas.ui.cpb3.model.CpbModelManager.bindDataPath("/CUSTOBJNM")];
	},
	getObjectIcon:function(){
		return sas.icons.HC.FORM;
	}
});
sas.ui.cpb3.model.CpbModelManagerObject.bindMiscPath=function(path){
	return sas.ui.cpb3.model.CpbModelManager._bindPath(path,sas.ui.cpb3.model.CpbModelManagerObject._nameMisc);
};
sas.ui.cpb3.model.CpbModelManagerObject.bindNestedSaves=function(path){
	return "{" + sas.ui.cpb3.model.CpbModelManagerObject.bindNestedSavesPath(path) + "}";
};
sas.ui.cpb3.model.CpbModelManagerObject.bindNestedSavesPath=function(path){
	return sas.ui.cpb3.model.CpbModelManager._bindPath(path,sas.ui.cpb3.model.CpbModelManagerObject._nameNestedSaves);
};
sas.ui.cpb3.model.CpbModelManagerObject.bindNestedDeletes=function(path){
	return "{" + sas.ui.cpb3.model.CpbModelManagerObject.bindNestedDeletesPath(path) + "}";
};
sas.ui.cpb3.model.CpbModelManagerObject.bindNestedDeletesPath=function(path){
	return sas.ui.cpb3.model.CpbModelManager._bindPath(path,sas.ui.cpb3.model.CpbModelManagerObject._nameNestedDeletes);
};
sas.ui.cpb3.model.CpbModelManagerObject.bindMessage=function(path) {
	return "{" + sas.ui.cpb3.model.CpbModelManagerObject.bindMessagePath(path) + "}";
};
sas.ui.cpb3.model.CpbModelManagerObject.bindMessagePath=function(path){
	return sas.ui.cpb3.model.CpbModelManager._bindPath(path,sas.ui.cpb3.model.CpbModelManagerObject._nameMessages);
};