jQuery.sap.declare("sas.ui.cpb3.model.CpbScreenEditorModel");
jQuery.sap.require("sas.ui.cpb3.model.CpbJSONModel");

sas.ui.cpb3.model.CpbScreenEditorModel=function(){};
sas.ui.cpb3.model.CpbScreenEditorModel.prototype={
	_nameLabels : "cpb_labels",
	_nameExps : "cpb_exps",
	_nameStructure : "cpb_structure",
	_nameObservers : "cpb_observers",
	_nameChoices : "cpb_choices",
	_nameMessages : "cpb_messages",
	_nameData : "cpb_data",
	_nameNestedSaves : "cpb_nsaves",
	_nameNestedDeletes : "cpb_ndeletes",
	_nameMisc : "cpb_misc",
	_nameScreen : "cpb_screen",
	_nameValidation : "cpb_validation",
	refreshSourceModel : function(json,context) {
		context=this._resolveContext(context);
		this._setModel(json.cpb_screen,this._nameScreen,context);
		this._setModel(json.cpb_validation,this._nameValidation,context);
	},
	refreshErrorModel : function(json,context) {
		context=this._resolveContext(context);
		this._setModel(json,this._nameValidation,context);
	},
	refreshPreviewModel : function(json,context) {
		context=this._resolveContext(context);
		this._setModel(json.cpb_labels,this._nameLabels,context);
		this._setModel(json.cpb_exps,this._nameExps,context);
		this._setModel(json.cpb_structure,this._nameStructure,context);
		this._setModel(json.cpb_observers,this._nameObservers,context);
		this._setModel(json.cpb_choices,this._nameChoices,context);
		this._setModel(json.cpb_nestedSaves,this._nameNestedSaves,context);
		this._setModel(json.cpb_nestedDeletes,this._nameNestedDeletes,context);
		this._setModel(json.cpb_messages,this._nameMessages,context);
		this._setModel(json.cpb_misc,this._nameMisc,context);
		this._setModel(json.cpb_data,this._nameData,context);
		this._setModel({},this._nameValidation,this._resolveContext());
	},
	_setModel:function(json,name,view){
		if(!json){
			view.setModel(null,name);
		}else{
			view.setModel(new sas.ui.cpb3.model.CpbJSONModel(json),name);
		}
	},
	clear : function(context){
		context=this._resolveContext(context);
		this.refreshSourceModel({},context);
		this.refreshPreviewModel({}, context);
	},
	_resolveContext:function(context){
		var currentTemplate=sas.ui.mashup.App.getInstance().getCurrentTemplate();
		return context || currentTemplate;
	},
	hasValidationErrors : function(context){
		context=this._resolveContext(context);
		var validationModel=context.getModel(this._nameValidation)
		var validationData=validationModel ? validationModel.getData() : null;
		return validationData && validationData.errorCount && validationData.errorCount>0;
	},
	applyScreenUpdate : function(name,value,context){
		context=this._resolveContext(context);
		var screenModel=context.getModel(this._nameScreen);
		screenModel.setProperty("/"+name,value);
	},
	getScreenXML : function(context){
		var screenData=this.getScreenData(context);
		return screenData["XML"];
	},
	getStructure:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameStructure);
		return model.getData();
	},
	getScreenData:function(context){
		context=this._resolveContext(context);
		var model=context.getModel(this._nameScreen);
		return model.getData();
	},
	getValidationModelName:function(){
		return this._nameValidation;
	},
	//BINDINGS
	bindData : function(path) {
		return "{" + this.bindDataPath(path) + "}";
	},
	bindDataPath : function(path){
		return this._bindPath(path,this._nameData);
	},
	bindStructure: function(path) {
		return "{" + this.bindStructurePath(path) + "}";
	},
	bindStructurePath : function(path){
		return this._bindPath(path,this._nameStructure);
	},
	bindExp : function(path) {
		return "{" + this.bindExpPath(path) + "}";
	},
	bindExpPath : function(path){
		return this._bindPath(path,this._nameExps);
	},
	bindLabel : function(path) {
		return "{" + this.bindLabelPath(path) + "}";
	},
	bindLabelPath : function(path){
		return this._bindPath(path,this._nameLabels);
	},
	bindScreen : function(path) {
		return "{" + this.bindScreenPath(path) + "}";
	},
	bindScreenPath : function(path){
		return this._bindPath(path,this._nameScreen);
	},
	bindValidation : function(path) {
		return "{" + this.bindValidationPath(path) + "}";
	},
	bindValidationPath : function(path){
		return this._bindPath(path,this._nameValidation);
	},
	//HELPERS
	_bindPath : function(path,name) {
		return name?name + ">" + path:path;
	}
};
sas.ui.cpb3.model.CpbScreenEditorModel._instance=new sas.ui.cpb3.model.CpbScreenEditorModel();
sas.ui.cpb3.model.CpbScreenEditorModel.getInstance=function(){
	return sas.ui.cpb3.model.CpbScreenEditorModel._instance;
};