jQuery.sap.declare("sas.ui.cpb3.model.type.CpbNumber");
jQuery.sap.require("sas.ui.cpb3.model.type.CpbType");
jQuery.sap.require("sap.ui.model.type.Float");
jQuery.sap.require("sas.ui.cpb3.model.format.CpbNumberFormat");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");

sas.ui.cpb3.model.type.CpbType.extend("sas.ui.cpb3.model.type.CpbNumber", {
	constructor : function () {
		sas.ui.cpb3.model.type.CpbType.apply(this, arguments);
		this._oNumber=new sap.ui.model.type.Float(arguments[0]);
		var locale=sas.ui.cpb3.CpbUtil.getLocale();
		this._oNumber.oFormat = sas.ui.cpb3.model.format.CpbNumberFormat.getFloatInstance(this.oFormatOptions,locale);
		this.sName = "CpbNumber";
	}
});
sas.ui.cpb3.model.type.CpbNumber.prototype.formatValue = function(nValue, sInternalType) {
	return this._oNumber.formatValue(nValue, sInternalType);
};
sas.ui.cpb3.model.type.CpbNumber.prototype.parseValue = function(nValue, sInternalType) {
	if (!nValue) {
		return undefined;
	}
	try{
		return this._oNumber.parseValue(nValue, sInternalType);
	}catch(e){//last ditch attempt
		var num=Number(nValue);
		if(_.isNaN(num))throw e;
		return num;
	}
};
sas.ui.cpb3.model.type.CpbNumber.prototype.validateValue = function(nValue) {
	return this._oNumber.validateValue(nValue);
};