jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");

sap.ui.jsview("sas.ui.cpb3.nav.ChangeReasonDialog", {
	getControllerName : function() {
		return "sas.ui.cpb3.nav.ChangeReasonDialog";
	},
	createContent : function(controller) {
	   var that=this;
	   var viewData=this.getViewData();
	   this.mainLayout = new sas.hc.ui.commons.layout.VerticalLayout({width:"100%"});
	   this.headerCellLayout=new sas.risk.common.layout.flexlayout.FlexLayout({
		      width:"100%",
		      flexDirection:  sas.risk.common.layout.flexlayout.FlexLayoutDirection.Row,
		      justifyContent: sas.risk.common.layout.flexlayout.FlexLayoutJustifyContent.SpaceBetween
		});
	    this.changeReasonLabel= new sas.hc.m.Label({text:viewData.reasonTxt,textAlign:sap.ui.core.TextAlign.Right,required:true}).addStyleClass("cpbReasonTextLbl");
	    this.changeReasonTextArea=new sas.hc.m.TextArea({
			  required:true,
			  rows: 5,
			  width:"100%",
		      maxLength:viewData.changeReasonMaxLen,
		      value: viewData.changeReason,
	          liveChange:function(e){
	       		that.saveButton.setEnabled(controller.actionIsSaveEnabled());
	 	      }
		});
	   this.mainLayout.addContent(this.changeReasonLabel);
	   this.mainLayout.addContent(this.changeReasonTextArea);
	   this.createButtons(controller);
	   that.saveButton.setEnabled(controller.actionIsSaveEnabled());
	   return this.mainLayout;
	},
	createButtons : function(controller) {
		var viewData=this.getViewData();
		this.saveButton=new sas.risk.common.widgets.Button({
			text:viewData.saveButtonTxt,
			enabled:false,
			press:$.proxy(controller.actionSave,controller)
		});
	   this.saveButton.addStyleClass("sasPrimaryButton");
		this.cancelButton=new sas.risk.common.widgets.Button({
			text:viewData.cancelButtonTxt,
			press:$.proxy(controller.actionCancel,controller)
		});
	},
	getDialogSettings : function() {
		return {
          contentWidth:"50%",
          beginButton: this.saveButton,
          endButton: this.cancelButton,
 		  initialFocus: this.changeReasonTextArea
		};
	}
});

sap.ui.controller("sas.ui.cpb3.nav.ChangeReasonDialog", {
	actionSave:function(){
		var view=this.getView();
		var viewData=view.getViewData();
		var dialog=view.getDialog();
		dialog.setBusyIndicatorDelay(0);
		dialog.setBusy(true);
		view.fireClosing({
			changeReason:view.changeReasonTextArea.getValue(),
			transition:viewData.transition
		});
	},
	actionCancel:function(){
		this.getView().getDialog().close();
	},
	actionIsSaveEnabled:function(){
		var view=this.getView();
		return view.changeReasonTextArea.getValue().trim().length > 0;
	}
});

