jQuery.sap.declare("sas.ui.cpb3.nav.ScreenEditorToolbarActions");
jQuery.sap.require("sas.ui.cpb3.model.CpbScreenEditorModel");
jQuery.sap.require("sas.ui.cpb3.nav.ToolbarActions");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutRenderer");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.ui.cpb3.nav.NavUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");

sas.ui.cpb3.nav.ToolbarActions.extend("sas.ui.cpb3.nav.ScreenEditorToolbarActions",{
	metadata:{
		properties:{
			bizcomp:{type:"any"}
		}
	},
	renderer:"sas.risk.common.layout.flexlayout.FlexLayoutRenderer"
});
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.applySettings=function(){
	sas.ui.cpb3.nav.ToolbarActions.prototype.applySettings.apply(this,arguments);
	this.publishButton=this.createPublishButton();
	this.closeButton=this.createCloseButton();
	this.addItem(this.publishButton);
	this.addItem(this.closeButton);
};
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.createCloseButton=function(){
	var bizcomp=this.getBizcomp();
	var rb=sas.ui.cpb3.CPBService.getInstance(bizcomp.getServiceId()).getBundle();
	return new sas.risk.common.widgets.Button({
		text:rb.getText("form.button.close.txt"),
		press: $.proxy(this.actionCloseCheck,this)
	}).addStyleClass("FormCloseButton").setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexShrink:0}));
};
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.createPublishButton=function(){
	var bizcomp=this.getBizcomp();
	var rb=sas.ui.cpb3.CPBService.getInstance(bizcomp.getServiceId()).getBundle();
	var that=this;
	return new sas.risk.common.widgets.Button({
		text:rb.getText("form.button.publish.txt"),
		design: sas.hc.m.Button.Design.Primary,
		press: $.proxy(this.actionPublish,this),
		enabled:{
			parts:[sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().bindScreenPath("/isDirty")],
			formatter:function(isDirty){
				return !!isDirty;
			}
		}
	}).addStyleClass("FormSaveButton").setLayoutData(new sas.risk.common.layout.flexlayout.FlexLayoutData({flexShrink:0}));
};
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.actionPublish=function(){
	sas.ui.mashup.App.getInstance().setBusy(true);
	var screenXML=sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().getScreenXML();
	var screenId=this.getBizcomp().getScreenId();
	var that=this;
	var bizcomp=this.getBizcomp();
	var cpbService=sas.ui.cpb3.CPBService.getInstance(bizcomp.getServiceId());
	cpbService.getScreenEditorAPI().saveScreen(screenId,screenXML,true).done(function(results){
		sas.ui.cpb3.nav.NavUtil.getInstance().navTo(
			bizcomp,
			{
				event_name:"published_screenedit"
			}
		);
	}).fail(function(json){
		sas.ui.cpb3.model.CpbScreenEditorModel.getInstance().refreshErrorModel(json);
		that.getBizcomp().selectSourceTab();
	}).always(function(){
		sas.ui.mashup.App.getInstance().setBusy(false);
	});
};
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.actionCloseCheck = function(e){
	if(this.publishButton.getEnabled()){
		var bizcomp=this.getBizcomp();
		var rb=sas.ui.cpb3.CPBService.getInstance(bizcomp.getServiceId()).getBundle();
		var answer=confirm(rb.getText("form.unsaved.warning.txt"));
		if(answer){
			this.actionClose();
		}
	}else{
		this.actionClose();
	}
};
sas.ui.cpb3.nav.ScreenEditorToolbarActions.prototype.actionClose = function(e) {
	var bizcomp=this.getBizcomp();
	sas.ui.cpb3.nav.NavUtil.getInstance().navTo(
		bizcomp,
		{
			event_name:"close_screenedit"
		}
	);
};