jQuery.sap.declare("sas.ui.cpb3.template.CpbViewToolbarTemplate");
jQuery.sap.require("sas.ui.mashup.template.ViewToolbarTemplate");
jQuery.sap.require("sas.ui.mashup.LibRegistry");
jQuery.sap.require("sas.ui.mashup.util.PerspectiveUtil");

sas.ui.cpb3.template.CpbViewToolbarTemplate=function(routeName,page){
	sas.ui.mashup.template.ViewToolbarTemplate.apply(this,arguments);
};
sas.ui.cpb3.template.CpbViewToolbarTemplate.prototype=Object.create(sas.ui.mashup.template.ViewToolbarTemplate.prototype);
sas.ui.cpb3.template.CpbViewToolbarTemplate.prototype.getCssStyles=function(){
	return sas.ui.mashup.template.ViewToolbarTemplate.prototype.getCssStyles.apply(this,arguments).concat(["CpbViewToolbarTemplate"]);
};
sas.ui.cpb3.template.CpbViewToolbarTemplate.prototype.createTitle=function(){
	var cpbForm=this.getPage().getComponents()[0].cpbForm
	var cpbModelManager=cpbForm.getCpbModelManager();
	var iconCss=sas.ui.mashup.util.PerspectiveUtil.generateObjectCssClasses(cpbForm);
	var rb=cpbForm.getCpbService().getBundle();
//   this.heading=new sas.hc.m.Heading({
//   	text:{
//      	parts:cpbModelManager.getObjectNameBindParts(),
//			formatter:function(){
//				var objectName=_.find(Array.prototype.slice.call(arguments),function(arg){return !!arg;});
//				var neverBeenSaved=cpbModelManager.getNeverBeenSaved();
//				var objectTypeName=cpbModelManager.getObjectTypeName();
//				if(!this.visited){
//					this.visited=true;
//					if(neverBeenSaved && !!objectName){
//						return rb.getText("cpb.draft.object.createdFrom.fmt.txt",[objectName]);
//					}
//				}
//				if(!!objectName){
//					if(neverBeenSaved){
//						return rb.getText("cpb.draft.named.object.fmt.txt",[objectTypeName,objectName]);
//					}else{
//						return rb.getText("cpb.edit.object.fmt.txt",[objectTypeName,objectName]);
//					}
//				}
//				return rb.getText("cpb.draft.object.fmt.txt",[objectTypeName]);
//			}
//   	},
//   	level:2
//   });
   this.heading=new sas.hc.m.Input({
   	editable: false,
   	value:{
      	parts:cpbModelManager.getObjectNameBindParts(),
			formatter:function(){
				var objectName=_.find(Array.prototype.slice.call(arguments),function(arg){return !!arg;});
				var neverBeenSaved=cpbModelManager.getNeverBeenSaved();
				var objectTypeName=cpbModelManager.getObjectTypeName();
				if(!this.visited){
					this.visited=true;
					if(neverBeenSaved && !!objectName){
						return rb.getText("cpb.draft.object.createdFrom.fmt.txt",[objectName]);
					}
				}
				if(!!objectName){
					if(neverBeenSaved){
						return rb.getText("cpb.draft.named.object.fmt.txt",[objectTypeName,objectName]);
					}else{
						return rb.getText("cpb.edit.object.fmt.txt",[objectTypeName,objectName]);
					}
				}
				return rb.getText("cpb.draft.object.fmt.txt",[objectTypeName]);
			}
   	},
   	width: '100%'
   });
	return new sas.risk.common.layout.flexlayout.FlexLayout({
		alignItems:sas.risk.common.layout.flexlayout.FlexLayoutAlignItems.Center,
		items:[
	      sas.icons.pool.createControlByURI(cpbModelManager.getObjectIcon()).addStyleClass(iconCss),
	      this.heading
      ]
	}).addStyleClass("CpbViewToolbarTemplateTitle");
};
sas.ui.cpb3.template.CpbViewToolbarTemplate.prototype.getControllerName=function(){
	return "sas.ui.cpb3.template.CpbViewToolbarTemplateController";
};
sas.ui.cpb3.template.CpbViewToolbarTemplateController=function(){
	sas.ui.mashup.template.ViewToolbarTemplateController.apply(this,arguments);
};
sas.ui.cpb3.template.CpbViewToolbarTemplateController.prototype=Object.create(sas.ui.mashup.template.ViewToolbarTemplateController.prototype);
sas.ui.cpb3.template.CpbViewToolbarTemplateController.prototype.onLeave=function(){
	//this.getView().heading.setText("");
	this.getView().heading.setValue("");
	this.getView().heading.visited=false;
	sas.ui.mashup.template.ViewToolbarTemplateController.prototype.onLeave.apply(this,arguments);
};
sap.ui.controller("sas.ui.cpb3.template.CpbViewToolbarTemplateController",new sas.ui.cpb3.template.CpbViewToolbarTemplateController());