jQuery.sap.declare("sas.ui.cpb3.widget.InputField");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.ui.cpb3.model.format.CpbNumberFormat");
jQuery.sap.require("sas.ui.cpb3.model.type.CpbNumber");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");

sas.hc.m.Input.extend("sas.ui.cpb3.widget.InputField", {
	metadata:{
		properties:{
			size : {type : "int", group : "Behavior", defaultValue : 0}
		}
	}
});
//RGFRMWRK-642
//sas.ui.cpb3.widget.InputField.prototype.setValue = function(sValue) {
//
//	// validate given value
//	sValue = this.validateProperty("value", sValue);
//
//	// get the value respect to the max length
//	sValue = this._getInputValue(sValue);
//
//	// update the dom value when necessary
//	this.updateDomValue(sValue);
//
//	// check if we need to update the last value because
//	// when setProperty("value") called setValue is called again via binding
//	var bindType = this.getBinding("value") ? this.getBinding("value").getType() : null;
//	var parsedSValue = bindType ? bindType.parseValue(sValue,"string") : sValue;
//	var parsedPropValue = bindType ? bindType.parseValue(this.getProperty("value"),"string") : this.getProperty("value");
//	if (parsedSValue !== parsedPropValue) {
//		this._lastValue = sValue;
//	}
//
//	// update value property
//	this.setProperty("value", sValue, true);
//
//	return this;
//};

sas.ui.cpb3.widget.InputField.prototype._onInput = function(oEvent) {
	var value = this._$input.val();

	// add maxlength support for all types
	// TODO: type number add min and max properties
	if (this.getMaxLength() > 0 && value.length > this.getMaxLength()) {
		value = value.substring(0, this.getMaxLength());
		this._$input.val(value);
	}

	if (value !== this.getProperty("value")) {
		//CPB: override - start
		//Specical case for handling number input fields
		var type = this.getBinding("value") ? this.getBinding("value").getType() : null;
		if(type && type instanceof sas.ui.cpb3.model.type.CpbNumber){
			var maxDecimalDigits = type ? type.oFormatOptions.maxFractionDigits : null;
			var exceedsMaxDecimalDigits = null;
			var parsedVal = null;
			try{
				var parsedVal = type.parseValue(value,"string");
			}
			catch(exception){
				console.log("InputField's _onInput - Error parsing value ", value, exception);
			}
			var ooFormat = sas.ui.cpb3.model.format.CpbNumberFormat.getFloatInstance(this.oFormatOptions,sas.ui.cpb3.CpbUtil.getLocale());
			var decimalChar = ooFormat.oLocaleData.getNumberSymbol("decimal");
			var hasDecimalDigits = (value.indexOf(decimalChar) > -1) ? true : false;
			if($.isNumeric(parsedVal) && hasDecimalDigits){
				if(maxDecimalDigits){
					var decimalDigits = value.split(decimalChar)[1];
					exceedsMaxDecimalDigits = decimalDigits.length > maxDecimalDigits;
				}
			}
			//For the case when user enters 0 after decimal point for example 1.20 
			//default behavior is that during setting the value, the binding parsing will remove the trailing zero and return 1.2 making it impossible for user to type for example 1.203
			//Following line is to trick the binding that there is no change by parsing it ahead and then setting the value. Then it keeps what is in the input field letting user to type ahead.
			//ManagedObject.prototype.setProperty always compares the new value with old value and if there is no change then it will leave it as it is
			var val = value;
			if(val.charAt(val.length - 1)==="0" && !exceedsMaxDecimalDigits && hasDecimalDigits){
				for(var i=0;i<val.length;i++){
					var char = val.charAt(val.length - 1);
					if(char === "0"){
						val = val.substring(0,val.length-1);
					}
					else{
						break;
					}
				}
			}
			this.setProperty("value", val, true);
		}
		else{
			this.setProperty("value", value, true);
		}
		//CPB: override - end
		
		this._setLabelVisibility();
		this.fireLiveChange({
			value: value,

			// backwards compatibility
			newValue: value
		});

		// No need to fire suggest event when suggestion feature isn't enabled or runs on the phone.
		// Because suggest event should only be fired by the input in dialog when runs on the phone.
		if (!this.getShowSuggestion() || sap.ui.Device.system.phone) {
			return;
		}

		this._triggerSuggest(value);
	}

};