jQuery.sap.declare("sas.ui.cpb3.widget.RadioButtonGroup");
jQuery.sap.require("sas.hc.ui.commons.RadioButtonGroup");
jQuery.sap.require("sas.risk.common.utils.CompositeUtil");
jQuery.sap.require("sas.hc.m.RadioButtonGroupRenderer");

sas.hc.m.RadioButtonGroup.extend("sas.ui.cpb3.widget.RadioButtonGroup", {
	metadata:{
		properties:{
			"selectedIndex" : {type : "int", group : "Data", defaultValue : -1}
		},
		events : {
			"change" : {}
		}
	},
	renderer:sas.hc.m.RadioButtonGroupRenderer
});
sas.ui.cpb3.widget.RadioButtonGroup.prototype.init = function(){
	sas.risk.common.utils.CompositeUtil.addComposite(this, "change", this, "select");
	this.addStyleClass("cpbRadioButtonGroup")
};
sas.risk.common.utils.CompositeUtil.mixinEventSupport(sas.ui.cpb3.widget.RadioButtonGroup);

sas.ui.cpb3.widget.RadioButtonGroup.prototype.removeAllButtons = function() {
	/**
	 * The removeAllButtons is calling setSelectedIndex on the buttons, and if they happen to be bound 
	 * it is updating the model when we dont want it too. Thinking is that if you are destroying things
	 * that you dont want the bound model to be updated with a -1
	 */
	var orig=this._bUpdateButtons;
	this._bUpdateButtons=true;
	var val=sas.hc.m.RadioButtonGroup.prototype.removeAllButtons.apply(this,arguments);
	this._bUpdateButtons=orig;
	return val;
};
sas.ui.cpb3.widget.RadioButtonGroup.prototype.destroyButtons = function() {
	var orig=this._bUpdateButtons;
	this._bUpdateButtons=true;
	var val=sas.hc.m.RadioButtonGroup.prototype.destroyButtons.apply(this,arguments);
	this._bUpdateButtons=orig;
	return val;
};
sas.ui.cpb3.widget.RadioButtonGroup.prototype.setSelectedIndex = function(iSelectedIndex) {

	var iIndexOld = this.getSelectedIndex();

	this.setProperty("selectedIndex", iSelectedIndex, true); // no re-rendering

	// deselect old RadioButton
	if( !isNaN(iIndexOld) && this.aRBs && this.aRBs[iIndexOld]){
		this.aRBs[iIndexOld].setSelected(false);
	}

	// select new one
	if(iSelectedIndex >= 0 && this.aRBs && this.aRBs[iSelectedIndex]){
		this.aRBs[iSelectedIndex].setSelected(true);
	}

	if(this.oItemNavigation){
		this.oItemNavigation.setSelectedIndex(iSelectedIndex);
		this.oItemNavigation.setFocusedIndex(iSelectedIndex);
	}

	return this;

};