jQuery.sap.declare("sas.ui.cpb3.widget.diagram.GraphDiagram");
jQuery.sap.require("sas.ui.cpb3.widget.diagram.ADiagram");
jQuery.sap.require("sas.hc.ui.core.HTMLRenderer");
jQuery.sap.require("sas.ui.cpb3.widget.diagram.GraphTemplateFactory");

sas.ui.cpb3.widget.diagram.ADiagram.extend("sas.ui.cpb3.widget.diagram.GraphDiagram", {
	 metadata:{
       properties:{
           values: {type:"any",defaultValue:[]},
           value:{type:"string"}
       }
   },
	renderer: "sas.hc.ui.core.HTMLRenderer"
});

sas.ui.cpb3.widget.diagram.GraphDiagram.prototype.onBeforeRendering=function(){
	var options=this.getOptions();
	this.styleId=options.styleId[0];
	this.rootHandle=options.rootHandle[0];
	this.callback=options.callback?options.callback:null;
	var width=options.width?options.width[0]:"100%";
	var height=options.height?options.height[0]:"400px";
	this.setContent('<div class="cpbDiagram_'+this.styleId+'" style="width:'+width+'; height:100%; min-height:'+height+'"></div>');
	this.setPreferDOM(false);
};
sas.ui.cpb3.widget.diagram.GraphDiagram.prototype.onAfterRendering=function(e){
	sas.ui.cpb3.widget.diagram.ADiagram.prototype.onAfterRendering.apply(this,arguments);
	this.diagram=go.GraphObject.make(
		go.Diagram,
		e.srcControl.getId(),
		{
         initialContentAlignment: go.Spot.Center,  // center the content
         "undoManager.isEnabled": true,  // enable undo & redo,
         "toolManager.hoverDelay":100,
         "animationManager.isEnabled": true,
         layout: go.GraphObject.make(
            go.ForceDirectedLayout, { 
            defaultSpringLength: 10,
            //randomNumberGenerator:null,
				//isInitial:true,
				//isOngoing:false,
            defaultSpringStiffness: 0.05
         })
      }
   );
	var diagramFactory=new sas.ui.cpb3.widget.diagram.GraphTemplateFactory(this.rootHandle,this.styleId,this.getBundle(),this.callback);
   this.diagram.nodeTemplateMap=diagramFactory.createNodeTemplates();
   this.diagram.linkTemplateMap=diagramFactory.createLinkTemplates();
   var values=this.getValues()||{nodes:[],links:[]};
   var that=this;
   var rootNode=_.find(values.nodes,function(node){
   	return node.key===that.rootHandle;
   });
   if(rootNode){
   	rootNode.selected=true;
   }
   this.diagram.model = new go.GraphLinksModel(values.nodes,values.links);
	this.fixMouseWheel();
	this.enableDoubleClick();
	this.turnOffDragSelection();
	this.firstTime=false;
};
