jQuery.sap.declare("sas.ui.cpb3.widget.diagram.GraphStyles");

sas.ui.cpb3.widget.diagram.GraphStyles=function(styleId){
   this.styleId=styleId;
};
sas.ui.cpb3.widget.diagram.GraphStyles.prototype={
   getLinkTemplateNames:function(){
      return this.getTemplateNames("#"+this.styleId+"_L_");
   },
   getNodeTemplateNames:function(){
      return this.getTemplateNames("#"+this.styleId+"_N_");
   },
   getTemplateNames:function(pattern){
      var names=_.reduce(sas.ui.cpb3.widget.diagram.GraphStyles._styles,function(memo,value,key){
         if(key.indexOf(pattern)===0){
            var chunks=key.split("_");
            if(chunks.length>2 && chunks[2].length && chunks[2]!=="default"){
            	chunks.shift();chunks.shift();
               memo.push(chunks.join("_"));
            }
         }
         return memo;
      },[]);
      return _.uniq(names);
   },
   getStyle:function(name,type){
   	var names=name.split("_");
   	var styles=[];
   	while(names.length){
   		styles.unshift(this._findStyle(names.join("_"),type));
   		names.pop();
   	}
   	styles.unshift(this._findStyle("default",type));
   	return $.extend.apply($,styles);
   },
   _findStyle:function(name,type){
   	var pattern="#"+this.styleId+"_"+type+"_"+name;
   	var rule=sas.ui.cpb3.widget.diagram.GraphStyles._styles[pattern];
   	if(rule && rule.style.content){
   		var content=rule.style.content;
   		if(content && content.length>2){
   			if(content[2]!=="\\"){//IE11
   				content=content.substring(1,content.length-1);
   				content=content.replace("\\","\\\\");
   			}else{
   				content=JSON.parse(content);
   			}
   			return JSON.parse(content);
   		}
		}
   	return {};
   },
   getIcon:function(style,name,type){
      var content=style.icon;
      if(content.charAt(0)==="\\"){
      	return String.fromCharCode(parseInt(content.substring(1,content.length),16));
      }
      return content.charAt(0);
   }
};
sas.ui.cpb3.widget.diagram.GraphStyles._styles={};
sas.ui.cpb3.widget.diagram.GraphStyles.loadStyles=function() {
   var styles = {};
   //For cross-origin loaded CSS links, the js code to read or manipulate the styleSheets does not work
   try {
      var safeGetRules=function(styleSheet){
         var rules=[];
         try{
            rules=styleSheet.cssRules||styleSheet.rules||[];
         }catch(err){
            console.error("Loading stylesheet "+styleSheet.href+" failed due to the following message : " + ((!!err.message) ? err.message : err));
         }finally{
            return rules;
         }
      };
      var processRule=function(cssRule){
         if (cssRule) {
            var selector = cssRule.selectorText;
            if (selector) {
               styles[selector] = cssRule;
            }
         }
      };
      var processStyleSheet=function(styleSheet){
         _.each(safeGetRules(styleSheet),function(cssRule){
            if(cssRule instanceof CSSImportRule){
               processStyleSheet(cssRule.styleSheet);
            }else{
               processRule(cssRule);
            }
         });
      };
      _.each(document.styleSheets||[],function(styleSheet){
         processStyleSheet(styleSheet);
      });
   } catch (err) {
      console.error("The getStyles invocation failed due to the following message : " + ((!!err.message) ? err.message : err));
   }
   sas.ui.cpb3.widget.diagram.GraphStyles._styles=styles;
};
sas.ui.cpb3.widget.diagram.GraphStyles.loadStyles();