jQuery.sap.declare("sas.ui.cpb3.widget.diagram.GraphUtils");

sas.ui.cpb3.widget.diagram.GraphUtils={
   getCollapseableNodes:function(myKey,rootKey,links,nodes){
      var peers=sas.ui.cpb3.widget.diagram.GraphUtils.getPeers(myKey,links);
      var results={};
      delete peers[rootKey];
      _.each(_.keys(peers),function(peer){
         var peerResults=sas.ui.cpb3.widget.diagram.GraphUtils._collapseCollector(peer,rootKey,[myKey],links,nodes);
         _.each(peerResults,function(linkArray,nodeKey){
            results[nodeKey]=(results[nodeKey]||[]).concat(linkArray);
         });
      });
      var nks=[];
      var lks=[];
      _.each(results,function(linkArray,nodeKey){
         nks.push(nodeKey);
         lks=lks.concat(linkArray);
      });
      return {nodeKeys:_.uniq(nks),linkKeys:_.uniq(lks)};
   },
   _collapseCollector:function(myKey,rootKey,processedNodes,links,nodes){
      processedNodes.push(myKey);
      var peers=sas.ui.cpb3.widget.diagram.GraphUtils.getPeers(myKey,links);
      var combackLinks=[];
      _.each(processedNodes,function(processedNode){
         if(peers[processedNode]){
            combackLinks=combackLinks.concat(peers[processedNode]);
            delete peers[processedNode];
         }
      });
      if(peers[rootKey]){
         return {};
      }
      var results={};//all the nodes that CAN be removed
      var count=0;
      _.each(_.keys(peers),function(peer){
         var peerResults=sas.ui.cpb3.widget.diagram.GraphUtils._collapseCollector(peer,rootKey,processedNodes,links,nodes);
         if(peerResults[peer]){
            count++;
         }else{
            var peerNode=_.find(nodes,function(n){return n.key===peer;});
            if(!peerNode.expanded){
                  count++;
                  combackLinks=combackLinks.concat(peers[peer]);
            }
         }
/*         else{
            combackLinks.push(peers[peer]);
         }*/
         _.each(peerResults,function(linkArray,nodeKey){
            results[nodeKey]=(results[nodeKey]||[]).concat(linkArray);
         });
      });
      if(count===_.size(peers) && !results[myKey]){
         results[myKey]=combackLinks;
      }
      return results;
   },
   getPeers:function(myKey,links){
      var peers={};
      _.each(links,function(link){
         var node=link.from===myKey?link.to:(link.to===myKey?link.from:null);
         if(node){
            peers[node]=peers[node]||[];
            peers[node].push(link.key);
         }
      });
      return peers;
   }
};