jQuery.sap.declare("sas.ui.mashup.biz.AppInfo");
jQuery.sap.require("sas.ui.mashup.template.TemplateFactory");
jQuery.sap.require("sas.ui.mashup.biz.Menu");
jQuery.sap.require("sas.ui.mashup.biz.Page");

sas.ui.mashup.biz.AppInfo=function(appId,title,appswitcher,helpUrl,globalSearch,vaHubAppId,dependencies,menu){
	this.appId=appId;
	this.title=title;
	this.appswitcher=appswitcher;
	this.helpUrl=helpUrl;
	this.globalSearch=globalSearch;
	this.vaHubappId=vaHubAppId;
	this.dependencies=dependencies;
	this.pages=[];
	this.menu=menu||new sas.ui.mashup.biz.Menu();
};
sas.ui.mashup.biz.AppInfo.prototype={
	createRoutes:function(){
		var routes=[];
		_.each(this.pages,function(page){
			var name=page.getPageId();
			var routePatterns=_.pluck(page.getRoutePatterns(),"pattern");
			routes.push({
				name:name,
				pattern:routePatterns,
				viewName:name
			});
			var template=sas.ui.mashup.template.TemplateFactory.create(page,name);
			sap.ui.jsview(name,template);
		});
		return routes;
	},
	getAppId:function(){
	   return this.appId;
	},
	getMenu:function(){
		return this.menu;
	},
	getDependencies:function(){
		return this.dependencies;
	},
//	getDependentLibraries:function(){
//		var libs=[];
//		_.each(this.pages,function(page){
//			libs=libs.concat(page.getDependentLibraries());
//		});
//		return _.uniq(libs);
//	},
	getHelpUrl:function(){
		return this.helpUrl;
	},
	getTitle:function(){
		return this.title;
	},
	getAppSwitcher:function(){
		return this.appswitcher;
	},
	getGlobalSearch:function(){
		return this.globalSearch;
	},
	getVaHubAppId:function(){
		return this.vaHubAppId;
	},
	getPages:function(){
		return this.pages;
	},
	getPage:function(pageId){
		return _.find(this.pages,function(page){return pageId===page.getPageId();});
	}
};
sas.ui.mashup.biz.AppInfo.create=function(json){
	var menu=sas.ui.mashup.biz.Menu.create(json.menu);
	var appInfo=new sas.ui.mashup.biz.AppInfo(json.id,json.title,json.appswitcher,json.helpUrl,json.globalSearch,json.vaHubAppId,json.dependencies,menu);
	_.each(json.pages||[],function(pageJson){
		var page=sas.ui.mashup.biz.Page.create(pageJson);
		appInfo.pages.push(page);
	});
	return appInfo;
};