jQuery.sap.declare("sas.ui.mashup.biz.MenuItem");

sas.ui.mashup.biz.MenuItem=function(menu,icon,text,pageId,context){
	this.menu=menu;
	this.icon=sas.icons.HC[icon]||icon;
	this.text=text;
	this.pageId=pageId;
	this.id=pageId||(sas.ui.mashup.biz.MenuItem._generatedId++).toString();
	this.context=context;
	this.children=[];
	this.parent=null;
};
sas.ui.mashup.biz.MenuItem.prototype={
	getId:function(){
		return this.id;
	},
	getMenu:function(){
		return this.menu;
	},
	getIcon:function(){
		return this.icon;
	},
	getText:function(){
		return this.text;
	},
	getPageId:function(){
		return this.pageId;
	},
	getContext:function(){
		return this.context;
	},
	getChildren:function(){
		return this.children;
	},
//	getHead:function(){
//		var collapsed=this.menu.isCollapsed();
//		if((!!collapsed&&this.parent.parent===null) || this.parent===null){
//			return this;
//		}
//		return this.parent.getHead();
//	},
	findLevel:function(level){
		var current=this;
		while(current!=null){
			if(current.getLevel()===level){
				return current;
			}
			current=current.parent;
		}
		return null;
	},
	getLevel:function(){
		var collapsed=this.menu.isCollapsed();
		var level=1;
		var current=this;
		while(current.parent!=null){
			level++;
			current=current.parent;
		}
		return collapsed?Math.max(1,level-1):level;
	},
	getParent:function(){
		return this.parent;
	},
	setParent:function(parent){
		this.parent=parent;
	},
	findMenuItem:function(pageId){
		if(this.pageId===pageId){
			return this;
		}else{
			for(var i=0;i<this.children.length;i++){
				var menu=this.children[i].findMenuItem(pageId);
				if(menu){
					return menu;
				}
			}
		}
		return null;
	}
};
sas.ui.mashup.biz.MenuItem.create=function(json,menu){
	var menuItem=new sas.ui.mashup.biz.MenuItem(menu,json.icon,json.text,json.pageId,json.context);
	_.each(json.children,function(childJson){
		var childMenuItem=sas.ui.mashup.biz.MenuItem.create(childJson,menu);
		childMenuItem.setParent(menuItem);
		menuItem.children.push(childMenuItem);
	});
	return menuItem;
};
sas.ui.mashup.biz.MenuItem._generatedId=0;