/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
*/

jQuery.sap.declare("sas.ui.mashup.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.ui.mashup
 * @public
*/
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sas.hc.ui.core.library");
jQuery.sap.require("sap.ui.layout.library");
jQuery.sap.require("sap.ui.unified.library")
jQuery.sap.require("sap.ui.commons.library");
jQuery.sap.require("sap.ui.ux3.library");
jQuery.sap.require("sas.hc.ui.layout.library");
jQuery.sap.require("sap.m.library");
jQuery.sap.require("sas.hc.m.library");
jQuery.sap.require("sas.hc.ui.commons.library");
jQuery.sap.require("sas.hc.ui.commons.codeEditor.library");
//jQuery.sap.require("sas.vaviewer.library");
jQuery.sap.require("sas.risk.common.library");
jQuery.sap.require("sas.risk.slimtable.library");
jQuery.sap.require("sas.ui.cpb3.library");


// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
  name : "sas.ui.mashup",
  dependencies : [
      "sap.ui.core",
      "sas.hc.ui.core",
      "sap.ui.layout",
      "sap.ui.unified",
      "sap.ui.commons",
      "sap.ui.ux3",
      "sas.hc.ui.layout",
      "sap.m",
      "sas.hc.m",
      "sas.hc.ui.commons",
      "sas.hc.ui.commons.codeEditor",
      "sas.risk.common",
      "sas.risk.slimtable"
//      "sas.vaviewer",
  ],
  version : "704001.11.2.20241204113535_f0cpbcmn5p"
});
jQuery.sap.require("sas.ui.mashup.util.HashChanger");/*hacks up the hashchanger and loads ours*/
jQuery.sap.require("sas.ui.mashup.api.AppAPI");
/*register a router with the routes and target view*/
new sap.ui.core.routing.Router([],{
   targetControl: "MashupAppArea",
   targetAggregation: "items",
   viewType: sap.ui.core.mvc.ViewType.JS,
   clearTarget: true
}).register("router");

sas.ui.mashup.library={
	bootHook:function(){
		var def=$.Deferred();
		$.when(
			sas.ui.mashup.api.AppAPI.getAppInfo(),
			sas.ui.mashup.api.AppAPI.loadAppLibs()
		).done(function(appInfo){
			/*Loading and initializing dependent libraries*/
			var dependencies=appInfo.getDependencies();
			var defs=[];
			_.each(dependencies,function(dependency){
				//load preloads first
				try {
					var libraryPreloadClassName=dependency.name+".library-preload";
					jQuery.sap.require(libraryPreloadClassName);
				}
				catch(e) {console.warn(e);}
				
				//load library inits and individual files if preloads don't exist
				try {
					var libraryClassName = dependency.name+".library";
					jQuery.sap.require(libraryClassName);
					var libraryClass = sap.ui.require(libraryClassName.replace(/\./g, "/"));
					if (libraryClass && libraryClass.initialize) {
						defs.push(libraryClass.initialize(appInfo.getAppId()));
					}                             
				} catch(e) {console.warn(e);}
			});
			$.when.apply($,defs).done(function(){
				jQuery.sap.require("sas.hc.ui.core.util");
				sas.hc.ui.core.util._bootHook().then(function(){def.resolve();},function(){def.reject();});
			});
		});
		return new Promise(function(resolve,reject){
			def.done(function(){resolve();});
		});
	}
};
window["sap-ui-config"]["xx-sas-boothook"]=sas.ui.mashup.library.bootHook;
