jQuery.sap.declare("sas.ui.mashup.util.NavUtil");

sas.ui.mashup.util.NavUtil=function(app){
	this.app=app;
	this.navstack=[];
	this.maxstacksize=5;
	this.navcurrent=null;
};
sas.ui.mashup.util.NavUtil.prototype={
	navTo:function(routeName,context,index,navstyle){
		if(this.isGotoPrevPage(navstyle)){
			var prevNav=this.popCurrentNavigation({routeName:routeName,context:context,index:index,navstyle:navstyle});
			return this.navTo(prevNav.routeName,prevNav.context,prevNav.index,prevNav.navstyle);
		}
		index=!!index?index:0;
		var router=this.getRouter();
		var route=router.getRoute(routeName);
		context=_.mapObject(context,function(val,key){return encodeURIComponent(val);})
		if (route) {
			var url=route._aRoutes[index].interpolate(context);
			if(this.isOpenInNewWindow(navstyle)){
		      var baseUrl=this.getContextPath()+"?sap-ui-sas-sessionMaxInActiveInterval=-1"+this.getContextQuery(true);
		      window.open(baseUrl+'/#/'+url, '_blank', '', true);
			}else{
				this.pushCurrentNavigation(routeName,context,index,navstyle);
//				router.oHashChanger.replaceHash(url);
				router.oHashChanger.setHash(url);
			}
		}
	},
   _contextPath:top.location.pathname,
   getContextPath:function(){
   	return this._contextPath;
   },
   _contextQuery:top.location.search||"",
   getContextQuery:function(useAmpersand){
   	if(useAmpersand && this._contextQuery){
   		return "&"+this._contextQuery.substring(1);
   	}
   	return this._contextQuery;
   },
	getRouter:function(){
		if(!this.router){
			this.router=sap.ui.core.routing.Router.getRouter("router");
		}
		return this.router;
	},
	isRefreshing:function(){
		return this.navcurrent&&this.isRefreshOnArrival(this.navcurrent.navstyle);
	},
	popCurrentNavigation:function(defaultNav){
		if(!this.navstack.length){
			this.navcurrent=null;
			delete defaultNav.navstyle;
			if(defaultNav&&defaultNav.routeName){
				return defaultNav;
			}else{
				var menuItem=this.app.getAppInfo().getMenu().getRoots()[0];//"home"
				return {routeName:menuItem.getPageId(),context:menuItem.getContext()};
			}
		}else{
			var goBackStyle=defaultNav.navstyle;//propagate the navstyle of the go back action
			this.navcurrent=this.navstack.shift();
			this.navcurrent.navstyle=this.matchRefreshOnArrival(goBackStyle,this.navcurrent.navstyle);//to the previous page we are about to go to
			return this.navcurrent;
		}
	},
	pushCurrentNavigation:function(routeName,context,index,navstyle){
		var incoming={routeName:routeName,context:context,index:index,navstyle:navstyle};
		if(this.navcurrent && !_.isEqual(incoming,this.navcurrent)){
			var count=this.navstack.unshift(this.navcurrent);
			if(count>this.maxstacksize){
				this.navstack.length=this.maxstacksize;
			}
		}
		this.navcurrent=incoming;
	},
	isOpenInNewWindow:function(navstyle){
		return (navstyle&sas.ui.mashup.util.NavUtil.NAVSTYLE_NEW_WINDOW)===sas.ui.mashup.util.NavUtil.NAVSTYLE_NEW_WINDOW;
	},
	isRefreshOnArrival:function(navstyle){
		return (navstyle&sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL)===sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL;
	},
	matchRefreshOnArrival:function(newNavStyle,currentNavStyle){
		var newNavStyleIsRefresh=this.isRefreshOnArrival(newNavStyle);
		var putOn=newNavStyleIsRefresh?sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL:
												 sas.ui.mashup.util.NavUtil.NAVSTYLE_NO_REFRESH_ON_ARRIVAL;
		var takeOff=newNavStyleIsRefresh?sas.ui.mashup.util.NavUtil.NAVSTYLE_NO_REFRESH_ON_ARRIVAL:
													sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL;
		currentNavStyle=currentNavStyle&(-1^takeOff);
		return currentNavStyle|putOn;
	},
	isNoRefreshOnArrival:function(navstyle){
		return (navstyle&sas.ui.mashup.util.NavUtil.NAVSTYLE_NO_REFRESH_ON_ARRIVAL)===sas.ui.mashup.util.NavUtil.NAVSTYLE_NO_REFRESH_ON_ARRIVAL;
	},
	isGotoPrevPage:function(navstyle){
		return (navstyle&sas.ui.mashup.util.NavUtil.NAVSTYLE_GOTO_PREV_PAGE)===sas.ui.mashup.util.NavUtil.NAVSTYLE_GOTO_PREV_PAGE;
	},
	firstLoadPrimeTheStack:function(name,context){
		var route=this.getRouter().getRoute(name);
		if(route){
			var url=hasher.getHash();
			var routeIndex=0;
			for(var i=0;i<route._aRoutes.length;i++){
				try{
					if(url===route._aRoutes[i].interpolate(context)){
						routeIndex=i;
						break;
					}
				}catch(e){}
			}
			this.pushCurrentNavigation(name,context,routeIndex,sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL);
		}
	}
};
sas.ui.mashup.util.NavUtil.NAVSTYLE_REFRESH_ON_ARRIVAL=1;
sas.ui.mashup.util.NavUtil.NAVSTYLE_NO_REFRESH_ON_ARRIVAL=2;
sas.ui.mashup.util.NavUtil.NAVSTYLE_NEW_WINDOW=4;
sas.ui.mashup.util.NavUtil.NAVSTYLE_GOTO_PREV_PAGE=8;