<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="com.sas.oprisk.server.services.ServiceLocator"%>
<%@ page import="com.sas.oprisk.server.ApplicationProperties"%>
<%@ page import="com.sas.oprisk.server.services.ServiceLocator"%>
<%@ page import="com.sas.oprisk.monitor.web.security.ContentSecurityUtils"%>
<%@ page import="com.sas.oprisk.monitor.web.security.ContentInfo"%>
<%@ page import="java.util.ResourceBundle"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="java.util.Map.Entry"%>

<html>
<%
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   String title = bundle.getString("application.title.txt");
   String welcome = bundle.getString("application.welcome.title.txt");
   String text = bundle.getString("application.select.info.txt");
   String noContentPackages = bundle.getString("application.noContent.txt");
   String notAuthorized = bundle.getString("application.notAuthorized.txt");
   String contactAdmin = bundle.getString("logout.contactAdmin.txt");
   String continueText = bundle.getString("application.continue.txt");
   String signoutText = bundle.getString("logout.tryAgain.txt");
   String signoutHref = request.getContextPath() + "/Logoff";
%>

<head>
   <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
   <!-- Splash screen and custom styles -->
   <link rel="stylesheet" href="<%=request.getContextPath()%>/resources/themes/sas/hc/ui/commons/themes/sas_corporate/splash.css">
   <link rel="stylesheet" href="<%=request.getContextPath()%>/resources/themes/sas/risk/rgf/themes/sas_corporate/library-rgf.css">
   <title><%=title%></title>
</head>

<body>
   <div id="loginbox">
      <% 
      String contentId=request.getParameter("rgfContentId");
      List<ContentInfo> contentList = ContentSecurityUtils.getSymphonyContentPackages(contentId,request.getLocale());
      boolean isAdmin = ContentSecurityUtils.isAdministrator();
      if (contentList.isEmpty() && isAdmin) {
      %>
         
         <h3 class="soloMessage"><%=noContentPackages%></h3>
         <button type="button" class="btn-submit" title="<%=signoutText%>" 
           onclick="javascript:window.location.href='<%=signoutHref%>'"><%=signoutText%></button>
         
      <%
      } else if (contentList.isEmpty() && !isAdmin) {
      %>
      
         <h3 class="soloMessage"><%=notAuthorized%></h3>
         <p class="smalltext"><%=contactAdmin%></p>
         <button type="button" class="btn-submit" title="<%=signoutText%>" 
           onclick="javascript:window.location.href='<%=signoutHref%>'"><%=signoutText%></button>
      
      <%
      } else if (contentList.size() == 1) {
         String comboId = contentList.get(0).getContentId();
         String alias = ServiceLocator.getContentService().resolveAlias(comboId);
         if(alias==null)
            alias=comboId;
         response.sendRedirect(alias);
         return;
      } else {
      %>
      
         <h2 class="title"><%=welcome%></h2>
         <p class="basicText"><%=text%></p>
         <select id="contentPackageSelect" class="contentOptions" onchange="selectContentPackage()">
            
      <%
      boolean first = true;
      for (ContentInfo info : contentList) {
         String comboId = info.getContentId();
         String alias = ServiceLocator.getContentService().resolveAlias(comboId);
         if(alias==null)
            alias=info.getContentId();
         String name = info.getName();
         if(first) {
      %>
         
            <option id="<%=alias%>" value="<%=alias%>" class="contentOption contentOptionSelected"><%=name%></option>
            
      <% 
            first = false;
         } else {
      %>
      
         <option id="<%=alias%>" value="<%=alias%>" class="contentOption"><%=name%></option>
         
      <% 
         }
      %>

      <%   
      }
      %>
      
         </select>
         <button type="button" class="btn-submit" title="<%=continueText%>"
           onclick="confirmContentPackage()"><%=continueText%></button>
         <button type="button" class="btn-submit notPrimary" title="<%=signoutText%>" 
           onclick="javascript:window.location.href='<%=signoutHref%>'"><%=signoutText%></button>
       
      <%
      }
      %>
      
   </div>
 
   <!-- splash screen -->
   <main id="sas-hc-splash" class="indexedSplash">
      <section class="splashLogo"></section>
   </main>
   
   <script>
   function selectContentPackage() {
      var select = document.getElementById("contentPackageSelect");
      var option, i;
      for(i = 0; i < select.length; i++) {
         option = select[i];
         if (option.selected) {
            option.classList.add("contentOptionSelected");
         } else {
      	   option.classList.remove("contentOptionSelected");
         }
       }
   }
   function confirmContentPackage() {
   	var select = document.getElementById("contentPackageSelect");
   	var value = select.options[select.selectedIndex].value;
   	window.location.href=value;
   }
</script>
</body>
</html>




      