#!/bin/sh
# shell function to parse command line options for PostgreSQL scripts.
# Usage:
# . ./ParseArgs.sh
# parseargs $*
# shift `expr $OPTIND - 1`
#
# -U option (-U username will be in $USERNAMEOPTION
# -P option (-P password) will be in $PASSWORDOPTION
# -h option (-h hostname) will be in $HOSTNAMEOPTION
# -s option (-s schemaname) will be in $SCHEMA
#
parseargs() {
   HOSTNAME=
   PASSWORD=
   USERNAME=
   while getopts 'h:P:U:s:' OPTION
   do
      case "$OPTION" in
      "h") HOSTNAME=$OPTARG
      ;;
      "P") PASSWORD=$OPTARG
      ;;
      "U") USERNAME=$OPTARG
      ;;
      "s") SCHEMA=$OPTARG
      ;;
       \?) exit 1
      ;;
       esac
   done
   ARGCOUNT=`expr $OPTIND - 1`
   HOSTNAMEOPTION=
   if [ "${HOSTNAME}" != "" ]
   then 
      HOSTNAMEOPTION="-S ${HOSTNAME}"
   fi
   USERNAMEOPTION=
   if [ "${USERNAME}" != "" ]
   then 
      USERNAMEOPTION="-U ${USERNAME}"
   fi
   PASSWORDOPTION=
   if [ "${PASSWORD}" != "" ]
   then 
      PASSWORDOPTION="-P ${PASSWORD}"
   fi
}
