#!/bin/sh
# Usage: Usage: PrepareDatabase -U sa-username [-P sa-password] [-h hostname] <database> <new-user-name>
# <Copyright></Copyright>

. ./ParseArgs.sh
parseargs $*
shift $ARGCOUNT
if [ $# -lt 2 ]
then
   echo
   echo "Usage: $0 -U sa-username [-P sa-password] [-h hostname] <database> <new-user-name>"
   echo sa-username is the name of a database administrator
   echo sa-password is the password for the database administrator
   echo hostname is the hostname for the SQLServer server, default value localhost
   echo database is the name of the database to associate the new user with
   echo new-user-name is the new database user to be created
   echo .
   echo "SQLServer will prompt for the adminstrator's password if it is not provided"
   echo
   exit
fi
echo Creating user $2
sqlcmd -e $HOSTNAMEOPTION $USERNAMEOPTION $PASSWORDOPTION -d $1 -i PrepareDatabase.sql -o $2.log -v database=$1 newusername=$2
