#!/bin/sh
# Usage: Usage: PrepareSchema -U username [-P password] [-h hostname] <database> <schemaName>
# <Copyright></Copyright>

. ./ParseArgs.sh
parseargs $*
shift $ARGCOUNT
if [ $# -lt 2 ]
then
   echo
   echo "Usage: $0 -U username [-P password] [-h hostname] <database> <schemaName>"
   echo username is the name of a database user
   echo password is the password for the database user
   echo hostname is the hostname for the SQLServer server, default value localhost
   echo database is the name of the database to associate the new user with
   echo new-user-name is the new database user to be created
   echo .
   echo "SQLServer will prompt for the adminstrator's password if it is not provided"
   echo
   exit
fi

echo Creating schema $2 owned by user $USERNAME
sqlcmd -e $HOSTNAMEOPTION $USERNAMEOPTION $PASSWORDOPTION -d $1 -i PrepareSchema.sql -o $2.log -v schemaName=$2 rgfdbusername=$USERNAME
