@echo off
setlocal
@rem Usage: ReinitDatabase -U username [-P password] -s schemaName
rem  <Copyright></Copyright>

call Parseargs.cmd %*
for /l %%i in (1,1,%ARGCOUNT%) do shift /1
if "%USERNAMEOPTION%"=="" (
   @echo.
   @echo "Usage: %0 -U username [-P password] -s schemaName"
   @echo username is the name of a database user
   @echo password is the password for the database user
   @echo schemaName is the name of the schema
   @echo.
   @echo SQLServer will prompt for the database user's password if it is not provided
   @echo.
   goto :EOF
)
set USERNAME=%USERNAMEOPTION:~3%

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i SetSchema.sql /o ReinitDatabase.log /v schemaName=%SCHEMA% /v rgfdbusername=%USERNAME%

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i DeleteCustomViews.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i DropViews.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i DropCustom.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i DropTables.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i DropSequences.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateTables.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateSequences.sql /o temp.log /v schemaName=%SCHEMA%

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateIndexes.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateAssocIndexes.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateTriggers.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i UpdateStatistics.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateViews.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateCustom.sql /o temp.log /v schemaName=%SCHEMA%

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i CreateCustomViews.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO ON
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i InitDBVersion.sql /o temp.log

@ECHO OFF
type temp.log >> ReinitDatabase.log

@ECHO OFF
sqlcmd %USERNAMEOPTION% %PASSWORDOPTION% /i SetSchema.sql /o temp.log /v schemaName=%USERNAME% /v rgfdbusername=%USERNAME%

@ECHO OFF
type temp.log >> ReinitDatabase.log

del temp.log

endlocal
