#!/bin/sh
# Usage: Usage: UpdateStatistics -U username [-P password] [-h hostname] -s schemaName
# <Copyright></Copyright>

. ./ParseArgs.sh
parseargs $*
shift $ARGCOUNT
if [ -z "$USERNAMEOPTION" ] || [ -z "$SCHEMA" ]
then
   echo
   echo Usage: $0 -U username [-P password] [-h hostname] -s schemaName
   echo username is the name of a database user
   echo password is the password for the database user
   echo hostname is the hostname for the SQLServer server, default value localhost   
   echo schemaName is the name of the schema
   echo
   echo "SQLServer will prompt for the database user's password if it is not provided"
   echo
   exit
fi

sqlcmd $HOSTNAMEOPTION $USERNAMEOPTION $PASSWORDOPTION -i SetSchema.sql -o UpdateStatistics.log -v schemaName=$SCHEMA -v rgfdbusername=$USERNAME

sqlcmd $HOSTNAMEOPTION $USERNAMEOPTION $PASSWORDOPTION -i UpdateStatistics.sql -o temp.log
cat temp.log >> UpdateStatistics.log

sqlcmd $HOSTNAMEOPTION $USERNAMEOPTION $PASSWORDOPTION -i SetSchema.sql -o temp.log -v schemaName=$USERNAME -v rgfdbusername=$USERNAME
cat temp.log >> UpdateStatistics.log

rm temp.log
