/**********************************************************************/
/*  Copyright (c) 2019 by SAS Institute, Inc., Cary, NC, USA.         */
/*  All rights reserved.                                              */
/**********************************************************************/
/*  NAME:        rskmgt_varexist.sas                                  */
/*  VERSION:     7.4                                                  */
/*  DESCRIPTION: Check for the existence of a specified variable.     */
/*  PARAMETERS:  dsn=target table                                     */
/*               var=variable name                                    */
/*               out_var=global macro variable with value=0 or 1      */
/*                       0=does not exist 1=exist                     */
/*  PRODUCT:     SAS Risk Management Server                           */
/**********************************************************************/

%macro rskmgt_varexist(dsn=,
                       var=,
                       out_var=);

%local dsid rc;
%global &out_var;

%let dsid = %sysfunc(open(&dsn));

%if (&dsid) %then %do;
  %if %sysfunc(varnum(&dsid,&var)) %then %let &out_var=1;
  %else %let &out_var=0 ;
  %let rc = %sysfunc(close(&dsid));
%end;
%else %let &out_var=0;

%mend rskmgt_varexist;
