/********************************************************************/
/*  Copyright (c) 2018 by SAS Institute, Inc., Cary, NC, USA.       */
/*  All rights reserved.                                            */
/********************************************************************/
/*  NAME:        rgf_job_load_audit_data.sas                        */
/*  VERSION:     7.4                                                */
/*  DESCRIPTION: Loads all audit data into Visual Analytics for     */
/*               analysis and reporting.                            */
/*  PARAMETERS:                                                     */
/*  PRODUCT:     SAS Risk Governance Framework                      */
/********************************************************************/

%rskmgt;

%macro rgf_job_load_audit_data;

%put NOTE: {START: &sysmacroname};

%global contentId;

%let zz=1;
%let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,)));
%do %while (&contentId ne );
  /* Sets a variable used to hold the &contentId.DB libref */
  %global src_lib;
  %let src_lib=&&&contentId._src_lib; 
  
  /* Load Custom Object Audit Data */
  %rskmgt_job_audit_custobj_data;
  
  /* Load Change Reason Data */
  %rskmgt_job_changereason_data;
  
  /* Load the MRM Model Trend Data */
  %if %upcase(&contentId)=MRM %then
  %do;
    %if %eval(%sysfunc(exist(&contentId.dat.mrm_model_a)) = 1) %then
    %do;
      %if %symexist(&contentId._load_links) %then
      %do;
        %let ModelTrendExist=%substr(&RGF_CUSTOM_PATH,1,(%sysfunc(indexw("&RGF_CUSTOM_PATH",%qscan(%bquote(&RGF_CUSTOM_PATH),-2,'/\'),"/\"))-2))Source/mrm/ucmacros/mrm_job_model_trend_data.sas;
        
        %if (%upcase(&&&contentId._load_links)=YES or %upcase(&&&contentId._load_links)=TRUE) and %sysfunc(fileexist(&ModelTrendExist)) %then
        %do;
          %mrm_job_model_trend_data;
        %end;
      %end;
    %end;    
  %end;
  
  %let zz=%eval(&zz+1);
  %let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,))); 
%end;

%put NOTE: {END: &sysmacroname};

%mend rgf_job_load_audit_data;
%rgf_job_load_audit_data;      