/***************************************************************************/
/*  Copyright (c) 2018 by SAS Institute, Inc., Cary, NC, USA.              */
/*  All rights reserved.                                                   */
/***************************************************************************/
/*  NAME:        rgf_job_reload_audit_data.sas                             */
/*  VERSION:     7.4                                                       */
/*  DESCRIPTION: Reloads all audit data from back into Visual Analytics    */
/*  PARAMETERS:                                                            */
/*  PRODUCT:     SAS Risk Governance Framework                             */
/***************************************************************************/

%rskmgt;

%macro rgf_job_reload_audit_data;

%put NOTE: {START: &sysmacroname};

%global contentId;

%let zz=1;
%let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,)));
%do %while (&contentId ne );
  /* Sets a variable used to hold the &contentId.DB libref */
  %global src_lib;
  %let src_lib=&&&contentId._src_lib; 
  
  /* Reload the Custom Object Audit Tables */
  %rskmgt_reload_custobj_data(intbltype=_A);

  /* Reload the Change_Reason table */
  %global loadETLDataTbls;
  %let loadETLDataTbls=true;
  
  %rskmgt_reload_lasr_data(intblnm=&contentId._change_reason,
                           rls_perm=N);
  
  /* Reload the MRM Model Trend Data */
  %if %upcase(&contentId)=MRM %then
  %do;
    %if %eval(%sysfunc(exist(&contentId.dat.mrm_model_a)) = 1) %then
    %do;
      %if %symexist(&contentId._load_links) %then
      %do;
        %let ModelTrendExist=%substr(&RGF_CUSTOM_PATH,1,(%sysfunc(indexw("&RGF_CUSTOM_PATH",%qscan(%bquote(&RGF_CUSTOM_PATH),-2,'/\'),"/\"))-2))Source/mrm/ucmacros/mrm_job_model_trend_data.sas;
        
        %if (%upcase(&&&contentId._load_links)=YES or %upcase(&&&contentId._load_links)=TRUE) and %sysfunc(fileexist(&ModelTrendExist)) %then
        %do;
          %rskmgt_reload_lasr_data(intblnm=&contentId._model_trend,
                                   rls_perm=N);
        %end;
      %end;
    %end;    
  %end;
  				   
  %let loadETLDataTbls=;  
  
  %let zz=%eval(&zz+1);
  %let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,))); 
%end;
    
%put NOTE: {END: &sysmacroname};

%mend rgf_job_reload_audit_data;
%rgf_job_reload_audit_data;      