/***************************************************************/
/*  Copyright (c) 2018 by SAS Institute, Inc., Cary, NC, USA.  */
/*  All rights reserved.                                       */
/***************************************************************/
/*  NAME:        rgf_job_reload_data.sas                       */
/*  VERSION:     7.4                                           */
/*  DESCRIPTION: Reloads all data back into Visual Analytics   */
/*  PARAMETERS:                                                */
/*  PRODUCT:     SAS Risk Governance Framework                 */
/***************************************************************/

%rskmgt;

%macro rgf_job_reload_data;

%put NOTE: {START: &sysmacroname};

%global contentId;

%let zz=1;
%let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,)));
%do %while (&contentId ne );
  /* Sets a variable used to hold the &contentId.DB libref */
  %global src_lib;
  %let src_lib=&&&contentId._src_lib; 
  
  /* Reload the Custom Object Tables */
  %rskmgt_reload_custobj_data(intbltype=_l);  

  /* If loading LASR tables, also load the &contentId._users_l table. */
  %global loadETLDataTbls;
  %let loadETLDataTbls=;
  
  %if %upcase(&load_lasr)=YES or %upcase(&load_lasr)=TRUE %then %let loadETLDataTbls=TRUE;
  
  /* Reload the Users Table */
  %rskmgt_reload_lasr_data(intblnm=&contentId._users_l,
                           feature=,
                           rls_perm=N); 
  
  %let zz=%eval(&zz+1);
  %let contentId=%trim(%qscan(%bquote(&rgf_content_ids),&zz,%str(,))); 
%end;

%put NOTE: {END: &sysmacroname};

%mend rgf_job_reload_data;
%rgf_job_reload_data;            