jQuery.sap.registerPreloadedModules({
	"version": "2.0",
	"name": "sap.f.library-preload",
	"modules": {
		"sap/f/Avatar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/ui/core/IconPool\"],function(t,e,a,s){\"use strict\";var i=a.extend(\"sap.f.Avatar\",{metadata:{library:\"sap.f\",properties:{src:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},initials:{type:\"string\",group:\"Data\",defaultValue:null},displayShape:{type:\"sap.f.AvatarShape\",group:\"Appearance\",defaultValue:sap.f.AvatarShape.Circle},displaySize:{type:\"sap.f.AvatarSize\",group:\"Appearance\",defaultValue:sap.f.AvatarSize.S},customDisplaySize:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"3rem\"},customFontSize:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"1.125rem\"},imageFitType:{type:\"sap.f.AvatarImageFitType\",group:\"Appearance\",defaultValue:sap.f.AvatarImageFitType.Cover}},aggregations:{detailBox:{type:\"sap.m.LightBox\",multiple:!1,bindable:\"bindable\"}},events:{press:{}}}});return i.DEFAULT_CIRCLE_PLACEHOLDER=\"sap-icon://person-placeholder\",i.DEFAULT_SQUARE_PLACEHOLDER=\"sap-icon://product\",i.prototype.init=function(){this._sActualType=null,this._bIsDefaultIcon=!0},i.prototype.exit=function(){this._icon&&this._icon.destroy(),this._fnLightBoxOpen&&(this._fnLightBoxOpen=null)},i.prototype.setDetailBox=function(t){return t?(this._fnLightBoxOpen=t.open.bind(t),this.attachPress(this._fnLightBoxOpen)):this._fnLightBoxOpen&&(a.prototype.detachEvent.call(this,\"press\",this._fnLightBoxOpen),this._fnLightBoxOpen=null),this.setAggregation(\"detailBox\",t)},i.prototype.attachPress=function(){return Array.prototype.unshift.apply(arguments,[\"press\"]),a.prototype.attachEvent.apply(this,arguments),this.hasListeners(\"press\")&&(this.$().attr(\"tabindex\",\"0\"),this.$().attr(\"role\",\"button\")),this},i.prototype.detachPress=function(){return Array.prototype.unshift.apply(arguments,[\"press\"]),a.prototype.detachEvent.apply(this,arguments),this.hasListeners(\"press\")||(this.$().removeAttr(\"tabindex\"),this.getDecorative()?this.$().attr(\"role\",\"presentation\"):this.$().removeAttr(\"role\")),this},i.prototype.ontap=function(t){this.firePress({})},i.prototype.onkeyup=function(e){e.which!==t.sap.KeyCodes.SPACE&&e.which!==t.sap.KeyCodes.ENTER||(this.firePress({}),e.stopPropagation())},i.prototype._areInitialsValid=function(e){var a=/^[a-zA-Z]{1,2}$/;return!!a.test(e)||(t.sap.log.warning(\"Initials should consist of only 1 or 2 latin letters\",this),this._sActualType=sap.f.AvatarType.Icon,this._bIsDefaultIcon=!0,!1)},i.prototype._validateSrc=function(t){return s.isIconURI(t)?(this._sActualType=sap.f.AvatarType.Icon,this._bIsDefaultIcon=!1):this._sActualType=sap.f.AvatarType.Image,this},i.prototype._getActualDisplayType=function(){var e=this.getSrc(),a=this.getInitials();return e?this._validateSrc(e):a&&this._areInitialsValid(a)?this._sActualType=sap.f.AvatarType.Initials:(t.sap.log.warning(\"No src and initials were provided\",this),this._sActualType=sap.f.AvatarType.Icon,this._bIsDefaultIcon=!0),this._sActualType},i.prototype._getDefaultIconPath=function(t){var e=null;return t===sap.f.AvatarShape.Circle?e=i.DEFAULT_CIRCLE_PLACEHOLDER:t===sap.f.AvatarShape.Square&&(e=i.DEFAULT_SQUARE_PLACEHOLDER),e},i.prototype._getIcon=function(){var t=this.getSrc(),e=this.getDisplayShape();return this._bIsDefaultIcon&&(t=this._getDefaultIconPath(e)),this._icon?this._icon.getSrc()!==t&&this._icon.setSrc(t):this._icon=s.createControlByURI({alt:\"Image placeholder\",src:t}),this._icon},i.prototype.getAccessibilityInfo=function(){var t=this.hasListeners(\"press\");return t?{role:t?\"button\":\"img\",type:sap.ui.getCore().getLibraryResourceBundle(\"sap.f\").getText(t?\"ACC_CTR_TYPE_BUTTON\":\"ACC_CTR_TYPE_IMAGE\"),focusable:t}:null},i},!0);",
		"sap/f/AvatarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";var a={};return a.render=function(a,e){var t=e.getInitials(),s=e._getActualDisplayType(),i=e.getDisplaySize(),r=e.getDisplayShape(),d=e.getImageFitType(),n=e.getCustomDisplaySize(),l=e.getCustomFontSize(),p=e.getSrc(),o=\"sapFAvatar\";a.write(\"<span\"),a.writeControlData(e),a.addClass(o),a.addClass(o+i),a.addClass(o+s),a.addClass(o+r),e.hasListeners(\"press\")&&(a.addClass(\"sapMPointer\"),a.addClass(\"sapFAvatarFocusable\"),a.writeAccessibilityState(e,{role:\"button\"}),a.writeAttribute(\"tabIndex\",0)),s===sap.f.AvatarType.Image&&(a.addClass(o+s+d),a.addStyle(\"background-image\",\"url('\"+jQuery.sap.encodeHTML(p)+\"')\")),i===sap.f.AvatarSize.Custom&&(a.addStyle(\"width\",n),a.addStyle(\"height\",n),a.addStyle(\"font-size\",l)),a.writeClasses(),a.writeStyles(),a.write(\">\"),s===sap.f.AvatarType.Icon?a.renderControl(e._getIcon()):s===sap.f.AvatarType.Initials&&(a.write(\"<span\"),a.addClass(o+\"InitialsHolder\"),a.writeClasses(),a.write(\">\"),a.writeEscaped(t),a.write(\"</span>\")),e._fnLightBoxOpen&&a.write('<span class=\"sapFAvatarMagnifyingGlass\"></span>'),a.write(\"</span>\")},a},!0);",
		"sap/f/DynamicPage.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/ui/core/ScrollBar\",\"sap/ui/core/ResizeHandler\",\"sap/ui/core/delegate/ScrollEnablement\",\"sap/ui/Device\"],function(e,t,i,r,n,o,a){\"use strict\";function s(e){return 1===arguments.length?e&&\"length\"in e?e.length>0:!!e:Array.prototype.slice.call(arguments).every(function(e){return s(e)})}var l=i.extend(\"sap.f.DynamicPage\",{metadata:{library:\"sap.f\",properties:{preserveHeaderStateOnScroll:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},headerExpanded:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},toggleHeaderOnTitleClick:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},showFooter:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},fitContent:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},aggregations:{title:{type:\"sap.f.DynamicPageTitle\",multiple:!1},header:{type:\"sap.f.DynamicPageHeader\",multiple:!1},content:{type:\"sap.ui.core.Control\",multiple:!1},footer:{type:\"sap.m.IBar\",multiple:!1},_scrollBar:{type:\"sap.ui.core.ScrollBar\",multiple:!1,visibility:\"hidden\"}}}}),h=sap.ui.getCore().getConfiguration().getAnimation();return l.HEADER_MAX_ALLOWED_PINNED_PERCENTAGE=.6,l.HEADER_MAX_ALLOWED_NON_SROLLABLE_PERCENTAGE=.6,l.FOOTER_ANIMATION_DURATION=350,l.BREAK_POINTS={TABLET:1024,PHONE:600},l.EVENTS={TITLE_PRESS:\"_titlePress\",PIN_UNPIN_PRESS:\"_pinUnpinPress\"},l.MEDIA={INVISIBLE:\"sapUiHidden\",PHONE:\"sapFDynamicPage-Std-Phone\",TABLET:\"sapFDynamicPage-Std-Tablet\",DESKTOP:\"sapFDynamicPage-Std-Desktop\"},l.RESIZE_HANDLER_ID={PAGE:\"_sResizeHandlerId\",TITLE:\"_sTitleResizeHandlerId\",CONTENT:\"_sContentResizeHandlerId\"},l.prototype.init=function(){this._bPinned=!1,this._bHeaderInTitleArea=!1,this._bExpandingWithAClick=!1,this._bSuppressToggleHeaderOnce=!1,this._headerBiggerThanAllowedHeight=!1,this._bMSBrowser=a.browser.internet_explorer||a.browser.edge||!1,this._oScrollHelper=new o(this,this.getId()+\"-content\",{horizontal:!1,vertical:!0})},l.prototype.onBeforeRendering=function(){this._preserveHeaderStateOnScroll()||this._attachPinPressHandler(),this._attachTitlePressHandler(),this._detachScrollHandler()},l.prototype.onAfterRendering=function(){var t;this._preserveHeaderStateOnScroll()&&e.sap.delayedCall(0,this,this._overridePreserveHeaderStateOnScroll),this._bPinned=!1,this._cacheDomElements(),this._detachResizeHandlers(),this._attachResizeHandlers(),this._updateMedia(this._getWidth(this)),this._attachScrollHandler(),this._updateScrollBar(),this._attachPageChildrenAfterRenderingDelegates(),this._resetPinButtonState(),this.getHeaderExpanded()||(this._snapHeader(!1),t=this.getHeader()&&!this.getPreserveHeaderStateOnScroll()&&this._canSnapHeaderOnScroll(),t?this._setScrollPosition(this._getSnappingHeight()):(this._toggleHeaderVisibility(!1),this._moveHeaderToTitleArea()))},l.prototype.exit=function(){this._detachResizeHandlers(),this._oScrollHelper&&this._oScrollHelper.destroy()},l.prototype.setShowFooter=function(e){var t=this.setProperty(\"showFooter\",e,!0);return this._toggleFooter(e),t},l.prototype.setHeaderExpanded=function(e){return this._bPinned?this:this.getHeaderExpanded()===e?this:(this.getDomRef()&&this._titleExpandCollapseWhenAllowed(),this.setProperty(\"headerExpanded\",e,!0),this)},l.prototype.setToggleHeaderOnTitleClick=function(e){var t=this.setProperty(\"toggleHeaderOnTitleClick\",e,!0);return this.$().toggleClass(\"sapFDynamicPageTitleClickEnabled\",e),t},l.prototype.setFitContent=function(e){var t=this.setProperty(\"fitContent\",e,!0);return s(this.$())&&this._updateFitContainer(),t},l.prototype.getScrollDelegate=function(){return this._oScrollHelper},l.prototype._overridePreserveHeaderStateOnScroll=function(){return this._shouldOverridePreserveHeaderStateOnScroll()?(this._headerBiggerThanAllowedHeight=!0,this.getHeaderExpanded()?this._moveHeaderToContentArea(!0):this._adjustSnap(),void this._updateScrollBar()):void(this._headerBiggerThanAllowedHeight=!1)},l.prototype._shouldOverridePreserveHeaderStateOnScroll=function(){return!a.system.desktop&&this._headerBiggerThanAllowedToBeFixed()&&this._preserveHeaderStateOnScroll()},l.prototype._toggleFooter=function(t){var i=this.getFooter();s(this.$())&&s(i)&&(i.toggleStyleClass(\"sapFDynamicPageActualFooterControlShow\",t),i.toggleStyleClass(\"sapFDynamicPageActualFooterControlHide\",!t),this._toggleFooterSpacer(t),h&&(t?this.$footerWrapper.toggleClass(\"sapUiHidden\",!this.getShowFooter()):e.sap.delayedCall(l.FOOTER_ANIMATION_DURATION,this,function(){this.$footerWrapper.toggleClass(\"sapUiHidden\",!this.getShowFooter())}),e.sap.delayedCall(l.FOOTER_ANIMATION_DURATION,this,function(){i.removeStyleClass(\"sapFDynamicPageActualFooterControlShow\")})),this._updateScrollBar())},l.prototype._toggleFooterSpacer=function(e){var t=this.$(\"spacer\");s(t)&&t.toggleClass(\"sapFDynamicPageContentWrapperSpacer\",e),s(this.$contentFitContainer)&&this.$contentFitContainer.toggleClass(\"sapFDynamicPageContentFitContainerFooterVisible\",e)},l.prototype._snapHeader=function(t){var i=this.getTitle();return this._bPinned?void e.sap.log.debug(\"DynamicPage :: aborted snapping, header is pinned\",this):(e.sap.log.debug(\"DynamicPage :: snapped header\",this),s(i)&&(s(i.getExpandedContent())&&i._setShowExpandContent(!1),s(i.getSnappedContent())&&i._setShowSnapContent(!0),t&&this._bHeaderInTitleArea&&this._moveHeaderToContentArea(!0)),s(this.$titleArea)?(this.setProperty(\"headerExpanded\",!1,!0),void this.$titleArea.addClass(\"sapFDynamicPageTitleSnapped\")):void e.sap.log.warning(\"DynamicPage :: couldn't snap header. There's no title.\",this))},l.prototype._expandHeader=function(t){var i=this.getTitle();return e.sap.log.debug(\"DynamicPage :: expand header\",this),s(i)&&(s(i.getExpandedContent())&&i._setShowExpandContent(!0),s(i.getSnappedContent())&&i._setShowSnapContent(!1),t&&this._moveHeaderToTitleArea(!0)),s(this.$titleArea)?(this.setProperty(\"headerExpanded\",!0,!0),void this.$titleArea.removeClass(\"sapFDynamicPageTitleSnapped\")):void e.sap.log.warning(\"DynamicPage :: couldn't expand header. There's no title.\",this)},l.prototype._toggleHeaderVisibility=function(t){var i=this.getHeaderExpanded(),r=this.getTitle(),n=this.getHeader();return this._bPinned?void e.sap.log.debug(\"DynamicPage :: header toggle aborted, header is pinned\",this):(s(r)&&(r._setShowExpandContent(i),r._setShowSnapContent(!i)),void(s(n)&&(n.$().toggleClass(\"sapFDynamicPageHeaderHidden\",!t),this._updateScrollBar())))},l.prototype._moveHeaderToContentArea=function(e){var t=this.getHeader();s(t)&&(t.$().prependTo(this.$wrapper),this._bHeaderInTitleArea=!1,e&&this._offsetContentOnMoveHeader())},l.prototype._moveHeaderToTitleArea=function(e){var t=this.getHeader();s(t)&&(t.$().appendTo(this.$titleArea),this._bHeaderInTitleArea=!0,e&&this._offsetContentOnMoveHeader())},l.prototype._offsetContentOnMoveHeader=function(){var e,t=this.getHeader().$().outerHeight(),i=Math.ceil(this._getScrollPosition());t&&(e=this._bHeaderInTitleArea?i-t:i+t,e=Math.max(e,0),this._setScrollPosition(e,!0))},l.prototype._pin=function(){this._bPinned||(this._bPinned=!0,this._bHeaderInTitleArea||(this._moveHeaderToTitleArea(!0),this._updateScrollBar()),this._togglePinButtonARIAState(this._bPinned))},l.prototype._unPin=function(){this._bPinned&&(this._bPinned=!1,this._togglePinButtonARIAState(this._bPinned))},l.prototype._togglePinButtonVisibility=function(e){var t=this.getHeader();s(t)&&t._setShowPinBtn(e)},l.prototype._togglePinButtonPressedState=function(e){var t=this.getHeader();s(t)&&t._togglePinButton(e)},l.prototype._togglePinButtonARIAState=function(e){var t=this.getHeader();s(t)&&t._updateARIAPinButtonState(e)},l.prototype._resetPinButtonState=function(){this._preserveHeaderStateOnScroll()?this._togglePinButtonVisibility(!1):(this._togglePinButtonPressedState(!1),this._togglePinButtonARIAState(!1))},l.prototype._restorePinButtonFocus=function(){this.getHeader()._focusPinButton()},l.prototype._getScrollPosition=function(){return this.getScrollDelegate().getScrollTop()},l.prototype._setScrollPosition=function(e,t){s(this.$wrapper)&&this._getScrollPosition()!==e&&(t&&(this._bSuppressToggleHeaderOnce=!0),this.getScrollDelegate()._$Container||(this.getScrollDelegate()._$Container=this.$wrapper),this.getScrollDelegate().scrollTo(0,e))},l.prototype._shouldSnap=function(){return!this._preserveHeaderStateOnScroll()&&this._getScrollPosition()>=this._getSnappingHeight()&&this.getHeaderExpanded()&&!this._bPinned},l.prototype._shouldExpand=function(){return!this._preserveHeaderStateOnScroll()&&this._getScrollPosition()<this._getSnappingHeight()&&!this.getHeaderExpanded()&&!this._bPinned},l.prototype._headerScrolledOut=function(){return this._getScrollPosition()>=this._getSnappingHeight()},l.prototype._headerSnapAllowed=function(){return!this._preserveHeaderStateOnScroll()&&this.getHeaderExpanded()&&!this._bPinned},l.prototype._canSnapHeaderOnScroll=function(){var e=this._getMaxScrollPosition(),t=this._bMSBrowser?1:0;return this._bHeaderInTitleArea&&(e+=this._getHeaderHeight(),e-=t),e>this._getSnappingHeight()},l.prototype._getSnappingHeight=function(){return this._getHeaderHeight()||this._getTitleHeight()},l.prototype._getMaxScrollPosition=function(){var e;return s(this.$wrapper)?(e=this.$wrapper[0],e.scrollHeight-e.clientHeight):0},l.prototype._needsVerticalScrollBar=function(){var e=this._bMSBrowser?1:0;return this._getMaxScrollPosition()>e},l.prototype._getOwnHeight=function(){return this._getHeight(this)},l.prototype._getEntireHeaderHeight=function(){var e=0,t=0,i=this.getTitle(),r=this.getHeader();return s(i)&&(e=i.$().outerHeight()),s(r)&&(t=r.$().outerHeight()),e+t},l.prototype._headerBiggerThanAllowedToPin=function(e){return(\"number\"!=typeof e||isNaN(parseInt(e,10)))&&(e=this._getOwnHeight()),this._getEntireHeaderHeight()>l.HEADER_MAX_ALLOWED_PINNED_PERCENTAGE*e},l.prototype._headerBiggerThanAllowedToBeFixed=function(){var e=this._getOwnHeight();return this._getEntireHeaderHeight()>l.HEADER_MAX_ALLOWED_NON_SROLLABLE_PERCENTAGE*e},l.prototype._measureScrollBarOffsetHeight=function(){var t=0,i=!this.getHeaderExpanded(),r=this._bHeaderInTitleArea;return this._preserveHeaderStateOnScroll()||this._bPinned||!i&&this._bHeaderInTitleArea?(t=this._getTitleAreaHeight(),e.sap.log.debug(\"DynamicPage :: preserveHeaderState is enabled or header pinned :: title area height\"+t,this),t):!i&&s(this.getTitle())&&this._canSnapHeaderOnScroll()?(this._snapHeader(!0),t=this._getTitleHeight(),i||this._expandHeader(r),e.sap.log.debug(\"DynamicPage :: snapped mode :: title height \"+t,this),t):(t=this._getTitleHeight(),e.sap.log.debug(\"DynamicPage :: header snapped :: title height \"+t,this),t)},l.prototype._updateScrollBar=function(){var t,i,r;a.system.desktop&&s(this.$wrapper)&&(t=this._getScrollBar(),t.setContentSize(this._measureScrollBarOffsetHeight()+this.$wrapper[0].scrollHeight+\"px\"),i=this._needsVerticalScrollBar(),r=this.bHasScrollbar!==i,r&&(t.toggleStyleClass(\"sapUiHidden\",!i),this.toggleStyleClass(\"sapFDynamicPageWithScroll\",i),this.bHasScrollbar=i,e.sap.delayedCall(0,this,this._updateFitContainer)),e.sap.delayedCall(0,this,this._updateScrollBarOffset))},l.prototype._updateFitContainer=function(e){var t=\"undefined\"!=typeof e?!e:!this._needsVerticalScrollBar(),i=this.getFitContent(),r=i||t;this.$contentFitContainer.toggleClass(\"sapFDynamicPageContentFitContainer\",r)},l.prototype._updateScrollBarOffset=function(){var t=sap.ui.getCore().getConfiguration().getRTL()?\"left\":\"right\",i=this._needsVerticalScrollBar()?e.sap.scrollbarSize().width+\"px\":0,r=this.getFooter();this.$titleArea.css(\"padding-\"+t,i),s(r)&&r.$().css(t,i)},l.prototype._updateHeaderARIAState=function(e){var t=this.getHeader();s(t)&&t._updateARIAState(e)},l.prototype._updateMedia=function(e){0===e?this._updateMediaStyle(l.MEDIA.INVISIBLE):e<=l.BREAK_POINTS.PHONE?this._updateMediaStyle(l.MEDIA.PHONE):e<=l.BREAK_POINTS.TABLET?this._updateMediaStyle(l.MEDIA.TABLET):this._updateMediaStyle(l.MEDIA.DESKTOP)},l.prototype._updateMediaStyle=function(e){Object.keys(l.MEDIA).forEach(function(t){var i=e===l.MEDIA[t];this.toggleStyleClass(l.MEDIA[t],i)},this)},l.prototype._getHeight=function(e){return e instanceof i?e.$().outerHeight()||0:0},l.prototype._getWidth=function(e){return e instanceof i?e.$().outerWidth()||0:0},l.prototype._getTitleAreaHeight=function(){return s(this.$titleArea)?this.$titleArea.outerHeight()||0:0},l.prototype._getTitleHeight=function(){return this._getHeight(this.getTitle())},l.prototype._getHeaderHeight=function(){return this._getHeight(this.getHeader())},l.prototype._preserveHeaderStateOnScroll=function(){return this.getPreserveHeaderStateOnScroll()&&!this._headerBiggerThanAllowedHeight},l.prototype._getScrollBar=function(){if(!s(this.getAggregation(\"_scrollBar\"))){var e=new r(this.getId()+\"-vertSB\",{vertical:!0,size:\"100%\",scrollPosition:0,scroll:this._onScrollBarScroll.bind(this)});this.setAggregation(\"_scrollBar\",e,!0)}return this.getAggregation(\"_scrollBar\")},l.prototype._cacheDomElements=function(){var e=this.getFooter();s(e)&&(this.$footer=e.$(),this.$footerWrapper=this.$(\"footerWrapper\")),this.$wrapper=this.$(\"contentWrapper\"),this.$contentFitContainer=this.$(\"contentFitContainer\"),this.$titleArea=this.$(\"header\"),this._cacheTitleDom()},l.prototype._cacheTitleDom=function(){var e=this.getTitle();s(e)&&(this.$title=e.$())},l.prototype._adjustSnap=function(){var e,t,i=this.getHeader(),r=!this.getHeaderExpanded();i&&r&&(e=!this._preserveHeaderStateOnScroll()&&this._canSnapHeaderOnScroll(),t=r&&i.$().hasClass(\"sapFDynamicPageHeaderHidden\"),e&&t?(this._toggleHeaderVisibility(!0),this._moveHeaderToContentArea(!0)):e||t||(this._moveHeaderToTitleArea(!0),this._toggleHeaderVisibility(!1)))},l.prototype.ontouchmove=function(e){e.setMarked()},l.prototype._onChildControlAfterRendering=function(t){t.srcControl instanceof sap.f.DynamicPageTitle&&(this._cacheTitleDom(),this._deRegisterResizeHandler(l.RESIZE_HANDLER_ID.TITLE),this._registerResizeHandler(l.RESIZE_HANDLER_ID.TITLE,this.$title[0],this._onChildControlsHeightChange.bind(this))),e.sap.delayedCall(0,this,this._updateScrollBar)},l.prototype._onChildControlsHeightChange=function(e){var t=this._needsVerticalScrollBar();t&&this._updateFitContainer(t),this._adjustSnap(),this._bExpandingWithAClick||this._updateScrollBar(),this._bExpandingWithAClick=!1},l.prototype._onResize=function(e){var t=this.getHeader();!this._preserveHeaderStateOnScroll()&&t&&(this._headerBiggerThanAllowedToPin(e.size.height)||a.system.phone?(this._unPin(),this._togglePinButtonVisibility(!1),this._togglePinButtonPressedState(!1)):this._togglePinButtonVisibility(!0)),this._adjustSnap(),this._updateScrollBar(),this._updateMedia(e.size.width)},l.prototype._onWrapperScroll=function(e){var t=Math.max(e.target.scrollTop,0);if(a.system.desktop){if(this.allowCustomScroll===!0)return void(this.allowCustomScroll=!1);this.allowInnerDiv=!0,this._getScrollBar().setScrollPosition(t),this.toggleStyleClass(\"sapFDynamicPageWithScroll\",this._needsVerticalScrollBar())}},l.prototype._toggleHeaderOnScroll=function(){if(this._bSuppressToggleHeaderOnce)return void(this._bSuppressToggleHeaderOnce=!1);if(!(a.system.desktop&&this._bExpandingWithAClick||this._preserveHeaderStateOnScroll()))if(this._shouldSnap())this._snapHeader(!0),this._updateHeaderARIAState(!1);else if(this._shouldExpand())this._expandHeader(),this._toggleHeaderVisibility(!0),this._updateHeaderARIAState(!0);else if(!this._bPinned&&this._bHeaderInTitleArea){var e=this._getScrollPosition()>=this._getSnappingHeight();this._moveHeaderToContentArea(e)}},l.prototype._onScrollBarScroll=function(){return this.allowInnerDiv===!0?void(this.allowInnerDiv=!1):(this.allowCustomScroll=!0,void this._setScrollPosition(this._getScrollBar().getScrollPosition()))},l.prototype._onTitlePress=function(){this.getToggleHeaderOnTitleClick()&&this._titleExpandCollapseWhenAllowed()},l.prototype._titleExpandCollapseWhenAllowed=function(){if(this._bPinned)return this;if(!this._preserveHeaderStateOnScroll()&&this._canSnapHeaderOnScroll()&&this.getHeader())if(this.getHeaderExpanded()){var e=this._bHeaderInTitleArea;this._snapHeader(e),e||this._setScrollPosition(this._getSnappingHeight())}else this._bExpandingWithAClick=!0,this._expandHeader(!0),this._bExpandingWithAClick=!1;else this.getHeaderExpanded()?(this._snapHeader(!1),this._toggleHeaderVisibility(!1)):(this._expandHeader(!1),this._toggleHeaderVisibility(!0))},l.prototype._onPinUnpinButtonPress=function(e){this._bPinned?this._unPin(e):(this._pin(e),this._restorePinButtonFocus())},l.prototype._attachResizeHandlers=function(){var e=this._onChildControlsHeightChange.bind(this);this._registerResizeHandler(l.RESIZE_HANDLER_ID.PAGE,this,this._onResize.bind(this)),s(this.$title)&&this._registerResizeHandler(l.RESIZE_HANDLER_ID.TITLE,this.$title[0],e),s(this.$contentFitContainer)&&this._registerResizeHandler(l.RESIZE_HANDLER_ID.CONTENT,this.$contentFitContainer[0],e)},l.prototype._registerResizeHandler=function(e,t,i){this[e]||(this[e]=n.register(t,i))},l.prototype._detachResizeHandlers=function(){this._deRegisterResizeHandler(l.RESIZE_HANDLER_ID.PAGE),this._deRegisterResizeHandler(l.RESIZE_HANDLER_ID.TITLE),this._deRegisterResizeHandler(l.RESIZE_HANDLER_ID.CONTENT)},l.prototype._deRegisterResizeHandler=function(e){this[e]&&(n.deregister(this[e]),this[e]=null)},l.prototype._attachPageChildrenAfterRenderingDelegates=function(){var e=this.getTitle(),t=this.getContent(),i={onAfterRendering:this._onChildControlAfterRendering.bind(this)};s(e)&&e.addEventDelegate(i),s(t)&&t.addEventDelegate(i)},l.prototype._attachTitlePressHandler=function(){var e=this.getTitle();s(e)&&!this._bAlreadyAttachedTitlePressHandler&&(e.attachEvent(l.EVENTS.TITLE_PRESS,this._onTitlePress,this),this._bAlreadyAttachedTitlePressHandler=!0)},l.prototype._attachPinPressHandler=function(){var e=this.getHeader();s(e)&&!this._bAlreadyAttachedPinPressHandler&&(e.attachEvent(l.EVENTS.PIN_UNPIN_PRESS,this._onPinUnpinButtonPress,this),this._bAlreadyAttachedPinPressHandler=!0)},l.prototype._attachScrollHandler=function(){this.$wrapper.on(\"scroll\",this._onWrapperScroll.bind(this)),this.$wrapper.on(\"scroll\",this._toggleHeaderOnScroll.bind(this))},l.prototype._detachScrollHandler=function(){this.$wrapper&&this.$wrapper.unbind(\"scroll\")},l},!0);",
		"sap/f/DynamicPageHeader.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/ui/core/InvisibleText\",\"sap/m/ButtonType\",\"sap/m/ToggleButton\"],function(t,e,n,i,A,o){\"use strict\";var r=n.extend(\"sap.f.DynamicPageHeader\",{metadata:{library:\"sap.f\",properties:{pinnable:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0},_pinButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"}}}});return r._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle(\"sap.f\")},r.ARIA={ARIA_CONTROLS:\"aria-controls\",ARIA_EXPANDED:\"aria-expanded\",ARIA_LABEL:\"aria-label\",LABEL_EXPANDED:r._getResourceBundle().getText(\"EXPANDED_HEADER\"),LABEL_SNAPPED:r._getResourceBundle().getText(\"SNAPPED_HEADER\"),LABEL_PINNED:r._getResourceBundle().getText(\"PIN_HEADER\"),LABEL_UNPINNED:r._getResourceBundle().getText(\"UNPIN_HEADER\"),STATE_TRUE:\"true\",STATE_FALSE:\"false\"},r.prototype.onAfterRendering=function(){this._initARIAState(),this._initPinButtonARIAState()},r.prototype._togglePinButton=function(t){this._getPinButton().setPressed(t)},r.prototype._setShowPinBtn=function(t){this._getPinButton().$().toggleClass(\"sapUiHidden\",!t)},r.prototype._pinUnpinFireEvent=function(){this.fireEvent(\"_pinUnpinPress\")},r.prototype._initARIAState=function(){var t=this.$();t.attr(r.ARIA.ARIA_EXPANDED,r.ARIA.STATE_TRUE),t.attr(r.ARIA.ARIA_LABEL,r.ARIA.LABEL_EXPANDED)},r.prototype._initPinButtonARIAState=function(){var t;this.getPinnable()&&(t=this._getPinButtonJQueryRef(),t.attr(r.ARIA.ARIA_CONTROLS,this.getId()))},r.prototype._updateARIAState=function(t){var e=this.$();t?(e.attr(r.ARIA.ARIA_EXPANDED,r.ARIA.STATE_TRUE),e.attr(r.ARIA.ARIA_LABEL,r.ARIA.LABEL_EXPANDED)):(e.attr(r.ARIA.ARIA_EXPANDED,r.ARIA.STATE_FALSE),e.attr(r.ARIA.ARIA_LABEL,r.ARIA.LABEL_SNAPPED))},r.prototype._updateARIAPinButtonState=function(t){var e=this._getPinButton();t?e.setTooltip(r.ARIA.LABEL_UNPINNED):e.setTooltip(r.ARIA.LABEL_PINNED)},r.prototype._getPinButton=function(){if(!this.getAggregation(\"_pinButton\")){var t=new o({id:this.getId()+\"-pinBtn\",icon:\"sap-icon://pushpin-off\",tooltip:r.ARIA.LABEL_PINNED,type:A.Transparent,press:this._pinUnpinFireEvent.bind(this)});this.setAggregation(\"_pinButton\",t,!0)}return this.getAggregation(\"_pinButton\")},r.prototype._focusPinButton=function(){this._getPinButtonJQueryRef().focus()},r.prototype._getPinButtonJQueryRef=function(){return this._getPinButton().$()},r},!1);",
		"sap/f/DynamicPageHeaderRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";var e={};return e.render=function(a,r){var n=r.getContent(),t=n.length>0,i=sap.ui.Device.system.phone,s=r.getPinnable()&&t&&!i;a.write(\"<header\"),a.writeControlData(r),a.writeAccessibilityState({role:\"region\"}),a.addClass(\"sapContrastPlus\"),a.addClass(\"sapFDynamicPageHeader\"),t&&a.addClass(\"sapFDynamicPageHeaderWithContent\"),s&&a.addClass(\"sapFDynamicPageHeaderPinnable\"),a.writeClasses(),a.write(\">\"),t&&(a.write(\"<div\"),a.addClass(\"sapFDynamicPageHeaderContent\"),a.writeClasses(),a.write(\">\"),n.forEach(a.renderControl),a.write(\"</div>\"),s&&e._renderPinUnpinArea(r,a)),a.write(\"</header>\")},e._renderPinUnpinArea=function(e,a){a.write(\"<div\"),a.addClass(\"sapFDynamicPageHeaderPinButtonArea\"),a.writeClasses(),a.write(\">\"),a.renderControl(e._getPinButton()),a.write(\"</div>\")},e},!0);",
		"sap/f/DynamicPageRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/Device\"],function(e){\"use strict\";var t={};return t.render=function(r,a){var i=a.getTitle(),s=a.getHeader(),d=a.getFooter(),n=a.getContent(),o=a.getHeaderExpanded(),l=s?s.getContent():[],C=l.length>0,p=a.getShowFooter(),c=a._preserveHeaderStateOnScroll();r.write(\"<article\"),r.writeControlData(a),r.addClass(\"sapFDynamicPage\"),a.getToggleHeaderOnTitleClick()&&r.addClass(\"sapFDynamicPageTitleClickEnabled\"),r.writeClasses(),r.write(\">\"),e.system.desktop&&r.renderControl(a._getScrollBar().addStyleClass(\"sapFDynamicPageScrollBar\")),r.write(\"<header\"),r.writeAttributeEscaped(\"id\",a.getId()+\"-header\"),r.addClass(\"sapContrastPlus\"),r.addClass(\"sapFDynamicPageTitleWrapper\"),o||r.addClass(\"sapFDynamicPageTitleSnapped\"),C||r.addClass(\"sapFDynamicPageTitleOnly\"),r.writeClasses(),r.write(\">\"),r.renderControl(i),c&&r.renderControl(s),r.write(\"</header>\"),r.write(\"<div\"),r.writeAttributeEscaped(\"id\",a.getId()+\"-contentWrapper\"),r.addClass(\"sapFDynamicPageContentWrapper\"),r.writeClasses(),r.write(\">\"),c||r.renderControl(s),r.write(\"<div\"),r.writeAttributeEscaped(\"id\",a.getId()+\"-content\"),r.addClass(\"sapFDynamicPageContent\"),r.writeClasses(),r.write(\">\"),r.write(\"<div\"),r.writeAttributeEscaped(\"id\",a.getId()+\"-contentFitContainer\"),a.getFitContent()&&r.addClass(\"sapFDynamicPageContentFitContainer\"),d&&p&&r.addClass(\"sapFDynamicPageContentFitContainerFooterVisible\"),r.writeClasses(),r.write(\">\"),r.renderControl(n),t.renderFooterSpacer(r,a,d,p),r.write(\"</div>\"),r.write(\"</div>\"),r.write(\"</div>\"),t.renderFooter(r,a,d,p),r.write(\"</article>\")},t.renderFooter=function(e,t,r,a){r&&(e.write(\"<footer\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-footerWrapper\"),e.addClass(\"sapContrast sapContrastPlus sapFDynamicPageFooter sapFFooter-CTX\"),a||e.addClass(\"sapUiHidden\"),e.writeClasses(),e.write(\">\"),r.addStyleClass(\"sapFDynamicPageActualFooterControl\"),e.renderControl(r),e.write(\"</footer>\"))},t.renderFooterSpacer=function(e,t,r,a){r&&(e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-spacer\"),a&&e.addClass(\"sapFDynamicPageContentWrapperSpacer\"),e.writeClasses(),e.write(\">\"),e.write(\"</div>\"))},t},!0);",
		"sap/f/DynamicPageTitle.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/m/OverflowToolbar\"],function(t,e,o,n){\"use strict\";function i(t){return\"function\"==typeof t}var r=o.extend(\"sap.f.DynamicPageTitle\",{metadata:{library:\"sap.f\",aggregations:{heading:{type:\"sap.ui.core.Control\",multiple:!1,defaultValue:null},actions:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"action\"},snappedContent:{type:\"sap.ui.core.Control\",multiple:!0},expandedContent:{type:\"sap.ui.core.Control\",multiple:!0},_overflowToolbar:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"}}}});return r.prototype.init=function(){this._bShowSnappedContent=!1,this._bShowExpandContent=!0,this._fnActionSubstituteParentFunction=function(){return this}.bind(this),this._oRB=sap.ui.getCore().getLibraryResourceBundle(\"sap.f\")},r.prototype.onBeforeRendering=function(){this._getOverflowToolbar()},r.prototype.onAfterRendering=function(){this._cacheDomElements(),this._setShowSnapContent(this._getShowSnapContent()),this._setShowExpandContent(this._getShowExpandContent())},r.prototype.ontap=function(t){t.srcControl!==this&&this.getAggregation(\"_overflowToolbar\")!==t.srcControl||this.fireEvent(\"_titlePress\")},r.prototype.onsapspace=function(t){this.onsapenter(t)},r.prototype.onsapenter=function(t){t.srcControl===this&&this.fireEvent(\"_titlePress\")},r.prototype._cacheDomElements=function(){this.$snappedWrapper=this.$(\"snapped-wrapper\"),this.$expandWrapper=this.$(\"expand-wrapper\")},r.prototype._getOverflowToolbar=function(){return this.getAggregation(\"_overflowToolbar\")||this.setAggregation(\"_overflowToolbar\",new n({id:this.getId()+\"-overflowToolbar\"}).addStyleClass(\"sapFDynamicPageTitleOverflowToolbar\"),!0),this.getAggregation(\"_overflowToolbar\")},r.prototype._preProcessAction=function(t){i(t._fnOriginalGetParent)||(t._fnOriginalGetParent=t.getParent,t.getParent=this._fnActionSubstituteParentFunction)},r.prototype._postProcessAction=function(t){i(t._fnOriginalGetParent)&&(t.getParent=t._fnOriginalGetParent)},[\"addAction\",\"insertAction\",\"removeAction\",\"indexOfAction\",\"removeAllActions\",\"destroyActions\",\"getActions\"].forEach(function(t){r.prototype[t]=function(e){var o=this._getOverflowToolbar(),n=t.replace(/Actions?/,\"Content\");return\"addAction\"===t||\"insertAction\"===t?(o[n].apply(o,arguments),this._preProcessAction(e),this):(\"removeAction\"===t?this._postProcessAction(e):\"removeAllActions\"!==t&&\"destroyActions\"!==t||this.getActions().forEach(this._postProcessAction,this),o[n].apply(o,arguments))}}),r.prototype._setShowSnapContent=function(t){this._bShowSnappedContent=t,this.$snappedWrapper.toggleClass(\"sapUiHidden\",!t),this.$snappedWrapper.parent().toggleClass(\"sapFDynamicPageSnapContentVisible\",t)},r.prototype._getShowSnapContent=function(){return this._bShowSnappedContent},r.prototype._setShowExpandContent=function(t){this._bShowExpandContent=t,this.$expandWrapper.toggleClass(\"sapUiHidden\",!t),this.$snappedWrapper.parent().toggleClass(\"sapFDynamicPageExpandContentVisible\",t)},r.prototype._getShowExpandContent=function(){return this._bShowExpandContent},r},!1);",
		"sap/f/DynamicPageTitleRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";var e={};return e.render=function(t,i){var a=i._getOverflowToolbar(),r=i.getHeading(),n=i.getSnappedContent(),d=i.getExpandedContent(),s=i.getId(),w=i._oRB.getText(\"TOGGLE_HEADER\");t.write(\"<div\"),t.writeAttribute(\"tabindex\",0),t.writeControlData(i),t.writeAccessibilityState({role:\"heading\",level:2}),t.addClass(\"sapFDynamicPageTitle\"),t.writeClasses(),t.write(\">\"),t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleLeft\"),t.writeClasses(),t.write(\">\"),t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleLeftInner\"),t.writeClasses(),t.write(\">\"),t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleLeftHeading\"),t.writeClasses(),t.write(\">\"),t.renderControl(r),t.write(\"</div>\"),(n.length>0||d.length>0)&&(t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleLeftSnappedExpandContent\"),t.writeClasses(),t.write(\">\"),e._renderSnappedContent(t,i,n),e._renderExpandContent(t,i,d),t.write(\"</div>\")),t.write(\"</div>\"),t.write(\"</div>\"),t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleRight\"),t.writeClasses(),t.write(\">\"),t.write(\"<div\"),t.addClass(\"sapFDynamicPageTitleRightActions\"),t.writeClasses(),t.write(\">\"),a.getContent().length>0&&t.renderControl(a),t.write(\"</div>\"),t.write(\"</div>\"),t.write('<span id=\"'+s+'-Descr\" class=\"sapUiInvisibleText\">'+w+\"</span>\"),t.write(\"</div>\")},e._renderExpandContent=function(e,t,i){i.length>0&&(e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-expand-wrapper\"),e.writeClasses(),e.write(\">\"),i.forEach(e.renderControl),e.write(\"</div>\"))},e._renderSnappedContent=function(e,t,i){i.length>0&&(e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-snapped-wrapper\"),t._getShowSnapContent()||e.addClass(\"sapUiHidden\"),e.addClass(\"sapFDynamicPageTitleSnapped\"),e.writeClasses(),e.write(\">\"),i.forEach(e.renderControl),e.write(\"</div>\"))},e},!0);",
		"sap/f/FlexibleColumnLayout.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"./LayoutType\",\"sap/ui/Device\",\"sap/ui/core/ResizeHandler\",\"sap/ui/core/Control\",\"sap/ui/core/InvisibleText\",\"sap/m/Button\",\"sap/m/NavContainer\"],function(t,e,n,o,i,a,s,r,u){\"use strict\";function l(){this._aLayoutHistory=[]}var d=a.extend(\"sap.f.FlexibleColumnLayout\",{metadata:{properties:{layout:{type:\"sap.f.LayoutType\",defaultValue:sap.f.LayoutType.OneColumn},defaultTransitionNameBeginColumn:{type:\"string\",group:\"Appearance\",defaultValue:\"slide\"},defaultTransitionNameMidColumn:{type:\"string\",group:\"Appearance\",defaultValue:\"slide\"},defaultTransitionNameEndColumn:{type:\"string\",group:\"Appearance\",defaultValue:\"slide\"}},aggregations:{beginColumnPages:{type:\"sap.ui.core.Control\",multiple:!0},midColumnPages:{type:\"sap.ui.core.Control\",multiple:!0},endColumnPages:{type:\"sap.ui.core.Control\",multiple:!0},_beginColumnNav:{type:\"sap.m.NavContainer\",multiple:!1,visibility:\"hidden\"},_midColumnNav:{type:\"sap.m.NavContainer\",multiple:!1,visibility:\"hidden\"},_endColumnNav:{type:\"sap.m.NavContainer\",multiple:!1,visibility:\"hidden\"},_beginColumnBackArrow:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_midColumnForwardArrow:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_midColumnBackArrow:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_endColumnForwardArrow:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"}},associations:{initialBeginColumnPage:{type:\"sap.ui.core.Control\",multiple:!1},initialMidColumnPage:{type:\"sap.ui.core.Control\",multiple:!1},initialEndColumnPage:{type:\"sap.ui.core.Control\",multiple:!1}},events:{stateChange:{parameters:{layout:{type:\"sap.f.LayoutType\"},maxColumnsCount:{type:\"int\"},isNavigationArrow:{type:\"boolean\"},isResize:{type:\"boolean\"}}},beginColumnNavigate:{allowPreventDefault:!0,parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}},afterBeginColumnNavigate:{parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}},midColumnNavigate:{allowPreventDefault:!0,parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}},afterMidColumnNavigate:{parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}},endColumnNavigate:{allowPreventDefault:!0,parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}},afterEndColumnNavigate:{parameters:{from:{type:\"sap.ui.core.Control\"},fromId:{type:\"string\"},to:{type:\"sap.ui.core.Control\"},toId:{type:\"string\"},firstTime:{type:\"boolean\"},isTo:{type:\"boolean\"},isBack:{type:\"boolean\"},isBackToTop:{type:\"boolean\"},isBackToPage:{type:\"boolean\"},direction:{type:\"string\"}}}}}});return d.prototype.init=function(){this._initNavContainers(),this._initButtons(),this._oLayoutHistory=new l},d.prototype._createNavContainer=function(t){var e=t.charAt(0).toUpperCase()+t.slice(1);return new u(this.getId()+\"-\"+t+\"ColumnNav\",{navigate:function(e){this._handleNavigationEvent(e,!1,t)}.bind(this),afterNavigate:function(e){this._handleNavigationEvent(e,!0,t)}.bind(this),defaultTransitionName:this[\"getDefaultTransitionName\"+e+\"Column\"]()})},d.prototype._handleNavigationEvent=function(t,e,n){var o,i;o=e?\"after\"+(n.charAt(0).toUpperCase()+n.slice(1))+\"ColumnNavigate\":n+\"ColumnNavigate\",i=this.fireEvent(o,t.mParameters,!0),i||t.preventDefault()},d.prototype._getBeginColumn=function(){return this.getAggregation(\"_beginColumnNav\")},d.prototype._getMidColumn=function(){return this.getAggregation(\"_midColumnNav\")},d.prototype._getEndColumn=function(){return this.getAggregation(\"_endColumnNav\")},d.prototype._flushColumnContent=function(t){var e=this.getAggregation(\"_\"+t+\"ColumnNav\"),n=sap.ui.getCore().createRenderManager();n.renderControl(e),n.flush(this._$columns[t].find(\".sapFFCLColumnContent\")[0],void 0,!0),n.destroy()},d.prototype.setLayout=function(t){t=this.validateProperty(\"layout\",t);var e=this.getLayout();if(e===t)return this;var n=this.setProperty(\"layout\",t,!0);return this._oLayoutHistory.addEntry(t),this._resizeColumns(),this._hideShowArrows(),n},d.prototype.onBeforeRendering=function(){this._deregisterResizeHandler()},d.prototype.onAfterRendering=function(){this._registerResizeHandler(),this._cacheDOMElements(),this._hideShowArrows(),this._resizeColumns(),this._flushColumnContent(\"begin\"),this._flushColumnContent(\"mid\"),this._flushColumnContent(\"end\"),this._fireStateChange(!1,!1)},d.prototype._getControlWidth=function(){return this.$().width()},d.prototype.exit=function(){this._deregisterResizeHandler(),this._handleEvent(t.Event(\"Destroy\"))},d.prototype._registerResizeHandler=function(){t.sap.assert(!this._iResizeHandlerId,\"Resize handler already registered\"),this._iResizeHandlerId=i.register(this,this._onResize.bind(this))},d.prototype._deregisterResizeHandler=function(){this._iResizeHandlerId&&(i.deregister(this._iResizeHandlerId),this._iResizeHandlerId=null)},d.prototype._initNavContainers=function(){this.setAggregation(\"_beginColumnNav\",this._createNavContainer(\"begin\"),!0),this.setAggregation(\"_midColumnNav\",this._createNavContainer(\"mid\"),!0),this.setAggregation(\"_endColumnNav\",this._createNavContainer(\"end\"),!0)},d.prototype._initButtons=function(){var t=new r(this.getId()+\"-beginBack\",{icon:\"sap-icon://slim-arrow-left\",tooltip:d._getResourceBundle().getText(\"FCL_BEGIN_COLUMN_BACK_ARROW\"),press:this._onArrowClick.bind(this,\"left\")}).addStyleClass(\"sapFFCLNavigationButton\").addStyleClass(\"sapFFCLNavigationButtonRight\");this.setAggregation(\"_beginColumnBackArrow\",t,!0);var e=new r(this.getId()+\"-midForward\",{icon:\"sap-icon://slim-arrow-right\",tooltip:d._getResourceBundle().getText(\"FCL_MID_COLUMN_FORWARD_ARROW\"),press:this._onArrowClick.bind(this,\"right\")}).addStyleClass(\"sapFFCLNavigationButton\").addStyleClass(\"sapFFCLNavigationButtonLeft\");this.setAggregation(\"_midColumnForwardArrow\",e,!0);var n=new r(this.getId()+\"-midBack\",{icon:\"sap-icon://slim-arrow-left\",tooltip:d._getResourceBundle().getText(\"FCL_MID_COLUMN_BACK_ARROW\"),press:this._onArrowClick.bind(this,\"left\")}).addStyleClass(\"sapFFCLNavigationButton\").addStyleClass(\"sapFFCLNavigationButtonRight\");this.setAggregation(\"_midColumnBackArrow\",n,!0);var o=new r(this.getId()+\"-endForward\",{icon:\"sap-icon://slim-arrow-right\",tooltip:d._getResourceBundle().getText(\"FCL_END_COLUMN_FORWARD_ARROW\"),press:this._onArrowClick.bind(this,\"right\")}).addStyleClass(\"sapFFCLNavigationButton\").addStyleClass(\"sapFFCLNavigationButtonLeft\");this.setAggregation(\"_endColumnForwardArrow\",o,!0)},d.prototype._cacheDOMElements=function(){this._cacheColumns(),o.system.phone||this._cacheArrows()},d.prototype._cacheColumns=function(){this._$columns={begin:this.$(\"beginColumn\"),mid:this.$(\"midColumn\"),end:this.$(\"endColumn\")}},d.prototype._cacheArrows=function(){this._$columnButtons={beginBack:this.$(\"beginBack\"),midForward:this.$(\"midForward\"),midBack:this.$(\"midBack\"),endForward:this.$(\"endForward\")}},d.prototype._getVisibleColumnsCount=function(){return[\"begin\",\"mid\",\"end\"].filter(function(t){return this._getColumnSize(t)>0},this).length},d.prototype._resizeColumns=function(){var t,e,n,i,a,s,r,u=!1,l=[\"begin\",\"mid\",\"end\"],g=sap.ui.getCore().getConfiguration().getRTL();this.isActive()&&(r=this._getVisibleColumnsCount(),0!==r&&(i=(r-1)*d.COLUMN_MARGIN,a=this._getControlWidth()-i,l.forEach(function(i){t=this._getColumnSize(i),this._$columns[i].toggleClass(\"sapFFCLColumnMargin\",u&&t>0),this._$columns[i].toggleClass(\"sapFFCLColumnActive\",t>0),this._$columns[i].removeClass(\"sapFFCLColumnOnlyActive\"),this._$columns[i].removeClass(\"sapFFCLColumnLastActive\"),this._$columns[i].removeClass(\"sapFFCLColumnFirstActive\"),e=Math.round(a*(t/100)),n=[100,0].indexOf(t)!==-1?t+\"%\":e+\"px\",this._$columns[i].width(n),o.system.phone||(this._updateColumnContextualSettings(i,e),this._updateColumnCSSClasses(i,e)),t>0&&(u=!0)},this),s=l.filter(function(t){return this._getColumnSize(t)>0},this),g&&l.reverse(),1===s.length&&this._$columns[s[0]].addClass(\"sapFFCLColumnOnlyActive\"),s.length>1&&(this._$columns[s[0]].addClass(\"sapFFCLColumnFirstActive\"),this._$columns[s[s.length-1]].addClass(\"sapFFCLColumnLastActive\"))))},d.prototype._propagateContextualSettings=function(){},d.prototype._updateColumnContextualSettings=function(t,e){var n,o;n=this.getAggregation(\"_\"+t+\"ColumnNav\"),n&&(o=n._getContextualSettings(),o&&o.contextualWidth===e||n._applyContextualSettings({contextualWidth:e}))},d.prototype._updateColumnCSSClasses=function(t,e){var n=\"\";this._$columns[t].removeClass(\"sapUiContainer-Narrow sapUiContainer-Medium sapUiContainer-Wide sapUiContainer-ExtraWide\"),n=e<o.media._predefinedRangeSets[o.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0]?\"Narrow\":e<o.media._predefinedRangeSets[o.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1]?\"Medium\":e<o.media._predefinedRangeSets[o.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2]?\"Wide\":\"ExtraWide\",this._$columns[t].addClass(\"sapUiContainer-\"+n)},d.prototype._getColumnSize=function(t){var e=this.getLayout(),n=this._getColumnWidthDistributionForLayout(e),o=n.split(\"/\"),i={begin:0,mid:1,end:2},a=o[i[t]];return parseInt(a,10)},d.prototype.getMaxColumnsCount=function(){return this._getMaxColumnsCountForWidth(this._getControlWidth())},d.prototype._getMaxColumnsCountForWidth=function(t){return t>=d.DESKTOP_BREAKPOINT?3:t>=d.TABLET_BREAKPOINT&&t<d.DESKTOP_BREAKPOINT?2:t>0?1:0},d.prototype._onResize=function(t){var e,n,o=t.oldSize.width,i=t.size.width;0!==i&&(e=this._getMaxColumnsCountForWidth(o),n=this._getMaxColumnsCountForWidth(i),this._resizeColumns(),n!==e&&(this._hideShowArrows(),this._fireStateChange(!1,!0)))},d.prototype._onArrowClick=function(e){var o=this.getLayout(),i={TwoColumnsBeginExpanded:{left:n.TwoColumnsMidExpanded},TwoColumnsMidExpanded:{right:n.TwoColumnsBeginExpanded},ThreeColumnsMidExpanded:{left:n.ThreeColumnsEndExpanded,right:n.ThreeColumnsMidExpandedEndHidden},ThreeColumnsEndExpanded:{right:n.ThreeColumnsMidExpanded},ThreeColumnsMidExpandedEndHidden:{left:n.ThreeColumnsMidExpanded,right:n.ThreeColumnsBeginExpandedEndHidden},ThreeColumnsBeginExpandedEndHidden:{left:n.ThreeColumnsMidExpandedEndHidden}};t.sap.assert(\"undefined\"!=typeof i[o]&&\"undefined\"!=typeof i[o][e],\"An invalid layout was used for determining arrow behavior\"),o=\"undefined\"!=typeof i[o]&&\"undefined\"!=typeof i[o][e]?i[o][e]:n.OneColumn,this.setLayout(o),this._fireStateChange(!0,!1)},d.prototype._hideShowArrows=function(){var t,e=this.getLayout(),i={},a=[];this.isActive()&&!o.system.phone&&(t=this.getMaxColumnsCount(),t>1&&(i[n.TwoColumnsBeginExpanded]=[\"beginBack\"],i[n.TwoColumnsMidExpanded]=[\"midForward\"],i[n.ThreeColumnsMidExpanded]=[\"midForward\",\"midBack\"],i[n.ThreeColumnsEndExpanded]=[\"endForward\"],i[n.ThreeColumnsMidExpandedEndHidden]=[\"midForward\",\"midBack\"],i[n.ThreeColumnsBeginExpandedEndHidden]=[\"beginBack\"],\"object\"==typeof i[e]&&(a=i[e])),this._toggleButton(\"beginBack\",a.indexOf(\"beginBack\")!==-1),this._toggleButton(\"midForward\",a.indexOf(\"midForward\")!==-1),this._toggleButton(\"midBack\",a.indexOf(\"midBack\")!==-1),this._toggleButton(\"endForward\",a.indexOf(\"endForward\")!==-1))},d.prototype._toggleButton=function(t,e){this._$columnButtons[t].toggle(e)},d.prototype._fireStateChange=function(t,e){0!==this._getControlWidth()&&this.fireStateChange({isNavigationArrow:t,isResize:e,layout:this.getLayout(),maxColumnsCount:this.getMaxColumnsCount()})},d.prototype.getBeginColumnPages=function(){return this._getBeginColumn().getPages()},d.prototype.addBeginColumnPage=function(t){return this._getBeginColumn().addPage(t),this},d.prototype.insertBeginColumnPage=function(t,e){return this._getBeginColumn().insertPage(t,e),this},d.prototype.removeBeginColumnPage=function(t){return this._getBeginColumn().removePage(t),this},d.prototype.removeAllBeginColumnPages=function(){return this._getBeginColumn().removeAllPages()},d.prototype.getMidColumnPages=function(){return this._getMidColumn().getPages()},d.prototype.addMidColumnPage=function(t){return this._getMidColumn().addPage(t),this},d.prototype.insertMidColumnPage=function(t,e){return this._getMidColumn().insertPage(t,e),this},d.prototype.removeMidColumnPage=function(t){return this._getMidColumn().removePage(t),this},d.prototype.removeAllMidColumnPages=function(){return this._getMidColumn().removeAllPages()},d.prototype.getEndColumnPages=function(){return this._getEndColumn().getPages()},d.prototype.addEndColumnPage=function(t){return this._getEndColumn().addPage(t),this},d.prototype.insertEndColumnPage=function(t,e){return this._getEndColumn().insertPage(t,e),this},d.prototype.removeEndColumnPage=function(t){return this._getEndColumn().removePage(t),this},d.prototype.removeAllEndColumnPages=function(){return this._getEndColumn().removeAllPages()},d.prototype.setInitialBeginColumnPage=function(t){return this._getBeginColumn().setInitialPage(t),this.setAssociation(\"initialBeginColumnPage\",t,!0),this},d.prototype.setInitialMidColumnPage=function(t){return this._getMidColumn().setInitialPage(t),this.setAssociation(\"initialMidColumnPage\",t,!0),this},d.prototype.setInitialEndColumnPage=function(t){return this._getEndColumn().setInitialPage(t),this.setAssociation(\"initialEndColumnPage\",t,!0),this},d.prototype.to=function(t,e,n,o){this._getBeginColumn().getPage(t)?this._getBeginColumn().to(t,e,n,o):this._getMidColumn().getPage(t)?this._getMidColumn().to(t,e,n,o):this._getEndColumn().to(t,e,n,o)},d.prototype.backToPage=function(t,e,n){this._getBeginColumn().getPage(t)?this._getBeginColumn().backToPage(t,e,n):this._getMidColumn().getPage(t)?this._getMidColumn().backToPage(t,e,n):this._getEndColumn().backToPage(t,e,n)},d.prototype._safeBackToPage=function(t,e,n,o){this._getBeginColumn().getPage(t)?this._getBeginColumn()._safeBackToPage(t,e,n,o):this._getMidColumn().getPage(t)?this._getMidColumn()._safeBackToPage(t,e,n,o):this._getEndColumn()._safeBackToPage(t,e,n,o)},d.prototype.toBeginColumnPage=function(t,e,n,o){this._getBeginColumn().to(t,e,n,o)},d.prototype.toMidColumnPage=function(t,e,n,o){this._getMidColumn().to(t,e,n,o)},d.prototype.toEndColumnPage=function(t,e,n,o){this._getEndColumn().to(t,e,n,o)},d.prototype.backBeginColumn=function(t,e){return this._getBeginColumn().back(t,e)},d.prototype.backMidColumn=function(t,e){return this._getMidColumn().back(t,e)},d.prototype.backEndColumn=function(t,e){return this._getEndColumn().back(t,e)},d.prototype.backBeginColumnToPage=function(t,e,n){return this._getBeginColumn().backToPage(t,e,n)},d.prototype.backMidColumnToPage=function(t,e,n){return this._getMidColumn().backToPage(t,e,n)},d.prototype.backEndColumnToPage=function(t,e,n){return this._getEndColumn().backToPage(t,e,n)},d.prototype.backToTopBeginColumn=function(t,e){this._getBeginColumn().backToTop(t,e)},d.prototype.backToTopMidColumn=function(t,e){this._getMidColumn().backToTop(t,e)},d.prototype.backToTopEndColumn=function(t,e){this._getEndColumn().backToTop(t,e)},d.prototype.getCurrentBeginColumnPage=function(){return this._getBeginColumn().getCurrentPage()},d.prototype.getCurrentMidColumnPage=function(){return this._getMidColumn().getCurrentPage()},d.prototype.getCurrentEndColumnPage=function(){return this._getEndColumn().getCurrentPage()},d.prototype.setDefaultTransitionNameBeginColumn=function(t){return this.setProperty(\"defaultTransitionNameBeginColumn\",t,!0),this._getBeginColumn().setDefaultTransitionName(t),this},d.prototype.setDefaultTransitionNameMidColumn=function(t){return this.setProperty(\"defaultTransitionNameMidColumn\",t,!0),this._getMidColumn().setDefaultTransitionName(t),this},d.prototype.setDefaultTransitionNameEndColumn=function(t){return this.setProperty(\"defaultTransitionNameEndColumn\",t,!0),this._getEndColumn().setDefaultTransitionName(t),this},d.prototype._getLayoutHistory=function(){return this._oLayoutHistory},d.prototype._getColumnWidthDistributionForLayout=function(t,e){var o,i=this.getMaxColumnsCount(),a={};return 0===i?o=\"0/0/0\":(a[n.OneColumn]=\"100/0/0\",a[n.MidColumnFullScreen]=\"0/100/0\",a[n.EndColumnFullScreen]=\"0/0/100\",1===i?(a[n.TwoColumnsBeginExpanded]=\"0/100/0\",a[n.TwoColumnsMidExpanded]=\"0/100/0\",a[n.ThreeColumnsMidExpanded]=\"0/0/100\",a[n.ThreeColumnsEndExpanded]=\"0/0/100\",a[n.ThreeColumnsMidExpandedEndHidden]=\"0/0/100\",a[n.ThreeColumnsBeginExpandedEndHidden]=\"0/0/100\"):(a[n.TwoColumnsBeginExpanded]=\"67/33/0\",a[n.TwoColumnsMidExpanded]=\"33/67/0\",a[n.ThreeColumnsMidExpanded]=2===i?\"0/67/33\":\"25/50/25\",a[n.ThreeColumnsEndExpanded]=2===i?\"0/33/67\":\"25/25/50\",a[n.ThreeColumnsMidExpandedEndHidden]=\"33/67/0\",a[n.ThreeColumnsBeginExpandedEndHidden]=\"67/33/0\"),o=a[t]),e&&(o=o.split(\"/\").map(function(t){return parseInt(t,10)})),o},d.COLUMN_MARGIN=8,d.DESKTOP_BREAKPOINT=1280,d.TABLET_BREAKPOINT=960,d._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle(\"sap.f\")},d._getAriaLabels=function(){return d._sAriaFlexibleColumnLayoutLabels||(d._sAriaFlexibleColumnLayoutLabels={beginColumnLabel:d._getARIAInvisibleTextId(\"FCL_BEGIN_COLUMN_REGION_TEXT\"),midColumnLabel:d._getARIAInvisibleTextId(\"FCL_MID_COLUMN_REGION_TEXT\"),endColumnLabel:d._getARIAInvisibleTextId(\"FCL_END_COLUMN_REGION_TEXT\")}),d._sAriaFlexibleColumnLayoutLabels},d._getARIAInvisibleTextId=function(t){return new s({text:d._getResourceBundle().getText(t)}).toStatic().getId()},l.prototype.addEntry=function(t){\"undefined\"!=typeof t&&this._aLayoutHistory.push(t)},l.prototype.getClosestEntryThatMatches=function(t){var e;for(e=this._aLayoutHistory.length-1;e>=0;e--)if(t.indexOf(this._aLayoutHistory[e])!==-1)return this._aLayoutHistory[e]},d},!0);",
		"sap/f/FlexibleColumnLayoutRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/FlexibleColumnLayout\",\"sap/ui/Device\"],function(e,r){\"use strict\";var n={};return n.render=function(e,r){e.write(\"<div\"),e.writeControlData(r),e.addClass(\"sapFFCL\"),e.writeClasses(),e.write(\">\"),n.renderBeginColumn(e,r),n.renderMidColumn(e,r),n.renderEndColumn(e,r),e.write(\"</div>\")},n.renderBeginColumn=function(r,t){var i=t.getAggregation(\"_beginColumnBackArrow\");r.write(\"<div\"),r.writeAttribute(\"id\",t.getId()+\"-beginColumn\"),r.writeAccessibilityState(t,{role:\"region\",labelledBy:e._getAriaLabels().beginColumnLabel}),r.addClass(\"sapFFCLColumn\").addClass(\"sapFFCLColumnBegin\").addClass(\"sapFFCLColumnActive\"),r.writeClasses(),r.writeStyles(),r.write(\">\"),n.renderColumnContentWrapper(r),n.renderArrow(r,i),r.write(\"</div>\")},n.renderMidColumn=function(r,t){var i=t.getAggregation(\"_midColumnForwardArrow\"),l=t.getAggregation(\"_midColumnBackArrow\");r.write(\"<div\"),r.writeAttribute(\"id\",t.getId()+\"-midColumn\"),r.writeAccessibilityState(t,{role:\"region\",labelledBy:e._getAriaLabels().midColumnLabel}),r.addClass(\"sapFFCLColumn\").addClass(\"sapFFCLColumnMid\"),r.writeClasses(),r.writeStyles(),r.write(\">\"),n.renderArrow(r,i),n.renderColumnContentWrapper(r),n.renderArrow(r,l),r.write(\"</div>\")},n.renderEndColumn=function(r,t){var i=t.getAggregation(\"_endColumnForwardArrow\");r.write(\"<div\"),r.writeAttribute(\"id\",t.getId()+\"-endColumn\"),r.writeAccessibilityState(t,{role:\"region\",labelledBy:e._getAriaLabels().endColumnLabel}),r.addClass(\"sapFFCLColumn\").addClass(\"sapFFCLColumnEnd\"),r.writeClasses(),r.writeStyles(),r.write(\">\"),n.renderArrow(r,i),n.renderColumnContentWrapper(r),r.write(\"</div>\")},n.renderArrow=function(e,n){r.system.phone||(n.addStyleClass(\"sapContrastPlus\"),e.renderControl(n))},n.renderColumnContentWrapper=function(e){e.write(\"<div\"),e.addClass(\"sapFFCLColumnContent\"),e.writeClasses(),e.write(\"></div>\")},n},!0);",
		"sap/f/FlexibleColumnLayoutSemanticHelper.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"./LayoutType\",\"./FlexibleColumnLayout\"],function(e,n,o,t){\"use strict\";var l=function(e,n){this._oFCL=e,this._mode=\"Normal\",n||(n={}),this._defaultLayoutType=o.OneColumn,this._defaultTwoColumnLayoutType=[o.TwoColumnsBeginExpanded,o.TwoColumnsMidExpanded].indexOf(n.defaultTwoColumnLayoutType)!==-1?n.defaultTwoColumnLayoutType:o.TwoColumnsBeginExpanded,this._defaultThreeColumnLayoutType=[o.ThreeColumnsMidExpanded,o.ThreeColumnsEndExpanded].indexOf(n.defaultThreeColumnLayoutType)!==-1?n.defaultThreeColumnLayoutType:o.ThreeColumnsMidExpanded,this._mode=[\"Normal\",\"MasterDetail\",\"SingleColumn\"].indexOf(n.mode)!==-1?n.mode:\"Normal\"};return l._oInstances={},l.getInstanceFor=function(n,o){e.sap.assert(n instanceof t,\"Passed control is not FlexibleColumnLayout\");var u=n.getId();if(\"undefined\"==typeof l._oInstances[u]){l._oInstances[u]=new l(n,o);var i={onDestroy:function(){delete l._oInstances[u]}};n.addEventDelegate(i)}return l._oInstances[u]},l.prototype.getCurrentUIState=function(){var e=this._oFCL.getLayout();return this._getUIStateForLayout(e)},l.prototype.getNextUIState=function(e){var n,t=this._oFCL.getLayout();return 0===e&&(n=o.OneColumn),1===e&&(n=\"SingleColumn\"===this._mode?o.MidColumnFullScreen:[o.TwoColumnsBeginExpanded,o.TwoColumnsMidExpanded].indexOf(t)!==-1?t:[o.MidColumnFullScreen,o.EndColumnFullScreen].indexOf(t)!==-1?o.MidColumnFullScreen:this._defaultTwoColumnLayoutType),2===e&&(n=\"SingleColumn\"===this._mode||\"MasterDetail\"===this._mode?o.EndColumnFullScreen:[o.ThreeColumnsMidExpandedEndHidden,o.ThreeColumnsBeginExpandedEndHidden].indexOf(t)!==-1?this._defaultThreeColumnLayoutType:[o.ThreeColumnsMidExpanded,o.ThreeColumnsEndExpanded].indexOf(t)!==-1?t:[o.MidColumnFullScreen,o.EndColumnFullScreen].indexOf(t)!==-1?o.EndColumnFullScreen:this._defaultThreeColumnLayoutType),e>2&&(n=o.EndColumnFullScreen),this._getUIStateForLayout(n)},l.prototype._getUIStateForLayout=function(e){var n=this._oFCL._getColumnWidthDistributionForLayout(e,!0),o=n.join(\"/\"),t=this._oFCL.getMaxColumnsCount();return{layout:e,maxColumnsCount:t,columnsSizes:this._getColumnsSizes(n),columnsVisibility:this._getColumnsVisibility(n),isFullScreen:this._getIsFullScreen(n),isLogicallyFullScreen:this._getIsLogicallyFullScreen(e),actionButtonsInfo:this._getActionButtonsInfo(o,t)}},l.prototype._getColumnsSizes=function(e){return{beginColumn:e[0],midColumn:e[1],endColumn:e[2]}},l.prototype._getColumnsVisibility=function(e){return{beginColumn:0!==e[0],midColumn:0!==e[1],endColumn:0!==e[2]}},l.prototype._getIsFullScreen=function(e){return e.indexOf(100)!==-1},l.prototype._getIsLogicallyFullScreen=function(e){return[o.OneColumn,o.MidColumnFullScreen,o.EndColumnFullScreen].indexOf(e)!==-1},l.prototype._getActionButtonsInfo=function(e,n){var t,l,u={fullScreen:null,exitFullScreen:null,closeColumn:null},i={fullScreen:null,exitFullScreen:null,closeColumn:null};return\"SingleColumn\"===this._mode?{midColumn:u,endColumn:i}:(1===n?(u.closeColumn=this._defaultLayoutType,i.closeColumn=this._defaultTwoColumnLayoutType):(\"67/33/0\"!==e&&\"33/67/0\"!==e||(u.fullScreen=o.MidColumnFullScreen,u.closeColumn=this._defaultLayoutType),\"25/50/25\"!==e&&\"25/25/50\"!==e&&\"0/67/33\"!==e||(i.fullScreen=o.EndColumnFullScreen,i.closeColumn=this._defaultTwoColumnLayoutType),\"0/100/0\"===e&&(t=[o.TwoColumnsBeginExpanded,o.TwoColumnsMidExpanded,o.ThreeColumnsBeginExpandedEndHidden,o.ThreeColumnsMidExpandedEndHidden],l=this._oFCL._getLayoutHistory().getClosestEntryThatMatches(t)||this._defaultTwoColumnLayoutType,u.exitFullScreen=l,u.closeColumn=this._defaultLayoutType),\"0/0/100\"===e&&\"MasterDetail\"!==this._mode&&(t=[o.ThreeColumnsMidExpanded,o.ThreeColumnsEndExpanded],l=this._oFCL._getLayoutHistory().getClosestEntryThatMatches(t)||this._defaultThreeColumnLayoutType,i.exitFullScreen=l,i.closeColumn=this._defaultTwoColumnLayoutType)),{midColumn:u,endColumn:i})},l.prototype.getDefaultLayouts=function(){return{defaultLayoutType:this._defaultLayoutType,defaultTwoColumnLayoutType:this._defaultTwoColumnLayoutType,defaultThreeColumnLayoutType:this._defaultThreeColumnLayoutType}},l},!0);",
		"sap/f/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/library\",\"sap/m/library\"],function(){\"use strict\";return sap.ui.getCore().initLibrary({name:\"sap.f\",version:\"800001.6.0.20241202143000_f0htmcm80p\",dependencies:[\"sap.ui.core\",\"sap.m\"],types:[\"sap.f.LayoutType\"],controls:[\"sap.f.Avatar\",\"sap.f.DynamicPage\",\"sap.f.DynamicPageHeader\",\"sap.f.DynamicPageTitle\",\"sap.f.FlexibleColumnLayout\",\"sap.f.semantic.SemanticPage\"],elements:[\"sap.f.semantic.AddAction\",\"sap.f.semantic.CloseAction\",\"sap.f.semantic.CopyAction\",\"sap.f.semantic.DeleteAction\",\"sap.f.semantic.DiscussInJamAction\",\"sap.f.semantic.ExitFullScreenAction\",\"sap.f.semantic.FavoriteAction\",\"sap.f.semantic.FlagAction\",\"sap.f.semantic.FooterMainAction\",\"sap.f.semantic.FullScreenAction\",\"sap.f.semantic.MessagesIndicator\",\"sap.f.semantic.NegativeAction\",\"sap.f.semantic.PositiveAction\",\"sap.f.semantic.PrintAction\",\"sap.f.semantic.SemanticButton\",\"sap.f.semantic.SemanticControl\",\"sap.f.semantic.SemanticToggleButton\",\"sap.f.semantic.SendEmailAction\",\"sap.f.semantic.SendMessageAction\",\"sap.f.semantic.ShareInJamAction\",\"sap.f.semantic.TitleMainAction\"]}),sap.f.LayoutType={OneColumn:\"OneColumn\",TwoColumnsBeginExpanded:\"TwoColumnsBeginExpanded\",TwoColumnsMidExpanded:\"TwoColumnsMidExpanded\",MidColumnFullScreen:\"MidColumnFullScreen\",ThreeColumnsMidExpanded:\"ThreeColumnsMidExpanded\",ThreeColumnsEndExpanded:\"ThreeColumnsEndExpanded\",ThreeColumnsMidExpandedEndHidden:\"ThreeColumnsMidExpandedEndHidden\",ThreeColumnsBeginExpandedEndHidden:\"ThreeColumnsBeginExpandedEndHidden\",EndColumnFullScreen:\"EndColumnFullScreen\"},sap.ui.lazyRequire(\"sap.f.routing.Router\"),sap.ui.lazyRequire(\"sap.f.routing.Target\"),sap.ui.lazyRequire(\"sap.f.routing.TargetHandler\"),sap.ui.lazyRequire(\"sap.f.routing.Targets\"),sap.f.AvatarShape={Circle:\"Circle\",Square:\"Square\"},sap.f.AvatarSize={XS:\"XS\",S:\"S\",M:\"M\",L:\"L\",XL:\"XL\",Custom:\"Custom\"},sap.f.AvatarType={Icon:\"Icon\",Image:\"Image\",Initials:\"Initials\"},sap.f.AvatarImageFitType={Cover:\"Cover\",Contain:\"Contain\"},sap.f});",
		"sap/f/routing/async/Target.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{_place:function(t){var n=this._super._place.apply(this,arguments),i=t&&t.routeConfig||{},a=this;return this._oTargetHandler._chainNavigation(function(){return n.then(function(n){return a._oTargetHandler.addNavigation({navigationIdentifier:a._oOptions.name,transition:a._oOptions.transition,transitionParameters:a._oOptions.transitionParameters,eventData:t,targetControl:n.control,view:n.view,layout:i.layout}),n})})}}},!0);",
		"sap/f/routing/async/Targets.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{display:function(){var t,i;this._oLastDisplayedTarget=null;var e=this._super.display.apply(this,arguments);return e.then(function(e){return this._oLastDisplayedTarget&&(t=this._getViewLevel(this._oLastDisplayedTarget),i=this._oLastDisplayedTarget._oOptions.name),this._oTargetHandler.navigate({viewLevel:t,navigationIdentifier:i}),e}.bind(this))},_displaySingleTarget:function(t){var i=this.getTarget(t);return this._super._displaySingleTarget.apply(this,arguments).then(function(t){return i&&(this._oLastDisplayedTarget=i),t}.bind(this))}}},!0);",
		"sap/f/routing/Router.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Router\",\"./TargetHandler\",\"./Targets\"],function(t,e,r){\"use strict\";var a=t.extend(\"sap.f.routing.Router\",{constructor:function(){this._oTargetHandler=new e,t.prototype.constructor.apply(this,arguments)},destroy:function(){t.prototype.destroy.apply(this,arguments),this._oTargetHandler.destroy(),this._oTargetHandler=null},getTargetHandler:function(){return this._oTargetHandler},_createTargets:function(t,e){return new r({views:this._oViews,config:t,targets:e,targetHandler:this._oTargetHandler})},fireRouteMatched:function(e){var r,a=this.getRoute(e.name);return a._oTarget&&(r=a._oTarget._oOptions,this._oTargetHandler.addNavigation({navigationIdentifier:e.name,transition:r.transition,transitionParameters:r.transitionParameters,eventData:e.arguments,targetControl:e.targetControl,view:e.view,layout:a._oConfig.layout})),t.prototype.fireRouteMatched.apply(this,arguments)},fireRoutePatternMatched:function(e){var r,a=e.name;return this._oTargets&&this._oTargets._oLastDisplayedTarget&&(r=this._oTargets._getViewLevel(this._oTargets._oLastDisplayedTarget)),this._oTargetHandler.navigate({navigationIdentifier:a,viewLevel:r,askHistory:!0}),t.prototype.fireRoutePatternMatched.apply(this,arguments)}});return a},!0);",
		"sap/f/routing/Target.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Target\",\"sap/f/FlexibleColumnLayout\",\"./async/Target\"],function(t,o,a){\"use strict\";var e=t.extend(\"sap.f.routing.Target\",{constructor:function(o,e,n,r){this._oTargetHandler=r,t.prototype.constructor.apply(this,arguments);var i=a;this._super={};for(var s in i)this._super[s]=this[s],this[s]=i[s]},_beforePlacingViewIntoContainer:function(a){var e=a.container,n=a.data&&a.data.routeConfig;e instanceof o&&n&&n.layout&&e.setLayout(n.layout),t.prototype._beforePlacingViewIntoContainer.apply(this,arguments)}});return e},!0);",
		"sap/f/routing/TargetHandler.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/InstanceManager\",\"sap/ui/base/Object\",\"sap/ui/core/routing/History\"],function(t,e,i,o){\"use strict\";var a=i.extend(\"sap.f.routing.TargetHandler\",{constructor:function(t){this._aQueue=[],this._oNavigationOrderPromise=Promise.resolve(),void 0===t?this._bCloseDialogs=!0:this._bCloseDialogs=!!t}});return a.prototype.setCloseDialogs=function(t){return this._bCloseDialogs=!!t,this},a.prototype.getCloseDialogs=function(){return this._bCloseDialogs},a.prototype.addNavigation=function(t){this._aQueue.push(t)},a.prototype.navigate=function(t){for(var e,i=this._createResultingNavigations(t.navigationIdentifier),o=!1,a=this._getDirection(t);i.length;)e=this._applyNavigationResult(i.shift().oParams,a),o=o||e;o&&this._closeDialogs()},a.prototype._chainNavigation=function(t){return this._oNavigationOrderPromise=this._oNavigationOrderPromise.then(t),this._oNavigationOrderPromise},a.prototype._getDirection=function(t){var e=t.viewLevel,i=o.getInstance(),a=!1;return\"Backwards\"===t.direction?a=!0:isNaN(e)||isNaN(this._iCurrentViewLevel)||e===this._iCurrentViewLevel?t.askHistory&&(a=\"Backwards\"===i.getDirection()):a=e<this._iCurrentViewLevel,this._iCurrentViewLevel=e,a},a.prototype._createResultingNavigations=function(t){for(var e,i,o,a,s,r=[];this._aQueue.length;){for(i=this._aQueue.shift(),o=i.targetControl,a={oContainer:o,oParams:i},e=0;e<r.length;e++)s=r[e],s.oContainer===o;r.push(a)}return r},a.prototype._applyNavigationResult=function(e,i){var o=e.targetControl,a=e.eventData,s=e.transition||\"\",r=e.transitionParameters,n=e.view.getId();return t.sap.log.info(\"navigation to view with id: \"+n+\" the targetControl is \"+o.getId()+\" backwards is \"+i),i?o._safeBackToPage(n,s,a,r):o.to(n,s,a,r),!0},a.prototype._closeDialogs=function(){this._bCloseDialogs&&(e.hasOpenPopover()&&e.closeAllPopovers(),e.hasOpenDialog()&&e.closeAllDialogs(),e.hasOpenLightBox()&&e.closeAllLightBoxes())},a},!0);",
		"sap/f/routing/Targets.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Targets\",\"./TargetHandler\",\"./Target\",\"./async/Targets\"],function(t,r,e,n){\"use strict\";var a=t.extend(\"sap.f.routing.Targets\",{constructor:function(e){e.config._async=!0,e.targetHandler?this._oTargetHandler=e.targetHandler:(this._oTargetHandler=new r,this._bHasOwnTargetHandler=!0),t.prototype.constructor.apply(this,arguments);var a=n;this._super={};for(var s in a)this._super[s]=this[s],this[s]=a[s]},destroy:function(){t.prototype.destroy.apply(this,arguments),this._bHasOwnTargetHandler&&this._oTargetHandler.destroy(),this._oTargetHandler=null},getTargetHandler:function(){return this._oTargetHandler},_constructTarget:function(t,r){return new e(t,this._oViews,r,this._oTargetHandler)},_getViewLevel:function(t){var r;do{if(r=t._oOptions.viewLevel,void 0!==r)return r;t=t._oParent}while(t);return r}});return a},!0);",
		"sap/f/semantic/AddAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.AddAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/CloseAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.CloseAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/CopyAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.CopyAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/DeleteAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.DeleteAction\",{metadata:{library:\"sap.f\"}});return e},!0);",
		"sap/f/semantic/DiscussInJamAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(a){\"use strict\";var t=a.extend(\"sap.f.semantic.DiscussInJamAction\",{metadata:{library:\"sap.f\"}});return t},!0);",
		"sap/f/semantic/ExitFullScreenAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.ExitFullScreenAction\",{metadata:{library:\"sap.f\"}});return e},!0);",
		"sap/f/semantic/FavoriteAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticToggleButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.FavoriteAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/FlagAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticToggleButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.FlagAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/FooterMainAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./MainAction\"],function(a){\"use strict\";var t=a.extend(\"sap.f.semantic.FooterMainAction\",{metadata:{library:\"sap.f\"}});return t},!0);",
		"sap/f/semantic/FullScreenAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.FullScreenAction\",{metadata:{library:\"sap.f\"}});return e},!0);",
		"sap/f/semantic/MainAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.MainAction\",{metadata:{library:\"sap.f\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null}}}});return e},!1);",
		"sap/f/semantic/MessagesIndicator.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\"],function(a){\"use strict\";var t=a.extend(\"sap.f.semantic.MessagesIndicator\",{metadata:{library:\"sap.f\"}});return t},!0);",
		"sap/f/semantic/NegativeAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.NegativeAction\",{metadata:{library:\"sap.f\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null}}}});return e},!0);",
		"sap/f/semantic/PositiveAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var e=t.extend(\"sap.f.semantic.PositiveAction\",{metadata:{library:\"sap.f\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null}}}});return e},!0);",
		"sap/f/semantic/PrintAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(t){\"use strict\";var a=t.extend(\"sap.f.semantic.PrintAction\",{metadata:{library:\"sap.f\"}});return a},!0);",
		"sap/f/semantic/SemanticButton.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticControl\",\"./SemanticConfiguration\",\"sap/m/Button\",\"sap/m/OverflowToolbarButton\"],function(t,e,n,o){\"use strict\";var r=t.extend(\"sap.f.semantic.SemanticButton\",{metadata:{library:\"sap.f\",abstract:!0,properties:{enabled:{type:\"boolean\",group:\"Behavior\",defaultValue:!0}},events:{press:{}}}});return r.prototype._getControl=function(){var t,e,r=this.getAggregation(\"_control\"),a=this._getConfiguration();return a?(r||(t=a&&\"IconOnly\"===a.constraints?o:n,e=this._createInstance(t),e.applySettings(a.getSettings()),\"function\"==typeof a.getEventDelegates&&e.addEventDelegate(a.getEventDelegates(e)),this.setAggregation(\"_control\",e,!0),r=this.getAggregation(\"_control\")),r):null},r.prototype._createInstance=function(t){return new t({id:this.getId()+\"-button\",press:jQuery.proxy(this.firePress,this)})},r},!1);",
		"sap/f/semantic/SemanticConfiguration.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/Metadata\",\"sap/ui/core/IconPool\",\"sap/m/ButtonType\",\"sap/m/OverflowToolbarLayoutData\",\"sap/m/OverflowToolbarPriority\"],function(t,e,n,o,i,a){\"use strict\";var r=e.createClass(\"sap.f.semantic.SemanticConfiguration\",{});return r._Placement={titleText:\"titleText\",titleIcon:\"titleIcon\",footerLeft:\"footerLeft\",footerRight:\"footerRight\",shareMenu:\"shareMenu\"},r.isKnownSemanticType=function(t){return null!==r.getConfiguration(t)},r.getConfiguration=function(t){return r._oTypeConfigs[t]||null},r.getSettings=function(t){return r.isKnownSemanticType(t)?r._oTypeConfigs[t].getSettings():null},r.getConstraints=function(t){return r.isKnownSemanticType(t)?r._oTypeConfigs[t].constraints||null:null},r.getPlacement=function(t){return r.isKnownSemanticType(t)?r._oTypeConfigs[t].placement:null},r.getOrder=function(t){return r.isKnownSemanticType(t)?r._oTypeConfigs[t].order:null},r.isMainAction=function(t){return!!r.isKnownSemanticType(t)&&(r._oTypeConfigs[t].mainAction||!1)},r.isNavigationAction=function(t){return!!r.isKnownSemanticType(t)&&(r._oTypeConfigs[t].navigation||!1)},r._oTypeConfigs=function(){var t={},e=sap.ui.getCore().getLibraryResourceBundle(\"sap.f\");return t[\"sap.f.semantic.TitleMainAction\"]={placement:r._Placement.titleText,order:0,mainAction:!0,getSettings:function(){return{type:o.Emphasized,layoutData:new i({priority:a.NeverOverflow})}}},t[\"sap.f.semantic.AddAction\"]={placement:r._Placement.titleText,order:1,getSettings:function(){return{text:e.getText(\"SEMANTIC_CONTROL_ADD\"),tooltip:e.getText(\"SEMANTIC_CONTROL_ADD\"),type:o.Transparent}}},t[\"sap.f.semantic.DeleteAction\"]={placement:r._Placement.titleText,order:2,getSettings:function(){return{text:e.getText(\"SEMANTIC_CONTROL_DELETE\"),type:o.Transparent}}},t[\"sap.f.semantic.CopyAction\"]={placement:r._Placement.titleText,order:3,getSettings:function(){return{text:e.getText(\"SEMANTIC_CONTROL_COPY\"),type:o.Transparent}}},t[\"sap.f.semantic.FavoriteAction\"]={placement:r._Placement.titleIcon,order:0,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"favorite\"),text:e.getText(\"SEMANTIC_CONTROL_FAVORITE\"),type:o.Transparent}}},t[\"sap.f.semantic.FlagAction\"]={placement:r._Placement.titleIcon,order:1,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"flag\"),text:e.getText(\"SEMANTIC_CONTROL_FLAG\"),type:o.Transparent}}},t[\"sap.f.semantic.FullScreenAction\"]={placement:r._Placement.titleIcon,order:3,constraints:\"IconOnly\",navigation:!0,getSettings:function(){return{icon:n.getIconURI(\"full-screen\"),tooltip:e.getText(\"SEMANTIC_CONTROL_FULL_SCREEN\"),layoutData:new i({priority:a.NeverOverflow}),type:o.Transparent}}},t[\"sap.f.semantic.ExitFullScreenAction\"]={placement:r._Placement.titleIcon,order:4,constraints:\"IconOnly\",navigation:!0,getSettings:function(){return{icon:n.getIconURI(\"exit-full-screen\"),tooltip:e.getText(\"SEMANTIC_CONTROL_EXIT_FULL_SCREEN\"),layoutData:new i({priority:a.NeverOverflow}),type:o.Transparent}}},t[\"sap.f.semantic.CloseAction\"]={placement:r._Placement.titleIcon,order:5,constraints:\"IconOnly\",navigation:!0,getSettings:function(){return{icon:n.getIconURI(\"decline\"),tooltip:e.getText(\"SEMANTIC_CONTROL_CLOSE\"),layoutData:new i({priority:a.NeverOverflow}),type:o.Transparent}}},t[\"sap.f.semantic.MessagesIndicator\"]={placement:r._Placement.footerLeft,order:0,mainAction:!1,getSettings:function(){return{icon:n.getIconURI(\"message-popup\"),text:{path:\"message>/\",formatter:function(t){return t.length||0}},tooltip:e.getText(\"SEMANTIC_CONTROL_MESSAGES_INDICATOR\"),type:o.Emphasized,visible:{path:\"message>/\",formatter:function(t){return t&&t.length>0}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new i({priority:a.NeverOverflow})}}},t[\"sap.m.DraftIndicator\"]={placement:r._Placement.footerLeft,order:1,mainAction:!1,getSettings:function(){return{layoutData:new i({shrinkable:!1})}}},t[\"sap.f.semantic.FooterMainAction\"]={placement:r._Placement.footerRight,order:0,mainAction:!0,getSettings:function(){return{type:o.Emphasized,text:e.getText(\"SEMANTIC_CONTROL_SAVE\"),layoutData:new i({priority:a.NeverOverflow})}}},t[\"sap.f.semantic.PositiveAction\"]={placement:r._Placement.footerRight,order:1,mainAction:!1,getSettings:function(){return{type:o.Accept,text:e.getText(\"SEMANTIC_CONTROL_ACCEPT\"),layoutData:new i({priority:a.NeverOverflow})}}},t[\"sap.f.semantic.NegativeAction\"]={placement:r._Placement.footerRight,order:2,mainAction:!1,getSettings:function(){return{type:o.Reject,text:e.getText(\"SEMANTIC_CONTROL_REJECT\"),layoutData:new i({priority:a.NeverOverflow})}}},t[\"sap.f.semantic.SendEmailAction\"]={placement:r._Placement.shareMenu,order:0,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"email\"),text:e.getText(\"SEMANTIC_CONTROL_SEND_EMAIL\"),type:o.Transparent}}},t[\"sap.f.semantic.DiscussInJamAction\"]={placement:r._Placement.shareMenu,order:1,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"discussion-2\"),text:e.getText(\"SEMANTIC_CONTROL_DISCUSS_IN_JAM\"),type:o.Transparent}}},t[\"sap.f.semantic.ShareInJamAction\"]={placement:r._Placement.shareMenu,order:2,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"share-2\"),text:e.getText(\"SEMANTIC_CONTROL_SHARE_IN_JAM\"),type:o.Transparent}}},t[\"sap.f.semantic.SendMessageAction\"]={placement:r._Placement.shareMenu,order:3,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"discussion\"),text:e.getText(\"SEMANTIC_CONTROL_SEND_MESSAGE\"),type:o.Transparent}}},t.saveAsTileAction={placement:r._Placement.shareMenu,order:4,constraints:\"IconOnly\"},t[\"sap.f.semantic.PrintAction\"]={placement:r._Placement.shareMenu,order:5,constraints:\"IconOnly\",getSettings:function(){return{icon:n.getIconURI(\"print\"),text:e.getText(\"SEMANTIC_CONTROL_PRINT\"),type:o.Transparent}}},t}(),r},!1);",
		"sap/f/semantic/SemanticContainer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/Metadata\",\"sap/ui/core/CustomData\",\"sap/m/ToolbarSpacer\",\"./SemanticConfiguration\"],function(t,e,n,o,r){\"use strict\";var a=e.createClass(\"sap.f.semantic.SemanticContainer\",{constructor:function(e,n){return e?(this._oContainer=e,void(this._oParent=n)):void t.sap.log.error(\"SemanticContainer :: missing argument - container reference\",this)}});return a.prototype._getContainer=function(){return this._oContainer},a.prototype._getParent=function(){return this._oParent},a.prototype._getControlOrder=function(t){var e=t._getType&&t._getType()||t.getMetadata().getName();return r.getOrder(e)},a.prototype._getConstraints=function(t){return r.getConstraints(t.getMetadata().getName())},a.prototype._getControl=function(t){return t._getControl?t._getControl():t},a.prototype._isMainAction=function(t){return r.isMainAction(t.getMetadata().getName())},a.prototype._isNavigationAction=function(t){return r.isNavigationAction(t.getMetadata().getName())},a.prototype._callContainerAggregationMethod=function(t){return this._getContainer()[t].apply(this._getContainer(),Array.prototype.slice.call(arguments).slice(1))},a.prototype._sortControlByOrder=function(t,e){return this._getControlOrder(t)-this._getControlOrder(e)},a.prototype.destroy=function(){this._oParent=null,this._oContainer=null},a},!1);",
		"sap/f/semantic/SemanticControl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/ManagedObject\",\"sap/ui/core/Element\",\"./SemanticConfiguration\"],function(t,e,o,r){\"use strict\";function n(t){return t.charAt(0).toUpperCase()+t.slice(1)}var g=o.extend(\"sap.f.semantic.SemanticControl\",{metadata:{library:\"sap.f\",abstract:!0,properties:{visible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{_control:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"}}}});return g.prototype.setProperty=function(t,o,r){return e.prototype.setProperty.call(this,t,o,!0),this._applyProperty(t,o,r),this},g.prototype.updateAggregation=function(t){this._getControl().updateAggregation(t)},g.prototype.refreshAggregation=function(t){this._getControl().refreshAggregation(t)},g.prototype.setAggregation=function(t,o,r){return\"_control\"===t?e.prototype.setAggregation.call(this,t,o,r):this._getControl().setAggregation(t,o,r)},g.prototype.getAggregation=function(t,o){return\"_control\"===t?e.prototype.getAggregation.call(this,t,o):this._getControl().getAggregation(t,o)},g.prototype.indexOfAggregation=function(t,e){return this._getControl().indexOfAggregation(t,e)},g.prototype.insertAggregation=function(t,e,o,r){return this._getControl().insertAggregation(t,e,o,r)},g.prototype.addAggregation=function(t,e,o){return this._getControl().addAggregation(t,e,o)},g.prototype.removeAggregation=function(t,e,o){return this._getControl().removeAggregation(t,e,o)},g.prototype.removeAllAggregation=function(t,e){return this._getControl().removeAllAggregation(t,e)},g.prototype.destroyAggregation=function(t,e){return this._getControl().destroyAggregation(t,e)},g.prototype.bindAggregation=function(t,e){return this._getControl().bindAggregation(t,e)},g.prototype.unbindAggregation=function(t,e){return this._getControl().unbindAggregation(t,e)},g.prototype.clone=function(t,e){var r=o.prototype.clone.apply(this,arguments),n=this._getControl().clone(t,e);return r.setAggregation(\"_control\",n),r},g.prototype.destroy=function(){var t=o.prototype.destroy.apply(this,arguments);return this.getAggregation(\"_control\")&&this.getAggregation(\"_control\").destroy(),t},g.prototype.getDomRef=function(t){return this._getControl().getDomRef(t)},g.prototype.addEventDelegate=function(e,o){return t.each(e,function(t,r){\"function\"==typeof r&&(e[t]=function(t){t.srcControl=this,r.call(o,t)}.bind(this))}.bind(this)),this._getControl().addEventDelegate(e,o),this},g.prototype.removeEventDelegate=function(t){return this._getControl().removeEventDelegate(t),this},g.prototype._getConfiguration=function(){return r.getConfiguration(this.getMetadata().getName())},g.prototype._applyProperty=function(t,e,o){var r,g=this._getControl();g&&(r=\"set\"+n(t),this._getControl()[r](e,o))},g},!1);",
		"sap/f/semantic/SemanticFooter.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/ToolbarSpacer\",\"sap/m/ButtonType\",\"./SemanticConfiguration\",\"./SemanticContainer\"],function(t,n,e,o,i){\"use strict\";var r=i.extend(\"sap.f.semantic.SemanticFooter\",{constructor:function(t,n){i.call(this,t,n),this._aCustomContent=[],this._aSemanticLeftContent=[],this._aSemanticRightContent=[],this._iSemanticLeftContentCount=1,this._fnParentSubstitute=function(){return this._oParent}.bind(this),this._insertSpacer()}});return r.mPlacementMethodMap={footerLeft:\"LeftContent\",footerRight:\"RightContent\"},r.prototype.addCustomAction=function(t){return t.setType(e.Transparent),this._callContainerAggregationMethod(\"addContent\",t),this._aCustomContent.push(t),this},r.prototype.insertCustomAction=function(t,n){var o=this._getCustomContentInsertIndex(n);return t.setType(e.Transparent),this._callContainerAggregationMethod(\"insertContent\",t,o),this._aCustomContent.splice(n,0,t),this},r.prototype.getCustomActions=function(){return this._aCustomContent},r.prototype.indexOfCustomAction=function(t){return this._aCustomContent.indexOf(t)},r.prototype.removeCustomAction=function(t){var n=this._callContainerAggregationMethod(\"removeContent\",t);return this._aCustomContent.splice(this._aCustomContent.indexOf(t),1),n},r.prototype.removeAllCustomActions=function(){var t=[];return this._aCustomContent.forEach(function(n){var e=this._callContainerAggregationMethod(\"removeContent\",n);e&&t.push(n)},this),this._aCustomContent=[],t},r.prototype.destroyCustomActions=function(){return this.removeAllCustomActions(!0).forEach(function(t){t.destroy()}),this},r.prototype.addContent=function(t,n){return this[\"_insertSemantic\"+r.mPlacementMethodMap[n]].call(this,t),this},r.prototype.removeContent=function(t,n){return this[\"_removeSemantic\"+r.mPlacementMethodMap[n]].call(this,t),this},r.prototype.destroy=function(){return this._aCustomContent=null,this._aSemanticLeftContent=null,this._aSemanticRightContent=null,this._oSpacer=null,i.prototype.destroy.call(this)},r.prototype._insertSemanticLeftContent=function(t){var n=this._getControl(t),e=this._getControlOrder(t),o=this._getSemanticLeftContentInsertIndex(e);return this._callContainerAggregationMethod(\"insertContent\",n,o),this._iSemanticLeftContentCount++,this._aSemanticLeftContent.push(t),this._preProcessControl(n),this},r.prototype._insertSemanticRightContent=function(t){var n=this._getControl(t);return this._aSemanticRightContent.push(t),this._callContainerAggregationMethod(\"insertContent\",n,this._getSemanticRightContentInsertIndex(t)),this},r.prototype._removeSemanticLeftContent=function(t){var n=this._getControl(t);return this._callContainerAggregationMethod(\"removeContent\",n),this._iSemanticLeftContentCount--,this._aSemanticLeftContent.splice(this._aSemanticLeftContent.indexOf(n),1),this._postProcessControl(n),t},r.prototype._removeSemanticRightContent=function(t){var n=this._getControl(t);return this._callContainerAggregationMethod(\"removeContent\",n),this._aSemanticRightContent.splice(this._aSemanticRightContent.indexOf(t),1),t},r.prototype._getSemanticLeftContentInsertIndex=function(t){return this._iSemanticLeftContentCount>1?t:0},r.prototype._getSemanticRightContentInsertIndex=function(t){return this._aSemanticRightContent.sort(this._sortControlByOrder.bind(this)),this._iSemanticLeftContentCount+this._aSemanticRightContent.indexOf(t)},r.prototype._getCustomContentInsertIndex=function(t){return t+this._iSemanticLeftContentCount+this._aSemanticRightContent.length},r.prototype._insertSpacer=function(){return this._callContainerAggregationMethod(\"addContent\",this._getSpacer()),this},r.prototype._getSpacer=function(){return this._oSpacer||(this._oSpacer=new n),this._oSpacer},r.prototype._preProcessControl=function(t){\"function\"!=typeof t._fnOriginalGetParent&&(t._fnOriginalGetParent=t.getParent,t.getParent=this._fnParentSubstitute)},r.prototype._postProcessControl=function(t){t._fnOriginalGetParent&&(t.getParent=t._fnOriginalGetParent,delete t._fnOriginalGetParent)},r},!1);",
		"sap/f/semantic/SemanticPage.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/base/ManagedObject\",\"sap/f/library\",\"sap/f/DynamicPage\",\"sap/f/DynamicPageTitle\",\"sap/f/DynamicPageHeader\",\"sap/m/OverflowToolbar\",\"sap/m/ActionSheet\",\"./SemanticTitle\",\"./SemanticFooter\",\"./SemanticShareMenu\",\"./SemanticConfiguration\"],function(t,e,o,n,i,a,r,s,l,c,p,u,g){\"use strict\";var h=e.extend(\"sap.f.semantic.SemanticPage\",{metadata:{library:\"sap.f\",properties:{headerExpanded:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},headerPinnable:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},preserveHeaderStateOnScroll:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},toggleHeaderOnTitleClick:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},showFooter:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},defaultAggregation:\"content\",aggregations:{titleHeading:{type:\"sap.ui.core.Control\",multiple:!1,defaultValue:null},titleSnappedContent:{type:\"sap.ui.core.Control\",multiple:!0},titleExpandedContent:{type:\"sap.ui.core.Control\",multiple:!0},titleMainAction:{type:\"sap.f.semantic.TitleMainAction\",multiple:!1},addAction:{type:\"sap.f.semantic.AddAction\",multiple:!1},deleteAction:{type:\"sap.f.semantic.DeleteAction\",multiple:!1},copyAction:{type:\"sap.f.semantic.CopyAction\",multiple:!1},flagAction:{type:\"sap.f.semantic.FlagAction\",multiple:!1},favoriteAction:{type:\"sap.f.semantic.FavoriteAction\",multiple:!1},fullScreenAction:{type:\"sap.f.semantic.FullScreenAction\",multiple:!1},exitFullScreenAction:{type:\"sap.f.semantic.ExitFullScreenAction\",multiple:!1},closeAction:{type:\"sap.f.semantic.CloseAction\",multiple:!1},titleCustomTextActions:{type:\"sap.m.Button\",multiple:!0},titleCustomIconActions:{type:\"sap.m.OverflowToolbarButton\",multiple:!0},headerContent:{type:\"sap.ui.core.Control\",multiple:!0},content:{type:\"sap.ui.core.Control\",multiple:!1},footerMainAction:{type:\"sap.f.semantic.FooterMainAction\",multiple:!1},messagesIndicator:{type:\"sap.f.semantic.MessagesIndicator\",multiple:!1},draftIndicator:{type:\"sap.m.DraftIndicator\",multiple:!1},positiveAction:{type:\"sap.f.semantic.PositiveAction\",multiple:!1},negativeAction:{type:\"sap.f.semantic.NegativeAction\",multiple:!1},footerCustomActions:{type:\"sap.m.Button\",multiple:!0},discussInJamAction:{type:\"sap.f.semantic.DiscussInJamAction\",multiple:!1},saveAsTileAction:{type:\"sap.m.Button\",multiple:!1},shareInJamAction:{type:\"sap.f.semantic.ShareInJamAction\",multiple:!1},sendMessageAction:{type:\"sap.f.semantic.SendMessageAction\",multiple:!1},sendEmailAction:{type:\"sap.f.semantic.SendEmailAction\",multiple:!1},printAction:{type:\"sap.f.semantic.PrintAction\",multiple:!1},customShareActions:{type:\"sap.m.Button\",multiple:!0},_dynamicPage:{type:\"sap.f.DynamicPage\",multiple:!1,visibility:\"hidden\"}}}});return h._EVENTS={SHARE_MENU_CONTENT_CHANGED:\"_shareMenuContentChanged\"},h._SAVE_AS_TILE_ACTION=\"saveAsTileAction\",h.prototype.init=function(){this._bSPBeingDestroyed=!1,this._initDynamicPage(),this._attachShareMenuButtonChange(),this._fnActionSubstituteParentFunction=function(){return this}.bind(this)},h.prototype.exit=function(){this._bSPBeingDestroyed=!0,this._cleanMemory()},h.prototype.setHeaderExpanded=function(t){return this._getPage().setHeaderExpanded(t),this},h.prototype.getHeaderExpanded=function(){return this._getPage().getHeaderExpanded()},h.prototype.setHeaderPinnable=function(t){var e=this._getPage(),o=e.getHeader();return o.setPinnable(t),this.setProperty(\"headerPinnable\",o.getPinnable(),!0)},h.prototype.setPreserveHeaderStateOnScroll=function(t){var e=this._getPage();return e.setPreserveHeaderStateOnScroll(t),this.setProperty(\"preserveHeaderStateOnScroll\",e.getPreserveHeaderStateOnScroll(),!0)},h.prototype.setToggleHeaderOnTitleClick=function(t){return this._getPage().setToggleHeaderOnTitleClick(t),this.setProperty(\"toggleHeaderOnTitleClick\",t,!0)},h.prototype.setShowFooter=function(t){return this._getPage().setShowFooter(t),this.setProperty(\"showFooter\",t,!0)},h.prototype.setAggregation=function(t,e,n){var i,a,r=this.mAggregations[t];return r===e?this:(e=this.validateAggregation(t,e,!1),i=t===h._SAVE_AS_TILE_ACTION?h._SAVE_AS_TILE_ACTION:this.getMetadata().getManagedAggregation(t).type,g.isKnownSemanticType(i)?(a=g.getPlacement(i),r&&(this._onRemoveAggregation(r,i),this._getSemanticContainer(a).removeContent(r,a)),e&&(e._getType=function(){return i},this._getSemanticContainer(a).addContent(e,a),this._onAddAggregation(e,i)),o.prototype.setAggregation.call(this,t,e,!0)):o.prototype.setAggregation.call(this,t,e,n))},h.prototype.destroyAggregation=function(t,e){var n,i,a,r=this.getMetadata().getAggregations()[t];return a=t===h._SAVE_AS_TILE_ACTION?h._SAVE_AS_TILE_ACTION:r&&r.type,a&&g.isKnownSemanticType(a)&&(n=o.prototype.getAggregation.call(this,t),n&&(i=g.getPlacement(a),this._onRemoveAggregation(n,a),!this._bSPBeingDestroyed&&this._getSemanticContainer(i).removeContent(n,i))),o.prototype.destroyAggregation.call(this,t,e)},[\"getTitleHeading\",\"setTitleHeading\",\"destroyTitleHeading\"].forEach(function(t){h.prototype[t]=function(e){var o=this._getTitle(),n=t.replace(/TitleHeading?/,\"Heading\");return o[n].apply(o,arguments)}},this),[\"addTitleExpandedContent\",\"insertTitleExpandedContent\",\"removeTitleExpandedContent\",\"indexOfTitleExpandedContent\",\"removeAllTitleExpandedContent\",\"destroyTitleExpandedContent\",\"getTitleExpandedContent\"].forEach(function(t){h.prototype[t]=function(e){var o=this._getTitle(),n=t.replace(/TitleExpandedContent?/,\"ExpandedContent\");return o[n].apply(o,arguments)}}),[\"addTitleSnappedContent\",\"insertTitleSnappedContent\",\"removeTitleSnappedContent\",\"indexOfTitleSnappedContent\",\"removeAllTitleSnappedContent\",\"destroyTitleSnappedContent\",\"getTitleSnappedContent\"].forEach(function(t){h.prototype[t]=function(e){var o=this._getTitle(),n=t.replace(/TitleSnappedContent?/,\"SnappedContent\");return o[n].apply(o,arguments)}}),[\"addHeaderContent\",\"insertHeaderContent\",\"removeHeaderContent\",\"indexOfHeaderContent\",\"removeAllHeaderContent\",\"destroyHeaderContent\",\"getHeaderContent\"].forEach(function(t){h.prototype[t]=function(e){var o=this._getHeader(),n=t.replace(/HeaderContent?/,\"Content\");return o[n].apply(o,arguments)}}),[\"getContent\",\"setContent\",\"destroyContent\"].forEach(function(t){h.prototype[t]=function(e){var o=this._getPage();return o[t].apply(o,arguments)}},this),[\"addTitleCustomTextAction\",\"insertTitleCustomTextAction\",\"indexOfTitleCustomTextAction\",\"removeTitleCustomTextAction\",\"removeAllTitleCustomTextActions\",\"destroyTitleCustomTextActions\",\"getTitleCustomTextActions\"].forEach(function(t){h.prototype[t]=function(){var e=this._getSemanticTitle(),o=t.replace(/TitleCustomTextAction?/,\"CustomTextAction\");return e[o].apply(e,arguments)}},this),[\"addTitleCustomIconAction\",\"insertTitleCustomIconAction\",\"indexOfTitleCustomIconAction\",\"removeTitleCustomIconAction\",\"removeAllTitleCustomIconActions\",\"destroyTitleCustomIconActions\",\"getTitleCustomIconActions\"].forEach(function(t){h.prototype[t]=function(){var e=this._getSemanticTitle(),o=t.replace(/TitleCustomIconAction?/,\"CustomIconAction\");return e[o].apply(e,arguments)}},this),[\"addFooterCustomAction\",\"insertFooterCustomAction\",\"indexOfFooterCustomAction\",\"removeFooterCustomAction\",\"removeAllFooterCustomActions\",\"destroyFooterCustomActions\",\"getFooterCustomActions\"].forEach(function(t){h.prototype[t]=function(){var e=this._getSemanticFooter(),o=t.replace(/FooterCustomAction?/,\"CustomAction\");return e[o].apply(e,arguments)}},this),[\"addCustomShareAction\",\"insertCustomShareAction\",\"indexOfCustomShareAction\",\"removeCustomShareAction\",\"removeAllCustomShareActions\",\"destroyCustomShareActions\",\"getCustomShareActions\"].forEach(function(t){h.prototype[t]=function(){var e=this._getShareMenu(),o=t.replace(/CustomShareAction?/,\"CustomAction\");return e[o].apply(e,arguments)}},this),h.prototype._onAddAggregation=function(t,e){e===h._SAVE_AS_TILE_ACTION&&this._replaceParent(t)},h.prototype._onRemoveAggregation=function(t,e){e===h._SAVE_AS_TILE_ACTION&&this._restoreParent(t),t._getType&&delete t._getType},h.prototype._replaceParent=function(t){t._fnOriginalGetParent||(t._fnOriginalGetParent=t.getParent,t.getParent=this._fnActionSubstituteParentFunction)},h.prototype._restoreParent=function(t){t&&t._fnOriginalGetParent&&(t.getParent=t._fnOriginalGetParent)},h.prototype._attachShareMenuButtonChange=function(){this.attachEvent(h._EVENTS.SHARE_MENU_CONTENT_CHANGED,this._onShareMenuContentChanged,this)},h.prototype._onShareMenuContentChanged=function(t){var e=t.getParameter(\"bEmpty\"),o=this._getSemanticTitle(),n=this._getShareMenu(),i=n._getShareMenuButton();return i.getParent()?void i.setVisible(!e):void o.addContent(i,\"shareIcon\")},h.prototype._getPage=function(){return this.getAggregation(\"_dynamicPage\")||this._initDynamicPage(),this.getAggregation(\"_dynamicPage\")},h.prototype._initDynamicPage=function(){this.setAggregation(\"_dynamicPage\",new i(this.getId()+\"-page\",{title:this._getTitle(),header:this._getHeader(),footer:this._getFooter()}),!0)},h.prototype._getTitle=function(){return this._oDynamicPageTitle||(this._oDynamicPageTitle=this._getSemanticTitle()._getContainer()),this._oDynamicPageTitle},h.prototype._getHeader=function(){return this._oDynamicPageHeader||(this._oDynamicPageHeader=new r(this.getId()+\"-pageHeader\")),this._oDynamicPageHeader},h.prototype._getFooter=function(){return this._oDynamicPageFooter||(this._oDynamicPageFooter=this._getSemanticFooter()._getContainer()),this._oDynamicPageFooter},h.prototype._getSemanticTitle=function(){return this._oSemanticTitle||(this._oSemanticTitle=new c(new a(this.getId()+\"-pageTitle\"),this)),this._oSemanticTitle},h.prototype._getShareMenu=function(){return this._oShareMenu||(this._oShareMenu=new u(this._getActionSheet(),this)),this._oShareMenu},h.prototype._getActionSheet=function(){return this._oActionSheet||(this._oActionSheet=new l(this.getId()+\"-shareMenu\")),this._oActionSheet},h.prototype._getSemanticFooter=function(){return this._oSemanticFooter||(this._oSemanticFooter=new p(this._getOverflowToolbar(),this)),this._oSemanticFooter},h.prototype._getOverflowToolbar=function(){return this._oOverflowToolbar||(this._oOverflowToolbar=new s(this.getId()+\"-pageFooter\")),this._oOverflowToolbar},h.prototype._getSemanticContainer=function(t){var e=g._Placement;return t===e.titleText||t===e.titleIcon?this._getSemanticTitle():t===e.footerLeft||t===e.footerRight?this._getSemanticFooter():t===e.shareMenu?this._getShareMenu():null},h.prototype._cleanMemory=function(){this._oShareMenu&&(this._oShareMenu.destroy(),this._oShareMenu=null),this._oActionSheet&&(this._oActionSheet.destroy(),this._oActionSheet=null),this._oSemanticTitle&&(this._oSemanticTitle.destroy(),this._oSemanticTitle=null),this._oDynamicPageTitle&&(this._oDynamicPageTitle.destroy(),this._oDynamicPageTitle=null),this._oDynamicPageHeader&&(this._oDynamicPageHeader.destroy(),this._oDynamicPageHeader=null),this._oSemanticFooter&&(this._oSemanticFooter.destroy(),this._oSemanticFooter=null),this._oDynamicPageFooter&&(this._oDynamicPageFooter.destroy(),this._oDynamicPageFooter=null),this._oOverflowToolbar&&(this._oOverflowToolbar.destroy(),this._oOverflowToolbar=null)},h},!0);",
		"sap/f/semantic/SemanticPageRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(\"sap/f/semantic/SemanticPageRenderer\",[],function(){\"use strict\";var e={};return e.render=function(e,r){e.write(\"<div\"),e.writeControlData(r),e.addClass(\"sapFSemanticPage\"),e.writeClasses(),e.write(\">\"),e.renderControl(r._getPage()),e.write(\"</div>\")},e},!0);",
		"sap/f/semantic/SemanticShareMenu.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/IconPool\",\"sap/ui/base/EventProvider\",\"sap/m/Button\",\"sap/m/ButtonType\",\"sap/m/OverflowToolbarButton\",\"sap/m/OverflowToolbarLayoutData\",\"./SemanticConfiguration\",\"./SemanticContainer\"],function(t,e,o,n,i,r,s,a,h){\"use strict\";var u=h.extend(\"sap.f.semantic.SemanticShareMenu\",{constructor:function(t,e){h.call(this,t,e),this._aShareMenuActions=[],this._aCustomShareActions=[],this._setMode(u._Mode.initial)}});return u._Mode={initial:\"initial\",menu:\"menu\"},u.prototype.addCustomAction=function(t){return this._onControlAdded(t),this._callContainerAggregationMethod(\"insertButton\",t,this._getCustomActionInsertIndex()),this._aCustomShareActions.push(t),this},u.prototype.insertCustomAction=function(t,e){return this._onControlAdded(t),this._callContainerAggregationMethod(\"insertButton\",t,this._getCustomActionInsertIndex(e)),this._aCustomShareActions.splice(e,0,t),this},u.prototype.getCustomActions=function(){return this._aCustomShareActions},u.prototype.indexOfCustomAction=function(t){return this._aCustomShareActions.indexOf(t)},u.prototype.removeCustomAction=function(t){var e=this._callContainerAggregationMethod(\"removeButton\",t);return this._aCustomShareActions.splice(this._aCustomShareActions.indexOf(t),1),this._onControlRemoved(),e},u.prototype.removeAllCustomActions=function(){var t=[];return this._aCustomShareActions.forEach(function(e){var o=this._callContainerAggregationMethod(\"removeButton\",e);o&&t.push(e)},this),this._aCustomShareActions=[],this._onControlRemoved(),t},u.prototype.destroyCustomActions=function(){return this.removeAllCustomActions(!0).forEach(function(t){t.destroy()}),this},u.prototype.addContent=function(t){var e=this._getControl(t);return this._onControlAdded(e),this._aShareMenuActions.push(t),this._preProcessOverflowToolbarButton(e),this._callContainerAggregationMethod(\"insertButton\",e,this._getSemanticActionInsertIndex(t)),this},u.prototype.removeContent=function(t){var e=this._getControl(t);return this._callContainerAggregationMethod(\"removeButton\",e),this._aShareMenuActions.splice(this._aShareMenuActions.indexOf(t),1),this._postProcessOverflowToolbarButton(t),this._onControlRemoved(),this},u.prototype.destroy=function(){return this._oShareMenuBtn=null,this._aShareMenuActions=null,this._aCustomShareActions=null,h.prototype.destroy.call(this)},u.prototype._getMode=function(){return this._mode},u.prototype._setMode=function(t){return this._getMode()===t?this:t===u._Mode.initial?(this._getMode()&&this._fireContentChanged(!0),this._mode=u._Mode.initial,this):(t===u._Mode.menu&&(this._mode=u._Mode.menu,this._fireContentChanged(!1)),this)},u.prototype._fireContentChanged=function(t){o.prototype.fireEvent.call(this._getParent(),\"_shareMenuContentChanged\",{bEmpty:t})},u.prototype._getShareMenuButton=function(){var t=this._getContainer();return this._oShareMenuBtn||(this._oShareMenuBtn=new r(t.getId()+\"-shareButton\",{icon:e.getIconURI(\"action\"),tooltip:sap.ui.getCore().getLibraryResourceBundle(\"sap.f\").getText(\"SEMANTIC_CONTROL_ACTION_SHARE\"),layoutData:new s({closeOverflowOnInteraction:!1}),text:sap.ui.getCore().getLibraryResourceBundle(\"sap.f\").getText(\"SEMANTIC_CONTROL_ACTION_SHARE\"),type:i.Transparent,press:function(){t.openBy(this._oShareMenuBtn)}.bind(this)}),this._oShareMenuBtn.addEventDelegate({onAfterRendering:function(){this._oShareMenuBtn.$().attr(\"aria-haspopup\",!0)}.bind(this)},this)),this._oShareMenuBtn},u.prototype._getCustomActionInsertIndex=function(t){var e=this._aCustomShareActions.length;return void 0===t?this._aShareMenuActions.length+e:(t=t>=e?e:t,t+=this._aShareMenuActions.length)},u.prototype._getSemanticActionInsertIndex=function(t){return this._aShareMenuActions.sort(this._sortControlByOrder.bind(this)),this._aShareMenuActions.indexOf(t)},u.prototype._onControlAdded=function(t){this._isInitialMode()&&this._setMode(u._Mode.menu,t)},u.prototype._onControlRemoved=function(){var t=this._aShareMenuActions.length,e=this._aCustomShareActions.length,o=t+e===0;this._isMenuMode()&&o&&this._setMode(u._Mode.initial)},u.prototype._preProcessOverflowToolbarButton=function(t){t instanceof r&&(t._bInOverflow=!0)},u.prototype._postProcessOverflowToolbarButton=function(t){t instanceof r&&delete t._bInOverflow},u.prototype._isInitialMode=function(){return this._getMode()===u._Mode.initial},u.prototype._isMenuMode=function(){return this._getMode()===u._Mode.menu},u},!1);",
		"sap/f/semantic/SemanticTitle.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/ButtonType\",\"sap/m/ToolbarSeparator\",\"sap/m/ToolbarSpacer\",\"./SemanticConfiguration\",\"./SemanticContainer\"],function(t,n,o,e,i,s){\"use strict\";var r=s.extend(\"sap.f.semantic.SemanticTitle\",{constructor:function(t,n){s.call(this,t,n),this._iMainActionCount=0,this._aSemanticTextActions=[],this._aSemanticSimpleIconActions=[],this._aSemanticNavIconActions=[],this._aCustomTextActions=[],this._aCustomIconActions=[],this._insertSeparator(),this._attachContainerWidthChange()}});return r.mPlacementMethodMap={titleText:\"TextContent\",titleIcon:\"IconContent\",shareIcon:\"ShareContent\"},r.prototype.addContent=function(t,n){return this[\"_insertSemantic\"+r.mPlacementMethodMap[n]].call(this,t),this},r.prototype.removeContent=function(t,n){return this[\"_removeSemantic\"+r.mPlacementMethodMap[n]].call(this,t),this},r.prototype.destroy=function(){return this._aSemanticSimpleIconActions=null,this._aSemanticTextActions=null,this._aCustomTextActions=null,this._aCustomIconActions=null,this._aSemanticNavIconActions=null,this._oSeparator=null,s.prototype.destroy.call(this)},r.prototype.addCustomTextAction=function(t){return t.setType(n.Transparent),this._callContainerAggregationMethod(\"insertAction\",t,this._getCustomTextActionInsertIndex()),this._aCustomTextActions.push(t),this},r.prototype.insertCustomTextAction=function(t,o){return t.setType(n.Transparent),this._callContainerAggregationMethod(\"insertAction\",t,this._getCustomTextActionInsertIndex(o)),this._aCustomTextActions.splice(o,0,t),this},r.prototype.indexOfCustomTextAction=function(t){return this._aCustomTextActions.indexOf(t)},r.prototype.removeCustomTextAction=function(t){var n=this._aCustomTextActions.indexOf(t),o=this._callContainerAggregationMethod(\"removeAction\",t);return this._aCustomTextActions.splice(n,1),o},r.prototype.removeAllCustomTextActions=function(){var t=[];return this._aCustomTextActions.forEach(function(n){var o=this._callContainerAggregationMethod(\"removeAction\",n);o&&t.push(n)},this),this._aCustomTextActions=[],t},r.prototype.destroyCustomTextActions=function(){return this.removeAllCustomTextActions().forEach(function(t){t.destroy()}),this},r.prototype.getCustomTextActions=function(){return this._aCustomTextActions},r.prototype.addCustomIconAction=function(t){return t.setType(n.Transparent),this._callContainerAggregationMethod(\"insertAction\",t,this._getCustomIconActionInsertIndex()),this._aCustomIconActions.push(t),this},r.prototype.insertCustomIconAction=function(t,o){return t.setType(n.Transparent),this._callContainerAggregationMethod(\"insertAction\",t,this._getCustomIconActionInsertIndex(o)),this._aCustomIconActions.splice(o,0,t),this},r.prototype.indexOfCustomIconAction=function(t){return this._aCustomIconActions.indexOf(t)},r.prototype.removeCustomIconAction=function(t){var n=this._aCustomIconActions.indexOf(t),o=this._callContainerAggregationMethod(\"removeAction\",t);return this._aCustomIconActions.splice(n,1),o},r.prototype.removeAllCustomIconActions=function(){var t=[];return this._aCustomIconActions.forEach(function(n){var o=this._callContainerAggregationMethod(\"removeAction\",n);o&&t.push(n)},this),this._aCustomIconActions=[],t},r.prototype.destroyCustomIconActions=function(){return this.removeAllCustomIconActions().forEach(function(t){t.destroy()}),this},r.prototype.getCustomIconActions=function(){return this._aCustomIconActions},r.prototype._insertSemanticTextContent=function(t){var n,o=this._getControl(t),e=this._isMainAction(t);return this._aSemanticTextActions.push(t),e?(this._iMainActionCount++,n=this._getSemanticTextMainActionInsertIndex()):n=this._getSemanticTextActionInsertIndex(t),this._callContainerAggregationMethod(\"insertAction\",o,n),this},r.prototype._removeSemanticTextContent=function(t){var n=this._getControl(t),o=this._aSemanticTextActions.indexOf(t),e=this._isMainAction(t);return e&&this._iMainActionCount--,this._aSemanticTextActions.splice(o,1),this._callContainerAggregationMethod(\"removeAction\",n),this},r.prototype._insertSemanticIconContent=function(t){var n=this._getControl(t),o=0;return this._isNavigationAction(t)?(this._aSemanticNavIconActions.push(t),o=this._getSemanticNavIconActionInsertIndex(t)):(this._aSemanticSimpleIconActions.push(t),o=this._getSemanticSimpleIconActionInsertIndex(t)),this._callContainerAggregationMethod(\"insertAction\",n,o),this},r.prototype._removeSemanticIconContent=function(t){var n,o=this._getControl(t);return this._isNavigationAction(t)?(n=this._aSemanticNavIconActions.indexOf(t),this._aSemanticNavIconActions.splice(n,1)):(n=this._aSemanticTextActions.indexOf(t),this._aSemanticSimpleIconActions.splice(n,1)),this._callContainerAggregationMethod(\"removeAction\",o),this},r.prototype._insertSemanticShareContent=function(t){var n=this._getControl(t),o=this._getSemanticShareMenuInsertIndex();return this._callContainerAggregationMethod(\"insertAction\",n,o),this},r.prototype._removeSemanticShareContent=function(t){var n=this._getControl(t);return this._callContainerAggregationMethod(\"removeAction\",n),this},r.prototype._getSemanticTextMainActionInsertIndex=function(){return 0},r.prototype._getCustomTextActionInsertIndex=function(t){var n=this._aCustomTextActions.length;return void 0===t?this._iMainActionCount+n:(t=t>=n?n:t,t+=this._iMainActionCount)},r.prototype._getSemanticTextActionInsertIndex=function(t){return this._aSemanticTextActions.sort(this._sortControlByOrder.bind(this)),this._getCustomTextActionInsertIndex()+this._aSemanticTextActions.indexOf(t)-this._iMainActionCount},r.prototype._getCustomIconActionInsertIndex=function(t){var n=this._aCustomIconActions.length,o=this._aCustomTextActions.length+this._aSemanticTextActions.length;return void 0===t?o+n:(t=t>=n?n:t,t+=o)},r.prototype._getSemanticSimpleIconActionInsertIndex=function(t){return this._aSemanticSimpleIconActions.sort(this._sortControlByOrder.bind(this)),this._getCustomIconActionInsertIndex()+this._aSemanticSimpleIconActions.indexOf(t)},r.prototype._getSemanticNavIconActionInsertIndex=function(t){return this._aSemanticNavIconActions.sort(this._sortControlByOrder.bind(this)),this._getSeparatorIndex()+this._aSemanticNavIconActions.indexOf(t)+1},r.prototype._getSemanticShareMenuInsertIndex=function(){return this._getSeparatorIndex()},r.prototype._getSeparatorIndex=function(){return this._callContainerAggregationMethod(\"indexOfAction\",this._oSeparator)},r.prototype._updateSeparatorVisibility=function(){var t,n=this._getContainerBar();n&&(t=n._getVisibleAndNonOverflowContent(),t.length>0&&this._toggleSeparator(this._shouldSeparatorBeVisible(t)))},r.prototype._shouldSeparatorBeVisible=function(t){var n=t[0],e=t[t.length-1];return!(n instanceof o||e instanceof o)},r.prototype._toggleSeparator=function(t){var n=this._getSeparator().$();n.length>0&&n.toggleClass(\"sapUiHidden\",!t)},r.prototype._insertSeparator=function(){return this._callContainerAggregationMethod(\"addAction\",this._getSeparator()),this},r.prototype._getSeparator=function(){return this._oSeparator||(this._oSeparator=new o,this._oSeparator.addStyleClass(\"sapUiHidden\")),this._oSeparator},r.prototype._attachContainerWidthChange=function(){var t=this._getContainerBar();t&&t.attachEvent(\"_controlWidthChanged\",this._onContainerWidthChanged,this)},r.prototype._onContainerWidthChanged=function(){t.sap.delayedCall(0,this,this._updateSeparatorVisibility)},r.prototype._getContainerBar=function(){var t=this._getContainer();return t?t.getAggregation(\"_overflowToolbar\"):null},r},!1);",
		"sap/f/semantic/SemanticToggleButton.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./SemanticButton\",\"./SemanticControl\",\"sap/m/ButtonType\"],function(e,t,s){\"use strict\";var o=e.extend(\"sap.f.semantic.SemanticToggleButton\",{metadata:{library:\"sap.f\",abstract:!0,properties:{pressed:{type:\"boolean\",group:\"Data\",defaultValue:!1}}}});return o.prototype._onTap=function(e){e.setMarked(),this.getEnabled()&&(this.setPressed(!this.getPressed()),this.firePress({pressed:this.getPressed()}))},o.prototype._onKeydown=function(e){e.which!==jQuery.sap.KeyCodes.SPACE&&e.which!==jQuery.sap.KeyCodes.ENTER||this._onTap(e)},o.prototype._applyProperty=function(t,s,o){\"pressed\"===t?this._setPressed(s,o):e.prototype._applyProperty.apply(this,arguments)},o.prototype._setPressed=function(e,t){var o=e?s.Emphasized:s.Transparent;this._getControl().setType(o,t)},o.prototype._createInstance=function(e){var t=new e({id:this.getId()+\"-toggleButton\"});return t.addEventDelegate({ontap:this._onTap,onkeydown:this._onKeydown},this),t},o},!1);",
		"sap/f/semantic/SendEmailAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(a){\"use strict\";var t=a.extend(\"sap.f.semantic.SendEmailAction\",{metadata:{library:\"sap.f\"}});return t},!0);",
		"sap/f/semantic/SendMessageAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(a){\"use strict\";var e=a.extend(\"sap.f.semantic.SendMessageAction\",{metadata:{library:\"sap.f\"}});return e},!0);",
		"sap/f/semantic/ShareInJamAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/semantic/SemanticButton\"],function(a){\"use strict\";var t=a.extend(\"sap.f.semantic.ShareInJamAction\",{metadata:{library:\"sap.f\"}});return t},!0);",
		"sap/f/semantic/TitleMainAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./MainAction\"],function(a){\"use strict\";var i=a.extend(\"sap.f.semantic.TitleMainAction\",{metadata:{library:\"sap.f\"}});return i},!0);",
		"sap/f/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.f\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"8.0.0-0\"},\"title\":\"The OpenUI5-based library, sap.f.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{},\"sap.m\":{}}},\"library\":{\"i18n\":\"messagebundle.properties\"}}}"
	},
	"dependencies": ["sap.ui.core.library-preload","sap.m.library-preload"],
	"sas-uglified": true
});