jQuery.sap.registerPreloadedModules({
	"version": "2.0",
	"name": "sap.ui.fl.library-preload",
	"modules": {
		"sap/ui/fl/Cache.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\"],function(e){\"use strict\";var n=function(){};return n._isOn=!0,n._entries={},n._switches={},n.getSwitches=function(){return n._switches},n.isActive=function(){return n._isOn},n.setActive=function(e){n._isOn=e},n.getEntries=function(){return n._entries},n.clearEntries=function(){n._entries={}},n.getEntry=function(e,t){return n._entries[e]||(n._entries[e]={}),n._entries[e][t]||(n._entries[e][t]={file:{changes:{changes:[]}}}),n._entries[e][t]},n.clearEntry=function(e,t){n.getEntry(e,t),n._entries[e][t]={}},n.getChangesFillingCache=function(t,i,r){if(!this.isActive())return t.loadChanges(i,r);var s=i.name,a=i.appVersion||e.DEFAULT_APP_VERSION,c=n.getEntry(s,a);if(c.promise)return c.promise;if(r&&\"<NO CHANGES>\"===r.cacheKey)return Promise.resolve({changes:{changes:[],contexts:[]},componentClassName:s});var o=t.loadChanges(i,r).then(function(t){return c.file&&e.log.error(\"sap.ui.fl.Cache: Cached changes for component \"+s+\" overwritten.\"),t&&t.changes&&t.changes.settings&&t.changes.settings.switchedOnBusinessFunctions&&t.changes.settings.switchedOnBusinessFunctions.forEach(function(e){n._switches[e]=!0}),c.file=t,c.file},function(e){throw delete c.promise,e});return c.promise=o,o},n._getChangeArray=function(t){var i=t.name,r=t.appVersion||e.DEFAULT_APP_VERSION,s=n.getEntry(i,r);return s.file.changes.changes},n.addChange=function(e,t){var i=n._getChangeArray(e);i&&i.push(t)},n.updateChange=function(e,t){var i=n._getChangeArray(e);if(i)for(var r=0;r<i.length;r++)if(i[r].fileName===t.fileName){i.splice(r,1,t);break}},n.deleteChange=function(e,t){var i=n._getChangeArray(e);if(i)for(var r=0;r<i.length;r++)if(i[r].fileName===t.fileName){i.splice(r,1);break}},n},!0);",
		"sap/ui/fl/Change.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/base/EventProvider\",\"sap/ui/fl/Utils\",\"sap/ui/fl/registry/Settings\"],function(e,t,i){\"use strict\";var n=function(i){e.apply(this),\"object\"!=typeof i&&t.log.error(\"Constructor : sap.ui.fl.Change : oFile is not defined\"),this._oDefinition=i,this._oOriginDefinition=JSON.parse(JSON.stringify(i)),this._sRequest=\"\",this._bIsDeleted=!1,this._bUserDependent=\"USER\"===i.layer};return n.events={markForDeletion:\"markForDeletion\"},n.prototype=jQuery.sap.newObject(e.prototype),n.prototype.isValid=function(){var e=!0;return\"object\"!=typeof this._oDefinition&&(e=!1),this._oDefinition.fileType||(e=!1),this._oDefinition.fileName||(e=!1),this._oDefinition.changeType||(e=!1),this._oDefinition.layer||(e=!1),this._oDefinition.originalLanguage||(e=!1),e},n.prototype.isVariant=function(){return\"variant\"===this._oDefinition.fileType},n.prototype.getChangeType=function(){if(this._oDefinition)return this._oDefinition.changeType},n.prototype.getOriginalLanguage=function(){return this._oDefinition&&this._oDefinition.originalLanguage?this._oDefinition.originalLanguage:\"\"},n.prototype.getContext=function(){return this._oDefinition&&this._oDefinition.context?this._oDefinition.context:\"\"},n.prototype.getPackage=function(){return this._oDefinition.packageName},n.prototype.getNamespace=function(){return this._oDefinition.namespace},n.prototype.getId=function(){return this._oDefinition.fileName},n.prototype.getContent=function(){return this._oDefinition.content},n.prototype.setContent=function(e){this._oDefinition.content=e},n.prototype.getSelector=function(){return this._oDefinition.selector},n.prototype.getOwnerId=function(){return this._oDefinition.support?this._oDefinition.support.user:\"\"},n.prototype.getText=function(e){return\"string\"!=typeof e&&t.log.error(\"sap.ui.fl.Change.getTexts : sTextId is not defined\"),this._oDefinition.texts&&this._oDefinition.texts[e]?this._oDefinition.texts[e].value:\"\"},n.prototype.setText=function(e,i){return\"string\"!=typeof e?void t.log.error(\"sap.ui.fl.Change.setTexts : sTextId is not defined\"):void(this._oDefinition.texts&&this._oDefinition.texts[e]&&(this._oDefinition.texts[e].value=i))},n.prototype.isReadOnly=function(){return this._isReadOnlyDueToLayer()||this._isReadOnlyWhenNotKeyUser()},n.prototype._isReadOnlyWhenNotKeyUser=function(){if(this.isUserDependent())return!1;var e=this.getDefinition().reference;if(!e)return!0;var t=i.getInstanceOrUndef();return!t||!t.isKeyUser()},n.prototype.isLabelReadOnly=function(){return!!this._isReadOnlyDueToLayer()||this._isReadOnlyDueToOriginalLanguage()},n.prototype._isReadOnlyDueToLayer=function(){var e;return e=t.getCurrentLayer(this._bUserDependent),this._oDefinition.layer!==e},n.prototype._isReadOnlyDueToOriginalLanguage=function(){var e,i;return!!(i=this.getOriginalLanguage())&&(e=t.getCurrentLanguage(),e!==i)},n.prototype.markForDeletion=function(){this._bIsDeleted=!0},n.prototype._isDirty=function(){var e=JSON.stringify(this._oDefinition),t=JSON.stringify(this._oOriginDefinition);return e!==t},n.prototype.setRequest=function(e){\"string\"!=typeof e&&t.log.error(\"sap.ui.fl.Change.setRequest : sRequest is not defined\"),this._sRequest=e},n.prototype.getRequest=function(){return this._sRequest},n.prototype.getLayer=function(){return this._oDefinition.layer},n.prototype.getComponent=function(){return this._oDefinition.reference},n.prototype.getCreation=function(){return this._oDefinition.creation},n.prototype.isUserDependent=function(){return this._bUserDependent},n.prototype.getPendingAction=function(){return this._bIsDeleted?\"DELETE\":this._oDefinition.creation?this._isDirty()===!0?\"UPDATE\":\"NONE\":\"NEW\"},n.prototype.getDefinition=function(){return this._oDefinition},n.prototype.setResponse=function(e){var t=JSON.stringify(e);t&&(this._oDefinition=JSON.parse(t),this._oOriginDefinition=JSON.parse(t))},n.prototype.getFullFileIdentifier=function(){var e=this.getLayer(),t=this.getNamespace(),i=this.getDefinition().fileName,n=this.getDefinition().fileType;return e+\"/\"+t+\"/\"+i+\".\"+n},n.prototype.addDependentControl=function(e,t,i,n){if(!e)throw new Error(\"Parameter vControl is mandatory\");if(!t)throw new Error(\"Parameter sAlias is mandatory\");if(!i)throw new Error(\"Parameter mPropertyBag is mandatory\");if(this._oDefinition.dependentSelector||(this._oDefinition.dependentSelector={}),this._oDefinition.dependentSelector[t])throw new Error(\"Alias '\"+t+\"' already exists in the change.\");var o=i.modifier,r=i.appComponent;if(Array.isArray(e)){var s=[];e.forEach(function(e){s.push(o.getSelector(e,r,n))}),this._oDefinition.dependentSelector[t]=s}else this._oDefinition.dependentSelector[t]=o.getSelector(e,r,n);delete this._aDependentIdList},n.prototype.getDependentControl=function(e,t){var i,n=[];if(!e)throw new Error(\"Parameter sAlias is mandatory\");if(!t)throw new Error(\"Parameter mPropertyBag is mandatory\");var o=t.modifier,r=t.appComponent;if(this._oDefinition.dependentSelector)return i=this._oDefinition.dependentSelector[e],Array.isArray(i)?(i.forEach(function(e){n.push(o.bySelector(e,r,t.view))}),n):o.bySelector(i,r,t.view)},n.prototype.getDependentIdList=function(e){var t,i=this,n=[this.getSelector()],o=[];return this._aDependentIdList||(this._oDefinition.dependentSelector&&(n=Object.keys(this._oDefinition.dependentSelector).reduce(function(e,t){return e.concat(i._oDefinition.dependentSelector[t])},n)),n.forEach(function(i){t=i.id,i.idIsLocal&&(t=e.createId(i.id)),o.indexOf(t)===-1&&o.push(t)}),this._aDependentIdList=o),this._aDependentIdList},n.prototype.getKey=function(){return this._oDefinition.fileName+this._oDefinition.layer+this._oDefinition.namespace},n.createInitialFileContent=function(e){e||(e={});var i={fileName:e.id||t.createDefaultFileName(e.changeType),fileType:e.isVariant?\"variant\":\"change\",changeType:e.changeType||\"\",reference:e.reference||\"\",packageName:e.packageName||\"\",content:e.content||{},selector:e.selector||{},layer:e.layer||t.getCurrentLayer(e.isUserDependent),texts:e.texts||{},namespace:e.namespace||t.createNamespace(e,\"changes\"),creation:\"\",originalLanguage:t.getCurrentLanguage(),conditions:{},context:e.context||\"\",support:{generator:\"Change.createInitialFileContent\",service:e.service||\"\",user:\"\",sapui5Version:sap.ui.version},dependentSelector:e.dependentSelector||{},validAppVersions:e.validAppVersions||{}};return i},n},!0);",
		"sap/ui/fl/changeHandler/Base.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\",\"jquery.sap.global\"],function(t,e){\"use strict\";var s={};return s.setTextInChange=function(t,e,s,n){t.texts||(t.texts={}),t.texts[e]||(t.texts[e]={}),t.texts[e].value=s,t.texts[e].type=n},s},!0);",
		"sap/ui/fl/changeHandler/BaseRename.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\",\"sap/ui/fl/Utils\"],function(e,t,n){\"use strict\";var r={createRenameChangeHandler:function(e){return e.changePropertyName=e.changePropertyName||\"newText\",{applyChange:function(t,r,i){var o=i.modifier,a=e.propertyName,p=t.getDefinition(),l=p.texts[e.changePropertyName],f=l.value;return p.texts&&l&&\"string\"==typeof f?(n.isBinding(f)?o.setPropertyBinding(r,a,f):o.setProperty(r,a,f),!0):void n.log.error(\"Change does not contain sufficient information to be applied: [\"+p.layer+\"]\"+p.namespace+\"/\"+p.fileName+\".\"+p.fileType)},completeChangeContent:function(n,r,i){var o=n.getDefinition(),a=e.changePropertyName,p=e.translationTextType,l=i.modifier.bySelector(n.getSelector(),i.appComponent);if(o.content.originalControlType=i.modifier.getControlType(l),\"string\"!=typeof r.value)throw new Error(\"oSpecificChangeInfo.value attribute required\");t.setTextInChange(o,a,r.value,p)}}}};return r},!0);",
		"sap/ui/fl/changeHandler/BaseTreeModifier.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\",\"sap/ui/base/ManagedObject\"],function(e,t){\"use strict\";return{bySelector:function(e,t,o){var r=this.getControlIdBySelector(e,t);return this._byId(r,o)},getControlIdBySelector:function(e,t){if(e){\"string\"==typeof e&&(e={id:e});var o=e.id;if(e.idIsLocal){if(!t)throw new Error(\"App Component instance needed to get a control's id from selector\");o=t.createId(o)}else{var r=/^application-[^-]*-[^-]*-component---/gim,i=!!r.exec(e.id);if(i){if(o=o.replace(/^application-[^-]*-[^-]*-component---/g,\"\"),!t)throw new Error(\"App Component instance needed to get a control's id from selector\");o=t.createId(o)}}return o}},getSelector:function(o,r,i){var n=o;if(o instanceof t)n=o.getId();else if(!r)throw new Error(\"App Component instance needed to get a selector from string id\");if(i&&(i.id||i.idIsLocal))throw new Error(\"A selector of control with the id '\"+n+\"' was requested, but core properties were overwritten by the additionally passed information.\");var a=e.checkControlId(o,r);if(!a)throw new Error(\"Generated id attribute found - to offer flexibility a stable control id is needed to assign the changes to, but for this control the id was generated by SAPUI5 \"+n);var d=jQuery.extend(i||{},{id:\"\",idIsLocal:!1},!0);if(e.hasLocalIdSuffix(o,r)){var c=r.getLocalId(n);d.id=c,d.idIsLocal=!0}else d.id=n;return d}}});",
		"sap/ui/fl/changeHandler/HideControl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\"],function(e,n){\"use strict\";var t={};return t.applyChange=function(e,n,t){return t.modifier.setVisible(n,!1),!0},t.completeChangeContent=function(e,n){},t},!0);",
		"sap/ui/fl/changeHandler/JsControlTreeModifier.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/changeHandler/BaseTreeModifier\",\"sap/ui/fl/Utils\"],function(t,e){\"use strict\";var r={targets:\"jsControlTree\",setVisible:function(t,e){if(!t.setVisible)throw new Error(\"Provided control instance has no setVisible method\");this.unbindProperty(t,\"visible\"),t.setVisible(e)},getVisible:function(t){if(t.getVisible)return t.getVisible();throw new Error(\"Provided control instance has no getVisible method\")},setStashed:function(t,e){if(!t.setStashed)throw new Error(\"Provided control instance has no setStashed method\");t.setVisible&&t.setVisible(!e),t.setStashed(e)},bindProperty:function(t,e,r){t.bindProperty(e,r)},unbindProperty:function(t,e){t&&t.unbindProperty(e,!0)},setProperty:function(t,e,r){var i=t.getMetadata().getPropertyLikeSetting(e);if(this.unbindProperty(t,e),i){var n=i._sMutator;t[n](r)}},getProperty:function(t,e){var r=t.getMetadata().getPropertyLikeSetting(e);if(r){var i=r._sGetter;return t[i]()}},setPropertyBinding:function(t,e,r){var i={};i[e]=r,t.applySettings(i)},createControl:function(t,e,r,i){if(this.bySelector(i,e))throw new Error(\"Can't create a control with duplicated id \"+i);jQuery.sap.require(t);var n=jQuery.sap.getObject(t),a=this.getControlIdBySelector(i,e);return new n(a)},byId:function(t){return this._byId(t)},_byId:function(t){return sap.ui.getCore().byId(t)},getId:function(t){return t.getId()},getParent:function(t){return t.getParent()},getControlType:function(t){return e.getControlType(t)},getAggregation:function(t,e){if(t&&t.getMetadata){var r=t.getMetadata(),i=r.getAllAggregations();if(i){var n=i[e];if(n)return t[n._sGetter]()}}},insertAggregation:function(t,e,r,i){if(t&&t.getMetadata){var n=t.getMetadata(),a=n.getAllAggregations();if(a){var o=a[e];if(o)if(o.multiple){var s=i||0;t[o._sInsertMutator](r,s)}else t[o._sMutator](r)}}},removeAggregation:function(t,e,r){if(t&&t.getMetadata){var i=t.getMetadata(),n=i.getAllAggregations();if(n){var a=n[e];a&&t[a._sRemoveMutator](r)}}},removeAllAggregation:function(t,e){if(t&&t.getMetadata){var r=t.getMetadata(),i=r.getAllAggregations();if(i){var n=i[e];n&&t[n._sRemoveAllMutator]()}}}};return jQuery.sap.extend(!0,{},t,r)},!0);",
		"sap/ui/fl/changeHandler/MoveControls.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\",\"sap/ui/fl/Utils\"],function(e,t,r){\"use strict\";var o={};return o.CHANGE_TYPE=\"moveControls\",o.SOURCE_ALIAS=\"source\",o.TARGET_ALIAS=\"target\",o.MOVED_ELEMENTS_ALIAS=\"movedElements\",o._checkConditions=function(e,t,r,o){if(!e)throw new Error(\"No change instance\");var n=e.getContent();if(!n||!n.movedElements||0===n.movedElements.length)throw new Error(\"Change format invalid\");if(!n.source||!n.source.selector)throw new Error(\"No source supplied for move\");if(!n.target||!n.target.selector)throw new Error(\"No target supplied for move\");if(!t.bySelector(n.source.selector,o,r))throw new Error(\"Move source parent not found\");if(!t.bySelector(n.target.selector,o,r))throw new Error(\"Move target parent not found\");if(!n.source.selector.aggregation)throw new Error(\"No source aggregation supplied for move\");if(!n.target.selector.aggregation)throw new Error(\"No target aggregation supplied for move\")},o._getElementControlOrThrowError=function(e,t,r,o){if(!e.selector&&!e.id)throw new Error(\"Change format invalid - moveElements element has no id attribute\");if(\"number\"!=typeof e.targetIndex)throw new Error(\"Missing targetIndex for element with id '\"+e.selector.id+\"' in movedElements supplied\");return t.bySelector(e.selector||e.id,r,o)},o._checkCompleteChangeContentConditions=function(e){if(!e.movedElements)throw new Error(\"mSpecificChangeInfo.movedElements attribute required\");if(0===e.movedElements.length)throw new Error(\"MovedElements array is empty\");e.movedElements.forEach(function(e){if(!e.id)throw new Error(\"MovedControls element has no id attribute\");if(\"number\"!=typeof e.sourceIndex)throw new Error(\"SourceIndex attribute at MovedElements element is no number\");if(\"number\"!=typeof e.targetIndex)throw new Error(\"TargetIndex attribute at MovedElements element is no number\")})},o._getSpecificChangeInfo=function(e,t,r){delete t.source.publicAggregation,delete t.target.publicAggregation;var o=t.source.parent||e.bySelector(t.source.id,r),n=t.target.parent||e.bySelector(t.target.id,r),i=t.source.aggregation,a=t.target.aggregation,g={aggregation:t.source.aggregation,type:e.getControlType(o)},s={aggregation:t.target.aggregation,type:e.getControlType(n)},c={source:{id:o.getId(),aggregation:i,type:g.type,selector:e.getSelector(t.source.id,r,g)},target:{id:n.getId(),aggregation:a,type:s.type,selector:e.getSelector(t.target.id,r,s)},movedElements:t.movedElements};return c},o.applyChange=function(e,t,o){var n=o.modifier,i=o.view,a=o.appComponent;this._checkConditions(e,n,i,a);var g=e.getContent(),s=n.bySelector(g.source.selector,a,i),c=n.bySelector(g.target.selector,a,i),l=g.source.selector.aggregation,d=g.target.selector.aggregation;return g.movedElements.forEach(function(e){var t=this._getElementControlOrThrowError(e,n,a,i);return t?(n.removeAggregation(s,l,t,i),void n.insertAggregation(c,d,t,e.targetIndex)):void r.log.warning(\"Element to move not found\")},this),!0},o.completeChangeContent=function(e,t,r){this._checkCompleteChangeContentConditions(t);var n=r.modifier,i=r.appComponent,a=e.getDefinition();t=this._getSpecificChangeInfo(n,t,i),a.changeType=o.CHANGE_TYPE,a.content={movedElements:[],source:{selector:t.source.selector},target:{selector:t.target.selector}},t.movedElements.forEach(function(e){var t=e.element||n.bySelector(e.id,i);a.content.movedElements.push({selector:n.getSelector(t,i),sourceIndex:e.sourceIndex,targetIndex:e.targetIndex})}),e.addDependentControl(t.source.id,o.SOURCE_ALIAS,r),e.addDependentControl(t.target.id,o.TARGET_ALIAS,r),e.addDependentControl(t.movedElements.map(function(e){return e.id}),o.MOVED_ELEMENTS_ALIAS,r)},o},!0);",
		"sap/ui/fl/changeHandler/MoveElements.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\",\"sap/ui/fl/Utils\",\"sap/ui/fl/changeHandler/JsControlTreeModifier\"],function(e,t,r,o){\"use strict\";var n={};return n.CHANGE_TYPE=\"moveElements\",n.applyChange=function(e,t,o){function n(e,t,r,o){if(!e)throw new Error(\"No change instance\");var n=e.getContent();if(!n||!n.movedElements||0===n.movedElements.length)throw new Error(\"Change format invalid\");if(!e.getSelector().aggregation)throw new Error(\"No source aggregation supplied via selector for move\");if(!n.target||!n.target.selector)throw new Error(\"No target supplied for move\");if(!t.bySelector(n.target.selector,o,r))throw new Error(\"Move target parent not found\");if(!n.target.selector.aggregation)throw new Error(\"No target aggregation supplied for move\")}function a(e,t,r,o){if(!e.selector&&!e.id)throw new Error(\"Change format invalid - moveElements element has no id attribute\");if(\"number\"!=typeof e.targetIndex)throw new Error(\"Missing targetIndex for element with id '\"+e.selector.id+\"' in movedElements supplied\");return t.bySelector(e.selector||e.id,r,o)}var g=o.modifier,i=o.view,l=o.appComponent;n(e,g,i,l);var s=e.getContent(),c=g.bySelector(s.target.selector,l,i),d=e.getSelector().aggregation,f=s.target.selector.aggregation;return s.movedElements.forEach(function(e){var o=a(e,g,l,i);return o?(g.removeAggregation(t,d,o,i),void g.insertAggregation(c,f,o,e.targetIndex)):void r.log.warning(\"Element to move not found\")}),!0},n.completeChangeContent=function(){throw new Error(\"Using deprecated change handler. Please consider of using 'MoveControls' instead\")},n.getSpecificChangeInfo=function(e,t){var r=t.source.parent||e.bySelector(t.source.id),o=t.target.parent||e.bySelector(t.target.id),n=t.source.aggregation,a=t.target.aggregation,g={source:{id:r.getId(),aggregation:n,type:e.getControlType(r)},target:{id:o.getId(),aggregation:a,type:e.getControlType(o)},movedElements:t.movedElements};return g},n},!0);",
		"sap/ui/fl/changeHandler/PropertyBindingChange.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/changeHandler/Base\",\"sap/ui/fl/Utils\"],function(n,e,t){\"use strict\";var i={};return i.applyChange=function(n,e,t){var i=n.getDefinition(),o=i.content.property,r=i.content.newBinding;t.modifier.setPropertyBinding(e,o,r)},i.completeChangeContent=function(n,e){var t=n.getDefinition();if(!e.content)throw new Error(\"oSpecificChangeInfo attribute required\");t.content=e.content},i},!0);",
		"sap/ui/fl/changeHandler/PropertyChange.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/changeHandler/Base\",\"sap/ui/fl/Utils\"],function(e,n,t){\"use strict\";var i={};return i.applyChange=function(e,n,i){try{var r=e.getDefinition(),o=r.content.property,a=r.content.newValue;t.isBinding(a)?i.modifier.setPropertyBinding(n,o,a):i.modifier.setProperty(n,o,a)}catch(e){throw new Error(\"Applying property changes failed: \"+e)}},i.completeChangeContent=function(e,n){var t=e.getDefinition();if(!n.content)throw new Error(\"oSpecificChangeInfo attribute required\");t.content=n.content},i},!0);",
		"sap/ui/fl/changeHandler/StashControl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\"],function(e,n){\"use strict\";var t={};return t.applyChange=function(e,n,t){return t.modifier.setVisible(n,!1),t.modifier.setStashed(n,!0),!0},t.completeChangeContent=function(e,n){},t},!0);",
		"sap/ui/fl/changeHandler/UnhideControl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\"],function(e,n){\"use strict\";var t={};return t.applyChange=function(e,n,t){return t.modifier.setVisible(n,!0),!0},t.completeChangeContent=function(e,n){var t=e.getDefinition();t.content||(t.content={})},t},!0);",
		"sap/ui/fl/changeHandler/UnstashControl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Base\"],function(e,n){\"use strict\";var t={};return t.applyChange=function(e,n,t){var a=e.getContent(),r=t.modifier;if(r.setStashed(n,!1),a.parentAggregationName){var g=a.parentAggregationName,i=r.getParent(n);r.removeAggregation(i,g,n),r.insertAggregation(i,g,n,a.index)}return!0},t.completeChangeContent=function(e,n){var t=e.getDefinition();n.content&&(t.content=n.content)},t},!0);",
		"sap/ui/fl/changeHandler/XmlTreeModifier.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/changeHandler/BaseTreeModifier\"],function(e){\"use strict\";var t={targets:\"xmlTree\",setVisible:function(e,t){this.setProperty(e,\"visible\",t)},getVisible:function(e){return this.getProperty(e,\"visible\")},setStashed:function(e,t){this.setProperty(e,\"stashed\",t)},bindProperty:function(e,t,r){e.setAttribute(t,\"{\"+r+\"}\")},setProperty:function(e,t,r){e.setAttribute(t,r)},getProperty:function(e,t){return e.getAttribute(t)},setPropertyBinding:function(e,t,r){e.setAttribute(t,r)},createControl:function(e,t,r,n){if(this.bySelector(n,t,r))throw new Error(\"Can't create a control with duplicated id \"+o);var i=r.createElement(e),o=this.getControlIdBySelector(n,t);return o&&i.setAttribute(\"id\",o),i},byId:function(e,t){return this._byId(e,t)},_byId:function(e,t){if(t){if(t.ownerDocument&&t.ownerDocument.getElementById&&t.ownerDocument.getElementById(e))return t.ownerDocument.getElementById(e);if(t.getElementById&&t.getElementById(e))return t.getElementById(e)}var r=jQuery(t).find(\"#\"+e);if(1===r.length)return r[0]},getId:function(e){return e.getAttribute(\"id\")},getParent:function(e){var t=e.parentNode;return this.getId(t)||(t=t.parentNode),t},_getLocalName:function(e){return e.localName||e.baseName||e.nodeName},getControlType:function(e){var t=e.namespaceURI;return t=t?t+\".\":\"\",t+=this._getLocalName(e)},getAggregation:function(e,t){var r=this._findAggregationNode(e,t);return Array.prototype.slice.call(this._children(r))},insertAggregation:function(e,t,r,n,i,o,a){var d=this._findAggregationNode(e,t,i,o,a);if(n>=d.childElementCount)d.appendChild(r);else{var l=this._children(d)[n];d.insertBefore(r,l)}},removeAggregation:function(e,t,r,n){var i=this._findAggregationNode(e,t,n);i.removeChild(r)},removeAllAggregation:function(e,t,r){var n=this._findAggregationNode(e,t,r);if(e===n)for(var i=this._children(e),o=0;o<i.length;o++)e.removeChild(i[o]);else e.removeChild(n)},_findAggregationNode:function(e,t,r,n,i){var o;if(n)o=this.createControl(t,i,r),e.appendChild(o);else{for(var a=this._children(e),d=0;d<a.length;d++){var l=a[d];if(l.localName===t){o=l;break}}o||(o=e)}return o},_children:function(e){if(e.children)return e.children;for(var t=[],r=0;r<e.childNodes.length;r++){var n=e.childNodes[r];n.nodeType===n.ELEMENT_NODE&&t.push(n)}return t}};return jQuery.sap.extend(!0,{},e,t)},!0);",
		"sap/ui/fl/ChangePersistence.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Change\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Cache\",\"sap/ui/fl/context/ContextManager\",\"sap/ui/fl/registry/Settings\"],function(e,n,t,i,r,a){\"use strict\";var o=function(e){if(this._mComponent=e,this._mChanges={mChanges:{},mDependencies:{},mDependentChangesOnMe:{}},!this._mComponent||!this._mComponent.name)throw n.log.error(\"The Control does not belong to an SAPUI5 component. Personalization and changes for this control might not work as expected.\"),new Error(\"Missing component name.\");this._oConnector=this._createLrepConnector(),this._aDirtyChanges=[]};return o.NOTAG=\"<NoTag>\",o.prototype.getComponentName=function(){return this._mComponent.name},o.prototype._createLrepConnector=function(){return t.createConnector()},o.prototype.getCacheKey=function(){return i.getChangesFillingCache(this._oConnector,this._mComponent).then(function(e){return e&&e.etag?e.etag:o.NOTAG})},o.prototype._preconditionsFulfilled=function(e,n,t){function i(){return n?\"change\"===t.fileType||\"variant\"===t.fileType:\"change\"===t.fileType&&\"defaultVariant\"!==t.changeType}function a(){return!n||\"variant\"!==t.fileType&&\"defaultVariant\"!==t.changeType||t.selector&&t.selector.persistencyKey}function o(){return r.doesContextMatch(t,e)}return!!(i()&&a()&&o())},o.prototype.getChangesForComponent=function(t){function o(n){return new e(n)}return i.getChangesFillingCache(this._oConnector,this._mComponent,t).then(function(e){if(this._bHasLoadedChangesFromBackEnd=!0,e.changes&&e.changes.settings&&a._storeInstance(e.changes.settings),!e.changes||!e.changes.changes)return[];var i=e.changes.changes,s=t&&t.currentLayer;if(s){var h=[];i.forEach(function(e){e.layer===s&&h.push(e)}),i=h}else if(n.isLayerFilteringRequired()&&(!t||!t.ignoreMaxLayerParameter)){var p=[];i.forEach(function(e){n.isOverMaxLayer(e.layer)||p.push(e)}),i=p}var g=t&&t.includeVariants,c=e.changes.contexts||[];return new Promise(function(e){r.getActiveContexts(c).then(function(n){e(i.filter(this._preconditionsFulfilled.bind(this,n,g)).map(o))}.bind(this))}.bind(this))}.bind(this))},o.prototype._addChangeIntoMap=function(e,n){var t=n.getSelector();if(t&&t.id){var i=t.id;if(t.idIsLocal&&(i=e.createId(i)),this._addMapEntry(i,n),void 0===t.idIsLocal&&i.indexOf(\"---\")!=-1){var r=i.split(\"---\")[0];r!==e.getId()&&(i=i.split(\"---\")[1],i=e.createId(i),this._addMapEntry(i,n))}}return this._mChanges},o.prototype._addMapEntry=function(e,n){this._mChanges.mChanges[e]||(this._mChanges.mChanges[e]=[]),this._mChanges.mChanges[e].push(n)},o.prototype._addDependency=function(e,n){this._mChanges.mDependencies[e.getKey()]||(this._mChanges.mDependencies[e.getKey()]={changeObject:e,dependencies:[]}),this._mChanges.mDependencies[e.getKey()].dependencies.push(n.getKey()),this._mChanges.mDependentChangesOnMe[n.getKey()]||(this._mChanges.mDependentChangesOnMe[n.getKey()]=[]),this._mChanges.mDependentChangesOnMe[n.getKey()].push(e.getKey())},o.prototype.loadChangesMapForComponent=function(e,n){function t(n){return this._mChanges={mChanges:{},mDependencies:{},mDependentChangesOnMe:{}},n.forEach(this._addChangeAndUpdateDependencies.bind(this,e)),this.getChangesMapForComponent.bind(this)}return this.getChangesForComponent(n).then(t.bind(this))},o.prototype._addChangeAndUpdateDependencies=function(e,t,i,r){this._addChangeIntoMap(e,t);for(var a,o,s,h,p=n.getAppComponentForControl(e),g=t.getDependentIdList(p),c=i-1;c>=0;c--){a=r[c],o=r[c].getDependentIdList(p),h=!1;for(var d=0;d<g.length&&!h;d++)s=o.indexOf(g[d]),s>-1&&(this._addDependency(t,a),h=!0)}},o.prototype.getChangesMapForComponent=function(){return this._mChanges},o.prototype.getChangesForView=function(e,n){function t(e){var t=e.getSelector();if(!t)return!1;var i=t.id;if(!i||!n)return!1;var r,a=i.slice(0,i.lastIndexOf(\"--\"));if(e.getSelector().idIsLocal){var o=n.appComponent;o&&(r=o.getLocalId(n.viewId))}else r=n.viewId;return a===r}var i=this;return this.getChangesForComponent(n).then(function(e){return e.filter(t.bind(i))})},o.prototype.addChange=function(n,t){var i;return i=n instanceof e?n:new e(n),this._aDirtyChanges.push(i),this._addChangeIntoMap(t,i),this._addPropagationListener(t),i},o.prototype._addPropagationListener=function(e){if(e){var t=function(e){return!e._bIsSapUiFlFlexControllerApplyChangesOnControl},i=e.getPropagationListeners().every(t);if(i){var r=e.getManifest(),a=n.getAppVersionFromManifest(r),o=sap.ui.fl.FlexControllerFactory.create(this.getComponentName(),a),s=o.getBoundApplyChangesOnControl(this.getChangesMapForComponent.bind(this),e);e.addPropagationListener(s)}}},o.prototype.saveDirtyChanges=function(){var e=this._aDirtyChanges.slice(0),n=this._aDirtyChanges,t=this._getRequests(e),i=this._getPendingActions(e);if(1===i.length&&1===t.length&&\"NEW\"===i[0]){var r=t[0],a=this._prepareDirtyChanges(n);return this._oConnector.create(a,r).then(this._massUpdateCacheAndDirtyState(n,e))}return e.reduce(function(e,t){var i=e.then(this._performSingleSaveAction(t).bind(this));return i.then(this._updateCacheAndDirtyState(n,t)),i}.bind(this),Promise.resolve())},o.prototype._performSingleSaveAction=function(e){return function(){return\"NEW\"===e.getPendingAction()?this._oConnector.create(e.getDefinition(),e.getRequest()):\"DELETE\"===e.getPendingAction()?this._oConnector.deleteChange({sChangeName:e.getId(),sLayer:e.getLayer(),sNamespace:e.getNamespace(),sChangelist:e.getRequest()}):void 0}},o.prototype._updateCacheAndDirtyState=function(e,n){var t=this;return function(){\"NEW\"===n.getPendingAction()&&i.addChange(t._mComponent,n.getDefinition()),\"DELETE\"===n.getPendingAction()&&i.deleteChange(t._mComponent,n.getDefinition());var r=e.indexOf(n);r>-1&&e.splice(r,1)}},o.prototype._massUpdateCacheAndDirtyState=function(e,n){var t=this;jQuery.each(n,function(n,i){t._updateCacheAndDirtyState(e,i)()})},o.prototype._getRequests=function(e){var n=[];return jQuery.each(e,function(e,t){var i=t.getRequest();n.indexOf(i)===-1&&n.push(i)}),n},o.prototype._getPendingActions=function(e){var n=[];return jQuery.each(e,function(e,t){var i=t.getPendingAction();n.indexOf(i)===-1&&n.push(i)}),n},o.prototype._prepareDirtyChanges=function(e){var n=[];return jQuery.each(e,function(e,t){n.push(t.getDefinition())}),n},o.prototype.getDirtyChanges=function(){return this._aDirtyChanges},o.prototype.deleteChange=function(e){var n=this._aDirtyChanges.indexOf(e);if(n>-1){if(\"DELETE\"===e.getPendingAction())return;return this._aDirtyChanges.splice(n,1),void this._deleteChangeInMap(e)}e.markForDeletion(),this._aDirtyChanges.push(e),this._deleteChangeInMap(e)},o.prototype._deleteChangeInMap=function(e){var n=e.getKey(),t=this._mChanges.mChanges,i=this._mChanges.mDependencies,r=this._mChanges.mDependentChangesOnMe;Object.keys(t).some(function(n){var i=t[n],r=i.map(function(e){return e.getKey()}).indexOf(e.getKey());if(r!==-1)return i.splice(r,1),!0}),Object.keys(i).forEach(function(e){e===n?delete i[e]:i[e].dependencies&&jQuery.isArray(i[e].dependencies)&&i[e].dependencies.indexOf(n)!==-1&&(i[e].dependencies.splice(i[e].dependencies.indexOf(n),1),0===i[e].dependencies.length&&delete i[e])}),Object.keys(r).forEach(function(e){e===n?delete r[e]:jQuery.isArray(r[e])&&r[e].indexOf(n)!==-1&&(r[e].splice(r[e].indexOf(n),1),0===r[e].length&&delete r[e])})},o},!0);",
		"sap/ui/fl/ChangePersistenceFactory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Component\",\"sap/ui/fl/ChangePersistence\",\"sap/ui/fl/Utils\"],function(e,n,t,o){\"use strict\";var a={};return a._instanceCache={},a.getChangePersistenceForComponent=function(e,n){var s;if(n=n||o.DEFAULT_APP_VERSION,a._instanceCache[e]||(a._instanceCache[e]={}),s=a._instanceCache[e][n],!s){var r={name:e,appVersion:n};s=new t(r),a._instanceCache[e][n]=s}return s},a.getChangePersistenceForControl=function(e){var n;n=this._getComponentClassNameForControl(e);var t=o.getAppVersionFromManifest(o.getAppComponentForControl(e).getManifest());return a.getChangePersistenceForComponent(n,t)},a._getComponentClassNameForControl=function(e){return o.getComponentClassName(e)},a.registerLoadComponentEventHandler=function(){n._fnLoadComponentCallback=this._onLoadComponent.bind(this)},a._doLoadComponent=function(e,n){var t,a,s,r={oChangePersistence:{},oRequestOptions:{}},i=o.getFlexReference(n),p=o.getAppVersionFromManifest(n);if(a=e&&e.componentData&&e.componentData.startupParameters||{},s=e&&e.componentData&&e.componentData.technicalParameters,a[\"sap-app-id\"]&&1===a[\"sap-app-id\"].length)i=a[\"sap-app-id\"][0];else if(e){var c=e.asyncHints;if(c&&c.requests&&Array.isArray(c.requests)){var C=this._findFlAsyncHint(c.requests);C&&i===C.reference&&(r.oRequestOptions.cacheKey=C.cachebusterToken||\"<NO CHANGES>\")}}var u=s||a;return u&&u[\"sap-ui-fl-max-layer\"]&&1===u[\"sap-ui-fl-max-layer\"].length&&(t=u[\"sap-ui-fl-max-layer\"][0]),o.setMaxLayerParameter(t),r.oRequestOptions.siteId=o.getSiteIdByComponentData(e.componentData),r.oChangePersistence=this.getChangePersistenceForComponent(i,p),r},a._onLoadComponent=function(e,n){if(o.isApplication(n)){var t=this._doLoadComponent(e,n);t.oChangePersistence.getChangesForComponent(t.oRequestOptions)}},a._getChangesForComponentAfterInstantiation=function(e,n,t){if(!o.isApplication(n))return Promise.resolve(function(){return{mChanges:{},mDependencies:{},mDependentChangesOnMe:{}}});var a=this._doLoadComponent(e,n);return a.oChangePersistence.loadChangesMapForComponent(t,a.oRequestOptions)},a._findFlAsyncHint=function(n){var t,o=this;return e.each(n,function(e,n){if(o._flAsyncHintMatches(n))return t=n,!1}),t},a._flAsyncHintMatches=function(e){return\"sap.ui.fl.changes\"===e.name},a},!0);",
		"sap/ui/fl/codeExt/CodeExtManager.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Utils\",\"sap/ui/fl/Change\"],function(e,n,a){\"use strict\";var r;return r={_oLrepConnector:new e,createOrUpdateCodeExtChange:function(e,n){if(!e.content||!e.content.codeRef)throw new Error(\"no code reference passed for the code extension change\");if(!e.selector||!e.selector.id)throw new Error(\"no controller name passed for the code extension change\");if(!e.reference)throw new Error(\"no reference passed for the code extension change\");e.changeType=e.changeType||\"codeExt\";var r=a.createInitialFileContent(e),t=\"/sap/bc/lrep/content/\"+r.namespace+r.fileName+\".change\";t+=\"?layer=\"+r.layer,n&&(n.transportId&&(t+=\"&changelist=\"+n.transportId),n.packageName&&(t+=\"&package=\"+n.packageName));var o=\"PUT\";return this._oLrepConnector.send(t,o,r,{})},createCodeExtChanges:function(e,n){if(e=e||[],0===e.length)return Promise.resolve();var r=[];return e.forEach(function(e){e.changeType=e.changeType||\"codeExt\",e.packageName=n.packageName,e.content={codeRef:n.codeRef},r.push(a.createInitialFileContent(e))}),this._oLrepConnector.create(r,n.transportId)},deleteCodeExtChange:function(e,n){if(\"codeExt\"!==e.changeType||\"change\"!==e.fileType)throw new Error(\"the change is not of type 'code extension'\");if(!e.fileName)throw new Error(\"the extension does not contains a file name\");if(void 0===e.namespace)throw new Error(\"the extension does not contains a namespace\");var a=\"/sap/bc/lrep/content/\"+e.namespace+e.fileName+\".change\";e.layer&&(a+=\"&layer=\"+e.layer),n&&(n.transportId&&(a+=\"&changelist=\"+n.transportId),n.packageName&&(a+=\"&package=\"+n.packageName)),a=a.replace(\"&\",\"?\");var r=\"DELETE\";return this._oLrepConnector.send(a,r,e,{})}}},!0);",
		"sap/ui/fl/context/BaseContextProvider.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/base/ManagedObject\"],function(e){\"use strict\";var t=e.extend(\"sap.ui.fl.context.BaseContextProvider\",{metadata:{properties:{text:{type:\"String\"},description:{type:\"String\"}}}});return t.prototype.loadData=function(){return Promise.resolve({})},t.prototype.getValue=function(e){return this.loadData().then(function(t){var r=e&&e.split(\".\")||[],n=r.reduce(function(e,t){if(e&&e.hasOwnProperty(t))return e[t]},t);return n})},t.prototype.getValueHelp=function(e){return Promise.resolve({})},t.prototype.validate=function(e,t){return Promise.resolve(!0)},t},!0);",
		"sap/ui/fl/context/Context.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/base/ManagedObject\"],function(e){\"use strict\";var t=e.extend(\"sap.ui.fl.context.Context\",{metadata:{library:\"sap.ui.fl\",properties:{configuration:{type:\"object\"},content:{type:\"object\"}},aggregations:{contextProviders:{type:\"object\",multiple:!0}},events:{}}});t.prototype.getValue=function(e){return this._getProviderContent(e,\"getValue\")},t.prototype.getValueHelp=function(e){return this._getProviderContent(e,\"getValueHelp\")};var r=function(e,t){if(e.indexOf(t)===-1){if(t.indexOf(e+\".\")!==-1)return t.substring(e.length+1);throw new Error(\"Invalid request for sap.ui.fl.context - domain:\"+e+\"request:\"+t)}};return t.prototype._getProviderContent=function(e,t){var n=this,o=[],i=[],u=function(e){var t=n._assureDomain(e);if(t){var u=n._loadProvider(t);o.push(u),i.push({domain:t,request:r(t,e)})}else i.push({domain:void 0,request:e})},a=function(e){for(var t=n.getConfiguration(),r=!1,o=0;o<e.length;o++){var i=e[o];i&&(t[i.domain]=i.provider,r=!0)}r&&n.setConfiguration(t)};if(e instanceof Array)e.forEach(function(e){u(e)});else if(void 0===e){for(var s in this.getConfiguration())o.push(this._loadProvider(s));i=Object.keys(this.getConfiguration()).map(function(e){return{domain:e,request:void 0}})}return Promise.all(o).then(a).then(function(){return n._mergeProviderContent(i,t,e)})},t.prototype._assureDomain=function(e){var t=this.getConfiguration();if(t.hasOwnProperty(e))return e;for(var r=Object.keys(t),n=0;n<r.length;n++){var o=r[n];if(0===e.indexOf(o)||0===o.indexOf(e))return o}return null},t.prototype._loadProvider=function(e,t){var r=this.getConfiguration()[e];return\"string\"==typeof r?new Promise(function(t,n){try{sap.ui.require([r],function(r){var n=new r;t({domain:e,provider:n})})}catch(e){return jQuery.sap.log.error(e),void t()}}):Promise.resolve()},t.prototype._mergeProviderContent=function(e,t,r){var n=[],o=this.getConfiguration();return e.forEach(function(e){if(o.hasOwnProperty(e.domain)){var r=o[e.domain];r instanceof sap.ui.fl.context.BaseContextProvider&&n.push(r[t].call(r,e.request).then(function(t){var r={},n=e.domain;return e.request&&(n=n+\".\"+e.request),r[n]=t,r}))}else{var i={};i[e.request]=void 0,n.push(Promise.resolve(i))}}),Promise.all(n).then(function(e){return e.reduce(function(e,t){var r=Object.keys(t)[0];return e[r]=t[r],e},{})})},t},!0);",
		"sap/ui/fl/context/ContextManager.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Utils\",\"sap/ui/fl/context/Context\"],function(e,t,r){\"use strict\";var n;return n={_oContext:new r({configuration:{device:\"sap/ui/fl/context/DeviceContextProvider\",switches:\"sap/ui/fl/context/SwitchContextProvider\"}}),_oLrepConnector:new e,doesContextMatch:function(e,t){var r=e.context||\"\";return!r||jQuery.inArray(r,t)!==-1},getActiveContexts:function(e){var t=this._getContextIdsFromUrl();return 0===t.length?this._getContextParametersFromAPI(e).then(this._getActiveContextsByAPIParameters.bind(this,e)):Promise.resolve(this._getActiveContextsByUrlParameters(e,t))},_getContextParametersFromAPI:function(e){var t=[];return e.forEach(function(e){e.parameters.forEach(function(e){var r=e.selector;t.indexOf(r)===-1&&t.push(r)})}),this._oContext.getValue(t)},_getActiveContextsByAPIParameters:function(e,t){var r=this,n=[];return e.forEach(function(e){r._isContextObjectActive(e,t)&&n.push(e.id)}),n},_getActiveContextsByUrlParameters:function(e,t){var r=[];return e.forEach(function(e){var n=jQuery.inArray(e.id,t)!==-1;n&&r.push(e.id)}),r},_isContextObjectActive:function(e,t){var r=this,n=!0,a=e.parameters;return a.every(function(e){return n=n&&r._checkContextParameter(e,t)}),n},_getContextIdsFromUrl:function(){var e=t.getUrlParameter(\"sap-ui-flexDesignTimeContext\");return e?e.split(\",\"):[]},_checkContextParameter:function(e,t){var r=e.selector,n=e.operator,a=e.value;switch(n){case\"EQ\":return this._checkEquals(r,a,t);case\"NE\":return!this._checkEquals(r,a,t);default:return jQuery.sap.log.info(\"A context within a flexibility change with the operator '\"+n+\"' could not be verified\"),!1}},_checkEquals:function(e,t,r){return r[e]===t},createOrUpdateContextObject:function(e){if(!e.reference)throw new Error(\"no reference passed for the context object\");if(!e.namespace)throw new Error(\"no namespace passed for the context object\");var r=e.id||t.createDefaultFileName();e={id:r,fileName:r,title:e.title||\"\",description:e.description||\"\",parameters:e.parameters||[],fileType:\"context\",reference:e.reference||\"\",packageName:e.packageName||\"\",layer:e.layer||t.getCurrentLayer(!1),namespace:e.namespace,creation:e.creation||\"\",originalLanguage:e.originalLanguage||t.getCurrentLanguage(),support:e.support||{generator:\"\",service:\"\",user:\"\"},validAppVersions:e.validAppVersions||{}};var n=\"/sap/bc/lrep/content/\"+e.namespace+e.fileName+\".context\";n+=\"?layer=\"+e.layer;var a=\"PUT\";return this._oLrepConnector.send(n,a,e,{})}}},!0);",
		"sap/ui/fl/context/DeviceContextProvider.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/context/BaseContextProvider\",\"sap/ui/Device\"],function(e,t){\"use strict\";var r=e.extend(\"sap.ui.fl.context.DeviceContextProvider\",{metadata:{properties:{text:{type:\"String\",defaultValue:\"Device\"},description:{type:\"String\",defaultValue:\"Returns the values of sap.ui.Device\"}}}});return r.prototype.loadData=function(){return Promise.resolve(t)},r.prototype.getValueHelp=function(){return Promise.resolve({})},r.prototype.validate=function(e,t){return Promise.resolve(!0)},r},!0);",
		"sap/ui/fl/context/SwitchContextProvider.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/context/BaseContextProvider\",\"sap/ui/fl/Cache\"],function(e,t){\"use strict\";var r=e.extend(\"sap.ui.fl.context.SwitchContextProvider\",{metadata:{properties:{text:{type:\"String\",defaultValue:\"Switch\"},description:{type:\"String\",defaultValue:\"Returns the values of switches recieved in the flexibility response from the back end\"}}}});return r.prototype.loadData=function(){return Promise.resolve(t.getSwitches())},r.prototype.getValueHelp=function(){return Promise.resolve({})},r.prototype.validate=function(e,t){return Promise.resolve(!0)},r},!0);",
		"sap/ui/fl/core/EventDelegate.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/Utils\",\"sap/ui/base/EventProvider\",\"sap/ui/fl/registry/ChangeRegistry\",\"sap/ui/fl/core/FlexVisualizer\"],function(e,t,o,r,i){\"use strict\";var s=function(e,r){e||t.log.error(\"sap.ui.fl.core.EventDelegate: Control required\"),r||t.log.error(\"sap.ui.fl.core.EventDelegate: Supported registry items required\"),o.apply(this),this._oControl=e,this._oSupportedRegistryItems=r};return s.prototype=e.sap.newObject(o.prototype),s.registerControl=function(e){if(e){var t=0;if(e.aDelegates)for(t=0;t<e.aDelegates.length;t++){var o=\"\";if(e.aDelegates[t].oDelegate&&e.aDelegates[t].oDelegate.getType&&(o=e.aDelegates[t].oDelegate.getType()),\"Flexibility\"===o)return}s.registerExplicitChanges(e)}},s.registerExplicitChanges=function(e){var o=r.getInstance(),i={controlType:t.getControlType(e)},a=o.getRegistryItems(i);Object.keys(a).length>0&&e.addEventDelegate(new s(e,a))},s.unregisterControl=function(){},s.prototype.onmouseover=function(t){t.stopPropagation(),t.handled||(t.handled=!0,i.isPersonalizationMode()&&this._oControl&&!e(this._oControl.getDomRef()).hasClass(\"sapuiflex-highlight\")&&i.showDialog(this._oControl))},s.prototype.onmouseout=function(e){i.isPersonalizationMode()&&this._oControl&&i.closeDialog()},s},!0);",
		"sap/ui/fl/core/FlexVisualizer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(n){\"use strict\";var i=function(){};return i.showDialog=function(n,i){},i.closeDialog=function(){},i},!0);",
		"sap/ui/fl/DefaultVariant.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/Change\"],function(e,t){\"use strict\";var a=function(){};return a.prototype.getDefaultVariantId=function(e){var t=this.getNewestDefaultVariantChangeDeleteTheRest(e);return t?t.getContent().defaultVariantName:\"\"},a.prototype.getNewestDefaultVariantChangeDeleteTheRest=function(e){var t=this.getDefaultVariantChanges(e).sort(function(e,t){var a=new Date(e.getCreation()),n=new Date(t.getCreation());return isNaN(a.getDate())?-1:isNaN(n.getDate())?1:n-a}),a=t.shift();return t.forEach(function(e){e.markForDeletion()}),a},a.prototype.getDefaultVariantChanges=function(e){function t(t){return e[t]}function a(e){return\"defaultVariant\"===e.getChangeType()}return e&&\"object\"==typeof e?Object.keys(e).map(t).filter(a):[]},a.prototype.updateDefaultVariantId=function(e,t){var a=this.getNewestDefaultVariantChangeDeleteTheRest(e);return a&&(a.getContent().defaultVariantName=t),a},a.prototype._createChangeFile=function(e){var a;return e.namespace=e.component+\"/changes/default\",e.componentName=e.component,e.changeType=\"defaultVariant\",a=t.createInitialFileContent(e),a.content.defaultVariantName=e.defaultVariantId,a.layer=\"USER\",a},a.prototype.createChangeObject=function(e){var a,n;return a=this._createChangeFile(e),n=new t(a)},new a},!0);",
		"sap/ui/fl/descriptorRelated/api/DescriptorChangeFactory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/ChangePersistenceFactory\",\"sap/ui/fl/ChangePersistence\",\"sap/ui/fl/Change\",\"sap/ui/fl/descriptorRelated/internal/Utils\",\"sap/ui/fl/registry/Settings\",\"sap/ui/fl/Utils\"],function(e,t,n,r,s,i){\"use strict\";var a=function(e,t,n){this._mChangeFile=e,this._mChangeFile.packageName=\"$TMP\",this._oInlineChange=t,this._sTransportRequest=null,this._oSettings=n};a.prototype.setTransportRequest=function(e){try{r.checkTransportRequest(e)}catch(e){return Promise.reject(e)}return this._sTransportRequest=e,Promise.resolve()},a.prototype.setPackage=function(e){try{r.checkPackage(e)}catch(e){return Promise.reject(e)}return this._mChangeFile.packageName=e,Promise.resolve()},a.prototype.submit=function(){var t=this._mChangeFile.reference,n=e.getChangePersistenceForComponent(t),r=this._getChangeToSubmit();return n.addChange(r),n.saveDirtyChanges()},a.prototype._getChangeToSubmit=function(){var e=new n(this._getMap());return this._sTransportRequest?e.setRequest(this._sTransportRequest):this._oSettings.isAtoEnabled()&&i.isCustomerDependentLayer(this._mChangeFile.layer)&&e.setRequest(\"ATO_NOTIFICATION\"),e},a.prototype._getMap=function(){var e=this._oInlineChange.getMap();return this._mChangeFile.content=e.content,this._mChangeFile.texts=e.texts,this._mChangeFile},a.prototype.getJson=function(){return jQuery.extend(!0,{},this._getMap())};var o=function(){};return o.prototype.createNew=function(e,t,r){var o=function(e,t){e.setHostingIdForTextKey&&e.setHostingIdForTextKey(t)};o(t,e);var u={};if(u.changeType=t._getChangeType(),u.componentName=e,u.reference=e,r){if(\"VENDOR\"!=r&&\"PARTNER\"!=r&&!i.isCustomerDependentLayer(r))throw new Error(\"Parameter \\\"layer\\\" needs to be 'VENDOR', 'PARTNER' or customer dependent\");u.layer=r}else u.layer=\"CUSTOMER\";var h=n.createInitialFileContent(u);return s.getInstance().then(function(e){return Promise.resolve(new a(h,t,e))})},o},!0);",
		"sap/ui/fl/descriptorRelated/api/DescriptorInlineChangeFactory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/descriptorRelated/internal/Utils\"],function(e){\"use strict\";var t=function(t,r,a){e.checkTexts(a),this._mParameters={},this._mParameters.changeType=t,this._mParameters.content=r,this._mParameters.texts=a};t.prototype._getChangeType=function(){return this._mParameters.changeType},t.prototype.getMap=function(){return this._mParameters};var r={};return r.getDescriptorChangeTypes=function(){return[\"appdescr_ovp_addNewCard\",\"appdescr_ovp_removeCard\",\"appdescr_app_addNewInbound\",\"appdescr_app_changeInbound\",\"appdescr_app_removeInbound\",\"appdescr_app_addNewOutbound\",\"appdescr_app_changeOutbound\",\"appdescr_app_removeOutbound\",\"appdescr_app_addNewDataSource\",\"appdescr_app_changeDataSource\",\"appdescr_app_removeDataSource\",\"appdescr_app_addAnnotationsToOData\",\"appdescr_app_addTechnicalAttributes\",\"appdescr_app_removeTechnicalAttributes\",\"appdescr_app_setTitle\",\"appdescr_app_setSubTitle\",\"appdescr_app_setShortTitle\",\"appdescr_app_setDescription\",\"appdescr_app_setDestination\",\"appdescr_app_setKeywords\",\"appdescr_ui5_addNewModel\",\"appdescr_ui5_replaceComponentUsage\",\"appdescr_smb_addNamespace\",\"appdescr_smb_changeNamespace\",\"appdescr_ui_generic_app_setMainPage\",\"appdescr_ui_setIcon\"]},r.createNew=function(e,r,a){var n=new t(e,r,a);return new Promise(function(e,t){if(n)e(n);else{var r={};t(r)}})},r._createDescriptorInlineChange=function(e,r,a){var n=new t(e,r,a);return new Promise(function(e,t){if(n)e(n);else{var r={};t(r)}})},r.createDescriptorInlineChange=function(e,t,r){return this._createDescriptorInlineChange(e,t,r)},r.create_ovp_addNewCard=function(t,r){return e.checkParameterAndType(t,\"card\",\"object\"),this._createDescriptorInlineChange(\"appdescr_ovp_addNewCard\",t,r)},r.create_ovp_removeCard=function(t){return e.checkParameterAndType(t,\"cardId\",\"string\"),this._createDescriptorInlineChange(\"appdescr_ovp_removeCard\",t)},r.create_app_addNewInbound=function(t,r){return e.checkParameterAndType(t,\"inbound\",\"object\"),this._createDescriptorInlineChange(\"appdescr_app_addNewInbound\",t,r)},r.create_app_removeInbound=function(t){return e.checkParameterAndType(t,\"inboundId\",\"string\"),this._createDescriptorInlineChange(\"appdescr_app_removeInbound\",t)},r.create_app_changeInbound=function(t,r){return e.checkParameterAndType(t,\"inboundId\",\"string\"),e.checkEntityPropertyChange(t),this._createDescriptorInlineChange(\"appdescr_app_changeInbound\",t,r)},r.create_app_addNewOutbound=function(t){return e.checkParameterAndType(t,\"outbound\",\"object\"),this._createDescriptorInlineChange(\"appdescr_app_addNewOutbound\",t)},r.create_app_removeOutbound=function(t){return e.checkParameterAndType(t,\"outboundId\",\"string\"),this._createDescriptorInlineChange(\"appdescr_app_removeOutbound\",t)},r.create_app_changeOutbound=function(t){return e.checkParameterAndType(t,\"outboundId\",\"string\"),e.checkEntityPropertyChange(t),this._createDescriptorInlineChange(\"appdescr_app_changeOutbound\",t)},r.create_app_addNewDataSource=function(t){return e.checkParameterAndType(t,\"dataSource\",\"object\"),this._createDescriptorInlineChange(\"appdescr_app_addNewDataSource\",t)},r.create_app_removeDataSource=function(t){return e.checkParameterAndType(t,\"dataSourceId\",\"string\"),this._createDescriptorInlineChange(\"appdescr_app_removeDataSource\",t)},r.create_app_changeDataSource=function(t){return e.checkParameterAndType(t,\"dataSourceId\",\"string\"),e.checkEntityPropertyChange(t),this._createDescriptorInlineChange(\"appdescr_app_changeDataSource\",t)},r.create_app_addAnnotationsToOData=function(t){return e.checkParameterAndType(t,\"dataSourceId\",\"string\"),e.checkParameterAndType(t,\"annotations\",\"array\"),e.checkParameterAndType(t,\"dataSource\",\"object\"),this._createDescriptorInlineChange(\"appdescr_app_addAnnotationsToOData\",t)},r.create_app_setTitle=function(e){var t={\"\":e};return this._createDescriptorInlineChange(\"appdescr_app_setTitle\",{},t).then(function(e){return new Promise(function(t){e.setHostingIdForTextKey=function(t){var r=e,a=t+\"_sap.app.title\";r._mParameters.texts[a]=r._mParameters.texts[\"\"],delete r._mParameters.texts[\"\"]},t(e)})})},r.create_app_setSubTitle=function(e){var t={\"\":e};return this._createDescriptorInlineChange(\"appdescr_app_setSubTitle\",{},t).then(function(e){return new Promise(function(t){e.setHostingIdForTextKey=function(t){var r=e,a=t+\"_sap.app.subTitle\";r._mParameters.texts[a]=r._mParameters.texts[\"\"],delete r._mParameters.texts[\"\"]},t(e)})})},r.create_app_setShortTitle=function(e){var t={\"\":e};return this._createDescriptorInlineChange(\"appdescr_app_setShortTitle\",{},t).then(function(e){return new Promise(function(t){e.setHostingIdForTextKey=function(t){var r=e,a=t+\"_sap.app.shortTitle\";r._mParameters.texts[a]=r._mParameters.texts[\"\"],delete r._mParameters.texts[\"\"]},t(e)})})},r.create_app_setDescription=function(e){var t={\"\":e};return this._createDescriptorInlineChange(\"appdescr_app_setDescription\",{},t).then(function(e){return new Promise(function(t){e.setHostingIdForTextKey=function(t){var r=e,a=t+\"_sap.app.description\";r._mParameters.texts[a]=r._mParameters.texts[\"\"],delete r._mParameters.texts[\"\"]},t(e)})})},r.create_app_setDestination=function(t){return e.checkParameterAndType(t,\"destination\",\"object\"),this._createDescriptorInlineChange(\"appdescr_app_setDestination\",t)},r.create_app_setKeywords=function(t,r){return e.checkParameterAndType(t,\"keywords\",\"array\"),this._createDescriptorInlineChange(\"appdescr_app_setKeywords\",t,r)},r.create_app_addTechnicalAttributes=function(t){return e.checkParameterAndType(t,\"technicalAttributes\",\"array\"),this._createDescriptorInlineChange(\"appdescr_app_addTechnicalAttributes\",t)},r.create_app_removeTechnicalAttributes=function(t){return e.checkParameterAndType(t,\"technicalAttributes\",\"array\"),this._createDescriptorInlineChange(\"appdescr_app_removeTechnicalAttributes\",t)},r.create_ui5_addNewModel=function(t){return e.checkParameterAndType(t,\"model\",\"object\"),this._createDescriptorInlineChange(\"appdescr_ui5_addNewModel\",t)},r.create_ui5_replaceComponentUsage=function(t){return e.checkParameterAndType(t,\"componentUsageId\",\"string\"),e.checkParameterAndType(t,\"componentUsage\",\"object\"),this._createDescriptorInlineChange(\"appdescr_ui5_replaceComponentUsage\",t)},r.create_smb_addNamespace=function(t){return e.checkParameterAndType(t,\"smartBusinessApp\",\"object\"),this._createDescriptorInlineChange(\"appdescr_smb_addNamespace\",t)},r.create_smb_changeNamespace=function(t){return e.checkParameterAndType(t,\"smartBusinessApp\",\"object\"),this._createDescriptorInlineChange(\"appdescr_smb_changeNamespace\",t)},r.create_ui_generic_app_setMainPage=function(t,r){return e.checkParameterAndType(t,\"page\",\"object\"),this._createDescriptorInlineChange(\"appdescr_ui_generic_app_setMainPage\",t,r)},r.create_ui_setIcon=function(t){return e.checkParameterAndType(t,\"icon\",\"string\"),this._createDescriptorInlineChange(\"appdescr_ui_setIcon\",t)},r},!0);",
		"sap/ui/fl/descriptorRelated/api/DescriptorVariantFactory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/descriptorRelated/api/DescriptorInlineChangeFactory\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/descriptorRelated/internal/Utils\",\"sap/ui/fl/registry/Settings\"],function(e,t,r,n,a){\"use strict\";var i=function(e,t,r,n){e&&r?(this._id=e.id,this._mode=\"DELETION\",this._mMap=t):e?(this._id=e.id,this._reference=e.reference,this._layer=e.layer,void 0!=typeof e.isAppVariantRoot&&(this._isAppVariantRoot=e.isAppVariantRoot),this._mode=\"NEW\"):t&&(this._mMap=t,this._mode=\"FROM_EXISTING\"),this._oSettings=n,this._sTransportRequest=null,this._content=[]};i.prototype.addDescriptorInlineChange=function(e){var t=this;return new Promise(function(r){var n=function(e,t){e.setHostingIdForTextKey&&e.setHostingIdForTextKey(t)};switch(t._mode){case\"NEW\":n(e,t._id),t._content.push(e.getMap());break;case\"FROM_EXISTING\":n(e,t._mMap.id),t._mMap.content.push(e.getMap())}r(null)})},i.prototype.setTransportRequest=function(e){try{n.checkTransportRequest(e)}catch(e){return Promise.reject(e)}return this._sTransportRequest=e,Promise.resolve()},i.prototype.setPackage=function(e){try{n.checkPackage(e)}catch(e){return Promise.reject(e)}return this._package=e,Promise.resolve()},i.prototype.submit=function(){var e,n=\"/sap/bc/lrep/appdescr_variants/\";switch(this._mode){case\"NEW\":e=\"POST\";break;case\"FROM_EXISTING\":e=\"PUT\",n+=this._getMap().id;break;case\"DELETION\":e=\"DELETE\",n+=this._id}var a=this._getMap();this._sTransportRequest?n+=\"?changelist=\"+this._sTransportRequest:this._oSettings.isAtoEnabled()&&t.isCustomerDependentLayer(a.layer)&&(n+=\"?changelist=ATO_NOTIFICATION\");var i=r.createConnector();return i.send(n,e,a)},i.prototype.getJson=function(){return jQuery.extend(!0,{},this._getMap())},i.prototype._getMap=function(){switch(this._mode){case\"NEW\":var e={fileName:this._getNameAndNameSpace().fileName,fileType:\"appdescr_variant\",namespace:this._getNameAndNameSpace().namespace,layer:this._layer,packageName:this._package?this._package:\"$TMP\",reference:this._reference,id:this._id,content:this._content};return void 0!=typeof this._isAppVariantRoot&&(e.isAppVariantRoot=this._isAppVariantRoot),e;case\"FROM_EXISTING\":case\"DELETION\":return this._mMap}},i.prototype._getNameAndNameSpace=function(){return n.getNameAndNameSpace(this._id,this._reference)};var s={};return s._getDescriptorVariant=function(e){var t=\"/sap/bc/lrep/appdescr_variants/\"+e,n=r.createConnector();return n.send(t,\"GET\")},s.createNew=function(e){if(n.checkParameterAndType(e,\"reference\",\"string\"),n.checkParameterAndType(e,\"id\",\"string\"),e.layer){if(n.checkParameterAndType(e,\"layer\",\"string\"),\"VENDOR\"!=e.layer&&\"PARTNER\"!=e.layer&&!t.isCustomerDependentLayer(e.layer))throw new Error(\"Parameter \\\"layer\\\" needs to be 'VENDOR', 'PARTNER' or customer dependent\")}else e.layer=\"CUSTOMER\";return e.isAppVariantRoot&&n.checkParameterAndType(e,\"isAppVariantRoot\",\"boolean\"),a.getInstance().then(function(t){return Promise.resolve(new i(e,null,!1,t))})},s.createForExisting=function(e){if(void 0===e||\"string\"!=typeof e)throw new Error('Parameter \"sId\" must be provided of type string');var t;return s._getDescriptorVariant(e).then(function(e){return t=e,a.getInstance()}).then(function(e){var r=t.response;return jQuery.isPlainObject(r)||(r=JSON.parse(r)),Promise.resolve(new i(null,r,!1,e))})},s.createDeletion=function(e){if(void 0===e||\"string\"!=typeof e)throw new Error('Parameter \"sId\" must be provided of type string');var t={};t.id=e;var r;return s._getDescriptorVariant(e).then(function(e){return r=e,a.getInstance()}).then(function(e){var n=JSON.parse(r.response);return Promise.resolve(new i(t,n,!0,e))})},s},!0);",
		"sap/ui/fl/descriptorRelated/internal/Utils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e=function(){};return e.prototype.getNameAndNameSpace=function(e,r){return{fileName:\"manifest\",namespace:\"apps/\"+r+\"/changes/\"+e+\"/\"}},e.prototype.checkEntityPropertyChange=function(e){if(this.checkParameterAndType(e,\"entityPropertyChange\",\"object\"),this.checkParameterAndType(e.entityPropertyChange,\"propertyPath\",\"string\"),this.checkParameterAndType(e.entityPropertyChange,\"operation\",\"string\"),jQuery.inArray(e.entityPropertyChange.operation,[\"INSERT\",\"UPDATE\",\"UPSERT\",\"DELETE\"])<0)throw new Error(\"Parameter \\\"entityPropertyChange.operation\\\" needs to be one of 'INSERT', 'UPDATE', 'UPSERT', 'DELETE'\");if(void 0===e.entityPropertyChange.propertyValue&&\"DELETE\"!==e.entityPropertyChange.operation)throw new Error('No parameter \"entityPropertyChange.propertyValue\" provided')},e.prototype.checkParameterAndType=function(e,r,t){if(\"array\"===t){if(void 0===e||void 0===e[r]||!Array.isArray(e[r]))throw new Error('No parameter \"'+r+'\" of type '+t+\" provided\")}else if(void 0===e||void 0===e[r]||typeof e[r]!==t)throw new Error('No parameter \"'+r+'\" of type '+t+\" provided\")},e.prototype.checkTexts=function(e){if(void 0!==e&&\"object\"!=typeof e)throw new Error('Wrong format for provided \"texts\" parameter')},e.prototype.checkTransportRequest=function(e){if(!/^[A-Z0-9]{1,20}$/.test(e))throw new Error('Wrong format for provided \"sTransportRequest\" parameter')},e.prototype.checkPackage=function(e){if(!/^[A-Z0-9\\/_]{1,30}$/.test(e))throw new Error('Wrong format for provided \"sPackage\" parameter')},new e},!0);",
		"sap/ui/fl/EventHistory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e=function(){};return e._aEventIds=[\"ControlForPersonalizationRendered\"],e._aUnsubscribedEventIds=[],e._oHistory={},e.start=function(){e._aEventIds.forEach(function(n){e._aUnsubscribedEventIds.indexOf(n)===-1&&(sap.ui.getCore().getEventBus().subscribe(\"sap.ui\",n,e.saveEvent),e._oHistory[n]=[])})},e.saveEvent=function(n,s,t){var i={channelId:n,eventId:s,parameters:t};e._oHistory[s]&&e._oHistory[s].push(i)},e.getHistoryAndStop=function(n){return sap.ui.getCore().getEventBus().unsubscribe(\"sap.ui\",n,e.saveEvent),e._addUnsubscribedEvent(n),e._oHistory[n]||[]},e._addUnsubscribedEvent=function(n){e._aUnsubscribedEventIds.indexOf(n)===-1&&e._aUnsubscribedEventIds.push(n)},e},!0);",
		"sap/ui/fl/FakeLrepConnector.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/thirdparty/URI\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Cache\",\"sap/ui/fl/ChangePersistenceFactory\"],function(e,n,o,t,r,a){\"use strict\";function s(e){this.sInitialComponentJsonPath=e}function c(e,n,o,t,r){e.match(/^\\/sap\\/bc\\/lrep\\/actions\\/make_changes_transportable\\//)&&\"POST\"===n&&r()}function i(e,n,o,t,r,a){e.match(/^\\/sap\\/bc\\/lrep\\/actions\\/gettransports\\//)&&r({response:{transports:[{transportId:\"U31K008488\",description:\"The Ultimate Transport\",owner:\"Fantasy Owner\",locked:!1}],localonly:!1,errorCode:\"\"}})}var p=Object.create(t.prototype);s._oBackendInstances={};for(var l in p)\"function\"==typeof p[l]&&(s.prototype[l]=function(e){return function(){throw new Error(\"Method \"+e+\"() is not implemented in FakeLrepConnector.\")}}(l));return s.prototype.loadChanges=function(n){var o=this.sInitialComponentJsonPath;return new Promise(function(t,r){e.getJSON(o).done(function(e){var o={changes:e,componentClassName:n};t(o)}).fail(function(e){r(e)})})},s.prototype.create=function(e,n,o){return o?(e.creation||(e.creation=(new Date).toISOString()),Promise.resolve({response:e,status:\"success\"})):Promise.resolve()},s.prototype.update=function(e,n,o,t){return t?Promise.resolve({response:e,status:\"success\"}):Promise.resolve()},s.prototype.deleteChange=function(e,n){return n?Promise.resolve({response:void 0,status:\"nocontent\"}):Promise.resolve()},s.prototype.send=function(e,n,o,t){return new Promise(function(r,a){i(e,n,o,t,r,a),c(e,n,o,t,r,a)})},s.enableFakeConnector=function(e,n,o){if(n&&o){var c=a.getChangePersistenceForComponent(n,o);return void(c._oConnector instanceof s||(r.clearEntry(n,o),s._oBackendInstances[n]||(s._oBackendInstances[n]={}),s._oBackendInstances[n][o]=c._oConnector,c._oConnector=new s(e)))}r.clearEntries(),s.enableFakeConnector.original||(s.enableFakeConnector.original=t.createConnector,t.createConnector=function(){return s._oFakeInstance||(s._oFakeInstance=new s(e)),s._oFakeInstance})},s.disableFakeConnector=function(e,n){if(e&&n){var o=a.getChangePersistenceForComponent(e,n);return void(o._oConnector instanceof t||(r.clearEntry(e,n),s._oBackendInstances[e]&&s._oBackendInstances[e][n]&&(o._oConnector=s._oBackendInstances[e][n],s._oBackendInstances[e][n]=void 0)))}r.clearEntries(),s.enableFakeConnector.original&&(t.createConnector=s.enableFakeConnector.original,s.enableFakeConnector.original=void 0,s._oFakeInstance=void 0)},s},!0);",
		"sap/ui/fl/FakeLrepConnectorLocalStorage.js": "/*\n * ! UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/FakeLrepLocalStorage\",\"sap/ui/fl/FakeLrepConnector\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Cache\",\"sap/ui/fl/ChangePersistenceFactory\"],function(e,n,t,o,a){\"use strict\";function r(e){this.mSettings=jQuery.extend({isKeyUser:!0,isAtoAvailable:!1,isProductiveSystem:!1},e)}return r._oBackendInstances={},jQuery.extend(r.prototype,n.prototype),r.prototype.create=function(e){var n;return n=Array.isArray(e)?e.map(function(e){return this._saveChange(e)}.bind(this)):this._saveChange(e),Promise.resolve({response:n,status:\"success\"})},r.prototype._saveChange=function(n){return n.creation||(n.creation=(new Date).toISOString()),e.saveChange(n.fileName,n),n},r.prototype.update=function(e,n,t,o){return Promise.resolve({response:this._saveChange(e),status:\"success\"})},r.prototype.deleteChange=function(n){return e.deleteChange(n.fileName),Promise.resolve({response:void 0,status:\"nocontent\"})},r.prototype.deleteChanges=function(){return e.deleteChanges(),Promise.resolve({response:void 0,status:\"nocontent\"})},r.prototype.loadChanges=function(n){var t=e.getChanges();return new Promise(function(e,o){var a={changes:{changes:t,settings:this.mSettings},componentClassName:n};e(a)}.bind(this))},r.enableFakeConnector=function(e,n,s){if(e=e||{},n&&s){var c=a.getChangePersistenceForComponent(n,s);return void(c._oConnector instanceof r||(o.clearEntry(n,s),r._oBackendInstances[n]||(r._oBackendInstances[n]={}),r._oBackendInstances[n][s]=c._oConnector,c._oConnector=new r(e)))}o.clearEntries(),r.enableFakeConnector.original||(r.enableFakeConnector.original=t.createConnector,t.createConnector=function(){return r._oFakeInstance||(r._oFakeInstance=new r(e)),r._oFakeInstance})},r.disableFakeConnector=function(e,n){if(e&&n){var s=a.getChangePersistenceForComponent(e,n);return void(s._oConnector instanceof t||(o.clearEntry(e,n),r._oBackendInstances[e]&&r._oBackendInstances[e][n]&&(s._oConnector=r._oBackendInstances[e][n],r._oBackendInstances[e][n]=void 0)))}o.clearEntries(),r.enableFakeConnector.original&&(t.createConnector=r.enableFakeConnector.original,r.enableFakeConnector.original=void 0,r._oFakeInstance=void 0)},r},!0);",
		"sap/ui/fl/FakeLrepLocalStorage.js": "/*\n * ! UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";var a=\"sap.ui.fl.change\",e={};return e.createChangeKey=function(e){if(e)return a+\".\"+e},e.forEachLrepChangeInLocalStorage=function(e){for(var n in window.localStorage)n.indexOf(a)>-1&&e(n)},e.getChange=function(a){if(a){var e=window.localStorage.getItem(this.createChangeKey(a));return JSON.parse(e)}},e.getChanges=function(){var a,e=[];return this.forEachLrepChangeInLocalStorage(function(n){a=JSON.parse(window.localStorage[n]),e.push(a)}),e},e.getNumChanges=function(){var a=0;return this.forEachLrepChangeInLocalStorage(function(e){a++}),a},e._aModifyCallbacks=[],e.attachModifyCallback=function(a){this._aModifyCallbacks.push(a)},e.detachModifyCallback=function(a){var e=this._aModifyCallbacks.indexOf(a);e!==-1&&this._aModifyCallbacks.splice(e,1)},e._callModifyCallbacks=function(){this._aModifyCallbacks.forEach(function(a){a()})},e.deleteChange=function(a){a&&window.localStorage.removeItem(this.createChangeKey(a)),this._callModifyCallbacks()},e.deleteChanges=function(){this.forEachLrepChangeInLocalStorage(function(a){window.localStorage.removeItem(a)}),this._callModifyCallbacks()},e.saveChange=function(a,e){if(a&&e){var n=this.createChangeKey(a),t=JSON.stringify(e);window.localStorage.setItem(n,t)}this._callModifyCallbacks()},e},!0);",
		"sap/ui/fl/fieldExt/Access.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.storage\"],function(e){\"use strict\";var t={};return t._sStorageKey=\"sap.ui.fl.fieldExt.Access\",t._iValidityPeriod=6048e5,t.getBusinessContexts=function(e,t,r){var i=this._parseServiceUri(e),s=this._buildBusinessContextRetrievalUri(i.serviceName,i.serviceVersion,t,r),a=this._getAjaxSettings(),n=this._executeAjaxCall(s,a,i.serviceName,i.serviceVersion,t,r);return n},t.isServiceOutdated=function(e){if(!this._isSystemInfoAvailable())return!1;var t=this._getServiceItem(this._createServiceItem(e));return!!t&&(!this._isServiceExpired(t)||(this.setServiceValid(e),!1))},t.setServiceValid=function(e){if(this._isSystemInfoAvailable()){var t=this._getDataFromLocalStorage();delete t[this._createServiceItem(e).serviceKey],this._setDataToLocalStorage(t)}},t.setServiceInvalid=function(e){if(this._isSystemInfoAvailable()){var t=this._getDataFromLocalStorage(),r=this._createServiceItem(e);t[r.serviceKey]=r,this._setDataToLocalStorage(t)}},t._parseServiceUri=function(e){var t,r=/.*sap\\/opu\\/odata\\/([^\\/]+)\\/([^\\/]+)/i,i=/([^;]+);v=(\\d{1,4})/i,s=\"sap/opu/odata\";if(e.toLowerCase().indexOf(s)!==-1){var a=e.match(r);if(!a||3!==a.length)throw new Error(\"sap.ui.fl.fieldExt.Access._parseService\",\"Malformed service URI (Invalid service name)\");t=\"sap\"!==a[1].toLowerCase()?\"/\"+a[1]+\"/\"+a[2]:a[2]}else e.length>0&&e.lastIndexOf(\"/\")+1===e.length&&(e=e.substring(0,e.length-1)),t=e.substring(e.lastIndexOf(\"/\")+1);if(t.indexOf(\";v=\")!==-1){var n=t.match(i);if(!n||3!==n.length)throw new Error(\"sap.ui.fl.fieldExt.Access._parseService\",\"Malformed service URI (Invalid version)\");return{serviceName:n[1],serviceVersion:n[2]}}return{serviceName:t,serviceVersion:\"0001\"}},t._buildBusinessContextRetrievalUri=function(e,t,r,i){if(null==r&&(r=\"\"),null==i&&(i=\"\"),0===i.length&&0===r.length||0!==i.length&&0!==r.length)throw new Error(\"sap.ui.fl.fieldExt.Access._buildBusinessContextRetrievalUri()Inconsistent input parameters EntityName: \"+r+\" EntitySet: \"+i);var s=\"/sap/opu/odata/SAP/APS_CUSTOM_FIELD_MAINTENANCE_SRV/GetBusinessContextsByEntityType?EntitySetName='\"+i+\"'&EntityTypeName='\"+r+\"'&ServiceName='\"+e+\"'&ServiceVersion='\"+t+\"'&$format=json\";return s},t._executeAjaxCall=function(e,t,r,i,s,a){var n=this,o=jQuery.Deferred();return jQuery.ajax(e,t).done(function(e,t,s){var a=[];e&&(a=n._extractBusinessContexts(e));var c={BusinessContexts:a,ServiceName:r,ServiceVersion:i};o.resolve(c)}).fail(function(e,t,c){var u=n._getMessagesFromXHR(e),l={errorOccured:!0,errorMessages:u,serviceName:r,serviceVersion:i,entityType:s,entitySet:a};o.reject(l)}),o.promise()},t._getAjaxSettings=function(){var e={type:\"GET\",async:!0,dataType:\"json\"};return e},t._extractBusinessContexts=function(e){var t=null,r=[];if(e&&e.d&&(t=e.d.results),null!==t&&t.length>0)for(var i=0;i<t.length;i++)null!==t[i].BusinessContext&&r.push(t[i].BusinessContext);return r},t._getMessagesFromXHR=function(e){var t=[];try{var r=JSON.parse(e.responseText);r&&r.error&&r.error.message&&r.error.message.value&&\"\"!==r.error.message.value?t.push({severity:\"error\",text:r.error.message.value}):t.push({severity:\"error\",text:e.responseText})}catch(e){}return t},t._getCurrentTime=function(){return Date.now()},t._isServiceExpired=function(e){return e.expirationDate<=this._getCurrentTime()},t._getLocalStorage=function(){return jQuery.sap.storage(jQuery.sap.storage.Type.local)},t.isLocalStorageAvailable=function(){return this._getLocalStorage()&&this._getLocalStorage().isSupported()},t._getServiceItem=function(e){return this._getDataFromLocalStorage()[e.serviceKey]||null},t._createServiceItem=function(e){var t=this._getCurrentTime()+this._iValidityPeriod,r=this._getSystemInfo(),i=this._extractServiceInfo(e);return{serviceKey:r.getName()+r.getClient()+i.serviceName+i.serviceVersion,expirationDate:t}},t._extractServiceInfo=function(e){return\"string\"==typeof e?this._parseServiceUri(e):e},t._isSystemInfoAvailable=function(){return sap&&sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getLogonSystem},t._getSystemInfo=function(){return sap.ushell.Container.getLogonSystem()},t._setDataToLocalStorage=function(e){this.isLocalStorageAvailable()&&this._getLocalStorage().put(t._sStorageKey,JSON.stringify(e))},t._getDataFromLocalStorage=function(){if(!this.isLocalStorageAvailable())return{};var e=this._getLocalStorage().get(t._sStorageKey);return e?JSON.parse(e):{}},t},!0);",
		"sap/ui/fl/FlexController.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/Persistence\",\"sap/ui/fl/registry/ChangeRegistry\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Change\",\"sap/ui/fl/Cache\",\"sap/ui/fl/registry/Settings\",\"sap/ui/fl/ChangePersistenceFactory\",\"sap/ui/core/mvc/View\",\"sap/ui/fl/changeHandler/JsControlTreeModifier\",\"sap/ui/fl/changeHandler/XmlTreeModifier\",\"sap/ui/fl/context/ContextManager\"],function(e,t,n,r,o,a,i,s,p,g,h,c,l){\"use strict\";var C=function(e,t){this._oChangePersistence=void 0,this._sComponentName=e||\"\",this._sAppVersion=t||r.DEFAULT_APP_VERSION,this._sComponentName&&this._sAppVersion&&this._createChangePersistence()};return C.appliedChangesCustomDataKey=\"sap.ui.fl:AppliedChanges\",C.PENDING=\"sap.ui.fl:PendingChange\",C.PROCESSING=\"sap.ui.fl:ProcessingChange\",C.prototype.setComponentName=function(e){this._sComponentName=e,this._createChangePersistence()},C.prototype.getComponentName=function(){return this._sComponentName},C.prototype.getAppVersion=function(){return this._sAppVersion},C.prototype.getVariantModelData=function(){var e;return this._oChangePersistence&&this._oChangePersistence._oVariantController._mVariantManagement&&Object.keys(this._oChangePersistence._oVariantController._mVariantManagement).length>0&&(e=this._oChangePersistence._oVariantController._fillVariantModel()),e},C.prototype.createChange=function(t,n){var o,i,s;if(!n)throw new Error(\"A flexibility change cannot be created without a targeted control.\");var p=l._getContextIdsFromUrl();if(p.length>1)throw new Error(\"More than one DesignTime Context is currently active.\");var g=n.id||n.getId();t.selector||(t.selector={});var c=n.appComponent||r.getAppComponentForControl(n);if(!c)throw new Error(\"No Application Component found - to offer flexibility the control with the id '\"+g+\"' has to have a valid relation to its owning application component.\");if(r.hasLocalIdSuffix(g,c)){var C=c.getLocalId(g);if(!C)throw new Error(\"Generated ID attribute found ('\"+g+\"'); provide a stable ID for the control as required by flexibility for assigning the changes.\");t.selector.id=C,t.selector.idIsLocal=!0}else t.selector.id=g,t.selector.idIsLocal=!1;t.reference=this.getComponentName(),t.packageName=\"$TMP\",t.context=1===p.length?p[0]:\"\";var d=this.getAppVersion(),f={creation:d,from:d};d&&t.developerMode&&(f.to=d),t.validAppVersions=f,o=a.createInitialFileContent(t),i=new a(o);var u=n.controlType||r.getControlType(n);if(!u)throw new Error(\"No control type found - the change handler can not be retrieved.\");if(s=this._getChangeHandler(i,u),!s)throw new Error(\"Change handler could not be retrieved for change \"+JSON.stringify(t)+\".\");return t.variantManagementKey&&t.variantKey&&e.sap.log.error(\"VariantChange-\"+t.variantManagementKey+\"-\"+t.variantKey),s.completeChangeContent(i,t,{modifier:h,appComponent:c}),i},C.prototype.addChange=function(e,t){var n=this.createChange(e,t),o=r.getAppComponentForControl(t);return this._oChangePersistence.addChange(n,o),n},C.prototype.addPreparedChange=function(e,t){return this._oChangePersistence.addChange(e,t),e},C.prototype.deleteChange=function(e){this._oChangePersistence.deleteChange(e)},C.prototype.createAndApplyChange=function(e,t){var n=this.addChange(e,t);try{var o={modifier:h,appComponent:r.getAppComponentForControl(t)};this.checkTargetAndApplyChange(n,t,o)}catch(e){throw this._oChangePersistence.deleteChange(n),e}},C.prototype.saveAll=function(){return this._oChangePersistence.saveDirtyChanges()},C.prototype.processXmlView=function(e,t){var n=sap.ui.getCore().getComponent(t.componentId),o=r.getAppComponentForControl(n),a=n.getManifest();return t.appComponent=o,t.appDescriptor=a,t.modifier=c,t.view=e,this.processViewByModifier(t)},C.prototype.processViewByModifier=function(e){return e.siteId=r.getSiteId(e.appComponent),this._oChangePersistence.getChangesForView(e.viewId,e).then(this._resolveGetChangesForView.bind(this,e),this._handlePromiseChainError.bind(this,e.view))},C.prototype._resolveGetChangesForView=function(e,t){if(!Array.isArray(t)){var n=\"No list of changes was passed for processing the flexibility on view: \"+e.view+\".\";return r.log.error(n,void 0,\"sap.ui.fl.FlexController\"),[]}return t.forEach(function(t){try{var n=this._getSelectorOfChange(t);if(!n||!n.id)throw new Error(\"No selector in change found or no selector ID.\");var r=e.modifier.bySelector(n,e.appComponent,e.view);if(!r)throw new Error(\"A flexibility change tries to change a nonexistent control.\");this.checkTargetAndApplyChange(t,r,e)}catch(e){this._logApplyChangeError(e,t)}}.bind(this)),e.view},C.prototype._logApplyChangeError=function(e,t){var n=t.getDefinition(),o=n.changeType,a=n.selector.id,i=n.namespace+n.fileName+\".\"+n.fileType,s=\"A flexibility change could not be applied.\";s+=\"\\nThe displayed UI might not be displayed as intedend.\",e.message&&(s+=\"\\n   occurred error message: '\"+e.message+\"'\"),s+=\"\\n   type of change: '\"+o+\"'\",s+=\"\\n   LRep location of the change: \"+i,s+=\"\\n   id of targeted control: '\"+a+\"'.\",r.log.warning(s,void 0,\"sap.ui.fl.FlexController\")},C.prototype.checkTargetAndApplyChange=function(e,t,n){var o=n.modifier,a=o.getControlType(t),i=this._getChangeHandler(e,a);if(!i)return void r.log.warning(\"Change handler implementation for change not found or change type not enabled for current layer - Change ignored\");var s=this._getAppliedCustomData(e,t,o),p=s.appliedChangesString,g=s.appliedChanges,h=s.appliedChangeCustomData,c=e.getId();if(g.indexOf(c)===-1){try{i.applyChange(e,t,n)}catch(e){return this._setMergeError(!0),void r.log.error(\"Change could not be applied. Merge error detected.\")}var l=p?p+\",\"+c:c;this._writeCustomData(h,l,n,t)}},C.prototype._removeFromAppliedChangesAndMaybeRevert=function(e,t,n,o){var a=n.modifier,i=a.getControlType(t),s=this._getChangeHandler(e,i);if(o&&!s)return void r.log.warning(\"Change handler implementation for change not found or change type not enabled for current layer - Change ignored\");var p=this._getAppliedCustomData(e,t,a),g=p.appliedChanges,h=p.appliedChangeCustomData,c=e.getId(),l=g.indexOf(c);if(l>-1){if(o)try{s.revertChange(e,t,n)}catch(e){return void r.log.error(\"Change could not be reverted.\")}h&&(g.splice(l,1),this._writeCustomData(h,g.join(),n,t))}},C.prototype._writeCustomData=function(e,t,n,r){var o=n.modifier;if(e)o.setProperty(e,\"value\",t);else{var a=n.appComponent,i=n.view;e=o.createControl(\"sap.ui.core.CustomData\",a,i),o.setProperty(e,\"key\",C.appliedChangesCustomDataKey),o.setProperty(e,\"value\",t),o.insertAggregation(r,\"customData\",e,0,i,!0)}},C.prototype._getAppliedCustomData=function(e,t,n){var r=n.getAggregation(t,\"customData\")||[],o={appliedChanges:[]};return r.some(function(e){var t=n.getProperty(e,\"key\");if(t===C.appliedChangesCustomDataKey)return o.appliedChangeCustomData=e,o.appliedChangesString=n.getProperty(e,\"value\"),o.appliedChanges=o.appliedChangesString.split(\",\"),!0}),o},C.prototype._handlePromiseChainError=function(e,t){return r.log.error(\"Error processing view \"+t+\".\"),e},C.prototype._getSelectorOfChange=function(e){if(e&&e.getSelector)return e.getSelector()},C.prototype.applyChange=function(e,t){var n=r.getControlType(t),o=this._getChangeHandler(e,n);if(!o)return void(e&&t&&r.log.warning(\"Change handler implementation for change not found or change type not enabled for current layer - Change ignored.\"));try{o.applyChange(e,t)}catch(e){throw this._setMergeError(!0),r.log.error(\"Change could not be applied. Merge error detected.\"),e}},C.prototype._getChangeHandler=function(e,t){var n,r;if(n=this._getChangeTypeMetadata(e,t))return r=n.getChangeHandler()},C.prototype._getChangeTypeMetadata=function(e,t){var n,r;if(n=this._getChangeRegistryItem(e,t),n&&n.getChangeTypeMetadata)return r=n.getChangeTypeMetadata()},C.prototype._getChangeRegistryItem=function(e,t){var n,r,o;if(e&&t&&(n=e.getChangeType(),n&&t))return o=e.getLayer(),r=this._getChangeRegistry().getRegistryItems({changeTypeName:n,controlType:t,layer:o}),r&&r[t]&&r[t][n]?r[t][n]:r&&r[t]?r[t]:r},C.prototype._getChangeRegistry=function(){var e=n.getInstance();return e.initSettings(),e},C.prototype.getComponentChanges=function(e){return this._oChangePersistence.getChangesForComponent(e)},C.prototype.isPersonalized=function(e){return e=e||{},e.includeVariants=!0,this.getComponentChanges(e).then(function(e){var t=e.some(function(e){return e.isUserDependent()});return!!t})},C.prototype._createChangePersistence=function(){return this._oChangePersistence=p.getChangePersistenceForComponent(this.getComponentName(),this.getAppVersion()),this._oChangePersistence},C.prototype.discardChanges=function(e,t){var n,o,a=r.getCurrentLayer(!!t),i=0;for(n=e.length;i<e.length;)o=e[i],o&&o.getLayer&&o.getLayer()===a&&this._oChangePersistence.deleteChange(o),n===e.length?i++:n=e.length;return this._oChangePersistence.saveDirtyChanges()},C.prototype.discardChangesForId=function(e,t){if(!e)return Promise.resolve();var n=this._oChangePersistence.getChangesMapForComponent(),r=n.mChanges[e]||[];return this.discardChanges(r,t)},C.prototype._setMergeError=function(){return s.getInstance().then(function(e){e.setMergeErrorOccured(!0)})},C.prototype._applyChangesOnControl=function(e,t,n){var r=e(),o=r.mChanges,a=r.mDependencies,i=r.mDependentChangesOnMe,s=o[n.getId()]||[];s.forEach(function(e){a[e.getKey()]?a[e.getKey()][C.PENDING]=this.checkTargetAndApplyChange.bind(this,e,n,{modifier:h,appComponent:t}):(this.checkTargetAndApplyChange(e,n,{modifier:h,appComponent:t}),this._updateDependencies(a,i,e.getKey()))}.bind(this)),this._processDependentQueue(a,i)},C.prototype.getBoundApplyChangesOnControl=function(e,t){var n=this._applyChangesOnControl.bind(this,e,t);return n._bIsSapUiFlFlexControllerApplyChangesOnControl=!0,n},C.prototype.revertChangesOnControl=function(e,t){e.forEach(function(e){var n={modifier:h,appComponent:t},r=this._getSelectorOfChange(e),o=n.modifier.bySelector(r,n.appComponent);this._removeFromAppliedChangesAndMaybeRevert(e,o,{modifier:h,appComponent:t},!0),this._oChangePersistence._deleteChangeInMap(e)}.bind(this))},C.prototype.applyVariantChanges=function(e,t){var n=r.getAppComponentForControl(t),o=[];e.forEach(function(e){var a=this._oChangePersistence.getChangesMapForComponent().mChanges,i=Object.keys(a).reduce(function(e,t){return e.concat(a[t])},[]);this._oChangePersistence._addChangeAndUpdateDependencies(t,e,i.length,i),o.push(function(){var t={modifier:h,appComponent:n},o=this._getSelectorOfChange(e),a=t.modifier.bySelector(o,t.appComponent);return a?void this._applyChangesOnControl(this._oChangePersistence.getChangesMapForComponent.bind(this._oChangePersistence),n,a):void r.log.error(\"A flexibility change tries to change a nonexistent control.\")}.bind(this))}.bind(this)),o.forEach(function(e){e()})},C.prototype.removeFromAppliedChangesOnControl=function(e,t,n){this._removeFromAppliedChangesAndMaybeRevert(e,n,{modifier:h,appComponent:t},!1)},C.prototype._updateDependencies=function(e,t,n){t[n]&&(t[n].forEach(function(t){var r=e[t],o=r.dependencies.indexOf(n);o>-1&&r.dependencies.splice(o,1)}),delete t[n])},C.prototype._processDependentQueue=function(e,t){var n,r;do{n=[],r=[];for(var o=0;o<Object.keys(e).length;o++){var a=Object.keys(e)[o],i=e[a];i[C.PENDING]&&0===i.dependencies.length&&!i[C.PROCESSING]&&(i[C.PROCESSING]=!0,i[C.PENDING](),r.push(a),n.push(i.changeObject.getKey()))}for(var s=0;s<r.length;s++)delete e[r[s]];for(var p=0;p<n.length;p++)this._updateDependencies(e,t,n[p])}while(n.length>0)},C},!0);",
		"sap/ui/fl/FlexControllerFactory.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/FlexController\",\"sap/ui/fl/Utils\",\"sap/ui/fl/ChangePersistenceFactory\"],function(e,n,t,a){\"use strict\";var r={};return r._instanceCache={},r.create=function(e,a){var a=a||t.DEFAULT_APP_VERSION;r._instanceCache[e]||(r._instanceCache[e]={});var o=r._instanceCache[e][a];return o||(o=new n(e,a),r._instanceCache[e][a]=o),o},r.createForControl=function(e,n){var a=t.getComponentClassName(e),o=n||t.getAppComponentForControl(e).getManifest(),i=t.getAppVersionFromManifest(o);return r.create(a,i)},r.getChangesAndPropagate=function(e,n){var o=e.getManifestObject();if(t.isApplication(o)){var i=r.createForControl(e,o);a._getChangesForComponentAfterInstantiation(n,o,e).then(function(n){e.addPropagationListener(i.getBoundApplyChangesOnControl(n,e))})}},r},!0);",
		"sap/ui/fl/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/RegistrationDelegator\"],function(i){\"use strict\";return sap.ui.getCore().initLibrary({name:\"sap.ui.fl\",version:\"800001.6.0.20241202143000_f0htmcm80p\",dependencies:[\"sap.ui.core\",\"sap.m\"],noLibraryCSS:!0,extensions:{\"sap.ui.support\":{diagnosticPlugins:[\"sap/ui/fl/support/Flexibility\"]}}}),i.registerAll(),sap.ui.fl},!0);",
		"sap/ui/fl/LrepConnector.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/thirdparty/URI\",\"sap/ui/fl/Utils\"],function(e,t,s){\"use strict\";var a=function(e){this._initClientParam(),this._initLanguageParam(),e&&(this._sXsrfToken=e.XsrfToken)};return a.createConnector=function(e){return new a(e)},a.prototype.DEFAULT_CONTENT_TYPE=\"application/json\",a.prototype._sClient=void 0,a.prototype._sLanguage=void 0,a.prototype._aSentRequestListeners=[],a.prototype._sRequestUrlPrefix=\"\",a.attachSentRequest=function(e){\"function\"==typeof e&&a.prototype._aSentRequestListeners.indexOf(e)===-1&&a.prototype._aSentRequestListeners.push(e)},a.detachSentRequest=function(e){var t=a.prototype._aSentRequestListeners.indexOf(e);t!==-1&&a.prototype._aSentRequestListeners.splice(t,1)},a.prototype._initClientParam=function(){var e=s.getClient();e&&(this._sClient=e)},a.prototype._initLanguageParam=function(){var e;e=s.getUrlParameter(\"sap-language\")||s.getUrlParameter(\"sap-ui-language\"),e&&(this._sLanguage=e)},a.prototype.setRequestUrlPrefix=function(e){this._sRequestUrlPrefix=e},a.prototype._resolveUrl=function(s){e.sap.startsWith(s,\"/\")||(s=\"/\"+s),s=this._sRequestUrlPrefix+s;var a=t(s).absoluteTo(\"\");return a.toString()},a.prototype._getDefaultHeader=function(){var e={headers:{\"X-CSRF-Token\":this._sXsrfToken||\"fetch\"}};return e},a.prototype._getDefaultOptions=function(t,s,a){var n;return s||(s=this.DEFAULT_CONTENT_TYPE),n=e.extend(!0,this._getDefaultHeader(),{type:t,async:!0,contentType:s,processData:!1,headers:{\"Content-Type\":s}}),a&&\"application/json\"===n.contentType?(n.dataType=\"json\",\"object\"==typeof a?n.data=JSON.stringify(a):n.data=a):a&&(n.data=a),\"DELETE\"===t&&(delete n.data,delete n.contentType),n},a.prototype.send=function(t,s,a,n){if(s=s||\"GET\",s=s.toUpperCase(),n=n||{},t=this._resolveUrl(t),n.success||n.error){var r=\"Success and error handler are not allowed in mOptions\";throw new Error(r)}var o=n.contentType||this.DEFAULT_CONTENT_TYPE;return n=e.extend(!0,this._getDefaultOptions(s,o,a),n),this._sendAjaxRequest(t,n)},a.prototype._getMessagesFromXHR=function(e){var t,s,a,n;s=[];try{if(t=JSON.parse(e.responseText),t&&t.messages&&t.messages.length>0)for(a=t.messages.length,n=0;n<a;n++)s.push({severity:t.messages[n].severity,text:t.messages[n].text})}catch(e){}return s},a.prototype._sendAjaxRequest=function(t,s){var a=this,n=\"/sap/bc/lrep/actions/getcsrftoken/\",r={headers:{\"X-CSRF-Token\":\"fetch\"},type:\"HEAD\"};return this._sClient&&(r.headers[\"sap-client\"]=this._sClient),new Promise(function(o,i){function p(t,s,n){var r=n.getResponseHeader(\"X-CSRF-Token\");a._sXsrfToken=r||a._sXsrfToken;var i=n.getResponseHeader(\"etag\"),p={status:s,etag:i,response:t};o(p),e.each(a._aSentRequestListeners,function(e,t){t(p)})}function u(n,r,o){a._sXsrfToken=o.getResponseHeader(\"X-CSRF-Token\"),s.headers=s.headers||{},s.headers[\"X-CSRF-Token\"]=a._sXsrfToken,e.ajax(t,s).done(p).fail(function(e,t,s){var n=new Error(s);n.status=\"error\",n.code=e.statusCode().status,n.messages=a._getMessagesFromXHR(e),i(n)})}function l(t,p,l){if(403===t.status)e.ajax(n,r).done(u).fail(function(e,t,s){i({status:\"error\"})});else if(s&&\"DELETE\"===s.type&&404===t.status)o();else{var c;c={status:\"error\"},c.code=t.statusCode().status,c.messages=a._getMessagesFromXHR(t),i(c)}}var c=!0;s&&s.type?\"GET\"!==s.type&&\"HEAD\"!==s.type||(c=!1):a._sXsrfToken&&\"fetch\"!==a._sXsrfToken&&(c=!1),c?e.ajax(n,r).done(u).fail(function(e,t,s){i({status:\"error\"})}):e.ajax(t,s).done(p).fail(l)})},a.prototype.loadChanges=function(e,t){var a,n={},r=this,o=e.name;if(!o)return Promise.reject(new Error(\"Component name not specified\"));a=\"/sap/bc/lrep/flex/data/\";var i=\"\";if(t){var p=t.cacheKey;p&&(n.cache=!0,a+=\"~\"+p+\"~/\"),t.appDescriptor&&t.appDescriptor[\"sap.app\"]&&(n.headers||(n.headers={}),n.headers={\"X-LRep-AppDescriptor-Id\":t.appDescriptor[\"sap.app\"].id}),t.siteId&&(n.headers||(n.headers={}),n.headers={\"X-LRep-Site-Id\":t.siteId}),t.layer&&(i=t.layer)}return o&&(a+=o),this._sClient&&(a+=\"&sap-client=\"+this._sClient),i&&(a+=\"&upToLayerType=\"+i),e.appVersion&&e.appVersion!==s.DEFAULT_APP_VERSION&&(a+=\"&appVersion=\"+e.appVersion),a=a.replace(\"&\",\"?\"),this.send(a,void 0,void 0,n).then(function(e){return{changes:e.response,componentClassName:o,etag:e.etag}},function(e){if(404===e.code||405===e.code)return r._loadChangesBasedOnOldRoute(o);throw e})},a.prototype.loadSettings=function(){var e=\"/sap/bc/lrep/flex/settings\";return this._sClient&&(e+=\"?sap-client=\"+this._sClient),this.send(e,void 0,void 0,{}).then(function(e){return e.response})},a.prototype._loadChangesBasedOnOldRoute=function(t){var s,a;try{s=e.sap.getResourceName(t,\"-changes.json\")}catch(e){return Promise.reject(e)}return a={async:!0,dataType:\"json\",failOnError:!0,headers:{\"X-UI5-Component\":t}},this._sClient&&(a.headers[\"sap-client\"]=this._sClient),e.sap.loadResource(s,a).then(function(e){return{changes:e,componentClassName:t}})},a.prototype._buildParams=function(e){e||(e=[]),this._sClient&&e.push({name:\"sap-client\",value:this._sClient}),this._sLanguage&&e.push({name:\"sap-language\",value:this._sLanguage});for(var t=\"\",s=e.length,a=0;a<s;a++)0===a?t+=\"?\":a>0&&a<s&&(t+=\"&\"),t+=e[a].name+\"=\"+e[a].value;return t},a.prototype._getUrlPrefix=function(e){return e?\"/sap/bc/lrep/variants/\":\"/sap/bc/lrep/changes/\"},a.prototype.create=function(e,t,s){var a=this._getUrlPrefix(s),n=[];return t&&n.push({name:\"changelist\",value:t}),a+=this._buildParams(n),this.send(a,\"POST\",e,null)},a.prototype.update=function(e,t,s,a){var n=this._getUrlPrefix(a);n+=t;var r=[];return s&&r.push({name:\"changelist\",value:s}),n+=this._buildParams(r),this.send(n,\"PUT\",e,null)},a.prototype.deleteChange=function(e,t){var s=this._getUrlPrefix(t);s+=e.sChangeName;var a=[];return e.sLayer&&a.push({name:\"layer\",value:e.sLayer}),e.sNamespace&&a.push({name:\"namespace\",value:e.sNamespace}),e.sChangelist&&a.push({name:\"changelist\",value:e.sChangelist}),s+=this._buildParams(a),this.send(s,\"DELETE\",{},null)},a.prototype.getStaticResource=function(e,t,s,a){var n=\"/sap/bc/lrep/content/\",r=n;r+=e+\"/\"+t+\".\"+s;var o=[];return a||o.push({name:\"dt\",value:\"true\"}),r+=this._buildParams(o),this.send(r,\"GET\",null,null)},a.prototype.getFileAttributes=function(e,t,s,a){var n=\"/sap/bc/lrep/content/\",r=n;r+=e+\"/\"+t+\".\"+s;var o=[];return o.push({name:\"metadata\",value:\"true\"}),a&&o.push({name:\"layer\",value:a}),r+=this._buildParams(o),this.send(r,\"GET\",null,null)},a.prototype.upsert=function(e,t,s,a,n,r,o){var i=this;return Promise.resolve(i._fileAction(\"PUT\",e,t,s,a,n,r,o))},a.prototype.deleteFile=function(e,t,s,a,n){return this._fileAction(\"DELETE\",e,t,s,a,null,null,n)},a.prototype._fileAction=function(e,t,s,a,n,r,o,i){var p=\"/sap/bc/lrep/content/\",u=p;u+=t+\"/\"+s+\".\"+a;var l=[];l.push({name:\"layer\",value:n}),i&&l.push({name:\"changelist\",value:i}),u+=this._buildParams(l);var c={contentType:o||this.DEFAULT_CONTENT_TYPE};return this.send(u,e.toUpperCase(),r,c)},a.prototype.publish=function(e,t,s,a,n,r,o){var i=\"/sap/bc/lrep/actions/publish/\",p=i;p+=e+\"/\"+t+\".\"+s;var u=[];return a&&u.push({name:\"layer\",value:a}),n&&u.push({name:\"target-layer\",value:n}),r&&u.push({name:\"target-namespace\",value:r}),o&&u.push({name:\"changelist\",value:o}),p+=this._buildParams(u),this.send(p,\"POST\",{},null)},a.prototype.listContent=function(e,t){var s=\"/sap/bc/lrep/content/\";s+=e;var a=[];return t&&a.push({name:\"layer\",value:t}),s+=this._buildParams(a),this.send(s,\"GET\",null,null)},a},!0);",
		"sap/ui/fl/Persistence.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Change\",\"sap/ui/fl/DefaultVariant\",\"sap/ui/fl/StandardVariant\",\"sap/ui/fl/Utils\",\"jquery.sap.global\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Cache\"],function(e,t,n,o,r,a,s){\"use strict\";var i=function(e,t){this._oControl=e,this._bHasLoadedChangesFromBackEnd=!1,this._sStableIdPropertyName=t||\"id\",this._sStableId=this._getStableId(),this._sComponentName=o.getComponentClassName(e),this._sComponentName||o.log.error(\"The Control does not belong to an SAPUI5 component. Variants and Changes for this control might not work as expected.\"),this._oAppDescriptor=o.getAppDescriptor(e),this._sAppVersion=o.getAppVersionFromManifest(this._oAppDescriptor),this._sSiteId=o.getSiteId(e),this._oChanges={},this._oMessagebundle={},this._oConnector=this._createLrepConnector()};return i.prototype.getComponentName=function(){return this._sComponentName},i.prototype.setComponentName=function(e){this._sComponentName=e},i.prototype._createLrepConnector=function(){var e,t;return e=o.getXSRFTokenFromControl(this._oControl),t={XsrfToken:e},a.createConnector(t)},i.prototype._getStableId=function(){if(this._oControl){if(this._sStableIdPropertyName&&\"id\"!==this._sStableIdPropertyName){var e;try{e=this._oControl.getProperty(this._sStableIdPropertyName)}catch(t){e=\"\"}return e}if(\"function\"==typeof this._oControl.getId)return this._oControl.getId()}},i.prototype._existVendorLayerChange=function(){var e=!1;return jQuery.each(this._oChanges,function(t,n){var o=n._oOriginDefinition;if(\"VENDOR\"===o.layer)return e=!0,!1}),e},i.prototype._getOwnerComponentOfControl=function(e){if(e){var t=sap.ui.core.Component.getOwnerIdFor(e);if(t){var n=sap.ui.component(t);return n}return this._getOwnerComponentOfControl(e.getParent())}},i.prototype._checkForMessagebundleBinding=function(){if(this._existVendorLayerChange()){var e=this._getOwnerComponentOfControl(this._oControl);if(e&&!e.getModel(\"i18nFlexVendor\")){var t=new sap.ui.model.json.JSONModel(this._oMessagebundle);e.setModel(t,\"i18nFlexVendor\")}}},i.prototype.getChanges=function(){var e=this,t={appDescriptor:this._oAppDescriptor,siteId:this._sSiteId};return this._bHasLoadedChangesFromBackEnd===!0?(this._oMessagebundle&&this._checkForMessagebundleBinding(),Promise.resolve(this._oChanges)):s.getChangesFillingCache(this._oConnector,{name:this._sComponentName,appVersion:this._sAppVersion},t).then(e._resolveFillingCacheWithChanges.bind(e))},i.prototype._resolveFillingCacheWithChanges=function(e){return this._fillRelevantChanges(e),e&&e.changes&&e.changes.messagebundle&&(this._oMessagebundle=e.changes.messagebundle,this._checkForMessagebundleBinding()),this._bHasLoadedChangesFromBackEnd=!0,this._oChanges},i.prototype.getComponentChanges=function(){var e=this,t={appDescriptor:this._oAppDescriptor,siteId:this._sSiteId};return s.getChangesFillingCache(this._oConnector,{name:this._sComponentName,appVersion:this._sAppVersion},t).then(function(t){var n=!0;return e._fillRelevantChanges(t,n),e._oChanges})},i.prototype._fillRelevantChanges=function(t,n){var r,a,s,i,h,p,c,g=this,l=function(e,t){o.log.error(\"key : \"+e+\" and text : \"+t.value)},u=function(t,r){if(n===!0&&\"change\"===s.fileType||g._sStableId===r)return h=new e(s),h.attachEvent(e.events.markForDeletion,g._onDeleteChange.bind(g)),c=h.getId(),h.isValid()&&(g._oChanges[c]&&h.isVariant()&&(o.log.error(\"Id collision - two or more variant files having the same id detected: \"+c),jQuery.each(h.getDefinition().texts,l),o.log.error(\"already exists in variant : \"),jQuery.each(g._oChanges[c].getDefinition().texts,l)),g._oChanges[c]=h),!1};if(t&&t.changes&&t.changes.changes)for(r=t.changes.changes,a=r.length,p=0;p<a;p++)o.isOverMaxLayer(r[p].layer)||(s=r[p],i=s.selector,i&&jQuery.each(i,u))},i.prototype.getChange=function(e){return e?this._oChanges[e]:void o.log.error(\"sap.ui.fl.Persistence.getChange : sChangeId is not defined\")},i.prototype.addChange=function(t){var n,r,a,s;if(t){t.type||o.log.error(\"sap.ui.fl.Persistence.addChange : type is not defined\");var i=jQuery.type(t.content);\"object\"!==i&&\"array\"!==i&&o.log.error(\"mParameters.content is not of expected type object or array, but is: \"+i,\"sap.ui.fl.Persistence#addChange\"),a={},\"object\"==typeof t.texts&&jQuery.each(t.texts,function(e,t){a[e]={value:t,type:\"XFLD\"}});var h={creation:this._sAppVersion,from:this._sAppVersion};return this._sAppVersion&&t.developerMode&&(h.to=this._sAppVersion),r={changeType:t.type,service:t.ODataService,texts:a,content:t.content,reference:this._sComponentName,isVariant:t.isVariant,packageName:t.packageName,isUserDependent:t.isUserDependent,validAppVersions:h},r.selector=this._getSelector(),n=e.createInitialFileContent(r),t.id&&(n.fileName=t.id),s=this.addChangeFile(n),s.getId()}},i.prototype.addChangeFile=function(t){var n,o;return n=new e(t),n.attachEvent(e.events.markForDeletion,this._onDeleteChange.bind(this)),o=n.getId(),this._oChanges[o]=n,n},i.prototype.removeChangeFromPersistence=function(e){if(\"NEW\"===e.getPendingAction()){var t=e.getId();delete this._oChanges[t]}},i.prototype.putChange=function(t){t.attachEvent(e.events.markForDeletion,this._onDeleteChange.bind(this));var n=t.getId();this._oChanges[n]=t},i.prototype._getSelector=function(){var e;return e={},this._sStableIdPropertyName&&(e[this._sStableIdPropertyName]=this._sStableId),e},i.prototype.getExecuteOnSelect=function(){return this.getChanges().then(function(e){return n.getExecuteOnSelect(e)})},i.prototype.getExecuteOnSelectSync=function(){return n.getExecuteOnSelect(this._oChanges)},i.prototype.setExecuteOnSelectSync=function(t){var o,r,a={};if(a[this._sStableIdPropertyName]=this._sStableId,o={executeOnSelect:t,reference:this._sComponentName,selector:a},r=n.updateExecuteOnSelect(this._oChanges,t))return r;r=n.createChangeObject(o),r.attachEvent(e.events.markForDeletion,this._onDeleteChange.bind(this));var s=r.getId();return this._oChanges[s]=r,r},i.prototype.setExecuteOnSelect=function(t){var o,r,a=this;return this.getChanges().then(function(s){var i={};return i[a._sStableIdPropertyName]=a._sStableId,o={executeOnSelect:t,reference:a._sComponentName,selector:i},(r=n.updateExecuteOnSelect(s,t))?r:(r=n.createChangeObject(o),r.attachEvent(e.events.markForDeletion,a._onDeleteChange.bind(a)),s[r.getId()]=r,r)})},i.prototype.getDefaultVariantId=function(){return this.getChanges().then(function(e){return t.getDefaultVariantId(e)})},i.prototype.getDefaultVariantIdSync=function(){return t.getDefaultVariantId(this._oChanges)},i.prototype.setDefaultVariantIdSync=function(n){var o,r,a={};if(a[this._sStableIdPropertyName]=this._sStableId,o={defaultVariantId:n,reference:this._sComponentName,selector:a},r=t.updateDefaultVariantId(this._oChanges,n))return r;r=t.createChangeObject(o),r.attachEvent(e.events.markForDeletion,this._onDeleteChange.bind(this));var s=r.getId();return this._oChanges[s]=r,r},i.prototype.setDefaultVariantId=function(n){var o,r,a=this;return this.getChanges().then(function(s){var i={};return i[a._sStableIdPropertyName]=a._sStableId,o={defaultVariantId:n,reference:a._sComponentName,selector:i},(r=t.updateDefaultVariantId(s,n))?r:(r=t.createChangeObject(o),r.attachEvent(e.events.markForDeletion,a._onDeleteChange.bind(a)),s[r.getId()]=r,r)})},i.prototype.saveAll=function(){var t=[],n=this;return jQuery.each(this._oChanges,function(o,r){switch(r.getPendingAction()){case\"NEW\":t.push(n._oConnector.create(r.getDefinition(),r.getRequest(),r.isVariant()).then(function(e){return r.setResponse(e.response),s.isActive()&&s.addChange({name:n._sComponentName,appVersion:n._sAppVersion},e.response),e}));break;case\"UPDATE\":t.push(n._oConnector.update(r.getDefinition(),r.getId(),r.getRequest(),r.isVariant()).then(function(e){return r.setResponse(e.response),s.isActive()&&s.updateChange({name:n._sComponentName,appVersion:n._sAppVersion},e.response),e}));break;case\"DELETE\":t.push(n._oConnector.deleteChange({sChangeName:r.getId(),sLayer:r.getLayer(),sNamespace:r.getNamespace(),sChangelist:r.getRequest()},r.isVariant()).then(function(t){var o=r.getId(),a={id:o};return r.fireEvent(e.events.markForDeletion,a),s.isActive()&&s.deleteChange({name:n._sComponentName,appVersion:n._sAppVersion},r.getDefinition()),t}))}}),Promise.all(t)},i.prototype._onDeleteChange=function(e){var t;t=e.getParameter(\"id\");var n=this.getChange(t);\"DELETE\"===n.getPendingAction()&&delete this._oChanges[t]},i.prototype.isVariantDownport=function(){var e,t;return e=o.getCurrentLayer(),t=o.isHotfixMode(),\"VENDOR\"===e&&t},i},!0);",
		"sap/ui/fl/Preprocessor.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/Object\"],function(e,s){\"use strict\";return s.extend(\"sap.ui.fl.Preprocessor\",{})},!0);",
		"sap/ui/fl/PreprocessorImpl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Component\",\"sap/ui/fl/FlexControllerFactory\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/ChangePersistenceFactory\"],function(jQuery,Component,FlexControllerFactory,Utils,LrepConnector,ChangePersistenceFactory){\"use strict\";var PreprocessorImpl=function(){};return PreprocessorImpl.prototype.getControllerExtensions=function(e,o,n){if(n){if(!o)return jQuery.sap.log.warning(\"No component ID for determining the anchor of the code extensions was passed.\"),[];var t=sap.ui.component(o),r=Utils.getAppComponentForControl(t),s=Utils.getComponentClassName(r),i=Utils.getAppVersionFromManifest(r.getManifest()),a=ChangePersistenceFactory.getChangePersistenceForComponent(s,i);return a.getChangesForComponent().then(function(o){var n=[];return jQuery.each(o,function(o,t){var r=t.getDefinition();\"codeExt\"===r.changeType&&r.content&&e===r.selector.id&&n.push(PreprocessorImpl.getExtensionProvider(r))}),n})}},PreprocessorImpl.getExtensionProvider=function(oChange){var sConvertedAsciiCodeContent=oChange.content.code||{},sConvertedCodeContent=Utils.asciiToString(sConvertedAsciiCodeContent),oExtensionProvider;return eval(\"oExtensionProvider = \"+sConvertedCodeContent),oExtensionProvider},PreprocessorImpl},!0);",
		"sap/ui/fl/RegistrationDelegator.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/FlexControllerFactory\",\"sap/ui/core/Component\",\"sap/ui/fl/registry/ChangeHandlerRegistration\",\"sap/ui/fl/ChangePersistenceFactory\",\"sap/ui/core/mvc/Controller\",\"sap/ui/core/mvc/XMLView\",\"sap/ui/fl/EventHistory\"],function(e,r,n,s,t,o,i){\"use strict\";var a={};return a.registerChangesInComponent=function(){r._fnOnInstanceCreated=e.getChangesAndPropagate},a.registerChangeHandlers=function(){n.getChangeHandlersOfLoadedLibsAndRegisterOnNewLoadedLibs()},a.registerLoadComponentEventHandler=function(){r._fnLoadComponentCallback=s._onLoadComponent.bind(s)},a.registerExtensionProvider=function(){t.registerExtensionProvider(\"sap.ui.fl.PreprocessorImpl\")},a.registerXMLPreprocessor=function(){o.registerPreprocessor&&o.registerPreprocessor(\"viewxml\",\"sap.ui.fl.XmlPreprocessorImpl\",!0)},a.registerEventListener=function(){i.start()},a.registerAll=function(){a.registerEventListener(),a.registerChangeHandlers(),a.registerLoadComponentEventHandler(),a.registerExtensionProvider(),a.registerChangesInComponent(),a.registerXMLPreprocessor()},a},!0);",
		"sap/ui/fl/registry/ChangeHandlerRegistration.js": "/*!\n* UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n*/\nsap.ui.define([\"sap/ui/fl/registry/ChangeRegistry\"],function(e){\"use strict\";var a={getChangeHandlersOfLoadedLibsAndRegisterOnNewLoadedLibs:function(){var e=this,a=sap.ui.getCore(),n=a.getLoadedLibraries();jQuery.each(n,function(a,n){n.extensions&&n.extensions.flChangeHandlers&&e.registerFlexChangeHandlers(n.extensions.flChangeHandlers)}),a.attachLibraryChanged(this.handleLibraryRegistrationAfterFlexLibraryIsLoaded.bind(this))},registerFlexChangeHandlers:function(a){if(a){var n=e.getInstance();n.registerControlsForChanges(a)}},handleLibraryRegistrationAfterFlexLibraryIsLoaded:function(e){if(\"add\"===e.getParameter(\"operation\")){var a=e.getParameter(\"metadata\");if(a&&a.extensions&&a.extensions.flChangeHandlers){var n=a.extensions.flChangeHandlers;this.registerFlexChangeHandlers(n)}}}};return a},!0);",
		"sap/ui/fl/registry/ChangeRegistry.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\",\"jquery.sap.global\",\"sap/ui/fl/registry/ChangeRegistryItem\",\"sap/ui/fl/registry/ChangeTypeMetadata\",\"sap/ui/fl/registry/Settings\",\"sap/ui/fl/changeHandler/HideControl\",\"sap/ui/fl/changeHandler/MoveElements\",\"sap/ui/fl/changeHandler/MoveControls\",\"sap/ui/fl/changeHandler/PropertyChange\",\"sap/ui/fl/changeHandler/PropertyBindingChange\",\"sap/ui/fl/changeHandler/UnhideControl\",\"sap/ui/fl/changeHandler/StashControl\",\"sap/ui/fl/changeHandler/UnstashControl\"],function(e,t,r,n,a,i,o,s,l,g,h,d,p){\"use strict\";var c=function(){this._registeredItems={},this.initSettings(),this.initDeveloperModeChangeHandlers()};return c._instance=void 0,c.prototype._oDefaultActiveChangeHandlers={},c.prototype._oDefaultChangeHandlers={hideControl:i,moveElements:o,moveControls:s,unhideControl:h,stashControl:d,unstashControl:p},c.prototype._mDeveloperModeChangeHandlers={propertyChange:{changeHandler:l},propertyBindingChange:{changeHandler:g}},c.prototype.initDeveloperModeChangeHandlers=function(){Object.keys(this._mDeveloperModeChangeHandlers).forEach(function(e){var t=this._mDeveloperModeChangeHandlers[e].changeHandler,r=this._oSettings.getDeveloperModeLayerPermissions(),n={changeType:e,changeHandler:t,layers:r},a=this._createChangeRegistryItemForSimpleChange(\"defaultActiveForAllControls\",n);this._oDefaultActiveChangeHandlers[e]=a}.bind(this))},c.getInstance=function(){return c._instance||(c._instance=new c),c._instance},c.prototype.hasRegisteredChangeHandlersForControl=function(e){var t=Object.keys(this._registeredItems);return t.indexOf(e)!==-1},c.prototype.hasChangeHandlerForControlAndChange=function(e,t){if(!this.hasRegisteredChangeHandlersForControl(e))return!1;var r=this._registeredItems[e],n=Object.keys(r);return n.indexOf(t)!==-1},c.prototype.registerControlsForChanges=function(e){var r=this;t.each(e,function(e,t){if(Array.isArray(t)){var n={};t.forEach(function(e){n[e.changeType]=e.changeHandler}),r._registerChangeHandlersForControl(e,n)}else r._registerChangeHandlersForControl(e,t)})},c.prototype._registerChangeHandlersForControl=function(r,n){var a=this;if(\"string\"==typeof n)try{n=sap.ui.requireSync(n+\".flexibility\")}catch(t){return void e.log.error(\"Flexibility change handler registration failed.\\nControlType: \"+r+\"\\n\"+t.message)}t.each(n,function(e,t){var n=a._getChangeHandler(e,t),i={changeType:e,changeHandler:n.changeHandler,layers:n.layers};a.registerControlForSimpleChange(r,i)})},c.prototype._getChangeHandler=function(e,t){var r={},n=Object.keys(this._mDeveloperModeChangeHandlers);if(t.changeHandler?r=t:r.changeHandler=t,\"default\"===r.changeHandler)r.changeHandler=this._oDefaultChangeHandlers[e];else if(n.indexOf(e)>-1)throw new Error(\"You can't use a custom change handler for the following Developer Mode change types: \"+n.toString()+\". Please use 'default' instead.\");return r},c.prototype.registerControlForSimpleChange=function(e,t){var r;e&&t&&t.changeType&&t.changeHandler&&(r=this._createChangeRegistryItemForSimpleChange(e,t),r&&this.addRegistryItem(r))},c.prototype._createChangeRegistryItemForSimpleChange=function(e,a){var i,o,s,l;l=t.extend({},this._oSettings.getDefaultLayerPermissions());var g=a.layers;return g&&Object.keys(g).forEach(function(e){if(void 0===l[e])throw new Error(\"The Layer '\"+e+\"' is not supported. Please only use supported layers\");l[e]=g[e]}),i={name:a.changeType,changeHandler:a.changeHandler,layers:l},o=new n(i),i={changeTypeMetadata:o,controlType:e},s=new r(i)},c.prototype.addRegistryItem=function(e){var t,r;e&&(t=e.getChangeTypeName(),r=e.getControlType(),this._registeredItems[r]=this._registeredItems[r]||{},this._registeredItems[r][t]=e)},c.prototype.removeRegistryItem=function(t){if(!t.changeTypeName&&!t.controlType)return void e.log.error(\"sap.ui.fl.registry.ChangeRegistry: ChangeType and/or ControlType required\");if(t.controlType&&t.changeTypeName)this._registeredItems[t.controlType]&&(1===Object.keys(this._registeredItems[t.controlType]).length?delete this._registeredItems[t.controlType]:delete this._registeredItems[t.controlType][t.changeTypeName]);else if(t.controlType)this._registeredItems[t.controlType]&&delete this._registeredItems[t.controlType];else if(t.changeTypeName)for(var r in this._registeredItems){var n=this._registeredItems[r];delete n[t.changeTypeName]}},c.prototype.getRegistryItems=function(t){t||e.log.error(\"sap.ui.fl.registry.ChangeRegistry: no parameters passed for getRegistryItems\");var r=t.changeTypeName,n=t.controlType;r||n||e.log.error(\"sap.ui.fl.registry.ChangeRegistry: Change Type Name and/or Control Type required\");var a=null;if(n&&r){var i=this._getOrLoadChangeHandler(n,r);i&&(a={},a[n]={},a[n][r]=i)}else if(n){if(a={},a[n]={},this._registeredItems[n]){var o=Object.keys(this._registeredItems[n]);o.forEach(function(e){a[n][e]=this._getOrLoadChangeHandler(n,e)}.bind(this))}for(var s in this._oDefaultActiveChangeHandlers)a[n][s]=this._oDefaultActiveChangeHandlers[s]}else if(r){a={};for(n in this._registeredItems)this._registeredItems[n][r]&&(a[n]={},a[n][r]=this._getOrLoadChangeHandler(n,r));a.defaultActiveForAllControls={};for(var l in this._oDefaultActiveChangeHandlers)a.defaultActiveForAllControls[l]=this._oDefaultActiveChangeHandlers[l]}return this._filterChangeTypes(a,t.layer),a},c.prototype._getOrLoadChangeHandler=function(e,r){var n=this._registeredItems[e];if(n){var a=n[r];if(a){var i=a.getChangeTypeMetadata(),o=i.getChangeHandler();return\"string\"==typeof o&&(t.sap.require(o),o=sap.ui.require(o),i._changeHandler=o),a}}var s=this._oDefaultActiveChangeHandlers[r];return s?s:null},c.prototype.initSettings=function(){this._oSettings=a.getInstanceOrUndef(),this._oSettings||(this._oSettings=new a({}))},c.prototype._filterChangeTypes=function(r,n){if(this._oSettings&&n&&r){var a=!1;t.each(r,function(r,i){t.each(i,function(t,r){var o=r.getChangeTypeMetadata().getLayers();a=o[n],a||(e.log.warning(\"Change type \"+t+\" not enabled for layer \"+n),delete i[t])})})}},c.prototype.getDragInfo=function(e){var t=this._registeredItems[e];return t?t.getDragInfo():null},c},!0);",
		"sap/ui/fl/registry/ChangeRegistryItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\",\"jquery.sap.global\"],function(e,t){\"use strict\";var r=function(t){t.changeTypeMetadata||e.log.error(\"sap.ui.fl.registry.ChangeRegistryItem: ChangeTypeMetadata required\"),t.controlType||e.log.error(\"sap.ui.fl.registry.ChangeRegistryItem: ControlType required\"),this._changeTypeMetadata=t.changeTypeMetadata,this._controlType=t.controlType,t.permittedRoles&&(this._permittedRoles=t.permittedRoles),t.dragTargets&&(this._dragTargets=t.dragTargets)};return r.prototype._changeTypeMetadata=void 0,r.prototype._controlType=void 0,r.prototype._permittedRoles={},r.prototype._dragTargets=[],r.prototype.getChangeTypeMetadata=function(){return this._changeTypeMetadata},r.prototype.getChangeTypeName=function(){return this._changeTypeMetadata.getName()},r.prototype.getControlType=function(){return this._controlType},r.prototype.getPermittedRoles=function(){return this._permittedRoles},r.prototype.getDragTargets=function(){return this._dragTargets},r},!0);",
		"sap/ui/fl/registry/ChangeTypeMetadata.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/Utils\",\"jquery.sap.global\"],function(e,t){\"use strict\";var o=function(t){t.name||e.log.error(\"sap.ui.fl.registry.ChangeType: Name required\"),t.changeHandler||e.log.error(\"sap.ui.fl.registry.ChangeType: ChangeHandler required\"),this._name=t.name,this._changeHandler=t.changeHandler,this._layers=t.layers,t.labelKey&&(this._labelKey=t.labelKey),t.tooltipKey&&(this._tooltipKey=t.tooltipKey),t.iconKey&&(this._iconKey=t.iconKey),t.sortIndex&&(this._sortIndex=t.sortIndex)};return o.prototype._name=\"\",o.prototype._changeHandler=\"\",o.prototype._layers=[],o.prototype._sortIndex=0,o.prototype._labelKey=\"\",o.prototype._tooltipKey=\"\",o.prototype._iconKey=\"\",o.prototype.getName=function(){return this._name},o.prototype.getChangeHandler=function(){return this._changeHandler},o.prototype.getLayers=function(){return this._layers},o.prototype.getLabel=function(){return this._labelKey},o.prototype.getTooltip=function(){return this._tooltipKey},o.prototype.getIcon=function(){return this._iconKey},o.prototype.getSortIndex=function(){return this._sortIndex},o},!0);",
		"sap/ui/fl/registry/Settings.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Cache\",\"sap/ui/fl/Utils\",\"sap/ui/base/EventProvider\"],function(e,t,n,i,o){\"use strict\";var a=function(e){if(o.apply(this),!e)throw new Error(\"no flex settings provided\");e.defaultLayerPermissions||(e.defaultLayerPermissions={VENDOR:!0,CUSTOMER_BASE:!0,CUSTOMER:!0,USER:!1}),e.developerModeLayerPermissions||(e.developerModeLayerPermissions={VENDOR:!0,CUSTOMER_BASE:!0,CUSTOMER:!1,USER:!1}),this._oSettings=e,this._hasMergeErrorOccured=!1};return a.prototype=e.sap.newObject(o.prototype),a.events={flexibilityAdaptationButtonAllowedChanged:\"flexibilityAdaptationButtonAllowedChanged\",changeModeUpdated:\"changeModeUpdated\"},a._instance=void 0,a._bFlexChangeMode=!0,a._bFlexibilityAdaptationButtonAllowed=!1,a._oEventProvider=new o,a.fireEvent=function(e,t){a._oEventProvider.fireEvent(e,t)},a.attachEvent=function(e,t){a._oEventProvider.attachEvent(e,t)},a.detachEvent=function(e,t){a._oEventProvider.detachEvent(e,t)},a.getInstance=function(e,o,r){return a._instance?Promise.resolve(a._instance):e?(o=o||i.DEFAULT_APP_VERSION,n.getChangesFillingCache(t.createConnector(),{name:e,appVersion:o},r).then(function(e){var t={};return e.changes&&e.changes.settings&&(t=e.changes.settings),a._storeInstance(t)})):a._loadSettings()},a._loadSettings=function(){return t.createConnector().loadSettings().then(function(e){return a._storeInstance(e)})},a._storeInstance=function(e){return a._instance||(a._instance=new a(e)),a._instance},a.getInstanceOrUndef=function(){var e;return a._instance&&(e=a._instance),e},a.isFlexChangeMode=function(){var e=this._isFlexChangeModeFromUrl();return void 0!==e?e:a._bFlexChangeMode},a._isFlexChangeModeFromUrl=function(){var t,n=e.sap.getUriParameters();return n&&n.mParams&&n.mParams[\"sap-ui-fl-changeMode\"]&&n.mParams[\"sap-ui-fl-changeMode\"][0]&&(\"true\"===n.mParams[\"sap-ui-fl-changeMode\"][0]?t=!0:\"false\"===n.mParams[\"sap-ui-fl-changeMode\"][0]&&(t=!1)),t},a.activateFlexChangeMode=function(){var e=!0;a._setFlexChangeMode(e)},a.leaveFlexChangeMode=function(){var e=!1;a._setFlexChangeMode(e)},a._setFlexChangeMode=function(e){if(a._bFlexChangeMode!==e){a._bFlexChangeMode=e;var t={bFlexChangeMode:e};a.fireEvent(a.events.changeModeUpdated,t)}},a.isFlexibilityAdaptationButtonAllowed=function(){return a._bFlexibilityAdaptationButtonAllowed},a.allowFlexibilityAdaptationButton=function(){var e=!0;a.setFlexibilityAdaptationButtonAllowed(e)},a.disallowFlexibilityAdaptationButton=function(){var e=!1;a.setFlexibilityAdaptationButtonAllowed(e)},a.setFlexibilityAdaptationButtonAllowed=function(e){if(a._bFlexibilityAdaptationButtonAllowed!==e){a._bFlexibilityAdaptationButtonAllowed=e;var t={bFlexibilityAdaptationButtonAllowed:e};a.fireEvent(a.events.flexibilityAdaptationButtonAllowedChanged,t)}},a.prototype.isKeyUser=function(){var e=!1;return this._oSettings.isKeyUser&&(e=this._oSettings.isKeyUser),e},a.prototype.isModelS=function(){var e=!1;return this._oSettings.isAtoAvailable&&(e=this._oSettings.isAtoAvailable),e},a.prototype.isAtoEnabled=function(){var e=!1;return this._oSettings.isAtoEnabled&&(e=this._oSettings.isAtoEnabled),e},a.prototype.isProductiveSystem=function(){var e=!1;return this._oSettings.isProductiveSystem&&(e=this._oSettings.isProductiveSystem),e},a.prototype.setMergeErrorOccured=function(e){this._hasMergeErrorOccoured=e},a.prototype.hasMergeErrorOccured=function(){return this._hasMergeErrorOccured},a.prototype.getDefaultLayerPermissions=function(){return this._oSettings.defaultLayerPermissions},a.prototype.getDeveloperModeLayerPermissions=function(){return this._oSettings.developerModeLayerPermissions},a},!0);",
		"sap/ui/fl/registry/SimpleChanges.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/changeHandler/HideControl\",\"sap/ui/fl/changeHandler/UnhideControl\",\"sap/ui/fl/changeHandler/StashControl\",\"sap/ui/fl/changeHandler/UnstashControl\",\"sap/ui/fl/changeHandler/MoveElements\",\"sap/ui/fl/changeHandler/MoveControls\",\"sap/ui/fl/changeHandler/PropertyChange\",\"sap/ui/fl/changeHandler/PropertyBindingChange\"],function(e,n,a,r,l,o,h,g,t){\"use strict\";var s={hideControl:{changeType:\"hideControl\",changeHandler:n},unhideControl:{changeType:\"unhideControl\",changeHandler:a},stashControl:{changeType:\"stashControl\",changeHandler:r},unstashControl:{changeType:\"unstashControl\",changeHandler:l},moveElements:{changeType:\"moveElements\",changeHandler:o},moveControls:{changeType:\"moveControls\",changeHandler:h},propertyChange:{changeType:\"propertyChange\",changeHandler:g},propertyBindingChange:{changeType:\"propertyBindingChange\",changeHandler:t}};return s},!0);",
		"sap/ui/fl/StandardVariant.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/Change\"],function(e,t){\"use strict\";var n=function(){};return n.prototype.getExecuteOnSelect=function(e){var t=this.getNewestStandardVariantChangeDeleteTheRest(e);return t?t.getContent().executeOnSelect:null},n.prototype.getNewestStandardVariantChangeDeleteTheRest=function(e){var t=this.getStandardVariantChanges(e).sort(function(e,t){var n=new Date(e.getCreation()),a=new Date(t.getCreation());return isNaN(n.getDate())?-1:isNaN(a.getDate())?1:a-n}),n=t.shift();return t.forEach(function(e){e.markForDeletion()}),n},n.prototype.getStandardVariantChanges=function(e){function t(t){return e[t]}function n(e){return\"standardVariant\"===e.getChangeType()}return e&&\"object\"==typeof e?Object.keys(e).map(t).filter(n):[]},n.prototype.updateExecuteOnSelect=function(e,t){var n=this.getNewestStandardVariantChangeDeleteTheRest(e);return n&&(n.getContent().executeOnSelect=t),n},n.prototype._createChangeFile=function(e){var n;return e.namespace=e.component+\"/changes/standard\",e.componentName=e.component,e.changeType=\"standardVariant\",n=t.createInitialFileContent(e),n.content.executeOnSelect=e.executeOnSelect,n.layer=\"USER\",n},n.prototype.createChangeObject=function(e){var n,a;return n=this._createChangeFile(e),a=new t(n)},new n},!0);",
		"sap/ui/fl/support/apps/contentbrowser/Component.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/UIComponent\"],function(e){\"use strict\";var s=e.extend(\"sap.ui.fl.support.apps.contentbrowser.Component\",{init:function(){var s=this;e.prototype.init.apply(this,arguments);var o=new sap.ui.model.resource.ResourceModel({bundleUrl:\"sap.ui.fl.support.apps.contentbrowser.i18n.i18n.properties\"});this.setModel(\"i18n\",o);var n=[],i=new sap.ui.model.json.JSONModel(n);this.setModel(i,\"messages\"),sap.ui.require([\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\"],function(e){e.setMessagesModel(s,i)});var a={},t=new sap.ui.model.json.JSONModel(a);this.setModel(t,\"content\");var p=[{name:\"All\",icon:\"sap-icon://world\"},{name:\"VENDOR\",icon:\"sap-icon://sap-logo-shape\"},{name:\"PARTNER\",icon:\"sap-icon://supplier\"},{name:\"CUSTOMER_BASE\",icon:\"sap-icon://customer-and-supplier\"},{name:\"CUSTOMER\",icon:\"sap-icon://customer\"},{name:\"LOAD\",icon:\"sap-icon://database\"},{name:\"USER\",icon:\"sap-icon://person-placeholder\"}],r=new sap.ui.model.json.JSONModel(p);this.setModel(r,\"layers\"),this.getRouter().initialize()},metadata:{manifest:\"json\"}});return s});",
		"sap/ui/fl/support/apps/contentbrowser/controller/ContentDetails.controller.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/mvc/Controller\",\"sap/m/Dialog\",\"sap/m/Text\",\"sap/m/Button\",\"sap/ui/fl/support/apps/contentbrowser/lrepConnector/LRepConnector\",\"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils\",\"sap/ui/fl/support/apps/contentbrowser/utils/DataUtils\"],function(e,t,n,o,a,i,s){\"use strict\";return e.extend(\"sap.ui.fl.support.apps.contentbrowser.controller.ContentDetails\",{oSelectedContentModel:void 0,oDataUtils:s,onInit:function(){this._initAndBindSelectedContentModel();var e=sap.ui.core.UIComponent.getRouterFor(this);e.getRoute(\"ContentDetails\").attachMatched(this._onRouteMatched,this),e.getRoute(\"ContentDetailsFlip\").attachMatched(this._onRouteMatched,this)},_initAndBindSelectedContentModel:function(){this.oSelectedContentModel=new sap.ui.model.json.JSONModel,this.getView().setModel(this.oSelectedContentModel,\"selectedContent\")},_onRouteMatched:function(e){var t=this,n=e.getParameter(\"arguments\"),o={};o.layer=n.layer,o.namespace=i.unescapeSlashes(n.namespace),o.fileName=n.fileName,o.fileType=n.fileType,\"/\"!==o.namespace[o.namespace.length-1]&&(o.namespace+=\"/\");var s=o.namespace+o.fileName+\".\"+o.fileType,l=t.getView().getContent()[0];return l.setBusy(!0),a.getContent(o.layer,s,null,null,!0).then(t._onContentReceived.bind(t,o,l,s),function(){l.setBusy(!1)})},_onContentReceived:function(e,t,n,o){var i=this;return e.data=s.formatData(o,e.fileType),e.fileType?a.getContent(e.layer,n,!0).then(i._onContentMetadataReceived.bind(i,e,t),function(){t.setBusy(!1)}):Promise().resolve()},_onContentMetadataReceived:function(e,t,n){e.metadata=n,this.oSelectedContentModel.setData(e);var o=sap.ui.getCore(),a=this.getView().createId(\"contentDetailsIconTabBar\"),i=o.getElementById(a);if(i){var s=i.getItems()[0];i.getSelectedKey()!==s.getId()&&i.setSelectedItem(s)}t.setBusy(!1)},onEditClicked:function(){var e=this.getView().getModel(\"selectedContent\"),t=e.getData(),n=sap.ui.core.UIComponent.getRouterFor(this);n.navTo(\"ContentDetailsEdit\",{layer:t.layer,namespace:i.escapeSlashes(t.namespace),fileName:t.fileName,fileType:t.fileType})},onDeleteClicked:function(){var e=this,a=new t({title:\"{i18n>confirmDeletionTitle}\",type:\"Message\",content:new n({text:\"{i18n>questionFileDeletion}\"}),beginButton:new o({text:\"{i18n>confirm}\",type:sap.m.ButtonType.Reject,press:function(){e._deleteFile(),a.close()}}),endButton:new o({text:\"{i18n>cancel}\",press:function(){a.close()}}),afterClose:function(){a.destroy()}});this.getView().addDependent(a),a.open()},_deleteFile:function(){var e=this.getView().getModel(\"selectedContent\"),t=e.getData(),n=t.layer,o=\"\";t.metadata.some(function(e){if(\"layer\"===e.name)return o=e.value,!0});var s=t.namespace,l=t.fileName,c=t.fileType,r=sap.ui.core.UIComponent.getRouterFor(this);return a.deleteFile(o,s,l,c).then(function(){r.navTo(\"LayerContentMaster\",{layer:n,namespace:i.escapeSlashes(s)})})}})});",
		"sap/ui/fl/support/apps/contentbrowser/controller/ContentDetailsEdit.controller.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/mvc/Controller\",\"sap/ui/fl/support/apps/contentbrowser/lrepConnector/LRepConnector\",\"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils\",\"sap/ui/fl/support/apps/contentbrowser/utils/DataUtils\"],function(e,t,n,a){\"use strict\";return e.extend(\"sap.ui.fl.support.apps.contentbrowser.controller.ContentDetailsEdit\",{oSelectedContentModel:void 0,oDataUtils:a,onInit:function(){this._initAndBindSelectedContentModel();var e=sap.ui.core.UIComponent.getRouterFor(this);e.getRoute(\"ContentDetailsEdit\").attachMatched(this._onRouteMatched,this)},_initAndBindSelectedContentModel:function(){this.oSelectedContentModel=new sap.ui.model.json.JSONModel,this.getView().setModel(this.oSelectedContentModel,\"selectedContent\")},_onRouteMatched:function(e){var a=this,o=e.getParameter(\"arguments\"),s={};s.layer=o.layer,s.namespace=n.unescapeSlashes(o.namespace),s.fileName=o.fileName,s.fileType=o.fileType,\"/\"!==s.namespace[s.namespace.length-1]&&(s.namespace+=\"/\");var i=s.namespace+s.fileName+\".\"+s.fileType,l=a.getView().getContent()[0];return l.setBusy(!0),t.getContent(s.layer,i,null,null,!0).then(a._onContentReceived.bind(a,s,l,i),function(){l.setBusy(!1)})},_onContentReceived:function(e,n,o,s){var i=this;return t.getContent(e.layer,o,!0).then(function(t){e.data=a.formatData(s,e.fileType),e.metadata=t,i.oSelectedContentModel.setData(e),n.setBusy(!1)},function(){n.setBusy(!1)})},onSave:function(){var e,a=this.getView().getModel(\"selectedContent\"),o=a.getData();return o.metadata.some(function(t){if(\"layer\"===t.name)return e=t.value,!0}),t.saveFile(e,n.escapeSlashes(o.namespace),o.fileName,o.fileType,o.data).then(this._navToDisplayMode.bind(this))},onCancel:function(){this._navToDisplayMode()},_navToDisplayMode:function(){var e=this.getView().getModel(\"selectedContent\"),t=e.getData(),a=sap.ui.core.UIComponent.getRouterFor(this);a.navTo(\"ContentDetailsFlip\",{layer:t.layer,namespace:n.escapeSlashes(t.namespace),fileName:t.fileName,fileType:t.fileType})}})});",
		"sap/ui/fl/support/apps/contentbrowser/controller/LayerContentMaster.controller.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/mvc/Controller\",\"sap/ui/core/UIComponent\",\"sap/ui/model/Filter\",\"sap/ui/model/FilterOperator\",\"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils\",\"sap/ui/fl/support/apps/contentbrowser/lrepConnector/LRepConnector\",\"sap/ui/fl/support/apps/contentbrowser/utils/DataUtils\"],function(e,s,t,a,n,r,i){\"use strict\";return e.extend(\"sap.ui.fl.support.apps.contentbrowser.controller.LayerContentMaster\",{sNamespace:\"\",sLayer:\"\",oDataUtils:i,onInit:function(){var e=s.getRouterFor(this);e.getRoute(\"LayerContentMaster\").attachMatched(this._onRouteMatched,this)},_onRouteMatched:function(e){var s=this,t=e.getParameter(\"arguments\");this.sLayer=t.layer,this.sNamespace=t.namespace||\"\";var a=this.getView().getContent()[0];a.setTitle(this._shortenNamespace()),a.setBusy(!0),s.sNamespace=n.unescapeSlashes(s.sNamespace),r.getContent(s.sLayer,s.sNamespace).then(s._onContentReceived.bind(s,a),function(){a.setBusy(!1)}).then(function(){r.requestPending=!1})},_onContentReceived:function(e,s){var t=this.getView().getModel(\"content\");t.setData(s),e.setBusy(!1),this.filterListByQuery(\"\"),this.getView().byId(\"search\").setValue(\"\")},onSearch:function(e){var s=e.getSource().getValue();this.filterListByQuery(s)},filterListByQuery:function(e){var s=[];e&&e.length>0&&(s=new t({filters:[new t(\"name\",a.Contains,e),new t(\"fileType\",a.Contains,e)],and:!1}));var n=this.getView().byId(\"masterComponentsList\"),r=n.getBinding(\"items\");r.filter(s,\"content\")},onContentSelected:function(e){var t=this,a=e.getSource(),r=a.getBindingContextPath().substring(1),i=t.getView().getModel(\"content\").getData(),o=i[r],p=o.name,c=i[r].fileType,l=s.getRouterFor(this);if(t.sNamespace=n.escapeSlashes(t.sNamespace),c){var u={layer:t.sLayer,namespace:t.sNamespace||n.sEscapedSlash,fileName:p,fileType:c};l.navTo(\"ContentDetails\",u)}else{var h=(t.sNamespace?t.sNamespace:n.sEscapedSlash)+p+n.sEscapedSlash;l.navTo(\"LayerContentMaster\",{layer:t.sLayer,namespace:h})}},navBack:function(){var e=s.getRouterFor(this);if(this.sNamespace&&this.sNamespace!==n.sEscapedSlash&&\"/\"!==this.sNamespace){var t=this.sNamespace.split(\"/\");t.splice(-2,1);var a=t.join(n.sEscapedSlash);e.navTo(\"LayerContentMaster\",{layer:this.sLayer,namespace:a},!0)}else e.navTo(\"Layers\")},_shortenNamespace:function(){if(!this.sNamespace||this.sNamespace===n.sEscapedSlash)return\"[\"+this.sLayer+\"] /\";var e=this.sNamespace.split(n.sEscapedSlash),s=e.length;return s>2?\"[\"+this.sLayer+\"] .../\"+e[s-2]:\"[\"+this.sLayer+\"] /\"+this.sNamespace[s-1]},handleMessagePopoverPress:function(e){var s=e.getSource();sap.ui.require([\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\"],function(e){e.handleMessagePopoverPress(s)})}})});",
		"sap/ui/fl/support/apps/contentbrowser/controller/Layers.controller.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/mvc/Controller\",\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\"],function(e,t){\"use strict\";return e.extend(\"sap.ui.fl.support.apps.contentbrowser.controller.Layers\",{onLayerSelected:function(e){var t=e.getSource(),r=t.getBindingContextPath().substring(1),o=this.getView().getModel(\"layers\").getData(),s=o[r].name,n=sap.ui.core.UIComponent.getRouterFor(this);n.navTo(\"LayerContentMaster\",{layer:s})},handleMessagePopoverPress:function(e){var r=e.getSource();t.handleMessagePopoverPress(r)}})});",
		"sap/ui/fl/support/apps/contentbrowser/lrepConnector/LRepConnector.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils\"],function(e){\"use strict\";var t={};return t.sContentPathPrefix=\"/sap/bc/lrep/content\",t._sXcsrfToken=void 0,t.getContent=function(e,n,r,o,s){var u=this,i=new Promise(function(i,f){n=encodeURI(n);var c=u._getLayerSuffix(e),a=u._getContextSuffix(c,o,r),d=t.sContentPathPrefix+(n?\"\":\"/\")+n+c+a;u._sendContentRequest(d,i,f,s)});return i},t.saveFile=function(n,r,o,s,u){var i=this;return new Promise(function(f,c){n&&void 0!==r&&o&&s||c();var a=e.unescapeSlashes(r)+o+\".\"+s,d=i._getLayerSuffix(n),p=t.sContentPathPrefix+a+d;i._getTokenAndSendPutRequest.call(i,p,u,f,c)})},t.deleteFile=function(n,r,o,s){var u=this;return new Promise(function(i,f){n&&void 0!==r&&o&&s||f();var c=e.unescapeSlashes(r)+o+\".\"+s,a=u._getLayerSuffix(n),d=t.sContentPathPrefix+c+a;u._getTokenAndSendDeletionRequest.call(u,d,i,f)})},t._getXcsrfToken=function(e){var n=this;return new Promise(function(r,o){n._sXcsrfToken&&r(n._sXcsrfToken),jQuery.ajax({url:e,type:\"HEAD\",beforeSend:function(e){e.setRequestHeader(\"X-CSRF-Token\",\"fetch\")},success:function(e,t,o){n._sXcsrfToken=o.getResponseHeader(\"x-csrf-token\"),r(n._sXcsrfToken)},error:function(e,n,r){t._reportError(e,n,r),o(r)}})})},t._getLayerSuffix=function(e){return\"All\"===e?\"\":\"?layer=\"+e},t._getContextSuffix=function(e,t,n){var r=\"\";return t||(r+=e?\"&\":\"?\",r+=\"dt=true\"),n&&(r+=e||r?\"&\":\"?\",r+=\"metadata=true\"),r},t._reportError=function(e,t,n){sap.ui.require([\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\"],function(r){r.displayError(\"Error\",e.status,t+\": \"+n)})},t._sendContentRequest=function(e,n,r,o){var s={url:e,type:\"GET\",success:function(e){n(e)},error:function(e,n,o){t._reportError(e,n,o),r(o)}};o&&(s.dataType=\"text\"),jQuery.ajax(s)},t._getTokenAndSendPutRequest=function(e,n,r,o){var s=this;t._getXcsrfToken(e).then(function(t){s._sendPutRequest(t,e,n,r,o)})},t._sendPutRequest=function(e,n,r,o,s){jQuery.ajax({url:n,contentType:\"text/plain\",dataType:\"text\",data:r,beforeSend:function(t){t.setRequestHeader(\"X-CSRF-Token\",e)},type:\"PUT\",success:function(){o()},error:function(e,n,r){t._reportError(e,n,r),s(r)}})},t._getTokenAndSendDeletionRequest=function(e,t,n){var r=this;this._getXcsrfToken(e).then(function(o){r._sendDeletionRequest(o,e,t,n)})},t._sendDeletionRequest=function(e,n,r,o){jQuery.ajax({url:n,beforeSend:function(t){t.setRequestHeader(\"X-CSRF-Token\",e)},type:\"DELETE\",success:function(e){r(e)},error:function(e,n,r){t._reportError(e,n,r),o(r)}})},t});",
		"sap/ui/fl/support/apps/contentbrowser/utils/DataUtils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(\"sap/ui/fl/support/apps/contentbrowser/utils/DataUtils\",[\"sap/m/GroupHeaderListItem\"],function(e){\"use strict\";var r={aBlacklist:[{category:\"NS\",name:\"LREP_HOME_CONTENT\",ns:\"UIF/\"},{category:\"NS\",name:\"virtual~\",ns:\"/\"}],formatData:function(e,r){if(\"js\"===r||\"properties\"===r)return e;try{return e=JSON.parse(e),JSON.stringify(e,null,\"\\t\")}catch(r){var t=sap.ui.require(\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\");return t.displayError(\"Error\",r.name,r.message),e}},getGroupHeader:function(r){var t=\"{i18n>systemData}\";return\"custom\"===r.key&&(t=\"{i18n>externalReferences}\"),new e({title:t,upperCase:!1})},isNotOnBlacklist:function(e){var r=!0;return jQuery.each(this.aBlacklist,function(t,n){var a=!0;if(jQuery.each(n,function(r,t){a=a&&e[r]===t}),a)return r=!1,!1}),r},cleanLeadingAndTrailingSlashes:function(e){if(!e)return\"\";if(\"/\"===e[0]){var r=e.substring(1,e.length);return this.cleanLeadingAndTrailingSlashes(r)}if(\"/\"===e[e.length-1]){var t=e.substring(0,e.length-1);return this.cleanLeadingAndTrailingSlashes(t)}return e},formatItemTitle:function(e){return e.namespace+e.fileName+\".\"+e.fileType},endsStringWith:function(e,r){return e.indexOf(r,e.length-r.length)!==-1}};return r},!0);",
		"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(\"sap/ui/fl/support/apps/contentbrowser/utils/ErrorUtils\",[\"sap/m/MessagePopoverItem\",\"sap/m/MessagePopover\"],function(e,s){\"use strict\";var o={};return o._masterComponent=void 0,o._messagesModel=void 0,o._emptyModel=new sap.ui.model.json.JSONModel([]),o._messageTemplate=new e({type:\"{messages>type}\",title:\"{messages>title}\",description:\"{messages>description}\"}),o._messagePopover=new s({items:{path:\"messages>/\",template:o._messageTemplate}}),o.setMessagesModel=function(e,s){o._masterComponent=e,o._messagesModel=s,o._messagePopover.setModel(o._messagesModel,\"messages\")},o.handleMessagePopoverPress=function(e){o._messagePopover.openBy(e)},o.displayError=function(e,s,t){if(o._messagesModel){var a=o._messagesModel.getData();a.push({type:e||\"Information\",title:s||\"\",description:t||\"\"}),o._messagesModel.setData(a),o._masterComponent.setModel(o._emptyModel,\"messages\"),o._masterComponent.setModel(o._messagesModel,\"messages\")}},o});",
		"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(\"sap/ui/fl/support/apps/contentbrowser/utils/HtmlEscapeUtils\",function(){\"use strict\";var s={};return s.sUnescapedSlash=\"/\",s.sEscapedSlash=\"%2F\",s.escapeSlashes=function(e){return this._replaceAll(e,s.sUnescapedSlash,s.sEscapedSlash)},s.unescapeSlashes=function(e){return this._replaceAll(e,s.sEscapedSlash,s.sUnescapedSlash)},s._replaceAll=function(s,e,a){return s.indexOf(e)===-1?s:this._replaceAll(s.replace(e,a),e,a)},s});",
		"sap/ui/fl/support/Flexibility.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/support/Plugin\",\"sap/ui/core/support/Support\",\"sap/ui/model/json/JSONModel\",\"sap/ui/fl/Utils\"],function(e,t,i,s,n){\"use strict\";var o=t.extend(\"sap.ui.fl.support.Flexibility\",{constructor:function(e){t.apply(this,[\"sapUiSupportFlexibility\",\"Flexibility\",e]),this._oStub=e,this.runsAsToolPlugin()?this._aEventIds=[this.getId()+\"SetChanges\"]:this._aEventIds=[this.getId()+\"GetChanges\"]}});return o.prototype.init=function(e){t.prototype.init.apply(this,arguments),e.isToolStub()?(this.addStylesheet(\"sap/ui/fl/support/flexibility\"),this.oModel=new s,this._renderToolPlugin()):this.onsapUiSupportFlexibilityGetChanges()},o.prototype._renderToolPlugin=function(){var t=this,i=function(){var i=sap.ui.getCore().createRenderManager();i.write(\"<div class='sapUiSupportToolbar'>\"),i.write(\"<a href='#' id='\"+t.getId()+\"-Refresh' class='sapUiSupportLink'>Refresh</a>\"),t.$().on(\"click\",\"#\"+t.getId()+\"-Refresh\",e.proxy(t._onRefreshChanges,t)),i.write(\"</div>\"),i.write(\"<div id='\"+t.getId()+\"-FlexCacheArea' class='sapUiSizeCompact'></div>\"),i.flush(t.$().get(0)),i.destroy()},s=function(){t.oView=sap.ui.view({viewName:\"sap.ui.fl.support.Flexibility\",type:sap.ui.core.mvc.ViewType.XML}),t.oView.placeAt(t.getId()+\"-FlexCacheArea\"),t.oView.setModel(t.oModel,\"flex\")};i(),s(),this._onRefreshChanges()},o.prototype._onRefreshChanges=function(){i.getStub().sendEvent(this.getId()+\"GetChanges\",{})},o.prototype.onsapUiSupportFlexibilityGetChanges=function(){var e=this;if(sap.ui.fl&&sap.ui.fl.Cache){var t,i,s=sap.ui.fl.Cache.getEntries(),o=[],r=[];t=Object.keys(s),t.sort(),t.forEach(function(e){i=Object.keys(s[e]),i.sort(function(e,t){var i=function(e){if(e===n.DEFAULT_APP_VERSION)return\"000000000\";var t=e.split(\".\"),i=\"\";return t.forEach(function(e){i+=(\"000\"+e).substring(e.length)}),i},s=i(e),o=i(t);return s<o?-1:s>o?1:0}),i.forEach(function(t){var i=s[e][t];t===n.DEFAULT_APP_VERSION&&(t=\"Version independent\");var a=i.file.changes.changes.slice(0),p=i.file.changes.contexts.slice(0);if(p.length>0){var u=sap.ui.fl.context.ContextManager.getActiveContexts(p).then(function(e){p.forEach(function(t){t.isActive=e.indexOf(t.id)!==-1}),a.forEach(function(t){t.isActive=!t.context||e.indexOf(t.context)!==-1})});o.push({reference:e+\" - \"+t,changes:a,contexts:p}),r.push(u)}else a.forEach(function(e){e.isActive=!e.context}),o.push({reference:e+\" - \"+t,changes:a,contexts:p})})}),Promise.all(r).then(function(){e._oStub.sendEvent(e.getId()+\"SetChanges\",o)})}else e._oStub.sendEvent(e.getId()+\"SetChanges\",{})},o.prototype.onsapUiSupportFlexibilitySetChanges=function(e){var t=e.getParameters();this.oModel.setData(t)},o.prototype.exit=function(e){t.prototype.exit.apply(this,arguments)},o});",
		"sap/ui/fl/transport/TransportDialog.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/List\",\"sap/m/InputListItem\",\"sap/m/Button\",\"sap/m/ComboBox\",\"sap/m/Dialog\",\"sap/m/DialogRenderer\",\"sap/m/Input\",\"sap/m/Label\",\"sap/m/MessageToast\",\"sap/ui/core/ListItem\",\"sap/ui/fl/transport/Transports\"],function(t,e,s,o,a,r,n,i,p,c,l,u){\"use strict\";var _=r.extend(\"sap.ui.fl.transport.TransportDialog\",{metadata:{library:\"sap.ui.fl\",properties:{pkg:{type:\"string\",group:\"Misc\",defaultValue:null},transports:{type:\"any\",group:\"Misc\",defaultValue:null},lrepObject:{type:\"any\",group:\"Misc\",defaultValue:null},hidePackage:{type:\"boolean\",group:\"Misc\",defaultValue:null}},events:{ok:{},cancel:{}}},renderer:n.render});return _.prototype.init=function(){r.prototype.init.apply(this),this._oResources=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.fl\"),this.setTitle(this._oResources.getText(\"TRANSPORT_DIALOG_TITLE\")),this._oPackageLabel=null,this._oPackage=this._createPackageField(),this._oTransport=this._createTransportCombo(),this.addContent(this._createContentList()),this._createButtons()},_.prototype._createContentList=function(){return this._oPackageListItem=new s({label:this._oResources.getText(\"TRANSPORT_DIALOG_PACKAGE\"),content:[this._oPackage]}),this._oTransportListItem=new s({label:this._oResources.getText(\"TRANSPORT_DIALOG_TRANSPORT\"),content:[this._oTransport]}),new e({items:[this._oPackageListItem,this._oTransportListItem]})},_.prototype._createButtons=function(){var t=this;this.addButton(new o({text:this._oResources.getText(\"TRANSPORT_DIALOG_LOCAL_OBJECT\"),tooltip:this._oResources.getText(\"TRANSPORT_DIALOG_LOCAL_OBJECT\"),press:function(){t._onLocal()}})),this.addButton(new o({text:this._oResources.getText(\"TRANSPORT_DIALOG_OK\"),tooltip:this._oResources.getText(\"TRANSPORT_DIALOG_OK\"),enabled:!1,press:function(){t._onOkay()}})),this.addButton(new o({text:this._oResources.getText(\"TRANSPORT_DIALOG_CANCEL\"),tooltip:this._oResources.getText(\"TRANSPORT_DIALOG_CANCEL\"),press:function(){t.fireCancel(),t.close(),t.destroy()}}))},_.prototype._onLocal=function(){this.fireOk({selectedTransport:\"\",selectedPackage:this.getPkg()||\"$TMP\",dialog:!0}),this.close(),this.destroy()},_.prototype._onOkay=function(){var t=this._oTransport.getSelectedKey();this._checkOkay(t)?(this.fireOk({selectedTransport:t,selectedPackage:this.getPkg()||this._oPackage.getValue(),dialog:!0}),this.close(),this.destroy()):(this.getButtons()[1].setEnabled(!1),this._oTransport.setValueState(sap.ui.core.ValueState.Error),this._oTransport.setValueStateText(this.getTitle()))},_.prototype._checkOkay=function(t){return!!t},_.prototype._createTransportCombo=function(){var t=this;return new a({showSecondaryValues:!0,enabled:!1,tooltip:this._oResources.getText(\"TRANSPORT_DIALOG_TRANSPORT_TT\"),width:\"100%\",selectionChange:function(){t._oPackageListItem.getVisible()&&!t._oPackage.getValue()||(t.getButtons()[1].setEnabled(!0),t._oTransport.setValueState(sap.ui.core.ValueState.None))},change:function(e){var s=function(t){return!((!t||e.mParameters.newValue===t.getText())&&t)};e&&e.mParameters&&e.mParameters.newValue&&s(t._oTransport.getSelectedItem())&&(t.getButtons()[1].setEnabled(!1),t._oTransport.setValueState(sap.ui.core.ValueState.Error),t._oTransport.setValueStateText(t._oResources.getText(\"TRANSPORT_DIALOG_TRANSPORT_TT\")))}})},_.prototype._createPackageField=function(){var t=this;return new i({tooltip:this._oResources.getText(\"TRANSPORT_DIALOG_PACKAGE_TT\"),width:\"100%\",change:function(){var e,s,o;o=t._createObjectInfo(),e=new sap.ui.fl.transport.Transports,s=e.getTransports(o),s.then(function(e){t._onPackageChangeSuccess(e)},function(e){t._onPackageChangeError(e)})},liveChange:function(e){e.mParameters.liveValue&&e.mParameters.liveValue.length>3&&t._oTransport.setEnabled(!0)}})},_.prototype._createObjectInfo=function(){var t,e={package:this._oPackage.getValue()||\"\"};return t=this.getProperty(\"lrepObject\"),t&&(t.name&&(e.name=t.name),t.type&&(e.type=t.type),t.namespace&&(e.namespace=t.namespace)),e},_.prototype._onPackageChangeSuccess=function(t){t&&(t.localonly?(this._oTransport.setEnabled(!1),this.getButtons()[1].setEnabled(!0)):t.transports&&t.transports.length>0?(this._oTransport.setEnabled(!0),this._setTransports(t)):t.errorCode?(this.getButtons()[1].setEnabled(!1),this._oPackage.setValueState(sap.ui.core.ValueState.Error),this._oPackage.setValueStateText(this._oResources.getText(\"TRANSPORT_DIALOG_\"+t.errorCode)),this._setTransports(t)):c.show(this._oResources.getText(\"TRANSPORT_DIALOG_NO_TRANSPORTS\")))},_.prototype._setTransports=function(t){var e,s;e=this._hasLock(t.transports),s=e?[e]:t.transports,this.setTransports(s),s&&1===s.length&&(this._oTransport.setValue(s[0].description,!0),this.getButtons()[1].setEnabled(!0)),s&&0!==s.length||(this._oTransport.setSelectedKey(null),this._oTransport.setValueState(sap.ui.core.ValueState.None),this.getButtons()[1].setEnabled(!1))},_.prototype._onPackageChangeError=function(t){c.show(t),this.setTransports([])},_.prototype._hasLock=function(t){for(var e,s=t.length;s--;)if(e=t[s],e.locked)return e;return null},_.prototype.setPkg=function(t){t&&!this.getProperty(\"pkg\")&&(this.setProperty(\"pkg\",t),this._oPackage.setValue(t),this._oPackage.setEnabled(!1),this._oTransport.setEnabled(!0),this.setTitle(this._oResources.getText(\"TRANSPORT_DIALOG_TITLE_SIMPLE\")),this.getButtons()[0].setVisible(!1))},_.prototype.setTransports=function(t){var e,s,o=0;if(t){for(this.setProperty(\"transports\",t),this._oTransport.removeAllItems(),o=t.length,e=0;e<o;e++)s=t[e],this._oTransport.addItem(new l({key:s.transportId,text:s.transportId,additionalText:s.description}));1===o&&(this._oTransport.setSelectedKey(t[0].transportId),this.getButtons()[1].setEnabled(!0)),o>0&&this._oTransport.setEnabled(!0)}},_.prototype.setLrepObject=function(t){t&&!this.getProperty(\"lrepObject\")&&this.setProperty(\"lrepObject\",t)},_.prototype.setHidePackage=function(t){this.setProperty(\"hidePackage\",t),this._oPackageListItem.setVisible(!t),t&&(this.getButtons()[0].setEnabled(t),this.setTitle(this._oResources.getText(\"TRANSPORT_DIALOG_TITLE_SIMPLE\")))},_},!0);",
		"sap/ui/fl/transport/Transports.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/Utils\"],function(e,r){\"use strict\";var n=function(){};return n.prototype.getTransports=function(n){var t,a,o,s;return t=\"/sap/bc/lrep/actions/gettransports/\",n.package&&(t+=\"&package=\"+n.package),n.name&&(t+=\"&name=\"+n.name),n.namespace&&(t+=\"&namespace=\"+n.namespace),n.type&&(t+=\"&type=\"+n.type),a=r.getClient(),a&&(t+=\"&sap-client=\"+a),t=t.replace(\"&\",\"?\"),o=e.createConnector(),s=o.send(t),s.then(function(e){return e.response?(e.response.localonly||(e.response.localonly=!1),e.response.errorCode||(e.response.errorCode=\"\"),Promise.resolve(e.response)):Promise.reject(\"response is empty\")})},n.prototype.makeChangesTransportable=function(n){var t,a,o;return t=\"/sap/bc/lrep/actions/make_changes_transportable/\",a=r.getClient(),a&&(t+=\"?sap-client=\"+a),n.transportId?n.changeIds?(o=e.createConnector(),o.send(t,\"POST\",n)):Promise.reject(new Error(\"no changeIds provided as attribute of mParameters\")):Promise.reject(new Error(\"no transportId provided as attribute of mParameters\"))},n.prototype._convertToChangeTransportData=function(e){for(var r=[],n=e.length,t=0;t<n;t++){var a=e[t],o={};o.namespace=a.getNamespace(),o.fileName=a.getId(),o.fileType=a.getDefinition().fileType,r.push(o)}return r},n},!0);",
		"sap/ui/fl/transport/TransportSelection.js": "/*\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/fl/Utils\",\"sap/ui/fl/transport/Transports\",\"sap/ui/fl/transport/TransportDialog\",\"sap/ui/fl/registry/Settings\"],function(t,e,r,a,n){\"use strict\";var o=function(){this.oTransports=new sap.ui.fl.transport.Transports};return o.prototype.selectTransport=function(t,r,a,o,s){var p=this;if(t){var i=e.getCurrentLayer(!1);i&&\"CUSTOMER\"===i?n.getInstance().then(function(e){if(e.isAtoEnabled()){var n={transportId:\"ATO_NOTIFICATION\"};r(p._createEventObject(t,n))}else p._selectTransport(t,r,a,o)}):p._selectTransport(t,r,a,o)}},o.prototype._selectTransport=function(t,r,a,n){var o=this;t&&this.oTransports.getTransports(t).then(function(s){var p;o._checkDialog(s)?o._openDialog({hidePackage:!e.doesSharedVariantRequirePackage(),pkg:t.package,transports:s.transports,lrepObject:o._toLREPObject(t)},r,a,n):(p=o._getTransport(s),r(o._createEventObject(t,p)))},function(t){a(t)})},o.prototype._createEventObject=function(t,e){return{mParameters:{selectedTransport:e.transportId,selectedPackage:t.package,dialog:!1},getParameters:function(){return this.mParameters},getParameter:function(t){return this.mParameters[t]}}},o.prototype._toLREPObject=function(t){var e={};return t.namespace&&(e.namespace=t.namespace),t.name&&(e.name=t.name),t.type&&(e.type=t.type),e},o.prototype._openDialog=function(t,e,r,n){var o=new a(t);return o.attachOk(e),o.attachCancel(r),n?o.addStyleClass(\"sapUiSizeCompact\"):o.removeStyleClass(\"sapUiSizeCompact\"),o.open(),o},o.prototype._getTransport=function(t){var e;return e=t.localonly?{transportId:\"\"}:this._hasLock(t.transports)},o.prototype._checkDialog=function(t){return!t||!t.localonly&&!this._hasLock(t.transports)},o.prototype._hasLock=function(t){for(var e=t.length;e--;){var r=t[e];if(r.locked)return r}return!1},o.prototype.setTransports=function(t,e){var r=t.length-1,a=this,n=function(t,e,r,o,s){if(e>=0){var p=t[e];return s===!0?(\"$TMP\"!==p.getDefinition().packageName&&p.setRequest(o),e--,n(t,e,r,o,s)):\"$TMP\"!==p.getDefinition().packageName?a.openTransportSelection(p,r).then(function(a){return p.setRequest(a.transport),a.fromDialog===!0&&(o=a.transport,s=!0),e--,n(t,e,r,o,s)},function(){return null}):(e--,n(t,e,r,o,s))}return Promise.resolve()};return n(t,r,e)},o.prototype.openTransportSelection=function(t,e){var r=this;return new Promise(function(a,n){var o=function(t){if(t&&t.getParameters){var e=t.getParameters().selectedTransport,r=t.getParameters().selectedPackage,n=t.getParameters().dialog,o={transport:e,packageName:r,fromDialog:n};a(o)}else a({})},s=function(t){\"cancel\"===t.sId?a():n(t)},p={};t&&(p.package=t.getPackage(),p.namespace=t.getNamespace(),p.name=t.getId(),p.type=t.getDefinition().fileType),r.selectTransport(p,o,s,!1,e)})},o},!0);",
		"sap/ui/fl/Utils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Component\"],function(t,e){\"use strict\";var n=[\"VENDOR\",\"PARTNER\",\"CUSTOMER_BASE\",\"CUSTOMER\",\"USER\"],r={};n.forEach(function(t,e){r[t]=e});var o={_aLayers:n,_mLayersIndex:r,_sTopLayer:n[n.length-1],_sMaxLayer:n[n.length-1],DEFAULT_APP_VERSION:\"DEFAULT_APP_VERSION\",log:{error:function(e,n,r){t.sap.log.error(e,n,r)},warning:function(e,n,r){t.sap.log.warning(e,n,r)},debug:function(e,n,r){t.sap.log.debug(e,n,r)}},getXSRFTokenFromControl:function(t){var e;return t&&t&&\"function\"==typeof t.getModel?(e=t.getModel(),o._getXSRFTokenFromModel(e)):\"\"},_getXSRFTokenFromModel:function(t){var e;return t&&\"function\"==typeof t.getHeaders&&(e=t.getHeaders())?e[\"x-csrf-token\"]:\"\"},getComponentClassName:function(t){var e;if(t&&(e=this.getAppComponentForControl(t))){var n=this._getComponentStartUpParameter(e,\"sap-app-id\");if(n)return n;if(e.getManifestEntry(\"sap.ui5\")&&e.getManifestEntry(\"sap.ui5\").appVariantId)return e.getManifestEntry(\"sap.ui5\").appVariantId}return o.getComponentName(e)},isVariantByStartupParameter:function(t){if(t){var e=this.getAppComponentForControl(t);if(e)return!!this._getComponentStartUpParameter(e,\"sap-app-id\")}return!1},getAppComponentClassNameForComponent:function(t){return o.getComponentClassName(t)},getAppDescriptor:function(t){var e=null,n=null,r=null;return t&&(n=this.getAppComponentForControl(t),n&&n.getMetadata&&(r=n.getMetadata(),r&&r.getManifest&&(e=r.getManifest()))),e},getSiteId:function(t){var e=null,n=null;return t&&(n=this.getAppComponentForControl(t),n&&(e=this._getComponentStartUpParameter(n,\"hcpApplicationId\"))),e},getSiteIdByComponentData:function(t){var e=null;return e=this._getStartUpParameter(t,\"hcpApplicationId\")},isAppVariantMode:function(t){return o.isVendorLayer()&&o.isApplicationVariant(t)},isBinding:function(t){var e=!1;return t&&\"string\"==typeof t&&\"{\"===t.substring(0,1)&&\"}\"===t.slice(-1)&&(e=!0),e},isVendorLayer:function(){return\"VENDOR\"===o.getCurrentLayer(!1)},isApplicationVariant:function(t){var e=o.getComponentClassName(t),n=o.getAppComponentForControl(t),r=o.getComponentName(n);return e!==r},setMaxLayerParameter:function(t){this._sMaxLayer=t||this._sTopLayer},getLayerIndex:function(t){return this._mLayersIndex[t]},isOverMaxLayer:function(t){return this.getLayerIndex(t)>this.getLayerIndex(this._sMaxLayer)},isLayerFilteringRequired:function(){return!(this._sTopLayer===this._sMaxLayer)},_getComponentStartUpParameter:function(t,e){var n=null;return e&&t&&t.getComponentData&&(n=this._getStartUpParameter(t.getComponentData(),e)),n},_getStartUpParameter:function(e,n){if(e&&e.startupParameters&&n&&t.isArray(e.startupParameters[n]))return e.startupParameters[n][0]},getComponentName:function(t){var e=\"\";return t&&(e=t.getMetadata().getName()),e.length>0&&e.indexOf(\".Component\")<0&&(e+=\".Component\"),e},_getComponent:function(t){var e;return t&&(e=sap.ui.getCore().getComponent(t)),e},_getComponentIdForControl:function(t){var e=\"\",n=0;do{if(n++,e=o._getOwnerIdForControl(t))return e;if(!t||\"function\"!=typeof t.getParent)return\"\";t=t.getParent()}while(t&&n<100);return\"\"},getComponentForControl:function(t){return o._getComponentForControl(t)},getAppComponentForControl:function(t){var e;return e=t instanceof sap.ui.core.Component?t:this._getComponentForControl(t),this._getAppComponentForComponent(e)},_getComponentForControl:function(t){var e=null,n=null;return t&&(n=o._getComponentIdForControl(t),n&&(e=o._getComponent(n))),e},_getAppComponentForComponent:function(t){var e=null;return t&&t.getAppComponent?t.getAppComponent():t&&t.oComponentData&&t.oComponentData.appComponent?t.oComponentData.appComponent:t&&t.getManifestEntry?(e=t.getManifestEntry(\"sap.app\"),e&&e.type&&\"application\"!==e.type?(t instanceof sap.ui.core.Component&&(t=this._getComponentForControl(t)),this.getAppComponentForControl(t)):t):t},getViewForControl:function(t){return o.getFirstAncestorOfControlWithControlType(t,sap.ui.core.mvc.View)},getFirstAncestorOfControlWithControlType:function(t,e){return t instanceof e?t:t&&\"function\"==typeof t.getParent?(t=t.getParent(),o.getFirstAncestorOfControlWithControlType(t,e)):void 0},hasControlAncestorWithId:function(t,e){var n;if(t===e)return!0;for(n=sap.ui.getCore().byId(t);n;){if(n.getId()===e)return!0;if(\"function\"!=typeof n.getParent)return!1;n=n.getParent()}return!1},_isView:function(t){return t instanceof sap.ui.core.mvc.View},_getOwnerIdForControl:function(t){return e.getOwnerIdFor(t)},getCurrentLayer:function(t){var e,n;return t?\"USER\":(e=this._getUriParameters(),n=e.mParams[\"sap-ui-layer\"],n&&n.length>0?n[0]:\"CUSTOMER\")},doesSharedVariantRequirePackage:function(){var t;return t=o.getCurrentLayer(!1),\"VENDOR\"===t||\"PARTNER\"===t||\"CUSTOMER_BASE\"===t},getClient:function(){var t,e;if(t=this._getUriParameters(),e=t.mParams[\"sap-client\"],e&&e.length>0)return e[0]},_getUriParameters:function(){return t.sap.getUriParameters()},isHotfixMode:function(){var t,e,n;return t=this._getUriParameters(),e=t.mParams.hotfix,e&&e.length>0&&(n=e[0]),\"true\"===n},convertBrowserLanguageToISO639_1:function(t){if(!t||\"string\"!=typeof t)return\"\";var e=t.indexOf(\"-\");return e<0&&t.length<=2?t.toUpperCase():e>0&&e<=2?t.substring(0,e).toUpperCase():\"\"},getCurrentLanguage:function(){var t=sap.ui.getCore().getConfiguration().getLanguage();return o.convertBrowserLanguageToISO639_1(t)},getControlType:function(t){var e;if(t&&\"function\"==typeof t.getMetadata&&(e=t.getMetadata(),e&&\"function\"==typeof e.getElementName))return e.getElementName()},asciiToString:function(e){var n=e.split(\",\"),r=\"\";return t.each(n,function(t,e){r+=String.fromCharCode(e)}),r},stringToAscii:function(t){for(var e=\"\",n=0;n<t.length;n++)e+=t.charCodeAt(n)+\",\";return e=e.substring(0,e.length-1)},_fnCheckElementIsNoClone:function(t){var e=!0;if(t.getBindingContext&&t.getBindingContext()){var n=t.getBindingContext().getPath().split(\"/\"),r=n[n.length-1];e=isNaN(r)}return e},checkControlId:function(t,e,n){var r=t instanceof sap.ui.base.ManagedObject?t.getId():t;e||(t=t instanceof sap.ui.base.ManagedObject?t:sap.ui.getCore().byId(r),e=o.getAppComponentForControl(t));var a=sap.ui.base.ManagedObjectMetadata.isGeneratedId(r);if(!a||this.hasLocalIdSuffix(t,e))return!0;var i=r.indexOf(\"--\")!==-1;return n||i||!this._fnCheckElementIsNoClone(t)||this.log.warning(\"Generated id attribute found, to offer flexibility a stable control id is needed to assign the changes to, but for this control the id was generated by SAPUI5\",r),!1},hasLocalIdSuffix:function(t,e){var n=t instanceof sap.ui.base.ManagedObject?t.getId():t;return e?!!e.getLocalId(n):(this.log.error(\"determination of a local id suffix failed due to missing app component for \"+n),!1)},_getAllUrlParameters:function(){return window.location.search.substring(1)},getUrlParameter:function(e){return t.sap.getUriParameters().get(e)},createDefaultFileName:function(e){var n=t.sap.uid().replace(/-/g,\"_\");return e&&(n+=\"_\"+e),n},createNamespace:function(t,e){var n=t.reference.replace(\".Component\",\"\"),r=\"apps/\"+n+\"/\"+e+\"/\";return r},isApplication:function(t){return t&&t.getEntry(\"sap.app\")&&\"application\"===t.getEntry(\"sap.app\").type},getFlexReference:function(t){if(t){if(t.getEntry(\"sap.ui5\")){if(t.getEntry(\"sap.ui5\").appVariantId)return t.getEntry(\"sap.ui5\").appVariantId;if(t.getEntry(\"sap.ui5\").componentName)return t.getEntry(\"sap.ui5\").componentName+\".Component\"}if(t.getEntry(\"sap.app\")&&t.getEntry(\"sap.app\").id)return t.getEntry(\"sap.app\").id+\".Component\"}return this.log.warning(\"No Manifest received.\"),\"\"},getAppVersionFromManifest:function(t){var e=\"\";if(t){var n=t.getEntry?t.getEntry(\"sap.app\"):t[\"sap.app\"];n&&n.applicationVersion&&n.applicationVersion.version&&(e=n.applicationVersion.version)}else this.log.warning(\"No Manifest received.\");return e},isCustomerDependentLayer:function(t){return[\"CUSTOMER\",\"CUSTOMER_BASE\"].indexOf(t)>-1}};return o},!0);",
		"sap/ui/fl/XmlPreprocessorImpl.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Component\",\"sap/ui/fl/FlexControllerFactory\",\"sap/ui/fl/Utils\",\"sap/ui/fl/LrepConnector\",\"sap/ui/fl/ChangePersistenceFactory\",\"sap/ui/fl/ChangePersistence\"],function(e,n,o,r,t,i,s){\"use strict\";var a=function(){};return a.process=function(n,t){try{if(!t||t.sync)return r.log.warning(\"Flexibility feature for applying changes on an XML view is only available for asynchronous views; merge is be done later on the JS controls.\"),n;t.viewId=t.id;var a=sap.ui.getCore().getComponent(t.componentId);if(!a)return r.log.warning(\"View is generated without a component. Flexibility features are not possible.\"),Promise.resolve(n);var l=r.getAppComponentForControl(a),p=r.getComponentClassName(l),g=r.getAppVersionFromManifest(l.getManifest()),c=i.getChangePersistenceForComponent(p,g);return c.getCacheKey().then(function(e){if(!e||e===s.NOTAG)return r.log.warning(\"No cache key could be determined for the view; flexibility XML view preprocessing is skipped. The processing will be done later on the JS controls.\"),Promise.resolve(n);var i=o.create(p,g);return i.processXmlView(n,t).then(function(){return r.log.debug(\"flex processing view \"+t.id+\" finished\"),n})},function(){return r.log.warning(\"Error happens when getting flex cache key! flexibility XML view preprocessing is skipped. The processing will be done later on the JS controls.\"),Promise.resolve(n)})}catch(o){var u=\"view \"+t.id+\": \"+o;return e.sap.log.info(u),Promise.resolve(n)}},a.getCacheKey=function(e){var n=sap.ui.getCore().getComponent(e.componentId),o=r.getAppComponentForControl(n);if(r.isVariantByStartupParameter(o))return Promise.resolve();var t=r.getComponentClassName(o),s=r.getAppVersionFromManifest(o.getManifest()),a=i.getChangePersistenceForComponent(t,s);return a.getCacheKey()},a},!0);",
		"sap/ui/fl/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.ui.fl\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"8.0.0-0\"},\"title\":\"The OpenUI5-based library, sap.ui.fl.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{},\"sap.m\":{}}},\"library\":{\"i18n\":\"messagebundle.properties\"}}}",
		"sap/ui/fl/support/apps/contentbrowser/manifest.json": "{\"_version\":\"1.1.0\",\"sap.app\":{\"_version\":\"1.1.0\",\"id\":\"sap.ui.fl.support.apps.contentbrowser.app\",\"type\":\"application\",\"i18n\":\"i18n/i18n.properties\",\"title\":\"{{appTitle}}\",\"description\":\"{{appDescription}}\",\"applicationVersion\":{\"version\":\"1.0.0\"},\"ach\":\"CA-UI5-FL\",\"resources\":\"resources.json\"},\"sap.ui\":{\"_version\":\"1.1.0\",\"technology\":\"UI5\",\"deviceTypes\":{\"desktop\":true,\"tablet\":true,\"phone\":true},\"supportedThemes\":[\"sap_bluecrystal\"]},\"sap.ui5\":{\"_version\":\"1.1.0\",\"rootView\":\"sap.ui.fl.support.apps.contentbrowser.view.MainView\",\"dependencies\":{\"minUI5Version\":\"1.45\",\"libs\":{\"sap.m\":{}}},\"models\":{\"i18n\":{\"type\":\"sap.ui.model.resource.ResourceModel\",\"settings\":{\"bundleName\":\"sap.ui.fl.support.apps.contentbrowser.i18n.i18n\"}},\"@i18n\":{\"type\":\"sap.ui.model.resource.ResourceModel\",\"settings\":{\"bundleName\":\"sap.ui.fl.support.apps.contentbrowser.i18n.i18n\"}}},\"routing\":{\"config\":{\"routerClass\":\"sap.m.routing.Router\",\"viewType\":\"XML\",\"viewPath\":\"sap.ui.fl.support.apps.contentbrowser.view\",\"controlId\":\"sap.ui.fl.support.apps.contentbrowser.App\",\"controlAggregation\":\"masterPages\"},\"routes\":[{\"pattern\":\"\",\"name\":\"Layers\",\"target\":\"Layers\"},{\"pattern\":\"{layer}/:namespace:\",\"name\":\"LayerContentMaster\",\"target\":[\"LayerContentMaster\",\"EmptyDetails\"],\"subroutes\":[{\"pattern\":\"{layer}/{namespace}/{fileName}.{fileType}\",\"name\":\"ContentDetailsFlip\",\"target\":\"ContentDetailsFlip\"},{\"pattern\":\"{layer}/{namespace}/{fileName}.{fileType}\",\"name\":\"ContentDetails\",\"target\":\"ContentDetails\"},{\"pattern\":\"edit/{layer}/{namespace}/{fileName}.{fileType}\",\"name\":\"ContentDetailsEdit\",\"target\":\"ContentDetailsEdit\"}]}],\"targets\":{\"overview\":{\"viewName\":\"Overview\"},\"Layers\":{\"viewName\":\"Layers\",\"viewLevel\":1},\"LayerContentMaster\":{\"viewName\":\"LayerContentMaster\",\"viewLevel\":2},\"EmptyDetails\":{\"viewName\":\"EmptyDetails\",\"controlAggregation\":\"detailPages\"},\"ContentDetails\":{\"viewName\":\"ContentDetails\",\"controlAggregation\":\"detailPages\"},\"ContentDetailsFlip\":{\"viewName\":\"ContentDetails\",\"transition\":\"flip\",\"controlAggregation\":\"detailPages\"},\"ContentDetailsEdit\":{\"viewName\":\"ContentDetailsEdit\",\"transition\":\"flip\",\"controlAggregation\":\"detailPages\"}}},\"contentDensities\":{\"compact\":false,\"cozy\":false}}}",
		"sap/ui/fl/support/apps/contentbrowser/view/ContentDetails.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\txmlns:mvc=\"sap.ui.core.mvc\"\n\txmlns=\"sap.m\" controllerName=\"sap.ui.fl.support.apps.contentbrowser.controller.ContentDetails\"\n\txmlns:f=\"sap.ui.layout.form\"\n\txmlns:html=\"http://www.w3.org/1999/xhtml\"><Page\n\t\ttitle=\"{path: 'selectedContent>/', formatter: '.oDataUtils.formatItemTitle'}\"><IconTabBar id=\"contentDetailsIconTabBar\"><items><IconTabFilter\n\t\t\t\t\ticon=\"sap-icon://attachment\"\n\t\t\t\t\ttext=\"{i18n>content}\"><f:SimpleForm\n\t\t\t\t\t\tminWidth=\"1024\"\n\t\t\t\t\t\tmaxContainerCols=\"1\"\n\t\t\t\t\t\teditable=\"false\"\n\t\t\t\t\t\tlayout=\"ResponsiveGridLayout\"\n\t\t\t\t\t\tlabelSpanL=\"12\"\n\t\t\t\t\t\tlabelSpanM=\"12\"\n\t\t\t\t\t\tcolumnsL=\"1\"\n\t\t\t\t\t\tcolumnsM=\"1\"><Text class=\"codeBlock\" text=\"{selectedContent>/data}\" /></f:SimpleForm></IconTabFilter><IconTabFilter\n\t\t\t\t\ticon=\"sap-icon://hint\"\n\t\t\t\t\tcount=\"{selectedContent>/metadata/length}\"\n\t\t\t\t\ttext=\"{i18n>metadata}\"><List\n\t\t\t\t\t\titems=\"{\n\t\t\t\t\t\t\tpath: 'selectedContent>/metadata',\n\t\t\t\t\t\t\tsorter: {\n\t\t\t\t\t\t\t\tpath: 'selectedContent>category',\n\t\t\t\t\t\t\t\tdescending: true,\n\t\t\t\t\t\t\t\tgroup: true\n\t\t\t\t\t\t\t},\n\t\t\t\t\t\t\tgroupHeaderFactory: '.oDataUtils.getGroupHeader'}\" ><items><DisplayListItem\n\t\t\t\t\t\t\t\tlabel=\"{selectedContent>name}\"\n\t\t\t\t\t\t\t\tvalue=\"{selectedContent>value}\" /></items></List></IconTabFilter></items></IconTabBar><footer><Toolbar><ToolbarSpacer /><Button text=\"{i18n>edit}\" press=\".onEditClicked\" /><Button text=\"{i18n>delete}\" press=\".onDeleteClicked\" /></Toolbar></footer></Page></core:View>\n",
		"sap/ui/fl/support/apps/contentbrowser/view/ContentDetailsEdit.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n           xmlns:mvc=\"sap.ui.core.mvc\"\n           xmlns=\"sap.m\" controllerName=\"sap.ui.fl.support.apps.contentbrowser.controller.ContentDetailsEdit\"\n           xmlns:f=\"sap.ui.layout.form\"\n           xmlns:html=\"http://www.w3.org/1999/xhtml\"><Page title=\"{path: 'selectedContent>/', formatter: '.oDataUtils.formatItemTitle'}\"><f:SimpleForm\n\t\t\t\tminWidth=\"1024\"\n\t\t\t\tmaxContainerCols=\"1\"\n\t\t\t\teditable=\"false\"\n\t\t\t\tlayout=\"ResponsiveGridLayout\"\n\t\t\t\tlabelSpanL=\"12\"\n\t\t\t\tlabelSpanM=\"12\"\n\t\t\t\tcolumnsL=\"1\"\n\t\t\t\tcolumnsM=\"1\"><TextArea id=\"dataTextArea\" class=\"codeBlock\" rows=\"50\" value=\"{selectedContent>/data}\" /></f:SimpleForm><footer><Toolbar><ToolbarSpacer /><Button text=\"{i18n>save}\" press=\".onSave\" /><Button text=\"{i18n>cancel}\" press=\".onCancel\" /></Toolbar></footer></Page></core:View>",
		"sap/ui/fl/support/apps/contentbrowser/view/EmptyDetails.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\txmlns:mvc=\"sap.ui.core.mvc\"\n\txmlns=\"sap.m\"\n\txmlns:html=\"http://www.w3.org/1999/xhtml\"><Page></Page></core:View>",
		"sap/ui/fl/support/apps/contentbrowser/view/LayerContentMaster.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\txmlns:mvc=\"sap.ui.core.mvc\"\n\txmlns=\"sap.m\" controllerName=\"sap.ui.fl.support.apps.contentbrowser.controller.LayerContentMaster\"\n\txmlns:html=\"http://www.w3.org/1999/xhtml\"><Page\n\t\t\tshowNavButton=\"true\"\n\t\t\tnavButtonPress=\".navBack\"><subHeader><Toolbar><SearchField\n                    id=\"search\"\n\t\t\t\t\tliveChange=\"onSearch\"\n\t\t\t\t\twidth=\"100%\" /></Toolbar></subHeader><content><List\n\t\t\t\tid=\"masterComponentsList\"\n\t\t\t\tgrowing=\"true\"\n\t\t\t\tgrowingThreshold=\"100\"\n\t\t\t\tgrowingScrollToLoad=\"true\"\n\t\t\t\titems=\"{content>/}\"><items><StandardListItem\n\t\t\t\t\t\ttitle=\"{content>name}\"\n\t\t\t\t\t\tdescription=\"{path: 'content>fileType'}\"\n\t\t\t\t\t\ttype=\"Active\"\n\t\t\t\t\t\tpress=\"onContentSelected\"\n\t\t\t\t\t\tvisible=\"{path: 'content>', formatter: '.oDataUtils.isNotOnBlacklist'}\"\n\t\t\t\t\t\ticon=\"{= ${content>fileType} ? 'sap-icon://document' : 'sap-icon://folder-full'}\"></StandardListItem></items></List></content><footer><Toolbar><Button\n\t\t\t\t\ticon=\"sap-icon://alert\"\n\t\t\t\t\ttext=\"{messages>/length}\"\n\t\t\t\t\ttype=\"Emphasized\"\n\t\t\t\t\tpress=\".handleMessagePopoverPress\"\n\t\t\t\t\tvisible=\"{= ${messages>/length} > 0 }\"/></Toolbar></footer></Page></core:View>\n",
		"sap/ui/fl/support/apps/contentbrowser/view/Layers.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\txmlns:mvc=\"sap.ui.core.mvc\"\n\txmlns=\"sap.m\" controllerName=\"sap.ui.fl.support.apps.contentbrowser.controller.Layers\"\n\txmlns:html=\"http://www.w3.org/1999/xhtml\"><Page title=\"Layers\"><List id=\"masterComponentsList\" items=\"{layers>/}\"><items><StandardListItem\n\t\t\t\t\ttitle=\"{layers>name}\"\n\t\t\t\t\ttype=\"Navigation\"\n\t\t\t\t\tpress=\"onLayerSelected\"\n\t\t\t\t\ticon=\"{layers>icon}\"></StandardListItem></items></List><footer><Toolbar visible=\"{= ${messages>/length} > 0 }\"><Button\n\t\t\t\t\ticon=\"sap-icon://alert\"\n\t\t\t\t\ttext=\"{messages>/length}\"\n\t\t\t\t\ttype=\"Emphasized\"\n\t\t\t\t\tpress=\".handleMessagePopoverPress\"/></Toolbar></footer></Page></core:View>\n",
		"sap/ui/fl/support/apps/contentbrowser/view/MainView.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\txmlns:mvc=\"sap.ui.core.mvc\"\n\txmlns=\"sap.m\"\n\txmlns:html=\"http://www.w3.org/1999/xhtml\"><SplitApp id=\"sap.ui.fl.support.apps.contentbrowser.App\"/></core:View>\n",
		"sap/ui/fl/support/Flexibility.view.xml": "<mvc:View xmlns=\"sap.m\" xmlns:core=\"sap.ui.core\" xmlns:mvc=\"sap.ui.core.mvc\"><List items=\"{flex>/}\"><items><CustomListItem><Panel expandable=\"true\" expanded=\"false\" headerText=\"{flex>reference}\" ><Table items=\"{path: 'flex>changes', templateShareable: false}\" visible=\"{= ${flex>changes/length} > 0}\"><headerToolbar><Toolbar><Title text=\"Changes\" level=\"H2\"/></Toolbar></headerToolbar><columns><Column><Text text=\"Layer\" /></Column><Column><Text text=\"Type\" /></Column><Column><Text text=\"Target\" /></Column><Column><Text text=\"Creator\" /></Column><Column><Text text=\"Created At\" /></Column><Column hAlign=\"Center\"><Text text=\"Active\" /></Column></columns><items><ColumnListItem><cells><Text text=\"{flex>layer}\" /><Text text=\"{flex>changeType}\" /><Text text=\"{flex>selector/id}\" /><Text text=\"{flex>support/user}\" /><Text text=\"{\n\t\t\t\t\t\t\t\t\t\tpath: 'flex>creation',\n\t\t\t\t\t\t\t\t\t\ttype: 'sap.ui.model.type.Date',\n\t\t\t\t\t\t\t\t\t\tformatOptions: {\n\t\t\t\t\t\t\t\t\t\t\tstyle: 'medium',\n\t\t\t\t\t\t\t\t\t\t\tsource: {\n\t\t\t\t\t\t\t\t\t\t\t\tpattern: 'yyyy-MM-ddThh:mm:ss.SSSSSSSZ'\n\t\t\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t\t}\" /><core:Icon src=\"{= ${flex>isActive} ? 'sap-icon://sys-enter' : 'sap-icon://sys-cancel'}\" /></cells></ColumnListItem></items></Table><Table items=\"{path: 'flex>contexts', templateShareable: false}\" visible=\"{= ${flex>contexts/length} > 0}\"><headerToolbar><Toolbar><Title text=\"Contexts\" level=\"H2\"/></Toolbar></headerToolbar><columns><Column><Text text=\"Layer\" /></Column><Column><Text text=\"Title\" /></Column><Column><Text text=\"Active\" /></Column></columns><items><ColumnListItem><cells><Text text=\"{flex>layer}\" /><Text text=\"{flex>title}\" /><core:Icon src=\"{= ${flex>isActive} ? 'sap-icon://sys-enter' : 'sap-icon://sys-cancel'}\" /></cells></ColumnListItem></items></Table></Panel></CustomListItem></items></List></mvc:View>\n"
	},
	"dependencies": ["sap.ui.core.library-preload","sap.m.library-preload"],
	"sas-uglified": true
});