jQuery.sap.registerPreloadedModules({
	"version": "2.0",
	"name": "sap.ui.unified.library-preload",
	"modules": {
		"sap/ui/unified/Calendar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"./calendar/Header\",\"./calendar/Month\",\"./calendar/MonthPicker\",\"./calendar/YearPicker\",\"./calendar/CalendarDate\",\"./library\"],function(e,t,a,i,o,s,n,r,h,g,l){\"use strict\";function c(e,t,a){var i,s,n,r=this._getFocusedDate(),h=this.getAggregation(\"month\"),l=!1,c=0;for(c=0;c<h.length;c++)if(i=h[c],i.checkDateFocusable(r.toLocalJSDate())&&(l=!0),l||1==h.length){e?i.displayDate(r.toLocalJSDate()):i.setDate(r.toLocalJSDate());break}if(!l){if(n=new g(r,this.getPrimaryCalendarType()),h.length>1)for(n=k.call(this,n),c=0;c<h.length;c++)i=h[c],s=new g(n,this.getPrimaryCalendarType()),s.setMonth(n.getMonth()+c),!e&&o._isSameMonthAndYear(s,r)?i.setDate(r.toLocalJSDate()):i.displayDate(s.toLocalJSDate());this._updateHeader(n),a||this.fireStartDateChange()}}function d(){var e=this.getSelectedDates(),t=this.getPrimaryCalendarType();e&&e[0]&&e[0].getStartDate()?this._oFocusedDate=g.fromLocalJSDate(e[0].getStartDate(),t):this._oFocusedDate=g.fromLocalJSDate(new Date,t),this._oFocusedDate.isBefore(this._oMinDate)?this._oFocusedDate=new g(this._oMinDate,t):this._oFocusedDate.isAfter(this._oMaxDate)&&(this._oFocusedDate=new g(this._oMaxDate,t))}function p(t){2==this._iMode&&_.call(this,!0);var a=this._getFocusedDate(),i=this.getAggregation(\"monthPicker\");if(this.getPickerPopup&&this.getPickerPopup())this._openPickerPopup(i);else if(i.getDomRef())i.$().css(\"display\",\"\");else{var o=sap.ui.getCore().createRenderManager(),s=this.$(\"content\");o.renderControl(i),o.flush(s[0],!1,!0),o.destroy()}if(this.$(\"contentOver\").css(\"display\",\"\"),!t&&(i.setMonth(a.getMonth()),this._setDisabledMonths(a.getYear(),i),0==this._iMode))for(var n=this.getAggregation(\"month\"),r=0;r<n.length;r++){var h=n[r];e(h._oItemNavigation.getItemDomRefs()[h._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}this._iMode=1,this._togglePrevNext(a,!1)}function u(t){if(this._iMode=0,this.getPickerPopup&&this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"monthPicker\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!t&&(c.call(this),v.call(this)>1))for(var i=this.getAggregation(\"month\"),o=0;o<i.length;o++){var s=i[o];e(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}this._togglePrevNext(this._getFocusedDate(),!0)}function D(){1==this._iMode&&u.call(this,!0);var t=this._getFocusedDate(),a=this.getAggregation(\"yearPicker\");if(this.getPickerPopup&&this.getPickerPopup())this._openPickerPopup(a);else if(a.getDomRef())a.$().css(\"display\",\"\");else{var i=sap.ui.getCore().createRenderManager(),o=this.$(\"content\");i.renderControl(a),i.flush(o[0],!1,!0),i.destroy()}this.$(\"contentOver\").css(\"display\",\"\"),a.setDate(t.toLocalJSDate());var s;if(1==v.call(this)){s=this.getAggregation(\"month\")[0];var n=s.$(\"days\").find(\".sapUiCalItem\");28==n.length?a.$().addClass(\"sapUiCalYearNoTop\"):a.$().removeClass(\"sapUiCalYearNoTop\")}if(0==this._iMode)for(var r=this.getAggregation(\"month\"),h=0;h<r.length;h++)s=r[h],e(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\");this._togglePrevNexYearPicker(),this._iMode=2}function _(t){if(this._iMode=0,this.getPickerPopup&&this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"yearPicker\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!t&&(c.call(this),v.call(this)>1))for(var i=this.getAggregation(\"month\"),o=0;o<i.length;o++){var s=i[o];e(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}this._togglePrevNext(this._getFocusedDate(),!0)}function m(){if(this._bNamesLengthChecked)v.call(this)>1&&this._focusDate(this._getFocusedDate(),!0,!0);else{p.call(this,!0),u.call(this,!0);var e=this.getAggregation(\"monthPicker\");if(this._bLongMonth=e._bLongMonth,this._bNamesLengthChecked=!0,!this._bLongMonth){var t,a=this.getAggregation(\"month\");t=a.length>1?g.fromLocalJSDate(a[0].getDate(),this.getPrimaryCalendarType()):this._getFocusedDate(),f.call(this,t)}}}function f(e){var t,a,i,o=this.getAggregation(\"header\"),s=this._getLocaleData(),n=[],r=[],h=[],l=!1,c=this.getPrimaryCalendarType(),d=this._getSecondaryCalendarType();if(this._bLongMonth||!this._bNamesLengthChecked?n=s.getMonthsStandAlone(\"wide\",c):(l=!0,n=s.getMonthsStandAlone(\"abbreviated\",c),r=s.getMonthsStandAlone(\"wide\",c)),d){h=s.getMonthsStandAlone(\"abbreviated\",d);var p=this._getDisplayedSecondaryMonths(c,d);p.start==p.end?a=h[p.start]:(i=s.getIntervalPattern(),a=i.replace(/\\{0\\}/,h[p.start]).replace(/\\{1\\}/,h[p.end]))}o.setAdditionalTextButton1(a);var u=this._getDisplayedMonths(e);u.length>1&&!this._bShowOneMonth?(i||(i=s.getIntervalPattern()),a=i.replace(/\\{0\\}/,n[u[0]]).replace(/\\{1\\}/,n[u[u.length-1]]),l&&(t=i.replace(/\\{0\\}/,r[u[0]]).replace(/\\{1\\}/,r[u[u.length-1]]))):(a=n[u[0]],l&&(t=r[u[0]])),o.setTextButton1(a),l&&o.setAriaLabelButton1(t);var D=new g(e,c);D.setDate(1),o.setTextButton2(this._oYearFormat.format(D.toUTCJSDate(),!0)),d?(D=new g(D,d),o.setAdditionalTextButton2(this._oYearFormatSecondary.format(D.toUTCJSDate(),!0))):o.setAdditionalTextButton2()}function y(e,t){if(e){var a=g.fromLocalJSDate(e,this.getPrimaryCalendarType());if(!this._oFocusedDate||!this._oFocusedDate.isSame(a)){var i=a.getYear();if(o._checkYearInValidRange(i),o._isOutside(a,this._oMinDate,this._oMaxDate))throw new Error(\"Date must not be in valid range (minDate and maxDate); \"+this);this._setFocusedDate(a),this.getDomRef()&&0==this._iMode&&c.call(this,t,!1,!0)}}}function v(){return sap.ui.Device.system.phone?1:this.getMonths()}function M(e){1!=this._iMode?p.call(this):u.call(this)}function P(e){2!=this._iMode?D.call(this):_.call(this)}function C(e){this.fireEvent(\"_renderMonth\",{days:e.getParameter(\"days\")})}function b(e){if(v.call(this)>1)for(var t=this.getAggregation(\"month\"),a=0;a<t.length;a++){var i=t[a];i.getId()!=e.oSource.getId()&&i._updateSelection()}this._oSelectedMonth=e.oSource,this.fireSelect()}function S(e){if(v.call(this)>1)for(var t=this.getAggregation(\"month\"),a=0;a<t.length;a++){var i=t[a];i.getId()!=e.oSource.getId()&&i._bindMousemove()}}function x(e){if(v.call(this)>1)for(var t=this.getAggregation(\"month\"),a=0;a<t.length;a++){var i=t[a];i.getId()!=e.oSource.getId()&&i._unbindMousemove()}}function I(e){var t=new g(this._getFocusedDate(),this.getPrimaryCalendarType()),a=this.getAggregation(\"monthPicker\"),i=a.getMonth();this._adjustFocusedDateUponMonthChange?this._adjustFocusedDateUponMonthChange(t,i):(t.setMonth(i),i!=t.getMonth()&&t.setDate(0)),this._focusDate(t,!0),u.call(this)}function A(e){var t,a=new g(this._getFocusedDate(),this.getPrimaryCalendarType()),i=this.getAggregation(\"yearPicker\"),o=g.fromLocalJSDate(i.getDate(),this.getPrimaryCalendarType()),s=i.getYear();this._adjustFocusedDateUponYearChange?(t=this._adjustFocusedDateUponYearChange(a,s),t&&(a=t)):(o.setMonth(a.getMonth()),o.setDate(a.getDate()),a=o),this._focusDate(a,!0),_.call(this)}function T(e){var t=e.size.width;if(!(t<=0)){var a=this._iSize;t<this._iBreakPointTablet?this._iSize=0:t<this._iBreakPointDesktop?this._iSize=1:t<this._iBreakPointLargeDesktop?this._iSize=2:this._iSize=3;var i,o=v.call(this);if(a!=this._iSize||this._bInitMonth){switch(this._iSize){case 1:i=2;break;case 2:i=3;break;case 3:i=4;break;default:i=1}if(o<i&&(i=o),i>2&&o>i){for(var s=i,n=0,r=i;s>=2;){var h=o%s;if(0==h){r=s;break}var g=h/s;g>n&&(n=g,r=s),s--}i=r}var l,c=this.getAggregation(\"month\");i>1?(l=100/i+\"%\",this.$(\"content\").removeClass(\"sapUiCalContentSingle\")):(l=\"100%\",this.$(\"content\").addClass(\"sapUiCalContentSingle\"));for(var d=0;d<c.length;d++){var p=c[d];p.setWidth(l)}}}}function k(e){var t=new g(e,this.getPrimaryCalendarType());t.setDate(1);var a=v.call(this);if(a<=12){var i=e.getMonth();i-=i%a,12%a>0&&i+a>11&&(i=12-a),t.setMonth(i)}return t}var F=t.extend(\"sap.ui.unified.Calendar\",{metadata:{library:\"sap.ui.unified\",properties:{intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},months:{type:\"int\",group:\"Appearance\",defaultValue:1},firstDayOfWeek:{type:\"int\",group:\"Appearance\",defaultValue:-1},nonWorkingDays:{type:\"int[]\",group:\"Appearance\",defaultValue:null},primaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\",defaultValue:null},secondaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\",defaultValue:null},width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},minDate:{type:\"object\",group:\"Misc\",defaultValue:null},maxDate:{type:\"object\",group:\"Misc\",defaultValue:null},showWeekNumbers:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"},disabledDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"disabledDate\"},header:{type:\"sap.ui.unified.calendar.Header\",multiple:!1,visibility:\"hidden\"},month:{type:\"sap.ui.unified.calendar.Month\",multiple:!0,visibility:\"hidden\"},monthPicker:{type:\"sap.ui.unified.calendar.MonthPicker\",multiple:!1,visibility:\"hidden\"},yearPicker:{type:\"sap.ui.unified.calendar.YearPicker\",multiple:!1,visibility:\"hidden\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},cancel:{},startDateChange:{}}}});return F.prototype.init=function(){this._iBreakPointTablet=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0],this._iBreakPointDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1],this._iBreakPointLargeDesktop=sap.ui.Device.media._predefinedRangeSets[sap.ui.Device.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];var t=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty(\"primaryCalendarType\",t),this.setProperty(\"secondaryCalendarType\",t),this._iMode=0,this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\",calendarType:t}),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this._oMinDate=o._minDate(this.getPrimaryCalendarType()),this._oMaxDate=o._maxDate(this.getPrimaryCalendarType());var a=this._createHeader(this.getId()+\"--Head\");a.attachEvent(\"pressPrevious\",this._handlePrevious,this),a.attachEvent(\"pressNext\",this._handleNext,this),a.attachEvent(\"pressButton1\",this._handleMonth,this),a.attachEvent(\"pressButton2\",this._handleYear,this),this.setAggregation(\"header\",a);var i=this._createMonth(this.getId()+\"--Month0\");i.attachEvent(\"focus\",this._handleFocus,this),i.attachEvent(\"select\",b,this),i.attachEvent(\"_renderMonth\",C,this),i.attachEvent(\"_bindMousemove\",S,this),i.attachEvent(\"_unbindMousemove\",x,this),i._bNoThemeChange=!0,this.addAggregation(\"month\",i);var s=new r(this.getId()+\"--MP\");s.attachEvent(\"select\",I,this),s._bNoThemeChange=!0,this.setAggregation(\"monthPicker\",s);var n=new h(this.getId()+\"--YP\");n.attachEvent(\"select\",A,this),this.setAggregation(\"yearPicker\",n),this._resizeProxy=e.proxy(T,this),this._oSelectedMonth},F.prototype._createHeader=function(e){var t=new s(e);return t},F.prototype.exit=function(){this._sInvalidateMonth&&e.sap.clearDelayedCall(this._sInvalidateMonth),this._sResizeListener&&(sap.ui.core.ResizeHandler.deregister(this._sResizeListener),this._sResizeListener=void 0),this._oSelectedMonth=null},F.prototype._createMonth=function(e){var t=new n(e);return t},F.prototype.onBeforeRendering=function(){var e,t=this.getAggregation(\"month\"),a=t[0].getDate(),i=this._getFocusedDate();e=t.length>1&&a?g.fromLocalJSDate(a,this.getPrimaryCalendarType()):t.length>1?k.call(this,this._getFocusedDate()):i;for(var o=0;o<t.length;o++){a=new g(e),o>0&&(a.setDate(1),a.setMonth(a.getMonth()+o));var s=a;i.getYear()===a.getYear()&&i.getMonth()===a.getMonth()&&(s=i),t[o].displayDate(s.toLocalJSDate()),t[o].setShowWeekNumbers(this.getShowWeekNumbers())}this._updateHeader(e),this._iSize=0},F.prototype.onAfterRendering=function(e){m.call(this),(v.call(this)>1||this._bInitMonth)&&(e.size={width:this.getDomRef().offsetWidth},T.call(this,e,!0),this._sResizeListener||(this._sResizeListener=sap.ui.core.ResizeHandler.register(this,this._resizeProxy)),this._bInitMonth=void 0)},F.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&0==this._iMode&&!this._sInvalidateMonth&&(this._sInvalidateMonth=e.sap.delayedCall(0,this,this._invalidateMonth,[a])):t.prototype.invalidate.apply(this,arguments)},F.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"selectedDates\");return e},F.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"selectedDates\");return e},F.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"specialDates\");return e},F.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"specialDates\");return e},F.prototype.getSpecialDates=function(){var e=this.getParent();return e&&e.getSpecialDates?e.getSpecialDates():this.getAggregation(\"specialDates\",[])},F.prototype.removeAllDisabledDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"disabledDates\");return e},F.prototype.destroyDisabledDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"disabledDates\");return e},F.prototype.setLocale=function(e){return this._sLocale!=e&&(this._sLocale=e,this._oLocaleData=void 0,this.invalidate()),this},F.prototype.getLocale=function(){return this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale},F.prototype._getFocusedDate=function(){return this._oFocusedDate||d.call(this),this._oFocusedDate},F.prototype._setFocusedDate=function(e){o._checkCalendarDate(e),this._oFocusedDate=new g(e,this.getPrimaryCalendarType())},F.prototype.focusDate=function(e){return y.call(this,e,!1),this},F.prototype.displayDate=function(e){return y.call(this,e,!0),this},F.prototype.getStartDate=function(){var e;if(this.getDomRef()){var t=this.getAggregation(\"month\");e=g.fromLocalJSDate(t[0].getDate(),this.getPrimaryCalendarType())}else e=new g(this._getFocusedDate());return e.setDate(1),e.toLocalJSDate()},F.prototype.setPopupMode=function(e){return this._bPoupupMode=e,this},F.prototype.setMonths=function(e){this._bDateRangeChanged=void 0,this.setProperty(\"months\",e,!1),e=v.call(this);var t,a=this.getAggregation(\"month\"),i=0;if(a.length<e)for(i=a.length;i<e;i++)t=this._createMonth(this.getId()+\"--Month\"+i),t.attachEvent(\"focus\",this._handleFocus,this),t.attachEvent(\"select\",b,this),t.attachEvent(\"_renderMonth\",C,this),t.attachEvent(\"_bindMousemove\",S,this),t.attachEvent(\"_unbindMousemove\",x,this),t._bNoThemeChange=!0,this.addAggregation(\"month\",t);else if(a.length>e){for(i=a.length;i>e;i--)t=this.removeAggregation(\"month\",i-1),t.destroy();1==e&&(this._bInitMonth=!0)}return e>1&&a[0].getDate()&&a[0].setProperty(\"date\",null,!0),this},F.prototype.setPrimaryCalendarType=function(e){var t=this.getAggregation(\"month\"),a=!1;t.length>1&&(a=!0),this.setProperty(\"primaryCalendarType\",e,!a),this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\",calendarType:e}),this._oFocusedDate&&(this._oFocusedDate=new g(this._oFocusedDate,e)),this._oMinDate=new g(this._oMinDate,e),this._oMaxDate=new g(this._oMaxDate,e);for(var i=0;i<t.length;i++){var o=t[i];o.setPrimaryCalendarType(e)}var s=this.getAggregation(\"monthPicker\");s.setPrimaryCalendarType(e);var n=this.getAggregation(\"yearPicker\");return n.setPrimaryCalendarType(e),this.getDomRef()&&(this._updateHeader(this._oFocusedDate),1!=this.iMode&&s.getDomRef()&&s.$().remove(),2!=this.iMode&&n.getDomRef()&&n.$().remove()),this},F.prototype.setSecondaryCalendarType=function(e){this._bSecondaryCalendarTypeSet=!0,this.setProperty(\"secondaryCalendarType\",e,!0),this._oYearFormatSecondary=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\",calendarType:e});for(var t=this.getAggregation(\"month\"),a=0;a<t.length;a++){var i=t[a];i.setSecondaryCalendarType(e)}return this.getDomRef()&&(this._updateHeader(this._getFocusedDate()),this.$().toggleClass(\"sapUiCalSecType\",!!this._getSecondaryCalendarType())),this},F.prototype._getSecondaryCalendarType=function(){var e;if(this._bSecondaryCalendarTypeSet){e=this.getSecondaryCalendarType();var t=this.getPrimaryCalendarType();e==t&&(e=void 0)}return e},F.prototype.setMinDate=function(t){if(e.sap.equal(t,this.getMinDate()))return this;if(t){o._checkJSDateObject(t),this._oMinDate=g.fromLocalJSDate(t,this.getPrimaryCalendarType());var a=this._oMinDate.getYear();o._checkYearInValidRange(a),this._oMaxDate.isBefore(this._oMinDate)&&(e.sap.log.warning(\"minDate > maxDate -> maxDate set to end of the month\",this),this._oMaxDate=g.fromLocalJSDate(t,this.getPrimaryCalendarType()),this._oMaxDate.setDate(o._daysInMonth(this._oMaxDate)),this.setProperty(\"maxDate\",this._oMaxDate.toLocalJSDate(),!0)),this._setMinMaxDateExtend(g.fromLocalJSDate(t,this.getPrimaryCalendarType()))}else this._oMinDate=o._minDate(this.getPrimaryCalendarType());this.setProperty(\"minDate\",t,!1);var i=this.getAggregation(\"yearPicker\");return i._oMinDate.setYear(this._oMinDate.getYear()),this},F.prototype.setMaxDate=function(t){if(e.sap.equal(t,this.getMaxDate()))return this;if(t){o._checkJSDateObject(t),this._oMaxDate=g.fromLocalJSDate(t,this.getPrimaryCalendarType());var a=this._oMaxDate.getYear();o._checkYearInValidRange(a),this._oMinDate.isAfter(this._oMaxDate)&&(e.sap.log.warning(\"maxDate < minDate -> minDate set to begin of the month\",this),this._oMinDate=g.fromLocalJSDate(t,this.getPrimaryCalendarType()),this._oMinDate.setDate(1),this.setProperty(\"minDate\",this._oMinDate.toLocalJSDate(),!0)),this._setMinMaxDateExtend(g.fromLocalJSDate(t,this.getPrimaryCalendarType()))}else this._oMaxDate=o._maxDate(this.getPrimaryCalendarType());this.setProperty(\"maxDate\",t,!1);var i=this.getAggregation(\"yearPicker\");return i._oMaxDate.setYear(this._oMaxDate.getYear()),this},F.prototype._setMinMaxDateExtend=function(t){this._oFocusedDate&&o._isOutside(this._oFocusedDate,this._oMinDate,this._oMaxDate)&&(e.sap.log.warning(\"focused date is not between [minDate - maxDate] -> refocus to the new max/min date: \"+t.toString(),this),this.focusDate(t.toLocalJSDate()))},F.prototype._getLocaleData=function(){if(!this._oLocaleData){var e=this.getLocale(),t=new sap.ui.core.Locale(e);this._oLocaleData=a.getInstance(t)}return this._oLocaleData},F.prototype._getShowMonthHeader=function(){var e=v.call(this);return e>2},F.prototype.setWidth=function(e){return this.setProperty(\"width\",e,!0),this.getDomRef()&&(e=this.getWidth(),this.$().css(\"width\",e),e?this.$().addClass(\"sapUiCalWidth\"):this.$().removeClass(\"sapUiCalWidth\")),this},F.prototype.onclick=function(e){e.isMarked(\"delayedMouseEvent\")||e.target.id==this.getId()+\"-cancel\"&&this.onsapescape(e)},F.prototype.onmousedown=function(e){e.preventDefault(),e.setMark(\"cancelAutoClose\")},F.prototype.onsapescape=function(e){0==this._iMode&&this.fireCancel(),this._closedPickers()},F.prototype.onsapshow=function(e){this._bPoupupMode&&(this._closedPickers(),this.fireCancel(),e.preventDefault())},F.prototype.onsaphide=F.prototype.onsapshow,F.prototype.onsaptabnext=function(t){var a=this.getAggregation(\"header\");if(e.sap.containsOrEquals(this.getDomRef(\"content\"),t.target)){if(e.sap.focus(a.getDomRef(\"B1\")),!this._bPoupupMode){for(var i=this.getAggregation(\"month\"),o=this.getAggregation(\"monthPicker\"),s=this.getAggregation(\"yearPicker\"),n=0;n<i.length;n++){var r=i[n];e(r._oItemNavigation.getItemDomRefs()[r._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}o.getDomRef()&&e(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),s.getDomRef()&&e(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}t.preventDefault()}else t.target.id==a.getId()+\"-B1\"&&(e.sap.focus(a.getDomRef(\"B2\")),t.preventDefault())},F.prototype.onsaptabprevious=function(t){var a=this.getAggregation(\"header\");if(e.sap.containsOrEquals(this.getDomRef(\"content\"),t.target))this._bPoupupMode&&(e.sap.focus(a.getDomRef(\"B2\")),t.preventDefault());else if(t.target.id==a.getId()+\"-B1\"){var i,o=this.getAggregation(\"month\"),s=this.getAggregation(\"monthPicker\"),n=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:i=this._getFocusedDate();for(var r=0;r<o.length;r++){var h=o[r],l=g.fromLocalJSDate(h.getDate(),this.getPrimaryCalendarType());i.isSame(l)?h._oItemNavigation.focusItem(h._oItemNavigation.getFocusedIndex()):e(h._oItemNavigation.getItemDomRefs()[h._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}break;case 1:s._oItemNavigation.focusItem(s._oItemNavigation.getFocusedIndex());break;case 2:n._oItemNavigation.focusItem(n._oItemNavigation.getFocusedIndex())}t.preventDefault()}else t.target.id==a.getId()+\"-B2\"&&(e.sap.focus(a.getDomRef(\"B1\")),t.preventDefault())},F.prototype.onfocusin=function(t){if(t.target.id==this.getId()+\"-end\"){var a=this.getAggregation(\"header\"),i=this.getAggregation(\"month\"),o=this.getAggregation(\"monthPicker\"),s=this.getAggregation(\"yearPicker\");if(e.sap.focus(a.getDomRef(\"B2\")),!this._bPoupupMode){for(var n=0;n<i.length;n++){var r=i[n];e(r._oItemNavigation.getItemDomRefs()[r._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}o.getDomRef()&&e(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),s.getDomRef()&&e(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}}this.$(\"end\").attr(\"tabindex\",\"-1\")},F.prototype.onsapfocusleave=function(t){if(!(t.relatedControlId&&e.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(t.relatedControlId).getFocusDomRef())||(this.$(\"end\").attr(\"tabindex\",\"0\"),this._bPoupupMode))){var a=this.getAggregation(\"month\"),i=this.getAggregation(\"monthPicker\"),o=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:for(var s=0;s<a.length;s++){var n=a[s];e(n._oItemNavigation.getItemDomRefs()[n._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}break;case 1:e(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\");break;case 2:e(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}},F.prototype.getFocusDomRef=function(){var e=this._oSelectedMonth?this._oSelectedMonth:this.getAggregation(\"month\")[0];return e._oItemNavigation.getItemDomRefs()[e._oItemNavigation.getFocusedIndex()]},F.prototype.onThemeChanged=function(){if(this.getDomRef()){this._bNamesLengthChecked=void 0;var e=this.getAggregation(\"monthPicker\");p.call(this,!0),e._bNoThemeChange=!1,e.onThemeChanged(arguments),e._bNoThemeChange=!0,this._bLongMonth=e._bLongMonth,u.call(this,!0);for(var t=this.getAggregation(\"month\"),a=0;a<t.length;a++){var i=t[a];i._bNoThemeChange=!1,i.onThemeChanged(arguments),i._bNoThemeChange=!0}var o;o=t.length>1?g.fromLocalJSDate(t[0].getDate(),this.getPrimaryCalendarType()):this._getFocusedDate(),f.call(this,o),m.call(this)}},F.prototype._updateHeader=function(e){f.call(this,e),this._togglePrevNext(e,!0)},F.prototype._togglePrevNext=function(e,t){var a=this._oMaxDate.getYear(),i=this._oMinDate.getYear(),s=this._oMaxDate.getMonth(),n=this._oMinDate.getMonth(),r=this.getAggregation(\"header\"),h=v.call(this),l=new g(e,this.getPrimaryCalendarType());0==this._iMode&&h>1?(l=k.call(this,e),l.setMonth(l.getMonth()+h-1),l.setDate(o._daysInMonth(l))):l.setDate(o._daysInMonth(l));var c=l.getYear(),d=l.getMonth();c>a||c==a&&(!t||d>=s)||1==this._iMode&&this.getPickerPopup&&this.getPickerPopup()?r.setEnabledNext(!1):r.setEnabledNext(!0),0==this._iMode&&h>1?(l.setMonth(l.getMonth()-h+1),l.setDate(1)):l.setDate(1),c=l.getYear(),d=l.getMonth(),c<i||c==i&&(!t||d<=n)||1==this._iMode&&this.getPickerPopup&&this.getPickerPopup()?r.setEnabledPrevious(!1):r.setEnabledPrevious(!0)},F.prototype._togglePrevNexYearPicker=function(){var e=this.getAggregation(\"yearPicker\"),t=e.getYears(),a=g.fromLocalJSDate(e.getFirstRenderedDate());a.setYear(a.getYear()+Math.floor(t/2));var i=this.getAggregation(\"header\"),o=new g(this._oMaxDate,this.getPrimaryCalendarType());o.setYear(o.getYear()-Math.ceil(t/2)),o.setMonth(11),o.setDate(31);var s=new g(this._oMinDate,this.getPrimaryCalendarType());s.setYear(s.getYear()+Math.floor(t/2)+1),s.setMonth(0),s.setDate(1),i.setEnabledNext(a.isSameOrBefore(o)),i.setEnabledPrevious(a.isSameOrAfter(s))},F.prototype._handlePrevious=function(e){var t,a,i=this._getFocusedDate(),o=this.getAggregation(\"header\"),s=this.getAggregation(\"yearPicker\"),n=v.call(this),r=!1;switch(this._iMode){case 0:n>1?(t=g.fromLocalJSDate(this.getAggregation(\"month\")[0].getDate(),this.getPrimaryCalendarType()),t.setDate(1),this._setFocusedDate(t),i=this._getFocusedDate()):i.setDate(1),i.setDate(i.getDate()-1),c.call(this,r,!0);break;case 1:i.setYear(i.getYear()-1),o.setTextButton2(this._oYearFormat.format(i.toUTCJSDate(),!0));var h=this._getSecondaryCalendarType();h?(a=new g(i,h),a.setMonth(0),a.setDate(1),o.setAdditionalTextButton2(this._oYearFormatSecondary.format(a.toUTCJSDate(),!0))):o.setAdditionalTextButton2(),this._togglePrevNext(i),this._setDisabledMonths(i.getYear());break;case 2:s.previousPage(),this._togglePrevNexYearPicker()}},F.prototype._handleNext=function(e){var t,a,i=this._getFocusedDate(),o=this.getAggregation(\"header\"),s=this.getAggregation(\"yearPicker\"),n=v.call(this);switch(this._iMode){case 0:n>1&&(t=g.fromLocalJSDate(this.getAggregation(\"month\")[0].getDate(),this.getPrimaryCalendarType()),this._setFocusedDate(t),i=this._getFocusedDate()),i.setDate(1),i.setMonth(i.getMonth()+n),c.call(this);break;case 1:i.setYear(i.getYear()+1),o.setTextButton2(this._oYearFormat.format(i.toUTCJSDate(),!0));var r=this._getSecondaryCalendarType();r?(a=new g(i,r),a.setMonth(0),a.setDate(1),o.setAdditionalTextButton2(this._oYearFormatSecondary.format(a.toUTCJSDate(),!0))):o.setAdditionalTextButton2(),this._togglePrevNext(i),this._setDisabledMonths(i.getYear());break;case 2:s.nextPage(),this._togglePrevNexYearPicker()}},F.prototype._handleMonth=function(e){M.call(this)},F.prototype._handleYear=function(e){P.call(this)},F.prototype._getDisplayedMonths=function(e){var t=[],a=e.getMonth(),i=v.call(this);if(i>1)for(var o=0;o<i;o++)t.push((a+o)%12);else t.push(a);return t},F.prototype._getDisplayedSecondaryMonths=function(e,t){var a=this.getAggregation(\"month\"),i=g.fromLocalJSDate(a[0].getDate(),e);i.setDate(1),i=new g(i,t);var s=i.getMonth(),n=g.fromLocalJSDate(a[a.length-1].getDate(),e);n.setDate(o._daysInMonth(n)),n=new g(n,t);var r=n.getMonth();return{start:s,end:r}},F.prototype._closedPickers=function(){switch(this._iMode){case 0:break;case 1:u.call(this);break;case 2:_.call(this)}},F.prototype._setDisabledMonths=function(e,t){var a=0,i=11;e==this._oMinDate.getYear()&&(a=this._oMinDate.getMonth()),e==this._oMaxDate.getYear()&&(i=this._oMaxDate.getMonth()),t||(t=this.getAggregation(\"monthPicker\")),t.setMinMax(a,i)},F.prototype._renderMonth=function(e,t,a){c.call(this,e,t,a)},F.prototype._handleFocus=function(t){var a=g.fromLocalJSDate(t.getParameter(\"date\"),this.getPrimaryCalendarType()),i=t.getParameter(\"otherMonth\"),o=t.getParameter(\"restoreOldDate\");o?e.sap.equal(this._getFocusedDate(),a)||c.call(this,!1,!1,!0):this._focusDate(a,i)},F.prototype._getVisibleDays=function(){var e=this.getAggregation(\"month\")[0];return e._getVisibleDays(e._getDate(),!1)},F.prototype._focusDate=function(e,t,a){var i,o=!1,s=!1;e.isBefore(this._oMinDate)?(i=this._oMinDate,o=!0):e.isAfter(this._oMaxDate)?(i=this._oMaxDate,o=!0):i=e,this._focusDateExtend&&(s=this._focusDateExtend(e,t,a));var n=i.isBefore(this._getFocusedDate());this._setFocusedDate(i),(o||t)&&c.call(this,!1,n,a),s&&this.fireStartDateChange()},F.prototype._invalidateMonth=function(e){this._sInvalidateMonth=void 0;var t=this.getAggregation(\"month\");if(t){for(var a=0;a<t.length;a++){var i=t[a];i._bDateRangeChanged=!0,i._bInvalidateSync=!0,t.length>1&&(i._bNoFocus=!0),i.invalidate(e),i._bInvalidateSync=void 0}t.length>1&&this._focusDate(this._getFocusedDate(),!0,!0)}this._bDateRangeChanged=void 0},F},!0);",
		"sap/ui/unified/calendar/CalendarDate.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/base/Object\",\"sap/ui/core/date/UniversalDate\"],function(t,e){\"use strict\";function a(t,a){return a?e.getInstance(n(t),a):new e(n(t).getTime())}function n(t){var e=new Date(Date.UTC(0,0,1));return e.setUTCFullYear(t.getFullYear(),t.getMonth(),t.getDate()),e}function r(t){if(!(t instanceof i))throw\"Invalid calendar date: [\"+t+\"]. Expected: sap.ui.unified.calendar.CalendarDate\"}function o(t,e){if(void 0==t||t===1/0||isNaN(t))throw e}var i=t.extend(\"sap.ui.unified.calendar.CalendarDate\",{constructor:function(){var t,e,n,r=arguments;switch(r.length){case 0:return e=new Date,this.constructor(e.getFullYear(),e.getMonth(),e.getDate());case 1:case 2:if(!(r[0]instanceof i))throw\"Invalid arguments: the first argument must be of type sap.ui.unified.calendar.CalendarDate.\";n=r[1]?r[1]:r[0]._oUDate.sCalendarType,t=new Date(r[0].valueOf()),t.setFullYear(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()),t.setHours(t.getUTCHours(),t.getUTCMinutes(),t.getUTCSeconds(),t.getUTCMilliseconds()),this._oUDate=a(t,n);break;case 3:case 4:o(r[0],\"Invalid year: \"+r[0]),o(r[1],\"Invalid month: \"+r[1]),o(r[2],\"Invalid date: \"+r[2]),t=new Date(0,0,1),t.setFullYear(r[0],r[1],r[2]),r[3]&&(n=r[3]),this._oUDate=a(t,n);break;default:throw\"Invalid arguments. Accepted arguments are: 1) oCalendarDate, (optional)calendarTypeor 2) year, month, date, (optional) calendarType\"+r}}});return i.prototype.getYear=function(){return this._oUDate.getUTCFullYear()},i.prototype.setYear=function(t){return o(t,\"Invalid year: \"+t),this._oUDate.setUTCFullYear(t),this},i.prototype.getMonth=function(){return this._oUDate.getUTCMonth()},i.prototype.setMonth=function(t){return o(t,\"Invalid month: \"+t),this._oUDate.setUTCMonth(t),this},i.prototype.getDate=function(){return this._oUDate.getUTCDate()},i.prototype.setDate=function(t){return o(t,\"Invalid date: \"+t),this._oUDate.setUTCDate(t),this},i.prototype.getDay=function(){return this._oUDate.getUTCDay()},i.prototype.getCalendarType=function(){return this._oUDate.sCalendarType},i.prototype.isBefore=function(t){return r(t),this.valueOf()<t.valueOf()},i.prototype.isAfter=function(t){return r(t),this.valueOf()>t.valueOf()},i.prototype.isSameOrBefore=function(t){return r(t),this.valueOf()<=t.valueOf()},i.prototype.isSameOrAfter=function(t){return r(t),this.valueOf()>=t.valueOf()},i.prototype.isSame=function(t){return r(t),this.valueOf()===t.valueOf()},i.prototype.toLocalJSDate=function(){var t=new Date(this._oUDate.getTime());return t.setFullYear(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()),t.setHours(0,0,0,0),t},i.prototype.toUTCJSDate=function(){var t=new Date(this._oUDate.getTime());return t.setUTCHours(0,0,0,0),t},i.prototype.toString=function(){return this._oUDate.sCalendarType+\": \"+this.getYear()+\"/\"+(this.getMonth()+1)+\"/\"+this.getDate()},i.prototype.valueOf=function(){return this._oUDate.getTime()},i.fromLocalJSDate=function(t,e){if(!(t instanceof Date))throw new Error(\"Date parameter must be a JavaScript Date object: [\"+t+\"].\");return new i(t.getFullYear(),t.getMonth(),t.getDate(),e)},i},!0);",
		"sap/ui/unified/calendar/CalendarUtils.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/date/UniversalDate\",\"./CalendarDate\"],function(e,t,a){\"use strict\";var n={};return n.MAX_MILLISECONDS=864e13,n.HOURS24=864e5,n._createLocalDate=function(e,a){var n;if(e){var r;r=e instanceof t?e.getJSDate():e,n=new Date(r.getUTCFullYear(),r.getUTCMonth(),r.getUTCDate()),r.getFullYear()<1e3&&n.setFullYear(r.getFullYear()),a&&(n.setHours(r.getUTCHours()),n.setMinutes(r.getUTCMinutes()),n.setSeconds(r.getUTCSeconds()),n.setMilliseconds(r.getUTCMilliseconds()))}return n},n._createUTCDate=function(e,a){var n;if(e){var r;r=e instanceof t?e.getJSDate():e,n=new Date(Date.UTC(r.getFullYear(),r.getMonth(),r.getDate())),r.getFullYear()<1e3&&n.setUTCFullYear(r.getFullYear()),a&&(n.setUTCHours(r.getHours()),n.setUTCMinutes(r.getMinutes()),n.setUTCSeconds(r.getSeconds()),n.setUTCMilliseconds(r.getMilliseconds()))}return n},n._createUniversalUTCDate=function(e,a,n){var r;return r=a?t.getInstance(this._createUTCDate(e,n),a):new t(this._createUTCDate(e,n).getTime())},n.calculateWeekNumber=function(e,a,n,r){var i=0,s=0,g=r.getFirstDayOfWeek(),o=new sap.ui.core.Locale(n);if(o&&\"en\"==o.getLanguage()&&\"US\"==o.getRegion()){var u=new t(e.getTime());u.setUTCFullYear(a,0,1),s=u.getUTCDay();var c=new t(e.getTime());c.setUTCDate(c.getUTCDate()-c.getUTCDay()+s),i=Math.round((c.getTime()-u.getTime())/864e5/7)+1}else{var l=new t(e.getTime());l.setUTCDate(l.getUTCDate()-g),s=l.getUTCDay(),l.setUTCDate(l.getUTCDate()-s+4);var D=new t(l.getTime());D.setUTCMonth(0,1),s=D.getUTCDay();var C=0;s>4&&(C=7);var T=new t(D.getTime());T.setUTCDate(1-s+4+C),i=Math.round((l.getTime()-T.getTime())/864e5/7)+1}return i},n.getFirstDateOfWeek=function(e){var a,n,r=new t(e.getTime());return n=t.getWeekByDate(r.getCalendarType(),r.getUTCFullYear(),r.getUTCMonth(),r.getUTCDate()),0===n.week&&\"US\"===sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().getRegion()&&(n.year--,n.week=52),a=t.getFirstDateOfWeek(r.getCalendarType(),n.year,n.week),new t(Date.UTC(a.year,a.month,a.day,e.getUTCHours(),e.getUTCMinutes(),e.getUTCSeconds())).getJSDate()},n.getFirstDateOfMonth=function(e){var a=new t(e.getTime());return a.setUTCDate(1),a},n._getNumberOfWeeksForYear=function(e){var t=sap.ui.getCore().getConfiguration().getFormatLocale(),a=sap.ui.core.LocaleData.getInstance(new sap.ui.core.Locale(t)),n=new Date(Date.UTC(e,0,1)),r=n.getUTCDay(),i=52;return 0===a.getFirstDayOfWeek()?5!==r&&6!==r||(i=53):3!==r&&4!==r||(i=53),i},n.monthsDiffer=function(e,t){return e.getMonth()!==t.getMonth()||e.getFullYear()!==t.getFullYear()},n.isDateLastInMonth=function(e){var t=new Date(e.getTime()+864e5);return t.getUTCDate()<e.getUTCDate()},n._updateUTCDate=function(t,a,n,r,i,s,g,o){e.isNumeric(a)&&t.setUTCFullYear(a),e.isNumeric(n)&&t.setUTCMonth(n),e.isNumeric(r)&&t.setUTCDate(r),e.isNumeric(i)&&t.setUTCHours(i),e.isNumeric(s)&&t.setUTCMinutes(s),e.isNumeric(g)&&t.setUTCSeconds(g),e.isNumeric(o)&&t.setUTCMilliseconds(o)},n._checkJSDateObject=function(e){if(!(e instanceof Date))throw new Error(\"Date must be a JavaScript date object.\")},n._checkYearInValidRange=function(t){if(!e.isNumeric(t)||t<1||t>9999)throw new Error(\"Year must be in valid range (between year 0001 and year 9999).\")},n._isNextMonth=function(e,t){return e.getMonth()>t.getMonth()&&e.getFullYear()===t.getFullYear()||e.getFullYear()>t.getFullYear()},n._daysInMonth=function(e){return this._checkCalendarDate(e),e=new a(e),e.setDate(1),e.setMonth(e.getMonth()+1),e.setDate(0),e.getDate()},n._isLastDateInMonth=function(e){return e.getDate()===n._daysInMonth(e)},n._getFirstDateOfWeek=function(e){this._checkCalendarDate(e);var t=n.getFirstDateOfWeek(e.toUTCJSDate());return t.setFullYear(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()),a.fromLocalJSDate(t,e.getCalendarType())},n._getFirstDateOfMonth=function(e){this._checkCalendarDate(e);var t=n.getFirstDateOfMonth(e.toUTCJSDate()).getJSDate();return t.setFullYear(t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()),a.fromLocalJSDate(t,e.getCalendarType())},n._minDate=function(e){return new a(1,0,1,e)},n._maxDate=function(e){var t=new a(9999,11,1,e);return t.setDate(this._daysInMonth(t)),new a(t)},n._isBetween=function(e,t,a,n){return this._checkCalendarDate(e),this._checkCalendarDate(t),this._checkCalendarDate(a),n?e.isSameOrAfter(t)&&e.isSameOrBefore(a):e.isAfter(t)&&e.isBefore(a)},n._daysBetween=function(e,t){return this._checkCalendarDate(e),this._checkCalendarDate(t),Math.ceil((e.valueOf()-t.valueOf())/this.HOURS24)},n._isOutside=function(e,t,a){return!this._isBetween(e,t,a,!0)},n._isSameMonthAndYear=function(e,t){return this._checkCalendarDate(e),this._checkCalendarDate(t),e.getYear()===t.getYear()&&e.getMonth()===t.getMonth()},n._checkCalendarDate=function(e){if(!(e&&e instanceof a))throw\"Invalid calendar date: [\"+e+\"]. Expected: sap.ui.unified.calendar.CalendarDate\"},n._getWeek=function(e){return this._checkCalendarDate(e),t.getWeekByDate(e.getCalendarType(),e.getYear(),e.getMonth(),e.getDate())},n},!0);",
		"sap/ui/unified/calendar/DatesRow.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/unified/calendar/Month\",\"sap/ui/unified/library\"],function(e,t,a,r,i,s,o,n,p){\"use strict\";var h=n.extend(\"sap.ui.unified.calendar.DatesRow\",{metadata:{library:\"sap.ui.unified\",properties:{startDate:{type:\"object\",group:\"Data\"},days:{type:\"int\",group:\"Appearance\",defaultValue:7},showDayNamesLine:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}}}});return h.prototype.init=function(){n.prototype.init.apply(this,arguments),this._iColumns=1},h.prototype.setStartDate=function(e){s._checkJSDateObject(e);var t=e.getFullYear();if(s._checkYearInValidRange(t),this.setProperty(\"startDate\",e,!0),this._oStartDate=o.fromLocalJSDate(e,this.getPrimaryCalendarType()),this.getDomRef()){var a=this._getDate().toLocalJSDate();this._bNoRangeCheck=!0,this.displayDate(e),this._bNoRangeCheck=!1,a&&this.checkDateFocusable(a)&&this.displayDate(a)}return this},h.prototype._getStartDate=function(){return this._oStartDate||(this._oStartDate=o.fromLocalJSDate(new Date,this.getPrimaryCalendarType())),this._oStartDate},h.prototype.setDate=function(e){if(!this._bNoRangeCheck&&!this.checkDateFocusable(e))throw new Error(\"Date must be in visible date range; \"+this);return n.prototype.setDate.apply(this,arguments),this},h.prototype.displayDate=function(e){if(!this._bNoRangeCheck&&!this.checkDateFocusable(e))throw new Error(\"Date must be in visible date range; \"+this);return n.prototype.displayDate.apply(this,arguments),this},h.prototype.setPrimaryCalendarType=function(e){return n.prototype.setPrimaryCalendarType.apply(this,arguments),this._oStartDate&&(this._oStartDate=new o(this._oStartDate,e)),this},h.prototype.setFirstDayOfWeek=function(e){if(e==-1)return this.setProperty(\"firstDayOfWeek\",e,!1);throw new Error(\"Property firstDayOfWeek not supported \"+this)},h.prototype._handleBorderReached=function(e){var t=e.getParameter(\"event\"),a=this.getDays(),r=this._getDate(),i=new o(r,this.getPrimaryCalendarType());if(t.type){switch(t.type){case\"sapnext\":case\"sapnextmodifiers\":i.setDate(i.getDate()+1);break;case\"sapprevious\":case\"sappreviousmodifiers\":i.setDate(i.getDate()-1);break;case\"sappagedown\":i.setDate(i.getDate()+a);break;case\"sappageup\":i.setDate(i.getDate()-a)}this.fireFocus({date:i.toLocalJSDate(),otherMonth:!0,_outsideBorder:!0})}},h.prototype.checkDateFocusable=function(e){if(s._checkJSDateObject(e),this._bNoRangeCheck)return!1;var t=this._getStartDate(),a=new o(t,this.getPrimaryCalendarType());a.setDate(a.getDate()+this.getDays());var r=o.fromLocalJSDate(e,this.getPrimaryCalendarType());return r.isSameOrAfter(t)&&r.isBefore(a)},h.prototype._renderHeader=function(){var t=this._getStartDate(),a=t.getDay(),r=this._getLocaleData(),i=this.$(\"Names\").children(),s=[];s=this._bLongWeekDays||!this._bNamesLengthChecked?r.getDaysStandAlone(\"abbreviated\"):r.getDaysStandAlone(\"narrow\");var o=r.getDaysStandAlone(\"wide\"),n=0;for(n=0;n<i.length;n++){var p=e(i[n]);p.text(s[(n+a)%7]),p.attr(\"aria-label\",o[(n+a)%7])}if(this._getShowHeader()){var h=this.$(\"Head\");if(h.length>0){var c=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(c,this,r,t),c.flush(h[0]),c.destroy()}}},h.prototype._getFirstWeekDay=function(){return this._getStartDate().getDay()},h},!0);",
		"sap/ui/unified/calendar/DatesRowRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"./MonthRenderer\"],function(e,a,t,n,r){\"use strict\";var i=a.extend(r);return i.getStartDate=function(e){return e._getStartDate()},i.getClass=function(e){var a=\"sapUiCalDatesRow sapUiCalRow\";return e.getShowDayNamesLine()||(a+=\" sapUiCalNoNameLine\"),a},i.renderHeader=function(e,a,t){var n=a._getLocaleData(),r=a.getId(),i=a.getDays(),s=\"\";a._getShowHeader()&&(e.write('<div id=\"'+r+'-Head\">'),this.renderHeaderLine(e,a,n,t),e.write(\"</div>\")),s=100/i+\"%\",a.getShowDayNamesLine()&&(e.write('<div id=\"'+r+'-Names\" style=\"display: inline;\">'),this.renderDayNames(e,a,n,t.getDay(),i,!1,s),e.write(\"</div>\"))},i.renderHeaderLine=function(e,a,t,r){var i=a.getId(),s=a.getDays(),d=new n(r,a.getPrimaryCalendarType()),o=\"\",D=0,g=[],l=0;for(l=0;l<s;l++)D=d.getMonth(),g.length>0&&g[g.length-1].iMonth==D?g[g.length-1].iDays++:g.push({iMonth:D,iDays:1}),d.setDate(d.getDate()+1);var y=t.getMonthsStandAlone(\"wide\");for(l=0;l<g.length;l++){var h=g[l];o=100/s*h.iDays+\"%\",e.write('<div id=\"'+i+\"-Head\"+l+'\"class=\"sapUiCalHeadText\" style=\"width:'+o+'\">'),e.write(y[h.iMonth]),e.write(\"</div>\")}},i.renderDays=function(e,a,t){var r=a.getDays(),i=100/r+\"%\",s=a.getShowDayNamesLine();t||(t=a._getFocusedDate());var d=this.getDayHelper(a,t);s||(a._bLongWeekDays||!a._bNamesLengthChecked?d.aWeekDays=d.oLocaleData.getDaysStandAlone(\"abbreviated\"):d.aWeekDays=d.oLocaleData.getDaysStandAlone(\"narrow\"),d.aWeekDaysWide=d.oLocaleData.getDaysStandAlone(\"wide\"));for(var o=new n(t,a.getPrimaryCalendarType()),D=0;D<r;D++)this.renderDay(e,a,o,d,!1,!1,D,i,!s),o.setDate(o.getDate()+1)},i},!0);",
		"sap/ui/unified/calendar/Header.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/unified/library\"],function(t,e,i,s){\"use strict\";function a(t,e){this.setProperty(\"textButton\"+t,e,!0),this.getDomRef()&&this[\"getVisibleButton\"+t]()&&(this.$(\"B\"+t+\"-Text\").get(0)?this.$(\"B\"+t+\"-Text\").text(e):this.$(\"B\"+t).text(e))}function o(t,e){var i=!1,s=this[\"getAdditionalTextButton\"+t]();s!=e&&((!s&&e||s&&!e)&&(i=!0),this.setProperty(\"additionalTextButton\"+t,e,!i),!i&&this.getDomRef()&&this[\"getVisibleButton\"+t]()&&this.$(\"B\"+t+\"-AddText\").text(e))}function r(t,e){this.setProperty(\"ariaLabelButton\"+t,e,!0),this.getDomRef()&&this[\"getVisibleButton\"+t]()&&(e?this.$(\"B\"+t).attr(\"aria-label\",e):this.$(\"B\"+t).removeAttr(\"aria-label\"))}var n=e.extend(\"sap.ui.unified.calendar.Header\",{metadata:{library:\"sap.ui.unified\",properties:{textButton0:{type:\"string\",group:\"Appearance\"},additionalTextButton0:{type:\"string\",group:\"Appearance\"},ariaLabelButton0:{type:\"string\",group:\"Misc\"},visibleButton0:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},textButton1:{type:\"string\",group:\"Appearance\"},additionalTextButton1:{type:\"string\",group:\"Appearance\"},ariaLabelButton1:{type:\"string\",group:\"Misc\"},visibleButton1:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},textButton2:{type:\"string\",group:\"Appearance\"},additionalTextButton2:{type:\"string\",group:\"Appearance\"},ariaLabelButton2:{type:\"string\",group:\"Misc\"},visibleButton2:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},enabledPrevious:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},enabledNext:{type:\"boolean\",group:\"Behavior\",defaultValue:!0}},events:{pressPrevious:{},pressNext:{},pressButton0:{},pressButton1:{},pressButton2:{}}}});return n.prototype.setTextButton0=function(t){return a.call(this,0,t),this},n.prototype.setAdditionalTextButton0=function(t){return o.call(this,0,t),this},n.prototype.setAriaLabelButton0=function(t){return r.call(this,0,t),this},n.prototype.setTextButton1=function(t){return a.call(this,1,t),this},n.prototype.setAdditionalTextButton1=function(t){return o.call(this,1,t),this},n.prototype.setAriaLabelButton1=function(t){return r.call(this,1,t),this},n.prototype.setTextButton2=function(t){return a.call(this,2,t),this},n.prototype.setAdditionalTextButton2=function(t){return o.call(this,2,t),this},n.prototype.setAriaLabelButton2=function(t){return r.call(this,2,t),this},n.prototype.setEnabledPrevious=function(t){return this.setProperty(\"enabledPrevious\",t,!0),this.getDomRef()&&(t?this.$(\"prev\").toggleClass(\"sapUiCalDsbl\",!1).removeAttr(\"disabled\"):this.$(\"prev\").toggleClass(\"sapUiCalDsbl\",!0).attr(\"disabled\",\"disabled\")),this},n.prototype.setEnabledNext=function(t){return this.setProperty(\"enabledNext\",t,!0),this.getDomRef()&&(t?this.$(\"next\").toggleClass(\"sapUiCalDsbl\",!1).removeAttr(\"disabled\"):this.$(\"next\").toggleClass(\"sapUiCalDsbl\",!0).attr(\"disabled\",\"disabled\")),this},n.prototype.onclick=function(e){e.isMarked(\"delayedMouseEvent\")||(t.sap.containsOrEquals(this.getDomRef(\"prev\"),e.target)&&this.getEnabledPrevious()?this.firePressPrevious():t.sap.containsOrEquals(this.getDomRef(\"next\"),e.target)&&this.getEnabledNext()?this.firePressNext():t.sap.containsOrEquals(this.getDomRef(\"B0\"),e.target)?this.firePressButton0():t.sap.containsOrEquals(this.getDomRef(\"B1\"),e.target)?this.firePressButton1():t.sap.containsOrEquals(this.getDomRef(\"B2\"),e.target)&&this.firePressButton2())},n.prototype.onsapnext=function(t){t.preventDefault()},n},!0);",
		"sap/ui/unified/calendar/HeaderRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var i=sap.ui.getCore().getConfiguration().getLocale().getLanguage(),a=e.getTooltip_AsString(),r=e.getId(),s={},l=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\").getText(\"CALENDAR_BTN_NEXT\"),d=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\").getText(\"CALENDAR_BTN_PREV\");t.write(\"<div\"),t.writeControlData(e),t.addClass(\"sapUiCalHead\"),t.writeClasses(),a&&t.writeAttributeEscaped(\"title\",a),t.writeAccessibilityState(e),t.write(\">\"),t.write(\"<button\"),t.writeAttributeEscaped(\"id\",r+\"-prev\"),t.writeAttributeEscaped(\"title\",d),t.writeAccessibilityState(null,{label:d}),t.addClass(\"sapUiCalHeadPrev\"),e.getEnabledPrevious()||(t.addClass(\"sapUiCalDsbl\"),t.writeAttribute(\"disabled\",\"disabled\")),t.writeAttribute(\"tabindex\",\"-1\"),t.writeClasses(),t.writeAttribute(\"title\",this.getPreviousTooltip(e)),t.writeAttribute(\"aria-label\",this.getPreviousTooltip(e)),t.write(\">\"),this.renderHeaderPreviousIcon(t,e),t.write(\"</button>\");var n,o=-1,u=-1,w=0;for(w=0;w<3;w++)e[\"getVisibleButton\"+w]()&&(o<0&&(o=w),u=w);for(w=0;w<3;w++)n=\"ja\"===i.toLowerCase()||\"zh\"===i.toLowerCase()?2-w:w,this.renderCalendarButtons(t,e,r,o,u,s,n);t.write(\"<button\"),t.writeAttributeEscaped(\"id\",r+\"-next\"),t.writeAttributeEscaped(\"title\",l),t.writeAccessibilityState(null,{label:l}),t.addClass(\"sapUiCalHeadNext\"),e.getEnabledNext()||(t.addClass(\"sapUiCalDsbl\"),t.writeAttribute(\"disabled\",\"disabled\")),t.writeAttribute(\"tabindex\",\"-1\"),t.writeClasses(),t.writeAttribute(\"title\",this.getNextTooltip(e)),t.writeAttribute(\"aria-label\",this.getNextTooltip(e)),t.write(\">\"),this.renderHeaderNextIcon(t,e),t.write(\"</button>\"),t.write(\"</div>\")},e.renderCalendarButtons=function(e,i,a,r,s,l,d){if(i[\"getVisibleButton\"+d]()){e.write(\"<button\"),e.writeAttributeEscaped(\"id\",a+\"-B\"+d),e.addClass(\"sapUiCalHeadB\"),e.addClass(\"sapUiCalHeadB\"+d),r==d&&e.addClass(\"sapUiCalHeadBFirst\"),s==d&&e.addClass(\"sapUiCalHeadBLast\"),e.writeAttribute(\"tabindex\",\"-1\"),e.writeClasses(),i[\"getAriaLabelButton\"+d]()&&(l.label=t.sap.encodeHTML(i[\"getAriaLabelButton\"+d]())),e.writeAccessibilityState(null,l),l={},e.write(\">\");var n=i[\"getTextButton\"+d]()||\"\",o=i[\"getAdditionalTextButton\"+d]()||\"\";o?(e.write(\"<span\"),e.writeAttributeEscaped(\"id\",a+\"-B\"+d+\"-Text\"),e.addClass(\"sapUiCalHeadBText\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(n),e.write(\"</span>\"),e.write(\"<span\"),e.writeAttributeEscaped(\"id\",a+\"-B\"+d+\"-AddText\"),e.addClass(\"sapUiCalHeadBAddText\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(o),e.write(\"</span>\")):e.writeEscaped(n),e.write(\"</button>\")}},e.renderHeaderPreviousIcon=function(t,e){t.writeIcon(\"sap-icon://slim-arrow-left\",null,{title:null})},e.renderHeaderNextIcon=function(t,e){t.writeIcon(\"sap-icon://slim-arrow-right\",null,{title:null})},e.getPreviousTooltip=function(){return\"\"},e.getNextTooltip=function(){return\"\"},e},!0);",
		"sap/ui/unified/calendar/Month.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/unified/library\"],function(e,t,a,i,s,o,r,n){\"use strict\";function l(){for(var t=this._oFormatYyyymmdd.format(this._getDate().toUTCJSDate(),!0),a=0,s=this.$(\"days\").get(0),o=this.$(\"days\").find(\".sapUiCalItem\"),r=0;r<o.length;r++){var n=e(o[r]);if(n.attr(\"data-sap-day\")===t){a=r;break}}this._oItemNavigation||(this._oItemNavigation=new i,this._oItemNavigation.attachEvent(i.Events.AfterFocus,h,this),this._oItemNavigation.attachEvent(i.Events.FocusAgain,d,this),this._oItemNavigation.attachEvent(i.Events.BorderReached,this._handleBorderReached,this),this.addDelegate(this._oItemNavigation),this._iColumns>1&&this._oItemNavigation.setHomeEndColumnMode(!0,!0),this._oItemNavigation.setDisabledModifiers({sapnext:[\"alt\"],sapprevious:[\"alt\"],saphome:[\"alt\"],sapend:[\"alt\"]}),this._oItemNavigation.setCycling(!1),this._oItemNavigation.setColumns(this._iColumns,!0)),this._oItemNavigation.setRootDomRef(s),this._oItemNavigation.setItemDomRefs(o),this._oItemNavigation.setFocusedIndex(a),this._oItemNavigation.setPageSize(o.length)}function h(t){var a=t.getParameter(\"index\"),i=t.getParameter(\"event\");if(i){var s,o=this._getDate(),n=new r(o,this.getPrimaryCalendarType()),l=!1,h=!0,d=this._oItemNavigation.getItemDomRefs(),p=0,c=e(d[a]);if(c.hasClass(\"sapUiCalItemOtherMonth\"))if(\"saphomemodifiers\"==i.type&&(i.metaKey||i.ctrlKey))n.setDate(1),this._focusDate(n);else if(\"sapendmodifiers\"==i.type&&(i.metaKey||i.ctrlKey)){for(p=d.length-1;p>0;p--)if(s=e(d[p]),!s.hasClass(\"sapUiCalItemOtherMonth\")){n=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(s.attr(\"data-sap-day\")),this.getPrimaryCalendarType());break}this._focusDate(n)}else l=!0,n=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(c.attr(\"data-sap-day\")),this.getPrimaryCalendarType()),n||(n=new r(o)),this._focusDate(o),(\"mousedown\"==i.type||this._sTouchstartYyyyMMdd&&\"focusin\"==i.type&&this._sTouchstartYyyyMMdd==c.attr(\"data-sap-day\"))&&(h=!1,this.fireFocus({date:o.toLocalJSDate(),otherMonth:!1,restoreOldDate:!0})),i.originalEvent&&\"touchstart\"==i.originalEvent.type?this._sTouchstartYyyyMMdd=c.attr(\"data-sap-day\"):this._sTouchstartYyyyMMdd=void 0;else e(i.target).hasClass(\"sapUiCalWeekNum\")?this._focusDate(n):(n=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(c.attr(\"data-sap-day\")),this.getPrimaryCalendarType()),this._setDate(n)),this._sTouchstartYyyyMMdd=void 0;\"mousedown\"==i.type&&this.getIntervalSelection()&&(this._sLastTargetId=c.attr(\"id\")),h&&this.fireFocus({date:n.toLocalJSDate(),otherMonth:l}),\"mousedown\"==i.type&&g.call(this,i,n,a)}}function d(e){var t=e.getParameter(\"index\"),a=e.getParameter(\"event\");if(a&&\"mousedown\"==a.type){var i=this._getDate();if(this.getIntervalSelection()){var s=this._oItemNavigation.getItemDomRefs();this._sLastTargetId=s[t].id}g.call(this,a,i,t)}}function g(e,t,a){if(!e.button){var i=y.call(this,t);i&&(this._bMousedownChange=!0),this._bMouseMove?(this._unbindMousemove(!0),this._bMoveChange=!1,this._oMoveSelectedDate=void 0):i&&this.getIntervalSelection()&&this.$().is(\":visible\")&&(this._bindMousemove(!0),this._oMoveSelectedDate=new r(t,this.getPrimaryCalendarType())),e.preventDefault(),e.setMark(\"cancelAutoClose\")}}function p(e,t){o._checkCalendarDate(e);var a=e.getYear();o._checkYearInValidRange(a);var i=!0;if(!this.getDate()||!e.isSame(r.fromLocalJSDate(this.getDate(),e.getCalendarType()))){var s=new r(e);i=this.checkDateFocusable(e.toLocalJSDate()),this.setProperty(\"date\",e.toLocalJSDate(),!0),this._oDate=s}this.getDomRef()&&(i?this._focusDate(this._oDate,!0,t):c.call(this,t))}function c(t){var a,i,s=this.getRenderer().getStartDate(this),o=this.$(\"days\"),r=0,n=0;if(this._sLastTargetId)for(a=this._oItemNavigation.getItemDomRefs(),r=0;r<a.length;r++)if(i=e(a[r]),i.attr(\"id\")==this._sLastTargetId){n=r;break}if(o.length>0){var h=sap.ui.getCore().createRenderManager();this.getRenderer().renderDays(h,this,s),h.flush(o[0]),h.destroy()}this._renderHeader(),this.fireEvent(\"_renderMonth\",{days:o.find(\".sapUiCalItem\").length}),l.call(this),t||this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex()),this._sLastTargetId&&(a=this._oItemNavigation.getItemDomRefs(),n<=a.length-1&&(i=e(a[n]),this._sLastTargetId=i.attr(\"id\")))}function y(t,a){if(!this._checkDateEnabled(t))return!1;var i,s,o,n,l=this.getSelectedDates(),h=this._oItemNavigation.getItemDomRefs(),d=0,g=this.getParent(),p=this,c=this.getPrimaryCalendarType();if(g&&g.getSelectedDates&&(p=g),this.getSingleSelection())if(l.length>0?(i=l[0],n=i.getStartDate(),n&&(n=r.fromLocalJSDate(n,c))):(i=new sap.ui.unified.DateRange,p.addAggregation(\"selectedDates\",i,!0)),this.getIntervalSelection()&&(!i.getEndDate()||a)&&n){var y;t.isBefore(n)?(y=n,n=t,a||(i.setProperty(\"startDate\",n.toLocalJSDate(),!0),i.setProperty(\"endDate\",y.toLocalJSDate(),!0))):t.isSameOrAfter(n)&&(y=t,a||i.setProperty(\"endDate\",y.toLocalJSDate(),!0)),m.call(this,n,y)}else m.call(this,t),i.setProperty(\"startDate\",t.toLocalJSDate(),!0),i.setProperty(\"endDate\",void 0,!0);else{if(this.getIntervalSelection())throw new Error(\"Calender don't support multiple interval selection\");var u=this._checkDateSelected(t);if(u>0){for(d=0;d<l.length;d++)if(n=l[d].getStartDate(),n&&t.isSame(r.fromLocalJSDate(n,c))){p.removeAggregation(\"selectedDates\",d,!0);break}}else i=new sap.ui.unified.DateRange({startDate:t.toLocalJSDate()}),p.addAggregation(\"selectedDates\",i,!0);for(o=this._oFormatYyyymmdd.format(t.toUTCJSDate(),!0),d=0;d<h.length;d++)s=e(h[d]),s.attr(\"data-sap-day\")==o&&(u>0?(s.removeClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"false\")):(s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\")))}return!0}function m(t,a){Array.isArray(t)||(t=[t]);var i,s=this._oItemNavigation.getItemDomRefs(),n=0,l=!1,h=!1;if(a){var d;for(n=0;n<s.length;n++)i=e(s[n]),l=!1,h=!1,d=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(i.attr(\"data-sap-day\"),sap.ui.core.CalendarType.Gregorian)),d.isSame(t[0])?(i.addClass(\"sapUiCalItemSelStart\"),l=!0,i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),a&&d.isSame(a)&&(i.addClass(\"sapUiCalItemSelEnd\"),h=!0),i.removeClass(\"sapUiCalItemSelBetween\")):a&&o._isBetween(d,t[0],a)?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),i.addClass(\"sapUiCalItemSelBetween\"),i.removeClass(\"sapUiCalItemSelStart\"),i.removeClass(\"sapUiCalItemSelEnd\")):a&&d.isSame(a)?(i.addClass(\"sapUiCalItemSelEnd\"),h=!0,i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),i.removeClass(\"sapUiCalItemSelStart\"),i.removeClass(\"sapUiCalItemSelBetween\")):(i.hasClass(\"sapUiCalItemSel\")&&(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\")),i.hasClass(\"sapUiCalItemSelStart\")?i.removeClass(\"sapUiCalItemSelStart\"):i.hasClass(\"sapUiCalItemSelBetween\")?i.removeClass(\"sapUiCalItemSelBetween\"):i.hasClass(\"sapUiCalItemSelEnd\")&&i.removeClass(\"sapUiCalItemSelEnd\")),u.call(this,i,l,h)}else{var g=t.map(function(e){return this._oFormatYyyymmdd.format(e.toUTCJSDate(),!0)},this);for(n=0;n<s.length;n++)i=e(s[n]),l=!1,h=!1,g.indexOf(i.attr(\"data-sap-day\"))>-1?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),l=!0):i.hasClass(\"sapUiCalItemSel\")&&(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\")),i.hasClass(\"sapUiCalItemSelStart\")?i.removeClass(\"sapUiCalItemSelStart\"):i.hasClass(\"sapUiCalItemSelBetween\")?i.removeClass(\"sapUiCalItemSelBetween\"):i.hasClass(\"sapUiCalItemSelEnd\")&&i.removeClass(\"sapUiCalItemSelEnd\"),u.call(this,i,l,h)}}function u(e,t,a){if(this.getIntervalSelection()){var i=\"\",s=[],o=this.getId(),r=!1;i=e.attr(\"aria-describedby\"),i&&(s=i.split(\" \"));for(var n=-1,l=-1,h=0;h<s.length;h++){var d=s[h];d==o+\"-Start\"&&(n=h),d==o+\"-End\"&&(l=h)}n>=0&&!t&&(s.splice(n,1),r=!0,l>n&&l--),l>=0&&!a&&(s.splice(l,1),r=!0),n<0&&t&&(s.push(o+\"-Start\"),r=!0),l<0&&a&&(s.push(o+\"-End\"),r=!0),r&&(i=s.join(\" \"),e.attr(\"aria-describedby\",i))}}function D(){this._bMouseMove&&this._unbindMousemove(!0),this.fireSelect()}function f(){if(!this._bNamesLengthChecked){var t,a=this.$().find(\".sapUiCalWH\"),i=this._isMonthNameLong(a),s=0;if(i){this._bLongWeekDays=!1;var o=this._getLocaleData(),r=this._getFirstWeekDay(),n=o.getDaysStandAlone(\"narrow\",this.getPrimaryCalendarType());for(s=0;s<a.length;s++)t=a[s],e(t).text(n[(s+r)%7])}else this._bLongWeekDays=!0;this._bNamesLengthChecked=!0}}function v(){this._sInvalidateMonth=void 0,c.call(this,this._bNoFocus),this._bDateRangeChanged=void 0,this._bNoFocus=void 0}var _=t.extend(\"sap.ui.unified.calendar.Month\",{metadata:{library:\"sap.ui.unified\",properties:{date:{type:\"object\",group:\"Data\"},intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},showHeader:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},firstDayOfWeek:{type:\"int\",group:\"Appearance\",defaultValue:-1},nonWorkingDays:{type:\"int[]\",group:\"Appearance\",defaultValue:null},primaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\"},secondaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\"},width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},showWeekNumbers:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"},disabledDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"disabledDate\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},focus:{parameters:{date:{type:\"object\"},otherMonth:{type:\"boolean\"},restoreOldDate:{type:\"boolean\"}}}}}});return _.prototype.init=function(){var t=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty(\"primaryCalendarType\",t),this.setProperty(\"secondaryCalendarType\",t),this._oFormatYyyymmdd=sap.ui.core.format.DateFormat.getInstance({pattern:\"yyyyMMdd\",calendarType:sap.ui.core.CalendarType.Gregorian}),this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\",calendarType:t}),this._mouseMoveProxy=e.proxy(this._handleMouseMove,this),this._iColumns=7,this._aVisibleDays=[]},_.prototype.exit=function(){this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation),this._sInvalidateMonth&&e.sap.clearDelayedCall(this._sInvalidateMonth),this._aVisibleDays=null},_.prototype.onAfterRendering=function(){l.call(this),f.call(this)},_.prototype.onsapfocusleave=function(t){if(!t.relatedControlId||!e.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(t.relatedControlId).getFocusDomRef())){if(this._bMouseMove){this._unbindMousemove(!0);var a=y.call(this,this._getDate());!a&&this._oMoveSelectedDate&&y.call(this,this._oMoveSelectedDate),this._bMoveChange=!1,this._bMousedownChange=!1,this._oMoveSelectedDate=void 0,D.call(this)}this._bMousedownChange&&(this._bMousedownChange=!1,D.call(this))}},_.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&!this._sInvalidateMonth&&(a&&\"specialDates\"===a.sParentAggregationName&&(this._bNoFocus=!0),this._bInvalidateSync?v.call(this):this._sInvalidateMonth=e.sap.delayedCall(0,this,v,[this])):t.prototype.invalidate.apply(this,arguments)},_.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"selectedDates\");return e},_.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"selectedDates\");return e},_.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"specialDates\");return e},_.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"specialDates\");return e},_.prototype.removeAllDisabledDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"disabledDates\");return e},_.prototype.destroyDisabledDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"disabledDates\");return e},_.prototype.setDate=function(e){var t=r.fromLocalJSDate(e,this.getPrimaryCalendarType());return p.call(this,t,!1),this},_.prototype._setDate=function(e){var t=e.toLocalJSDate();this.setProperty(\"date\",t,!0),this._oDate=e},_.prototype._getDate=function(){return this._oDate||(this._oDate=r.fromLocalJSDate(new Date,this.getPrimaryCalendarType())),this._oDate},_.prototype.displayDate=function(e){var t=r.fromLocalJSDate(e,this.getPrimaryCalendarType());return p.call(this,t,!0),this},_.prototype.setPrimaryCalendarType=function(e){return this.setProperty(\"primaryCalendarType\",e),this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\",calendarType:e}),this._oDate&&(this._oDate=new r(this._oDate,e)),this},_.prototype.setSecondaryCalendarType=function(e){return this._bSecondaryCalendarTypeSet=!0,this.setProperty(\"secondaryCalendarType\",e),this.invalidate(),this._oFormatSecondaryLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\",calendarType:e}),this},_.prototype._getSecondaryCalendarType=function(){var e;if(this._bSecondaryCalendarTypeSet){e=this.getSecondaryCalendarType();var t=this.getPrimaryCalendarType();e==t&&(e=void 0)}return e},_.prototype._getLocale=function(){var e=this.getParent();return e&&e.getLocale?e.getLocale():(this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale)},_.prototype._getLocaleData=function(){var e=this.getParent();if(e&&e._getLocaleData)return e._getLocaleData();if(!this._oLocaleData){var t=this._getLocale(),i=new sap.ui.core.Locale(t);this._oLocaleData=a.getInstance(i)}return this._oLocaleData},_.prototype._getFormatLong=function(){var e=this._getLocale();if(this._oFormatLong.oLocale.toString()!=e){var t=new sap.ui.core.Locale(e);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\",calendarType:this.getPrimaryCalendarType()},t),this._oFormatSecondaryLong&&(this._oFormatSecondaryLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\",calendarType:this._getSecondaryCalendarType()},t))}return this._oFormatLong},_.prototype.getIntervalSelection=function(){var e=this.getParent();return e&&e.getIntervalSelection?e.getIntervalSelection():this.getProperty(\"intervalSelection\")},_.prototype.getSingleSelection=function(){var e=this.getParent();return e&&e.getSingleSelection?e.getSingleSelection():this.getProperty(\"singleSelection\")},_.prototype.getSelectedDates=function(){var e=this.getParent();return e&&e.getSelectedDates?e.getSelectedDates():this.getAggregation(\"selectedDates\",[])},_.prototype.getSpecialDates=function(){var e=this.getParent();return e&&e.getSpecialDates?e.getSpecialDates():this.getAggregation(\"specialDates\",[])},_.prototype.getDisabledDates=function(){var e=this.getParent();return e&&e.getDisabledDates?e.getDisabledDates():this.getAggregation(\"disabledDates\",[])},_.prototype._getShowHeader=function(){var e=this.getParent();return e&&e._getShowMonthHeader?e._getShowMonthHeader():this.getProperty(\"showHeader\")},_.prototype.getAriaLabelledBy=function(){var e=this.getParent();return e&&e.getAriaLabelledBy?e.getAriaLabelledBy():this.getAssociation(\"ariaLabelledBy\",[])},_.prototype.getLegend=function(){var e=this.getParent();return e&&e.getLegend?e.getLegend():this.getAssociation(\"ariaLabelledBy\",[])},_.prototype._getFirstDayOfWeek=function(){var e=this.getParent(),t=0;if(t=e&&e.getFirstDayOfWeek?e.getFirstDayOfWeek():this.getProperty(\"firstDayOfWeek\"),t<0||t>6){var a=this._getLocaleData();t=a.getFirstDayOfWeek()}return t},_.prototype._getNonWorkingDays=function(){var t,a=this.getParent();return t=a&&a.getNonWorkingDays?a.getNonWorkingDays():this.getProperty(\"nonWorkingDays\"),t&&!e.isArray(t)&&(t=[]),t},_.prototype._checkDateSelected=function(e){o._checkCalendarDate(e);for(var t=0,a=this.getSelectedDates(),i=e.toUTCJSDate().getTime(),s=this.getPrimaryCalendarType(),n=0;n<a.length;n++){var l=a[n],h=l.getStartDate(),d=0;h&&(h=r.fromLocalJSDate(h,s),d=h.toUTCJSDate().getTime());var g=l.getEndDate(),p=0;if(g&&(g=r.fromLocalJSDate(g,s),p=g.toUTCJSDate().getTime()),i==d&&!g){t=1;break}if(i==d&&g){t=2,g&&i==p&&(t=5);break}if(g&&i==p){t=3;break}if(g&&i>d&&i<p){t=4;break}if(this.getSingleSelection())break}return t},_.prototype._getDateType=function(e){o._checkCalendarDate(e);for(var t,a=this.getSpecialDates(),i=e.toUTCJSDate().getTime(),s=this.getPrimaryCalendarType(),n=0;n<a.length;n++){var l=a[n],h=l.getStartDate(),d=o.MAX_MILLISECONDS;h&&(h=r.fromLocalJSDate(h,s),d=h.toUTCJSDate().getTime());var g=l.getEndDate(),p=-o.MAX_MILLISECONDS;if(g&&(g=r.fromLocalJSDate(g,s),p=g.toUTCJSDate().getTime()),i==d&&!g||i>=d&&i<=p){t={type:l.getType(),tooltip:l.getTooltip_AsString()};break}}return t},_.prototype._checkDateEnabled=function(e){o._checkCalendarDate(e);var t=!0,a=this.getDisabledDates(),i=e.toUTCJSDate().getTime(),s=this.getPrimaryCalendarType(),n=this.getParent();if(n&&n._oMinDate&&n._oMaxDate&&(i<n._oMinDate.valueOf()||i>n._oMaxDate.valueOf()))return!1;for(var l=0;l<a.length;l++){var h=a[l],d=h.getStartDate(),g=0;d&&(d=r.fromLocalJSDate(d,s),g=d.toUTCJSDate().getTime());var p=h.getEndDate(),c=0;if(p&&(p=r.fromLocalJSDate(p,s),c=p.toUTCJSDate().getTime()),p){if(i>g&&i<c){t=!1;break}}else if(i==g){t=!1;break}}return t},_.prototype.setWidth=function(e){return this.setProperty(\"width\",e,!0),this.getDomRef()&&(e=this.getWidth(),this.$().css(\"width\",e)),this},_.prototype._handleMouseMove=function(t){this.$().is(\":visible\")||this._unbindMousemove(!0);var a=e(t.target);if(a.hasClass(\"sapUiCalItemText\")&&(a=a.parent()),(!this._sLastTargetId||this._sLastTargetId!=a.attr(\"id\"))&&(this._sLastTargetId=a.attr(\"id\"),a.hasClass(\"sapUiCalItem\"))){var i=this._getDate();if(e.sap.containsOrEquals(this.getDomRef(),t.target)){var s=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(a.attr(\"data-sap-day\"),this.getPrimaryCalendarType()));if(!s.isSame(i))if(a.hasClass(\"sapUiCalItemOtherMonth\"))this.fireFocus({date:s.toLocalJSDate(),otherMonth:!0});else{this._setDate(s);var o=y.call(this,s,!0);o&&(this._oMoveSelectedDate=new r(s,this.getPrimaryCalendarType())),this._bMoveChange=!0}}else{var n=this.getSelectedDates();if(n.length>0&&this.getSingleSelection()){var l=n[0].getStartDate();l&&(l=r.fromLocalJSDate(l,this.getPrimaryCalendarType()));var h=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(a.attr(\"data-sap-day\")));h.isSameOrAfter(l)?m.call(this,l,h):m.call(this,h,l)}}}},_.prototype.onmouseup=function(t){if(this._bMouseMove){this._unbindMousemove(!0);for(var a=this._getDate(),i=this._oItemNavigation.getItemDomRefs(),s=0;s<i.length;s++){var o=e(i[s]);if(!o.hasClass(\"sapUiCalItemOtherMonth\")&&o.attr(\"data-sap-day\")==this._oFormatYyyymmdd.format(a.toUTCJSDate(),!0)){o.focus();break}}if(this._bMoveChange){var r=y.call(this,a);!r&&this._oMoveSelectedDate&&y.call(this,this._oMoveSelectedDate),this._bMoveChange=!1,this._bMousedownChange=!1,this._oMoveSelectedDate=void 0,D.call(this)}}this._bMousedownChange&&(this._bMousedownChange=!1,D.call(this))},_.prototype.onsapselect=function(e){var t=y.call(this,this._getDate());t&&D.call(this),e.stopPropagation(),e.preventDefault()},_.prototype.onsapselectmodifiers=function(e){this.onsapselect(e)},_.prototype.onsappageupmodifiers=function(e){var t=new r(this._getDate(),this.getPrimaryCalendarType()),a=t.getYear();e.metaKey||e.ctrlKey?t.setYear(a-10):t.setYear(a-1),this.fireFocus({date:t.toLocalJSDate(),otherMonth:!0}),e.preventDefault()},_.prototype.onsappagedownmodifiers=function(e){var t=new r(this._getDate(),this.getPrimaryCalendarType()),a=t.getYear();e.metaKey||e.ctrlKey?t.setYear(a+10):t.setYear(a+1),this.fireFocus({date:t.toLocalJSDate(),otherMonth:!0}),e.preventDefault()},_.prototype._updateSelection=function(){var e=this.getSelectedDates();if(e.length>0){var t=this.getPrimaryCalendarType(),a=e.map(function(e){var a=e.getStartDate();if(a)return r.fromLocalJSDate(a,t)}),i=e[0].getEndDate();i&&(i=r.fromLocalJSDate(i,t)),m.call(this,a,i)}},_.prototype._bindMousemove=function(t){e(window.document).bind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=!0,t&&this.fireEvent(\"_bindMousemove\")},_.prototype._unbindMousemove=function(t){e(window.document).unbind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=void 0,this._sLastTargetId=void 0,t&&this.fireEvent(\"_unbindMousemove\")},_.prototype.onThemeChanged=function(){if(!this._bNoThemeChange){this._bNamesLengthChecked=void 0,this._bLongWeekDays=void 0;for(var t=this.$().find(\".sapUiCalWH\"),a=this._getLocaleData(),i=this._getFirstWeekDay(),s=a.getDaysStandAlone(\"abbreviated\",this.getPrimaryCalendarType()),o=0;o<t.length;o++){var r=t[o];e(r).text(s[(o+i)%7])}f.call(this)}},_.prototype._handleBorderReached=function(t){var a=t.getParameter(\"event\"),i=0,s=this._getDate(),o=new r(s,this.getPrimaryCalendarType());if(a.type){switch(a.type){case\"sapnext\":case\"sapnextmodifiers\":a.keyCode==e.sap.KeyCodes.ARROW_DOWN?o.setDate(o.getDate()+7):o.setDate(o.getDate()+1);break;case\"sapprevious\":case\"sappreviousmodifiers\":a.keyCode==e.sap.KeyCodes.ARROW_UP?o.setDate(o.getDate()-7):o.setDate(o.getDate()-1);break;case\"sappagedown\":if(i=o.getMonth()+1,o.setMonth(i),i%12!=o.getMonth())for(;i!=o.getMonth();)o.setDate(o.getDate()-1);break;case\"sappageup\":if(i=o.getMonth()-1,o.setMonth(i),i<0&&(i=11),i!=o.getMonth())for(;i!=o.getMonth();)o.setDate(o.getDate()-1)}this.fireFocus({date:o.toLocalJSDate(),otherMonth:!0})}},_.prototype.checkDateFocusable=function(e){o._checkJSDateObject(e);var t=this._getDate(),a=r.fromLocalJSDate(e,this.getPrimaryCalendarType());return o._isSameMonthAndYear(a,t)},_.prototype.applyFocusInfo=function(e){return this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex()),this},_.prototype._renderHeader=function(){if(this._getShowHeader()){var e=this._getDate(),t=this._getLocaleData(),a=t.getMonthsStandAlone(\"wide\",this.getPrimaryCalendarType());this.$(\"Head\").text(a[e.getMonth()])}},_.prototype._getFirstWeekDay=function(){return this._getFirstDayOfWeek()},_.prototype._isMonthNameLong=function(e){var t,a;for(t=0;t<e.length;t++)if(a=e[t],Math.abs(a.clientWidth-a.scrollWidth)>1)return!0;return!1},_.prototype.selectDay=function(e){y.call(this,e)},_.prototype._getVisibleDays=function(e,t){var a,i,s,o,n,l,h;if(!e)return this._aVisibleDays;this._aVisibleDays=[],l=this._getFirstDayOfWeek(),n=new r(e,this.getPrimaryCalendarType()),n.setDate(1),o=n.getDay()-l,o<0&&(o=7+o),o>0&&n.setDate(1-o),i=new r(n),a=(e.getMonth()+1)%12;do h=i.getYear(),s=new r(i,this.getPrimaryCalendarType()),t&&h<1?(s._bBeforeFirstYear=!0,this._aVisibleDays.push(s)):h>0&&h<1e4&&this._aVisibleDays.push(s),i.setDate(i.getDate()+1);while(i.getMonth()!==a||i.getDay()!==l);return this._aVisibleDays},_.prototype._focusDate=function(t,a,i){a||this.setDate(t.toLocalJSDate());for(var s,o=this._oFormatYyyymmdd.format(t.toUTCJSDate(),!0),r=this._oItemNavigation.getItemDomRefs(),n=0;n<r.length;n++)if(s=e(r[n]),s.attr(\"data-sap-day\")==o){document.activeElement!=r[n]&&(i?this._oItemNavigation.setFocusedIndex(n):this._oItemNavigation.focusItem(n));break}},_},!0);",
		"sap/ui/unified/calendar/MonthPicker.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/unified/library\"],function(t,e,a,i,s){\"use strict\";function o(){var t=this.getDomRef(),e=this.$().find(\".sapUiCalItem\"),a=this.getColumns(),s=this.getMonths(),o=!0;s<12&&(o=!1),this._oItemNavigation||(this._oItemNavigation=new i,this._oItemNavigation.attachEvent(i.Events.AfterFocus,n,this),this._oItemNavigation.attachEvent(i.Events.FocusAgain,h,this),this._oItemNavigation.attachEvent(i.Events.BorderReached,l,this),this.addDelegate(this._oItemNavigation),this._oItemNavigation.setHomeEndColumnMode(!0,!0),this._oItemNavigation.setDisabledModifiers({sapnext:[\"alt\"],sapprevious:[\"alt\"],saphome:[\"alt\"],sapend:[\"alt\"]})),this._oItemNavigation.setRootDomRef(t),this._oItemNavigation.setItemDomRefs(e),this._oItemNavigation.setCycling(o),this._oItemNavigation.setColumns(a,!o);var r=this.getMonth()-this.getStartMonth();this._oItemNavigation.setFocusedIndex(r),this._oItemNavigation.setPageSize(e.length)}function n(t){var e=t.getParameter(\"index\"),a=t.getParameter(\"event\");a&&\"mousedown\"==a.type&&r.call(this,a,e)}function h(t){var e=t.getParameter(\"index\"),a=t.getParameter(\"event\");a&&\"mousedown\"==a.type&&r.call(this,a,e)}function r(t,e){if(!t.button){var a=e+this.getStartMonth();a>=this._iMinMonth&&a<=this._iMaxMonth&&(g.call(this,a),this._bMousedownChange=!0),t.preventDefault(),t.setMark(\"cancelAutoClose\")}}function l(t){var e=t.getParameter(\"event\");if(e.type){var a=this.getStartMonth(),i=this._oItemNavigation.getFocusedIndex(),s=i+a,o=this.getMonths();switch(e.type){case\"sapnext\":case\"sapnextmodifiers\":s<11&&(s++,p.call(this,s,!0));break;case\"sapprevious\":case\"sappreviousmodifiers\":s>0&&(s--,p.call(this,s,!0));break;case\"sappagedown\":s<12-o&&(s+=o,p.call(this,s,!0));break;case\"sappageup\":s>o&&(s-=o,p.call(this,s,!0))}}}function g(e,a){for(var i,s=this._oItemNavigation.getItemDomRefs(),o=this.getId()+\"-m\"+e,n=0;n<s.length;n++)i=t(s[n]),i.attr(\"id\")==o?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\")):(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\"));a||this.setProperty(\"month\",e,!0)}function c(){if(!this._bNamesLengthChecked){for(var e=0,a=this._oItemNavigation.getItemDomRefs(),i=!1,s=this.getMonths(),o=Math.ceil(12/s),n=s-1,h=0;h<o;h++){for(s<12&&(p.call(this,n),n+=s,n>11&&(n=11)),e=0;e<a.length;e++){var r=a[e];if(Math.abs(r.clientWidth-r.scrollWidth)>1){i=!0;break}}if(i)break}if(s<12&&(n=this.getMonth(),p.call(this,n)),i){this._bLongMonth=!1;var l=this._getLocaleData(),g=this.getPrimaryCalendarType(),c=l.getMonthsStandAlone(\"abbreviated\",g),m=l.getMonthsStandAlone(\"wide\",g);for(e=0;e<a.length;e++){var d=t(a[e]);d.text(c[e]),d.attr(\"aria-label\",m[e])}}else this._bLongMonth=!0;this._bNamesLengthChecked=!0}}function p(e,a){var i=this._oItemNavigation.getItemDomRefs();if(!(i.legth>11)){var s=i.length,o=Math.floor(e/s)*s;o+s>12&&(o=12-s);var n=this._getLocaleData(),h=[],r=[],l=this.getPrimaryCalendarType();this._bLongMonth||!this._bNamesLengthChecked?h=n.getMonthsStandAlone(\"wide\",l):(h=n.getMonthsStandAlone(\"abbreviated\",l),r=n.getMonthsStandAlone(\"wide\",l));for(var g=this.getMonth(),c=0;c<i.length;c++){var p=c+o,m=t(i[c]);m.text(h[c+o]),m.attr(\"id\",this.getId()+\"-m\"+(c+o)),this._bLongMonth||m.attr(\"aria-label\",r[c+o]),p==g?(m.addClass(\"sapUiCalItemSel\"),m.attr(\"aria-selected\",\"true\")):(m.removeClass(\"sapUiCalItemSel\"),m.attr(\"aria-selected\",\"false\")),p<this._iMinMonth||p>this._iMaxMonth?(m.addClass(\"sapUiCalItemDsbl\"),m.attr(\"aria-disabled\",!0)):(m.removeClass(\"sapUiCalItemDsbl\"),m.removeAttr(\"aria-disabled\"))}this._oItemNavigation.focusItem(e-o),a&&this.firePageChange()}}var m=e.extend(\"sap.ui.unified.calendar.MonthPicker\",{metadata:{library:\"sap.ui.unified\",properties:{month:{type:\"int\",group:\"Data\",defaultValue:0},months:{type:\"int\",group:\"Appearance\",defaultValue:12},columns:{type:\"int\",group:\"Appearance\",defaultValue:3},primaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\"}},events:{select:{},pageChange:{}}}});return m.prototype.init=function(){var t=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty(\"primaryCalendarType\",t),this._iMinMonth=0,this._iMaxMonth=11},m.prototype.onAfterRendering=function(){o.call(this),c.call(this)},m.prototype.setMonth=function(t){if(this.setProperty(\"month\",t,!0),t=this.getProperty(\"month\"),t<0||t>11)throw new Error(\"Property month must be between 0 and 11; \"+this);if(this.getDomRef())if(this.getMonths()<12){var e=this.getStartMonth();t>=e&&t<=e+this.getMonths()-1?(g.call(this,t,!0),this._oItemNavigation.focusItem(t-e)):p.call(this,t)}else g.call(this,t,!0),this._oItemNavigation.focusItem(t);return this},m.prototype._getLocale=function(){var t=this.getParent();return t&&t._getLocale?t._getLocale():(this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale)},m.prototype._getLocaleData=function(){var t=this.getParent();if(t&&t._getLocaleData)return t._getLocaleData();if(!this._oLocaleData){var e=this._getLocale(),i=new sap.ui.core.Locale(e);this._oLocaleData=a.getInstance(i)}return this._oLocaleData},m.prototype.onsapspace=function(t){t.preventDefault()},m.prototype.onsapselect=function(t){var e=this._oItemNavigation.getFocusedIndex(),a=e+this.getStartMonth();a>=this._iMinMonth&&a<=this._iMaxMonth&&(g.call(this,a),this.fireSelect())},m.prototype.onmouseup=function(t){this._bMousedownChange&&(this._bMousedownChange=!1,this.fireSelect())},m.prototype.onThemeChanged=function(){if(!this._bNoThemeChange&&this.getDomRef()){this._bNamesLengthChecked=void 0;var e=this._oItemNavigation.getItemDomRefs();this._bLongMonth=!1;for(var a=this._getLocaleData(),i=a.getMonthsStandAlone(\"wide\",this.getPrimaryCalendarType()),s=0;s<e.length;s++){var o=t(e[s]);o.text(i[s])}c.call(this)}},m.prototype.nextPage=function(){var t=this.getStartMonth(),e=this._oItemNavigation.getFocusedIndex(),a=e+t,i=this.getMonths();return a+=i,a>11&&(a=11),p.call(this,a),this},m.prototype.previousPage=function(){var t=this.getStartMonth(),e=this._oItemNavigation.getFocusedIndex(),a=e+t,i=this.getMonths();return a-=i,a<0&&(a=0),p.call(this,a),this},m.prototype.setMinMax=function(e,a){if(e==this._iMinMonth&&a==this._iMaxMonth)return this;if(e=parseInt(e,10),(isNaN(e)||e<0||e>11)&&(e=0),a=parseInt(a,10),(isNaN(a)||a<0||a>11)&&(a=11),e<=a?(this._iMinMonth=e,this._iMaxMonth=a):(this._iMaxMonth=e,this._iMinMonth=a),this.getDomRef())for(var i=this._oItemNavigation.getItemDomRefs(),s=this.getId().length+2,o=0;o<i.length;o++){var n=t(i[o]),h=parseInt(n.attr(\"id\").slice(s),10);h<this._iMinMonth||h>this._iMaxMonth?(n.addClass(\"sapUiCalItemDsbl\"),n.attr(\"aria-disabled\",!0)):(n.removeClass(\"sapUiCalItemDsbl\"),n.removeAttr(\"aria-disabled\"))}return this},m.prototype.getStartMonth=function(){if(this.getMonths()<12){var t=this._oItemNavigation.getItemDomRefs()[0];return parseInt(t.id.slice(this.getId().length+2),10)}return 0},m},!0);",
		"sap/ui/unified/calendar/MonthPickerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var i=t.getMonth(),a=t.getMonths(),r=0,l=t.getColumns(),s=t.getTooltip_AsString(),d=t._getLocaleData(),n=t.getId(),o=\"\",w=[],b=[],c=t.getPrimaryCalendarType();t._bLongMonth||!t._bNamesLengthChecked?w=d.getMonthsStandAlone(\"wide\",c):(w=d.getMonthsStandAlone(\"abbreviated\",c),b=d.getMonthsStandAlone(\"wide\",c)),e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiCalMonthPicker\"),e.writeClasses(),s&&e.writeAttributeEscaped(\"title\",s),e.writeAccessibilityState(t,{role:\"grid\",readonly:\"true\",multiselectable:\"false\"}),e.write(\">\");var g;a>12?a=12:a<12&&(r=Math.floor(i/a)*a,r+a>12&&(r=12-a)),o=l>0?100/l+\"%\":100/a+\"%\";for(var h=0;h<a;h++){var C=h+r;g={role:\"gridcell\"},!t._bLongMonth&&t._bNamesLengthChecked&&(g.label=b[C]),l>0&&h%l==0&&(e.write(\"<div\"),e.writeAccessibilityState(null,{role:\"row\"}),e.write(\">\")),e.write(\"<div\"),e.writeAttribute(\"id\",n+\"-m\"+C),e.addClass(\"sapUiCalItem\"),C==i?(e.addClass(\"sapUiCalItemSel\"),g.selected=!0):g.selected=!1,(C<t._iMinMonth||C>t._iMaxMonth)&&(e.addClass(\"sapUiCalItemDsbl\"),g.disabled=!0),e.writeAttribute(\"tabindex\",\"-1\"),e.addStyle(\"width\",o),e.writeClasses(),e.writeStyles(),e.writeAccessibilityState(null,g),e.write(\">\"),e.write(w[C]),e.write(\"</div>\"),l>0&&(h+1)%l==0&&e.write(\"</div>\")}e.write(\"</div>\")},t},!0);",
		"sap/ui/unified/calendar/MonthRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/unified/CalendarLegend\"],function(e,a,t,i){\"use strict\";var r={};return r.render=function(e,a){var t=this.getStartDate(a),i=a.getTooltip_AsString(),r=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),d=a.getId(),s={value:d+\"-Descr\",append:!0},n=a.getWidth();e.write(\"<div\"),e.writeControlData(a),e.addClass(this.getClass(a)),a._getSecondaryCalendarType()&&e.addClass(\"sapUiCalMonthSecType\"),e.writeClasses(),i&&e.writeAttributeEscaped(\"title\",i),a._getShowHeader()&&(s.value=s.value+\" \"+d+\"-Head\"),n&&(e.addStyle(\"width\",n),e.writeStyles()),e.writeAccessibilityState(a,{role:sap.ui.Device.browser.chrome?\"\":\"grid\",readonly:\"true\",multiselectable:!a.getSingleSelection()||a.getIntervalSelection(),labelledby:s}),e.write(\">\"),e.write('<span id=\"'+d+'-Descr\" style=\"display: none;\">'+r.getText(\"CALENDAR_DIALOG\")+\"</span>\"),a.getIntervalSelection()&&(e.write('<span id=\"'+d+'-Start\" style=\"display: none;\">'+r.getText(\"CALENDAR_START_DATE\")+\"</span>\"),e.write('<span id=\"'+d+'-End\" style=\"display: none;\">'+r.getText(\"CALENDAR_END_DATE\")+\"</span>\")),this.renderMonth(e,a,t),e.write(\"</div>\")},r.getStartDate=function(e){return e._getDate()},r.getClass=function(e){var a=\"sapUiCalMonthView\",t=e.getPrimaryCalendarType(),i=e.getShowWeekNumbers();return t!=sap.ui.core.CalendarType.Islamic&&i||(a+=\" sapUiCalNoWeekNum\"),a},r.renderMonth=function(e,a,t){var i=a.getId();this.renderHeader(e,a,t),e.write('<div id=\"'+i+'-days\" class=\"sapUiCalItems\">'),this.renderDays(e,a,t),e.write(\"</div>\")},r.renderHeader=function(e,a,t){var i=a._getLocaleData(),r=a._getFirstDayOfWeek(),d=a.getId(),s=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\");this.renderHeaderLine(e,a,i,t),e.write(\"<div\"),e.writeAttribute(\"id\",d+\"-CW\"),e.addStyle(\"display\",\"none\"),e.writeStyles(),sap.ui.Device.browser.chrome&&e.writeAccessibilityState(null,{role:\"columnheader\"}),e.write(\">\"),e.write(s.getText(\"CALENDAR_WEEK\")),e.write(\"</div>\"),e.write(\"<div\"),sap.ui.Device.browser.chrome&&e.writeAccessibilityState(null,{role:\"row\"}),e.write(\">\"),this.renderDayNames(e,a,i,r,7,!0,void 0),e.write(\"</div>\")},r.renderHeaderLine=function(e,t,i,r){if(a._checkCalendarDate(r),t._getShowHeader()){var d=t.getId(),s=t.getPrimaryCalendarType(),n=i.getMonthsStandAlone(\"wide\",s);e.write('<div id=\"'+d+'-Head\"class=\"sapUiCalHeadText\" >'),e.write(n[r.getMonth()]),e.write(\"</div>\")}},r.renderDayNames=function(e,a,t,i,r,d,s){var n=a._getFirstDayOfWeek(),l=a.getId(),o=\"\",y=a.getPrimaryCalendarType(),c=[];c=a._bLongWeekDays||!a._bNamesLengthChecked?t.getDaysStandAlone(\"short\",y):t.getDaysStandAlone(\"narrow\",y);for(var g=t.getDaysStandAlone(\"wide\",y),p=0;p<r;p++)e.write(\"<div\"),e.addClass(\"sapUiCalWH\"),o=d?l+\"-WH\"+(p+n)%7:l+\"-WH\"+p,e.writeAttribute(\"id\",o),0==p&&e.addClass(\"sapUiCalFirstWDay\"),s&&e.addStyle(\"width\",s),sap.ui.Device.browser.chrome?e.writeAccessibilityState(null,{label:g[(p+i)%7]}):e.writeAccessibilityState(null,{role:\"columnheader\",label:g[(p+i)%7]}),e.writeClasses(),e.writeStyles(),e.write(\">\"),e.write(c[(p+i)%7]),e.write(\"</div>\")},r.renderDays=function(e,t,i){var r,d,s,n,l,o,y;if(a._checkCalendarDate(i),i||(i=t._getFocusedDate()),o=i.toUTCJSDate().getTime(),!o&&0!==o)throw new Error(\"Date is invalid \"+t);for(n=this.getDayHelper(t,i),d=t._getVisibleDays(i,!0),y=t.getShowWeekNumbers(),r=t.getPrimaryCalendarType()!==sap.ui.core.CalendarType.Islamic&&y,s=d.length,l=0;l<s;l++)this.renderDay(e,t,d[l],n,!0,r,-1)},r.getDayHelper=function(a,r){var d,s,n=a._getLocaleData(),l={sLocale:a._getLocale(),oLocaleData:n,iMonth:r.getMonth(),iYear:r.getYear(),iFirstDayOfWeek:a._getFirstDayOfWeek(),iWeekendStart:n.getWeekendStart(),iWeekendEnd:n.getWeekendEnd(),aNonWorkingDays:a._getNonWorkingDays(),sToday:n.getRelativeDay(0),oToday:t.fromLocalJSDate(new Date,a.getPrimaryCalendarType()),sId:a.getId(),oFormatLong:a._getFormatLong(),sSecondaryCalendarType:a._getSecondaryCalendarType(),oLegend:void 0};if(s=a.getLegend(),s&&\"string\"==typeof s)if(d=sap.ui.getCore().byId(s)){if(!(d instanceof i))throw new Error(d+\" is not an sap.ui.unified.CalendarLegend. \"+a);l.oLegend=d}else e.sap.log.warning(\"CalendarLegend \"+s+\" does not exist!\",a);return l},r.renderDay=function(e,r,d,s,n,l,o,y,c){a._checkCalendarDate(d);var g=new t(d,s.sSecondaryCalendarType),p={role:sap.ui.Device.browser.chrome?\"\":\"gridcell\",selected:!1,label:\"\",describedby:\"\"},C=d._bBeforeFirstYear,w=r._oFormatYyyymmdd.format(d.toUTCJSDate(),!0),u=d.getDay(),b=r._checkDateSelected(d),D=r._getDateType(d),S=r._checkDateEnabled(d),m=0;C&&(S=!1);var h=0;if(l&&(h=a.calculateWeekNumber(d.toUTCJSDate(),s.iYear,s.sLocale,s.oLocaleData),p.describedby=s.sId+\"-CW \"+s.sId+\"-WNum-\"+h),!c){var W=\"\";W=o<0?s.sId+\"-WH\"+u:s.sId+\"-WH\"+o,p.describedby=p.describedby+\" \"+W}if(e.write(\"<div\"),e.writeAttribute(\"id\",s.sId+\"-\"+w),e.addClass(\"sapUiCalItem\"),e.addClass(\"sapUiCalWDay\"+u),y&&e.addStyle(\"width\",y),u==s.iFirstDayOfWeek&&e.addClass(\"sapUiCalFirstWDay\"),n&&s.iMonth!=d.getMonth()&&(e.addClass(\"sapUiCalItemOtherMonth\"),p.disabled=!0),d.isSame(s.oToday)&&(e.addClass(\"sapUiCalItemNow\"),p.label=s.sToday+\" \"),b>0?(e.addClass(\"sapUiCalItemSel\"),p.selected=!0):p.selected=!1,2==b?(e.addClass(\"sapUiCalItemSelStart\"),p.describedby=p.describedby+\" \"+s.sId+\"-Start\"):3==b?(e.addClass(\"sapUiCalItemSelEnd\"),p.describedby=p.describedby+\" \"+s.sId+\"-End\"):4==b?e.addClass(\"sapUiCalItemSelBetween\"):5==b&&(e.addClass(\"sapUiCalItemSelStart\"),e.addClass(\"sapUiCalItemSelEnd\"),p.describedby=p.describedby+\" \"+s.sId+\"-Start\",p.describedby=p.describedby+\" \"+s.sId+\"-End\"),D&&D.type!=sap.ui.unified.CalendarDayType.None&&(D.type===sap.ui.unified.CalendarDayType.NonWorking?e.addClass(\"sasUiCalItemNonWorkday\"):(e.addClass(\"sapUiCalItem\"+D.type),D.tooltip&&e.writeAttributeEscaped(\"title\",D.tooltip))),r.getParent()&&\"CalendarOneMonthInterval\"===r.getParent().getMetadata().getName()&&d.getMonth()!==r.getStartDate().getMonth()&&e.addClass(\"sapUiCalItemOtherMonth\"),S||(e.addClass(\"sapUiCalItemDsbl\"),p.disabled=!0),s.aNonWorkingDays){for(m=0;m<s.aNonWorkingDays.length;m++)if(u==s.aNonWorkingDays[m]){e.addClass(\"sasUiCalItemNonWorkday\");break}}else(u>=s.iWeekendStart&&u<=s.iWeekendEnd||s.iWeekendEnd<s.iWeekendStart&&(u>=s.iWeekendStart||u<=s.iWeekendEnd))&&this.addWeekendStyle(e,r);if(e.writeAttribute(\"tabindex\",\"-1\"),e.writeAttribute(\"data-sap-day\",w),c&&(p.label=p.label+s.aWeekDaysWide[u]+\" \"),p.label=p.label+s.oFormatLong.format(d.toUTCJSDate(),!0),D&&D.type!=sap.ui.unified.CalendarDayType.None){var f,I;if(s.oLegend){var v=s.oLegend._getItemByType(D.type);v&&(f=v.getId()+\"-Text\")}f||(I=i.getTypeAriaText(D.type),I&&(f=I.getId())),f&&(p.describedby+=\" \"+f)}s.sSecondaryCalendarType&&(p.label=p.label+\" \"+r._oFormatSecondaryLong.format(g.toUTCJSDate(),!0)),e.writeAccessibilityState(null,p),e.writeClasses(),e.writeStyles(),e.write(\">\"),e.write(\"<span\"),e.writeAttribute(\"id\",s.sId+\"-\"+w+\"-span\"),e.addClass(\"sapUiCalItemText\"),e.writeClasses(),e.write(\">\"),C||e.write(d.getDate()),e.write(\"</span>\"),l&&u==s.iFirstDayOfWeek&&(e.write(\"<span\"),e.writeAttribute(\"id\",s.sId+\"-WNum-\"+h),e.addClass(\"sapUiCalWeekNum\"),e.writeClasses(),sap.ui.Device.browser.chrome?e.writeAccessibilityState(null,{desribedby:s.sId+\"-CW\"}):e.writeAccessibilityState(null,{role:\"rowheader\",desribedby:s.sId+\"-CW\"}),e.write(\">\"),e.write(h),e.write(\"</span>\")),c&&(e.write(\"<span\"),e.addClass(\"sapUiCalDayName\"),e.writeClasses(),e.write(\">\"),e.write(s.aWeekDays[u]),e.write(\"</span>\")),s.sSecondaryCalendarType&&(e.write(\"<span\"),e.addClass(\"sapUiCalItemSecText\"),e.writeClasses(),e.write(\">\"),e.write(g.getDate()),e.write(\"</span>\")),e.write(\"</div>\")},r.addWeekendStyle=function(e,a){e.addClass(\"sapUiCalItemWeekEnd\")},r},!0);",
		"sap/ui/unified/calendar/MonthsRow.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/unified/library\"],function(t,e,a,s,i,o,n,r){\"use strict\";function l(){for(var e=this._getDate(),a=this._oFormatYyyymm.format(e.toUTCJSDate(),!0),i=0,o=this.$(\"months\").get(0),n=this.$(\"months\").children(\".sapUiCalItem\"),r=0;r<n.length;r++){var l=t(n[r]);if(l.attr(\"data-sap-month\")===a){i=r;break}}this._oItemNavigation||(this._oItemNavigation=new s,this._oItemNavigation.attachEvent(s.Events.AfterFocus,h,this),this._oItemNavigation.attachEvent(s.Events.FocusAgain,c,this),this._oItemNavigation.attachEvent(s.Events.BorderReached,g,this),this.addDelegate(this._oItemNavigation),this._oItemNavigation.setDisabledModifiers({sapnext:[\"alt\"],sapprevious:[\"alt\"],saphome:[\"alt\"],sapend:[\"alt\"]}),this._oItemNavigation.setCycling(!1),this._oItemNavigation.setColumns(1,!0)),this._oItemNavigation.setRootDomRef(o),this._oItemNavigation.setItemDomRefs(n),this._oItemNavigation.setFocusedIndex(i),this._oItemNavigation.setPageSize(n.length)}function h(e){var a=e.getParameter(\"index\"),s=e.getParameter(\"event\");if(s){var i=this._getDate(),o=new n(i),r=this._oItemNavigation.getItemDomRefs(),l=t(r[a]);o=n.fromLocalJSDate(this._oFormatYyyymm.parse(l.attr(\"data-sap-month\"))),o.setDate(1),this._setDate(o),this.fireFocus({date:o.toLocalJSDate(),notVisible:!1}),\"mousedown\"==s.type&&p.call(this,s,o,a)}}function c(t){var e=t.getParameter(\"index\"),a=t.getParameter(\"event\");if(a&&\"mousedown\"==a.type){var s=this._getDate();p.call(this,a,s,e)}}function g(t){var e=t.getParameter(\"event\"),a=this.getMonths(),s=this._getDate(),i=new n(s);if(e.type){switch(e.type){case\"sapnext\":case\"sapnextmodifiers\":i.setMonth(i.getMonth()+1);break;case\"sapprevious\":case\"sappreviousmodifiers\":i.setMonth(i.getMonth()-1);break;case\"sappagedown\":i.setMonth(i.getMonth()+a);break;case\"sappageup\":i.setMonth(i.getMonth()-a)}this.fireFocus({date:i.toLocalJSDate(),notVisible:!0})}}function p(t,e,a){if(!t.button){var s=f.call(this,e);s&&(this._bMousedownChange=!0),this._bMouseMove?(b.call(this,!0),this._bMoveChange=!1):s&&this.getIntervalSelection()&&this.$().is(\":visible\")&&I.call(this,!0),t.preventDefault(),t.setMark(\"cancelAutoClose\")}}function d(t,e){o._checkCalendarDate(t);var a=t.getYear();o._checkYearInValidRange(a);var s=!0;if(!this.getDate()||!t.isSame(n.fromLocalJSDate(this.getDate()))){var i=new n(t);if(i.setDate(1),s=this.checkDateFocusable(t.toLocalJSDate()),!this._bNoRangeCheck&&!s)throw new Error(\"Date must be in visible date range; \"+this);this.setProperty(\"date\",t.toLocalJSDate(),!0),this._oDate=i}this.getDomRef()&&(s?m.call(this,this._oDate,e):u.call(this,e))}function m(e,a){for(var s,i=this._oFormatYyyymm.format(e.toUTCJSDate(),!0),o=this._oItemNavigation.getItemDomRefs(),n=0;n<o.length;n++)if(s=t(o[n]),s.attr(\"data-sap-month\")==i){document.activeElement!=o[n]&&(a?this._oItemNavigation.setFocusedIndex(n):this._oItemNavigation.focusItem(n));break}}function u(t){var e=this._getStartDate(),a=this.$(\"months\");if(a.length>0){var s=sap.ui.getCore().createRenderManager();this.getRenderer().renderMonths(s,this,e),s.flush(a[0]),s.destroy()}D.call(this),l.call(this),t||this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex())}function D(){var t=this._getStartDate();if(this._getShowHeader()){var e=this.$(\"Head\");if(e.length>0){var a=this._getLocaleData(),s=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(s,this,a,t),s.flush(e[0]),s.destroy()}}}function f(e,a){if(!this._checkMonthEnabled(e))return!1;var s,i,o,r,l=this.getSelectedDates(),h=this._oItemNavigation.getItemDomRefs(),c=0,g=this.getParent(),p=this;if(g&&g.getSelectedDates&&(p=g),this.getSingleSelection())if(l.length>0?(s=l[0],r=s.getStartDate(),r&&(r=n.fromLocalJSDate(r),r.setDate(1))):(s=new sap.ui.unified.DateRange,p.addAggregation(\"selectedDates\",s,!0)),this.getIntervalSelection()&&(!s.getEndDate()||a)&&r){var d;e.isBefore(r)?(d=r,r=e,a||(s.setProperty(\"startDate\",r.toLocalJSDate(),!0),s.setProperty(\"endDate\",d.toLocalJSDate(),!0))):e.isSameOrAfter(r)&&(d=e,a||s.setProperty(\"endDate\",d.toLocalJSDate(),!0)),v.call(this,r,d)}else v.call(this,e),s.setProperty(\"startDate\",e.toLocalJSDate(),!0),s.setProperty(\"endDate\",void 0,!0);else{if(this.getIntervalSelection())throw new Error(\"Calender don't support multiple interval selection\");var m=this._checkDateSelected(e);if(m>0){for(c=0;c<l.length;c++)if(r=l[c].getStartDate(),r&&(r=n.fromLocalJSDate(r),r.setDate(1),e.isSame(r))){p.removeAggregation(\"selectedDates\",c,!0);break}}else s=new sap.ui.unified.DateRange({startDate:e.toLocalJSDate()}),p.addAggregation(\"selectedDates\",s,!0);for(o=this._oFormatYyyymm.format(e.toUTCJSDate(),!0),c=0;c<h.length;c++)i=t(h[c]),i.attr(\"data-sap-month\")==o&&(m>0?(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\")):(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\")))}return!0}function v(e,a){var s,i=this._oItemNavigation.getItemDomRefs(),r=0,l=!1,h=!1;if(a){var c;for(r=0;r<i.length;r++)s=t(i[r]),l=!1,h=!1,c=n.fromLocalJSDate(this._oFormatYyyymm.parse(s.attr(\"data-sap-month\"))),c.setDate(1),c.isSame(e)?(s.addClass(\"sapUiCalItemSelStart\"),l=!0,s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\"),a&&c.isSame(a)&&(s.addClass(\"sapUiCalItemSelEnd\"),h=!0),s.removeClass(\"sapUiCalItemSelBetween\")):a&&o._isBetween(c,e,a)?(s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\"),s.addClass(\"sapUiCalItemSelBetween\"),s.removeClass(\"sapUiCalItemSelStart\"),s.removeClass(\"sapUiCalItemSelEnd\")):a&&c.isSame(a)?(s.addClass(\"sapUiCalItemSelEnd\"),h=!0,s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\"),s.removeClass(\"sapUiCalItemSelStart\"),s.removeClass(\"sapUiCalItemSelBetween\")):(s.hasClass(\"sapUiCalItemSel\")&&(s.removeClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"false\")),s.hasClass(\"sapUiCalItemSelStart\")?s.removeClass(\"sapUiCalItemSelStart\"):s.hasClass(\"sapUiCalItemSelBetween\")?s.removeClass(\"sapUiCalItemSelBetween\"):s.hasClass(\"sapUiCalItemSelEnd\")&&s.removeClass(\"sapUiCalItemSelEnd\")),_.call(this,s,l,h)}else{var g=this._oFormatYyyymm.format(e.toUTCJSDate(),!0);for(r=0;r<i.length;r++)s=t(i[r]),l=!1,h=!1,s.attr(\"data-sap-month\")==g?(s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\"),l=!0):s.hasClass(\"sapUiCalItemSel\")&&(s.removeClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"false\")),s.hasClass(\"sapUiCalItemSelStart\")?s.removeClass(\"sapUiCalItemSelStart\"):s.hasClass(\"sapUiCalItemSelBetween\")?s.removeClass(\"sapUiCalItemSelBetween\"):s.hasClass(\"sapUiCalItemSelEnd\")&&s.removeClass(\"sapUiCalItemSelEnd\"),_.call(this,s,l,h)}}function _(t,e,a){if(this.getIntervalSelection()){var s=\"\",i=[],o=this.getId(),n=!1;s=t.attr(\"aria-describedby\"),s&&(i=s.split(\" \"));for(var r=-1,l=-1,h=0;h<i.length;h++){var c=i[h];c==o+\"-Start\"&&(r=h),c==o+\"-End\"&&(l=h)}r>=0&&!e&&(i.splice(r,1),n=!0,l>r&&l--),l>=0&&!a&&(i.splice(l,1),n=!0),r<0&&e&&(i.push(o+\"-Start\"),n=!0),l<0&&a&&(i.push(o+\"-End\"),n=!0),n&&(s=i.join(\" \"),t.attr(\"aria-describedby\",s))}}function S(){this._bMouseMove&&b.call(this,!0),this.fireSelect()}function y(){if(!this._bNamesLengthChecked){for(var e,a=0,s=this.$(\"months\").children(),i=!1,o=this.getMonths(),n=Math.ceil(12/o),r=0,l=this._getLocaleData(),h=l.getMonthsStandAlone(\"wide\"),c=0;c<n;c++){if(o<12){for(a=0;a<s.length;a++)e=t(t(s[a]).children(\".sapUiCalItemText\")),e.text(h[(a+r)%12]);r+=o,r>11&&(r=11)}for(a=0;a<s.length;a++){var g=s[a];if(Math.abs(g.clientWidth-g.scrollWidth)>1){i=!0;break}}if(i)break}if(o<12)for(r=this._getStartDate().getMonth(),a=0;a<s.length;a++)e=t(t(s[a]).children(\".sapUiCalItemText\")),e.text(h[(a+r)%12]);if(i){this._bLongMonth=!1;var p=l.getMonthsStandAlone(\"abbreviated\");for(r=this._getStartDate().getMonth(),a=0;a<s.length;a++)e=t(t(s[a]).children(\".sapUiCalItemText\")),e.text(p[(a+r)%12])}else this._bLongMonth=!0;this._bNamesLengthChecked=!0}}function C(){this._sInvalidateMonths=void 0,u.call(this,this._bNoFocus),this._bDateRangeChanged=void 0,this._bNoFocus=void 0}function I(){t(window.document).bind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=!0}function b(){t(window.document).unbind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=void 0}var M=e.extend(\"sap.ui.unified.calendar.MonthsRow\",{metadata:{library:\"sap.ui.unified\",properties:{date:{type:\"object\",group:\"Data\"},startDate:{type:\"object\",group:\"Data\"},months:{type:\"int\",group:\"Appearance\",defaultValue:12},intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},showHeader:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},focus:{parameters:{date:{type:\"object\"},notVisible:{type:\"boolean\"}}}}}});return M.prototype.init=function(){this._oFormatYyyymm=sap.ui.core.format.DateFormat.getInstance({pattern:\"yyyyMMdd\",calendarType:sap.ui.core.CalendarType.Gregorian}),this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({pattern:\"MMMM y\"}),this._mouseMoveProxy=t.proxy(this._handleMouseMove,this),this._rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\")},M.prototype.exit=function(){this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation),this._sInvalidateMonths&&t.sap.clearDelayedCall(this._sInvalidateMonths)},M.prototype.onAfterRendering=function(){l.call(this),y.call(this)},M.prototype.onsapfocusleave=function(e){e.relatedControlId&&t.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())||(this._bMouseMove&&(b.call(this,!0),f.call(this,this._getDate()),this._bMoveChange=!1,this._bMousedownChange=!1,S.call(this)),this._bMousedownChange&&(this._bMousedownChange=!1,S.call(this)))},M.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&!this._sInvalidateMonths&&(this._bInvalidateSync?C.call(this):this._sInvalidateMonths=t.sap.delayedCall(0,this,C)):e.prototype.invalidate.apply(this,arguments)},M.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"selectedDates\");return t},M.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"selectedDates\");return t},M.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"specialDates\");return t},M.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"specialDates\");return t},M.prototype.setDate=function(t){return d.call(this,n.fromLocalJSDate(t),!1),this},M.prototype._setDate=function(t){var e=t.toLocalJSDate();this.setProperty(\"date\",e,!0),this._oDate=t},M.prototype._getDate=function(){return this._oDate||(this._oDate=new n),this._oDate},M.prototype.setStartDate=function(t){o._checkJSDateObject(t);var e,a,s;return a=t.getFullYear(),o._checkYearInValidRange(a),e=n.fromLocalJSDate(t),this.setProperty(\"startDate\",t,!0),this._oStartDate=e,this._oStartDate.setDate(1),this.getDomRef()&&(s=this._getDate().toLocalJSDate(),this._bNoRangeCheck=!0,this.displayDate(t),this._bNoRangeCheck=!1,s&&this.checkDateFocusable(s)&&this.setDate(s)),this},M.prototype._getStartDate=function(){return this._oStartDate||(this._oStartDate=new n,this._oStartDate.setDate(1)),this._oStartDate},M.prototype.displayDate=function(t){return d.call(this,n.fromLocalJSDate(t),!0),this},M.prototype._getLocale=function(){var t=this.getParent();return t&&t.getLocale?t.getLocale():(this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale)},M.prototype._getLocaleData=function(){var t=this.getParent();if(t&&t._getLocaleData)return t._getLocaleData();if(!this._oLocaleData){var e=this._getLocale(),s=new sap.ui.core.Locale(e);this._oLocaleData=a.getInstance(s)}return this._oLocaleData},M.prototype._getFormatLong=function(){var t=this._getLocale();if(this._oFormatLong.oLocale.toString()!=t){var e=new sap.ui.core.Locale(t);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:\"long\"},e)}return this._oFormatLong},M.prototype.getIntervalSelection=function(){var t=this.getParent();return t&&t.getIntervalSelection?t.getIntervalSelection():this.getProperty(\"intervalSelection\")},M.prototype.getSingleSelection=function(){var t=this.getParent();return t&&t.getSingleSelection?t.getSingleSelection():this.getProperty(\"singleSelection\")},M.prototype.getSelectedDates=function(){var t=this.getParent();return t&&t.getSelectedDates?t.getSelectedDates():this.getAggregation(\"selectedDates\",[])},M.prototype.getSpecialDates=function(){var t=this.getParent();return t&&t.getSpecialDates?t.getSpecialDates():this.getAggregation(\"specialDates\",[])},M.prototype._getShowHeader=function(){var t=this.getParent();return t&&t._getShowItemHeader?t._getShowItemHeader():this.getProperty(\"showHeader\")},M.prototype.getAriaLabelledBy=function(){var t=this.getParent();return t&&t.getAriaLabelledBy?t.getAriaLabelledBy():this.getAssociation(\"ariaLabelledBy\",[])},M.prototype.getLegend=function(){var t=this.getParent();return t&&t.getLegend?t.getLegend():this.getAssociation(\"ariaLabelledBy\",[])},M.prototype._checkDateSelected=function(t){var e,a,s,i,r,l,h,c=0,g=0,p=0;for(o._checkCalendarDate(t),l=this.getSelectedDates(),h=new n(t),h.setDate(1),i=h.toUTCJSDate().getTime(),r=0;r<l.length;r++){if(e=l[r],a=e.getStartDate(),c=0,a&&(a=n.fromLocalJSDate(a),a.setDate(1),c=a.toUTCJSDate().getTime()),s=e.getEndDate(),g=0,s&&(s=n.fromLocalJSDate(s),s.setDate(1),g=s.toUTCJSDate().getTime()),i==c&&!s){p=1;break}if(i==c&&s){p=2,s&&i==g&&(p=5);break}if(s&&i==g){p=3;break}if(s&&i>c&&i<g){p=4;break}if(this.getSingleSelection())break}return p},M.prototype._getDateType=function(t){o._checkCalendarDate(t);var e,a,s,i,r,l,h=0,c=0,g=this.getSpecialDates(),p=new n(t);for(p.setDate(1),l=p.toUTCJSDate().getTime(),s=0;s<g.length;s++)if(a=g[s],i=a.getStartDate(),h=0,i&&(i=n.fromLocalJSDate(i),i.setDate(1),h=i.toUTCJSDate().getTime()),r=a.getEndDate(),c=0,r&&(r=n.fromLocalJSDate(r),r.setDate(o._daysInMonth(r)),c=r.toUTCJSDate().getTime()),l==h&&!r||l>=h&&l<=c){e={type:a.getType(),tooltip:a.getTooltip_AsString()};break}return e},M.prototype._checkMonthEnabled=function(t){o._checkCalendarDate(t);var e=this.getParent();return!(e&&e._oMinDate&&e._oMaxDate&&o._isOutside(t,e._oMinDate,e._oMaxDate))},M.prototype._handleMouseMove=function(e){this.$().is(\":visible\")||b.call(this,!0);var a=t(e.target);if(a.hasClass(\"sapUiCalItemText\")&&(a=a.parent()),a.hasClass(\"sapUiCalItem\")){var s=this._getDate(),i=n.fromLocalJSDate(this._oFormatYyyymm.parse(a.attr(\"data-sap-month\")));i.setDate(1),i.isSame(s)||(this._setDate(i),f.call(this,i,!0),this._bMoveChange=!0)}},M.prototype.onmouseup=function(e){if(this._bMouseMove){b.call(this,!0);for(var a=this._getDate(),s=this._oItemNavigation.getItemDomRefs(),i=0;i<s.length;i++){var o=t(s[i]);if(o.attr(\"data-sap-month\")==this._oFormatYyyymm.format(a.toUTCJSDate(),!0)){o.focus();break}}if(this._bMoveChange){var r=t(e.target);r.hasClass(\"sapUiCalItemText\")&&(r=r.parent()),r.hasClass(\"sapUiCalItem\")&&(a=n.fromLocalJSDate(this._oFormatYyyymm.parse(r.attr(\"data-sap-month\"))),a.setDate(1)),f.call(this,a),this._bMoveChange=!1,this._bMousedownChange=!1,S.call(this)}}this._bMousedownChange&&(this._bMousedownChange=!1,S.call(this))},M.prototype.onsapselect=function(t){var e=f.call(this,this._getDate());e&&S.call(this),t.stopPropagation(),t.preventDefault()},M.prototype.onsapselectmodifiers=function(t){this.onsapselect(t)},M.prototype.onsappageupmodifiers=function(t){var e=new n(this._getDate()),a=e.getYear();if(t.metaKey||t.ctrlKey)e.setYear(a-10);else{var s=this.getMonths();s<=12?e.setYear(a-1):e.setMonth(e.getMonth()-s)}this.fireFocus({date:e.toLocalJSDate(),notVisible:!0}),t.preventDefault()},M.prototype.onsappagedownmodifiers=function(t){var e=new n(this._getDate()),a=e.getYear();if(t.metaKey||t.ctrlKey)e.setYear(a+10);else{var s=this.getMonths();s<=12?e.setYear(a+1):e.setMonth(e.getMonth()+s)}this.fireFocus({date:e.toLocalJSDate(),notVisible:!0}),t.preventDefault()},M.prototype.onThemeChanged=function(){if(!this._bNoThemeChange){this._bNamesLengthChecked=void 0,this._bLongWeekDays=void 0;for(var e=this._getLocaleData(),a=e.getMonthsStandAlone(\"wide\"),s=this.$(\"months\").children(),i=this._getStartDate().getMonth(),o=0;o<s.length;o++){var n=t(t(s[o]).children(\".sapUiCalItemText\"));n.text(a[(o+i)%12])}y.call(this)}},M.prototype.checkDateFocusable=function(t){if(o._checkJSDateObject(t),this._bNoRangeCheck)return!1;var e=this._getStartDate(),a=new n(e);a.setDate(1),a.setMonth(a.getMonth()+this.getMonths());var s=n.fromLocalJSDate(t);return s.isSameOrAfter(e)&&s.isBefore(a)},M.prototype.applyFocusInfo=function(t){return this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex()),this},M},!0);",
		"sap/ui/unified/calendar/MonthsRowRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\"],function(e,t,a){\"use strict\";var i={};return i.render=function(e,t){var a=t._getStartDate(),i=t.getTooltip_AsString(),d=t.getId(),r={value:d+\"-Descr\",append:!0};e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiCalMonthsRow\"),e.addClass(\"sapUiCalRow\"),e.writeClasses(),i&&e.writeAttributeEscaped(\"title\",i),t._getShowHeader()&&(r.value=r.value+\" \"+d+\"-Head\"),e.writeAccessibilityState(t,{role:\"grid\",readonly:\"true\",multiselectable:!t.getSingleSelection()||t.getIntervalSelection(),labelledby:r}),e.write(\">\"),e.write('<span id=\"'+d+'-Descr\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_DIALOG\")+\"</span>\"),t.getIntervalSelection()&&(e.write('<span id=\"'+d+'-Start\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_START_MONTH\")+\"</span>\"),e.write('<span id=\"'+d+'-End\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_END_MONTH\")+\"</span>\")),this.renderRow(e,t,a),e.write(\"</div>\")},i.renderRow=function(e,t,a){var i=t.getId();this.renderHeader(e,t,a),e.write('<div id=\"'+i+'-months\" class=\"sapUiCalItems\">'),this.renderMonths(e,t,a),e.write(\"</div>\")},i.renderHeader=function(e,a,i){if(t._checkCalendarDate(i),a._getShowHeader()){var d=a._getLocaleData(),r=a.getId();e.write('<div id=\"'+r+'-Head\">'),this.renderHeaderLine(e,a,d,i),e.write(\"</div>\")}},i.renderHeaderLine=function(e,i,d,r){t._checkCalendarDate(r);var s=i.getId(),n=i.getMonths(),l=new a(r),o=\"\",c=0,g=[],h=0;for(h=0;h<n;h++)c=l.getYear(),g.length>0&&g[g.length-1].iYear==c?g[g.length-1].iMonths++:g.push({iYear:c,iMonths:1}),l.setMonth(l.getMonth()+1);for(h=0;h<g.length;h++){var p=g[h];o=100/n*p.iMonths+\"%\",e.write('<div id=\"'+s+\"-Head\"+h+'\"class=\"sapUiCalHeadText\" style=\"width:'+o+'\">'),e.write(p.iYear),e.write(\"</div>\")}},i.renderMonths=function(e,t,i){var d=this.getHelper(t,i),r=t.getMonths(),s=100/r+\"%\",n=new a(i);n.setDate(1);for(var l=0;l<r;l++)this.renderMonth(e,t,n,d,s),n.setMonth(n.getMonth()+1)},i.getHelper=function(i,d){t._checkCalendarDate(d);var r={};r.sLocale=i._getLocale(),r.oLocaleData=i._getLocaleData(),r.oToday=new a,r.sCurrentMonth=i._rb.getText(\"CALENDAR_CURRENT_MONTH\"),r.sId=i.getId(),r.oFormatLong=i._getFormatLong(),i._bLongMonth||!i._bNamesLengthChecked?r.aMonthNames=r.oLocaleData.getMonthsStandAlone(\"wide\"):(r.aMonthNames=r.oLocaleData.getMonthsStandAlone(\"abbreviated\"),r.aMonthNamesWide=r.oLocaleData.getMonthsStandAlone(\"wide\"));var s=i.getLegend();if(s){var n=sap.ui.getCore().byId(s);if(n){if(!(n instanceof sap.ui.unified.CalendarLegend))throw new Error(n+\" is not an sap.ui.unified.CalendarLegend. \"+i);r.aTypes=n.getItems()}else e.sap.log.warning(\"CalendarLegend \"+s+\" does not exist!\",i)}else r.aTypes=[];return r},i.renderMonth=function(e,a,i,d,r){t._checkCalendarDate(i);var s={role:\"gridcell\",selected:!1,label:\"\",describedby:\"\"};!a._bLongMonth&&a._bNamesLengthChecked&&(s.label=d.aMonthNamesWide[i.getMonth()]);var n=a._oFormatYyyymm.format(i.toUTCJSDate(),!0),l=a._checkDateSelected(i),o=a._getDateType(i),c=a._checkMonthEnabled(i);if(e.write(\"<div\"),e.writeAttribute(\"id\",d.sId+\"-\"+n),e.addClass(\"sapUiCalItem\"),r&&e.addStyle(\"width\",r),t._isSameMonthAndYear(i,d.oToday)&&(e.addClass(\"sapUiCalItemNow\"),s.label=d.sCurrentMonth+\" \"),l>0&&(e.addClass(\"sapUiCalItemSel\"),s.selected=!0),2==l?(e.addClass(\"sapUiCalItemSelStart\"),s.describedby=s.describedby+\" \"+d.sId+\"-Start\"):3==l?(e.addClass(\"sapUiCalItemSelEnd\"),s.describedby=s.describedby+\" \"+d.sId+\"-End\"):4==l?e.addClass(\"sapUiCalItemSelBetween\"):5==l&&(e.addClass(\"sapUiCalItemSelStart\"),e.addClass(\"sapUiCalItemSelEnd\"),s.describedby=s.describedby+\" \"+d.sId+\"-Start\",s.describedby=s.describedby+\" \"+d.sId+\"-End\"),o&&o.type!=sap.ui.unified.CalendarDayType.None&&(e.addClass(\"sapUiCalItem\"+o.type),o.tooltip&&e.writeAttributeEscaped(\"title\",o.tooltip)),c||(e.addClass(\"sapUiCalItemDsbl\"),s.disabled=!0),e.writeAttribute(\"tabindex\",\"-1\"),e.writeAttribute(\"data-sap-month\",n),s.label=s.label+d.oFormatLong.format(i.toUTCJSDate(),!0),o&&o.type!=sap.ui.unified.CalendarDayType.None)for(var g=0;g<d.aTypes.length;g++){var h=d.aTypes[g];if(h.getType()==o.type){s.label=s.label+\"; \"+h.getText();break}}e.writeAccessibilityState(null,s),e.writeClasses(),e.writeStyles(),e.write(\">\"),e.write(\"<span\"),e.addClass(\"sapUiCalItemText\"),e.writeClasses(),e.write(\">\"),e.write(d.aMonthNames[i.getMonth()]),e.write(\"</span>\"),e.write(\"</div>\")},i},!0);",
		"sap/ui/unified/calendar/OneMonthDatesRow.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/DatesRow\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/unified/library\"],function(t,e,a,i,o){\"use strict\";function s(t){t.stopPropagation(),t.preventDefault(),t.stopImmediatePropagation(!0)}var n=e.extend(\"sap.ui.unified.calendar.OneMonthDatesRow\",{metadata:{library:\"sap.ui.unified\"}});return n.prototype.init=function(){e.prototype.init.apply(this,arguments),this.iMode=2},n.prototype.setMode=function(t){var e,a=this.getSelectedDates(),i=this.iMode!==t;return this.iMode=t,i&&a.length&&(this.iMode<2&&(e=this.getStartDate()),a[0].setProperty(\"startDate\",e,!0)),this},n.prototype.getMode=function(){return this.iMode},n.prototype.selectDate=function(t){return this.iMode<2&&this.getSelectedDates().length&&this.getSelectedDates()[0].setStartDate(t),this},n.prototype.setDate=function(t){return this._bNoRangeCheck||this.checkDateFocusable(t)?(e.prototype.setDate.apply(this,arguments),this):this},n.prototype.displayDate=function(t){return this._bNoRangeCheck||this.checkDateFocusable(t)?(e.prototype.displayDate.apply(this,arguments),this):this},n.prototype.onsaphome=function(t){var e=i.fromLocalJSDate(this.getStartDate());s(t),this._setDate(e),this._focusDate(e),this.fireFocus({date:e.toLocalJSDate(),otherMonth:!1})},n.prototype.onsapend=function(t){var e,o=this.getStartDate();e=i.fromLocalJSDate(o),e.setDate(a._daysInMonth(e)),s(t),this._setDate(e),this._focusDate(e),this.fireFocus({date:e.toLocalJSDate(),otherMonth:!1})},n},!0);",
		"sap/ui/unified/calendar/OneMonthDatesRowRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"sap/ui/unified/calendar/CalendarUtils\",\"./MonthRenderer\",\"./DatesRowRenderer\"],function(e,r,n,a,s){\"use strict\";var t=r.extend(s);return t.getClass=function(e){return e.iMode<2?a.getClass(e):s.getClass(e)},t.renderDays=function(e,r,n){r.iMode<2?a.renderDays(e,r,n):s.renderDays(e,r,n)},t},!0);",
		"sap/ui/unified/calendar/TimesRow.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/core/date/UniversalDate\",\"sap/ui/unified/library\"],function(e,t,a,i,s,r,o,n){\"use strict\";function l(){for(var t=this._getDate(),a=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),!0),s=0,r=this.$(\"times\").get(0),o=this.$(\"times\").children(\".sapUiCalItem\"),n=0;n<o.length;n++){var l=e(o[n]);if(l.attr(\"data-sap-time\")===a){s=n;break}}this._oItemNavigation||(this._oItemNavigation=new i,this._oItemNavigation.attachEvent(i.Events.AfterFocus,g,this),this._oItemNavigation.attachEvent(i.Events.FocusAgain,h,this),this._oItemNavigation.attachEvent(i.Events.BorderReached,c,this),this.addDelegate(this._oItemNavigation),this._oItemNavigation.setDisabledModifiers({sapnext:[\"alt\"],sapprevious:[\"alt\"],saphome:[\"alt\"],sapend:[\"alt\"]}),this._oItemNavigation.setCycling(!1),this._oItemNavigation.setColumns(1,!0)),this._oItemNavigation.setRootDomRef(r),this._oItemNavigation.setItemDomRefs(o),this._oItemNavigation.setFocusedIndex(s),this._oItemNavigation.setPageSize(o.length)}function g(t){var a=t.getParameter(\"index\"),i=t.getParameter(\"event\");if(i){var s=this._getDate(),n=new o(s.getTime()),l=this._oItemNavigation.getItemDomRefs(),g=e(l[a]);n=new o(this._oFormatYyyyMMddHHmm.parse(g.attr(\"data-sap-time\"),!0).getTime()),this._setDate(n),this.fireFocus({date:r._createLocalDate(n,!0),notVisible:!1}),\"mousedown\"==i.type&&m.call(this,i,n,a)}}function h(e){var t=e.getParameter(\"index\"),a=e.getParameter(\"event\");if(a&&\"mousedown\"==a.type){var i=this._getDate();m.call(this,a,i,t)}}function c(e){var t=e.getParameter(\"event\"),a=this.getItems(),i=this.getIntervalMinutes(),s=this._getDate(),n=new o(s.getTime());if(t.type){switch(t.type){case\"sapnext\":case\"sapnextmodifiers\":n.setUTCMinutes(n.getUTCMinutes()+i);break;case\"sapprevious\":case\"sappreviousmodifiers\":n.setUTCMinutes(n.getUTCMinutes()-i);break;case\"sappagedown\":n.setUTCMinutes(n.getUTCMinutes()+i*a);break;case\"sappageup\":n.setUTCMinutes(n.getUTCMinutes()-i*a)}this.fireFocus({date:r._createLocalDate(n,!0),notVisible:!0})}}function m(e,t,a){if(!e.button){var i=D.call(this,t);i&&(this._bMousedownChange=!0),this._bMouseMove?(I.call(this,!0),this._bMoveChange=!1):this.getIntervalSelection()&&this.$().is(\":visible\")&&T.call(this,!0),e.preventDefault(),e.setMark(\"cancelAutoClose\")}}function p(t,a){r._checkJSDateObject(t);var i=t.getFullYear();r._checkYearInValidRange(i);var s=!0;if(!e.sap.equal(this.getDate(),t)){var o=r._createUniversalUTCDate(t,void 0,!0);if(o=this._getIntervalStart(o),s=this.checkDateFocusable(t),!this._bNoRangeCheck&&!s)throw new Error(\"Date must be in visible date range; \"+this);this.setProperty(\"date\",t,!0),this._oUTCDate=o}this.getDomRef()&&(s?u.call(this,this._oUTCDate,a):d.call(this,a))}function u(t,a){for(var i,s=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),!0),r=this._oItemNavigation.getItemDomRefs(),o=0;o<r.length;o++)if(i=e(r[o]),i.attr(\"data-sap-time\")==s){document.activeElement!=r[o]&&(a?this._oItemNavigation.setFocusedIndex(o):this._oItemNavigation.focusItem(o));break}}function d(e){var t=this._getStartDate(),a=this.$(\"times\");if(a.length>0){var i=sap.ui.getCore().createRenderManager();this.getRenderer().renderTimes(i,this,t),i.flush(a[0]),i.destroy()}v.call(this),l.call(this),e||this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex())}function v(){var e=this._getStartDate();if(this._getShowHeader()){var t=this.$(\"Head\");if(t.length>0){var a=this._getLocaleData(),i=sap.ui.getCore().createRenderManager();this.getRenderer().renderHeaderLine(i,this,a,e),i.flush(t[0]),i.destroy()}}}function D(t,a){if(!this._checkTimeEnabled(t))return!1;var i,s,o,n,l=this.getSelectedDates(),g=this._oItemNavigation.getItemDomRefs(),h=0,c=this.getParent(),m=this;if(c&&c.getSelectedDates&&(m=c),this.getSingleSelection())if(l.length>0?(i=l[0],n=i.getStartDate(),n&&(n=r._createUniversalUTCDate(n,void 0,!0),n=this._getIntervalStart(n))):(i=new sap.ui.unified.DateRange,m.addAggregation(\"selectedDates\",i,!0)),this.getIntervalSelection()&&(!i.getEndDate()||a)&&n){var p;t.getTime()<n.getTime()?(p=n,n=t,a||(i.setProperty(\"startDate\",r._createLocalDate(new Date(n.getTime()),!0),!0),i.setProperty(\"endDate\",r._createLocalDate(new Date(p.getTime()),!0),!0))):t.getTime()>=n.getTime()&&(p=t,a||i.setProperty(\"endDate\",r._createLocalDate(new Date(p.getTime()),!0),!0)),_.call(this,n,p)}else _.call(this,t),i.setProperty(\"startDate\",r._createLocalDate(new Date(t.getTime()),!0),!0),i.setProperty(\"endDate\",void 0,!0);else{if(this.getIntervalSelection())throw new Error(\"Calender don't support multiple interval selection\");var u=this._checkDateSelected(t);if(u>0){for(h=0;h<l.length;h++)if(n=l[h].getStartDate(),n&&(n=r._createUniversalUTCDate(n,void 0,!0),n=this._getIntervalStart(n),t.getTime()==n.getTime())){m.removeAggregation(\"selectedDates\",h,!0);break}}else i=new sap.ui.unified.DateRange({startDate:r._createLocalDate(new Date(t.getTime()),!0)}),m.addAggregation(\"selectedDates\",i,!0);for(o=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),!0),h=0;h<g.length;h++)s=e(g[h]),s.attr(\"data-sap-time\")==o&&(u>0?(s.removeClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"false\")):(s.addClass(\"sapUiCalItemSel\"),s.attr(\"aria-selected\",\"true\")))}return!0}function _(t,a){var i,s=this._oItemNavigation.getItemDomRefs(),r=0,n=!1,l=!1;if(a){var g;for(r=0;r<s.length;r++)i=e(s[r]),n=!1,l=!1,g=new o(this._oFormatYyyyMMddHHmm.parse(i.attr(\"data-sap-time\"),!0).getTime()),g.getTime()==t.getTime()?(i.addClass(\"sapUiCalItemSelStart\"),n=!0,i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),a&&g.getTime()==a.getTime()&&(i.addClass(\"sapUiCalItemSelEnd\"),l=!0),i.removeClass(\"sapUiCalItemSelBetween\")):a&&g.getTime()>t.getTime()&&g.getTime()<a.getTime()?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),i.addClass(\"sapUiCalItemSelBetween\"),i.removeClass(\"sapUiCalItemSelStart\"),i.removeClass(\"sapUiCalItemSelEnd\")):a&&g.getTime()==a.getTime()?(i.addClass(\"sapUiCalItemSelEnd\"),l=!0,i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),i.removeClass(\"sapUiCalItemSelStart\"),i.removeClass(\"sapUiCalItemSelBetween\")):(i.hasClass(\"sapUiCalItemSel\")&&(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\")),i.hasClass(\"sapUiCalItemSelStart\")?i.removeClass(\"sapUiCalItemSelStart\"):i.hasClass(\"sapUiCalItemSelBetween\")?i.removeClass(\"sapUiCalItemSelBetween\"):i.hasClass(\"sapUiCalItemSelEnd\")&&i.removeClass(\"sapUiCalItemSelEnd\")),f.call(this,i,n,l)}else{var h=this._oFormatYyyyMMddHHmm.format(t.getJSDate(),!0);for(r=0;r<s.length;r++)i=e(s[r]),n=!1,l=!1,i.attr(\"data-sap-time\")==h?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\"),n=!0):i.hasClass(\"sapUiCalItemSel\")&&(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\")),i.hasClass(\"sapUiCalItemSelStart\")?i.removeClass(\"sapUiCalItemSelStart\"):i.hasClass(\"sapUiCalItemSelBetween\")?i.removeClass(\"sapUiCalItemSelBetween\"):i.hasClass(\"sapUiCalItemSelEnd\")&&i.removeClass(\"sapUiCalItemSelEnd\"),f.call(this,i,n,l)}}function f(e,t,a){if(this.getIntervalSelection()){var i=\"\",s=[],r=this.getId(),o=!1;i=e.attr(\"aria-describedby\"),i&&(s=i.split(\" \"));for(var n=-1,l=-1,g=0;g<s.length;g++){var h=s[g];h==r+\"-Start\"&&(n=g),h==r+\"-End\"&&(l=g)}n>=0&&!t&&(s.splice(n,1),o=!0,l>n&&l--),l>=0&&!a&&(s.splice(l,1),o=!0),n<0&&t&&(s.push(r+\"-Start\"),o=!0),l<0&&a&&(s.push(r+\"-End\"),o=!0),o&&(i=s.join(\" \"),e.attr(\"aria-describedby\",i))}}function C(){this._bMouseMove&&I.call(this,!0),this.fireSelect()}function y(){this._sInvalidateTimes=void 0,d.call(this,this._bNoFocus),this._bDateRangeChanged=void 0,this._bNoFocus=void 0}function T(){e(window.document).bind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=!0}function I(){e(window.document).unbind(\"mousemove\",this._mouseMoveProxy),this._bMouseMove=void 0}var S=t.extend(\"sap.ui.unified.calendar.TimesRow\",{metadata:{library:\"sap.ui.unified\",properties:{date:{type:\"object\",group:\"Data\"},startDate:{type:\"object\",group:\"Data\"},items:{type:\"int\",group:\"Appearance\",defaultValue:12},intervalMinutes:{type:\"int\",group:\"Appearance\",defaultValue:60},intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},showHeader:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},focus:{parameters:{date:{type:\"object\"},notVisible:{type:\"boolean\"}}}}}});return S.prototype.init=function(){this._oFormatYyyyMMddHHmm=sap.ui.core.format.DateFormat.getInstance({pattern:\"yyyyMMddHHmm\",calendarType:sap.ui.core.CalendarType.Gregorian}),this._oFormatLong=sap.ui.core.format.DateFormat.getDateTimeInstance({style:\"long/short\"}),this._oFormatDate=sap.ui.core.format.DateFormat.getDateInstance({style:\"medium\"}),this._mouseMoveProxy=e.proxy(this._handleMouseMove,this),this._rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\")},S.prototype.exit=function(){this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation),this._sInvalidateTimes&&e.sap.clearDelayedCall(this._sInvalidateTimes)},S.prototype.onAfterRendering=function(){l.call(this)},S.prototype.onsapfocusleave=function(t){t.relatedControlId&&e.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(t.relatedControlId).getFocusDomRef())||(this._bMouseMove&&(I.call(this,!0),D.call(this,this._getDate()),this._bMoveChange=!1,this._bMousedownChange=!1,C.call(this)),this._bMousedownChange&&(this._bMousedownChange=!1,C.call(this)))},S.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&!this._sInvalidateTimes&&(this._bInvalidateSync?y.call(this):this._sInvalidateTimes=e.sap.delayedCall(0,this,y)):t.prototype.invalidate.apply(this,arguments)},S.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"selectedDates\");return e},S.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"selectedDates\");return e},S.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var e=this.removeAllAggregation(\"specialDates\");return e},S.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var e=this.destroyAggregation(\"specialDates\");return e},S.prototype.setIntervalMinutes=function(e){if(e>=720)throw new Error(\"Only intervals < 720 minutes are allowed; \"+this);if(1440%e>0)throw new Error(\"A day must be divisible by the interval size; \"+this);return this.setProperty(\"intervalMinutes\",e,!1),this._oFormatTime=void 0,this},S.prototype.setDate=function(e){return p.call(this,e,!1),this},S.prototype._setDate=function(e){var t=r._createLocalDate(e,!0);this.setProperty(\"date\",t,!0),this._oUTCDate=e},S.prototype._getDate=function(){return this._oUTCDate||(this._oUTCDate=r._createUniversalUTCDate(new Date,void 0,!0)),this._oUTCDate},S.prototype.setStartDate=function(e){r._checkJSDateObject(e);var t=e.getFullYear();r._checkYearInValidRange(t);var a=r._createUniversalUTCDate(e,void 0,!0);if(this.setProperty(\"startDate\",e,!0),this._oUTCStartDate=this._getIntervalStart(a),this.getDomRef()){var i=r._createLocalDate(this._getDate(),!0);this._bNoRangeCheck=!0,this.displayDate(e),this._bNoRangeCheck=!1,i&&this.checkDateFocusable(i)&&this.displayDate(i)}return this},S.prototype._getStartDate=function(){return this._oUTCStartDate||(this._oUTCStartDate=r._createUniversalUTCDate(new Date,void 0,!0),this._oUTCStartDate=this._getIntervalStart(this._oUTCStartDate)),this._oUTCStartDate},S.prototype.displayDate=function(e){return p.call(this,e,!0),this},S.prototype._getLocale=function(){var e=this.getParent();return e&&e.getLocale?e.getLocale():(this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale)},S.prototype._getLocaleData=function(){var e=this.getParent();if(e&&e._getLocaleData)return e._getLocaleData();if(!this._oLocaleData){var t=this._getLocale(),i=new sap.ui.core.Locale(t);this._oLocaleData=a.getInstance(i)}return this._oLocaleData},S.prototype._getFormatLong=function(){var e=this._getLocale();if(this._oFormatLong.oLocale.toString()!=e){var t=new sap.ui.core.Locale(e);this._oFormatLong=sap.ui.core.format.DateFormat.getInstance({style:\"long/short\"},t)}return this._oFormatLong},S.prototype._getFormatTime=function(){var e=this._getLocale();if(!this._oFormatTime||this._oFormatTime.oLocale.toString()!=e){var t,a=new sap.ui.core.Locale(e),i=this.getIntervalMinutes(),s=this._getLocaleData();this._oFormatTimeAmPm=void 0,i%60==0?(t=s.getPreferredHourSymbol(),s.getTimePattern(\"short\").search(\"a\")>=0&&(this._oFormatTimeAmPm=sap.ui.core.format.DateFormat.getTimeInstance({pattern:\"a\"},a))):(t=s.getTimePattern(\"short\"),t=t.replace(\"HH\",\"H\"),t=t.replace(\"hh\",\"h\"),t.search(\"a\")>=0&&(this._oFormatTimeAmPm=sap.ui.core.format.DateFormat.getTimeInstance({pattern:\"a\"},a),t=t.replace(\"a\",\"\").trim())),this._oFormatTime=sap.ui.core.format.DateFormat.getTimeInstance({pattern:t},a)}return this._oFormatTime},S.prototype._getFormatDate=function(){var e=this._getLocale();if(this._oFormatDate.oLocale.toString()!=e){var t=new sap.ui.core.Locale(e);this._oFormatDate=sap.ui.core.format.DateFormat.getDateInstance({style:\"medium\"},t)}return this._oFormatDate},S.prototype.getIntervalSelection=function(){var e=this.getParent();return e&&e.getIntervalSelection?e.getIntervalSelection():this.getProperty(\"intervalSelection\")},S.prototype.getSingleSelection=function(){var e=this.getParent();return e&&e.getSingleSelection?e.getSingleSelection():this.getProperty(\"singleSelection\")},S.prototype.getSelectedDates=function(){var e=this.getParent();return e&&e.getSelectedDates?e.getSelectedDates():this.getAggregation(\"selectedDates\",[])},S.prototype.getSpecialDates=function(){var e=this.getParent();return e&&e.getSpecialDates?e.getSpecialDates():this.getAggregation(\"specialDates\",[])},S.prototype._getShowHeader=function(){var e=this.getParent();return e&&e._getShowItemHeader?e._getShowItemHeader():this.getProperty(\"showHeader\")},S.prototype.getIntervalMinutes=function(){var e=this.getParent();return e&&e.getIntervalMinutes?e.getIntervalMinutes():this.getProperty(\"intervalMinutes\")},S.prototype.getAriaLabelledBy=function(){var e=this.getParent();return e&&e.getAriaLabelledBy?e.getAriaLabelledBy():this.getAssociation(\"ariaLabelledBy\",[])},S.prototype.getLegend=function(){var e=this.getParent();return e&&e.getLegend?e.getLegend():this.getAssociation(\"ariaLabelledBy\",[])},S.prototype._checkDateSelected=function(e){if(!(e instanceof o))throw new Error(\"Date must be a UniversalDate object \"+this);var t=0,a=this.getSelectedDates(),i=new o(e.getTime());i=this._getIntervalStart(i);for(var s=i.getTime(),n=0;n<a.length;n++){var l=a[n],g=l.getStartDate(),h=0;g&&(g=r._createUniversalUTCDate(g,void 0,!0),g=this._getIntervalStart(g),h=g.getTime());var c=l.getEndDate(),m=0;if(c&&(c=r._createUniversalUTCDate(c,void 0,!0),c=this._getIntervalStart(c),m=c.getTime()),s==h&&!c){t=1;break}if(s==h&&c){t=2,c&&s==m&&(t=5);break}if(c&&s==m){t=3;break}if(c&&s>h&&s<m){t=4;break}if(this.getSingleSelection())break}return t},S.prototype._getDateType=function(e){if(!(e instanceof o))throw new Error(\"Date must be a UniversalDate object \"+this);var t,a=this.getSpecialDates(),i=new o(e.getTime());i=this._getIntervalStart(i);for(var s=i.getTime(),n=0;n<a.length;n++){var l=a[n],g=l.getStartDate(),h=0;g&&(g=r._createUniversalUTCDate(g,void 0,!0),g=this._getIntervalStart(g),h=g.getTime());var c=l.getEndDate(),m=0;if(c?(c=r._createUniversalUTCDate(c,void 0,!0),c=this._getIntervalStart(c),c.setUTCMinutes(c.getUTCMinutes()+this.getIntervalMinutes()-1),m=c.getTime()):0==g.getUTCHours()&&0==g.getUTCMinutes()&&0==g.getUTCSeconds()&&0==g.getUTCMilliseconds()&&(c=new o(g.getTime()),c.setUTCDate(c.getUTCDate()+1),m=c.getTime()),s==h&&!c||s>=h&&s<=m){t={type:l.getType(),tooltip:l.getTooltip_AsString()};break}}return t},S.prototype._checkTimeEnabled=function(e){if(!(e instanceof o))throw new Error(\"Date must be a UniversalDate object \"+this);var t=e.getTime(),a=this.getParent();return!(a&&a._oMinDate&&a._oMaxDate&&(t<a._oMinDate.getTime()||t>a._oMaxDate.getTime()))},S.prototype._handleMouseMove=function(t){this.$().is(\":visible\")||I.call(this,!0);var a=e(t.target);if(a.hasClass(\"sapUiCalItemText\")&&(a=a.parent()),a.hasClass(\"sapUiCalItem\")){var i=this._getDate(),s=new o(this._oFormatYyyyMMddHHmm.parse(a.attr(\"data-sap-time\"),!0).getTime());s.getTime()!=i.getTime()&&(this._setDate(s),D.call(this,s,!0),this._bMoveChange=!0)}},S.prototype.onmouseup=function(t){if(this._bMouseMove){I.call(this,!0);for(var a=this._getDate(),i=this._oItemNavigation.getItemDomRefs(),s=0;s<i.length;s++){var r=e(i[s]);if(r.attr(\"data-sap-time\")==this._oFormatYyyyMMddHHmm.format(a.getJSDate(),!0)){r.focus();break}}if(this._bMoveChange){var n=e(t.target);n.hasClass(\"sapUiCalItemText\")&&(n=n.parent()),n.hasClass(\"sapUiCalItem\")&&(a=new o(this._oFormatYyyyMMddHHmm.parse(n.attr(\"data-sap-time\"),!0).getTime())),D.call(this,a),this._bMoveChange=!1,this._bMousedownChange=!1,C.call(this)}}this._bMousedownChange&&(this._bMousedownChange=!1,C.call(this))},S.prototype.onsapselect=function(e){var t=D.call(this,this._getDate());t&&C.call(this),e.stopPropagation(),e.preventDefault()},S.prototype.onsapselectmodifiers=function(e){this.onsapselect(e)},S.prototype.onsappageupmodifiers=function(e){var t=new o(this._getDate().getTime()),a=t.getUTCDate();e.metaKey||e.ctrlKey?t.setUTCDate(a-7):t.setUTCDate(a-1),this.fireFocus({date:r._createLocalDate(t,!0),notVisible:!0}),e.preventDefault()},S.prototype.onsappagedownmodifiers=function(e){var t=new o(this._getDate().getTime()),a=t.getUTCDate();e.metaKey||e.ctrlKey?t.setUTCDate(a+7):t.setUTCDate(a+1),this.fireFocus({date:r._createLocalDate(t,!0),notVisible:!0}),e.preventDefault()},S.prototype.checkDateFocusable=function(e){if(r._checkJSDateObject(e),this._bNoRangeCheck)return!1;var t=this._getStartDate(),a=new o(t.getTime());a.setUTCMinutes(a.getUTCMinutes()+this.getItems()*this.getIntervalMinutes());var i=r._createUniversalUTCDate(e,void 0,!0);return i.getTime()>=t.getTime()&&i.getTime()<a.getTime()},S.prototype.applyFocusInfo=function(e){return this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex()),this},S.prototype._getIntervalStart=function(e){var t=e.getTime(),a=new o(e.getTime());a.setUTCHours(0),a.setUTCMinutes(0),a.setUTCSeconds(0),a.setUTCMilliseconds(0);for(var i=this.getIntervalMinutes();a.getTime()<=t;)a.setUTCMinutes(a.getUTCMinutes()+i);var s=new o(a.getTime());return s.setUTCMinutes(s.getUTCMinutes()-i),s},S},!0);",
		"sap/ui/unified/calendar/TimesRowRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/core/date/UniversalDate\"],function(e,t,a){\"use strict\";var i={};return i.render=function(e,t){var a=t._getStartDate(),i=t.getTooltip_AsString(),r=t.getId(),s={value:r+\"-Descr\",append:!0};e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiCalTimesRow\"),e.addClass(\"sapUiCalRow\"),e.writeClasses(),i&&e.writeAttributeEscaped(\"title\",i),t._getShowHeader()&&(s.value=s.value+\" \"+r+\"-Head\"),e.writeAccessibilityState(t,{role:\"grid\",readonly:\"true\",multiselectable:!t.getSingleSelection()||t.getIntervalSelection(),labelledby:s}),e.write(\">\"),e.write('<span id=\"'+r+'-Descr\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_DIALOG\")+\"</span>\"),t.getIntervalSelection()&&(e.write('<span id=\"'+r+'-Start\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_START_TIME\")+\"</span>\"),e.write('<span id=\"'+r+'-End\" style=\"display: none;\">'+t._rb.getText(\"CALENDAR_END_TIME\")+\"</span>\")),this.renderRow(e,t,a),e.write(\"</div>\")},i.renderRow=function(e,t,a){var i=t.getId();this.renderHeader(e,t,a),e.write('<div id=\"'+i+'-times\" class=\"sapUiCalItems\">'),this.renderTimes(e,t,a),e.write(\"</div>\")},i.renderHeader=function(e,t,a){if(t._getShowHeader()){var i=t._getLocaleData(),r=t.getId();e.write('<div id=\"'+r+'-Head\">'),this.renderHeaderLine(e,t,i,a),e.write(\"</div>\")}},i.renderHeaderLine=function(e,t,a,i){var r=t._getFormatDate(),s=t.getId(),d=t.getItems(),l=t._getIntervalStart(i),n=t.getIntervalMinutes(),o=\"\",m=0,g=[],p=0;for(p=0;p<d;p++)m=r.format(l,!0),g.length>0&&g[g.length-1].sDay==m?g[g.length-1].iItems++:g.push({sDay:m,iItems:1}),l.setUTCMinutes(l.getUTCMinutes()+n);for(p=0;p<g.length;p++){var C=g[p];o=100/d*C.iItems+\"%\",e.write('<div id=\"'+s+\"-Head\"+p+'\"class=\"sapUiCalHeadText\" style=\"width:'+o+'\">'),e.write(C.sDay),e.write(\"</div>\")}},i.renderTimes=function(e,t,a){for(var i=this.getHelper(t,a),r=t.getItems(),s=100/r+\"%\",d=t._getIntervalStart(a),l=\"\",n=\"\",o=0;o<r;o++)i.oFormatTimeAmPm&&(n=i.oFormatTimeAmPm.format(d,!0),l==n?n=\"\":l=n),this.renderTime(e,t,d,i,s,n),d.setUTCMinutes(d.getUTCMinutes()+i.iMinutes)},i.getHelper=function(a,i){var r={};r.sLocale=a._getLocale(),r.oLocaleData=a._getLocaleData(),r.oNow=t._createUniversalUTCDate(new Date,void 0,!0),r.sCurrentTime=a._rb.getText(\"CALENDAR_CURRENT_TIME\"),r.sId=a.getId(),r.oFormatLong=a._getFormatLong(),r.oFormatTime=a._getFormatTime(),r.oFormatTimeAmPm=a._oFormatTimeAmPm,r.iMinutes=a.getIntervalMinutes();var s=a.getLegend();if(s){var d=sap.ui.getCore().byId(s);if(d){if(!(d instanceof sap.ui.unified.CalendarLegend))throw new Error(d+\" is not an sap.ui.unified.CalendarLegend. \"+a);r.aTypes=d.getItems()}else e.sap.log.warning(\"CalendarLegend \"+s+\" does not exist!\",a)}else r.aTypes=[];return r},i.renderTime=function(e,t,i,r,s,d){var l={role:\"gridcell\",selected:!1,label:\"\",describedby:\"\"},n=t._oFormatYyyyMMddHHmm.format(i.getJSDate(),!0),o=t._checkDateSelected(i),m=t._getDateType(i),g=t._checkTimeEnabled(i);e.write(\"<div\"),e.writeAttribute(\"id\",r.sId+\"-\"+n),e.addClass(\"sapUiCalItem\"),s&&e.addStyle(\"width\",s);var p=new a(i.getTime());if(p.setUTCMinutes(p.getUTCMinutes()+r.iMinutes),i.getTime()<=r.oNow.getTime()&&p.getTime()>r.oNow.getTime()&&(e.addClass(\"sapUiCalItemNow\"),l.label=r.sCurrentTime+\" \"),o>0&&(e.addClass(\"sapUiCalItemSel\"),l.selected=!0),2==o?(e.addClass(\"sapUiCalItemSelStart\"),l.describedby=l.describedby+\" \"+r.sId+\"-Start\"):3==o?(e.addClass(\"sapUiCalItemSelEnd\"),l.describedby=l.describedby+\" \"+r.sId+\"-End\"):4==o?e.addClass(\"sapUiCalItemSelBetween\"):5==o&&(e.addClass(\"sapUiCalItemSelStart\"),e.addClass(\"sapUiCalItemSelEnd\"),l.describedby=l.describedby+\" \"+r.sId+\"-Start\",l.describedby=l.describedby+\" \"+r.sId+\"-End\"),m&&m.type!=sap.ui.unified.CalendarDayType.None&&(e.addClass(\"sapUiCalItem\"+m.type),m.tooltip&&e.writeAttributeEscaped(\"title\",m.tooltip)),g||(e.addClass(\"sapUiCalItemDsbl\"),l.disabled=!0),e.writeAttribute(\"tabindex\",\"-1\"),e.writeAttribute(\"data-sap-time\",n),l.label=l.label+r.oFormatLong.format(i,!0),m&&m.type!=sap.ui.unified.CalendarDayType.None)for(var C=0;C<r.aTypes.length;C++){var w=r.aTypes[C];if(w.getType()==m.type){l.label=l.label+\"; \"+w.getText();break}}e.writeAccessibilityState(null,l),e.writeClasses(),e.writeStyles(),e.write(\">\"),e.write(\"<span\"),e.addClass(\"sapUiCalItemText\"),e.writeClasses(),e.write(\">\"),e.write(r.oFormatTime.format(i,!0)),d&&(e.write(\"<span\"),e.addClass(\"sapUiCalItemTextAmPm\"),e.writeClasses(),e.write(\">\"),e.write(d),e.write(\"</span>\")),e.write(\"</span>\"),e.write(\"</div>\")},i},!0);",
		"sap/ui/unified/calendar/YearPicker.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/core/date/UniversalDate\",\"sap/ui/unified/library\"],function(e,t,a,i,s,r,o,n){\"use strict\";function h(){var e=this.getYears(),t=this._getDate().getYear(),i=this._oMinDate.getYear(),s=this._oMaxDate.getYear(),r=this.getDomRef(),o=this.$().find(\".sapUiCalItem\"),n=Math.floor(e/2);t>s-Math.floor(e/2)?n=n+t-s+Math.floor(e/2):t<=i+Math.floor(e/2)&&(n=t-i),this._oItemNavigation||(this._oItemNavigation=new a,this._oItemNavigation.attachEvent(a.Events.AfterFocus,l,this),this._oItemNavigation.attachEvent(a.Events.FocusAgain,p,this),this._oItemNavigation.attachEvent(a.Events.BorderReached,m,this),this.addDelegate(this._oItemNavigation),this._oItemNavigation.setHomeEndColumnMode(!0,!0),this._oItemNavigation.setDisabledModifiers({sapnext:[\"alt\"],sapprevious:[\"alt\"],saphome:[\"alt\"],sapend:[\"alt\"]})),this._oItemNavigation.setRootDomRef(r),this._oItemNavigation.setItemDomRefs(o),this._oItemNavigation.setCycling(!1),this._oItemNavigation.setColumns(this.getColumns(),!0),this._oItemNavigation.setFocusedIndex(n),this._oItemNavigation.setPageSize(o.length)}function l(e){var t=e.getParameter(\"index\"),a=e.getParameter(\"event\");a&&\"mousedown\"==a.type&&g.call(this,a,t)}function p(e){var t=e.getParameter(\"index\"),a=e.getParameter(\"event\");a&&\"mousedown\"==a.type&&g.call(this,a,t)}function g(e,t){if(!e.button){var a=d.call(this,t);a&&(this._bMousedownChange=!0),e.preventDefault(),e.setMark(\"cancelAutoClose\")}}function m(t){var a=t.getParameter(\"event\");if(a.type){var i=this.getYears(),s=this.getColumns();switch(0==s&&(s=i),a.type){case\"sapnext\":case\"sapnextmodifiers\":a.keyCode==e.sap.KeyCodes.ARROW_DOWN&&s<i?y.call(this,!0,this._oItemNavigation.getFocusedIndex()-i+s,!0):y.call(this,!0,0,!0);break;case\"sapprevious\":case\"sappreviousmodifiers\":a.keyCode==e.sap.KeyCodes.ARROW_UP&&s<i?y.call(this,!1,i-s+this._oItemNavigation.getFocusedIndex(),!0):y.call(this,!1,i-1,!0);break;case\"sappagedown\":y.call(this,!0,this._oItemNavigation.getFocusedIndex(),!0);break;case\"sappageup\":y.call(this,!1,this._oItemNavigation.getFocusedIndex(),!0)}}}function d(t){var a=this._oItemNavigation.getItemDomRefs(),i=e(a[t]);if(i.hasClass(\"sapUiCalItemDsbl\"))return!1;for(var s=i.attr(\"data-sap-year-start\"),o=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(s)),n=this.getId()+\"-y\"+s,h=0;h<a.length;h++)i=e(a[h]),i.attr(\"id\")==n?(i.addClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"true\")):(i.removeClass(\"sapUiCalItemSel\"),i.attr(\"aria-selected\",\"false\"));return this.setProperty(\"date\",o.toLocalJSDate(),!0),this.setProperty(\"year\",o.getYear(),!0),!0}function y(t,a,i){var s=this._oItemNavigation.getItemDomRefs(),o=r.fromLocalJSDate(this._oFormatYyyymmdd.parse(e(s[0]).attr(\"data-sap-year-start\")),this.getPrimaryCalendarType()),n=this.getYears();if(t){var h=new r(this._oMaxDate,this.getPrimaryCalendarType());if(h.setYear(h.getYear()-n+1),!o.isBefore(h))return;o.setYear(o.getYear()+n),o.isAfter(h)&&(a+=o.getYear()-h.getYear(),a>n-1&&(a=n-1),o=this._oMaxDate,o.setMonth(0),o.setDate(1))}else{if(!o.isAfter(this._oMinDate))return;o.setYear(o.getYear()-n),o.isBefore(this._oMinDate)&&(a-=this._oMinDate.getYear()-o.getYear(),a<0&&(a=0),o=new r(this._oMinDate,this.getPrimaryCalendarType()))}c.call(this,o,a),i&&this.firePageChange()}function c(t,a){var i,s=this._oFormatYyyymmdd.format(this._getDate().toUTCJSDate(),!0),n=!1,h=this._checkFirstDate(t);h.isSame(t)||(i=new r(t,this.getPrimaryCalendarType()),i.setYear(i.getYear()+a),t=h,n=!0);for(var l=this._oItemNavigation.getItemDomRefs(),p=new r(t,this.getPrimaryCalendarType()),g=0;g<l.length;g++){var m=this._oFormatYyyymmdd.format(p.toUTCJSDate(),!0),d=e(l[g]);d.attr(\"id\",this.getId()+\"-y\"+m),d.text(this._oYearFormat.format(o.getInstance(p.toUTCJSDate(),p.getCalendarType()),!0)),d.attr(\"data-sap-year-start\",m),d.hasClass(\"sapUiCalItemSel\")&&m!=s?(d.removeClass(\"sapUiCalItemSel\"),d.attr(\"aria-selected\",\"false\")):d.hasClass(\"sapUiCalItemSel\")||m!=s||(d.addClass(\"sapUiCalItemSel\"),d.attr(\"aria-selected\",\"true\"));var y=!0;n&&(y=this._checkDateEnabled(p),p.isSame(i)&&(a=g)),y?(d.removeClass(\"sapUiCalItemDsbl\"),d.removeAttr(\"aria-disabled\")):(d.addClass(\"sapUiCalItemDsbl\"),d.attr(\"aria-disabled\",!0)),p.setYear(p.getYear()+1)}this._oItemNavigation.focusItem(a)}var u=t.extend(\"sap.ui.unified.calendar.YearPicker\",{metadata:{library:\"sap.ui.unified\",properties:{year:{type:\"int\",group:\"Data\",defaultValue:2e3},years:{type:\"int\",group:\"Appearance\",defaultValue:20},columns:{type:\"int\",group:\"Appearance\",defaultValue:4},date:{type:\"object\",group:\"Data\"},primaryCalendarType:{type:\"sap.ui.core.CalendarType\",group:\"Appearance\"}},events:{select:{},pageChange:{}}}});return u.prototype.init=function(){var e=sap.ui.getCore().getConfiguration().getCalendarType();this.setProperty(\"primaryCalendarType\",e),this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\",calendarType:e}),this._oFormatYyyymmdd=sap.ui.core.format.DateFormat.getInstance({pattern:\"yyyyMMdd\",calendarType:sap.ui.core.CalendarType.Gregorian}),this._oMinDate=s._minDate(this.getPrimaryCalendarType()),this._oMaxDate=s._maxDate(this.getPrimaryCalendarType())},u.prototype.onAfterRendering=function(){h.call(this)},u.prototype.setYear=function(e){this.setProperty(\"year\",e,!0),e=this.getProperty(\"year\");var t=r.fromLocalJSDate(new Date,this.getPrimaryCalendarType());return t.setDate(1),t.setMonth(0),t.setYear(e),this.setDate(t.toLocalJSDate()),this},u.prototype.setDate=function(e){var t,a,i,o;return e&&s._checkJSDateObject(e),a=e.getFullYear(),s._checkYearInValidRange(a),t=r.fromLocalJSDate(e,this.getPrimaryCalendarType()),t.setMonth(0),t.setDate(1),this.setProperty(\"date\",e,!0),this.setProperty(\"year\",t.getYear(),!0),this._oDate=t,this.getDomRef()&&(i=this.getYears(),o=new r(this._oDate,this.getPrimaryCalendarType()),o.setYear(o.getYear()-Math.floor(i/2)),c.call(this,o,Math.floor(i/2))),this},u.prototype._getDate=function(){if(!this._oDate){var e=this.getYear();this._oDate=new r(e,0,1,this.getPrimaryCalendarType())}return this._oDate},u.prototype.setPrimaryCalendarType=function(e){return this.setProperty(\"primaryCalendarType\",e),this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\",calendarType:e}),this._oDate&&(this._oDate=new r(this._oDate,e),this._oDate.setMonth(0),this._oDate.setDate(1)),this._oMinDate=new r(this._oMinDate,e),this._oMaxDate=new r(this._oMaxDate,e),this},u.prototype.nextPage=function(){return y.call(this,!0,this._oItemNavigation.getFocusedIndex()),this},u.prototype.previousPage=function(){return y.call(this,!1,this._oItemNavigation.getFocusedIndex()),this},u.prototype.onsapspace=function(e){e.preventDefault()},u.prototype.onsapselect=function(e){var t=this._oItemNavigation.getFocusedIndex(),a=d.call(this,t);a&&this.fireSelect()},u.prototype.onmouseup=function(e){this._bMousedownChange&&(this._bMousedownChange=!1,this.fireSelect())},u.prototype.getFirstRenderedDate=function(){var t;if(this.getDomRef()){var a=this._oItemNavigation.getItemDomRefs();t=this._oFormatYyyymmdd.parse(e(a[0]).attr(\"data-sap-year-start\"),!0)}return t},u.prototype._checkFirstDate=function(e){var t=this.getYears(),a=new r(this._oMaxDate,this.getPrimaryCalendarType());return a.setYear(a.getYear()-t+1),e.isAfter(a)&&e.getYear()!=a.getYear()?(e=new r(a,this.getPrimaryCalendarType()),e.setMonth(0),e.setDate(1)):e.isBefore(this._oMinDate)&&e.getYear()!=this._oMinDate.getYear()&&(e=new r(this._oMinDate,this.getPrimaryCalendarType()),e.setMonth(0),e.setDate(1)),e},u.prototype._checkDateEnabled=function(e){var t=!0;return(e.isAfter(this._oMaxDate)&&e.getYear()!=this._oMaxDate.getYear()||e.isBefore(this._oMinDate)&&e.getYear()!=this._oMinDate.getYear())&&(t=!1),t},u},!0);",
		"sap/ui/unified/calendar/YearPickerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarDate\",\"sap/ui/core/date/UniversalDate\"],function(e,t,a){\"use strict\";var r={};return r.render=function(e,r){var i=r.getTooltip_AsString(),s=r.getId(),l=r._getDate(),d=l.getYear(),o=r.getYears(),n=r.getColumns(),w=\"\";e.write(\"<div\"),e.writeControlData(r),e.addClass(\"sapUiCalYearPicker\"),e.writeClasses(),i&&e.writeAttributeEscaped(\"title\",i),e.writeAccessibilityState(r,{role:\"grid\",readonly:\"true\",multiselectable:\"false\"}),e.write(\">\");var c=new t(l,r.getPrimaryCalendarType());c.setYear(c.getYear()-Math.floor(o/2));var u=!1,C=r._checkFirstDate(c);C.isSame(c)||(c=C,u=!0),w=n>0?100/n+\"%\":100/o+\"%\";for(var g=0;g<o;g++){var y=r._oFormatYyyymmdd.format(c.toUTCJSDate(),!0),b={role:\"gridcell\"},m=!0;u&&(m=r._checkDateEnabled(c)),n>0&&g%n==0&&(e.write(\"<div\"),e.writeAccessibilityState(null,{role:\"row\"}),e.write(\">\")),e.write(\"<div\"),e.writeAttribute(\"id\",s+\"-y\"+y),e.addClass(\"sapUiCalItem\"),c.getYear()==d?(e.addClass(\"sapUiCalItemSel\"),b.selected=!0):b.selected=!1,m||(e.addClass(\"sapUiCalItemDsbl\"),b.disabled=!0),e.writeAttribute(\"tabindex\",\"-1\"),e.writeAttribute(\"data-sap-year-start\",y),e.addStyle(\"width\",w),e.writeClasses(),e.writeStyles(),e.writeAccessibilityState(null,b),e.write(\">\"),e.write(r._oYearFormat.format(a.getInstance(c.toUTCJSDate(),c.getCalendarType()),!0)),e.write(\"</div>\"),c.setYear(c.getYear()+1),n>0&&(g+1)%n==0&&e.write(\"</div>\")}e.write(\"</div>\")},r},!0);",
		"sap/ui/unified/CalendarAppointment.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./DateTypeRange\",\"sap/ui/core/format/DateFormat\",\"./library\"],function(e,t,a,r){\"use strict\";var n=t.extend(\"sap.ui.unified.CalendarAppointment\",{metadata:{library:\"sap.ui.unified\",properties:{title:{type:\"string\",group:\"Data\"},text:{type:\"string\",group:\"Data\"},icon:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},tentative:{type:\"boolean\",group:\"Data\",defaultValue:!1},selected:{type:\"boolean\",group:\"Data\",defaultValue:!1},key:{type:\"string\",group:\"Data\",defaultValue:null},color:{type:\"sap.ui.core.CSSColor\",group:\"Appearance\",defaultValue:null}}}});return n.prototype.applyFocusInfo=function(e){var t=this.getParent();return t&&t.applyFocusInfo(e),this},n.prototype._getDateRangeIntersectionText=function(e){var t,r=this.getStartDate(),n=this.getEndDate()?this.getEndDate():new Date(864e12),o=new Date(e.getFullYear(),e.getMonth(),e.getDate(),0,0,0),i=new Date(o.getTime()+864e5),p=a.getTimeInstance({pattern:\"HH:mm\"}),g=sap.ui.getCore().getLibraryResourceBundle(\"sap.m\");return t=r.getTime()>i.getTime()||n.getTime()<o.getTime()?\"\":r.getTime()<o.getTime()&&n.getTime()>i.getTime()?g.getText(\"PLANNINGCALENDAR_ALLDAY\"):r.getTime()<o.getTime()?g.getText(\"PLANNINGCALENDAR_UNTIL\",[p.format(n)]):n.getTime()>i.getTime()?p.format(r):p.format(r)+\" - \"+p.format(n)},n._getComparer=function(e){var t=864e5,a=new Date(e.getFullYear(),e.getMonth(),e.getDate(),0,0,0).getTime(),r=a+t;return function(e,t){var n,o=e.appointment.getStartDate().getTime(),i=t.appointment.getStartDate().getTime(),p=e.appointment.getEndDate()?e.appointment.getEndDate().getTime():864e12,g=t.appointment.getEndDate()?t.appointment.getEndDate().getTime():864e12,u=o<=a&&p>=r,l=i<=a&&g>=r;return u&&l||!u&&!l?(n=o-i,0===n&&(n=g-p)):n=u?-1:1,n}},n.prototype.setColor=function(t){return t&&t.match(/^#[0-9a-f]{6}$/i)&&e.sap.log.warning(\"setColor accepts only full hex color value with pound symbol.\"),this.setProperty(\"color\",t)},n.prototype._getCSSColorForBackground=function(e){return\"rgba(\"+[parseInt(e.substr(1,2),16),parseInt(e.substr(3,2),16),parseInt(e.substr(5,2),16)].join(\",\")+\", 0.2)\"},n},!0);",
		"sap/ui/unified/CalendarDateInterval.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"./Calendar\",\"./calendar/Header\",\"./calendar/Month\",\"./calendar/DatesRow\",\"./calendar/MonthPicker\",\"./calendar/YearPicker\",\"sap/ui/unified/calendar/CalendarDate\",\"./library\"],function(t,e,a,s,r,i,o,n,h,g,p,D,u){\"use strict\";function c(t){this._closedPickers()}function d(t){var e=new D(this._getFocusedDate(),this.getPrimaryCalendarType());this._togglePrevNext(e)}function _(t){this._togglePrevNexYearPicker()}var l=i.extend(\"sap.ui.unified.CalendarDateInterval\",{metadata:{library:\"sap.ui.unified\",properties:{startDate:{type:\"object\",group:\"Data\"},days:{type:\"int\",group:\"Appearance\",defaultValue:7},showDayNamesLine:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},pickerPopup:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}}}});return l.prototype.init=function(){i.prototype.init.apply(this,arguments);var t=this.getAggregation(\"monthPicker\");t.setColumns(0),t.setMonths(3),t.attachEvent(\"pageChange\",d,this);var e=this.getAggregation(\"yearPicker\");e.setColumns(0),e.setYears(3),e.attachEvent(\"pageChange\",_,this),this._iDaysMonthHead=35},l.prototype._getDaysLarge=function(){return 10},l.prototype._createMonth=function(t){var e=new h(t);return e},l.prototype.setStartDate=function(e){if(r._checkJSDateObject(e),t.sap.equal(this.getStartDate(),e))return this;var a=e.getFullYear();r._checkYearInValidRange(a);var s=D.fromLocalJSDate(e,this.getPrimaryCalendarType());if(r._isOutside(s,this._oMinDate,this._oMaxDate))throw new Error(\"Date must be in valid range (minDate and maxDate); \"+this);var i=this.getMinDate();i&&e.getTime()<i.getTime()&&(t.sap.log.warning(\"startDate < minDate -> minDate as startDate set\",this),e=new Date(i.getTime()));var o=this.getMaxDate();o&&e.getTime()>o.getTime()&&(t.sap.log.warning(\"startDate > maxDate -> maxDate as startDate set\",this),e=new Date(o.getTime())),this.setProperty(\"startDate\",e,!0),s=D.fromLocalJSDate(e,this.getPrimaryCalendarType()),this._oStartDate=s;var n=this.getAggregation(\"month\")[0];n.setStartDate(e),this._updateHeader(s);var h=this._getFocusedDate(!0).toLocalJSDate();return n.checkDateFocusable(h)||(this._setFocusedDate(s),n.displayDate(e)),this},l.prototype.getStartDate=function(){return this.getProperty(\"startDate\")},l.prototype.setDays=function(t){this.setProperty(\"days\",t,!0),t=this._getDays();var e=this.getAggregation(\"month\")[0];if(e.setDays(t),!this.getPickerPopup()){var a=this.getAggregation(\"monthPicker\"),s=Math.ceil(t/3);s>12&&(s=12),a.setMonths(s);var r=this.getAggregation(\"yearPicker\"),i=Math.floor(t/2);i>20&&(i=20),r.setYears(i)}var o=this._getStartDate();return this._updateHeader(o),this.getDomRef()&&(t>this._getDaysLarge()?this.$().addClass(\"sapUiCalIntLarge\"):this.$().removeClass(\"sapUiCalIntLarge\"),t>this._iDaysMonthHead?this.$().addClass(\"sapUiCalIntHead\"):this.$().removeClass(\"sapUiCalIntHead\")),this},l.prototype._getDays=function(){var t=this.getDays();return sap.ui.Device.system.phone&&t>8?8:t},l.prototype.setShowDayNamesLine=function(t){this.setProperty(\"showDayNamesLine\",t,!0);var e=this.getAggregation(\"month\")[0];return e.setShowDayNamesLine(t),this},l.prototype._getShowMonthHeader=function(){var t=this._getDays();return t>this._iDaysMonthHead},l.prototype._getFocusedDate=function(t){if(!this._oFocusedDate||t){this._oFocusedDate=null,i.prototype._getFocusedDate.apply(this,arguments);var e=this.getStartDate(),a=this.getAggregation(\"month\")[0];e?a.checkDateFocusable(this._oFocusedDate.toLocalJSDate())||(this._oFocusedDate=D.fromLocalJSDate(e,this.getPrimaryCalendarType())):this._setStartDate(this._oFocusedDate,!1,!0)}return this._oFocusedDate},l.prototype.setMonths=function(t){if(1==t)return this.setProperty(\"months\",t,!1);throw new Error(\"Property months not supported \"+this)},l.prototype.setFirstDayOfWeek=function(t){if(t==-1)return this.setProperty(\"firstDayOfWeek\",t,!1);throw new Error(\"Property firstDayOfWeek not supported \"+this)},l.prototype.focusDate=function(t){var e=this.getAggregation(\"month\")[0];return e.checkDateFocusable(t)||this._focusDateExtend(D.fromLocalJSDate(t,this.getPrimaryCalendarType()),!0,!0),i.prototype.focusDate.apply(this,arguments),this},l.prototype._focusDateExtend=function(t,e,a){if(e){var s=this._getFocusedDate(),i=this._getStartDate(),o=r._daysBetween(s,i),n=new D(t,this.getPrimaryCalendarType());if(n.setDate(n.getDate()-o),this._setStartDate(n,!1,!0),!a)return!0}return!1},l.prototype._setMinMaxDateExtend=function(e){if(this._oStartDate)if(this._oStartDate.isBefore(this._oMinDate))t.sap.log.warning(\"start date < minDate -> minDate will be start date\",this),this._setStartDate(new D(this._oMinDate,this.getPrimaryCalendarType()),!0,!0);else{var a=new D(this._oStartDate);if(a.setDate(a.getDate()+this._getDays()-1),a.isAfter(this._oMaxDate)){t.sap.log.warning(\"end date > maxDate -> start date will be changed\",this);var s=new D(this._oMaxDate);s.setDate(s.getDate()-this._getDays()+1),this._setStartDate(s,!0,!0)}}},l.prototype.setPickerPopup=function(t){this.setProperty(\"pickerPopup\",t,!0);var e=this.getAggregation(\"monthPicker\"),a=this.getAggregation(\"yearPicker\");return t?(e.setColumns(3),e.setMonths(12),a.setColumns(4),a.setYears(20)):(e.setColumns(0),e.setMonths(6),a.setColumns(0),a.setYears(6)),this},l.prototype._togglePrevNext=function(t,e){if(this._iMode>1||1==this._iMode&&this.getPickerPopup())return i.prototype._togglePrevNext.apply(this,arguments);var a,s,o,n,h,g=this._oMaxDate.getYear(),p=this._oMinDate.getYear(),u=this._oMaxDate.getMonth(),c=this._oMinDate.getMonth(),d=this._oMinDate.getDate(),_=this._oMaxDate.getDate(),l=this.getAggregation(\"header\"),y=this._getDays();if(1==this._iMode&&!e){var f=this.getAggregation(\"monthPicker\"),P=f.getMonths(),m=f.getStartMonth(),v=m+P-1;return a=t.getYear(),0==m||a==p&&m<=c?l.setEnabledPrevious(!1):l.setEnabledPrevious(!0),void(v>10||a==g&&v>=u?l.setEnabledNext(!1):l.setEnabledNext(!0))}s=this._getStartDate(),o=new D(s,this.getPrimaryCalendarType()),o.setDate(o.getDate()+y-1),r._isOutside(t,s,o)&&(s=new D(t,this.getPrimaryCalendarType()),o=new D(s,this.getPrimaryCalendarType()),o.setDate(o.getDate()+y-1)),a=s.getYear(),n=s.getMonth(),h=s.getDate(),a<p||a==p&&(!e||n<c||n==c&&h<=d)?l.setEnabledPrevious(!1):l.setEnabledPrevious(!0),a=o.getYear(),n=o.getMonth(),h=o.getDate(),a>g||a==g&&(!e||n>u||n==u&&h>=_)?l.setEnabledNext(!1):l.setEnabledNext(!0)},l.prototype._shiftStartFocusDates=function(t,e,a){t.setDate(t.getDate()+a),e.setDate(e.getDate()+a),this._setFocusedDate(e),this._setStartDate(t,!0)},l.prototype._handlePrevious=function(t){var e=new D(this._getFocusedDate(),this.getPrimaryCalendarType()),a=this.getAggregation(\"monthPicker\"),s=this.getAggregation(\"yearPicker\"),r=new D(this._getStartDate(),this.getPrimaryCalendarType()),i=this._getDays();switch(this._iMode){case 0:this._shiftStartFocusDates(r,e,i*-1);break;case 1:if(a.getMonths()<12)a.previousPage(),this._togglePrevNext(e);else{e.setYear(e.getYear()-1);var o=this._focusDateExtend(e,!0,!1);this._setFocusedDate(e),this._updateHeader(e),this._setDisabledMonths(e.getYear()),o&&this.fireStartDateChange()}break;case 2:s.previousPage(),this._togglePrevNexYearPicker()}},l.prototype._handleNext=function(t){var e=new D(this._getFocusedDate(),this.getPrimaryCalendarType()),a=this.getAggregation(\"monthPicker\"),s=this.getAggregation(\"yearPicker\"),r=new D(this._getStartDate(),this.getPrimaryCalendarType()),i=this._getDays();switch(this._iMode){case 0:this._shiftStartFocusDates(r,e,i);break;case 1:if(a.getMonths()<12)a.nextPage(),this._togglePrevNext(e);else{e.setYear(e.getYear()+1);var o=this._focusDateExtend(e,!0,!1);this._setFocusedDate(e),this._updateHeader(e),this._setDisabledMonths(e.getYear()),o&&this.fireStartDateChange()}break;case 2:s.nextPage(),this._togglePrevNexYearPicker()}},l.prototype._getDisplayedMonths=function(t){var e=[],a=t.getMonth(),s=this._getDays();if(e.push(a),s>this._getDaysLarge()){var r=new D(t,this.getPrimaryCalendarType());r.setDate(r.getDate()+s-1);for(var i=r.getMonth();a!=i;)a=(a+1)%12,e.push(a)}return e},l.prototype._getDisplayedSecondaryMonths=function(t,e){var a=this._getDays(),s=new D(this._getStartDate(),e),r=s.getMonth(),i=new D(s,this.getPrimaryCalendarType());i.setDate(i.getDate()+a-1),i=new D(i,e);var o=i.getMonth();return{start:r,end:o}},l.prototype._openPickerPopup=function(e){this._oPopup||(t.sap.require(\"sap.ui.core.Popup\"),this._oPopup=new sap.ui.core.Popup,this._oPopup.setAutoClose(!0),this._oPopup.setAutoCloseAreas([this.getDomRef()]),this._oPopup.setDurations(0,0),this._oPopup._oCalendar=this,this._oPopup.attachClosed(c,this),this._oPopup.onsapescape=function(t){this._oCalendar.onsapescape(t)}),this._oPopup.setContent(e);var a=this.getAggregation(\"header\"),s=sap.ui.core.Popup.Dock;this._oPopup.open(0,s.CenterTop,s.CenterBottom,a,null,\"flipfit\",!0)},l.prototype._setStartDate=function(t,e,a){var s=new D(this._oMaxDate,this.getPrimaryCalendarType());s.setDate(s.getDate()-this._getDays()+1),s.isBefore(this._oMinDate)&&(s=new D(this._oMinDate),s.setDate(s.getDate()+this._getDays()-1)),t.isBefore(this._oMinDate)?t=new D(this._oMinDate,this.getPrimaryCalendarType()):t.isAfter(s)&&(t=s);var r=t.toLocalJSDate();this.setProperty(\"startDate\",r,!0),this._oStartDate=t;var i=this.getAggregation(\"month\")[0];if(i.setStartDate(r),this._updateHeader(t),e){var o=this._getFocusedDate().toLocalJSDate();i.checkDateFocusable(o)?i.setDate(o):(this._setFocusedDate(t),i.setDate(r))}a||this.fireStartDateChange()},l.prototype._getStartDate=function(){return this._oStartDate||(this._oStartDate=this._getFocusedDate()),this._oStartDate},l},!0);",
		"sap/ui/unified/CalendarDateIntervalRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"./CalendarRenderer\"],function(a,e,s){\"use strict\";var d=e.extend(s);return d.addAttributes=function(a,e){a.addClass(\"sapUiCalInt\"),a.addClass(\"sapUiCalDateInt\");var s=e._getDays();s>e._getDaysLarge()&&a.addClass(\"sapUiCalIntLarge\"),s>e._iDaysMonthHead&&a.addClass(\"sapUiCalIntHead\")},d},!0);",
		"sap/ui/unified/CalendarLegend.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"./library\"],function(e,t,i){\"use strict\";var n=t.extend(\"sap.ui.unified.CalendarLegend\",{metadata:{library:\"sap.ui.unified\",properties:{columnWidth:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:\"120px\"}},aggregations:{items:{type:\"sap.ui.unified.CalendarLegendItem\",multiple:!0,singularName:\"item\"},standardItems:{type:\"sap.ui.unified.CalendarLegendItem\",multiple:!0,visibility:\"hidden\"}}}});return n.prototype.init=function(){var e=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),t=this.getId(),i=new sap.ui.unified.CalendarLegendItem(t+\"-Today\",{text:e.getText(\"LEGEND_TODAY\")});this.addAggregation(\"standardItems\",i),i=new sap.ui.unified.CalendarLegendItem(t+\"-Selected\",{text:e.getText(\"LEGEND_SELECTED\")}),this.addAggregation(\"standardItems\",i),i=new sap.ui.unified.CalendarLegendItem(t+\"-NormalDay\",{text:e.getText(\"LEGEND_NORMAL_DAY\")}),this.addAggregation(\"standardItems\",i),i=new sap.ui.unified.CalendarLegendItem(t+\"-NonWorkingDay\",{text:e.getText(\"LEGEND_NON_WORKING_DAY\")}),this.addAggregation(\"standardItems\",i)},n.prototype.onAfterRendering=function(){sap.ui.Device.browser.msie&&sap.ui.Device.browser.version<10&&e(\".sapUiUnifiedLegendItem\").css(\"width\",this.getColumnWidth()+4+\"px\").css(\"display\",\"inline-block\")},n.prototype._getItemType=function(t){var i,n,a=this.getItems(),r=t.getType();return r&&r!==sap.ui.unified.CalendarDayType.None?r:(n=this._getUnusedItemTypes(),i=a.filter(function(e){return!e.getType()||e.getType()===sap.ui.unified.CalendarDayType.None}).indexOf(t),i<0?(e.sap.log.error(\"Legend item is not in the legend\",this),r):r=n[i]?n[i]:\"Type\"+(Object.keys(sap.ui.unified.CalendarDayType).length+i-n.length-1))},n.prototype._getItemByType=function(e){var t,i,n=this.getItems();for(i=0;i<n.length;i++)if(this._getItemType(n[i])===e){t=n[i];break}return t},n.prototype._getUnusedItemTypes=function(){var t,i,n=e.extend({},sap.ui.unified.CalendarDayType),a=this.getItems();for(delete n[sap.ui.unified.CalendarDayType.None],delete n[sap.ui.unified.CalendarDayType.NonWorking],i=0;i<a.length;i++)t=a[i].getType(),n[t]&&delete n[t];return Object.keys(n)},n.typeARIATexts={},n.getTypeAriaText=function(e){var t,i;if(0===e.indexOf(\"Type\"))return n.typeARIATexts[e]||(t=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),i=t.getText(\"LEGEND_UNNAMED_TYPE\",parseInt(e.slice(4),10).toString()),n.typeARIATexts[e]=new sap.ui.core.InvisibleText({text:i}),n.typeARIATexts[e].toStatic()),n.typeARIATexts[e]},n},!0);",
		"sap/ui/unified/CalendarLegendItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(e,a,u){\"use strict\";var r=a.extend(\"sap.ui.unified.CalendarLegendItem\",{metadata:{library:\"sap.ui.unified\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null},type:{type:\"sap.ui.unified.CalendarDayType\",group:\"Appearance\",defaultValue:sap.ui.unified.CalendarDayType.None},color:{type:\"sap.ui.core.CSSColor\",group:\"Appearance\",defaultValue:null}}}});return r},!0);",
		"sap/ui/unified/CalendarLegendRenderer.js": "/*\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var i=t.getAggregation(\"standardItems\"),r=t.getItems(),d=0;e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiUnifiedLegend\"),e.writeClasses();var s=t.getColumnWidth();e.writeAttribute(\"style\",\"column-width:\"+s+\";-moz-column-width:\"+s+\";-webkit-column-width:\"+s+\";\"),e.writeStyles(),e.write(\">\");var a=t.getId().length+1;for(d=0;d<i.length;++d){var n=\"sapUiUnifiedLegend\"+i[d].getId().slice(a);this.renderLegendItem(e,n,i[d])}for(d=0;d<r.length;d++)this.renderLegendItem(e,\"sapUiCalLegDayType\"+t._getItemType(r[d]).slice(4),r[d]);e.write(\"</div>\")},t.renderLegendItem=function(e,t,i){var r=i.getText(),d=i.getTooltip_AsString(),s=i.getColor();e.write(\"<div\"),e.writeElementData(i),d&&e.writeAttributeEscaped(\"title\",d),e.addClass(\"sapUiUnifiedLegendItem\"),e.addClass(t),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.addClass(\"sapUiUnifiedLegendSquare\"),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.addClass(\"sapUiUnifiedLegendSquareColor\"),s&&(e.addStyle(\"background-color\",s),e.writeStyles()),e.writeClasses(),e.write(\"></div></div>\"),e.write(\"<div\"),e.writeAttribute(\"id\",i.getId()+\"-Text\"),e.addClass(\"sapUiUnifiedLegendDescription\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(r),e.write(\"</div></div>\")},t},!0);",
		"sap/ui/unified/CalendarMonthInterval.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"./calendar/Header\",\"./calendar/MonthsRow\",\"./calendar/MonthPicker\",\"./calendar/YearPicker\",\"sap/ui/unified/calendar/CalendarDate\",\"./library\"],function(t,e,a,i,o,s,n,r,h,g,c){\"use strict\";function l(t,e,a){var i=new g(this._oMaxDate);i.setDate(1),i.setMonth(i.getMonth()-this._getMonths()+1),i.isBefore(this._oMinDate)&&(i=new g(this._oMinDate),i.setMonth(i.getMonth()+this._getMonths()-1)),t.isBefore(this._oMinDate)?t=new g(this._oMinDate):t.isAfter(i)&&(t=i),t.setDate(1);var o=t.toLocalJSDate();this.setProperty(\"startDate\",o,!0),this._oStartDate=t;var s=this.getAggregation(\"monthsRow\");if(s.setStartDate(o),f.call(this),e){var n=this._getFocusedDate().toLocalJSDate();s.checkDateFocusable(n)?s.setDate(n):(this._setFocusedDate(t),s.setDate(o))}a||this.fireStartDateChange()}function u(){return this._oStartDate||(this._oStartDate=this._getFocusedDate(),this._oStartDate.setDate(1)),this._oStartDate}function D(t){var e=this._getFocusedDate(),a=this.getAggregation(\"monthsRow\");t?a.displayDate(e.toLocalJSDate()):a.setDate(e.toLocalJSDate()),f.call(this)}function d(){var t=this.getSelectedDates();t&&t[0]&&t[0].getStartDate()?this._oFocusedDate=g.fromLocalJSDate(t[0].getStartDate()):this._oFocusedDate=new g,this._oFocusedDate.setDate(1),this._oFocusedDate.isBefore(this._oMinDate)?this._oFocusedDate=new g(this._oMinDate):this._oFocusedDate.isAfter(this._oMaxDate)&&(this._oFocusedDate=new g(this._oMaxDate))}function p(){var e=this._getFocusedDate(),a=this.getAggregation(\"yearPicker\");if(this.getPickerPopup())F.call(this,a);else if(a.getDomRef())a.$().css(\"display\",\"\");else{var i=sap.ui.getCore().createRenderManager(),o=this.$(\"content\");i.renderControl(a),i.flush(o[0],!1,!0),i.destroy()}if(this.$(\"contentOver\").css(\"display\",\"\"),a.setDate(e.toLocalJSDate()),0==this._iMode){var s=this.getAggregation(\"monthsRow\");t(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}v.call(this),this._iMode=1}function _(e){if(this._iMode=0,this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"yearPicker\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!e){D.call(this);var i=this.getAggregation(\"monthsRow\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}function f(){M.call(this),m.call(this)}function m(){var t=new g(u.call(this)),e=this._getMonths(),a=t.getYear(),i=this._oMaxDate.getYear(),o=this._oMinDate.getYear(),s=t.getMonth(),n=this._oMaxDate.getMonth(),r=this._oMinDate.getMonth(),h=this.getAggregation(\"header\");a<o||a==o&&s<=r?h.setEnabledPrevious(!1):h.setEnabledPrevious(!0),t.setMonth(t.getMonth()+e-1),a=t.getYear(),s=t.getMonth(),a>i||a==i&&s>=n?h.setEnabledNext(!1):h.setEnabledNext(!0)}function v(){var t=this.getAggregation(\"yearPicker\"),e=t.getYears(),a=g.fromLocalJSDate(t.getFirstRenderedDate());a.setYear(a.getYear()+Math.floor(e/2));var i=this.getAggregation(\"header\"),o=new g(this._oMaxDate);o.setYear(o.getYear()-Math.ceil(e/2)),o.setMonth(11,31);var s=new g(this._oMinDate);s.setYear(s.getYear()+Math.floor(e/2)+1),s.setMonth(0,1),i.setEnabledNext(!a.isAfter(o)),i.setEnabledPrevious(!a.isBefore(s))}function M(){var t,e=u.call(this),a=this._oYearFormat.format(e.toUTCJSDate(),!0),i=new g(e);i.setMonth(i.getMonth()+this._getMonths()-1);var o=this._oYearFormat.format(i.toUTCJSDate(),!0);if(a!=o){var s=this._getLocaleData(),n=s.getIntervalPattern();t=n.replace(/\\{0\\}/,a).replace(/\\{1\\}/,o)}else t=a;var r=this.getAggregation(\"header\");r.setTextButton2(t)}function y(t,e){var a,i=!1;t.isBefore(this._oMinDate)?(a=this._oMinDate,i=!0):t.isAfter(this._oMaxDate)?(a=this._oMaxDate,i=!0):a=t,this._setFocusedDate(a),(i||e)&&(A.call(this,a),D.call(this,!1),this.fireStartDateChange())}function x(t,e){if(t){var a=g.fromLocalJSDate(t);if(!this._oFocusedDate||!this._oFocusedDate.isSame(a)){var i=a.getYear();if(o._checkYearInValidRange(i),o._isOutside(a,this._oMinDate,this._oMaxDate))throw new Error(\"Date must not be in valid range (minDate and maxDate); \"+this);this._setFocusedDate(a),this.getDomRef()&&0==this._iMode&&D.call(this,e)}}}function I(t){1!=this._iMode?p.call(this):_.call(this)}function P(t){this.fireSelect()}function S(t){var e=g.fromLocalJSDate(t.getParameter(\"date\")),a=t.getParameter(\"notVisible\");y.call(this,e,a)}function b(t){var e=new g(this._getFocusedDate()),a=this.getAggregation(\"yearPicker\"),i=g.fromLocalJSDate(a.getDate());i.setMonth(e.getMonth()),i.setDate(e.getDate()),e=i,y.call(this,e,!0),_.call(this)}function w(){this._sInvalidateContent=void 0;var t=this.getAggregation(\"monthsRow\");t._bDateRangeChanged=!0,t._bInvalidateSync=!0,t.invalidate(),t._bInvalidateSync=void 0,this._bDateRangeChanged=void 0}function A(t){var e=this.getAggregation(\"monthsRow\"),a=u.call(this),i=e._oItemNavigation.getFocusedIndex();a=new g(t),a.setMonth(a.getMonth()-i),l.call(this,a,!1,!0)}function F(e){this._oPopup||(t.sap.require(\"sap.ui.core.Popup\"),this._oPopup=new sap.ui.core.Popup,this._oPopup.setAutoClose(!0),this._oPopup.setAutoCloseAreas([this.getDomRef()]),this._oPopup.setDurations(0,0),this._oPopup._oCalendar=this,this._oPopup.attachClosed(R,this),this._oPopup.onsapescape=function(t){this._oCalendar.onsapescape(t)}),this._oPopup.setContent(e);var a=this.getAggregation(\"header\"),i=sap.ui.core.Popup.Dock;this._oPopup.open(0,i.CenterTop,i.CenterBottom,a,null,\"flipfit\",!0)}function R(t){switch(this._iMode){case 0:break;case 1:_.call(this)}}function C(t){v.call(this)}var k=e.extend(\"sap.ui.unified.CalendarMonthInterval\",{metadata:{library:\"sap.ui.unified\",properties:{width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},startDate:{type:\"object\",group:\"Data\"},intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},months:{type:\"int\",group:\"Appearance\",defaultValue:12},pickerPopup:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},minDate:{type:\"object\",group:\"Misc\",defaultValue:null},maxDate:{type:\"object\",group:\"Misc\",defaultValue:null}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"},header:{type:\"sap.ui.unified.calendar.Header\",multiple:!1,visibility:\"hidden\"},monthsRow:{type:\"sap.ui.unified.calendar.MonthsRow\",multiple:!1,visibility:\"hidden\"},yearPicker:{type:\"sap.ui.unified.calendar.YearPicker\",multiple:!1,visibility:\"hidden\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},cancel:{},startDateChange:{}}}});return k.prototype.init=function(){this._iMode=0,this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\"}),this._oMinDate=o._minDate(),this._oMaxDate=o._maxDate();var t=new s(this.getId()+\"--Head\",{visibleButton0:!1,visibleButton1:!1,visibleButton2:!0});t.attachEvent(\"pressPrevious\",this._handlePrevious,this),t.attachEvent(\"pressNext\",this._handleNext,this),t.attachEvent(\"pressButton2\",I,this),this.setAggregation(\"header\",t);var e=new n(this.getId()+\"--MonthsRow\");e.attachEvent(\"focus\",S,this),e.attachEvent(\"select\",P,this),e._bNoThemeChange=!0,this.setAggregation(\"monthsRow\",e);var a=new h(this.getId()+\"--YP\",{columns:0,years:6});a.attachEvent(\"select\",b,this),a.attachEvent(\"pageChange\",C,this),this.setAggregation(\"yearPicker\",a),this._iDaysMonthsHead=15},k.prototype.exit=function(){this._sInvalidateContent&&t.sap.clearDelayedCall(this._sInvalidateContent)},k.prototype.onBeforeRendering=function(){var t=this.getAggregation(\"monthsRow\"),e=this._getFocusedDate();f.call(this),t.displayDate(e.toLocalJSDate())},k.prototype.setStartDate=function(e){if(o._checkJSDateObject(e),t.sap.equal(this.getStartDate(),e))return this;var a=e.getFullYear();o._checkYearInValidRange(a),this.setProperty(\"startDate\",e,!0),this._oStartDate=g.fromLocalJSDate(e),this._oStartDate.setDate(1);var i=this.getAggregation(\"monthsRow\");i.setStartDate(e),f.call(this);var s=this._getFocusedDate().toLocalJSDate();return i.checkDateFocusable(s)||(this._setFocusedDate(this._oStartDate),i.displayDate(e)),this},k.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&0==this._iMode&&!this._sInvalidateContent&&(this._sInvalidateContent=t.sap.delayedCall(0,this,w)):e.prototype.invalidate.apply(this,arguments)},k.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"selectedDates\");return t},k.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"selectedDates\");return t},k.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"specialDates\");return t},k.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"specialDates\");return t},k.prototype.setLocale=function(t){return this._sLocale!=t&&(this._sLocale=t,this._oLocaleData=void 0,this.invalidate()),this},k.prototype.getLocale=function(){return this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale},k.prototype._getFocusedDate=function(){return this._oFocusedDate||d.call(this),this._oFocusedDate},k.prototype._setFocusedDate=function(t){o._checkCalendarDate(t),this._oFocusedDate=new g(t)},k.prototype.focusDate=function(t){var e=!1,a=this.getAggregation(\"monthsRow\");return t&&!a.checkDateFocusable(t)&&(A.call(this,g.fromLocalJSDate(t)),e=!0),x.call(this,t,!1),e&&this.fireStartDateChange(),this},k.prototype.displayDate=function(t){return x.call(this,t,!0),this},k.prototype.setMonths=function(t){this.setProperty(\"months\",t,!0),t=this._getMonths();var e=this.getAggregation(\"monthsRow\");if(e.setMonths(t),!e.checkDateFocusable(this._getFocusedDate().toLocalJSDate())){var a=u.call(this);this._setFocusedDate(this._oStartDate),e.setDate(a.toLocalJSDate())}if(!this.getPickerPopup()){var i=this.getAggregation(\"yearPicker\"),o=Math.floor(t/2);o>20&&(o=20),i.setYears(o)}return f.call(this),this.getDomRef()&&(this._getShowItemHeader()?this.$().addClass(\"sapUiCalIntHead\"):this.$().removeClass(\"sapUiCalIntHead\")),this},k.prototype._getMonths=function(){var t=this.getMonths();return sap.ui.Device.system.phone&&t>6?6:t},k.prototype._getLocaleData=function(){if(!this._oLocaleData){var t=this.getLocale(),e=new sap.ui.core.Locale(t);this._oLocaleData=a.getInstance(e)}return this._oLocaleData},k.prototype.setPickerPopup=function(t){this.setProperty(\"pickerPopup\",t,!0);var e=this.getAggregation(\"yearPicker\");return t?(e.setColumns(4),e.setYears(20)):(e.setColumns(0),e.setYears(6)),this},k.prototype.setMinDate=function(e){if(t.sap.equal(e,this.getMinDate()))return this;if(e){o._checkJSDateObject(e),this._oMinDate=g.fromLocalJSDate(e),this._oMinDate.setDate(1);var a=this._oMinDate.getYear();o._checkYearInValidRange(a),this._oMaxDate.isBefore(this._oMinDate)&&(t.sap.log.warning(\"minDate > maxDate -> maxDate set to end of the month\",this),this._oMaxDate=g.fromLocalJSDate(e),this._oMaxDate.setDate(o._daysInMonth(this._oMaxDate)),this.setProperty(\"maxDate\",this._oMaxDate.toLocalJSDate(),!0)),this._oFocusedDate&&this._oFocusedDate.isBefore(this._oMinDate)&&(t.sap.log.warning(\"focused date < minDate -> minDate focused\",this),this.focusDate(e)),this._oStartDate&&this._oStartDate.isBefore(this._oMinDate)&&(t.sap.log.warning(\"start date < minDate -> minDate set as start date\",this),l.call(this,new g(this._oMinDate),!0,!0))}else this._oMinDate=o._minDate();this.setProperty(\"minDate\",e,!1);var i=this.getAggregation(\"yearPicker\");return i._oMinDate.setYear(this._oMinDate.getYear()),this},k.prototype.setMaxDate=function(e){if(t.sap.equal(e,this.getMaxDate()))return this;if(e){o._checkJSDateObject(e),this._oMaxDate=g.fromLocalJSDate(e),this._oMaxDate.setDate(o._daysInMonth(this._oMaxDate));var a=this._oMaxDate.getYear();if(o._checkYearInValidRange(a),this._oMinDate.isAfter(this._oMaxDate)&&(t.sap.log.warning(\"maxDate < minDate -> minDate set to begin of the month\",this),this._oMinDate=g.fromLocalJSDate(e),this._oMinDate.setDate(1),this.setProperty(\"minDate\",this._oMinDate.toLocalJSDate(),!0)),this._oFocusedDate&&this._oFocusedDate.isAfter(this._oMaxDate)&&(t.sap.log.warning(\"focused date > maxDate -> maxDate focused\",this),this.focusDate(e)),this._oStartDate){var i=new g(this._oStartDate);if(i.setDate(1),i.setMonth(i.getMonth()+this._getMonths()),i.setDate(0),i.isAfter(this._oMaxDate)){var s=new g(this._oMaxDate);s.setDate(1),s.setMonth(s.getMonth()-this._getMonths()+1),s.isSameOrAfter(this._oMinDate)&&(t.sap.log.warning(\"end date > maxDate -> maxDate set as end date\",this),l.call(this,s,!0,!0))}}}else this._oMaxDate=o._maxDate();this.setProperty(\"maxDate\",e,!1);var n=this.getAggregation(\"yearPicker\");return n._oMaxDate.setYear(this._oMaxDate.getYear()),this},k.prototype.onclick=function(t){t.isMarked(\"delayedMouseEvent\")||t.target.id==this.getId()+\"-cancel\"&&this.onsapescape(t)},k.prototype.onmousedown=function(t){t.preventDefault(),t.setMark(\"cancelAutoClose\")},k.prototype.onsapescape=function(t){switch(this._iMode){case 0:this.fireCancel();break;case 1:_.call(this)}},k.prototype.onsaptabnext=function(e){var a=this.getAggregation(\"header\");if(t.sap.containsOrEquals(this.getDomRef(\"content\"),e.target)){if(t.sap.focus(a.getDomRef(\"B2\")),!this._bPoupupMode){var i=this.getAggregation(\"monthsRow\"),o=this.getAggregation(\"yearPicker\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),o.getDomRef()&&t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}e.preventDefault()}},k.prototype.onsaptabprevious=function(e){var a=this.getAggregation(\"header\");if(t.sap.containsOrEquals(this.getDomRef(\"content\"),e.target))this._bPoupupMode&&(t.sap.focus(a.getDomRef(\"B2\")),e.preventDefault());else if(e.target.id==a.getId()+\"-B2\"){var i=this.getAggregation(\"monthsRow\"),o=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:i._oItemNavigation.focusItem(i._oItemNavigation.getFocusedIndex());break;case 1:o._oItemNavigation.focusItem(o._oItemNavigation.getFocusedIndex())}e.preventDefault()}},k.prototype.onfocusin=function(e){if(e.target.id==this.getId()+\"-end\"){var a=this.getAggregation(\"header\"),i=this.getAggregation(\"monthsRow\"),o=this.getAggregation(\"yearPicker\");t.sap.focus(a.getDomRef(\"B2\")),this._bPoupupMode||(t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),o.getDomRef()&&t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"))}this.$(\"end\").attr(\"tabindex\",\"-1\")},k.prototype.onsapfocusleave=function(e){if(!(e.relatedControlId&&t.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())||(this.$(\"end\").attr(\"tabindex\",\"0\"),this._bPoupupMode))){var a=this.getAggregation(\"monthsRow\"),i=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:t(a._oItemNavigation.getItemDomRefs()[a._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\");break;case 1:t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}},k.prototype._handlePrevious=function(t){var e=this._getFocusedDate(),a=this.getAggregation(\"yearPicker\"),i=this._getMonths(),o=new g(u.call(this));switch(this._iMode){case 0:o.setMonth(o.getMonth()-i),e.setMonth(e.getMonth()-i),this._setFocusedDate(e),l.call(this,o,!0);break;case 1:a.previousPage(),v.call(this)}},k.prototype._handleNext=function(t){var e=this._getFocusedDate(),a=this.getAggregation(\"yearPicker\"),i=this._getMonths(),o=new g(u.call(this));switch(this._iMode){case 0:o.setMonth(o.getMonth()+i),e.setMonth(e.getMonth()+i),this._setFocusedDate(e),l.call(this,o,!0);break;case 1:a.nextPage(),v.call(this)}},k.prototype._getShowItemHeader=function(){var t=this.getMonths();return t>this._iDaysMonthsHead},k},!0);",
		"sap/ui/unified/CalendarMonthIntervalRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){e._iMode=0;var i=e.getId(),a=e.getTooltip_AsString(),r=e.getAggregation(\"monthsRow\");t.write(\"<div\"),t.writeControlData(e),t.addClass(\"sapUiCal\"),t.addClass(\"sapUiCalInt\"),t.addClass(\"sapUiCalMonthInt\"),e._getShowItemHeader()&&t.addClass(\"sapUiCalIntHead\"),t.writeAttribute(\"tabindex\",\"-1\");var d=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),n={labelledby:{value:\"\",append:!1}};e._bPoupupMode&&(n.role=\"dialog\"),t.writeAccessibilityState(e,n),a&&t.writeAttributeEscaped(\"title\",a);var s=e.getWidth();s&&\"\"!=s&&(t.addStyle(\"width\",s),t.writeStyles()),t.writeClasses(),t.write(\">\");var l=e.getAggregation(\"header\");t.renderControl(l),t.write('<div id=\"'+i+'-content\" class=\"sapUiCalContent\">'),t.renderControl(r),t.write('<div id=\"'+i+'-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>'),t.write(\"</div>\"),t.write('<button id=\"'+i+'-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">'),t.write(d.getText(\"CALENDAR_CANCEL\")),t.write(\"</button>\"),t.write('<div id=\"'+i+'-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>'),t.write(\"</div>\")},e},!0);",
		"sap/ui/unified/CalendarOneMonthInterval.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"./library\",\"sap/ui/unified/CalendarDateInterval\",\"sap/ui/unified/CalendarDateIntervalRenderer\",\"sap/ui/unified/calendar/OneMonthDatesRow\"],function(t,e,a,o,n,s,r){\"use strict\";var i=n.extend(\"CalendarOneMonthInterval\",{renderer:s});return i.prototype.init=function(){n.prototype.init.apply(this,arguments),this._bShowOneMonth=!0},i.prototype._createMonth=function(t){return new r(t)},i.prototype._handleFocus=function(t){var o,s,r,i=!!t.getParameter(\"_outsideBorder\"),h=t.getParameter(\"date\"),c=a.fromLocalJSDate(h),u=a.fromLocalJSDate(this.getStartDate()),D=!e._isSameMonthAndYear(c,u);return(i||D)&&(e._isLastDateInMonth(c)?this._oFocusDateOneMonth=c:this._oFocusDateOneMonth=e._getFirstDateOfMonth(c),o=c.isBefore(u)?-1:1,s=new a(this._getFocusedDate(),this.getPrimaryCalendarType()),r=new a(this._getStartDate(),this.getPrimaryCalendarType()),n.prototype._shiftStartFocusDates.call(this,s,r,o)),n.prototype._handleFocus.apply(this,arguments)},i.prototype._focusDateExtend=function(t,e,a){var o,s;return this._oFocusDateOneMonth?(o=this.getAggregation(\"month\")[0],s=this._oFocusDateOneMonth.toLocalJSDate(),this._setFocusedDate(this._oFocusDateOneMonth),o._bNoRangeCheck=!0,o.setDate(s),o._bNoRangeCheck=!1,this.getSelectedDates().length&&this._setRowsStartDate(this.getSelectedDates()[0].getStartDate()),this._oFocusDateOneMonth=null,!a):n.prototype._focusDateExtend.apply(this,arguments)},i.prototype._setDisplayMode=function(t){this.getAggregation(\"month\")[0].setMode(t)},i.prototype._shiftStartFocusDates=function(t,e,a){var o=a,n=this.getAggregation(\"month\")[0];0!==o&&(o=o>0?1:-1),t.setMonth(t.getMonth()+o),e.setYear(t.getYear()),e.setMonth(t.getMonth()),e.setDate(t.getDate()),this._setFocusedDate(e),this._setStartDate(t,!0),n.selectDate(t.toLocalJSDate())},i.prototype._adjustFocusedDateUponMonthChange=function(t,e){t.setMonth(e),e!=t.getMonth()&&t.setDate(0),this._adjustSelectedDate(t,!0)},i.prototype._adjustFocusedDateUponYearChange=function(t,e){var o=this.getAggregation(\"yearPicker\"),n=a.fromLocalJSDate(o.getDate(),this.getPrimaryCalendarType());return n.setMonth(t.getMonth()),n.setDate(t.getDate()),t=n,this._adjustSelectedDate(t,!0),t},i.prototype._adjustSelectedDate=function(t,a){var o,n=this.getAggregation(\"month\")[0];o=a?e._getFirstDateOfMonth(t):t,n.getMode&&n.getMode()<2&&this._selectDate(o)},i.prototype._selectDate=function(t){var e=this.getAggregation(\"month\")[0],a=t.toLocalJSDate();this.removeAllSelectedDates(),this.addSelectedDate(new sap.ui.unified.DateRange({startDate:a})),e.selectDate(a)},i.prototype._dateMatchesVisibleRange=function(t){return e._isSameMonthAndYear(a.fromLocalJSDate(this.getStartDate()),a.fromLocalJSDate(t))},i},!0);",
		"sap/ui/unified/CalendarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){e._iMode=0;var i=e.getId(),a=e.getTooltip_AsString(),r=e.getAggregation(\"month\"),d=e.getWidth();t.write(\"<div\"),t.writeControlData(e),t.addClass(\"sapUiCal\"),r.length>1&&t.addClass(\"sapUiCalMulti\"),t.writeAttribute(\"tabindex\",\"-1\");var n=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),s={labelledby:{value:\"\",append:!1}};e._bPoupupMode&&(s.role=\"dialog\"),t.writeAccessibilityState(e,s),a&&t.writeAttributeEscaped(\"title\",a),d&&(t.addClass(\"sapUiCalWidth\"),t.addStyle(\"width\",d),t.writeStyles()),e._getSecondaryCalendarType()&&t.addClass(\"sapUiCalSecType\"),this.addAttributes&&this.addAttributes(t,e),t.writeClasses(),t.write(\">\");var l=e.getAggregation(\"header\");t.renderControl(l),t.write('<div id=\"'+i+'-content\" class=\"sapUiCalContent'),this.writeAdditionalStyleClasses(t,e),t.write('\">');for(var o=0;o<r.length;o++){var C=r[o];t.renderControl(C)}if(this.writeAdditionalControls(t,e),t.write('<div id=\"'+i+'-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>'),!e._bNamesLengthChecked){var g=e.getAggregation(\"monthPicker\");t.renderControl(g)}t.write(\"</div>\"),t.write('<button id=\"'+i+'-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">'),t.write(n.getText(\"CALENDAR_CANCEL\")),t.write(\"</button>\"),t.write('<div id=\"'+i+'-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>'),t.write(\"</div>\")},e.writeAdditionalControls=function(t,e){},e.writeAdditionalStyleClasses=function(t,e){},e},!0);",
		"sap/ui/unified/CalendarRow.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/Device\",\"sap/ui/core/LocaleData\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/core/date/UniversalDate\",\"./library\"],function(e,t,i,a,n,s,r,o){\"use strict\";function p(){return this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale}function l(){if(!this._oLocaleData){var e=p.call(this),t=new sap.ui.core.Locale(e);this._oLocaleData=a.getInstance(t)}return this._oLocaleData}function u(){var e,t=this.getStartDate(),i=this.getIntervals(),a=this.getIntervalType();switch(this._oUTCStartDate=d.call(this,t),a){case sap.ui.unified.CalendarIntervalType.Hour:e=new r(this._oUTCStartDate.getTime()),e.setUTCHours(e.getUTCHours()+i),this._iMinDelta=this._iHoursMinDelta;break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:e=new r(this._oUTCStartDate.getTime()),e.setUTCDate(e.getUTCDate()+i),this._iMinDelta=this._iDaysMinDelta;break;case sap.ui.unified.CalendarIntervalType.Month:e=new r(this._oUTCStartDate.getTime()),e.setUTCMonth(e.getUTCMonth()+i),this._iMinDelta=this._iMonthsMinDelta;break;default:throw new Error(\"Unknown IntervalType: \"+a+\"; \"+this)}e.setUTCMilliseconds(-1),this._iRowSize=e.getTime()-this._oUTCStartDate.getTime(),this._iIntervalSize=Math.floor(this._iRowSize/i),this._oUTCEndDate=e}function d(e){var t=this.getIntervalType(),i=s._createUniversalUTCDate(e,void 0,!0);switch(t){case sap.ui.unified.CalendarIntervalType.Hour:i.setUTCMinutes(0),i.setUTCSeconds(0),i.setUTCMilliseconds(0);break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:i.setUTCHours(0),i.setUTCMinutes(0),i.setUTCSeconds(0),i.setUTCMilliseconds(0);break;case sap.ui.unified.CalendarIntervalType.Month:i.setUTCDate(1),i.setUTCHours(0),i.setUTCMinutes(0),i.setUTCSeconds(0),i.setUTCMilliseconds(0);break;default:throw new Error(\"Unknown IntervalType: \"+t+\"; \"+this)}return i}function g(){return i.system.phone||this.getGroupAppointmentsMode()===sap.ui.unified.GroupAppointmentsMode.Collapsed}function h(){var e,t,i,a=this._aVisibleAppointments||[],n=y.call(this),o=this.getIntervals(),p=this.getIntervalType(),l=this._getStartDate(),u=l.getTime(),d=this._oUTCEndDate,h=d.getTime(),f=[],C=!1,v=0,U=0,_=g.call(this);for(this.destroyAggregation(\"groupAppointments\",!0),v=0;v<n.length;v++){e=n[v];var D=s._createUniversalUTCDate(e.getStartDate(),void 0,!0);D.setUTCSeconds(0),D.setUTCMilliseconds(0);var A=e.getEndDate()?s._createUniversalUTCDate(e.getEndDate(),void 0,!0):s._createUniversalUTCDate(new Date(864e12),void 0,!0);A.setUTCSeconds(0),A.setUTCMilliseconds(0);var b=!1;D.getTime()<u&&A.getTime()>=u&&(D=new r(u),b=!0),A.getTime()>h&&D.getTime()<=h&&(A=new r(h),b=!0);var I=60*D.getUTCHours()+D.getUTCMinutes();D.setUTCMinutes(D.getUTCMinutes()-I%this._iMinDelta);var M=(A.getTime()-D.getTime())/6e4;if(!b||0!=M){var S=0,w=0,H=-1;if(t=void 0,i=void 0,D&&D.getTime()<=h&&A&&A.getTime()>=u){if(_&&p==sap.ui.unified.CalendarIntervalType.Month&&A.getTime()-D.getTime()<6048e5){t=c.call(this,D,e,p,o,l,d,u,f);var k=s._createUniversalUTCDate(t.getEndDate(),void 0,!0);A.getTime()>k.getTime()&&(i=c.call(this,A,e,p,o,l,d,u,f))}for(S=T.call(this,p,o,l,d,u,D),w=m.call(this,p,o,l,d,u,A),U=0;U<a.length;U++){var R=a[U];e==R.appointment&&(H=R.level)}if(t){t._iBegin=S,t._iEnd=w,t._iLevel=H,i&&(i._iBegin=S,i._iEnd=w,i._iLevel=H);continue}f.push({appointment:e,begin:S,end:w,calculatedEnd:w,level:H}),this._sFocusedAppointmentId&&this._sFocusedAppointmentId==e.getId()&&(C=!0)}}}var E=this.getAggregation(\"groupAppointments\",[]);if(E.length>0)for(v=0;v<f.length;v++)if(e=f[v],e.appointment._aAppointments&&e.appointment._aAppointments.length<=1){t=e.appointment;var V=!1;if(0==t._aAppointments.length)V=!0;else for(U=0;U<f.length;U++)if(f[U].appointment==t._aAppointments[0]){V=!0;break}if(V)f.splice(v,1),v--;else{for(U=0;U<E.length;U++)if(i=E[U],t!=i)for(var L=0;L<i._aAppointments.length;L++)if(t._aAppointments[0]==i._aAppointments[L]){i._aAppointments.splice(L,1),1==i._aAppointments.length?(this.removeAggregation(\"groupAppointments\",i),i.destroy(),E=this.getAggregation(\"groupAppointments\",[])):i.setProperty(\"title\",i._aAppointments.length,!0);break}e.begin=t._iBegin,e.end=t._iEnd,e.calculatedEnd=t._iEnd,e.level=t._iLevel,e.appointment=t._aAppointments[0]}this.removeAggregation(\"groupAppointments\",t),t.destroy(),E=this.getAggregation(\"groupAppointments\",[])}return C||(f.length>0?this._sFocusedAppointmentId=f[0].appointment.getId():this._sFocusedAppointmentId=void 0),this._aVisibleAppointments=f,this._aVisibleAppointments}function c(e,t,i,a,n,o,p,u){var d,g=this.getAggregation(\"groupAppointments\",[]),h=l.call(this),c=h.getFirstDayOfWeek(),f=e.getUTCDay(),C=new r(e.getTime());C.setUTCHours(0),C.setUTCMinutes(0),C.setUTCSeconds(0),C.setUTCMilliseconds(0),c<=f?C.setDate(C.getDate()-(f-c)):C.setDate(C.getDate()-(7-f-c));for(var v=0;v<g.length;v++){d=g[v];var y=s._createUniversalUTCDate(d.getStartDate(),void 0,!0);if(y.getTime()==C.getTime())break;d=void 0}if(!d){var U=new r(C.getTime());U.setDate(U.getDate()+7),U.setMilliseconds(-1),d=new sap.ui.unified.CalendarAppointment(this.getId()+\"-Group\"+g.length,{type:t.getType(),startDate:s._createLocalDate(new Date(C.getTime()),!0),endDate:s._createLocalDate(new Date(U.getTime()),!0)}),d._aAppointments=[],this.addAggregation(\"groupAppointments\",d,!0);var _=T.call(this,i,a,n,o,p,C),D=m.call(this,i,a,n,o,p,U);u.push({appointment:d,begin:_,end:D,calculatedEnd:D,level:-1})}return d._aAppointments.push(t),d.getType()!=sap.ui.unified.CalendarDayType.None&&d.getType()!=t.getType()&&d.setType(sap.ui.unified.CalendarDayType.None),d.setProperty(\"title\",d._aAppointments.length,!0),d}function T(e,t,i,a,n,s){var o=0;if(e!=sap.ui.unified.CalendarIntervalType.Month)o=100*(s.getTime()-n)/this._iRowSize;else{var p=new r(s.getTime());p.setUTCDate(1),p.setUTCHours(0),p.setUTCMinutes(0),p.setUTCSeconds(0),p.setUTCMilliseconds(0);var l=new r(p.getTime());l.setUTCMonth(l.getUTCMonth()+1),l.setMilliseconds(-1);var u=l.getTime()-p.getTime(),d=12*(p.getUTCFullYear()-i.getUTCFullYear())+p.getUTCMonth()-i.getUTCMonth();o=100*d/t+100*(s.getTime()-p.getTime())/u/t}return o<0&&(o=0),o=Math.round(1e5*o)/1e5}function m(e,t,i,a,n,s){var o=0;if(e!=sap.ui.unified.CalendarIntervalType.Month)o=100-100*(s.getTime()-n)/this._iRowSize;else{var p=new r(s.getTime());p.setUTCDate(1),p.setUTCHours(0),p.setUTCMinutes(0),p.setUTCSeconds(0),p.setUTCMilliseconds(0);var l=new r(p.getTime());l.setUTCMonth(l.getUTCMonth()+1),l.setMilliseconds(-1);var u=l.getTime()-p.getTime(),d=12*(p.getUTCFullYear()-i.getUTCFullYear())+p.getUTCMonth()-i.getUTCMonth();o=100-(100*d/t+100*(s.getTime()-p.getTime())/u/t)}return o<0&&(o=0),o=Math.round(1e5*o)/1e5}function f(){var e=[];if(this.getShowIntervalHeaders()){var t,i=this.getIntervalHeaders(),a=this.getIntervals(),n=this.getIntervalType(),o=this._getStartDate(),p=o.getTime(),l=this._oUTCEndDate,u=l.getTime(),d=0,g=0;for(d=0;d<i.length;d++){t=i[d];var h=s._createUniversalUTCDate(t.getStartDate(),void 0,!0);h.setUTCSeconds(0),h.setUTCMilliseconds(0);var c=t.getEndDate()?s._createUniversalUTCDate(t.getEndDate(),void 0,!0):s._createUniversalUTCDate(new Date(864e12),void 0,!0);if(c.setUTCSeconds(0),c.setUTCMilliseconds(0),h&&h.getTime()<=u&&c&&c.getTime()>=p){var T=new r(o.getTime()),m=new r(o.getTime());m.setUTCMinutes(m.getUTCMinutes()-1);var f=-1,C=-1;for(g=0;g<a;g++){switch(n){case sap.ui.unified.CalendarIntervalType.Hour:m.setUTCHours(m.getUTCHours()+1),g>0&&T.setUTCHours(T.getUTCHours()+1);break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:m.setUTCDate(m.getUTCDate()+1),g>0&&T.setUTCDate(T.getUTCDate()+1);break;case sap.ui.unified.CalendarIntervalType.Month:m.setUTCDate(1),m.setUTCMonth(m.getUTCMonth()+2),m.setUTCDate(0),g>0&&T.setUTCMonth(T.getUTCMonth()+1);break;default:throw new Error(\"Unknown IntervalType: \"+n+\"; \"+this)}h&&h.getTime()<=T.getTime()&&c&&c.getTime()>=m.getTime()&&(f<0&&(f=g),C=g)}f>=0&&e.push({interval:f,appointment:t,last:C})}}}return this._aVisibleIntervalHeaders=e,this._aVisibleIntervalHeaders}function C(){var t=this.getIntervals(),a=this.getIntervalType();if(a!==sap.ui.unified.CalendarIntervalType.OneMonth||1!==t){var n=this.$(\"Apps\"),s=n.innerWidth();if(!(s<=0)){var r=this.$(\"DummyApp\"),o=r.outerHeight(!0);if(!(o<=0)){var p,l,u=r.outerWidth(),d=u/s*100,g=Math.ceil(1e3*d)/1e3,h=0,c=0,T=0,m=!i.system.phone&&this.getAppointmentsReducedHeight();for(this.getShowIntervalHeaders()&&(this.getShowEmptyIntervalHeaders()||this._getVisibleIntervalHeaders().length>0)&&(h=e(this.$(\"AppsInt0\").children(\".sapUiCalendarRowAppsIntHead\")[0]).outerHeight(!0)),T=0;T<this._aVisibleAppointments.length;T++){p=this._aVisibleAppointments[T],l=p.appointment.$();var f=Math.floor(1e3*(100-p.calculatedEnd-p.begin))/1e3,C=!1;f<g?(p.end=100-p.begin-d,p.end<0&&(p.end=0),p.level=-1,C=!0,l.addClass(\"sapUiCalendarAppSmall\")):l.hasClass(\"sapUiCalendarAppSmall\")&&(p.end=p.calculatedEnd,C=!0,l.removeClass(\"sapUiCalendarAppSmall\")),C&&(this._bRTL?l.css(\"left\",p.end+\"%\"):l.css(\"right\",p.end+\"%\"))}for(T=0;T<this._aVisibleAppointments.length;T++){p=this._aVisibleAppointments[T],l=p.appointment.$();var v={},y=m&&!this._getAppointmentReducedHeight(p.appointment);if(p.level<0){for(var U=0;U<this._aVisibleAppointments.length;U++){var _=this._aVisibleAppointments[U];p!=_&&p.begin<Math.floor(1e3*(100-_.end))/1e3&&Math.floor(1e3*(100-p.end))/1e3>_.begin&&_.level>=0&&(v[_.level]?v[_.level]++:v[_.level]=1,m&&!this._getAppointmentReducedHeight(_.appointment)&&(v[_.level+1]?v[_.level+1]++:v[_.level+1]=1))}for(p.level=0;v[p.level]||y&&v[p.level+1];)p.level++;l.attr(\"data-sap-level\",p.level)}l.css(\"top\",o*p.level+h+\"px\");var D=p.level;y&&D++,c<D&&(c=D)}if(c++,o=o*c+h,this.getHeight()){var A=this.$(\"Apps\").children(\".sapUiCalendarRowAppsInt\");for(T=0;T<A.length;T++){var b=e(A[T]);b.outerHeight(o)}}else n.outerHeight(o);r.css(\"display\",\"none\")}}}}function v(t,i){var a,n,s,r,o=0,p=sap.ui.unified.CalendarRow._oStaticSelectedText.getId();if(i){var l=this.getAppointments(),u=this.getAggregation(\"groupAppointments\",[]);for(e.merge(l,u),o=0;o<l.length;o++)a=l[o],a.getSelected()&&(a.setProperty(\"selected\",!1,!0),a.$().removeClass(\"sapUiCalendarAppSel\"),n=a.$().attr(\"aria-labelledby\"),s=n?n.replace(p,\"\"):\"\",a.$().attr(\"aria-labelledby\",s))}if(t.setProperty(\"selected\",!0,!0),t.$().addClass(\"sapUiCalendarAppSel\"),r=t.$().attr(\"aria-labelledby\")+\" \"+p,t.$().attr(\"aria-labelledby\",r),t._aAppointments){for(o=0;o<t._aAppointments.length;o++)a=t._aAppointments[o],a.setProperty(\"selected\",!0,!0),r=a.$().attr(\"aria-labelledby\")+\" \"+p,a.$().attr(\"aria-labelledby\",r);this.fireSelect({appointments:t._aAppointments,multiSelect:!i})}else this.fireSelect({appointment:t,multiSelect:!i})}function y(){var e=this.getAppointments();return e.sort(function(e,t){var i=e.getStartDate()-t.getStartDate();return 0==i&&(i=t.getEndDate()-e.getEndDate()),i}),e}function U(e){for(var t,i=this.getAggregation(\"groupAppointments\",[]),a=!1,n=0;n<i.length;n++){for(var s=i[n]._aAppointments,r=0;r<s.length;r++)if(s[r].getId()==e){t=i[n],a=!0;break}if(a)break}return t}function _(t){if(this._sFocusedAppointmentId!=t){var i,a=y.call(this),n=this._aVisibleAppointments,r=0;for(i=U.call(this,t),i&&(t=i.getId(),i=void 0),r=0;r<n.length;r++)if(n[r].appointment.getId()==t){i=n[r].appointment;break}if(i){var o=this.getFocusedAppointment().$(),p=i.$();this._sFocusedAppointmentId=i.getId(),o.attr(\"tabindex\",\"-1\"),p.attr(\"tabindex\",\"0\"),p.focus()}else{for(r=0;r<a.length;r++)if(a[r].getId()==t){i=a[r];break}if(i){this._sFocusedAppointmentId=i.getId();var l=d.call(this,i.getStartDate());this.setStartDate(s._createLocalDate(l,!0)),e.sap.containsOrEquals(this.getDomRef(),document.activeElement)||e.sap.delayedCall(0,this,function(){this.getFocusedAppointment().focus()}),this.fireStartDateChange()}}}}function D(e,t){var i,a=this._sFocusedAppointmentId,n=y.call(this),s=this.getAggregation(\"groupAppointments\",[]),r=0,o=0;for(o=0;o<s.length;o++)if(s[o].getId()==a){var p=s[o]._aAppointments;a=e?p[p.length-1].getId():p[0].getId();break}for(o=0;o<n.length;o++)if(n[o].getId()==a){r=o;break}e?r+=t:r-=t,r<0?r=0:r>=n.length&&(r=n.length-1),i=n[r],_.call(this,i.getId())}function A(e){var t,i,a,n=y.call(this),o=new r(this._getStartDate()),p=new r(this._oUTCEndDate),l=this.getIntervalType();switch(o.setUTCHours(0),p.setUTCHours(0),p.setUTCMinutes(0),p.setUTCSeconds(0),l){case sap.ui.unified.CalendarIntervalType.Hour:p.setUTCDate(p.getUTCDate()+1),p.setUTCMilliseconds(-1);break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:o.setUTCDate(1),p.setUTCMonth(p.getUTCMonth()+1),p.setUTCDate(1),p.setUTCMilliseconds(-1);break;case sap.ui.unified.CalendarIntervalType.Month:o.setUTCMonth(0),o.setUTCDate(1),p.setUTCFullYear(p.getUTCFullYear()+1),p.setUTCMonth(1),p.setUTCDate(1),p.setUTCMilliseconds(-1);break;default:throw new Error(\"Unknown IntervalType: \"+l+\"; \"+this)}for(var u=s._createLocalDate(o,!0),d=s._createLocalDate(p,!0),g=0;g<n.length;g++)if(n[g].getStartDate()>=u&&n[g].getStartDate()<=d){if(t=n[g],i=t.getId(),\"saphome\"==e.type)break}else if(n[g].getStartDate()>d)break;a=U.call(this,i),a&&(t=a,i=t.getId()),i&&i!=this._sFocusedAppointmentId?_.call(this,i):e._bPlanningCalendar&&t?t.focus():this.fireLeaveRow({type:e.type})}function b(t,i){var a,n=this.getIntervalType(),o=this._getStartDate(),p=new r(o.getTime()),l=!1,u=0,d=0;if(e(i).hasClass(\"sapUiCalendarRowAppsSubInt\")){l=!0;var g=e(e(i).parent()).children(\".sapUiCalendarRowAppsSubInt\");for(d=g.length,u=0;u<d;u++){var h=g[u];if(h==i)break}}switch(n){case sap.ui.unified.CalendarIntervalType.Hour:p.setUTCHours(p.getUTCHours()+t),l?(p.setUTCMinutes(p.getUTCMinutes()+60*u/d),a=new r(p.getTime()),a.setUTCMinutes(a.getUTCMinutes()+60/d)):(a=new r(p.getTime()),a.setUTCHours(a.getUTCHours()+1));break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:p.setUTCDate(p.getUTCDate()+t),l?(p.setUTCHours(p.getUTCHours()+24*u/d),a=new r(p.getTime()),a.setUTCHours(a.getUTCHours()+24/d)):(a=new r(p.getTime()),a.setUTCDate(a.getUTCDate()+1));break;case sap.ui.unified.CalendarIntervalType.Month:p.setUTCMonth(p.getUTCMonth()+t),l?(p.setUTCDate(p.getUTCDate()+u),a=new r(p.getTime()),a.setUTCDate(a.getUTCDate()+1)):(a=new r(p.getTime()),a.setUTCMonth(a.getUTCMonth()+1));break;default:throw new Error(\"Unknown IntervalType: \"+n+\"; \"+this)}a.setUTCMilliseconds(a.getUTCMilliseconds()-1),p=s._createLocalDate(p,!0),a=s._createLocalDate(a,!0),this.fireIntervalSelect({startDate:p,endDate:a,subInterval:l})}var I=t.extend(\"sap.ui.unified.CalendarRow\",{metadata:{library:\"sap.ui.unified\",properties:{startDate:{type:\"object\",group:\"Data\"},intervals:{type:\"int\",group:\"Appearance\",defaultValue:12},intervalType:{type:\"sap.ui.unified.CalendarIntervalType\",group:\"Appearance\",defaultValue:sap.ui.unified.CalendarIntervalType.Hour},showSubIntervals:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},showIntervalHeaders:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},showEmptyIntervalHeaders:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},nonWorkingDays:{type:\"int[]\",group:\"Misc\",defaultValue:null},nonWorkingHours:{type:\"int[]\",group:\"Misc\",defaultValue:null},width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},height:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},checkResize:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},updateCurrentTime:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},groupAppointmentsMode:{type:\"sap.ui.unified.GroupAppointmentsMode\",group:\"Appearance\",defaultValue:sap.ui.unified.GroupAppointmentsMode.Collapsed},appointmentsReducedHeight:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},appointmentsVisualization:{type:\"sap.ui.unified.CalendarAppointmentVisualization\",group:\"Appearance\",defaultValue:sap.ui.unified.CalendarAppointmentVisualization.Standard}},aggregations:{appointments:{type:\"sap.ui.unified.CalendarAppointment\",multiple:!0,singularName:\"appointment\"},intervalHeaders:{type:\"sap.ui.unified.CalendarAppointment\",multiple:!0,singularName:\"intervalHeader\"},groupAppointments:{type:\"sap.ui.unified.CalendarAppointment\",multiple:!0,singularName:\"groupAppointment\",visibility:\"hidden\"},_nonWorkingDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,visibility:\"hidden\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{parameters:{appointment:{type:\"sap.ui.unified.CalendarAppointment\"},appointments:{type:\"sap.ui.unified.CalendarAppointment[]\"},multiSelect:{type:\"boolean\"}}},startDateChange:{},leaveRow:{parameters:{type:{type:\"string\"}}},intervalSelect:{parameters:{startDate:{type:\"object\"},endDate:{type:\"object\"},subInterval:{type:\"boolean\"}}}}}});return I.PCROW_FOREIGN_KEY_NAME=\"relatedToPCRowDateRange\",I.AGGR_NONWORKING_DATES_NAME=\"_nonWorkingDates\",I.prototype.init=function(){this._bRTL=sap.ui.getCore().getConfiguration().getRTL(),this._oRb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),I._oStaticAppointmentText||(I._oStaticAppointmentText=new sap.ui.core.InvisibleText({text:this._oRb.getText(\"APPOINTMENT\")}),I._oStaticAppointmentText.toStatic(),I._oStaticTentativeText=new sap.ui.core.InvisibleText({text:this._oRb.getText(\"APPOINTMENT_TENTATIVE\")}),I._oStaticTentativeText.toStatic()),I._oStaticSelectedText||(I._oStaticSelectedText=new sap.ui.core.InvisibleText({text:this._oRb.getText(\"APPOINTMENT_SELECTED\")}),I._oStaticSelectedText.toStatic()),this._oFormatAria=sap.ui.core.format.DateFormat.getDateTimeInstance({pattern:\"EEEE dd/MM/YYYY 'at' HH:mm:ss a\"}),this._iHoursMinDelta=1,this._iDaysMinDelta=30,this._iMonthsMinDelta=720,this._aVisibleAppointments=[],this._aVisibleIntervalHeaders=[],this.setStartDate(new Date),this._resizeProxy=e.proxy(this.handleResize,this)},I.prototype.exit=function(){this._sResizeListener&&(sap.ui.core.ResizeHandler.deregister(this._sResizeListener),this._sResizeListener=void 0),this._sUpdateCurrentTime&&(e.sap.clearDelayedCall(this._sUpdateCurrentTime),this._sUpdateCurrentTime=void 0)},I.prototype.onBeforeRendering=function(){u.call(this),h.call(this),f.call(this),this._sUpdateCurrentTime&&(e.sap.clearDelayedCall(this._sUpdateCurrentTime),this._sUpdateCurrentTime=void 0)},I.prototype.onAfterRendering=function(){C.call(this),this.updateCurrentTimeVisualization(),this.getCheckResize()&&!this._sResizeListener&&(this._sResizeListener=sap.ui.core.ResizeHandler.register(this,this._resizeProxy))},I.prototype.onThemeChanged=function(e){if(this.getDomRef()){for(var t=0;t<this._aVisibleAppointments.length;t++){var i=this._aVisibleAppointments[t];i.level=-1}this.handleResize(e)}},I.prototype.invalidate=function(e){if(e&&e instanceof sap.ui.unified.CalendarAppointment){for(var i=!1,a=0;a<this._aVisibleAppointments.length;a++)if(this._aVisibleAppointments[a].appointment==e){i=!0;break}i&&(this._aVisibleAppointments=[])}t.prototype.invalidate.apply(this,arguments)},I.prototype.setStartDate=function(e){e||(e=new Date),s._checkJSDateObject(e);var t=e.getFullYear();return s._checkYearInValidRange(t),this.setProperty(\"startDate\",e),this},I.prototype._getStartDate=function(){return this._oUTCStartDate||(this._oUTCStartDate=s._createUniversalUTCDate(this.getStartDate(),void 0,!0)),this._oUTCStartDate},I.prototype.setIntervalType=function(e){return this.setProperty(\"intervalType\",e),this._aVisibleAppointments=[],this},I.prototype.setGroupAppointmentsMode=function(e){return this.setProperty(\"groupAppointmentsMode\",e),this._aVisibleAppointments=[],this},I.prototype.setAppointmentsReducedHeight=function(e){return this.setProperty(\"appointmentsReducedHeight\",e),this._aVisibleAppointments=[],this},I.prototype._getAppointmentReducedHeight=function(e){var t=!1;return i.system.phone||!this.getAppointmentsReducedHeight()||e.getText()||(t=!0),t},I.prototype.onfocusin=function(t){if(e(t.target).hasClass(\"sapUiCalendarApp\"))_.call(this,t.target.id);else{for(var i,a=this._getVisibleAppointments(),n=!1,s=0;s<a.length;s++)if(i=a[s].appointment,e.sap.containsOrEquals(i.getDomRef(),t.target)){n=!0,i.focus();break}n||(i=this.getFocusedAppointment(),i&&i.focus())}},I.prototype.applyFocusInfo=function(e){return this._sFocusedAppointmentId&&this.getFocusedAppointment().focus(),this},I.prototype.onsapleft=function(t){e(t.target).hasClass(\"sapUiCalendarApp\")&&D.call(this,this._bRTL,1),t.preventDefault(),t.stopPropagation()},I.prototype.onsapright=function(t){e(t.target).hasClass(\"sapUiCalendarApp\")&&D.call(this,!this._bRTL,1),t.preventDefault(),t.stopPropagation()},I.prototype.onsapup=function(e){this.fireLeaveRow({type:e.type})},I.prototype.onsapdown=function(e){this.fireLeaveRow({type:e.type})},I.prototype.onsaphome=function(e){A.call(this,e),e.preventDefault(),e.stopPropagation()},I.prototype.onsapend=function(e){A.call(this,e),e.preventDefault(),e.stopPropagation()},I.prototype.onsapselect=function(t){for(var i=this._getVisibleAppointments(),a=0;a<i.length;a++){var n=i[a].appointment;if(e.sap.containsOrEquals(n.getDomRef(),t.target)){v.call(this,n,!t.ctrlKey);break}}t.stopPropagation(),t.preventDefault()},I.prototype.ontap=function(t){var i=this.$(\"Apps\").children(\".sapUiCalendarRowAppsInt\"),a=0,n=!1;for(a=0;a<i.length;a++){var s=i[a];if(e.sap.containsOrEquals(s,t.target)){n=!0;break}}n?b.call(this,a,t.target):this.onsapselect(t)},I.prototype.onsapselectmodifiers=function(e){this.onsapselect(e)},I.prototype.handleResize=function(e){if(e&&e.size&&e.size.width<=0)return this;var t=this.$(\"DummyApp\");return t.css(\"display\",\"\"),C.call(this),this},I.prototype.updateCurrentTimeVisualization=function(){var t=this.$(\"Now\"),i=s._createUniversalUTCDate(new Date,void 0,!0),a=this.getIntervals(),n=this.getIntervalType(),r=this._getStartDate(),o=r.getTime(),p=this._oUTCEndDate,l=p.getTime();if(this._sUpdateCurrentTime=void 0,i.getTime()<=l&&i.getTime()>=o){var u=T.call(this,n,a,r,p,o,i),d=0;if(this._bRTL?t.css(\"right\",u+\"%\"):t.css(\"left\",u+\"%\"),t.css(\"display\",\"\"),this.getUpdateCurrentTime()){switch(n){case sap.ui.unified.CalendarIntervalType.Hour:d=6e4;break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:d=18e5;break;default:d=-1}d>0&&(this._sUpdateCurrentTime=e.sap.delayedCall(d,this,this.updateCurrentTimeVisualization))}}else t.css(\"display\",\"none\");return this},I.prototype.getFocusedAppointment=function(){var e,t=y.call(this),i=this.getAggregation(\"groupAppointments\",[]),a=0;for(a=0;a<i.length;a++)if(i[a].getId()==this._sFocusedAppointmentId){e=i[a];break}if(!e)for(a=0;a<t.length;a++)if(t[a].getId()==this._sFocusedAppointmentId){e=t[a];break}return e},I.prototype.focusAppointment=function(e){if(!(e&&e instanceof sap.ui.unified.CalendarAppointment))throw new Error(\"Appointment must be a CalendarAppointment; \"+this);var t=e.getId();return this._sFocusedAppointmentId!=t?_.call(this,t):e.focus(),this},I.prototype.focusNearestAppointment=function(e){s._checkJSDateObject(e);for(var t,i,a,n=y.call(this),r=0;r<n.length;r++)if(t=n[r],t.getStartDate()>e){i=r>0?n[r-1]:t;break}return t&&(a=i&&Math.abs(t.getStartDate()-e)>=Math.abs(i.getStartDate()-e)?i:t,this.focusAppointment(a)),this},I.prototype._getVisibleAppointments=function(){return this._aVisibleAppointments},I.prototype._getVisibleIntervalHeaders=function(){return this._aVisibleIntervalHeaders},I.prototype._getNonWorkingDays=function(){var t=this.getNonWorkingDays();if(t)e.isArray(t)||(t=[]);else{var i=l.call(this),a=i.getWeekendStart(),n=i.getWeekendEnd();t=[];for(var s=0;s<=6;s++)(a<=n&&s>=a&&s<=n||a>n&&(s>=a||s<=n))&&t.push(s)}return t},I},!0);",
		"sap/ui/unified/CalendarRowRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/date/UniversalDate\",\"sap/ui/unified/CalendarAppointment\",\"sap/ui/unified/CalendarRow\"],function(e,a,t,i){\"use strict\";var r={};return r.render=function(a,t){var i=t.getTooltip_AsString(),r=t.getAppointmentsVisualization(),n=t.getLegend(),s=[];if(n){var d=sap.ui.getCore().byId(n);d?s=d.getItems():e.sap.log.warning(\"CalendarLegend \"+n+\" does not exist!\",t)}a.write(\"<div\"),a.writeControlData(t),a.addClass(\"sapUiCalendarRow\"),!sap.ui.Device.system.phone&&t.getAppointmentsReducedHeight()&&a.addClass(\"sapUiCalendarRowAppsRedHeight\"),r!=sap.ui.unified.CalendarAppointmentVisualization.Standard&&a.addClass(\"sapUiCalendarRowVis\"+r),t._sFocusedAppointmentId?a.writeAttribute(\"tabindex\",\"-1\"):a.writeAttribute(\"tabindex\",\"0\"),i&&a.writeAttributeEscaped(\"title\",i);var l=t.getWidth();l&&a.addStyle(\"width\",l);var p=t.getHeight();p&&a.addStyle(\"height\",p),a.writeAccessibilityState(t),a.writeClasses(),a.writeStyles(),a.write(\">\"),this.renderAppointmentsRow(a,t,s),a.write(\"</div>\")},r.renderAppointmentsRow=function(e,a,t){var i=a.getId();e.write('<div id=\"'+i+'-Apps\" class=\"sapUiCalendarRowApps\">'),this.renderAppointments(e,a,t),e.write(\"</div>\")},r.renderAppointments=function(e,t,i){var r=t._getVisibleAppointments(),n=t._getVisibleIntervalHeaders(),s=t._getStartDate(),d=[],l=[],p=0,o=0,C=[],w=0,g=0,v=t.getIntervals(),u=t.getIntervalType(),T=100/v,y=0,I=new a(s),A=!1,c=!1;switch(u){case sap.ui.unified.CalendarIntervalType.Hour:d=t.getNonWorkingHours()||[],p=s.getUTCHours(),o=24;break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:d=t._getNonWorkingDays(),l=t.getAggregation(\"_nonWorkingDates\"),p=s.getUTCDay(),o=7,C=t.getNonWorkingHours()||[],w=s.getUTCHours(),g=24;break;case sap.ui.unified.CalendarIntervalType.Month:C=t._getNonWorkingDays(),w=s.getUTCDay(),g=7}if(u===sap.ui.unified.CalendarIntervalType.OneMonth&&1===v)this.renderSingleDayInterval(e,t,r,i,n,d,p,o,C,w,g,!0,!0);else{for(y=0;y<v;y++){switch(A=!!c,c=!1,u){case sap.ui.unified.CalendarIntervalType.Hour:I.setUTCHours(I.getUTCHours()+1),0==I.getUTCHours()&&(c=!0);break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:I.setUTCDate(I.getUTCDate()+1),1==I.getUTCDate()&&(c=!0);break;case sap.ui.unified.CalendarIntervalType.Month:I.setUTCMonth(I.getUTCMonth()+1),0==I.getUTCMonth()&&(c=!0)}this.renderInterval(e,t,y,T,n,d,l,p,o,C,w,g,A,c)}for(this.renderIntervalHeaders(e,t,T,n,v),e.write('<div id=\"'+t.getId()+'-Now\" class=\"sapUiCalendarRowNow\"></div>'),y=0;y<r.length;y++){var h=r[y];this.renderAppointment(e,t,h,i)}e.write('<div id=\"'+t.getId()+'-DummyApp\" class=\"sapUiCalendarApp sapUiCalendarAppTitleOnly sapUiCalendarAppDummy\"></div>')}},r.renderInterval=function(e,t,i,r,n,s,d,l,p,o,C,w,g,v){var u,T,y,I,A=t.getId()+\"-AppsInt\"+i,c=t.getShowIntervalHeaders()&&(t.getShowEmptyIntervalHeaders()||n.length>0),h=t.getStartDate().getMonth(),U=new Date(t.getStartDate().getFullYear(),h+1,0).getDate(),f=t.getStartDate();for(e.write('<div id=\"'+A+'\"'),e.addClass(\"sapUiCalendarRowAppsInt\"),e.addStyle(\"width\",r+\"%\"),i>=U&&t.getIntervalType()===sap.ui.unified.CalendarIntervalType.OneMonth&&e.addClass(\"sapUiCalItemOtherMonth\"),u=0;u<s.length;u++)if((i+l)%p==s[u]){e.addClass(\"sapUiCalendarRowAppsNoWork\");break}if(d&&d.length){T=new Date(f.getTime()),T.setHours(0,0,0),T.setDate(f.getDate()+i);var b=function(e){return e===T.getDay()};for(u=0;u<d.length;u++)if(d[u].getStartDate()&&(y=new Date(d[u].getStartDate().getTime())),d[u].getEndDate()?I=new Date(d[u].getEndDate().getTime()):(I=new Date(d[u].getStartDate().getTime()),I.setHours(23,59,59)),T.getTime()>=y.getTime()&&T.getTime()<=I.getTime()){var S=s.some(b);S||e.addClass(\"sapUiCalendarRowAppsNoWork\")}}if(c||e.addClass(\"sapUiCalendarRowAppsIntNoHead\"),g&&e.addClass(\"sapUiCalendarRowAppsIntFirst\"),v&&e.addClass(\"sapUiCalendarRowAppsIntLast\"),e.writeClasses(),e.writeStyles(),e.write(\">\"),c&&(e.write(\"<div\"),e.addClass(\"sapUiCalendarRowAppsIntHead\"),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")),t.getShowSubIntervals()){var m=t.getIntervalType(),D=0;switch(m){case sap.ui.unified.CalendarIntervalType.Hour:D=4;break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:D=24;break;case sap.ui.unified.CalendarIntervalType.Month:var R=t._getStartDate(),H=new a(R);H.setUTCMonth(H.getUTCMonth()+i+1,0),D=H.getUTCDate(),H.setUTCDate(1),l=H.getUTCDay()}var _=100/D;for(u=0;u<D;u++){e.write(\"<div\"),e.addClass(\"sapUiCalendarRowAppsSubInt\"),e.addStyle(\"width\",_+\"%\");for(var k=0;k<o.length;k++)if((u+C)%w==o[k]){e.addClass(\"sapUiCalendarRowAppsNoWork\");break}e.writeStyles(),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")}}e.write(\"</div>\")},r.renderIntervalHeaders=function(e,a,t,i,r){var n=a.getShowIntervalHeaders()&&(a.getShowEmptyIntervalHeaders()||i.length>0);if(n)for(var s=0;s<i.length;s++){var d,l,p=i[s];a._bRTL?(l=t*p.interval,d=t*(r-p.last-1)):(d=t*p.interval,l=t*(r-p.last-1)),this.renderIntervalHeader(e,p,a._bRTL,d,l)}},r.renderIntervalHeader=function(e,a,t,i,r){var n=a.appointment.getId();e.write(\"<div\"),e.addClass(\"sapUiCalendarRowAppsIntHead\"),void 0!==i&&e.addStyle(\"left\",i+\"%\"),void 0!==r&&e.addStyle(\"right\",r+\"%\"),e.writeElementData(a.appointment),e.addClass(\"sapUiCalendarRowAppsIntHeadFirst\"),a.appointment.getSelected()&&e.addClass(\"sapUiCalendarRowAppsIntHeadSel\"),a.appointment.getTentative()&&e.addClass(\"sapUiCalendarRowAppsIntHeadTent\");var s=a.appointment.getTooltip_AsString();s&&e.writeAttributeEscaped(\"title\",s);var d=a.appointment.getType(),l=a.appointment.getColor();!l&&d&&d!=sap.ui.unified.CalendarDayType.None&&e.addClass(\"sapUiCalendarRowAppsIntHead\"+d),l&&(t?e.addStyle(\"border-right-color\",l):e.addStyle(\"border-left-color\",l)),e.writeStyles(),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.addClass(\"sapUiCalendarIntervalHeaderCont\"),e.writeClasses(),l&&(e.addStyle(\"background-color\",a.appointment._getCSSColorForBackground(l)),e.writeStyles()),e.write(\">\");var p=a.appointment.getIcon();if(p){var o=[\"sapUiCalendarRowAppsIntHeadIcon\"],C={};C.id=n+\"-Icon\",C.title=null,e.writeIcon(p,o,C)}var w=a.appointment.getTitle();w&&(e.write(\"<span\"),e.writeAttribute(\"id\",n+\"-Title\"),e.addClass(\"sapUiCalendarRowAppsIntHeadTitle\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(w,!0),e.write(\"</span>\"));var g=a.appointment.getText();g&&(e.write(\"<span\"),e.writeAttribute(\"id\",n+\"-Text\"),e.addClass(\"sapUiCalendarRowAppsIntHeadText\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(g,!0),e.write(\"</span>\")),e.write(\"</div>\"),e.write(\"</div>\")},r.renderAppointment=function(e,a,t,r,n){var s=t.appointment,d=s.getTooltip_AsString(),l=s.getType(),p=s.getColor(),o=s.getTitle(),C=s.getText(),w=s.getIcon(),g=s.getId(),v={labelledby:{value:i._oStaticAppointmentText.getId()+\" \"+g+\"-Descr\",append:!0}},u=a.getAriaLabelledBy();if(u.length>0&&(v.labelledby.value=v.labelledby.value+\" \"+u.join(\" \")),o&&(v.labelledby.value=v.labelledby.value+\" \"+g+\"-Title\"),C&&(v.labelledby.value=v.labelledby.value+\" \"+g+\"-Text\"),e.write(\"<div\"),e.writeElementData(s),e.addClass(\"sapUiCalendarApp\"),s.getSelected()&&(e.addClass(\"sapUiCalendarAppSel\"),v.labelledby.value=v.labelledby.value+\" \"+i._oStaticSelectedText.getId()),s.getTentative()&&(e.addClass(\"sapUiCalendarAppTent\"),v.labelledby.value=v.labelledby.value+\" \"+i._oStaticTentativeText.getId()),C||e.addClass(\"sapUiCalendarAppTitleOnly\"),w&&e.addClass(\"sapUiCalendarAppWithIcon\"),n||(a._bRTL?(e.addStyle(\"right\",t.begin+\"%\"),e.addStyle(\"left\",t.end+\"%\")):(e.addStyle(\"left\",t.begin+\"%\"),e.addStyle(\"right\",t.end+\"%\"))),e.writeAttribute(\"data-sap-level\",t.level),a._sFocusedAppointmentId==g?e.writeAttribute(\"tabindex\",\"0\"):e.writeAttribute(\"tabindex\",\"-1\"),d&&e.writeAttributeEscaped(\"title\",d),!p&&l&&l!=sap.ui.unified.CalendarDayType.None&&e.addClass(\"sapUiCalendarApp\"+l),p&&(a._bRTL?e.addStyle(\"border-right-color\",p):e.addStyle(\"border-left-color\",p)),e.writeAccessibilityState(s,v),e.writeClasses(),e.writeStyles(),e.write(\">\"),e.write(\"<div\"),e.addClass(\"sapUiCalendarAppCont\"),p&&a.getAppointmentsVisualization()===sap.ui.unified.CalendarAppointmentVisualization.Filled&&(e.addStyle(\"background-color\",s._getCSSColorForBackground(p)),e.writeStyles()),e.writeClasses(),e.write(\">\"),w){var T=[\"sapUiCalendarAppIcon\"],y={};y.id=g+\"-Icon\",y.title=null,e.writeIcon(w,T,y)}o&&(e.write(\"<span\"),e.writeAttribute(\"id\",g+\"-Title\"),e.addClass(\"sapUiCalendarAppTitle\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(o,!0),e.write(\"</span>\")),C&&(e.write(\"<span\"),e.writeAttribute(\"id\",g+\"-Text\"),e.addClass(\"sapUiCalendarAppText\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(C,!0),e.write(\"</span>\"));var I=a._oRb.getText(\"CALENDAR_START_TIME\")+\": \"+a._oFormatAria.format(s.getStartDate());if(I=I+\"; \"+a._oRb.getText(\"CALENDAR_END_TIME\")+\": \"+a._oFormatAria.format(s.getEndDate()),d&&(I=I+\"; \"+d),l&&l!=sap.ui.unified.CalendarDayType.None)for(var A=0;A<r.length;A++){var c=r[A];if(c.getType()==l){I=I+\"; \"+c.getText();break}}e.write('<span id=\"'+g+'-Descr\" class=\"sapUiInvisibleText\">'+I+\"</span>\"),e.write(\"</div>\"),e.write(\"</div>\")},r.renderSingleDayInterval=function(e,i,r,n,s,d,l,p,o,C,w,g,v){var u,T,y,I=1,A=100,c=i.getId()+\"-AppsInt\"+I,h=i.getShowIntervalHeaders()&&(i.getShowEmptyIntervalHeaders()||s.length>0),U=i.getStartDate(),f=U.getMonth(),b=new Date(U.getFullYear(),f+1,0).getDate(),S=r.concat(i.getIntervalHeaders().filter(function(e){var a=e.getStartDate().getTime(),t=e.getStartDate().getTime(),i=U.getTime(),r=i+864e5;return a>=i&&a<r||t>=i&&t<r}).map(function(e){return{appointment:e,isHeader:!0}})).sort(t._getComparer(U));for(e.write('<div id=\"'+c+'\"'),e.addClass(\"sapUiCalendarRowAppsInt\"),e.addClass(\"sapUiCalendarMonthRowAppsS\"),e.addStyle(\"width\",A+\"%\"),I>=b&&i.getIntervalType()===sap.ui.unified.CalendarIntervalType.OneMonth&&e.addClass(\"sapUiCalItemOtherMonth\"),u=0;u<d.length;u++)if((I+l)%p==d[u]){e.addClass(\"sapUiCalendarRowAppsNoWork\");break}for(h||e.addClass(\"sapUiCalendarRowAppsIntNoHead\"),g&&e.addClass(\"sapUiCalendarRowAppsIntFirst\"),v&&e.addClass(\"sapUiCalendarRowAppsIntLast\"),e.writeClasses(),e.writeStyles(),e.write(\">\"),h&&(e.write(\"<div\"),e.addClass(\"sapUiCalendarRowAppsIntHead\"),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")),u=0;u<S.length;u++)y=S[u],e.write('<div class=\"sapUiCalendarAppContainer\">'),e.write('<div class=\"sapUiCalendarAppContainerLeft\">'),e.write(\"<div>\"+y.appointment._getDateRangeIntersectionText(U)+\"</div>\"),e.write(\"</div>\"),e.write('<div class=\"sapUiCalendarAppContainerRight\">'),y.isHeader?this.renderIntervalHeader(e,y):this.renderAppointment(e,i,y,n,!0),e.write(\"</div>\"),e.write(\"</div>\");if(0===r.length&&(e.write('<div class=\"sapUiCalendarNoApps\">'),T=sap.ui.getCore().getLibraryResourceBundle(\"sap.m\").getText(\"PLANNINGCALENDAR_ROW_NO_APPOINTMENTS\"),e.write(T),e.write(\"</div>\")),e.write('<div id=\"'+i.getId()+'-Now\" class=\"sapUiCalendarRowNow\"></div>'),e.write('<div id=\"'+i.getId()+'-DummyApp\" class=\"sapUiCalendarApp sapUiCalendarAppTitleOnly sapUiCalendarAppDummy\" style=\\'margin:0; height:0px;\\'></div>'),i.getShowSubIntervals()){var m=i.getIntervalType(),D=0;switch(m){case sap.ui.unified.CalendarIntervalType.Hour:D=4;break;case sap.ui.unified.CalendarIntervalType.Day:case sap.ui.unified.CalendarIntervalType.Week:case sap.ui.unified.CalendarIntervalType.OneMonth:D=24;break;case sap.ui.unified.CalendarIntervalType.Month:var R=new a(U);R.setUTCMonth(R.getUTCMonth()+I+1,0),D=R.getUTCDate(),R.setUTCDate(1),l=R.getUTCDay()}var H=100/D;for(u=0;u<D;u++){e.write(\"<div\"),e.addClass(\"sapUiCalendarRowAppsSubInt\"),e.addStyle(\"width\",H+\"%\");for(var _=0;_<o.length;_++)if((u+C)%w==o[_]){e.addClass(\"sapUiCalendarRowAppsNoWork\");break}e.writeStyles(),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")}}e.write(\"</div>\")},r},!0);",
		"sap/ui/unified/CalendarTimeInterval.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/model/type/Date\",\"sap/ui/unified/calendar/CalendarUtils\",\"./calendar/Header\",\"./calendar/TimesRow\",\"./calendar/DatesRow\",\"./calendar/MonthPicker\",\"./calendar/YearPicker\",\"sap/ui/core/date/UniversalDate\",\"./library\"],function(t,e,a,i,s,o,n,g,r,h,l,c){\"use strict\";function u(t,e,a){var i=new l(this._oMaxDate.getTime());i.setUTCMinutes(i.getUTCMinutes()-this.getIntervalMinutes()*(this._getItems()-1)),i.getTime()<this._oMinDate.getTime()&&(i=new l(this._oMinDate.getTime()),i.setUTCMinutes(i.getUTCMinutes()+this.getIntervalMinutes()*(this._getItems()-1))),t.getTime()<this._oMinDate.getTime()?t=new l(this._oMinDate.getTime()):t.getTime()>i.getTime()&&(t=i);var o=this.getAggregation(\"timesRow\"),n=s._createLocalDate(t,!0);if(o.setStartDate(n),this._oUTCStartDate=new l(o._getStartDate().getTime()),n=s._createLocalDate(this._oUTCStartDate,!0),this.setProperty(\"startDate\",n,!0),M.call(this),e){var g=s._createLocalDate(this._getFocusedDate(),!0);o.checkDateFocusable(g)?o.setDate(g):(this._setFocusedDate(t),o.setDate(n))}a||this.fireStartDateChange()}function D(){if(!this._oUTCStartDate){var t=this.getAggregation(\"timesRow\");t.setStartDate(s._createLocalDate(this._getFocusedDate(),!0)),this._oUTCStartDate=new l(t._getStartDate().getTime()),this._setFocusedDate(this._oUTCStartDate)}return this._oUTCStartDate}function d(t){var e=this._getFocusedDate(),a=this.getAggregation(\"timesRow\");t?a.displayDate(s._createLocalDate(e,!0)):a.setDate(s._createLocalDate(e,!0)),M.call(this)}function p(){var t=this.getSelectedDates();if(t&&t[0]&&t[0].getStartDate())this._oFocusedDate=s._createUniversalUTCDate(t[0].getStartDate(),void 0,!0);else{var e=new Date;this._oFocusedDate=s._createUniversalUTCDate(e,void 0,!0)}this._oFocusedDate.getTime()<this._oMinDate.getTime()?this._oFocusedDate=new l(this._oMinDate.getTime()):this._oFocusedDate.getTime()>this._oMaxDate.getTime()&&(this._oFocusedDate=new l(this._oMaxDate.getTime()))}function _(){3==this._iMode?C.call(this,!0):2==this._iMode&&T.call(this,!0);var e=this._getFocusedDate(),a=this._getItems(),i=this.getAggregation(\"datesRow\"),o=i.getSelectedDates()[0];if(o.setStartDate(s._createLocalDate(e,!0)),this.getPickerPopup())B.call(this,i);else{var n=new l(e.getTime());n.setUTCDate(1),n.setUTCMonth(n.getUTCMonth()+1),n.setUTCDate(0);var g=n.getUTCDate(),r=Math.floor(1.5*a);if(r>g&&(r=g),i.setDays(r),i.getDomRef())i.$().css(\"display\",\"\");else{var h=sap.ui.getCore().createRenderManager(),c=this.$(\"content\");h.renderControl(i),h.flush(c[0],!1,!0),h.destroy()}}if(this.$(\"contentOver\").css(\"display\",\"\"),J.call(this,e),0==this._iMode){var u=this.getAggregation(\"timesRow\");t(u._oItemNavigation.getItemDomRefs()[u._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}this._iMode=1}function m(e){if(this._iMode=0,this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"datesRow\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!e){d.call(this);var i=this.getAggregation(\"timesRow\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}function v(){1==this._iMode?m.call(this,!0):3==this._iMode&&C.call(this,!0);var e=this._getFocusedDate(),a=this.getAggregation(\"monthPicker\");if(this.getPickerPopup())B.call(this,a);else if(a.getDomRef())a.$().css(\"display\",\"\");else{var i=sap.ui.getCore().createRenderManager(),s=this.$(\"content\");i.renderControl(a),i.flush(s[0],!1,!0),i.destroy()}if(this.$(\"contentOver\").css(\"display\",\"\"),a.setMonth(e.getUTCMonth()),O.call(this,e.getUTCFullYear(),a),0==this._iMode){var o=this.getAggregation(\"timesRow\");t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}this._iMode=2,U.call(this)}function T(e){if(this._iMode=0,this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"monthPicker\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!e){d.call(this);var i=this.getAggregation(\"timesRow\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}function f(){1==this._iMode?m.call(this,!0):2==this._iMode&&T.call(this,!0);var e=this._getFocusedDate(),a=this.getAggregation(\"yearPicker\");if(this.getPickerPopup())B.call(this,a);else if(a.getDomRef())a.$().css(\"display\",\"\");else{var i=sap.ui.getCore().createRenderManager(),s=this.$(\"content\");i.renderControl(a),i.flush(s[0],!1,!0),i.destroy()}if(this.$(\"contentOver\").css(\"display\",\"\"),a.setDate(e.getJSDate()),0==this._iMode){var o=this.getAggregation(\"timesRow\");t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}I.call(this),this._iMode=3}function C(e){if(this._iMode=0,this.getPickerPopup())this._oPopup.isOpen()&&this._oPopup.close();else{var a=this.getAggregation(\"yearPicker\");a.$().css(\"display\",\"none\")}if(this.$(\"contentOver\").css(\"display\",\"none\"),!e){d.call(this);var i=this.getAggregation(\"timesRow\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}function M(){y.call(this),U.call(this,!0)}function U(t){var e=new l(D.call(this).getTime()),a=this._getItems(),i=e.getJSDate().getUTCFullYear(),s=this._oMaxDate.getJSDate().getUTCFullYear(),o=this._oMinDate.getJSDate().getUTCFullYear(),n=e.getJSDate().getUTCMonth(),g=this._oMaxDate.getJSDate().getUTCMonth(),r=this._oMinDate.getJSDate().getUTCMonth(),h=e.getJSDate().getUTCDate(),c=this._oMaxDate.getJSDate().getUTCDate(),u=this._oMinDate.getJSDate().getUTCDate(),d=e.getJSDate().getUTCHours(),p=this._oMaxDate.getJSDate().getUTCHours(),_=this._oMinDate.getJSDate().getUTCHours(),m=e.getJSDate().getUTCMinutes(),v=this._oMaxDate.getJSDate().getUTCMinutes(),T=this._oMinDate.getJSDate().getUTCMinutes(),f=this.getAggregation(\"header\");if(2==this._iMode&&!t){var C=this.getAggregation(\"monthPicker\"),M=C.getMonths(),U=C.getStartMonth(),I=U+M-1;return 0==U||i==o&&U<=r?f.setEnabledPrevious(!1):f.setEnabledPrevious(!0),void(I>10||i==s&&I>=g?f.setEnabledNext(!1):f.setEnabledNext(!0))}i<o||i==o&&(!t||n<r||n==r&&(h<u||h==u&&(d<_||d==_&&m<=T)))||(1==this._iMode||2==this._iMode)&&this.getPickerPopup()?f.setEnabledPrevious(!1):f.setEnabledPrevious(!0),e.setUTCMinutes(e.getUTCMinutes()+a*this.getIntervalMinutes()-1),i=e.getJSDate().getUTCFullYear(),n=e.getJSDate().getUTCMonth(),h=e.getJSDate().getUTCDate(),d=e.getJSDate().getUTCHours(),m=e.getJSDate().getUTCMinutes(),i>s||i==s&&(!t||n>g||n==g&&(h>c||h==c&&(d>p||d==p&&m>=v)))||(1==this._iMode||2==this._iMode)&&this.getPickerPopup()?f.setEnabledNext(!1):f.setEnabledNext(!0)}function I(){var t=this.getAggregation(\"yearPicker\"),e=t.getYears(),a=s._createUniversalUTCDate(t.getFirstRenderedDate());a.setUTCFullYear(a.getUTCFullYear()+Math.floor(e/2));var i=this.getAggregation(\"header\"),o=new l(this._oMaxDate);o.setUTCFullYear(o.getUTCFullYear()-Math.ceil(e/2)),o.setUTCMonth(11,31);var n=new l(this._oMinDate);n.setUTCFullYear(n.getUTCFullYear()+Math.floor(e/2)+1),n.setUTCMonth(0,1),a.getTime()>o.getTime()?i.setEnabledNext(!1):i.setEnabledNext(!0),a.getTime()<n.getTime()?i.setEnabledPrevious(!1):i.setEnabledPrevious(!0)}function y(){var t,e,a,i=this.getAggregation(\"header\"),s=D.call(this),o=this._getLocaleData(),n=[],g=[],r=!1;a=\"ja\"===o.oLocale.sLanguage.toLowerCase()||\"zh\"===o.oLocale.sLanguage.toLowerCase()?sap.ui.core.format.DateFormat.getDateInstance({format:\"d\"}).format(s,!0):s.getUTCDate().toString(),i.setTextButton0(a),this._bLongMonth||!this._bNamesLengthChecked?n=o.getMonthsStandAlone(\"wide\"):(r=!0,n=o.getMonthsStandAlone(\"abbreviated\"),g=o.getMonthsStandAlone(\"wide\"));var h=s.getUTCMonth();t=n[h],r&&(e=g[n[h]]),i.setTextButton1(t),r&&i.setAriaLabelButton1(e),i.setTextButton2(this._oYearFormat.format(s,!0))}function P(t,e){var a,i=!1;t.getTime()<this._oMinDate.getTime()?(a=this._oMinDate,i=!0):t.getTime()>this._oMaxDate.getTime()?(a=this._oMaxDate,i=!0):a=t,this._setFocusedDate(a),(i||e)&&(E.call(this,a),d.call(this,!1),this.fireStartDateChange())}function w(t,e){if(t&&(!this._oFocusedDate||this._oFocusedDate.getTime()!=t.getTime())){s._checkJSDateObject(t),t=s._createUniversalUTCDate(t,void 0,!0);var a=t.getUTCFullYear();if(s._checkYearInValidRange(a),t.getTime()<this._oMinDate.getTime()||t.getTime()>this._oMaxDate.getTime())throw new Error(\"Date must not be in valid range (minDate and maxDate); \"+this);this._setFocusedDate(t),this.getDomRef()&&0==this._iMode&&d.call(this,e)}}function b(t){1!=this._iMode?_.call(this):m.call(this)}function x(t){2!=this._iMode?v.call(this):T.call(this)}function F(t){3!=this._iMode?f.call(this):C.call(this)}function R(t){this.fireSelect()}function S(t){var e=s._createUniversalUTCDate(t.getParameter(\"date\"),void 0,!0),a=t.getParameter(\"notVisible\");P.call(this,e,a)}function A(t){var e=new l(this._getFocusedDate().getTime()),a=t.oSource,i=a.getSelectedDates()[0],o=s._createUniversalUTCDate(i.getStartDate());this.getPickerPopup()&&o.getUTCMonth()!=e.getUTCMonth()||(e.setUTCDate(o.getUTCDate()),e.setUTCMonth(o.getUTCMonth()),e.setUTCFullYear(o.getUTCFullYear()),P.call(this,e,!0),m.call(this))}function k(t){var e=new l(this._getFocusedDate().getTime()),a=s._createUniversalUTCDate(t.getParameter(\"date\"),void 0,!0),i=t.getParameter(\"otherMonth\");i&&a.getUTCMonth()==e.getUTCMonth()&&a.getUTCFullYear()==e.getUTCFullYear()&&J.call(this,a)}function N(t){var e=new l(this._getFocusedDate().getTime()),a=this.getAggregation(\"monthPicker\"),i=a.getMonth();e.setUTCMonth(i),i!=e.getUTCMonth()&&e.setUTCDate(0),P.call(this,e,!0),T.call(this)}function Y(t){var e=new l(this._getFocusedDate().getTime()),a=this.getAggregation(\"yearPicker\"),i=s._createUniversalUTCDate(a.getDate()),o=e.getUTCMonth();i.setUTCMonth(e.getUTCMonth(),e.getUTCDate()),i.setUTCHours(e.getUTCHours()),i.setUTCMinutes(e.getUTCMinutes()),e=i,o!=e.getUTCMonth()&&e.setUTCDate(0),P.call(this,e,!0),C.call(this)}function L(){this._sInvalidateContent=void 0;var t=this.getAggregation(\"timesRow\");t._bDateRangeChanged=!0,t._bInvalidateSync=!0,t.invalidate(),t._bInvalidateSync=void 0,this._bDateRangeChanged=void 0}function E(t){var e=this.getAggregation(\"timesRow\"),a=D.call(this),i=e._oItemNavigation.getFocusedIndex();a=new l(t.getTime()),a.setUTCMinutes(a.getUTCMinutes()-i*this.getIntervalMinutes()),u.call(this,a,!1,!0)}function J(t){var e=this.getAggregation(\"datesRow\"),a=this.getAggregation(\"header\");if(this.getPickerPopup())a.setEnabledPrevious(!1),a.setEnabledNext(!1);else{var i=new l(t.getTime());i.setUTCDate(1),i.setUTCMonth(i.getUTCMonth()+1),i.setUTCDate(0);var o=e.getDays(),n=new l(t.getTime());n.setUTCDate(1+(Math.ceil(t.getUTCDate()/o)-1)*o),i.getUTCDate()-n.getUTCDate()<o&&n.setUTCDate(i.getUTCDate()-o+1),e.setStartDate(s._createLocalDate(n,!0));var g=n.getJSDate().getUTCFullYear(),r=this._oMaxDate.getJSDate().getUTCFullYear(),h=this._oMinDate.getJSDate().getUTCFullYear(),c=n.getJSDate().getUTCMonth(),u=this._oMaxDate.getJSDate().getUTCMonth(),D=this._oMinDate.getJSDate().getUTCMonth(),d=n.getJSDate().getUTCDate(),p=this._oMaxDate.getJSDate().getUTCDate(),_=this._oMinDate.getJSDate().getUTCDate();d<=1||g==h&&c==D&&d<=_?a.setEnabledPrevious(!1):a.setEnabledPrevious(!0),d+o>=i.getUTCDate()||g==r&&c==u&&d>=p?a.setEnabledNext(!1):a.setEnabledNext(!0)}e.setDate(s._createLocalDate(t,!0))}function B(e){this._oPopup||(t.sap.require(\"sap.ui.core.Popup\"),this._oPopup=new sap.ui.core.Popup,this._oPopup.setAutoClose(!0),this._oPopup.setAutoCloseAreas([this.getDomRef()]),this._oPopup.setDurations(0,0),this._oPopup._oCalendar=this,this._oPopup.attachClosed($,this),this._oPopup.onsapescape=function(t){this._oCalendar.onsapescape(t)}),this._oPopup.setContent(e);var a=this.getAggregation(\"header\"),i=sap.ui.core.Popup.Dock;this._oPopup.open(0,i.CenterTop,i.CenterBottom,a,null,\"flipfit\",!0)}function $(t){switch(this._iMode){case 0:break;case 1:m.call(this);break;case 2:T.call(this);break;case 3:C.call(this)}}function O(t,e){var a=0,i=11;t==this._oMinDate.getUTCFullYear()&&(a=this._oMinDate.getUTCMonth()),t==this._oMaxDate.getUTCFullYear()&&(i=this._oMaxDate.getUTCMonth()),e.setMinMax(a,i)}function H(t){U.call(this)}function V(t){I.call(this)}var j=e.extend(\"sap.ui.unified.CalendarTimeInterval\",{metadata:{library:\"sap.ui.unified\",properties:{width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},startDate:{type:\"object\",group:\"Data\"},intervalSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},singleSelection:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},items:{type:\"int\",group:\"Appearance\",defaultValue:12},intervalMinutes:{type:\"int\",group:\"Appearance\",defaultValue:60},pickerPopup:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},minDate:{type:\"object\",group:\"Misc\",defaultValue:null},maxDate:{type:\"object\",group:\"Misc\",defaultValue:null}},aggregations:{selectedDates:{type:\"sap.ui.unified.DateRange\",multiple:!0,singularName:\"selectedDate\"},specialDates:{type:\"sap.ui.unified.DateTypeRange\",multiple:!0,singularName:\"specialDate\"},header:{type:\"sap.ui.unified.calendar.Header\",multiple:!1,visibility:\"hidden\"},timesRow:{type:\"sap.ui.unified.calendar.TimesRow\",multiple:!1,visibility:\"hidden\"},datesRow:{type:\"sap.ui.unified.calendar.Month\",multiple:!1,visibility:\"hidden\"},monthPicker:{type:\"sap.ui.unified.calendar.MonthPicker\",multiple:!1,visibility:\"hidden\"},yearPicker:{type:\"sap.ui.unified.calendar.YearPicker\",multiple:!1,visibility:\"hidden\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"},legend:{type:\"sap.ui.unified.CalendarLegend\",multiple:!1}},events:{select:{},cancel:{},startDateChange:{}}}});return j.prototype.init=function(){this._iMode=0,this._oYearFormat=sap.ui.core.format.DateFormat.getDateInstance({format:\"y\"}),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this._oMinDate=new l(new Date(Date.UTC(1,0,1))),this._oMinDate.getJSDate().setUTCFullYear(1),this._oMaxDate=new l(new Date(Date.UTC(9999,11,31,23,59,59)));var t=new o(this.getId()+\"--Head\",{visibleButton0:!0,visibleButton1:!0,visibleButton2:!0});t.attachEvent(\"pressPrevious\",this._handlePrevious,this),t.attachEvent(\"pressNext\",this._handleNext,this),t.attachEvent(\"pressButton0\",b,this),t.attachEvent(\"pressButton1\",x,this),t.attachEvent(\"pressButton2\",F,this),this.setAggregation(\"header\",t);var e=new n(this.getId()+\"--TimesRow\");e.attachEvent(\"focus\",S,this),e.attachEvent(\"select\",R,this),e._bNoThemeChange=!0,this.setAggregation(\"timesRow\",e);var a=new r(this.getId()+\"--MP\",{columns:0,months:6});a.attachEvent(\"select\",N,this),a._bNoThemeChange=!0,a.attachEvent(\"pageChange\",H,this),this.setAggregation(\"monthPicker\",a);var i=new h(this.getId()+\"--YP\",{columns:0,years:6});i.attachEvent(\"select\",Y,this),i.attachEvent(\"pageChange\",V,this),this.setAggregation(\"yearPicker\",i),this.setPickerPopup(!1),this._iItemsHead=15},j.prototype.exit=function(){this._sInvalidateContent&&t.sap.clearDelayedCall(this._sInvalidateContent)},j.prototype.onBeforeRendering=function(){var t=this.getAggregation(\"timesRow\"),e=this._getFocusedDate();M.call(this),t.displayDate(s._createLocalDate(e,!0))},j.prototype.setStartDate=function(e){if(s._checkJSDateObject(e),t.sap.equal(this.getStartDate(),e))return this;var a=e.getFullYear();s._checkYearInValidRange(a);var i=this.getMinDate();i&&e.getTime()<i.getTime()&&(t.sap.log.warning(\"startDate < minDate -> minDate as startDate set\",this),e=new Date(i));var o=this.getMaxDate();o&&e.getTime()>o.getTime()&&(t.sap.log.warning(\"startDate > maxDate -> maxDate as startDate set\",this),e=new Date(o)),this.setProperty(\"startDate\",e,!0);var n=this.getAggregation(\"timesRow\");n.setStartDate(e),this._oUTCStartDate=new l(n._getStartDate().getTime()),M.call(this);var g=s._createLocalDate(this._getFocusedDate(),!0);return n.checkDateFocusable(g)||(this._setFocusedDate(this._oUTCStartDate),n.displayDate(e)),this},j.prototype.invalidate=function(a){this._bDateRangeChanged||a&&a instanceof sap.ui.unified.DateRange?this.getDomRef()&&0==this._iMode&&!this._sInvalidateContent&&(this._sInvalidateContent=t.sap.delayedCall(0,this,L)):a&&(a instanceof sap.ui.unified.calendar.DatesRow||a instanceof sap.ui.unified.calendar.MonthPicker||a instanceof sap.ui.unified.calendar.YearPicker||a instanceof sap.ui.unified.calendar.Header)||e.prototype.invalidate.apply(this,arguments)},j.prototype.removeAllSelectedDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"selectedDates\");return t},j.prototype.destroySelectedDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"selectedDates\");return t},j.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=!0;var t=this.removeAllAggregation(\"specialDates\");return t},j.prototype.destroySpecialDates=function(){this._bDateRangeChanged=!0;var t=this.destroyAggregation(\"specialDates\");return t},j.prototype.setIntervalMinutes=function(t){if(t>=720)throw new Error(\"Only intervals < 720 minutes are allowed; \"+this);if(1440%t>0)throw new Error(\"A day must be divisible by the interval size; \"+this);this.setProperty(\"intervalMinutes\",t,!1);var e=this.getAggregation(\"timesRow\"),a=s._createLocalDate(this._getFocusedDate(),!0);if(!e.checkDateFocusable(a)){var i=D.call(this);this._setFocusedDate(i),e.setDate(s._createLocalDate(i,!0))}return this},j.prototype.setLocale=function(t){return this._sLocale!=t&&(this._sLocale=t,this._oLocaleData=void 0,this.invalidate()),this},j.prototype.getLocale=function(){return this._sLocale||(this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()),this._sLocale},j.prototype._getFocusedDate=function(){return this._oFocusedDate||p.call(this),this._oFocusedDate},j.prototype._setFocusedDate=function(t){if(!(t instanceof l))throw new Error(\"Date must be a UniversalDate object \"+this);this._oFocusedDate=new l(t.getTime())},j.prototype.focusDate=function(t){var e=!1,a=this.getAggregation(\"timesRow\");if(!a.checkDateFocusable(t)){var i=s._createUniversalUTCDate(t,void 0,!0);E.call(this,i),e=!0}return w.call(this,t,!1),e&&this.fireStartDateChange(),this},j.prototype.displayDate=function(t){return w.call(this,t,!0),this},j.prototype.setItems=function(t){this.setProperty(\"items\",t,!0),t=this._getItems();var e=this.getAggregation(\"timesRow\");e.setItems(t);var a=s._createLocalDate(this._getFocusedDate(),!0);if(!e.checkDateFocusable(a)){var i=D.call(this);this._setFocusedDate(i),e.setDate(s._createLocalDate(i,!0))}if(!this.getPickerPopup()){var o=this.getAggregation(\"datesRow\"),n=Math.floor(1.5*t);n>31&&(n=31),o.setDays(n);var g=this.getAggregation(\"monthPicker\"),r=Math.floor(t/2);r>12&&(r=12),g.setMonths(r);var h=this.getAggregation(\"yearPicker\"),l=Math.floor(t/2);l>20&&(l=20),h.setYears(l)}return M.call(this),this.getDomRef()&&(this._getShowItemHeader()?this.$().addClass(\"sapUiCalIntHead\"):this.$().removeClass(\"sapUiCalIntHead\")),this},j.prototype._getItems=function(){var t=this.getItems();return sap.ui.Device.system.phone&&t>6?6:t},j.prototype._getLocaleData=function(){if(!this._oLocaleData){var t=this.getLocale(),e=new sap.ui.core.Locale(t);this._oLocaleData=a.getInstance(e)}return this._oLocaleData},j.prototype.setPickerPopup=function(t){this.setProperty(\"pickerPopup\",t,!0);var e=this.getAggregation(\"datesRow\"),a=this.getAggregation(\"monthPicker\"),i=this.getAggregation(\"yearPicker\");return e&&e.destroy(),t?(e=new sap.ui.unified.calendar.Month(this.getId()+\"--DatesRow\",{selectedDates:[new sap.ui.unified.DateRange(this.getId()+\"--Range\")]}),this.setAggregation(\"datesRow\",e),a.setColumns(3),a.setMonths(12),i.setColumns(4),i.setYears(20)):(e=new g(this.getId()+\"--DatesRow\",{days:18,selectedDates:[new sap.ui.unified.DateRange(this.getId()+\"--Range\")]}),this.setAggregation(\"datesRow\",e),a.setColumns(0),a.setMonths(6),i.setColumns(0),i.setYears(6)),e.attachEvent(\"focus\",k,this),e.attachEvent(\"select\",A,this),e._bNoThemeChange=!0,e.getIntervalSelection=function(){return this.getProperty(\"intervalSelection\")},e.getSingleSelection=function(){return this.getProperty(\"singleSelection\")},e.getSelectedDates=function(){return this.getAggregation(\"selectedDates\",[])},e.getSpecialDates=function(){return this.getAggregation(\"specialDates\",[])},e.getAriaLabelledBy=function(){return this.getAssociation(\"ariaLabelledBy\",[])},this},j.prototype.setMinDate=function(e){if(t.sap.equal(e,this.getMinDate()))return this;if(e){s._checkJSDateObject(e),this._oMinDate=s._createUniversalUTCDate(e,void 0,!0);var a=this.getAggregation(\"timesRow\");this._oMinDate=a._getIntervalStart(this._oMinDate);var i=this._oMinDate.getUTCFullYear();s._checkYearInValidRange(i),this._oMaxDate.getTime()<this._oMinDate.getTime()&&(t.sap.log.warning(\"minDate > maxDate -> maxDate set to end of the month\",this),this._oMaxDate=s._createUniversalUTCDate(e,void 0,!0),s._updateUTCDate(this._oMaxDate,null,this._oMaxDate.getUTCMonth()+1,0,23,59,59,0),this.setProperty(\"maxDate\",s._createLocalDate(this._oMaxDate,!0),!0)),this._oFocusedDate&&this._oFocusedDate.getTime()<this._oMinDate.getTime()&&(t.sap.log.warning(\"focused date < minDate -> minDate focused\",this),this.focusDate(e)),this._oUTCStartDate&&this._oUTCStartDate.getTime()<this._oMinDate.getTime()&&(t.sap.log.warning(\"start date < minDate -> minDate set as start date\",this),u.call(this,new l(this._oMinDate.getTime()),!0,!0))}else s._updateUTCDate(this._oMinDate.getJSDate(),1,0,1,0,0,0,0);this.setProperty(\"minDate\",e,!1);var o=this.getAggregation(\"yearPicker\");return o._oMinDate.setYear(this._oMinDate.getUTCFullYear()),this},j.prototype.setMaxDate=function(e){if(t.sap.equal(e,this.getMaxDate()))return this;if(e){s._checkJSDateObject(e),this._oMaxDate=s._createUniversalUTCDate(e,void 0,!0);var a=this.getAggregation(\"timesRow\");this._oMaxDate=a._getIntervalStart(this._oMaxDate),this._oMaxDate.setUTCMinutes(this._oMaxDate.getUTCMinutes()+this.getIntervalMinutes()),this._oMaxDate.setUTCMilliseconds(-1);var i=this._oMaxDate.getUTCFullYear();if(s._checkYearInValidRange(i),this._oMinDate.getTime()>this._oMaxDate.getTime()&&(t.sap.log.warning(\"maxDate < minDate -> minDate set to begin of the month\",this),this._oMinDate=s._createUniversalUTCDate(e,void 0,!0),s._updateUTCDate(this._oMinDate,null,null,1,0,0,0,0),this.setProperty(\"minDate\",s._createLocalDate(this._oMinDate,!0),!0)),this._oFocusedDate&&this._oFocusedDate.getTime()>this._oMaxDate.getTime()&&(t.sap.log.warning(\"focused date > maxDate -> maxDate focused\",this),this.focusDate(e)),this._oUTCStartDate){var o=new l(this._oUTCStartDate.getTime());if(o.setUTCMinutes(o.getUTCMinutes()+this.getIntervalMinutes()*(this._getItems()-1)),o.getTime()>this._oMaxDate.getTime()){var n=new l(this._oMaxDate.getTime());n.setUTCMinutes(n.getUTCMinutes()-this.getIntervalMinutes()*(this._getItems()-1)),n.getTime()>=this._oMinDate.getTime()&&(t.sap.log.warning(\"end date > maxDate -> maxDate set as end date\",this),u.call(this,n,!0,!0))}}}else s._updateUTCDate(this._oMaxDate.getJSDate(),9999,11,31,23,59,59,0);this.setProperty(\"maxDate\",e,!1);var g=this.getAggregation(\"yearPicker\");return g._oMaxDate.setYear(this._oMaxDate.getUTCFullYear()),this},j.prototype.onclick=function(t){t.isMarked(\"delayedMouseEvent\")||t.target.id==this.getId()+\"-cancel\"&&this.onsapescape(t)},j.prototype.onmousedown=function(t){t.preventDefault(),t.setMark(\"cancelAutoClose\")},j.prototype.onsapescape=function(t){switch(this._iMode){case 0:this.fireCancel();break;case 1:m.call(this);break;case 2:T.call(this);break;case 3:C.call(this)}},j.prototype.onsaptabnext=function(e){var a=this.getAggregation(\"header\");if(t.sap.containsOrEquals(this.getDomRef(\"content\"),e.target)){if(t.sap.focus(a.getDomRef(\"B0\")),!this._bPoupupMode){var i=this.getAggregation(\"timesRow\"),s=this.getAggregation(\"monthPicker\"),o=this.getAggregation(\"yearPicker\");t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),s.getDomRef()&&t(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),o.getDomRef()&&t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\")}e.preventDefault()}else e.target.id==a.getId()+\"-B0\"?(t.sap.focus(a.getDomRef(\"B1\")),e.preventDefault()):e.target.id==a.getId()+\"-B1\"&&(t.sap.focus(a.getDomRef(\"B2\")),e.preventDefault())},j.prototype.onsaptabprevious=function(e){var a=this.getAggregation(\"header\");if(t.sap.containsOrEquals(this.getDomRef(\"content\"),e.target))this._bPoupupMode&&(t.sap.focus(a.getDomRef(\"B2\")),e.preventDefault());else if(e.target.id==a.getId()+\"-B0\"){var i=this.getAggregation(\"timesRow\"),s=this.getAggregation(\"monthPicker\"),o=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:i._oItemNavigation.focusItem(i._oItemNavigation.getFocusedIndex());break;case 2:s._oItemNavigation.focusItem(s._oItemNavigation.getFocusedIndex());break;case 3:o._oItemNavigation.focusItem(o._oItemNavigation.getFocusedIndex())}e.preventDefault()}else e.target.id==a.getId()+\"-B2\"?(t.sap.focus(a.getDomRef(\"B1\")),e.preventDefault()):e.target.id==a.getId()+\"-B1\"&&(t.sap.focus(a.getDomRef(\"B0\")),e.preventDefault())},j.prototype.onfocusin=function(e){if(e.target.id==this.getId()+\"-end\"){var a=this.getAggregation(\"header\"),i=this.getAggregation(\"timesRow\"),s=this.getAggregation(\"monthPicker\"),o=this.getAggregation(\"yearPicker\");t.sap.focus(a.getDomRef(\"B2\")),this._bPoupupMode||(t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),s.getDomRef()&&t(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"),o.getDomRef()&&t(o._oItemNavigation.getItemDomRefs()[o._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"-1\"))}this.$(\"end\").attr(\"tabindex\",\"-1\")},j.prototype.onsapfocusleave=function(e){if(!(e.relatedControlId&&t.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())||(this.$(\"end\").attr(\"tabindex\",\"0\"),this._bPoupupMode))){var a=this.getAggregation(\"timesRow\"),i=this.getAggregation(\"monthPicker\"),s=this.getAggregation(\"yearPicker\");switch(this._iMode){case 0:t(a._oItemNavigation.getItemDomRefs()[a._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\");break;case 2:t(i._oItemNavigation.getItemDomRefs()[i._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\");break;case 3:t(s._oItemNavigation.getItemDomRefs()[s._oItemNavigation.getFocusedIndex()]).attr(\"tabindex\",\"0\")}}},j.prototype._handlePrevious=function(t){var e=this._getFocusedDate();switch(this._iMode){case 0:var a=this._getItems(),i=new l(D.call(this).getTime()),o=this.getIntervalMinutes();i.setUTCMinutes(i.getUTCMinutes()-a*o),e.setUTCMinutes(e.getUTCMinutes()-a*o),this._setFocusedDate(e),u.call(this,i,!0);break;case 1:var n=this.getAggregation(\"datesRow\"),g=s._createUniversalUTCDate(n.getDate()),r=n.getDays();g.getUTCDate()<=r?g.setUTCDate(1):g.setUTCDate(g.getUTCDate()-r),J.call(this,g);break;case 2:var h=this.getAggregation(\"monthPicker\");h.getMonths()<12?(h.previousPage(),U.call(this)):(e.setUTCFullYear(e.getUTCFullYear()-1),E.call(this,e),this._setFocusedDate(e),M.call(this),O.call(this,e.getUTCFullYear(),h),this.fireStartDateChange());break;case 3:var c=this.getAggregation(\"yearPicker\");c.previousPage(),I.call(this)}},j.prototype._handleNext=function(t){var e=this._getFocusedDate();switch(this._iMode){case 0:var a=this._getItems(),i=new l(D.call(this).getTime()),o=this.getIntervalMinutes();i.setUTCMinutes(i.getUTCMinutes()+a*o),e.setUTCMinutes(e.getUTCMinutes()+a*o),this._setFocusedDate(e),u.call(this,i,!0);break;case 1:var n=this.getAggregation(\"datesRow\"),g=s._createUniversalUTCDate(n.getDate()),r=new l(g.getTime());r.setUTCDate(1),r.setUTCMonth(r.getUTCMonth()+1),r.setUTCDate(0);var h=n.getDays();g.getUTCDate()+h>r.getUTCDate()?g.setUTCDate(r.getUTCDate()):g.setUTCDate(g.getUTCDate()+h),J.call(this,g);break;case 2:var c=this.getAggregation(\"monthPicker\");c.getMonths()<12?(c.nextPage(),U.call(this)):(e.setUTCFullYear(e.getUTCFullYear()+1),E.call(this,e),this._setFocusedDate(e),M.call(this),O.call(this,e.getUTCFullYear(),c),this.fireStartDateChange());break;case 3:var d=this.getAggregation(\"yearPicker\");d.nextPage(),I.call(this)}},j.prototype._getShowItemHeader=function(){var t=this.getItems();return t>this._iItemsHead},j},!0);",
		"sap/ui/unified/CalendarTimeIntervalRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){t._iMode=0;var i=t.getId(),a=t.getTooltip_AsString(),r=t.getAggregation(\"timesRow\");e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiCal\"),e.addClass(\"sapUiCalInt\"),e.addClass(\"sapUiCalTimeInt\"),t._getShowItemHeader()&&e.addClass(\"sapUiCalIntHead\"),e.writeAttribute(\"tabindex\",\"-1\");var d=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),s={labelledby:{value:\"\",append:!1}};t._bPoupupMode&&(s.role=\"dialog\"),e.writeAccessibilityState(t,s),a&&e.writeAttributeEscaped(\"title\",a);var n=t.getWidth();n&&\"\"!=n&&(e.addStyle(\"width\",n),e.writeStyles()),e.writeClasses(),e.write(\">\");var l=t.getAggregation(\"header\");e.renderControl(l),e.write('<div id=\"'+i+'-content\" class=\"sapUiCalContent\">'),e.renderControl(r),e.write('<div id=\"'+i+'-contentOver\" class=\"sapUiCalContentOver\" style=\"display:none;\"></div>'),e.write(\"</div>\"),e.write('<button id=\"'+i+'-cancel\" class=\"sapUiCalCancel\" tabindex=\"-1\">'),e.write(d.getText(\"CALENDAR_CANCEL\")),e.write(\"</button>\"),e.write('<div id=\"'+i+'-end\" tabindex=\"0\" style=\"width:0;height:0;position:absolute;right:0;bottom:0;\"></div>'),e.write(\"</div>\")},t},!0);",
		"sap/ui/unified/CalendarWeekInterval.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/unified/calendar/CalendarUtils\",\"sap/ui/unified/calendar/CalendarDate\",\"./library\",\"sap/ui/unified/CalendarDateInterval\",\"sap/ui/unified/CalendarDateIntervalRenderer\"],function(e,t,a,o,r,s){\"use strict\";var n=r.extend(\"CalendarWeekInterval\",{renderer:s});return n.prototype._getDaysLarge=function(){return 6},n.prototype._handleFocus=function(e){var o,s,n,i=!!e.getParameter(\"_outsideBorder\");return i&&(o=e.getParameter(\"date\"),this._oFocusDateWeek=a.fromLocalJSDate(o),s=t._getFirstDateOfWeek(this._oFocusDateWeek),n=this.getAggregation(\"month\")[0],n.getDomRef()&&this._setStartDate(s,!1,!0)),r.prototype._handleFocus.apply(this,arguments)},n.prototype._adjustFocusedDateUponMonthChange=function(e,o){var r,s=new a(e);if(s.setDate(1),s.setMonth(s.getMonth()+1),r=this._oPlanningCalendar._dateMatchesVisibleRange(s.toLocalJSDate(),sap.ui.unified.CalendarIntervalType.Week),!r||o!==s.getMonth()){e.setMonth(o),e.setDate(1);var n=t._getFirstDateOfWeek(e);this._setStartDate(n,!1,!0),this._oFocusDateWeek=n,e.setYear(n.getYear()),e.setMonth(n.getMonth()),e.setDate(n.getDate())}},n.prototype._adjustFocusedDateUponYearChange=function(e,o){if(e&&e instanceof a){var r,s=t._getWeek(e),n=new a(e);for(n.setYear(o),n.setDate(n.getDate()-7),r=t._getWeek(n),52===s.week&&t._getNumberOfWeeksForYear(o)<53&&(s.week=51);s.week!==r.week;)n.setDate(n.getDate()+1),r=t._getWeek(n);e.setYear(n.getYear()),e.setMonth(n.getMonth()),e.setDate(n.getDate())}},n.prototype._focusDateExtend=function(e,t,a){var o,s;return this._oFocusDateWeek?(o=this.getAggregation(\"month\")[0],s=this._oFocusDateWeek.toLocalJSDate(),this._setFocusedDate(this._oFocusDateWeek),o.setDate(s),this._oFocusDateWeek=null,!a):r.prototype._focusDateExtend.apply(this,arguments)},n.prototype._dateMatchesVisibleRange=function(e){var t=this.getDays(),o=a.fromLocalJSDate(e),r=a.fromLocalJSDate(this.getStartDate()),s=a.fromLocalJSDate(this.getStartDate());return s.setDate(s.getDate()+t),o.isSameOrAfter(r)&&o.isBefore(s)},n},!0);",
		"sap/ui/unified/ColorPicker.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/ui/core/HTML\",\"sap/ui/core/ResizeHandler\",\"sap/ui/layout/Grid\",\"sap/ui/layout/GridData\",\"sap/ui/layout/VerticalLayout\",\"sap/ui/layout/HorizontalLayout\",\"sap/ui/core/Icon\",\"sap/ui/core/theming/Parameters\",\"sap/ui/core/InvisibleText\"],function(e,t,o,i,s,a,r,l,h,n,d,u){\"use strict\";var C=o.extend(\"sap.ui.unified.ColorPicker\",{metadata:{library:\"sap.ui.unified\",properties:{colorString:{type:\"string\",group:\"Misc\",defaultValue:null},mode:{type:\"sap.ui.unified.ColorPickerMode\",group:\"Appearance\",defaultValue:sap.ui.unified.ColorPickerMode.HSV}},aggregations:{_grid:{type:\"sap.ui.layout.Grid\",group:\"Appearance\",multiple:!1,visibility:\"hidden\"},_invisibleTexts:{type:\"sap.ui.core.InvisibleText\",multiple:!0,visibility:\"hidden\"}},events:{change:{parameters:{r:{type:\"int\"},g:{type:\"int\"},b:{type:\"int\"},h:{type:\"int\"},s:{type:\"int\"},v:{type:\"int\"},l:{type:\"int\"},hex:{type:\"string\"},alpha:{type:\"string\"}}},liveChange:{parameters:{r:{type:\"int\"},g:{type:\"int\"},b:{type:\"int\"},h:{type:\"int\"},s:{type:\"int\"},v:{type:\"int\"},l:{type:\"int\"},hex:{type:\"string\"},alpha:{type:\"string\"}}}}}}),p=\"\",c=sap.ui.resource(\"sap.ui.unified\",\"img/ColorPicker/Alphaslider_BG.png\"),g=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),f=t.ColorPickerHelper,S=f.factory,b={};Object.defineProperties(b,{RGB:{value:\"RGB\"},CPResponsiveClass:{value:\"sapUnifiedColorPicker\"},CPMatrixClass:{value:\"sapUiColorPicker-ColorPickerMatrix\"},HSLClass:{value:\"sapUiColorPickerHSL\"},LabelClass:{value:\"sapUiColorPicker-ColorPickerLabels\"},UnitLabelClass:{value:\"sapUiCPUnitLabel\"},HEXClass:{value:\"sapUiColorPicker-ColorPickerHexField\"},LeftColumnInputClass:{value:\"sapUiColorPicker-ColorPickerInputFieldsLeft\"},RightColumnInputClass:{value:\"sapUiColorPicker-ColorPickerInputFieldsRight\"},SliderClass:{value:\"sapUiColorPicker-ColorPickerSlider\"},AlphaSliderClass:{value:\"sapUiColorPicker-ColorPickerAlphaSlider\"},OutputSelectorClass:{value:\"sapUiColorPickerHSL-RB\"},OutputSelectorRowClass:{value:\"sapUiColorPicker-RBRow\"},CPBoxClass:{value:\"sapUiColorPicker-ColorPickerBox\"},CPCircleClass:{value:\"sapUiColorPicker-ColorPickerCircle\"},LastColumnClass:{value:\"sapUiColorPicker-ColorPickerLastColumn\"},HideForHSVClass:{value:\"hideForHSV\"},HideForHSLClass:{value:\"hideForHSL\"},OldColorClass:{value:\"sapUiColorPicker-ColorPickerOldColor\"},NewColorClass:{value:\"sapUiColorPicker-ColorPickerNewColor\"},SwatchesClass:{value:\"sapUiColorPicker-swatches\"},ArrowClass:{value:\"sapUiColorPicker-Arrow\"},Colors:{value:{aliceblue:\"f0f8ff\",antiquewhite:\"faebd7\",aqua:\"00ffff\",aquamarine:\"7fffd4\",azure:\"f0ffff\",beige:\"f5f5dc\",bisque:\"ffe4c4\",black:\"000000\",blanchedalmond:\"ffebcd\",blue:\"0000ff\",blueviolet:\"8a2be2\",brown:\"a52a2a\",burlywood:\"deb887\",cadetblue:\"5f9ea0\",chartreuse:\"7fff00\",chocolate:\"d2691e\",coral:\"ff7f50\",cornflowerblue:\"6495ed\",cornsilk:\"fff8dc\",crimson:\"dc143c\",cyan:\"00ffff\",darkblue:\"00008b\",darkcyan:\"008b8b\",darkgoldenrod:\"b8860b\",darkgray:\"a9a9a9\",darkgrey:\"a9a9a9\",darkgreen:\"006400\",darkkhaki:\"bdb76b\",darkmagenta:\"8b008b\",darkolivegreen:\"556b2f\",darkorange:\"ff8c00\",darkorchid:\"9932cc\",darkred:\"8b0000\",darksalmon:\"e9967a\",darkseagreen:\"8fbc8f\",darkslateblue:\"483d8b\",darkslategray:\"2f4f4f\",darkslategrey:\"2f4f4f\",darkturquoise:\"00ced1\",darkviolet:\"9400d3\",deeppink:\"ff1493\",deepskyblue:\"00bfff\",dimgray:\"696969\",dimgrey:\"696969\",dodgerblue:\"1e90ff\",firebrick:\"b22222\",floralwhite:\"fffaf0\",forestgreen:\"228b22\",fuchsia:\"ff00ff\",gainsboro:\"dcdcdc\",ghostwhite:\"f8f8ff\",gold:\"ffd700\",goldenrod:\"daa520\",gray:\"808080\",grey:\"808080\",green:\"008000\",greenyellow:\"adff2f\",honeydew:\"f0fff0\",hotpink:\"ff69b4\",indianred:\"cd5c5c\",indigo:\"4b0082\",ivory:\"fffff0\",khaki:\"f0e68c\",lavender:\"e6e6fa\",lavenderblush:\"fff0f5\",lawngreen:\"7cfc00\",lemonchiffon:\"fffacd\",lightblue:\"add8e6\",lightcoral:\"f08080\",lightcyan:\"e0ffff\",lightgoldenrodyellow:\"fafad2\",lightgray:\"d3d3d3\",lightgrey:\"d3d3d3\",lightgreen:\"90ee90\",lightpink:\"ffb6c1\",lightsalmon:\"ffa07a\",lightseagreen:\"20b2aa\",lightskyblue:\"87cefa\",lightslategray:\"778899\",lightslategrey:\"778899\",lightsteelblue:\"b0c4de\",lightyellow:\"ffffe0\",lime:\"00ff00\",limegreen:\"32cd32\",linen:\"faf0e6\",magenta:\"ff00ff\",maroon:\"800000\",mediumaquamarine:\"66cdaa\",mediumblue:\"0000cd\",mediumorchid:\"ba55d3\",mediumpurple:\"9370db\",mediumseagreen:\"3cb371\",mediumslateblue:\"7b68ee\",mediumspringgreen:\"00fa9a\",mediumturquoise:\"48d1cc\",mediumvioletred:\"c71585\",midnightblue:\"191970\",mintcream:\"f5fffa\",mistyrose:\"ffe4e1\",moccasin:\"ffe4b5\",navajowhite:\"ffdead\",navy:\"000080\",oldlace:\"fdf5e6\",olive:\"808000\",olivedrab:\"6b8e23\",orange:\"ffa500\",orangered:\"ff4500\",orchid:\"da70d6\",palegoldenrod:\"eee8aa\",palegreen:\"98fb98\",paleturquoise:\"afeeee\",palevioletred:\"db7093\",papayawhip:\"ffefd5\",peachpuff:\"ffdab9\",peru:\"cd853f\",pink:\"ffc0cb\",plum:\"dda0dd\",powderblue:\"b0e0e6\",purple:\"800080\",red:\"ff0000\",rosybrown:\"bc8f8f\",royalblue:\"4169e1\",saddlebrown:\"8b4513\",salmon:\"fa8072\",sandybrown:\"f4a460\",seagreen:\"2e8b57\",seashell:\"fff5ee\",sienna:\"a0522d\",silver:\"c0c0c0\",skyblue:\"87ceeb\",slateblue:\"6a5acd\",slategray:\"708090\",slategrey:\"708090\",snow:\"fffafa\",springgreen:\"00ff7f\",steelblue:\"4682b4\",tan:\"d2b48c\",teal:\"008080\",thistle:\"d8bfd8\",tomato:\"ff6347\",turquoise:\"40e0d0\",violet:\"ee82ee\",wheat:\"f5deb3\",white:\"ffffff\",whitesmoke:\"f5f5f5\",yellow:\"ffff00\",yellowgreen:\"9acd32\",transparent:\"00000000\"}}}),C.prototype.init=function(){p=sap.ui.Device.browser.firefox?\"-moz-linear-gradient\":sap.ui.Device.browser.msie?\"-ms-linear-gradient\":sap.ui.Device.browser.webkit?\"-webkit-linear-gradient\":\"linear-gradient\",this.Color={r:255,g:255,b:255,h:0,s:0,l:100,v:100,a:1,oldA:1,hex:\"#ffffff\",old:\"#ffffff\"},this.sHexString=\"ffffff\",this.$CPBox=null,this.$CPCur=null,this.RGB={r:0,g:0,b:0},this.bRtl=sap.ui.getCore().getConfiguration().getRTL(),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this.bResponsive=f.isResponsive(),this._iCPCursorSize=parseInt(d.get(\"_sap_ui_unified_ColorPickerCircleSize\"),10),this._processChanges=this._processHSVChanges,this._bHSLMode=!1};var _=o.extend(\"sap.ui.unified._ColorPickerBox\",{metadata:{events:{select:{parameters:{value:{type:\"int\"},saturation:{type:\"int\"}}},resize:{parameters:{size:{type:\"int\"}}}}},init:function(){this.bRtl=sap.ui.getCore().getConfiguration().getRTL()},exit:function(){this._sResizeListener&&s.deregister(this._sResizeListener)},getWidth:function(){return this.$().width()},getOffset:function(){return this.$().offset()},onBeforeRendering:function(){this._sResizeListener&&s.deregister(this._sResizeListener)},onAfterRendering:function(){this._handle=this.$().find(\"> div.\"+b.CPCircleClass),this._sResizeListener=s.register(this.getDomRef(),this.handleResize.bind(this))},handleResize:function(e){this.fireResize({size:e.size.width})},getHandle:function(){return this._handle},ontouchstart:function(e){this.handleTouch(e)},ontouchend:function(e){this.handleTouch(e)},ontouchmove:function(e){this.handleTouch(e)},handleTouch:function(e){var t=this.calculateValuesFromEvent(e);t&&this.fireSelect(t)},calculateValuesFromEvent:function(e){var t,o,i,s=e.offsetX,a=e.offsetY,r=t=this.getWidth();if(e.preventDefault&&e.preventDefault(),!s){if(o=e.targetTouches?e.targetTouches[0]:e,o&&o.pageX||(o=e,o&&o.pageX||!e.changedTouches||(o=e.changedTouches[0])),!o.pageX)return!1;i=this.getOffset(),s=o.pageX-i.left,a=o.pageY-i.top}return s=Math.min(Math.max(s,0),r),a=Math.min(Math.max(a,0),t),this.bRtl&&(s=r-s),{value:s/r*100,saturation:100*(1-a/t)}},renderer:function(e,t){e.write(\"<div\"),e.addClass(b.CPBoxClass),e.writeControlData(t),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.writeAttribute(\"id\",t.getId()+\"-cpCur\"),e.writeAttribute(\"tabindex\",0),e.addClass(b.CPCircleClass),e.writeClasses(),e.write(\"></div>\"),e.write(\"</div>\")}});return C.prototype._createRowFromInput=function(e,t,o,i){var s,a=g.getText(t);return s=new h({content:[S.createLabel({text:o,tooltip:a,labelFor:e}).addStyleClass(b.LabelClass),e.setTooltip(a)]}),i&&s.addContent(S.createLabel({text:i,labelFor:e}).addStyleClass(b.UnitLabelClass).addStyleClass(b.LabelClass)),s},C.prototype._updateColorStringProperty=function(e,t){var o=this._getCSSColorString();this.setProperty(\"colorString\",o,!0),t&&this.fireLiveChange({r:this.Color.r,g:this.Color.g,b:this.Color.b,h:this.Color.h,s:this.Color.s,v:this.Color.v,l:this.Color.l,alpha:this.Color.a,hex:this.Color.hex,formatHSL:this.Color.formatHSL,colorString:o}),e&&this.fireChange({r:this.Color.r,g:this.Color.g,b:this.Color.b,h:this.Color.h,s:this.Color.s,v:this.Color.v,l:this.Color.l,alpha:this.Color.a,hex:this.Color.hex,formatHSL:this.Color.formatHSL,colorString:o})},C.prototype._handleCPBoxSelectEvent=function(e){var t=e.getParameter(\"value\"),o=e.getParameter(\"saturation\");this.oSatField.setValue(o),this._bHSLMode?this.oLitField.setValue(t):this.oValField.setValue(t),this._processChanges(),this._updateColorStringProperty(!1,!0),$(this.$CPCur).focus()},C.prototype._handleCPBoxResizeEvent=function(e){this._iCPBoxSize=e.getParameter(\"size\"),this._updateCursorPosition()},C.prototype._handleCPBoxTouchEndEvent=function(e){this._updateColorStringProperty(!0,!1)},C.prototype.createRGBHexFields=function(){var e=this.getId();this.oHexField=S.createInput(e+\"-hxF\",{value:this.Color.hex.substr(1),change:this._handleHexValueChange.bind(this)}).addStyleClass(b.HEXClass),this.oRedField=S.createInput(e+\"-rF\",{value:this.Color.r,change:this._handleRedValueChange.bind(this)}).addStyleClass(b.LeftColumnInputClass),this.oGreenField=S.createInput(e+\"-gF\",{value:this.Color.g,change:this._handleGreenValueChange.bind(this)}).addStyleClass(b.LeftColumnInputClass),this.oBlueField=S.createInput(e+\"-bF\",{value:this.Color.b,change:this._handleBlueValueChange.bind(this)}).addStyleClass(b.LeftColumnInputClass)},C.prototype._createInteractionControls=function(){var e,o,i=this.getId();this.oCPBox=new _(i+\"-cpBox\",{select:this._handleCPBoxSelectEvent.bind(this),resize:this._handleCPBoxResizeEvent.bind(this)}),this.oCPBox.addDelegate({ontouchend:this._handleCPBoxTouchEndEvent.bind(this)}),this.createRGBHexFields(),this.oHueField=S.createInput(i+\"-hF\",{value:this.Color.h,change:this._handleHueValueChange.bind(this)}).addStyleClass(b.RightColumnInputClass),this.oSatField=S.createInput(i+\"-sF\",{value:this.Color.s,change:this._handleSatValueChange.bind(this)}).addStyleClass(b.RightColumnInputClass),this.oLitField=S.createInput(i+\"-lF\",{value:this.Color.l,change:this._handleLitValueChange.bind(this)}).addStyleClass(b.RightColumnInputClass),this.oAlphaField=S.createInput(i+\"-aF\",{value:this.Color.a,change:this._handleAlphaValueChange.bind(this)}).addStyleClass(b.RightColumnInputClass),this.oValField=S.createInput(i+\"-vF\",{value:this.Color.v,change:this._handleValValueChange.bind(this)}).addStyleClass(b.RightColumnInputClass),this.oRGBorHSLRBGroup=S.createRadioButtonGroup({columns:2,buttons:[S.createRadioButtonItem({text:b.RGB}),S.createRadioButtonItem({text:t.ColorPickerMode.HSL})],select:this._handleRGBorHSLValueChange.bind(this),selectedIndex:this.Color.formatHSL?1:0}).addStyleClass(b.OutputSelectorClass),e=new u({text:g.getText(\"COLORPICKER_HUE_SLIDER\")}).toStatic(),this.addAggregation(\"_invisibleTexts\",e,!0),C.prototype.createSlider=S.createSlider,this.oSlider=this.createSlider(i+\"-hSLD\",{max:360,step:1,tooltip:g.getText(\"COLORPICKER_HUE\"),value:parseInt(this.oHueField.getValue(),10)}),this.oSlider.addStyleClass(b.SliderClass).addAriaLabelledBy&&this.oSlider.addStyleClass(b.SliderClass).addAriaLabelledBy(e),this.oSlider.attachEvent(\"liveChange\",\"liveChange\",this._handleSliderChange.bind(this)),this.oSlider.attachEvent(\"change\",\"change\",this._handleSliderChange.bind(this)),o=new u({text:g.getText(\"COLORPICKER_ALPHA_SLIDER\")}).toStatic(),this.addAggregation(\"_invisibleTexts\",o,!0),this.oAlphaSlider=S.createSlider(i+\"-aSLD\",{max:1,value:1,step:.01,tooltip:g.getText(\"COLORPICKER_ALPHA\")}).addStyleClass(b.AlphaSliderClass).addAriaLabelledBy(o),this.oAlphaSlider.attachEvent(\"liveChange\",\"liveChange\",this._handleAlphaSliderChange.bind(this)),this.oAlphaSlider.attachEvent(\"change\",\"change\",this._handleAlphaSliderChange.bind(this))},C.prototype._createLayout=function(){var e,t=this.getId();this._bLayoutControlsCreated||(this._createInteractionControls(),e=new a({containerQuery:!0,content:[this.oCPBox.setLayoutData(this._oLayoutData.oCPBox),new l({content:[this._createRowFromInput(this.oRedField,\"COLORPICKER_RED\",\"R:\"),this._createRowFromInput(this.oGreenField,\"COLORPICKER_GREEN\",\"G:\"),this._createRowFromInput(this.oBlueField,\"COLORPICKER_BLUE\",\"B:\"),this._createRowFromInput(this.oHexField,\"COLORPICKER_HEX\",\"#:\")],layoutData:this._oLayoutData.icOne}),new l({content:[this._createRowFromInput(this.oHueField,\"COLORPICKER_HUE\",\"H:\"),this._createRowFromInput(this.oSatField,\"COLORPICKER_SAT\",\"S:\",\"%\"),this._createRowFromInput(this.oLitField,\"COLORPICKER_LIGHTNESS\",\"L:\",\"%\").addStyleClass(b.HideForHSVClass),this._createRowFromInput(this.oAlphaField,\"COLORPICKER_ALPHA\",\"A:\").addStyleClass(b.HideForHSVClass),this._createRowFromInput(this.oValField,\"COLORPICKER_VALUE\",\"V:\").addStyleClass(b.HideForHSLClass)],layoutData:this._oLayoutData.icTwo}).addStyleClass(b.LastColumnClass),new h({content:[new i({content:[\"<div id='\",t,\"-ocBox' class='\",b.OldColorClass,\"'></div>\"].join(\"\")}),new n({backgroundColor:\"transparent\",src:\"sap-icon://arrow-right\",tooltip:g.getText(\"COLORPICKER_NEW_OLD_COLOR\")}).addStyleClass(b.HideForHSVClass).addStyleClass(b.ArrowClass),new i({content:[\"<div id='\",t,\"-ncBox' class='\",b.NewColorClass,\"'></div>\"].join(\"\")})],layoutData:this._oLayoutData.swatches}).addStyleClass(b.SwatchesClass),new h({content:[S.createLabel({text:\"Output:\",labelFor:this.oRGBorHSLRBGroup}),this.oRGBorHSLRBGroup],layoutData:this._oLayoutData.rbg}).addStyleClass(b.HideForHSVClass).addStyleClass(b.OutputSelectorRowClass),this.oSlider.setLayoutData(new r({span:\"L6 M6 S12\",linebreak:!0})),this.oAlphaSlider.setLayoutData(new r({span:\"L6 M6 S12\"}))]}).addStyleClass(b.CPMatrixClass),this.setAggregation(\"_grid\",e,!0),this._bLayoutControlsCreated=!0,this._adaptControlToLibrary())},C.prototype._adaptControlToLibrary=function(){var t;this._bLayoutControlsCreated&&(t=this.getAggregation(\"_grid\"),this.bResponsive?(t._setBreakPointTablet(314),t.addStyleClass(b.CPResponsiveClass)):(t.setProperty(\"hSpacing\",0,!0),t.setProperty(\"vSpacing\",0,!0),this._oLayoutData.oCPBox.setSpanS(5),this._oLayoutData.icOne.setSpanS(4),this._oLayoutData.icTwo.setSpanS(3),this._oLayoutData.rbg.setSpanS(8)),this._adaptControlToLibrary=e.noop)},C.prototype._updateControlVisualState=function(){var e=this.getAggregation(\"_grid\");this._bLayoutControlsCreated&&(this.bResponsive?this._bHSLMode?(e.addStyleClass(b.HSLClass),this._oLayoutData.swatches.setSpanM(4).setLinebreak(!0)):(e.removeStyleClass(b.HSLClass),this._oLayoutData.swatches.setSpanM(3).setLinebreak(!1)):this._bHSLMode?(e.addStyleClass(b.HSLClass),this._oLayoutData.swatches.setSpanS(4).setLinebreak(!0)):(e.removeStyleClass(b.HSLClass),this._oLayoutData.swatches.setSpanS(3).setLinebreak(!1)))},C.prototype._processChanges=e.noop,C.prototype.setMode=function(o,i){switch(o){case t.ColorPickerMode.HSL:this._processChanges=this._processHSLChanges;break;case t.ColorPickerMode.HSV:this._processChanges=this._processHSVChanges;break;default:e.sap.log.error(\"Control must have a valid mode set to work correct\")}return this._bHSLMode=o===t.ColorPickerMode.HSL,this.setProperty(\"mode\",o,i)},C.prototype.onBeforeRendering=function(){this.createLayoutData(),this._createLayout(),this._updateControlVisualState(),this._updateColorString()},C.prototype.createLayoutData=function(){this._oLayoutData={oCPBox:new r({span:\"L6 M6 S12\"}),icOne:new r({span:\"L3 M3 S6\"}),icTwo:new r({span:\"L3 M3 S6\"}),swatches:new r({span:\"L3 M3 S12\"}),rbg:new r({span:\"L6 M8 S12\"})}},C.prototype._updateColorString=function(){this._parseColorString(this.getColorString()),this.oHexField.setValue(this.Color.hex.substr(1).toUpperCase()),this.oRedField.setValue(this.Color.r),this.oGreenField.setValue(this.Color.g),this.oBlueField.setValue(this.Color.b),this.oHueField.setValue(this.Color.h),this.oSatField.setValue(this.Color.s),this._bHSLMode?(this.oLitField.setValue(this.Color.l),this.oAlphaField.setValue(this.Color.a),this.oSlider.setValue(this.Color.h),this.oAlphaSlider.setValue(this.Color.a),this.oRGBorHSLRBGroup.setSelectedIndex(this.Color.formatHSL?1:0)):(this.oValField.setValue(this.Color.v),this.oSlider.setValue(this.Color.h),this.oAlphaSlider.setValue(this.Color.a),this.oAlphaField.setValue(this.Color.a)),this._updateColorStringProperty(!0,!0)},C.prototype.isColor=function(e){return this._parseColorString(e,!0)},C.prototype._handleSliderChange=function(e,t){var o=parseInt(this.oSlider.getValue(),10);this.oHueField.setValue(o),this._processChanges(),this._updateColorStringProperty(\"change\"===t,\"liveChange\"===t)},C.prototype._handleAlphaSliderChange=function(e,t){this.Color.a=this.oAlphaSlider.getValue(),this._bHSLMode&&this.oAlphaField.setValue(this.Color.a),this.Color.formatHSL?this._processChanges():this._processRGBChanges(),this._updateColorStringProperty(\"change\"===t,\"liveChange\"===t)},C.prototype._getValueInRange=function(e,t,o){return isNaN(e)&&(e=0),Math.min(Math.max(e,t),o)},C.prototype._handleAlphaValueChange=function(){var e=parseFloat(this.oAlphaField.getValue(),10);e=this._getValueInRange(e,0,1),this.Color.a=e,this.oAlphaField.setValue(e),this.oAlphaSlider.setValue(e),this.Color.formatHSL?this._processChanges():this._processRGBChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleRGBorHSLValueChange=function(){this.Color.formatHSL=1===this.oRGBorHSLRBGroup.getSelectedIndex(),this._updateColorStringProperty(!0,!0)},C.prototype._handleHueValueChange=function(){var e=parseInt(this.oHueField.getValue(),10);e=this._getValueInRange(e,0,360),this.oHueField.setValue(e),this.oSlider.setValue(e),this._processChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleSatValueChange=function(){var e=parseInt(this.oSatField.getValue(),10);e=this._getValueInRange(e,0,100),this.oSatField.setValue(e),this._processChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleValValueChange=function(){var e=parseInt(this.oValField.getValue(),10);e=this._getValueInRange(e,0,100),this.oValField.setValue(e),this._processHSVChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleLitValueChange=function(){var e=parseInt(this.oLitField.getValue(),10);e=this._getValueInRange(e,0,100),this.oLitField.setValue(e),this._processHSLChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleRedValueChange=function(){var e=parseInt(this.oRedField.getValue(),10);e=this._getValueInRange(e,0,255),this.oRedField.setValue(e),this._processRGBChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleGreenValueChange=function(){var e=parseInt(this.oGreenField.getValue(),10);e=this._getValueInRange(e,0,255),this.oGreenField.setValue(e),this._processRGBChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._handleBlueValueChange=function(){var e=parseInt(this.oBlueField.getValue(),10);e=this._getValueInRange(e,0,255),this.oBlueField.setValue(e),this._processRGBChanges(),this._updateColorStringProperty(!0,!0)},C.prototype._processHSVChanges=function(){var e=parseInt(this.oHueField.getValue(),10),t=parseInt(this.oSatField.getValue(),10),o=parseInt(this.oValField.getValue(),10);this._calculateRGB(e,t,o),this.Color.r=this.RGB.r,this.Color.g=this.RGB.g,this.Color.b=this.RGB.b,this.oRedField.setValue(this.Color.r),this.oGreenField.setValue(this.Color.g),this.oBlueField.setValue(this.Color.b),this._calculateHEX(this.Color.r,this.Color.g,this.Color.b),this.oHexField.setValue(this.sHexString.toUpperCase()),this.Color.hex=\"#\"+this.oHexField.getValue(),this.Color.h=e,this.Color.s=t,this.Color.v=o,this.oHueField.setValue(this.Color.h),this.oSatField.setValue(this.Color.s),this.oValField.setValue(this.Color.v),this._updateGradientBoxBackground(this.Color.h),this._updateCursorPosition(),this._updateSelColorBackground()},C.prototype._processHSLChanges=function(){var e=parseInt(this.oHueField.getValue(),10),t=parseInt(this.oSatField.getValue(),10),o=parseInt(this.oLitField.getValue(),10);e>360&&(e%=360),this._calculateRGB(e,t,o),this.Color.r=this.RGB.r,this.Color.g=this.RGB.g,this.Color.b=this.RGB.b,this.oRedField.setValue(this.Color.r),this.oGreenField.setValue(this.Color.g),this.oBlueField.setValue(this.Color.b),this._calculateHEX(this.Color.r,this.Color.g,this.Color.b),this.oHexField.setValue(this.sHexString.toUpperCase()),this.Color.hex=\"#\"+this.oHexField.getValue(),this.Color.h=e,this.Color.s=t,this.Color.l=o,this.oHueField.setValue(this.Color.h),this.oSatField.setValue(this.Color.s),this.oLitField.setValue(this.Color.l),this._updateGradientBoxBackground(this.Color.h),this._updateCursorPosition(),this._updateAlphaBackground(),this._updateSelColorBackground()},C.prototype._processRGBChanges=function(){var e=Math.round(parseInt(this.oRedField.getValue(),10)),t=Math.round(parseInt(this.oGreenField.getValue(),10)),o=Math.round(parseInt(this.oBlueField.getValue(),10));this._calculateHEX(e,t,o),this.oHexField.setValue(this.sHexString.toUpperCase()),this._bHSLMode?(this._calculateHSL(e,t,o),this.oLitField.setValue(this.Color.l)):(this._calculateHSV(e,t,o),this.oValField.setValue(this.Color.v)),this.oHueField.setValue(this.Color.h),this.oSatField.setValue(this.Color.s),this.oSlider.setValue(parseInt(this.oHueField.getValue(),10)),this.Color.r=e,this.Color.g=t,this.Color.b=o,this.Color.hex=\"#\"+this.oHexField.getValue(),this._updateGradientBoxBackground(this.Color.h),this._updateCursorPosition(),this._updateSelColorBackground()},C.prototype._handleHexValueChange=function(){var e,t=this.oHexField.getValue().toLowerCase(),o=1;return\"#\"===t.substr(0,1)&&(t=t.substr(1)),e=/^([0-9a-fA-F]{8})$/,e.test(t)!==!1&&(o=Number((parseInt(t.substr(6,2),16)/255).toFixed(2)),t=t.substr(0,6)),e=/^([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/,e.test(t)===!1?(this.oHexField.setValueState(sap.ui.core.ValueState.Error),this.oSlider.setEnabled(!1),this.oAlphaSlider.setEnabled(!1),this.oHueField.setEnabled(!1),this.oRedField.setEnabled(!1),this.oGreenField.setEnabled(!1),this.oBlueField.setEnabled(!1),this.oSatField.setEnabled(!1),void(this._bHSLMode?(this.oLitField.setEnabled(!1),this.oAlphaField.setEnabled(!1)):this.oValField.setEnabled(!1))):(this.oHexField.getValueState()===sap.ui.core.ValueState.Error&&(this.oHexField.setValueState(sap.ui.core.ValueState.None),this.oSlider.setEnabled(!0),this.oAlphaSlider.setEnabled(!0),this.oHueField.setEnabled(!0),this.oRedField.setEnabled(!0),this.oGreenField.setEnabled(!0),this.oBlueField.setEnabled(!0),this.oSatField.setEnabled(!0),this._bHSLMode?(this.oLitField.setEnabled(!0),this.oAlphaField.setEnabled(!0)):this.oValField.setEnabled(!0)),3===t.length&&(t=t.charAt(0)+t.charAt(0)+t.charAt(1)+t.charAt(1)+t.charAt(2)+t.charAt(2)),this._processHexChanges(t),this.oHexField.setValue(t.toUpperCase()),this.oRedField.setValue(this.Color.r),this.oGreenField.setValue(this.Color.g),this.oBlueField.setValue(this.Color.b),this.oHueField.setValue(this.Color.h),this.oSatField.setValue(this.Color.s),this._bHSLMode?(this.oLitField.setValue(this.Color.l),this.oAlphaField.setValue(1)):this.oValField.setValue(this.Color.v),this.oSlider.setValue(parseInt(this.oHueField.getValue(),10)),this.oAlphaSlider.setValue(o),this.Color.a=o,this._bHSLMode&&this.oAlphaField.setValue(o),this._updateGradientBoxBackground(this.Color.h),this._updateCursorPosition(),this._updateSelColorBackground(),void this._updateColorStringProperty(!0,!0))},C.prototype._processHexChanges=function(e){this._convertRGB(e),this._bHSLMode?this._calculateHSL(this.Color.r,this.Color.g,this.Color.b):this._calculateHSV(this.Color.r,this.Color.g,this.Color.b),this.Color.hex=\"#\"+e.toLowerCase()},C.prototype._updateAlphaBackground=function(){var e=[this.Color.r,this.Color.g,this.Color.b].join(\",\"),t=p+\"(left,rgba(\"+e+\",0),rgba(\"+e+\",1)),url(\"+c+\")\";this.lastAlphaSliderGradient!==t&&(this.oAlphaSlider.$().find(this.bResponsive?\".sapMSliderInner\":\".sapUiSliBar\").css(\"background-image\",t),this.lastAlphaSliderGradient=t)},C.prototype._updateCursorPosition=function(){var e,t;this._iCPBoxSize&&(e=this._bHSLMode?Math.round(this.oLitField.getValue()*this._iCPBoxSize/100):Math.round(this.oValField.getValue()*this._iCPBoxSize/100),this.bRtl&&(e=this._iCPBoxSize-e),t=Math.round((1-this.oSatField.getValue()/100)*this._iCPBoxSize),e=Math.round(Math.max(e,0)-this._iCPCursorSize/2-1),t=Math.round(Math.max(t,0)-this._iCPCursorSize/2-1),this.$CPCur.css(\"left\",e).css(\"top\",t))},C.prototype._calculateRGB=function(e,t,o){var i,s,a,r,l,h,n;if(this._bHSLMode)return void this._calculateRGBAdvanced(e,t,o);switch(e%=360,e/=60,t/=100,o/=100,h=o*t,l=h*(1-Math.abs(e%2-1)),r=o-h,i=0,s=0,a=0,n=Math.floor(e)){case 0:i=h,s=l;break;case 1:i=l,s=h;break;case 2:s=h,a=l;break;case 3:s=l,a=h;break;case 4:i=l,a=h;break;case 5:i=h,a=l;break;default:i=0,a=0,s=0}this.RGB.r=Math.floor(255*(i+r)),this.RGB.g=Math.floor(255*(s+r)),this.RGB.b=Math.floor(255*(a+r))},C.prototype._calculateRGBAdvanced=function(e,t,o){var i,s,a,r,l,h,n,d,u;switch(e=this._getValueInRange(e,0,360),t>100?t=1:t<0?t=0:t/=100,o>100?o=1:o<0?o=0:o/=100,d=t*(1-Math.abs(2*o-1)),n=255*(o-.5*d),h=d*(1-Math.abs(e/60%2-1)),u=Math.floor(e/60),l=n+255*h,r=n+255*d,u){case 0:i=r,s=l,a=n;break;case 1:i=l,s=r,a=n;break;case 2:i=n,s=r,a=l;break;case 3:i=n,s=l,a=r;break;case 4:i=l,s=n,a=r;break;case 5:i=r,s=n,a=l;break;default:i=0,s=0,a=0}this.RGB.r=Math.round(i),this.RGB.g=Math.round(s),this.RGB.b=Math.round(a)},C.prototype._getCSSColorString=function(){return this.Color.formatHSL?this.Color.a<1?\"hsla(\"+this.Color.h+\",\"+this.Color.s+\"%,\"+this.Color.l+\"%, \"+this.Color.a+\")\":\"hsl(\"+this.Color.h+\",\"+this.Color.s+\"%,\"+this.Color.l+\"%)\":this.Color.a<1?\"rgba(\"+this.Color.r+\",\"+this.Color.g+\",\"+this.Color.b+\", \"+this.Color.a+\")\":\"rgb(\"+this.Color.r+\",\"+this.Color.g+\",\"+this.Color.b+\")\"},C.prototype._calculateHEX=function(e,t,o){var i=e.toString(16),s=t.toString(16),a=o.toString(16);1===i.length&&(i=\"0\"+i),1===s.length&&(s=\"0\"+s),1===a.length&&(a=\"0\"+a),this.sHexString=(i+s+a).toLowerCase()},C.prototype._calculateHSV=function(e,t,o){var i=Math.max(Math.max(e,t),o),s=Math.min(Math.min(e,t),o),a=i-s,r=Math.round(100*i/255),l=0===i?0:100*a/i,h=0;0===l?h=0:e===i?h=60*(t-o)/a:t===i?h=120+60*(o-e)/a:o===i&&(h=240+60*(e-t)/a),h<0&&(h+=359.9),h=Math.round(h),l=Math.round(l),this.Color.h=h,this.Color.s=l,this.Color.v=r},C.prototype._calculateHSL=function(e,t,o){var i=Math.max(e,t,o),s=Math.min(e,t,o),a=(i-s)/255,r=(i+s)/510,l=1-Math.abs(2*r-1),h=0===r?0:a/l,n=0!==l?h:0,d=0;if(r=Math.round(100*r),n=Math.round(100*n),0===r||0===n||e+t+o===765)d=0;else{var u=i-s;i===e&&(d=(t-o)/u%6),i===t&&(d=(o-e)/u+2),i===o&&(d=(e-t)/u+4),0===u&&(d=0),d*=60,d<0&&(d+=360)}this.Color.h=Math.round(d),this.Color.s=n,this.Color.l=r},C.prototype._convertRGB=function(e){this.Color.r=parseInt(e.substr(0,2),16),this.Color.g=parseInt(e.substr(2,2),16),this.Color.b=parseInt(e.substr(4,2),16)},C.prototype._updateGradientBoxBackground=function(e){this._bHSLMode?this._calculateRGBAdvanced(e,100,50):this._calculateRGB(e,100,100),this._calculateHEX(this.RGB.r,this.RGB.g,this.RGB.b),this.$CPBox.css(\"background-color\",\"rgb(\"+[this.RGB.r,this.RGB.g,this.RGB.b].join(\",\")+\")\")},C.prototype._updateSelColorBackground=function(){this.$(\"ncBox\").css(\"background-color\",this._getCSSColorString())},C.prototype._parseColorString=function(e,t){var o;return\"#\"===e.substr(0,1)&&(e=e.substr(1)),e=e.trim().toLowerCase(),o=this._parseColorName(e),o?!!t||(8===o.length&&(this.Color.a=this.Color.oldA=Number((parseInt(o.substr(6,2),16)/255).toFixed(2)),o=o.substring(0,6)),this._processHexChanges(o),this.Color.old=this.Color.hex,this._bHSLMode&&(this.Color.formatHSL=!1),!0):/^([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/.test(e)?!!t||(o=3===e.length?e[0]+e[0]+e[1]+e[1]+e[2]+e[2]:e,this._processHexChanges(o),this.Color.old=this.Color.hex,this._bHSLMode&&(this.Color.formatHSL=!1),!0):\"rgb\"===e.substr(0,3)?this._parseRGB(e,t):this._bHSLMode?this._parseHSL(e,t):\"hsv\"===e.substr(0,3)&&this._parseHSV(e,t)},C.prototype._parseHSV=function(e,t){var o,i,s,a,r=/^(((\\d{1,2})|([1,2]\\d{2})|(3[0-5]\\d)|(360)),)(((\\d{1,2})|(100)),)((\\d{1,2})|(100))$/;return e=e.substr(3).replace(\"(\",\"\").replace(\")\",\"\").split(\" \").join(\"\"),r.test(e)===!0&&(!!t||(o=e.split(\",\"),i=parseInt(o[0],10),s=parseInt(o[1],10),a=parseInt(o[2],10),this._calculateRGB(i,s,a),this._calculateHEX(this.RGB.r,this.RGB.g,this.RGB.b),this.Color.r=this.RGB.r,this.Color.g=this.RGB.g,this.Color.b=this.RGB.b,this.Color.h=i,this.Color.s=s,this.Color.v=a,this.Color.hex=\"#\"+this.sHexString,this.Color.old=this.Color.hex,!0))},C.prototype._parseHSL=function(e,t){var o,i,s,a,r,l,h=e.substr(0,4);if(\"hsla\"===h)i=!0;else{if(\"hsl(\"!==h)return!1;i=!1}if(e=e.substr(i?4:3).replace(\"(\",\"\").replace(\")\",\"\").split(\" \").join(\"\"),o=e.split(\",\"),s=parseInt(o[0],10),a=parseFloat(o[1]),r=parseFloat(o[2]),i)l=parseFloat(o[3]);else{if(o[3]&&parseFloat(o[3])>=0)return!1;l=1}return a=a<1&&a>0?100*a:a,r=r<1&&r>0?100*r:r,s>=0&&s<=360&&a>=0&&a<=100&&r>=0&&r<=100&&l>=0&&l<=1&&(!!t||(this._calculateRGB(s,a,r),this._calculateHEX(this.RGB.r,this.RGB.g,this.RGB.b),this.Color.r=this.RGB.r,this.Color.g=this.RGB.g,this.Color.b=this.RGB.b,this.Color.h=s,this.Color.s=a,this.Color.l=r,this.Color.hex=\"#\"+this.sHexString,this.Color.old=this.Color.hex,this.Color.a=this.Color.oldA=l,this.Color.formatHSL=!0,!0))},C.prototype._parseRGB=function(e,t){var o,i,s,a;if(i=e.substring(0,4),\"rgba\"===i)a=/^(((\\d{1,2})|(1\\d{2})|(2[0-4]\\d)|(25[0-5])),){2}(((\\d{1,2})|(1\\d{2})|(2[0-4]\\d)|(25[0-5])),)([0]|([0]\\.[0-9]+)|(\\.[0-9]+)|[1])$/,s=!0;else{if(\"rgb\"!==i.substring(0,3))return!1;a=/^(((\\d{1,2})|(1\\d{2})|(2[0-4]\\d)|(25[0-5])),){2}(((\\d{1,2})|(1\\d{2})|(2[0-4]\\d)|(25[0-5])))$/,s=!1}return e=e.substr(s?4:3).replace(\"(\",\"\").replace(\")\",\"\").split(\" \").join(\"\"),a.test(e)?!!t||(o=e.split(\",\"),this._calculateHEX(parseInt(o[0],10),parseInt(o[1],10),parseInt(o[2],10)),this._processHexChanges(this.sHexString),this.Color.old=this.Color.hex,s&&(this.Color.a=this.Color.oldA=parseFloat(o[3])),!0):(this._bHSLMode&&(this.Color.formatHSL=!1),!1)},C.prototype._parseColorName=function(e){return b.Colors[e]},C.prototype.onAfterRendering=function(){var t=this._getCSSColorString();this.$CPBox=this.oCPBox.$(),this.$CPCur=this.oCPBox.getHandle(),this.$(\"ncBox\").css(\"background-color\",t),this.$(\"ocBox\").css(\"background-color\",t),this._updateGradientBoxBackground(this.Color.h),this._iCPBoxSize=this.oCPBox.getWidth(),this._updateCursorPosition(),this._bHSLMode&&this._updateAlphaBackground(),this.oSlider.iShiftGrip=Math.round(e(this.oSlider.oGrip).outerWidth()/2),this.oAlphaSlider.iShiftGrip=Math.round(e(this.oAlphaSlider.oGrip).outerWidth()/2)},C.prototype.getRGB=function(){return{r:this.Color.r,g:this.Color.g,b:this.Color.b}},C.prototype._getConstants=function(){return b},C},!0);",
		"sap/ui/unified/ColorPickerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(r){\"use strict\";var e={};return e.render=function(r,e){r.write(\"<div\"),r.writeControlData(e),r.writeClasses(),r.write(\">\"),r.renderControl(e.getAggregation(\"_grid\")),r.write(\"</div>\")},e},!0);",
		"sap/ui/unified/ContentSwitcher.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"./library\"],function(t,e,n){\"use strict\";var i=e.extend(\"sap.ui.unified.ContentSwitcher\",{metadata:{deprecated:!0,library:\"sap.ui.unified\",properties:{animation:{type:\"string\",group:\"Appearance\",defaultValue:\"None\"},activeContent:{type:\"int\",group:\"Behavior\",defaultValue:1}},aggregations:{content1:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content1\"},content2:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content2\"}}}});return function(e){i.prototype.init=function(){},i.prototype.switchContent=function(){return this.setActiveContent(1==this.getActiveContent()?2:1),this},i.prototype.onAfterRendering=function(){this._$Contents=[this.$(\"content1\"),this.$(\"content2\")]},i.prototype._showActiveContent=function(t){this._$Contents&&(this._$Contents[0].toggleClass(\"sapUiUfdCSwitcherVisible\",1===t),this._$Contents[1].toggleClass(\"sapUiUfdCSwitcherVisible\",2===t))},i.prototype.setActiveContent=function(e){return e=parseInt(e,10),isNaN(e)||e<1?(e=1,t.sap.log.warning(\"setActiveContent argument must be either 1 or 2. Active content set to 1.\")):e>2&&(e=2,t.sap.log.warning(\"setActiveContent argument must be either 1 or 2. Active content set to 2.\")),this.setProperty(\"activeContent\",e,!0),this._showActiveContent(e),this},i.prototype.setAnimation=function(e,n){\"string\"!=typeof e&&(e=sap.ui.unified.ContentSwitcherAnimation.None,t.sap.log.warning('setAnimation argument must be a string. Animation was set to \"'+sap.ui.unified.ContentSwitcherAnimation.None+'\".')),e=e.replace(/[^a-zA-Z0-9]/g,\"\");var i=this.getProperty(\"animation\");if(e===i)return this;var o=this.$();return o[0]&&(o.toggleClass(\"sapUiUfdCSwitcherAnimation\"+i,!1),o.toggleClass(\"sapUiUfdCSwitcherAnimation\"+e,!0)),this.setProperty(\"animation\",e,n)}}(window),i},!0);",
		"sap/ui/unified/ContentSwitcherRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(e,i){var n=i.getId(),r=i.getAnimation();sap.ui.getCore().getConfiguration().getAnimation()||(r=sap.ui.unified.ContentSwitcherAnimation.None);var o=i.getActiveContent();e.write(\"<div\"),e.writeControlData(i),e.addClass(\"sapUiUfdCSwitcher\"),e.addClass(\"sapUiUfdCSwitcherAnimation\"+t.sap.encodeHTML(r)),e.writeClasses(),e.write(\">\"),e.write('<section id=\"'+n+'-content1\" class=\"sapUiUfdCSwitcherContent sapUiUfdCSwitcherContent1'+(1==o?\" sapUiUfdCSwitcherVisible\":\"\")+'\">'),this.renderContent(e,i.getContent1()),e.write(\"</section>\"),e.write('<section id=\"'+n+'-content2\" class=\"sapUiUfdCSwitcherContent sapUiUfdCSwitcherContent2'+(2==o?\" sapUiUfdCSwitcherVisible\":\"\")+'\">'),this.renderContent(e,i.getContent2()),e.write(\"</section>\"),e.write(\"</div>\")},e.renderContent=function(t,e){for(var i=0;i<e.length;++i)t.renderControl(e[i])},e},!0);",
		"sap/ui/unified/Currency.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/LocaleData\",\"sap/ui/core/format/NumberFormat\"],function(t,e,r,i){\"use strict\";var s=e.extend(\"sap.ui.unified.Currency\",{metadata:{library:\"sap.ui.unified\",properties:{value:{type:\"float\",group:\"Appearance\",defaultValue:0},currency:{type:\"string\",group:\"Appearance\",defaultValue:null},maxPrecision:{type:\"int\",group:\"Appearance\",defaultValue:3},useSymbol:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}}}});return s.FIGURE_SPACE=\" \",s.PUNCTUATION_SPACE=\" \",s.prototype.init=function(){this._oFormat=i.getCurrencyInstance({showMeasure:!1})},s.prototype.exit=function(){this._oFormat=null,this._$Value=null,this._$Currency=null,this._sLastCurrency=null,this._iLastCurrencyDigits=null,this._bRenderNoValClass=null},s.prototype.onAfterRendering=function(){this.$()&&(this._$Value=this.$().find(\".sapUiUfdCurrencyValue\"),this._$Currency=this.$().find(\".sapUiUfdCurrencyCurrency\"))},s.prototype.setValue=function(t){return this.isBound(\"value\")&&(this._bRenderNoValClass=null==t,this.$()&&this.$().toggleClass(\"sapUiUfdCurrencyNoVal\",this._bRenderNoValClass)),this.setProperty(\"value\",t,!0),this._renderValue(),this},s.prototype.unbindProperty=function(t){e.prototype.unbindProperty.apply(this,arguments),\"value\"===t&&(this._bRenderNoValClass=!1,this.$()&&this.$().toggleClass(\"sapUiUfdCurrencyNoVal\",!1))},s.prototype.setCurrency=function(e){var r,i;return this.setProperty(\"currency\",e,!0),this._renderCurrency(),r=this._oFormat.oLocaleData.getCurrencyDigits(e),t.isNumeric(this._iLastCurrencyDigits)&&this._iLastCurrencyDigits!==r&&(i=!0),this._iLastCurrencyDigits=r,\"*\"!==this._sLastCurrency&&\"*\"!==e||(i=!0),this._sLastCurrency=e,i&&(this._renderValue(),\"*\"===e&&this.$()&&(this._bRenderNoValClass=!1,this.$().toggleClass(\"sapUiUfdCurrencyNoVal\",!1))),this},s.prototype.setUseSymbol=function(t){return this.setProperty(\"useSymbol\",t,!0),this._renderCurrency(),this},s.prototype.setMaxPrecision=function(t){return this.setProperty(\"maxPrecision\",t,!0),this._renderValue(),this},s.prototype._renderValue=function(){this._$Value&&this._$Value.text(this.getFormattedValue())},s.prototype._renderCurrency=function(){this._$Currency&&this._$Currency.text(this._getCurrency())},s.prototype._getCurrency=function(){return this.getUseSymbol()?this.getCurrencySymbol():this.getCurrency()},s.prototype.getFormattedValue=function(){var e,r,i,n,o=this.getCurrency();return\"*\"===o?\"\":(i=this._oFormat.oLocaleData.getCurrencyDigits(o),e=this.getMaxPrecision(),e=e<=0&&i>0?e-1:e,r=e-i,n=this._oFormat.format(this.getValue(),o),r==e&&e>0&&(n+=s.PUNCTUATION_SPACE),r>0?n=t.sap.padRight(n,s.FIGURE_SPACE,n.length+r):r<0&&(n=n.substr(0,n.length+r)),n)},s.prototype.getCurrencySymbol=function(){return this._oFormat.oLocaleData.getCurrencySymbol(this.getCurrency())},s.prototype.getAccessibilityInfo=function(){return this._bRenderNoValClass?{}:{description:(this.getFormattedValue()||\"\")+\" \"+(this.getCurrency()||\"\").trim()}},s},!0);",
		"sap/ui/unified/CurrencyRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var r={};return r.render=function(e,r){var t=r.getTooltip_AsString();e.write(\"<div\"),e.writeControlData(r),t&&e.writeAttributeEscaped(\"title\",t),e.addClass(\"sapUiUfdCurrency\"),r._bRenderNoValClass&&e.addClass(\"sapUiUfdCurrencyNoVal\"),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.addClass(\"sapUiUfdCurrencyAlign\"),e.writeClasses(),e.write(\">\"),e.write(\"<span\"),e.writeAttribute(\"dir\",\"ltr\"),e.addClass(\"sapUiUfdCurrencyValue\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(r.getFormattedValue()),e.write(\"</span>\"),e.write(\"<span\"),e.addClass(\"sapUiUfdCurrencyCurrency\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(r._getCurrency()),e.write(\"</span>\"),e.write(\"</div>\"),e.write(\"</div>\")},r},!0);",
		"sap/ui/unified/DateRange.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\",\"sap/ui/unified/calendar/CalendarUtils\"],function(e,t,a,r){\"use strict\";var i=t.extend(\"sap.ui.unified.DateRange\",{metadata:{library:\"sap.ui.unified\",properties:{startDate:{type:\"object\",group:\"Misc\",defaultValue:null},endDate:{type:\"object\",group:\"Misc\",defaultValue:null}}}});return i.prototype.setStartDate=function(e){if(e){r._checkJSDateObject(e);var t=e.getFullYear();r._checkYearInValidRange(t)}return this.setProperty(\"startDate\",e),this},i.prototype.setEndDate=function(e){if(e){r._checkJSDateObject(e);var t=e.getFullYear();r._checkYearInValidRange(t)}return this.setProperty(\"endDate\",e),this},i},!0);",
		"sap/ui/unified/DateTypeRange.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./DateRange\",\"./library\"],function(e,a,i){\"use strict\";var p=a.extend(\"sap.ui.unified.DateTypeRange\",{metadata:{library:\"sap.ui.unified\",properties:{type:{type:\"sap.ui.unified.CalendarDayType\",group:\"Appearance\",defaultValue:sap.ui.unified.CalendarDayType.Type01}}}});return p},!0);",
		"sap/ui/unified/FileUploader.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"./library\",\"sap/ui/core/LabelEnablement\",\"sap/ui/core/EnabledPropagator\"],function(e,t,i,s,o){\"use strict\";var a=t.extend(\"sap.ui.unified.FileUploader\",{metadata:{interfaces:[\"sap.ui.core.IFormContent\"],library:\"sap.ui.unified\",properties:{value:{type:\"string\",group:\"Data\",defaultValue:\"\"},enabled:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},uploadUrl:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:\"\"},name:{type:\"string\",group:\"Data\",defaultValue:null},width:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:\"\"},uploadOnChange:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},additionalData:{type:\"string\",group:\"Data\",defaultValue:null},sameFilenameAllowed:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},buttonText:{type:\"string\",group:\"Misc\",defaultValue:null},fileType:{type:\"string[]\",group:\"Data\",defaultValue:null},multiple:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},maximumFileSize:{type:\"float\",group:\"Data\",defaultValue:null},mimeType:{type:\"string[]\",group:\"Data\",defaultValue:null},sendXHR:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},placeholder:{type:\"string\",group:\"Appearance\",defaultValue:null},style:{type:\"string\",group:\"Appearance\",defaultValue:null},buttonOnly:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},useMultipart:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},maximumFilenameLength:{type:\"int\",group:\"Data\",defaultValue:null},valueState:{type:\"sap.ui.core.ValueState\",group:\"Data\",defaultValue:sap.ui.core.ValueState.None},icon:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:\"\"},iconHovered:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:\"\"},iconSelected:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:\"\"},iconFirst:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},iconOnly:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},aggregations:{parameters:{type:\"sap.ui.unified.FileUploaderParameter\",multiple:!0,singularName:\"parameter\"},headerParameters:{type:\"sap.ui.unified.FileUploaderParameter\",multiple:!0,singularName:\"headerParameter\"}},events:{change:{parameters:{newValue:{type:\"string\"},files:{type:\"object[]\"}}},uploadComplete:{parameters:{fileName:{type:\"string\"},response:{type:\"string\"},readyStateXHR:{type:\"string\"},status:{type:\"string\"},responseRaw:{type:\"string\"},headers:{type:\"object\"},requestHeaders:{type:\"object[]\"}}},typeMissmatch:{parameters:{fileName:{type:\"string\"},fileType:{type:\"string\"},mimeType:{type:\"string\"}}},fileSizeExceed:{parameters:{fileName:{type:\"string\"},fileSize:{type:\"string\"}}},fileAllowed:{},uploadProgress:{parameters:{lengthComputable:{type:\"boolean\"},loaded:{type:\"float\"},total:{type:\"float\"},fileName:{type:\"string\"},requestHeaders:{type:\"object[]\"}}},uploadAborted:{parameters:{fileName:{type:\"string\"},requestHeaders:{type:\"object[]\"}}},filenameLengthExceed:{parameters:{fileName:{type:\"string\"}}},uploadStart:{parameters:{fileName:{type:\"string\"},requestHeaders:{type:\"object[]\"}}}}}});return o.call(a.prototype),a.prototype.init=function(){if(this.oFilePath=sap.ui.unified.FileUploaderHelper.createTextField(this.getId()+\"-fu_input\"),this.oBrowse=sap.ui.unified.FileUploaderHelper.createButton(),this.oFilePath.setParent(this),this.oBrowse.setParent(this),this.oFileUpload=null,this.bMobileLib=\"sap.m.Button\"==this.oBrowse.getMetadata().getName(),this.getIconOnly()?this.oBrowse.setTooltip(this.getBrowseText()):this.oBrowse.setText(this.getBrowseText()),sap.ui.getCore().getConfiguration().getAccessibility()){if(!a.prototype._sAccText){var e=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\");a.prototype._sAccText=e.getText(\"FILEUPLOAD_ACC\")}this.oBrowse.addAriaDescribedBy&&this.oBrowse.addAriaDescribedBy(this.getId()+\"-AccDescr\")}},a.prototype.setButtonText=function(e){return this.setProperty(\"buttonText\",e,!1),this.getIconOnly()?this.oBrowse.setTooltip(e||this.getBrowseText()):this.oBrowse.setText(e||this.getBrowseText()),this},a.prototype.setIcon=function(e){return this.oBrowse.setIcon(e),this.setProperty(\"icon\",e,!1),this},a.prototype.setIconHovered=function(e){return this.setProperty(\"iconHovered\",e,!1),this.oBrowse.setIconHovered&&this.oBrowse.setIconHovered(e),this},a.prototype.setIconSelected=function(e){return this.setProperty(\"iconSelected\",e,!1),this.oBrowse.setIconSelected?this.oBrowse.setIconSelected(e):this.oBrowse.setActiveIcon(e),this},a.prototype.setIconFirst=function(e){return this.oBrowse.setIconFirst(e),this.setProperty(\"iconFirst\",e,!1),this},a.prototype.setIconOnly=function(e){return this.setProperty(\"iconOnly\",e,!1),e?(this.oBrowse.setText(\"\"),this.oBrowse.setTooltip(this.getButtonText()||this.getBrowseText())):(this.oBrowse.setText(this.getButtonText()||this.getBrowseText()),this.oBrowse.setTooltip(\"\")),this},a.prototype.getIdForLabel=function(){return this.oBrowse.getId()},a.prototype.setFileType=function(e){var t=this._convertTypesToArray(e);return this.setProperty(\"fileType\",t,!1),this},a.prototype.setMimeType=function(e){var t=this._convertTypesToArray(e);return this.setProperty(\"mimeType\",t,!1),this},a.prototype.setTooltip=function(t){return this._refreshTooltipBaseDelegate(t),this.setAggregation(\"tooltip\",t,!0),this.oFileUpload&&\"string\"==typeof t&&(e(this.oFileUpload).attr(\"title\",e.sap.encodeHTML(t)),this.$().find(\".sapUiFupInputMask\").attr(\"title\",e.sap.encodeHTML(t))),this},a.prototype._convertTypesToArray=function(e){return\"string\"==typeof e?\"\"===e?[]:e.split(\",\"):e},a.prototype.exit=function(){this.oFilePath.destroy(),this.oBrowse.destroy(),this.oIFrameRef&&(e(this.oIFrameRef).unbind(),sap.ui.getCore().getStaticAreaRef().removeChild(this.oIFrameRef),this.oIFrameRef=null)},a.prototype.onBeforeRendering=function(){var t=sap.ui.getCore().getStaticAreaRef();e(this.oFileUpload).appendTo(t),e(this.oFileUpload).unbind()},a.prototype.onAfterRendering=function(){this.prepareFileUploadAndIFrame(),this._cacheDOMEls(),this._addLabelFeaturesToBrowse(),e(this.oFileUpload).change(e.proxy(this.handlechange,this)),this.bMobileLib?this.oFilePath.$().find(\"input\").attr(\"tabindex\",\"-1\"):this.oFilePath.$().attr(\"tabindex\",\"-1\"),sap.ui.Device.browser.internet_explorer&&9==sap.ui.Device.browser.version&&this.oBrowse.$().attr(\"tabindex\",\"-1\"),s.isRequired(this)&&this.oBrowse.$().attr(\"aria-required\",\"true\"),e.sap.delayedCall(0,this,this._recalculateWidth),this.oFilePath.$().find(\"input\").removeAttr(\"role\").attr(\"aria-live\",\"polite\"),this.getValueState()==sap.ui.core.ValueState.Error&&this.oBrowse.$().attr(\"aria-invalid\",\"true\")},a.prototype._cacheDOMEls=function(){this.FUEl=this.getDomRef(\"fu\"),this.FUDataEl=this.getDomRef(\"fu_data\")},a.prototype.onfocusin=function(e){this.oFilePath.shouldValueStateMessageBeOpened&&!this.oFilePath.shouldValueStateMessageBeOpened()||this.openValueStateMessage()},a.prototype.onsapfocusleave=function(t){t.relatedControlId&&e.sap.containsOrEquals(this.getDomRef(),sap.ui.getCore().byId(t.relatedControlId).getFocusDomRef())||this.closeValueStateMessage()},a.prototype._recalculateWidth=function(){this.getWidth()&&(this.getButtonOnly()&&this.oBrowse.getDomRef()&&(this.oBrowse.getDomRef().style.width=this.getWidth()),this._resizeDomElements())},a.prototype.getFocusDomRef=function(){return this.$(\"fu\").get(0)},a.prototype._resizeDomElements=function(){var t=this.getId();this._oBrowseDomRef=this.oBrowse.getDomRef();var i=e(this._oBrowseDomRef),s=i.parent().outerWidth(!0);this._oFilePathDomRef=this.oFilePath.getDomRef();var o=this._oFilePathDomRef,a=this.getWidth();if(\"%\"==a.substr(-1)&&o){for(;o.id!=t;)o.style.width=\"100%\",o=o.parentNode;o.style.width=a}else if(o){o.style.width=a;var r=e(this._oFilePathDomRef),l=r.outerWidth()-s;l<0?(this.oFilePath.getDomRef().style.width=\"0px\",sap.ui.Device.browser.internet_explorer||(this.oFileUpload.style.width=i.outerWidth(!0))):this.oFilePath.getDomRef().style.width=l+\"px\"}},a.prototype.onresize=function(){this._recalculateWidth()},a.prototype.onThemeChanged=function(){this._recalculateWidth()},a.prototype.setEnabled=function(t){var i=e(this.oFileUpload);return this.setProperty(\"enabled\",t,!0),this.oFilePath.setEnabled(t),this.oBrowse.setEnabled(t),t?i.removeAttr(\"disabled\"):i.attr(\"disabled\",\"disabled\"),this.$().toggleClass(\"sapUiFupDisabled\",!t),this},a.prototype.setValueState=function(t){if(this.setProperty(\"valueState\",t,!0),this.oFilePath.setValueState&&this.oFilePath.setValueState(t),this.oBrowse.getDomRef()&&(t==sap.ui.core.ValueState.Error?this.oBrowse.$().attr(\"aria-invalid\",\"true\"):this.oBrowse.$().removeAttr(\"aria-invalid\")),e.sap.containsOrEquals(this.getDomRef(),document.activeElement))switch(t){case sap.ui.core.ValueState.Error:case sap.ui.core.ValueState.Warning:case sap.ui.core.ValueState.Success:this.openValueStateMessage();break;default:this.closeValueStateMessage()}return this},a.prototype.setUploadUrl=function(e,t){this.setProperty(\"uploadUrl\",e,!0);var i=this.$(\"fu_form\");return i.attr(\"action\",this.getUploadUrl()),this},a.prototype.setPlaceholder=function(e){return this.setProperty(\"placeholder\",e,!0),this.oFilePath.setPlaceholder(e),this},a.prototype.setStyle=function(e){return this.setProperty(\"style\",e,!0),e&&(\"Transparent\"==e?this.oBrowse.setLite?this.oBrowse.setLite(!0):this.oBrowse.setType(\"Transparent\"):this.oBrowse.setType?this.oBrowse.setType(e):(\"Emphasized\"==e&&(e=\"Emph\"),this.oBrowse.setStyle(e))),this},a.prototype.setValue=function(t,i,s){var o,a=this.getValue();if(a!=t||this.getSameFilenameAllowed()){var r=this.getUploadOnChange()&&t;this.setProperty(\"value\",t,r),this.oFilePath&&(this.oFilePath.setValue(t),this.oBrowse.getDomRef()&&!s&&e.sap.containsOrEquals(this.getDomRef(),document.activeElement)&&this.oBrowse.focus());var l=this.getDomRef(\"fu_form\"),n=this.getDomRef(\"fu_input-inner\");this.oFileUpload&&l&&!t&&(l.reset(),this.getDomRef(\"fu_input\").value=\"\",n&&(n.value=\"\"),e(this.FUDataEl).val(this.getAdditionalData())),i&&(window.File&&(o=this.FUEl.files),this.getSameFilenameAllowed()&&!t||this.fireChange({id:this.getId(),newValue:t,files:o})),r&&this.upload()}return this},a.prototype.clear=function(){var e=this.getDomRef(\"fu_form\");return e&&e.reset(),this.setValue(\"\",!1,!0)},a.prototype.ontap=function(){this.getEnabled()&&this.getVisible()&&this.FUEl.click()},a.prototype.onmousedown=function(e){this.bMobileLib||this.oBrowse.onmousedown(e)},a.prototype.onmouseup=function(e){this.bMobileLib||this.oBrowse.onmouseup(e)},a.prototype.onmouseover=function(t){this.bMobileLib||(e(this.oBrowse.getDomRef()).addClass(\"sapUiBtnStdHover\"),this.oBrowse.onmouseover(t))},a.prototype.onmouseout=function(t){this.bMobileLib||(e(this.oBrowse.getDomRef()).removeClass(\"sapUiBtnStdHover\"),this.oBrowse.onmouseout(t))},a.prototype.setAdditionalData=function(e){this.setProperty(\"additionalData\",e,!0);var t=this.FUDataEl;return t&&(e=this.getAdditionalData()||\"\",t.value=e),this},a.prototype.sendFiles=function(e,t){for(var i=this,s=!0,o=0;o<e.length;o++)if(!e[o].bPosted){s=!1;break}if(s)return void(this.getSameFilenameAllowed()&&this.getUploadOnChange()&&i.setValue(\"\",!0));var a=e[t],r=a.file.name?a.file.name:\"MultipartFile\";if((sap.ui.Device.browser.edge||sap.ui.Device.browser.internet_explorer)&&a.file.type&&1==a.xhr.readyState){var l=a.file.type;a.xhr.setRequestHeader(\"Content-Type\",l),a.requestHeaders.push({name:\"Content-Type\",value:l})}var n=a.requestHeaders,p=function(e){var t={lengthComputable:!!e.lengthComputable,loaded:e.loaded,total:e.total};i.fireUploadProgress({lengthComputable:t.lengthComputable,loaded:t.loaded,total:t.total,fileName:r,requestHeaders:n})};a.xhr.upload.addEventListener(\"progress\",p),a.xhr.onreadystatechange=function(){var e,t,s,o,l,p,h={};p=a.xhr.readyState;var u=a.xhr.status;if(4==a.xhr.readyState){if(a.xhr.responseXML&&(e=a.xhr.responseXML.documentElement.textContent),t=a.xhr.response,s=a.xhr.getAllResponseHeaders()){o=s.split(\"\\r\\n\");for(var d=0;d<o.length;d++)o[d]&&(l=o[d].indexOf(\": \"),h[o[d].substring(0,l)]=o[d].substring(l+2))}i.fireUploadComplete({fileName:r,headers:h,response:e,responseRaw:t,readyStateXHR:p,status:u,requestHeaders:n})}i._bUploading=!1},0===a.xhr.readyState||a.bPosted?(t++,i.sendFiles(e,t)):(a.xhr.send(a.file),a.bPosted=!0,t++,i.sendFiles(e,t))},a.prototype.upload=function(){if(this.getEnabled()){var t=this.getDomRef(\"fu_form\");try{if(this._bUploading=!0,this.getSendXHR()&&window.File){var i=this.FUEl.files;this._sendFilesWithXHR(i)}else t&&(t.submit(),this._resetValueAfterUploadStart())}catch(t){e.sap.log.error(\"File upload failed:\\n\"+t.message)}}},a.prototype.abort=function(t,i){if(this.getUseMultipart())this._uploadXHR&&this._uploadXHR.abort&&(this._uploadXHR.abort(),this.fireUploadAborted({fileName:null,requestHeaders:null}),e.sap.log.info(\"File upload aborted.\"));else for(var s=this._aXhr.length-1,o=s;o>-1;o--)if(t&&i)for(var a=0;a<this._aXhr[o].requestHeaders.length;a++){var r=this._aXhr[o].requestHeaders[a].name,l=this._aXhr[o].requestHeaders[a].value;if(r==t&&l==i){this._aXhr[o].xhr.abort(),this.fireUploadAborted({fileName:this._aXhr[o].fileName,requestHeaders:this._aXhr[o].requestHeaders}),this._aXhr.splice(o,1),e.sap.log.info(\"File upload aborted.\");break}}else this._aXhr[o].xhr.abort(),this.fireUploadAborted({fileName:this._aXhr[o].fileName,requestHeaders:this._aXhr[o].requestHeaders}),this._aXhr.splice(o,1),e.sap.log.info(\"File upload aborted.\")},a.prototype.onkeypress=function(e){this.onkeydown(e)},a.prototype.onclick=function(t){this.getSameFilenameAllowed()&&this.getEnabled()&&this.setValue(\"\",!0),this.oBrowse.getDomRef()&&e.sap.containsOrEquals(this.getDomRef(),document.activeElement)&&this.oBrowse.focus()},a.prototype.onkeydown=function(t){if(this.getEnabled()){this.getSameFilenameAllowed()&&this.getUploadOnChange()&&this.setValue(\"\",!0);var i=t.keyCode,s=e.sap.KeyCodes;i==s.DELETE||i==s.BACKSPACE?this.oFileUpload&&this.setValue(\"\",!0):i==s.SPACE||i==s.ENTER?sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9||!this.oFileUpload||(this.oFileUpload.click(),t.preventDefault(),t.stopPropagation()):i!=s.TAB&&i!=s.SHIFT&&i!=s.F6&&i!=s.PAGE_UP&&i!=s.PAGE_DOWN&&i!=s.END&&i!=s.HOME&&i!=s.ARROW_LEFT&&i!=s.ARROW_UP&&i!=s.ARROW_RIGHT&&i!=s.ARROW_DOWN&&(t.preventDefault(),t.stopPropagation())}},a.prototype._isFilenameTooLong=function(t){var i=this.getMaximumFilenameLength();return 0!==i&&t.length>i&&(e.sap.log.info(\"The filename of \"+t+\" (\"+t.length+\" characters)  is longer than the maximum of \"+i+\" characters.\"),!0)},a.prototype.handlechange=function(t){if(this.oFileUpload&&this.getEnabled()){var i,s,o,a,r=this.getFileType(),l=\"\",n=this.getDomRef(\"fu_form\");if(window.File){var p=t.target.files;if(!this._areFilesAllowed(p))return n.reset(),void this.setValue(\"\",!0,!0);this.fireFileAllowed(),l=this._generateInputValue(p)}else if(r&&r.length>0){i=!0,s=this.oFileUpload.value||\"\",o=s.lastIndexOf(\".\"),a=s.substring(o+1);for(var h=0;h<r.length;h++)a==r[h]&&(i=!1);if(i)return e.sap.log.info(\"File: \"+s+\" is of type \"+a+\". Allowed types are: \"+r+\".\"),this.fireTypeMissmatch({fileName:s,fileType:a}),n.reset(),void this.setValue(\"\",!0,!0);if(this._isFilenameTooLong(s))return this.fireFilenameLengthExceed({fileName:s}),n.reset(),void this.setValue(\"\",!0,!0);s&&this.fireFileAllowed()}var u=this.oFileUpload.value||\"\",d=u.lastIndexOf(\"\\\\\");d>=0&&(u=u.substring(d+1)),this.getMultiple()&&(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9||(u=l)),(u||sap.ui.Device.browser.chrome)&&this.setValue(u,!0)}},a.prototype._sendFilesWithXHR=function(e){var t,i,s,o;if(e.length>0){t=this.getUseMultipart()?1:e.length,this._aXhr=this._aXhr||[];for(var a=0;a<t;a++){if(this._uploadXHR=new window.XMLHttpRequest,o={xhr:this._uploadXHR,requestHeaders:[]},this._aXhr.push(o),o.xhr.open(\"POST\",this.getUploadUrl(),!0),this.getHeaderParameters())for(var r=this.getHeaderParameters(),l=0;l<r.length;l++)i=r[l].getName(),s=r[l].getValue(),o.requestHeaders.push({name:i,value:s});var n=e[a].name,p=o.requestHeaders;o.fileName=n,o.file=e[a],this.fireUploadStart({fileName:n,requestHeaders:p});for(var h=0;h<p.length&&0!==o.xhr.readyState;h++)i=p[h].name,s=p[h].value,o.xhr.setRequestHeader(i,s)}if(this.getUseMultipart()){for(var u=new window.FormData,d=this.FUEl.name,f=0;f<e.length;f++)u.append(d,e[f]);u.append(\"_charset_\",\"UTF-8\");var g=this.FUDataEl.name;if(this.getAdditionalData()){var c=this.getAdditionalData();u.append(g,c)}else u.append(g,\"\");if(this.getParameters())for(var y=this.getParameters(),m=0;m<y.length;m++){var F=y[m].getName();s=y[m].getValue(),u.append(F,s)}o.file=u,this.sendFiles(this._aXhr,0)}else this.sendFiles(this._aXhr,0);this._bUploading=!1,this._resetValueAfterUploadStart()}return this},a.prototype._areFilesAllowed=function(t){for(var i,s,o,a,r,l=this.getMaximumFileSize(),n=this.getMimeType(),p=this.getFileType(),h=0;h<t.length;h++){i=t[h].name,r=t[h].type,r||(r=\"unknown\");var u=t[h].size/1024/1024;if(l&&u>l)return e.sap.log.info(\"File: \"+i+\" is of size \"+u+\" MB which exceeds the file size limit of \"+l+\" MB.\"),this.fireFileSizeExceed({fileName:i,fileSize:u}),!1;if(this._isFilenameTooLong(i))return this.fireFilenameLengthExceed({fileName:i}),!1;if(n&&n.length>0){for(var d=!0,f=0;f<n.length;f++)(r==n[f]||\"*/*\"==n[f]||r.match(n[f]))&&(d=!1);if(d)return e.sap.log.info(\"File: \"+i+\" is of type \"+r+\". Allowed types are: \"+n+\".\"),this.fireTypeMissmatch({fileName:i,mimeType:r}),!1}if(p&&p.length>0){s=!0,o=i.lastIndexOf(\".\"),a=i.substring(o+1);for(var g=0;g<p.length;g++)a.toLowerCase()==p[g].toLowerCase()&&(s=!1);if(s)return e.sap.log.info(\"File: \"+i+\" is of type \"+a+\". Allowed types are: \"+p+\".\"),this.fireTypeMissmatch({fileName:i,fileType:a}),!1}}return!0},a.prototype._sendFilesFromDragAndDrop=function(e){return this._areFilesAllowed(e)&&this._sendFilesWithXHR(e),this},a.prototype._generateInputValue=function(e){for(var t=\"\",i=0;i<e.length;i++)t=t+'\"'+e[i].name+'\" ';return t},a.prototype.getBrowseText=function(){if(!a.prototype._sBrowseText){var e=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\");a.prototype._sBrowseText=e.getText(\"FILEUPLOAD_BROWSE\")}return a.prototype._sBrowseText?a.prototype._sBrowseText:\"Browse...\"},a.prototype.getShortenValue=function(){return this.getValue()},a.prototype.prepareFileUploadAndIFrame=function(){if(this.oFileUpload)e(this.oFileUpload).prependTo(this.$().find(\".sapUiFupInputMask\"));else{var t=[];if(t.push(\"<input \"),t.push('type=\"file\" '),t.push('aria-hidden=\"true\" '),this.getName()?this.getMultiple()?sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9||t.push('name=\"'+this.getName()+'[]\" '):t.push('name=\"'+this.getName()+'\" '):this.getMultiple()?sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9||t.push('name=\"'+this.getId()+'[]\" '):t.push('name=\"'+this.getId()+'\" '),t.push('id=\"'+this.getId()+'-fu\" '),sap.ui.Device.browser.internet_explorer&&9==sap.ui.Device.browser.version||t.push('tabindex=\"-1\" '),t.push('size=\"1\" '),this.getTooltip_AsString()?t.push('title=\"'+e.sap.encodeHTML(this.getTooltip_AsString())+'\" '):\"\"!==this.getValue()&&t.push('title=\"'+e.sap.encodeHTML(this.getValue())+'\" '),this.getEnabled()||t.push('disabled=\"disabled\" '),this.getMultiple()&&(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9||t.push(\"multiple \")),this.getMimeType()&&window.File){var i=this.getMimeType(),s=i.join(\",\");t.push('accept=\"'+s+'\" ')}t.push(\">\"),this.oFileUpload=e(t.join(\"\")).prependTo(this.$().find(\".sapUiFupInputMask\")).get(0)}if(!this.oIFrameRef){var o=document.createElement(\"iframe\");o.style.display=\"none\",o.id=this.sId+\"-frame\",sap.ui.getCore().getStaticAreaRef().appendChild(o),o.contentWindow.name=this.sId+\"-frame\";var a=this;this._bUploading=!1,e(o).load(function(t){if(a._bUploading){e.sap.log.info(\"File uploaded to \"+a.getUploadUrl());var i;try{i=a.oIFrameRef.contentDocument.body.innerHTML}catch(e){}a.fireUploadComplete({response:i}),a._bUploading=!1}}),this.oIFrameRef=o}},a.prototype.openValueStateMessage=function(){this.oFilePath.openValueStateMessage&&(this.oFilePath.openValueStateMessage(),this.oBrowse.$().addAriaDescribedBy(this.oFilePath.getId()+\"-message\"))},a.prototype.closeValueStateMessage=function(){this.oFilePath.closeValueStateMessage&&(this.oFilePath.closeValueStateMessage(),this.oBrowse.$().removeAriaDescribedBy(this.oFilePath.getId()+\"-message\"))},a.prototype._resetValueAfterUploadStart=function(){e.sap.log.info(\"File uploading to \"+this.getUploadUrl()),this.getSameFilenameAllowed()&&this.getUploadOnChange()&&this.getUseMultipart()&&this.setValue(\"\",!0)},a.prototype._addLabelFeaturesToBrowse=function(){var e;this.oBrowse&&this.oBrowse.$().length&&(e=this.oBrowse.$(),e.attr(\"type', 'button\"),e.click(function(e){e.preventDefault(),e.stopPropagation(),this.ontap()}.bind(this)))},a},!0);",
		"sap/ui/unified/FileUploaderParameter.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(e,a,r){\"use strict\";var u=a.extend(\"sap.ui.unified.FileUploaderParameter\",{metadata:{library:\"sap.ui.unified\",properties:{name:{type:\"string\",group:\"Data\",defaultValue:null},value:{type:\"string\",group:\"Data\",defaultValue:null}}}});return u},!0);",
		"sap/ui/unified/FileUploaderRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t=function(){};return t.render=function(t,i){var r=sap.ui.getCore().getConfiguration().getAccessibility(),a=i.getEnabled();t.write(\"<div\"),t.writeControlData(i),t.addClass(\"sapUiFup\"),i.getButtonOnly()&&t.addClass(\"sapUiFupButtonOnly\");var d=sap.ui.unified.FileUploaderHelper.addFormClass();d&&t.addClass(d),a||t.addClass(\"sapUiFupDisabled\"),t.writeClasses(),t.write(' aria-haspopup=\"true\">'),t.write('<form style=\"display:inline-block\" encType=\"multipart/form-data\" method=\"post\"'),t.writeAttribute(\"id\",i.getId()+\"-fu_form\"),t.writeAttributeEscaped(\"action\",i.getUploadUrl()),t.writeAttribute(\"target\",i.getId()+\"-frame\"),t.write(\">\"),t.write(\"<div \"),i.bMobileLib||t.write('class=\"sapUiFupInp\"'),r&&(t.writeAttribute(\"role\",\"textbox\"),t.writeAttribute(\"aria-readonly\",\"true\")),t.write(\">\"),i.getButtonOnly()?t.write('<div class=\"sapUiFupGroup\" border=\"0\" cellPadding=\"0\" cellSpacing=\"0\"><div><div style=\"display:none\">'):t.write('<div class=\"sapUiFupGroup\" border=\"0\" cellPadding=\"0\" cellSpacing=\"0\"><div><div>'),t.renderControl(i.oFilePath),t.write(\"</div><div>\"),t.renderControl(i.oBrowse);var s,l=\"\";i.getTooltip()&&(l=i.getTooltip_AsString());var n=\"\";i.getPlaceholder()&&(n=i.getPlaceholder());var u=\"\";i.getValue()&&(u=i.getValue());var p=\"\";p=i.getButtonText()?i.getButtonText():i.getBrowseText(),s=u?l+\" \"+u+\" \"+p:l+\" \"+n+\" \"+p,t.write('<span id=\"'+i.getId()+'-AccDescr\" class=\"sapUiInvisibleText\" aria-hidden=\"true\">'),t.writeEscaped(s+\" \"+i._sAccText),t.write(\"</span>\"),t.write(\"</div></div></div>\");var o=i.getName()||i.getId();t.write('<div class=\"sapUiFupInputMask\"'),l.length&&t.writeAttributeEscaped(\"title\",l),t.write(\">\"),t.write('<input type=\"hidden\" name=\"_charset_\" aria-hidden=\"true\">'),t.write('<input type=\"hidden\" id=\"'+i.getId()+'-fu_data\" aria-hidden=\"true\"'),t.writeAttributeEscaped(\"name\",o+\"-data\"),t.writeAttributeEscaped(\"value\",i.getAdditionalData()||\"\"),t.write(\">\"),e.each(i.getParameters(),function(e,i){t.write('<input type=\"hidden\" aria-hidden=\"true\" '),t.writeAttributeEscaped(\"name\",i.getName()||\"\"),t.writeAttributeEscaped(\"value\",i.getValue()||\"\"),t.write(\">\")}),t.write(\"</div>\"),t.write(\"</div>\"),t.write(\"</form>\"),t.write(\"</div>\")},t},!0);",
		"sap/ui/unified/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/library\"],function(e){\"use strict\";return sap.ui.getCore().initLibrary({name:\"sap.ui.unified\",version:\"800001.6.0.20241202143000_f0htmcm80p\",dependencies:[\"sap.ui.core\"],types:[\"sap.ui.unified.CalendarDayType\",\"sap.ui.unified.GroupAppointmentsMode\",\"sap.ui.unified.ContentSwitcherAnimation\",\"sap.ui.unified.ColorPickerMode\"],interfaces:[],controls:[\"sap.ui.unified.calendar.DatesRow\",\"sap.ui.unified.calendar.Header\",\"sap.ui.unified.calendar.Month\",\"sap.ui.unified.calendar.MonthPicker\",\"sap.ui.unified.calendar.MonthsRow\",\"sap.ui.unified.calendar.TimesRow\",\"sap.ui.unified.calendar.YearPicker\",\"sap.ui.unified.Calendar\",\"sap.ui.unified.CalendarDateInterval\",\"sap.ui.unified.CalendarWeekInterval\",\"sap.ui.unified.CalendarMonthInterval\",\"sap.ui.unified.CalendarTimeInterval\",\"sap.ui.unified.CalendarLegend\",\"sap.ui.unified.CalendarRow\",\"sap.ui.unified.ContentSwitcher\",\"sap.ui.unified.ColorPicker\",\"sap.ui.unified.Currency\",\"sap.ui.unified.FileUploader\",\"sap.ui.unified.Menu\",\"sap.ui.unified.Shell\",\"sap.ui.unified.ShellLayout\",\"sap.ui.unified.ShellOverlay\",\"sap.ui.unified.SplitContainer\"],elements:[\"sap.ui.unified.CalendarAppointment\",\"sap.ui.unified.CalendarLegendItem\",\"sap.ui.unified.DateRange\",\"sap.ui.unified.DateTypeRange\",\"sap.ui.unified.FileUploaderParameter\",\"sap.ui.unified.MenuItem\",\"sap.ui.unified.MenuItemBase\",\"sap.ui.unified.MenuTextFieldItem\",\"sap.ui.unified.ShellHeadItem\",\"sap.ui.unified.ShellHeadUserItem\"]}),sap.ui.unified.CalendarDayType={None:\"None\",NonWorking:\"NonWorking\",Type01:\"Type01\",Type02:\"Type02\",Type03:\"Type03\",Type04:\"Type04\",Type05:\"Type05\",Type06:\"Type06\",Type07:\"Type07\",Type08:\"Type08\",Type09:\"Type09\",Type10:\"Type10\"},sap.ui.unified.CalendarIntervalType={Hour:\"Hour\",Day:\"Day\",Month:\"Month\",Week:\"Week\",OneMonth:\"One Month\"},sap.ui.unified.GroupAppointmentsMode={Collapsed:\"Collapsed\",Expanded:\"Expanded\"},sap.ui.unified.CalendarAppointmentVisualization={Standard:\"Standard\",Filled:\"Filled\"},sap.ui.unified.ContentSwitcherAnimation={None:\"None\",Fade:\"Fade\",ZoomIn:\"ZoomIn\",ZoomOut:\"ZoomOut\",Rotate:\"Rotate\",SlideRight:\"SlideRight\",SlideOver:\"SlideOver\"},sap.ui.unified.ColorPickerMode={HSV:\"HSV\",HSL:\"HSL\"},sap.ui.base.Object.extend(\"sap.ui.unified._ContentRenderer\",{constructor:function(e,i,n,a){sap.ui.base.Object.apply(this),this._id=i,this._cntnt=n,this._ctrl=e,this._rm=sap.ui.getCore().createRenderManager(),this._cb=a||function(){}},destroy:function(){this._rm.destroy(),delete this._rm,delete this._id,delete this._cntnt,delete this._cb,delete this._ctrl,this._rerenderTimer&&(e.sap.clearDelayedCall(this._rerenderTimer),delete this._rerenderTimer),sap.ui.base.Object.prototype.destroy.apply(this,arguments)},render:function(){this._rm&&(this._rerenderTimer&&e.sap.clearDelayedCall(this._rerenderTimer),this._rerenderTimer=e.sap.delayedCall(0,this,function(){var i=e.sap.byId(this._id),n=i.length>0;if(n){if(\"string\"==typeof this._cntnt)for(var a=this._ctrl.getAggregation(this._cntnt,[]),t=0;t<a.length;t++)this._rm.renderControl(a[t]);else this._cntnt(this._rm);this._rm.flush(i[0])}this._cb(n)}))}}),sap.ui.unified._iNumberOfOpenedShellOverlays=0,sap.ui.unified.ColorPickerHelper||(sap.ui.unified.ColorPickerHelper={isResponsive:function(){return!1},factory:{createLabel:function(){throw new Error(\"no Label control available\")},createInput:function(){throw new Error(\"no Input control available\")},createSlider:function(){throw new Error(\"no Slider control available\")},createRadioButtonGroup:function(){throw new Error(\"no RadioButtonGroup control available\")},createRadioButtonItem:function(){throw new Error(\"no RadioButtonItem control available\")}},bFinal:!1}),sap.ui.unified.FileUploaderHelper||(sap.ui.unified.FileUploaderHelper={createTextField:function(e){throw new Error(\"no TextField control available!\")},setTextFieldContent:function(e,i){throw new Error(\"no TextField control available!\")},createButton:function(){throw new Error(\"no Button control available!\")},addFormClass:function(){return null},bFinal:!1}),sap.ui.unified.calendar=sap.ui.unified.calendar||{},sap.ui.unified});",
		"sap/ui/unified/Menu.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/Device\",\"sap/ui/core/Popup\",\"./MenuItemBase\",\"./library\",\"jquery.sap.script\"],function(e,t,o,i,s,n){\"use strict\";var r=t.extend(\"sap.ui.unified.Menu\",{metadata:{interfaces:[\"sap.ui.core.IContextMenu\"],library:\"sap.ui.unified\",properties:{enabled:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},ariaDescription:{type:\"string\",group:\"Accessibility\",defaultValue:null},maxVisibleItems:{type:\"int\",group:\"Behavior\",defaultValue:0},pageSize:{type:\"int\",group:\"Behavior\",defaultValue:5}},defaultAggregation:\"items\",aggregations:{items:{type:\"sap.ui.unified.MenuItemBase\",multiple:!0,singularName:\"item\"}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"}},events:{itemSelect:{parameters:{item:{type:\"sap.ui.unified.MenuItemBase\"}}},tabPressed:{}}}});return function(n){function a(t){return!!t&&(t=t.$?t.$():e(t),t.closest(\".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy\").hasClass(\"sapUiSizeCozy\"))}function p(e,t){var o=e.getParent();o&&o instanceof s&&o.onSubmenuToggle(t)}function u(e){var t=e.getMaxVisibleItems(),o=document.documentElement.clientHeight-10,i=e.$();if(t>0)for(var s=e.getItems(),n=0;n<s.length;n++)if(s[n].getDomRef()){o=Math.min(o,s[n].$().outerHeight(!0)*t);break}i.outerHeight(!0)>o?i.css(\"max-height\",o+\"px\").toggleClass(\"sapUiMnuScroll\",!0):i.css(\"max-height\",\"\").toggleClass(\"sapUiMnuScroll\",!1)}/*!\n\t * The following code is taken from\n\t * jQuery UI 1.10.3 - 2013-11-18\n\t * jquery.ui.position.js\n\t *\n\t * http://jqueryui.com\n\t * Copyright 2013 jQuery Foundation and other contributors; Licensed MIT\n\t */\nfunction l(t){var o=e(n);return t.within={element:o,isWindow:!0,offset:o.offset()||{left:0,top:0},scrollLeft:o.scrollLeft(),scrollTop:o.scrollTop(),width:o.width(),height:o.height()},t.collisionPosition={marginLeft:0,marginTop:0},t}r.prototype.bCozySupported=!0,r._DELAY_SUBMENU_TIMER=300,r._DELAY_SUBMENU_TIMER_EXT=400,r.prototype.init=function(){var t=this;this.bOpen=!1,this.oOpenedSubMenu=null,this.oHoveredItem=null,this.oPopup=null,this.fAnyEventHandlerProxy=e.proxy(function(e){var t=this.getRootMenu();t==this&&this.bOpen&&this.getDomRef()&&(\"mousedown\"==e.type||\"touchstart\"==e.type)&&t.handleOuterEvent(this.getId(),e)},this),this.fOrientationChangeHandler=function(){t.close()},this.bUseTopStyle=!1},r.prototype.exit=function(){this.oPopup&&(this.oPopup.detachClosed(this._menuClosed,this),this.oPopup.destroy(),delete this.oPopup),e.sap.unbindAnyEvent(this.fAnyEventHandlerProxy),this._bOrientationChangeBound&&(e(n).unbind(\"orientationchange\",this.fOrientationChangeHandler),this._bOrientationChangeBound=!1),this._resetDelayedRerenderItems()},r.prototype.invalidate=function(e){e instanceof s&&this.getDomRef()?this._delayedRerenderItems():t.prototype.invalidate.apply(this,arguments)},r.prototype.onBeforeRendering=function(){this._resetDelayedRerenderItems()},r.prototype.onAfterRendering=function(){\"sap-ui-static\"!=this.$().parent().attr(\"id\")&&(e.sap.log.error(\"sap.ui.unified.Menu: The Menu is popup based and must not be rendered directly as content of the page.\"),this.close(),this.$().remove());for(var t=this.getItems(),o=0;o<t.length;o++)t[o].onAfterRendering&&t[o].getDomRef()&&t[o].onAfterRendering();this.oHoveredItem&&this.oHoveredItem.hover(!0,this);var i=this,s=this.getDomRef();s&&e(\".sapUiMnuItmTxt\",s).bind(\"mouseenter\",function(){var t,o=this.length>1?this.eq(0):this;if(i.getAggregation(\"items\").forEach(function(e){if(e.sId===o.parentElement.id)return t=e,!1}),!t)return void e.sap.log.warning(\"sap.ui.unified.Menu: menuitem doesn't exist for this dom reference: \"+o.parentElement.id);if(t&&!t.getMetadata().getProperty(\"text\")){var s=e(\".sapUiMnuTfItemLbl\",o);o=s[0]}!t||t.getTooltip()&&0!==t.getTooltip().length||t.getSubmenu()&&0!=t.getSubmenu().getItems().length||((sap.ui.Device.browser.msie?o.offsetWidth+1:o.offsetWidth)<o.scrollWidth&&!e(o).attr(\"title\")?(t.getMetadata().getProperty(\"text\")?e(o).attr(\"title\",t.getText()):t.getMetadata().getProperty(\"label\")&&e(o).attr(\"title\",t.getLabel()),t._titleSetInternally=!0):e(o).attr(\"title\")&&t._titleSetInternally&&o.offsetWidth>=o.scrollWidth&&(e(o).removeAttr(\"title\"),t._titleSetInternally=!1))}),u(this)},r.prototype.onThemeChanged=function(){this.getDomRef()&&this.getPopup().getOpenState()===sap.ui.core.OpenState.OPEN&&(u(this),this.getPopup()._applyPosition(this.getPopup()._oLastPosition))},r.prototype.setPageSize=function(e){return this.setProperty(\"pageSize\",e,!0)},r.prototype.addItem=function(e){return this.addAggregation(\"items\",e,!!this.getDomRef()),this._delayedRerenderItems(),this},r.prototype.insertItem=function(e,t){return this.insertAggregation(\"items\",e,t,!!this.getDomRef()),this._delayedRerenderItems(),this},r.prototype.removeItem=function(e){return this.removeAggregation(\"items\",e,!!this.getDomRef()),this._delayedRerenderItems(),this},r.prototype.removeAllItems=function(){var e=this.removeAllAggregation(\"items\",!!this.getDomRef());return this._delayedRerenderItems(),e},r.prototype.destroyItems=function(){return this.destroyAggregation(\"items\",!!this.getDomRef()),this._delayedRerenderItems(),this},r.prototype.isItemChecked=function(e){return!1},r.prototype.isItemDeletable=function(e){return!1},r.prototype.isItemHeader=function(e){return!1},r.prototype.isItemOverflowFirst=function(e){return!1},r.prototype.isItemOverflowLast=function(e){return!1},r.prototype._delayedRerenderItems=function(){this.getDomRef()&&(this._resetDelayedRerenderItems(),this._discardOpenSubMenuDelayed(),this._itemRerenderTimer=e.sap.delayedCall(0,this,function(){var e=this.getDomRef();if(e){var t=sap.ui.getCore().createRenderManager();sap.ui.unified.MenuRenderer.renderItems(t,this),t.flush(e),t.destroy(),this.onAfterRendering(),this.getPopup()._applyPosition(this.getPopup()._oLastPosition)}}))},r.prototype._resetDelayedRerenderItems=function(){this._itemRerenderTimer&&(e.sap.clearDelayedCall(this._itemRerenderTimer),delete this._itemRerenderTimer)},r.prototype.open=function(t,i,s,r,a,u,l){if(!this.bOpen){p(this,!0),this.oOpenerRef=i,this.bIgnoreOpenerDOMRef=!1,this.getPopup().open(0,s,r,a,u||\"0 0\",l||\"_sapUiCommonsMenuFlip _sapUiCommonsMenuFlip\",!0),this.bOpen=!0,o.resize.attachHandler(this._handleResizeChange,this);var h=this.getDomRef();e(h).attr(\"tabIndex\",0).focus(),t&&this.setHoveredItem(this.getNextSelectableItem(-1)),e.sap.bindAnyEvent(this.fAnyEventHandlerProxy),sap.ui.Device.support.orientation&&this.getRootMenu()===this&&(e(n).bind(\"orientationchange\",this.fOrientationChangeHandler),this._bOrientationChangeBound=!0)}},r.prototype._handleResizeChange=function(){this.getPopup()._applyPosition(this.getPopup()._oLastPosition)},r.prototype.openAsContextMenu=function(t,o){var i=t.pageX-e(o.getDomRef()).offset().left,s=t.pageY-e(o.getDomRef()).offset().top,n=sap.ui.getCore().getConfiguration().getRTL(),r=sap.ui.core.Popup.Dock;n&&(i=o.getDomRef().clientWidth-i),this.open(!0,o,r.BeginTop,r.BeginTop,o,i+\" \"+s,\"flip\")},r.prototype.close=function(){this.bOpen&&!r._dbg&&(this._discardOpenSubMenuDelayed(),p(this,!1),delete this._bFixed,e.sap.unbindAnyEvent(this.fAnyEventHandlerProxy),this._bOrientationChangeBound&&(e(n).unbind(\"orientationchange\",this.fOrientationChangeHandler),this._bOrientationChangeBound=!1),this.bOpen=!1,this.closeSubmenu(),this.setHoveredItem(),e(this.getDomRef()).attr(\"tabIndex\",-1),this.getPopup().close(0),o.resize.detachHandler(this._handleResizeChange,this),this._resetDelayedRerenderItems(),this.$().remove(),this.bOutput=!1,this.isSubMenu()&&(this.getParent().getParent().oOpenedSubMenu=null))},r.prototype._menuClosed=function(){if(this.oOpenerRef){if(!this.bIgnoreOpenerDOMRef)try{this.oOpenerRef.focus()}catch(t){e.sap.log.warning(\"Menu.close cannot restore the focus on opener \"+this.oOpenerRef+\", \"+t)}this.oOpenerRef=void 0}},r.prototype.onclick=function(e){this.selectItem(this.getItemByDomRef(e.target),!1,!(!e.metaKey&&!e.ctrlKey)),e.preventDefault(),e.stopPropagation()},r.prototype.onsapnext=function(t){if(t.keyCode!=e.sap.KeyCodes.ARROW_DOWN)return void(this.oHoveredItem&&this.oHoveredItem.getSubmenu()&&this.checkEnabled(this.oHoveredItem)&&this.openSubmenu(this.oHoveredItem,!0));var o=this.oHoveredItem?this.indexOfAggregation(\"items\",this.oHoveredItem):-1;$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocus\"),$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocusEnabled\");var i=this.getNextSelectableItem(o);i.getEnabled()?this.setHoveredItem(i):(this.oHoveredItem&&this.oHoveredItem.getEnabled()&&this.oHoveredItem.$().addClass(\"sasUiMnuItmDisabledFocusEnabled\"),this.setHoveredItem(i),this._setActiveDescendant(i),i.$().addClass(\"sasUiMnuItmDisabledFocus\")),t.preventDefault(),t.stopPropagation()},r.prototype.onsapprevious=function(t){if(t.keyCode!=e.sap.KeyCodes.ARROW_UP)return this.isSubMenu()&&this.close(),t.preventDefault(),void t.stopPropagation();var o=this.oHoveredItem?this.indexOfAggregation(\"items\",this.oHoveredItem):-1,i=this.getPreviousSelectableItem(o);$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocus\"),$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocusEnabled\"),i.getEnabled()?this.setHoveredItem(i):(this.oHoveredItem&&this.oHoveredItem.getEnabled()&&this.oHoveredItem.$().addClass(\"sasUiMnuItmDisabledFocusEnabled\"),this.setHoveredItem(i),this._setActiveDescendant(i),i.$().addClass(\"sasUiMnuItmDisabledFocus\")),t.preventDefault(),t.stopPropagation()},r.prototype.onsaphome=function(e){var t=this.getNextSelectableItem(-1);$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocus\"),$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocusEnabled\"),t.getEnabled()?this.setHoveredItem(t):(this.oHoveredItem&&this.oHoveredItem.getEnabled()&&this.oHoveredItem.$().addClass(\"sasUiMnuItmDisabledFocusEnabled\"),this.setHoveredItem(t),t.$().addClass(\"sasUiMnuItmDisabledFocus\")),e.preventDefault(),e.stopPropagation()},r.prototype.onsapend=function(e){var t=this.getPreviousSelectableItem(this.getItems().length);$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocus\"),$(\".sapUiMnuItm\",this.$()).removeClass(\"sasUiMnuItmDisabledFocusEnabled\"),t.getEnabled()?this.setHoveredItem(t):(this.oHoveredItem&&this.oHoveredItem.getEnabled()&&this.oHoveredItem.$().addClass(\"sasUiMnuItmDisabledFocusEnabled\"),this.setHoveredItem(t),t.$().addClass(\"sasUiMnuItmDisabledFocus\")),e.preventDefault(),e.stopPropagation()},r.prototype.onsappagedown=function(e){if(this.getPageSize()<1)return void this.onsapend(e);var t=this.oHoveredItem?this.indexOfAggregation(\"items\",this.oHoveredItem):-1;return t+=this.getPageSize(),t>=this.getItems().length?void this.onsapend(e):(this.setHoveredItem(this.getNextSelectableItem(t-1)),e.preventDefault(),void e.stopPropagation())},r.prototype.onsappageup=function(e){if(this.getPageSize()<1)return void this.onsaphome(e);var t=this.oHoveredItem?this.indexOfAggregation(\"items\",this.oHoveredItem):-1;return t-=this.getPageSize(),t<0?void this.onsaphome(e):(this.setHoveredItem(this.getPreviousSelectableItem(t+1)),e.preventDefault(),void e.stopPropagation())},r.prototype.onsapselect=function(e){this._sapSelectOnKeyDown=!0,e.preventDefault(),e.stopPropagation()},r.prototype.onkeyup=function(t){this._sapSelectOnKeyDown&&(this._sapSelectOnKeyDown=!1,e.sap.PseudoEvents.sapselect.fnCheck(t)&&(this.selectItem(this.oHoveredItem,!0,!1),t.preventDefault(),t.stopPropagation()))},r.prototype.onsapbackspace=function(t){\"INPUT\"!=e(t.target).prop(\"tagName\")&&t.preventDefault()},r.prototype.onsapbackspacemodifiers=r.prototype.onsapbackspace,r.prototype.onsapescape=function(e){this.close(),e.preventDefault(),e.stopPropagation()},r.prototype.onsaptabnext=function(e){var t=this.getRootMenu();t.close(),this.fireTabPressed(e)},r.prototype.onsaptabprevious=function(e){var t=this.getRootMenu();t.close(),this.fireTabPressed(e)},r.prototype.onmouseover=function(t){if(sap.ui.Device.system.desktop){var i=this.getItemByDomRef(t.target);this.bOpen&&i&&i!=this.oHoveredItem&&(this.oOpenedSubMenu&&e.sap.containsOrEquals(this.oOpenedSubMenu.getDomRef(),t.target)||(this.oOpenedSubMenu&&!i.getSubmenu()&&this.closeSubmenu(!0),this.setHoveredItem(i),e.sap.checkMouseEnterOrLeave(t,this.getDomRef())&&(o.browser.msie||o.browser.edge||this.getDomRef().focus()),this._openSubMenuDelayed(i)))}},r.prototype._openSubMenuDelayed=function(t){t&&(this._discardOpenSubMenuDelayed(),this._delayedSubMenuTimer=e.sap.delayedCall(t.getSubmenu()&&this.checkEnabled(t)?r._DELAY_SUBMENU_TIMER:r._DELAY_SUBMENU_TIMER_EXT,this,function(){this.closeSubmenu(),t.getSubmenu()&&this.checkEnabled(t)&&(this.setHoveredItem(t),this.openSubmenu(t,!1,!0))}))},r.prototype._discardOpenSubMenuDelayed=function(t){this._delayedSubMenuTimer&&(e.sap.clearDelayedCall(this._delayedSubMenuTimer),this._delayedSubMenuTimer=null)},r.prototype.onmouseout=function(t){sap.ui.Device.system.desktop&&e.sap.checkMouseEnterOrLeave(t,this.getDomRef())&&(this.oOpenedSubMenu&&this.oOpenedSubMenu.getParent()===this.oHoveredItem||this.setHoveredItem(null),this._discardOpenSubMenuDelayed())},r.prototype.onsapfocusleave=function(e){!this.oOpenedSubMenu&&this.bOpen&&this.getRootMenu().handleOuterEvent(this.getId(),e)},r.prototype.handleOuterEvent=function(t,o){var i=!1,s=!1,n=null,r=this.getRootMenu(),a=this.getPopup().touchEnabled;if(this.bIgnoreOpenerDOMRef=!1,\"mousedown\"==o.type||\"touchstart\"==o.type){if(a&&(o.isMarked(\"delayedMouseEvent\")||o.isMarked(\"cancelAutoClose\")))return;for(var p=this;p&&!i;)e.sap.containsOrEquals(p.getDomRef(),o.target)&&(i=!0),p=p.oOpenedSubMenu}else if(\"sapfocusleave\"==o.type){if(a)return;if(o.relatedControlId)for(var p=this;p&&!i;)(p.oOpenedSubMenu&&p.oOpenedSubMenu.getId()==o.relatedControlId||e.sap.containsOrEquals(p.getDomRef(),e.sap.byId(o.relatedControlId).get(0)))&&(i=!0),p=p.oOpenedSubMenu;if(!i)for(this.bIgnoreOpenerDOMRef=!0;r&&!s;)r instanceof sap.m.Popover&&r.isOpen()&&r.oPopup&&r.oPopup.getAutoClose()?(n=r,s=!0):r=r.getParent()}i||this.close(),s&&n&&n.close()},r.prototype.getItemByDomRef=function(t){for(var o=this.getItems(),i=o.length,s=0;s<i;s++){var n=o[s],r=n.getDomRef();if(e.sap.containsOrEquals(r,t))return n}return null},r.prototype.selectItem=function(e,t,o){if(e&&e instanceof s&&this.checkEnabled(e)){var i=e.getSubmenu();this.isItemHeader(e)||(i?sap.ui.Device.system.desktop||this.oOpenedSubMenu!==i?this.openSubmenu(e,t):this.closeSubmenu():this.getRootMenu().close(),e.fireSelect({item:e,ctrlKey:o}),this.getRootMenu().fireItemSelect({item:e}))}},r.prototype.isSubMenu=function(){return this.getParent()&&this.getParent().getParent&&this.getParent().getParent()instanceof r},r.prototype.getRootMenu=function(){for(var e=this;e.isSubMenu();)e=e.getParent().getParent();return e},r.prototype.getMenuLevel=function(){for(var e=1,t=this;t.isSubMenu();)t=t.getParent().getParent(),e++;return e},r.prototype.getPopup=function(){return this.oPopup||(this.oPopup=new i(this,!1,!0,!1),this.oPopup.setDurations(0,0),this.oPopup.attachClosed(this._menuClosed,this)),this.oPopup},r.prototype.setHoveredItem=function(t){return this.oHoveredItem&&this.oHoveredItem.hover(!1,this),t?(this.oHoveredItem=t,t.hover(!0,this),this._setActiveDescendant(this.oHoveredItem),void this.scrollToItem(this.oHoveredItem)):(this.oHoveredItem=null,void e(this.getDomRef()).removeAttr(\"aria-activedescendant\"))},r.prototype._setActiveDescendant=function(e){if(sap.ui.getCore().getConfiguration().getAccessibility()&&e){var t=this;t.$().removeAttr(\"aria-activedescendant\"),setTimeout(function(){t.oHoveredItem===e&&t.$().attr(\"aria-activedescendant\",t.oHoveredItem.getId())},10)}},r.prototype.openSubmenu=function(e,t,o){var s=e.getSubmenu();if(s)if(this.oOpenedSubMenu&&this.oOpenedSubMenu!==s&&this.closeSubmenu(),this.oOpenedSubMenu)this.oOpenedSubMenu._bFixed=o&&this.oOpenedSubMenu._bFixed||!o&&!this.oOpenedSubMenu._bFixed,this.oOpenedSubMenu._bringToFront();else{this.oOpenedSubMenu=s;var n=i.Dock;s.open(t,this,n.BeginTop,n.EndTop,e,\"0 0\")}},r.prototype.closeSubmenu=function(e,t){if(this.oOpenedSubMenu){if(e&&this.oOpenedSubMenu._bFixed)return;t&&(this.oOpenedSubMenu.bIgnoreOpenerDOMRef=!0),this.oOpenedSubMenu.close(),this.oOpenedSubMenu=null}},r.prototype.scrollToItem=function(t){var o=this.getDomRef(),i=t?t.getDomRef():null;if(i&&o){var s=o.scrollTop,n=i.offsetTop,r=e(o).height(),a=e(i).height();s>n?o.scrollTop=n:n+a>s+r&&(o.scrollTop=Math.ceil(n+a-r))}},r.prototype._bringToFront=function(){e.sap.byId(this.getPopup().getId()).mousedown()},r.prototype.checkEnabled=function(e){return e&&e.getEnabled()&&this.getEnabled()},r.prototype.getNextSelectableItem=function(e){for(var t=null,o=this.getItems(),i=e+1;i<o.length;i++)if(o[i].getVisible()){t=o[i];break}if(!t)for(var i=0;i<=e;i++)if(o[i].getVisible()){t=o[i];break}return t},r.prototype.getPreviousSelectableItem=function(e){for(var t=null,o=this.getItems(),i=e-1;i>=0;i--)if(o[i].getVisible()){t=o[i];break}if(!t)for(var i=o.length-1;i>=0&&i>=e;i--)if(o[i].getVisible()){t=o[i];break}return t},r.prototype.setRootMenuTopStyle=function(e){this.getRootMenu().bUseTopStyle=e,r.rerenderMenu(this.getRootMenu())},r.rerenderMenu=function(e){for(var t=e.getItems(),o=0;o<t.length;o++){var i=t[o].getSubmenu();i&&r.rerenderMenu(i)}e.invalidate(),e.rerender()},r.prototype.focus=function(){this.bOpen&&(t.prototype.focus.apply(this,arguments),this._setActiveDescendant(this.oHoveredItem))},r.prototype.isCozy=function(){return!!this.bCozySupported&&(!!this.hasStyleClass(\"sapUiSizeCozy\")||(!!a(this.oOpenerRef)||!!a(this.getParent())))};var h={fit:{left:function(e,t){var o,i=t.within,s=i.isWindow?i.scrollLeft:i.offset.left,n=i.width,r=e.left-t.collisionPosition.marginLeft,a=s-r,p=r+t.collisionWidth-n-s;t.collisionWidth>n?a>0&&p<=0?(o=e.left+a+t.collisionWidth-n-s,e.left+=a-o):p>0&&a<=0?e.left=s:a>p?e.left=s+n-t.collisionWidth:e.left=s:a>0?e.left+=a:p>0?e.left-=p:e.left=Math.max(e.left-r,e.left)},top:function(e,t){var o,i=t.within,s=i.isWindow?i.scrollTop:i.offset.top,n=t.within.height,r=e.top-t.collisionPosition.marginTop,a=s-r,p=r+t.collisionHeight-n-s;t.collisionHeight>n?a>0&&p<=0?(o=e.top+a+t.collisionHeight-n-s,e.top+=a-o):p>0&&a<=0?e.top=s:a>p?e.top=s+n-t.collisionHeight:e.top=s:a>0?e.top+=a:p>0?e.top-=p:e.top=Math.max(e.top-r,e.top)}},flip:{left:function(e,t){var o,i,s=t.within,n=s.offset.left+s.scrollLeft,r=s.width,a=s.isWindow?s.scrollLeft:s.offset.left,p=e.left-t.collisionPosition.marginLeft,u=p-a,l=p+t.collisionWidth-r-a,h=\"left\"===t.my[0]?-t.elemWidth:\"right\"===t.my[0]?t.elemWidth:0,d=\"left\"===t.at[0]?t.targetWidth:\"right\"===t.at[0]?-t.targetWidth:0,f=-2*t.offset[0];u<0?(o=e.left+h+d+f+t.collisionWidth-r-n,(o<0||o<Math.abs(u))&&(e.left+=h+d+f)):l>0&&(i=e.left-t.collisionPosition.marginLeft+h+d+f-a,(i>0||Math.abs(i)<l)&&(e.left+=h+d+f))},top:function(e,t){var o,i,s=t.within,n=s.offset.top+s.scrollTop,r=s.height,a=s.isWindow?s.scrollTop:s.offset.top,p=e.top-t.collisionPosition.marginTop,u=p-a,l=p+t.collisionHeight-r-a,h=\"top\"===t.my[1],d=h?-t.elemHeight:\"bottom\"===t.my[1]?t.elemHeight:0,f=\"top\"===t.at[1]?t.targetHeight:\"bottom\"===t.at[1]?-t.targetHeight:0,g=-2*t.offset[1];u<0?(i=e.top+d+f+g+t.collisionHeight-r-n,e.top+d+f+g>u&&(i<0||i<Math.abs(u))&&(e.top+=d+f+g)):l>0&&(o=e.top-t.collisionPosition.marginTop+d+f+g-a,e.top+d+f+g>l&&(o>0||Math.abs(o)<l)&&(e.top+=d+f+g))}},flipfit:{left:function(){h.flip.left.apply(this,arguments),h.fit.left.apply(this,arguments)},top:function(){h.flip.top.apply(this,arguments),h.fit.top.apply(this,arguments)}}};e.ui.position._sapUiCommonsMenuFlip={left:function(t,o){return e.ui.position.flipfit?void e.ui.position.flipfit.left.apply(this,arguments):(o=l(o),void h.flipfit.left.apply(this,arguments))},top:function(t,o){return e.ui.position.flipfit?void e.ui.position.flipfit.top.apply(this,arguments):(o=l(o),void h.flipfit.top.apply(this,arguments))}}}(window),r},!0);",
		"sap/ui/unified/MenuItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/IconPool\",\"./MenuItemBase\",\"./library\"],function(t,e,i,r){\"use strict\";var s=i.extend(\"sap.ui.unified.MenuItem\",{metadata:{library:\"sap.ui.unified\",properties:{text:{type:\"string\",group:\"Appearance\",defaultValue:\"\"},icon:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:\"\"}},_titleSetInternally:!1}});return e.getIconInfo(\"\",\"\"),s.prototype.render=function(t,e,i,r,s){var n=t,a=e.getSubmenu();n.write(\"<li \");var o=\"sapUiMnuItm\";1==r.iItemNo?o+=\" sapUiMnuItmFirst\":r.iItemNo==r.iTotalItems&&(o+=\" sapUiMnuItmLast\"),i.checkEnabled(e)||(o+=\" sapUiMnuItmDsbl\"),e.getStartsSection()&&(o+=\" sapUiMnuItmSepBefore\"),i.isItemHeader(e)&&(o+=s===!1?\" sasUiMnuItmSingleHeader\":\" sasUiMnuItmMultipleHeaders\"),i.isItemOverflowFirst(e)&&(o+=\" sasToggleButtonOverflowFirst\"),i.isItemOverflowLast(e)&&(o+=\" sasToggleButtonOverflowLast\"),n.writeAttribute(\"class\",o),e.getTooltip_AsString()&&n.writeAttributeEscaped(\"title\",e.getTooltip_AsString()),this.writeAdditionalItemAttributes&&\"function\"==typeof this.writeAdditionalItemAttributes&&this.writeAdditionalItemAttributes(t,e,i,r),n.writeElementData(e),r.bAccessible&&(n.writeAccessibilityState(e,{role:\"menuitem\",disabled:!i.checkEnabled(e),posinset:r.iItemNo,setsize:r.iTotalItems}),a&&(n.writeAttribute(\"aria-haspopup\",!0),n.writeAttribute(\"aria-owns\",a.getId()))),n.write('><div class=\"sapUiMnuItmL\"></div>'),this.renderCheckColumn(t,e,i,r),i.isItemHeader(e)===!1&&(n.write('<div class=\"sapUiMnuItmIco\">'),e.getIcon()&&n.writeIcon(e.getIcon(),null,{title:null}),n.write(\"</div>\")),n.write('<div id=\"'+this.getId()+'-txt\" class=\"sapUiMnuItmTxt\">'),n.writeEscaped(e.getText()),n.write(\"</div>\"),this.renderDeleteColumn(t,e,i,r),n.write('<div id=\"'+this.getId()+'-scuttxt\" class=\"sapUiMnuItmSCut\"></div>'),this.renderSubMenuColumn(t,e,i,r),n.write('<div class=\"sapUiMnuItmR\"></div>'),n.write(\"</li>\")},s.prototype.renderSubMenuColumn=function(t,e,i,r){var s=e.getSubmenu();t.write('<div class=\"sapUiMnuItmSbMnu\">'),s&&t.write('<div class=\"sapUiIconMirrorInRTL\"></div>'),t.write(\"</div>\")},s.prototype.renderCheckColumn=function(t,e,i,r){},s.prototype.renderDeleteColumn=function(t,e,i,r){},s.prototype.hover=function(t,e){this.$().toggleClass(\"sapUiMnuItmHov\",t)},s.prototype.exit=function(){var e=this.getDomRef();e&&t(\".sapUiMnuItmTxt\",e).unbind(\"mouseenter\")},s},!0);",
		"sap/ui/unified/MenuItemBase.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(e,t,i){\"use strict\";var n=t.extend(\"sap.ui.unified.MenuItemBase\",{metadata:{library:\"sap.ui.unified\",properties:{enabled:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},visible:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},startsSection:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},defaultAggregation:\"submenu\",aggregations:{submenu:{type:\"sap.ui.unified.Menu\",multiple:!1}},events:{select:{parameters:{item:{type:\"sap.ui.unified.MenuItemBase\"}}}}}});return n.prototype.init=function(){},n.prototype.render=function(e,t,i){var n=e;n.write(\"<li\"),n.writeElementData(t),n.write('><div style=\"white-space:nowrap;display:inline-block;padding:1px;color:black;\" id=\"'+this.getId()+'-txt\">'),n.write(t.getId()),this.getSubmenu()&&n.write(\"&nbsp;&nbsp;->\"),n.write(\"</div></li>\")},n.prototype.hover=function(e,t){this.$(\"txt\").attr(\"style\",e?\"white-space:nowrap;display:inline-block;padding:1px;color:red;\":\"white-space:nowrap;display:inline-block;padding:1px;color:black;\")},n.prototype.onSubmenuToggle=function(e){this.$().toggleClass(\"sapUiMnuItmSubMnuOpen\",e)},n.prototype.onAfterRendering=function(){},n.prototype.onmouseover=function(e){var t=this.getParent();t&&t instanceof sap.ui.unified.Menu&&this.getTooltip()instanceof sap.ui.core.TooltipBase&&t.onmouseover(e)},n},!0);",
		"sap/ui/unified/MenuRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,i){i.oHoveredItem&&i.indexOfItem(i.oHoveredItem)<0&&(i.oHoveredItem=null),e.write('<div tabindex=\"-1\" hideFocus=\"true\"'),i.getTooltip_AsString()&&e.writeAttributeEscaped(\"title\",i.getTooltip_AsString());var s=sap.ui.getCore().getConfiguration().getAccessibility();s&&(e.writeAccessibilityState(i,{role:\"menu\",disabled:null,labelledby:{value:i.getId()+\"-label\",append:!0}}),i.oHoveredItem&&e.writeAttribute(\"aria-activedescendant\",i.oHoveredItem.getId())),this.addCSSClasses(e,i);var r=i.getRootMenu();r.isCozy()&&e.addClass(\"sapUiSizeCozy\"),i.bCozySupported&&e.addClass(\"sapUiMnuCozySupport\"),e.writeClasses(),e.writeControlData(i),e.write(\">\"),t.renderItems(e,i),s&&(e.write(\"<span id='\",i.getId(),\"-label' class='sapUiInvisibleText' aria-hidden='true'>\"),e.writeEscaped(i.getAriaDescription()?i.getAriaDescription():\"\"),e.write(\"</span>\")),e.write(\"</div>\")},t.addCSSClasses=function(e,t){e.addClass(\"sapUiMnu\"),t.getRootMenu().bUseTopStyle&&e.addClass(\"sapUiMnuTop\")},t.renderItems=function(e,t){var i=t.getItems(),s=sap.ui.getCore().getConfiguration().getAccessibility();e.write('<ul class=\"sapUiMnuLst');for(var r=!1,a=!1,n=!1,o=!1,l=0,d=0;d<i.length;d++)i[d].getIcon&&i[d].getIcon()&&(r=!0),i[d].getSubmenu()&&(a=!0),t.isItemChecked(i[d])&&(n=!0),t.isItemDeletable(i[d])&&(o=!0),t.isItemHeader(i[d])&&l++;r||e.write(\" sapUiMnuNoIco\"),a||e.write(\" sapUiMnuNoSbMnu\"),n||e.write(\" sapUiMnuNoChk\"),o||e.write(\" sapUiMnuNoDlt\"),e.write('\">');for(var u=0,p=0;p<i.length;p++)i[p].getVisible()&&i[p].render&&u++;for(var c=0,p=0;p<i.length;p++){var g=i[p];g.getVisible()&&g.render&&(c++,g.getStartsSection()&&(e.write(\"<li \"),s&&e.write('role=\"separator\" '),e.write('class=\"sapUiMnuDiv\"><div class=\"sapUiMnuDivL\"></div><hr><div class=\"sapUiMnuDivR\"></div></li>')),g.render(e,g,t,{bAccessible:s,iItemNo:c,iTotalItems:u},l>1))}e.write(\"</ul>\")},t},!0);",
		"sap/ui/unified/MenuTextFieldItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/ValueStateSupport\",\"./MenuItemBase\",\"./library\"],function(t,e,i,s){\"use strict\";var a=i.extend(\"sap.ui.unified.MenuTextFieldItem\",{metadata:{library:\"sap.ui.unified\",properties:{label:{type:\"string\",group:\"Appearance\",defaultValue:null},icon:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:null},value:{type:\"string\",group:\"Misc\",defaultValue:null},valueState:{type:\"sap.ui.core.ValueState\",group:\"Appearance\",defaultValue:sap.ui.core.ValueState.None}}}});return function(){a.prototype.render=function(t,e,i,s){var a=t,o=i.checkEnabled(e),n=e.getId(),r=\"sapUiMnuItm sapUiMnuTfItm\";1==s.iItemNo?r+=\" sapUiMnuItmFirst\":s.iItemNo==s.iTotalItems&&(r+=\" sapUiMnuItmLast\"),i.checkEnabled(e)||(r+=\" sapUiMnuItmDsbl\"),e.getStartsSection()&&(r+=\" sapUiMnuItmSepBefore\"),a.write(\"<li \"),a.writeAttribute(\"class\",r),a.writeElementData(e),s.bAccessible&&(a.writeAttribute(\"role\",\"menuitem\"),a.writeAttribute(\"aria-disabled\",!o),a.writeAttribute(\"aria-posinset\",s.iItemNo),a.writeAttribute(\"aria-setsize\",s.iTotalItems)),a.write('><div class=\"sapUiMnuItmL\"></div>'),a.write('<div class=\"sapUiMnuItmIco\">'),e.getIcon()&&a.writeIcon(e.getIcon(),null,{title:null}),a.write(\"</div>\"),a.write('<div id=\"'+n+'-txt\" class=\"sapUiMnuItmTxt\">'),a.write('<label id=\"'+n+'-lbl\" class=\"sapUiMnuTfItemLbl\">'),a.writeEscaped(e.getLabel()||\"\"),a.write(\"</label>\"),a.write('<div id=\"'+n+'-str\" class=\"sapUiMnuTfItmStretch\"></div>'),a.write('<div class=\"sapUiMnuTfItemWrppr\">'),a.write('<input id=\"'+n+'-tf\" tabindex=\"-1\"'),a.writeAttributeEscaped(\"value\",e.getValue()||\"\"),a.writeAttribute(\"class\",o?\"sapUiMnuTfItemTf sapUiMnuTfItemTfEnbl\":\"sapUiMnuTfItemTf sapUiMnuTfItemTfDsbl\"),o||a.writeAttribute(\"disabled\",\"disabled\"),s.bAccessible&&a.writeAccessibilityState(e,{role:\"textbox\",disabled:!o,multiline:!1,autocomplete:\"none\",labelledby:{value:n+\"-lbl\",append:!0}}),a.write(\"></div></div>\"),a.write('<div class=\"sapUiMnuItmR\"></div>'),a.write(\"</li>\")},a.prototype.hover=function(t,e){this.$().toggleClass(\"sapUiMnuItmHov\",t),t&&e.checkEnabled(this)&&(e.closeSubmenu(!1,!0),this.$(\"tf\").focus())},a.prototype.onAfterRendering=function(){this._adaptSizes(),this.setValueState(this.getValueState())},a.prototype.onsapup=function(t){this.getParent().focus(),this.getParent().onsapprevious(t)},a.prototype.onsapdown=function(t){this.getParent().focus(),this.getParent().onsapnext(t)},a.prototype.onsaphome=function(t){this._checkCursorPosForNav(!1)&&(this.getParent().focus(),this.getParent().onsaphome(t))},a.prototype.onsapend=function(t){this._checkCursorPosForNav(!0)&&(this.getParent().focus(),this.getParent().onsapend(t))},a.prototype.onsappageup=function(t){this.getParent().focus(),this.getParent().onsappageup(t)},a.prototype.onsappagedown=function(t){this.getParent().focus(),this.getParent().onsappagedown(t)},a.prototype.onsapescape=function(t){this.getParent().onsapescape(t)},a.prototype.onkeydown=function(t){t.stopPropagation()},a.prototype.onclick=function(t){this.getParent().closeSubmenu(!1,!0),!sap.ui.Device.system.desktop&&this.getParent().checkEnabled(this)&&this.focus(),t.stopPropagation()},a.prototype.onkeyup=function(e){if(t.sap.PseudoEvents.sapenter.fnCheck(e)){var i=this.$(\"tf\").val();this.setValue(i),this.getParent().selectItem(this),e.preventDefault(),e.stopPropagation()}},a.prototype.setSubmenu=function(e){return t.sap.log.warning(\"The aggregation 'submenu' is not supported for this type of menu item.\",\"\",\"sap.ui.unified.MenuTextFieldItem\"),this},a.prototype.setLabel=function(t){return this.setProperty(\"label\",t,!0),this.$(\"lbl\").text(t),this._adaptSizes(),this},a.prototype.setValue=function(t){return this.setProperty(\"value\",t,!0),this.$(\"tf\").val(t),this},a.prototype.setValueState=function(t){this.setProperty(\"valueState\",t,!0);var i=this.$(\"tf\");i.toggleClass(\"sapUiMnuTfItemTfErr\",t==sap.ui.core.ValueState.Error),i.toggleClass(\"sapUiMnuTfItemTfWarn\",t==sap.ui.core.ValueState.Warning);var s=e.enrichTooltip(this,this.getTooltip_AsString());return this.$().attr(\"title\",s?s:\"\"),this},a.prototype.getFocusDomRef=function(){var t=this.$(\"tf\");return t.length?t.get(0):null},a.prototype._adaptSizes=function(){var t=this.$(\"tf\"),e=this.$(\"lbl\"),i=e.length?e.get(0).offsetLeft:0;sap.ui.getCore().getConfiguration().getRTL()?t.parent().css({width:\"auto\",right:this.$().outerWidth(!0)-i+(e.outerWidth(!0)-e.outerWidth())+\"px\"}):t.parent().css({width:\"auto\",left:i+e.outerWidth(!0)+\"px\"})},a.prototype._checkCursorPosForNav=function(t){var e=sap.ui.getCore().getConfiguration().getRTL(),i=t?e:!e,s=this.$(\"tf\"),a=s.cursorPos(),o=s.val().length;return e&&(a=o-a),!(!i&&a!=o||i&&0!=a)}}(),a},!0);",
		"sap/ui/unified/Shell.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./ShellHeader\",\"./ShellLayout\",\"./library\"],function(e,t,r,n){\"use strict\";var a=r.extend(\"sap.ui.unified.Shell\",{metadata:{library:\"sap.ui.unified\",properties:{icon:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:null},showCurtain:{type:\"boolean\",group:\"Appearance\",defaultValue:null,deprecated:!0},showCurtainPane:{type:\"boolean\",group:\"Appearance\",defaultValue:null,deprecated:!0},searchVisible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{curtainContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"curtainContent\"},curtainPaneContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"curtainPaneContent\"},headItems:{type:\"sap.ui.unified.ShellHeadItem\",multiple:!0,singularName:\"headItem\"},headEndItems:{type:\"sap.ui.unified.ShellHeadItem\",multiple:!0,singularName:\"headEndItem\"},search:{type:\"sap.ui.core.Control\",multiple:!1},user:{type:\"sap.ui.unified.ShellHeadUserItem\",multiple:!1}}}});return a.prototype.init=function(){r.prototype.init.apply(this,arguments),this._header=new t(this.getId()+\"-header\"),this.setHeader(this._header)},a.prototype.exit=function(){r.prototype.exit.apply(this,arguments),this._header.destroy(),delete this._header},a.prototype._getSearchWidth=function(){if(this._header===this.getHeader()&&this._header.getDomRef()){var e=this._header.$(\"hdr-center\").children();if(e.length)return e.width()}return-1},a.prototype.setIcon=function(e){return this.setProperty(\"icon\",e,!0),this._header.setLogo(e),this},a.prototype.getIcon=function(){return this._header.getLogo()},a.prototype.setSearchVisible=function(e){return this.setProperty(\"searchVisible\",e,!0),this._header.setSearchVisible(e),this},a.prototype.getSearchVisible=function(){return this._header.getSearchVisible()},a.prototype.setSearch=function(e){return this._header.setSearch(e),this},a.prototype.getSearch=function(){return this._header.getSearch()},a.prototype.setUser=function(e){return this._header.setUser(e),this},a.prototype.getUser=function(){return this._header.getUser()},a.prototype.getHeadItems=function(){return this._header.getHeadItems()},a.prototype.insertHeadItem=function(e,t){return this._header.insertHeadItem(e,t),this},a.prototype.addHeadItem=function(e){return this._header.addHeadItem(e),this},a.prototype.removeHeadItem=function(e){return this._header.removeHeadItem(e)},a.prototype.removeAllHeadItems=function(){return this._header.removeAllHeadItems()},a.prototype.destroyHeadItems=function(){return this._header.destroyHeadItems(),this},a.prototype.indexOfHeadtem=function(e){return this._header.indexOfHeadItem(e)},a.prototype.getHeadEndItems=function(){return this._header.getHeadEndItems()},a.prototype.insertHeadEndItem=function(e,t){return this._header.insertHeadEndItem(e,t),this},a.prototype.addHeadEndItem=function(e){return this._header.addHeadEndItem(e),this},a.prototype.removeHeadEndItem=function(e){return this._header.removeHeadEndItem(e)},a.prototype.removeAllHeadEndItems=function(){return this._header.removeAllHeadEndItems()},a.prototype.destroyHeadEndItems=function(){return this._header.destroyHeadEndItems(),this},a.prototype.indexOfHeadEndItem=function(e){return this._header.indexOfHeadEndItem(e)},a.prototype.setHeader=function(e){return r.prototype.setHeader.apply(this,[e?e:this._header])},a.prototype.destroyHeader=function(){return this.getHeader()===this._header?this:r.prototype.destroyHeader.apply(this,[])},a},!0);",
		"sap/ui/unified/ShellHeader.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\"],function(e,t){\"use strict\";var i=sap.ui.core.Control.extend(\"sap.ui.unified.ShellHeader\",{metadata:{properties:{logo:{type:\"sap.ui.core.URI\",defaultValue:\"\"},searchVisible:{type:\"boolean\",defaultValue:!0}},aggregations:{headItems:{type:\"sap.ui.unified.ShellHeadItem\",multiple:!0},headEndItems:{type:\"sap.ui.unified.ShellHeadItem\",multiple:!0},search:{type:\"sap.ui.core.Control\",multiple:!1},user:{type:\"sap.ui.unified.ShellHeadUserItem\",multiple:!1}}},renderer:{render:function(e,t){var i=t.getId();e.write(\"<div\"),e.writeControlData(t),e.writeAttribute(\"class\",\"sapUiUfdShellHeader\"),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAttribute(\"role\",\"toolbar\"),e.write(\">\"),e.write(\"<div id='\",i,\"-hdr-begin' class='sapUiUfdShellHeadBegin'>\"),this.renderHeaderItems(e,t,!0),e.write(\"</div>\"),e.write(\"<div id='\",i,\"-hdr-center' class='sapUiUfdShellHeadCenter'>\"),this.renderSearch(e,t),e.write(\"</div>\"),e.write(\"<div id='\",i,\"-hdr-end' class='sapUiUfdShellHeadEnd'>\"),this.renderHeaderItems(e,t,!1),e.write(\"</div>\"),e.write(\"</div>\")},renderSearch:function(e,t){var i=t.getSearch();e.write(\"<div id='\",t.getId(),\"-hdr-search'\"),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAttribute(\"role\",\"search\"),e.writeAttribute(\"class\",\"sapUiUfdShellSearch\"+(t.getSearchVisible()?\"\":\" sapUiUfdShellHidden\")),e.write(\"><div>\"),i&&e.renderControl(i),e.write(\"</div></div>\")},renderHeaderItems:function(e,t,i){e.write(\"<div class='sapUiUfdShellHeadContainer'>\");for(var a=i?t.getHeadItems():t.getHeadEndItems(),r=0;r<a.length;r++){e.write(\"<div tabindex='0'\"),e.writeElementData(a[r]),e.addClass(\"sapUiUfdShellHeadItm\"),a[r].getStartsSection()&&e.addClass(\"sapUiUfdShellHeadItmDelim\"),a[r].getShowSeparator()&&e.addClass(\"sapUiUfdShellHeadItmSep\"),a[r].getVisible()||e.addClass(\"sapUiUfdShellHidden\"),a[r].getSelected()&&a[r].getToggleEnabled()&&e.addClass(\"sapUiUfdShellHeadItmSel\"),a[r].getShowMarker()&&e.addClass(\"sapUiUfdShellHeadItmMark\"),e.writeClasses();var s=a[r].getTooltip_AsString();s&&e.writeAttributeEscaped(\"title\",s),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAccessibilityState(a[r],{role:\"button\",selected:null,pressed:a[r].getToggleEnabled()?a[r].getSelected():null}),e.write(\"><span></span><div class='sapUiUfdShellHeadItmMarker'><div></div></div></div>\")}var d=t.getUser();if(!i&&d){e.write(\"<div tabindex='0'\"),e.writeElementData(d),e.addClass(\"sapUiUfdShellHeadUsrItm\"),d.getShowPopupIndicator()||e.addClass(\"sapUiUfdShellHeadUsrItmWithoutPopup\"),e.writeClasses();var s=d.getTooltip_AsString();s&&e.writeAttributeEscaped(\"title\",s),sap.ui.getCore().getConfiguration().getAccessibility()&&(e.writeAccessibilityState(d,{role:\"button\"}),d.getShowPopupIndicator()&&e.writeAttribute(\"aria-haspopup\",\"true\")),e.write(\"><span id='\",d.getId(),\"-img' aria-hidden='true' class='sapUiUfdShellHeadUsrItmImg'></span>\"),e.write(\"<span id='\"+d.getId()+\"-name' class='sapUiUfdShellHeadUsrItmName'\");var l=d.getUsername()||\"\";e.writeAttributeEscaped(\"title\",l),e.write(\">\"),e.writeEscaped(l),e.write(\"</span><span class='sapUiUfdShellHeadUsrItmExp' aria-hidden='true'></span></div>\")}e.write(\"</div>\"),i&&this._renderLogo(e,t)},_renderLogo:function(e,t){var i=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),a=i.getText(\"SHELL_LOGO_TOOLTIP\"),r=t._getLogo();e.write(\"<div class='sapUiUfdShellIco'>\"),e.write(\"<img id='\",t.getId(),\"-icon'\"),e.writeAttributeEscaped(\"title\",a),e.writeAttributeEscaped(\"alt\",a),e.write(\"src='\"),e.writeEscaped(r),e.write(\"' style='\",r?\"\":\"display:none;\",\"'>\"),e.write(\"</div>\")}}});return i.prototype.init=function(){var e=this;this._rtl=sap.ui.getCore().getConfiguration().getRTL(),this._handleMediaChange=function(t){e.getDomRef()&&e._refresh()},sap.ui.Device.media.attachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD),this._handleResizeChange=function(t){if(e.getDomRef()&&e.getUser()){var i=this.getUser(),a=i._checkAndAdaptWidth(!e.$(\"hdr-search\").hasClass(\"sapUiUfdShellHidden\")&&!!e.getSearch());a&&e._refresh()}},sap.ui.Device.resize.attachHandler(this._handleResizeChange,this),this.data(\"sap-ui-fastnavgroup\",\"true\",!0)},i.prototype.exit=function(){sap.ui.Device.media.detachHandler(this._handleMediaChange,this,sap.ui.Device.media.RANGESETS.SAP_STANDARD),delete this._handleMediaChange,sap.ui.Device.resize.detachHandler(this._handleResizeChange,this),delete this._handleResizeChange},i.prototype.onAfterRendering=function(){this._refresh(),this.$(\"hdr-center\").toggleClass(\"sapUiUfdShellAnim\",!this._noHeadCenterAnim)},i.prototype.onThemeChanged=function(){this.getDomRef()&&this.invalidate()},i.prototype._getLogo=function(){var t=this.getLogo();return t||(e.sap.require(\"sap.ui.core.theming.Parameters\"),t=sap.ui.core.theming.Parameters._getThemeImage(null,!0)),t},i.prototype._refresh=function(){function t(e){for(var t=0;t<e.length;t++)e[t]._refreshIcon()}t(this.getHeadItems()),t(this.getHeadEndItems());var i=this.getUser(),a=e(\"html\").hasClass(\"sapUiMedia-Std-Phone\"),r=!this.$(\"hdr-search\").hasClass(\"sapUiUfdShellHidden\"),s=this.$(\"icon\");i&&(i._refreshImage(),i._checkAndAdaptWidth(r&&!!this.getSearch())),s.parent().toggleClass(\"sapUiUfdShellHidden\",a&&r&&!!this.getSearch());var d=this.$(\"hdr-end\").outerWidth(),l=this.$(\"hdr-begin\").outerWidth(),n=Math.max(d,l),h=(a&&r?l:n)+\"px\",o=(a&&r?d:n)+\"px\";this.$(\"hdr-center\").css({left:this._rtl?o:h,right:this._rtl?h:o})},i},!0);",
		"sap/ui/unified/ShellHeadItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"sap/ui/core/IconPool\",\"./library\"],function(e,t,r,a){\"use strict\";function o(){var e=this.$(),t=this.getToggleEnabled(),r=this.getSelected();e.length&&(t?(e.toggleClass(\"sapUiUfdShellHeadItmSel\",r),e.attr(\"aria-pressed\",r)):(e.removeClass(\"sapUiUfdShellHeadItmSel\"),e.removeAttr(\"aria-pressed\")))}var s=t.extend(\"sap.ui.unified.ShellHeadItem\",{metadata:{library:\"sap.ui.unified\",properties:{startsSection:{type:\"boolean\",group:\"Appearance\",defaultValue:!1,deprecated:!0},showSeparator:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},selected:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},toggleEnabled:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},showMarker:{type:\"boolean\",group:\"Appearance\",defaultValue:!1,deprecated:!0},icon:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:null},visible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"}},events:{press:{}}}});return s.prototype.onclick=function(e){this.firePress(),e.preventDefault()},s.prototype.onsapspace=s.prototype.onclick,s.prototype.onsapenter=s.prototype.onclick,s.prototype.setStartsSection=function(e){return e=!!e,this.setProperty(\"startsSection\",e,!0),this.$().toggleClass(\"sapUiUfdShellHeadItmDelim\",e),this},s.prototype.setShowSeparator=function(e){return e=!!e,this.setProperty(\"showSeparator\",e,!0),this.$().toggleClass(\"sapUiUfdShellHeadItmSep\",e),this},s.prototype.setToggleEnabled=function(e){return this.setProperty(\"toggleEnabled\",!!e,!0),o.apply(this),this},s.prototype.setSelected=function(e){return this.setProperty(\"selected\",!!e,!0),o.apply(this),this},s.prototype.setVisible=function(e){return this.setProperty(\"visible\",!!e),this},s.prototype.setShowMarker=function(e){return e=!!e,this.setProperty(\"showMarker\",e,!0),this.$().toggleClass(\"sapUiUfdShellHeadItmMark\",e),this},s.prototype.setIcon=function(e){return this.setProperty(\"icon\",e,!0),this.getDomRef()&&this._refreshIcon(),this},s.prototype._refreshIcon=function(){var t=e(this.$().children()[0]),a=this.getIcon();if(r.isIconURI(a)){var o=r.getIconInfo(a);t.html(\"\").css(\"style\",\"\"),o&&t.text(o.content).attr(\"role\",\"presentation\").attr(\"aria-label\",o.text||o.name).css(\"font-family\",\"'\"+o.fontFamily+\"'\")}else{var s=this.$(\"img-inner\");0!=s.length&&s.attr(\"src\")==a||t.css(\"style\",\"\").attr(\"aria-label\",null).html(\"<img role='presentation' id='\"+this.getId()+\"-img-inner' src='\"+e.sap.encodeHTML(a)+\"'/>\")}},s},!0);",
		"sap/ui/unified/ShellHeadUserItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"sap/ui/core/IconPool\",\"./library\"],function(e,t,i,a){\"use strict\";var s=t.extend(\"sap.ui.unified.ShellHeadUserItem\",{metadata:{library:\"sap.ui.unified\",properties:{username:{type:\"string\",group:\"Appearance\",defaultValue:\"\"},showPopupIndicator:{type:\"boolean\",group:\"Accessibility\",defaultValue:!0},image:{type:\"sap.ui.core.URI\",group:\"Appearance\",defaultValue:null}},associations:{ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"}},events:{press:{}}}});return i.getIconInfo(\"\",\"\"),s.prototype.onclick=function(e){this.firePress(),e.preventDefault()},s.prototype.onsapspace=s.prototype.onclick,s.prototype.onsapenter=s.prototype.onclick,s.prototype.setImage=function(e){return this.setProperty(\"image\",e,!0),this.getDomRef()&&this._refreshImage(),this},s.prototype._refreshImage=function(){var t=this.$(\"img\"),a=this.getImage();if(a)if(i.isIconURI(a)){var s=i.getIconInfo(a);t.html(\"\").css(\"style\",\"\"),s&&t.text(s.content).attr(\"role\",\"presentation\").attr(\"aria-label\",s.text||s.name).css(\"font-family\",\"'\"+s.fontFamily+\"'\")}else{var r=this.$(\"img-inner\");0!=r.length&&r.attr(\"src\")==a||t.css(\"style\",\"\").attr(\"aria-label\",null).html(\"<img role='presentation' id='\"+this.getId()+\"-img-inner' src='\"+e.sap.encodeHTML(a)+\"'/>\")}else t.html(\"\").css(\"style\",\"\").css(\"display\",\"none\")},s.prototype._checkAndAdaptWidth=function(e){if(!this.getDomRef())return!1;var t=this.$(),i=this.$(\"name\"),a=t.width();t.toggleClass(\"sapUiUfdShellHeadUsrItmLimit\",!1);var s=240;return e&&(s=Math.min(s,.5*document.documentElement.clientWidth-225)),s<i.width()&&t.toggleClass(\"sapUiUfdShellHeadUsrItmLimit\",!0),a!=t.width()},s},!0);",
		"sap/ui/unified/ShellLayout.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/Device\",\"sap/ui/core/Control\",\"sap/ui/core/Popup\",\"sap/ui/core/theming/Parameters\",\"./SplitContainer\",\"./library\",\"jquery.sap.dom\",\"jquery.sap.script\"],function(t,e,n,i,o,r,s){\"use strict\";var a=n.extend(\"sap.ui.unified.ShellLayout\",{metadata:{library:\"sap.ui.unified\",properties:{showPane:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},headerHiding:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},headerVisible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},paneContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"paneContent\"},header:{type:\"sap.ui.core.Control\",multiple:!1},canvasSplitContainer:{type:\"sap.ui.unified.SplitContainer\",multiple:!1,visibility:\"hidden\"},curtainSplitContainer:{type:\"sap.ui.unified.SplitContainer\",multiple:!1,visibility:\"hidden\"}}}});return a._SIDEPANE_WIDTH_PHONE=208,a._SIDEPANE_WIDTH_TABLET=208,a._SIDEPANE_WIDTH_DESKTOP=240,a._HEADER_ALWAYS_VISIBLE=!0,a._HEADER_AUTO_CLOSE=!0,a._HEADER_TOUCH_TRESHOLD=15,e.browser.chrome&&e.browser.version<36&&(a._HEADER_TOUCH_TRESHOLD=10),a.prototype.init=function(){if(this._rtl=sap.ui.getCore().getConfiguration().getRTL(),this._animation=sap.ui.getCore().getConfiguration().getAnimation(),this._showHeader=!0,this._showCurtain=!1,this._iHeaderHidingDelay=3e3,this._useStrongBG=!1,this._cont=new r(this.getId()+\"-container\"),this._cont._bRootContent=!0,sap.ui.getCore().getConfiguration().getAccessibility()){var t=this;this._cont.addEventDelegate({onAfterRendering:function(){t._cont.$(\"canvas\").attr(\"role\",\"main\"),t._cont.$(\"pane\").attr(\"role\",\"complementary\")}})}this.setAggregation(\"canvasSplitContainer\",this._cont,!0),this._curtCont=new r(this.getId()+\"-curt-container\"),this._curtCont._bRootContent=!0,this.setAggregation(\"curtainSplitContainer\",this._curtCont,!0),this._setSidePaneWidth(),e.media.attachHandler(this._handleMediaChange,this,e.media.RANGESETS.SAP_STANDARD),e.resize.attachHandler(this._handleResizeChange,this)},a.prototype.exit=function(){e.media.detachHandler(this._handleMediaChange,this,e.media.RANGESETS.SAP_STANDARD),e.resize.detachHandler(this._handleResizeChange,this),delete this._cont,delete this._curtCont},a.prototype.onAfterRendering=function(){function e(e){var i=t.event.fix(e);t.sap.containsOrEquals(n.getDomRef(\"hdr\"),i.target)&&n._timedHideHeader(\"focus\"===i.type)}var n=this;if(window.addEventListener&&!a._HEADER_ALWAYS_VISIBLE){var i=this.getDomRef(\"hdr\");i.addEventListener(\"focus\",e,!0),i.addEventListener(\"blur\",e,!0)}this._refreshAfterRendering()},a.prototype.onThemeChanged=function(){this._refreshAfterRendering()},a.prototype.onfocusin=function(e){var n=this.getId();e.target.id===n+\"-curt-focusDummyOut\"?t.sap.focus(this.$(\"hdrcntnt\").firstFocusableDomRef()):e.target.id===n+\"-main-focusDummyOut\"&&t.sap.focus(this.$(\"curtcntnt\").firstFocusableDomRef())},function(){function t(t){if(void 0!==t._startY&&void 0!==t._currY){var e=t._currY-t._startY;Math.abs(e)>a._HEADER_TOUCH_TRESHOLD&&(t._doShowHeader(e>0),t._startY=t._currY)}}e.support.touch&&(a._HEADER_ALWAYS_VISIBLE=!1,a.prototype.ontouchstart=function(t){this._startY=t.touches[0].pageY,this._startY>96&&(this._startY=void 0),this._currY=this._startY},a.prototype.ontouchend=function(e){t(this),this._startY=void 0,this._currY=void 0},a.prototype.ontouchcancel=a.prototype.ontouchend,a.prototype.ontouchmove=function(e){this._currY=e.touches[0].pageY,t(this)})}(),a.prototype.setHeaderHiding=function(t){return t=!!t,this._mod(function(e){return this.setProperty(\"headerHiding\",t,e)},function(){this._doShowHeader(!t||this._showHeader)})},a.prototype.setHeaderHidingDelay=function(t){return this._iHeaderHidingDelay=t,this},a.prototype.getHeaderHidingDelay=function(){return this._iHeaderHidingDelay},a.prototype.getShowPane=function(){return this._cont.getShowSecondaryContent()},a.prototype.setShowPane=function(t){return this._cont.setShowSecondaryContent(t),this.setProperty(\"showPane\",!!t,!0),this},a.prototype.setShowCurtainPane=function(t){return this._curtCont.setShowSecondaryContent(t),this},a.prototype.getShowCurtainPane=function(){return this._curtCont.getShowSecondaryContent()},a.prototype.setHeaderVisible=function(t){return t=!!t,this.setProperty(\"headerVisible\",t,!0),this.$().toggleClass(\"sapUiUfdShellNoHead\",!t),this},a.prototype.setShowCurtain=function(t){return t=!!t,this._mod(function(e){return this._showCurtain=t,this},function(){if(this.$(\"main-focusDummyOut\").attr(\"tabindex\",t?0:-1),this.$().toggleClass(\"sapUiUfdShellCurtainHidden\",!t).toggleClass(\"sapUiUfdShellCurtainVisible\",t),t){var e=i.getNextZIndex();this.$(\"curt\").css(\"z-index\",e+1),this.$(\"hdr\").css(\"z-index\",e+3),this.$(\"brand\").css(\"z-index\",e+7),this.$().toggleClass(\"sapUiUfdShellCurtainClosed\",!1)}this._timedCurtainClosed(t),this._doShowHeader(!0)})},a.prototype.getShowCurtain=function(){return this._showCurtain},a.prototype.getContent=function(){return this._cont.getContent()},a.prototype.insertContent=function(t,e){return this._cont.insertContent(t,e),this},a.prototype.addContent=function(t){return this._cont.addContent(t),this},a.prototype.removeContent=function(t){return this._cont.removeContent(t)},a.prototype.removeAllContent=function(){return this._cont.removeAllContent()},a.prototype.destroyContent=function(){return this._cont.destroyContent(),this},a.prototype.indexOfContent=function(t){return this._cont.indexOfContent(t)},a.prototype.getPaneContent=function(){return this._cont.getSecondaryContent()},a.prototype.insertPaneContent=function(t,e){return this._cont.insertSecondaryContent(t,e),this},a.prototype.addPaneContent=function(t){return this._cont.addSecondaryContent(t),this},a.prototype.removePaneContent=function(t){return this._cont.removeSecondaryContent(t)},a.prototype.removeAllPaneContent=function(){return this._cont.removeAllSecondaryContent()},a.prototype.destroyPaneContent=function(){return this._cont.destroySecondaryContent(),this},a.prototype.indexOfPaneContent=function(t){return this._cont.indexOfSecondaryContent(t)},a.prototype.setHeader=function(t){if(this.setAggregation(\"header\",t,!0),t=this.getHeader(),this.getDomRef())if(t){var e=sap.ui.getCore().createRenderManager();e.renderControl(t),e.flush(this.getDomRef(\"hdrcntnt\")),e.destroy()}else this.$(\"hdrcntnt\").html(\"\");return this},a.prototype.destroyHeader=function(){return this.destroyAggregation(\"header\",!0),this.$(\"hdrcntnt\").html(\"\"),this},a.prototype.getCurtainContent=function(){return this._curtCont.getContent()},a.prototype.insertCurtainContent=function(t,e){return this._curtCont.insertContent(t,e),this},a.prototype.addCurtainContent=function(t){return this._curtCont.addContent(t),this},a.prototype.removeCurtainContent=function(t){return this._curtCont.removeContent(t)},a.prototype.removeAllCurtainContent=function(){return this._curtCont.removeAllContent()},a.prototype.destroyCurtainContent=function(){return this._curtCont.destroyContent(),this},a.prototype.indexOfCurtainContent=function(t){return this._curtCont.indexOfCurtainContent(t)},a.prototype.getCurtainPaneContent=function(){return this._curtCont.getSecondaryContent()},a.prototype.insertCurtainPaneContent=function(t,e){return this._curtCont.insertSecondaryContent(t,e),this},a.prototype.addCurtainPaneContent=function(t){return this._curtCont.addSecondaryContent(t),this},a.prototype.removeCurtainPaneContent=function(t){return this._curtCont.removeSecondaryContent(t)},a.prototype.removeAllCurtainPaneContent=function(){return this._curtCont.removeAllSecondaryContent()},a.prototype.destroyCurtainPaneContent=function(){return this._curtCont.destroySecondaryContent(),this},a.prototype.indexOfCurtainPaneContent=function(t){return this._curtCont.indexOfSecondaryContent(t)},a.prototype._setStrongBackground=function(t){this._useStrongBG=!!t,this.$(\"strgbg\").toggleClass(\"sapUiStrongBackgroundColor\",this._useStrongBG)},a.prototype._mod=function(t,e){var n=!!this.getDomRef(),i=t.apply(this,[n]);return n&&e&&(e instanceof sap.ui.unified._ContentRenderer?e.render():e.apply(this)),i},a.prototype._doShowHeader=function(e){var n=this._showHeader;this._showHeader=!this._isHeaderHidingActive()||!!e,this.$().toggleClass(\"sapUiUfdShellHeadHidden\",!this._showHeader).toggleClass(\"sapUiUfdShellHeadVisible\",this._showHeader),this._showHeader&&this._timedHideHeader(),n!=this._showHeader&&this._isHeaderHidingActive()&&t.sap.delayedCall(500,this,function(){try{var e=document.createEvent(\"UIEvents\");e.initUIEvent(\"resize\",!0,!1,window,0),window.dispatchEvent(e)}catch(e){t.sap.log.error(e)}})},a.prototype._timedHideHeader=function(e){this._headerHidingTimer&&(t.sap.clearDelayedCall(this._headerHidingTimer),this._headerHidingTimer=null),e||!a._HEADER_AUTO_CLOSE||!this._isHeaderHidingActive()||this._iHeaderHidingDelay<=0||(this._headerHidingTimer=t.sap.delayedCall(this._iHeaderHidingDelay,this,function(){this._isHeaderHidingActive()&&this._iHeaderHidingDelay>0&&!t.sap.containsOrEquals(this.getDomRef(\"hdr\"),document.activeElement)&&this._doShowHeader(!1)}))},a.prototype._timedCurtainClosed=function(n){if(this._curtainClosedTimer&&(t.sap.clearDelayedCall(this._curtainClosedTimer),this._curtainClosedTimer=null),!n){var i=parseInt(o.get(\"_sap_ui_unified_ShellLayout_AnimDuration\"),10);(!this._animation||e.browser.internet_explorer&&e.browser.version<10)&&(i=0),this._curtainClosedTimer=t.sap.delayedCall(i,this,function(){this._curtainClosedTimer=null,this.$(\"curt\").css(\"z-index\",\"\"),this.$(\"hdr\").css(\"z-index\",\"\"),this.$(\"brand\").css(\"z-index\",\"\"),this.$().toggleClass(\"sapUiUfdShellCurtainClosed\",!0)})}},a.prototype._isHeaderHidingActive=function(){return!(a._HEADER_ALWAYS_VISIBLE||this.getShowCurtain()||!this.getHeaderHiding()||sap.ui.unified._iNumberOfOpenedShellOverlays>0||!this.getHeaderVisible())},a.prototype._refreshCSSWorkaround=function(){e.browser.webkit&&e.support.touch&&(this._cssWorkaroundTimer&&(t.sap.clearDelayedCall(this._cssWorkaroundTimer),this._cssWorkaroundTimer=null),this.$(\"css\").remove(),this._cssWorkaroundTimer=t.sap.delayedCall(10,this,function(){this._cssWorkaroundTimer=null,t.sap.log.debug(\"sap.ui.unified.ShellLayout: CSS Workaround applied.\"),t(\"head\").append(\"<link type='text/css' rel='stylesheet' id='\"+this.getId()+\"-css' href='data:text/css;base64,LnNhcFVpVWZkU2hlbGxDaHJvbWVSZXBhaW50e291dGxpbmUtY29sb3I6aW5pdGlhbDt9'/>\"),this._cssWorkaroundTimer=t.sap.delayedCall(100,this,function(){this.$(\"css\").remove()})}))},a.prototype._setSidePaneWidth=function(t){t||(t=e.media.getCurrentRange(e.media.RANGESETS.SAP_STANDARD).name);var n=a[\"_SIDEPANE_WIDTH_\"+t.toUpperCase()]+\"px\";this._cont.setSecondaryContentSize(n),this._curtCont.setSecondaryContentSize(n)},a.prototype._handleMediaChange=function(t){return!!this.getDomRef()&&void this._setSidePaneWidth(t.name)},a.prototype._handleResizeChange=function(t){},a.prototype._refreshAfterRendering=function(){var t=this.getDomRef();return!!t&&(this._repaint(t),this._timedHideHeader(),!0)},a.prototype._repaint=function(t){if(e.browser.webkit){var n=t.style.display;t.style.display=\"none\",t.offsetHeight,t.style.display=n,this._refreshCSSWorkaround()}},a.prototype._getSearchWidth=function(){return-1},a},!0);",
		"sap/ui/unified/ShellLayoutRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(i){\"use strict\";var e={};return e.render=function(i,e){var a=e.getId();i.write(\"<div\"),i.writeControlData(e),i.addClass(\"sapUiUfdShell\"),e._animation&&i.addClass(\"sapUiUfdShellAnim\"),e.getHeaderVisible()||i.addClass(\"sapUiUfdShellNoHead\"),i.addClass(\"sapUiUfdShellHead\"+(e._showHeader?\"Visible\":\"Hidden\")),e.getShowCurtain()?i.addClass(\"sapUiUfdShellCurtainVisible\"):(i.addClass(\"sapUiUfdShellCurtainHidden\"),i.addClass(\"sapUiUfdShellCurtainClosed\")),i.writeClasses(),i.write(\">\"),i.write(\"<hr id='\",a,\"-brand' class='sapUiUfdShellBrand'>\"),i.write(\"<header id='\",a,\"-hdr'  class='sapUiUfdShellHead'\"),sap.ui.getCore().getConfiguration().getAccessibility()&&i.writeAttribute(\"role\",\"banner\"),i.write(\"><div><div id='\",a,\"-hdrcntnt' class='sapUiUfdShellCntnt'>\"),e.getHeader()&&i.renderControl(e.getHeader()),i.write(\"</div>\",\"</div>\",\"</header>\"),i.write(\"<section id='\",a,\"-curt' class='sapUiUfdShellCntnt sapUiUfdShellCurtain'>\"),i.write(\"<div id='\",a,\"-curtcntnt' class='sapUiUfdShellCntnt'>\"),i.renderControl(e._curtCont),i.write(\"</div>\"),i.write(\"<span id='\",a,\"-curt-focusDummyOut' tabindex='0'></span>\"),i.write(\"</section>\"),i.write(\"<div id='\",a,\"-cntnt' class='sapUiUfdShellCntnt sapUiUfdShellCanvas sapUiGlobalBackgroundColor sapUiGlobalBackgroundColorForce'>\"),i.write(\"<div id='\",a,\"-strgbg' class='sapUiUfdShellBG\"+(e._useStrongBG?\" sapUiStrongBackgroundColor\":\"\")+\"'></div>\"),i.write(\"<div class='sapUiGlobalBackgroundImage sapUiGlobalBackgroundImageForce sapUiUfdShellBG'></div>\"),i.renderControl(e._cont),i.write(\"</div>\"),i.write(\"<span id='\",a,\"-main-focusDummyOut' tabindex='\"+(e.getShowCurtain()?0:-1)+\"'></span>\"),i.write(\"</div>\")},e},!0);",
		"sap/ui/unified/ShellOverlay.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/Device\",\"sap/ui/core/Control\",\"sap/ui/core/Popup\",\"./Shell\",\"./library\",\"jquery.sap.script\"],function(e,t,i,n,o,r){\"use strict\";var s=i.extend(\"sap.ui.unified.ShellOverlay\",{metadata:{library:\"sap.ui.unified\",defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},search:{type:\"sap.ui.core.Control\",multiple:!1}},associations:{shell:{type:\"sap.ui.unified.ShellLayout\",multiple:!1},ariaLabelledBy:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"ariaLabelledBy\"}},events:{closed:{}}}});return s.prototype.open=function(){if(!this._getPopup().isOpen()){this._opening=!0,this._forceShellHeaderVisible(),this._getPopup().setModal(!0,0==n.blStack.length&&this._getAnimActive()?\"sapUiUfdShellOvrlyBly sapUiUfdShellOvrlyBlyTp\":\"\"),this._getPopup().open(0,n.Dock.BeginTop,n.Dock.BeginTop,window,\"0 0\",\"none\");var t=this.getSearch();t&&t.focus(),this._opening=!1,this._getAnimActive()&&e.sap.delayedCall(50,this,function(){e.sap.byId(\"sap-ui-blocklayer-popup\").toggleClass(\"sapUiUfdShellOvrlyBlyTp\",!1)}),e.sap.delayedCall(this._getAnimDuration(!0),this,function(){this.$().toggleClass(\"sapUiUfdShellOvrlyOpening\",!1)})}},s.prototype.close=function(){this._getPopup().isOpen()&&(this.$().toggleClass(\"sapUiUfdShellOvrlyCntntHidden\",!0).toggleClass(\"sapUiUfdShellOvrlyClosing\",!0),this._setSearchWidth(),e.sap.delayedCall(Math.max(this._getAnimDuration(!1)-this._getBLAnimDuration(),0),this,function(){var t=e.sap.byId(\"sap-ui-blocklayer-popup\");1==n.blStack.length&&this._getAnimActive()&&t.hasClass(\"sapUiUfdShellOvrlyBly\")&&t.toggleClass(\"sapUiUfdShellOvrlyBlyTp\",!0)}),e.sap.delayedCall(this._getAnimDuration(!1),this,function(){this._getPopup().close(0),this.$().remove(),this._forceShellHeaderVisible(),this.fireClosed()}))},s.prototype.setShell=function(e){return this.setAssociation(\"shell\",e,!0)},s.prototype.setSearch=function(e){return this.setAggregation(\"search\",e,!0),this.getDomRef()&&this._headRenderer.render(),this},s.prototype.insertContent=function(e,t){var i=this.insertAggregation(\"content\",e,t,!0);return this.getDomRef()&&this._contentRenderer.render(),i},s.prototype.addContent=function(e){var t=this.addAggregation(\"content\",e,!0);return this.getDomRef()&&this._contentRenderer.render(),t},s.prototype.removeContent=function(e){var t=this.removeAggregation(\"content\",e,!0);return this.getDomRef()&&this._contentRenderer.render(),t},s.prototype.removeAllContent=function(){var e=this.removeAllAggregation(\"content\",!0);return this.getDomRef()&&this._contentRenderer.render(),e},s.prototype.destroyContent=function(){var e=this.destroyAggregation(\"content\",!0);return this.getDomRef()&&this._contentRenderer.render(),e},s.prototype.init=function(){this._animOpenDuration=-1,this._animCloseDuration=-1,this._animBlockLayerDuration=-1,this._animation=sap.ui.getCore().getConfiguration().getAnimation(),this._opening=!1;var e=this;this._headRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+\"-hdr-center\",function(t){sap.ui.unified.ShellOverlayRenderer.renderSearch(t,e)}),this._contentRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+\"-cntnt\",function(t){sap.ui.unified.ShellOverlayRenderer.renderContent(t,e)})},s.prototype.exit=function(){this._popup&&(this._popup.close(0),this._popup.destroy(),this._popup=null),this._getPopup=function(){return null},this._headRenderer.destroy(),delete this._headRenderer,this._contentRenderer.destroy(),delete this._contentRenderer},s.prototype.onAfterRendering=function(){this._opening&&this._setSearchWidth(),e.sap.delayedCall(10,this,function(){this.$().toggleClass(\"sapUiUfdShellOvrlyCntntHidden\",!1),this.$(\"search\").css(\"width\",\"\")})},s.prototype.onclick=function(t){e(t.target).attr(\"id\")===this.getId()+\"-close\"&&(this.close(),t.preventDefault())},s.prototype.onsapspace=s.prototype.onclick,s.prototype.onThemeChanged=function(){this._animOpenDuration=-1,this._animCloseDuration=-1,this._animBlockLayerDuration=-1},s.prototype.onfocusin=function(t){var i,n;t.target.id==this.getId()+\"-focfirst\"?(i=e(\":sapTabbable\",this.$(\"inner\")),n=i.get(i.length-1)):t.target.id==this.getId()+\"-foclast\"&&(i=e(\":sapTabbable\",this.$(\"inner\")),n=i.get(0)),n&&e.sap.focus(n)},s.prototype._getAnimDurationThemeParam=function(e,t){var i=parseInt(sap.ui.core.theming.Parameters.get(e),10);return!this._getAnimActive()&&t&&(i=0),i},s.prototype._getAnimDuration=function(e){if(e&&this._animOpenDuration==-1||!e&&this._animCloseDuration==-1){var t=e?\"Open\":\"Close\";this[\"_anim\"+t+\"Duration\"]=this._getAnimDurationThemeParam(\"_sap_ui_unified_ShellOverlay_\"+t+\"AnimOverAll\",!0)}return e?this._animOpenDuration:this._animCloseDuration},s.prototype._getBLAnimDuration=function(){return this._animBlockLayerDuration==-1&&(this._animBlockLayerDuration=this._getAnimDurationThemeParam(\"_sap_ui_unified_ShellOverlay_BlockLayerAnimDuration\",!0)),this._animBlockLayerDuration},s.prototype._getAnimActive=function(){return!(!this._animation||t.browser.internet_explorer&&t.browser.version<10)},s.prototype._getPopup=function(){return this._popup||(this._popup=new n(this,!0,!1,!1),this._popup._applyPosition=function(t){this._$().css(\"left\",\"0\").css(\"top\",\"0\"),this._oLastPosition=t,this._oLastOfRect=e(window).rect()},this._popup.attachOpened(function(){sap.ui.unified._iNumberOfOpenedShellOverlays++}),this._popup.attachClosed(function(){sap.ui.unified._iNumberOfOpenedShellOverlays--})),this._popup},s.prototype._getShell=function(){var e=this.getShell();if(e){var t=sap.ui.getCore().byId(e);if(t&&t instanceof sap.ui.unified.ShellLayout)return t}},s.prototype._forceShellHeaderVisible=function(){var e=this._getShell();e&&e._doShowHeader(!0)},s.prototype._getSearchWidth=function(){var e=this._getShell();return e?e._getSearchWidth():-1},s.prototype._setSearchWidth=function(){var e=this._getSearchWidth();if(!(e<=0)){var i=e+\"px\";if(t.browser.safari){var n=this.$(\"hdr-center\").width();i=n>e?Math.round(100*e/n)+\"%\":\"100%\"}this.$(\"search\").css(\"width\",i)}},s},!0);",
		"sap/ui/unified/ShellOverlayRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var i={};return i.render=function(e,t){e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiUfdShellOvrly\"),t._opening&&(e.addClass(\"sapUiUfdShellOvrlyCntntHidden\"),e.addClass(\"sapUiUfdShellOvrlyOpening\")),t._getAnimActive()&&e.addClass(\"sapUiUfdShellOvrlyAnim\"),e.writeClasses(),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAccessibilityState(t,{role:\"dialog\"}),e.write(\"><span id='\",t.getId(),\"-focfirst' tabIndex='0'></span><div id='\",t.getId(),\"-inner'>\"),e.write(\"<header class='sapUiUfdShellOvrlyHead'>\"),e.write(\"<hr class='sapUiUfdShellOvrlyBrand'>\"),e.write(\"<div class='sapUiUfdShellOvrlyHeadCntnt'\"),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAttribute(\"role\",\"toolbar\"),e.write(\"><div id='\"+t.getId()+\"-hdr-center' class='sapUiUfdShellOvrlyHeadCenter'>\"),i.renderSearch(e,t),e.write(\"</div>\");var r=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.unified\"),d=r.getText(\"SHELL_OVERLAY_CLOSE\");e.write(\"<a tabindex='0' href='#' id='\"+t.getId()+\"-close' class='sapUiUfdShellOvrlyHeadClose'\"),e.writeAttributeEscaped(\"title\",d),sap.ui.getCore().getConfiguration().getAccessibility()&&e.writeAttribute(\"role\",\"button\"),e.write(\">\"),e.writeEscaped(d),e.write(\"</a></div></header>\"),e.write(\"<div id='\"+t.getId()+\"-cntnt' class='sapUiUfdShellOvrlyCntnt'>\"),i.renderContent(e,t),e.write(\"</div>\"),e.write(\"</div><span id='\",t.getId(),\"-foclast' tabIndex='0'></span></div>\")},i.renderSearch=function(e,i){var t=i._getSearchWidth(),r=\"\";t>0&&i._opening&&(r=\"style='width:\"+t+\"px'\"),e.write(\"<div id='\"+i.getId()+\"-search' class='sapUiUfdShellOvrlySearch' \"+r+\"><div>\");var d=i.getSearch();d&&e.renderControl(d),e.write(\"</div></div>\")},i.renderContent=function(e,i){e.write(\"<div tabindex='-1'>\");for(var t=i.getContent(),r=0;r<t.length;r++)e.renderControl(t[r]);e.write(\"</div>\")},i},!0);",
		"sap/ui/unified/ShellRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"./ShellLayoutRenderer\"],function(e,r,n){\"use strict\";var u=r.extend(n);return u},!0);",
		"sap/ui/unified/SplitContainer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/theming/Parameters\",\"./library\"],function(t,e,n,o){\"use strict\";var r=e.extend(\"sap.ui.unified.SplitContainer\",{metadata:{library:\"sap.ui.unified\",properties:{showSecondaryContent:{type:\"boolean\",group:\"Appearance\",defaultValue:null},secondaryContentSize:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"250px\"},secondaryContentWidth:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"250px\",deprecated:!0},orientation:{type:\"sap.ui.core.Orientation\",group:\"Appearance\",defaultValue:sap.ui.core.Orientation.Horizontal}},defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},secondaryContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"secondaryContent\"}}}});return function(e){r.prototype.init=function(){this.bRtl=sap.ui.getCore().getConfiguration().getRTL(),this._paneRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+\"-panecntnt\",\"secondaryContent\"),this._canvasRenderer=new sap.ui.unified._ContentRenderer(this,this.getId()+\"-canvascntnt\",\"content\"),this._moveContent=!0},r.prototype.exit=function(){this._paneRenderer.destroy(),delete this._paneRenderer,this._canvasRenderer.destroy(),delete this._canvasRenderer,this._closeContentDelayId&&(t.sap.clearDelayedCall(this._closeContentDelayId),delete this._closeContentDelayId),delete this._contentContainer,delete this._secondaryContentContainer},r.prototype.onAfterRendering=function(){this.bRtl=sap.ui.getCore().getConfiguration().getRTL(),this._contentContainer=this.$(\"canvas\"),this._secondaryContentContainer=this.$(\"pane\"),this._applySecondaryContentSize()},r.prototype._applySecondaryContentSize=function(){if(this.getDomRef()){var e,o,r,i,a=this.getOrientation()==sap.ui.core.Orientation.Vertical,s=this.getSecondaryContentSize(),d=this.getShowSecondaryContent();if(a?(e=\"height\",o=\"width\",r=\"top\",i=this.bRtl?\"right\":\"left\"):(e=\"width\",o=\"height\",r=this.bRtl?\"right\":\"left\",i=\"top\"),this._closeContentDelayId&&(t.sap.clearDelayedCall(this._closeContentDelayId),delete this._closeContentDelayId),this._secondaryContentContainer.css(e,s),this._secondaryContentContainer.css(o,\"\"),this._secondaryContentContainer.css(r,d?\"0\":\"-\"+s),this._secondaryContentContainer.css(i,\"\"),this._moveContent?this._contentContainer.css(r,d?s:\"0\"):this._contentContainer.css(r,\"0\"),d)this._secondaryContentContainer.toggleClass(\"sapUiUfdSplitContSecondClosed\",!1);else{var c=parseInt(n.get(\"_sap_ui_unified_SplitContainer_AnimationDuration\"),10);this._closeContentDelayId=t.sap.delayedCall(c,this,function(){this._secondaryContentContainer.toggleClass(\"sapUiUfdSplitContSecondClosed\",!0)})}}},r.prototype._mod=function(t,e){var n=!!this.getDomRef(),o=t.apply(this,[n]);return n&&e&&e.render(),o},r.prototype.setShowSecondaryContent=function(t){var e=this.getDomRef();return this.setProperty(\"showSecondaryContent\",!!t,e),this._applySecondaryContentSize(),this},r.prototype.setSecondaryContentSize=function(t){return this.setProperty(\"secondaryContentSize\",t,!0),this._applySecondaryContentSize(),this},r.prototype.getSecondaryContentWidth=function(){return t.sap.log.warning('SplitContainer: Use of deprecated property \"SecondaryContentWidth\", please use \"SecondaryContentSize\" instead.'),this.getSecondaryContentSize.apply(this,arguments)},r.prototype.setSecondaryContentWidth=function(){return t.sap.log.warning('SplitContainer: Use of deprecated property \"SecondaryContentWidth\", please use \"SecondaryContentSize\" instead.'),this.setSecondaryContentSize.apply(this,arguments)},r.prototype.insertContent=function(t,e){return this._mod(function(n){return this.insertAggregation(\"content\",t,e,n)},this._canvasRenderer)},r.prototype.addContent=function(t){return this._mod(function(e){return this.addAggregation(\"content\",t,e)},this._canvasRenderer)},r.prototype.removeContent=function(t){return this._mod(function(e){return this.removeAggregation(\"content\",t,e)},this._canvasRenderer)},r.prototype.removeAllContent=function(){return this._mod(function(t){return this.removeAllAggregation(\"content\",t)},this._canvasRenderer)},r.prototype.destroyContent=function(){return this._mod(function(t){return this.destroyAggregation(\"content\",t)},this._canvasRenderer)},r.prototype.insertSecondaryContent=function(t,e){return this._mod(function(n){return this.insertAggregation(\"secondaryContent\",t,e,n)},this._paneRenderer)},r.prototype.addSecondaryContent=function(t){return this._mod(function(e){return this.addAggregation(\"secondaryContent\",t,e)},this._paneRenderer)},r.prototype.removeSecondaryContent=function(t){return this._mod(function(e){return this.removeAggregation(\"secondaryContent\",t,e)},this._paneRenderer)},r.prototype.removeAllSecondaryContent=function(){return this._mod(function(t){return this.removeAllAggregation(\"secondaryContent\",t)},this._paneRenderer)},r.prototype.destroySecondaryContent=function(){return this._mod(function(t){return this.destroyAggregation(\"secondaryContent\",t)},this._paneRenderer)}}(window),r},!0);",
		"sap/ui/unified/SplitContainerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var n=e.getId(),i=e.getOrientation()==sap.ui.core.Orientation.Vertical;t.write(\"<div\"),t.writeControlData(e),t.addClass(\"sapUiUfdSpltCont\"),t.addClass(\"sapUiUfdSpltCont\"+(i?\"V\":\"H\")),sap.ui.getCore().getConfiguration().getAnimation()&&t.addClass(\"sapUiUfdSpltContAnim\"),e.getShowSecondaryContent()||t.addClass(\"sapUiUfdSpltContPaneHidden\"),t.writeClasses(),t.write(\">\");var a=n+\"-canvas\";t.write(\"<section id='\",a,\"' class='sapUiUfdSpltContCanvas'>\"),this.renderContent(t,a,e.getContent(),e._bRootContent),t.write(\"</section>\");var o=n+\"-pane\",r=e.getShowSecondaryContent()?e.getSecondaryContentSize():\"0\";t.write(\"<aside id='\",o,\"' style='width:\",r,\"'\"),t.addClass(\"sapUiUfdSpltContPane\"),e.getShowSecondaryContent()||t.addClass(\"sapUiUfdSplitContSecondClosed\"),t.writeClasses(),t.write(\">\"),this.renderContent(t,o,e.getSecondaryContent(),e._bRootContent),t.write(\"</aside>\"),t.write(\"</div>\")},e.renderContent=function(t,e,n,i){t.write(\"<div id='\",e,\"cntnt' class='sapUiUfdSpltContCntnt'\"),i&&t.writeAttribute(\"data-sap-ui-root-content\",\"true\"),t.write(\">\");for(var a=0;a<n.length;a++)t.renderControl(n[a]);t.write(\"</div>\")},e},!0);",
		"sap/ui/unified/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.ui.unified\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"8.0.0-0\"},\"title\":\"The OpenUI5-based library, sap.ui.unified.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{}}},\"library\":{\"i18n\":\"messagebundle.properties\"}}}"
	},
	"dependencies": ["sap.ui.core.library-preload"],
	"sas-uglified": true
});