jQuery.sap.registerPreloadedModules({
	"version": "2.0",
	"name": "sap.uxap.library-preload",
	"modules": {
		"sap/uxap/AnchorBar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/Button\",\"sap/m/PlacementType\",\"sap/m/Popover\",\"sap/m/Toolbar\",\"sap/ui/core/IconPool\",\"sap/ui/core/Item\",\"sap/ui/core/ResizeHandler\",\"sap/ui/core/delegate/ScrollEnablement\",\"sap/ui/layout/HorizontalLayout\",\"sap/ui/Device\",\"sap/ui/core/CustomData\",\"./HierarchicalSelect\",\"./library\"],function(t,e,o,r,i,s,n,a,l,c,h,p,u){\"use strict\";var d=r.extend(\"sap.uxap.AnchorBar\",{metadata:{library:\"sap.uxap\",properties:{showPopover:{type:\"boolean\",defaultValue:!0},upperCase:{type:\"boolean\",defaultValue:!1}},associations:{selectedButton:{type:\"sap.m.Button\",multiple:!1}},aggregations:{_select:{type:\"sap.uxap.HierarchicalSelect\",multiple:!1,visibility:\"hidden\"},_popovers:{type:\"sap.m.Popover\",multiple:!0,visibility:\"hidden\"},_scrollArrowLeft:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"},_scrollArrowRight:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"}}}});return d.prototype.init=function(){r.prototype.init&&r.prototype.init.call(this),this.addStyleClass(\"sapUxAPAnchorBar\"),this._oPressHandlers={},this._oSectionInfo={},this._oScroller=null,this._sSelectedKey=null,this._bRtl=sap.ui.getCore().getConfiguration().getRTL(),this._bRtlScenario=this._bRtl&&!c.browser.msie,this._bHasButtonsBar=c.system.tablet||c.system.desktop,this._oSelect=this._getHierarchicalSelect(),this._bHasButtonsBar&&(this._oScroller=new a(this,this.getId()+\"-scroll\",{horizontal:!0,vertical:!1,nonTouchScrolling:!0}),this._iREMSize=parseInt(jQuery(\"body\").css(\"font-size\"),10),this._iTolerance=1*this._iREMSize,this._iOffset=3*this._iREMSize,this._sResizeListenerId=void 0),this.setDesign(\"Transparent\")},d.SCROLL_STEP=250,d.SCROLL_DURATION=500,d.DOM_CALC_DELAY=200,d.prototype.setSelectedButton=function(t){var e=this._oSelect.getItems(),o=e.length>0;if(\"string\"==typeof t&&(t=sap.ui.getCore().byId(t)),t){if(t.getId()===this.getSelectedButton())return this;var r=t.data(\"sectionId\");this._sSelectedKey=r,r&&o&&this._oSelect.setSelectedKey(r),this._bHasButtonsBar&&(this.$().find(\".sapUxAPAnchorBarButtonSelected\").removeClass(\"sapUxAPAnchorBarButtonSelected\"),t.$().addClass(\"sapUxAPAnchorBarButtonSelected\"),r&&this.scrollToSection(r,d.SCROLL_DURATION),this._setAnchorButtonsTabFocusValues(t))}return this.setAssociation(\"selectedButton\",t,!0)},d.prototype.setShowPopover=function(t,e){if(this.getShowPopover()===t)return this;var o,r=!jQuery.isEmptyObject(this._oPressHandlers);if(r){var i=this.getContent()||[];o=this.getSelectedButton(),i.forEach(this._detachPopoverHandler,this)}return this.setProperty(\"showPopover\",t,!0),r&&(this.rerender(),o&&this.setSelectedButton(o)),this},d.prototype.getSelectedSection=function(){var e=this.getSelectedButton();return e&&\"string\"==typeof e&&(e=sap.ui.getCore().byId(e)),e&&e instanceof t&&e.data(\"sectionId\")?sap.ui.getCore().byId(e.data(\"sectionId\")):null},d.prototype.onBeforeRendering=function(){r.prototype.onBeforeRendering&&r.prototype.onBeforeRendering.call(this);var t=this.getContent()||[],e=this.getUpperCase(),o={oLastFirstLevelButton:null,oCurrentPopover:null};this._oSelect.removeAllItems(),this._oSelect.setUpperCase(e),this.toggleStyleClass(\"sapUxAPAnchorBarUpperCase\",e),t.forEach(function(t){this._createSelectItem(t),this._bHasButtonsBar&&this._createPopoverSubMenu(t,o)},this),t.length>0&&this._sSelectedKey&&this._oSelect.setSelectedKey(this._sSelectedKey)},d.prototype.addContent=function(t,e){return t.addStyleClass(\"sapUxAPAnchorBarButton\"),t.removeAllAriaDescribedBy(),!this._bHasButtonsBar||t.data(\"secondLevel\")!==!0&&\"true\"!==t.data(\"secondLevel\")||t.attachPress(this._handleDirectScroll,this),this.addAggregation(\"content\",t,e)},d.prototype._createSelectItem=function(t){var e=t.data(\"secondLevel\")===!0||\"true\"===t.data(\"secondLevel\");if(\"\"!=t.getText().trim()&&(!e||t.data(\"bTitleVisible\")===!0)){var o=new s({key:t.data(\"sectionId\"),text:t.getText(),customData:[new h({key:\"secondLevel\",value:t.data(\"secondLevel\")})]});this._oSelect.addItem(o)}},d.prototype._createPopoverSubMenu=function(t,r){var i=t.data(\"secondLevel\")===!0||\"true\"===t.data(\"secondLevel\"),s=null;i?r.oLastFirstLevelButton&&r.oCurrentPopover?(this._oPressHandlers[r.oLastFirstLevelButton.getId()]||(s=jQuery.proxy(this._handlePopover,{oCurrentPopover:r.oCurrentPopover,oLastFirstLevelButton:r.oLastFirstLevelButton}),r.oLastFirstLevelButton.attachPress(s),this._oPressHandlers[r.oLastFirstLevelButton.getId()]=s),r.oCurrentPopover.addContent(t)):this.getShowPopover()?jQuery.sap.log.error(\"sapUxApAnchorBar :: missing parent first level for item \"+t.getText()):(this.removeContent(t),t.destroy()):(r.oLastFirstLevelButton=t,this.getShowPopover()?(r.oCurrentPopover=new o({placement:e.Bottom,showHeader:!1,verticalScrolling:!0,horizontalScrolling:!1,contentWidth:\"auto\",showArrow:!1}),r.oCurrentPopover.addStyleClass(\"sapUxAPAnchorBarPopover\"),this._addKeyboardHandling(r.oCurrentPopover),this.addAggregation(\"_popovers\",r.oCurrentPopover)):this._oPressHandlers[r.oLastFirstLevelButton.getId()]||(s=jQuery.proxy(this._handleDirectScroll,this),r.oLastFirstLevelButton.attachPress(s),this._oPressHandlers[r.oLastFirstLevelButton.getId()]=s))},d.prototype._addKeyboardHandling=function(t){t.onsapdown=function(t){t.target.nextSibling&&t.target.nextSibling.focus()},t.onsapright=function(e){t.onsapdown(e)},t.onsapup=function(t){t.target.previousSibling&&t.target.previousSibling.focus()},t.onsapleft=function(e){t.onsapup(e)},t.onsaphome=function(t){t.target.parentElement.firstChild&&t.target.parentElement.firstChild.focus()},t.onsapend=function(t){t.target.parentElement.lastChild&&t.target.parentElement.lastChild.focus()},t.onsappageup=this._handlePageUp.bind(t),t.onsappagedown=this._handlePageDown.bind(t)},d.prototype._detachPopoverHandler=function(t){this._oPressHandlers[t.getId()]&&(t.detachPress(this._oPressHandlers[t.getId()]),this._oPressHandlers[t.getId()]=null)},d.prototype._handlePopover=function(t){var e=this.oCurrentPopover.getContent()||[];this.oLastFirstLevelButton.$().is(\":visible\")&&(1==e.length?e[0].firePress({}):this.oCurrentPopover.openBy(this.oLastFirstLevelButton))},d.prototype._handleDirectScroll=function(t){t.getSource().getParent()instanceof o&&t.getSource().getParent().close(),this._requestScrollToSection(t.getSource().data(\"sectionId\"))},d.prototype._requestScrollToSection=function(t){var e=sap.ui.getCore().byId(t),o=e.getParent();if(this.getParent()instanceof u.ObjectPageLayout){var r=t;e instanceof u.ObjectPageSubSection&&o instanceof u.ObjectPageSection&&(r=o.getId()),this.getParent().setDirectScrollingToSection(r),this.getParent().scrollToSection(e.getId(),null,0,!0)}e instanceof u.ObjectPageSubSection&&o instanceof u.ObjectPageSection&&o.setAssociation(\"selectedSubSection\",e,!0)},d.prototype._onSelectChange=function(t){var e,o=t.getParameter(\"selectedItem\");e=sap.ui.getCore().byId(o.getKey()),e?this._requestScrollToSection(e.getId()):jQuery.sap.log.error(\"AnchorBar :: cannot find corresponding section\",o.getKey())},d.prototype._getHierarchicalSelect=function(){return this.getAggregation(\"_select\")||this.setAggregation(\"_select\",new p({width:\"100%\",icon:\"sap-icon://overflow\",change:jQuery.proxy(this._onSelectChange,this)})),this.getAggregation(\"_select\")},d.prototype._createScrollArrow=function(e){var o,r,s,n,a=this;return e?(o=this.getId()+\"-arrowScrollLeft\",r=\"slim-arrow-left\",s=\"anchorBarArrowLeft\"):(o=this.getId()+\"-arrowScrollRight\",r=\"slim-arrow-right\",s=\"anchorBarArrowRight\"),n=new t(o,{icon:i.getIconURI(r),type:\"Transparent\",press:function(t){t.preventDefault(),a._handleScrollButtonTap(e)}}),n.addEventDelegate({onAfterRendering:function(){\"sap_hcb\"!=sap.ui.getCore().getConfiguration().getTheme()&&this.$().attr(\"tabindex\",-1)},onThemeChanged:function(){\"sap_hcb\"==sap.ui.getCore().getConfiguration().getTheme()?this.$().removeAttr(\"tabindex\"):this.$().attr(\"tabindex\",-1)}},n),new l({content:[n]}).addStyleClass(\"anchorBarArrow\").addStyleClass(s)},d.prototype._getScrollArrowLeft=function(){var t=this.getAggregation(\"_scrollArrowLeft\");return t?t:(t=this._createScrollArrow(!0),this.setAggregation(\"_scrollArrowLeft\",t),t)},d.prototype._getScrollArrowRight=function(){var t=this.getAggregation(\"_scrollArrowRight\");return t?t:(t=this._createScrollArrow(!1),this.setAggregation(\"_scrollArrowRight\",t),t)},d._hierarchicalSelectModes={Icon:\"icon\",Text:\"text\"},d.prototype._applyHierarchicalSelectMode=function(){this._sHierarchicalSelectMode===d._hierarchicalSelectModes.Icon?(this.$().find(\".sapUxAPAnchorBarScrollContainer\").show(),this._oSelect.setWidth(\"auto\"),this._oSelect.setAutoAdjustWidth(!0),this._oSelect.setType(sap.m.SelectType.IconOnly),this._computeBarSectionsInfo()):(this.$().find(\".sapUxAPAnchorBarScrollContainer\").hide(),this._oSelect.setWidth(\"100%\"),this._oSelect.setAutoAdjustWidth(!1),this._oSelect.setType(sap.m.SelectType.Default)),this.$().toggleClass(\"sapUxAPAnchorBarOverflow\",this._sHierarchicalSelectMode===d._hierarchicalSelectModes.Icon)},d.prototype._adjustSize=function(){var t=u.Utilities.isPhoneScenario(this._getCurrentMediaContainerRange())?d._hierarchicalSelectModes.Text:d._hierarchicalSelectModes.Icon;if(t!==this._sHierarchicalSelectMode&&(this._sHierarchicalSelectMode=t,this._applyHierarchicalSelectMode()),this._sHierarchicalSelectMode===d._hierarchicalSelectModes.Icon){if(this._iMaxPosition<0)return;var e,o,r,i=this.$(),s=i.find(\".sapUxAPAnchorBarScrollContainer\");r=s.width(),this._bRtlScenario?c.browser.firefox?(o=Math.abs(s.scrollLeft())+r<this._iMaxPosition-this._iTolerance,e=Math.abs(s.scrollLeft())>=this._iTolerance):(o=Math.abs(s.scrollLeft())>=this._iTolerance,e=Math.abs(s.scrollLeft())+r<this._iMaxPosition-this._iTolerance):(o=s.scrollLeft()+r<this._iMaxPosition-this._iTolerance,e=s.scrollLeft()>=this._iTolerance),jQuery.sap.log.debug(\"AnchorBar :: scrolled at \"+s.scrollLeft(),\"scrollBegin [\"+(e?\"true\":\"false\")+\"] scrollEnd [\"+(o?\"true\":\"false\")+\"]\"),i.toggleClass(\"sapUxAPAnchorBarScrollLeft\",e),i.toggleClass(\"sapUxAPAnchorBarScrollRight\",o)}},d.prototype._handleScrollButtonTap=function(t){var e=!this._bRtlScenario&&t||this._bRtlScenario&&!t?-1:1;this._oScroller.scrollTo(this._iMaxPosition*e,0,3*d.SCROLL_DURATION)},d.prototype.scrollToSection=function(t,e){if(this._bHasButtonsBar){var o,r=e||d.SCROLL_DURATION;!u.Utilities.isPhoneScenario(this._getCurrentMediaContainerRange())&&this._oSectionInfo[t]?(this._bRtlScenario&&c.browser.firefox?o=this._oSectionInfo[t].scrollLeft+this._iOffset:(o=this._oSectionInfo[t].scrollLeft-this._iOffset,o<0&&(o=0)),jQuery.sap.log.debug(\"AnchorBar :: scrolling to section \"+t+\" of \"+o),this._sCurrentScrollId!=t&&(this._sCurrentScrollId=t,this._iCurrentScrollTimeout&&(jQuery.sap.clearDelayedCall(this._iCurrentScrollTimeout),jQuery.sap.byId(this.getId()+\"-scroll\").parent().stop(!0,!1)),this._iCurrentScrollTimeout=jQuery.sap.delayedCall(e,this,function(){this._sCurrentScrollId=void 0,this._iCurrentScrollTimeout=void 0}),this._oScroller.scrollTo(o,0,r))):jQuery.sap.log.debug(\"AnchorBar :: no need to scroll to \"+t)}},d.prototype.getScrollDelegate=function(){return this._oScroller},d.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5,d.prototype.onsapdown=function(t){t.preventDefault(),t.target.nextSibling&&t.target.nextSibling.focus()},d.prototype.onsapright=function(t){var e=this._bRtl?\"onsapup\":\"onsapdown\";this[e](t)},d.prototype.onsapup=function(t){t.preventDefault(),t.target.previousSibling&&t.target.previousSibling.focus()},d.prototype.onsapleft=function(t){var e=this._bRtl?\"onsapdown\":\"onsapup\";this[e](t)},d.prototype.onsaphome=function(t){t.preventDefault(),t.target.parentElement.firstChild&&t.target.parentElement.firstChild.focus()},d.prototype.onsapend=function(t){t.preventDefault(),t.target.parentElement.lastChild&&t.target.parentElement.lastChild.focus()},d.prototype.onsappageup=function(t){this._handlePageUp(t)},d.prototype.onsappagedown=function(t){this._handlePageDown(t)},d.prototype._handlePageUp=function(t){t.preventDefault();var e,o=this.getContent();o.forEach(function(o,r){if(o.getId()===t.target.id)return void(e=r-(d.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1))}),e&&o[e]?o[e].focus():o[0]&&o[0].focus()},d.prototype._handlePageDown=function(t){t.preventDefault();var e,o=this.getContent();o.forEach(function(o,r){if(o.getId()===t.target.id)return void(e=r+d.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1)}),e&&o[e]?o[e].focus():o[o.length-1]&&o[o.length-1].focus()},d.prototype._setAnchorButtonsTabFocusValues=function(t){var e,o=this.getContent()||[],r=\"0\",i=\"-1\",s=\"tabIndex\";o.forEach(function(o){e=o.$(),o.sId===t.sId?e.attr(s,r):e.attr(s,i)})},d.prototype.onsapskipforward=function(t){this._handleGroupNavigation(t,!1)},d.prototype._handleGroupNavigation=function(t,e){var o,r=jQuery.Event(\"keydown\"),i={},s=this.getParent(),n=s.getUseIconTabBar(),a=s.getSelectedSection(),l=s.getSections(),c=[this.getDomRef()];n?o=sap.ui.getCore().byId(a).getSubSections().map(function(t){return t.$().attr(\"tabindex\",-1)[0]}):l.forEach(function(t){o=t.getSubSections().map(function(t){return t.$().attr(\"tabindex\",-1)[0]})}),c=c.concat(o),i.scope=c,t.preventDefault(),this.$().focus(),r.target=t.target,r.keyCode=jQuery.sap.KeyCodes.F6,r.shiftKey=e,jQuery.sap.handleF6GroupNavigation(r,i)},d.prototype.onAfterRendering=function(){var t;r.prototype.onAfterRendering&&r.prototype.onAfterRendering.call(this),t=sap.ui.getCore().byId(this.getSelectedButton()),this._iMaxPosition=-1,this._sResizeListenerId=n.register(this,jQuery.proxy(this._adjustSize,this)),this.$().find(\".sapUxAPAnchorBarScrollContainer\").scroll(jQuery.proxy(this._onScroll,this)),t&&(this.setSelectedButton(t),this._setAnchorButtonsTabFocusValues(t)),this._bHasButtonsBar&&jQuery.sap.delayedCall(d.DOM_CALC_DELAY,this,function(){this._adjustSize()})},d.prototype._onScroll=function(){this._iCurrentSizeCheckTimeout||(this._iCurrentSizeCheckTimeout=jQuery.sap.delayedCall(d.SCROLL_DURATION,this,function(){this._iCurrentSizeCheckTimeout=void 0,this._adjustSize()}))},d.prototype._computeBarSectionsInfo=function(){this._iMaxPosition=0;var t=this.getContent()||[];t.forEach(this._computeNextSectionInfo,this),this._bRtlScenario&&(c.browser.webkit||c.browser.firefox)&&(t.forEach(this._adjustNextSectionInfo,this),this._oScroller.scrollTo(this._iMaxPosition,0,0))},d.prototype._computeNextSectionInfo=function(t){t.data(\"bHasSubMenu\")&&t.$().attr(\"aria-haspopup\",\"true\"),t.$().attr(\"aria-controls\",t.data(\"sectionId\"));var e=t.$().outerWidth(!0);this._oSectionInfo[t.data(\"sectionId\")]={scrollLeft:this._iMaxPosition,width:e},this._iMaxPosition+=e},d.prototype._adjustNextSectionInfo=function(t){var e=this._oSectionInfo[t.data(\"sectionId\")];c.browser.firefox?e.scrollLeft=-e.scrollLeft:e.scrollLeft=this._iMaxPosition-e.scrollLeft-e.width},d.prototype._destroyPopoverContent=function(){var t=this.getAggregation(\"_popovers\");Array.isArray(t)&&t.forEach(function(t){t.destroyContent()})},d.prototype._resetControl=function(){return this._destroyPopoverContent(),this.getContent().forEach(this._detachPopoverHandler,this),this.destroyAggregation(\"content\",!0),this},d.prototype.exit=function(){this._sResizeListenerId&&(n.deregister(this._sResizeListenerId),this._sResizeListenerId=null),this._oScroller&&(this._oScroller.destroy(),this._oScroller=null)},d});",
		"sap/uxap/AnchorBarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/ToolbarRenderer\",\"sap/ui/core/Renderer\",\"sap/m/BarInPageEnabler\",\"./AnchorBar\",\"./library\"],function(e,r,t,o,a){\"use strict\";var n=r.extend(e);return n.renderBarContent=function(e,r){r._bHasButtonsBar&&(e.renderControl(r._getScrollArrowLeft()),e.write(\"<div\"),e.writeAttributeEscaped(\"id\",r.getId()+\"-scrollContainer\"),e.writeAttributeEscaped(\"aria-label\",a.i18nModel.getResourceBundle().getText(\"ANCHOR_BAR_LABEL\")),e.addClass(\"sapUxAPAnchorBarScrollContainer\"),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.writeAttributeEscaped(\"id\",r.getId()+\"-scroll\"),e.write(\">\"),n.renderBarItems(e,r),e.write(\"</div>\"),e.write(\"</div>\"),e.renderControl(r._getScrollArrowRight())),t.addChildClassTo(r._oSelect,r),e.renderControl(r._oSelect)},n.renderBarItems=function(e,r){var o=r.getSelectedButton();r.getContent().forEach(function(a){t.addChildClassTo(a,r),a.getId()===o&&a.addStyleClass(\"sapUxAPAnchorBarButtonSelected\"),e.renderControl(a)})},n.decorateRootElement=function(r,t){e.decorateRootElement.apply(this,arguments),t._sHierarchicalSelectMode===o._hierarchicalSelectModes.Icon&&r.addClass(\"sapUxAPAnchorBarOverflow\")},n},!0);",
		"sap/uxap/BlockBase.designtime.js": "/*\n * ! UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{aggregations:{_views:{ignore:!1}}}},!1);",
		"sap/uxap/BlockBase.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/Control\",\"sap/ui/core/CustomData\",\"./BlockBaseMetadata\",\"./ModelMapping\",\"sap/ui/model/Context\",\"sap/ui/Device\",\"sap/ui/layout/form/ResponsiveGridLayout\",\"./library\",\"sap/ui/core/Component\"],function(e,t,o,i,a,n,s,r,p){\"use strict\";var u=e.extend(\"sap.uxap.BlockBase\",{metadata:{designTime:!0,library:\"sap.uxap\",properties:{mode:{type:\"string\",group:\"Appearance\"},visible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},columnLayout:{type:\"sap.uxap.BlockBaseColumnLayout\",group:\"Behavior\",defaultValue:\"auto\"},formAdjustment:{type:\"sap.uxap.BlockBaseFormAdjustment\",group:\"Behavior\",defaultValue:sap.uxap.BlockBaseFormAdjustment.BlockColumns},showSubSectionMore:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},defaultAggregation:\"mappings\",aggregations:{mappings:{type:\"sap.uxap.ModelMapping\",multiple:!0,singularName:\"mapping\"},_views:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"view\",visibility:\"hidden\"}},associations:{selectedView:{type:\"sap.ui.core.Control\",multiple:!1}},views:{}},renderer:\"sap.uxap.BlockBaseRenderer\"},o);return u.prototype.init=function(){this.getMetadata().hasViews()||this.getMetadata().setView(\"defaultXML\",{viewName:this.getMetadata().getName(),type:\"XML\"}),this._oMappingApplied={},this._bLazyLoading=!1,this._bConnected=!1,this._oUpdatedModels={}},u.prototype.onBeforeRendering=function(){this._applyMapping(),this.getMode()&&\"\"!==this.getMode()||(this.getMetadata().getView(\"defaultXML\")?this.setMode(\"defaultXML\"):jQuery.sap.log.error(\"BlockBase ::: there is no mode defined for rendering \"+this.getMetadata().getName()+\". You can either set a default mode on the block metadata or set the mode property before rendering the block.\")),this._applyFormAdjustment(),this._bLazyLoading=this._getObjectPageLayout()&&(this._getObjectPageLayout().getEnableLazyLoading()||this._getObjectPageLayout().getUseIconTabBar())},u.prototype.onAfterRendering=function(){this._getObjectPageLayout()&&this._getObjectPageLayout()._requestAdjustLayout()},u.prototype.setParent=function(t,o,i){e.prototype.setParent.call(this,t,o,i),t instanceof r.ObjectPageSubSection&&(this._bLazyLoading=!0,this._oParentObjectPageSubSection=t)},u.prototype.setModel=function(t,o){return this._applyMapping(o),e.prototype.setModel.call(this,t,o)},u.prototype._applyMapping=function(){this._bLazyLoading&&!this._bConnected?jQuery.sap.log.debug(\"BlockBase ::: Ignoring the _applyMapping as the block is not connected\"):this.getMappings().forEach(function(t,o){var i,n,s,r=t.getInternalModelName(),p=t.getExternalPath(),u=t.getExternalModelName();if(p){if(\"\"==r||\"\"==p)throw new Error(\"BlockBase :: incorrect mapping, one of the modelMapping property is empty\");if(i=this.getModel(u),!i)return;s=i.resolve(p,this.getBindingContext(u)),n=this.getBindingContext(r),(!this._isMappingApplied(r)||this.getModel(r)!==this.getModel(u)||n&&n.getPath()!==s)&&(jQuery.sap.log.info(\"BlockBase :: mapping external model \"+u+\" to \"+r),this._oMappingApplied[r]=!0,e.prototype.setModel.call(this,i,r),this.setBindingContext(new a(i,s),r))}},this)},u.prototype._isMappingApplied=function(e){return this.getModel(e)&&this._oMappingApplied[e]},u.prototype.propagateProperties=function(t){return!this._bLazyLoading||this._bConnected||this._oUpdatedModels.hasOwnProperty(t)?this._applyMapping(t):this._oUpdatedModels[t]=!0,e.prototype.propagateProperties.call(this,t)},u.prototype.getSupportedModes=function(){var e=jQuery.extend({},this.getMetadata().getViews());for(var t in e)e[t]=t;return e},u.prototype.setMode=function(e){return e=this._validateMode(e),this.getMode()!==e&&(this.setProperty(\"mode\",e,!1),this._bLazyLoading&&!this._bConnected||this._initView(e)),this},u.prototype.setColumnLayout=function(e){this._oParentObjectPageSubSection&&this._oParentObjectPageSubSection.invalidate(),this.setProperty(\"columnLayout\",e)},u.prototype.clone=function(){var t=-1,o=this.getAssociation(\"selectedView\"),i=this.getAggregation(\"_views\")||[];o&&i.forEach(function(e,i){return e.getId()===o&&(t=i),t<0});var a=e.prototype.clone.call(this);return t>=0&&a.setAssociation(\"selectedView\",a.getAggregation(\"_views\")[t]),a},u.prototype._validateMode=function(e){if(this.validateProperty(\"mode\",e),!this.getMetadata().getView(e)){var t=this.getMetadata()._sClassName||this.getId();if(!this.getMetadata().getView(\"defaultXML\"))throw new Error(\"BlockBase :: no view defined for block \"+t+\" for mode \"+e);jQuery.sap.log.warning(\"BlockBase :: no view defined for block \"+t+\" for mode \"+e+\", loading defaultXML instead\"),e=\"defaultXML\"}return e},u.prototype._getSelectedViewContent=function(){var e,t,o=null;if(e=this.getAssociation(\"selectedView\"),t=this.getAggregation(\"_views\"))for(var i=0;!o&&i<t.length;i++)t[i].getId()===e&&(o=t[i]);return o},u.prototype.createView=function(e,t){var o,i;return i=function(){return sap.ui.xmlview(this.getId()+\"-\"+t,e)}.bind(this),o=p.getOwnerComponentFor(this),o?o.runAsOwner(i):i()},u.prototype._initView=function(e){var t,o=this.getAggregation(\"_views\")||[],i=this.getMetadata().getView(e);return o.forEach(function(o,i){o.data(\"layoutMode\")===e&&(t=o)}),t||(t=this._initNewView(e)),this.setAssociation(\"selectedView\",t,!0),t.getController()&&t.getController().onParentBlockModeChange?t.getController().onParentBlockModeChange(e):jQuery.sap.log.info(\"BlockBase ::: could not notify \"+i.viewName+\" of loading in mode \"+e+\": missing controller onParentBlockModeChange method\"),t},u.prototype._initNewView=function(e){var o=this._getSelectedViewContent(),i=this.getMetadata().getView(e);if(!o||i.viewName!=o.getViewName()){if(o=this.createView(i,e),!o)throw new Error(\"BlockBase :: no view defined in metadata.views for mode \"+e);o.getController()&&(o.getController().oParentBlock=this),o.addCustomData(new t({key:\"layoutMode\",value:e})),this.addAggregation(\"_views\",o,!0)}return o},u.FORM_ADUSTMENT_OFFSET=32,u._FORM_ADJUSTMENT_CONST={breakpoints:{XL:n.media._predefinedRangeSets.StdExt.points[2]-u.FORM_ADUSTMENT_OFFSET,L:n.media._predefinedRangeSets.StdExt.points[1]-u.FORM_ADUSTMENT_OFFSET,M:n.media._predefinedRangeSets.StdExt.points[0]-u.FORM_ADUSTMENT_OFFSET},labelSpan:{XL:12,L:12,M:12,S:12},emptySpan:{XL:0,L:0,M:0,S:0},columns:{XL:1,L:1,M:1}},u._PARENT_GRID_SIZE=12,u.prototype._computeFormAdjustmentFields=function(e,t,o,i){if(e&&t&&o&&i){var a=this._computeFormColumns(t,o,i),n=this._computeFormBreakpoints(t,o);return jQuery.extend({},u._FORM_ADJUSTMENT_CONST,{columns:a},{breakpoints:n})}},u.prototype._computeFormColumns=function(e,t,o){var i=jQuery.extend({},u._FORM_ADJUSTMENT_CONST.columns);if(t===sap.uxap.BlockBaseFormAdjustment.BlockColumns){var a=u._PARENT_GRID_SIZE/o.XL,n=u._PARENT_GRID_SIZE/o.L,s=u._PARENT_GRID_SIZE/o.M;i.XL=e.getSpanXL()/a,i.L=e.getSpanL()/n,i.M=e.getSpanM()/s}return i},u.prototype._computeFormBreakpoints=function(e,t){var o=jQuery.extend({},u._FORM_ADJUSTMENT_CONST.breakpoints);return t===sap.uxap.BlockBaseFormAdjustment.BlockColumns&&(o.XL=Math.round(o.XL*e.getSpanXL()/u._PARENT_GRID_SIZE),o.L=Math.round(o.L*e.getSpanL()/u._PARENT_GRID_SIZE),o.M=Math.round(o.M*e.getSpanM()/u._PARENT_GRID_SIZE)),o},u.prototype._applyFormAdjustment=function(){var e,t=this.getLayoutData(),o=this.getFormAdjustment(),i=this._getSelectedViewContent(),a=this._oParentObjectPageSubSection;if(o&&o!==sap.uxap.BlockBaseFormAdjustment.None&&i&&t&&a){var n=a._oLayoutConfig;i.getContent().forEach(function(a){if(\"sap.ui.layout.form.SimpleForm\"===a.getMetadata().getName())a.setLayout(sap.ui.layout.form.SimpleFormLayout.ResponsiveGridLayout),e||(e=this._computeFormAdjustmentFields(i,t,o,n)),this._applyFormAdjustmentFields(e,a),a.setWidth(\"100%\");else if(\"sap.ui.layout.form.Form\"===a.getMetadata().getName()){var r,p=a.getLayout();p&&\"sap.ui.layout.form.ResponsiveGridLayout\"===p.getMetadata().getName()?r=p:(r=new s,a.setLayout(r)),e||(e=this._computeFormAdjustmentFields(i,t,o,n)),this._applyFormAdjustmentFields(e,r),a.setWidth(\"100%\")}},this)}},u.prototype._applyFormAdjustmentFields=function(e,t){t.setColumnsXL(e.columns.XL),t.setColumnsL(e.columns.L),t.setColumnsM(e.columns.M),t.setLabelSpanXL(e.labelSpan.XL),t.setLabelSpanL(e.labelSpan.L),t.setLabelSpanM(e.labelSpan.M),t.setLabelSpanS(e.labelSpan.S),t.setEmptySpanXL(e.emptySpan.XL),t.setEmptySpanL(e.emptySpan.L),t.setEmptySpanM(e.emptySpan.M),t.setEmptySpanS(e.emptySpan.S),t.setBreakpointXL(e.breakpoints.XL),t.setBreakpointL(e.breakpoints.L),t.setBreakpointM(e.breakpoints.M)},u.prototype._getObjectPageLayout=function(){return r.Utilities.getClosestOPL(this)},u.prototype.setVisible=function(e,t){return this.setProperty(\"visible\",e,t),this._getObjectPageLayout()&&this._getObjectPageLayout()._adjustLayoutAndUxRules(),this},u.prototype.setShowSubSectionMore=function(e,t){return e!=this.getShowSubSectionMore()&&(this.setProperty(\"showSubSectionMore\",e,!0),this._oParentObjectPageSubSection&&this._oParentObjectPageSubSection.refreshSeeMoreVisibility()),this},u.prototype.connectToModels=function(){if(!this._bConnected){if(jQuery.sap.log.debug(\"BlockBase :: Connecting block to the UI5 model tree\"),this._bConnected=!0,this._bLazyLoading){var e=this.getMode();e&&this._initView(e)}this.invalidate()}},u.prototype._allowPropagationToLoadedViews=function(e){this._bConnected&&(this.mSkipPropagation._views=!e)},u.prototype.updateBindingContext=function(t,o,i,a){return!this._bLazyLoading||this._bConnected?e.prototype.updateBindingContext.call(this,t,o,i,a):void jQuery.sap.log.debug(\"BlockBase ::: Ignoring the updateBindingContext as the block is not visible for now in the ObjectPageLayout\")},u.prototype.updateBindings=function(t,o){return!this._bLazyLoading||this._bConnected?e.prototype.updateBindings.call(this,t,o):void jQuery.sap.log.debug(\"BlockBase ::: Ignoring the updateBindingContext as the block is not visible for now in the ObjectPageLayout\")},u});",
		"sap/uxap/BlockBaseMetadata.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/ElementMetadata\"],function(e,t){\"use strict\";var r=function(e,r){t.apply(this,arguments),this._mViews=r.metadata.views||{}};return r.prototype=e.sap.newObject(t.prototype),r.prototype.applySettings=function(e){var r=e.hasOwnProperty(\"renderer\")?e.renderer||\"\":void 0;t.prototype.applySettings.call(this,e),null==r&&(this._sRendererName=null)},r.prototype.getRendererName=function(){return this._sBlockRenderer||(this._sBlockRenderer=this._resolveRendererName(),e.sap.log.debug(\"BlockBaseMetadata :: \"+this.getName()+\" is renderer with \"+this._sBlockRenderer)),this._sBlockRenderer},r.prototype._resolveRendererName=function(){var e=t.prototype.getRendererName.call(this);if(null==e){var n=this.getParent();if(!n)throw new Error(\"BlockBaseMetadata :: no renderer found for \"+this.getName());e=r.prototype._resolveRendererName.apply(n)}return e},r.prototype.getView=function(e){return this._mViews[e]},r.prototype.getViews=function(){return this._mViews},r.prototype.setView=function(e,t){return this._mViews[e]=t,this},r.prototype.hasViews=function(){return!e.isEmptyObject(this._mViews)},r},!0);",
		"sap/uxap/BlockBaseRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e={};return e.render=function(e,t){if(t.getVisible()){if(e.write(\"<div\"),e.writeControlData(t),t._getSelectedViewContent())e.addClass(\"sapUxAPBlockBase\"),e.addClass(\"sapUxAPBlockBase\"+t.getMode());else{var a=t.getMetadata().getName().split(\".\").pop();e.addClass(\"sapUxAPBlockBaseDefaultSize\"),e.addClass(\"sapUxAPBlockBaseDefaultSize\"+a+t.getMode())}e.writeClasses(),e.write(\">\"),t._getSelectedViewContent()&&e.renderControl(t._getSelectedViewContent()),e.write(\"</div>\")}},e},!0);",
		"sap/uxap/BreadCrumbs.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/Link\",\"sap/m/Select\",\"sap/m/Text\",\"sap/ui/core/Control\",\"sap/ui/core/ResizeHandler\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/core/Item\",\"sap/ui/core/Icon\",\"sap/ui/Device\",\"./library\"],function(e,t,i,s,r,o,n,a,l,h){\"use strict\";var u=s.extend(\"sap.uxap.BreadCrumbs\",{metadata:{library:\"sap.uxap\",properties:{showCurrentLocation:{type:\"boolean\",group:\"Behavior\",defaultValue:!0}},defaultAggregation:\"links\",aggregations:{links:{type:\"sap.m.Link\",multiple:!0,singularName:\"link\"},currentLocation:{type:\"sap.m.Text\",multiple:!1},_tubeIcon:{type:\"sap.ui.core.Icon\",multiple:!1,visibility:\"hidden\"},_overflowSelect:{type:\"sap.m.Select\",multiple:!1,visibility:\"hidden\"}}}});return u.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5,u.prototype.init=function(){this._iREMSize=parseInt(jQuery(\"body\").css(\"font-size\"),10),this._iContainerMaxHeight=2*this._iREMSize},u.prototype.onBeforeRendering=function(){this._bOnPhone=l.system.phone,this._resetControl()},u.prototype.onAfterRendering=function(){this._handleInitialModeSelection()},u.prototype._handleInitialModeSelection=function(){return this._bOnPhone?(this._setSelectVisible(!0),this):(this._configureKeyboardHandling(),this._iContainerHeight||(this._iContainerHeight=this.$().outerHeight()),this._iContainerHeight>this._iContainerMaxHeight?(this._toggleOverflowMode(!0),this):(this._sResizeListenerId=r.register(this,this._handleScreenResize.bind(this)),this))},u.prototype._toggleOverflowMode=function(e){return this._sResizeListenerId&&r.deregister(this._sResizeListenerId),this._setSelectVisible(e),this._setBreadcrumbsVisible(!e),this._sResizeListenerId=r.register(this,this._handleScreenResize.bind(this)),this},u.prototype._getTubeIcon=function(){return this.getAggregation(\"_tubeIcon\")||this.setAggregation(\"_tubeIcon\",new a({src:\"sap-icon://slim-arrow-right\",color:\"#bfbfbf\",size:\"1rem\",useIconTooltip:!1}).addStyleClass(\"sapUxAPTubeIcon\")),this.getAggregation(\"_tubeIcon\")},u.prototype._getOverflowSelect=function(){var e,i;return this.getAggregation(\"_overflowSelect\")||(i=this.getLinks().reverse()||[],i.unshift(this.getCurrentLocation()),e=new t({items:i.map(this._createSelectItem),autoAdjustWidth:!0}),e.attachChange(this._overflowSelectChangeHandler),this.setAggregation(\"_overflowSelect\",e)),this.getAggregation(\"_overflowSelect\")},u.prototype._createSelectItem=function(e){return new n({key:e.getId(),text:e.getText()})},u.prototype._overflowSelectChangeHandler=function(t){var i,s,r=t.getParameter(\"selectedItem\").getKey(),o=sap.ui.getCore().byId(r);return o instanceof e&&(i=o.getHref(),o.firePress(),i&&(s=o.getTarget(),s?window.open(i,s):window.location.href=i)),this},u.prototype._handleScreenResize=function(e){var t=this._shouldOverflow(),i=this._getUsingOverflowSelect();return t&&!i?this._toggleOverflowMode(!0):!t&&i&&this._toggleOverflowMode(!1),this},u.prototype._shouldOverflow=function(){var e,t=this._getBreadcrumbsAsJQueryObject(),i=this._getUsingOverflowSelect();return i&&this._setBreadcrumbsVisible(!0),t.addClass(\"sapUxAPInvisible\"),e=t.outerHeight()>this._iContainerMaxHeight,t.removeClass(\"sapUxAPInvisible\"),i&&this._setBreadcrumbsVisible(!1),e},u.prototype._getBreadcrumbsAsJQueryObject=function(){return this._$breadcrumbs||(this._$breadcurmbs=this.$(\"breadcrumbs\")),this._$breadcurmbs},u.prototype._getOverflowSelectAsJQueryObject=function(){return this._$select||(this._$select=this.$(\"select\")),this._$select},u.prototype._setBreadcrumbsVisible=function(e){var t=this.$(),i=this._getBreadcrumbsAsJQueryObject(),s=\"sapUxAPFullWidth\",r=\"sapUiHidden\";return e?(i.removeClass(r),t.removeClass(s)):(i.addClass(r),t.addClass(s)),t},u.prototype._setSelectVisible=function(e){var t=this._getOverflowSelectAsJQueryObject(),i=\"sapUiHidden\";return e?t.removeClass(i):t.addClass(i),this},u.prototype._resetControl=function(){return this._iContainerHeight=null,this._$select=null,this._$breadcrumbs=null,this.setAggregation(\"_overflowSelect\",null,!0),this._sResizeListenerId&&r.deregister(this._sResizeListenerId),this},u.prototype._getAriaLabelledBy=function(){return this._oAriaLabelledBy||(u.prototype._oAriaLabelledBy=new sap.ui.core.InvisibleText({text:h.i18nModel.getResourceBundle().getText(\"BREADCRUMB_TRAIL_LABEL\")}).toStatic()),this._oAriaLabelledBy},u.prototype._getItemNavigation=function(){return this._ItemNavigation||(this._ItemNavigation=new o),this._ItemNavigation},u.prototype._getItemsToNavigate=function(){var e=this.getLinks(),t=this.getCurrentLocation(),i=this.getShowCurrentLocation();return i&&t&&e.push(t),e},u.prototype._configureKeyboardHandling=function(){var e=this._getItemNavigation(),t=this._getBreadcrumbsAsJQueryObject()[0],i=-1,s=this._getItemsToNavigate(),r=[];return s.forEach(function(e){e.$().attr(\"tabIndex\",\"-1\"),r.push(e.getDomRef())}),this.addDelegate(e),e.setCycling(!1),e.setRootDomRef(t),e.setItemDomRefs(r),e.setSelectedIndex(i),this._getBreadcrumbsAsJQueryObject().attr(\"tabindex\",\"-1\"),s[0].$().attr(\"tabindex\",\"0\"),this},u.prototype.onsappageup=function(e){this._handlePageKeys(e,!1)},u.prototype.onsappagedown=function(e){this._handlePageKeys(e,!0)},u.prototype._handlePageKeys=function(e,t){var i,s=this._getItemsToNavigate(),r=0,o=t?s.length-1:0;e.preventDefault(),s.some(function(t,i){if(t.getId()===e.target.id)return r=i,!0}),i=t?r+u.PAGEUP_AND_PAGEDOWN_JUMP_SIZE:r-u.PAGEUP_AND_PAGEDOWN_JUMP_SIZE,i&&s[i]?s[i].focus():s[o]&&s[o].focus()},u.prototype._getUsingOverflowSelect=function(){return!this._getOverflowSelectAsJQueryObject().hasClass(\"sapUiHidden\")},u.prototype.exit=function(){this._ItemNavigation&&(this.removeDelegate(this._ItemNavigation),this._ItemNavigation.destroy(),this._ItemNavigation=null),this._resetControl()},u});",
		"sap/uxap/BreadCrumbsRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e={};return e.render=function(e,r){e.write(\"<div\"),e.writeControlData(r),e.addClass(\"sapUxAPBreadCrumbs\"),e.writeClasses(),e.writeAttribute(\"role\",\"navigation\"),e.writeAttributeEscaped(\"aria-labelledby\",r._getAriaLabelledBy().getId()),e.write(\">\"),this._renderOverflowSelect(e,r),r._bOnPhone||this._renderBreadcrumbTrail(e,r),e.write(\"</div>\")},e._renderBreadcrumbTrail=function(e,r){var t=r.getLinks(),i=r.getCurrentLocation(),n=r._getTubeIcon(),a=r.getShowCurrentLocation();e.write(\"<ul id='\"+r.getId()+\"-breadcrumbs'\"),e.write(\">\"),t.forEach(function(r){e.write(\"<li>\"),e.renderControl(r),e.renderControl(n),e.write(\"</li>\")}),a&&(e.write(\"<li>\"),e.renderControl(i),e.write(\"</li>\")),e.write(\"</ul>\")},e._renderOverflowSelect=function(e,r){var t=r._getTubeIcon();e.write(\"<div id='\"+r.getId()+\"-select'\"),e.addClass(\"sapUiHidden\"),e.writeClasses(),e.write(\">\"),e.write('<span class=\"sapUxAPBreadCrumbsDots\">...</span>'),e.renderControl(t),e.renderControl(r._getOverflowSelect()),e.write(\"</div>\")},e},!0);",
		"sap/uxap/component/Component.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/uxap/ObjectPageConfigurationMode\",\"sap/ui/core/UIComponent\",\"sap/ui/model/json/JSONModel\",\"sap/ui/core/Component\"],function(o,e,t){\"use strict\";var n=e.extend(\"sap.uxap.component.Component\",{metadata:{},init:function(){switch(this._oModel=null,this._oViewConfig={viewData:{component:this}},this.oComponentData.mode){case o.JsonURL:this._oModel=new e(this.oComponentData.jsonConfigurationURL),this._oViewConfig.viewName=\"sap.uxap.component.ObjectPageLayoutUXDrivenFactory\",this._oViewConfig.type=sap.ui.core.mvc.ViewType.XML;break;case o.JsonModel:this._oViewConfig.viewName=\"sap.uxap.component.ObjectPageLayoutUXDrivenFactory\",this._oViewConfig.type=sap.ui.core.mvc.ViewType.XML;break;default:jQuery.sap.log.error(\"UxAPComponent :: missing bootstrap information. Expecting one of the following: JsonURL, JsonModel and FacetsAnnotation\")}e.prototype.init.call(this)},createContent:function(){var o;return this._oView=sap.ui.view(this._oViewConfig),this._oModel&&(o=this._oView.getController(),o&&o.connectToComponent&&o.connectToComponent(this._oModel),this._oView.setModel(this._oModel,\"objectPageLayoutMetadata\")),this._oView},propagateProperties:function(t){if(this.oComponentData.mode===o.JsonModel){var n=this._oView.getController();n&&n.connectToComponent&&n.connectToComponent(this.getModel(\"objectPageLayoutMetadata\"))}return e.prototype.propagateProperties.apply(this,arguments)},destroy:function(){this._oView&&(this._oView.destroy(),this._oView=null),this._oModel&&(this._oModel.destroy(),this._oModel=null),e.prototype.destroy&&e.prototype.destroy.call(this)}});return n});",
		"sap/uxap/component/ObjectPageComponentContainer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/ComponentContainer\",\"sap/uxap/ObjectPageConfigurationMode\",\"sap/ui/core/Component\"],function(e,o){\"use strict\";var n=e.extend(\"sap.uxap.component.ObjectPageComponentContainer\",{metadata:{properties:{jsonConfigurationURL:{type:\"string\",group:\"Behavior\"},mode:{type:\"sap.uxap.ObjectPageConfigurationMode\",group:\"Behavior\"}}},init:function(){this.setPropagateModel(!0),this.setName(\"sap.uxap.component\")},onBeforeRendering:function(){this._oComponent=sap.ui.component(\"sap.uxap\"),this._oComponent||(this._oComponent=sap.ui.component({name:this.getName(),url:this.getUrl(),componentData:{jsonConfigurationURL:this.getJsonConfigurationURL(),mode:this.getMode()}}),this.setComponent(this._oComponent,!0)),e.prototype.onBeforeRendering&&e.prototype.onBeforeRendering.call(this)},getObjectPageLayoutInstance:function(){var e=null;return this._oComponent&&this._oComponent._oView?e=this._oComponent._oView.byId(\"ObjectPageLayout\"):jQuery.sap.log.error(\"ObjectPageComponentContainer :: cannot find children ObjectPageLayout, has it been rendered already?\"),e},renderer:\"sap.ui.core.ComponentContainerRenderer\"});return n});",
		"sap/uxap/component/ObjectPageLayoutUXDrivenFactory.controller.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/layout/GridData\",\"sap/ui/model/BindingMode\",\"sap/uxap/BlockBase\",\"sap/uxap/ModelMapping\",\"sap/ui/model/Context\",\"sap/ui/base/ManagedObject\",\"sap/ui/core/mvc/Controller\"],function(e,t,r,a,o,n,i){\"use strict\";return i.extend(\"sap.uxap.component.ObjectPageLayoutUXDrivenFactory\",{connectToComponent:function(e){var r=jQuery.isEmptyObject(e.getData());e.setDefaultBindingMode(t.OneWay);var a=jQuery.proxy(function(){r&&e.detachRequestCompleted(a);var t=new o(e,\"/headerTitle\"),n=this.getView().byId(\"ObjectPageLayout\");if(t.getProperty(\"\"))try{this._oHeader=this.controlFactory(n.getId(),t),n.setHeaderTitle(this._oHeader)}catch(e){jQuery.sap.log.error(\"ObjectPageLayoutFactory :: error in header creation from config: \"+e)}},this);r?e.attachRequestCompleted(a):a()},controlFactory:function(e,t){var r,a,o,i=t.getProperty(\"\");try{jQuery.sap.require(i.Type),a=jQuery.sap.getObject(i.Type),o=a.getMetadata(),jQuery.each(o._mAllEvents,jQuery.proxy(function(e,t){\"string\"==typeof i[e]&&(i[e]=this.convertEventHandler(i[e]))},this)),r=n.create(i),jQuery.each(o._mAllProperties,jQuery.proxy(function(e,a){i[e]&&r.bindProperty(e,\"objectPageLayoutMetadata>\"+t.getPath()+\"/\"+e)},this))}catch(e){jQuery.sap.log.error(\"ObjectPageLayoutFactory :: error in control creation from config: \"+e)}return r},convertEventHandler:function(e){var t=window,r=e.split(\".\");try{jQuery.each(r,function(e,r){t=t[r]})}catch(r){jQuery.sap.log.error(\"ObjectPageLayoutFactory :: undefined event handler: \"+e+\". Did you forget to require its static class?\"),t=void 0}return t}})},!0);",
		"sap/uxap/flexibility/ObjectPageHeader.flexibility.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/changeHandler/CombineButtons\",\"sap/m/changeHandler/SplitMenuButton\"],function(n,e){\"use strict\";return{combineButtons:{changeHandler:n,layers:{CUSTOMER:!1}},moveControls:\"default\",splitMenuButton:{changeHandler:e,layers:{CUSTOMER:!1}}}},!0);",
		"sap/uxap/flexibility/ObjectPageSubSection.flexibility.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/changeHandler/CombineButtons\",\"sap/m/changeHandler/SplitMenuButton\"],function(n,e){\"use strict\";return{combineButtons:{changeHandler:n,layers:{CUSTOMER:!1}},moveControls:\"default\",splitMenuButton:{changeHandler:e,layers:{CUSTOMER:!1}}}},!0);",
		"sap/uxap/HierarchicalSelect.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/Select\",\"sap/ui/Device\",\"./library\"],function(e,t,o,r){\"use strict\";var a=t.extend(\"sap.uxap.HierarchicalSelect\",{metadata:{library:\"sap.uxap\",properties:{upperCase:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}}}});return a.POPOVER_MIN_WIDTH_REM=11,a.prototype.onAfterRendering=function(){t.prototype.onAfterRendering.apply(this,arguments),this.$().attr(\"tabindex\",\"-1\")},a.prototype.onAfterRenderingPicker=function(){t.prototype.onAfterRenderingPicker.call(this);var e=this.getItems()||[];e.forEach(function(e){var t=e.data(\"secondLevel\")===!0?\"sapUxAPHierarchicalSelectSecondLevel\":\"sapUxAPHierarchicalSelectFirstLevel\";e.$().addClass(t)},this)},a.prototype.setUpperCase=function(e,t){this.setProperty(\"upperCase\",e,t),this.toggleStyleClass(\"sapUxAPHierarchicalSelectUpperCase\",e);var o=this.getAggregation(\"picker\");return o&&(o.toggleStyleClass(\"sapMSltPickerFirstLevelUpperCase\",e),t||o.invalidate()),this},a.prototype.onsapenter=t.prototype.onsapspace,[\"onsapup\",\"onsappageup\",\"onsappagedown\",\"onsaphome\",\"onsapend\"].forEach(function(e){a.prototype[e]=function(o){t.prototype[e].call(this,o),o.stopPropagation()}}),a.prototype._createDialog=function(){var e=t.prototype._createDialog.call(this),o=e.getCustomHeader();return o&&o.addStyleClass(\"sapUxAPHierarchicalSelect\"),e},a.prototype._decoratePopover=function(r){if(t.prototype._decoratePopover.call(this,r),r._adaptPositionParams=function(){this._marginTop=0,this._marginLeft=0,this._marginRight=0,this._marginBottom=0,this._arrowOffset=0,this._offsets=[\"0 0\",\"0 0\",\"0 0\",\"0 0\"],this._myPositions=[\"end bottom\",\"end center\",\"end top\",\"begin center\"],this._atPositions=[\"end top\",\"end center\",\"end bottom\",\"begin center\"]},o.system.tablet||o.system.desktop){var a=e.position.scrollbarWidth();a>0&&r.setOffsetX(a)}},a.prototype._onAfterRenderingPopover=function(){var t=this.getPicker(),o=t.getDomRef(\"cont\"),r=o.style.minWidth;if(e.sap.endsWith(r,\"rem\")){r=r.substring(0,r.length-3);var i=parseFloat(r);i<a.POPOVER_MIN_WIDTH_REM&&o&&(o.style.minWidth=a.POPOVER_MIN_WIDTH_REM+\"rem\")}},a});",
		"sap/uxap/HierarchicalSelectRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/SelectRenderer\",\"sap/ui/core/Renderer\"],function(e,a){\"use strict\";var r=a.extend(e);return r.addClass=function(e){e.addClass(\"sapUxAPHierarchicalSelect\")},r},!0);",
		"sap/uxap/LazyLoading.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/Device\",\"sap/ui/base/Metadata\",\"./ObjectPageSubSection\",\"./library\"],function(i,e,t,o,s){\"use strict\";var a=t.createClass(\"sap.uxap._helpers.LazyLoading\",{constructor:function(e){this._oObjectPageLayout=e,this._$html=i(\"html\"),this._iPreviousScrollTop=0,this._iScrollProgress=0,this._iPreviousScrollTimestamp=0,this._sLazyLoadingTimer=null,this._oPrevSubSectionsInView={},this.setLazyLoadingParameters()}});return a.prototype.setLazyLoadingParameters=function(){this.LAZY_LOADING_DELAY=200,this.LAZY_LOADING_EXTRA_PAGE_SIZE=.5,this._isPhone()?this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={FirstRendering:1,ScrollToSection:1}:this._isTablet()?this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={FirstRendering:2,ScrollToSection:1}:this._isTabletSize()?this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={FirstRendering:2,ScrollToSection:2}:this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD={FirstRendering:3,ScrollToSection:3},this.LAZY_LOADING_FAST_SCROLLING_THRESHOLD=5},a.prototype._triggerVisibleSubSectionsEvents=function(){this._oPrevSubSectionsInView={},this.doLazyLoading()},a.prototype.lazyLoadDuringScroll=function(e,t,o){var s,a,n=!1;this._iScrollProgress=e-this._iPreviousScrollTop,s=Math.round(Math.abs(this._iScrollProgress)/o*100),s>=this.LAZY_LOADING_FAST_SCROLLING_THRESHOLD&&(n=!0),this._iPreviousScrollTop=e,this._iPreviousScrollTimestamp=t||0,a=0===e?0:this.LAZY_LOADING_DELAY,n&&this._sLazyLoadingTimer&&(i.sap.log.debug(\"ObjectPageLayout :: lazyLoading\",\"delayed by \"+a+\" ms because of fast scroll\"),i.sap.clearDelayedCall(this._sLazyLoadingTimer),this._sLazyLoadingTimer=null),this._sLazyLoadingTimer||(this._sLazyLoadingTimer=i.sap.delayedCall(a,this,this.doLazyLoading))},a.prototype.doLazyLoading=function(){var e,t,o,s,a,n,r,l=this._oObjectPageLayout._getHeightRelatedParameters(),_=this._oObjectPageLayout._oSectionInfo,c=this._iPreviousScrollTop>=l.iHeaderContentHeight,h=-1,L={},g={};o=l.iScreenHeight-(c?l.iAnchorBarHeight:0)-(c?l.iHeaderTitleHeightStickied:0),e=l.iScrollTop,a=Date.now()-this._iPreviousScrollTimestamp,n=a<this.LAZY_LOADING_DELAY/2&&Math.abs(this._iScrollProgress)>5,n&&(r=this._iScrollProgress>=0?Math.round(Math.min(20*this._iScrollProgress,o/2)):-1*Math.round(Math.min(20*Math.abs(this._iScrollProgress),o/2)),e+=r,i.sap.log.debug(\"ObjectPageLayout :: lazyLoading\",\"Visible page shifted from : \"+r)),t=e+o,e+=16,i.each(_,i.proxy(function(i,a){!a.isSection&&a.sectionReference.getParent()&&a.sectionReference.getParent().getVisible()&&(a.positionTop<=t&&e<a.positionBottom-1?(g[i]=i,a.loaded||(L[i]=i)):!a.loaded&&a.positionTop>t&&a.positionTop<t+o*this.LAZY_LOADING_EXTRA_PAGE_SIZE&&(h==-1||a.positionTop<h)&&(h=a.positionTop,s=i))},this)),h!=-1&&i.isEmptyObject(L)&&(i.sap.log.debug(\"ObjectPageLayout :: lazyLoading\",\"extra section added : \"+s),L[s]=s),i.each(L,i.proxy(function(e,t){i.sap.log.debug(\"ObjectPageLayout :: lazyLoading\",\"connecting \"+t),sap.ui.getCore().byId(t).connectToModels(),_[t].loaded=!0},this)),i.each(g,i.proxy(function(e,t){this._oPrevSubSectionsInView[e]||(i.sap.log.debug(\"ObjectPageLayout :: lazyLoading\",\"subSectionEnteredViewPort \"+t),this._oObjectPageLayout.fireEvent(\"subSectionEnteredViewPort\",{subSection:sap.ui.getCore().byId(t)}))},this)),this._oPrevSubSectionsInView=g,n?this._sLazyLoadingTimer=i.sap.delayedCall(this.LAZY_LOADING_DELAY,this,this.doLazyLoading):h?this._sLazyLoadingTimer=i.sap.delayedCall(5*this.LAZY_LOADING_DELAY,this,this.doLazyLoading):this._sLazyLoadingTimer=null},a.prototype.getSubsectionsToPreload=function(i,e){var t,s;e?(t=this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD.ScrollToSection,s=!1):(t=this.NUMBER_OF_SUBSECTIONS_TO_PRELOAD.FirstRendering,s=!0);var a=[];return i.some(function(i){return!s&&e&&(s=i.getId()==e),s&&i instanceof o&&i.getVisible()&&i._getInternalVisible()&&(a.push(i),t--),t<=0}),a},a.prototype._isPhone=function(){return s.Utilities.isPhoneScenario(this._oObjectPageLayout._getCurrentMediaContainerRange())},a.prototype._isTablet=function(){return e.system.tablet},a.prototype._isTabletSize=function(){return s.Utilities.isTabletScenario(this._oObjectPageLayout._getCurrentMediaContainerRange())},a},!1);",
		"sap/uxap/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Core\",\"sap/ui/core/library\",\"sap/m/library\",\"sap/ui/layout/library\"],function(e,a,t){\"use strict\";return sap.ui.getCore().initLibrary({name:\"sap.uxap\",dependencies:[\"sap.ui.core\",\"sap.m\",\"sap.ui.layout\"],types:[\"sap.uxap.BlockBaseColumnLayout\",\"sap.uxap.ObjectPageConfigurationMode\",\"sap.uxap.ObjectPageHeaderDesign\",\"sap.uxap.ObjectPageHeaderPictureShape\",\"sap.uxap.ObjectPageSubSectionLayout\",\"sap.uxap.ObjectPageSubSectionMode\"],interfaces:[],controls:[\"sap.uxap.AnchorBar\",\"sap.uxap.BlockBase\",\"sap.uxap.BreadCrumbs\",\"sap.uxap.HierarchicalSelect\",\"sap.uxap.ObjectPageHeader\",\"sap.uxap.ObjectPageHeaderActionButton\",\"sap.uxap.ObjectPageHeaderContent\",\"sap.uxap.ObjectPageLayout\",\"sap.uxap.ObjectPageSection\",\"sap.uxap.ObjectPageSectionBase\",\"sap.uxap.ObjectPageSubSection\"],elements:[\"sap.uxap.ModelMapping\",\"sap.uxap.ObjectPageHeaderLayoutData\"],version:\"800001.6.0.20241202143000_f0htmcm80p\",extensions:{flChangeHandlers:{\"sap.uxap.ObjectPageHeader\":\"sap/uxap/flexibility/ObjectPageHeader\",\"sap.uxap.ObjectPageLayout\":{moveControls:{changeHandler:\"default\",layers:{USER:!0}}},\"sap.uxap.ObjectPageSection\":{hideControl:{changeHandler:\"default\",layers:{USER:!0}},unhideControl:{changeHandler:\"default\",layers:{USER:!0}},stashControl:{changeHandler:\"default\",layers:{USER:!0}},unstashControl:{changeHandler:\"default\",layers:{USER:!0}}},\"sap.uxap.ObjectPageSubSection\":\"sap/uxap/flexibility/ObjectPageSubSection\",\"sap.ui.core._StashedControl\":{unstashControl:{changeHandler:\"default\",layers:{USER:!0}}}}}}),sap.uxap.BlockBaseColumnLayout=sap.ui.base.DataType.createType(\"sap.uxap.BlockBaseColumnLayout\",{isValid:function(e){return/^(auto|[1-4]{1})$/.test(e)}},sap.ui.base.DataType.getType(\"string\")),sap.uxap.BlockBaseFormAdjustment={BlockColumns:\"BlockColumns\",OneColumn:\"OneColumn\",None:\"None\"},sap.uxap.ObjectPageConfigurationMode={JsonURL:\"JsonURL\",JsonModel:\"JsonModel\"},sap.uxap.ObjectPageHeaderDesign={Light:\"Light\",Dark:\"Dark\"},sap.uxap.ObjectPageHeaderPictureShape={Circle:\"Circle\",Square:\"Square\"},sap.uxap.ObjectPageSubSectionLayout={TitleOnTop:\"TitleOnTop\",TitleOnLeft:\"TitleOnLeft\"},sap.uxap.ObjectPageSubSectionMode={Collapsed:\"Collapsed\",Expanded:\"Expanded\"},sap.uxap.Importance={Low:\"Low\",Medium:\"Medium\",High:\"High\"},sap.uxap.i18nModel=function(){return new sap.ui.model.resource.ResourceModel({bundleUrl:e.sap.getModulePath(\"sap.uxap.i18n.i18n\",\".properties\")})}(),sap.uxap.Utilities={getClosestOPL:function(e){for(;e&&!(e instanceof sap.uxap.ObjectPageLayout);)e=e.getParent();return e},isPhoneScenario:function(e){return!!sap.ui.Device.system.phone||sap.uxap.Utilities._isCurrentMediaSize(\"Phone\",e)},isTabletScenario:function(e){return sap.uxap.Utilities._isCurrentMediaSize(\"Tablet\",e)},_isCurrentMediaSize:function(e,a){return a&&a.name===e}},sap.uxap},!0);",
		"sap/uxap/ModelMapping.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/Element\",\"./library\"],function(e,a){\"use strict\";var t=e.extend(\"sap.uxap.ModelMapping\",{metadata:{library:\"sap.uxap\",properties:{externalModelName:{type:\"string\",group:\"Misc\",defaultValue:null},internalModelName:{type:\"string\",group:\"Misc\",defaultValue:\"Model\"},externalPath:{type:\"string\",group:\"Misc\",defaultValue:null}}}});return t});",
		"sap/uxap/ObjectImageHelper.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Icon\",\"sap/ui/core/IconPool\",\"sap/m/Image\"],function(e,a,t,r){\"use strict\";var s=function(){};return s.createObjectImage=function(e){var t,s=e.getObjectImageURI();return 0===s.indexOf(\"sap-icon://\")?(t=new a,t.addStyleClass(\"sapUxAPObjectPageHeaderObjectImageIcon\")):(t=new r({densityAware:e.getObjectImageDensityAware(),alt:e.getObjectImageAlt(),decorative:!1}),t.addStyleClass(\"sapUxAPObjectPageHeaderObjectImage\")),t.setSrc(s),e.getObjectImageAlt()&&t.setTooltip(e.getObjectImageAlt()),t},s.createPlaceholder=function(){return t.createControlByURI({src:t.getIconURI(\"picture\"),visible:!0})},s._renderImageAndPlaceholder=function(e,t){var r=t.oHeader,c=t.oObjectImage,d=t.oPlaceholder,l=t.bIsObjectIconAlwaysVisible,n=t.bAddSubContainer,o=t.sBaseClass,i=!(r.getObjectImageShape()||r.getShowPlaceholder()),g=c instanceof a;(r.getObjectImageURI()||r.getShowPlaceholder())&&(e.write(\"<span \"),e.addClass(o),e.addClass(\"sapUxAPObjectPageHeaderObjectImage-\"+r.getObjectImageShape()),l&&e.addClass(\"sapUxAPObjectPageHeaderObjectImageForce\"),e.writeClasses(),e.write(\">\"),n&&e.write(\"<span class='sapUxAPObjectPageHeaderObjectImageContainerSub'>\"),g&&(e.write(\"<div\"),e.addClass(\"sapUxAPObjectPageHeaderObjectImage\"),e.addClass(\"sapUxAPObjectPageHeaderPlaceholder\"),e.writeClasses(),e.write(\">\")),e.renderControl(c),s._renderPlaceholder(e,d,i),g&&e.write(\"</div>\"),n&&e.write(\"</span>\"),e.write(\"</span>\"))},s._renderPlaceholder=function(e,a,t){e.write(\"<div\"),e.addClass(\"sapUxAPObjectPageHeaderPlaceholder\"),e.addClass(\"sapUxAPObjectPageHeaderObjectImage\"),t||e.addClass(\"sapUxAPHidePlaceholder\"),e.writeClasses(),e.write(\">\"),e.renderControl(a),e.write(\"</div>\")},s},!1);",
		"sap/uxap/ObjectPageHeader.designtime.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{aggregations:{actions:{domRef:\":sap-domref .sapUxAPObjectPageHeaderIdentifierActions\",actions:{move:{changeType:\"moveControls\"}}}}}},!1);",
		"sap/uxap/ObjectPageHeader.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/Control\",\"sap/ui/core/IconPool\",\"sap/ui/core/CustomData\",\"sap/ui/core/Icon\",\"sap/ui/Device\",\"sap/m/Breadcrumbs\",\"./ObjectPageHeaderActionButton\",\"sap/ui/core/ResizeHandler\",\"sap/m/Text\",\"sap/m/Button\",\"sap/m/ActionSheet\",\"sap/m/Image\",\"./ObjectImageHelper\",\"./library\"],function(t,e,i,o,n,a,r,s,l,c,h,u,p,g){\"use strict\";var d=t.extend(\"sap.uxap.ObjectPageHeader\",{metadata:{library:\"sap.uxap\",properties:{objectImageURI:{type:\"string\",defaultValue:null},objectImageAlt:{type:\"string\",defaultValue:\"\"},objectImageDensityAware:{type:\"boolean\",defaultValue:!1},objectTitle:{type:\"string\",defaultValue:null},objectSubtitle:{type:\"string\",defaultValue:null},objectImageShape:{type:\"sap.uxap.ObjectPageHeaderPictureShape\",defaultValue:sap.uxap.ObjectPageHeaderPictureShape.Square},isObjectIconAlwaysVisible:{type:\"boolean\",defaultValue:!1},isObjectTitleAlwaysVisible:{type:\"boolean\",defaultValue:!0},isObjectSubtitleAlwaysVisible:{type:\"boolean\",defaultValue:!0},isActionAreaAlwaysVisible:{type:\"boolean\",defaultValue:!0},headerDesign:{type:\"sap.uxap.ObjectPageHeaderDesign\",defaultValue:sap.uxap.ObjectPageHeaderDesign.Light},showTitleSelector:{type:\"boolean\",group:\"Misc\",defaultValue:!1},markFavorite:{type:\"boolean\",group:\"Misc\",defaultValue:!1},markFlagged:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showMarkers:{type:\"boolean\",group:\"Misc\",defaultValue:!1},markLocked:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showPlaceholder:{type:\"boolean\",group:\"Misc\",defaultValue:!1},markChanges:{type:\"boolean\",group:\"Misc\",defaultValue:!1}},defaultAggregation:\"actions\",aggregations:{_breadCrumbs:{type:\"sap.m.Breadcrumbs\",multiple:!1,visibility:\"hidden\"},breadCrumbsLinks:{type:\"sap.m.Link\",multiple:!0,singularName:\"breadCrumbLink\"},_overflowButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_expandButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_objectImage:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"},_placeholder:{type:\"sap.ui.core.Icon\",multiple:!1,visibility:\"hidden\"},_lockIconCont:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_lockIcon:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_titleArrowIconCont:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_titleArrowIcon:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_favIcon:{type:\"sap.ui.core.Icon\",multiple:!1,visibility:\"hidden\"},_flagIcon:{type:\"sap.ui.core.Icon\",multiple:!1,visibility:\"hidden\"},_overflowActionSheet:{type:\"sap.m.ActionSheet\",multiple:!1,visibility:\"hidden\"},_changesIconCont:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_changesIcon:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_sideContentBtn:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},navigationBar:{type:\"sap.m.Bar\",multiple:!1},actions:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"action\"},sideContentButton:{type:\"sap.m.Button\",multiple:!1}},events:{titleSelectorPress:{parameters:{domRef:{type:\"string\"}}},markLockedPress:{parameters:{domRef:{type:\"string\"}}},markChangesPress:{parameters:{domRef:{type:\"string\"}}}},designTime:!0}});d.prototype._iAvailablePercentageForActions=.3,d.prototype.init=function(){this._bFirstRendering=!0,this.oLibraryResourceBundle||(this.oLibraryResourceBundle=sap.ui.getCore().getLibraryResourceBundle(\"sap.m\")),this.oLibraryResourceBundleOP||(this.oLibraryResourceBundleOP=g.i18nModel.getResourceBundle()),this._oOverflowActionSheet=this._lazyLoadInternalAggregation(\"_overflowActionSheet\",!0),this._oOverflowButton=this._lazyLoadInternalAggregation(\"_overflowButton\",!0).attachPress(this._handleOverflowButtonPress,this),this._oExpandButton=this._lazyLoadInternalAggregation(\"_expandButton\",!0),this._oActionSheetButtonMap={},this._oFlagIcon=this._lazyLoadInternalAggregation(\"_flagIcon\",!0),this._oFavIcon=this._lazyLoadInternalAggregation(\"_favIcon\",!0),this._oTitleArrowIcon=this._lazyLoadInternalAggregation(\"_titleArrowIcon\",!0).attachPress(this._handleArrowPress,this),this._oTitleArrowIconCont=this._lazyLoadInternalAggregation(\"_titleArrowIconCont\",!0).attachPress(this._handleArrowPress,this),this._oLockIcon=this._lazyLoadInternalAggregation(\"_lockIcon\",!0).attachPress(this._handleLockPress,this),this._oLockIconCont=this._lazyLoadInternalAggregation(\"_lockIconCont\",!0).attachPress(this._handleLockPress,this),this._oChangesIcon=this._lazyLoadInternalAggregation(\"_changesIcon\",!0).attachPress(this._handleChangesPress,this),this._oChangesIconCont=this._lazyLoadInternalAggregation(\"_changesIconCont\",!0).attachPress(this._handleChangesPress,this)},d.prototype._handleOverflowButtonPress=function(t){this._oOverflowActionSheet.openBy(this._oOverflowButton)},d.prototype._handleArrowPress=function(t){this.fireTitleSelectorPress({domRef:t.getSource().getDomRef()})},d.prototype._handleLockPress=function(t){this.fireMarkLockedPress({domRef:t.getSource().getDomRef()})},d.prototype._handleChangesPress=function(t){this.fireMarkChangesPress({domRef:t.getSource().getDomRef()})},d._internalAggregationFactory={_objectImage:p.createObjectImage,_placeholder:p.createPlaceholder,_overflowActionSheet:function(){return new h({placement:sap.m.PlacementType.Bottom})},_lockIconCont:function(t){return this._getButton(t,\"sap-icon://private\",\"lock-cont\")},_breadCrumbs:function(t){return new a({links:t.getAggregation(\"breadCrumbLinks\")})},_lockIcon:function(t){return this._getButton(t,\"sap-icon://private\",\"lock\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_LOCK_MARK_VALUE\"))},_titleArrowIconCont:function(t){return this._getButton(t,\"sap-icon://arrow-down\",\"titleArrow-cont\",t.oLibraryResourceBundleOP.getText(\"OP_SELECT_ARROW_TOOLTIP\"))},_titleArrowIcon:function(t){return this._getButton(t,\"sap-icon://arrow-down\",\"titleArrow\",t.oLibraryResourceBundleOP.getText(\"OP_SELECT_ARROW_TOOLTIP\"))},_favIcon:function(t){return this._getIcon(t,\"favorite\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_FAVORITE_MARK_VALUE\"))},_flagIcon:function(t){return this._getIcon(t,\"flag\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_FLAG_MARK_VALUE\"))},_overflowButton:function(t){return this._getButton(t,\"sap-icon://overflow\",\"overflow\")},_expandButton:function(t){return this._getButton(t,\"sap-icon://slim-arrow-down\",\"expand\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_EXPAND_HEADER_BTN\"))},_changesIconCont:function(t){return this._getButton(t,\"sap-icon://user-edit\",\"changes-cont\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_CHANGES_MARK_VALUE\"))},_changesIcon:function(t){return this._getButton(t,\"sap-icon://user-edit\",\"changes\",t.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_CHANGES_MARK_VALUE\"))},_getIcon:function(t,i,o){return e.createControlByURI({id:this._getParentAugmentedId(t,i),tooltip:o,src:e.getIconURI(i),visible:!1})},_getButton:function(t,e,i,o){return new c({id:this._getParentAugmentedId(t,i),tooltip:o,icon:e,type:sap.m.ButtonType.Transparent})},_getParentAugmentedId:function(t,e){return t.getId()+\"-\"+e}},d.prototype._lazyLoadInternalAggregation=function(t,e){return this.getAggregation(t)||this.setAggregation(t,d._internalAggregationFactory[t](this),e),this.getAggregation(t)},d.prototype._applyActionProperty=function(t,e){var i=e[0];return this.getProperty(t)!==i&&(e.unshift(t),this.setProperty.apply(this,e),this._bFirstRendering||this._notifyParentOfChanges()),this},d.prototype._applyObjectImageProperty=function(t,e){var i=e[0];return this.getProperty(t)!==i&&(e.unshift(t),this.setProperty.apply(this,e),this._destroyObjectImage(),this._bFirstRendering||this._notifyParentOfChanges(!0)),this},d.prototype._proxyMethodToBreadCrumbControl=function(t,e){var i=this._lazyLoadInternalAggregation(\"_breadCrumbs\"),o=i[t].apply(i,e);return this.invalidate(),o},d.prototype.setHeaderDesign=function(t){return this.setProperty(\"headerDesign\",t),this.getParent()&&this.getParent().invalidate(),this},d.prototype._shiftHeaderTitle=function(){var t,e=this.getParent();e&&\"function\"==typeof e._calculateShiftOffset&&(t=e._calculateShiftOffset(),\"function\"==typeof e._shiftHeader&&e._shiftHeader(t.sStyleAttribute,t.iMarginalsOffset+\"px\"))},d.prototype.setObjectTitle=function(t){var e=this.getProperty(\"objectTitle\"),i=e!==t;return this._applyActionProperty(\"objectTitle\",Array.prototype.slice.call(arguments)),i&&this.mEventRegistry._titleChange&&this.fireEvent(\"_titleChange\",{id:this.getId(),name:\"objectTitle\",oldValue:e,newValue:t}),this};var _=[\"objectSubtitle\",\"showTitleSelector\",\"markLocked\",\"markFavorite\",\"markFlagged\",\"showMarkers\",\"showPlaceholder\",\"markChanges\"],y=[\"objectImageURI\",\"objectImageAlt\",\"objectImageDensityAware\",\"objectImageShape\"],f=function(t){var e=\"set\"+t.charAt(0).toUpperCase()+t.slice(1);d.prototype[e]=function(){var e=Array.prototype.slice.call(arguments);this._applyActionProperty.call(this,t,e)}},b=function(t){var e=\"set\"+t.charAt(0).toUpperCase()+t.slice(1);d.prototype[e]=function(){var e=Array.prototype.slice.call(arguments);this._applyObjectImageProperty.call(this,t,e)}},m=function(t,e,i){var o=\"set\"+t.charAt(0).toUpperCase()+t.slice(1);e[o]=function(){var e=Array.prototype.slice.call(arguments);return e.unshift(t),i.setProperty.apply(i,e),this.setProperty.apply(this,e)}};return _.forEach(f),y.forEach(b),d.prototype.getBreadCrumbsLinks=function(){return this._lazyLoadInternalAggregation(\"_breadCrumbs\").getLinks()},d.prototype.addBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl(\"addLink\",arguments)},d.prototype.indexOfBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl(\"indexOfLink\",arguments)},d.prototype.insertBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl(\"insertLink\",arguments)},d.prototype.removeBreadCrumbLink=function(){return this._proxyMethodToBreadCrumbControl(\"removeLink\",arguments)},d.prototype.removeAllBreadCrumbsLinks=function(){return this._proxyMethodToBreadCrumbControl(\"removeAllLinks\",arguments)},d.prototype.destroyBreadCrumbsLinks=function(){return this._proxyMethodToBreadCrumbControl(\"destroyLinks\",arguments)},d.prototype._destroyObjectImage=function(){var t=\"_objectImage\",e=this.getAggregation(t);e&&(e.destroy(),this.setAggregation(t,null))},d.prototype.onBeforeRendering=function(){var t=this.getSideContentButton();t&&!t.getTooltip()&&t.setTooltip(this.oLibraryResourceBundleOP.getText(\"TOOLTIP_OP_SHOW_SIDE_CONTENT\"));var e=this.getActions()||[];this._oOverflowActionSheet.removeAllButtons(),this._oActionSheetButtonMap={},(e.length>1||this._hasOneButtonShowText(e))&&e.forEach(function(t){if(t instanceof c&&!(t instanceof r)&&(t._bInternalVisible=t.getVisible(),t._getInternalVisible=function(){return this._bInternalVisible},t._setInternalVisible=function(t,e){this.$().toggle(t),t!=this._bInternalVisible&&(this._bInternalVisible=t,e&&this.invalidate())},t.onAfterRendering=function(){this._getInternalVisible()||this.$().hide()}),t instanceof c&&(\"Default\"===t.getType()||\"Unstyled\"===t.getType())&&t.setProperty(\"type\",sap.m.ButtonType.Transparent,!1),t instanceof c&&t.getVisible()){var e=this._createActionSheetButton(t);this._oActionSheetButtonMap[t.getId()]=e,this._oOverflowActionSheet.addButton(e),m(\"text\",t,e),m(\"icon\",t,e),m(\"enabled\",t,e)}},this),this._oTitleArrowIcon.setVisible(this.getShowTitleSelector()),this._oFavIcon.setVisible(this.getMarkFavorite()),this._oFlagIcon.setVisible(this.getMarkFlagged()),this._attachDetachActionButtonsHandler(!1),this._bFirstRendering=!1},d.prototype._createActionSheetButton=function(t){return new c({press:jQuery.proxy(this._onSeeMoreContentSelect,this),enabled:t.getEnabled(),text:t.getText(),icon:t.getIcon(),tooltip:t.getTooltip(),customData:new i({key:\"originalId\",value:t.getId()})})},d.prototype._handleImageNotFoundError=function(){var t=this._lazyLoadInternalAggregation(\"_objectImage\"),e=this.getParent(),i=e?e.$():this.$();this.getShowPlaceholder()?(i.find(\".sapMImg.sapUxAPObjectPageHeaderObjectImage\").hide(),i.find(\".sapUxAPObjectPageHeaderPlaceholder\").removeClass(\"sapUxAPHidePlaceholder\")):t.addStyleClass(\"sapMNoImg\")},d.prototype._clearImageNotFoundHandler=function(){this._lazyLoadInternalAggregation(\"_objectImage\").$().off(\"error\")},d.prototype.onAfterRendering=function(){var t=this._lazyLoadInternalAggregation(\"_objectImage\").$();this._adaptLayout(),this._clearImageNotFoundHandler(),t.error(this._handleImageNotFoundError.bind(this)),this.getObjectImageURI()||this._handleImageNotFoundError(),this._iResizeId||(this._iResizeId=s.register(this,this._onHeaderResize.bind(this))),this._shiftHeaderTitle(),this._attachDetachActionButtonsHandler(!0)},d.prototype._onHeaderResize=function(){this._adaptLayout(),this.getParent()&&\"function\"==typeof this.getParent()._adjustHeaderHeights&&this.getParent()._adjustHeaderHeights()},d.prototype._attachDetachActionButtonsHandler=function(t){var e=this.getActions()||[];e.length<1||e.forEach(function(e){if(e instanceof c){var i=this._oActionSheetButtonMap[e.getId()];t?(e.attachEvent(\"_change\",this._adaptLayout,this),i&&i.attachEvent(\"_change\",this._adaptOverflow,this)):(e.detachEvent(\"_change\",this._adaptLayout,this),i&&i.detachEvent(\"_change\",this._adaptOverflow,this))}},this)},d.prototype._onSeeMoreContentSelect=function(t){var e=t.getSource(),i=sap.ui.getCore().byId(e.data(\"originalId\"));i.firePress&&i.firePress({overflowButtonId:this._oOverflowButton.getId()}),this._oOverflowActionSheet.close()},d._actionImportanceMap={Low:3,Medium:2,High:1},d._sortActionsByImportance=function(t,e){var i=t instanceof r?t.getImportance():sap.uxap.Importance.High,o=e instanceof r?e.getImportance():sap.uxap.Importance.High,n=d._actionImportanceMap[i]-d._actionImportanceMap[o];return 0===n?t.position-e.position:n},d.prototype._hasOneButtonShowText=function(t){var e=!1;return 1!==t.length?e:(t[0]instanceof r?e=!t[0].getHideText()&&\"\"!=t[0].getText():t[0]instanceof c&&(e=\"\"!=t[0].getText()),e)},d.prototype._adaptLayout=function(t){var e=this.$(\"identifierLine\").width(),i=this._getActionsWidth(),o=i/e,n=this._iAvailablePercentageForActions*e,a=this._oOverflowButton.$(),s=this.$(\"actions\").find(\".sapMBtn\").not(\".sapUxAPObjectPageHeaderExpandButton\");o>this._iAvailablePercentageForActions?this._adaptActions(n):t&&t.getSource()instanceof r&&t.getSource()._setInternalVisible(!0),sap.ui.Device.system.phone&&s.css(\"visibility\",\"visible\"),s.filter(\":visible\").length===s.length&&a.hide(),this._adaptObjectPageHeaderIndentifierLine()},d.prototype._adaptObjectPageHeaderIndentifierLine=function(){var t,e,i=this.$(\"identifierLine\").width(),o=this.$(\"subtitle\"),n=this.$(\"identifierLineContainer\"),a=this.$(\"actions\").width()+this.$().find(\".sapUxAPObjectPageHeaderObjectImageContainer\").width(),r=this.$().parents().hasClass(\"sapUiSizeCompact\")?7:3;o.length&&(o.hasClass(\"sapOPHSubtitleBlock\")&&o.removeClass(\"sapOPHSubtitleBlock\"),t=o.outerHeight()+o.position().top,e=this.$(\"innerTitle\").outerHeight()+this.$(\"innerTitle\").position().top,Math.abs(t-e)>r&&o.addClass(\"sapOPHSubtitleBlock\")),n.width(100*(.95-a/i)+\"%\")},d.prototype._adaptActions=function(t){for(var e,i=g.Utilities.isPhoneScenario(this._getCurrentMediaContainerRange())||n.system.phone,o=this._oOverflowButton.$().show().width(),a=this.getActions(),r=a.length,s=0;s<r;s++)a[s].position=s;a.sort(d._sortActionsByImportance),a.forEach(function(n){e=this._oActionSheetButtonMap[n.getId()],e&&(o+=n.$().width(),t>o&&!i?this._setActionButtonVisibility(n,!0):this._setActionButtonVisibility(n,!1))},this)},d.prototype._adaptOverflow=function(){var t=this._oOverflowActionSheet.getButtons(),e=t.some(function(t){return t.getVisible()});this._oOverflowButton.$().toggle(e)},d.prototype._setActionButtonVisibility=function(t,e){var i=this._oActionSheetButtonMap[t.getId()];i&&(t.getVisible()?(t._setInternalVisible(e),i.setVisible(!e)):i.setVisible(!1))},d.prototype._getActionsWidth=function(){var t=0;return this.getActions().forEach(function(e){e instanceof c&&(e.$().show(),sap.ui.Device.system.phone&&e.$().css(\"visibility\",\"hidden\"),t+=e.$().outerWidth(!0))}),t},d.prototype._notifyParentOfChanges=function(t){var e=this.getParent();e&&\"function\"==typeof e._headerTitleChangeHandler&&e._headerTitleChangeHandler(t)},d.prototype.exit=function(){this._clearImageNotFoundHandler(),this._iResizeId&&s.deregister(this._iResizeId)},d.prototype.setNavigationBar=function(t){return this.setAggregation(\"navigationBar\",t),t&&this.mEventRegistry._adaptableContentChange&&this.fireEvent(\"_adaptableContentChange\",{parent:this,adaptableContent:t}),this},d.prototype._getAdaptableContent=function(){return this.getNavigationBar()},d});",
		"sap/uxap/ObjectPageHeaderActionButton.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/Button\",\"./library\"],function(t,e){\"use strict\";var i=t.extend(\"sap.uxap.ObjectPageHeaderActionButton\",{metadata:{library:\"sap.uxap\",properties:{hideText:{type:\"boolean\",defaultValue:!0},hideIcon:{type:\"boolean\",defaultValue:!1},importance:{type:\"sap.uxap.Importance\",group:\"Behavior\",defaultValue:e.Importance.High}}}});return i.prototype.init=function(){this._bInternalVisible=this.getVisible()},i.prototype.onAfterRendering=function(){this._getInternalVisible()||this.$().hide()},i.prototype.applySettings=function(e,i){t.prototype.applySettings&&t.prototype.applySettings.call(this,e,i),this.toggleStyleClass(\"sapUxAPObjectPageHeaderActionButtonHideText\",this.getHideText()),this.toggleStyleClass(\"sapUxAPObjectPageHeaderActionButtonHideIcon\",this.getHideIcon())},i.prototype.setHideText=function(t,e){return this.toggleStyleClass(\"sapUxAPObjectPageHeaderActionButtonHideText\",t),this.setProperty(\"hideText\",t,e)},i.prototype.setHideIcon=function(t,e){return this.toggleStyleClass(\"sapUxAPObjectPageHeaderActionButtonHideIcon\",t),this.setProperty(\"hideIcon\",t,e)},i.prototype._setInternalVisible=function(t,e){this.$().toggle(t),t!=this._bInternalVisible&&(this._bInternalVisible=t,e&&this.invalidate())},i.prototype._getInternalVisible=function(){return this._bInternalVisible},i});",
		"sap/uxap/ObjectPageHeaderActionButtonRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/m/ButtonRenderer\",\"sap/ui/core/Renderer\"],function(e,r){\"use strict\";var n=r.extend(e);return n},!0);",
		"sap/uxap/ObjectPageHeaderContent.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/Control\",\"./library\",\"sap/m/Button\",\"./ObjectImageHelper\"],function(e,t,a,r){\"use strict\";var i=e.extend(\"sap.uxap.ObjectPageHeaderContent\",{metadata:{library:\"sap.uxap\",properties:{contentDesign:{type:\"sap.uxap.ObjectPageHeaderDesign\",group:\"Misc\",defaultValue:sap.uxap.ObjectPageHeaderDesign.Light}},aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},_editHeaderButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_objectImage:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"},_placeholder:{type:\"sap.ui.core.Icon\",multiple:!1,visibility:\"hidden\"}}}});return i.prototype.onBeforeRendering=function(){var e=this.getParent(),a=this.getAggregation(\"_editHeaderButton\");a||e&&e instanceof t.ObjectPageLayout&&e.getShowEditHeaderButton()&&(a=this._getInternalBtnAggregation(\"_editHeaderButton\",\"EDIT_HEADER\",\"-editHeaderBtn\",\"Transparent\"),a.attachPress(this._handleEditHeaderButtonPress,this))},i.prototype.exit=function(){var e=this.getAggregation(\"_editHeaderButton\");e&&e.detachPress(this._handleEditHeaderButtonPress,this)},i.prototype._handleEditHeaderButtonPress=function(e){this.getParent().fireEditHeaderButtonPress()},i.prototype._getInternalBtnAggregation=function(e,r,i,o){if(!this.getAggregation(e)){var g=new a({text:t.i18nModel.getResourceBundle().getText(r),type:o,id:this.getId()+i});this.setAggregation(e,g)}return this.getAggregation(e)},i.prototype._getObjectImage=function(){if(!this.getAggregation(\"_objectImage\")){var e=this.getParent(),t=e&&e.getHeaderTitle&&e.getHeaderTitle(),a=t&&r.createObjectImage(t);a&&this.setAggregation(\"_objectImage\",a,!0)}return this.getAggregation(\"_objectImage\")},i.prototype._destroyObjectImage=function(e){var t=this.getAggregation(\"_objectImage\");t&&(t.destroy(),this.getAggregation(\"_objectImage\",null,e))},i.prototype._getPlaceholder=function(){if(!this.getAggregation(\"_placeholder\")){var e=this.getParent(),t=e&&e.getHeaderTitle&&e.getHeaderTitle(),a=t.getShowPlaceholder(),i=a&&r.createPlaceholder();i&&this.setAggregation(\"_placeholder\",i,!0)}return this.getAggregation(\"_placeholder\")},i.prototype._getLayoutDataForControl=function(e){var a=e.getLayoutData();if(a){if(a instanceof t.ObjectPageHeaderLayoutData)return a;if(\"sap.ui.core.VariantLayoutData\"==a.getMetadata().getName())for(var r=a.getMultipleLayoutData(),i=0;i<r.length;i++){var o=r[i];if(o instanceof t.ObjectPageHeaderLayoutData)return o}}},i});",
		"sap/uxap/ObjectPageHeaderContentRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./ObjectPageHeaderRenderer\",\"./ObjectPageLayout\",\"./ObjectImageHelper\"],function(e,t,a){\"use strict\";var n={};return n.render=function(e,a){var n=a.getParent(),r=n instanceof t,s=n&&r?n.getHeaderTitle():void 0,d=!(!n||!r)&&(n instanceof t&&n.getShowTitleInHeaderContent()),i=r&&n.getShowEditHeaderButton()&&a.getContent()&&a.getContent().length>0;i&&(e.write(\"<div \"),e.writeControlData(a),e.addClass(\"sapUxAPObjectPageHeaderContentFlexBox\"),e.addClass(\"sapUxAPObjectPageHeaderContentDesign-\"+a.getContentDesign()),s&&e.addClass(\"sapUxAPObjectPageContentObjectImage-\"+s.getObjectImageShape()),e.writeClasses(),e.write(\">\")),e.write(\"<div \"),i?e.addClass(\"sapUxAPObjectPageHeaderContentCellLeft\"):(e.writeControlData(a),e.addClass(\"sapUxAPObjectPageHeaderContentDesign-\"+a.getContentDesign()),s&&e.addClass(\"sapUxAPObjectPageContentObjectImage-\"+s.getObjectImageShape())),e.addClass(\"ui-helper-clearfix\"),e.addClass(\"sapUxAPObjectPageHeaderContent\"),a.getVisible()||e.addClass(\"sapUxAPObjectPageHeaderContentHidden\"),e.writeClasses(),e.write(\">\"),r&&n.getIsChildPage()&&(e.write(\"<div\"),e.addClass(\"sapUxAPObjectChildPage\"),e.writeClasses(),e.write(\"></div>\")),d&&(this._renderTitleImage(e,a,s),0==a.getContent().length&&(e.write('<span class=\"sapUxAPObjectPageHeaderContentItem\">'),this._renderTitle(e,s),e.write(\"</span>\"))),a.getContent().forEach(function(t,n){this._renderHeaderContentItem(t,n,e,d,s,a)},this),e.write(\"</div>\"),i&&(this._renderEditButton(e,a),e.write(\"</div>\"))},n._renderHeaderContentItem=function(e,t,a,n,r,s){var d=!1,i=!1,o=s._getLayoutDataForControl(e),g=0===t;o?(d=o.getShowSeparatorBefore(),i=o.getShowSeparatorAfter(),a.write(\"<span \"),a.addClass(\"sapUxAPObjectPageHeaderWidthContainer\"),a.addClass(\"sapUxAPObjectPageHeaderContentItem\"),a.addStyle(\"width\",o.getWidth()),a.writeStyles(),(i||d)&&a.addClass(\"sapUxAPObjectPageHeaderSeparatorContainer\"),o.getVisibleL()||a.addClass(\"sapUxAPObjectPageHeaderLayoutHiddenL\"),o.getVisibleM()||a.addClass(\"sapUxAPObjectPageHeaderLayoutHiddenM\"),o.getVisibleS()||a.addClass(\"sapUxAPObjectPageHeaderLayoutHiddenS\"),a.writeClasses(),a.write(\">\"),d&&a.write('<span class=\"sapUxAPObjectPageHeaderSeparatorBefore\"></span>'),g&&n&&this._renderTitle(a,r)):g&&n?(a.write('<span class=\"sapUxAPObjectPageHeaderContentItem\">'),this._renderTitle(a,r)):e.addStyleClass(\"sapUxAPObjectPageHeaderContentItem\"),a.renderControl(e),i&&a.write('<span class=\"sapUxAPObjectPageHeaderSeparatorAfter\"></span>'),(o||g&&n)&&a.write(\"</span>\")},n._renderTitleImage=function(e,t,n){a._renderImageAndPlaceholder(e,{oHeader:n,oObjectImage:t._getObjectImage(),oPlaceholder:t._getPlaceholder(),bIsObjectIconAlwaysVisible:!1,bAddSubContainer:!1,sBaseClass:\"sapUxAPObjectPageHeaderContentImageContainer\"})},n._renderTitle=function(t,a){e._renderObjectPageTitle(t,a,!0)},n._renderEditButton=function(e,t){e.write('<div class=\"sapUxAPObjectPageHeaderContentCellRight\">'),e.renderControl(t.getAggregation(\"_editHeaderButton\")),e.write(\"</div>\")},n},!0);",
		"sap/uxap/ObjectPageHeaderLayoutData.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/LayoutData\",\"./library\"],function(e,a){\"use strict\";var t=e.extend(\"sap.uxap.ObjectPageHeaderLayoutData\",{metadata:{library:\"sap.uxap\",properties:{visibleS:{type:\"boolean\",group:\"Misc\",defaultValue:!0},visibleM:{type:\"boolean\",group:\"Misc\",defaultValue:!0},visibleL:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showSeparatorBefore:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showSeparatorAfter:{type:\"boolean\",group:\"Misc\",defaultValue:!1},width:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:\"auto\"}}}});/*!\n\t * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n\t */\nreturn t});",
		"sap/uxap/ObjectPageHeaderRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./ObjectPageLayout\",\"sap/ui/core/Icon\",\"./ObjectImageHelper\"],function(e,t,a){\"use strict\";var r={};return r.render=function(t,r){var s,i=r.getNavigationBar(),n=r.getIsObjectIconAlwaysVisible()||r.getIsObjectTitleAlwaysVisible()||r.getIsObjectSubtitleAlwaysVisible()||r.getIsActionAreaAlwaysVisible(),d=r.getParent(),o=r.getAggregation(\"_expandButton\"),l=r._lazyLoadInternalAggregation(\"_objectImage\",!0),g=sap.ui.Device.system.desktop,c=d&&d instanceof e&&(d.getHeaderContent()&&d.getHeaderContent().length>0&&d.getShowHeaderContent()||d.getShowHeaderContent()&&d.getShowTitleInHeaderContent());t.write(\"<div\"),t.writeControlData(r),t.addClass(\"sapUxAPObjectPageHeader\"),t.addClass(\"sapUxAPObjectPageHeaderDesign-\"+r.getHeaderDesign()),t.writeClasses(),t.write(\">\"),i&&(t.write(\"<div\"),t.addClass(\"sapUxAPObjectPageHeaderNavigation\"),t.writeClasses(),t.write(\">\"),t.renderControl(i),t.write(\"</div>\")),t.write(\"<div\"),t.writeAttributeEscaped(\"id\",r.getId()+\"-identifierLine\"),t.addClass(\"sapUxAPObjectPageHeaderIdentifier\"),n&&t.addClass(\"sapUxAPObjectPageHeaderIdentifierForce\"),t.writeClasses(),t.write(\">\"),d&&d instanceof e&&d.getIsChildPage()&&(t.write(\"<div\"),t.addClass(\"sapUxAPObjectChildPage\"),t.writeClasses(),t.write(\"></div>\")),r.getShowPlaceholder()&&(s=r._lazyLoadInternalAggregation(\"_placeholder\",!0)),a._renderImageAndPlaceholder(t,{oHeader:r,oObjectImage:l,oPlaceholder:s,bIsObjectIconAlwaysVisible:r.getIsObjectIconAlwaysVisible(),bAddSubContainer:!0,sBaseClass:\"sapUxAPObjectPageHeaderObjectImageContainer\"}),t.write(\"<span \"),t.writeAttributeEscaped(\"id\",r.getId()+\"-identifierLineContainer\"),t.addClass(\"sapUxAPObjectPageHeaderIdentifierContainer\"),t.writeClasses(),t.write(\">\"),this._renderObjectPageTitle(t,r),t.write(\"</span>\"),t.write(\"<span\"),t.writeAttributeEscaped(\"id\",r.getId()+\"-actions\"),t.addClass(\"sapUxAPObjectPageHeaderIdentifierActions\"),r.getIsActionAreaAlwaysVisible()&&t.addClass(\"sapUxAPObjectPageHeaderIdentifierActionsForce\"),t.writeClasses(),t.write(\">\"),g&&c&&(o.addStyleClass(\"sapUxAPObjectPageHeaderExpandButton\"),t.renderControl(o));for(var w=r.getActions(),C=0;C<w.length;C++){var p=w[C];t.renderControl(p)}var b=r.getAggregation(\"_overflowButton\");t.renderControl(b),this._renderSideContentBtn(t,r),t.write(\"</span>\"),t.write(\"</div>\"),t.write(\"</div>\")},r._renderObjectPageTitle=function(e,t,a){var r=t.getObjectTitle(),s=t.getShowMarkers()&&(t.getMarkFavorite()||t.getMarkFlagged()),i=t._lazyLoadInternalAggregation(\"_breadCrumbs\",!0);if(!a&&i&&i.getLinks().length&&e.renderControl(i),e.write(\"<h1\"),e.addClass(\"sapUxAPObjectPageHeaderIdentifierTitle\"),t.getIsObjectTitleAlwaysVisible()&&e.addClass(\"sapUxAPObjectPageHeaderIdentifierTitleForce\"),a&&e.addClass(\"sapUxAPObjectPageHeaderIdentifierTitleInContent\"),t.getShowTitleSelector()&&e.addClass(\"sapUxAPObjectPageHeaderTitleFollowArrow\"),e.writeClasses(),e.writeAttributeEscaped(\"id\",t.getId()+\"-title\"),e.write(\">\"),e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderTitleTextWrappable\"),e.writeClasses(),e.writeAttributeEscaped(\"id\",t.getId()+\"-innerTitle\"),e.write(\">\"),s||t.getShowTitleSelector()||t.getMarkLocked()||t.getMarkChanges()){var n=r.substr(r.lastIndexOf(\" \")+1),d=r.substr(0,r.lastIndexOf(\" \")+1);1===n.length&&(n=r,d=\"\"),e.writeEscaped(d),e.write(\"</span>\"),e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderNowrapMarkers\"),(t.getMarkLocked()||t.getMarkChanges())&&e.addClass(\"sapUxAPObjectPageHeaderMarks\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(n),this._renderMarkers(e,t),t.getMarkLocked()?this._renderLock(e,t,a):t.getMarkChanges()&&this._renderMarkChanges(e,t,a),this._renderSelectTitleArrow(e,t,a),e.write(\"</span>\")}else e.writeEscaped(r),e.write(\"</span>\");e.write(\"</h1>\"),e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderIdentifierDescription\"),t.getIsObjectSubtitleAlwaysVisible()&&t.getObjectSubtitle()&&e.addClass(\"sapUxAPObjectPageHeaderIdentifierDescriptionForce\"),a&&e.addClass(\"sapUxAPObjectPageHeaderIdentifierSubTitleInContent\"),e.writeClasses(),e.writeAttributeEscaped(\"id\",t.getId()+\"-subtitle\"),e.write(\">\"),e.writeEscaped(t.getObjectSubtitle()),e.write(\"</span>\")},r._renderSelectTitleArrow=function(e,t,a){t.getShowTitleSelector()&&(e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderTitleArrow\"),e.writeClasses(),e.write(\">\"),a?e.renderControl(t._oTitleArrowIconCont):e.renderControl(t._oTitleArrowIcon),e.write(\"</span>\"))},r._renderSideContentBtn=function(e,t){var a=t.getSideContentButton();a&&(e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderSideContentBtn\"),e.writeClasses(),e.write(\">\"),e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderSeparator\"),e.writeClasses(),e.write(\"></span>\"),e.renderControl(a),e.write(\"</span>\"))},r._renderMarkChanges=function(e,t,a){e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderChangesBtn\"),e.addClass(\"sapUiSizeCompact\"),e.writeClasses(),e.write(\">\"),a?e.renderControl(t._oChangesIconCont):e.renderControl(t._oChangesIcon),e.write(\"</span>\")},r._renderLock=function(e,t,a){e.write(\"<span\"),e.addClass(\"sapUxAPObjectPageHeaderLockBtn\"),e.addClass(\"sapUiSizeCompact\"),e.writeClasses(),e.write(\">\"),a?e.renderControl(t._oLockIconCont):e.renderControl(t._oLockIcon),e.write(\"</span>\")},r._renderMarkers=function(e,t){var a=[];if(t.getShowMarkers()){a.push(t._oFavIcon),a.push(t._oFlagIcon),this._renderMarkersAria(e,t),e.write(\"<span\"),e.addClass(\"sapMObjStatusMarker\"),e.writeClasses(),e.writeAttributeEscaped(\"id\",t.getId()+\"-markers\"),e.writeAttributeEscaped(\"aria-describedby\",t.getId()+\"-markers-aria\"),e.write(\">\");for(var r=0;r<a.length;r++)e.renderControl(a[r]);e.write(\"</span>\")}},r._renderMarkersAria=function(e,t){var a=\"\";t.getMarkFlagged()&&(a+=t.oLibraryResourceBundle.getText(\"ARIA_FLAG_MARK_VALUE\")+\" \"),t.getMarkFavorite()&&(a+=t.oLibraryResourceBundle.getText(\"ARIA_FAVORITE_MARK_VALUE\")+\" \"),\"\"!==a&&(e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-markers-aria\"),e.writeAttribute(\"aria-hidden\",\"false\"),e.addClass(\"sapUiHidden\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(a),e.write(\"</div>\"))},r},!0);",
		"sap/uxap/ObjectPageLayout.designtime.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{name:{singular:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"LAYOUT_CONTROL_NAME\")},plural:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"LAYOUT_CONTROL__PLURAL\")}},aggregations:{sections:{domRef:\":sap-domref > .sapUxAPObjectPageWrapper\",childNames:{singular:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"SECTION_CONTROL_NAME\")},plural:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"SECTION_CONTROL_NAME_PLURAL\")}},actions:{move:\"moveControls\"}},vScroll:{ignore:!1,domRef:function(e){return e.$(\"vertSB-sb\").get(0)}}},cloneDomRef:\":sap-domref > header\"}},!1);",
		"sap/uxap/ObjectPageLayout.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/ResizeHandler\",\"sap/ui/core/Control\",\"sap/ui/core/CustomData\",\"sap/ui/Device\",\"sap/ui/core/delegate/ScrollEnablement\",\"./ObjectPageSection\",\"./ObjectPageSubSection\",\"./ObjectPageSubSectionLayout\",\"./LazyLoading\",\"./ObjectPageLayoutABHelper\",\"./ThrottledTaskHelper\",\"sap/ui/core/ScrollBar\",\"sap/ui/core/TitleLevel\",\"./library\"],function(t,e,i,o,n,s,r,a,h,c,l,d,g,p,u){\"use strict\";function _(t){return 1===arguments.length?Array.isArray(t)?t.length>0:!!t:Array.prototype.slice.call(arguments).every(function(t){return _(t)})}var S=i.extend(\"sap.uxap.ObjectPageLayout\",{metadata:{library:\"sap.uxap\",properties:{showAnchorBar:{type:\"boolean\",defaultValue:!0},showAnchorBarPopover:{type:\"boolean\",defaultValue:!0},upperCaseAnchorBar:{type:\"boolean\",defaultValue:!0},height:{type:\"sap.ui.core.CSSSize\",defaultValue:\"100%\"},enableLazyLoading:{type:\"boolean\",defaultValue:!1},subSectionLayout:{type:\"sap.uxap.ObjectPageSubSectionLayout\",defaultValue:h.TitleOnTop},sectionTitleLevel:{type:\"sap.ui.core.TitleLevel\",group:\"Appearance\",defaultValue:sap.ui.core.TitleLevel.Auto},useIconTabBar:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showHeaderContent:{type:\"boolean\",group:\"Misc\",defaultValue:!0},useTwoColumnsForLargeScreen:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},showTitleInHeaderContent:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},showOnlyHighImportance:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},isChildPage:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},alwaysShowContentHeader:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},showEditHeaderButton:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},flexEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showFooter:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},associations:{selectedSection:{type:\"sap.uxap.ObjectPageSection\",multiple:!1}},defaultAggregation:\"sections\",aggregations:{sections:{type:\"sap.uxap.ObjectPageSection\",multiple:!0,singularName:\"section\"},headerTitle:{type:\"sap.uxap.ObjectPageHeader\",multiple:!1},headerContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"headerContent\"},footer:{type:\"sap.m.IBar\",multiple:!1},_anchorBar:{type:\"sap.uxap.AnchorBar\",multiple:!1,visibility:\"hidden\"},_iconTabBar:{type:\"sap.m.IconTabBar\",multiple:!1,visibility:\"hidden\"},_headerContent:{type:\"sap.uxap.ObjectPageHeaderContent\",multiple:!1,visibility:\"hidden\"},_customScrollBar:{type:\"sap.ui.core.ScrollBar\",multiple:!1,visibility:\"hidden\"}},events:{toggleAnchorBar:{parameters:{fixed:{type:\"boolean\"}}},editHeaderButtonPress:{},navigate:{parameters:{section:{type:\"sap.uxap.ObjectPageSection\"}}}},designTime:!0}});return S.HEADER_CALC_DELAY=350,S.DOM_CALC_DELAY=200,S.FOOTER_ANIMATION_DURATION=350,S.TITLE_LEVEL_AS_ARRAY=Object.keys(p),S._getNextTitleLevelEntry=function(t){var e=S.TITLE_LEVEL_AS_ARRAY.indexOf(t),i=e!==-1,o=i&&e!==S.TITLE_LEVEL_AS_ARRAY.length-1;return i?S.TITLE_LEVEL_AS_ARRAY[o?e+1:e]:p.Auto},S.prototype.init=function(){this._bFirstRendering=!0,this._bDomReady=!1,this._bStickyAnchorBar=!1,this._iStoredScrollPosition=0,this._bInternalAnchorBarVisible=!0,this._$opWrapper=[],this._$anchorBar=[],this._$headerTitle=[],this._$stickyAnchorBar=[],this._$headerContent=[],this._$stickyHeaderContent=[],this._bMobileScenario=!1,this._oSectionInfo={},this._aSectionBases=[],this._sScrolledSectionId=\"\",this._iScrollToSectionDuration=600,this._$spacer=[],this.iHeaderContentHeight=0,this.iStickyHeaderContentHeight=0,this.iHeaderTitleHeight=0,this.iHeaderTitleHeightStickied=0,this.iAnchorBarHeight=0,this.iTotalHeaderSize=0,this._iREMSize=parseInt(t(\"body\").css(\"font-size\"),10),this._iOffset=parseInt(.25*this._iREMSize,10),this._iResizeId=e.register(this,this._onUpdateScreenSize.bind(this)),this._oABHelper=new l(this),this._bSuppressLayoutCalculations=!1},S.prototype.onBeforeRendering=function(){if(this._oLazyLoading=new c(this),this.getVisible()){this._bMobileScenario=u.Utilities.isPhoneScenario(this._getCurrentMediaContainerRange()),this._bTabletScenario=u.Utilities.isTabletScenario(this._getCurrentMediaContainerRange()),this._bHContentAlwaysExpanded=this._checkAlwaysShowContentHeader(),this._initializeScroller(),this._getHeaderContent().setContentDesign(this._getHeaderDesign()),this._oABHelper._getAnchorBar().setProperty(\"upperCase\",this.getUpperCaseAnchorBar(),!0),this._applyUxRules(),this._storeScrollLocation(),!t.isEmptyObject(this._oSectionInfo)&&this._bFirstRendering&&(this._preloadSectionsOnBeforeFirstRendering(),this._bFirstRendering=!1),this._bStickyAnchorBar=!1;var e=this.getHeaderTitle();e&&e.getAggregation(\"_expandButton\")&&e.getAggregation(\"_expandButton\").attachPress(this._handleExpandButtonPress,this)}},S.prototype._getSectionsToRender=function(){var t=sap.ui.getCore().byId(this.getSelectedSection());return this.getUseIconTabBar()&&t?[t]:this.getSections()},S.prototype._preloadSectionsOnBeforeFirstRendering=function(){var t;if(this.getEnableLazyLoading()){var e=this.getUseIconTabBar()?this._grepCurrentTabSectionBases():this._aSectionBases;t=this._oLazyLoading.getSubsectionsToPreload(e)}else t=this.getUseIconTabBar()?[sap.ui.getCore().byId(this.getSelectedSection())||this._oFirstVisibleSection]:this.getSections();this._connectModelsForSections(t)},S.prototype._grepCurrentTabSectionBases=function(){var t=[],e=this._oCurrentTabSection||sap.ui.getCore().byId(this.getSelectedSection())||this._oFirstVisibleSection;if(e){var i=e.getId();this._aSectionBases.forEach(function(e){e.getParent().getId()===i&&t.push(e)})}return t},S.prototype.onAfterRendering=function(){this._ensureCorrectParentHeight(),this._cacheDomElements(),this._$opWrapper.on(\"scroll\",this._onScroll.bind(this)),this._bDomReady&&0===this.$().parents(\":hidden\").length?this._onAfterRenderingDomReady():t.sap.delayedCall(S.HEADER_CALC_DELAY,this,this._onAfterRenderingDomReady)},S.prototype._onAfterRenderingDomReady=function(){var t,e,i=this._oStoredSection||this._oFirstVisibleSection;this._bDomReady=!0,this._adjustHeaderHeights(),i&&(e=i.getId(),t=this._oFirstVisibleSection&&this._oFirstVisibleSection.getId(),this.getUseIconTabBar()?(this._setSelectedSectionId(e),this._setCurrentTabSection(i)):e!==t&&this.scrollToSection(e)),this._initAnchorBarScroll(),sap.ui.Device.system.desktop&&this._$opWrapper.on(\"scroll\",this.onWrapperScroll.bind(this)),this._registerOnContentResize(),this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle(),this.getFooter()&&this._shiftFooter(),this._setSectionsFocusValues(),this._restoreScrollPosition(),sap.ui.getCore().getEventBus().publish(\"sap.ui\",\"ControlForPersonalizationRendered\",this),this.fireEvent(\"onAfterRenderingDOMReady\")},S.prototype._shiftFooter=function(){var t=this.$(\"footerWrapper\"),e=this._calculateShiftOffset();t.css(e.sStyleAttribute,e.iMarginalsOffset+\"px\")},S.prototype._calculateShiftOffset=function(){var e,i=0,o=sap.ui.getCore().getConfiguration().getRTL()?\"left\":\"right\",n=this._hasVerticalScrollBar(),s=this._iOffset;return sap.ui.Device.system.desktop&&(e=t.sap.scrollbarSize().width,i=e,n||(i=0,s+=e)),{sStyleAttribute:o,iActionsOffset:s,iMarginalsOffset:i}},S.prototype.exit=function(){this._oScroller&&(this._oScroller.destroy(),this._oScroller=null),this._iResizeId&&e.deregister(this._iResizeId),this._iContentResizeId&&e.deregister(this._iContentResizeId)},S.prototype._getCustomScrollBar=function(){if(!this.getAggregation(\"_customScrollBar\")){var t=new g(this.getId()+\"-vertSB\",{vertical:!0,size:\"100%\",scrollPosition:0,scroll:this.onCustomScrollerScroll.bind(this)});this.setAggregation(\"_customScrollBar\",t,!0)}return this.getAggregation(\"_customScrollBar\")},S.prototype.onWrapperScroll=function(t){var e=Math.max(t.target.scrollTop,0);if(this._getCustomScrollBar()){if(this.allowCustomScroll===!0)return void(this.allowCustomScroll=!1);this.allowInnerDiv=!0,this._getCustomScrollBar().setScrollPosition(e)}},S.prototype.onCustomScrollerScroll=function(e){var i=Math.max(this._getCustomScrollBar().getScrollPosition(),0);return this.allowInnerDiv===!0?void(this.allowInnerDiv=!1):(this.allowCustomScroll=!0,void t(this._$opWrapper).scrollTop(i))},S.prototype.setShowOnlyHighImportance=function(t){var e=this.getShowOnlyHighImportance();return e!==t&&(this.setProperty(\"showOnlyHighImportance\",t,!0),this.getSections().forEach(function(t){t._updateImportance()})),this},S.prototype.setIsHeaderContentAlwaysExpanded=function(t){var e=this.getAlwaysShowContentHeader(),i=n.system.phone||n.system.tablet;return e!==t&&this.setProperty(\"alwaysShowContentHeader\",t,i),this},S.prototype._initializeScroller=function(){this._oScroller||(this._oScroller=new s(this,this.getId()+\"-scroll\",{horizontal:!1,vertical:!0}))},S.prototype.setSelectedSection=function(e){if(!sap.ui.getCore().byId(e))return t.sap.log.warning(\"setSelectedSection aborted: unknown section\",e,this),this;var i=this.getSelectedSection();return e===i?this:(this.scrollToSection(e),this.setAssociation(\"selectedSection\",e,!0))},S.prototype._ensureCorrectParentHeight=function(){this._bCorrectParentHeightIsSet||(this.getParent().getHeight&&[\"\",\"auto\"].indexOf(this.getParent().getHeight())!==-1&&this.$().parent().css(\"height\",\"100%\"),this._bCorrectParentHeightIsSet=!0)},S.prototype._cacheDomElements=function(){this._$headerTitle=t.sap.byId(this.getId()+\"-headerTitle\"),this._$anchorBar=t.sap.byId(this.getId()+\"-anchorBar\"),this._$stickyAnchorBar=t.sap.byId(this.getId()+\"-stickyAnchorBar\"),this._$opWrapper=t.sap.byId(this.getId()+\"-opwrapper\"),this._$spacer=t.sap.byId(this.getId()+\"-spacer\"),this._$headerContent=t.sap.byId(this.getId()+\"-headerContent\"),this._$stickyHeaderContent=t.sap.byId(this.getId()+\"-stickyHeaderContent\"),this._$contentContainer=t.sap.byId(this.getId()+\"-scroll\"),this._$sectionsContainer=t.sap.byId(this.getId()+\"-sectionsContainer\"),this._bDomElementsCached=!0},S.prototype._handleExpandButtonPress=function(t){this._expandCollapseHeader(!0)},S.prototype._toggleStickyHeader=function(t){this._bIsHeaderExpanded=t,this._$headerTitle.toggleClass(\"sapUxAPObjectPageHeaderStickied\",!t)},S.prototype._expandCollapseHeader=function(t){this._bHContentAlwaysExpanded||(t&&this._bStickyAnchorBar?(this._$headerContent.css(\"height\",this.iHeaderContentHeight).children().appendTo(this._$stickyHeaderContent),this._toggleStickyHeader(t)):!t&&this._bIsHeaderExpanded&&(this._$headerContent.css(\"height\",\"auto\").append(this._$stickyHeaderContent.children()),this._$stickyHeaderContent.children().remove(),this._toggleStickyHeader(t)))},S.prototype._updateNavigation=function(){this.getShowAnchorBar()&&this._oABHelper._buildAnchorBar()},S.prototype._applyUxRules=function(e){var i,o,n,s,r,a,c,l,d;i=this.getSections()||[],s=0,a=this.getShowAnchorBar(),c=this.getUseIconTabBar(),l=null,this._cleanMemory(),i.forEach(function(i){return!i.getVisible()||(this._registerSectionBaseInfo(i),o=i.getSubSections()||[],n=0,d=null,o.forEach(function(i){return!i.getVisible()||(this._registerSectionBaseInfo(i),r=i.getVisibleBlocksCount(),void(0===r?(i._setInternalVisible(!1,e),t.sap.log.info(\"ObjectPageLayout :: noVisibleBlock UX rule matched\",\"subSection \"+i.getTitle()+\" forced to hidden\")):(i._setInternalVisible(!0,e),i._setInternalTitleVisible(!0,e),n++,d||(d=i),this._shouldApplySectionTitleLevel(i)&&i._setInternalTitleLevel(this._determineSectionBaseInternalTitleLevel(i)))))},this),0==n?(i._setInternalVisible(!1,e),t.sap.log.info(\"ObjectPageLayout :: noVisibleSubSection UX rule matched\",\"section \"+i.getTitle()+\" forced to hidden\")):(i._setInternalVisible(!0,e),i._setInternalTitleVisible(!0,e),l||(l=i),this.getSubSectionLayout()===h.TitleOnTop&&1===n&&\"\"!==d.getTitle().trim()?(t.sap.log.info(\"ObjectPageLayout :: TitleOnTop.sectionGetSingleSubSectionTitle UX rule matched\",\"section \"+i.getTitle()+\" is taking its single subsection title \"+d.getTitle()),i._setInternalTitle(d.getTitle(),e),d._setInternalTitleVisible(!1,e)):i._setInternalTitle(\"\",e),this._shouldApplySectionTitleLevel(i)&&i._setInternalTitleLevel(this._determineSectionBaseInternalTitleLevel(i)),s++),void(c&&i._setInternalTitleVisible(!1,e)))},this),s<=1?(a=!1,t.sap.log.info(\"ObjectPageLayout :: notEnoughVisibleSection UX rule matched\",\"anchorBar forced to hidden\")):l&&a&&(l._setInternalTitleVisible(!1,e),t.sap.log.info(\"ObjectPageLayout :: firstSectionTitleHidden UX rule matched\",\"section \"+l.getTitle()+\" title forced to hidden\")),a&&this._oABHelper._buildAnchorBar(),this._setInternalAnchorBarVisible(a,e),this._oFirstVisibleSection=l},S.prototype.setUseIconTabBar=function(t){var e=this.getUseIconTabBar();return t!=e&&this._applyUxRules(),this.setProperty(\"useIconTabBar\",t),this},S.prototype._setCurrentTabSection=function(t,e){if(t){var i;t instanceof sap.uxap.ObjectPageSubSection?(i=t,t=t.getParent()):i=this._getFirstVisibleSubSection(t),this._oCurrentTabSection!==t&&(this._renderSection(t),this._oCurrentTabSection=t),this._oCurrentTabSubSection=i}},S.prototype._renderSection=function(t){var e,i=this.$().find(\".sapUxAPObjectPageContainer\");t&&i.length&&(e=sap.ui.getCore().createRenderManager(),e.renderControl(t),e.flush(i[0]),e.destroy())},S.prototype.setShowAnchorBarPopover=function(t,e){return this._oABHelper._buildAnchorBar(),this._oABHelper._getAnchorBar().setShowPopover(t),this.setProperty(\"showAnchorBarPopover\",t,!0)},S.prototype._getInternalAnchorBarVisible=function(){return this._bInternalAnchorBarVisible},S.prototype._setInternalAnchorBarVisible=function(t,e){t!=this._bInternalAnchorBarVisible&&(this._bInternalAnchorBarVisible=t,e===!0&&this.invalidate())},S.prototype.setUpperCaseAnchorBar=function(t){return this._oABHelper._getAnchorBar().setProperty(\"upperCase\",t),this.setProperty(\"upperCaseAnchorBar\",t,!0)},S.prototype._requestAdjustLayout=function(e,i,o){return this._oLayoutTask||(this._oLayoutTask=new d(this._executeAdjustLayout,S.DOM_CALC_DELAY,this)),i||t.sap.log.debug(\"ObjectPageLayout :: _requestAdjustLayout\",\"delayed by \"+S.DOM_CALC_DELAY+\" ms because of dom modifications\"),this._oLayoutTask.reSchedule(i,{needLazyLoading:!!o}).catch(function(t){})},S.prototype._executeAdjustLayout=function(t){var e=t.needLazyLoading,i=this._updateScreenHeightSectionBasesAndSpacer();return i&&e&&this._oLazyLoading.doLazyLoading(),i},S.prototype._adjustLayoutAndUxRules=function(){if(!this._bSuppressLayoutCalculations){t.sap.log.debug(\"ObjectPageLayout :: _requestAdjustLayout\",\"refreshing ux rules\");var e=this.getSelectedSection(),i=sap.ui.getCore().byId(e),o=!1;this._applyUxRules(!0),i&&i.getVisible()&&i._getInternalVisible()||(i=this._oFirstVisibleSection,e=i&&i.getId(),o=!0),i&&(this._setSelectedSectionId(e),this.getUseIconTabBar()&&this._setCurrentTabSection(i),this._requestAdjustLayout(null,!1,!0).then(function(){o&&this.scrollToSection(e)}.bind(this)))}},S.prototype._suppressLayoutCalculations=function(){this._bSuppressLayoutCalculations=!0},S.prototype._resumeLayoutCalculations=function(){this._bSuppressLayoutCalculations=!1,this._adjustLayoutAndUxRules()},S.prototype._setSelectedSectionId=function(t){var e=this.getAggregation(\"_anchorBar\"),i=t&&this._oSectionInfo[t];i&&e&&i.buttonId&&(e.setSelectedButton(i.buttonId),this.setAssociation(\"selectedSection\",t,!0))},S.prototype.isFirstRendering=function(){return this._bFirstRendering},S.prototype._cleanMemory=function(){var t=this.getAggregation(\"_anchorBar\");t&&t._resetControl(),this._oSectionInfo={},this._aSectionBases=[]},S.prototype._registerSectionBaseInfo=function(t){this._oSectionInfo[t.getId()]={$dom:[],positionTop:0,positionTopMobile:0,buttonId:\"\",isSection:t instanceof r,sectionReference:t},this._aSectionBases.push(t)},S.prototype._triggerVisibleSubSectionsEvents=function(){this.getEnableLazyLoading()&&this._oLazyLoading&&this._oLazyLoading._triggerVisibleSubSectionsEvents()},S.prototype.scrollToSection=function(e,i,o,n){var s=sap.ui.getCore().byId(e);if(!this.getDomRef())return void t.sap.log.warning(\"scrollToSection can only be used after the ObjectPage is rendered\",this);if(!s)return void t.sap.log.warning(\"scrollToSection aborted: unknown section\",e,this);if(!this._oSectionInfo[e])return void t.sap.log.warning(\"scrollToSection aborted: section is hidden by UX rules\",e,this);if(this.bIsDestroyed)return void t.sap.log.debug(\"ObjectPageLayout :: scrollToSection\",\"scrolling canceled as page is being destroyed\");if(this.getUseIconTabBar()){var a=r._getClosestSection(s);this._oCurrentTabSection&&this._oCurrentTabSection._allowPropagationToLoadedViews(!1),a._allowPropagationToLoadedViews(!0),this._setCurrentTabSection(s),this.getAggregation(\"_anchorBar\").setSelectedButton(this._oSectionInfo[a.getId()].buttonId),this.setAssociation(\"selectedSection\",a.getId(),!0)}n&&this.fireNavigate({section:r._getClosestSection(s)}),this._bIsHeaderExpanded&&this._expandCollapseHeader(!1),o=o||0,s._expandSection(),this._requestAdjustLayout(null,!0),i=this._computeScrollDuration(i,s);var h=this._computeScrollPosition(s);this._sCurrentScrollId!=e&&(this._sCurrentScrollId=e,this._iCurrentScrollTimeout&&(clearTimeout(this._iCurrentScrollTimeout),this._$contentContainer&&this._$contentContainer.parent().stop(!0,!1)),this._bDomElementsCached&&(this._iCurrentScrollTimeout=t.sap.delayedCall(i,this,function(){this._sCurrentScrollId=void 0,this._iCurrentScrollTimeout=void 0})),this._preloadSectionsOnScroll(s),this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle(),this._scrollTo(h+o,i))},S.prototype._computeScrollDuration=function(t,e){var i=parseInt(t,10);return i=i>=0?i:this._iScrollToSectionDuration,this.getUseIconTabBar()&&(e instanceof r||this._isFirstVisibleSectionBase(e))&&this._bStickyAnchorBar&&(i=0),i},S.prototype._computeScrollPosition=function(t){var e=t&&t instanceof r,i=t.getId(),o=this._bMobileScenario||e?this._oSectionInfo[i].positionTopMobile:this._oSectionInfo[i].positionTop,n=!this._bStickyAnchorBar;return n&&this._isFirstVisibleSectionBase(t)&&(o-=this.iHeaderContentHeight),o},S.prototype._preloadSectionsOnScroll=function(e){var i,o=e.getId();if(!this.getEnableLazyLoading()&&this.getUseIconTabBar()&&(i=e instanceof r?e:e.getParent(),this._connectModelsForSections([i])),this.getEnableLazyLoading()){var s=this.getUseIconTabBar()?this._grepCurrentTabSectionBases():this._aSectionBases;i=this._oLazyLoading.getSubsectionsToPreload(s,o),n.system.desktop?t.sap.delayedCall(50,this,function(){this._connectModelsForSections(i)}):this._connectModelsForSections(i),i.forEach(function(t){this.fireEvent(\"subSectionEnteredViewPort\",{subSection:t})},this)}},S.prototype.getScrollingSectionId=function(){return this._sScrolledSectionId},S.prototype.setDirectScrollingToSection=function(t){this.sDirectSectionId=t},S.prototype.getDirectScrollingToSection=function(){return this.sDirectSectionId},S.prototype.clearDirectScrollingToSection=function(){this.sDirectSectionId=null},S.prototype._scrollTo=function(e,i){return this._oScroller&&(t.sap.log.debug(\"ObjectPageLayout :: scrolling to \"+e),0===i&&e>=this._getSnapPosition()&&this._toggleHeader(!0),this._oScroller.scrollTo(0,e,i)),this},S.prototype._updateScreenHeightSectionBasesAndSpacer=function(){var e,i,o,n,s,a;if(!this._bDomReady)return!1;t.sap.log.debug(\"ObjectPageLayout :: _updateScreenHeightSectionBasesAndSpacer\",\"re-evaluating dom positions\"),this.iScreenHeight=this.$().height();var h=0;return this._aSectionBases.forEach(function(t){var e,o=this._oSectionInfo[t.getId()],a=t.$(),c=!1;if(o&&a.length){o.isSection||h++,o.$dom=a;var l=a.position().top;if(o.positionTop=Math.ceil(l),e=o.isSection?t.$(\"header\"):t.$(\"headerTitle\"),c=0===e.length,c?o.positionTopMobile=o.positionTop:o.positionTopMobile=Math.ceil(e.position().top)+e.outerHeight(),this._bStickyAnchorBar||this._bIsHeaderExpanded||(o.positionTopMobile-=this.iAnchorBarHeight,o.positionTop-=this.iAnchorBarHeight),o.sectionReference.toggleStyleClass(\"sapUxAPObjectPageSubSectionPromoted\",c),this._bMobileScenario){var d=sap.ui.getCore().byId(t.getId()).getParent();if(d instanceof r&&d._getIsHidden())return;s&&(this._oSectionInfo[s].positionBottom=o.positionTop),s=t.getId(),i=t}else o.isSection?(s&&(this._oSectionInfo[s].positionBottom=o.positionTop,n&&(this._oSectionInfo[n].positionBottom=o.positionTop)),s=t.getId(),n=null):(n&&(this._oSectionInfo[n].positionBottom=o.positionTop),n=t.getId(),i=t)}},this),i&&(e=this._computeLastVisibleHeight(i),this._bMobileScenario&&s?this._oSectionInfo[s].positionBottom=this._oSectionInfo[s].positionTop+e:(n&&(this._oSectionInfo[n].positionBottom=this._oSectionInfo[n].positionTop+e),s&&n&&(this._oSectionInfo[s].positionBottom=this._oSectionInfo[n].positionTop+e)),a=this._bStickyAnchorBar||h>1||this._checkContentBottomRequiresSnap(i),o=this._computeSpacerHeight(i,e,a),this._$spacer.height(o+\"px\"),t.sap.log.debug(\"ObjectPageLayout :: bottom spacer is now \"+o+\"px\")),this._updateCustomScrollerHeight(a),!0},S.prototype._updateCustomScrollerHeight=function(t){if(sap.ui.Device.system.desktop&&this.getAggregation(\"_customScrollBar\")){var e=this._computeScrollableContentSize(t);e+=this._getStickyAreaHeight(t),this._getCustomScrollBar().setContentSize(e+\"px\");var i=e>this.iScreenHeight,o=i!==this._getCustomScrollBar().getVisible();o&&(this._getCustomScrollBar().setVisible(i),this.getHeaderTitle()&&this.getHeaderTitle()._shiftHeaderTitle())}},S.prototype._computeScrollableContentSize=function(t){var e=0;return this._$contentContainer&&this._$contentContainer.length&&(e=this._$contentContainer[0].scrollHeight),!this._bStickyAnchorBar&&t&&(e-=this.iAnchorBarHeight),this._bStickyAnchorBar&&!t&&(e+=this.iAnchorBarHeight),e},S.prototype._computeLastVisibleHeight=function(t){var e=this._bStickyAnchorBar||this._bIsHeaderExpanded,i=this._getSectionPositionTop(t,e);return this._$spacer.position().top-i},S.prototype._getStickyAreaHeight=function(t){return this._bHContentAlwaysExpanded?this.iHeaderTitleHeight:t?this.iHeaderTitleHeightStickied+this.iAnchorBarHeight:this.iHeaderTitleHeight},S.prototype._getScrollableViewportHeight=function(t){var e=this.$().height();return e-this._getStickyAreaHeight(t)},S.prototype._getSectionPositionTop=function(t,e){var i=this._oSectionInfo[t.getId()].positionTop;return e||(i+=this.iAnchorBarHeight),i},S.prototype._getSectionPositionBottom=function(t,e){var i=this._oSectionInfo[t.getId()].positionBottom;return e||(i+=this.iAnchorBarHeight),i},S.prototype._determineSectionBaseInternalTitleLevel=function(t){var e=this.getSectionTitleLevel(),i=t instanceof r;return e===p.Auto?i?p.H3:p.H4:i?e:S._getNextTitleLevelEntry(e)},S.prototype._shouldApplySectionTitleLevel=function(t){return t.getTitleLevel()===p.Auto},S.prototype._checkContentBottomRequiresSnap=function(t){var e=!1;return this._getSectionPositionBottom(t,e)>=this._getScrollableViewportHeight(e)+this._getSnapPosition()},S.prototype._computeSpacerHeight=function(t,e,i){var o,n,s;return this.getFooter()&&this.getShowFooter()&&(s=this.$(\"footerWrapper\").outerHeight()),n=this._getScrollableViewportHeight(i),i||(e=this._getSectionPositionBottom(t,!1)),e<n?(o=n-e,this._bMobileScenario&&(o+=this._oSectionInfo[t.getId()].positionTopMobile-this._oSectionInfo[t.getId()].positionTop)):o=0,s>o&&(o+=s),o},S.prototype._isFirstVisibleSectionBase=function(t){var e=this._oSectionInfo[t.getId()];return!!e&&Math.abs(e.positionTop-this.iHeaderContentHeight)<=1},S.prototype._getFirstVisibleSubSection=function(t){if(t){var e;return this._aSectionBases.every(function(i){return!i.getParent()||i.getParent().getId()!==t.getId()||(e=i,!1)}),e}},S.prototype._initAnchorBarScroll=function(){this._requestAdjustLayout(null,!0),this._sScrolledSectionId=\"\",this._onScroll({target:{scrollTop:0}})},S.prototype._setAsCurrentSection=function(e){var i,o,n;this._sScrolledSectionId!==e&&(t.sap.log.debug(\"ObjectPageLayout :: current section is \"+e),this._sScrolledSectionId=e,i=this.getAggregation(\"_anchorBar\"),i&&this._getInternalAnchorBarVisible()&&(o=sap.ui.getCore().byId(e),n=o&&o instanceof a&&(\"\"===o.getTitle().trim()||!o._getInternalTitleVisible()||o.getParent()._getIsHidden()),n&&(e=o.getParent().getId(),t.sap.log.debug(\"ObjectPageLayout :: current section is a subSection with an empty or hidden title, selecting parent \"+e)),this._oSectionInfo[e]&&(i.setSelectedButton(this._oSectionInfo[e].buttonId),this.setAssociation(\"selectedSection\",e,!0),this._setSectionsFocusValues(e))))},S.prototype._registerOnContentResize=function(){var t=this._$sectionsContainer.length&&this._$sectionsContainer[0];t&&(this._iContentResizeId&&e.deregister(this._iContentResizeId),this._iContentResizeId=e.register(t,this._onUpdateContentSize.bind(this)))},S.prototype._onUpdateContentSize=function(t){var e,i,o,n;this._requestAdjustLayout().then(function(){e=this._$opWrapper.scrollTop(),i=this.iScreenHeight,o=this._getClosestScrolledSectionId(e,i),n=this.getSelectedSection(),o&&n!==o&&this.getAggregation(\"_anchorBar\").setSelectedButton(this._oSectionInfo[o].buttonId)}.bind(this))},S.prototype._onUpdateScreenSize=function(e){return this._bDomReady?(this._oLazyLoading.setLazyLoadingParameters(),void t.sap.delayedCall(S.HEADER_CALC_DELAY,this,function(){this._bMobileScenario=u.Utilities.isPhoneScenario(this._getCurrentMediaContainerRange()),this._bTabletScenario=u.Utilities.isTabletScenario(this._getCurrentMediaContainerRange()),this._bHContentAlwaysExpanded!=this._checkAlwaysShowContentHeader()&&this.invalidate(),this._adjustHeaderHeights(),this._requestAdjustLayout(null,!0),this.getFooter()&&this.getShowFooter()&&this._shiftFooter(),this._scrollTo(this._$opWrapper.scrollTop(),0)})):void t.sap.log.info(\"ObjectPageLayout :: cannot _onUpdateScreenSize before dom is ready\")},S.prototype._onScroll=function(e){var i,o,n=Math.max(e.target.scrollTop,0),s=this.getHeaderTitle(),r=n>0&&n>=this._getSnapPosition(),a=!1;if(i=this.iScreenHeight,r&&!this._bHContentAlwaysExpanded?i-=this.iAnchorBarHeight+this.iHeaderTitleHeightStickied:r&&this._bHContentAlwaysExpanded&&(i-=this._$stickyAnchorBar.height()+this.iHeaderTitleHeight+this.iStickyHeaderContentHeight),this._bIsHeaderExpanded&&this._expandCollapseHeader(!1),!this._bHContentAlwaysExpanded&&(s&&this.getShowHeaderContent()||this.getShowAnchorBar())?this._toggleHeader(r):0==n&&(s&&this.getShowHeaderContent()||this.getShowAnchorBar())&&this._toggleHeader(!1),this._bHContentAlwaysExpanded||this._adjustHeaderTitleBackgroundPosition(n),t.sap.log.debug(\"ObjectPageLayout :: lazy loading : Scrolling at \"+n,\"----------------------------------------\"),o=this._getClosestScrolledSectionId(n,i)){var h=this.getDirectScrollingToSection();if(o!==this._sScrolledSectionId){t.sap.log.debug(\"ObjectPageLayout :: closest id \"+o,\"----------------------------------------\");var h=this.getDirectScrollingToSection();if(h&&h!==o)return;this.clearDirectScrollingToSection(),this._setAsCurrentSection(o)}else o===this.getDirectScrollingToSection()&&this.clearDirectScrollingToSection()}this.getEnableLazyLoading()&&this._oLazyLoading.lazyLoadDuringScroll(n,e.timeStamp,i),s&&this.getShowHeaderContent()&&this.getShowTitleInHeaderContent()&&s.getShowTitleSelector()&&(0===n?(t.sap.byId(this.getId()+\"-scroll\").css(\"z-index\",\"1000\"),a=!1):a||(a=!0,t.sap.byId(this.getId()+\"-scroll\").css(\"z-index\",\"0\")))},S.prototype._getSnapPosition=function(){return this.iHeaderContentHeight-(this.iHeaderTitleHeightStickied-this.iHeaderTitleHeight)},S.prototype._getClosestScrolledSectionId=function(e,i){if(this.getUseIconTabBar()&&this._oCurrentTabSection)return this._oCurrentTabSection.getId();var o,n=e+i;return t.each(this._oSectionInfo,function(t,i){var s=sap.ui.getCore().byId(t).getParent(),a=s instanceof r&&s._getIsHidden();if((i.isSection||this._bMobileScenario&&!a)&&(o||i.sectionReference._getInternalVisible()!==!0||(o=t),i.positionTop<=n&&e<=i.positionBottom&&i.positionTop<=e&&i.positionBottom>=e))return o=t,!1}.bind(this)),o},S.prototype._toggleHeader=function(t){var e=this.getHeaderTitle();this._bHContentAlwaysExpanded||this._bIsHeaderExpanded||this._$headerTitle.toggleClass(\"sapUxAPObjectPageHeaderStickied\",t),!this._bStickyAnchorBar&&t?(this._restoreFocusAfter(this._convertHeaderToStickied),e&&e._adaptLayout(),this._adjustHeaderHeights()):this._bStickyAnchorBar&&!t&&(this._restoreFocusAfter(this._convertHeaderToExpanded),e&&e._adaptLayout(),this._adjustHeaderHeights())},S.prototype._restoreFocusAfter=function(t){var e=sap.ui.getCore(),i=e.byId(e.getCurrentFocusedControlId());return t.call(this),n.system.phone!==!0&&(e.byId(e.getCurrentFocusedControlId())||i&&i.$().focus()),this},S.prototype._convertHeaderToStickied=function(){return this._bHContentAlwaysExpanded||(this._$anchorBar.children().appendTo(this._$stickyAnchorBar),this._toggleHeaderStyleRules(!0),this.iHeaderTitleHeight!=this.iHeaderTitleHeightStickied&&this._adjustHeaderBackgroundSize()),this},S.prototype._convertHeaderToExpanded=function(){return this._bHContentAlwaysExpanded||(this._$anchorBar.css(\"height\",\"auto\").append(this._$stickyAnchorBar.children()),this._toggleHeaderStyleRules(!1)),this},S.prototype._toggleHeaderStyleRules=function(t){t=!!t;var e=t?\"hidden\":\"inherit\";this._bStickyAnchorBar=t,this._$headerContent.css(\"overflow\",e),this._$headerContent.toggleClass(\"sapContrastPlus\",!t),this._$headerContent.toggleClass(\"sapUxAPObjectPageHeaderDetailsHidden\",t),this._$anchorBar.css(\"visibility\",e),this.fireToggleAnchorBar({fixed:t})},S.prototype.getScrollDelegate=function(){return this._oScroller},S.prototype.setHeaderTitle=function(t,e){return t&&\"function\"==typeof t.addEventDelegate&&t.addEventDelegate({onAfterRendering:this._adjustHeaderHeights.bind(this)}),this.setAggregation(\"headerTitle\",t,e)},S.prototype._adjustHeaderBackgroundSize=function(){var t=this.getHeaderTitle();t&&\"Dark\"==t.getHeaderDesign()&&(this._bHContentAlwaysExpanded?(this.iTotalHeaderSize=this.iHeaderTitleHeight-this._$stickyAnchorBar.height(),this._$stickyHeaderContent.css(\"background-size\",\"100% \"+this.iTotalHeaderSize+\"px\")):(this.iTotalHeaderSize=this.iHeaderTitleHeight+this.iHeaderContentHeight,this._$headerContent.css(\"background-size\",\"100% \"+this.iTotalHeaderSize+\"px\")),t.$().css(\"background-size\",\"100% \"+this.iTotalHeaderSize+\"px\"),this._adjustHeaderTitleBackgroundPosition(0))},S.prototype._adjustHeaderTitleBackgroundPosition=function(t){var e=this.getHeaderTitle();e&&\"Dark\"==e.getHeaderDesign()&&(this._bStickyAnchorBar?e.$().css(\"background-position\",\"0px \"+(this.iTotalHeaderSize-this.iHeaderTitleHeightStickied)*-1+\"px\"):this._bHContentAlwaysExpanded?e.$().css(\"background-position\",\"0px 0px\"):e.$().css(\"background-position\",\"0px \"+(this.iHeaderTitleHeight+this.iHeaderContentHeight-this.iTotalHeaderSize-t)+\"px\"))},S.prototype._adjustHeaderHeights=function(){if(this._$headerTitle.length>0){var e=this._$headerTitle.clone();this.iHeaderContentHeight=this._$headerContent.height(),this.iStickyHeaderContentHeight=this._$stickyHeaderContent.height(),this.iAnchorBarHeight=this._bStickyAnchorBar?this._$stickyAnchorBar.height():this._$anchorBar.height(),e.css({left:\"-10000px\",top:\"-10000px\",width:this._$headerTitle.width()+\"px\"}),this._bStickyAnchorBar?(this.iHeaderTitleHeightStickied=this._$headerTitle.height()-this.iAnchorBarHeight,e.removeClass(\"sapUxAPObjectPageHeaderStickied\"),e.appendTo(this._$headerTitle.parent()),this.iHeaderTitleHeight=e.is(\":visible\")?e.height()-this.iAnchorBarHeight:0):(this.iHeaderTitleHeight=this._$headerTitle.is(\":visible\")?this._$headerTitle.height():0,e.addClass(\"sapUxAPObjectPageHeaderStickied\"),e.appendTo(this._$headerTitle.parent()),this.iHeaderTitleHeightStickied=e.height()),e.remove(),this._adjustHeaderBackgroundSize(),t.sap.log.info(\"ObjectPageLayout :: adjustHeaderHeight\",\"headerTitleHeight: \"+this.iHeaderTitleHeight+\" - headerTitleStickiedHeight: \"+this.iHeaderTitleHeightStickied+\" - headerContentHeight: \"+this.iHeaderContentHeight)}else t.sap.log.debug(\"ObjectPageLayout :: adjustHeaderHeight\",\"skipped as the objectPageLayout is being rendered\")},S.prototype._getHeaderDesign=function(){var t=this.getHeaderTitle(),e=u.ObjectPageHeaderDesign.Light;return null!=t&&(e=t.getHeaderDesign()),e},S.prototype._getVisibleSections=function(){return this.getSections().filter(function(t){\nreturn t.getVisible()&&t._getInternalVisible()})},S.prototype._setSectionsFocusValues=function(t){var e,i,o=this._getVisibleSections()||[],n=\"0\",s=\"-1\",r=\"tabIndex\",a=o[0];return o.forEach(function(o){e=o.$(),t===o.sId?(e.attr(r,n),i=o,o._setSubSectionsFocusValues()):(e.attr(r,s),o._disableSubSectionsFocus())}),!i&&o.length>0&&(a.$().attr(r,n),a._setSubSectionsFocusValues(),i=a),i},S.prototype.setShowHeaderContent=function(t){var e=this.getShowHeaderContent();return e!==t&&(e&&this._bIsHeaderExpanded&&this._expandCollapseHeader(!1),this.setProperty(\"showHeaderContent\",t),this._getHeaderContent().setProperty(\"visible\",t)),this},S.prototype._headerTitleChangeHandler=function(t){var e;this.getShowTitleInHeaderContent()&&(t&&this._getHeaderContent()._destroyObjectImage(!0),e=sap.ui.getCore().createRenderManager(),this.getRenderer()._rerenderHeaderContentArea(e,this),this._getHeaderContent().invalidate(),e.destroy())},S.prototype.getHeaderContent=function(){return this._getHeaderContent().getAggregation(\"content\")},S.prototype.insertHeaderContent=function(t,e,i){return this._getHeaderContent().insertAggregation(\"content\",t,e,i)},S.prototype.addHeaderContent=function(t,e){return this._getHeaderContent().addAggregation(\"content\",t,e)},S.prototype.removeAllHeaderContent=function(t){return this._getHeaderContent().removeAllAggregation(\"content\",t)},S.prototype.removeHeaderContent=function(t,e){return this._getHeaderContent().removeAggregation(\"content\",t,e)},S.prototype.destroyHeaderContent=function(t){return this._getHeaderContent().destroyAggregation(\"content\",t)},S.prototype.indexOfHeaderContent=function(t){return this._getHeaderContent().indexOfAggregation(\"content\",t)},S.prototype._getHeaderContent=function(){return this.getAggregation(\"_headerContent\")||this.setAggregation(\"_headerContent\",new u.ObjectPageHeaderContent({visible:this.getShowHeaderContent(),contentDesign:this._getHeaderDesign(),content:this.getAggregation(\"headerContent\",[])}),!0),this.getAggregation(\"_headerContent\")},S.prototype._checkAlwaysShowContentHeader=function(){return!this._bMobileScenario&&!this._bTabletScenario&&this.getShowHeaderContent()&&this.getAlwaysShowContentHeader()},S.prototype._connectModelsForSections=function(t){t=t||[],t.forEach(function(t){t.connectToModels()})},S.prototype._getHeightRelatedParameters=function(){return{iHeaderContentHeight:this.iHeaderContentHeight,iScreenHeight:this.iScreenHeight,iAnchorBarHeight:this.iAnchorBarHeight,iHeaderTitleHeightStickied:this.iHeaderTitleHeightStickied,iStickyHeaderContentHeight:this.iStickyHeaderContentHeight,iScrollTop:this._$opWrapper.scrollTop()}},S.prototype._hasVerticalScrollBar=function(){return this._getCustomScrollBar().getVisible()===!0},S.prototype._shiftHeader=function(t,e){this.$().find(\".sapUxAPObjectPageHeaderTitle\").css(\"padding-\"+t,e)},S.prototype._isFirstSection=function(t){var e=this._getVisibleSections();return t===e[0]},S.prototype._restoreScrollPosition=function(){this._scrollTo(this._iStoredScrollPosition,0)},S.prototype._storeScrollLocation=function(){if(this._iStoredScrollPosition=this._oScroller.getScrollTop(),this._oStoredSection=this._oCurrentTabSubSection||this._oCurrentTabSection||sap.ui.getCore().byId(this.getSelectedSection()),this._oStoredSection){var t=this._aSectionBases.map(function(t){return t.getId()});t.indexOf(this._oStoredSection.getId())===-1&&(this._oStoredSection=null)}this._oCurrentTabSection=null},S.prototype.onkeyup=function(e){var i,o;e.which===t.sap.KeyCodes.TAB&&(i=sap.ui.getCore().getCurrentFocusedControlId(),o=i&&sap.ui.getCore().byId(i),o&&this._isFirstSection(o)&&this._scrollTo(0,0))},S.prototype.setShowFooter=function(t){var e=this.setProperty(\"showFooter\",t,!0);return this._toggleFooter(t),e},S.prototype._toggleFooter=function(e){var i=sap.ui.getCore().getConfiguration().getAnimation(),o=this.getFooter();_(o)&&(o.toggleStyleClass(\"sapUxAPObjectPageFloatingFooterShow\",e),o.toggleStyleClass(\"sapUxAPObjectPageFloatingFooterHide\",!e),this._iFooterWrapperHideTimeout&&t.sap.clearDelayedCall(this._iFooterWrapperHideTimeout),i&&(e?(this.$(\"footerWrapper\").toggleClass(\"sapUiHidden\",!e),this._iFooterWrapperHideTimeout=null):this._iFooterWrapperHideTimeout=t.sap.delayedCall(S.FOOTER_ANIMATION_DURATION,this,function(){this.$(\"footerWrapper\").toggleClass(\"sapUiHidden\",!e)}),t.sap.delayedCall(S.FOOTER_ANIMATION_DURATION,this,function(){o.removeStyleClass(\"sapUxAPObjectPageFloatingFooterShow\")})),this._requestAdjustLayout())},S.prototype.clone=function(){return Object.keys(this.mAggregations).forEach(this._cloneProxiedAggregations,this),i.prototype.clone.apply(this,arguments)},S.prototype._cloneProxiedAggregations=function(t){var e=this.mAggregations[t];Array.isArray(e)&&0===e.length&&(e=this[\"get\"+t.charAt(0).toUpperCase()+t.slice(1)]()),this.mAggregations[t]=e},S});",
		"sap/uxap/ObjectPageLayoutABHelper.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/Metadata\",\"sap/ui/core/CustomData\",\"./AnchorBar\",\"sap/m/Button\",\"sap/ui/core/IconPool\"],function(t,e,o,a,n,i){\"use strict\";var r=e.createClass(\"sap.uxap._helpers.AB\",{constructor:function(t){this._oObjectPageLayout=t,this._iScrollDuration=t._iScrollToSectionDuration}});return r.prototype.getObjectPageLayout=function(){return this._oObjectPageLayout},r.prototype._getAnchorBar=function(){var t=this.getObjectPageLayout().getAggregation(\"_anchorBar\");return t||(t=new a({id:this.getObjectPageLayout().getId()+\"-anchBar\",showPopover:this.getObjectPageLayout().getShowAnchorBarPopover()}),this.getObjectPageLayout().setAggregation(\"_anchorBar\",t,!0)),t},r.prototype._buildAnchorBar=function(){var t=this.getObjectPageLayout().getSections()||[],e=this._getAnchorBar();e&&this.getObjectPageLayout().getShowAnchorBar()&&(e._resetControl(),t.forEach(function(t){if(t.getVisible()&&t._getInternalVisible()){var o,a=t.getSubSections()||[];o=this._buildAnchorBarButton(t,!0),o&&(e.addContent(o),a.forEach(function(t){if(t.getVisible()&&t._getInternalVisible()){var o=this._buildAnchorBarButton(t,!1);o&&e.addContent(o)}},this))}},this))},r.prototype._focusOnSectionWhenUsingKeyboard=function(e){var o=e.srcControl.data(),a=sap.ui.getCore().byId(o.sectionId),n=this.getObjectPageLayout();!a||o.bHasSubMenu||n.getUseIconTabBar()||t.sap.delayedCall(this._iScrollDuration,a.$(),\"focus\")},r.prototype._buildAnchorBarButton=function(t,e){var a,r,s=null,c=this.getObjectPageLayout(),u=this._getAnchorBar(),g=t.getAggregation(\"subSections\"),l=this._focusOnSectionWhenUsingKeyboard.bind(this),h={onsapenter:l,onsapspace:l};if(t.getVisible()&&t._getInternalVisible()){if(a=t.getCustomAnchorBarButton())s=a.clone();else{r=u.getId()+\"-\"+t.getId()+\"-anchor\",s=new n({ariaDescribedBy:t,id:r}),s.addEventDelegate(h);var d=\"\"!=t._getInternalTitle()?t._getInternalTitle():t.getTitle();s.setText(d)}if(c._oSectionInfo[t.getId()].buttonId=s.getId(),s.addCustomData(new o({key:\"sectionId\",value:t.getId()})),s.addCustomData(new o({key:\"bTitleVisible\",value:t._getInternalTitleVisible()})),e||s.addCustomData(new o({key:\"secondLevel\",value:!0})),g&&g.length>1){var b=g.filter(function(t){return t.getVisible()}).length;b>1&&(s.addCustomData(new o({key:\"bHasSubMenu\",value:!0})),c.getShowAnchorBarPopover()&&(s.setIcon(i.getIconURI(\"slim-arrow-down\")),s.setIconFirst(!1)))}}return s},r},!1);",
		"sap/uxap/ObjectPageLayoutRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/Renderer\",\"./ObjectPageHeaderRenderer\"],function(e,t){\"use strict\";var r={};return r.render=function(e,t){var r,a=t.getHeaderTitle(),s=null,i=t.getHeaderContent()&&t.getHeaderContent().length>0&&t.getShowHeaderContent(),n=t.getShowTitleInHeaderContent()&&t.getShowHeaderContent(),d=i||n;t.getShowAnchorBar()&&t._getInternalAnchorBarVisible()&&(s=t.getAggregation(\"_anchorBar\")),e.write(\"<div\"),e.writeControlData(t),a&&e.writeAttributeEscaped(\"aria-label\",a.getObjectTitle()),e.addClass(\"sapUxAPObjectPageLayout\"),e.writeClasses(),e.addStyle(\"height\",t.getHeight()),e.writeStyles(),e.write(\">\"),sap.ui.Device.system.desktop&&e.renderControl(t._getCustomScrollBar().addStyleClass(\"sapUxAPObjectPageCustomScroller\")),e.write(\"<header \"),e.writeAttribute(\"role\",\"banner\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-headerTitle\"),e.addClass(\"sapUxAPObjectPageHeaderTitle\"),e.addClass(\"sapContrastPlus\"),e.writeClasses(),e.write(\">\"),a&&e.renderControl(a),this._renderHeaderContentDOM(e,t,d&&t._bHContentAlwaysExpanded,\"-stickyHeaderContent\"),e.write(\"<div \"),e.writeAttributeEscaped(\"id\",t.getId()+\"-stickyAnchorBar\"),e.addClass(\"sapUxAPObjectPageStickyAnchorBar\"),e.addClass(\"sapUxAPObjectPageNavigation\"),e.writeClasses(),e.write(\">\"),this._renderAnchorBar(e,t,s,t._bHContentAlwaysExpanded),e.write(\"</div>\"),e.write(\"</header>\"),e.write(\"<div \"),e.writeAttributeEscaped(\"id\",t.getId()+\"-opwrapper\"),e.addClass(\"sapUxAPObjectPageWrapper\"),t.getShowTitleInHeaderContent()&&a.getShowTitleSelector()||e.addClass(\"sapUxAPObjectPageWrapperTransform\"),e.writeClasses(),e.write(\">\"),e.write(\"<div \"),e.writeAttributeEscaped(\"id\",t.getId()+\"-scroll\"),e.addClass(\"sapUxAPObjectPageScroll\"),e.writeClasses(),e.write(\">\"),this._renderHeaderContentDOM(e,t,d&&!t._bHContentAlwaysExpanded,\"-headerContent\",!0),e.write(\"<section \"),e.writeAttributeEscaped(\"id\",t.getId()+\"-anchorBar\"),e.writeAttribute(\"role\",\"navigation\"),e.addClass(\"sapUxAPObjectPageNavigation\"),e.addClass(\"sapContrastPlus\"),e.writeClasses(),e.write(\">\"),this._renderAnchorBar(e,t,s,!t._bHContentAlwaysExpanded),e.write(\"</section>\"),e.write(\"<section\"),e.addClass(\"sapUxAPObjectPageContainer\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-sectionsContainer\"),e.addClass(\"ui-helper-clearfix\"),s||e.addClass(\"sapUxAPObjectPageContainerNoBar\"),e.writeClasses(),e.write(\">\"),r=t._getSectionsToRender(),jQuery.isArray(r)&&jQuery.each(r,function(t,r){e.renderControl(r)}),e.write(\"</section>\"),this.renderFooterContent(e,t),e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-spacer\"),e.write(\"></div>\"),e.write(\"</div>\"),e.write(\"</div>\"),this._renderFooterContentInternal(e,t),e.write(\"</div>\")},r._renderAnchorBar=function(e,t,r,a){var s=t.getAggregation(\"sections\");a&&(t.getIsChildPage()&&(e.write(\"<div \"),e.writeAttributeEscaped(\"id\",t.getId()+\"-childPageBar\"),jQuery.isArray(s)&&s.length>1&&e.addClass(\"sapUxAPObjectChildPage\"),e.writeClasses(),e.write(\"></div>\")),r&&e.renderControl(r))},r._renderHeaderContentDOM=function(e,t,r,a,s){e.write(\"<header \"),e.writeAttributeEscaped(\"id\",t.getId()+a),e.addClass(\"ui-helper-clearfix\"),e.addClass(\"sapUxAPObjectPageHeaderDetails\"),e.addClass(\"sapUxAPObjectPageHeaderDetailsDesign-\"+t._getHeaderDesign()),s&&e.addClass(\"sapContrastPlus\"),e.writeClasses(),e.writeAttribute(\"data-sap-ui-customfastnavgroup\",!0),e.write(\">\"),r&&this.renderHeaderContent(e,t),e.write(\"</header>\")},r.renderHeaderContent=function(e,t){e.renderControl(t._getHeaderContent())},r.renderFooterContent=function(e,t){},r._renderFooterContentInternal=function(e,t){var r=t.getFooter();r&&(e.write(\"<footer\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-footerWrapper\"),e.addClass(\"sapUxAPObjectPageFooter sapMFooter-CTX sapContrast sapContrastPlus\"),t.getShowFooter()||e.addClass(\"sapUiHidden\"),e.writeClasses(),e.write(\">\"),r.addStyleClass(\"sapUxAPObjectPageFloatingFooter\"),e.renderControl(r),e.write(\"</footer>\"))},r._rerenderHeaderContentArea=function(e,t){var r,a=t._bHContentAlwaysExpanded?\"stickyHeaderContent\":\"headerContent\";this.renderHeaderContent(e,t),r=t.$(a)[0],r&&e.flush(r)},r},!0);",
		"sap/uxap/ObjectPageLazyLoader.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"./library\",\"sap/ui/core/Element\",\"sap/ui/core/StashedControlSupport\"],function(t,e,a){\"use strict\";var n=e.extend(\"sap.uxap.ObjectPageLazyLoader\",{metadata:{library:\"sap.uxap\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"}},defaultAggregation:\"content\"}});return a.mixInto(n),n.prototype.setParent=function(t){return null===t||t instanceof sap.uxap.ObjectPageSubSection||jQuery.sap.assert(!1,\"setParent(): oParent must be an instance of sap.uxap.ObjectPageSubSection or null\"),e.prototype.setParent.apply(this,arguments)},n},!0);",
		"sap/uxap/ObjectPageSection.designtime.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{name:{singular:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"SECTION_CONTROL_NAME\")},plural:function(){return sap.uxap.i18nModel.getResourceBundle().getText(\"SECTION_CONTROL_NAME_PLURAL\")}},actions:{remove:{changeType:\"stashControl\"},reveal:{changeType:\"unstashControl\"}}}},!1);",
		"sap/uxap/ObjectPageSection.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/InvisibleText\",\"./ObjectPageSectionBase\",\"sap/ui/Device\",\"sap/m/Button\",\"sap/ui/core/StashedControlSupport\",\"./ObjectPageSubSection\",\"./library\"],function(t,e,o,i,n,s,a,u){\"use strict\";var r=o.extend(\"sap.uxap.ObjectPageSection\",{metadata:{library:\"sap.uxap\",properties:{showTitle:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},titleUppercase:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},defaultAggregation:\"subSections\",aggregations:{subSections:{type:\"sap.uxap.ObjectPageSubSection\",multiple:!0,singularName:\"subSection\"},ariaLabelledBy:{type:\"sap.ui.core.InvisibleText\",multiple:!1,visibility:\"hidden\"},_showHideAllButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"},_showHideButton:{type:\"sap.m.Button\",multiple:!1,visibility:\"hidden\"}},associations:{selectedSubSection:{type:\"sap.uxap.ObjectPageSubSection\",multiple:!1}},designTime:!0}});return r.MEDIA_RANGE=i.media.RANGESETS.SAP_STANDARD,r._getClosestSection=function(t){return t instanceof a?t.getParent():t},r.prototype._expandSection=function(){o.prototype._expandSection.call(this)._updateShowHideAllButton(!this._thereAreHiddenSubSections())},r.prototype.init=function(){o.prototype.init.call(this),this._sContainerSelector=\".sapUxAPObjectPageSectionContainer\"},r.prototype.exit=function(){this._detachMediaContainerWidthChange(this._updateImportance,this)},r.prototype._getImportanceLevelToHide=function(t){var e=this._getObjectPageLayout(),o=t||this._getCurrentMediaContainerRange(),i=e&&e.getShowOnlyHighImportance();return this._determineTheLowestLevelOfImportanceToShow(o.name,i)},r.prototype._updateImportance=function(t){var e=this._getObjectPageLayout(),o=this._getImportanceLevelToHide(t);this.getSubSections().forEach(function(t){t._applyImportanceRules(o)}),this._applyImportanceRules(o),this._updateShowHideAllButton(!1),e&&this.getDomRef()&&e._requestAdjustLayout()},r.prototype._determineTheLowestLevelOfImportanceToShow=function(t,e){return e||\"Phone\"===t?u.Importance.High:\"Tablet\"===t?u.Importance.Medium:u.Importance.Low},r.prototype.connectToModels=function(){this.getSubSections().forEach(function(t){t.connectToModels()})},r.prototype._allowPropagationToLoadedViews=function(t){this.getSubSections().forEach(function(e){e._allowPropagationToLoadedViews(t)})},r.prototype.onBeforeRendering=function(){var t=\"ariaLabelledBy\";this.getAggregation(t)||this.setAggregation(t,this._getAriaLabelledBy(),!0),this._detachMediaContainerWidthChange(this._updateImportance,this),this._updateImportance()},r.prototype.onAfterRendering=function(){this._attachMediaContainerWidthChange(this._updateImportance,this)},r.prototype._getAriaLabelledBy=function(){return new e({text:this._getInternalTitle()||this.getTitle()}).toStatic()},r.prototype._setSubSectionsFocusValues=function(){var t,e=this.getSubSections()||[],o=this.getSelectedSubSection();return 0===e.length?this:1===e.length?(e[0]._setToFocusable(!1),this):(e.forEach(function(e){o===e.sId?(e._setToFocusable(!0),t=!0):e._setToFocusable(!1)}),t||e[0]._setToFocusable(!0),this)},r.prototype._disableSubSectionsFocus=function(){var t=this.getSubSections()||[];return t.forEach(function(t){t._setToFocusable(!1)}),this},r.prototype._thereAreHiddenSubSections=function(){return this.getSubSections().some(function(t){return t._getIsHidden()})},r.prototype._updateShowHideSubSections=function(t){this.getSubSections().forEach(function(e){t&&e._shouldBeHidden()?e._updateShowHideState(!0):t||e._updateShowHideState(!1)})},r.prototype._getShouldDisplayShowHideAllButton=function(){return this.getSubSections().some(function(t){return t._shouldBeHidden()})},r.prototype._showHideContentAllContent=function(){var t=this._thereAreHiddenSubSections();this._getIsHidden()&&t&&this._updateShowHideState(!1),this._updateShowHideSubSections(!t),this._updateShowHideAllButton(t)},r.prototype._updateShowHideState=function(t){return this._updateShowHideButton(t),this._getShowHideAllButton().setVisible(this._getShouldDisplayShowHideAllButton()),o.prototype._updateShowHideState.call(this,t)},r.prototype._updateShowHideAllButton=function(t){this._getShowHideAllButton().setVisible(this._getShouldDisplayShowHideAllButton()).setText(this._getShowHideAllButtonText(t))},r.prototype._getShowHideAllButton=function(){return this.getAggregation(\"_showHideAllButton\")||this.setAggregation(\"_showHideAllButton\",new n({visible:this._getShouldDisplayShowHideAllButton(),text:this._getShowHideAllButtonText(!this._thereAreHiddenSubSections()),press:this._showHideContentAllContent.bind(this),type:sap.m.ButtonType.Transparent}).addStyleClass(\"sapUxAPSectionShowHideButton\"),!0),this.getAggregation(\"_showHideAllButton\")},r.prototype._getShowHideButtonText=function(t){return u.i18nModel.getResourceBundle().getText(t?\"HIDE\":\"SHOW\")},r.prototype._getShowHideAllButtonText=function(t){return u.i18nModel.getResourceBundle().getText(t?\"HIDE_ALL\":\"SHOW_ALL\")},r.prototype._updateShowHideButton=function(t){this._getShowHideButton().setVisible(this._shouldBeHidden()).setText(this._getShowHideButtonText(!t))},r.prototype._getShowHideButton=function(){return this.getAggregation(\"_showHideButton\")||this.setAggregation(\"_showHideButton\",new n({visible:this._shouldBeHidden(),text:this._getShowHideButtonText(!this._getIsHidden()),press:this._showHideContent.bind(this),type:sap.m.ButtonType.Transparent}).addStyleClass(\"sapUxAPSectionShowHideButton\"),!0),this.getAggregation(\"_showHideButton\")},s.mixInto(r),r});",
		"sap/uxap/ObjectPageSectionBase.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/TitleLevel\",\"./library\"],function(t,e,i,n){\"use strict\";var o=e.extend(\"sap.uxap.ObjectPageSectionBase\",{metadata:{abstract:!0,library:\"sap.uxap\",properties:{title:{type:\"string\",group:\"Appearance\",defaultValue:null},titleLevel:{type:\"sap.ui.core.TitleLevel\",group:\"Appearance\",defaultValue:sap.ui.core.TitleLevel.Auto},visible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},importance:{type:\"sap.uxap.Importance\",group:\"Behavior\",defaultValue:n.Importance.High}},aggregations:{customAnchorBarButton:{type:\"sap.m.Button\",multiple:!1}}}});return o.prototype.init=function(){this._bInternalVisible=!0,this._bInternalTitleVisible=!0,this._sInternalTitle=\"\",this._sInternalTitleLevel=i.Auto,this._isHidden=!1,this._bRtl=sap.ui.getCore().getConfiguration().getRTL()},o.prototype.onAfterRendering=function(){this._getObjectPageLayout()&&(this._getObjectPageLayout()._requestAdjustLayout().catch(function(){t.sap.log.debug(\"ObjectPageSectionBase :: cannot adjustLayout\",this)}),this._getObjectPageLayout()._setSectionsFocusValues())},o.prototype.setCustomAnchorBarButton=function(t){var e=this.setAggregation(\"customAnchorBarButton\",t,!0);return this._getObjectPageLayout()&&this._getObjectPageLayout()._updateNavigation(),e},o.prototype._setInternalVisible=function(t,e){t!=this._bInternalVisible&&(this._bInternalVisible=t,e&&this.invalidate())},o.prototype._getInternalVisible=function(){return this._bInternalVisible},o.prototype._setInternalTitleVisible=function(t,e){t!=this._bInternalTitleVisible&&(this._bInternalTitleVisible=t,e&&this.invalidate())},o.prototype._getInternalTitleVisible=function(){return this._bInternalTitleVisible},o.prototype._setInternalTitle=function(t,e){t!=this._sInternalTitle&&(this._sInternalTitle=t,e&&this.invalidate())},o.prototype._getInternalTitle=function(){return this._sInternalTitle},o.prototype._getARIALevel=function(){return this._getTitleLevel().slice(-1)},o.prototype._getTitleLevel=function(){var t=this.getTitleLevel();return t===i.Auto?this._getInternalTitleLevel():t},o.prototype._setInternalTitleLevel=function(t){this._sInternalTitleLevel=t},o.prototype._getInternalTitleLevel=function(){return this._sInternalTitleLevel},o.prototype._getObjectPageLayout=function(){return n.Utilities.getClosestOPL(this)},o.prototype._notifyObjectPageLayout=function(){this._getObjectPageLayout()&&this._getObjectPageLayout().$().length&&this._getObjectPageLayout()._adjustLayoutAndUxRules()},[\"addAggregation\",\"insertAggregation\",\"removeAllAggregation\",\"removeAggregation\",\"destroyAggregation\"].forEach(function(t){o.prototype[t]=function(i,n,o,r){[\"addAggregation\",\"removeAggregation\"].indexOf(t)>-1&&(r=o),[\"removeAllAggregation\",\"destroyAggregation\"].indexOf(t)>-1&&(r=n);var a=e.prototype[t].apply(this,arguments);return r!==!0&&this._notifyObjectPageLayout(),a}}),o.prototype.setVisible=function(t,e){return this._getObjectPageLayout()?(this.setProperty(\"visible\",t,!0),this._getObjectPageLayout()._adjustLayoutAndUxRules(),this.invalidate(),this):this.setProperty(\"visible\",t,e)},o.prototype.setTitle=function(t,e){return this.setProperty(\"title\",t,e),this._notifyObjectPageLayout(),this},o.prototype._shouldBeHidden=function(){return o._importanceMap[this.getImportance()]>o._importanceMap[this._sCurrentLowestImportanceLevelToShow]},o._importanceMap={Low:3,Medium:2,High:1},o.prototype._updateShowHideState=function(t){var e=this._getObjectPageLayout();return this._isHidden=t,this.$().children(this._sContainerSelector).toggle(!t),e&&e._requestAdjustLayout(),this},o.prototype._getIsHidden=function(){return this._isHidden},o.prototype._expandSection=function(){return this._updateShowHideState(!1)},o.prototype._showHideContent=function(){return this._updateShowHideState(!this._getIsHidden())},o.prototype._applyImportanceRules=function(t){this._sCurrentLowestImportanceLevelToShow=t,this.getDomRef()?this._updateShowHideState(this._shouldBeHidden()):this._isHidden=this._shouldBeHidden()},o.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5,o.prototype.onkeydown=function(e){if(e.keyCode===t.sap.KeyCodes.F7){var i,n=this.getSubSections(),o=n[0];1===n.length?(i=o._oLastFocusedControlF7,i?i.$().focus():o.$().firstFocusableDomRef().focus()):o.getActions().length&&o.getActions()[0].$().focus()}},o.prototype.onsapdown=function(t){this._handleFocusing(t,t.currentTarget.nextSibling)},o.prototype._handleFocusing=function(e,i){this._targetIsCorrect(e)&&i&&(e.preventDefault(),i.focus(),this._scrollParent(t(i).attr(\"id\")))},o.prototype._targetIsCorrect=function(t){return t.srcControl===this},o.prototype.onsapright=function(t){var e=this._bRtl?\"onsapup\":\"onsapdown\";this[e](t)},o.prototype.onsapup=function(t){this._handleFocusing(t,t.currentTarget.previousSibling)},o.prototype.onsapleft=function(t){var e=this._bRtl?\"onsapdown\":\"onsapup\";this[e](t)},o.prototype.onsaphome=function(t){this._handleFocusing(t,t.currentTarget.parentElement.firstChild)},o.prototype.onsapend=function(t){this._handleFocusing(t,t.currentTarget.parentElement.lastChild)},o.prototype.onsappageup=function(e){if(this._targetIsCorrect(e)){e.preventDefault();var i,n,r=t(e.currentTarget).parent().children();r.each(function(n,r){if(t(r).attr(\"id\")===e.currentTarget.id)return void(i=n-(o.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1))}),i&&r[i]?(r[i].focus(),n=t(r[i]).attr(\"id\")):r[0]&&(r[0].focus(),n=t(r[0]).attr(\"id\")),this._scrollParent(n)}},o.prototype.onsappagedown=function(e){if(this._targetIsCorrect(e)){e.preventDefault();var i,n,r=t(e.currentTarget).parent().children();r.each(function(n,r){if(t(r).attr(\"id\")===e.currentTarget.id)return void(i=n+o.PAGEUP_AND_PAGEDOWN_JUMP_SIZE+1)}),i&&r[i]?(r[i].focus(),n=t(r[i]).attr(\"id\")):r[r.length-1]&&(r[r.length-1].focus(),n=t(r[r.length-1]).attr(\"id\")),this._scrollParent(n)}},o.prototype._scrollParent=function(t){this._getObjectPageLayout()&&this._getObjectPageLayout().scrollToSection(t,0,10)},o});",
		"sap/uxap/ObjectPageSectionRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e={};return e.render=function(e,t){if(t.getVisible()&&t._getInternalVisible()){var i=t._getInternalTitle()?t._getInternalTitle():t.getTitle();e.write(\"<section \"),e.addClass(\"sapUxAPObjectPageSection\"),e.writeClasses(),e.writeAttribute(\"role\",\"region\"),e.writeAttributeEscaped(\"aria-labelledby\",t.getAggregation(\"ariaLabelledBy\").getId()),e.writeControlData(t),e.write(\">\"),t.getShowTitle()&&t._getInternalTitleVisible()&&(e.write(\"<div\"),e.writeAttribute(\"role\",\"heading\"),e.writeAttribute(\"aria-level\",t._getARIALevel()),e.writeAttributeEscaped(\"id\",t.getId()+\"-header\"),e.addClass(\"sapUxAPObjectPageSectionHeader\"),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-title\"),e.addClass(\"sapUxAPObjectPageSectionTitle\"),t.getTitleUppercase()&&e.addClass(\"sapUxAPObjectPageSectionTitleUppercase\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(i),e.write(\"</div>\"),e.renderControl(t._getShowHideAllButton()),e.renderControl(t._getShowHideButton()),e.write(\"</div>\")),e.write(\"<div\"),e.addClass(\"sapUxAPObjectPageSectionContainer\"),e.writeClasses(),t._isHidden&&e.addStyle(\"display\",\"none\"),e.writeStyles(),e.write(\">\"),t.getSubSections().forEach(e.renderControl),e.write(\"</div>\"),e.write(\"</section>\")}},e},!0);",
		"sap/uxap/ObjectPageSubSection.designtime.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{aggregations:{actions:{domRef:\":sap-domref .sapUxAPObjectPageSubSectionHeaderActions\",actions:{move:{changeType:\"moveControls\"}}}}}},!1);",
		"sap/uxap/ObjectPageSubSection.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/CustomData\",\"sap/ui/layout/Grid\",\"sap/ui/layout/GridData\",\"./ObjectPageSectionBase\",\"./ObjectPageSubSectionLayout\",\"./ObjectPageSubSectionMode\",\"./ObjectPageLazyLoader\",\"./BlockBase\",\"sap/m/Button\",\"sap/ui/Device\",\"sap/ui/core/StashedControlSupport\",\"./library\"],function(t,e,o,i,n,a,r,s,g,c,u,l,h){\"use strict\";var p=n.extend(\"sap.uxap.ObjectPageSubSection\",{metadata:{library:\"sap.uxap\",properties:{mode:{type:\"sap.uxap.ObjectPageSubSectionMode\",group:\"Appearance\",defaultValue:r.Collapsed},titleUppercase:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},defaultAggregation:\"blocks\",aggregations:{_grid:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"},blocks:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"block\"},moreBlocks:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"moreBlock\"},actions:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"action\"}},designTime:!0}});return p.MEDIA_RANGE=u.media.RANGESETS.SAP_STANDARD,p.prototype.init=function(){n.prototype.init.call(this),this._bRenderedFirstTime=!1,this._aAggregationProxy={blocks:[],moreBlocks:[]},this._$spacer=[],this._sContainerSelector=\".sapUxAPBlockContainer\",this._switchSubSectionMode(this.getMode())},p.prototype._expandSection=function(){n.prototype._expandSection.call(this);var t=this.getParent();return t&&\"function\"==typeof t._expandSection&&t._expandSection(),this},p.prototype._getGrid=function(){return this.getAggregation(\"_grid\")||this.setAggregation(\"_grid\",new o({id:this.getId()+\"-innerGrid\",defaultSpan:\"XL12 L12 M12 S12\",hSpacing:1,vSpacing:1,width:\"100%\",containerQuery:!0}),!0),this.getAggregation(\"_grid\")},p.prototype._unStashControls=function(){l.getStashedControls(this.getId()).forEach(function(t){t.setStashed(!1)})},p.prototype.connectToModels=function(){var t=this.getBlocks()||[],e=this.getMoreBlocks()||[],o=this.getMode();this._unStashControls(),t.forEach(function(t){t instanceof g&&(t.getMode()||t.setMode(o),t.connectToModels())}),e.length>0&&o===r.Expanded&&e.forEach(function(t){t instanceof g&&(t.getMode()||t.setMode(o),t.connectToModels())})},p.prototype._allowPropagationToLoadedViews=function(t){var e=this.getBlocks()||[],o=this.getMoreBlocks()||[];e.forEach(function(e){e instanceof g&&e._allowPropagationToLoadedViews(t)}),o.forEach(function(e){e instanceof g&&e._allowPropagationToLoadedViews(t)})},p.prototype.clone=function(){return Object.keys(this._aAggregationProxy).forEach(function(t){var e=this.mAggregations[t];e&&0!==e.length||(this.mAggregations[t]=this._aAggregationProxy[t])},this),sap.ui.core.Control.prototype.clone.apply(this,arguments)},p.prototype._cleanProxiedAggregations=function(){var t=this._aAggregationProxy;Object.keys(t).forEach(function(e){t[e].forEach(function(t){t.destroy()})})},p.prototype.exit=function(){this._oSeeMoreButton&&(this._oSeeMoreButton.destroy(),this._oSeeMoreButton=null),this._detachMediaContainerWidthChange(this._synchronizeBlockLayouts,this),this._cleanProxiedAggregations(),n.prototype.exit&&n.prototype.exit.call(this)},p.prototype.onAfterRendering=function(){var e=this._getObjectPageLayout();n.prototype.onAfterRendering&&n.prototype.onAfterRendering.call(this),e&&(this._synchronizeBlockLayouts(),this._attachMediaContainerWidthChange(this._synchronizeBlockLayouts,this),this._$spacer=t.sap.byId(e.getId()+\"-spacer\"))},p.prototype.onBeforeRendering=function(){n.prototype.onBeforeRendering&&n.prototype.onBeforeRendering.call(this),this._detachMediaContainerWidthChange(this._synchronizeBlockLayouts,this),this._setAggregationProxy(),this._getGrid().removeAllContent(),this._applyLayout(this._getObjectPageLayout()),this.refreshSeeMoreVisibility()},p.prototype._applyLayout=function(e){var o,i=this._getGrid(),n=this.getMode(),a=e.getSubSectionLayout(),s=this._calculateLayoutConfiguration(a,e),g=this.getBlocks(),c=g.concat(this.getMoreBlocks());this._oLayoutConfig=s,this._resetLayoutData(c),o=n===r.Expanded?c:g,this._calcBlockColumnLayout(o,this._oLayoutConfig);try{o.forEach(function(t){this._setBlockMode(t,n),i.addAggregation(\"content\",t,!0)},this)}catch(e){t.sap.log.error(\"ObjectPageSubSection :: error while building layout \"+a+\": \"+e)}return this},p.prototype._calculateLayoutConfiguration=function(t,e){var o={M:2,L:3,XL:4},i=o.L,n=o.XL,r=t===a.TitleOnLeft,s=e.getUseTwoColumnsForLargeScreen();return r&&(i-=1,n-=1),s&&(i-=1),o.L=i,o.XL=n,o},p.prototype.refreshSeeMoreVisibility=function(){var t=!!this.getMoreBlocks().length,e=this._getSeeMoreButton(),o=e.$(),i=this.$();return t||(t=this.getBlocks().some(function(t){if(t instanceof g&&t.getVisible()&&t.getShowSubSectionMore())return!0})),i.length&&i.toggleClass(\"sapUxAPObjectPageSubSectionWithSeeMore\",t),this.toggleStyleClass(\"sapUxAPObjectPageSubSectionWithSeeMore\",t),o.length&&o.toggleClass(\"sapUxAPSubSectionSeeMoreButtonVisible\",t),e.toggleStyleClass(\"sapUxAPSubSectionSeeMoreButtonVisible\",t),t},p.prototype.setMode=function(t){return this.getMode()!==t&&(this._switchSubSectionMode(t),this._bRenderedFirstTime&&this.rerender()),this},p.prototype.onkeydown=function(e){if(e.keyCode===t.sap.KeyCodes.F7){e.stopPropagation();var o=sap.ui.getCore().byId(e.target.id);o instanceof p?this._handleSubSectionF7():(this._handleInteractiveElF7(),this._oLastFocusedControlF7=o)}},p.prototype._handleInteractiveElF7=function(){this.getParent().getSubSections().length>1?this.$().focus():this.getParent().$().focus()},p.prototype._handleSubSectionF7=function(t){this._oLastFocusedControlF7?this._oLastFocusedControlF7.$().focus():this.$().firstFocusableDomRef().focus()},p.prototype._calcBlockColumnLayout=function(t,e){var o,n,a,r,s,g=12;return n={iRemaining:e.M,iColumnConfig:e.M},a={iRemaining:e.L,iColumnConfig:e.L},r={iRemaining:e.XL,iColumnConfig:e.XL},s=[r,a,n],o=t.filter(function(t){return t.getVisible&&t.getVisible()}),o.forEach(function(t,e){s.forEach(function(i){i.iCalculatedSize=this._calculateBlockSize(t,i.iRemaining,o,e,i.iColumnConfig)},this),t.setLayoutData(new i(t.getId()+\"-layoutData\",{spanS:g,spanM:n.iCalculatedSize*(g/n.iColumnConfig),spanL:a.iCalculatedSize*(g/a.iColumnConfig),spanXL:r.iCalculatedSize*(g/r.iColumnConfig),linebreakM:e>0&&n.iRemaining===n.iColumnConfig,linebreakL:e>0&&a.iRemaining===a.iColumnConfig,linebreakXL:e>0&&r.iRemaining===r.iColumnConfig})),s.forEach(function(t){t.iRemaining-=t.iCalculatedSize,t.iRemaining<1&&(t.iRemaining=t.iColumnConfig)})},this),o},p.prototype._calculateBlockSize=function(t,e,o,i,n){var a,r,s=n;if(!this._hasAutoLayout(t))return Math.min(n,parseInt(t.getColumnLayout(),10));for(r=1;r<=s&&(a=this._calcLayout(o[i+r]),a<e);r++)e-=a;return e},p.prototype._calcLayout=function(t){var e=1;return t?t instanceof g&&\"auto\"!=t.getColumnLayout()&&(e=parseInt(t.getColumnLayout(),10)):e=0,e},p.prototype._hasAutoLayout=function(t){return!(t instanceof g)||\"auto\"==t.getColumnLayout()},p.prototype._onDesktopMediaRange=function(t){return this._onMediaRange(t,[\"LargeDesktop\",\"Desktop\"])},p.prototype._onTabletMediaRange=function(t){return this._onMediaRange(t,[\"Tablet\"])},p.prototype._onPhoneMediaRange=function(t){return this._onMediaRange(t,[\"Phone\"])},p.prototype._onMediaRange=function(t,e){var o=t||this._getCurrentMediaContainerRange();return e.indexOf(o.name)>-1},p.prototype._synchronizeBlockLayouts=function(t){this._getUseTitleOnTheLeft()&&this.$(\"header\").toggleClass(\"titleOnLeftLayout\",this._onDesktopMediaRange(t)),this._toggleBlockLayoutResponsiveStyles(t)},p.prototype._toggleBlockLayoutResponsiveStyles=function(t){this.$().find(\".sapUxAPBlockContainer\").toggleClass(\"sapUxAPBlockContainerDesktop\",this._onDesktopMediaRange(t)),this.$().find(\".sapUxAPBlockContainer\").toggleClass(\"sapUxAPBlockContainerTablet\",this._onTabletMediaRange(t)),this.$().find(\".sapUxAPBlockContainer\").toggleClass(\"sapUxAPBlockContainerPhone\",this._onPhoneMediaRange(t))},p.prototype._setAggregationProxy=function(){this._bRenderedFirstTime||(t.each(this._aAggregationProxy,t.proxy(function(t,e){this._setAggregation(t,this.removeAllAggregation(t,!0),!0)},this)),this._bRenderedFirstTime=!0)},p.prototype.hasProxy=function(t){return this._bRenderedFirstTime&&this._aAggregationProxy.hasOwnProperty(t)},p.prototype._getAggregation=function(t){return this._aAggregationProxy[t]},p.prototype._setAggregation=function(t,e,o){return this._aAggregationProxy[t]=e,o!==!0&&(this._notifyObjectPageLayout(),this.invalidate()),this._aAggregationProxy[t]},p.prototype.addAggregation=function(t,e,o){var i;return e instanceof s?(e.getContent().forEach(function(e){this.addAggregation(t,e,!0)},this),e.removeAllContent(),e.destroy(),this.invalidate(),this):this.hasProxy(t)?(i=this._getAggregation(t),i.push(e),this._setAggregation(t,i,o),(e instanceof g||e instanceof s)&&e.setParent(this),this):n.prototype.addAggregation.apply(this,arguments)},p.prototype.insertBlock=function(e,o){return t.sap.log.warning(\"ObjectPageSubSection :: usage of insertBlock is not supported - addBlock is performed instead.\"),this.addAggregation(\"blocks\",e)},p.prototype.insertMoreBlock=function(e,o){return t.sap.log.warning(\"ObjectPageSubSection :: usage of insertMoreBlock is not supported - addMoreBlock is performed instead.\"),this.addAggregation(\"moreBlocks\",e)},p.prototype.removeAllAggregation=function(t,e){var o;return this.hasProxy(t)?(o=this._getAggregation(t),this._setAggregation(t,[],e),o.slice()):n.prototype.removeAllAggregation.apply(this,arguments)},p.prototype.removeAggregation=function(t,e){var o,i=!1;return this.hasProxy(t)?(o=this._getAggregation(t),o.forEach(function(t,n){return t.getId()===e.getId()&&(o.splice(n,1),this._setAggregation(o),i=!0),!i},this),i?e:null):n.prototype.removeAggregation.apply(this,arguments)},p.prototype.indexOfAggregation=function(t,e){var o=-1;return this.hasProxy(t)?(this._getAggregation(t).some(function(t,i){if(t.getId()===e.getId())return o=i,!0},this),o):n.prototype.indexOfAggregation.apply(this,arguments)},p.prototype.getAggregation=function(t){return this.hasProxy(t)?this._getAggregation(t):n.prototype.getAggregation.apply(this,arguments)},p.prototype.destroyAggregation=function(t){return this.hasProxy(t)?(this._getAggregation(t).forEach(function(t){t.destroy()}),this._setAggregation(t,[]),this):n.prototype.destroyAggregation.apply(this,arguments)},p.prototype._getSeeMoreButton=function(){return this._oSeeMoreButton||(this._oSeeMoreButton=new c(this.getId()+\"--seeMore\",{type:sap.m.ButtonType.Transparent,iconFirst:!1}).addStyleClass(\"sapUxAPSubSectionSeeMoreButton\").attachPress(this._seeMoreLessControlPressHandler,this)),this._oSeeMoreButton},p.prototype._seeMoreLessControlPressHandler=function(t){var e,o=this.getMode(),i=this.getMoreBlocks()||[];o===r.Expanded?e=r.Collapsed:(e=r.Expanded,i.forEach(function(t){t instanceof g&&(t.setMode(o),t.connectToModels())},this)),this._switchSubSectionMode(e),this._$spacer.length>0&&this._$spacer.height(this._$spacer.height()+this.$().height()),this.rerender()},p.prototype._switchSubSectionMode=function(t){t=this.validateProperty(\"mode\",t),t===r.Collapsed?(this.setProperty(\"mode\",r.Collapsed,!0),this._getSeeMoreButton().setText(h.i18nModel.getResourceBundle().getText(\"SEE_MORE\"))):(this.setProperty(\"mode\",r.Expanded,!0),this._getSeeMoreButton().setText(h.i18nModel.getResourceBundle().getText(\"SEE_LESS\")))},p.prototype._setBlockMode=function(e,o){e instanceof g?e.setMode(o):t.sap.log.debug(\"ObjectPageSubSection :: cannot propagate mode \"+o+\" to \"+e.getMetadata().getName())},p.prototype._setToFocusable=function(t){var e=\"0\",o=\"-1\",i=\"tabIndex\";return t?this.$().attr(i,e):this.$().attr(i,o),this},p.prototype._getUseTitleOnTheLeft=function(){var t=this._getObjectPageLayout();return t.getSubSectionLayout()===a.TitleOnLeft},p.prototype._resetLayoutData=function(t){t.forEach(function(t){t.getLayoutData()&&t.destroyLayoutData()},this)},p.prototype.getVisibleBlocksCount=function(){var t=l.getStashedControls(this.getId()).length;return(this.getBlocks()||[]).forEach(function(e){return!(!e.getVisible||e.getVisible())||void t++}),(this.getMoreBlocks()||[]).forEach(function(e){return!(!e.getVisible||e.getVisible())||void t++}),t},p});",
		"sap/uxap/ObjectPageSubSectionRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define(function(){\"use strict\";var e={};return e.render=function(e,t){var i,r,a,s,d;t.getVisible()&&t._getInternalVisible()&&(i=t.getActions()||[],s=i.length>0,r=t._getInternalTitleVisible()&&\"\"!==t.getTitle().trim(),a=r||s,e.write(\"<div \"),e.writeAttribute(\"role\",\"region\"),e.writeControlData(t),e.addClass(\"sapUxAPObjectPageSubSection\"),e.addClass(\"ui-helper-clearfix\"),e.writeClasses(t),e.writeClasses(),e.write(\">\"),a&&(e.write(\"<div\"),e.addClass(\"sapUxAPObjectPageSubSectionHeader\"),d=t._getUseTitleOnTheLeft(),d&&t._onDesktopMediaRange()&&e.addClass(\"titleOnLeftLayout\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-header\"),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),r&&(e.writeAttribute(\"role\",\"heading\"),e.writeAttribute(\"aria-level\",t._getARIALevel())),e.addClass(\"sapUxAPObjectPageSubSectionHeaderTitle\"),t.getTitleUppercase()&&e.addClass(\"sapUxAPObjectPageSubSectionHeaderTitleUppercase\"),e.writeAttributeEscaped(\"id\",t.getId()+\"-headerTitle\"),e.writeClasses(),e.writeAttribute(\"data-sap-ui-customfastnavgroup\",!0),e.write(\">\"),r&&e.writeEscaped(t.getTitle()),e.write(\"</div>\"),s&&(e.write(\"<div\"),e.addClass(\"sapUxAPObjectPageSubSectionHeaderActions\"),e.writeClasses(),e.writeAttribute(\"data-sap-ui-customfastnavgroup\",!0),e.write(\">\"),i.forEach(e.renderControl),e.write(\"</div>\")),e.write(\"</div>\")),e.write(\"<div\"),e.addClass(\"ui-helper-clearfix\"),e.addClass(\"sapUxAPBlockContainer\"),e.writeClasses(),t._isHidden&&e.addStyle(\"display\",\"none\"),e.writeStyles(),e.write(\">\"),e.renderControl(t._getGrid()),e.write(\"<div\"),e.addClass(\"sapUxAPSubSectionSeeMoreContainer\"),e.writeClasses(),e.write(\">\"),e.renderControl(t._getSeeMoreButton()),e.write(\"</div>\"),e.write(\"</div>\"),e.write(\"</div>\"))},e},!0);",
		"sap/uxap/ThrottledTaskHelper.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2024 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/Object\"],function(i,s){\"use strict\";var t=s.extend(\"ThrottledTask\",{constructor:function(i,s,t){this._fnTask=i,this._iDelay=s,this._oContext=t,this._oPromise=null,this._fnResolvePromise=null,this._fnRejectPromise=null,this._iTimer=null,this._oTaskOptions=null},reSchedule:function(s,t){var e=this._getPromise();if(this._iTimer&&(i.sap.clearDelayedCall(this._iTimer),this._iTimer=null),this._oTaskOptions=this._mergeOptions(this._oTaskOptions||{},t),s){var o=this._fnTask.call(this._oContext,this._oTaskOptions);return this._completePromise(o),e}return this._iTimer=i.sap.delayedCall(this._iDelay,this,function(){if(this._oPromise){var i=this._fnTask.call(this._oContext,this._oTaskOptions);this._completePromise(i)}}.bind(this)),e},_getPromise:function(){return this._oPromise||(this._oPromise=new window.Promise(function(i,s){this._fnResolvePromise=i,this._fnRejectPromise=s}.bind(this))),this._oPromise},_completePromise:function(i){var s=i?this._fnResolvePromise:this._fnRejectPromise;s(),this._oPromise=null,this._fnResolvePromise=null,this._fnRejectPromise=null,this._oTaskOptions=null},_mergeOptions:function(s,t){var e=i.extend({},s,t);return i.each(e,function(i){e[i]=s[i]||t[i]}),e}});return t},!1);",
		"sap/uxap/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.uxap\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"8.0.0-0\"},\"title\":\"The OpenUI5-based library, sap.uxap.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{},\"sap.m\":{},\"sap.ui.layout\":{}}},\"library\":{\"i18n\":false}}}",
		"sap/uxap/component/ObjectPageLayoutUXDrivenFactory.view.xml": "<core:View xmlns:core=\"sap.ui.core\"\n\t\t   xmlns=\"sap.uxap\"\n\t\t   height=\"100%\"\n\t\t   controllerName=\"sap.uxap.component.ObjectPageLayoutUXDrivenFactory\"\n><ObjectPageLayout id=\"ObjectPageLayout\"\n\t\t\t\t\t  subSectionLayout=\"{objectPageLayoutMetadata>/subSectionLayout}\"\n\t\t\t\t\t  showAnchorBar=\"{objectPageLayoutMetadata>/showAnchorBar}\"\n\t\t\t\t\t  height=\"{objectPageLayoutMetadata>/height}\"\n\t\t\t\t\t  enableLazyLoading=\"{objectPageLayoutMetadata>/enableLazyLoading}\"\n\t\t\t\t\t  sections=\"{objectPageLayoutMetadata>/sections}\"\n\t\t\t\t\t  headerContent=\"{path:'objectPageLayoutMetadata>/headerContent', factory:'.controlFactory'}\"\n\t\t\t\t\t  showAnchorBarPopover=\"{objectPageLayoutMetadata>/showAnchorBarPopover}\"\n\t\t\t\t\t  upperCaseAnchorBar=\"{objectPageLayoutMetadata>/upperCaseAnchorBar}\"\n\t\t\t\t\t  useIconTabBar=\"{objectPageLayoutMetadata>/useIconTabBar}\"\n\t\t\t\t\t  showHeaderContent=\"{objectPageLayoutMetadata>/showHeaderContent}\"\n\t\t\t\t\t  useTwoColumnsForLargeScreen=\"{objectPageLayoutMetadata>/useTwoColumnsForLargeScreen}\"\n\t\t\t\t\t  showTitleInHeaderContent=\"{objectPageLayoutMetadata>/showTitleInHeaderContent}\"\n\t\t\t\t\t  showOnlyHighImportance=\"{objectPageLayoutMetadata>/showOnlyHighImportance}\"\n\t\t\t\t\t  isChildPage=\"{objectPageLayoutMetadata>/isChildPage}\"\n\t\t\t\t\t  alwaysShowContentHeader=\"{objectPageLayoutMetadata>/alwaysShowContentHeader}\"\n\t\t\t\t\t  showEditHeaderButton=\"{objectPageLayoutMetadata>/showEditHeaderButton}\"\n\t><sections><ObjectPageSection id=\"ObjectPageSection\"\n\t\t\t\t\t\t\t   title=\"{objectPageLayoutMetadata>title}\"\n\t\t\t\t\t\t\t   importance=\"{objectPageLayoutMetadata>importance}\"\n\t\t\t\t\t\t\t   showTitle=\"{objectPageLayoutMetadata>showTitle}\"\n\t\t\t\t\t\t\t   subSections=\"{objectPageLayoutMetadata>subSections}\"\n\t\t\t\t\t\t\t   visible=\"{objectPageLayoutMetadata>visible}\"><subSections><ObjectPageSubSection id=\"ObjectPageSubSection\"\n\t\t\t\t\t\t\t\t\t\t  title=\"{objectPageLayoutMetadata>title}\"\n\t\t\t\t\t\t\t\t\t\t  visible=\"{objectPageLayoutMetadata>visible}\"\n\t\t\t\t\t\t\t\t\t\t  mode=\"{objectPageLayoutMetadata>mode}\"\n\t\t\t\t\t\t\t\t\t\t  importance=\"{objectPageLayoutMetadata>importance}\"\n\t\t\t\t\t\t\t\t\t\t  actions=\"{path:'objectPageLayoutMetadata>actions', factory:'.controlFactory'}\"\n\t\t\t\t\t\t\t\t\t\t  blocks=\"{path:'objectPageLayoutMetadata>blocks', factory:'.controlFactory'}\"\n\t\t\t\t\t\t\t\t\t\t  moreBlocks=\"{path:'objectPageLayoutMetadata>moreBlocks', factory:'.controlFactory'}\"></ObjectPageSubSection></subSections></ObjectPageSection></sections></ObjectPageLayout></core:View>\n"
	},
	"dependencies": ["sap.ui.core.library-preload","sap.m.library-preload","sap.ui.layout.library-preload"],
	"sas-uglified": true
});